/* Do not modify this file.                                                   */
/* It is created automatically by the ASN.1 to Wireshark dissector compiler   */
/* .\packet-umts_rrc_ies.c                                                    */
/* ../../tools/asn2wrs.py -u -e -p umts_rrc_ies -c umts_rrc_ies.cnf -s packet-umts_rrc_ies-template umts_rrc_InformationElements.asn */

/* Input file: packet-umts_rrc_ies-template.c */

#line 1 "packet-umts_rrc_ies-template.c"
/* packet-umts_rrc_ies.c
 * Routines for Universal Mobile Telecommunications System (UMTS);
 * Radio Resource Control (RRC) protocol specification 	
 * (3GPP TS 25.331 version 6.7.0 Release 6) chapter 11.3 Information element dissection
 * Copyright 2006, Anders Broman <anders.broman@ericsson.com>
 *
 * $Id: packet-umts_rrc_ies.c 18921 2006-08-16 05:58:39Z kukosa $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ref: 3GPP TS 25.423 version 6.7.0 Release 6
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <glib.h>
#include <epan/packet.h>
#include <epan/conversation.h>

#include <stdio.h>
#include <string.h>

#include "packet-ber.h"
#include "packet-per.h"
#include "packet-umts_rrc_ies.h"

#define PNAME  "Universal Mobile Telecommunications System (UMTS) Radio Resource Control (RRC) protocol Information element"
#define PSNAME "UMTS_RRC_IES"
#define PFNAME "umts_rrc_ies"

static dissector_handle_t umts_rrc_ies_handle=NULL;

/* Include constants */

/*--- Included file: packet-umts_rrc_ies-val.h ---*/
#line 1 "packet-umts_rrc_ies-val.h"
#define hiPDSCHidentities              64
#define hiPUSCHidentities              64
#define hiRM                           256
#define maxAC                          16
#define maxAdditionalMeas              4
#define maxASC                         8
#define maxASCmap                      7
#define maxASCpersist                  6
#define maxCCTrCH                      8
#define maxCellMeas                    32
#define maxCellMeas1                   31
#define maxCNdomains                   4
#define maxCPCHsets                    16
#define maxDPCHDLchan                  8
#define maxDPDCHUL                     6
#define maxDRACclasses                 8
#define maxEDCHMACdFlow                8
#define maxEDCHMACdFlow1               7
#define maxFACHPCH                     8
#define maxFreq                        8
#define maxFreqBandsFDD                8
#define maxFreqBandsTDD                4
#define maxFreqBandsGSM                16
#define maxGERANSI                     8
#define maxGSMTargetCells              32
#define maxHProcesses                  8
#define maxHSDSCHTBIndex               64
#define maxHSSCCHs                     4
#define maxInterSysMessages            4
#define maxLoCHperRLC                  2
#define maxMACdPDUsizes                8
#define maxMBMSCommonCCTrCh            32
#define maxMBMSCommonPhyCh             32
#define maxMBMSCommonRB                32
#define maxMBMSCommonTrCh              32
#define maxMBMSFreq                    4
#define maxMBMSL1CP                    4
#define maxMBMSservCount               8
#define maxMBMSservDedic               4
#define maxMBMSservModif               32
#define maxMBMSservSched               16
#define maxMBMSservUnmodif             64
#define maxMBMSTransmis                4
#define maxMeasEvent                   8
#define maxMeasIntervals               3
#define maxMeasParEvent                2
#define maxNumCDMA2000Freqs            8
#define maxNumGSMFreqRanges            32
#define maxNumFDDFreqs                 8
#define maxNumTDDFreqs                 8
#define maxNoOfMeas                    16
#define maxOtherRAT                    15
#define maxOtherRAT16                  16
#define maxPage1                       8
#define maxPCPCHAPsig                  16
#define maxPCPCHAPsubCh                12
#define maxPCPCHCDsig                  16
#define maxPCPCHCDsubCh                12
#define maxPCPCHSF                     7
#define maxPCPCHs                      64
#define maxPDCPAlgoType                8
#define maxPDSCH                       8
#define maxPDSCHTFCIgroups             256
#define maxPRACH                       16
#define maxPRACHFPACH                  8
#define maxPredefConfig                16
#define maxPUSCH                       8
#define maxQueueIDs                    8
#define maxRABsetup                    16
#define maxRAT                         16
#define maxRB                          32
#define maxRBallRABs                   27
#define maxRBMuxOptions                8
#define maxRBperRAB                    8
#define maxRBperTrCh                   16
#define maxReportedGSMCells            8
#define maxRL                          8
#define maxRL_1                        7
#define maxRLCPDUsizePerLogChan        32
#define maxROHCPacketSizesr4           16
#define maxROHCProfiler4               8
#define maxSat                         16
#define maxSCCPCH                      16
#define maxSIB                         32
#define maxSIBFACH                     8
#define maxSIBperMsg                   16
#define maxSRBsetup                    8
#define maxSystemCapability            16
#define maxTF                          32
#define maxTFCPCH                      16
#define maxTFC                         1024
#define maxTFCsub                      1024
#define maxTFCI2Combs                  512
#define maxTGPS                        6
#define maxTrCH                        32
#define maxTrChperSCCPCH               8
#define maxTrCHpreconf                 32
#define maxTS                          14
#define maxTS1                         13
#define maxTSLCR                       6
#define maxTSLCR1                      5
#define maxURA                         8
#define maxURNTIGroup                  8

/*--- End of included file: packet-umts_rrc_ies-val.h ---*/
#line 53 "packet-umts_rrc_ies-template.c"

/* Initialize the protocol and registered fields */
static int proto_umts_rrc_ies = -1;



/*--- Included file: packet-umts_rrc_ies-hf.c ---*/
#line 1 "packet-umts_rrc_ies-hf.c"
static int hf_umts_rrc_ies_cn_DomainIdentity = -1;  /* CN_DomainIdentity */
static int hf_umts_rrc_ies_cn_DomainSpecificNAS_Info = -1;  /* NAS_SystemInformationGSM_MAP */
static int hf_umts_rrc_ies_cn_DRX_CycleLengthCoeff = -1;  /* CN_DRX_CycleLengthCoefficient */
static int hf_umts_rrc_ies_CN_DomainInformationList_item = -1;  /* CN_DomainInformation */
static int hf_umts_rrc_ies_CN_DomainInformationListFull_item = -1;  /* CN_DomainInformationFull */
static int hf_umts_rrc_ies_cn_Type = -1;          /* T_cn_Type */
static int hf_umts_rrc_ies_gsm_MAP = -1;          /* NAS_SystemInformationGSM_MAP */
static int hf_umts_rrc_ies_ansi_41 = -1;          /* NAS_SystemInformationANSI_41 */
static int hf_umts_rrc_ies_CN_DomainSysInfoList_item = -1;  /* CN_DomainSysInfo */
static int hf_umts_rrc_ies_plmn_Identity = -1;    /* PLMN_Identity */
static int hf_umts_rrc_ies_cn_CommonGSM_MAP_NAS_SysInfo = -1;  /* NAS_SystemInformationGSM_MAP */
static int hf_umts_rrc_ies_cn_DomainInformationList = -1;  /* CN_DomainInformationList */
static int hf_umts_rrc_ies_primary_plmn_Identity = -1;  /* PLMN_Identity */
static int hf_umts_rrc_ies_cn_DomainInformationListFull = -1;  /* CN_DomainInformationListFull */
static int hf_umts_rrc_ies_routingbasis = -1;     /* T_routingbasis */
static int hf_umts_rrc_ies_localPTMSI = -1;       /* T_localPTMSI */
static int hf_umts_rrc_ies_routingparameter = -1;  /* RoutingParameter */
static int hf_umts_rrc_ies_tMSIofsamePLMN = -1;   /* T_tMSIofsamePLMN */
static int hf_umts_rrc_ies_tMSIofdifferentPLMN = -1;  /* T_tMSIofdifferentPLMN */
static int hf_umts_rrc_ies_iMSIresponsetopaging = -1;  /* T_iMSIresponsetopaging */
static int hf_umts_rrc_ies_iMSIcauseUEinitiatedEvent = -1;  /* T_iMSIcauseUEinitiatedEvent */
static int hf_umts_rrc_ies_iMEI = -1;             /* T_iMEI */
static int hf_umts_rrc_ies_spare2 = -1;           /* T_spare2 */
static int hf_umts_rrc_ies_spare1 = -1;           /* T_spare1 */
static int hf_umts_rrc_ies_dummy_BOOLEAN = -1;    /* BOOLEAN */
static int hf_umts_rrc_ies_IMEI_item = -1;        /* IMEI_Digit */
static int hf_umts_rrc_ies_IMSI_GSM_MAP_item = -1;  /* Digit */
static int hf_umts_rrc_ies_version = -1;          /* T_version */
static int hf_umts_rrc_ies_release99 = -1;        /* T_release99 */
static int hf_umts_rrc_ies_cn_Type1 = -1;         /* T_cn_Type1 */
static int hf_umts_rrc_ies_gsm_Map_IDNNS = -1;    /* Gsm_map_IDNNS */
static int hf_umts_rrc_ies_ansi_41_IDNNS = -1;    /* Ansi_41_IDNNS */
static int hf_umts_rrc_ies_later = -1;            /* T_later */
static int hf_umts_rrc_ies_futurecoding = -1;     /* BIT_STRING_SIZE_15 */
static int hf_umts_rrc_ies_lac = -1;              /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_MCC_item = -1;         /* Digit */
static int hf_umts_rrc_ies_MNC_item = -1;         /* Digit */
static int hf_umts_rrc_ies_mibPLMN_Identity = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_multiplePLMNs = -1;    /* SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6 */
static int hf_umts_rrc_ies_multiplePLMNs_item = -1;  /* PLMN_IdentityWithOptionalMCC_r6 */
static int hf_umts_rrc_ies_mcc = -1;              /* MCC */
static int hf_umts_rrc_ies_mnc = -1;              /* MNC */
static int hf_umts_rrc_ies_gsm_MAP1 = -1;         /* T_gsm_MAP */
static int hf_umts_rrc_ies_ansi_411 = -1;         /* T_ansi_41 */
static int hf_umts_rrc_ies_p_REV = -1;            /* P_REV */
static int hf_umts_rrc_ies_min_P_REV = -1;        /* Min_P_REV */
static int hf_umts_rrc_ies_sid = -1;              /* SID */
static int hf_umts_rrc_ies_nid = -1;              /* NID */
static int hf_umts_rrc_ies_gsm_MAP_and_ANSI_41 = -1;  /* T_gsm_MAP_and_ANSI_41 */
static int hf_umts_rrc_ies_spare = -1;            /* NULL */
static int hf_umts_rrc_ies_gsm_MAP_RAB_Identity = -1;  /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_ansi_41_RAB_Identity = -1;  /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_lai = -1;              /* LAI */
static int hf_umts_rrc_ies_rac = -1;              /* RoutingAreaCode */
static int hf_umts_rrc_ies_AccessClassBarredList_item = -1;  /* AccessClassBarred */
static int hf_umts_rrc_ies_cellBarred = -1;       /* CellBarred */
static int hf_umts_rrc_ies_cellReservedForOperatorUse = -1;  /* ReservedIndicator */
static int hf_umts_rrc_ies_cellReservationExtension = -1;  /* ReservedIndicator */
static int hf_umts_rrc_ies_accessClassBarredList = -1;  /* AccessClassBarredList */
static int hf_umts_rrc_ies_barred = -1;           /* T_barred */
static int hf_umts_rrc_ies_intraFreqCellReselectionInd = -1;  /* AllowedIndicator */
static int hf_umts_rrc_ies_t_Barred = -1;         /* T_Barred */
static int hf_umts_rrc_ies_notBarred = -1;        /* NULL */
static int hf_umts_rrc_ies_CellIdentity_PerRL_List_item = -1;  /* CellIdentity */
static int hf_umts_rrc_ies_mappingInfo = -1;      /* MappingInfo */
static int hf_umts_rrc_ies_cellSelectQualityMeasure = -1;  /* T_cellSelectQualityMeasure */
static int hf_umts_rrc_ies_cpich_Ec_N0 = -1;      /* T_cpich_Ec_N0 */
static int hf_umts_rrc_ies_q_HYST_2_S = -1;       /* Q_Hyst_S */
static int hf_umts_rrc_ies_cpich_RSCP = -1;       /* NULL */
static int hf_umts_rrc_ies_modeSpecificInfo = -1;  /* T_modeSpecificInfo */
static int hf_umts_rrc_ies_fdd = -1;              /* T_fdd */
static int hf_umts_rrc_ies_s_Intrasearch = -1;    /* S_SearchQual */
static int hf_umts_rrc_ies_s_Intersearch = -1;    /* S_SearchQual */
static int hf_umts_rrc_ies_s_SearchHCS = -1;      /* S_SearchRXLEV */
static int hf_umts_rrc_ies_rat_List = -1;         /* RAT_FDD_InfoList */
static int hf_umts_rrc_ies_q_QualMin = -1;        /* Q_QualMin */
static int hf_umts_rrc_ies_q_RxlevMin = -1;       /* Q_RxlevMin */
static int hf_umts_rrc_ies_tdd = -1;              /* T_tdd */
static int hf_umts_rrc_ies_s_Intrasearch1 = -1;   /* S_SearchRXLEV */
static int hf_umts_rrc_ies_s_Intersearch1 = -1;   /* S_SearchRXLEV */
static int hf_umts_rrc_ies_rat_List1 = -1;        /* RAT_TDD_InfoList */
static int hf_umts_rrc_ies_q_Hyst_l_S = -1;       /* Q_Hyst_S */
static int hf_umts_rrc_ies_t_Reselection_S = -1;  /* T_Reselection_S */
static int hf_umts_rrc_ies_hcs_ServingCellInformation = -1;  /* HCS_ServingCellInformation */
static int hf_umts_rrc_ies_maxAllowedUL_TX_Power = -1;  /* MaxAllowedUL_TX_Power */
static int hf_umts_rrc_ies_domainSpecificAccessRestictionList = -1;  /* DomainSpecificAccessRestrictionList_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestictionParametersForAll = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator1 = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator2 = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator3 = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator4 = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator5 = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_cSDomainSpecificAccessRestriction = -1;  /* DomainSpecificAccessRestriction_v670ext */
static int hf_umts_rrc_ies_pSDomainSpecificAccessRestriction = -1;  /* DomainSpecificAccessRestriction_v670ext */
static int hf_umts_rrc_ies_noRestriction = -1;    /* NULL */
static int hf_umts_rrc_ies_restriction = -1;      /* T_restriction */
static int hf_umts_rrc_ies_domainSpecficAccessClassBarredList = -1;  /* AccessClassBarredList */
static int hf_umts_rrc_ies_rat = -1;              /* RAT */
static int hf_umts_rrc_ies_mappingFunctionParameterList = -1;  /* MappingFunctionParameterList */
static int hf_umts_rrc_ies_functionType = -1;     /* MappingFunctionType */
static int hf_umts_rrc_ies_mapParameter1 = -1;    /* MapParameter */
static int hf_umts_rrc_ies_mapParameter2 = -1;    /* MapParameter */
static int hf_umts_rrc_ies_upperLimit = -1;       /* UpperLimit */
static int hf_umts_rrc_ies_MappingFunctionParameterList_item = -1;  /* MappingFunctionParameter */
static int hf_umts_rrc_ies_MappingInfo_item = -1;  /* Mapping */
static int hf_umts_rrc_ies_rat_Identifier = -1;   /* RAT_Identifier */
static int hf_umts_rrc_ies_s_SearchRAT = -1;      /* S_SearchQual */
static int hf_umts_rrc_ies_s_HCS_RAT = -1;        /* S_SearchRXLEV */
static int hf_umts_rrc_ies_s_Limit_SearchRAT = -1;  /* S_SearchQual */
static int hf_umts_rrc_ies_RAT_FDD_InfoList_item = -1;  /* RAT_FDD_Info */
static int hf_umts_rrc_ies_s_SearchRAT1 = -1;     /* S_SearchRXLEV */
static int hf_umts_rrc_ies_s_Limit_SearchRAT1 = -1;  /* S_SearchRXLEV */
static int hf_umts_rrc_ies_RAT_TDD_InfoList_item = -1;  /* RAT_TDD_Info */
static int hf_umts_rrc_ies_URA_IdentityList_item = -1;  /* URA_Identity */
static int hf_umts_rrc_ies_n_AP_RetransMax = -1;  /* N_AP_RetransMax */
static int hf_umts_rrc_ies_n_AccessFails = -1;    /* N_AccessFails */
static int hf_umts_rrc_ies_nf_BO_NoAICH = -1;     /* NF_BO_NoAICH */
static int hf_umts_rrc_ies_ns_BO_Busy = -1;       /* NS_BO_Busy */
static int hf_umts_rrc_ies_nf_BO_AllBusy = -1;    /* NF_BO_AllBusy */
static int hf_umts_rrc_ies_nf_BO_Mismatch = -1;   /* NF_BO_Mismatch */
static int hf_umts_rrc_ies_t_CPCH = -1;           /* T_CPCH */
static int hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_systemSpecificCapUpdateReqList = -1;  /* SystemSpecificCapUpdateReqList */
static int hf_umts_rrc_ies_ue_RadioCapabilityUpdateRequirement_TDD128 = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement_FDD = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD384 = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD128 = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_startRestart = -1;     /* CipheringAlgorithm */
static int hf_umts_rrc_ies_dummy_NULL = -1;       /* NULL */
static int hf_umts_rrc_ies_cipheringModeCommand = -1;  /* CipheringModeCommand */
static int hf_umts_rrc_ies_activationTimeForDPCH = -1;  /* ActivationTime */
static int hf_umts_rrc_ies_rb_DL_CiphActivationTimeInfo = -1;  /* RB_ActivationTimeInfoList */
static int hf_umts_rrc_ies_imsi_GSM_MAP = -1;     /* IMSI_GSM_MAP */
static int hf_umts_rrc_ies_tmsi_GSM_MAP = -1;     /* TMSI_GSM_MAP */
static int hf_umts_rrc_ies_p_TMSI_GSM_MAP = -1;   /* P_TMSI_GSM_MAP */
static int hf_umts_rrc_ies_imsi_DS_41 = -1;       /* IMSI_DS_41 */
static int hf_umts_rrc_ies_tmsi_DS_41 = -1;       /* TMSI_DS_41 */
static int hf_umts_rrc_ies_spare3 = -1;           /* NULL */
static int hf_umts_rrc_ies_spare21 = -1;          /* NULL */
static int hf_umts_rrc_ies_spare11 = -1;          /* NULL */
static int hf_umts_rrc_ies_fdd_Measurements = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_tdd_Measurements = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_gsm_Measurements = -1;  /* GSM_Measurements */
static int hf_umts_rrc_ies_multiCarrierMeasurements = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_tdd128_Measurements = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_CompressedModeMeasCapabFDDList_item = -1;  /* CompressedModeMeasCapabFDD */
static int hf_umts_rrc_ies_CompressedModeMeasCapabFDDList2_item = -1;  /* CompressedModeMeasCapabFDD2 */
static int hf_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext_item = -1;  /* CompressedModeMeasCapabFDD_ext */
static int hf_umts_rrc_ies_radioFrequencyBandFDD = -1;  /* RadioFrequencyBandFDD */
static int hf_umts_rrc_ies_dl_MeasurementsFDD = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_MeasurementsFDD = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_radioFrequencyBandFDD2 = -1;  /* RadioFrequencyBandFDD2 */
static int hf_umts_rrc_ies_CompressedModeMeasCapabTDDList_item = -1;  /* CompressedModeMeasCapabTDD */
static int hf_umts_rrc_ies_radioFrequencyBandTDD = -1;  /* RadioFrequencyBandTDD */
static int hf_umts_rrc_ies_dl_MeasurementsTDD = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_MeasurementsTDD = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_CompressedModeMeasCapabGSMList_item = -1;  /* CompressedModeMeasCapabGSM */
static int hf_umts_rrc_ies_radioFrequencyBandGSM = -1;  /* RadioFrequencyBandGSM */
static int hf_umts_rrc_ies_dl_MeasurementsGSM = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_MeasurementsGSM = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dl_MeasurementsMC = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_MeasurementsMC = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_initialPriorityDelayList = -1;  /* InitialPriorityDelayList */
static int hf_umts_rrc_ies_backoffControlParams = -1;  /* BackoffControlParams */
static int hf_umts_rrc_ies_powerControlAlgorithm = -1;  /* PowerControlAlgorithm */
static int hf_umts_rrc_ies_dl_DPCCH_BER = -1;     /* DL_DPCCH_BER */
static int hf_umts_rrc_ies_maxNoDPCH_PDSCH_Codes = -1;  /* INTEGER_1_8 */
static int hf_umts_rrc_ies_maxNoPhysChBitsReceived = -1;  /* MaxNoPhysChBitsReceived */
static int hf_umts_rrc_ies_supportForSF_512 = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dummy2_SimultaneousSCCPCH_DPCH_Reception = -1;  /* SimultaneousSCCPCH_DPCH_Reception */
static int hf_umts_rrc_ies_dummy_SupportOfDedicatedPilotsForChEstimation = -1;  /* SupportOfDedicatedPilotsForChEstimation */
static int hf_umts_rrc_ies_maxTS_PerFrame = -1;   /* MaxTS_PerFrame */
static int hf_umts_rrc_ies_maxPhysChPerFrame = -1;  /* MaxPhysChPerFrame */
static int hf_umts_rrc_ies_minimumSF = -1;        /* MinimumSF_DL */
static int hf_umts_rrc_ies_supportOfPDSCH = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_maxPhysChPerTS = -1;   /* MaxPhysChPerTS */
static int hf_umts_rrc_ies_maxTS_PerSubFrame = -1;  /* MaxTS_PerSubFrame_r4 */
static int hf_umts_rrc_ies_maxPhysChPerFrame1 = -1;  /* MaxPhysChPerSubFrame_r4 */
static int hf_umts_rrc_ies_supportOf8PSK = -1;    /* BOOLEAN */
static int hf_umts_rrc_ies_maxNoBitsReceived = -1;  /* MaxNoBits */
static int hf_umts_rrc_ies_maxConvCodeBitsReceived = -1;  /* MaxNoBits */
static int hf_umts_rrc_ies_turboDecodingSupport = -1;  /* TurboSupport */
static int hf_umts_rrc_ies_maxSimultaneousTransChs = -1;  /* MaxSimultaneousTransChsDL */
static int hf_umts_rrc_ies_maxSimultaneousCCTrCH_Count = -1;  /* MaxSimultaneousCCTrCH_Count */
static int hf_umts_rrc_ies_maxReceivedTransportBlocks = -1;  /* MaxTransportBlocksDL */
static int hf_umts_rrc_ies_maxNumberOfTFC = -1;   /* MaxNumberOfTFC_DL */
static int hf_umts_rrc_ies_maxNumberOfTF = -1;    /* MaxNumberOfTF */
static int hf_umts_rrc_ies_transmissionProbability = -1;  /* TransmissionProbability */
static int hf_umts_rrc_ies_maximumBitRate = -1;   /* MaximumBitRate */
static int hf_umts_rrc_ies_DRAC_SysInfoList_item = -1;  /* DRAC_SysInfo */
static int hf_umts_rrc_ies_configurationUnsupported = -1;  /* NULL */
static int hf_umts_rrc_ies_physicalChannelFailure = -1;  /* NULL */
static int hf_umts_rrc_ies_incompatibleSimultaneousReconfiguration = -1;  /* NULL */
static int hf_umts_rrc_ies_compressedModeRuntimeError = -1;  /* TGPSI */
static int hf_umts_rrc_ies_protocolError = -1;    /* ProtocolErrorInformation */
static int hf_umts_rrc_ies_cellUpdateOccurred = -1;  /* NULL */
static int hf_umts_rrc_ies_invalidConfiguration = -1;  /* NULL */
static int hf_umts_rrc_ies_configurationIncomplete = -1;  /* NULL */
static int hf_umts_rrc_ies_unsupportedMeasurement = -1;  /* NULL */
static int hf_umts_rrc_ies_mbmsSessionAlreadyReceivedCorrectly = -1;  /* NULL */
static int hf_umts_rrc_ies_lowerPriorityMBMSService = -1;  /* NULL */
static int hf_umts_rrc_ies_spare5 = -1;           /* NULL */
static int hf_umts_rrc_ies_spare4 = -1;           /* NULL */
static int hf_umts_rrc_ies_rrc_TransactionIdentifier = -1;  /* RRC_TransactionIdentifier */
static int hf_umts_rrc_ies_failureCause = -1;     /* FailureCauseWithProtErr */
static int hf_umts_rrc_ies_rrc_ConnectionReleaseInformation = -1;  /* RRC_ConnectionReleaseInformation */
static int hf_umts_rrc_ies_groupReleaseInformation = -1;  /* GroupReleaseInformation */
static int hf_umts_rrc_ies_uRNTI_Group = -1;      /* U_RNTI_Group */
static int hf_umts_rrc_ies_gsm900 = -1;           /* BOOLEAN */
static int hf_umts_rrc_ies_dcs1800 = -1;          /* BOOLEAN */
static int hf_umts_rrc_ies_gsm1900 = -1;          /* BOOLEAN */
static int hf_umts_rrc_ies_esn_DS_41 = -1;        /* ESN_DS_41 */
static int hf_umts_rrc_ies_InitialPriorityDelayList_item = -1;  /* NS_IP */
static int hf_umts_rrc_ies_imsi = -1;             /* IMSI_GSM_MAP */
static int hf_umts_rrc_ies_tmsi_and_LAI = -1;     /* TMSI_and_LAI_GSM_MAP */
static int hf_umts_rrc_ies_p_TMSI_and_RAI = -1;   /* P_TMSI_and_RAI_GSM_MAP */
static int hf_umts_rrc_ies_imei = -1;             /* IMEI */
static int hf_umts_rrc_ies_imsi_and_ESN_DS_41 = -1;  /* IMSI_and_ESN_DS_41 */
static int hf_umts_rrc_ies_messageAuthenticationCode = -1;  /* MessageAuthenticationCode */
static int hf_umts_rrc_ies_rrc_MessageSequenceNumber = -1;  /* RRC_MessageSequenceNumber */
static int hf_umts_rrc_ies_rrc_MessageSequenceNumberList = -1;  /* RRC_MessageSequenceNumberList */
static int hf_umts_rrc_ies_startIntegrityProtection = -1;  /* T_startIntegrityProtection */
static int hf_umts_rrc_ies_integrityProtInitNumber = -1;  /* IntegrityProtInitNumber */
static int hf_umts_rrc_ies_modify = -1;           /* T_modify */
static int hf_umts_rrc_ies_dl_IntegrityProtActivationInfo = -1;  /* IntegrityProtActivationInfo */
static int hf_umts_rrc_ies_integrityProtectionModeCommand = -1;  /* IntegrityProtectionModeCommand */
static int hf_umts_rrc_ies_integrityProtectionAlgorithm = -1;  /* IntegrityProtectionAlgorithm */
static int hf_umts_rrc_ies_downlinkCompressedMode = -1;  /* CompressedModeMeasCapability */
static int hf_umts_rrc_ies_uplinkCompressedMode = -1;  /* CompressedModeMeasCapability */
static int hf_umts_rrc_ies_compressedModeMeasCapabFDDList = -1;  /* CompressedModeMeasCapabFDDList */
static int hf_umts_rrc_ies_compressedModeMeasCapabTDDList = -1;  /* CompressedModeMeasCapabTDDList */
static int hf_umts_rrc_ies_compressedModeMeasCapabGSMList = -1;  /* CompressedModeMeasCapabGSMList */
static int hf_umts_rrc_ies_compressedModeMeasCapabMC = -1;  /* CompressedModeMeasCapabMC */
static int hf_umts_rrc_ies_compressedModeMeasCapabFDDList1 = -1;  /* CompressedModeMeasCapabFDDList2 */
static int hf_umts_rrc_ies_downlinkCompressedMode_LCR = -1;  /* CompressedModeMeasCapability_LCR_r4 */
static int hf_umts_rrc_ies_uplinkCompressedMode_LCR = -1;  /* CompressedModeMeasCapability_LCR_r4 */
static int hf_umts_rrc_ies_supportOfGSM = -1;     /* BOOLEAN */
static int hf_umts_rrc_ies_supportOfMulticarrier = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_supportOfUTRAN_ToGERAN_NACC = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_p_TMSI = -1;           /* P_TMSI_GSM_MAP */
static int hf_umts_rrc_ies_rai = -1;              /* RAI */
static int hf_umts_rrc_ies_cn_Identity = -1;      /* T_cn_Identity */
static int hf_umts_rrc_ies_pagingCause = -1;      /* PagingCause */
static int hf_umts_rrc_ies_cn_pagedUE_Identity = -1;  /* CN_PagedUE_Identity */
static int hf_umts_rrc_ies_utran_Identity = -1;   /* T_utran_Identity */
static int hf_umts_rrc_ies_u_RNTI = -1;           /* U_RNTI */
static int hf_umts_rrc_ies_cn_OriginatedPage_connectedMode_UE = -1;  /* T_cn_OriginatedPage_connectedMode_UE */
static int hf_umts_rrc_ies_pagingRecordTypeID = -1;  /* PagingRecordTypeID */
static int hf_umts_rrc_ies_utran_SingleUE_Identity = -1;  /* T_utran_SingleUE_Identity */
static int hf_umts_rrc_ies_cn_OriginatedPage_connectedMode_UE1 = -1;  /* T_cn_OriginatedPage_connectedMode_UE1 */
static int hf_umts_rrc_ies_utran_GroupIdentity = -1;  /* SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation */
static int hf_umts_rrc_ies_utran_GroupIdentity_item = -1;  /* GroupIdentityWithReleaseInformation */
static int hf_umts_rrc_ies_PagingRecordList_item = -1;  /* PagingRecord */
static int hf_umts_rrc_ies_PagingRecord2List_r5_item = -1;  /* PagingRecord2_r5 */
static int hf_umts_rrc_ies_losslessSRNS_RelocationSupport = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_supportForRfc2507 = -1;  /* T_supportForRfc2507 */
static int hf_umts_rrc_ies_notSupported = -1;     /* NULL */
static int hf_umts_rrc_ies_supported = -1;        /* MaxHcContextSpace */
static int hf_umts_rrc_ies_supportForRfc3095 = -1;  /* T_supportForRfc3095 */
static int hf_umts_rrc_ies_supported1 = -1;       /* T_supported */
static int hf_umts_rrc_ies_maxROHC_ContextSessions = -1;  /* MaxROHC_ContextSessions_r4 */
static int hf_umts_rrc_ies_reverseCompressionDepth = -1;  /* INTEGER_0_65535 */
static int hf_umts_rrc_ies_supportForRfc3095ContextRelocation = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_maxHcContextSpace = -1;  /* MaxHcContextSpace_r5_ext */
static int hf_umts_rrc_ies_losslessDLRLC_PDUSizeChange = -1;  /* T_losslessDLRLC_PDUSizeChange */
static int hf_umts_rrc_ies_fddPhysChCapability = -1;  /* T_fddPhysChCapability */
static int hf_umts_rrc_ies_downlinkPhysChCapability = -1;  /* DL_PhysChCapabilityFDD */
static int hf_umts_rrc_ies_uplinkPhysChCapability = -1;  /* UL_PhysChCapabilityFDD */
static int hf_umts_rrc_ies_tddPhysChCapability = -1;  /* T_tddPhysChCapability */
static int hf_umts_rrc_ies_downlinkPhysChCapability1 = -1;  /* DL_PhysChCapabilityTDD */
static int hf_umts_rrc_ies_uplinkPhysChCapability1 = -1;  /* UL_PhysChCapabilityTDD */
static int hf_umts_rrc_ies_tdd128_PhysChCapability = -1;  /* T_tdd128_PhysChCapability */
static int hf_umts_rrc_ies_downlinkPhysChCapability2 = -1;  /* DL_PhysChCapabilityTDD_LCR_r4 */
static int hf_umts_rrc_ies_uplinkPhysChCapability2 = -1;  /* UL_PhysChCapabilityTDD_LCR_r4 */
static int hf_umts_rrc_ies_fdd_hspdsch = -1;      /* T_fdd_hspdsch */
static int hf_umts_rrc_ies_supported2 = -1;       /* T_supported1 */
static int hf_umts_rrc_ies_hsdsch_physical_layer_category = -1;  /* HSDSCH_physical_layer_category */
static int hf_umts_rrc_ies_dummy = -1;            /* BOOLEAN */
static int hf_umts_rrc_ies_dummy2 = -1;           /* BOOLEAN */
static int hf_umts_rrc_ies_unsupported = -1;      /* NULL */
static int hf_umts_rrc_ies_tdd384_hspdsch = -1;   /* T_tdd384_hspdsch */
static int hf_umts_rrc_ies_supported3 = -1;       /* HSDSCH_physical_layer_category */
static int hf_umts_rrc_ies_tdd128_hspdsch = -1;   /* T_tdd128_hspdsch */
static int hf_umts_rrc_ies_numberOfRepetitionsPerSFNPeriod = -1;  /* T_numberOfRepetitionsPerSFNPeriod */
static int hf_umts_rrc_ies_noError = -1;          /* NULL */
static int hf_umts_rrc_ies_errorOccurred = -1;    /* T_errorOccurred */
static int hf_umts_rrc_ies_protocolErrorInformation = -1;  /* ProtocolErrorInformation */
static int hf_umts_rrc_ies_diagnosticsType = -1;  /* T_diagnosticsType */
static int hf_umts_rrc_ies_type1 = -1;            /* T_type1 */
static int hf_umts_rrc_ies_asn1_ViolationOrEncodingError = -1;  /* NULL */
static int hf_umts_rrc_ies_messageTypeNonexistent = -1;  /* NULL */
static int hf_umts_rrc_ies_messageNotCompatibleWithReceiverState = -1;  /* IdentificationOfReceivedMessage */
static int hf_umts_rrc_ies_ie_ValueNotComprehended = -1;  /* IdentificationOfReceivedMessage */
static int hf_umts_rrc_ies_conditionalInformationElementError = -1;  /* IdentificationOfReceivedMessage */
static int hf_umts_rrc_ies_messageExtensionNotComprehended = -1;  /* IdentificationOfReceivedMessage */
static int hf_umts_rrc_ies_t314_expired = -1;     /* BOOLEAN */
static int hf_umts_rrc_ies_t315_expired = -1;     /* BOOLEAN */
static int hf_umts_rrc_ies_frequencyInfo = -1;    /* FrequencyInfo */
static int hf_umts_rrc_ies_interRATInfo = -1;     /* InterRATInfo */
static int hf_umts_rrc_ies_interRATInfo1 = -1;    /* InterRATInfo_r6 */
static int hf_umts_rrc_ies_fddRF_Capability = -1;  /* T_fddRF_Capability */
static int hf_umts_rrc_ies_ue_PowerClass = -1;    /* UE_PowerClass */
static int hf_umts_rrc_ies_txRxFrequencySeparation = -1;  /* TxRxFrequencySeparation */
static int hf_umts_rrc_ies_tddRF_Capability = -1;  /* T_tddRF_Capability */
static int hf_umts_rrc_ies_radioFrequencyTDDBandList = -1;  /* RadioFrequencyBandTDDList */
static int hf_umts_rrc_ies_chipRateCapability = -1;  /* ChipRateCapability */
static int hf_umts_rrc_ies_tddRF_Capability1 = -1;  /* T_tddRF_Capability1 */
static int hf_umts_rrc_ies_radioFrequencyBandTDDList = -1;  /* RadioFrequencyBandTDDList */
static int hf_umts_rrc_ies_totalRLC_AM_BufferSize = -1;  /* TotalRLC_AM_BufferSize */
static int hf_umts_rrc_ies_maximumRLC_WindowSize = -1;  /* MaximumRLC_WindowSize */
static int hf_umts_rrc_ies_maximumAM_EntityNumber = -1;  /* MaximumAM_EntityNumberRLC_Cap */
static int hf_umts_rrc_ies_totalRLC_AM_BufferSize1 = -1;  /* TotalRLC_AM_BufferSize_r5_ext */
static int hf_umts_rrc_ies_noRelease = -1;        /* NULL */
static int hf_umts_rrc_ies_release = -1;          /* T_release */
static int hf_umts_rrc_ies_releaseCause = -1;     /* ReleaseCause */
static int hf_umts_rrc_ies_RRC_MessageSequenceNumberList_item = -1;  /* RRC_MessageSequenceNumber */
static int hf_umts_rrc_ies_cipheringAlgorithmCap = -1;  /* T_cipheringAlgorithmCap */
static int hf_umts_rrc_ies_integrityProtectionAlgorithmCap = -1;  /* T_integrityProtectionAlgorithmCap */
static int hf_umts_rrc_ies_deltaACK = -1;         /* DeltaACK */
static int hf_umts_rrc_ies_deltaNACK = -1;        /* DeltaNACK */
static int hf_umts_rrc_ies_harq_Preamble_Mode = -1;  /* HARQ_Preamble_Mode */
static int hf_umts_rrc_ies_primaryCPICH_Info = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_dl_hspdsch_Information = -1;  /* DL_HSPDSCH_Information */
static int hf_umts_rrc_ies_harqInfo = -1;         /* HARQ_Info */
static int hf_umts_rrc_ies_mac_hsResetIndicator = -1;  /* T_mac_hsResetIndicator */
static int hf_umts_rrc_ies_supported4 = -1;       /* T_supported2 */
static int hf_umts_rrc_ies_maxNoSCCPCH_RL = -1;   /* MaxNoSCCPCH_RL */
static int hf_umts_rrc_ies_simultaneousSCCPCH_DPCH_DPDCH_Reception = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_STARTList_item = -1;   /* STARTSingle */
static int hf_umts_rrc_ies_start_Value = -1;      /* START_Value */
static int hf_umts_rrc_ies_systemSpecificCapUpdateReqList1 = -1;  /* SystemSpecificCapUpdateReqList_r5 */
static int hf_umts_rrc_ies_SystemSpecificCapUpdateReqList_item = -1;  /* SystemSpecificCapUpdateReq */
static int hf_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5_item = -1;  /* SystemSpecificCapUpdateReq_r5 */
static int hf_umts_rrc_ies_tmsi = -1;             /* TMSI_GSM_MAP */
static int hf_umts_rrc_ies_dl_TransChCapability = -1;  /* DL_TransChCapability */
static int hf_umts_rrc_ies_ul_TransChCapability = -1;  /* UL_TransChCapability */
static int hf_umts_rrc_ies_supported5 = -1;       /* MaxNoBits */
static int hf_umts_rrc_ies_srnc_Identity = -1;    /* SRNC_Identity */
static int hf_umts_rrc_ies_s_RNTI = -1;           /* S_RNTI */
static int hf_umts_rrc_ies_all = -1;              /* NULL */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b1 = -1;  /* BIT_STRING_SIZE_31 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b2 = -1;  /* BIT_STRING_SIZE_30 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b3 = -1;  /* BIT_STRING_SIZE_29 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b4 = -1;  /* BIT_STRING_SIZE_28 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b5 = -1;  /* BIT_STRING_SIZE_27 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b6 = -1;  /* BIT_STRING_SIZE_26 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b7 = -1;  /* BIT_STRING_SIZE_25 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b8 = -1;  /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b9 = -1;  /* BIT_STRING_SIZE_23 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b10 = -1;  /* BIT_STRING_SIZE_22 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b11 = -1;  /* BIT_STRING_SIZE_21 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b12 = -1;  /* BIT_STRING_SIZE_20 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b13 = -1;  /* BIT_STRING_SIZE_19 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b14 = -1;  /* BIT_STRING_SIZE_18 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b15 = -1;  /* BIT_STRING_SIZE_17 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b16 = -1;  /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b17 = -1;  /* BIT_STRING_SIZE_15 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b18 = -1;  /* BIT_STRING_SIZE_14 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b19 = -1;  /* BIT_STRING_SIZE_13 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b20 = -1;  /* BIT_STRING_SIZE_12 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b21 = -1;  /* BIT_STRING_SIZE_11 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b22 = -1;  /* BIT_STRING_SIZE_10 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b23 = -1;  /* BIT_STRING_SIZE_9 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b24 = -1;  /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b25 = -1;  /* BIT_STRING_SIZE_7 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b26 = -1;  /* BIT_STRING_SIZE_6 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b27 = -1;  /* BIT_STRING_SIZE_5 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b28 = -1;  /* BIT_STRING_SIZE_4 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b29 = -1;  /* BIT_STRING_SIZE_3 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b30 = -1;  /* BIT_STRING_SIZE_2 */
static int hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b31 = -1;  /* BIT_STRING_SIZE_1 */
static int hf_umts_rrc_ies_s_RNTI_2 = -1;         /* S_RNTI_2 */
static int hf_umts_rrc_ies_ue_RadioAccessCapability_v6xyext = -1;  /* UE_RadioAccessCapability_v6xyext */
static int hf_umts_rrc_ies_ue_RATSpecificCapability_v6xyext = -1;  /* InterRAT_UE_RadioAccessCapability_v6xyext */
static int hf_umts_rrc_ies_nonCriticalExtensions = -1;  /* T_nonCriticalExtensions */
static int hf_umts_rrc_ies_t_301 = -1;            /* T_301 */
static int hf_umts_rrc_ies_n_301 = -1;            /* N_301 */
static int hf_umts_rrc_ies_t_302 = -1;            /* T_302 */
static int hf_umts_rrc_ies_n_302 = -1;            /* N_302 */
static int hf_umts_rrc_ies_t_304 = -1;            /* T_304 */
static int hf_umts_rrc_ies_n_304 = -1;            /* N_304 */
static int hf_umts_rrc_ies_t_305 = -1;            /* T_305 */
static int hf_umts_rrc_ies_t_307 = -1;            /* T_307 */
static int hf_umts_rrc_ies_t_308 = -1;            /* T_308 */
static int hf_umts_rrc_ies_t_309 = -1;            /* T_309 */
static int hf_umts_rrc_ies_t_310 = -1;            /* T_310 */
static int hf_umts_rrc_ies_n_310 = -1;            /* N_310 */
static int hf_umts_rrc_ies_t_311 = -1;            /* T_311 */
static int hf_umts_rrc_ies_t_312 = -1;            /* T_312 */
static int hf_umts_rrc_ies_n_312 = -1;            /* N_312 */
static int hf_umts_rrc_ies_t_313 = -1;            /* T_313 */
static int hf_umts_rrc_ies_n_313 = -1;            /* N_313 */
static int hf_umts_rrc_ies_t_314 = -1;            /* T_314 */
static int hf_umts_rrc_ies_t_315 = -1;            /* T_315 */
static int hf_umts_rrc_ies_n_315 = -1;            /* N_315 */
static int hf_umts_rrc_ies_t_316 = -1;            /* T_316 */
static int hf_umts_rrc_ies_t_317 = -1;            /* T_317 */
static int hf_umts_rrc_ies_n_3121 = -1;           /* N_312ext */
static int hf_umts_rrc_ies_n_3151 = -1;           /* N_315ext */
static int hf_umts_rrc_ies_n_3122 = -1;           /* N_312_r5 */
static int hf_umts_rrc_ies_n_3152 = -1;           /* N_315_r5 */
static int hf_umts_rrc_ies_t_300 = -1;            /* T_300 */
static int hf_umts_rrc_ies_n_300 = -1;            /* N_300 */
static int hf_umts_rrc_ies_multiRAT_CapabilityList = -1;  /* MultiRAT_Capability */
static int hf_umts_rrc_ies_multiModeCapability = -1;  /* MultiModeCapability */
static int hf_umts_rrc_ies_pdcp_Capability = -1;  /* PDCP_Capability */
static int hf_umts_rrc_ies_rlc_Capability = -1;   /* RLC_Capability */
static int hf_umts_rrc_ies_transportChannelCapability = -1;  /* TransportChannelCapability */
static int hf_umts_rrc_ies_rf_Capability = -1;    /* RF_Capability */
static int hf_umts_rrc_ies_physicalChannelCapability = -1;  /* PhysicalChannelCapability */
static int hf_umts_rrc_ies_ue_MultiModeRAT_Capability = -1;  /* UE_MultiModeRAT_Capability */
static int hf_umts_rrc_ies_securityCapability = -1;  /* SecurityCapability */
static int hf_umts_rrc_ies_ue_positioning_Capability = -1;  /* UE_Positioning_Capability */
static int hf_umts_rrc_ies_measurementCapability = -1;  /* MeasurementCapability */
static int hf_umts_rrc_ies_ue_RadioAccessCapability = -1;  /* UE_RadioAccessCapability */
static int hf_umts_rrc_ies_ue_RadioAccessCapability_v370ext = -1;  /* UE_RadioAccessCapability_v370ext */
static int hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList = -1;  /* UE_RadioAccessCapabBandFDDList */
static int hf_umts_rrc_ies_ue_PositioningCapabilityExt_v380 = -1;  /* UE_PositioningCapabilityExt_v380 */
static int hf_umts_rrc_ies_ue_PositioningCapabilityExt_v3a0 = -1;  /* UE_PositioningCapabilityExt_v3a0 */
static int hf_umts_rrc_ies_ue_PositioningCapabilityExt_v3g0 = -1;  /* UE_PositioningCapabilityExt_v3g0 */
static int hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList2 = -1;  /* UE_RadioAccessCapabBandFDDList2 */
static int hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList_ext = -1;  /* UE_RadioAccessCapabBandFDDList_ext */
static int hf_umts_rrc_ies_physicalchannelcapability_edch = -1;  /* PhysicalChannelCapability_edch_r6 */
static int hf_umts_rrc_ies_deviceType = -1;       /* T_deviceType */
static int hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2_item = -1;  /* UE_RadioAccessCapabBandFDD2 */
static int hf_umts_rrc_ies_fddRF_Capability1 = -1;  /* T_fddRF_Capability1 */
static int hf_umts_rrc_ies_ue_PowerClass1 = -1;   /* UE_PowerClassExt */
static int hf_umts_rrc_ies_measurementCapability2 = -1;  /* MeasurementCapabilityExt2 */
static int hf_umts_rrc_ies_rx_tx_TimeDifferenceType2Capable = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_validity_CellPCH_UraPCH = -1;  /* T_validity_CellPCH_UraPCH */
static int hf_umts_rrc_ies_sfn_sfnType2Capability = -1;  /* T_sfn_sfnType2Capability */
static int hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_item = -1;  /* UE_RadioAccessCapabBandFDD */
static int hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext_item = -1;  /* UE_RadioAccessCapabBandFDD_ext */
static int hf_umts_rrc_ies_fddRF_Capability2 = -1;  /* T_fddRF_Capability2 */
static int hf_umts_rrc_ies_measurementCapability1 = -1;  /* MeasurementCapabilityExt */
static int hf_umts_rrc_ies_compressedModeMeasCapabFDDList_ext = -1;  /* CompressedModeMeasCapabFDDList_ext */
static int hf_umts_rrc_ies_pdcp_Capability_r4_ext = -1;  /* PDCP_Capability_r4_ext */
static int hf_umts_rrc_ies_tdd_CapabilityExt = -1;  /* T_tdd_CapabilityExt */
static int hf_umts_rrc_ies_rf_Capability1 = -1;   /* RF_Capability_r4_ext */
static int hf_umts_rrc_ies_physicalChannelCapability_LCR = -1;  /* PhysicalChannelCapability_LCR_r4 */
static int hf_umts_rrc_ies_measurementCapability_r4_ext = -1;  /* MeasurementCapability_r4_ext */
static int hf_umts_rrc_ies_accessStratumReleaseIndicator = -1;  /* AccessStratumReleaseIndicator */
static int hf_umts_rrc_ies_totalAM_RLCMemoryExceeds10kB = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_rf_CapabilityComp = -1;  /* RF_CapabilityComp */
static int hf_umts_rrc_ies_fdd1 = -1;             /* T_fdd1 */
static int hf_umts_rrc_ies_supported6 = -1;       /* RF_CapabBandListFDDComp */
static int hf_umts_rrc_ies_tdd384_RF_Capability = -1;  /* T_tdd384_RF_Capability */
static int hf_umts_rrc_ies_supported7 = -1;       /* RadioFrequencyBandTDDList */
static int hf_umts_rrc_ies_tdd128_RF_Capability = -1;  /* T_tdd128_RF_Capability */
static int hf_umts_rrc_ies_RF_CapabBandListFDDComp_item = -1;  /* RF_CapabBandFDDComp */
static int hf_umts_rrc_ies_dl_CapabilityWithSimultaneousHS_DSCHConfig = -1;  /* DL_CapabilityWithSimultaneousHS_DSCHConfig */
static int hf_umts_rrc_ies_pdcp_Capability_r5_ext = -1;  /* PDCP_Capability_r5_ext */
static int hf_umts_rrc_ies_rlc_Capability_r5_ext = -1;  /* RLC_Capability_r5_ext */
static int hf_umts_rrc_ies_physicalChannelCapability1 = -1;  /* PhysicalChannelCapability_hspdsch_r5 */
static int hf_umts_rrc_ies_multiModeRAT_Capability_v590ext = -1;  /* MultiModeRAT_Capability_v590ext */
static int hf_umts_rrc_ies_pdcp_Capability_r5_ext2 = -1;  /* PDCP_Capability_r5_ext2 */
static int hf_umts_rrc_ies_maxNoDPDCH_BitsTransmitted = -1;  /* MaxNoDPDCH_BitsTransmitted */
static int hf_umts_rrc_ies_maxPhysChPerTimeslot = -1;  /* MaxPhysChPerTimeslot */
static int hf_umts_rrc_ies_minimumSF1 = -1;       /* MinimumSF_UL */
static int hf_umts_rrc_ies_supportOfPUSCH = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_fdd_edch = -1;         /* T_fdd_edch */
static int hf_umts_rrc_ies_supported8 = -1;       /* T_supported3 */
static int hf_umts_rrc_ies_edch_PhysicalLayerCategory = -1;  /* INTEGER_1_16 */
static int hf_umts_rrc_ies_maxNoBitsTransmitted = -1;  /* MaxNoBits */
static int hf_umts_rrc_ies_maxConvCodeBitsTransmitted = -1;  /* MaxNoBits */
static int hf_umts_rrc_ies_turboEncodingSupport = -1;  /* TurboSupport */
static int hf_umts_rrc_ies_maxSimultaneousTransChs1 = -1;  /* MaxSimultaneousTransChsUL */
static int hf_umts_rrc_ies_modeSpecificInfo1 = -1;  /* T_modeSpecificInfo1 */
static int hf_umts_rrc_ies_fdd2 = -1;             /* NULL */
static int hf_umts_rrc_ies_tdd1 = -1;             /* T_tdd1 */
static int hf_umts_rrc_ies_maxTransmittedBlocks = -1;  /* MaxTransportBlocksUL */
static int hf_umts_rrc_ies_maxNumberOfTFC1 = -1;  /* MaxNumberOfTFC_UL */
static int hf_umts_rrc_ies_standaloneLocMethodsSupported = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ue_BasedOTDOA_Supported = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_networkAssistedGPS_Supported = -1;  /* NetworkAssistedGPS_Supported */
static int hf_umts_rrc_ies_supportForUE_GPS_TimingOfCellFrames = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_supportForIPDL = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_start_CS = -1;         /* START_Value */
static int hf_umts_rrc_ies_start_PS = -1;         /* START_Value */
static int hf_umts_rrc_ies_rfc2507_Info = -1;     /* RFC2507_Info */
static int hf_umts_rrc_ies_rfc3095_Info = -1;     /* RFC3095_Info_r4 */
static int hf_umts_rrc_ies_inSequenceDelivery = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_receivingWindowSize = -1;  /* ReceivingWindowSize */
static int hf_umts_rrc_ies_dl_RLC_StatusInfo = -1;  /* DL_RLC_StatusInfo */
static int hf_umts_rrc_ies_dl_RLC_PDU_size = -1;  /* OctetModeRLC_SizeInfoType1 */
static int hf_umts_rrc_ies_rB_WithPDCP_InfoList = -1;  /* RB_WithPDCP_InfoList */
static int hf_umts_rrc_ies_rb_WithPDCP_InfoList = -1;  /* RB_WithPDCP_InfoList */
static int hf_umts_rrc_ies_rb_PDCPContextRelocationList = -1;  /* RB_PDCPContextRelocationList */
static int hf_umts_rrc_ies_dl_TransportChannelType = -1;  /* DL_TransportChannelType */
static int hf_umts_rrc_ies_logicalChannelIdentity = -1;  /* LogicalChannelIdentity */
static int hf_umts_rrc_ies_dl_TransportChannelType1 = -1;  /* DL_TransportChannelType_r5 */
static int hf_umts_rrc_ies_DL_LogicalChannelMappingList_item = -1;  /* DL_LogicalChannelMapping */
static int hf_umts_rrc_ies_DL_LogicalChannelMappingList_r5_item = -1;  /* DL_LogicalChannelMapping_r5 */
static int hf_umts_rrc_ies_cid_InclusionInfo = -1;  /* CID_InclusionInfo_r4 */
static int hf_umts_rrc_ies_max_CID = -1;          /* INTEGER_1_16383 */
static int hf_umts_rrc_ies_reverseDecompressionDepth = -1;  /* INTEGER_0_65535 */
static int hf_umts_rrc_ies_dl_AM_RLC_Mode = -1;   /* DL_AM_RLC_Mode */
static int hf_umts_rrc_ies_dl_UM_RLC_Mode = -1;   /* NULL */
static int hf_umts_rrc_ies_dl_TM_RLC_Mode = -1;   /* DL_TM_RLC_Mode */
static int hf_umts_rrc_ies_dl_AM_RLC_Mode_r5 = -1;  /* DL_AM_RLC_Mode_r5 */
static int hf_umts_rrc_ies_dl_UM_RLC_Mode_r5 = -1;  /* DL_UM_RLC_Mode_r5 */
static int hf_umts_rrc_ies_dl_UM_RLC_Mode_r51 = -1;  /* DL_UM_RLC_Mode_r6 */
static int hf_umts_rrc_ies_timerStatusProhibit = -1;  /* TimerStatusProhibit */
static int hf_umts_rrc_ies_dummy_TimerEPC = -1;   /* TimerEPC */
static int hf_umts_rrc_ies_missingPDU_Indicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_timerStatusPeriodic = -1;  /* TimerStatusPeriodic */
static int hf_umts_rrc_ies_segmentationIndication = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dch = -1;              /* TransportChannelIdentity */
static int hf_umts_rrc_ies_fach = -1;             /* NULL */
static int hf_umts_rrc_ies_dsch = -1;             /* TransportChannelIdentity */
static int hf_umts_rrc_ies_dch_and_dsch = -1;     /* TransportChannelIdentityDCHandDSCH */
static int hf_umts_rrc_ies_hsdsch = -1;           /* MAC_d_FlowIdentity */
static int hf_umts_rrc_ies_dch_and_hsdsch = -1;   /* MAC_d_FlowIdentityDCHandHSDSCH */
static int hf_umts_rrc_ies_dl_UM_RLC_LI_size = -1;  /* DL_UM_RLC_LI_size */
static int hf_umts_rrc_ies_dl_Reception_Window_Size = -1;  /* DL_Reception_Window_Size_r6 */
static int hf_umts_rrc_ies_timerMRW = -1;         /* TimerMRW */
static int hf_umts_rrc_ies_timerDiscard = -1;     /* TimerDiscard */
static int hf_umts_rrc_ies_maxMRW = -1;           /* MaxMRW */
static int hf_umts_rrc_ies_algorithmSpecificInfo = -1;  /* AlgorithmSpecificInfo */
static int hf_umts_rrc_ies_HeaderCompressionInfoList_item = -1;  /* HeaderCompressionInfo */
static int hf_umts_rrc_ies_algorithmSpecificInfo1 = -1;  /* AlgorithmSpecificInfo_r4 */
static int hf_umts_rrc_ies_HeaderCompressionInfoList_r4_item = -1;  /* HeaderCompressionInfo_r4 */
static int hf_umts_rrc_ies_supported9 = -1;       /* MaxPDCP_SN_WindowSize */
static int hf_umts_rrc_ies_maxDAT = -1;           /* MaxDAT */
static int hf_umts_rrc_ies_losslessSRNS_RelocSupport = -1;  /* LosslessSRNS_RelocSupport */
static int hf_umts_rrc_ies_pdcp_PDU_Header = -1;  /* PDCP_PDU_Header */
static int hf_umts_rrc_ies_headerCompressionInfoList = -1;  /* HeaderCompressionInfoList */
static int hf_umts_rrc_ies_headerCompressionInfoList1 = -1;  /* HeaderCompressionInfoList_r4 */
static int hf_umts_rrc_ies_pdcp_Info = -1;        /* PDCP_Info */
static int hf_umts_rrc_ies_dummy_INTEGER_0_65535 = -1;  /* INTEGER_0_65535 */
static int hf_umts_rrc_ies_pdcp_Info1 = -1;       /* PDCP_Info_r4 */
static int hf_umts_rrc_ies_timerPollProhibit = -1;  /* TimerPollProhibit */
static int hf_umts_rrc_ies_timerPoll = -1;        /* TimerPoll */
static int hf_umts_rrc_ies_poll_PDU = -1;         /* Poll_PDU */
static int hf_umts_rrc_ies_poll_SDU = -1;         /* Poll_SDU */
static int hf_umts_rrc_ies_lastTransmissionPDU_Poll = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_lastRetransmissionPDU_Poll = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_pollWindow = -1;       /* PollWindow */
static int hf_umts_rrc_ies_timerPollPeriodic = -1;  /* TimerPollPeriodic */
static int hf_umts_rrc_ies_re_EstablishmentTimer = -1;  /* Re_EstablishmentTimer */
static int hf_umts_rrc_ies_srb_InformationList = -1;  /* SRB_InformationSetupList */
static int hf_umts_rrc_ies_rb_InformationList = -1;  /* RB_InformationSetupList */
static int hf_umts_rrc_ies_predefinedRB_Configuration = -1;  /* PredefinedRB_Configuration */
static int hf_umts_rrc_ies_preDefTransChConfiguration = -1;  /* PreDefTransChConfiguration */
static int hf_umts_rrc_ies_preDefPhyChConfiguration = -1;  /* PreDefPhyChConfiguration */
static int hf_umts_rrc_ies_PredefinedConfigStatusList_item = -1;  /* PredefinedConfigStatusInfo */
static int hf_umts_rrc_ies_storedWithValueTagSameAsPrevius = -1;  /* NULL */
static int hf_umts_rrc_ies_other = -1;            /* T_other */
static int hf_umts_rrc_ies_notStored = -1;        /* NULL */
static int hf_umts_rrc_ies_storedWithDifferentValueTag = -1;  /* PredefinedConfigValueTag */
static int hf_umts_rrc_ies_setsWithDifferentValueTag = -1;  /* PredefinedConfigSetsWithDifferentValueTag */
static int hf_umts_rrc_ies_otherEntries = -1;     /* PredefinedConfigStatusListVarSz */
static int hf_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag_item = -1;  /* PredefinedConfigSetWithDifferentValueTag */
static int hf_umts_rrc_ies_startPosition = -1;    /* INTEGER_0_10 */
static int hf_umts_rrc_ies_valueTagList = -1;     /* PredefinedConfigValueTagList */
static int hf_umts_rrc_ies_PredefinedConfigValueTagList_item = -1;  /* PredefinedConfigValueTag */
static int hf_umts_rrc_ies_PredefinedConfigStatusListVarSz_item = -1;  /* PredefinedConfigStatusInfo */
static int hf_umts_rrc_ies_rab_Identity = -1;     /* RAB_Identity */
static int hf_umts_rrc_ies_nas_Synchronisation_Indicator = -1;  /* NAS_Synchronisation_Indicator */
static int hf_umts_rrc_ies_mbms_SessionIdentity = -1;  /* MBMS_SessionIdentity */
static int hf_umts_rrc_ies_RAB_InformationList_item = -1;  /* RAB_Info */
static int hf_umts_rrc_ies_RAB_InformationList_r6_item = -1;  /* RAB_Info_r6 */
static int hf_umts_rrc_ies_RAB_InformationReconfigList_item = -1;  /* RAB_InformationReconfig */
static int hf_umts_rrc_ies_rab_Info = -1;         /* RAB_Info */
static int hf_umts_rrc_ies_rb_InformationSetupList = -1;  /* RB_InformationSetupList */
static int hf_umts_rrc_ies_rb_InformationSetupList1 = -1;  /* RB_InformationSetupList_r4 */
static int hf_umts_rrc_ies_rb_InformationSetupList2 = -1;  /* RB_InformationSetupList_r5 */
static int hf_umts_rrc_ies_rab_Info_r6_ext = -1;  /* RAB_Info_r6_ext */
static int hf_umts_rrc_ies_rab_Info1 = -1;        /* RAB_Info_r6 */
static int hf_umts_rrc_ies_rb_InformationSetupList3 = -1;  /* RB_InformationSetupList_r6 */
static int hf_umts_rrc_ies_RAB_InformationSetupList_item = -1;  /* RAB_InformationSetup */
static int hf_umts_rrc_ies_RAB_InformationSetupList_r4_item = -1;  /* RAB_InformationSetup_r4 */
static int hf_umts_rrc_ies_RAB_InformationSetupList_r5_item = -1;  /* RAB_InformationSetup_r5 */
static int hf_umts_rrc_ies_RAB_InformationSetupList_r6_item = -1;  /* RAB_InformationSetup_r6 */
static int hf_umts_rrc_ies_RAB_InformationSetupList_r6_ext_item = -1;  /* RAB_InformationSetup_r6_ext */
static int hf_umts_rrc_ies_rb_Identity = -1;      /* RB_Identity */
static int hf_umts_rrc_ies_rlc_SequenceNumber = -1;  /* RLC_SequenceNumber */
static int hf_umts_rrc_ies_RB_ActivationTimeInfoList_item = -1;  /* RB_ActivationTimeInfo */
static int hf_umts_rrc_ies_count_C_UL = -1;       /* COUNT_C */
static int hf_umts_rrc_ies_count_C_DL = -1;       /* COUNT_C */
static int hf_umts_rrc_ies_RB_COUNT_C_InformationList_item = -1;  /* RB_COUNT_C_Information */
static int hf_umts_rrc_ies_count_C_MSB_UL = -1;   /* COUNT_C_MSB */
static int hf_umts_rrc_ies_count_C_MSB_DL = -1;   /* COUNT_C_MSB */
static int hf_umts_rrc_ies_RB_COUNT_C_MSB_InformationList_item = -1;  /* RB_COUNT_C_MSB_Information */
static int hf_umts_rrc_ies_RB_IdentityList_item = -1;  /* RB_Identity */
static int hf_umts_rrc_ies_rb_MappingInfo = -1;   /* RB_MappingInfo */
static int hf_umts_rrc_ies_rb_MappingInfo1 = -1;  /* RB_MappingInfo_r5 */
static int hf_umts_rrc_ies_rb_MappingInfo2 = -1;  /* RB_MappingInfo_r6 */
static int hf_umts_rrc_ies_RB_InformationAffectedList_item = -1;  /* RB_InformationAffected */
static int hf_umts_rrc_ies_RB_InformationAffectedList_r5_item = -1;  /* RB_InformationAffected_r5 */
static int hf_umts_rrc_ies_RB_InformationAffectedList_r6_item = -1;  /* RB_InformationAffected_r6 */
static int hf_umts_rrc_ies_rb_Change = -1;        /* T_rb_Change */
static int hf_umts_rrc_ies_release1 = -1;         /* NULL */
static int hf_umts_rrc_ies_re_mapToDefaultRb = -1;  /* RB_Identity */
static int hf_umts_rrc_ies_RB_InformationChangedList_r6_item = -1;  /* RB_InformationChanged_r6 */
static int hf_umts_rrc_ies_pdcp_Info2 = -1;       /* PDCP_InfoReconfig */
static int hf_umts_rrc_ies_pdcp_SN_Info = -1;     /* PDCP_SN_Info */
static int hf_umts_rrc_ies_rlc_Info = -1;         /* RLC_Info */
static int hf_umts_rrc_ies_rb_StopContinue = -1;  /* RB_StopContinue */
static int hf_umts_rrc_ies_pdcp_Info3 = -1;       /* PDCP_InfoReconfig_r4 */
static int hf_umts_rrc_ies_rlc_Info1 = -1;        /* RLC_Info_r5 */
static int hf_umts_rrc_ies_rlc_Info2 = -1;        /* RLC_Info_r6 */
static int hf_umts_rrc_ies_RB_InformationReconfigList_item = -1;  /* RB_InformationReconfig */
static int hf_umts_rrc_ies_RB_InformationReconfigList_r4_item = -1;  /* RB_InformationReconfig_r4 */
static int hf_umts_rrc_ies_RB_InformationReconfigList_r5_item = -1;  /* RB_InformationReconfig_r5 */
static int hf_umts_rrc_ies_RB_InformationReconfigList_r6_item = -1;  /* RB_InformationReconfig_r6 */
static int hf_umts_rrc_ies_RB_InformationReleaseList_item = -1;  /* RB_Identity */
static int hf_umts_rrc_ies_rlc_InfoChoice = -1;   /* RLC_InfoChoice */
static int hf_umts_rrc_ies_rlc_InfoChoice1 = -1;  /* RLC_InfoChoice_r5 */
static int hf_umts_rrc_ies_rlc_InfoChoice2 = -1;  /* RLC_InfoChoice_r6 */
static int hf_umts_rrc_ies_RB_InformationSetupList_item = -1;  /* RB_InformationSetup */
static int hf_umts_rrc_ies_RB_InformationSetupList_r4_item = -1;  /* RB_InformationSetup_r4 */
static int hf_umts_rrc_ies_RB_InformationSetupList_r5_item = -1;  /* RB_InformationSetup_r5 */
static int hf_umts_rrc_ies_RB_InformationSetupList_r6_item = -1;  /* RB_InformationSetup_r6 */
static int hf_umts_rrc_ies_RB_MappingInfo_item = -1;  /* RB_MappingOption */
static int hf_umts_rrc_ies_RB_MappingInfo_r5_item = -1;  /* RB_MappingOption_r5 */
static int hf_umts_rrc_ies_RB_MappingInfo_r6_item = -1;  /* RB_MappingOption_r6 */
static int hf_umts_rrc_ies_ul_LogicalChannelMappings = -1;  /* UL_LogicalChannelMappings */
static int hf_umts_rrc_ies_dl_LogicalChannelMappingList = -1;  /* DL_LogicalChannelMappingList */
static int hf_umts_rrc_ies_dl_LogicalChannelMappingList1 = -1;  /* DL_LogicalChannelMappingList_r5 */
static int hf_umts_rrc_ies_ul_LogicalChannelMappings1 = -1;  /* UL_LogicalChannelMappings_r6 */
static int hf_umts_rrc_ies_dl_RFC3095_Context_Relocation = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_RFC3095_Context_Relocation = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_RB_PDCPContextRelocationList_item = -1;  /* RB_PDCPContextRelocation */
static int hf_umts_rrc_ies_RB_WithPDCP_InfoList_item = -1;  /* RB_WithPDCP_Info */
static int hf_umts_rrc_ies_f_MAX_PERIOD = -1;     /* INTEGER_1_65535 */
static int hf_umts_rrc_ies_f_MAX_TIME = -1;       /* INTEGER_1_255 */
static int hf_umts_rrc_ies_max_HEADER = -1;       /* INTEGER_60_65535 */
static int hf_umts_rrc_ies_tcp_SPACE = -1;        /* INTEGER_3_255 */
static int hf_umts_rrc_ies_non_TCP_SPACE = -1;    /* INTEGER_3_65535 */
static int hf_umts_rrc_ies_expectReordering = -1;  /* ExpectReordering */
static int hf_umts_rrc_ies_rohcProfileList = -1;  /* ROHC_ProfileList_r4 */
static int hf_umts_rrc_ies_ul_RFC3095 = -1;       /* UL_RFC3095_r4 */
static int hf_umts_rrc_ies_dl_RFC3095 = -1;       /* DL_RFC3095_r4 */
static int hf_umts_rrc_ies_ul_RLC_Mode = -1;      /* UL_RLC_Mode */
static int hf_umts_rrc_ies_dl_RLC_Mode = -1;      /* DL_RLC_Mode */
static int hf_umts_rrc_ies_dl_RLC_Mode_r5 = -1;   /* DL_RLC_Mode_r5 */
static int hf_umts_rrc_ies_rlc_OneSidedReEst = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dl_RLC_Mode_r51 = -1;  /* DL_RLC_Mode_r6 */
static int hf_umts_rrc_ies_altE_bitInterpretation = -1;  /* T_altE_bitInterpretation */
static int hf_umts_rrc_ies_dl_UM_RLC_DuplAvoid_Reord_Info = -1;  /* UM_RLC_DuplAvoid_Reord_Info_r6 */
static int hf_umts_rrc_ies_dl_UM_RLC_OutOSeqDelivery_Info = -1;  /* UM_RLC_OutOSeqDelivery_Info_r6 */
static int hf_umts_rrc_ies_same_as_RB = -1;       /* RB_Identity */
static int hf_umts_rrc_ies_rlc_Info_r5 = -1;      /* RLC_Info_r5 */
static int hf_umts_rrc_ies_rlc_Info_r6 = -1;      /* RLC_Info_r6 */
static int hf_umts_rrc_ies_RLC_PDU_SizeList_item = -1;  /* RLC_PDU_Size */
static int hf_umts_rrc_ies_rlc_SizeIndex = -1;    /* INTEGER_1_maxTF */
static int hf_umts_rrc_ies_RLC_SizeExplicitList_item = -1;  /* RLC_SizeInfo */
static int hf_umts_rrc_ies_ROHC_ProfileList_r4_item = -1;  /* ROHC_Profile_r4 */
static int hf_umts_rrc_ies_ROHC_PacketSizeList_r4_item = -1;  /* ROHC_PacketSize_r4 */
static int hf_umts_rrc_ies_SRB_InformationSetupList_item = -1;  /* SRB_InformationSetup */
static int hf_umts_rrc_ies_SRB_InformationSetupList_r5_item = -1;  /* SRB_InformationSetup_r5 */
static int hf_umts_rrc_ies_SRB_InformationSetupList_r6_item = -1;  /* SRB_InformationSetup_r6 */
static int hf_umts_rrc_ies_SRB_InformationSetupList2_item = -1;  /* SRB_InformationSetup */
static int hf_umts_rrc_ies_timerBasedExplicit = -1;  /* ExplicitDiscard */
static int hf_umts_rrc_ies_timerBasedNoExplicit = -1;  /* NoExplicitDiscard */
static int hf_umts_rrc_ies_maxDAT_Retransmissions = -1;  /* MaxDAT_Retransmissions */
static int hf_umts_rrc_ies_noDiscard = -1;        /* MaxDAT */
static int hf_umts_rrc_ies_transmissionRLC_Discard = -1;  /* TransmissionRLC_Discard */
static int hf_umts_rrc_ies_transmissionWindowSize = -1;  /* TransmissionWindowSize */
static int hf_umts_rrc_ies_timerRST = -1;         /* TimerRST */
static int hf_umts_rrc_ies_max_RST = -1;          /* MaxRST */
static int hf_umts_rrc_ies_pollingInfo = -1;      /* PollingInfo */
static int hf_umts_rrc_ies_startList = -1;        /* STARTList */
static int hf_umts_rrc_ies_ul_TransportChannelType = -1;  /* UL_TransportChannelType */
static int hf_umts_rrc_ies_rlc_SizeList = -1;     /* T_rlc_SizeList */
static int hf_umts_rrc_ies_allSizes = -1;         /* NULL */
static int hf_umts_rrc_ies_configured = -1;       /* NULL */
static int hf_umts_rrc_ies_explicitList = -1;     /* RLC_SizeExplicitList */
static int hf_umts_rrc_ies_mac_LogicalChannelPriority = -1;  /* MAC_LogicalChannelPriority */
static int hf_umts_rrc_ies_ul_TrCH_Type = -1;     /* T_ul_TrCH_Type */
static int hf_umts_rrc_ies_dch_rach_cpch_usch = -1;  /* T_dch_rach_cpch_usch */
static int hf_umts_rrc_ies_rlc_SizeList1 = -1;    /* T_rlc_SizeList1 */
static int hf_umts_rrc_ies_e_dch = -1;            /* T_e_dch */
static int hf_umts_rrc_ies_e_DCH_MAC_d_FlowIdentity = -1;  /* E_DCH_MAC_d_FlowIdentity */
static int hf_umts_rrc_ies_ddi = -1;              /* DDI */
static int hf_umts_rrc_ies_rlc_PDU_SizeList = -1;  /* RLC_PDU_SizeList */
static int hf_umts_rrc_ies_includeInSchedulingInfo = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_rlc_LogicalChannelMappingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_LogicalChannelMapping = -1;  /* SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping */
static int hf_umts_rrc_ies_ul_LogicalChannelMapping_item = -1;  /* UL_LogicalChannelMapping */
static int hf_umts_rrc_ies_ul_LogicalChannelMapping1 = -1;  /* SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6 */
static int hf_umts_rrc_ies_ul_LogicalChannelMapping_item1 = -1;  /* UL_LogicalChannelMapping_r6 */
static int hf_umts_rrc_ies_oneLogicalChannel = -1;  /* UL_LogicalChannelMapping */
static int hf_umts_rrc_ies_twoLogicalChannels = -1;  /* UL_LogicalChannelMappingList */
static int hf_umts_rrc_ies_oneLogicalChannel1 = -1;  /* UL_LogicalChannelMapping_r6 */
static int hf_umts_rrc_ies_twoLogicalChannels1 = -1;  /* UL_LogicalChannelMappingList_r6 */
static int hf_umts_rrc_ies_rohcPacketSizeList = -1;  /* ROHC_PacketSizeList_r4 */
static int hf_umts_rrc_ies_ul_AM_RLC_Mode = -1;   /* UL_AM_RLC_Mode */
static int hf_umts_rrc_ies_ul_UM_RLC_Mode = -1;   /* UL_UM_RLC_Mode */
static int hf_umts_rrc_ies_ul_TM_RLC_Mode = -1;   /* UL_TM_RLC_Mode */
static int hf_umts_rrc_ies_rach = -1;             /* NULL */
static int hf_umts_rrc_ies_usch = -1;             /* TransportChannelIdentity */
static int hf_umts_rrc_ies_timer_DAR = -1;        /* TimerDAR_r6 */
static int hf_umts_rrc_ies_widowSize_DAR = -1;    /* WindowSizeDAR_r6 */
static int hf_umts_rrc_ies_timer_OSD = -1;        /* TimerOSD_r6 */
static int hf_umts_rrc_ies_windowSize_OSD = -1;   /* WindowSizeOSD_r6 */
static int hf_umts_rrc_ies_mac_hs_AddReconfQueue_List = -1;  /* MAC_hs_AddReconfQueue_List */
static int hf_umts_rrc_ies_mac_hs_DelQueue_List = -1;  /* MAC_hs_DelQueue_List */
static int hf_umts_rrc_ies_AllowedTFC_List_item = -1;  /* TFC_Value */
static int hf_umts_rrc_ies_AllowedTFI_List_item = -1;  /* INTEGER_0_31 */
static int hf_umts_rrc_ies_sizeType1 = -1;        /* INTEGER_0_127 */
static int hf_umts_rrc_ies_sizeType2 = -1;        /* T_sizeType2 */
static int hf_umts_rrc_ies_part1 = -1;            /* INTEGER_0_15 */
static int hf_umts_rrc_ies_part2 = -1;            /* INTEGER_1_7 */
static int hf_umts_rrc_ies_sizeType3 = -1;        /* T_sizeType3 */
static int hf_umts_rrc_ies_part11 = -1;           /* INTEGER_0_47 */
static int hf_umts_rrc_ies_part21 = -1;           /* INTEGER_1_15 */
static int hf_umts_rrc_ies_sizeType4 = -1;        /* T_sizeType4 */
static int hf_umts_rrc_ies_part12 = -1;           /* INTEGER_0_62 */
static int hf_umts_rrc_ies_part22 = -1;           /* INTEGER_1_63 */
static int hf_umts_rrc_ies_noCoding = -1;         /* NULL */
static int hf_umts_rrc_ies_convolutional = -1;    /* CodingRate */
static int hf_umts_rrc_ies_turbo = -1;            /* NULL */
static int hf_umts_rrc_ies_rlc_Size = -1;         /* T_rlc_Size */
static int hf_umts_rrc_ies_fdd3 = -1;             /* T_fdd2 */
static int hf_umts_rrc_ies_octetModeRLC_SizeInfoType2 = -1;  /* OctetModeRLC_SizeInfoType2 */
static int hf_umts_rrc_ies_tdd2 = -1;             /* T_tdd2 */
static int hf_umts_rrc_ies_commonTDD_Choice = -1;  /* T_commonTDD_Choice */
static int hf_umts_rrc_ies_bitModeRLC_SizeInfo = -1;  /* BitModeRLC_SizeInfo */
static int hf_umts_rrc_ies_octetModeRLC_SizeInfoType1 = -1;  /* OctetModeRLC_SizeInfoType1 */
static int hf_umts_rrc_ies_numberOfTbSizeList = -1;  /* SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks */
static int hf_umts_rrc_ies_numberOfTbSizeList_item = -1;  /* NumberOfTransportBlocks */
static int hf_umts_rrc_ies_logicalChannelList = -1;  /* LogicalChannelList */
static int hf_umts_rrc_ies_commonTDD_Choice1 = -1;  /* T_commonTDD_Choice1 */
static int hf_umts_rrc_ies_numberOfTbSizeAndTTIList = -1;  /* NumberOfTbSizeAndTTIList */
static int hf_umts_rrc_ies_CommonDynamicTF_InfoList_item = -1;  /* CommonDynamicTF_Info */
static int hf_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI_item = -1;  /* CommonDynamicTF_Info_DynamicTTI */
static int hf_umts_rrc_ies_tti = -1;              /* T_tti */
static int hf_umts_rrc_ies_tti10 = -1;            /* CommonDynamicTF_InfoList */
static int hf_umts_rrc_ies_tti20 = -1;            /* CommonDynamicTF_InfoList */
static int hf_umts_rrc_ies_tti40 = -1;            /* CommonDynamicTF_InfoList */
static int hf_umts_rrc_ies_tti80 = -1;            /* CommonDynamicTF_InfoList */
static int hf_umts_rrc_ies_dynamic = -1;          /* CommonDynamicTF_InfoList_DynamicTTI */
static int hf_umts_rrc_ies_semistaticTF_Information = -1;  /* SemistaticTF_Information */
static int hf_umts_rrc_ies_tti1 = -1;             /* T_tti1 */
static int hf_umts_rrc_ies_tti5 = -1;             /* CommonDynamicTF_InfoList */
static int hf_umts_rrc_ies_rlc_Size1 = -1;        /* T_rlc_Size1 */
static int hf_umts_rrc_ies_bitMode = -1;          /* BitModeRLC_SizeInfo */
static int hf_umts_rrc_ies_octetModeType1 = -1;   /* OctetModeRLC_SizeInfoType1 */
static int hf_umts_rrc_ies_rlc_Size2 = -1;        /* T_rlc_Size2 */
static int hf_umts_rrc_ies_DedicatedDynamicTF_InfoList_item = -1;  /* DedicatedDynamicTF_Info */
static int hf_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI_item = -1;  /* DedicatedDynamicTF_Info_DynamicTTI */
static int hf_umts_rrc_ies_tti2 = -1;             /* T_tti2 */
static int hf_umts_rrc_ies_tti101 = -1;           /* DedicatedDynamicTF_InfoList */
static int hf_umts_rrc_ies_tti201 = -1;           /* DedicatedDynamicTF_InfoList */
static int hf_umts_rrc_ies_tti401 = -1;           /* DedicatedDynamicTF_InfoList */
static int hf_umts_rrc_ies_tti801 = -1;           /* DedicatedDynamicTF_InfoList */
static int hf_umts_rrc_ies_dynamic1 = -1;         /* DedicatedDynamicTF_InfoList_DynamicTTI */
static int hf_umts_rrc_ies_DL_AddReconfTransChInfo2List_item = -1;  /* DL_AddReconfTransChInformation2 */
static int hf_umts_rrc_ies_DL_AddReconfTransChInfoList_item = -1;  /* DL_AddReconfTransChInformation */
static int hf_umts_rrc_ies_DL_AddReconfTransChInfoList_r4_item = -1;  /* DL_AddReconfTransChInformation_r4 */
static int hf_umts_rrc_ies_DL_AddReconfTransChInfoList_r5_item = -1;  /* DL_AddReconfTransChInformation_r5 */
static int hf_umts_rrc_ies_dl_TransportChannelType2 = -1;  /* DL_TrCH_Type */
static int hf_umts_rrc_ies_dl_transportChannelIdentity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_tfs_SignallingMode = -1;  /* T_tfs_SignallingMode */
static int hf_umts_rrc_ies_explicit_config = -1;  /* TransportFormatSet */
static int hf_umts_rrc_ies_sameAsULTrCH = -1;     /* UL_TransportChannelIdentity */
static int hf_umts_rrc_ies_dch_QualityTarget = -1;  /* QualityTarget */
static int hf_umts_rrc_ies_dummy_TM_SignallingInfo = -1;  /* TM_SignallingInfo */
static int hf_umts_rrc_ies_tfs_SignallingMode1 = -1;  /* T_tfs_SignallingMode1 */
static int hf_umts_rrc_ies_dl_TransportChannelType3 = -1;  /* DL_TrCH_TypeId1_r5 */
static int hf_umts_rrc_ies_tfs_SignallingMode2 = -1;  /* T_tfs_SignallingMode2 */
static int hf_umts_rrc_ies_hsdsch1 = -1;          /* HSDSCH_Info */
static int hf_umts_rrc_ies_transportChannelIdentity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_tfs_SignallingMode3 = -1;  /* T_tfs_SignallingMode3 */
static int hf_umts_rrc_ies_qualityTarget = -1;    /* QualityTarget */
static int hf_umts_rrc_ies_sccpch_TFCS = -1;      /* TFCS */
static int hf_umts_rrc_ies_modeSpecificInfo2 = -1;  /* T_modeSpecificInfo2 */
static int hf_umts_rrc_ies_fdd4 = -1;             /* T_fdd3 */
static int hf_umts_rrc_ies_dl_Parameters = -1;    /* T_dl_Parameters */
static int hf_umts_rrc_ies_dl_DCH_TFCS = -1;      /* TFCS */
static int hf_umts_rrc_ies_sameAsUL = -1;         /* NULL */
static int hf_umts_rrc_ies_tdd3 = -1;             /* T_tdd3 */
static int hf_umts_rrc_ies_individualDL_CCTrCH_InfoList = -1;  /* IndividualDL_CCTrCH_InfoList */
static int hf_umts_rrc_ies_modeSpecificInfo3 = -1;  /* T_modeSpecificInfo3 */
static int hf_umts_rrc_ies_fdd5 = -1;             /* T_fdd4 */
static int hf_umts_rrc_ies_dl_Parameters1 = -1;   /* T_dl_Parameters1 */
static int hf_umts_rrc_ies_dl_DCH_TFCS1 = -1;     /* T_dl_DCH_TFCS */
static int hf_umts_rrc_ies_tfcs = -1;             /* TFCS */
static int hf_umts_rrc_ies_tdd4 = -1;             /* T_tdd4 */
static int hf_umts_rrc_ies_DL_DeletedTransChInfoList_item = -1;  /* DL_TransportChannelIdentity */
static int hf_umts_rrc_ies_DL_DeletedTransChInfoList_r5_item = -1;  /* DL_TransportChannelIdentity_r5 */
static int hf_umts_rrc_ies_dl_TransportChannelIdentity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_dl_TransportChannelType4 = -1;  /* DL_TrCH_TypeId2_r5 */
static int hf_umts_rrc_ies_hsdsch2 = -1;          /* NULL */
static int hf_umts_rrc_ies_transmissionTimeValidity = -1;  /* TransmissionTimeValidity */
static int hf_umts_rrc_ies_timeDurationBeforeRetry = -1;  /* TimeDurationBeforeRetry */
static int hf_umts_rrc_ies_drac_ClassIdentity = -1;  /* DRAC_ClassIdentity */
static int hf_umts_rrc_ies_DRAC_StaticInformationList_item = -1;  /* DRAC_StaticInformation */
static int hf_umts_rrc_ies_mac_d_FlowIdentity = -1;  /* E_DCH_MAC_d_FlowIdentity */
static int hf_umts_rrc_ies_mac_d_FlowPowerOffset = -1;  /* E_DCH_MAC_d_FlowPowerOffset */
static int hf_umts_rrc_ies_mac_d_FlowMaxRetrans = -1;  /* E_DCH_MAC_d_FlowMaxRetrans */
static int hf_umts_rrc_ies_mac_d_FlowMultiplexingList = -1;  /* E_DCH_MAC_d_FlowMultiplexingList */
static int hf_umts_rrc_ies_transmissionGrantType = -1;  /* T_transmissionGrantType */
static int hf_umts_rrc_ies_non_ScheduledTranmGrantInfo = -1;  /* T_non_ScheduledTranmGrantInfo */
static int hf_umts_rrc_ies_maxMAC_e_PDUContents = -1;  /* INTEGER_1_19982 */
static int hf_umts_rrc_ies_ms2_NonSchedTransmGrantHARQAlloc = -1;  /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_scheduledTransmissionGrantInfo = -1;  /* NULL */
static int hf_umts_rrc_ies_harq_RV_Configuration = -1;  /* T_harq_RV_Configuration */
static int hf_umts_rrc_ies_complete = -1;         /* TFCS_ReconfAdd */
static int hf_umts_rrc_ies_addition = -1;         /* TFCS_ReconfAdd */
static int hf_umts_rrc_ies_removal = -1;          /* TFCS_RemovalList */
static int hf_umts_rrc_ies_replacement = -1;      /* T_replacement */
static int hf_umts_rrc_ies_tfcsRemoval = -1;      /* TFCS_RemovalList */
static int hf_umts_rrc_ies_tfcsAdd = -1;          /* TFCS_ReconfAdd */
static int hf_umts_rrc_ies_signalledGainFactors = -1;  /* SignalledGainFactors */
static int hf_umts_rrc_ies_computedGainFactors = -1;  /* ReferenceTFC_ID */
static int hf_umts_rrc_ies_addOrReconfMAC_dFlow = -1;  /* AddOrReconfMAC_dFlow */
static int hf_umts_rrc_ies_numberOfProcesses = -1;  /* INTEGER_1_8 */
static int hf_umts_rrc_ies_memoryPartitioning = -1;  /* T_memoryPartitioning */
static int hf_umts_rrc_ies_implicit = -1;         /* NULL */
static int hf_umts_rrc_ies_explicit = -1;         /* SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize */
static int hf_umts_rrc_ies_explicit_item = -1;    /* HARQMemorySize */
static int hf_umts_rrc_ies_dl_TFCS_Identity = -1;  /* TFCS_Identity */
static int hf_umts_rrc_ies_tfcs_SignallingMode = -1;  /* T_tfcs_SignallingMode */
static int hf_umts_rrc_ies_explicit_config1 = -1;  /* TFCS */
static int hf_umts_rrc_ies_sameAsUL1 = -1;        /* TFCS_Identity */
static int hf_umts_rrc_ies_IndividualDL_CCTrCH_InfoList_item = -1;  /* IndividualDL_CCTrCH_Info */
static int hf_umts_rrc_ies_ul_TFCS_Identity = -1;  /* TFCS_Identity */
static int hf_umts_rrc_ies_ul_TFCS = -1;          /* TFCS */
static int hf_umts_rrc_ies_tfc_Subset = -1;       /* TFC_Subset */
static int hf_umts_rrc_ies_IndividualUL_CCTrCH_InfoList_item = -1;  /* IndividualUL_CCTrCH_Info */
static int hf_umts_rrc_ies_logChOfRb = -1;        /* INTEGER_0_1 */
static int hf_umts_rrc_ies_explicitList1 = -1;    /* SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB */
static int hf_umts_rrc_ies_explicitList_item = -1;  /* LogicalChannelByRB */
static int hf_umts_rrc_ies_dch_transport_ch_id = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_hsdsch_mac_d_flow_id = -1;  /* MAC_d_FlowIdentity */
static int hf_umts_rrc_ies_MAC_d_PDU_SizeInfo_List_item = -1;  /* MAC_d_PDUsizeInfo */
static int hf_umts_rrc_ies_mac_d_PDU_Size = -1;   /* INTEGER_1_5000 */
static int hf_umts_rrc_ies_mac_d_PDU_Index = -1;  /* INTEGER_0_7 */
static int hf_umts_rrc_ies_MAC_hs_AddReconfQueue_List_item = -1;  /* MAC_hs_AddReconfQueue */
static int hf_umts_rrc_ies_mac_hsQueueId = -1;    /* INTEGER_0_7 */
static int hf_umts_rrc_ies_mac_dFlowId = -1;      /* MAC_d_FlowIdentity */
static int hf_umts_rrc_ies_reorderingReleaseTimer = -1;  /* T1_ReleaseTimer */
static int hf_umts_rrc_ies_mac_hsWindowSize = -1;  /* MAC_hs_WindowSize */
static int hf_umts_rrc_ies_mac_d_PDU_SizeInfo_List = -1;  /* MAC_d_PDU_SizeInfo_List */
static int hf_umts_rrc_ies_MAC_hs_DelQueue_List_item = -1;  /* MAC_hs_DelQueue */
static int hf_umts_rrc_ies_NumberOfTbSizeAndTTIList_item = -1;  /* NumberOfTbSizeAndTTIList_item */
static int hf_umts_rrc_ies_numberOfTransportBlocks = -1;  /* NumberOfTransportBlocks */
static int hf_umts_rrc_ies_transmissionTimeInterval = -1;  /* TransmissionTimeInterval */
static int hf_umts_rrc_ies_Non_allowedTFC_List_item = -1;  /* TFC_Value */
static int hf_umts_rrc_ies_zero = -1;             /* NULL */
static int hf_umts_rrc_ies_one = -1;              /* NULL */
static int hf_umts_rrc_ies_small = -1;            /* INTEGER_2_17 */
static int hf_umts_rrc_ies_large = -1;            /* INTEGER_18_512 */
static int hf_umts_rrc_ies_sizeType11 = -1;       /* INTEGER_0_31 */
static int hf_umts_rrc_ies_sizeType21 = -1;       /* T_sizeType21 */
static int hf_umts_rrc_ies_part13 = -1;           /* INTEGER_0_23 */
static int hf_umts_rrc_ies_part23 = -1;           /* INTEGER_1_3 */
static int hf_umts_rrc_ies_sizeType31 = -1;       /* T_sizeType31 */
static int hf_umts_rrc_ies_part14 = -1;           /* INTEGER_0_61 */
static int hf_umts_rrc_ies_sizeType22 = -1;       /* INTEGER_0_63 */
static int hf_umts_rrc_ies_sizeType32 = -1;       /* INTEGER_0_56 */
static int hf_umts_rrc_ies_referenceTFC = -1;     /* TFC_Value */
static int hf_umts_rrc_ies_modeSpecificInfo4 = -1;  /* T_modeSpecificInfo4 */
static int hf_umts_rrc_ies_fdd6 = -1;             /* T_fdd5 */
static int hf_umts_rrc_ies_gainFactorBetaC = -1;  /* GainFactor */
static int hf_umts_rrc_ies_tdd5 = -1;             /* NULL */
static int hf_umts_rrc_ies_gainFactorBetaD = -1;  /* GainFactor */
static int hf_umts_rrc_ies_gainFactorInformation = -1;  /* GainFactorInformation */
static int hf_umts_rrc_ies_powerOffsetPp_m = -1;  /* PowerOffsetPp_m */
static int hf_umts_rrc_ies_ul_CommonTransChInfo = -1;  /* UL_CommonTransChInfo */
static int hf_umts_rrc_ies_ul_AddReconfTrChInfoList = -1;  /* UL_AddReconfTransChInfoList */
static int hf_umts_rrc_ies_dl_CommonTransChInfo = -1;  /* DL_CommonTransChInfo */
static int hf_umts_rrc_ies_dl_TrChInfoList = -1;  /* DL_AddReconfTransChInfoList */
static int hf_umts_rrc_ies_bler_QualityValue = -1;  /* BLER_QualityValue */
static int hf_umts_rrc_ies_ul_TransportChannelType1 = -1;  /* UL_TrCH_Type */
static int hf_umts_rrc_ies_restrictedTrChIdentity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_allowedTFI_List = -1;  /* AllowedTFI_List */
static int hf_umts_rrc_ies_RestrictedTrChInfoList_item = -1;  /* RestrictedTrChInfo */
static int hf_umts_rrc_ies_channelCodingType = -1;  /* ChannelCodingType */
static int hf_umts_rrc_ies_rateMatchingAttribute = -1;  /* RateMatchingAttribute */
static int hf_umts_rrc_ies_crc_Size = -1;         /* CRC_Size */
static int hf_umts_rrc_ies_modeSpecificInfo5 = -1;  /* T_modeSpecificInfo5 */
static int hf_umts_rrc_ies_fdd7 = -1;             /* T_fdd6 */
static int hf_umts_rrc_ies_referenceTFC_ID = -1;  /* ReferenceTFC_ID */
static int hf_umts_rrc_ies_splitType = -1;        /* SplitType */
static int hf_umts_rrc_ies_tfci_Field2_Length = -1;  /* INTEGER_1_10 */
static int hf_umts_rrc_ies_tfci_Field1_Information = -1;  /* ExplicitTFCS_Configuration */
static int hf_umts_rrc_ies_tfci_Field2_Information = -1;  /* TFCI_Field2_Information */
static int hf_umts_rrc_ies_minimumAllowedTFC_Number = -1;  /* TFC_Value */
static int hf_umts_rrc_ies_allowedTFC_List = -1;  /* AllowedTFC_List */
static int hf_umts_rrc_ies_non_allowedTFC_List = -1;  /* Non_allowedTFC_List */
static int hf_umts_rrc_ies_restrictedTrChInfoList = -1;  /* RestrictedTrChInfoList */
static int hf_umts_rrc_ies_fullTFCS = -1;         /* NULL */
static int hf_umts_rrc_ies_TFC_SubsetList_item = -1;  /* TFC_SubsetList_item */
static int hf_umts_rrc_ies_modeSpecificInfo6 = -1;  /* T_modeSpecificInfo6 */
static int hf_umts_rrc_ies_tdd6 = -1;             /* T_tdd5 */
static int hf_umts_rrc_ies_tfcs_ID = -1;          /* TFCS_Identity */
static int hf_umts_rrc_ies_tfci_Range = -1;       /* TFCI_RangeList */
static int hf_umts_rrc_ies_explicit_config2 = -1;  /* ExplicitTFCS_Configuration */
static int hf_umts_rrc_ies_maxTFCIField2Value = -1;  /* INTEGER_1_1023 */
static int hf_umts_rrc_ies_tfcs_InfoForDSCH = -1;  /* TFCS_InfoForDSCH */
static int hf_umts_rrc_ies_TFCI_RangeList_item = -1;  /* TFCI_Range */
static int hf_umts_rrc_ies_normalTFCI_Signalling = -1;  /* ExplicitTFCS_Configuration */
static int hf_umts_rrc_ies_dummy_SplitTFCI_Signalling = -1;  /* SplitTFCI_Signalling */
static int hf_umts_rrc_ies_tfcs_ID1 = -1;         /* TFCS_IdentityPlain */
static int hf_umts_rrc_ies_sharedChannelIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ctfc2bit = -1;         /* INTEGER_0_3 */
static int hf_umts_rrc_ies_ctfc4bit = -1;         /* INTEGER_0_15 */
static int hf_umts_rrc_ies_ctfc6bit = -1;         /* INTEGER_0_63 */
static int hf_umts_rrc_ies_ctfc8bit = -1;         /* INTEGER_0_255 */
static int hf_umts_rrc_ies_ctfc12bit = -1;        /* INTEGER_0_4095 */
static int hf_umts_rrc_ies_ctfc16bit = -1;        /* INTEGER_0_65535 */
static int hf_umts_rrc_ies_ctfc24bit = -1;        /* INTEGER_0_16777215 */
static int hf_umts_rrc_ies_ctfcSize = -1;         /* T_ctfcSize */
static int hf_umts_rrc_ies_ctfc2Bit = -1;         /* T_ctfc2Bit */
static int hf_umts_rrc_ies_ctfc2Bit_item = -1;    /* T_ctfc2Bit_item */
static int hf_umts_rrc_ies_ctfc2 = -1;            /* INTEGER_0_3 */
static int hf_umts_rrc_ies_powerOffsetInformation = -1;  /* PowerOffsetInformation */
static int hf_umts_rrc_ies_ctfc4Bit = -1;         /* T_ctfc4Bit */
static int hf_umts_rrc_ies_ctfc4Bit_item = -1;    /* T_ctfc4Bit_item */
static int hf_umts_rrc_ies_ctfc4 = -1;            /* INTEGER_0_15 */
static int hf_umts_rrc_ies_ctfc6Bit = -1;         /* T_ctfc6Bit */
static int hf_umts_rrc_ies_ctfc6Bit_item = -1;    /* T_ctfc6Bit_item */
static int hf_umts_rrc_ies_ctfc6 = -1;            /* INTEGER_0_63 */
static int hf_umts_rrc_ies_ctfc8Bit = -1;         /* T_ctfc8Bit */
static int hf_umts_rrc_ies_ctfc8Bit_item = -1;    /* T_ctfc8Bit_item */
static int hf_umts_rrc_ies_ctfc8 = -1;            /* INTEGER_0_255 */
static int hf_umts_rrc_ies_ctfc12Bit = -1;        /* T_ctfc12Bit */
static int hf_umts_rrc_ies_ctfc12Bit_item = -1;   /* T_ctfc12Bit_item */
static int hf_umts_rrc_ies_ctfc12 = -1;           /* INTEGER_0_4095 */
static int hf_umts_rrc_ies_ctfc16Bit = -1;        /* T_ctfc16Bit */
static int hf_umts_rrc_ies_ctfc16Bit_item = -1;   /* T_ctfc16Bit_item */
static int hf_umts_rrc_ies_ctfc16 = -1;           /* INTEGER_0_65535 */
static int hf_umts_rrc_ies_ctfc24Bit = -1;        /* T_ctfc24Bit */
static int hf_umts_rrc_ies_ctfc24Bit_item = -1;   /* T_ctfc24Bit_item */
static int hf_umts_rrc_ies_ctfc24 = -1;           /* INTEGER_0_16777215 */
static int hf_umts_rrc_ies_tfci = -1;             /* INTEGER_0_1023 */
static int hf_umts_rrc_ies_TFCS_RemovalList_item = -1;  /* TFCS_Removal */
static int hf_umts_rrc_ies_messType = -1;         /* MessType */
static int hf_umts_rrc_ies_tm_SignallingMode = -1;  /* T_tm_SignallingMode */
static int hf_umts_rrc_ies_mode1 = -1;            /* NULL */
static int hf_umts_rrc_ies_mode2 = -1;            /* T_mode2 */
static int hf_umts_rrc_ies_ul_controlledTrChList = -1;  /* UL_ControlledTrChList */
static int hf_umts_rrc_ies_dsch_transport_ch_id = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_dedicatedTransChTFS = -1;  /* DedicatedTransChTFS */
static int hf_umts_rrc_ies_commonTransChTFS = -1;  /* CommonTransChTFS */
static int hf_umts_rrc_ies_commonTransChTFS_LCR = -1;  /* CommonTransChTFS_LCR */
static int hf_umts_rrc_ies_UL_AddReconfTransChInfoList_item = -1;  /* UL_AddReconfTransChInformation */
static int hf_umts_rrc_ies_UL_AddReconfTransChInfoList_r6_item = -1;  /* UL_AddReconfTransChInformation_r6 */
static int hf_umts_rrc_ies_transportFormatSet = -1;  /* TransportFormatSet */
static int hf_umts_rrc_ies_dch_usch = -1;         /* T_dch_usch */
static int hf_umts_rrc_ies_e_dch1 = -1;           /* T_e_dch1 */
static int hf_umts_rrc_ies_tti3 = -1;             /* E_DCH_TTI */
static int hf_umts_rrc_ies_harq_Info = -1;        /* E_DCH_Harq_Info */
static int hf_umts_rrc_ies_addReconf_MAC_d_Flow = -1;  /* E_DCH_AddReconf_MAC_d_Flow */
static int hf_umts_rrc_ies_prach_TFCS = -1;       /* TFCS */
static int hf_umts_rrc_ies_modeSpecificInfo7 = -1;  /* T_modeSpecificInfo7 */
static int hf_umts_rrc_ies_fdd8 = -1;             /* T_fdd7 */
static int hf_umts_rrc_ies_tdd7 = -1;             /* T_tdd6 */
static int hf_umts_rrc_ies_individualUL_CCTrCH_InfoList = -1;  /* IndividualUL_CCTrCH_InfoList */
static int hf_umts_rrc_ies_modeSpecificInfo8 = -1;  /* T_modeSpecificInfo8 */
static int hf_umts_rrc_ies_fdd9 = -1;             /* T_fdd8 */
static int hf_umts_rrc_ies_tdd8 = -1;             /* T_tdd7 */
static int hf_umts_rrc_ies_tfc_SubsetList = -1;   /* TFC_SubsetList */
static int hf_umts_rrc_ies_UL_ControlledTrChList_item = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_UL_DeletedTransChInfoList_item = -1;  /* UL_TransportChannelIdentity */
static int hf_umts_rrc_ies_UL_DeletedTransChInfoList_r6_item = -1;  /* UL_TransportChannelIdentity_r6 */
static int hf_umts_rrc_ies_ul_TransportChannelIdentity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_dch_usch1 = -1;        /* T_dch_usch1 */
static int hf_umts_rrc_ies_e_dch2 = -1;           /* E_DCH_MAC_d_FlowIdentity */
static int hf_umts_rrc_ies_USCH_TransportChannelsInfo_item = -1;  /* USCH_TransportChannelsInfo_item */
static int hf_umts_rrc_ies_usch_TransportChannelIdentity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_usch_TFS = -1;         /* TransportFormatSet */
static int hf_umts_rrc_ies_AC_To_ASC_MappingTable_item = -1;  /* AC_To_ASC_Mapping */
static int hf_umts_rrc_ies_availableSignatureStartIndex = -1;  /* INTEGER_0_15 */
static int hf_umts_rrc_ies_availableSignatureEndIndex = -1;  /* INTEGER_0_15 */
static int hf_umts_rrc_ies_assignedSubChannelNumber = -1;  /* T_assignedSubChannelNumber */
static int hf_umts_rrc_ies_channelisationCodeIndices = -1;  /* T_channelisationCodeIndices */
static int hf_umts_rrc_ies_subchannelSize = -1;   /* T_subchannelSize */
static int hf_umts_rrc_ies_size1 = -1;            /* NULL */
static int hf_umts_rrc_ies_size2 = -1;            /* T_size2 */
static int hf_umts_rrc_ies_subchannels = -1;      /* T_subchannels */
static int hf_umts_rrc_ies_size4 = -1;            /* T_size4 */
static int hf_umts_rrc_ies_subchannels1 = -1;     /* T_subchannels1 */
static int hf_umts_rrc_ies_size8 = -1;            /* T_size8 */
static int hf_umts_rrc_ies_subchannels2 = -1;     /* T_subchannels2 */
static int hf_umts_rrc_ies_availableSYNC_UlCodesIndics = -1;  /* T_availableSYNC_UlCodesIndics */
static int hf_umts_rrc_ies_subchannelSize1 = -1;  /* T_subchannelSize1 */
static int hf_umts_rrc_ies_size21 = -1;           /* T_size21 */
static int hf_umts_rrc_ies_subchannels3 = -1;     /* T_subchannels3 */
static int hf_umts_rrc_ies_size41 = -1;           /* T_size41 */
static int hf_umts_rrc_ies_subchannels4 = -1;     /* T_subchannels4 */
static int hf_umts_rrc_ies_size81 = -1;           /* T_size81 */
static int hf_umts_rrc_ies_subchannels5 = -1;     /* T_subchannels5 */
static int hf_umts_rrc_ies_dynamicTFInformationCCCH = -1;  /* DynamicTFInformationCCCH */
static int hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_IEs = -1;  /* AdditionalPRACH_TF_and_TFCS_CCCH_IEs */
static int hf_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List_item = -1;  /* AdditionalPRACH_TF_and_TFCS_CCCH */
static int hf_umts_rrc_ies_channelisationCode256 = -1;  /* ChannelisationCode256 */
static int hf_umts_rrc_ies_sttd_Indicator = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_aich_TransmissionTiming = -1;  /* AICH_TransmissionTiming */
static int hf_umts_rrc_ies_allocationActivationTime = -1;  /* INTEGER_0_255 */
static int hf_umts_rrc_ies_allocationDuration = -1;  /* INTEGER_1_256 */
static int hf_umts_rrc_ies_ap_Signature = -1;     /* AP_Signature */
static int hf_umts_rrc_ies_availableAP_SubchannelList = -1;  /* AvailableAP_SubchannelList */
static int hf_umts_rrc_ies_accessServiceClass_FDD = -1;  /* AccessServiceClass_FDD */
static int hf_umts_rrc_ies_accessServiceClass_TDD = -1;  /* AccessServiceClass_TDD */
static int hf_umts_rrc_ies_accessServiceClass_TDD_LCR = -1;  /* AccessServiceClass_TDD_LCR_r4 */
static int hf_umts_rrc_ies_AvailableAP_Signature_VCAMList_item = -1;  /* AP_Signature_VCAM */
static int hf_umts_rrc_ies_AvailableAP_SignatureList_item = -1;  /* AP_Signature */
static int hf_umts_rrc_ies_AvailableAP_SubchannelList_item = -1;  /* AP_Subchannel */
static int hf_umts_rrc_ies_AvailableMinimumSF_ListVCAM_item = -1;  /* AvailableMinimumSF_VCAM */
static int hf_umts_rrc_ies_minimumSpreadingFactor = -1;  /* MinimumSpreadingFactor */
static int hf_umts_rrc_ies_nf_Max = -1;           /* NF_Max */
static int hf_umts_rrc_ies_maxAvailablePCPCH_Number = -1;  /* MaxAvailablePCPCH_Number */
static int hf_umts_rrc_ies_availableAP_Signature_VCAMList = -1;  /* AvailableAP_Signature_VCAMList */
static int hf_umts_rrc_ies_tfcs_Identity = -1;    /* TFCS_Identity */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo = -1;  /* UL_DPCH_PowerControlInfo */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo1 = -1;  /* UL_DPCH_PowerControlInfo_r4 */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo2 = -1;  /* UL_DPCH_PowerControlInfo_r5 */
static int hf_umts_rrc_ies_CD_AccessSlotSubchannelList_item = -1;  /* CD_AccessSlotSubchannel */
static int hf_umts_rrc_ies_CD_SignatureCodeList_item = -1;  /* CD_SignatureCode */
static int hf_umts_rrc_ies_burstType = -1;        /* BurstType */
static int hf_umts_rrc_ies_midambleShift = -1;    /* MidambleShiftLong */
static int hf_umts_rrc_ies_timeslot = -1;         /* TimeslotNumber */
static int hf_umts_rrc_ies_cellParametersID = -1;  /* CellParametersID */
static int hf_umts_rrc_ies_notActive = -1;        /* NULL */
static int hf_umts_rrc_ies_isActive = -1;         /* AvailableMinimumSF_ListVCAM */
static int hf_umts_rrc_ies_availableAP_SignatureList = -1;  /* AvailableAP_SignatureList */
static int hf_umts_rrc_ies_pdsch_CodeMapList = -1;  /* PDSCH_CodeMapList */
static int hf_umts_rrc_ies_secondInterleavingMode = -1;  /* SecondInterleavingMode */
static int hf_umts_rrc_ies_tfci_Coding = -1;      /* TFCI_Coding */
static int hf_umts_rrc_ies_puncturingLimit = -1;  /* PuncturingLimit */
static int hf_umts_rrc_ies_repetitionPeriodAndLength = -1;  /* RepetitionPeriodAndLength */
static int hf_umts_rrc_ies_repetitionPeriodLengthAndOffset = -1;  /* RepetitionPeriodLengthAndOffset */
static int hf_umts_rrc_ies_cpch_SetID = -1;       /* CPCH_SetID */
static int hf_umts_rrc_ies_dynamicPersistenceLevelTF_List = -1;  /* DynamicPersistenceLevelTF_List */
static int hf_umts_rrc_ies_CPCH_PersistenceLevelsList_item = -1;  /* CPCH_PersistenceLevels */
static int hf_umts_rrc_ies_ap_PreambleScramblingCode = -1;  /* AP_PreambleScramblingCode */
static int hf_umts_rrc_ies_ap_AICH_ChannelisationCode = -1;  /* AP_AICH_ChannelisationCode */
static int hf_umts_rrc_ies_cd_PreambleScramblingCode = -1;  /* CD_PreambleScramblingCode */
static int hf_umts_rrc_ies_cd_CA_ICH_ChannelisationCode = -1;  /* CD_CA_ICH_ChannelisationCode */
static int hf_umts_rrc_ies_cd_AccessSlotSubchannelList = -1;  /* CD_AccessSlotSubchannelList */
static int hf_umts_rrc_ies_cd_SignatureCodeList = -1;  /* CD_SignatureCodeList */
static int hf_umts_rrc_ies_deltaPp_m = -1;        /* DeltaPp_m */
static int hf_umts_rrc_ies_ul_DPCCH_SlotFormat = -1;  /* UL_DPCCH_SlotFormat */
static int hf_umts_rrc_ies_n_StartMessage = -1;   /* N_StartMessage */
static int hf_umts_rrc_ies_n_EOT = -1;            /* N_EOT */
static int hf_umts_rrc_ies_channelAssignmentActive = -1;  /* ChannelAssignmentActive */
static int hf_umts_rrc_ies_cpch_StatusIndicationMode = -1;  /* CPCH_StatusIndicationMode */
static int hf_umts_rrc_ies_pcpch_ChannelInfoList = -1;  /* PCPCH_ChannelInfoList */
static int hf_umts_rrc_ies_CPCH_SetInfoList_item = -1;  /* CPCH_SetInfo */
static int hf_umts_rrc_ies_timeInfo = -1;         /* TimeInfo */
static int hf_umts_rrc_ies_commonTimeslotInfo = -1;  /* CommonTimeslotInfo */
static int hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes = -1;  /* DownlinkTimeslotsCodes */
static int hf_umts_rrc_ies_ul_CCTrChTPCList = -1;  /* UL_CCTrChTPCList */
static int hf_umts_rrc_ies_tddOption = -1;        /* T_tddOption */
static int hf_umts_rrc_ies_tdd384 = -1;           /* T_tdd384 */
static int hf_umts_rrc_ies_tdd128 = -1;           /* T_tdd128 */
static int hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes1 = -1;  /* DownlinkTimeslotsCodes_LCR_r4 */
static int hf_umts_rrc_ies_DL_CCTrChList_item = -1;  /* DL_CCTrCh */
static int hf_umts_rrc_ies_DL_CCTrChList_r4_item = -1;  /* DL_CCTrCh_r4 */
static int hf_umts_rrc_ies_DL_CCTrChListToRemove_item = -1;  /* TFCS_IdentityPlain */
static int hf_umts_rrc_ies_DL_CCTrChTPCList_item = -1;  /* TFCS_Identity */
static int hf_umts_rrc_ies_secondaryScramblingCode = -1;  /* SecondaryScramblingCode */
static int hf_umts_rrc_ies_sf_AndCodeNumber = -1;  /* SF512_AndCodeNumber */
static int hf_umts_rrc_ies_scramblingCodeChange = -1;  /* ScramblingCodeChange */
static int hf_umts_rrc_ies_DL_ChannelisationCodeList_item = -1;  /* DL_ChannelisationCode */
static int hf_umts_rrc_ies_dl_DPCH_InfoCommon = -1;  /* DL_DPCH_InfoCommon */
static int hf_umts_rrc_ies_modeSpecificInfo9 = -1;  /* T_modeSpecificInfo9 */
static int hf_umts_rrc_ies_fdd10 = -1;            /* T_fdd9 */
static int hf_umts_rrc_ies_defaultDPCH_OffsetValue = -1;  /* DefaultDPCH_OffsetValueFDD */
static int hf_umts_rrc_ies_dpch_CompressedModeInfo = -1;  /* DPCH_CompressedModeInfo */
static int hf_umts_rrc_ies_tx_DiversityMode = -1;  /* TX_DiversityMode */
static int hf_umts_rrc_ies_dummy_SSDT_Information = -1;  /* SSDT_Information */
static int hf_umts_rrc_ies_tdd9 = -1;             /* T_tdd8 */
static int hf_umts_rrc_ies_defaultDPCH_OffsetValue1 = -1;  /* DefaultDPCH_OffsetValueTDD */
static int hf_umts_rrc_ies_dl_DPCH_InfoCommon1 = -1;  /* DL_DPCH_InfoCommon_r4 */
static int hf_umts_rrc_ies_modeSpecificInfo10 = -1;  /* T_modeSpecificInfo10 */
static int hf_umts_rrc_ies_fdd11 = -1;            /* T_fdd10 */
static int hf_umts_rrc_ies_dummy_SSDT_Information_r4 = -1;  /* SSDT_Information_r4 */
static int hf_umts_rrc_ies_tdd10 = -1;            /* T_tdd9 */
static int hf_umts_rrc_ies_tddOption1 = -1;       /* T_tddOption1 */
static int hf_umts_rrc_ies_tdd3841 = -1;          /* NULL */
static int hf_umts_rrc_ies_tdd1281 = -1;          /* T_tdd1281 */
static int hf_umts_rrc_ies_tstd_Indicator = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_modeSpecificInfo11 = -1;  /* T_modeSpecificInfo11 */
static int hf_umts_rrc_ies_fdd12 = -1;            /* T_fdd11 */
static int hf_umts_rrc_ies_tdd11 = -1;            /* T_tdd10 */
static int hf_umts_rrc_ies_tddOption2 = -1;       /* T_tddOption2 */
static int hf_umts_rrc_ies_tdd1282 = -1;          /* T_tdd1282 */
static int hf_umts_rrc_ies_mac_hsResetIndicator1 = -1;  /* T_mac_hsResetIndicator1 */
static int hf_umts_rrc_ies_dl_dpchInfoCommon = -1;  /* T_dl_dpchInfoCommon */
static int hf_umts_rrc_ies_dl_DPCH_InfoCommon2 = -1;  /* DL_DPCH_InfoCommon_r6 */
static int hf_umts_rrc_ies_dl_FDPCH_InfoCommon = -1;  /* DL_FDPCH_InfoCommon_r6 */
static int hf_umts_rrc_ies_modeSpecificInfo12 = -1;  /* T_modeSpecificInfo12 */
static int hf_umts_rrc_ies_fdd13 = -1;            /* T_fdd12 */
static int hf_umts_rrc_ies_tdd12 = -1;            /* T_tdd11 */
static int hf_umts_rrc_ies_tddOption3 = -1;       /* T_tddOption3 */
static int hf_umts_rrc_ies_tdd1283 = -1;          /* T_tdd1283 */
static int hf_umts_rrc_ies_mac_hsResetIndicator2 = -1;  /* T_mac_hsResetIndicator2 */
static int hf_umts_rrc_ies_postVerificationPeriod = -1;  /* T_postVerificationPeriod */
static int hf_umts_rrc_ies_dl_DPCH_InfoCommon3 = -1;  /* DL_DPCH_InfoCommonPost */
static int hf_umts_rrc_ies_dl_DPCH_InfoCommon4 = -1;  /* DL_DPCH_InfoCommonPredef */
static int hf_umts_rrc_ies_cfnHandling = -1;      /* T_cfnHandling */
static int hf_umts_rrc_ies_maintain = -1;         /* NULL */
static int hf_umts_rrc_ies_initialise = -1;       /* T_initialise */
static int hf_umts_rrc_ies_cfntargetsfnframeoffset = -1;  /* Cfntargetsfnframeoffset */
static int hf_umts_rrc_ies_modeSpecificInfo13 = -1;  /* T_modeSpecificInfo13 */
static int hf_umts_rrc_ies_fdd14 = -1;            /* T_fdd13 */
static int hf_umts_rrc_ies_dl_DPCH_PowerControlInfo = -1;  /* DL_DPCH_PowerControlInfo */
static int hf_umts_rrc_ies_powerOffsetPilot_pdpdch = -1;  /* PowerOffsetPilot_pdpdch */
static int hf_umts_rrc_ies_dl_rate_matching_restriction = -1;  /* Dl_rate_matching_restriction */
static int hf_umts_rrc_ies_spreadingFactorAndPilot = -1;  /* SF512_AndPilot */
static int hf_umts_rrc_ies_positionFixedOrFlexible = -1;  /* PositionFixedOrFlexible */
static int hf_umts_rrc_ies_tfci_Existence = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_tdd13 = -1;            /* T_tdd12 */
static int hf_umts_rrc_ies_cfnHandling1 = -1;     /* T_cfnHandling1 */
static int hf_umts_rrc_ies_initialise1 = -1;      /* T_initialise1 */
static int hf_umts_rrc_ies_modeSpecificInfo14 = -1;  /* T_modeSpecificInfo14 */
static int hf_umts_rrc_ies_fdd15 = -1;            /* T_fdd14 */
static int hf_umts_rrc_ies_tdd14 = -1;            /* T_tdd13 */
static int hf_umts_rrc_ies_mac_d_HFN_initial_value = -1;  /* MAC_d_HFN_initial_value */
static int hf_umts_rrc_ies_cfnHandling2 = -1;     /* T_cfnHandling2 */
static int hf_umts_rrc_ies_maintain1 = -1;        /* T_maintain */
static int hf_umts_rrc_ies_timingmaintainedsynchind = -1;  /* TimingMaintainedSynchInd */
static int hf_umts_rrc_ies_initialise2 = -1;      /* NULL */
static int hf_umts_rrc_ies_modeSpecificInfo15 = -1;  /* T_modeSpecificInfo15 */
static int hf_umts_rrc_ies_fdd16 = -1;            /* T_fdd15 */
static int hf_umts_rrc_ies_tdd15 = -1;            /* T_tdd14 */
static int hf_umts_rrc_ies_modeSpecificInfo16 = -1;  /* T_modeSpecificInfo16 */
static int hf_umts_rrc_ies_fdd17 = -1;            /* T_fdd16 */
static int hf_umts_rrc_ies_tdd16 = -1;            /* T_tdd15 */
static int hf_umts_rrc_ies_fdd18 = -1;            /* T_fdd17 */
static int hf_umts_rrc_ies_pCPICH_UsageForChannelEst = -1;  /* PCPICH_UsageForChannelEst */
static int hf_umts_rrc_ies_dpch_FrameOffset = -1;  /* DPCH_FrameOffset */
static int hf_umts_rrc_ies_secondaryCPICH_Info = -1;  /* SecondaryCPICH_Info */
static int hf_umts_rrc_ies_dl_ChannelisationCodeList = -1;  /* DL_ChannelisationCodeList */
static int hf_umts_rrc_ies_tpc_CombinationIndex = -1;  /* TPC_CombinationIndex */
static int hf_umts_rrc_ies_dummy_SSDT_CellIdentity = -1;  /* SSDT_CellIdentity */
static int hf_umts_rrc_ies_closedLoopTimingAdjMode = -1;  /* ClosedLoopTimingAdjMode */
static int hf_umts_rrc_ies_tdd17 = -1;            /* T_tdd16 */
static int hf_umts_rrc_ies_dl_CCTrChListToEstablish = -1;  /* DL_CCTrChList */
static int hf_umts_rrc_ies_dl_CCTrChListToRemove = -1;  /* DL_CCTrChListToRemove */
static int hf_umts_rrc_ies_fdd19 = -1;            /* T_fdd18 */
static int hf_umts_rrc_ies_tdd18 = -1;            /* T_tdd17 */
static int hf_umts_rrc_ies_dl_CCTrChListToEstablish1 = -1;  /* DL_CCTrChList_r4 */
static int hf_umts_rrc_ies_fdd20 = -1;            /* T_fdd19 */
static int hf_umts_rrc_ies_powerOffsetTPC_pdpdch = -1;  /* PowerOffsetTPC_pdpdch */
static int hf_umts_rrc_ies_tdd19 = -1;            /* T_tdd18 */
static int hf_umts_rrc_ies_fdd21 = -1;            /* T_fdd20 */
static int hf_umts_rrc_ies_tdd20 = -1;            /* T_tdd19 */
static int hf_umts_rrc_ies_fdpch_FrameOffset = -1;  /* DPCH_FrameOffset */
static int hf_umts_rrc_ies_dl_ChannelisationCode = -1;  /* INTEGER_0_255 */
static int hf_umts_rrc_ies_dl_ChannelisationCode1 = -1;  /* DL_ChannelisationCode */
static int hf_umts_rrc_ies_dl_DPCH_TimeslotsCodes = -1;  /* DownlinkTimeslotsCodes */
static int hf_umts_rrc_ies_modeSpecificInfo17 = -1;  /* T_modeSpecificInfo17 */
static int hf_umts_rrc_ies_fdd22 = -1;            /* T_fdd21 */
static int hf_umts_rrc_ies_dpc_Mode = -1;         /* DPC_Mode */
static int hf_umts_rrc_ies_tdd21 = -1;            /* T_tdd20 */
static int hf_umts_rrc_ies_tpc_StepSizeTDD = -1;  /* TPC_StepSizeTDD */
static int hf_umts_rrc_ies_cfnHandling3 = -1;     /* T_cfnHandling3 */
static int hf_umts_rrc_ies_maintain2 = -1;        /* T_maintain1 */
static int hf_umts_rrc_ies_dl_FDPCH_PowerControlInfo = -1;  /* DL_DPCH_PowerControlInfo */
static int hf_umts_rrc_ies_dl_FDPCH_TPCcommandErrorRate = -1;  /* INTEGER_1_16 */
static int hf_umts_rrc_ies_hs_scch_Info = -1;     /* HS_SCCH_Info */
static int hf_umts_rrc_ies_measurement_feedback_Info = -1;  /* Measurement_Feedback_Info */
static int hf_umts_rrc_ies_modeSpecificInfo18 = -1;  /* T_modeSpecificInfo18 */
static int hf_umts_rrc_ies_tdd22 = -1;            /* T_tdd21 */
static int hf_umts_rrc_ies_tdd3842 = -1;          /* T_tdd3841 */
static int hf_umts_rrc_ies_dl_HSPDSCH_TS_Configuration = -1;  /* DL_HSPDSCH_TS_Configuration */
static int hf_umts_rrc_ies_tdd1284 = -1;          /* T_tdd1284 */
static int hf_umts_rrc_ies_hs_PDSCH_Midamble_Configuration_tdd128 = -1;  /* HS_PDSCH_Midamble_Configuration_TDD128 */
static int hf_umts_rrc_ies_hs_scch_Info1 = -1;    /* HS_SCCH_Info_r6 */
static int hf_umts_rrc_ies_modeSpecificInfo19 = -1;  /* T_modeSpecificInfo19 */
static int hf_umts_rrc_ies_tdd23 = -1;            /* T_tdd22 */
static int hf_umts_rrc_ies_tdd3843 = -1;          /* T_tdd3842 */
static int hf_umts_rrc_ies_tdd1285 = -1;          /* T_tdd1285 */
static int hf_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item = -1;  /* DL_HSPDSCH_TS_Configuration_item */
static int hf_umts_rrc_ies_midambleShiftAndBurstType = -1;  /* MidambleShiftAndBurstType_DL */
static int hf_umts_rrc_ies_modeSpecificInfo20 = -1;  /* T_modeSpecificInfo20 */
static int hf_umts_rrc_ies_fdd23 = -1;            /* T_fdd22 */
static int hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info = -1;  /* PDSCH_SHO_DCH_Info */
static int hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping = -1;  /* PDSCH_CodeMapping */
static int hf_umts_rrc_ies_tdd24 = -1;            /* PrimaryCCPCH_Info */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL = -1;  /* DL_DPCH_InfoPerRL */
static int hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH = -1;  /* SCCPCH_InfoForFACH */
static int hf_umts_rrc_ies_modeSpecificInfo21 = -1;  /* T_modeSpecificInfo21 */
static int hf_umts_rrc_ies_fdd24 = -1;            /* T_fdd23 */
static int hf_umts_rrc_ies_tdd25 = -1;            /* PrimaryCCPCH_Info_r4 */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL1 = -1;  /* DL_DPCH_InfoPerRL_r4 */
static int hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH_r4 = -1;  /* SCCPCH_InfoForFACH_r4 */
static int hf_umts_rrc_ies_cell_id = -1;          /* CellIdentity */
static int hf_umts_rrc_ies_modeSpecificInfo22 = -1;  /* T_modeSpecificInfo22 */
static int hf_umts_rrc_ies_fdd25 = -1;            /* T_fdd24 */
static int hf_umts_rrc_ies_servingHSDSCH_RL_indicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL2 = -1;  /* DL_DPCH_InfoPerRL_r5 */
static int hf_umts_rrc_ies_modeSpecificInfo23 = -1;  /* T_modeSpecificInfo23 */
static int hf_umts_rrc_ies_fdd26 = -1;            /* T_fdd25 */
static int hf_umts_rrc_ies_modeSpecificInfo24 = -1;  /* T_modeSpecificInfo24 */
static int hf_umts_rrc_ies_fdd27 = -1;            /* T_fdd26 */
static int hf_umts_rrc_ies_servingEDCH_RL_indicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dl_dpchInfo = -1;      /* T_dl_dpchInfo */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL3 = -1;  /* DL_DPCH_InfoPerRL_r6 */
static int hf_umts_rrc_ies_dl_FDPCH_InfoPerRL = -1;  /* DL_FDPCH_InfoPerRL_r6 */
static int hf_umts_rrc_ies_e_AGCH_Information = -1;  /* E_AGCH_Information */
static int hf_umts_rrc_ies_e_HICH_Information = -1;  /* E_HICH_Information */
static int hf_umts_rrc_ies_e_RGCH_Information = -1;  /* E_RGCH_Information */
static int hf_umts_rrc_ies_DL_InformationPerRL_List_item = -1;  /* DL_InformationPerRL */
static int hf_umts_rrc_ies_DL_InformationPerRL_List_r4_item = -1;  /* DL_InformationPerRL_r4 */
static int hf_umts_rrc_ies_DL_InformationPerRL_List_r5_item = -1;  /* DL_InformationPerRL_r5 */
static int hf_umts_rrc_ies_DL_InformationPerRL_List_r6_item = -1;  /* DL_InformationPerRL_r6 */
static int hf_umts_rrc_ies_DL_InformationPerRL_List_r5bis_item = -1;  /* DL_InformationPerRL_r5bis */
static int hf_umts_rrc_ies_DL_InformationPerRL_ListPostFDD_item = -1;  /* DL_InformationPerRL_PostFDD */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL4 = -1;  /* DL_DPCH_InfoPerRL_PostFDD */
static int hf_umts_rrc_ies_primaryCCPCH_Info = -1;  /* PrimaryCCPCH_InfoPost */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL5 = -1;  /* DL_DPCH_InfoPerRL_PostTDD */
static int hf_umts_rrc_ies_primaryCCPCH_Info1 = -1;  /* PrimaryCCPCH_InfoPostTDD_LCR_r4 */
static int hf_umts_rrc_ies_dl_DPCH_InfoPerRL6 = -1;  /* DL_DPCH_InfoPerRL_PostTDD_LCR_r4 */
static int hf_umts_rrc_ies_restrictedTrCH_InfoList = -1;  /* RestrictedTrCH_InfoList */
static int hf_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List_item = -1;  /* DL_TPC_PowerOffsetPerRL */
static int hf_umts_rrc_ies_codesRepresentation = -1;  /* T_codesRepresentation */
static int hf_umts_rrc_ies_consecutive = -1;      /* T_consecutive */
static int hf_umts_rrc_ies_firstChannelisationCode = -1;  /* DL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_lastChannelisationCode = -1;  /* DL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_bitmap = -1;           /* T_bitmap */
static int hf_umts_rrc_ies_parameters = -1;       /* T_parameters */
static int hf_umts_rrc_ies_sameAsLast = -1;       /* T_sameAsLast */
static int hf_umts_rrc_ies_timeslotNumber = -1;   /* TimeslotNumber */
static int hf_umts_rrc_ies_newParameters = -1;    /* T_newParameters */
static int hf_umts_rrc_ies_individualTimeslotInfo = -1;  /* IndividualTimeslotInfo */
static int hf_umts_rrc_ies_dl_TS_ChannelisationCodesShort = -1;  /* DL_TS_ChannelisationCodesShort */
static int hf_umts_rrc_ies_parameters1 = -1;      /* T_parameters1 */
static int hf_umts_rrc_ies_sameAsLast1 = -1;      /* T_sameAsLast1 */
static int hf_umts_rrc_ies_timeslotNumber1 = -1;  /* TimeslotNumber_LCR_r4 */
static int hf_umts_rrc_ies_newParameters1 = -1;   /* T_newParameters1 */
static int hf_umts_rrc_ies_individualTimeslotInfo1 = -1;  /* IndividualTimeslotInfo_LCR_r4 */
static int hf_umts_rrc_ies_firstIndividualTimeslotInfo = -1;  /* IndividualTimeslotInfo */
static int hf_umts_rrc_ies_moreTimeslots = -1;    /* T_moreTimeslots */
static int hf_umts_rrc_ies_noMore = -1;           /* NULL */
static int hf_umts_rrc_ies_additionalTimeslots = -1;  /* T_additionalTimeslots */
static int hf_umts_rrc_ies_consecutive1 = -1;     /* INTEGER_1_maxTS1 */
static int hf_umts_rrc_ies_timeslotList = -1;     /* SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots */
static int hf_umts_rrc_ies_timeslotList_item = -1;  /* DownlinkAdditionalTimeslots */
static int hf_umts_rrc_ies_firstIndividualTimeslotInfo1 = -1;  /* IndividualTimeslotInfo_LCR_r4 */
static int hf_umts_rrc_ies_moreTimeslots1 = -1;   /* T_moreTimeslots1 */
static int hf_umts_rrc_ies_additionalTimeslots1 = -1;  /* T_additionalTimeslots1 */
static int hf_umts_rrc_ies_consecutive2 = -1;     /* INTEGER_1_maxTSLCR1 */
static int hf_umts_rrc_ies_timeslotList1 = -1;    /* SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4 */
static int hf_umts_rrc_ies_timeslotList_item1 = -1;  /* DownlinkAdditionalTimeslots_LCR_r4 */
static int hf_umts_rrc_ies_tgp_SequenceList = -1;  /* TGP_SequenceList */
static int hf_umts_rrc_ies_tgps_Reconfiguration_CFN = -1;  /* TGPS_Reconfiguration_CFN */
static int hf_umts_rrc_ies_tgp_SequenceShortList = -1;  /* SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort */
static int hf_umts_rrc_ies_tgp_SequenceShortList_item = -1;  /* TGP_SequenceShort */
static int hf_umts_rrc_ies_maxTFCI_Field2Value = -1;  /* MaxTFCI_Field2Value */
static int hf_umts_rrc_ies_spreadingFactor = -1;  /* SF_PDSCH */
static int hf_umts_rrc_ies_codeNumber = -1;       /* CodeNumberDSCH */
static int hf_umts_rrc_ies_multiCodeInfo = -1;    /* MultiCodeInfo */
static int hf_umts_rrc_ies_DSCH_MappingList_item = -1;  /* DSCH_Mapping */
static int hf_umts_rrc_ies_DSCH_TransportChannelsInfo_item = -1;  /* DSCH_TransportChannelsInfo_item */
static int hf_umts_rrc_ies_dsch_transport_channel_identity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_dsch_TFS = -1;         /* TransportFormatSet */
static int hf_umts_rrc_ies_DynamicPersistenceLevelList_item = -1;  /* DynamicPersistenceLevel */
static int hf_umts_rrc_ies_DynamicPersistenceLevelTF_List_item = -1;  /* DynamicPersistenceLevel */
static int hf_umts_rrc_ies_e_AGCH_ChannelisationCode = -1;  /* E_AGCH_ChannelisationCode */
static int hf_umts_rrc_ies_e_DPCCH_DPCCH_PowerOffset = -1;  /* E_DPCCH_DPCCH_PowerOffset */
static int hf_umts_rrc_ies_happyBit_DelayCondition = -1;  /* HappyBit_DelayCondition */
static int hf_umts_rrc_ies_e_TFCI_TableIndex = -1;  /* E_TFCI_TableIndex */
static int hf_umts_rrc_ies_e_DCH_MinimumSet_E_TFCI = -1;  /* E_DCH_MinimumSet_E_TFCI */
static int hf_umts_rrc_ies_reference_E_TFCIs = -1;  /* E_DPDCH_Reference_E_TFCIList */
static int hf_umts_rrc_ies_maxChannelisationCodes = -1;  /* E_DPDCH_MaxChannelisationCodes */
static int hf_umts_rrc_ies_pl_NonMax = -1;        /* E_DPDCH_PL_NonMax */
static int hf_umts_rrc_ies_schedulingInfoConfiguration = -1;  /* E_DPDCH_SchedulingInfoConfiguration */
static int hf_umts_rrc_ies_schedulingTransmConfiguraration = -1;  /* E_DPDCH_SchedulingTransmConfiguration */
static int hf_umts_rrc_ies_reference_E_TFCI = -1;  /* INTEGER_0_127 */
static int hf_umts_rrc_ies_reference_E_TFCI_PO = -1;  /* INTEGER_0 */
static int hf_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList_item = -1;  /* E_DPDCH_Reference_E_TFCI */
static int hf_umts_rrc_ies_periodicityOfSchedInfo_NoGrant = -1;  /* E_DPDCH_PeriodicyOfSchedInfo */
static int hf_umts_rrc_ies_periodicityOfSchedInfo_Grant = -1;  /* E_DPDCH_PeriodicyOfSchedInfo */
static int hf_umts_rrc_ies_powerOffsetForSchedInfo = -1;  /* INTEGER_0_6 */
static int hf_umts_rrc_ies_ms2_SchedTransmGrantHARQAlloc = -1;  /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_servingGrant = -1;     /* INTEGER_0_31 */
static int hf_umts_rrc_ies_primary_Secondary_GrantSelector = -1;  /* T_primary_Secondary_GrantSelector */
static int hf_umts_rrc_ies_dl_ScramblingCode = -1;  /* SecondaryScramblingCode */
static int hf_umts_rrc_ies_channelisationCode = -1;  /* E_HICH_ChannelisationCode */
static int hf_umts_rrc_ies_signatureSequence = -1;  /* E_HICH_RGCH_SignatureSequence */
static int hf_umts_rrc_ies_rg_CombinationIndex = -1;  /* E_RGCH_CombinationIndex */
static int hf_umts_rrc_ies_e_RGCH_StepSize = -1;  /* E_RGCH_StepSize */
static int hf_umts_rrc_ies_ctch_Indicator = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_FACH_PCH_InformationList_item = -1;  /* FACH_PCH_Information */
static int hf_umts_rrc_ies_timeslot1 = -1;        /* TimeslotNumber_LCR_r4 */
static int hf_umts_rrc_ies_channelisationCode1 = -1;  /* TDD_FPACH_CCode16_r4 */
static int hf_umts_rrc_ies_midambleShiftAndBurstType1 = -1;  /* MidambleShiftAndBurstType_LCR_r4 */
static int hf_umts_rrc_ies_wi = -1;               /* Wi_LCR */
static int hf_umts_rrc_ies_modeSpecificInfo25 = -1;  /* T_modeSpecificInfo25 */
static int hf_umts_rrc_ies_fdd28 = -1;            /* FrequencyInfoFDD */
static int hf_umts_rrc_ies_tdd26 = -1;            /* FrequencyInfoTDD */
static int hf_umts_rrc_ies_uarfcn_UL = -1;        /* UARFCN */
static int hf_umts_rrc_ies_uarfcn_DL = -1;        /* UARFCN */
static int hf_umts_rrc_ies_uarfcn_Nt = -1;        /* UARFCN */
static int hf_umts_rrc_ies_midambleAllocationMode = -1;  /* T_midambleAllocationMode */
static int hf_umts_rrc_ies_defaultMidamble = -1;  /* NULL */
static int hf_umts_rrc_ies_commonMidamble = -1;   /* NULL */
static int hf_umts_rrc_ies_ueSpecificMidamble = -1;  /* INTEGER_0_15 */
static int hf_umts_rrc_ies_midambleConfiguration = -1;  /* INTEGER_1_8 */
static int hf_umts_rrc_ies_modeSpecificInfo26 = -1;  /* T_modeSpecificInfo26 */
static int hf_umts_rrc_ies_fdd29 = -1;            /* T_fdd27 */
static int hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo = -1;  /* SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes */
static int hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo_item = -1;  /* HS_SCCH_Codes */
static int hf_umts_rrc_ies_tdd27 = -1;            /* T_tdd23 */
static int hf_umts_rrc_ies_tdd3844 = -1;          /* T_tdd3843 */
static int hf_umts_rrc_ies_nack_ack_power_offset = -1;  /* INTEGER_M7_8 */
static int hf_umts_rrc_ies_hs_SICH_PowerControl_Info = -1;  /* HS_SICH_Power_Control_Info_TDD384 */
static int hf_umts_rrc_ies_hS_SCCH_SetConfiguration = -1;  /* SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384 */
static int hf_umts_rrc_ies_hS_SCCH_SetConfiguration_item = -1;  /* HS_SCCH_TDD384 */
static int hf_umts_rrc_ies_tdd1286 = -1;          /* SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128 */
static int hf_umts_rrc_ies_tdd128_item = -1;      /* HS_SCCH_TDD128 */
static int hf_umts_rrc_ies_modeSpecificInfo27 = -1;  /* T_modeSpecificInfo27 */
static int hf_umts_rrc_ies_fdd30 = -1;            /* T_fdd28 */
static int hf_umts_rrc_ies_tdd28 = -1;            /* T_tdd24 */
static int hf_umts_rrc_ies_tdd3845 = -1;          /* T_tdd3844 */
static int hf_umts_rrc_ies_dhs_sync = -1;         /* DHS_Sync */
static int hf_umts_rrc_ies_firstChannelisationCode1 = -1;  /* HS_ChannelisationCode_LCR */
static int hf_umts_rrc_ies_secondChannelisationCode = -1;  /* HS_ChannelisationCode_LCR */
static int hf_umts_rrc_ies_midambleAllocationMode1 = -1;  /* T_midambleAllocationMode1 */
static int hf_umts_rrc_ies_bler_target = -1;      /* Bler_Target */
static int hf_umts_rrc_ies_hs_sich_configuration = -1;  /* HS_SICH_Configuration_TDD128 */
static int hf_umts_rrc_ies_channelisationCode2 = -1;  /* HS_ChannelisationCode_LCR */
static int hf_umts_rrc_ies_midambleAllocationMode2 = -1;  /* T_midambleAllocationMode2 */
static int hf_umts_rrc_ies_ueSpecificMidamble1 = -1;  /* T_ueSpecificMidamble */
static int hf_umts_rrc_ies_power_level_HSSICH = -1;  /* INTEGER_M120_M58 */
static int hf_umts_rrc_ies_tpc_step_size = -1;    /* T_tpc_step_size */
static int hf_umts_rrc_ies_channelisationCode3 = -1;  /* DL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_midambleAllocationMode3 = -1;  /* T_midambleAllocationMode3 */
static int hf_umts_rrc_ies_ueSpecificMidamble2 = -1;  /* T_ueSpecificMidamble1 */
static int hf_umts_rrc_ies_midambleconfiguration = -1;  /* MidambleConfigurationBurstType1and3 */
static int hf_umts_rrc_ies_hs_sich_configuration1 = -1;  /* HS_SICH_Configuration_TDD384 */
static int hf_umts_rrc_ies_midambleAllocationMode4 = -1;  /* T_midambleAllocationMode4 */
static int hf_umts_rrc_ies_ueSpecificMidamble3 = -1;  /* T_ueSpecificMidamble2 */
static int hf_umts_rrc_ies_ul_target_SIR = -1;    /* INTEGER_M22_40 */
static int hf_umts_rrc_ies_hs_sich_ConstantValue = -1;  /* ConstantValue */
static int hf_umts_rrc_ies_midambleShiftAndBurstType2 = -1;  /* MidambleShiftAndBurstType */
static int hf_umts_rrc_ies_modulation = -1;       /* T_modulation */
static int hf_umts_rrc_ies_ss_TPC_Symbols = -1;   /* T_ss_TPC_Symbols */
static int hf_umts_rrc_ies_additionalSS_TPC_Symbols = -1;  /* INTEGER_1_15 */
static int hf_umts_rrc_ies_modulation1 = -1;      /* T_modulation1 */
static int hf_umts_rrc_ies_ss_TPC_Symbols1 = -1;  /* T_ss_TPC_Symbols1 */
static int hf_umts_rrc_ies_ul_TimeslotInterference = -1;  /* TDD_UL_Interference */
static int hf_umts_rrc_ies_IndividualTS_InterferenceList_item = -1;  /* IndividualTS_Interference */
static int hf_umts_rrc_ies_modeSpecificInfo28 = -1;  /* T_modeSpecificInfo28 */
static int hf_umts_rrc_ies_fdd31 = -1;            /* T_fdd29 */
static int hf_umts_rrc_ies_measurementPowerOffset = -1;  /* MeasurementPowerOffset */
static int hf_umts_rrc_ies_feedback_cycle = -1;   /* Feedback_cycle */
static int hf_umts_rrc_ies_cqi_RepetitionFactor = -1;  /* CQI_RepetitionFactor */
static int hf_umts_rrc_ies_deltaCQI = -1;         /* DeltaCQI */
static int hf_umts_rrc_ies_burstType1 = -1;       /* T_burstType */
static int hf_umts_rrc_ies_type11 = -1;           /* T_type11 */
static int hf_umts_rrc_ies_midambleConfigurationBurstType1and3 = -1;  /* MidambleConfigurationBurstType1and3 */
static int hf_umts_rrc_ies_midambleAllocationMode5 = -1;  /* T_midambleAllocationMode5 */
static int hf_umts_rrc_ies_ueSpecificMidamble4 = -1;  /* T_ueSpecificMidamble3 */
static int hf_umts_rrc_ies_type2 = -1;            /* T_type2 */
static int hf_umts_rrc_ies_midambleConfigurationBurstType2 = -1;  /* MidambleConfigurationBurstType2 */
static int hf_umts_rrc_ies_midambleAllocationMode6 = -1;  /* T_midambleAllocationMode6 */
static int hf_umts_rrc_ies_ueSpecificMidamble5 = -1;  /* T_ueSpecificMidamble4 */
static int hf_umts_rrc_ies_midambleShift1 = -1;   /* MidambleShiftShort */
static int hf_umts_rrc_ies_type3 = -1;            /* T_type3 */
static int hf_umts_rrc_ies_midambleAllocationMode7 = -1;  /* T_midambleAllocationMode7 */
static int hf_umts_rrc_ies_ueSpecificMidamble6 = -1;  /* T_ueSpecificMidamble5 */
static int hf_umts_rrc_ies_burstType2 = -1;       /* T_burstType1 */
static int hf_umts_rrc_ies_type12 = -1;           /* T_type12 */
static int hf_umts_rrc_ies_midambleAllocationMode8 = -1;  /* T_midambleAllocationMode8 */
static int hf_umts_rrc_ies_ueSpecificMidamble7 = -1;  /* T_ueSpecificMidamble6 */
static int hf_umts_rrc_ies_type21 = -1;           /* T_type21 */
static int hf_umts_rrc_ies_midambleAllocationMode9 = -1;  /* T_midambleAllocationMode9 */
static int hf_umts_rrc_ies_ueSpecificMidamble8 = -1;  /* T_ueSpecificMidamble7 */
static int hf_umts_rrc_ies_midambleAllocationMode10 = -1;  /* T_midambleAllocationMode10 */
static int hf_umts_rrc_ies_ueSpecificMidamble9 = -1;  /* T_ueSpecificMidamble8 */
static int hf_umts_rrc_ies_midambleShift2 = -1;   /* INTEGER_0_15 */
static int hf_umts_rrc_ies_primaryCCPCH_TX_Power = -1;  /* PrimaryCCPCH_TX_Power */
static int hf_umts_rrc_ies_alpha = -1;            /* Alpha */
static int hf_umts_rrc_ies_prach_ConstantValue = -1;  /* ConstantValueTdd */
static int hf_umts_rrc_ies_dpch_ConstantValue = -1;  /* ConstantValueTdd */
static int hf_umts_rrc_ies_pusch_ConstantValue = -1;  /* ConstantValueTdd */
static int hf_umts_rrc_ies_ipdl_alpha = -1;       /* Alpha */
static int hf_umts_rrc_ies_maxPowerIncrease = -1;  /* MaxPowerIncrease_r4 */
static int hf_umts_rrc_ies_pcpch_UL_ScramblingCode = -1;  /* INTEGER_0_79 */
static int hf_umts_rrc_ies_pcpch_DL_ChannelisationCode = -1;  /* INTEGER_0_511 */
static int hf_umts_rrc_ies_pcpch_DL_ScramblingCode = -1;  /* SecondaryScramblingCode */
static int hf_umts_rrc_ies_pcp_Length = -1;       /* PCP_Length */
static int hf_umts_rrc_ies_ucsm_Info = -1;        /* UCSM_Info */
static int hf_umts_rrc_ies_PCPCH_ChannelInfoList_item = -1;  /* PCPCH_ChannelInfo */
static int hf_umts_rrc_ies_pdsch_PowerControlInfo = -1;  /* PDSCH_PowerControlInfo */
static int hf_umts_rrc_ies_pdsch_AllocationPeriodInfo = -1;  /* AllocationPeriodInfo */
static int hf_umts_rrc_ies_configuration = -1;    /* T_configuration */
static int hf_umts_rrc_ies_old_Configuration = -1;  /* T_old_Configuration */
static int hf_umts_rrc_ies_pdsch_Identity = -1;   /* PDSCH_Identity */
static int hf_umts_rrc_ies_new_Configuration = -1;  /* T_new_Configuration */
static int hf_umts_rrc_ies_pdsch_Info = -1;       /* PDSCH_Info */
static int hf_umts_rrc_ies_configuration1 = -1;   /* T_configuration1 */
static int hf_umts_rrc_ies_old_Configuration1 = -1;  /* T_old_Configuration1 */
static int hf_umts_rrc_ies_new_Configuration1 = -1;  /* T_new_Configuration1 */
static int hf_umts_rrc_ies_pdsch_Info1 = -1;      /* PDSCH_Info_r4 */
static int hf_umts_rrc_ies_PDSCH_CodeInfoList_item = -1;  /* PDSCH_CodeInfo */
static int hf_umts_rrc_ies_codeNumberStart = -1;  /* CodeNumberDSCH */
static int hf_umts_rrc_ies_codeNumberStop = -1;   /* CodeNumberDSCH */
static int hf_umts_rrc_ies_PDSCH_CodeMapList_item = -1;  /* PDSCH_CodeMap */
static int hf_umts_rrc_ies_signallingMethod = -1;  /* T_signallingMethod */
static int hf_umts_rrc_ies_codeRange = -1;        /* CodeRange */
static int hf_umts_rrc_ies_tfci_Range1 = -1;      /* DSCH_MappingList */
static int hf_umts_rrc_ies_explicit_config3 = -1;  /* PDSCH_CodeInfoList */
static int hf_umts_rrc_ies_replace = -1;          /* ReplacedPDSCH_CodeInfoList */
static int hf_umts_rrc_ies_pdsch_TimeslotsCodes = -1;  /* DownlinkTimeslotsCodes */
static int hf_umts_rrc_ies_tddOption4 = -1;       /* T_tddOption4 */
static int hf_umts_rrc_ies_tdd3846 = -1;          /* T_tdd3845 */
static int hf_umts_rrc_ies_tdd1287 = -1;          /* T_tdd1286 */
static int hf_umts_rrc_ies_pdsch_TimeslotsCodes1 = -1;  /* DownlinkTimeslotsCodes_LCR_r4 */
static int hf_umts_rrc_ies_dsch_RadioLinkIdentifier = -1;  /* DSCH_RadioLinkIdentifier */
static int hf_umts_rrc_ies_rl_IdentifierList = -1;  /* RL_IdentifierList */
static int hf_umts_rrc_ies_dsch_TFCS = -1;        /* TFCS */
static int hf_umts_rrc_ies_dsch_TransportChannelsInfo = -1;  /* DSCH_TransportChannelsInfo */
static int hf_umts_rrc_ies_pdsch_Info2 = -1;      /* PDSCH_Info_LCR_r4 */
static int hf_umts_rrc_ies_PDSCH_SysInfoList_item = -1;  /* PDSCH_SysInfo */
static int hf_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5_item = -1;  /* PDSCH_SysInfo_HCR_r5 */
static int hf_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4_item = -1;  /* PDSCH_SysInfo_LCR_r4 */
static int hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_item = -1;  /* PDSCH_SysInfoList_SFN_item */
static int hf_umts_rrc_ies_pdsch_SysInfo = -1;    /* PDSCH_SysInfo */
static int hf_umts_rrc_ies_sfn_TimeInfo = -1;     /* SFN_TimeInfo */
static int hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item = -1;  /* PDSCH_SysInfoList_SFN_HCR_r5_item */
static int hf_umts_rrc_ies_pdsch_SysInfo1 = -1;   /* PDSCH_SysInfo_HCR_r5 */
static int hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item = -1;  /* PDSCH_SysInfoList_SFN_LCR_r4_item */
static int hf_umts_rrc_ies_pdsch_SysInfo2 = -1;   /* PDSCH_SysInfo_LCR_r4 */
static int hf_umts_rrc_ies_PersistenceScalingFactorList_item = -1;  /* PersistenceScalingFactor */
static int hf_umts_rrc_ies_PichChannelisationCodeList_LCR_r4_item = -1;  /* DL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_fdd32 = -1;            /* T_fdd30 */
static int hf_umts_rrc_ies_pi_CountPerFrame = -1;  /* PI_CountPerFrame */
static int hf_umts_rrc_ies_tdd29 = -1;            /* T_tdd25 */
static int hf_umts_rrc_ies_channelisationCode4 = -1;  /* TDD_PICH_CCode */
static int hf_umts_rrc_ies_repetitionPeriodLengthOffset = -1;  /* RepPerLengthOffset_PICH */
static int hf_umts_rrc_ies_pagingIndicatorLength = -1;  /* PagingIndicatorLength */
static int hf_umts_rrc_ies_n_GAP = -1;            /* N_GAP */
static int hf_umts_rrc_ies_n_PCH = -1;            /* N_PCH */
static int hf_umts_rrc_ies_pichChannelisationCodeList_LCR_r4 = -1;  /* PichChannelisationCodeList_LCR_r4 */
static int hf_umts_rrc_ies_algorithm1 = -1;       /* TPC_StepSizeFDD */
static int hf_umts_rrc_ies_algorithm2 = -1;       /* NULL */
static int hf_umts_rrc_ies_PRACH_ChanCodes_LCR_r4_item = -1;  /* TDD_PRACH_CCode_LCR_r4 */
static int hf_umts_rrc_ies_timeslot2 = -1;        /* TimeslotNumber_PRACH_LCR_r4 */
static int hf_umts_rrc_ies_prach_ChanCodes_LCR = -1;  /* PRACH_ChanCodes_LCR_r4 */
static int hf_umts_rrc_ies_fpach_Info = -1;       /* FPACH_Info_r4 */
static int hf_umts_rrc_ies_fdd33 = -1;            /* SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD */
static int hf_umts_rrc_ies_fdd_item = -1;         /* ASCSetting_FDD */
static int hf_umts_rrc_ies_tdd30 = -1;            /* SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD */
static int hf_umts_rrc_ies_tdd_item = -1;         /* ASCSetting_TDD */
static int hf_umts_rrc_ies_PRACH_Partitioning_LCR_r4_item = -1;  /* ASCSetting_TDD_LCR_r4 */
static int hf_umts_rrc_ies_powerRampStep = -1;    /* PowerRampStep */
static int hf_umts_rrc_ies_preambleRetransMax = -1;  /* PreambleRetransMax */
static int hf_umts_rrc_ies_modeSpecificInfo29 = -1;  /* T_modeSpecificInfo29 */
static int hf_umts_rrc_ies_fdd34 = -1;            /* T_fdd31 */
static int hf_umts_rrc_ies_availableSignatures = -1;  /* AvailableSignatures */
static int hf_umts_rrc_ies_availableSF = -1;      /* SF_PRACH */
static int hf_umts_rrc_ies_preambleScramblingCodeWordNumber = -1;  /* PreambleScramblingCodeWordNumber */
static int hf_umts_rrc_ies_availableSubChannelNumbers = -1;  /* AvailableSubChannelNumbers */
static int hf_umts_rrc_ies_tdd31 = -1;            /* T_tdd26 */
static int hf_umts_rrc_ies_channelisationCodeList = -1;  /* TDD_PRACH_CCodeList */
static int hf_umts_rrc_ies_prach_Midamble = -1;   /* PRACH_Midamble */
static int hf_umts_rrc_ies_sync_UL_Info = -1;     /* SYNC_UL_Info_r4 */
static int hf_umts_rrc_ies_prach_DefinitionList = -1;  /* SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4 */
static int hf_umts_rrc_ies_prach_DefinitionList_item = -1;  /* PRACH_Definition_LCR_r4 */
static int hf_umts_rrc_ies_prach_RACH_Info = -1;  /* PRACH_RACH_Info */
static int hf_umts_rrc_ies_rach_TransportFormatSet = -1;  /* TransportFormatSet */
static int hf_umts_rrc_ies_rach_TFCS = -1;        /* TFCS */
static int hf_umts_rrc_ies_prach_Partitioning = -1;  /* PRACH_Partitioning */
static int hf_umts_rrc_ies_persistenceScalingFactorList = -1;  /* PersistenceScalingFactorList */
static int hf_umts_rrc_ies_ac_To_ASC_MappingTable = -1;  /* AC_To_ASC_MappingTable */
static int hf_umts_rrc_ies_modeSpecificInfo30 = -1;  /* T_modeSpecificInfo30 */
static int hf_umts_rrc_ies_fdd35 = -1;            /* T_fdd32 */
static int hf_umts_rrc_ies_primaryCPICH_TX_Power = -1;  /* PrimaryCPICH_TX_Power */
static int hf_umts_rrc_ies_constantValue = -1;    /* ConstantValue */
static int hf_umts_rrc_ies_prach_PowerOffset = -1;  /* PRACH_PowerOffset */
static int hf_umts_rrc_ies_rach_TransmissionParameters = -1;  /* RACH_TransmissionParameters */
static int hf_umts_rrc_ies_aich_Info = -1;        /* AICH_Info */
static int hf_umts_rrc_ies_prach_RACH_Info_LCR = -1;  /* PRACH_RACH_Info_LCR_r4 */
static int hf_umts_rrc_ies_rach_TransportFormatSet_LCR = -1;  /* TransportFormatSet_LCR */
static int hf_umts_rrc_ies_prach_Partitioning_LCR = -1;  /* PRACH_Partitioning_LCR_r4 */
static int hf_umts_rrc_ies_PRACH_SystemInformationList_item = -1;  /* PRACH_SystemInformation */
static int hf_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4_item = -1;  /* PRACH_SystemInformation_LCR_r4 */
static int hf_umts_rrc_ies_ul_DPCH_InfoPredef = -1;  /* UL_DPCH_InfoPredef */
static int hf_umts_rrc_ies_dl_CommonInformationPredef = -1;  /* DL_CommonInformationPredef */
static int hf_umts_rrc_ies_fdd36 = -1;            /* T_fdd33 */
static int hf_umts_rrc_ies_tx_DiversityIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_tdd32 = -1;            /* T_tdd27 */
static int hf_umts_rrc_ies_syncCase = -1;         /* SyncCase */
static int hf_umts_rrc_ies_sctd_Indicator = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_syncCase1 = -1;        /* T_syncCase1 */
static int hf_umts_rrc_ies_syncCase2 = -1;        /* T_syncCase2 */
static int hf_umts_rrc_ies_timeslotSync2 = -1;    /* TimeslotSync2 */
static int hf_umts_rrc_ies_fdd37 = -1;            /* T_fdd34 */
static int hf_umts_rrc_ies_tdd33 = -1;            /* T_tdd28 */
static int hf_umts_rrc_ies_tddOption5 = -1;       /* T_tddOption5 */
static int hf_umts_rrc_ies_tdd3847 = -1;          /* T_tdd3846 */
static int hf_umts_rrc_ies_tdd1288 = -1;          /* T_tdd1287 */
static int hf_umts_rrc_ies_primaryScramblingCode = -1;  /* PrimaryScramblingCode */
static int hf_umts_rrc_ies_pusch_Allocation = -1;  /* T_pusch_Allocation */
static int hf_umts_rrc_ies_pusch_AllocationPending = -1;  /* NULL */
static int hf_umts_rrc_ies_pusch_AllocationAssignment = -1;  /* T_pusch_AllocationAssignment */
static int hf_umts_rrc_ies_pusch_AllocationPeriodInfo = -1;  /* AllocationPeriodInfo */
static int hf_umts_rrc_ies_pusch_PowerControlInfo = -1;  /* UL_TargetSIR */
static int hf_umts_rrc_ies_configuration2 = -1;   /* T_configuration2 */
static int hf_umts_rrc_ies_old_Configuration2 = -1;  /* T_old_Configuration2 */
static int hf_umts_rrc_ies_pusch_Identity = -1;   /* PUSCH_Identity */
static int hf_umts_rrc_ies_new_Configuration2 = -1;  /* T_new_Configuration2 */
static int hf_umts_rrc_ies_pusch_Info = -1;       /* PUSCH_Info */
static int hf_umts_rrc_ies_pusch_Allocation1 = -1;  /* T_pusch_Allocation1 */
static int hf_umts_rrc_ies_pusch_AllocationAssignment1 = -1;  /* T_pusch_AllocationAssignment1 */
static int hf_umts_rrc_ies_pusch_PowerControlInfo1 = -1;  /* PUSCH_PowerControlInfo_r4 */
static int hf_umts_rrc_ies_configuration3 = -1;   /* T_configuration3 */
static int hf_umts_rrc_ies_old_Configuration3 = -1;  /* T_old_Configuration3 */
static int hf_umts_rrc_ies_new_Configuration3 = -1;  /* T_new_Configuration3 */
static int hf_umts_rrc_ies_pusch_Info1 = -1;      /* PUSCH_Info_r4 */
static int hf_umts_rrc_ies_pusch_TimeslotsCodes = -1;  /* UplinkTimeslotsCodes */
static int hf_umts_rrc_ies_tddOption6 = -1;       /* T_tddOption6 */
static int hf_umts_rrc_ies_tdd3848 = -1;          /* T_tdd3847 */
static int hf_umts_rrc_ies_tdd1289 = -1;          /* T_tdd1288 */
static int hf_umts_rrc_ies_pusch_TimeslotsCodes1 = -1;  /* UplinkTimeslotsCodes_LCR_r4 */
static int hf_umts_rrc_ies_ul_TargetSIR = -1;     /* UL_TargetSIR */
static int hf_umts_rrc_ies_tddOption7 = -1;       /* T_tddOption7 */
static int hf_umts_rrc_ies_tdd12810 = -1;         /* T_tdd1289 */
static int hf_umts_rrc_ies_tpc_StepSize = -1;     /* TPC_StepSizeTDD */
static int hf_umts_rrc_ies_usch_TFCS = -1;        /* TFCS */
static int hf_umts_rrc_ies_usch_TransportChannelsInfo = -1;  /* USCH_TransportChannelsInfo */
static int hf_umts_rrc_ies_pusch_Info2 = -1;      /* PUSCH_Info_LCR_r4 */
static int hf_umts_rrc_ies_PUSCH_SysInfoList_item = -1;  /* PUSCH_SysInfo */
static int hf_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5_item = -1;  /* PUSCH_SysInfo_HCR_r5 */
static int hf_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4_item = -1;  /* PUSCH_SysInfo_LCR_r4 */
static int hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_item = -1;  /* PUSCH_SysInfoList_SFN_item */
static int hf_umts_rrc_ies_pusch_SysInfo = -1;    /* PUSCH_SysInfo */
static int hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item = -1;  /* PUSCH_SysInfoList_SFN_HCR_r5_item */
static int hf_umts_rrc_ies_pusch_SysInfo1 = -1;   /* PUSCH_SysInfo_HCR_r5 */
static int hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item = -1;  /* PUSCH_SysInfoList_SFN_LCR_r4_item */
static int hf_umts_rrc_ies_pusch_SysInfo2 = -1;   /* PUSCH_SysInfo_LCR_r4 */
static int hf_umts_rrc_ies_mmax = -1;             /* INTEGER_1_32 */
static int hf_umts_rrc_ies_nb01Min = -1;          /* NB01 */
static int hf_umts_rrc_ies_nb01Max = -1;          /* NB01 */
static int hf_umts_rrc_ies_repetitionPeriod1 = -1;  /* NULL */
static int hf_umts_rrc_ies_repetitionPeriod2 = -1;  /* INTEGER_1_1 */
static int hf_umts_rrc_ies_repetitionPeriod4 = -1;  /* INTEGER_1_3 */
static int hf_umts_rrc_ies_repetitionPeriod8 = -1;  /* INTEGER_1_7 */
static int hf_umts_rrc_ies_repetitionPeriod16 = -1;  /* INTEGER_1_15 */
static int hf_umts_rrc_ies_repetitionPeriod32 = -1;  /* INTEGER_1_31 */
static int hf_umts_rrc_ies_repetitionPeriod64 = -1;  /* INTEGER_1_63 */
static int hf_umts_rrc_ies_repetitionPeriod21 = -1;  /* T_repetitionPeriod2 */
static int hf_umts_rrc_ies_length = -1;           /* NULL */
static int hf_umts_rrc_ies_offset = -1;           /* INTEGER_0_1 */
static int hf_umts_rrc_ies_repetitionPeriod41 = -1;  /* T_repetitionPeriod4 */
static int hf_umts_rrc_ies_length1 = -1;          /* INTEGER_1_3 */
static int hf_umts_rrc_ies_offset1 = -1;          /* INTEGER_0_3 */
static int hf_umts_rrc_ies_repetitionPeriod81 = -1;  /* T_repetitionPeriod8 */
static int hf_umts_rrc_ies_length2 = -1;          /* INTEGER_1_7 */
static int hf_umts_rrc_ies_offset2 = -1;          /* INTEGER_0_7 */
static int hf_umts_rrc_ies_repetitionPeriod161 = -1;  /* T_repetitionPeriod16 */
static int hf_umts_rrc_ies_length3 = -1;          /* INTEGER_1_15 */
static int hf_umts_rrc_ies_offset3 = -1;          /* INTEGER_0_15 */
static int hf_umts_rrc_ies_repetitionPeriod321 = -1;  /* T_repetitionPeriod32 */
static int hf_umts_rrc_ies_length4 = -1;          /* INTEGER_1_31 */
static int hf_umts_rrc_ies_offset4 = -1;          /* INTEGER_0_31 */
static int hf_umts_rrc_ies_repetitionPeriod641 = -1;  /* T_repetitionPeriod64 */
static int hf_umts_rrc_ies_length5 = -1;          /* INTEGER_1_63 */
static int hf_umts_rrc_ies_offset5 = -1;          /* INTEGER_0_63 */
static int hf_umts_rrc_ies_tfci_Field2 = -1;      /* MaxTFCI_Field2Value */
static int hf_umts_rrc_ies_ReplacedPDSCH_CodeInfoList_item = -1;  /* ReplacedPDSCH_CodeInfo */
static int hf_umts_rrc_ies_rpp4_2 = -1;           /* INTEGER_0_3 */
static int hf_umts_rrc_ies_rpp8_2 = -1;           /* INTEGER_0_7 */
static int hf_umts_rrc_ies_rpp8_4 = -1;           /* INTEGER_0_7 */
static int hf_umts_rrc_ies_rpp16_2 = -1;          /* INTEGER_0_15 */
static int hf_umts_rrc_ies_rpp16_4 = -1;          /* INTEGER_0_15 */
static int hf_umts_rrc_ies_rpp32_2 = -1;          /* INTEGER_0_31 */
static int hf_umts_rrc_ies_rpp32_4 = -1;          /* INTEGER_0_31 */
static int hf_umts_rrc_ies_rpp64_2 = -1;          /* INTEGER_0_63 */
static int hf_umts_rrc_ies_rpp64_4 = -1;          /* INTEGER_0_63 */
static int hf_umts_rrc_ies_dl_restrictedTrCh_Type = -1;  /* DL_TrCH_Type */
static int hf_umts_rrc_ies_restrictedDL_TrCH_Identity = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_allowedTFIList = -1;   /* AllowedTFI_List */
static int hf_umts_rrc_ies_RestrictedTrCH_InfoList_item = -1;  /* RestrictedTrCH */
static int hf_umts_rrc_ies_sccpch_InfoforFACH = -1;  /* SCCPCH_InfoForFACH */
static int hf_umts_rrc_ies_cell_Id = -1;          /* CellIdentity */
static int hf_umts_rrc_ies_dl_dpchInfo1 = -1;     /* T_dl_dpchInfo1 */
static int hf_umts_rrc_ies_RL_AdditionInformationList_item = -1;  /* RL_AdditionInformation */
static int hf_umts_rrc_ies_RL_AdditionInformationList_r6_item = -1;  /* RL_AdditionInformation_r6 */
static int hf_umts_rrc_ies_RL_IdentifierList_item = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_RL_RemovalInformationList_item = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_SCCPCH_ChannelisationCodeList_item = -1;  /* SCCPCH_ChannelisationCode */
static int hf_umts_rrc_ies_secondaryCCPCH_Info = -1;  /* SecondaryCCPCH_Info */
static int hf_umts_rrc_ies_modeSpecificInfo31 = -1;  /* T_modeSpecificInfo31 */
static int hf_umts_rrc_ies_fdd38 = -1;            /* T_fdd35 */
static int hf_umts_rrc_ies_fach_PCH_InformationList = -1;  /* FACH_PCH_InformationList */
static int hf_umts_rrc_ies_sib_ReferenceListFACH = -1;  /* SIB_ReferenceListFACH */
static int hf_umts_rrc_ies_tdd34 = -1;            /* T_tdd29 */
static int hf_umts_rrc_ies_secondaryCCPCH_Info1 = -1;  /* SecondaryCCPCH_Info_r4 */
static int hf_umts_rrc_ies_modeSpecificInfo32 = -1;  /* T_modeSpecificInfo32 */
static int hf_umts_rrc_ies_fdd39 = -1;            /* T_fdd36 */
static int hf_umts_rrc_ies_pich_Info = -1;        /* PICH_Info */
static int hf_umts_rrc_ies_secondaryCCPCH_LCR_Extensions = -1;  /* SecondaryCCPCH_Info_LCR_r4_ext */
static int hf_umts_rrc_ies_pich_Info1 = -1;       /* PICH_Info_LCR_r4 */
static int hf_umts_rrc_ies_mcch_ConfigurationInfo = -1;  /* MBMS_MCCH_ConfigurationInfo_r6 */
static int hf_umts_rrc_ies_SCCPCH_SystemInformationList_item = -1;  /* SCCPCH_SystemInformation */
static int hf_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext_item = -1;  /* SCCPCH_SystemInformation_LCR_r4_ext */
static int hf_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext_item = -1;  /* SCCPCH_SystemInformation_MBMS_r6_ext */
static int hf_umts_rrc_ies_secondaryCCPCHInfo_MBMS = -1;  /* SecondaryCCPCHInfo_MBMS_r6 */
static int hf_umts_rrc_ies_transportFormatCombinationSet = -1;  /* TFCS */
static int hf_umts_rrc_ies_fachCarryingMCCH = -1;  /* T_fachCarryingMCCH */
static int hf_umts_rrc_ies_fachCarryingMTCH_List = -1;  /* MBMS_FACHCarryingMTCH_List */
static int hf_umts_rrc_ies_schedulingInformation = -1;  /* T_schedulingInformation */
static int hf_umts_rrc_ies_fachCarryingMSCH = -1;  /* TransportFormatSet */
static int hf_umts_rrc_ies_mschConfigurationInfo = -1;  /* MBMS_MSCHConfigurationInfo_r6 */
static int hf_umts_rrc_ies_primary_Secondary_GrantSelector1 = -1;  /* T_primary_Secondary_GrantSelector1 */
static int hf_umts_rrc_ies_e_DCH_RL_Info_NewServingCell = -1;  /* E_DCH_RL_Info */
static int hf_umts_rrc_ies_e_DCH_RL_Info_OldServingCell = -1;  /* E_DCH_RL_Info */
static int hf_umts_rrc_ies_modeSpecificInfo33 = -1;  /* T_modeSpecificInfo33 */
static int hf_umts_rrc_ies_fdd40 = -1;            /* T_fdd37 */
static int hf_umts_rrc_ies_dummy1_PCPICH_UsageForChannelEst = -1;  /* PCPICH_UsageForChannelEst */
static int hf_umts_rrc_ies_dummy2_SecondaryCPICH_Info = -1;  /* SecondaryCPICH_Info */
static int hf_umts_rrc_ies_sf_AndCodeNumber1 = -1;  /* SF256_AndCodeNumber */
static int hf_umts_rrc_ies_pilotSymbolExistence = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_timingOffset = -1;     /* TimingOffset */
static int hf_umts_rrc_ies_tdd35 = -1;            /* T_tdd30 */
static int hf_umts_rrc_ies_commonTimeslotInfo1 = -1;  /* CommonTimeslotInfoSCCPCH */
static int hf_umts_rrc_ies_channelisationCode5 = -1;  /* SCCPCH_ChannelisationCodeList */
static int hf_umts_rrc_ies_modeSpecificInfo34 = -1;  /* T_modeSpecificInfo34 */
static int hf_umts_rrc_ies_fdd41 = -1;            /* T_fdd38 */
static int hf_umts_rrc_ies_tdd36 = -1;            /* T_tdd31 */
static int hf_umts_rrc_ies_tddOption8 = -1;       /* T_tddOption8 */
static int hf_umts_rrc_ies_tdd3849 = -1;          /* T_tdd3848 */
static int hf_umts_rrc_ies_tdd12811 = -1;         /* T_tdd12810 */
static int hf_umts_rrc_ies_individualTimeslotLCR_Ext = -1;  /* IndividualTimeslotInfo_LCR_r4_ext */
static int hf_umts_rrc_ies_modeSpecificInfo35 = -1;  /* T_modeSpecificInfo35 */
static int hf_umts_rrc_ies_fdd42 = -1;            /* T_fdd39 */
static int hf_umts_rrc_ies_tdd38410 = -1;         /* DownlinkTimeslotsCodes */
static int hf_umts_rrc_ies_tdd12812 = -1;         /* DownlinkTimeslotsCodes_LCR_r4 */
static int hf_umts_rrc_ies_secondaryDL_ScramblingCode = -1;  /* SecondaryScramblingCode */
static int hf_umts_rrc_ies_channelisationCode6 = -1;  /* ChannelisationCode256 */
static int hf_umts_rrc_ies_sf4 = -1;              /* INTEGER_0_3 */
static int hf_umts_rrc_ies_sf8 = -1;              /* INTEGER_0_7 */
static int hf_umts_rrc_ies_sf16 = -1;             /* INTEGER_0_15 */
static int hf_umts_rrc_ies_sf32 = -1;             /* INTEGER_0_31 */
static int hf_umts_rrc_ies_sf64 = -1;             /* INTEGER_0_63 */
static int hf_umts_rrc_ies_sf128 = -1;            /* INTEGER_0_127 */
static int hf_umts_rrc_ies_sf256 = -1;            /* INTEGER_0_255 */
static int hf_umts_rrc_ies_sf512 = -1;            /* INTEGER_0_511 */
static int hf_umts_rrc_ies_sfd4 = -1;             /* NULL */
static int hf_umts_rrc_ies_sfd8 = -1;             /* NULL */
static int hf_umts_rrc_ies_sfd16 = -1;            /* NULL */
static int hf_umts_rrc_ies_sfd32 = -1;            /* NULL */
static int hf_umts_rrc_ies_sfd64 = -1;            /* NULL */
static int hf_umts_rrc_ies_sfd128 = -1;           /* PilotBits128 */
static int hf_umts_rrc_ies_sfd256 = -1;           /* PilotBits256 */
static int hf_umts_rrc_ies_sfd512 = -1;           /* NULL */
static int hf_umts_rrc_ies_activationTimeSFN = -1;  /* INTEGER_0_4095 */
static int hf_umts_rrc_ies_physChDuration = -1;   /* DurationTimeInfo */
static int hf_umts_rrc_ies_s_Field = -1;          /* S_Field */
static int hf_umts_rrc_ies_codeWordSet = -1;      /* CodeWordSet */
static int hf_umts_rrc_ies_ssdt_UL_r4 = -1;       /* SSDT_UL */
static int hf_umts_rrc_ies_sync_UL_CodesBitmap = -1;  /* T_sync_UL_CodesBitmap */
static int hf_umts_rrc_ies_prxUpPCHdes = -1;      /* INTEGER_0_62 */
static int hf_umts_rrc_ies_sync_UL_Procedure = -1;  /* SYNC_UL_Procedure_r4 */
static int hf_umts_rrc_ies_max_SYNC_UL_Transmissions = -1;  /* T_max_SYNC_UL_Transmissions */
static int hf_umts_rrc_ies_powerRampStep1 = -1;   /* INTEGER_0_3 */
static int hf_umts_rrc_ies_sync_UL_Codes_Bitmap = -1;  /* T_sync_UL_Codes_Bitmap */
static int hf_umts_rrc_ies_max_SYNC_UL_Transmissions1 = -1;  /* T_max_SYNC_UL_Transmissions1 */
static int hf_umts_rrc_ies_sf81 = -1;             /* SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8 */
static int hf_umts_rrc_ies_sf8_item = -1;         /* TDD_PRACH_CCode8 */
static int hf_umts_rrc_ies_sf161 = -1;            /* SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16 */
static int hf_umts_rrc_ies_sf16_item = -1;        /* TDD_PRACH_CCode16 */
static int hf_umts_rrc_ies_tgpsi = -1;            /* TGPSI */
static int hf_umts_rrc_ies_tgps_Status = -1;      /* T_tgps_Status */
static int hf_umts_rrc_ies_activate = -1;         /* T_activate */
static int hf_umts_rrc_ies_tgcfn = -1;            /* TGCFN */
static int hf_umts_rrc_ies_deactivate = -1;       /* NULL */
static int hf_umts_rrc_ies_tgps_ConfigurationParams = -1;  /* TGPS_ConfigurationParams */
static int hf_umts_rrc_ies_TGP_SequenceList_item = -1;  /* TGP_Sequence */
static int hf_umts_rrc_ies_tgps_Status1 = -1;     /* T_tgps_Status1 */
static int hf_umts_rrc_ies_activate1 = -1;        /* T_activate1 */
static int hf_umts_rrc_ies_tgmp = -1;             /* TGMP */
static int hf_umts_rrc_ies_tgprc = -1;            /* TGPRC */
static int hf_umts_rrc_ies_tgsn = -1;             /* TGSN */
static int hf_umts_rrc_ies_tgl1 = -1;             /* TGL */
static int hf_umts_rrc_ies_tgl2 = -1;             /* TGL */
static int hf_umts_rrc_ies_tgd = -1;              /* TGD */
static int hf_umts_rrc_ies_tgpl1 = -1;            /* TGPL */
static int hf_umts_rrc_ies_dummy_TGPL = -1;       /* TGPL */
static int hf_umts_rrc_ies_rpp = -1;              /* RPP */
static int hf_umts_rrc_ies_itp = -1;              /* ITP */
static int hf_umts_rrc_ies_ul_DL_Mode = -1;       /* UL_DL_Mode */
static int hf_umts_rrc_ies_dl_FrameType = -1;     /* DL_FrameType */
static int hf_umts_rrc_ies_deltaSIR1 = -1;        /* DeltaSIR */
static int hf_umts_rrc_ies_deltaSIRAfter1 = -1;   /* DeltaSIR */
static int hf_umts_rrc_ies_deltaSIR2 = -1;        /* DeltaSIR */
static int hf_umts_rrc_ies_deltaSIRAfter2 = -1;   /* DeltaSIR */
static int hf_umts_rrc_ies_nidentifyAbort = -1;   /* NidentifyAbort */
static int hf_umts_rrc_ies_treconfirmAbort = -1;  /* TreconfirmAbort */
static int hf_umts_rrc_ies_activationTime = -1;   /* ActivationTime */
static int hf_umts_rrc_ies_durationTimeInfo = -1;  /* DurationTimeInfo */
static int hf_umts_rrc_ies_TimeslotList_item = -1;  /* TimeslotNumber */
static int hf_umts_rrc_ies_tdd38411 = -1;         /* SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber */
static int hf_umts_rrc_ies_tdd384_item = -1;      /* TimeslotNumber */
static int hf_umts_rrc_ies_tdd12813 = -1;         /* SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4 */
static int hf_umts_rrc_ies_tdd128_item1 = -1;     /* TimeslotNumber_LCR_r4 */
static int hf_umts_rrc_ies_channelReqParamsForUCSM = -1;  /* ChannelReqParamsForUCSM */
static int hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes = -1;  /* UplinkTimeslotsCodes */
static int hf_umts_rrc_ies_tddOption9 = -1;       /* T_tddOption9 */
static int hf_umts_rrc_ies_tdd38412 = -1;         /* T_tdd3849 */
static int hf_umts_rrc_ies_tdd12814 = -1;         /* T_tdd12811 */
static int hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes1 = -1;  /* UplinkTimeslotsCodes_LCR_r4 */
static int hf_umts_rrc_ies_UL_CCTrCHList_item = -1;  /* UL_CCTrCH */
static int hf_umts_rrc_ies_UL_CCTrCHList_r4_item = -1;  /* UL_CCTrCH_r4 */
static int hf_umts_rrc_ies_UL_CCTrCHListToRemove_item = -1;  /* TFCS_IdentityPlain */
static int hf_umts_rrc_ies_UL_CCTrChTPCList_item = -1;  /* TFCS_Identity */
static int hf_umts_rrc_ies_ul_DPCH_Info = -1;     /* UL_DPCH_Info */
static int hf_umts_rrc_ies_dummy_CPCH_SetInfo = -1;  /* CPCH_SetInfo */
static int hf_umts_rrc_ies_ul_DPCH_Info1 = -1;    /* UL_DPCH_Info_r4 */
static int hf_umts_rrc_ies_ul_DPCH_Info2 = -1;    /* UL_DPCH_Info_r5 */
static int hf_umts_rrc_ies_dummy1_CPCH_SetInfo = -1;  /* CPCH_SetInfo */
static int hf_umts_rrc_ies_dummy2_CPCH_SetID = -1;  /* CPCH_SetID */
static int hf_umts_rrc_ies_ul = -1;               /* UL_CompressedModeMethod */
static int hf_umts_rrc_ies_dl = -1;               /* DL_CompressedModeMethod */
static int hf_umts_rrc_ies_ul_and_dl = -1;        /* T_ul_and_dl */
static int hf_umts_rrc_ies_modeSpecificInfo36 = -1;  /* T_modeSpecificInfo36 */
static int hf_umts_rrc_ies_fdd43 = -1;            /* T_fdd40 */
static int hf_umts_rrc_ies_scramblingCodeType = -1;  /* ScramblingCodeType */
static int hf_umts_rrc_ies_scramblingCode = -1;   /* UL_ScramblingCode */
static int hf_umts_rrc_ies_numberOfDPDCH = -1;    /* NumberOfDPDCH */
static int hf_umts_rrc_ies_spreadingFactor1 = -1;  /* SpreadingFactor */
static int hf_umts_rrc_ies_numberOfFBI_Bits = -1;  /* NumberOfFBI_Bits */
static int hf_umts_rrc_ies_tdd37 = -1;            /* T_tdd32 */
static int hf_umts_rrc_ies_ul_TimingAdvance = -1;  /* UL_TimingAdvanceControl */
static int hf_umts_rrc_ies_ul_CCTrCHList = -1;    /* UL_CCTrCHList */
static int hf_umts_rrc_ies_ul_CCTrCHListToRemove = -1;  /* UL_CCTrCHListToRemove */
static int hf_umts_rrc_ies_modeSpecificInfo37 = -1;  /* T_modeSpecificInfo37 */
static int hf_umts_rrc_ies_fdd44 = -1;            /* T_fdd41 */
static int hf_umts_rrc_ies_tdd38 = -1;            /* T_tdd33 */
static int hf_umts_rrc_ies_ul_TimingAdvance1 = -1;  /* UL_TimingAdvanceControl_r4 */
static int hf_umts_rrc_ies_ul_CCTrCHList1 = -1;   /* UL_CCTrCHList_r4 */
static int hf_umts_rrc_ies_modeSpecificInfo38 = -1;  /* T_modeSpecificInfo38 */
static int hf_umts_rrc_ies_fdd45 = -1;            /* T_fdd42 */
static int hf_umts_rrc_ies_tdd39 = -1;            /* T_tdd34 */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo3 = -1;  /* UL_DPCH_PowerControlInfo_r6 */
static int hf_umts_rrc_ies_modeSpecificInfo39 = -1;  /* T_modeSpecificInfo39 */
static int hf_umts_rrc_ies_fdd46 = -1;            /* T_fdd43 */
static int hf_umts_rrc_ies_tdd40 = -1;            /* T_tdd35 */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo4 = -1;  /* UL_DPCH_PowerControlInfoPostFDD */
static int hf_umts_rrc_ies_reducedScramblingCodeNumber = -1;  /* ReducedScramblingCodeNumber */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo5 = -1;  /* UL_DPCH_PowerControlInfoPostTDD */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo6 = -1;  /* UL_DPCH_PowerControlInfoPostTDD_LCR_r4 */
static int hf_umts_rrc_ies_ul_TimingAdvance2 = -1;  /* UL_TimingAdvanceControl_LCR_r4 */
static int hf_umts_rrc_ies_ul_DPCH_PowerControlInfo7 = -1;  /* UL_DPCH_PowerControlInfoPredef */
static int hf_umts_rrc_ies_modeSpecificInfo40 = -1;  /* T_modeSpecificInfo40 */
static int hf_umts_rrc_ies_fdd47 = -1;            /* T_fdd44 */
static int hf_umts_rrc_ies_tdd41 = -1;            /* T_tdd36 */
static int hf_umts_rrc_ies_fdd48 = -1;            /* T_fdd45 */
static int hf_umts_rrc_ies_dpcch_PowerOffset = -1;  /* DPCCH_PowerOffset */
static int hf_umts_rrc_ies_pc_Preamble = -1;      /* PC_Preamble */
static int hf_umts_rrc_ies_sRB_delay = -1;        /* SRB_delay */
static int hf_umts_rrc_ies_tdd42 = -1;            /* T_tdd37 */
static int hf_umts_rrc_ies_ul_OL_PC_Signalling = -1;  /* T_ul_OL_PC_Signalling */
static int hf_umts_rrc_ies_broadcast_UL_OL_PC_info = -1;  /* NULL */
static int hf_umts_rrc_ies_individuallySignalled = -1;  /* T_individuallySignalled */
static int hf_umts_rrc_ies_individualTS_InterferenceList = -1;  /* IndividualTS_InterferenceList */
static int hf_umts_rrc_ies_fdd49 = -1;            /* T_fdd46 */
static int hf_umts_rrc_ies_tdd43 = -1;            /* T_tdd38 */
static int hf_umts_rrc_ies_ul_OL_PC_Signalling1 = -1;  /* T_ul_OL_PC_Signalling1 */
static int hf_umts_rrc_ies_individuallySignalled1 = -1;  /* T_individuallySignalled1 */
static int hf_umts_rrc_ies_tddOption10 = -1;      /* T_tddOption10 */
static int hf_umts_rrc_ies_tdd38413 = -1;         /* T_tdd38410 */
static int hf_umts_rrc_ies_dpch_ConstantValue1 = -1;  /* ConstantValue */
static int hf_umts_rrc_ies_tdd12815 = -1;         /* T_tdd12812 */
static int hf_umts_rrc_ies_fdd50 = -1;            /* T_fdd47 */
static int hf_umts_rrc_ies_ack_NACK_repetition_factor = -1;  /* ACK_NACK_repetitionFactor */
static int hf_umts_rrc_ies_tdd44 = -1;            /* T_tdd39 */
static int hf_umts_rrc_ies_ul_OL_PC_Signalling2 = -1;  /* T_ul_OL_PC_Signalling2 */
static int hf_umts_rrc_ies_individuallySignalled2 = -1;  /* T_individuallySignalled2 */
static int hf_umts_rrc_ies_tddOption11 = -1;      /* T_tddOption11 */
static int hf_umts_rrc_ies_tdd38414 = -1;         /* T_tdd38411 */
static int hf_umts_rrc_ies_tdd12816 = -1;         /* T_tdd12813 */
static int hf_umts_rrc_ies_fdd51 = -1;            /* T_fdd48 */
static int hf_umts_rrc_ies_tdd45 = -1;            /* T_tdd40 */
static int hf_umts_rrc_ies_ul_OL_PC_Signalling3 = -1;  /* T_ul_OL_PC_Signalling3 */
static int hf_umts_rrc_ies_individuallySignalled3 = -1;  /* T_individuallySignalled3 */
static int hf_umts_rrc_ies_tddOption12 = -1;      /* T_tddOption12 */
static int hf_umts_rrc_ies_tdd38415 = -1;         /* T_tdd38412 */
static int hf_umts_rrc_ies_tdd12817 = -1;         /* T_tdd12814 */
static int hf_umts_rrc_ies_beaconPLEst = -1;      /* BEACON_PL_Est */
static int hf_umts_rrc_ies_dpcch_PowerOffset1 = -1;  /* DPCCH_PowerOffset2 */
static int hf_umts_rrc_ies_fdd52 = -1;            /* T_fdd49 */
static int hf_umts_rrc_ies_tdd46 = -1;            /* T_tdd41 */
static int hf_umts_rrc_ies_e_DPCCH_Info = -1;     /* E_DPCCH_Info */
static int hf_umts_rrc_ies_e_DPDCH_Info = -1;     /* E_DPDCH_Info */
static int hf_umts_rrc_ies_stepSize = -1;         /* INTEGER_1_8 */
static int hf_umts_rrc_ies_frequency = -1;        /* INTEGER_1_8 */
static int hf_umts_rrc_ies_disabled = -1;         /* NULL */
static int hf_umts_rrc_ies_enabled = -1;          /* T_enabled */
static int hf_umts_rrc_ies_ul_TimingAdvance3 = -1;  /* UL_TimingAdvance */
static int hf_umts_rrc_ies_enabled1 = -1;         /* T_enabled1 */
static int hf_umts_rrc_ies_tddOption13 = -1;      /* T_tddOption13 */
static int hf_umts_rrc_ies_tdd38416 = -1;         /* T_tdd38413 */
static int hf_umts_rrc_ies_tdd12818 = -1;         /* T_tdd12815 */
static int hf_umts_rrc_ies_ul_SynchronisationParameters = -1;  /* UL_SynchronisationParameters_r4 */
static int hf_umts_rrc_ies_synchronisationParameters = -1;  /* SynchronisationParameters_r4 */
static int hf_umts_rrc_ies_enabled2 = -1;         /* T_enabled2 */
static int hf_umts_rrc_ies_UL_TS_ChannelisationCodeList_item = -1;  /* UL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_parameters2 = -1;      /* T_parameters2 */
static int hf_umts_rrc_ies_sameAsLast2 = -1;      /* T_sameAsLast2 */
static int hf_umts_rrc_ies_newParameters2 = -1;   /* T_newParameters2 */
static int hf_umts_rrc_ies_ul_TS_ChannelisationCodeList = -1;  /* UL_TS_ChannelisationCodeList */
static int hf_umts_rrc_ies_parameters3 = -1;      /* T_parameters3 */
static int hf_umts_rrc_ies_sameAsLast3 = -1;      /* T_sameAsLast3 */
static int hf_umts_rrc_ies_newParameters3 = -1;   /* T_newParameters3 */
static int hf_umts_rrc_ies_dynamicSFusage = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_moreTimeslots2 = -1;   /* T_moreTimeslots2 */
static int hf_umts_rrc_ies_additionalTimeslots2 = -1;  /* T_additionalTimeslots2 */
static int hf_umts_rrc_ies_consecutive3 = -1;     /* T_consecutive1 */
static int hf_umts_rrc_ies_numAdditionalTimeslots = -1;  /* INTEGER_1_maxTS1 */
static int hf_umts_rrc_ies_timeslotList2 = -1;    /* SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots */
static int hf_umts_rrc_ies_timeslotList_item2 = -1;  /* UplinkAdditionalTimeslots */
static int hf_umts_rrc_ies_moreTimeslots3 = -1;   /* T_moreTimeslots3 */
static int hf_umts_rrc_ies_additionalTimeslots3 = -1;  /* T_additionalTimeslots3 */
static int hf_umts_rrc_ies_consecutive4 = -1;     /* T_consecutive2 */
static int hf_umts_rrc_ies_numAdditionalTimeslots1 = -1;  /* INTEGER_1_maxTSLCR1 */
static int hf_umts_rrc_ies_timeslotList3 = -1;    /* SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4 */
static int hf_umts_rrc_ies_timeslotList_item3 = -1;  /* UplinkAdditionalTimeslots_LCR_r4 */
static int hf_umts_rrc_ies_satID = -1;            /* SatID */
static int hf_umts_rrc_ies_doppler0thOrder = -1;  /* INTEGER_M2048_2047 */
static int hf_umts_rrc_ies_extraDopplerInfo = -1;  /* ExtraDopplerInfo */
static int hf_umts_rrc_ies_codePhase = -1;        /* INTEGER_0_1022 */
static int hf_umts_rrc_ies_integerCodePhase = -1;  /* INTEGER_0_19 */
static int hf_umts_rrc_ies_gps_BitNumber = -1;    /* INTEGER_0_3 */
static int hf_umts_rrc_ies_codePhaseSearchWindow = -1;  /* CodePhaseSearchWindow */
static int hf_umts_rrc_ies_azimuthAndElevation = -1;  /* AzimuthAndElevation */
static int hf_umts_rrc_ies_AcquisitionSatInfoList_item = -1;  /* AcquisitionSatInfo */
static int hf_umts_rrc_ies_AdditionalMeasurementID_List_item = -1;  /* MeasurementIdentity */
static int hf_umts_rrc_ies_dataID = -1;           /* INTEGER_0_3 */
static int hf_umts_rrc_ies_e = -1;                /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_t_oa = -1;             /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_deltaI = -1;           /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_omegaDot = -1;         /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_satHealth = -1;        /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_a_Sqrt = -1;           /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_omega0 = -1;           /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_m0 = -1;               /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_omega = -1;            /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_af0 = -1;              /* BIT_STRING_SIZE_11 */
static int hf_umts_rrc_ies_af1 = -1;              /* BIT_STRING_SIZE_11 */
static int hf_umts_rrc_ies_AlmanacSatInfoList_item = -1;  /* AlmanacSatInfo */
static int hf_umts_rrc_ies_azimuth = -1;          /* INTEGER_0_31 */
static int hf_umts_rrc_ies_elevation = -1;        /* INTEGER_0_7 */
static int hf_umts_rrc_ies_BadSatList_item = -1;  /* INTEGER_0_63 */
static int hf_umts_rrc_ies_dl_TransportChannelBLER = -1;  /* DL_TransportChannelBLER */
static int hf_umts_rrc_ies_BLER_MeasurementResultsList_item = -1;  /* BLER_MeasurementResults */
static int hf_umts_rrc_ies_BLER_TransChIdList_item = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_verifiedBSIC = -1;     /* INTEGER_0_maxCellMeas */
static int hf_umts_rrc_ies_nonVerifiedBSIC = -1;  /* BCCH_ARFCN */
static int hf_umts_rrc_ies_burstStart = -1;       /* INTEGER_0_15 */
static int hf_umts_rrc_ies_burstLength = -1;      /* INTEGER_10_25 */
static int hf_umts_rrc_ies_burstFreq = -1;        /* INTEGER_1_16 */
static int hf_umts_rrc_ies_intraFreqReportingCriteria = -1;  /* IntraFreqReportingCriteria */
static int hf_umts_rrc_ies_periodicalReportingCriteria = -1;  /* PeriodicalReportingCriteria */
static int hf_umts_rrc_ies_intraFreqReportingCriteria1 = -1;  /* IntraFreqReportingCriteria_LCR_r4 */
static int hf_umts_rrc_ies_cellIndividualOffset = -1;  /* CellIndividualOffset */
static int hf_umts_rrc_ies_referenceTimeDifferenceToCell = -1;  /* ReferenceTimeDifferenceToCell */
static int hf_umts_rrc_ies_modeSpecificInfo41 = -1;  /* T_modeSpecificInfo41 */
static int hf_umts_rrc_ies_fdd53 = -1;            /* T_fdd50 */
static int hf_umts_rrc_ies_readSFN_Indicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_tdd47 = -1;            /* T_tdd42 */
static int hf_umts_rrc_ies_primaryCCPCH_Info2 = -1;  /* PrimaryCCPCH_Info */
static int hf_umts_rrc_ies_timeslotInfoList = -1;  /* TimeslotInfoList */
static int hf_umts_rrc_ies_modeSpecificInfo42 = -1;  /* T_modeSpecificInfo42 */
static int hf_umts_rrc_ies_fdd54 = -1;            /* T_fdd51 */
static int hf_umts_rrc_ies_tdd48 = -1;            /* T_tdd43 */
static int hf_umts_rrc_ies_primaryCCPCH_Info3 = -1;  /* PrimaryCCPCH_Info_r4 */
static int hf_umts_rrc_ies_timeslotInfoList1 = -1;  /* TimeslotInfoList_r4 */
static int hf_umts_rrc_ies_modeSpecificInfo43 = -1;  /* T_modeSpecificInfo43 */
static int hf_umts_rrc_ies_fdd55 = -1;            /* T_fdd52 */
static int hf_umts_rrc_ies_tdd49 = -1;            /* T_tdd44 */
static int hf_umts_rrc_ies_cellSelectionReselectionInfo = -1;  /* CellSelectReselectInfoSIB_11_12_RSCP */
static int hf_umts_rrc_ies_primaryCCPCH_Info4 = -1;  /* PrimaryCCPCH_Info_LCR_r4 */
static int hf_umts_rrc_ies_timeslotInfoList2 = -1;  /* TimeslotInfoList_LCR_r4 */
static int hf_umts_rrc_ies_modeSpecificInfo44 = -1;  /* T_modeSpecificInfo44 */
static int hf_umts_rrc_ies_fdd56 = -1;            /* T_fdd53 */
static int hf_umts_rrc_ies_tdd50 = -1;            /* T_tdd45 */
static int hf_umts_rrc_ies_cellSelectionReselectionInfo1 = -1;  /* CellSelectReselectInfoSIB_11_12_ECN0 */
static int hf_umts_rrc_ies_modeSpecificInfo45 = -1;  /* T_modeSpecificInfo45 */
static int hf_umts_rrc_ies_fdd57 = -1;            /* T_fdd54 */
static int hf_umts_rrc_ies_tdd51 = -1;            /* T_tdd46 */
static int hf_umts_rrc_ies_cellSelectionReselectionInfo2 = -1;  /* CellSelectReselectInfoSIB_11_12_HCS_RSCP */
static int hf_umts_rrc_ies_modeSpecificInfo46 = -1;  /* T_modeSpecificInfo46 */
static int hf_umts_rrc_ies_fdd58 = -1;            /* T_fdd55 */
static int hf_umts_rrc_ies_tdd52 = -1;            /* T_tdd47 */
static int hf_umts_rrc_ies_cellSelectionReselectionInfo3 = -1;  /* CellSelectReselectInfoSIB_11_12_HCS_ECN0 */
static int hf_umts_rrc_ies_cellIdentity = -1;     /* CellIdentity */
static int hf_umts_rrc_ies_dummy_SFN_SFN_ObsTimeDifference = -1;  /* SFN_SFN_ObsTimeDifference */
static int hf_umts_rrc_ies_cellSynchronisationInfo = -1;  /* CellSynchronisationInfo */
static int hf_umts_rrc_ies_modeSpecificInfo47 = -1;  /* T_modeSpecificInfo47 */
static int hf_umts_rrc_ies_fdd59 = -1;            /* T_fdd56 */
static int hf_umts_rrc_ies_cpich_Ec_N01 = -1;     /* CPICH_Ec_N0 */
static int hf_umts_rrc_ies_cpich_RSCP1 = -1;      /* CPICH_RSCP */
static int hf_umts_rrc_ies_pathloss = -1;         /* Pathloss */
static int hf_umts_rrc_ies_tdd53 = -1;            /* T_tdd48 */
static int hf_umts_rrc_ies_proposedTGSN = -1;     /* TGSN */
static int hf_umts_rrc_ies_primaryCCPCH_RSCP = -1;  /* PrimaryCCPCH_RSCP */
static int hf_umts_rrc_ies_timeslotISCP_List = -1;  /* TimeslotISCP_List */
static int hf_umts_rrc_ies_fdd60 = -1;            /* SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info */
static int hf_umts_rrc_ies_fdd_item1 = -1;        /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_tdd54 = -1;            /* SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info */
static int hf_umts_rrc_ies_tdd_item1 = -1;        /* PrimaryCCPCH_Info */
static int hf_umts_rrc_ies_CellMeasurementEventResults_LCR_r4_item = -1;  /* PrimaryCCPCH_Info_LCR_r4 */
static int hf_umts_rrc_ies_dummy_SFN_SFN_OTD_Type = -1;  /* SFN_SFN_OTD_Type */
static int hf_umts_rrc_ies_cellIdentity_reportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_cellSynchronisationInfoReportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_modeSpecificInfo48 = -1;  /* T_modeSpecificInfo48 */
static int hf_umts_rrc_ies_fdd61 = -1;            /* T_fdd57 */
static int hf_umts_rrc_ies_cpich_Ec_N0_reportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_cpich_RSCP_reportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_pathloss_reportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_tdd55 = -1;            /* T_tdd49 */
static int hf_umts_rrc_ies_timeslotISCP_reportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_proposedTGSN_ReportingRequired = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_primaryCCPCH_RSCP_reportingIndicator = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_q_Offset1S_N = -1;     /* Q_OffsetS_N */
static int hf_umts_rrc_ies_q_Offset2S_N = -1;     /* Q_OffsetS_N */
static int hf_umts_rrc_ies_hcs_NeighbouringCellInformation_RSCP = -1;  /* HCS_NeighbouringCellInformation_RSCP */
static int hf_umts_rrc_ies_modeSpecificInfo49 = -1;  /* T_modeSpecificInfo49 */
static int hf_umts_rrc_ies_fdd62 = -1;            /* T_fdd58 */
static int hf_umts_rrc_ies_tdd56 = -1;            /* T_tdd50 */
static int hf_umts_rrc_ies_gsm = -1;              /* T_gsm */
static int hf_umts_rrc_ies_q_OffsetS_N = -1;      /* Q_OffsetS_N */
static int hf_umts_rrc_ies_modeSpecificInfo50 = -1;  /* T_modeSpecificInfo50 */
static int hf_umts_rrc_ies_fdd63 = -1;            /* T_fdd59 */
static int hf_umts_rrc_ies_tdd57 = -1;            /* T_tdd51 */
static int hf_umts_rrc_ies_gsm1 = -1;             /* T_gsm1 */
static int hf_umts_rrc_ies_modeSpecificInfo51 = -1;  /* T_modeSpecificInfo51 */
static int hf_umts_rrc_ies_fdd64 = -1;            /* T_fdd60 */
static int hf_umts_rrc_ies_tdd58 = -1;            /* T_tdd52 */
static int hf_umts_rrc_ies_gsm2 = -1;             /* T_gsm2 */
static int hf_umts_rrc_ies_modeSpecificInfo52 = -1;  /* T_modeSpecificInfo52 */
static int hf_umts_rrc_ies_fdd65 = -1;            /* T_fdd61 */
static int hf_umts_rrc_ies_tdd59 = -1;            /* T_tdd53 */
static int hf_umts_rrc_ies_gsm3 = -1;             /* T_gsm3 */
static int hf_umts_rrc_ies_hcs_NeighbouringCellInformation_ECN0 = -1;  /* HCS_NeighbouringCellInformation_ECN0 */
static int hf_umts_rrc_ies_modeSpecificInfo53 = -1;  /* T_modeSpecificInfo53 */
static int hf_umts_rrc_ies_fdd66 = -1;            /* T_fdd62 */
static int hf_umts_rrc_ies_tdd60 = -1;            /* T_tdd54 */
static int hf_umts_rrc_ies_gsm4 = -1;             /* T_gsm4 */
static int hf_umts_rrc_ies_deltaQrxlevmin = -1;   /* DeltaQrxlevmin */
static int hf_umts_rrc_ies_deltaQhcs = -1;        /* DeltaRSCP */
static int hf_umts_rrc_ies_q_Hyst_l_S_PCH = -1;   /* Q_Hyst_S_Fine */
static int hf_umts_rrc_ies_q_Hyst_l_S_FACH = -1;  /* Q_Hyst_S_Fine */
static int hf_umts_rrc_ies_q_Hyst_2_S_PCH = -1;   /* Q_Hyst_S_Fine */
static int hf_umts_rrc_ies_q_Hyst_2_S_FACH = -1;  /* Q_Hyst_S_Fine */
static int hf_umts_rrc_ies_t_Reselection_S_PCH = -1;  /* T_Reselection_S */
static int hf_umts_rrc_ies_t_Reselection_S_FACH = -1;  /* T_Reselection_S_Fine */
static int hf_umts_rrc_ies_non_HCS_t_CR_Max = -1;  /* T_CRMax */
static int hf_umts_rrc_ies_speedDependentScalingFactor = -1;  /* SpeedDependentScalingFactor */
static int hf_umts_rrc_ies_interFrequencyTreselectionScalingFactor = -1;  /* TreselectionScalingFactor */
static int hf_umts_rrc_ies_interRATTreselectionScalingFactor = -1;  /* TreselectionScalingFactor */
static int hf_umts_rrc_ies_CellsForInterFreqMeasList_item = -1;  /* InterFreqCellID */
static int hf_umts_rrc_ies_CellsForInterRATMeasList_item = -1;  /* InterRATCellID */
static int hf_umts_rrc_ies_CellsForIntraFreqMeasList_item = -1;  /* IntraFreqCellID */
static int hf_umts_rrc_ies_modeSpecificInfo54 = -1;  /* T_modeSpecificInfo54 */
static int hf_umts_rrc_ies_fdd67 = -1;            /* T_fdd63 */
static int hf_umts_rrc_ies_countC_SFN_Frame_difference = -1;  /* CountC_SFN_Frame_difference */
static int hf_umts_rrc_ies_tm = -1;               /* INTEGER_0_38399 */
static int hf_umts_rrc_ies_tdd61 = -1;            /* T_tdd55 */
static int hf_umts_rrc_ies_bsicReported = -1;     /* BSICReported */
static int hf_umts_rrc_ies_CellToReportList_item = -1;  /* CellToReport */
static int hf_umts_rrc_ies_countC_SFN_High = -1;  /* INTEGER_0_15 */
static int hf_umts_rrc_ies_off = -1;              /* INTEGER_0_255 */
static int hf_umts_rrc_ies_deltaRSCP = -1;        /* DeltaRSCP */
static int hf_umts_rrc_ies_iode = -1;             /* IODE */
static int hf_umts_rrc_ies_udre = -1;             /* UDRE */
static int hf_umts_rrc_ies_prc = -1;              /* PRC */
static int hf_umts_rrc_ies_rrc = -1;              /* RRC */
static int hf_umts_rrc_ies_dummy1_DeltaPRC = -1;  /* DeltaPRC */
static int hf_umts_rrc_ies_dummy2_DeltaPRC = -1;  /* DeltaRRC */
static int hf_umts_rrc_ies_dummy3_DeltaPRC = -1;  /* DeltaPRC */
static int hf_umts_rrc_ies_dummy4_DeltaPRC = -1;  /* DeltaRRC */
static int hf_umts_rrc_ies_DGPS_CorrectionSatInfoList_item = -1;  /* DGPS_CorrectionSatInfo */
static int hf_umts_rrc_ies_latitudeSign = -1;     /* T_latitudeSign */
static int hf_umts_rrc_ies_latitude = -1;         /* INTEGER_0_8388607 */
static int hf_umts_rrc_ies_longitude = -1;        /* INTEGER_M8388608_8388607 */
static int hf_umts_rrc_ies_latitudeSign1 = -1;    /* T_latitudeSign1 */
static int hf_umts_rrc_ies_altitudeDirection = -1;  /* T_altitudeDirection */
static int hf_umts_rrc_ies_altitude = -1;         /* INTEGER_0_32767 */
static int hf_umts_rrc_ies_latitudeSign2 = -1;    /* T_latitudeSign2 */
static int hf_umts_rrc_ies_altitudeDirection1 = -1;  /* T_altitudeDirection1 */
static int hf_umts_rrc_ies_uncertaintySemiMajor = -1;  /* INTEGER_0_127 */
static int hf_umts_rrc_ies_uncertaintySemiMinor = -1;  /* INTEGER_0_127 */
static int hf_umts_rrc_ies_orientationMajorAxis = -1;  /* INTEGER_0_89 */
static int hf_umts_rrc_ies_uncertaintyAltitude = -1;  /* INTEGER_0_127 */
static int hf_umts_rrc_ies_confidence = -1;       /* INTEGER_0_100 */
static int hf_umts_rrc_ies_latitudeSign3 = -1;    /* T_latitudeSign3 */
static int hf_umts_rrc_ies_uncertaintyCode = -1;  /* INTEGER_0_127 */
static int hf_umts_rrc_ies_latitudeSign4 = -1;    /* T_latitudeSign4 */
static int hf_umts_rrc_ies_triggeringCondition = -1;  /* TriggeringCondition2 */
static int hf_umts_rrc_ies_reportingRange = -1;   /* ReportingRange */
static int hf_umts_rrc_ies_forbiddenAffectCellList = -1;  /* ForbiddenAffectCellList */
static int hf_umts_rrc_ies_w = -1;                /* W */
static int hf_umts_rrc_ies_reportDeactivationThreshold = -1;  /* ReportDeactivationThreshold */
static int hf_umts_rrc_ies_reportingAmount = -1;  /* ReportingAmount */
static int hf_umts_rrc_ies_reportingInterval = -1;  /* ReportingInterval */
static int hf_umts_rrc_ies_forbiddenAffectCellList1 = -1;  /* ForbiddenAffectCellList_r4 */
static int hf_umts_rrc_ies_forbiddenAffectCellList2 = -1;  /* ForbiddenAffectCellList_LCR_r4 */
static int hf_umts_rrc_ies_triggeringCondition1 = -1;  /* TriggeringCondition1 */
static int hf_umts_rrc_ies_replacementActivationThreshold = -1;  /* ReplacementActivationThreshold */
static int hf_umts_rrc_ies_thresholdUsedFrequency = -1;  /* ThresholdUsedFrequency */
static int hf_umts_rrc_ies_dummy_Threshold = -1;  /* Threshold */
static int hf_umts_rrc_ies_usedFreqW = -1;        /* W */
static int hf_umts_rrc_ies_hysteresis = -1;       /* HysteresisInterFreq */
static int hf_umts_rrc_ies_timeToTrigger = -1;    /* TimeToTrigger */
static int hf_umts_rrc_ies_reportingCellStatus = -1;  /* ReportingCellStatus */
static int hf_umts_rrc_ies_nonUsedFreqParameterList = -1;  /* NonUsedFreqParameterList */
static int hf_umts_rrc_ies_usedFreqThreshold = -1;  /* Threshold */
static int hf_umts_rrc_ies_thresholdOwnSystem = -1;  /* Threshold */
static int hf_umts_rrc_ies_thresholdOtherSystem = -1;  /* Threshold */
static int hf_umts_rrc_ies_hysteresis1 = -1;      /* Hysteresis */
static int hf_umts_rrc_ies_intraFreqEventResults = -1;  /* IntraFreqEventResults */
static int hf_umts_rrc_ies_interFreqEventResults = -1;  /* InterFreqEventResults */
static int hf_umts_rrc_ies_interRATEventResults = -1;  /* InterRATEventResults */
static int hf_umts_rrc_ies_trafficVolumeEventResults = -1;  /* TrafficVolumeEventResults */
static int hf_umts_rrc_ies_qualityEventResults = -1;  /* QualityEventResults */
static int hf_umts_rrc_ies_ue_InternalEventResults = -1;  /* UE_InternalEventResults */
static int hf_umts_rrc_ies_ue_positioning_MeasurementEventResults = -1;  /* UE_Positioning_MeasurementEventResults */
static int hf_umts_rrc_ies_doppler1stOrder = -1;  /* INTEGER_M42_21 */
static int hf_umts_rrc_ies_dopplerUncertainty = -1;  /* DopplerUncertainty */
static int hf_umts_rrc_ies_fACH_meas_occasion_coeff = -1;  /* INTEGER_1_12 */
static int hf_umts_rrc_ies_inter_freq_FDD_meas_ind = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_inter_freq_TDD_meas_ind = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_inter_RAT_meas_ind = -1;  /* SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type */
static int hf_umts_rrc_ies_inter_RAT_meas_ind_item = -1;  /* RAT_Type */
static int hf_umts_rrc_ies_inter_freq_TDD128_meas_ind = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_fdd68 = -1;            /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_tdd62 = -1;            /* PrimaryCCPCH_Info_LCR_r4 */
static int hf_umts_rrc_ies_ForbiddenAffectCellList_item = -1;  /* ForbiddenAffectCell */
static int hf_umts_rrc_ies_ForbiddenAffectCellList_r4_item = -1;  /* ForbiddenAffectCell_r4 */
static int hf_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4_item = -1;  /* ForbiddenAffectCell_LCR_r4 */
static int hf_umts_rrc_ies_satelliteID = -1;      /* INTEGER_0_63 */
static int hf_umts_rrc_ies_c_N0 = -1;             /* INTEGER_0_63 */
static int hf_umts_rrc_ies_doppler = -1;          /* INTEGER_M32768_32768 */
static int hf_umts_rrc_ies_wholeGPS_Chips = -1;   /* INTEGER_0_1022 */
static int hf_umts_rrc_ies_fractionalGPS_Chips = -1;  /* INTEGER_0_1023 */
static int hf_umts_rrc_ies_multipathIndicator = -1;  /* MultipathIndicator */
static int hf_umts_rrc_ies_pseudorangeRMS_Error = -1;  /* INTEGER_0_63 */
static int hf_umts_rrc_ies_GPS_MeasurementParamList_item = -1;  /* GPS_MeasurementParam */
static int hf_umts_rrc_ies_gsm_CarrierRSSI = -1;  /* GSM_CarrierRSSI */
static int hf_umts_rrc_ies_dummy_INTEGER_46_173 = -1;  /* INTEGER_46_173 */
static int hf_umts_rrc_ies_dummy2_ObservedTimeDifferenceToGSM = -1;  /* ObservedTimeDifferenceToGSM */
static int hf_umts_rrc_ies_GSM_MeasuredResultsList_item = -1;  /* GSM_MeasuredResults */
static int hf_umts_rrc_ies_tlm_Message = -1;      /* BIT_STRING_SIZE_14 */
static int hf_umts_rrc_ies_tlm_Reserved = -1;     /* BIT_STRING_SIZE_2 */
static int hf_umts_rrc_ies_alert = -1;            /* BOOLEAN */
static int hf_umts_rrc_ies_antiSpoof = -1;        /* BOOLEAN */
static int hf_umts_rrc_ies_GPS_TOW_AssistList_item = -1;  /* GPS_TOW_Assist */
static int hf_umts_rrc_ies_penaltyTime = -1;      /* PenaltyTime_RSCP */
static int hf_umts_rrc_ies_penaltyTime1 = -1;     /* PenaltyTime_ECN0 */
static int hf_umts_rrc_ies_hcs_PRIO = -1;         /* HCS_PRIO */
static int hf_umts_rrc_ies_q_HCS = -1;            /* Q_HCS */
static int hf_umts_rrc_ies_hcs_CellReselectInformation = -1;  /* HCS_CellReselectInformation_RSCP */
static int hf_umts_rrc_ies_hcs_CellReselectInformation1 = -1;  /* HCS_CellReselectInformation_ECN0 */
static int hf_umts_rrc_ies_t_CR_Max = -1;         /* T_CRMax */
static int hf_umts_rrc_ies_nonFreqRelatedEventResults = -1;  /* CellMeasurementEventResults */
static int hf_umts_rrc_ies_nonFreqRelatedEventResults1 = -1;  /* CellMeasurementEventResults_LCR_r4 */
static int hf_umts_rrc_ies_removedInterFreqCellList = -1;  /* RemovedInterFreqCellList */
static int hf_umts_rrc_ies_newInterFreqCellList = -1;  /* NewInterFreqCellList */
static int hf_umts_rrc_ies_cellsForInterFreqMeasList = -1;  /* CellsForInterFreqMeasList */
static int hf_umts_rrc_ies_newInterFreqCellList1 = -1;  /* NewInterFreqCellList_r4 */
static int hf_umts_rrc_ies_newInterFreqCellList2 = -1;  /* NewInterFreqCellSI_List_RSCP */
static int hf_umts_rrc_ies_newInterFreqCellList3 = -1;  /* NewInterFreqCellSI_List_ECN0 */
static int hf_umts_rrc_ies_newInterFreqCellList4 = -1;  /* NewInterFreqCellSI_List_HCS_RSCP */
static int hf_umts_rrc_ies_newInterFreqCellList5 = -1;  /* NewInterFreqCellSI_List_HCS_ECN0 */
static int hf_umts_rrc_ies_newInterFreqCellList6 = -1;  /* NewInterFreqCellSI_List_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_newInterFreqCellList7 = -1;  /* NewInterFreqCellSI_List_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_newInterFreqCellList8 = -1;  /* NewInterFreqCellSI_List_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_newInterFreqCellList9 = -1;  /* NewInterFreqCellSI_List_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_InterFreqCellList_item = -1;  /* InterFreqCell */
static int hf_umts_rrc_ies_InterFreqCellList_LCR_r4_ext_item = -1;  /* InterFreqCell_LCR_r4 */
static int hf_umts_rrc_ies_InterFreqCellMeasuredResultsList_item = -1;  /* CellMeasuredResults */
static int hf_umts_rrc_ies_event2a = -1;          /* Event2a */
static int hf_umts_rrc_ies_event2b = -1;          /* Event2b */
static int hf_umts_rrc_ies_event2c = -1;          /* Event2c */
static int hf_umts_rrc_ies_event2d = -1;          /* Event2d */
static int hf_umts_rrc_ies_event2e = -1;          /* Event2e */
static int hf_umts_rrc_ies_event2f = -1;          /* Event2f */
static int hf_umts_rrc_ies_InterFreqEventList_item = -1;  /* InterFreqEvent */
static int hf_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext_item = -1;  /* DeltaRSCPPerCell */
static int hf_umts_rrc_ies_threholdUsedFrequency_delta = -1;  /* DeltaRSCP */
static int hf_umts_rrc_ies_threholdNonUsedFrequency_deltaList = -1;  /* ThreholdNonUsedFrequency_deltaList */
static int hf_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext_item = -1;  /* Inter_FreqEventCriteria_v590ext */
static int hf_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext_item = -1;  /* DeltaRSCP */
static int hf_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext_item = -1;  /* DeltaRSCPPerCell */
static int hf_umts_rrc_ies_periodicReportingInfo_1b = -1;  /* PeriodicReportingInfo_1b */
static int hf_umts_rrc_ies_eventID = -1;          /* EventIDInterFreq */
static int hf_umts_rrc_ies_interFreqCellList = -1;  /* InterFreqCellList */
static int hf_umts_rrc_ies_interFreqCellList1 = -1;  /* InterFreqCellList_LCR_r4_ext */
static int hf_umts_rrc_ies_reportingCriteria = -1;  /* T_reportingCriteria */
static int hf_umts_rrc_ies_intraFreqReportingCriteria2 = -1;  /* T_intraFreqReportingCriteria */
static int hf_umts_rrc_ies_intraFreqMeasQuantity = -1;  /* IntraFreqMeasQuantity */
static int hf_umts_rrc_ies_interFreqReportingCriteria = -1;  /* T_interFreqReportingCriteria */
static int hf_umts_rrc_ies_filterCoefficient = -1;  /* FilterCoefficient */
static int hf_umts_rrc_ies_modeSpecificInfo55 = -1;  /* T_modeSpecificInfo55 */
static int hf_umts_rrc_ies_fdd69 = -1;            /* T_fdd64 */
static int hf_umts_rrc_ies_freqQualityEstimateQuantity_FDD = -1;  /* FreqQualityEstimateQuantity_FDD */
static int hf_umts_rrc_ies_tdd63 = -1;            /* T_tdd56 */
static int hf_umts_rrc_ies_freqQualityEstimateQuantity_TDD = -1;  /* FreqQualityEstimateQuantity_TDD */
static int hf_umts_rrc_ies_utra_CarrierRSSI = -1;  /* UTRA_CarrierRSSI */
static int hf_umts_rrc_ies_interFreqCellMeasuredResultsList = -1;  /* InterFreqCellMeasuredResultsList */
static int hf_umts_rrc_ies_InterFreqMeasuredResultsList_item = -1;  /* InterFreqMeasuredResults */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List = -1;  /* InterFreqCellInfoSI_List_RSCP */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List1 = -1;  /* InterFreqCellInfoSI_List_ECN0 */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List2 = -1;  /* InterFreqCellInfoSI_List_HCS_RSCP */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List3 = -1;  /* InterFreqCellInfoSI_List_HCS_ECN0 */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List4 = -1;  /* InterFreqCellInfoSI_List_RSCP_LCR */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List5 = -1;  /* InterFreqCellInfoSI_List_ECN0_LCR */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List6 = -1;  /* InterFreqCellInfoSI_List_HCS_RSCP_LCR */
static int hf_umts_rrc_ies_interFreqCellInfoSI_List7 = -1;  /* InterFreqCellInfoSI_List_HCS_ECN0_LCR */
static int hf_umts_rrc_ies_InterFreqRACHRepCellsList_item = -1;  /* InterFreqCellID */
static int hf_umts_rrc_ies_modeSpecificInfo56 = -1;  /* T_modeSpecificInfo56 */
static int hf_umts_rrc_ies_fdd70 = -1;            /* T_fdd65 */
static int hf_umts_rrc_ies_interFreqRepQuantityRACH_FDD = -1;  /* InterFreqRepQuantityRACH_FDD */
static int hf_umts_rrc_ies_tdd64 = -1;            /* T_tdd57 */
static int hf_umts_rrc_ies_interFreqRepQuantityRACH_TDDList = -1;  /* InterFreqRepQuantityRACH_TDDList */
static int hf_umts_rrc_ies_interFreqRACHReportingThreshold = -1;  /* Threshold */
static int hf_umts_rrc_ies_maxReportedCellsOnRACHinterFreq = -1;  /* MaxReportedCellsOnRACHinterFreq */
static int hf_umts_rrc_ies_interFreqReportingCriteria1 = -1;  /* InterFreqReportingCriteria */
static int hf_umts_rrc_ies_periodicalReportingCriteria1 = -1;  /* PeriodicalWithReportingCellStatus */
static int hf_umts_rrc_ies_noReporting = -1;      /* ReportingCellStatusOpt */
static int hf_umts_rrc_ies_intraFreqReportingCriteria3 = -1;  /* IntraFreqReportingCriteria_r4 */
static int hf_umts_rrc_ies_interFreqEventList = -1;  /* InterFreqEventList */
static int hf_umts_rrc_ies_utra_Carrier_RSSI = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_frequencyQualityEstimate = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_nonFreqRelatedQuantities = -1;  /* CellReportingQuantities */
static int hf_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList_item = -1;  /* InterFreqRepQuantityRACH_TDD */
static int hf_umts_rrc_ies_interFreqCellInfoList = -1;  /* InterFreqCellInfoList */
static int hf_umts_rrc_ies_interFreqMeasQuantity = -1;  /* InterFreqMeasQuantity */
static int hf_umts_rrc_ies_interFreqReportingQuantity = -1;  /* InterFreqReportingQuantity */
static int hf_umts_rrc_ies_measurementValidity = -1;  /* MeasurementValidity */
static int hf_umts_rrc_ies_interFreqSetUpdate = -1;  /* UE_AutonomousUpdateMode */
static int hf_umts_rrc_ies_reportCriteria = -1;   /* InterFreqReportCriteria */
static int hf_umts_rrc_ies_interFreqCellInfoList1 = -1;  /* InterFreqCellInfoList_r4 */
static int hf_umts_rrc_ies_reportCriteria1 = -1;  /* InterFreqReportCriteria_r4 */
static int hf_umts_rrc_ies_technologySpecificInfo = -1;  /* T_technologySpecificInfo */
static int hf_umts_rrc_ies_gsm5 = -1;             /* T_gsm5 */
static int hf_umts_rrc_ies_bsic = -1;             /* BSIC */
static int hf_umts_rrc_ies_frequency_band = -1;   /* Frequency_Band */
static int hf_umts_rrc_ies_bcch_ARFCN = -1;       /* BCCH_ARFCN */
static int hf_umts_rrc_ies_ncMode = -1;           /* NC_Mode */
static int hf_umts_rrc_ies_is_2000 = -1;          /* NULL */
static int hf_umts_rrc_ies_removedInterRATCellList = -1;  /* RemovedInterRATCellList */
static int hf_umts_rrc_ies_newInterRATCellList = -1;  /* NewInterRATCellList */
static int hf_umts_rrc_ies_cellsForInterRATMeasList = -1;  /* CellsForInterRATMeasList */
static int hf_umts_rrc_ies_newInterRATCellList1 = -1;  /* NewInterRATCellList_B */
static int hf_umts_rrc_ies_event3a = -1;          /* Event3a */
static int hf_umts_rrc_ies_event3b = -1;          /* Event3b */
static int hf_umts_rrc_ies_event3c = -1;          /* Event3c */
static int hf_umts_rrc_ies_event3d = -1;          /* Event3d */
static int hf_umts_rrc_ies_InterRATEventList_item = -1;  /* InterRATEvent */
static int hf_umts_rrc_ies_eventID1 = -1;         /* EventIDInterRAT */
static int hf_umts_rrc_ies_cellToReportList = -1;  /* CellToReportList */
static int hf_umts_rrc_ies_rat1 = -1;             /* InterRATInfo */
static int hf_umts_rrc_ies_gsm_TargetCellInfoList = -1;  /* GSM_TargetCellInfoList */
static int hf_umts_rrc_ies_measQuantityUTRAN_QualityEstimate = -1;  /* IntraFreqMeasQuantity */
static int hf_umts_rrc_ies_ratSpecificInfo = -1;  /* T_ratSpecificInfo */
static int hf_umts_rrc_ies_gsm6 = -1;             /* T_gsm6 */
static int hf_umts_rrc_ies_measurementQuantity = -1;  /* MeasurementQuantityGSM */
static int hf_umts_rrc_ies_bsic_VerificationRequired = -1;  /* BSIC_VerificationRequired */
static int hf_umts_rrc_ies_is_20001 = -1;         /* T_is_2000 */
static int hf_umts_rrc_ies_tadd_EcIo = -1;        /* INTEGER_0_63 */
static int hf_umts_rrc_ies_tcomp_EcIo = -1;       /* INTEGER_0_15 */
static int hf_umts_rrc_ies_softSlope = -1;        /* INTEGER_0_63 */
static int hf_umts_rrc_ies_addIntercept = -1;     /* INTEGER_0_63 */
static int hf_umts_rrc_ies_gsm7 = -1;             /* GSM_MeasuredResultsList */
static int hf_umts_rrc_ies_InterRATMeasuredResultsList_item = -1;  /* InterRATMeasuredResults */
static int hf_umts_rrc_ies_interRATCellInfoList = -1;  /* InterRATCellInfoList */
static int hf_umts_rrc_ies_interRATMeasQuantity = -1;  /* InterRATMeasQuantity */
static int hf_umts_rrc_ies_interRATReportingQuantity = -1;  /* InterRATReportingQuantity */
static int hf_umts_rrc_ies_reportCriteria2 = -1;  /* InterRATReportCriteria */
static int hf_umts_rrc_ies_interRATCellInfoList1 = -1;  /* InterRATCellInfoList_r4 */
static int hf_umts_rrc_ies_interRATCellInfoList2 = -1;  /* InterRATCellInfoList_B */
static int hf_umts_rrc_ies_interRATReportingCriteria = -1;  /* InterRATReportingCriteria */
static int hf_umts_rrc_ies_interRATEventList = -1;  /* InterRATEventList */
static int hf_umts_rrc_ies_utran_EstimatedQuality = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ratSpecificInfo1 = -1;  /* T_ratSpecificInfo1 */
static int hf_umts_rrc_ies_gsm8 = -1;             /* T_gsm7 */
static int hf_umts_rrc_ies_dummy2_BOOLEAN = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_gsm_Carrier_RSSI = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_removedIntraFreqCellList = -1;  /* RemovedIntraFreqCellList */
static int hf_umts_rrc_ies_newIntraFreqCellList = -1;  /* NewIntraFreqCellList */
static int hf_umts_rrc_ies_cellsForIntraFreqMeasList = -1;  /* CellsForIntraFreqMeasList */
static int hf_umts_rrc_ies_newIntraFreqCellList1 = -1;  /* NewIntraFreqCellList_r4 */
static int hf_umts_rrc_ies_newIntraFreqCellList2 = -1;  /* NewIntraFreqCellSI_List_RSCP */
static int hf_umts_rrc_ies_newIntraFreqCellList3 = -1;  /* NewIntraFreqCellSI_List_ECN0 */
static int hf_umts_rrc_ies_newIntraFreqCellList4 = -1;  /* NewIntraFreqCellSI_List_HCS_RSCP */
static int hf_umts_rrc_ies_newIntraFreqCellList5 = -1;  /* NewIntraFreqCellSI_List_HCS_ECN0 */
static int hf_umts_rrc_ies_newIntraFreqCellList6 = -1;  /* NewIntraFreqCellSI_List_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_newIntraFreqCellList7 = -1;  /* NewIntraFreqCellSI_List_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_newIntraFreqCellList8 = -1;  /* NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_newIntraFreqCellList9 = -1;  /* NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_e1a = -1;              /* Event1a */
static int hf_umts_rrc_ies_e1b = -1;              /* Event1b */
static int hf_umts_rrc_ies_e1c = -1;              /* Event1c */
static int hf_umts_rrc_ies_e1d = -1;              /* NULL */
static int hf_umts_rrc_ies_e1e = -1;              /* Event1e */
static int hf_umts_rrc_ies_e1f = -1;              /* Event1f */
static int hf_umts_rrc_ies_e1g = -1;              /* NULL */
static int hf_umts_rrc_ies_e1h = -1;              /* ThresholdUsedFrequency */
static int hf_umts_rrc_ies_e1i = -1;              /* ThresholdUsedFrequency */
static int hf_umts_rrc_ies_e1a1 = -1;             /* Event1a_r4 */
static int hf_umts_rrc_ies_e1b1 = -1;             /* Event1b_r4 */
static int hf_umts_rrc_ies_e1a2 = -1;             /* Event1a_LCR_r4 */
static int hf_umts_rrc_ies_e1b2 = -1;             /* Event1b_LCR_r4 */
static int hf_umts_rrc_ies_useCIO = -1;           /* BOOLEAN */
static int hf_umts_rrc_ies_event = -1;            /* IntraFreqEvent */
static int hf_umts_rrc_ies_event1 = -1;           /* IntraFreqEvent_r4 */
static int hf_umts_rrc_ies_event2 = -1;           /* IntraFreqEvent_LCR_r4 */
static int hf_umts_rrc_ies_IntraFreqEventCriteriaList_item = -1;  /* IntraFreqEventCriteria */
static int hf_umts_rrc_ies_IntraFreqEventCriteriaList_r4_item = -1;  /* IntraFreqEventCriteria_r4 */
static int hf_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4_item = -1;  /* IntraFreqEventCriteria_LCR_r4 */
static int hf_umts_rrc_ies_eventID2 = -1;         /* EventIDIntraFreq */
static int hf_umts_rrc_ies_cellMeasurementEventResults = -1;  /* CellMeasurementEventResults */
static int hf_umts_rrc_ies_modeSpecificInfo57 = -1;  /* T_modeSpecificInfo57 */
static int hf_umts_rrc_ies_fdd71 = -1;            /* T_fdd66 */
static int hf_umts_rrc_ies_intraFreqMeasQuantity_FDD = -1;  /* IntraFreqMeasQuantity_FDD */
static int hf_umts_rrc_ies_tdd65 = -1;            /* T_tdd58 */
static int hf_umts_rrc_ies_intraFreqMeasQuantity_TDDList = -1;  /* IntraFreqMeasQuantity_TDDList */
static int hf_umts_rrc_ies_IntraFreqMeasQuantity_TDDList_item = -1;  /* IntraFreqMeasQuantity_TDD */
static int hf_umts_rrc_ies_IntraFreqMeasuredResultsList_item = -1;  /* CellMeasuredResults */
static int hf_umts_rrc_ies_intraFreqMeasurementID = -1;  /* MeasurementIdentity */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List = -1;  /* IntraFreqCellInfoSI_List_RSCP */
static int hf_umts_rrc_ies_intraFreqReportingQuantityForRACH = -1;  /* IntraFreqReportingQuantityForRACH */
static int hf_umts_rrc_ies_maxReportedCellsOnRACH = -1;  /* MaxReportedCellsOnRACH */
static int hf_umts_rrc_ies_reportingInfoForCellDCH = -1;  /* ReportingInfoForCellDCH */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List1 = -1;  /* IntraFreqCellInfoSI_List_ECN0 */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List2 = -1;  /* IntraFreqCellInfoSI_List_HCS_RSCP */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List3 = -1;  /* IntraFreqCellInfoSI_List_HCS_ECN0 */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List4 = -1;  /* IntraFreqCellInfoSI_List_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_reportingInfoForCellDCH1 = -1;  /* ReportingInfoForCellDCH_LCR_r4 */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List5 = -1;  /* IntraFreqCellInfoSI_List_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List6 = -1;  /* IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_intraFreqCellInfoSI_List7 = -1;  /* IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_eventCriteriaList = -1;  /* IntraFreqEventCriteriaList */
static int hf_umts_rrc_ies_eventCriteriaList1 = -1;  /* IntraFreqEventCriteriaList_r4 */
static int hf_umts_rrc_ies_eventCriteriaList2 = -1;  /* IntraFreqEventCriteriaList_LCR_r4 */
static int hf_umts_rrc_ies_activeSetReportingQuantities = -1;  /* CellReportingQuantities */
static int hf_umts_rrc_ies_monitoredSetReportingQuantities = -1;  /* CellReportingQuantities */
static int hf_umts_rrc_ies_detectedSetReportingQuantities = -1;  /* CellReportingQuantities */
static int hf_umts_rrc_ies_sfn_SFN_OTD_Type = -1;  /* SFN_SFN_OTD_Type */
static int hf_umts_rrc_ies_modeSpecificInfo58 = -1;  /* T_modeSpecificInfo58 */
static int hf_umts_rrc_ies_fdd72 = -1;            /* T_fdd67 */
static int hf_umts_rrc_ies_intraFreqRepQuantityRACH_FDD = -1;  /* IntraFreqRepQuantityRACH_FDD */
static int hf_umts_rrc_ies_tdd66 = -1;            /* T_tdd59 */
static int hf_umts_rrc_ies_intraFreqRepQuantityRACH_TDDList = -1;  /* IntraFreqRepQuantityRACH_TDDList */
static int hf_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList_item = -1;  /* IntraFreqRepQuantityRACH_TDD */
static int hf_umts_rrc_ies_intraFreqCellInfoList = -1;  /* IntraFreqCellInfoList */
static int hf_umts_rrc_ies_intraFreqReportingQuantity = -1;  /* IntraFreqReportingQuantity */
static int hf_umts_rrc_ies_reportCriteria3 = -1;  /* IntraFreqReportCriteria */
static int hf_umts_rrc_ies_intraFreqCellInfoList1 = -1;  /* IntraFreqCellInfoList_r4 */
static int hf_umts_rrc_ies_reportCriteria4 = -1;  /* IntraFreqReportCriteria_r4 */
static int hf_umts_rrc_ies_intraFreqMeasuredResultsList = -1;  /* IntraFreqMeasuredResultsList */
static int hf_umts_rrc_ies_interFreqMeasuredResultsList = -1;  /* InterFreqMeasuredResultsList */
static int hf_umts_rrc_ies_interRATMeasuredResultsList = -1;  /* InterRATMeasuredResultsList */
static int hf_umts_rrc_ies_trafficVolumeMeasuredResultsList = -1;  /* TrafficVolumeMeasuredResultsList */
static int hf_umts_rrc_ies_qualityMeasuredResults = -1;  /* QualityMeasuredResults */
static int hf_umts_rrc_ies_ue_InternalMeasuredResults = -1;  /* UE_InternalMeasuredResults */
static int hf_umts_rrc_ies_ue_positioning_MeasuredResults = -1;  /* UE_Positioning_MeasuredResults */
static int hf_umts_rrc_ies_ue_positioning_MeasuredResults_v390ext = -1;  /* UE_Positioning_MeasuredResults_v390ext */
static int hf_umts_rrc_ies_intraFrequencyMeasuredResultsList = -1;  /* IntraFrequencyMeasuredResultsList_v590ext */
static int hf_umts_rrc_ies_interFrequencyMeasuredResultsList = -1;  /* InterFrequencyMeasuredResultsList_v590ext */
static int hf_umts_rrc_ies_ue_InternalMeasuredResults1 = -1;  /* UE_InternalMeasuredResults_LCR_r4 */
static int hf_umts_rrc_ies_ue_positioniing_MeasuredResults = -1;  /* UE_Positioning_MeasuredResults */
static int hf_umts_rrc_ies_MeasuredResultsList_item = -1;  /* MeasuredResults */
static int hf_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext_item = -1;  /* MeasuredResults_LCR_r4 */
static int hf_umts_rrc_ies_currentCell = -1;      /* T_currentCell */
static int hf_umts_rrc_ies_modeSpecificInfo59 = -1;  /* T_modeSpecificInfo59 */
static int hf_umts_rrc_ies_fdd73 = -1;            /* T_fdd68 */
static int hf_umts_rrc_ies_measurementQuantity1 = -1;  /* T_measurementQuantity */
static int hf_umts_rrc_ies_tdd67 = -1;            /* T_tdd60 */
static int hf_umts_rrc_ies_timeslotISCP = -1;     /* TimeslotISCP_List */
static int hf_umts_rrc_ies_monitoredCells = -1;   /* MonitoredCellRACH_List */
static int hf_umts_rrc_ies_interFreqCellIndication_SIB11 = -1;  /* INTEGER_0_1 */
static int hf_umts_rrc_ies_interFreqCellIndication_SIB12 = -1;  /* INTEGER_0_1 */
static int hf_umts_rrc_ies_interFreqRACHRepCellsList = -1;  /* InterFreqRACHRepCellsList */
static int hf_umts_rrc_ies_setup = -1;            /* MeasurementType */
static int hf_umts_rrc_ies_modify1 = -1;          /* T_modify1 */
static int hf_umts_rrc_ies_measurementType = -1;  /* MeasurementType */
static int hf_umts_rrc_ies_setup1 = -1;           /* MeasurementType_r4 */
static int hf_umts_rrc_ies_modify2 = -1;          /* T_modify2 */
static int hf_umts_rrc_ies_measurementType1 = -1;  /* MeasurementType_r4 */
static int hf_umts_rrc_ies_use_of_HCS = -1;       /* T_use_of_HCS */
static int hf_umts_rrc_ies_hcs_not_used = -1;     /* T_hcs_not_used */
static int hf_umts_rrc_ies_cellSelectQualityMeasure1 = -1;  /* T_cellSelectQualityMeasure1 */
static int hf_umts_rrc_ies_cpich_RSCP2 = -1;      /* T_cpich_RSCP */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo = -1;  /* IntraFreqMeasurementSysInfo_RSCP */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo = -1;  /* InterFreqMeasurementSysInfo_RSCP */
static int hf_umts_rrc_ies_cpich_Ec_N02 = -1;     /* T_cpich_Ec_N01 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo1 = -1;  /* IntraFreqMeasurementSysInfo_ECN0 */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo1 = -1;  /* InterFreqMeasurementSysInfo_ECN0 */
static int hf_umts_rrc_ies_interRATMeasurementSysInfo = -1;  /* InterRATMeasurementSysInfo_B */
static int hf_umts_rrc_ies_hcs_used = -1;         /* T_hcs_used */
static int hf_umts_rrc_ies_cellSelectQualityMeasure2 = -1;  /* T_cellSelectQualityMeasure2 */
static int hf_umts_rrc_ies_cpich_RSCP3 = -1;      /* T_cpich_RSCP1 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo2 = -1;  /* IntraFreqMeasurementSysInfo_HCS_RSCP */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo2 = -1;  /* InterFreqMeasurementSysInfo_HCS_RSCP */
static int hf_umts_rrc_ies_cpich_Ec_N03 = -1;     /* T_cpich_Ec_N02 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo3 = -1;  /* IntraFreqMeasurementSysInfo_HCS_ECN0 */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo3 = -1;  /* InterFreqMeasurementSysInfo_HCS_ECN0 */
static int hf_umts_rrc_ies_interRATMeasurementSysInfo1 = -1;  /* InterRATMeasurementSysInfo */
static int hf_umts_rrc_ies_trafficVolumeMeasSysInfo = -1;  /* TrafficVolumeMeasSysInfo */
static int hf_umts_rrc_ies_dummy_UE_InternalMeasurementSysInfo = -1;  /* UE_InternalMeasurementSysInfo */
static int hf_umts_rrc_ies_use_of_HCS1 = -1;      /* T_use_of_HCS1 */
static int hf_umts_rrc_ies_hcs_not_used1 = -1;    /* T_hcs_not_used1 */
static int hf_umts_rrc_ies_cellSelectQualityMeasure3 = -1;  /* T_cellSelectQualityMeasure3 */
static int hf_umts_rrc_ies_cpich_RSCP4 = -1;      /* T_cpich_RSCP2 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo4 = -1;  /* IntraFreqMeasurementSysInfo_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo4 = -1;  /* InterFreqMeasurementSysInfo_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_cpich_Ec_N04 = -1;     /* T_cpich_Ec_N03 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo5 = -1;  /* IntraFreqMeasurementSysInfo_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo5 = -1;  /* InterFreqMeasurementSysInfo_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_hcs_used1 = -1;        /* T_hcs_used1 */
static int hf_umts_rrc_ies_cellSelectQualityMeasure4 = -1;  /* T_cellSelectQualityMeasure4 */
static int hf_umts_rrc_ies_cpich_RSCP5 = -1;      /* T_cpich_RSCP3 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo6 = -1;  /* IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo6 = -1;  /* InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_cpich_Ec_N05 = -1;     /* T_cpich_Ec_N04 */
static int hf_umts_rrc_ies_intraFreqMeasurementSysInfo7 = -1;  /* IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_interFreqMeasurementSysInfo7 = -1;  /* InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_measurementReportTransferMode = -1;  /* TransferMode */
static int hf_umts_rrc_ies_periodicalOrEventTrigger = -1;  /* PeriodicalOrEventTrigger */
static int hf_umts_rrc_ies_intraFrequencyMeasurement = -1;  /* IntraFrequencyMeasurement */
static int hf_umts_rrc_ies_interFrequencyMeasurement = -1;  /* InterFrequencyMeasurement */
static int hf_umts_rrc_ies_interRATMeasurement = -1;  /* InterRATMeasurement */
static int hf_umts_rrc_ies_ue_positioning_Measurement = -1;  /* UE_Positioning_Measurement */
static int hf_umts_rrc_ies_trafficVolumeMeasurement = -1;  /* TrafficVolumeMeasurement */
static int hf_umts_rrc_ies_qualityMeasurement = -1;  /* QualityMeasurement */
static int hf_umts_rrc_ies_ue_InternalMeasurement = -1;  /* UE_InternalMeasurement */
static int hf_umts_rrc_ies_intraFrequencyMeasurement1 = -1;  /* IntraFrequencyMeasurement_r4 */
static int hf_umts_rrc_ies_interFrequencyMeasurement1 = -1;  /* InterFrequencyMeasurement_r4 */
static int hf_umts_rrc_ies_interRATMeasurement1 = -1;  /* InterRATMeasurement_r4 */
static int hf_umts_rrc_ies_up_Measurement = -1;   /* UE_Positioning_Measurement_r4 */
static int hf_umts_rrc_ies_ue_InternalMeasurement1 = -1;  /* UE_InternalMeasurement_r4 */
static int hf_umts_rrc_ies_ue_State = -1;         /* T_ue_State */
static int hf_umts_rrc_ies_MonitoredCellRACH_List_item = -1;  /* MonitoredCellRACH_Result */
static int hf_umts_rrc_ies_sfn_SFN_ObsTimeDifference = -1;  /* SFN_SFN_ObsTimeDifference */
static int hf_umts_rrc_ies_modeSpecificInfo60 = -1;  /* T_modeSpecificInfo60 */
static int hf_umts_rrc_ies_fdd74 = -1;            /* T_fdd69 */
static int hf_umts_rrc_ies_measurementQuantity2 = -1;  /* T_measurementQuantity1 */
static int hf_umts_rrc_ies_tdd68 = -1;            /* T_tdd61 */
static int hf_umts_rrc_ies_n_CR = -1;             /* INTEGER_1_16 */
static int hf_umts_rrc_ies_t_CRMaxHyst = -1;      /* T_CRMaxHyst */
static int hf_umts_rrc_ies_satelliteStatus = -1;  /* SatelliteStatus */
static int hf_umts_rrc_ies_ephemerisParameter = -1;  /* EphemerisParameter */
static int hf_umts_rrc_ies_NavigationModelSatInfoList_item = -1;  /* NavigationModelSatInfo */
static int hf_umts_rrc_ies_codeOnL2 = -1;         /* BIT_STRING_SIZE_2 */
static int hf_umts_rrc_ies_uraIndex = -1;         /* BIT_STRING_SIZE_4 */
static int hf_umts_rrc_ies_satHealth1 = -1;       /* BIT_STRING_SIZE_6 */
static int hf_umts_rrc_ies_iodc = -1;             /* BIT_STRING_SIZE_10 */
static int hf_umts_rrc_ies_l2Pflag = -1;          /* BIT_STRING_SIZE_1 */
static int hf_umts_rrc_ies_sf1Revd = -1;          /* SubFrame1Reserved */
static int hf_umts_rrc_ies_t_GD = -1;             /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_t_oc = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_af2 = -1;              /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_af11 = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_af01 = -1;             /* BIT_STRING_SIZE_22 */
static int hf_umts_rrc_ies_c_rs = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_delta_n = -1;          /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_m01 = -1;              /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_c_uc = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_e1 = -1;               /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_c_us = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_a_Sqrt1 = -1;          /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_t_oe = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_fitInterval = -1;      /* BIT_STRING_SIZE_1 */
static int hf_umts_rrc_ies_aodo = -1;             /* BIT_STRING_SIZE_5 */
static int hf_umts_rrc_ies_c_ic = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_omega01 = -1;          /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_c_is = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_i0 = -1;               /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_c_rc = -1;             /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_omega1 = -1;           /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_omegaDot1 = -1;        /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_iDot = -1;             /* BIT_STRING_SIZE_14 */
static int hf_umts_rrc_ies_modeSpecificInfo61 = -1;  /* T_modeSpecificInfo61 */
static int hf_umts_rrc_ies_fdd75 = -1;            /* T_fdd70 */
static int hf_umts_rrc_ies_neighbourIdentity = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_uE_RX_TX_TimeDifferenceType2Info = -1;  /* UE_RX_TX_TimeDifferenceType2Info */
static int hf_umts_rrc_ies_tdd69 = -1;            /* T_tdd62 */
static int hf_umts_rrc_ies_neighbourAndChannelIdentity = -1;  /* CellAndChannelIdentity */
static int hf_umts_rrc_ies_neighbourQuality = -1;  /* NeighbourQuality */
static int hf_umts_rrc_ies_sfn_SFN_ObsTimeDifference2 = -1;  /* SFN_SFN_ObsTimeDifference2 */
static int hf_umts_rrc_ies_modeSpecificInfo62 = -1;  /* T_modeSpecificInfo62 */
static int hf_umts_rrc_ies_fdd76 = -1;            /* T_fdd71 */
static int hf_umts_rrc_ies_NeighbourList_item = -1;  /* Neighbour */
static int hf_umts_rrc_ies_NeighbourList_v390ext_item = -1;  /* Neighbour_v390ext */
static int hf_umts_rrc_ies_ue_Positioning_OTDOA_Quality = -1;  /* UE_Positioning_OTDOA_Quality */
static int hf_umts_rrc_ies_interFreqCellID = -1;  /* InterFreqCellID */
static int hf_umts_rrc_ies_cellInfo = -1;         /* CellInfo */
static int hf_umts_rrc_ies_cellInfo1 = -1;        /* CellInfo_r4 */
static int hf_umts_rrc_ies_NewInterFreqCellList_item = -1;  /* NewInterFreqCell */
static int hf_umts_rrc_ies_NewInterFreqCellList_r4_item = -1;  /* NewInterFreqCell_r4 */
static int hf_umts_rrc_ies_cellInfo2 = -1;        /* CellInfoSI_RSCP */
static int hf_umts_rrc_ies_cellInfo3 = -1;        /* CellInfoSI_ECN0 */
static int hf_umts_rrc_ies_cellInfo4 = -1;        /* CellInfoSI_HCS_RSCP */
static int hf_umts_rrc_ies_cellInfo5 = -1;        /* CellInfoSI_HCS_ECN0 */
static int hf_umts_rrc_ies_cellInfo6 = -1;        /* CellInfoSI_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_cellInfo7 = -1;        /* CellInfoSI_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_cellInfo8 = -1;        /* CellInfoSI_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_cellInfo9 = -1;        /* CellInfoSI_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_item = -1;  /* NewInterFreqCellSI_ECN0 */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_item = -1;  /* NewInterFreqCellSI_HCS_RSCP */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_item = -1;  /* NewInterFreqCellSI_HCS_ECN0 */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_item = -1;  /* NewInterFreqCellSI_RSCP */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4_item = -1;  /* NewInterFreqCellSI_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4_item = -1;  /* NewInterFreqCellSI_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4_item = -1;  /* NewInterFreqCellSI_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4_item = -1;  /* NewInterFreqCellSI_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_interRATCellID = -1;   /* InterRATCellID */
static int hf_umts_rrc_ies_technologySpecificInfo1 = -1;  /* T_technologySpecificInfo1 */
static int hf_umts_rrc_ies_gsm9 = -1;             /* T_gsm8 */
static int hf_umts_rrc_ies_cellSelectionReselectionInfo4 = -1;  /* CellSelectReselectInfoSIB_11_12 */
static int hf_umts_rrc_ies_interRATCellIndividualOffset = -1;  /* InterRATCellIndividualOffset */
static int hf_umts_rrc_ies_is_20002 = -1;         /* T_is_20001 */
static int hf_umts_rrc_ies_is_2000SpecificMeasInfo = -1;  /* IS_2000SpecificMeasInfo */
static int hf_umts_rrc_ies_absent = -1;           /* NULL */
static int hf_umts_rrc_ies_technologySpecificInfo2 = -1;  /* T_technologySpecificInfo2 */
static int hf_umts_rrc_ies_gsm10 = -1;            /* T_gsm9 */
static int hf_umts_rrc_ies_is_20003 = -1;         /* T_is_20002 */
static int hf_umts_rrc_ies_NewInterRATCellList_item = -1;  /* NewInterRATCell */
static int hf_umts_rrc_ies_NewInterRATCellList_B_item = -1;  /* NewInterRATCell_B */
static int hf_umts_rrc_ies_intraFreqCellID = -1;  /* IntraFreqCellID */
static int hf_umts_rrc_ies_NewIntraFreqCellList_item = -1;  /* NewIntraFreqCell */
static int hf_umts_rrc_ies_NewIntraFreqCellList_r4_item = -1;  /* NewIntraFreqCell_r4 */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_item = -1;  /* NewIntraFreqCellSI_RSCP */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_item = -1;  /* NewIntraFreqCellSI_ECN0 */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_item = -1;  /* NewIntraFreqCellSI_HCS_RSCP */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_item = -1;  /* NewIntraFreqCellSI_HCS_ECN0 */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4_item = -1;  /* NewIntraFreqCellSI_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4_item = -1;  /* NewIntraFreqCellSI_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4_item = -1;  /* NewIntraFreqCellSI_HCS_RSCP_LCR_r4 */
static int hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4_item = -1;  /* NewIntraFreqCellSI_HCS_ECN0_LCR_r4 */
static int hf_umts_rrc_ies_nonUsedFreqThreshold = -1;  /* Threshold */
static int hf_umts_rrc_ies_nonUsedFreqW = -1;     /* W */
static int hf_umts_rrc_ies_NonUsedFreqParameterList_item = -1;  /* NonUsedFreqParameter */
static int hf_umts_rrc_ies_notUsed = -1;          /* NULL */
static int hf_umts_rrc_ies_pt10 = -1;             /* TemporaryOffset1 */
static int hf_umts_rrc_ies_pt20 = -1;             /* TemporaryOffset1 */
static int hf_umts_rrc_ies_pt30 = -1;             /* TemporaryOffset1 */
static int hf_umts_rrc_ies_pt40 = -1;             /* TemporaryOffset1 */
static int hf_umts_rrc_ies_pt50 = -1;             /* TemporaryOffset1 */
static int hf_umts_rrc_ies_pt60 = -1;             /* TemporaryOffset1 */
static int hf_umts_rrc_ies_pt101 = -1;            /* TemporaryOffsetList */
static int hf_umts_rrc_ies_pt201 = -1;            /* TemporaryOffsetList */
static int hf_umts_rrc_ies_pt301 = -1;            /* TemporaryOffsetList */
static int hf_umts_rrc_ies_pt401 = -1;            /* TemporaryOffsetList */
static int hf_umts_rrc_ies_pt501 = -1;            /* TemporaryOffsetList */
static int hf_umts_rrc_ies_pt601 = -1;            /* TemporaryOffsetList */
static int hf_umts_rrc_ies_reportingInterval1 = -1;  /* ReportingIntervalLong */
static int hf_umts_rrc_ies_plmnsOfIntraFreqCellsList = -1;  /* PLMNsOfIntraFreqCellsList */
static int hf_umts_rrc_ies_plmnsOfInterFreqCellsList = -1;  /* PLMNsOfInterFreqCellsList */
static int hf_umts_rrc_ies_plmnsOfInterRATCellsList = -1;  /* PLMNsOfInterRATCellsList */
static int hf_umts_rrc_ies_PLMNsOfInterFreqCellsList_item = -1;  /* PLMNsOfInterFreqCellsList_item */
static int hf_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item = -1;  /* PLMNsOfIntraFreqCellsList_item */
static int hf_umts_rrc_ies_PLMNsOfInterRATCellsList_item = -1;  /* PLMNsOfInterRATCellsList_item */
static int hf_umts_rrc_ies_ellipsoidPoint = -1;   /* EllipsoidPoint */
static int hf_umts_rrc_ies_ellipsoidPointUncertCircle = -1;  /* EllipsoidPointUncertCircle */
static int hf_umts_rrc_ies_ellipsoidPointUncertEllipse = -1;  /* EllipsoidPointUncertEllipse */
static int hf_umts_rrc_ies_ellipsoidPointAltitude = -1;  /* EllipsoidPointAltitude */
static int hf_umts_rrc_ies_ellipsoidPointAltitudeEllipse = -1;  /* EllipsoidPointAltitudeEllipsoide */
static int hf_umts_rrc_ies_QualityEventResults_item = -1;  /* TransportChannelIdentity */
static int hf_umts_rrc_ies_blerMeasurementResultsList = -1;  /* BLER_MeasurementResultsList */
static int hf_umts_rrc_ies_modeSpecificInfo63 = -1;  /* T_modeSpecificInfo63 */
static int hf_umts_rrc_ies_tdd70 = -1;            /* T_tdd63 */
static int hf_umts_rrc_ies_sir_MeasurementResults = -1;  /* SIR_MeasurementList */
static int hf_umts_rrc_ies_qualityReportingQuantity = -1;  /* QualityReportingQuantity */
static int hf_umts_rrc_ies_reportCriteria5 = -1;  /* QualityReportCriteria */
static int hf_umts_rrc_ies_qualityReportingCriteria = -1;  /* QualityReportingCriteria */
static int hf_umts_rrc_ies_noReporting1 = -1;     /* NULL */
static int hf_umts_rrc_ies_QualityReportingCriteria_item = -1;  /* QualityReportingCriteriaSingle */
static int hf_umts_rrc_ies_totalCRC = -1;         /* INTEGER_1_512 */
static int hf_umts_rrc_ies_badCRC = -1;           /* INTEGER_1_512 */
static int hf_umts_rrc_ies_pendingAfterTrigger = -1;  /* INTEGER_1_512 */
static int hf_umts_rrc_ies_dl_TransChBLER = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_bler_dl_TransChIdList = -1;  /* BLER_TransChIdList */
static int hf_umts_rrc_ies_modeSpecificInfo64 = -1;  /* T_modeSpecificInfo64 */
static int hf_umts_rrc_ies_tdd71 = -1;            /* T_tdd64 */
static int hf_umts_rrc_ies_sir_TFCS_List = -1;    /* SIR_TFCS_List */
static int hf_umts_rrc_ies_ellipsoidPointWithAltitude = -1;  /* EllipsoidPointAltitude */
static int hf_umts_rrc_ies_ellipsoidPointAltitudeEllipsoide = -1;  /* EllipsoidPointAltitudeEllipsoide */
static int hf_umts_rrc_ies_accuracy40 = -1;       /* INTEGER_0_960 */
static int hf_umts_rrc_ies_accuracy256 = -1;      /* INTEGER_0_150 */
static int hf_umts_rrc_ies_accuracy2560 = -1;     /* INTEGER_0_15 */
static int hf_umts_rrc_ies_removeAllInterFreqCells = -1;  /* NULL */
static int hf_umts_rrc_ies_removeSomeInterFreqCells = -1;  /* SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID */
static int hf_umts_rrc_ies_removeSomeInterFreqCells_item = -1;  /* InterFreqCellID */
static int hf_umts_rrc_ies_removeNoInterFreqCells = -1;  /* NULL */
static int hf_umts_rrc_ies_removeAllInterRATCells = -1;  /* NULL */
static int hf_umts_rrc_ies_removeSomeInterRATCells = -1;  /* SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID */
static int hf_umts_rrc_ies_removeSomeInterRATCells_item = -1;  /* InterRATCellID */
static int hf_umts_rrc_ies_removeNoInterRATCells = -1;  /* NULL */
static int hf_umts_rrc_ies_removeAllIntraFreqCells = -1;  /* NULL */
static int hf_umts_rrc_ies_removeSomeIntraFreqCells = -1;  /* SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID */
static int hf_umts_rrc_ies_removeSomeIntraFreqCells_item = -1;  /* IntraFreqCellID */
static int hf_umts_rrc_ies_removeNoIntraFreqCells = -1;  /* NULL */
static int hf_umts_rrc_ies_withinActiveSet = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_withinMonitoredSetUsedFreq = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_withinActiveAndOrMonitoredUsedFreq = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_withinDetectedSetUsedFreq = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_withinMonitoredAndOrDetectedUsedFreq = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_allActiveplusMonitoredSet = -1;  /* MaxNumberOfReportingCellsType3 */
static int hf_umts_rrc_ies_allActivePlusDetectedSet = -1;  /* MaxNumberOfReportingCellsType3 */
static int hf_umts_rrc_ies_allActivePlusMonitoredAndOrDetectedSet = -1;  /* MaxNumberOfReportingCellsType3 */
static int hf_umts_rrc_ies_withinVirtualActSet = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_withinMonitoredSetNonUsedFreq = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_withinMonitoredAndOrVirtualActiveSetNonUsedFreq = -1;  /* MaxNumberOfReportingCellsType1 */
static int hf_umts_rrc_ies_allVirtualActSetplusMonitoredSetNonUsedFreq = -1;  /* MaxNumberOfReportingCellsType3 */
static int hf_umts_rrc_ies_withinActSetOrVirtualActSet_InterRATcells = -1;  /* MaxNumberOfReportingCellsType2 */
static int hf_umts_rrc_ies_withinActSetAndOrMonitoredUsedFreqOrVirtualActSetAndOrMonitoredNonUsedFreq = -1;  /* MaxNumberOfReportingCellsType2 */
static int hf_umts_rrc_ies_measurementReportingMode = -1;  /* MeasurementReportingMode */
static int hf_umts_rrc_ies_reportCriteria6 = -1;  /* CellDCH_ReportCriteria */
static int hf_umts_rrc_ies_reportCriteria7 = -1;  /* CellDCH_ReportCriteria_LCR_r4 */
static int hf_umts_rrc_ies_RL_AdditionInfoList_item = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_rl_AdditionInfoList = -1;  /* RL_AdditionInfoList */
static int hf_umts_rrc_ies_rL_RemovalInformationList = -1;  /* RL_RemovalInformationList */
static int hf_umts_rrc_ies_SatDataList_item = -1;  /* SatData */
static int hf_umts_rrc_ies_type13 = -1;           /* SFN_SFN_ObsTimeDifference1 */
static int hf_umts_rrc_ies_type22 = -1;           /* SFN_SFN_ObsTimeDifference2 */
static int hf_umts_rrc_ies_sfn_Offset = -1;       /* INTEGER_0_4095 */
static int hf_umts_rrc_ies_sfn_sfn_Reltimedifference = -1;  /* INTEGER_0_38399 */
static int hf_umts_rrc_ies_SIR_MeasurementList_item = -1;  /* SIR_MeasurementResults */
static int hf_umts_rrc_ies_sir_TimeslotList = -1;  /* SIR_TimeslotList */
static int hf_umts_rrc_ies_SIR_TFCS_List_item = -1;  /* SIR_TFCS */
static int hf_umts_rrc_ies_SIR_TimeslotList_item = -1;  /* SIR */
static int hf_umts_rrc_ies_reserved1 = -1;        /* BIT_STRING_SIZE_23 */
static int hf_umts_rrc_ies_reserved2 = -1;        /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_reserved3 = -1;        /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_reserved4 = -1;        /* BIT_STRING_SIZE_16 */
static int hf_umts_rrc_ies_t_ADV = -1;            /* INTEGER_0_2047 */
static int hf_umts_rrc_ies_sfn = -1;              /* INTEGER_0_4095 */
static int hf_umts_rrc_ies_t30 = -1;              /* N_CR_T_CRMaxHyst */
static int hf_umts_rrc_ies_t60 = -1;              /* N_CR_T_CRMaxHyst */
static int hf_umts_rrc_ies_t120 = -1;             /* N_CR_T_CRMaxHyst */
static int hf_umts_rrc_ies_t180 = -1;             /* N_CR_T_CRMaxHyst */
static int hf_umts_rrc_ies_t240 = -1;             /* N_CR_T_CRMaxHyst */
static int hf_umts_rrc_ies_temporaryOffset1 = -1;  /* TemporaryOffset1 */
static int hf_umts_rrc_ies_temporaryOffset2 = -1;  /* TemporaryOffset2 */
static int hf_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList_item = -1;  /* DeltaRSCPPerCell */
static int hf_umts_rrc_ies_TimeslotInfoList_item = -1;  /* TimeslotInfo */
static int hf_umts_rrc_ies_TimeslotInfoList_LCR_r4_item = -1;  /* TimeslotInfo_LCR_r4 */
static int hf_umts_rrc_ies_tdd38417 = -1;         /* SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo */
static int hf_umts_rrc_ies_tdd384_item1 = -1;     /* TimeslotInfo */
static int hf_umts_rrc_ies_tdd12819 = -1;         /* SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4 */
static int hf_umts_rrc_ies_tdd128_item2 = -1;     /* TimeslotInfo_LCR_r4 */
static int hf_umts_rrc_ies_TimeslotISCP_List_item = -1;  /* TimeslotISCP */
static int hf_umts_rrc_ies_TimeslotListWithISCP_item = -1;  /* TimeslotWithISCP */
static int hf_umts_rrc_ies_timeslotISCP1 = -1;    /* TimeslotISCP */
static int hf_umts_rrc_ies_eventID3 = -1;         /* TrafficVolumeEventType */
static int hf_umts_rrc_ies_reportingThreshold = -1;  /* TrafficVolumeThreshold */
static int hf_umts_rrc_ies_pendingTimeAfterTrigger = -1;  /* PendingTimeAfterTrigger */
static int hf_umts_rrc_ies_tx_InterruptionAfterTrigger = -1;  /* TX_InterruptionAfterTrigger */
static int hf_umts_rrc_ies_ul_transportChannelCausingEvent = -1;  /* UL_TrCH_Identity */
static int hf_umts_rrc_ies_trafficVolumeEventIdentity = -1;  /* TrafficVolumeEventType */
static int hf_umts_rrc_ies_rlc_BufferPayload = -1;  /* NULL */
static int hf_umts_rrc_ies_averageRLC_BufferPayload = -1;  /* TimeInterval */
static int hf_umts_rrc_ies_varianceOfRLC_BufferPayload = -1;  /* TimeInterval */
static int hf_umts_rrc_ies_trafficVolumeMeasurementID = -1;  /* MeasurementIdentity */
static int hf_umts_rrc_ies_trafficVolumeMeasurementObjectList = -1;  /* TrafficVolumeMeasurementObjectList */
static int hf_umts_rrc_ies_trafficVolumeMeasQuantity = -1;  /* TrafficVolumeMeasQuantity */
static int hf_umts_rrc_ies_trafficVolumeReportingQuantity = -1;  /* TrafficVolumeReportingQuantity */
static int hf_umts_rrc_ies_dummy_TrafficVolumeReportingCriteria = -1;  /* TrafficVolumeReportingCriteria */
static int hf_umts_rrc_ies_reportCriteriaSysInf = -1;  /* TrafficVolumeReportCriteriaSysInfo */
static int hf_umts_rrc_ies_rlc_BuffersPayload = -1;  /* RLC_BuffersPayload */
static int hf_umts_rrc_ies_averageRLC_BufferPayload1 = -1;  /* AverageRLC_BufferPayload */
static int hf_umts_rrc_ies_varianceOfRLC_BufferPayload1 = -1;  /* VarianceOfRLC_BufferPayload */
static int hf_umts_rrc_ies_TrafficVolumeMeasuredResultsList_item = -1;  /* TrafficVolumeMeasuredResults */
static int hf_umts_rrc_ies_reportCriteria8 = -1;  /* TrafficVolumeReportCriteria */
static int hf_umts_rrc_ies_TrafficVolumeMeasurementObjectList_item = -1;  /* UL_TrCH_Identity */
static int hf_umts_rrc_ies_trafficVolumeReportingCriteria = -1;  /* TrafficVolumeReportingCriteria */
static int hf_umts_rrc_ies_transChCriteriaList = -1;  /* TransChCriteriaList */
static int hf_umts_rrc_ies_rlc_RB_BufferPayload = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_rlc_RB_BufferPayloadAverage = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_rlc_RB_BufferPayloadVariance = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ul_transportChannelID = -1;  /* UL_TrCH_Identity */
static int hf_umts_rrc_ies_eventSpecificParameters = -1;  /* SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam */
static int hf_umts_rrc_ies_eventSpecificParameters_item = -1;  /* TrafficVolumeEventParam */
static int hf_umts_rrc_ies_TransChCriteriaList_item = -1;  /* TransChCriteria */
static int hf_umts_rrc_ies_transmittedPowerThreshold = -1;  /* TransmittedPowerThreshold */
static int hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceThreshold = -1;  /* UE_RX_TX_TimeDifferenceThreshold */
static int hf_umts_rrc_ies_dummy1 = -1;           /* NULL */
static int hf_umts_rrc_ies_onWithNoReporting = -1;  /* NULL */
static int hf_umts_rrc_ies_dummy2_RL_InformationLists = -1;  /* RL_InformationLists */
static int hf_umts_rrc_ies_event6a = -1;          /* UE_6AB_Event */
static int hf_umts_rrc_ies_event6b = -1;          /* UE_6AB_Event */
static int hf_umts_rrc_ies_event6c = -1;          /* TimeToTrigger */
static int hf_umts_rrc_ies_event6d = -1;          /* TimeToTrigger */
static int hf_umts_rrc_ies_event6e = -1;          /* TimeToTrigger */
static int hf_umts_rrc_ies_event6f = -1;          /* UE_6FG_Event */
static int hf_umts_rrc_ies_event6g = -1;          /* UE_6FG_Event */
static int hf_umts_rrc_ies_UE_InternalEventParamList_item = -1;  /* UE_InternalEventParam */
static int hf_umts_rrc_ies_event6a1 = -1;         /* NULL */
static int hf_umts_rrc_ies_event6b1 = -1;         /* NULL */
static int hf_umts_rrc_ies_event6c1 = -1;         /* NULL */
static int hf_umts_rrc_ies_event6d1 = -1;         /* NULL */
static int hf_umts_rrc_ies_event6e1 = -1;         /* NULL */
static int hf_umts_rrc_ies_event6f1 = -1;         /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_event6g1 = -1;         /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_measurementQuantity3 = -1;  /* UE_MeasurementQuantity */
static int hf_umts_rrc_ies_modeSpecificInfo65 = -1;  /* T_modeSpecificInfo65 */
static int hf_umts_rrc_ies_fdd77 = -1;            /* T_fdd72 */
static int hf_umts_rrc_ies_ue_TransmittedPowerFDD = -1;  /* UE_TransmittedPower */
static int hf_umts_rrc_ies_ue_RX_TX_ReportEntryList = -1;  /* UE_RX_TX_ReportEntryList */
static int hf_umts_rrc_ies_tdd72 = -1;            /* T_tdd65 */
static int hf_umts_rrc_ies_ue_TransmittedPowerTDD_List = -1;  /* UE_TransmittedPowerTDD_List */
static int hf_umts_rrc_ies_appliedTA = -1;        /* UL_TimingAdvance */
static int hf_umts_rrc_ies_t_ADVinfo = -1;        /* T_ADVinfo */
static int hf_umts_rrc_ies_ue_InternalMeasQuantity = -1;  /* UE_InternalMeasQuantity */
static int hf_umts_rrc_ies_ue_InternalReportingQuantity = -1;  /* UE_InternalReportingQuantity */
static int hf_umts_rrc_ies_reportCriteria9 = -1;  /* UE_InternalReportCriteria */
static int hf_umts_rrc_ies_ue_InternalReportingQuantity1 = -1;  /* UE_InternalReportingQuantity_r4 */
static int hf_umts_rrc_ies_ue_InternalMeasurementID = -1;  /* MeasurementIdentity */
static int hf_umts_rrc_ies_ue_InternalReportingCriteria = -1;  /* UE_InternalReportingCriteria */
static int hf_umts_rrc_ies_ue_InternalEventParamList = -1;  /* UE_InternalEventParamList */
static int hf_umts_rrc_ies_ue_TransmittedPower = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_modeSpecificInfo66 = -1;  /* T_modeSpecificInfo66 */
static int hf_umts_rrc_ies_fdd78 = -1;            /* T_fdd73 */
static int hf_umts_rrc_ies_ue_RX_TX_TimeDifference = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_tdd73 = -1;            /* T_tdd66 */
static int hf_umts_rrc_ies_appliedTA1 = -1;       /* BOOLEAN */
static int hf_umts_rrc_ies_modeSpecificInfo67 = -1;  /* T_modeSpecificInfo67 */
static int hf_umts_rrc_ies_fdd79 = -1;            /* T_fdd74 */
static int hf_umts_rrc_ies_tdd74 = -1;            /* T_tdd67 */
static int hf_umts_rrc_ies_tddOption14 = -1;      /* T_tddOption14 */
static int hf_umts_rrc_ies_tdd38418 = -1;         /* T_tdd38414 */
static int hf_umts_rrc_ies_tdd12820 = -1;         /* T_tdd12816 */
static int hf_umts_rrc_ies_t_ADVinfo1 = -1;       /* BOOLEAN */
static int hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType1 = -1;  /* UE_RX_TX_TimeDifferenceType1 */
static int hf_umts_rrc_ies_UE_RX_TX_ReportEntryList_item = -1;  /* UE_RX_TX_ReportEntry */
static int hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType2 = -1;  /* UE_RX_TX_TimeDifferenceType2 */
static int hf_umts_rrc_ies_UE_TransmittedPowerTDD_List_item = -1;  /* UE_TransmittedPower */
static int hf_umts_rrc_ies_rachorcpch = -1;       /* NULL */
static int hf_umts_rrc_ies_cipheringKeyFlag = -1;  /* BIT_STRING_SIZE_1 */
static int hf_umts_rrc_ies_cipheringSerialNumber = -1;  /* INTEGER_0_65535 */
static int hf_umts_rrc_ies_errorReason = -1;      /* UE_Positioning_ErrorCause */
static int hf_umts_rrc_ies_ue_positioning_GPS_additionalAssistanceDataRequest = -1;  /* UE_Positioning_GPS_AdditionalAssistanceDataRequest */
static int hf_umts_rrc_ies_reportFirstFix = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_measurementInterval = -1;  /* UE_Positioning_MeasurementInterval */
static int hf_umts_rrc_ies_eventSpecificInfo = -1;  /* UE_Positioning_EventSpecificInfo */
static int hf_umts_rrc_ies_UE_Positioning_EventParamList_item = -1;  /* UE_Positioning_EventParam */
static int hf_umts_rrc_ies_e7a = -1;              /* ThresholdPositionChange */
static int hf_umts_rrc_ies_e7b = -1;              /* ThresholdSFN_SFN_Change */
static int hf_umts_rrc_ies_e7c = -1;              /* ThresholdSFN_GPS_TOW */
static int hf_umts_rrc_ies_gps_ReferenceTime = -1;  /* INTEGER_0_604799999 */
static int hf_umts_rrc_ies_utran_GPSReferenceTime = -1;  /* UTRAN_GPSReferenceTime */
static int hf_umts_rrc_ies_satelliteInformationList = -1;  /* AcquisitionSatInfoList */
static int hf_umts_rrc_ies_almanacRequest = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_utcModelRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_ionosphericModelRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_navigationModelRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_dgpsCorrectionsRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_referenceLocationRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_referenceTimeRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_aquisitionAssistanceRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_realTimeIntegrityRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_navModelAddDataRequest = -1;  /* UE_Positioning_GPS_NavModelAddDataReq */
static int hf_umts_rrc_ies_wn_a = -1;             /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_almanacSatInfoList = -1;  /* AlmanacSatInfoList */
static int hf_umts_rrc_ies_sv_GlobalHealth = -1;  /* BIT_STRING_SIZE_364 */
static int hf_umts_rrc_ies_ue_positioning_GPS_ReferenceTime = -1;  /* UE_Positioning_GPS_ReferenceTime */
static int hf_umts_rrc_ies_ue_positioning_GPS_ReferenceLocation = -1;  /* ReferenceLocation */
static int hf_umts_rrc_ies_ue_positioning_GPS_DGPS_Corrections = -1;  /* UE_Positioning_GPS_DGPS_Corrections */
static int hf_umts_rrc_ies_ue_positioning_GPS_NavigationModel = -1;  /* UE_Positioning_GPS_NavigationModel */
static int hf_umts_rrc_ies_ue_positioning_GPS_IonosphericModel = -1;  /* UE_Positioning_GPS_IonosphericModel */
static int hf_umts_rrc_ies_ue_positioning_GPS_UTC_Model = -1;  /* UE_Positioning_GPS_UTC_Model */
static int hf_umts_rrc_ies_ue_positioning_GPS_Almanac = -1;  /* UE_Positioning_GPS_Almanac */
static int hf_umts_rrc_ies_ue_positioning_GPS_AcquisitionAssistance = -1;  /* UE_Positioning_GPS_AcquisitionAssistance */
static int hf_umts_rrc_ies_ue_positioning_GPS_Real_timeIntegrity = -1;  /* BadSatList */
static int hf_umts_rrc_ies_dummy_UE_Positioning_GPS_ReferenceCellInfo = -1;  /* UE_Positioning_GPS_ReferenceCellInfo */
static int hf_umts_rrc_ies_gps_TOW = -1;          /* INTEGER_0_604799 */
static int hf_umts_rrc_ies_statusHealth = -1;     /* DiffCorrectionStatus */
static int hf_umts_rrc_ies_dgps_CorrectionSatInfoList = -1;  /* DGPS_CorrectionSatInfoList */
static int hf_umts_rrc_ies_alfa0 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_alfa1 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_alfa2 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_alfa3 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_beta0 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_beta1 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_beta2 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_beta3 = -1;            /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_referenceTime = -1;    /* T_referenceTime */
static int hf_umts_rrc_ies_utran_GPSReferenceTimeResult = -1;  /* UTRAN_GPSReferenceTimeResult */
static int hf_umts_rrc_ies_gps_ReferenceTimeOnly = -1;  /* INTEGER_0_604799999 */
static int hf_umts_rrc_ies_gps_MeasurementParamList = -1;  /* GPS_MeasurementParamList */
static int hf_umts_rrc_ies_navigationModelSatInfoList = -1;  /* NavigationModelSatInfoList */
static int hf_umts_rrc_ies_gps_Week = -1;         /* INTEGER_0_1023 */
static int hf_umts_rrc_ies_gps_Toe = -1;          /* INTEGER_0_255 */
static int hf_umts_rrc_ies_tToeLimit = -1;        /* INTEGER_0_15 */
static int hf_umts_rrc_ies_satDataList = -1;      /* SatDataList */
static int hf_umts_rrc_ies_modeSpecificInfo68 = -1;  /* T_modeSpecificInfo68 */
static int hf_umts_rrc_ies_fdd80 = -1;            /* T_fdd75 */
static int hf_umts_rrc_ies_referenceIdentity = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_tdd75 = -1;            /* T_tdd68 */
static int hf_umts_rrc_ies_referenceIdentity1 = -1;  /* CellParametersID */
static int hf_umts_rrc_ies_gps_tow_1msec = -1;    /* GPS_TOW_1msec */
static int hf_umts_rrc_ies_sfn_tow_Uncertainty = -1;  /* SFN_TOW_Uncertainty */
static int hf_umts_rrc_ies_utran_GPS_DriftRate = -1;  /* UTRAN_GPS_DriftRate */
static int hf_umts_rrc_ies_gps_TOW_AssistList = -1;  /* GPS_TOW_AssistList */
static int hf_umts_rrc_ies_a1 = -1;               /* BIT_STRING_SIZE_24 */
static int hf_umts_rrc_ies_a0 = -1;               /* BIT_STRING_SIZE_32 */
static int hf_umts_rrc_ies_t_ot = -1;             /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_wn_t = -1;             /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_delta_t_LS = -1;       /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_wn_lsf = -1;           /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_dn = -1;               /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_delta_t_LSF = -1;      /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_ip_Spacing = -1;       /* IP_Spacing */
static int hf_umts_rrc_ies_ip_Length = -1;        /* IP_Length */
static int hf_umts_rrc_ies_ip_Offset = -1;        /* INTEGER_0_9 */
static int hf_umts_rrc_ies_seed = -1;             /* INTEGER_0_63 */
static int hf_umts_rrc_ies_burstModeParameters = -1;  /* BurstModeParameters */
static int hf_umts_rrc_ies_modeSpecificInfo69 = -1;  /* T_modeSpecificInfo69 */
static int hf_umts_rrc_ies_fdd81 = -1;            /* T_fdd76 */
static int hf_umts_rrc_ies_tdd76 = -1;            /* T_tdd69 */
static int hf_umts_rrc_ies_ip_Spacing_TDD = -1;   /* IP_Spacing_TDD */
static int hf_umts_rrc_ies_ip_slot = -1;          /* INTEGER_0_14 */
static int hf_umts_rrc_ies_ip_Start = -1;         /* INTEGER_0_4095 */
static int hf_umts_rrc_ies_ip_PCCPCG = -1;        /* IP_PCCPCH_r4 */
static int hf_umts_rrc_ies_ip_Spacing1 = -1;      /* IP_Spacing_TDD */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_Measurement = -1;  /* UE_Positioning_OTDOA_Measurement */
static int hf_umts_rrc_ies_ue_positioning_PositionEstimateInfo = -1;  /* UE_Positioning_PositionEstimateInfo */
static int hf_umts_rrc_ies_ue_positioning_GPS_Measurement = -1;  /* UE_Positioning_GPS_MeasurementResults */
static int hf_umts_rrc_ies_ue_positioning_Error = -1;  /* UE_Positioning_Error */
static int hf_umts_rrc_ies_ue_Positioning_OTDOA_Measurement_v390ext = -1;  /* UE_Positioning_OTDOA_Measurement_v390ext */
static int hf_umts_rrc_ies_ue_positioning_ReportingQuantity = -1;  /* UE_Positioning_ReportingQuantity */
static int hf_umts_rrc_ies_reportCriteria10 = -1;  /* UE_Positioning_ReportCriteria */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData = -1;  /* UE_Positioning_OTDOA_AssistanceData */
static int hf_umts_rrc_ies_ue_positioning_GPS_AssistanceData = -1;  /* UE_Positioning_GPS_AssistanceData */
static int hf_umts_rrc_ies_ue_positioning_ReportingQuantity_v390ext = -1;  /* UE_Positioning_ReportingQuantity_v390ext */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData_UEB = -1;  /* UE_Positioning_OTDOA_AssistanceData_UEB */
static int hf_umts_rrc_ies_ue_positioning_ReportingQuantity1 = -1;  /* UE_Positioning_ReportingQuantity_r4 */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData1 = -1;  /* UE_Positioning_OTDOA_AssistanceData_r4 */
static int hf_umts_rrc_ies_event7a = -1;          /* UE_Positioning_PositionEstimateInfo */
static int hf_umts_rrc_ies_event7b = -1;          /* UE_Positioning_OTDOA_Measurement */
static int hf_umts_rrc_ies_event7c = -1;          /* UE_Positioning_GPS_MeasurementResults */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo = -1;  /* UE_Positioning_OTDOA_ReferenceCellInfo */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList = -1;  /* UE_Positioning_OTDOA_NeighbourCellList */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo1 = -1;  /* UE_Positioning_OTDOA_ReferenceCellInfo_r4 */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList1 = -1;  /* UE_Positioning_OTDOA_NeighbourCellList_r4 */
static int hf_umts_rrc_ies_ue_Positioning_IPDL_Parameters_TDD_r4_ext = -1;  /* UE_Positioning_IPDL_Parameters_TDD_r4_ext */
static int hf_umts_rrc_ies_ue_Positioning_IPDL_Parameters_TDDList_r4_ext = -1;  /* UE_Positioning_IPDL_Parameters_TDDList_r4_ext */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo_UEB = -1;  /* UE_Positioning_OTDOA_ReferenceCellInfo_UEB */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList_UEB = -1;  /* UE_Positioning_OTDOA_NeighbourCellList_UEB */
static int hf_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext_item = -1;  /* UE_Positioning_IPDL_Parameters_TDD_r4_ext */
static int hf_umts_rrc_ies_modeSpecificInfo70 = -1;  /* T_modeSpecificInfo70 */
static int hf_umts_rrc_ies_fdd82 = -1;            /* T_fdd77 */
static int hf_umts_rrc_ies_referenceCellIDentity = -1;  /* PrimaryCPICH_Info */
static int hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType2Info = -1;  /* UE_RX_TX_TimeDifferenceType2Info */
static int hf_umts_rrc_ies_tdd77 = -1;            /* T_tdd70 */
static int hf_umts_rrc_ies_referenceCellIdentity = -1;  /* CellParametersID */
static int hf_umts_rrc_ies_neighbourList = -1;    /* NeighbourList */
static int hf_umts_rrc_ies_neighbourList_v390ext = -1;  /* NeighbourList_v390ext */
static int hf_umts_rrc_ies_modeSpecificInfo71 = -1;  /* T_modeSpecificInfo71 */
static int hf_umts_rrc_ies_fdd83 = -1;            /* T_fdd78 */
static int hf_umts_rrc_ies_tdd78 = -1;            /* T_tdd71 */
static int hf_umts_rrc_ies_cellAndChannelIdentity = -1;  /* CellAndChannelIdentity */
static int hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters = -1;  /* UE_Positioning_IPDL_Parameters */
static int hf_umts_rrc_ies_sfn_SFN_RelTimeDifference = -1;  /* SFN_SFN_RelTimeDifference1 */
static int hf_umts_rrc_ies_sfn_SFN_Drift = -1;    /* SFN_SFN_Drift */
static int hf_umts_rrc_ies_searchWindowSize = -1;  /* OTDOA_SearchWindowSize */
static int hf_umts_rrc_ies_positioningMode = -1;  /* T_positioningMode */
static int hf_umts_rrc_ies_ueBased = -1;          /* T_ueBased */
static int hf_umts_rrc_ies_ueAssisted = -1;       /* T_ueAssisted */
static int hf_umts_rrc_ies_modeSpecificInfo72 = -1;  /* T_modeSpecificInfo72 */
static int hf_umts_rrc_ies_fdd84 = -1;            /* T_fdd79 */
static int hf_umts_rrc_ies_tdd79 = -1;            /* T_tdd72 */
static int hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters1 = -1;  /* UE_Positioning_IPDL_Parameters_r4 */
static int hf_umts_rrc_ies_sfn_Offset_Validity = -1;  /* SFN_Offset_Validity */
static int hf_umts_rrc_ies_positioningMode1 = -1;  /* T_positioningMode1 */
static int hf_umts_rrc_ies_ueBased1 = -1;         /* T_ueBased1 */
static int hf_umts_rrc_ies_relativeNorth = -1;    /* INTEGER_M20000_20000 */
static int hf_umts_rrc_ies_relativeEast = -1;     /* INTEGER_M20000_20000 */
static int hf_umts_rrc_ies_relativeAltitude = -1;  /* INTEGER_M4000_4000 */
static int hf_umts_rrc_ies_fineSFN_SFN = -1;      /* FineSFN_SFN */
static int hf_umts_rrc_ies_roundTripTime = -1;    /* INTEGER_0_32766 */
static int hf_umts_rrc_ies_ueAssisted1 = -1;      /* T_ueAssisted1 */
static int hf_umts_rrc_ies_modeSpecificInfo73 = -1;  /* T_modeSpecificInfo73 */
static int hf_umts_rrc_ies_fdd85 = -1;            /* T_fdd80 */
static int hf_umts_rrc_ies_tdd80 = -1;            /* T_tdd73 */
static int hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_item = -1;  /* UE_Positioning_OTDOA_NeighbourCellInfo */
static int hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4_item = -1;  /* UE_Positioning_OTDOA_NeighbourCellInfo_r4 */
static int hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB_item = -1;  /* UE_Positioning_OTDOA_NeighbourCellInfo_UEB */
static int hf_umts_rrc_ies_stdResolution = -1;    /* BIT_STRING_SIZE_2 */
static int hf_umts_rrc_ies_numberOfOTDOA_Measurements = -1;  /* BIT_STRING_SIZE_3 */
static int hf_umts_rrc_ies_stdOfOTDOA_Measurements = -1;  /* BIT_STRING_SIZE_5 */
static int hf_umts_rrc_ies_modeSpecificInfo74 = -1;  /* T_modeSpecificInfo74 */
static int hf_umts_rrc_ies_fdd86 = -1;            /* T_fdd81 */
static int hf_umts_rrc_ies_tdd81 = -1;            /* T_tdd74 */
static int hf_umts_rrc_ies_positioningMode2 = -1;  /* T_positioningMode2 */
static int hf_umts_rrc_ies_ueBased2 = -1;         /* T_ueBased2 */
static int hf_umts_rrc_ies_ueAssisted2 = -1;      /* T_ueAssisted2 */
static int hf_umts_rrc_ies_modeSpecificInfo75 = -1;  /* T_modeSpecificInfo75 */
static int hf_umts_rrc_ies_fdd87 = -1;            /* T_fdd82 */
static int hf_umts_rrc_ies_tdd82 = -1;            /* T_tdd75 */
static int hf_umts_rrc_ies_positioningMode3 = -1;  /* T_positioningMode3 */
static int hf_umts_rrc_ies_ueBased3 = -1;         /* T_ueBased3 */
static int hf_umts_rrc_ies_cellPosition = -1;     /* ReferenceCellPosition */
static int hf_umts_rrc_ies_ueAssisted3 = -1;      /* T_ueAssisted3 */
static int hf_umts_rrc_ies_modeSpecificInfo76 = -1;  /* T_modeSpecificInfo76 */
static int hf_umts_rrc_ies_fdd88 = -1;            /* T_fdd83 */
static int hf_umts_rrc_ies_tdd83 = -1;            /* T_tdd76 */
static int hf_umts_rrc_ies_referenceTime1 = -1;   /* T_referenceTime1 */
static int hf_umts_rrc_ies_cell_Timing = -1;      /* T_cell_Timing */
static int hf_umts_rrc_ies_modeSpecificInfo77 = -1;  /* T_modeSpecificInfo77 */
static int hf_umts_rrc_ies_fdd89 = -1;            /* T_fdd84 */
static int hf_umts_rrc_ies_tdd84 = -1;            /* T_tdd77 */
static int hf_umts_rrc_ies_positionEstimate = -1;  /* PositionEstimate */
static int hf_umts_rrc_ies_ue_positioning_ReportingCriteria = -1;  /* UE_Positioning_EventParamList */
static int hf_umts_rrc_ies_methodType = -1;       /* UE_Positioning_MethodType */
static int hf_umts_rrc_ies_positioningMethod = -1;  /* PositioningMethod */
static int hf_umts_rrc_ies_dummy1_UE_Positioning_ResponseTime = -1;  /* UE_Positioning_ResponseTime */
static int hf_umts_rrc_ies_horizontal_Accuracy = -1;  /* UE_Positioning_Accuracy */
static int hf_umts_rrc_ies_gps_TimingOfCellWanted = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_additionalAssistanceDataRequest = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_environmentCharacterisation = -1;  /* EnvironmentCharacterisation */
static int hf_umts_rrc_ies_vertical_Accuracy = -1;  /* UE_Positioning_Accuracy */
static int hf_umts_rrc_ies_horizontalAccuracy = -1;  /* UE_Positioning_Accuracy */
static int hf_umts_rrc_ies_verticalAccuracy = -1;  /* UE_Positioning_Accuracy */
static int hf_umts_rrc_ies_additionalAssistanceDataReq = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_utran_GPSTimingOfCell = -1;  /* T_utran_GPSTimingOfCell */
static int hf_umts_rrc_ies_ms_part = -1;          /* INTEGER_0_1023 */
static int hf_umts_rrc_ies_ls_part = -1;          /* INTEGER_0_4294967295 */
static int hf_umts_rrc_ies_modeSpecificInfo78 = -1;  /* T_modeSpecificInfo78 */
static int hf_umts_rrc_ies_fdd90 = -1;            /* T_fdd85 */
static int hf_umts_rrc_ies_tdd85 = -1;            /* T_tdd78 */
static int hf_umts_rrc_ies_ue_GPSTimingOfCell = -1;  /* T_ue_GPSTimingOfCell */
static int hf_umts_rrc_ies_ms_part1 = -1;         /* INTEGER_0_16383 */
static int hf_umts_rrc_ies_modeSpecificInfo79 = -1;  /* T_modeSpecificInfo79 */
static int hf_umts_rrc_ies_fdd91 = -1;            /* T_fdd86 */
static int hf_umts_rrc_ies_tdd86 = -1;            /* T_tdd79 */
static int hf_umts_rrc_ies_mib_ValueTag = -1;     /* MIB_ValueTag */
static int hf_umts_rrc_ies_bcch_ModificationTime = -1;  /* BCCH_ModificationTime */
static int hf_umts_rrc_ies_ncc = -1;              /* NCC */
static int hf_umts_rrc_ies_bcc = -1;              /* BCC */
static int hf_umts_rrc_ies_ctch_AllocationPeriod = -1;  /* INTEGER_1_256 */
static int hf_umts_rrc_ies_cbs_FrameOffset = -1;  /* INTEGER_0_255 */
static int hf_umts_rrc_ies_msg_Type = -1;         /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_payload = -1;          /* BIT_STRING_SIZE_1_512 */
static int hf_umts_rrc_ies_CDMA2000_MessageList_item = -1;  /* CDMA2000_Message */
static int hf_umts_rrc_ies_CDMA2000_UMTS_Frequency_List_item = -1;  /* FrequencyInfoCDMA2000 */
static int hf_umts_rrc_ies_FDD_UMTS_Frequency_List_item = -1;  /* FrequencyInfoFDD */
static int hf_umts_rrc_ies_band_Class = -1;       /* BIT_STRING_SIZE_5 */
static int hf_umts_rrc_ies_cdma_Freq = -1;        /* BIT_STRING_SIZE_11 */
static int hf_umts_rrc_ies_GERAN_SystemInformation_item = -1;  /* GERAN_SystemInfoBlock */
static int hf_umts_rrc_ies_gsmLowRangeUARFCN = -1;  /* UARFCN */
static int hf_umts_rrc_ies_gsmUpRangeUARFCN = -1;  /* UARFCN */
static int hf_umts_rrc_ies_GSM_BA_Range_List_item = -1;  /* GSM_BA_Range */
static int hf_umts_rrc_ies_GSM_MessageList_item = -1;  /* BIT_STRING_SIZE_1_512 */
static int hf_umts_rrc_ies_GSM_TargetCellInfoList_item = -1;  /* GSM_TargetCellInfo */
static int hf_umts_rrc_ies_receivedMessageType = -1;  /* ReceivedMessageType */
static int hf_umts_rrc_ies_configurationUnacceptable = -1;  /* NULL */
static int hf_umts_rrc_ies_unspecified = -1;      /* NULL */
static int hf_umts_rrc_ies_GERANIu_MessageList_item = -1;  /* BIT_STRING_SIZE_1_32768 */
static int hf_umts_rrc_ies_gsm11 = -1;            /* T_gsm10 */
static int hf_umts_rrc_ies_gsm_Classmark2 = -1;   /* GSM_Classmark2 */
static int hf_umts_rrc_ies_gsm_Classmark3 = -1;   /* GSM_Classmark3 */
static int hf_umts_rrc_ies_cdma2000 = -1;         /* T_cdma2000 */
static int hf_umts_rrc_ies_cdma2000_MessageList = -1;  /* CDMA2000_MessageList */
static int hf_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList_item = -1;  /* InterRAT_UE_RadioAccessCapability */
static int hf_umts_rrc_ies_geranIu_RadioAccessCapability = -1;  /* GERANIu_RadioAccessCapability */
static int hf_umts_rrc_ies_gsm_MS_RadioAccessCapability = -1;  /* GSM_MS_RadioAccessCapability */
static int hf_umts_rrc_ies_gsm12 = -1;            /* T_gsm11 */
static int hf_umts_rrc_ies_gsmSecurityCapability = -1;  /* GsmSecurityCapability */
static int hf_umts_rrc_ies_InterRAT_UE_SecurityCapList_item = -1;  /* InterRAT_UE_SecurityCapability */
static int hf_umts_rrc_ies_interRAT_ProtocolError = -1;  /* NULL */
static int hf_umts_rrc_ies_spare10 = -1;          /* NULL */
static int hf_umts_rrc_ies_spare9 = -1;           /* NULL */
static int hf_umts_rrc_ies_spare8 = -1;           /* NULL */
static int hf_umts_rrc_ies_spare7 = -1;           /* NULL */
static int hf_umts_rrc_ies_spare6 = -1;           /* NULL */
static int hf_umts_rrc_ies_plmn_Type = -1;        /* PLMN_Type */
static int hf_umts_rrc_ies_sibSb_ReferenceList = -1;  /* SIBSb_ReferenceList */
static int hf_umts_rrc_ies_v6xyNonCriticalExtensions = -1;  /* T_v6xyNonCriticalExtensions */
static int hf_umts_rrc_ies_masterInformationBlock_v6xyext = -1;  /* MasterInformationBlock_v6xyext */
static int hf_umts_rrc_ies_nonCriticalExtensions1 = -1;  /* T_nonCriticalExtensions1 */
static int hf_umts_rrc_ies_multiplePLMN_List = -1;  /* MultiplePLMN_List_r6 */
static int hf_umts_rrc_ies_predefinedConfigIdentity = -1;  /* PredefinedConfigIdentity */
static int hf_umts_rrc_ies_predefinedConfigValueTag = -1;  /* PredefinedConfigValueTag */
static int hf_umts_rrc_ies_diagnosticsType1 = -1;  /* T_diagnosticsType1 */
static int hf_umts_rrc_ies_type14 = -1;           /* T_type13 */
static int hf_umts_rrc_ies_protocolErrorCause = -1;  /* ProtocolErrorCause */
static int hf_umts_rrc_ies_gsm_BA_Range_List = -1;  /* GSM_BA_Range_List */
static int hf_umts_rrc_ies_fdd_UMTS_Frequency_List = -1;  /* FDD_UMTS_Frequency_List */
static int hf_umts_rrc_ies_tdd_UMTS_Frequency_List = -1;  /* TDD_UMTS_Frequency_List */
static int hf_umts_rrc_ies_cdma2000_UMTS_Frequency_List = -1;  /* CDMA2000_UMTS_Frequency_List */
static int hf_umts_rrc_ies_tdd384_UMTS_Frequency_List = -1;  /* TDD_UMTS_Frequency_List */
static int hf_umts_rrc_ies_tdd128_UMTS_Frequency_List = -1;  /* TDD_UMTS_Frequency_List */
static int hf_umts_rrc_ies_scheduling = -1;       /* T_scheduling */
static int hf_umts_rrc_ies_segCount = -1;         /* SegCount */
static int hf_umts_rrc_ies_sib_Pos = -1;          /* T_sib_Pos */
static int hf_umts_rrc_ies_rep4 = -1;             /* INTEGER_0_1 */
static int hf_umts_rrc_ies_rep8 = -1;             /* INTEGER_0_3 */
static int hf_umts_rrc_ies_rep16 = -1;            /* INTEGER_0_7 */
static int hf_umts_rrc_ies_rep32 = -1;            /* INTEGER_0_15 */
static int hf_umts_rrc_ies_rep64 = -1;            /* INTEGER_0_31 */
static int hf_umts_rrc_ies_rep128 = -1;           /* INTEGER_0_63 */
static int hf_umts_rrc_ies_rep256 = -1;           /* INTEGER_0_127 */
static int hf_umts_rrc_ies_rep512 = -1;           /* INTEGER_0_255 */
static int hf_umts_rrc_ies_rep1024 = -1;          /* INTEGER_0_511 */
static int hf_umts_rrc_ies_rep2048 = -1;          /* INTEGER_0_1023 */
static int hf_umts_rrc_ies_rep4096 = -1;          /* INTEGER_0_2047 */
static int hf_umts_rrc_ies_sib_PosOffsetInfo = -1;  /* SibOFF_List */
static int hf_umts_rrc_ies_sib_Type = -1;         /* SIB_TypeAndTag */
static int hf_umts_rrc_ies_scheduling1 = -1;      /* SchedulingInformation */
static int hf_umts_rrc_ies_sibSb_Type = -1;       /* SIBSb_TypeAndTag */
static int hf_umts_rrc_ies_sibOccurIdentity = -1;  /* SIBOccurIdentity */
static int hf_umts_rrc_ies_sibOccurValueTag = -1;  /* SIBOccurValueTag */
static int hf_umts_rrc_ies_SIB_ReferenceList_item = -1;  /* SchedulingInformationSIB */
static int hf_umts_rrc_ies_SIBSb_ReferenceList_item = -1;  /* SchedulingInformationSIBSb */
static int hf_umts_rrc_ies_SIB_ReferenceListFACH_item = -1;  /* SchedulingInformationSIB */
static int hf_umts_rrc_ies_sysInfoType1 = -1;     /* PLMN_ValueTag */
static int hf_umts_rrc_ies_sysInfoType2 = -1;     /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType3 = -1;     /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType4 = -1;     /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType5 = -1;     /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType6 = -1;     /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType7 = -1;     /* NULL */
static int hf_umts_rrc_ies_dummy_CellValueTag = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_dummy2_NULL = -1;      /* NULL */
static int hf_umts_rrc_ies_dummy3_NULL = -1;      /* NULL */
static int hf_umts_rrc_ies_sysInfoType11 = -1;    /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType12 = -1;    /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType13 = -1;    /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType13_1 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType13_2 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType13_3 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType13_4 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType14 = -1;    /* NULL */
static int hf_umts_rrc_ies_sysInfoType15 = -1;    /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType16 = -1;    /* PredefinedConfigIdentityAndValueTag */
static int hf_umts_rrc_ies_sysInfoType17 = -1;    /* NULL */
static int hf_umts_rrc_ies_sysInfoType15_1 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType15_2 = -1;  /* SIBOccurrenceIdentityAndValueTag */
static int hf_umts_rrc_ies_sysInfoType15_3 = -1;  /* SIBOccurrenceIdentityAndValueTag */
static int hf_umts_rrc_ies_sysInfoType15_4 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType18 = -1;    /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType15_5 = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoType5bis = -1;  /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoTypeSB1 = -1;   /* CellValueTag */
static int hf_umts_rrc_ies_sysInfoTypeSB2 = -1;   /* CellValueTag */
static int hf_umts_rrc_ies_SibOFF_List_item = -1;  /* SibOFF */
static int hf_umts_rrc_ies_cn_DomainSysInfoList = -1;  /* CN_DomainSysInfoList */
static int hf_umts_rrc_ies_ue_ConnTimersAndConstants = -1;  /* UE_ConnTimersAndConstants */
static int hf_umts_rrc_ies_ue_IdleTimersAndConstants = -1;  /* UE_IdleTimersAndConstants */
static int hf_umts_rrc_ies_v3a0NonCriticalExtensions = -1;  /* T_v3a0NonCriticalExtensions */
static int hf_umts_rrc_ies_sysInfoType1_v3a0ext = -1;  /* SysInfoType1_v3a0ext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions2 = -1;  /* T_nonCriticalExtensions2 */
static int hf_umts_rrc_ies_ue_ConnTimersAndConstants_v3a0ext = -1;  /* UE_ConnTimersAndConstants_v3a0ext */
static int hf_umts_rrc_ies_ue_IdleTimersAndConstants_v3a0ext = -1;  /* UE_IdleTimersAndConstants_v3a0ext */
static int hf_umts_rrc_ies_ura_IdentityList = -1;  /* URA_IdentityList */
static int hf_umts_rrc_ies_nonCriticalExtensions3 = -1;  /* T_nonCriticalExtensions3 */
static int hf_umts_rrc_ies_sib4indicator = -1;    /* BOOLEAN */
static int hf_umts_rrc_ies_cellSelectReselectInfo = -1;  /* CellSelectReselectInfoSIB_3_4 */
static int hf_umts_rrc_ies_cellAccessRestriction = -1;  /* CellAccessRestriction */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions = -1;  /* T_v4b0NonCriticalExtensions */
static int hf_umts_rrc_ies_sysInfoType3_v4b0ext = -1;  /* SysInfoType3_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtension = -1;  /* T_v590NonCriticalExtension */
static int hf_umts_rrc_ies_sysInfoType3_v590ext = -1;  /* SysInfoType3_v590ext */
static int hf_umts_rrc_ies_v5c0NoncriticalExtension = -1;  /* T_v5c0NoncriticalExtension */
static int hf_umts_rrc_ies_sysInfoType3_v5c0ext = -1;  /* SysInfoType3_v5c0ext_IEs */
static int hf_umts_rrc_ies_v670NonCriticalExtension = -1;  /* T_v670NonCriticalExtension */
static int hf_umts_rrc_ies_sysInfoType3_v670ext = -1;  /* SysInfoType3_v670ext */
static int hf_umts_rrc_ies_nonCriticalExtensions4 = -1;  /* T_nonCriticalExtensions4 */
static int hf_umts_rrc_ies_mapping_LCR = -1;      /* Mapping_LCR_r4 */
static int hf_umts_rrc_ies_cellSelectReselectInfo_v590ext = -1;  /* CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_cellSelectReselectInfoTreselectionScaling_v5c0ext = -1;  /* CellSelectReselectInfoTreselectionScaling_v5c0ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForPLMNOfMIB = -1;  /* DomainSpecificAccessRestrictionParam_v670ext */
static int hf_umts_rrc_ies_domainSpecificAccessRestictionForSharedNetwork = -1;  /* DomainSpecificAccessRestrictionForSharedNetwork_v670ext */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions1 = -1;  /* T_v4b0NonCriticalExtensions1 */
static int hf_umts_rrc_ies_sysInfoType4_v4b0ext = -1;  /* SysInfoType4_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtension1 = -1;  /* T_v590NonCriticalExtension1 */
static int hf_umts_rrc_ies_sysInfoType4_v590ext = -1;  /* SysInfoType4_v590ext */
static int hf_umts_rrc_ies_v5b0NonCriticalExtension = -1;  /* T_v5b0NonCriticalExtension */
static int hf_umts_rrc_ies_sysInfoType4_v5b0ext = -1;  /* SysInfoType4_v5b0ext_IEs */
static int hf_umts_rrc_ies_v5c0NonCriticalExtension = -1;  /* T_v5c0NonCriticalExtension */
static int hf_umts_rrc_ies_sysInfoType4_v5c0ext = -1;  /* SysInfoType4_v5c0ext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions5 = -1;  /* T_nonCriticalExtensions5 */
static int hf_umts_rrc_ies_cellSelectReselectInfoPCHFACH_v5b0ext = -1;  /* CellSelectReselectInfoPCHFACH_v5b0ext */
static int hf_umts_rrc_ies_sib6indicator = -1;    /* BOOLEAN */
static int hf_umts_rrc_ies_pich_PowerOffset = -1;  /* PICH_PowerOffset */
static int hf_umts_rrc_ies_modeSpecificInfo80 = -1;  /* T_modeSpecificInfo80 */
static int hf_umts_rrc_ies_fdd92 = -1;            /* T_fdd87 */
static int hf_umts_rrc_ies_aich_PowerOffset = -1;  /* AICH_PowerOffset */
static int hf_umts_rrc_ies_tdd87 = -1;            /* T_tdd80 */
static int hf_umts_rrc_ies_pusch_SysInfoList_SFN = -1;  /* PUSCH_SysInfoList_SFN */
static int hf_umts_rrc_ies_pdsch_SysInfoList_SFN = -1;  /* PDSCH_SysInfoList_SFN */
static int hf_umts_rrc_ies_openLoopPowerControl_TDD = -1;  /* OpenLoopPowerControl_TDD */
static int hf_umts_rrc_ies_prach_SystemInformationList = -1;  /* PRACH_SystemInformationList */
static int hf_umts_rrc_ies_sCCPCH_SystemInformationList = -1;  /* SCCPCH_SystemInformationList */
static int hf_umts_rrc_ies_cbs_DRX_Level1Information = -1;  /* CBS_DRX_Level1Information */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions2 = -1;  /* T_v4b0NonCriticalExtensions2 */
static int hf_umts_rrc_ies_sysInfoType5_v4b0ext = -1;  /* SysInfoType5_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtensions = -1;  /* T_v590NonCriticalExtensions */
static int hf_umts_rrc_ies_sysInfoType5_v590ext = -1;  /* SysInfoType5_v590ext_IEs */
static int hf_umts_rrc_ies_v650NonCriticalExtensions = -1;  /* T_v650NonCriticalExtensions */
static int hf_umts_rrc_ies_sysInfoType5_v650ext = -1;  /* SysInfoType5_v650ext_IEs */
static int hf_umts_rrc_ies_v6xyNonCriticalExtensions1 = -1;  /* T_v6xyNonCriticalExtensions1 */
static int hf_umts_rrc_ies_sysInfoType5_v6xyext = -1;  /* SysInfoType5_v6xyext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions6 = -1;  /* T_nonCriticalExtensions6 */
static int hf_umts_rrc_ies_pNBSCH_Allocation_r4 = -1;  /* PNBSCH_Allocation_r4 */
static int hf_umts_rrc_ies_openLoopPowerControl_IPDL_TDD = -1;  /* OpenLoopPowerControl_IPDL_TDD_r4 */
static int hf_umts_rrc_ies_prach_SystemInformationList_LCR_r4 = -1;  /* PRACH_SystemInformationList_LCR_r4 */
static int hf_umts_rrc_ies_tdd128SpecificInfo = -1;  /* T_tdd128SpecificInfo */
static int hf_umts_rrc_ies_pusch_SysInfoList_SFN1 = -1;  /* PUSCH_SysInfoList_SFN_LCR_r4 */
static int hf_umts_rrc_ies_pdsch_SysInfoList_SFN1 = -1;  /* PDSCH_SysInfoList_SFN_LCR_r4 */
static int hf_umts_rrc_ies_pCCPCH_LCR_Extensions = -1;  /* PrimaryCCPCH_Info_LCR_r4_ext */
static int hf_umts_rrc_ies_sCCPCH_LCR_ExtensionsList = -1;  /* SCCPCH_SystemInformationList_LCR_r4_ext */
static int hf_umts_rrc_ies_frequencyBandIndicator = -1;  /* RadioFrequencyBandFDD */
static int hf_umts_rrc_ies_hcr_r5_SpecificInfo = -1;  /* T_hcr_r5_SpecificInfo */
static int hf_umts_rrc_ies_pusch_SysInfoList_SFN2 = -1;  /* PUSCH_SysInfoList_SFN_HCR_r5 */
static int hf_umts_rrc_ies_pdsch_SysInfoList_SFN2 = -1;  /* PDSCH_SysInfoList_SFN_HCR_r5 */
static int hf_umts_rrc_ies_frequencyBandIndicator2 = -1;  /* RadioFrequencyBandFDD2 */
static int hf_umts_rrc_ies_sccpch_SystemInformation_MBMS = -1;  /* T_sccpch_SystemInformation_MBMS */
static int hf_umts_rrc_ies_sccpch_CommonForMBMSAndNonMBMS = -1;  /* SCCPCH_SystemInformationList_MBMS_r6_ext */
static int hf_umts_rrc_ies_sccpch_DedicatedForMBMS = -1;  /* SCCPCH_SystemInformation_MBMS_r6 */
static int hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_List = -1;  /* AdditionalPRACH_TF_and_TFCS_CCCH_List */
static int hf_umts_rrc_ies_modeSpecificInfo81 = -1;  /* T_modeSpecificInfo81 */
static int hf_umts_rrc_ies_fdd93 = -1;            /* T_fdd88 */
static int hf_umts_rrc_ies_dummy_CSICH_PowerOffset = -1;  /* CSICH_PowerOffset */
static int hf_umts_rrc_ies_tdd88 = -1;            /* T_tdd81 */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions3 = -1;  /* T_v4b0NonCriticalExtensions3 */
static int hf_umts_rrc_ies_sysInfoType6_v4b0ext = -1;  /* SysInfoType6_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtensions1 = -1;  /* T_v590NonCriticalExtensions1 */
static int hf_umts_rrc_ies_sysInfoType6_v590ext = -1;  /* SysInfoType6_v590ext_IEs */
static int hf_umts_rrc_ies_v650nonCriticalExtensions = -1;  /* T_v650nonCriticalExtensions */
static int hf_umts_rrc_ies_sysInfoType6_v650ext = -1;  /* SysInfoType6_v650ext_IEs */
static int hf_umts_rrc_ies_v6xynonCriticalExtensions = -1;  /* T_v6xynonCriticalExtensions */
static int hf_umts_rrc_ies_sysInfoType6_v6xyext = -1;  /* SysInfoType6_v6xyext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions7 = -1;  /* T_nonCriticalExtensions7 */
static int hf_umts_rrc_ies_tdd128SpecificInfo1 = -1;  /* T_tdd128SpecificInfo1 */
static int hf_umts_rrc_ies_hcr_r5_SpecificInfo1 = -1;  /* T_hcr_r5_SpecificInfo1 */
static int hf_umts_rrc_ies_modeSpecificInfo82 = -1;  /* T_modeSpecificInfo82 */
static int hf_umts_rrc_ies_fdd94 = -1;            /* T_fdd89 */
static int hf_umts_rrc_ies_ul_Interference = -1;  /* UL_Interference */
static int hf_umts_rrc_ies_prach_Information_SIB5_List = -1;  /* DynamicPersistenceLevelList */
static int hf_umts_rrc_ies_prach_Information_SIB6_List = -1;  /* DynamicPersistenceLevelList */
static int hf_umts_rrc_ies_expirationTimeFactor = -1;  /* ExpirationTimeFactor */
static int hf_umts_rrc_ies_nonCriticalExtensions8 = -1;  /* T_nonCriticalExtensions8 */
static int hf_umts_rrc_ies_dummy1_CPCH_Parameters = -1;  /* CPCH_Parameters */
static int hf_umts_rrc_ies_dummy2_CPCH_SetInfoList = -1;  /* CPCH_SetInfoList */
static int hf_umts_rrc_ies_dummy3_CSICH_PowerOffset = -1;  /* CSICH_PowerOffset */
static int hf_umts_rrc_ies_nonCriticalExtensions9 = -1;  /* T_nonCriticalExtensions9 */
static int hf_umts_rrc_ies_dummy_CPCH_PersistenceLevelsList = -1;  /* CPCH_PersistenceLevelsList */
static int hf_umts_rrc_ies_nonCriticalExtensions10 = -1;  /* T_nonCriticalExtensions10 */
static int hf_umts_rrc_ies_dummy_DRAC_SysInfoList = -1;  /* DRAC_SysInfoList */
static int hf_umts_rrc_ies_nonCriticalExtensions11 = -1;  /* T_nonCriticalExtensions11 */
static int hf_umts_rrc_ies_sib12indicator = -1;   /* BOOLEAN */
static int hf_umts_rrc_ies_fach_MeasurementOccasionInfo = -1;  /* FACH_MeasurementOccasionInfo */
static int hf_umts_rrc_ies_measurementControlSysInfo = -1;  /* MeasurementControlSysInfo */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions4 = -1;  /* T_v4b0NonCriticalExtensions4 */
static int hf_umts_rrc_ies_sysInfoType11_v4b0ext = -1;  /* SysInfoType11_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtension2 = -1;  /* T_v590NonCriticalExtension2 */
static int hf_umts_rrc_ies_sysInfoType11_v590ext = -1;  /* SysInfoType11_v590ext_IEs */
static int hf_umts_rrc_ies_v6xyNonCriticalExtensions2 = -1;  /* T_v6xyNonCriticalExtensions2 */
static int hf_umts_rrc_ies_sysInfoType11_v6xyext = -1;  /* SysInfoType11_v6xyext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions12 = -1;  /* T_nonCriticalExtensions12 */
static int hf_umts_rrc_ies_fach_MeasurementOccasionInfo_LCR_Ext = -1;  /* FACH_MeasurementOccasionInfo_LCR_r4_ext */
static int hf_umts_rrc_ies_measurementControlSysInfo_LCR = -1;  /* MeasurementControlSysInfo_LCR_r4_ext */
static int hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext = -1;  /* SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext_item = -1;  /* CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_newInterFrequencyCellInfoList_v590ext = -1;  /* SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_newInterFrequencyCellInfoList_v590ext_item = -1;  /* CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_newInterRATCellInfoList_v590ext = -1;  /* SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_newInterRATCellInfoList_v590ext_item = -1;  /* CellSelectReselectInfo_v590ext */
static int hf_umts_rrc_ies_intraFreqEventCriteriaList_v590ext = -1;  /* Intra_FreqEventCriteriaList_v590ext */
static int hf_umts_rrc_ies_intraFreqReportingCriteria_1b_r5 = -1;  /* IntraFreqReportingCriteria_1b_r5 */
static int hf_umts_rrc_ies_intraFreqEvent_1d_r5 = -1;  /* IntraFreqEvent_1d_r5 */
static int hf_umts_rrc_ies_interFreqRACHReportingInfo = -1;  /* InterFreqRACHReportingInfo */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions5 = -1;  /* T_v4b0NonCriticalExtensions5 */
static int hf_umts_rrc_ies_sysInfoType12_v4b0ext = -1;  /* SysInfoType12_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtension3 = -1;  /* T_v590NonCriticalExtension3 */
static int hf_umts_rrc_ies_sysInfoType12_v590ext = -1;  /* SysInfoType12_v590ext_IEs */
static int hf_umts_rrc_ies_v6xyNonCriticalExtensions3 = -1;  /* T_v6xyNonCriticalExtensions3 */
static int hf_umts_rrc_ies_sysInfoType12_v6xyext = -1;  /* SysInfoType12_v6xyext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions13 = -1;  /* T_nonCriticalExtensions13 */
static int hf_umts_rrc_ies_capabilityUpdateRequirement = -1;  /* CapabilityUpdateRequirement */
static int hf_umts_rrc_ies_v3a0NonCriticalExtensions1 = -1;  /* T_v3a0NonCriticalExtensions1 */
static int hf_umts_rrc_ies_sysInfoType13_v3a0ext = -1;  /* SysInfoType13_v3a0ext_IEs */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions6 = -1;  /* T_v4b0NonCriticalExtensions6 */
static int hf_umts_rrc_ies_sysInfoType13_v4b0ext = -1;  /* SysInfoType13_v4b0ext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions14 = -1;  /* T_nonCriticalExtensions14 */
static int hf_umts_rrc_ies_capabilityUpdateRequirement_r4Ext = -1;  /* CapabilityUpdateRequirement_r4_ext */
static int hf_umts_rrc_ies_ansi_41_RAND_Information = -1;  /* ANSI_41_RAND_Information */
static int hf_umts_rrc_ies_nonCriticalExtensions15 = -1;  /* T_nonCriticalExtensions15 */
static int hf_umts_rrc_ies_ansi_41_UserZoneID_Information = -1;  /* ANSI_41_UserZoneID_Information */
static int hf_umts_rrc_ies_nonCriticalExtensions16 = -1;  /* T_nonCriticalExtensions16 */
static int hf_umts_rrc_ies_ansi_41_PrivateNeighbourListInfo = -1;  /* ANSI_41_PrivateNeighbourListInfo */
static int hf_umts_rrc_ies_nonCriticalExtensions17 = -1;  /* T_nonCriticalExtensions17 */
static int hf_umts_rrc_ies_ansi_41_GlobalServiceRedirectInfo = -1;  /* ANSI_41_GlobalServiceRedirectInfo */
static int hf_umts_rrc_ies_nonCriticalExtensions18 = -1;  /* T_nonCriticalExtensions18 */
static int hf_umts_rrc_ies_nonCriticalExtensions19 = -1;  /* T_nonCriticalExtensions19 */
static int hf_umts_rrc_ies_ue_positioning_GPS_CipherParameters = -1;  /* UE_Positioning_CipherParameters */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions7 = -1;  /* T_v4b0NonCriticalExtensions7 */
static int hf_umts_rrc_ies_sysInfoType15_v4b0ext = -1;  /* SysInfoType15_v4b0ext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions20 = -1;  /* T_nonCriticalExtensions20 */
static int hf_umts_rrc_ies_up_Ipdl_Parameters_TDD = -1;  /* UE_Positioning_IPDL_Parameters_TDD_r4_ext */
static int hf_umts_rrc_ies_nonCriticalExtensions21 = -1;  /* T_nonCriticalExtensions21 */
static int hf_umts_rrc_ies_transmissionTOW = -1;  /* INTEGER_0_604799 */
static int hf_umts_rrc_ies_nonCriticalExtensions22 = -1;  /* T_nonCriticalExtensions22 */
static int hf_umts_rrc_ies_satMask = -1;          /* BIT_STRING_SIZE_1_32 */
static int hf_umts_rrc_ies_lsbTOW = -1;           /* BIT_STRING_SIZE_8 */
static int hf_umts_rrc_ies_nonCriticalExtensions23 = -1;  /* T_nonCriticalExtensions23 */
static int hf_umts_rrc_ies_ue_positioning_OTDOA_CipherParameters = -1;  /* UE_Positioning_CipherParameters */
static int hf_umts_rrc_ies_v3a0NonCriticalExtensions2 = -1;  /* T_v3a0NonCriticalExtensions2 */
static int hf_umts_rrc_ies_sysInfoType15_4_v3a0ext = -1;  /* SysInfoType15_4_v3a0ext */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions8 = -1;  /* T_v4b0NonCriticalExtensions8 */
static int hf_umts_rrc_ies_sysInfoType15_4_v4b0ext = -1;  /* SysInfoType15_4_v4b0ext */
static int hf_umts_rrc_ies_nonCriticalExtensions24 = -1;  /* T_nonCriticalExtensions24 */
static int hf_umts_rrc_ies_ue_Positioning_OTDOA_AssistanceData_r4ext = -1;  /* UE_Positioning_OTDOA_AssistanceData_r4ext */
static int hf_umts_rrc_ies_v3a0NonCriticalExtensions3 = -1;  /* T_v3a0NonCriticalExtensions3 */
static int hf_umts_rrc_ies_sysInfoType15_5_v3a0ext = -1;  /* SysInfoType15_5_v3a0ext */
static int hf_umts_rrc_ies_nonCriticalExtensions25 = -1;  /* T_nonCriticalExtensions25 */
static int hf_umts_rrc_ies_preDefinedRadioConfiguration = -1;  /* PreDefRadioConfiguration */
static int hf_umts_rrc_ies_nonCriticalExtensions26 = -1;  /* T_nonCriticalExtensions26 */
static int hf_umts_rrc_ies_pusch_SysInfoList = -1;  /* PUSCH_SysInfoList */
static int hf_umts_rrc_ies_pdsch_SysInfoList = -1;  /* PDSCH_SysInfoList */
static int hf_umts_rrc_ies_v4b0NonCriticalExtensions9 = -1;  /* T_v4b0NonCriticalExtensions9 */
static int hf_umts_rrc_ies_sysInfoType17_v4b0ext = -1;  /* SysInfoType17_v4b0ext_IEs */
static int hf_umts_rrc_ies_v590NonCriticalExtensions2 = -1;  /* T_v590NonCriticalExtensions2 */
static int hf_umts_rrc_ies_sysInfoType17_v590ext = -1;  /* SysInfoType17_v590ext_IEs */
static int hf_umts_rrc_ies_nonCriticalExtensions27 = -1;  /* T_nonCriticalExtensions27 */
static int hf_umts_rrc_ies_tdd128SpecificInfo2 = -1;  /* T_tdd128SpecificInfo2 */
static int hf_umts_rrc_ies_pusch_SysInfoList1 = -1;  /* PUSCH_SysInfoList_LCR_r4 */
static int hf_umts_rrc_ies_pdsch_SysInfoList1 = -1;  /* PDSCH_SysInfoList_LCR_r4 */
static int hf_umts_rrc_ies_hcr_r5_SpecificInfo2 = -1;  /* T_hcr_r5_SpecificInfo2 */
static int hf_umts_rrc_ies_pusch_SysInfoList2 = -1;  /* PUSCH_SysInfoList_HCR_r5 */
static int hf_umts_rrc_ies_pdsch_SysInfoList2 = -1;  /* PDSCH_SysInfoList_HCR_r5 */
static int hf_umts_rrc_ies_idleModePLMNIdentities = -1;  /* PLMNIdentitiesOfNeighbourCells */
static int hf_umts_rrc_ies_connectedModePLMNIdentities = -1;  /* PLMNIdentitiesOfNeighbourCells */
static int hf_umts_rrc_ies_nonCriticalExtensions28 = -1;  /* T_nonCriticalExtensions28 */
static int hf_umts_rrc_ies_sib_ReferenceList = -1;  /* SIB_ReferenceList */
static int hf_umts_rrc_ies_nonCriticalExtensions29 = -1;  /* T_nonCriticalExtensions29 */
static int hf_umts_rrc_ies_nonCriticalExtensions30 = -1;  /* T_nonCriticalExtensions30 */
static int hf_umts_rrc_ies_TDD_UMTS_Frequency_List_item = -1;  /* FrequencyInfoTDD */
static int hf_umts_rrc_ies_commonRBIdentity = -1;  /* MBMS_CommonRBIdentity */
static int hf_umts_rrc_ies_rlc_Info3 = -1;        /* RLC_Info_MBMS_r6 */
static int hf_umts_rrc_ies_MBMS_CommonRBInformationList_r6_item = -1;  /* MBMS_CommonRBInformation_r6 */
static int hf_umts_rrc_ies_countingForUraPCH = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_countingForCellPCH = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_countingForCellFACH = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_sccpchIdentity = -1;   /* MBMS_SCCPCHIdentity */
static int hf_umts_rrc_ies_secondaryCCPCH_Info2 = -1;  /* MBMS_CommonPhyChIdentity */
static int hf_umts_rrc_ies_softComb_TimingOffset = -1;  /* MBMS_SoftComb_TimingOffset */
static int hf_umts_rrc_ies_transpCh_InfoCommonForAllTrCh = -1;  /* MBMS_CommonCCTrChIdentity */
static int hf_umts_rrc_ies_transpCHInformation = -1;  /* MBMS_TrCHInformation_CommList */
static int hf_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6_item = -1;  /* MBMS_CurrentCell_SCCPCH_r6 */
static int hf_umts_rrc_ies_MBMS_FACHCarryingMTCH_List_item = -1;  /* TransportFormatSet */
static int hf_umts_rrc_ies_cycleOffset = -1;      /* INTEGER_0_7 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList = -1;  /* T_mtch_L1CombiningPeriodList */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item = -1;  /* T_mtch_L1CombiningPeriodList_item */
static int hf_umts_rrc_ies_periodStart = -1;      /* INTEGER_0_7 */
static int hf_umts_rrc_ies_periodDuration = -1;   /* INTEGER_1_8 */
static int hf_umts_rrc_ies_cycleOffset1 = -1;     /* INTEGER_0_15 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList1 = -1;  /* T_mtch_L1CombiningPeriodList1 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item1 = -1;  /* T_mtch_L1CombiningPeriodList_item1 */
static int hf_umts_rrc_ies_periodStart1 = -1;     /* INTEGER_0_15 */
static int hf_umts_rrc_ies_periodDuration1 = -1;  /* INTEGER_1_16 */
static int hf_umts_rrc_ies_cycleOffset2 = -1;     /* INTEGER_0_31 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList2 = -1;  /* T_mtch_L1CombiningPeriodList2 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item2 = -1;  /* T_mtch_L1CombiningPeriodList_item2 */
static int hf_umts_rrc_ies_periodStart2 = -1;     /* INTEGER_0_31 */
static int hf_umts_rrc_ies_periodDuration2 = -1;  /* INTEGER_1_32 */
static int hf_umts_rrc_ies_cycleOffset3 = -1;     /* INTEGER_0_63 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList3 = -1;  /* T_mtch_L1CombiningPeriodList3 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item3 = -1;  /* T_mtch_L1CombiningPeriodList_item3 */
static int hf_umts_rrc_ies_periodStart3 = -1;     /* INTEGER_0_63 */
static int hf_umts_rrc_ies_periodDuration3 = -1;  /* INTEGER_1_64 */
static int hf_umts_rrc_ies_cycleOffset4 = -1;     /* INTEGER_0_127 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList4 = -1;  /* T_mtch_L1CombiningPeriodList4 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item4 = -1;  /* T_mtch_L1CombiningPeriodList_item4 */
static int hf_umts_rrc_ies_periodStart4 = -1;     /* INTEGER_0_127 */
static int hf_umts_rrc_ies_periodDuration4 = -1;  /* INTEGER_1_128 */
static int hf_umts_rrc_ies_cycleOffset5 = -1;     /* INTEGER_0_255 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList5 = -1;  /* T_mtch_L1CombiningPeriodList5 */
static int hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item5 = -1;  /* T_mtch_L1CombiningPeriodList_item5 */
static int hf_umts_rrc_ies_periodStart5 = -1;     /* INTEGER_0_255 */
static int hf_umts_rrc_ies_periodDuration5 = -1;  /* INTEGER_1_256 */
static int hf_umts_rrc_ies_cycleLength_32 = -1;   /* MBMS_L1CombiningSchedule_32 */
static int hf_umts_rrc_ies_cycleLength_64 = -1;   /* MBMS_L1CombiningSchedule_64 */
static int hf_umts_rrc_ies_cycleLength_128 = -1;  /* MBMS_L1CombiningSchedule_128 */
static int hf_umts_rrc_ies_cycleLength_256 = -1;  /* MBMS_L1CombiningSchedule_256 */
static int hf_umts_rrc_ies_cycleLength_512 = -1;  /* MBMS_L1CombiningSchedule_512 */
static int hf_umts_rrc_ies_cycleLength_1024 = -1;  /* MBMS_L1CombiningSchedule_1024 */
static int hf_umts_rrc_ies_sameAsCurrent = -1;    /* T_sameAsCurrent */
static int hf_umts_rrc_ies_currentCell_SCCPCH = -1;  /* MBMS_SCCPCHIdentity */
static int hf_umts_rrc_ies_different = -1;        /* T_different */
static int hf_umts_rrc_ies_transpCHInformation1 = -1;  /* MBMS_TrCHInformation_NeighbList */
static int hf_umts_rrc_ies_accessInfoPeriodCoefficient = -1;  /* INTEGER_0_3 */
static int hf_umts_rrc_ies_repetitionPeriodCoefficient = -1;  /* INTEGER_0_3 */
static int hf_umts_rrc_ies_modificationPeriodCoefficient = -1;  /* INTEGER_7_10 */
static int hf_umts_rrc_ies_tctf_Presence = -1;    /* MBMS_TCTF_Presence */
static int hf_umts_rrc_ies_michPowerOffset = -1;  /* MBMS_MICHPowerOffset */
static int hf_umts_rrc_ies_mode = -1;             /* T_mode */
static int hf_umts_rrc_ies_fdd95 = -1;            /* T_fdd90 */
static int hf_umts_rrc_ies_ni_CountPerFrame = -1;  /* MBMS_NI_CountPerFrame */
static int hf_umts_rrc_ies_tdd38419 = -1;         /* T_tdd38415 */
static int hf_umts_rrc_ies_repetitionPeriodLengthOffset1 = -1;  /* RepPerLengthOffset_MICH */
static int hf_umts_rrc_ies_mbmsNotificationIndLength = -1;  /* MBMS_MICHNotificationIndLength */
static int hf_umts_rrc_ies_tdd12821 = -1;         /* T_tdd12817 */
static int hf_umts_rrc_ies_channelisationCodeList1 = -1;  /* SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_channelisationCodeList_item = -1;  /* DL_TS_ChannelisationCode */
static int hf_umts_rrc_ies_mbms_TransmissionIdentity = -1;  /* MBMS_TransmissionIdentity */
static int hf_umts_rrc_ies_mbms_RequiredUEAction = -1;  /* MBMS_RequiredUEAction_Mod */
static int hf_umts_rrc_ies_mbms_PreferredFrequency = -1;  /* T_mbms_PreferredFrequency */
static int hf_umts_rrc_ies_mcch = -1;             /* MBMS_PFLIndex */
static int hf_umts_rrc_ies_dcch = -1;             /* MBMS_PFLInfo */
static int hf_umts_rrc_ies_mbms_DispersionIndicator = -1;  /* T_mbms_DispersionIndicator */
static int hf_umts_rrc_ies_continueMCCHReading = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_MBMS_ModifedServiceList_r6_item = -1;  /* MBMS_ModifedService_r6 */
static int hf_umts_rrc_ies_mschShedulingInfo = -1;  /* MBMS_MSCHSchedulingInfo */
static int hf_umts_rrc_ies_schedulingPeriod_32_Offset = -1;  /* INTEGER_0_31 */
static int hf_umts_rrc_ies_schedulingPeriod_64_Offset = -1;  /* INTEGER_0_63 */
static int hf_umts_rrc_ies_schedulingPeriod_128_Offset = -1;  /* INTEGER_0_127 */
static int hf_umts_rrc_ies_schedulingPeriod_256_Offset = -1;  /* INTEGER_0_255 */
static int hf_umts_rrc_ies_schedulingPeriod_512_Offset = -1;  /* INTEGER_0_511 */
static int hf_umts_rrc_ies_schedulingPeriod_1024_Offset = -1;  /* INTEGER_0_1023 */
static int hf_umts_rrc_ies_secondaryCCPCHPwrOffsetDiff = -1;  /* MBMS_SCCPCHPwrOffsetDiff */
static int hf_umts_rrc_ies_layer1Combining = -1;  /* T_layer1Combining */
static int hf_umts_rrc_ies_fdd96 = -1;            /* T_fdd91 */
static int hf_umts_rrc_ies_mbms_L1CombiningTransmTimeDiff = -1;  /* MBMS_L1CombiningTransmTimeDiff */
static int hf_umts_rrc_ies_mbms_L1CombiningSchedule = -1;  /* MBMS_L1CombiningSchedule */
static int hf_umts_rrc_ies_mbms_L23Configuration = -1;  /* MBMS_L23Configuration */
static int hf_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6_item = -1;  /* MBMS_NeighbouringCellSCCPCH_r6 */
static int hf_umts_rrc_ies_mbms_CommonPhyChIdentity = -1;  /* MBMS_CommonPhyChIdentity */
static int hf_umts_rrc_ies_MBMS_PhyChInformationList_r6_item = -1;  /* MBMS_PhyChInformation_r6 */
static int hf_umts_rrc_ies_preferredFreqRequest = -1;  /* FrequencyInfo */
static int hf_umts_rrc_ies_mbmsPreferredFrequency = -1;  /* INTEGER_1_maxMBMSFreq */
static int hf_umts_rrc_ies_layerConvergenceInformation = -1;  /* T_layerConvergenceInformation */
static int hf_umts_rrc_ies_mbms_Qoffset = -1;     /* INTEGER_0_7 */
static int hf_umts_rrc_ies_mbms_HCSoffset = -1;   /* INTEGER_0_7 */
static int hf_umts_rrc_ies_mbms_PL_ServiceRestrictInfo = -1;  /* MBMS_PL_ServiceRestrictInfo_r6 */
static int hf_umts_rrc_ies_MBMS_PreferredFrequencyList_r6_item = -1;  /* MBMS_PreferredFrequencyInfo_r6 */
static int hf_umts_rrc_ies_rbInformation = -1;    /* MBMS_CommonRBIdentity */
static int hf_umts_rrc_ies_shortTransmissionID = -1;  /* MBMS_ShortTransmissionID */
static int hf_umts_rrc_ies_logicalChIdentity = -1;  /* MBMS_LogicalChIdentity */
static int hf_umts_rrc_ies_MBMS_PTM_RBInformation_CList_item = -1;  /* MBMS_PTM_RBInformation_C */
static int hf_umts_rrc_ies_layer1_CombiningStatus = -1;  /* T_layer1_CombiningStatus */
static int hf_umts_rrc_ies_MBMS_PTM_RBInformation_NList_item = -1;  /* MBMS_PTM_RBInformation_N */
static int hf_umts_rrc_ies_MBMS_PTM_RBInformation_SList_item = -1;  /* MBMS_PTM_RBInformation_S */
static int hf_umts_rrc_ies_accessprobabilityFactor_Idle = -1;  /* MBMS_AccessProbabilityFactor */
static int hf_umts_rrc_ies_accessprobabilityFactor_UraPCH = -1;  /* MBMS_AccessProbabilityFactor */
static int hf_umts_rrc_ies_mbms_ConnectedModeCountingScope = -1;  /* MBMS_ConnectedModeCountingScope */
static int hf_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6_item = -1;  /* MBMS_ServiceAccessInfo_r6 */
static int hf_umts_rrc_ies_serviceIdentity = -1;  /* OCTET_STRING_SIZE_3 */
static int hf_umts_rrc_ies_plmn_Identity1 = -1;   /* T_plmn_Identity */
static int hf_umts_rrc_ies_sameAsMIB_PLMN_Id = -1;  /* NULL */
static int hf_umts_rrc_ies_other1 = -1;           /* T_other1 */
static int hf_umts_rrc_ies_sameAsMIB_MultiPLMN_Id = -1;  /* INTEGER_1_5 */
static int hf_umts_rrc_ies_explicitPLMN_Id = -1;  /* PLMN_Identity */
static int hf_umts_rrc_ies_mbms_ServiceTransmInfoList = -1;  /* MBMS_ServiceTransmInfoList */
static int hf_umts_rrc_ies_nextSchedulingperiod = -1;  /* INTEGER_0_31 */
static int hf_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6_item = -1;  /* MBMS_ServiceSchedulingInfo_r6 */
static int hf_umts_rrc_ies_start = -1;            /* INTEGER_0_255 */
static int hf_umts_rrc_ies_duration = -1;         /* INTEGER_1_256 */
static int hf_umts_rrc_ies_MBMS_ServiceTransmInfoList_item = -1;  /* MBMS_ServiceTransmInfo */
static int hf_umts_rrc_ies_transpCHInformation2 = -1;  /* MBMS_TrCHInformation_SIB5List */
static int hf_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6_item = -1;  /* MBMS_SIBType5_SCCPCH_r6 */
static int hf_umts_rrc_ies_t_318 = -1;            /* T_318 */
static int hf_umts_rrc_ies_mbms_ServiceIdentity = -1;  /* MBMS_ServiceIdentity */
static int hf_umts_rrc_ies_commonCCTrChIdentity = -1;  /* MBMS_CommonCCTrChIdentity */
static int hf_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6_item = -1;  /* MBMS_TranspChInfoForCCTrCh_r6 */
static int hf_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6_item = -1;  /* MBMS_TranspChInfoForTrCh_r6 */
static int hf_umts_rrc_ies_commonTrChIdentity = -1;  /* MBMS_CommonTrChIdentity */
static int hf_umts_rrc_ies_transpCh_Info = -1;    /* MBMS_CommonTrChIdentity */
static int hf_umts_rrc_ies_rbInformation1 = -1;   /* MBMS_PTM_RBInformation_CList */
static int hf_umts_rrc_ies_MBMS_TrCHInformation_CommList_item = -1;  /* MBMS_TrCHInformation_Comm */
static int hf_umts_rrc_ies_transpCh_CombiningStatus = -1;  /* BOOLEAN */
static int hf_umts_rrc_ies_rbInformation2 = -1;   /* MBMS_PTM_RBInformation_NList */
static int hf_umts_rrc_ies_MBMS_TrCHInformation_NeighbList_item = -1;  /* MBMS_TrCHInformation_Neighb */
static int hf_umts_rrc_ies_transpCh_Identity = -1;  /* INTEGER_1_maxFACHPCH */
static int hf_umts_rrc_ies_rbInformation3 = -1;   /* MBMS_PTM_RBInformation_SList */
static int hf_umts_rrc_ies_MBMS_TrCHInformation_SIB5List_item = -1;  /* MBMS_TrCHInformation_SIB5 */
static int hf_umts_rrc_ies_mbms_RequiredUEAction1 = -1;  /* MBMS_RequiredUEAction_UMod */
static int hf_umts_rrc_ies_mbms_PreferredFrequency1 = -1;  /* MBMS_PFLIndex */
static int hf_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6_item = -1;  /* MBMS_UnmodifiedService_r6 */
/* named bits */
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare15 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare14 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare13 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare12 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare11 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare10 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare9 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare8 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare7 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare6 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare5 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare4 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare3 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare2 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_uea1 = -1;
static int hf_umts_rrc_ies_T_cipheringAlgorithmCap_uea0 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare15 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare14 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare13 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare12 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare11 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare10 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare9 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare8 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare7 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare6 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare5 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare4 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare3 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare2 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_uia1 = -1;
static int hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare0 = -1;
static int hf_umts_rrc_ies_T_assignedSubChannelNumber_b3 = -1;
static int hf_umts_rrc_ies_T_assignedSubChannelNumber_b2 = -1;
static int hf_umts_rrc_ies_T_assignedSubChannelNumber_b1 = -1;
static int hf_umts_rrc_ies_T_assignedSubChannelNumber_b0 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex7 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex6 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex5 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex4 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex3 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex2 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex1 = -1;
static int hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex0 = -1;
static int hf_umts_rrc_ies_T_subchannels1_subCh3 = -1;
static int hf_umts_rrc_ies_T_subchannels1_subCh2 = -1;
static int hf_umts_rrc_ies_T_subchannels1_subCh1 = -1;
static int hf_umts_rrc_ies_T_subchannels1_subCh0 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh7 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh6 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh5 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh4 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh3 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh2 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh1 = -1;
static int hf_umts_rrc_ies_T_subchannels2_subCh0 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex7 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex6 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex5 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex4 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex3 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex2 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex1 = -1;
static int hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex0 = -1;
static int hf_umts_rrc_ies_T_subchannels4_subCh3 = -1;
static int hf_umts_rrc_ies_T_subchannels4_subCh2 = -1;
static int hf_umts_rrc_ies_T_subchannels4_subCh1 = -1;
static int hf_umts_rrc_ies_T_subchannels4_subCh0 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh7 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh6 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh5 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh4 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh3 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh2 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh1 = -1;
static int hf_umts_rrc_ies_T_subchannels5_subCh0 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature15 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature14 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature13 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature12 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature11 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature10 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature9 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature8 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature7 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature6 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature5 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature4 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature3 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature2 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature1 = -1;
static int hf_umts_rrc_ies_AvailableSignatures_signature0 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh11 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh10 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh9 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh8 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh7 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh6 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh5 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh4 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh3 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh2 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh1 = -1;
static int hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh0 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode16_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode15_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode14_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode13_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode12_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode11_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode10_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode9_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode8_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode7_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode6_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode5_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode4_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode3_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode2_SF16 = -1;
static int hf_umts_rrc_ies_T_bitmap_chCode1_SF16 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code7 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code6 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code5 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code4 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code3 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code2 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code1 = -1;
static int hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code0 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code7 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code6 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code5 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code4 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code3 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code2 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code1 = -1;
static int hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code0 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_7 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_6 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_5 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_4 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_3 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_2 = -1;
static int hf_umts_rrc_ies_GsmSecurityCapability_a5_1 = -1;
static int hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea0 = -1;
static int hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea1 = -1;
static int hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea2 = -1;

/*--- End of included file: packet-umts_rrc_ies-hf.c ---*/
#line 59 "packet-umts_rrc_ies-template.c"

/* Initialize the subtree pointers */
static int ett_umts_rrc_ies = -1;


/*--- Included file: packet-umts_rrc_ies-ett.c ---*/
#line 1 "packet-umts_rrc_ies-ett.c"
static gint ett_umts_rrc_ies_CN_DomainInformation = -1;
static gint ett_umts_rrc_ies_CN_DomainInformationFull = -1;
static gint ett_umts_rrc_ies_CN_DomainInformationList = -1;
static gint ett_umts_rrc_ies_CN_DomainInformationListFull = -1;
static gint ett_umts_rrc_ies_CN_DomainSysInfo = -1;
static gint ett_umts_rrc_ies_T_cn_Type = -1;
static gint ett_umts_rrc_ies_CN_DomainSysInfoList = -1;
static gint ett_umts_rrc_ies_CN_InformationInfo = -1;
static gint ett_umts_rrc_ies_CN_InformationInfo_r6 = -1;
static gint ett_umts_rrc_ies_CN_InformationInfoFull = -1;
static gint ett_umts_rrc_ies_Gsm_map_IDNNS = -1;
static gint ett_umts_rrc_ies_T_routingbasis = -1;
static gint ett_umts_rrc_ies_T_localPTMSI = -1;
static gint ett_umts_rrc_ies_T_tMSIofsamePLMN = -1;
static gint ett_umts_rrc_ies_T_tMSIofdifferentPLMN = -1;
static gint ett_umts_rrc_ies_T_iMSIresponsetopaging = -1;
static gint ett_umts_rrc_ies_T_iMSIcauseUEinitiatedEvent = -1;
static gint ett_umts_rrc_ies_T_iMEI = -1;
static gint ett_umts_rrc_ies_T_spare2 = -1;
static gint ett_umts_rrc_ies_T_spare1 = -1;
static gint ett_umts_rrc_ies_IMEI = -1;
static gint ett_umts_rrc_ies_IMSI_GSM_MAP = -1;
static gint ett_umts_rrc_ies_IntraDomainNasNodeSelector = -1;
static gint ett_umts_rrc_ies_T_version = -1;
static gint ett_umts_rrc_ies_T_release99 = -1;
static gint ett_umts_rrc_ies_T_cn_Type1 = -1;
static gint ett_umts_rrc_ies_T_later = -1;
static gint ett_umts_rrc_ies_LAI = -1;
static gint ett_umts_rrc_ies_MCC = -1;
static gint ett_umts_rrc_ies_MNC = -1;
static gint ett_umts_rrc_ies_MultiplePLMN_List_r6 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6 = -1;
static gint ett_umts_rrc_ies_PLMN_Identity = -1;
static gint ett_umts_rrc_ies_PLMN_IdentityWithOptionalMCC_r6 = -1;
static gint ett_umts_rrc_ies_PLMN_Type = -1;
static gint ett_umts_rrc_ies_T_gsm_MAP = -1;
static gint ett_umts_rrc_ies_T_ansi_41 = -1;
static gint ett_umts_rrc_ies_T_gsm_MAP_and_ANSI_41 = -1;
static gint ett_umts_rrc_ies_RAB_Identity = -1;
static gint ett_umts_rrc_ies_RAI = -1;
static gint ett_umts_rrc_ies_AccessClassBarredList = -1;
static gint ett_umts_rrc_ies_CellAccessRestriction = -1;
static gint ett_umts_rrc_ies_CellBarred = -1;
static gint ett_umts_rrc_ies_T_barred = -1;
static gint ett_umts_rrc_ies_CellIdentity_PerRL_List = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoSIB_3_4 = -1;
static gint ett_umts_rrc_ies_T_cellSelectQualityMeasure = -1;
static gint ett_umts_rrc_ies_T_cpich_Ec_N0 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo = -1;
static gint ett_umts_rrc_ies_T_fdd = -1;
static gint ett_umts_rrc_ies_T_tdd = -1;
static gint ett_umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext = -1;
static gint ett_umts_rrc_ies_DomainSpecificAccessRestrictionList_v670ext = -1;
static gint ett_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext = -1;
static gint ett_umts_rrc_ies_DomainSpecificAccessRestriction_v670ext = -1;
static gint ett_umts_rrc_ies_T_restriction = -1;
static gint ett_umts_rrc_ies_Mapping = -1;
static gint ett_umts_rrc_ies_Mapping_LCR_r4 = -1;
static gint ett_umts_rrc_ies_MappingFunctionParameter = -1;
static gint ett_umts_rrc_ies_MappingFunctionParameterList = -1;
static gint ett_umts_rrc_ies_MappingInfo = -1;
static gint ett_umts_rrc_ies_RAT_FDD_Info = -1;
static gint ett_umts_rrc_ies_RAT_FDD_InfoList = -1;
static gint ett_umts_rrc_ies_RAT_TDD_Info = -1;
static gint ett_umts_rrc_ies_RAT_TDD_InfoList = -1;
static gint ett_umts_rrc_ies_URA_IdentityList = -1;
static gint ett_umts_rrc_ies_BackoffControlParams = -1;
static gint ett_umts_rrc_ies_CapabilityUpdateRequirement = -1;
static gint ett_umts_rrc_ies_CapabilityUpdateRequirement_r4_ext = -1;
static gint ett_umts_rrc_ies_CapabilityUpdateRequirement_r4 = -1;
static gint ett_umts_rrc_ies_CipheringModeCommand = -1;
static gint ett_umts_rrc_ies_CipheringModeInfo = -1;
static gint ett_umts_rrc_ies_CN_PagedUE_Identity = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapability = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapability_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabFDDList = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabFDDList2 = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabFDD = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabFDD2 = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabFDD_ext = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabTDDList = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabTDD = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabGSMList = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabGSM = -1;
static gint ett_umts_rrc_ies_CompressedModeMeasCapabMC = -1;
static gint ett_umts_rrc_ies_CPCH_Parameters = -1;
static gint ett_umts_rrc_ies_DL_PhysChCapabilityFDD = -1;
static gint ett_umts_rrc_ies_DL_PhysChCapabilityFDD_v380ext = -1;
static gint ett_umts_rrc_ies_DL_PhysChCapabilityTDD = -1;
static gint ett_umts_rrc_ies_DL_PhysChCapabilityTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_DL_TransChCapability = -1;
static gint ett_umts_rrc_ies_DRAC_SysInfo = -1;
static gint ett_umts_rrc_ies_DRAC_SysInfoList = -1;
static gint ett_umts_rrc_ies_FailureCauseWithProtErr = -1;
static gint ett_umts_rrc_ies_FailureCauseWithProtErrTrId = -1;
static gint ett_umts_rrc_ies_GroupIdentityWithReleaseInformation = -1;
static gint ett_umts_rrc_ies_GroupReleaseInformation = -1;
static gint ett_umts_rrc_ies_GSM_Measurements = -1;
static gint ett_umts_rrc_ies_IMSI_and_ESN_DS_41 = -1;
static gint ett_umts_rrc_ies_InitialPriorityDelayList = -1;
static gint ett_umts_rrc_ies_InitialUE_Identity = -1;
static gint ett_umts_rrc_ies_IntegrityCheckInfo = -1;
static gint ett_umts_rrc_ies_IntegrityProtActivationInfo = -1;
static gint ett_umts_rrc_ies_IntegrityProtectionModeCommand = -1;
static gint ett_umts_rrc_ies_T_startIntegrityProtection = -1;
static gint ett_umts_rrc_ies_T_modify = -1;
static gint ett_umts_rrc_ies_IntegrityProtectionModeInfo = -1;
static gint ett_umts_rrc_ies_MeasurementCapability = -1;
static gint ett_umts_rrc_ies_MeasurementCapabilityExt = -1;
static gint ett_umts_rrc_ies_MeasurementCapabilityExt2 = -1;
static gint ett_umts_rrc_ies_MeasurementCapability_r4_ext = -1;
static gint ett_umts_rrc_ies_MultiRAT_Capability = -1;
static gint ett_umts_rrc_ies_MultiModeRAT_Capability_v590ext = -1;
static gint ett_umts_rrc_ies_P_TMSI_and_RAI_GSM_MAP = -1;
static gint ett_umts_rrc_ies_PagingRecord = -1;
static gint ett_umts_rrc_ies_T_cn_Identity = -1;
static gint ett_umts_rrc_ies_T_utran_Identity = -1;
static gint ett_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE = -1;
static gint ett_umts_rrc_ies_PagingRecord2_r5 = -1;
static gint ett_umts_rrc_ies_T_utran_SingleUE_Identity = -1;
static gint ett_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE1 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation = -1;
static gint ett_umts_rrc_ies_PagingRecordList = -1;
static gint ett_umts_rrc_ies_PagingRecord2List_r5 = -1;
static gint ett_umts_rrc_ies_PDCP_Capability = -1;
static gint ett_umts_rrc_ies_T_supportForRfc2507 = -1;
static gint ett_umts_rrc_ies_PDCP_Capability_r4_ext = -1;
static gint ett_umts_rrc_ies_T_supportForRfc3095 = -1;
static gint ett_umts_rrc_ies_T_supported = -1;
static gint ett_umts_rrc_ies_PDCP_Capability_r5_ext = -1;
static gint ett_umts_rrc_ies_PDCP_Capability_r5_ext2 = -1;
static gint ett_umts_rrc_ies_PhysicalChannelCapability = -1;
static gint ett_umts_rrc_ies_T_fddPhysChCapability = -1;
static gint ett_umts_rrc_ies_T_tddPhysChCapability = -1;
static gint ett_umts_rrc_ies_PhysicalChannelCapability_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_tdd128_PhysChCapability = -1;
static gint ett_umts_rrc_ies_PhysicalChannelCapability_hspdsch_r5 = -1;
static gint ett_umts_rrc_ies_T_fdd_hspdsch = -1;
static gint ett_umts_rrc_ies_T_supported1 = -1;
static gint ett_umts_rrc_ies_T_tdd384_hspdsch = -1;
static gint ett_umts_rrc_ies_T_tdd128_hspdsch = -1;
static gint ett_umts_rrc_ies_PNBSCH_Allocation_r4 = -1;
static gint ett_umts_rrc_ies_ProtocolErrorIndicatorWithMoreInfo = -1;
static gint ett_umts_rrc_ies_T_errorOccurred = -1;
static gint ett_umts_rrc_ies_ProtocolErrorMoreInformation = -1;
static gint ett_umts_rrc_ies_T_diagnosticsType = -1;
static gint ett_umts_rrc_ies_T_type1 = -1;
static gint ett_umts_rrc_ies_Rb_timer_indicator = -1;
static gint ett_umts_rrc_ies_RedirectionInfo = -1;
static gint ett_umts_rrc_ies_RedirectionInfo_r6 = -1;
static gint ett_umts_rrc_ies_RF_Capability = -1;
static gint ett_umts_rrc_ies_T_fddRF_Capability = -1;
static gint ett_umts_rrc_ies_T_tddRF_Capability = -1;
static gint ett_umts_rrc_ies_RF_Capability_r4_ext = -1;
static gint ett_umts_rrc_ies_T_tddRF_Capability1 = -1;
static gint ett_umts_rrc_ies_RLC_Capability = -1;
static gint ett_umts_rrc_ies_RLC_Capability_r5_ext = -1;
static gint ett_umts_rrc_ies_RRC_ConnectionReleaseInformation = -1;
static gint ett_umts_rrc_ies_T_release = -1;
static gint ett_umts_rrc_ies_RRC_MessageSequenceNumberList = -1;
static gint ett_umts_rrc_ies_SecurityCapability = -1;
static gint ett_umts_rrc_ies_T_cipheringAlgorithmCap = -1;
static gint ett_umts_rrc_ies_T_integrityProtectionAlgorithmCap = -1;
static gint ett_umts_rrc_ies_Serving_HSDSCH_CellInformation = -1;
static gint ett_umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception = -1;
static gint ett_umts_rrc_ies_T_supported2 = -1;
static gint ett_umts_rrc_ies_STARTList = -1;
static gint ett_umts_rrc_ies_STARTSingle = -1;
static gint ett_umts_rrc_ies_CapabilityUpdateRequirement_r5 = -1;
static gint ett_umts_rrc_ies_SystemSpecificCapUpdateReqList = -1;
static gint ett_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5 = -1;
static gint ett_umts_rrc_ies_TMSI_and_LAI_GSM_MAP = -1;
static gint ett_umts_rrc_ies_TransportChannelCapability = -1;
static gint ett_umts_rrc_ies_TurboSupport = -1;
static gint ett_umts_rrc_ies_U_RNTI = -1;
static gint ett_umts_rrc_ies_U_RNTI_Group = -1;
static gint ett_umts_rrc_ies_U_RNTI_Short = -1;
static gint ett_umts_rrc_ies_UE_CapabilityContainer_IEs = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_UE_ConnTimersAndConstants = -1;
static gint ett_umts_rrc_ies_UE_ConnTimersAndConstants_v3a0ext = -1;
static gint ett_umts_rrc_ies_UE_ConnTimersAndConstants_r5 = -1;
static gint ett_umts_rrc_ies_UE_IdleTimersAndConstants = -1;
static gint ett_umts_rrc_ies_UE_IdleTimersAndConstants_v3a0ext = -1;
static gint ett_umts_rrc_ies_UE_MultiModeRAT_Capability = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabilityInfo = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v370ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v380ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v3a0ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v3g0ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v650ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v6xyext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2 = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD2 = -1;
static gint ett_umts_rrc_ies_T_fddRF_Capability1 = -1;
static gint ett_umts_rrc_ies_UE_PositioningCapabilityExt_v380 = -1;
static gint ett_umts_rrc_ies_UE_PositioningCapabilityExt_v3a0 = -1;
static gint ett_umts_rrc_ies_UE_PositioningCapabilityExt_v3g0 = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD = -1;
static gint ett_umts_rrc_ies_T_fddRF_Capability2 = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD_ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v4b0ext = -1;
static gint ett_umts_rrc_ies_T_tdd_CapabilityExt = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapabilityComp = -1;
static gint ett_umts_rrc_ies_RF_CapabilityComp = -1;
static gint ett_umts_rrc_ies_T_fdd1 = -1;
static gint ett_umts_rrc_ies_T_tdd384_RF_Capability = -1;
static gint ett_umts_rrc_ies_T_tdd128_RF_Capability = -1;
static gint ett_umts_rrc_ies_RF_CapabBandListFDDComp = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v590ext = -1;
static gint ett_umts_rrc_ies_UE_RadioAccessCapability_v5c0ext = -1;
static gint ett_umts_rrc_ies_UL_PhysChCapabilityFDD = -1;
static gint ett_umts_rrc_ies_UL_PhysChCapabilityFDD_r6 = -1;
static gint ett_umts_rrc_ies_UL_PhysChCapabilityTDD = -1;
static gint ett_umts_rrc_ies_UL_PhysChCapabilityTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PhysicalChannelCapability_edch_r6 = -1;
static gint ett_umts_rrc_ies_T_fdd_edch = -1;
static gint ett_umts_rrc_ies_T_supported3 = -1;
static gint ett_umts_rrc_ies_UL_TransChCapability = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo1 = -1;
static gint ett_umts_rrc_ies_T_tdd1 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_Capability = -1;
static gint ett_umts_rrc_ies_UE_SecurityInformation = -1;
static gint ett_umts_rrc_ies_UE_SecurityInformation2 = -1;
static gint ett_umts_rrc_ies_AlgorithmSpecificInfo = -1;
static gint ett_umts_rrc_ies_AlgorithmSpecificInfo_r4 = -1;
static gint ett_umts_rrc_ies_DL_AM_RLC_Mode = -1;
static gint ett_umts_rrc_ies_DL_AM_RLC_Mode_r5 = -1;
static gint ett_umts_rrc_ies_DL_CounterSynchronisationInfo = -1;
static gint ett_umts_rrc_ies_DL_CounterSynchronisationInfo_r5 = -1;
static gint ett_umts_rrc_ies_DL_LogicalChannelMapping = -1;
static gint ett_umts_rrc_ies_DL_LogicalChannelMapping_r5 = -1;
static gint ett_umts_rrc_ies_DL_LogicalChannelMappingList = -1;
static gint ett_umts_rrc_ies_DL_LogicalChannelMappingList_r5 = -1;
static gint ett_umts_rrc_ies_DL_RFC3095_r4 = -1;
static gint ett_umts_rrc_ies_DL_RLC_Mode = -1;
static gint ett_umts_rrc_ies_DL_RLC_Mode_r5 = -1;
static gint ett_umts_rrc_ies_DL_RLC_Mode_r6 = -1;
static gint ett_umts_rrc_ies_DL_RLC_StatusInfo = -1;
static gint ett_umts_rrc_ies_DL_TM_RLC_Mode = -1;
static gint ett_umts_rrc_ies_DL_TransportChannelType = -1;
static gint ett_umts_rrc_ies_DL_TransportChannelType_r5 = -1;
static gint ett_umts_rrc_ies_DL_UM_RLC_Mode_r5 = -1;
static gint ett_umts_rrc_ies_DL_UM_RLC_Mode_r6 = -1;
static gint ett_umts_rrc_ies_ExplicitDiscard = -1;
static gint ett_umts_rrc_ies_HeaderCompressionInfo = -1;
static gint ett_umts_rrc_ies_HeaderCompressionInfoList = -1;
static gint ett_umts_rrc_ies_HeaderCompressionInfo_r4 = -1;
static gint ett_umts_rrc_ies_HeaderCompressionInfoList_r4 = -1;
static gint ett_umts_rrc_ies_LosslessSRNS_RelocSupport = -1;
static gint ett_umts_rrc_ies_MaxDAT_Retransmissions = -1;
static gint ett_umts_rrc_ies_PDCP_Info = -1;
static gint ett_umts_rrc_ies_PDCP_Info_r4 = -1;
static gint ett_umts_rrc_ies_PDCP_InfoReconfig = -1;
static gint ett_umts_rrc_ies_PDCP_InfoReconfig_r4 = -1;
static gint ett_umts_rrc_ies_PollingInfo = -1;
static gint ett_umts_rrc_ies_PredefinedRB_Configuration = -1;
static gint ett_umts_rrc_ies_PreDefRadioConfiguration = -1;
static gint ett_umts_rrc_ies_PredefinedConfigStatusList = -1;
static gint ett_umts_rrc_ies_PredefinedConfigStatusInfo = -1;
static gint ett_umts_rrc_ies_T_other = -1;
static gint ett_umts_rrc_ies_PredefinedConfigStatusListComp = -1;
static gint ett_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag = -1;
static gint ett_umts_rrc_ies_PredefinedConfigSetWithDifferentValueTag = -1;
static gint ett_umts_rrc_ies_PredefinedConfigValueTagList = -1;
static gint ett_umts_rrc_ies_PredefinedConfigStatusListVarSz = -1;
static gint ett_umts_rrc_ies_RAB_Info = -1;
static gint ett_umts_rrc_ies_RAB_Info_r6_ext = -1;
static gint ett_umts_rrc_ies_RAB_Info_r6 = -1;
static gint ett_umts_rrc_ies_RAB_InformationList = -1;
static gint ett_umts_rrc_ies_RAB_InformationList_r6 = -1;
static gint ett_umts_rrc_ies_RAB_InformationReconfigList = -1;
static gint ett_umts_rrc_ies_RAB_InformationReconfig = -1;
static gint ett_umts_rrc_ies_RAB_Info_Post = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetup = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetup_r4 = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetup_r5 = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetup_r6_ext = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetup_r6 = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetupList = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetupList_r4 = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetupList_r5 = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetupList_r6 = -1;
static gint ett_umts_rrc_ies_RAB_InformationSetupList_r6_ext = -1;
static gint ett_umts_rrc_ies_RB_ActivationTimeInfo = -1;
static gint ett_umts_rrc_ies_RB_ActivationTimeInfoList = -1;
static gint ett_umts_rrc_ies_RB_COUNT_C_Information = -1;
static gint ett_umts_rrc_ies_RB_COUNT_C_InformationList = -1;
static gint ett_umts_rrc_ies_RB_COUNT_C_MSB_Information = -1;
static gint ett_umts_rrc_ies_RB_COUNT_C_MSB_InformationList = -1;
static gint ett_umts_rrc_ies_RB_IdentityList = -1;
static gint ett_umts_rrc_ies_RB_InformationAffected = -1;
static gint ett_umts_rrc_ies_RB_InformationAffected_r5 = -1;
static gint ett_umts_rrc_ies_RB_InformationAffected_r6 = -1;
static gint ett_umts_rrc_ies_RB_InformationAffectedList = -1;
static gint ett_umts_rrc_ies_RB_InformationAffectedList_r5 = -1;
static gint ett_umts_rrc_ies_RB_InformationAffectedList_r6 = -1;
static gint ett_umts_rrc_ies_RB_InformationChanged_r6 = -1;
static gint ett_umts_rrc_ies_T_rb_Change = -1;
static gint ett_umts_rrc_ies_RB_InformationChangedList_r6 = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfig = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfig_r4 = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfig_r5 = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfig_r6 = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfigList = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfigList_r4 = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfigList_r5 = -1;
static gint ett_umts_rrc_ies_RB_InformationReconfigList_r6 = -1;
static gint ett_umts_rrc_ies_RB_InformationReleaseList = -1;
static gint ett_umts_rrc_ies_RB_InformationSetup = -1;
static gint ett_umts_rrc_ies_RB_InformationSetup_r4 = -1;
static gint ett_umts_rrc_ies_RB_InformationSetup_r5 = -1;
static gint ett_umts_rrc_ies_RB_InformationSetup_r6 = -1;
static gint ett_umts_rrc_ies_RB_InformationSetupList = -1;
static gint ett_umts_rrc_ies_RB_InformationSetupList_r4 = -1;
static gint ett_umts_rrc_ies_RB_InformationSetupList_r5 = -1;
static gint ett_umts_rrc_ies_RB_InformationSetupList_r6 = -1;
static gint ett_umts_rrc_ies_RB_MappingInfo = -1;
static gint ett_umts_rrc_ies_RB_MappingInfo_r5 = -1;
static gint ett_umts_rrc_ies_RB_MappingInfo_r6 = -1;
static gint ett_umts_rrc_ies_RB_MappingOption = -1;
static gint ett_umts_rrc_ies_RB_MappingOption_r5 = -1;
static gint ett_umts_rrc_ies_RB_MappingOption_r6 = -1;
static gint ett_umts_rrc_ies_RB_PDCPContextRelocation = -1;
static gint ett_umts_rrc_ies_RB_PDCPContextRelocationList = -1;
static gint ett_umts_rrc_ies_RB_WithPDCP_Info = -1;
static gint ett_umts_rrc_ies_RB_WithPDCP_InfoList = -1;
static gint ett_umts_rrc_ies_RFC2507_Info = -1;
static gint ett_umts_rrc_ies_RFC3095_Info_r4 = -1;
static gint ett_umts_rrc_ies_RLC_Info = -1;
static gint ett_umts_rrc_ies_RLC_Info_r5 = -1;
static gint ett_umts_rrc_ies_RLC_Info_r6 = -1;
static gint ett_umts_rrc_ies_RLC_Info_MBMS_r6 = -1;
static gint ett_umts_rrc_ies_RLC_InfoChoice = -1;
static gint ett_umts_rrc_ies_RLC_InfoChoice_r5 = -1;
static gint ett_umts_rrc_ies_RLC_InfoChoice_r6 = -1;
static gint ett_umts_rrc_ies_RLC_PDU_SizeList = -1;
static gint ett_umts_rrc_ies_RLC_SizeInfo = -1;
static gint ett_umts_rrc_ies_RLC_SizeExplicitList = -1;
static gint ett_umts_rrc_ies_ROHC_ProfileList_r4 = -1;
static gint ett_umts_rrc_ies_ROHC_PacketSizeList_r4 = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetup = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetup_r5 = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetup_r6 = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetupList = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetupList_r5 = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetupList_r6 = -1;
static gint ett_umts_rrc_ies_SRB_InformationSetupList2 = -1;
static gint ett_umts_rrc_ies_TransmissionRLC_Discard = -1;
static gint ett_umts_rrc_ies_UL_AM_RLC_Mode = -1;
static gint ett_umts_rrc_ies_UL_CounterSynchronisationInfo = -1;
static gint ett_umts_rrc_ies_UL_LogicalChannelMapping = -1;
static gint ett_umts_rrc_ies_T_rlc_SizeList = -1;
static gint ett_umts_rrc_ies_UL_LogicalChannelMapping_r6 = -1;
static gint ett_umts_rrc_ies_T_ul_TrCH_Type = -1;
static gint ett_umts_rrc_ies_T_dch_rach_cpch_usch = -1;
static gint ett_umts_rrc_ies_T_rlc_SizeList1 = -1;
static gint ett_umts_rrc_ies_T_e_dch = -1;
static gint ett_umts_rrc_ies_UL_LogicalChannelMappingList = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping = -1;
static gint ett_umts_rrc_ies_UL_LogicalChannelMappingList_r6 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6 = -1;
static gint ett_umts_rrc_ies_UL_LogicalChannelMappings = -1;
static gint ett_umts_rrc_ies_UL_LogicalChannelMappings_r6 = -1;
static gint ett_umts_rrc_ies_UL_RFC3095_r4 = -1;
static gint ett_umts_rrc_ies_UL_RLC_Mode = -1;
static gint ett_umts_rrc_ies_UL_TM_RLC_Mode = -1;
static gint ett_umts_rrc_ies_UL_UM_RLC_Mode = -1;
static gint ett_umts_rrc_ies_UL_TransportChannelType = -1;
static gint ett_umts_rrc_ies_UM_RLC_DuplAvoid_Reord_Info_r6 = -1;
static gint ett_umts_rrc_ies_UM_RLC_OutOSeqDelivery_Info_r6 = -1;
static gint ett_umts_rrc_ies_AddOrReconfMAC_dFlow = -1;
static gint ett_umts_rrc_ies_AllowedTFC_List = -1;
static gint ett_umts_rrc_ies_AllowedTFI_List = -1;
static gint ett_umts_rrc_ies_BitModeRLC_SizeInfo = -1;
static gint ett_umts_rrc_ies_T_sizeType2 = -1;
static gint ett_umts_rrc_ies_T_sizeType3 = -1;
static gint ett_umts_rrc_ies_T_sizeType4 = -1;
static gint ett_umts_rrc_ies_ChannelCodingType = -1;
static gint ett_umts_rrc_ies_CommonDynamicTF_Info = -1;
static gint ett_umts_rrc_ies_T_rlc_Size = -1;
static gint ett_umts_rrc_ies_T_fdd2 = -1;
static gint ett_umts_rrc_ies_T_tdd2 = -1;
static gint ett_umts_rrc_ies_T_commonTDD_Choice = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks = -1;
static gint ett_umts_rrc_ies_CommonDynamicTF_Info_DynamicTTI = -1;
static gint ett_umts_rrc_ies_T_commonTDD_Choice1 = -1;
static gint ett_umts_rrc_ies_CommonDynamicTF_InfoList = -1;
static gint ett_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI = -1;
static gint ett_umts_rrc_ies_CommonTransChTFS = -1;
static gint ett_umts_rrc_ies_T_tti = -1;
static gint ett_umts_rrc_ies_CommonTransChTFS_LCR = -1;
static gint ett_umts_rrc_ies_T_tti1 = -1;
static gint ett_umts_rrc_ies_DedicatedDynamicTF_Info = -1;
static gint ett_umts_rrc_ies_T_rlc_Size1 = -1;
static gint ett_umts_rrc_ies_DedicatedDynamicTF_Info_DynamicTTI = -1;
static gint ett_umts_rrc_ies_T_rlc_Size2 = -1;
static gint ett_umts_rrc_ies_DedicatedDynamicTF_InfoList = -1;
static gint ett_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI = -1;
static gint ett_umts_rrc_ies_DedicatedTransChTFS = -1;
static gint ett_umts_rrc_ies_T_tti2 = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInfo2List = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInfoList = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInfoList_r4 = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInfoList_r5 = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInformation = -1;
static gint ett_umts_rrc_ies_T_tfs_SignallingMode = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInformation_r4 = -1;
static gint ett_umts_rrc_ies_T_tfs_SignallingMode1 = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInformation_r5 = -1;
static gint ett_umts_rrc_ies_T_tfs_SignallingMode2 = -1;
static gint ett_umts_rrc_ies_DL_AddReconfTransChInformation2 = -1;
static gint ett_umts_rrc_ies_T_tfs_SignallingMode3 = -1;
static gint ett_umts_rrc_ies_DL_CommonTransChInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo2 = -1;
static gint ett_umts_rrc_ies_T_fdd3 = -1;
static gint ett_umts_rrc_ies_T_dl_Parameters = -1;
static gint ett_umts_rrc_ies_T_tdd3 = -1;
static gint ett_umts_rrc_ies_DL_CommonTransChInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo3 = -1;
static gint ett_umts_rrc_ies_T_fdd4 = -1;
static gint ett_umts_rrc_ies_T_dl_Parameters1 = -1;
static gint ett_umts_rrc_ies_T_dl_DCH_TFCS = -1;
static gint ett_umts_rrc_ies_T_tdd4 = -1;
static gint ett_umts_rrc_ies_DL_DeletedTransChInfoList = -1;
static gint ett_umts_rrc_ies_DL_DeletedTransChInfoList_r5 = -1;
static gint ett_umts_rrc_ies_DL_TransportChannelIdentity = -1;
static gint ett_umts_rrc_ies_DL_TransportChannelIdentity_r5 = -1;
static gint ett_umts_rrc_ies_DL_TrCH_TypeId1_r5 = -1;
static gint ett_umts_rrc_ies_DL_TrCH_TypeId2_r5 = -1;
static gint ett_umts_rrc_ies_DRAC_StaticInformation = -1;
static gint ett_umts_rrc_ies_DRAC_StaticInformationList = -1;
static gint ett_umts_rrc_ies_E_DCH_AddReconf_MAC_d_Flow = -1;
static gint ett_umts_rrc_ies_T_transmissionGrantType = -1;
static gint ett_umts_rrc_ies_T_non_ScheduledTranmGrantInfo = -1;
static gint ett_umts_rrc_ies_E_DCH_Harq_Info = -1;
static gint ett_umts_rrc_ies_ExplicitTFCS_Configuration = -1;
static gint ett_umts_rrc_ies_T_replacement = -1;
static gint ett_umts_rrc_ies_GainFactorInformation = -1;
static gint ett_umts_rrc_ies_HSDSCH_Info = -1;
static gint ett_umts_rrc_ies_HARQ_Info = -1;
static gint ett_umts_rrc_ies_T_memoryPartitioning = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize = -1;
static gint ett_umts_rrc_ies_IndividualDL_CCTrCH_Info = -1;
static gint ett_umts_rrc_ies_T_tfcs_SignallingMode = -1;
static gint ett_umts_rrc_ies_IndividualDL_CCTrCH_InfoList = -1;
static gint ett_umts_rrc_ies_IndividualUL_CCTrCH_Info = -1;
static gint ett_umts_rrc_ies_IndividualUL_CCTrCH_InfoList = -1;
static gint ett_umts_rrc_ies_LogicalChannelByRB = -1;
static gint ett_umts_rrc_ies_LogicalChannelList = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB = -1;
static gint ett_umts_rrc_ies_MAC_d_FlowIdentityDCHandHSDSCH = -1;
static gint ett_umts_rrc_ies_MAC_d_PDU_SizeInfo_List = -1;
static gint ett_umts_rrc_ies_MAC_d_PDUsizeInfo = -1;
static gint ett_umts_rrc_ies_MAC_hs_AddReconfQueue_List = -1;
static gint ett_umts_rrc_ies_MAC_hs_AddReconfQueue = -1;
static gint ett_umts_rrc_ies_MAC_hs_DelQueue_List = -1;
static gint ett_umts_rrc_ies_MAC_hs_DelQueue = -1;
static gint ett_umts_rrc_ies_NumberOfTbSizeAndTTIList = -1;
static gint ett_umts_rrc_ies_NumberOfTbSizeAndTTIList_item = -1;
static gint ett_umts_rrc_ies_Non_allowedTFC_List = -1;
static gint ett_umts_rrc_ies_NumberOfTransportBlocks = -1;
static gint ett_umts_rrc_ies_OctetModeRLC_SizeInfoType1 = -1;
static gint ett_umts_rrc_ies_T_sizeType21 = -1;
static gint ett_umts_rrc_ies_T_sizeType31 = -1;
static gint ett_umts_rrc_ies_OctetModeRLC_SizeInfoType2 = -1;
static gint ett_umts_rrc_ies_PowerOffsetInfoShort = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo4 = -1;
static gint ett_umts_rrc_ies_T_fdd5 = -1;
static gint ett_umts_rrc_ies_PowerOffsetInformation = -1;
static gint ett_umts_rrc_ies_PreDefTransChConfiguration = -1;
static gint ett_umts_rrc_ies_QualityTarget = -1;
static gint ett_umts_rrc_ies_RestrictedTrChInfo = -1;
static gint ett_umts_rrc_ies_RestrictedTrChInfoList = -1;
static gint ett_umts_rrc_ies_SemistaticTF_Information = -1;
static gint ett_umts_rrc_ies_SignalledGainFactors = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo5 = -1;
static gint ett_umts_rrc_ies_T_fdd6 = -1;
static gint ett_umts_rrc_ies_SplitTFCI_Signalling = -1;
static gint ett_umts_rrc_ies_TFC_Subset = -1;
static gint ett_umts_rrc_ies_TFC_SubsetList = -1;
static gint ett_umts_rrc_ies_TFC_SubsetList_item = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo6 = -1;
static gint ett_umts_rrc_ies_T_tdd5 = -1;
static gint ett_umts_rrc_ies_TFCI_Field2_Information = -1;
static gint ett_umts_rrc_ies_TFCI_Range = -1;
static gint ett_umts_rrc_ies_TFCI_RangeList = -1;
static gint ett_umts_rrc_ies_TFCS = -1;
static gint ett_umts_rrc_ies_TFCS_Identity = -1;
static gint ett_umts_rrc_ies_TFCS_InfoForDSCH = -1;
static gint ett_umts_rrc_ies_TFCS_ReconfAdd = -1;
static gint ett_umts_rrc_ies_T_ctfcSize = -1;
static gint ett_umts_rrc_ies_T_ctfc2Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc2Bit_item = -1;
static gint ett_umts_rrc_ies_T_ctfc4Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc4Bit_item = -1;
static gint ett_umts_rrc_ies_T_ctfc6Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc6Bit_item = -1;
static gint ett_umts_rrc_ies_T_ctfc8Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc8Bit_item = -1;
static gint ett_umts_rrc_ies_T_ctfc12Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc12Bit_item = -1;
static gint ett_umts_rrc_ies_T_ctfc16Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc16Bit_item = -1;
static gint ett_umts_rrc_ies_T_ctfc24Bit = -1;
static gint ett_umts_rrc_ies_T_ctfc24Bit_item = -1;
static gint ett_umts_rrc_ies_TFCS_Removal = -1;
static gint ett_umts_rrc_ies_TFCS_RemovalList = -1;
static gint ett_umts_rrc_ies_TM_SignallingInfo = -1;
static gint ett_umts_rrc_ies_T_tm_SignallingMode = -1;
static gint ett_umts_rrc_ies_T_mode2 = -1;
static gint ett_umts_rrc_ies_TransportChannelIdentityDCHandDSCH = -1;
static gint ett_umts_rrc_ies_TransportFormatSet = -1;
static gint ett_umts_rrc_ies_TransportFormatSet_LCR = -1;
static gint ett_umts_rrc_ies_UL_AddReconfTransChInfoList = -1;
static gint ett_umts_rrc_ies_UL_AddReconfTransChInfoList_r6 = -1;
static gint ett_umts_rrc_ies_UL_AddReconfTransChInformation = -1;
static gint ett_umts_rrc_ies_UL_AddReconfTransChInformation_r6 = -1;
static gint ett_umts_rrc_ies_T_dch_usch = -1;
static gint ett_umts_rrc_ies_T_e_dch1 = -1;
static gint ett_umts_rrc_ies_UL_CommonTransChInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo7 = -1;
static gint ett_umts_rrc_ies_T_fdd7 = -1;
static gint ett_umts_rrc_ies_T_tdd6 = -1;
static gint ett_umts_rrc_ies_UL_CommonTransChInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo8 = -1;
static gint ett_umts_rrc_ies_T_fdd8 = -1;
static gint ett_umts_rrc_ies_T_tdd7 = -1;
static gint ett_umts_rrc_ies_UL_ControlledTrChList = -1;
static gint ett_umts_rrc_ies_UL_DeletedTransChInfoList = -1;
static gint ett_umts_rrc_ies_UL_DeletedTransChInfoList_r6 = -1;
static gint ett_umts_rrc_ies_UL_TransportChannelIdentity = -1;
static gint ett_umts_rrc_ies_UL_TransportChannelIdentity_r6 = -1;
static gint ett_umts_rrc_ies_T_dch_usch1 = -1;
static gint ett_umts_rrc_ies_USCH_TransportChannelsInfo = -1;
static gint ett_umts_rrc_ies_USCH_TransportChannelsInfo_item = -1;
static gint ett_umts_rrc_ies_AC_To_ASC_MappingTable = -1;
static gint ett_umts_rrc_ies_AccessServiceClass_FDD = -1;
static gint ett_umts_rrc_ies_T_assignedSubChannelNumber = -1;
static gint ett_umts_rrc_ies_AccessServiceClass_TDD = -1;
static gint ett_umts_rrc_ies_T_channelisationCodeIndices = -1;
static gint ett_umts_rrc_ies_T_subchannelSize = -1;
static gint ett_umts_rrc_ies_T_size2 = -1;
static gint ett_umts_rrc_ies_T_size4 = -1;
static gint ett_umts_rrc_ies_T_subchannels1 = -1;
static gint ett_umts_rrc_ies_T_size8 = -1;
static gint ett_umts_rrc_ies_T_subchannels2 = -1;
static gint ett_umts_rrc_ies_AccessServiceClass_TDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_availableSYNC_UlCodesIndics = -1;
static gint ett_umts_rrc_ies_T_subchannelSize1 = -1;
static gint ett_umts_rrc_ies_T_size21 = -1;
static gint ett_umts_rrc_ies_T_size41 = -1;
static gint ett_umts_rrc_ies_T_subchannels4 = -1;
static gint ett_umts_rrc_ies_T_size81 = -1;
static gint ett_umts_rrc_ies_T_subchannels5 = -1;
static gint ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_IEs = -1;
static gint ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH = -1;
static gint ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List = -1;
static gint ett_umts_rrc_ies_AICH_Info = -1;
static gint ett_umts_rrc_ies_AllocationPeriodInfo = -1;
static gint ett_umts_rrc_ies_AP_Signature_VCAM = -1;
static gint ett_umts_rrc_ies_ASCSetting_FDD = -1;
static gint ett_umts_rrc_ies_ASCSetting_TDD = -1;
static gint ett_umts_rrc_ies_ASCSetting_TDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_AvailableAP_Signature_VCAMList = -1;
static gint ett_umts_rrc_ies_AvailableAP_SignatureList = -1;
static gint ett_umts_rrc_ies_AvailableAP_SubchannelList = -1;
static gint ett_umts_rrc_ies_AvailableMinimumSF_ListVCAM = -1;
static gint ett_umts_rrc_ies_AvailableMinimumSF_VCAM = -1;
static gint ett_umts_rrc_ies_AvailableSignatures = -1;
static gint ett_umts_rrc_ies_AvailableSubChannelNumbers = -1;
static gint ett_umts_rrc_ies_CCTrCH_PowerControlInfo = -1;
static gint ett_umts_rrc_ies_CCTrCH_PowerControlInfo_r4 = -1;
static gint ett_umts_rrc_ies_CCTrCH_PowerControlInfo_r5 = -1;
static gint ett_umts_rrc_ies_CD_AccessSlotSubchannelList = -1;
static gint ett_umts_rrc_ies_CD_SignatureCodeList = -1;
static gint ett_umts_rrc_ies_CellAndChannelIdentity = -1;
static gint ett_umts_rrc_ies_ChannelAssignmentActive = -1;
static gint ett_umts_rrc_ies_ChannelReqParamsForUCSM = -1;
static gint ett_umts_rrc_ies_CodeRange = -1;
static gint ett_umts_rrc_ies_CommonTimeslotInfo = -1;
static gint ett_umts_rrc_ies_CommonTimeslotInfoSCCPCH = -1;
static gint ett_umts_rrc_ies_CPCH_PersistenceLevels = -1;
static gint ett_umts_rrc_ies_CPCH_PersistenceLevelsList = -1;
static gint ett_umts_rrc_ies_CPCH_SetInfo = -1;
static gint ett_umts_rrc_ies_CPCH_SetInfoList = -1;
static gint ett_umts_rrc_ies_DL_CCTrCh = -1;
static gint ett_umts_rrc_ies_DL_CCTrCh_r4 = -1;
static gint ett_umts_rrc_ies_T_tddOption = -1;
static gint ett_umts_rrc_ies_T_tdd384 = -1;
static gint ett_umts_rrc_ies_T_tdd128 = -1;
static gint ett_umts_rrc_ies_DL_CCTrChList = -1;
static gint ett_umts_rrc_ies_DL_CCTrChList_r4 = -1;
static gint ett_umts_rrc_ies_DL_CCTrChListToRemove = -1;
static gint ett_umts_rrc_ies_DL_CCTrChTPCList = -1;
static gint ett_umts_rrc_ies_DL_ChannelisationCode = -1;
static gint ett_umts_rrc_ies_DL_ChannelisationCodeList = -1;
static gint ett_umts_rrc_ies_DL_CommonInformation = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo9 = -1;
static gint ett_umts_rrc_ies_T_fdd9 = -1;
static gint ett_umts_rrc_ies_T_tdd8 = -1;
static gint ett_umts_rrc_ies_DL_CommonInformation_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo10 = -1;
static gint ett_umts_rrc_ies_T_fdd10 = -1;
static gint ett_umts_rrc_ies_T_tdd9 = -1;
static gint ett_umts_rrc_ies_T_tddOption1 = -1;
static gint ett_umts_rrc_ies_T_tdd1281 = -1;
static gint ett_umts_rrc_ies_DL_CommonInformation_r5 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo11 = -1;
static gint ett_umts_rrc_ies_T_fdd11 = -1;
static gint ett_umts_rrc_ies_T_tdd10 = -1;
static gint ett_umts_rrc_ies_T_tddOption2 = -1;
static gint ett_umts_rrc_ies_T_tdd1282 = -1;
static gint ett_umts_rrc_ies_DL_CommonInformation_r6 = -1;
static gint ett_umts_rrc_ies_T_dl_dpchInfoCommon = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo12 = -1;
static gint ett_umts_rrc_ies_T_fdd12 = -1;
static gint ett_umts_rrc_ies_T_tdd11 = -1;
static gint ett_umts_rrc_ies_T_tddOption3 = -1;
static gint ett_umts_rrc_ies_T_tdd1283 = -1;
static gint ett_umts_rrc_ies_DL_CommonInformationPost = -1;
static gint ett_umts_rrc_ies_DL_CommonInformationPredef = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoCommon = -1;
static gint ett_umts_rrc_ies_T_cfnHandling = -1;
static gint ett_umts_rrc_ies_T_initialise = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo13 = -1;
static gint ett_umts_rrc_ies_T_fdd13 = -1;
static gint ett_umts_rrc_ies_T_tdd12 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoCommon_r4 = -1;
static gint ett_umts_rrc_ies_T_cfnHandling1 = -1;
static gint ett_umts_rrc_ies_T_initialise1 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo14 = -1;
static gint ett_umts_rrc_ies_T_fdd14 = -1;
static gint ett_umts_rrc_ies_T_tdd13 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoCommon_r6 = -1;
static gint ett_umts_rrc_ies_T_cfnHandling2 = -1;
static gint ett_umts_rrc_ies_T_maintain = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo15 = -1;
static gint ett_umts_rrc_ies_T_fdd15 = -1;
static gint ett_umts_rrc_ies_T_tdd14 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoCommonPost = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoCommonPredef = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo16 = -1;
static gint ett_umts_rrc_ies_T_fdd16 = -1;
static gint ett_umts_rrc_ies_T_tdd15 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL = -1;
static gint ett_umts_rrc_ies_T_fdd17 = -1;
static gint ett_umts_rrc_ies_T_tdd16 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r4 = -1;
static gint ett_umts_rrc_ies_T_fdd18 = -1;
static gint ett_umts_rrc_ies_T_tdd17 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r5 = -1;
static gint ett_umts_rrc_ies_T_fdd19 = -1;
static gint ett_umts_rrc_ies_T_tdd18 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r6 = -1;
static gint ett_umts_rrc_ies_T_fdd20 = -1;
static gint ett_umts_rrc_ies_T_tdd19 = -1;
static gint ett_umts_rrc_ies_DL_FDPCH_InfoPerRL_r6 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostFDD = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD = -1;
static gint ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_DL_DPCH_PowerControlInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo17 = -1;
static gint ett_umts_rrc_ies_T_fdd21 = -1;
static gint ett_umts_rrc_ies_T_tdd20 = -1;
static gint ett_umts_rrc_ies_DL_FDPCH_InfoCommon_r6 = -1;
static gint ett_umts_rrc_ies_T_cfnHandling3 = -1;
static gint ett_umts_rrc_ies_T_maintain1 = -1;
static gint ett_umts_rrc_ies_DL_HSPDSCH_Information = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo18 = -1;
static gint ett_umts_rrc_ies_T_tdd21 = -1;
static gint ett_umts_rrc_ies_T_tdd3841 = -1;
static gint ett_umts_rrc_ies_T_tdd1284 = -1;
static gint ett_umts_rrc_ies_DL_HSPDSCH_Information_r6 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo19 = -1;
static gint ett_umts_rrc_ies_T_tdd22 = -1;
static gint ett_umts_rrc_ies_T_tdd3842 = -1;
static gint ett_umts_rrc_ies_T_tdd1285 = -1;
static gint ett_umts_rrc_ies_DL_HSPDSCH_TS_Configuration = -1;
static gint ett_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo20 = -1;
static gint ett_umts_rrc_ies_T_fdd22 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo21 = -1;
static gint ett_umts_rrc_ies_T_fdd23 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_r5 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo22 = -1;
static gint ett_umts_rrc_ies_T_fdd24 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_r5bis = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo23 = -1;
static gint ett_umts_rrc_ies_T_fdd25 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_r6 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo24 = -1;
static gint ett_umts_rrc_ies_T_fdd26 = -1;
static gint ett_umts_rrc_ies_T_dl_dpchInfo = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_List = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_List_r4 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_List_r5 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_List_r6 = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_List_r5bis = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_ListPostFDD = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_PostFDD = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_PostTDD = -1;
static gint ett_umts_rrc_ies_DL_InformationPerRL_PostTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_DL_PDSCH_Information = -1;
static gint ett_umts_rrc_ies_Dl_rate_matching_restriction = -1;
static gint ett_umts_rrc_ies_DL_TPC_PowerOffsetPerRL = -1;
static gint ett_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List = -1;
static gint ett_umts_rrc_ies_DL_TS_ChannelisationCodesShort = -1;
static gint ett_umts_rrc_ies_T_codesRepresentation = -1;
static gint ett_umts_rrc_ies_T_consecutive = -1;
static gint ett_umts_rrc_ies_T_bitmap = -1;
static gint ett_umts_rrc_ies_DownlinkAdditionalTimeslots = -1;
static gint ett_umts_rrc_ies_T_parameters = -1;
static gint ett_umts_rrc_ies_T_sameAsLast = -1;
static gint ett_umts_rrc_ies_T_newParameters = -1;
static gint ett_umts_rrc_ies_DownlinkAdditionalTimeslots_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_parameters1 = -1;
static gint ett_umts_rrc_ies_T_sameAsLast1 = -1;
static gint ett_umts_rrc_ies_T_newParameters1 = -1;
static gint ett_umts_rrc_ies_DownlinkTimeslotsCodes = -1;
static gint ett_umts_rrc_ies_T_moreTimeslots = -1;
static gint ett_umts_rrc_ies_T_additionalTimeslots = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots = -1;
static gint ett_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_moreTimeslots1 = -1;
static gint ett_umts_rrc_ies_T_additionalTimeslots1 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4 = -1;
static gint ett_umts_rrc_ies_DPCH_CompressedModeInfo = -1;
static gint ett_umts_rrc_ies_DPCH_CompressedModeStatusInfo = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort = -1;
static gint ett_umts_rrc_ies_DSCH_Mapping = -1;
static gint ett_umts_rrc_ies_DSCH_MappingList = -1;
static gint ett_umts_rrc_ies_DSCH_TransportChannelsInfo = -1;
static gint ett_umts_rrc_ies_DSCH_TransportChannelsInfo_item = -1;
static gint ett_umts_rrc_ies_DynamicPersistenceLevelList = -1;
static gint ett_umts_rrc_ies_DynamicPersistenceLevelTF_List = -1;
static gint ett_umts_rrc_ies_DynamicTFInformationCCCH = -1;
static gint ett_umts_rrc_ies_E_AGCH_Information = -1;
static gint ett_umts_rrc_ies_E_DCH_RL_Info = -1;
static gint ett_umts_rrc_ies_E_DPCCH_Info = -1;
static gint ett_umts_rrc_ies_E_DPDCH_Info = -1;
static gint ett_umts_rrc_ies_E_DPDCH_Reference_E_TFCI = -1;
static gint ett_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList = -1;
static gint ett_umts_rrc_ies_E_DPDCH_SchedulingInfoConfiguration = -1;
static gint ett_umts_rrc_ies_E_DPDCH_SchedulingTransmConfiguration = -1;
static gint ett_umts_rrc_ies_E_HICH_Information = -1;
static gint ett_umts_rrc_ies_E_RGCH_Information = -1;
static gint ett_umts_rrc_ies_FACH_PCH_Information = -1;
static gint ett_umts_rrc_ies_FACH_PCH_InformationList = -1;
static gint ett_umts_rrc_ies_FPACH_Info_r4 = -1;
static gint ett_umts_rrc_ies_FrequencyInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo25 = -1;
static gint ett_umts_rrc_ies_FrequencyInfoFDD = -1;
static gint ett_umts_rrc_ies_FrequencyInfoTDD = -1;
static gint ett_umts_rrc_ies_HS_PDSCH_Midamble_Configuration_TDD128 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode = -1;
static gint ett_umts_rrc_ies_HS_SCCH_Info = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo26 = -1;
static gint ett_umts_rrc_ies_T_fdd27 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes = -1;
static gint ett_umts_rrc_ies_T_tdd23 = -1;
static gint ett_umts_rrc_ies_T_tdd3843 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128 = -1;
static gint ett_umts_rrc_ies_HS_SCCH_Info_r6 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo27 = -1;
static gint ett_umts_rrc_ies_T_fdd28 = -1;
static gint ett_umts_rrc_ies_T_tdd24 = -1;
static gint ett_umts_rrc_ies_T_tdd3844 = -1;
static gint ett_umts_rrc_ies_HS_SCCH_TDD128 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode1 = -1;
static gint ett_umts_rrc_ies_HS_SICH_Configuration_TDD128 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode2 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble = -1;
static gint ett_umts_rrc_ies_HS_SCCH_TDD384 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode3 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble1 = -1;
static gint ett_umts_rrc_ies_HS_SICH_Configuration_TDD384 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode4 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble2 = -1;
static gint ett_umts_rrc_ies_HS_SICH_Power_Control_Info_TDD384 = -1;
static gint ett_umts_rrc_ies_IndividualTimeslotInfo = -1;
static gint ett_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_IndividualTS_Interference = -1;
static gint ett_umts_rrc_ies_IndividualTS_InterferenceList = -1;
static gint ett_umts_rrc_ies_Measurement_Feedback_Info = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo28 = -1;
static gint ett_umts_rrc_ies_T_fdd29 = -1;
static gint ett_umts_rrc_ies_MidambleShiftAndBurstType = -1;
static gint ett_umts_rrc_ies_T_burstType = -1;
static gint ett_umts_rrc_ies_T_type11 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode5 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble3 = -1;
static gint ett_umts_rrc_ies_T_type2 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode6 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble4 = -1;
static gint ett_umts_rrc_ies_T_type3 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode7 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble5 = -1;
static gint ett_umts_rrc_ies_MidambleShiftAndBurstType_DL = -1;
static gint ett_umts_rrc_ies_T_burstType1 = -1;
static gint ett_umts_rrc_ies_T_type12 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode8 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble6 = -1;
static gint ett_umts_rrc_ies_T_type21 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode9 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble7 = -1;
static gint ett_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_midambleAllocationMode10 = -1;
static gint ett_umts_rrc_ies_T_ueSpecificMidamble8 = -1;
static gint ett_umts_rrc_ies_OpenLoopPowerControl_TDD = -1;
static gint ett_umts_rrc_ies_OpenLoopPowerControl_IPDL_TDD_r4 = -1;
static gint ett_umts_rrc_ies_PCPCH_ChannelInfo = -1;
static gint ett_umts_rrc_ies_PCPCH_ChannelInfoList = -1;
static gint ett_umts_rrc_ies_PDSCH_CapacityAllocationInfo = -1;
static gint ett_umts_rrc_ies_T_configuration = -1;
static gint ett_umts_rrc_ies_T_old_Configuration = -1;
static gint ett_umts_rrc_ies_T_new_Configuration = -1;
static gint ett_umts_rrc_ies_PDSCH_CapacityAllocationInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_configuration1 = -1;
static gint ett_umts_rrc_ies_T_old_Configuration1 = -1;
static gint ett_umts_rrc_ies_T_new_Configuration1 = -1;
static gint ett_umts_rrc_ies_PDSCH_CodeInfo = -1;
static gint ett_umts_rrc_ies_PDSCH_CodeInfoList = -1;
static gint ett_umts_rrc_ies_PDSCH_CodeMap = -1;
static gint ett_umts_rrc_ies_PDSCH_CodeMapList = -1;
static gint ett_umts_rrc_ies_PDSCH_CodeMapping = -1;
static gint ett_umts_rrc_ies_T_signallingMethod = -1;
static gint ett_umts_rrc_ies_PDSCH_Info = -1;
static gint ett_umts_rrc_ies_PDSCH_Info_r4 = -1;
static gint ett_umts_rrc_ies_T_tddOption4 = -1;
static gint ett_umts_rrc_ies_T_tdd3845 = -1;
static gint ett_umts_rrc_ies_T_tdd1286 = -1;
static gint ett_umts_rrc_ies_PDSCH_Info_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PDSCH_PowerControlInfo = -1;
static gint ett_umts_rrc_ies_PDSCH_SHO_DCH_Info = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfo = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfo_HCR_r5 = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfo_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5 = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_SFN = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_item = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5 = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item = -1;
static gint ett_umts_rrc_ies_PersistenceScalingFactorList = -1;
static gint ett_umts_rrc_ies_PichChannelisationCodeList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PICH_Info = -1;
static gint ett_umts_rrc_ies_T_fdd30 = -1;
static gint ett_umts_rrc_ies_T_tdd25 = -1;
static gint ett_umts_rrc_ies_PICH_Info_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PowerControlAlgorithm = -1;
static gint ett_umts_rrc_ies_PRACH_ChanCodes_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PRACH_Definition_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PRACH_Partitioning = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD = -1;
static gint ett_umts_rrc_ies_PRACH_Partitioning_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PRACH_PowerOffset = -1;
static gint ett_umts_rrc_ies_PRACH_RACH_Info = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo29 = -1;
static gint ett_umts_rrc_ies_T_fdd31 = -1;
static gint ett_umts_rrc_ies_T_tdd26 = -1;
static gint ett_umts_rrc_ies_PRACH_RACH_Info_LCR_r4 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PRACH_SystemInformation = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo30 = -1;
static gint ett_umts_rrc_ies_T_fdd32 = -1;
static gint ett_umts_rrc_ies_PRACH_SystemInformation_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PRACH_SystemInformationList = -1;
static gint ett_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PreDefPhyChConfiguration = -1;
static gint ett_umts_rrc_ies_PrimaryCCPCH_Info = -1;
static gint ett_umts_rrc_ies_T_fdd33 = -1;
static gint ett_umts_rrc_ies_T_tdd27 = -1;
static gint ett_umts_rrc_ies_SyncCase = -1;
static gint ett_umts_rrc_ies_T_syncCase1 = -1;
static gint ett_umts_rrc_ies_T_syncCase2 = -1;
static gint ett_umts_rrc_ies_PrimaryCCPCH_Info_r4 = -1;
static gint ett_umts_rrc_ies_T_fdd34 = -1;
static gint ett_umts_rrc_ies_T_tdd28 = -1;
static gint ett_umts_rrc_ies_T_tddOption5 = -1;
static gint ett_umts_rrc_ies_T_tdd3846 = -1;
static gint ett_umts_rrc_ies_T_tdd1287 = -1;
static gint ett_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_PrimaryCCPCH_InfoPost = -1;
static gint ett_umts_rrc_ies_PrimaryCCPCH_InfoPostTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PrimaryCPICH_Info = -1;
static gint ett_umts_rrc_ies_PUSCH_CapacityAllocationInfo = -1;
static gint ett_umts_rrc_ies_T_pusch_Allocation = -1;
static gint ett_umts_rrc_ies_T_pusch_AllocationAssignment = -1;
static gint ett_umts_rrc_ies_T_configuration2 = -1;
static gint ett_umts_rrc_ies_T_old_Configuration2 = -1;
static gint ett_umts_rrc_ies_T_new_Configuration2 = -1;
static gint ett_umts_rrc_ies_PUSCH_CapacityAllocationInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_pusch_Allocation1 = -1;
static gint ett_umts_rrc_ies_T_pusch_AllocationAssignment1 = -1;
static gint ett_umts_rrc_ies_T_configuration3 = -1;
static gint ett_umts_rrc_ies_T_old_Configuration3 = -1;
static gint ett_umts_rrc_ies_T_new_Configuration3 = -1;
static gint ett_umts_rrc_ies_PUSCH_Info = -1;
static gint ett_umts_rrc_ies_PUSCH_Info_r4 = -1;
static gint ett_umts_rrc_ies_T_tddOption6 = -1;
static gint ett_umts_rrc_ies_T_tdd3847 = -1;
static gint ett_umts_rrc_ies_T_tdd1288 = -1;
static gint ett_umts_rrc_ies_PUSCH_Info_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PUSCH_PowerControlInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_tddOption7 = -1;
static gint ett_umts_rrc_ies_T_tdd1289 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfo = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfo_HCR_r5 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfo_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_SFN = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_item = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4 = -1;
static gint ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item = -1;
static gint ett_umts_rrc_ies_RACH_TransmissionParameters = -1;
static gint ett_umts_rrc_ies_RepetitionPeriodAndLength = -1;
static gint ett_umts_rrc_ies_RepetitionPeriodLengthAndOffset = -1;
static gint ett_umts_rrc_ies_T_repetitionPeriod2 = -1;
static gint ett_umts_rrc_ies_T_repetitionPeriod4 = -1;
static gint ett_umts_rrc_ies_T_repetitionPeriod8 = -1;
static gint ett_umts_rrc_ies_T_repetitionPeriod16 = -1;
static gint ett_umts_rrc_ies_T_repetitionPeriod32 = -1;
static gint ett_umts_rrc_ies_T_repetitionPeriod64 = -1;
static gint ett_umts_rrc_ies_ReplacedPDSCH_CodeInfo = -1;
static gint ett_umts_rrc_ies_ReplacedPDSCH_CodeInfoList = -1;
static gint ett_umts_rrc_ies_RepPerLengthOffset_PICH = -1;
static gint ett_umts_rrc_ies_RepPerLengthOffset_MICH = -1;
static gint ett_umts_rrc_ies_RestrictedTrCH = -1;
static gint ett_umts_rrc_ies_RestrictedTrCH_InfoList = -1;
static gint ett_umts_rrc_ies_RL_AdditionInformation = -1;
static gint ett_umts_rrc_ies_RL_AdditionInformation_r6 = -1;
static gint ett_umts_rrc_ies_T_dl_dpchInfo1 = -1;
static gint ett_umts_rrc_ies_RL_AdditionInformationList = -1;
static gint ett_umts_rrc_ies_RL_AdditionInformationList_r6 = -1;
static gint ett_umts_rrc_ies_RL_IdentifierList = -1;
static gint ett_umts_rrc_ies_RL_RemovalInformationList = -1;
static gint ett_umts_rrc_ies_SCCPCH_ChannelisationCodeList = -1;
static gint ett_umts_rrc_ies_SCCPCH_InfoForFACH = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo31 = -1;
static gint ett_umts_rrc_ies_T_fdd35 = -1;
static gint ett_umts_rrc_ies_T_tdd29 = -1;
static gint ett_umts_rrc_ies_SCCPCH_InfoForFACH_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo32 = -1;
static gint ett_umts_rrc_ies_T_fdd36 = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformation = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformation_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6_ext = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformationList = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext = -1;
static gint ett_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6 = -1;
static gint ett_umts_rrc_ies_T_fachCarryingMCCH = -1;
static gint ett_umts_rrc_ies_T_schedulingInformation = -1;
static gint ett_umts_rrc_ies_Scheduling_E_DCH_CellInformation = -1;
static gint ett_umts_rrc_ies_SecondaryCCPCH_Info = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo33 = -1;
static gint ett_umts_rrc_ies_T_fdd37 = -1;
static gint ett_umts_rrc_ies_T_tdd30 = -1;
static gint ett_umts_rrc_ies_SecondaryCCPCH_Info_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo34 = -1;
static gint ett_umts_rrc_ies_T_fdd38 = -1;
static gint ett_umts_rrc_ies_T_tdd31 = -1;
static gint ett_umts_rrc_ies_T_tddOption8 = -1;
static gint ett_umts_rrc_ies_T_tdd3848 = -1;
static gint ett_umts_rrc_ies_T_tdd12810 = -1;
static gint ett_umts_rrc_ies_SecondaryCCPCH_Info_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_SecondaryCCPCHInfo_MBMS_r6 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo35 = -1;
static gint ett_umts_rrc_ies_T_fdd39 = -1;
static gint ett_umts_rrc_ies_SecondaryCPICH_Info = -1;
static gint ett_umts_rrc_ies_SF256_AndCodeNumber = -1;
static gint ett_umts_rrc_ies_SF512_AndCodeNumber = -1;
static gint ett_umts_rrc_ies_SF512_AndPilot = -1;
static gint ett_umts_rrc_ies_SFN_TimeInfo = -1;
static gint ett_umts_rrc_ies_SSDT_Information = -1;
static gint ett_umts_rrc_ies_SSDT_Information_r4 = -1;
static gint ett_umts_rrc_ies_SynchronisationParameters_r4 = -1;
static gint ett_umts_rrc_ies_T_sync_UL_CodesBitmap = -1;
static gint ett_umts_rrc_ies_SYNC_UL_Procedure_r4 = -1;
static gint ett_umts_rrc_ies_SYNC_UL_Info_r4 = -1;
static gint ett_umts_rrc_ies_T_sync_UL_Codes_Bitmap = -1;
static gint ett_umts_rrc_ies_TDD_PRACH_CCodeList = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16 = -1;
static gint ett_umts_rrc_ies_TGP_Sequence = -1;
static gint ett_umts_rrc_ies_T_tgps_Status = -1;
static gint ett_umts_rrc_ies_T_activate = -1;
static gint ett_umts_rrc_ies_TGP_SequenceList = -1;
static gint ett_umts_rrc_ies_TGP_SequenceShort = -1;
static gint ett_umts_rrc_ies_T_tgps_Status1 = -1;
static gint ett_umts_rrc_ies_T_activate1 = -1;
static gint ett_umts_rrc_ies_TGPS_ConfigurationParams = -1;
static gint ett_umts_rrc_ies_TimeInfo = -1;
static gint ett_umts_rrc_ies_TimeslotList = -1;
static gint ett_umts_rrc_ies_TimeslotList_r4 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4 = -1;
static gint ett_umts_rrc_ies_UCSM_Info = -1;
static gint ett_umts_rrc_ies_UL_CCTrCH = -1;
static gint ett_umts_rrc_ies_UL_CCTrCH_r4 = -1;
static gint ett_umts_rrc_ies_T_tddOption9 = -1;
static gint ett_umts_rrc_ies_T_tdd3849 = -1;
static gint ett_umts_rrc_ies_T_tdd12811 = -1;
static gint ett_umts_rrc_ies_UL_CCTrCHList = -1;
static gint ett_umts_rrc_ies_UL_CCTrCHList_r4 = -1;
static gint ett_umts_rrc_ies_UL_CCTrCHListToRemove = -1;
static gint ett_umts_rrc_ies_UL_CCTrChTPCList = -1;
static gint ett_umts_rrc_ies_UL_ChannelRequirement = -1;
static gint ett_umts_rrc_ies_UL_ChannelRequirement_r4 = -1;
static gint ett_umts_rrc_ies_UL_ChannelRequirement_r5 = -1;
static gint ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID = -1;
static gint ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r4 = -1;
static gint ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r5 = -1;
static gint ett_umts_rrc_ies_UL_DL_Mode = -1;
static gint ett_umts_rrc_ies_T_ul_and_dl = -1;
static gint ett_umts_rrc_ies_UL_DPCH_Info = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo36 = -1;
static gint ett_umts_rrc_ies_T_fdd40 = -1;
static gint ett_umts_rrc_ies_T_tdd32 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_Info_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo37 = -1;
static gint ett_umts_rrc_ies_T_fdd41 = -1;
static gint ett_umts_rrc_ies_T_tdd33 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_Info_r5 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo38 = -1;
static gint ett_umts_rrc_ies_T_fdd42 = -1;
static gint ett_umts_rrc_ies_T_tdd34 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_Info_r6 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo39 = -1;
static gint ett_umts_rrc_ies_T_fdd43 = -1;
static gint ett_umts_rrc_ies_T_tdd35 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_InfoPostFDD = -1;
static gint ett_umts_rrc_ies_UL_DPCH_InfoPostTDD = -1;
static gint ett_umts_rrc_ies_UL_DPCH_InfoPostTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_InfoPredef = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo40 = -1;
static gint ett_umts_rrc_ies_T_fdd44 = -1;
static gint ett_umts_rrc_ies_T_tdd36 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfo = -1;
static gint ett_umts_rrc_ies_T_fdd45 = -1;
static gint ett_umts_rrc_ies_T_tdd37 = -1;
static gint ett_umts_rrc_ies_T_ul_OL_PC_Signalling = -1;
static gint ett_umts_rrc_ies_T_individuallySignalled = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_fdd46 = -1;
static gint ett_umts_rrc_ies_T_tdd38 = -1;
static gint ett_umts_rrc_ies_T_ul_OL_PC_Signalling1 = -1;
static gint ett_umts_rrc_ies_T_individuallySignalled1 = -1;
static gint ett_umts_rrc_ies_T_tddOption10 = -1;
static gint ett_umts_rrc_ies_T_tdd38410 = -1;
static gint ett_umts_rrc_ies_T_tdd12812 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r5 = -1;
static gint ett_umts_rrc_ies_T_fdd47 = -1;
static gint ett_umts_rrc_ies_T_tdd39 = -1;
static gint ett_umts_rrc_ies_T_ul_OL_PC_Signalling2 = -1;
static gint ett_umts_rrc_ies_T_individuallySignalled2 = -1;
static gint ett_umts_rrc_ies_T_tddOption11 = -1;
static gint ett_umts_rrc_ies_T_tdd38411 = -1;
static gint ett_umts_rrc_ies_T_tdd12813 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r6 = -1;
static gint ett_umts_rrc_ies_T_fdd48 = -1;
static gint ett_umts_rrc_ies_T_tdd40 = -1;
static gint ett_umts_rrc_ies_T_ul_OL_PC_Signalling3 = -1;
static gint ett_umts_rrc_ies_T_individuallySignalled3 = -1;
static gint ett_umts_rrc_ies_T_tddOption12 = -1;
static gint ett_umts_rrc_ies_T_tdd38412 = -1;
static gint ett_umts_rrc_ies_T_tdd12814 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostFDD = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD_LCR_r4 = -1;
static gint ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPredef = -1;
static gint ett_umts_rrc_ies_T_fdd49 = -1;
static gint ett_umts_rrc_ies_T_tdd41 = -1;
static gint ett_umts_rrc_ies_UL_EDCH_Information_r6 = -1;
static gint ett_umts_rrc_ies_UL_SynchronisationParameters_r4 = -1;
static gint ett_umts_rrc_ies_UL_TimingAdvanceControl = -1;
static gint ett_umts_rrc_ies_T_enabled = -1;
static gint ett_umts_rrc_ies_UL_TimingAdvanceControl_r4 = -1;
static gint ett_umts_rrc_ies_T_enabled1 = -1;
static gint ett_umts_rrc_ies_T_tddOption13 = -1;
static gint ett_umts_rrc_ies_T_tdd38413 = -1;
static gint ett_umts_rrc_ies_T_tdd12815 = -1;
static gint ett_umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_enabled2 = -1;
static gint ett_umts_rrc_ies_UL_TS_ChannelisationCodeList = -1;
static gint ett_umts_rrc_ies_UplinkAdditionalTimeslots = -1;
static gint ett_umts_rrc_ies_T_parameters2 = -1;
static gint ett_umts_rrc_ies_T_sameAsLast2 = -1;
static gint ett_umts_rrc_ies_T_newParameters2 = -1;
static gint ett_umts_rrc_ies_UplinkAdditionalTimeslots_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_parameters3 = -1;
static gint ett_umts_rrc_ies_T_sameAsLast3 = -1;
static gint ett_umts_rrc_ies_T_newParameters3 = -1;
static gint ett_umts_rrc_ies_UplinkTimeslotsCodes = -1;
static gint ett_umts_rrc_ies_T_moreTimeslots2 = -1;
static gint ett_umts_rrc_ies_T_additionalTimeslots2 = -1;
static gint ett_umts_rrc_ies_T_consecutive1 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots = -1;
static gint ett_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4 = -1;
static gint ett_umts_rrc_ies_T_moreTimeslots3 = -1;
static gint ett_umts_rrc_ies_T_additionalTimeslots3 = -1;
static gint ett_umts_rrc_ies_T_consecutive2 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4 = -1;
static gint ett_umts_rrc_ies_AcquisitionSatInfo = -1;
static gint ett_umts_rrc_ies_AcquisitionSatInfoList = -1;
static gint ett_umts_rrc_ies_AdditionalMeasurementID_List = -1;
static gint ett_umts_rrc_ies_AlmanacSatInfo = -1;
static gint ett_umts_rrc_ies_AlmanacSatInfoList = -1;
static gint ett_umts_rrc_ies_AzimuthAndElevation = -1;
static gint ett_umts_rrc_ies_BadSatList = -1;
static gint ett_umts_rrc_ies_BLER_MeasurementResults = -1;
static gint ett_umts_rrc_ies_BLER_MeasurementResultsList = -1;
static gint ett_umts_rrc_ies_BLER_TransChIdList = -1;
static gint ett_umts_rrc_ies_BSICReported = -1;
static gint ett_umts_rrc_ies_BurstModeParameters = -1;
static gint ett_umts_rrc_ies_CellDCH_ReportCriteria = -1;
static gint ett_umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CellInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo41 = -1;
static gint ett_umts_rrc_ies_T_fdd50 = -1;
static gint ett_umts_rrc_ies_T_tdd42 = -1;
static gint ett_umts_rrc_ies_CellInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo42 = -1;
static gint ett_umts_rrc_ies_T_fdd51 = -1;
static gint ett_umts_rrc_ies_T_tdd43 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_RSCP = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo43 = -1;
static gint ett_umts_rrc_ies_T_fdd52 = -1;
static gint ett_umts_rrc_ies_T_tdd44 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_ECN0 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo44 = -1;
static gint ett_umts_rrc_ies_T_fdd53 = -1;
static gint ett_umts_rrc_ies_T_tdd45 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo45 = -1;
static gint ett_umts_rrc_ies_T_fdd54 = -1;
static gint ett_umts_rrc_ies_T_tdd46 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo46 = -1;
static gint ett_umts_rrc_ies_T_fdd55 = -1;
static gint ett_umts_rrc_ies_T_tdd47 = -1;
static gint ett_umts_rrc_ies_CellInfoSI_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CellMeasuredResults = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo47 = -1;
static gint ett_umts_rrc_ies_T_fdd56 = -1;
static gint ett_umts_rrc_ies_T_tdd48 = -1;
static gint ett_umts_rrc_ies_CellMeasurementEventResults = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info = -1;
static gint ett_umts_rrc_ies_CellMeasurementEventResults_LCR_r4 = -1;
static gint ett_umts_rrc_ies_CellReportingQuantities = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo48 = -1;
static gint ett_umts_rrc_ies_T_fdd57 = -1;
static gint ett_umts_rrc_ies_T_tdd49 = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo49 = -1;
static gint ett_umts_rrc_ies_T_fdd58 = -1;
static gint ett_umts_rrc_ies_T_tdd50 = -1;
static gint ett_umts_rrc_ies_T_gsm = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_RSCP = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo50 = -1;
static gint ett_umts_rrc_ies_T_fdd59 = -1;
static gint ett_umts_rrc_ies_T_tdd51 = -1;
static gint ett_umts_rrc_ies_T_gsm1 = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_ECN0 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo51 = -1;
static gint ett_umts_rrc_ies_T_fdd60 = -1;
static gint ett_umts_rrc_ies_T_tdd52 = -1;
static gint ett_umts_rrc_ies_T_gsm2 = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo52 = -1;
static gint ett_umts_rrc_ies_T_fdd61 = -1;
static gint ett_umts_rrc_ies_T_tdd53 = -1;
static gint ett_umts_rrc_ies_T_gsm3 = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo53 = -1;
static gint ett_umts_rrc_ies_T_fdd62 = -1;
static gint ett_umts_rrc_ies_T_tdd54 = -1;
static gint ett_umts_rrc_ies_T_gsm4 = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfo_v590ext = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoPCHFACH_v5b0ext = -1;
static gint ett_umts_rrc_ies_CellSelectReselectInfoTreselectionScaling_v5c0ext = -1;
static gint ett_umts_rrc_ies_CellsForInterFreqMeasList = -1;
static gint ett_umts_rrc_ies_CellsForInterRATMeasList = -1;
static gint ett_umts_rrc_ies_CellsForIntraFreqMeasList = -1;
static gint ett_umts_rrc_ies_CellSynchronisationInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo54 = -1;
static gint ett_umts_rrc_ies_T_fdd63 = -1;
static gint ett_umts_rrc_ies_T_tdd55 = -1;
static gint ett_umts_rrc_ies_CellToReport = -1;
static gint ett_umts_rrc_ies_CellToReportList = -1;
static gint ett_umts_rrc_ies_CountC_SFN_Frame_difference = -1;
static gint ett_umts_rrc_ies_DeltaRSCPPerCell = -1;
static gint ett_umts_rrc_ies_DGPS_CorrectionSatInfo = -1;
static gint ett_umts_rrc_ies_DGPS_CorrectionSatInfoList = -1;
static gint ett_umts_rrc_ies_EllipsoidPoint = -1;
static gint ett_umts_rrc_ies_EllipsoidPointAltitude = -1;
static gint ett_umts_rrc_ies_EllipsoidPointAltitudeEllipsoide = -1;
static gint ett_umts_rrc_ies_EllipsoidPointUncertCircle = -1;
static gint ett_umts_rrc_ies_EllipsoidPointUncertEllipse = -1;
static gint ett_umts_rrc_ies_Event1a = -1;
static gint ett_umts_rrc_ies_Event1a_r4 = -1;
static gint ett_umts_rrc_ies_Event1a_LCR_r4 = -1;
static gint ett_umts_rrc_ies_Event1b = -1;
static gint ett_umts_rrc_ies_Event1b_r4 = -1;
static gint ett_umts_rrc_ies_Event1b_LCR_r4 = -1;
static gint ett_umts_rrc_ies_Event1c = -1;
static gint ett_umts_rrc_ies_Event1e = -1;
static gint ett_umts_rrc_ies_Event1f = -1;
static gint ett_umts_rrc_ies_Event2a = -1;
static gint ett_umts_rrc_ies_Event2b = -1;
static gint ett_umts_rrc_ies_Event2c = -1;
static gint ett_umts_rrc_ies_Event2d = -1;
static gint ett_umts_rrc_ies_Event2e = -1;
static gint ett_umts_rrc_ies_Event2f = -1;
static gint ett_umts_rrc_ies_Event3a = -1;
static gint ett_umts_rrc_ies_Event3b = -1;
static gint ett_umts_rrc_ies_Event3c = -1;
static gint ett_umts_rrc_ies_Event3d = -1;
static gint ett_umts_rrc_ies_EventResults = -1;
static gint ett_umts_rrc_ies_ExtraDopplerInfo = -1;
static gint ett_umts_rrc_ies_FACH_MeasurementOccasionInfo = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type = -1;
static gint ett_umts_rrc_ies_FACH_MeasurementOccasionInfo_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_ForbiddenAffectCell = -1;
static gint ett_umts_rrc_ies_ForbiddenAffectCell_r4 = -1;
static gint ett_umts_rrc_ies_ForbiddenAffectCell_LCR_r4 = -1;
static gint ett_umts_rrc_ies_ForbiddenAffectCellList = -1;
static gint ett_umts_rrc_ies_ForbiddenAffectCellList_r4 = -1;
static gint ett_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_GPS_MeasurementParam = -1;
static gint ett_umts_rrc_ies_GPS_MeasurementParamList = -1;
static gint ett_umts_rrc_ies_GSM_MeasuredResults = -1;
static gint ett_umts_rrc_ies_GSM_MeasuredResultsList = -1;
static gint ett_umts_rrc_ies_GPS_TOW_Assist = -1;
static gint ett_umts_rrc_ies_GPS_TOW_AssistList = -1;
static gint ett_umts_rrc_ies_HCS_CellReselectInformation_RSCP = -1;
static gint ett_umts_rrc_ies_HCS_CellReselectInformation_ECN0 = -1;
static gint ett_umts_rrc_ies_HCS_NeighbouringCellInformation_RSCP = -1;
static gint ett_umts_rrc_ies_HCS_NeighbouringCellInformation_ECN0 = -1;
static gint ett_umts_rrc_ies_HCS_ServingCellInformation = -1;
static gint ett_umts_rrc_ies_InterFreqCell = -1;
static gint ett_umts_rrc_ies_InterFreqCell_LCR_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoList = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoList_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0 = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP_LCR = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0_LCR = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP_LCR = -1;
static gint ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0_LCR = -1;
static gint ett_umts_rrc_ies_InterFreqCellList = -1;
static gint ett_umts_rrc_ies_InterFreqCellList_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_InterFreqCellMeasuredResultsList = -1;
static gint ett_umts_rrc_ies_InterFreqEvent = -1;
static gint ett_umts_rrc_ies_InterFreqEventList = -1;
static gint ett_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext = -1;
static gint ett_umts_rrc_ies_Inter_FreqEventCriteria_v590ext = -1;
static gint ett_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext = -1;
static gint ett_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext = -1;
static gint ett_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext = -1;
static gint ett_umts_rrc_ies_IntraFreqReportingCriteria_1b_r5 = -1;
static gint ett_umts_rrc_ies_PeriodicReportingInfo_1b = -1;
static gint ett_umts_rrc_ies_InterFreqEventResults = -1;
static gint ett_umts_rrc_ies_InterFreqEventResults_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_InterFreqMeasQuantity = -1;
static gint ett_umts_rrc_ies_T_reportingCriteria = -1;
static gint ett_umts_rrc_ies_T_intraFreqReportingCriteria = -1;
static gint ett_umts_rrc_ies_T_interFreqReportingCriteria = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo55 = -1;
static gint ett_umts_rrc_ies_T_fdd64 = -1;
static gint ett_umts_rrc_ies_T_tdd56 = -1;
static gint ett_umts_rrc_ies_InterFreqMeasuredResults = -1;
static gint ett_umts_rrc_ies_InterFreqMeasuredResultsList = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0 = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqRACHRepCellsList = -1;
static gint ett_umts_rrc_ies_InterFreqRACHReportingInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo56 = -1;
static gint ett_umts_rrc_ies_T_fdd65 = -1;
static gint ett_umts_rrc_ies_T_tdd57 = -1;
static gint ett_umts_rrc_ies_InterFreqReportCriteria = -1;
static gint ett_umts_rrc_ies_InterFreqReportCriteria_r4 = -1;
static gint ett_umts_rrc_ies_InterFreqReportingCriteria = -1;
static gint ett_umts_rrc_ies_InterFreqReportingQuantity = -1;
static gint ett_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList = -1;
static gint ett_umts_rrc_ies_InterFrequencyMeasurement = -1;
static gint ett_umts_rrc_ies_InterFrequencyMeasurement_r4 = -1;
static gint ett_umts_rrc_ies_InterRAT_TargetCellDescription = -1;
static gint ett_umts_rrc_ies_T_technologySpecificInfo = -1;
static gint ett_umts_rrc_ies_T_gsm5 = -1;
static gint ett_umts_rrc_ies_InterRATCellInfoList = -1;
static gint ett_umts_rrc_ies_InterRATCellInfoList_B = -1;
static gint ett_umts_rrc_ies_InterRATCellInfoList_r4 = -1;
static gint ett_umts_rrc_ies_InterRATEvent = -1;
static gint ett_umts_rrc_ies_InterRATEventList = -1;
static gint ett_umts_rrc_ies_InterRATEventResults = -1;
static gint ett_umts_rrc_ies_InterRATInfo_r6 = -1;
static gint ett_umts_rrc_ies_InterRATMeasQuantity = -1;
static gint ett_umts_rrc_ies_T_ratSpecificInfo = -1;
static gint ett_umts_rrc_ies_T_gsm6 = -1;
static gint ett_umts_rrc_ies_T_is_2000 = -1;
static gint ett_umts_rrc_ies_InterRATMeasuredResults = -1;
static gint ett_umts_rrc_ies_InterRATMeasuredResultsList = -1;
static gint ett_umts_rrc_ies_InterRATMeasurement = -1;
static gint ett_umts_rrc_ies_InterRATMeasurement_r4 = -1;
static gint ett_umts_rrc_ies_InterRATMeasurementSysInfo = -1;
static gint ett_umts_rrc_ies_InterRATMeasurementSysInfo_B = -1;
static gint ett_umts_rrc_ies_InterRATReportCriteria = -1;
static gint ett_umts_rrc_ies_InterRATReportingCriteria = -1;
static gint ett_umts_rrc_ies_InterRATReportingQuantity = -1;
static gint ett_umts_rrc_ies_T_ratSpecificInfo1 = -1;
static gint ett_umts_rrc_ies_T_gsm7 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoList = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoList_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEvent = -1;
static gint ett_umts_rrc_ies_IntraFreqEvent_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEvent_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEvent_1d_r5 = -1;
static gint ett_umts_rrc_ies_IntraFreqEventCriteria = -1;
static gint ett_umts_rrc_ies_IntraFreqEventCriteria_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEventCriteria_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEventCriteriaList = -1;
static gint ett_umts_rrc_ies_IntraFreqEventCriteriaList_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqEventResults = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasQuantity = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo57 = -1;
static gint ett_umts_rrc_ies_T_fdd66 = -1;
static gint ett_umts_rrc_ies_T_tdd58 = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasQuantity_TDDList = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasuredResultsList = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0 = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqReportCriteria = -1;
static gint ett_umts_rrc_ies_IntraFreqReportCriteria_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqReportingCriteria = -1;
static gint ett_umts_rrc_ies_IntraFreqReportingCriteria_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqReportingCriteria_LCR_r4 = -1;
static gint ett_umts_rrc_ies_IntraFreqReportingQuantity = -1;
static gint ett_umts_rrc_ies_IntraFreqReportingQuantityForRACH = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo58 = -1;
static gint ett_umts_rrc_ies_T_fdd67 = -1;
static gint ett_umts_rrc_ies_T_tdd59 = -1;
static gint ett_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList = -1;
static gint ett_umts_rrc_ies_IntraFrequencyMeasurement = -1;
static gint ett_umts_rrc_ies_IntraFrequencyMeasurement_r4 = -1;
static gint ett_umts_rrc_ies_MeasuredResults = -1;
static gint ett_umts_rrc_ies_MeasuredResults_v390ext = -1;
static gint ett_umts_rrc_ies_MeasuredResults_v590ext = -1;
static gint ett_umts_rrc_ies_MeasuredResults_LCR_r4 = -1;
static gint ett_umts_rrc_ies_MeasuredResultsList = -1;
static gint ett_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_MeasuredResultsOnRACH = -1;
static gint ett_umts_rrc_ies_T_currentCell = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo59 = -1;
static gint ett_umts_rrc_ies_T_fdd68 = -1;
static gint ett_umts_rrc_ies_T_measurementQuantity = -1;
static gint ett_umts_rrc_ies_T_tdd60 = -1;
static gint ett_umts_rrc_ies_MeasuredResultsOnRACHinterFreq = -1;
static gint ett_umts_rrc_ies_MeasurementCommand = -1;
static gint ett_umts_rrc_ies_T_modify1 = -1;
static gint ett_umts_rrc_ies_MeasurementCommand_r4 = -1;
static gint ett_umts_rrc_ies_T_modify2 = -1;
static gint ett_umts_rrc_ies_MeasurementControlSysInfo = -1;
static gint ett_umts_rrc_ies_T_use_of_HCS = -1;
static gint ett_umts_rrc_ies_T_hcs_not_used = -1;
static gint ett_umts_rrc_ies_T_cellSelectQualityMeasure1 = -1;
static gint ett_umts_rrc_ies_T_cpich_RSCP = -1;
static gint ett_umts_rrc_ies_T_cpich_Ec_N01 = -1;
static gint ett_umts_rrc_ies_T_hcs_used = -1;
static gint ett_umts_rrc_ies_T_cellSelectQualityMeasure2 = -1;
static gint ett_umts_rrc_ies_T_cpich_RSCP1 = -1;
static gint ett_umts_rrc_ies_T_cpich_Ec_N02 = -1;
static gint ett_umts_rrc_ies_MeasurementControlSysInfo_LCR_r4_ext = -1;
static gint ett_umts_rrc_ies_T_use_of_HCS1 = -1;
static gint ett_umts_rrc_ies_T_hcs_not_used1 = -1;
static gint ett_umts_rrc_ies_T_cellSelectQualityMeasure3 = -1;
static gint ett_umts_rrc_ies_T_cpich_RSCP2 = -1;
static gint ett_umts_rrc_ies_T_cpich_Ec_N03 = -1;
static gint ett_umts_rrc_ies_T_hcs_used1 = -1;
static gint ett_umts_rrc_ies_T_cellSelectQualityMeasure4 = -1;
static gint ett_umts_rrc_ies_T_cpich_RSCP3 = -1;
static gint ett_umts_rrc_ies_T_cpich_Ec_N04 = -1;
static gint ett_umts_rrc_ies_MeasurementReportingMode = -1;
static gint ett_umts_rrc_ies_MeasurementType = -1;
static gint ett_umts_rrc_ies_MeasurementType_r4 = -1;
static gint ett_umts_rrc_ies_MeasurementValidity = -1;
static gint ett_umts_rrc_ies_MonitoredCellRACH_List = -1;
static gint ett_umts_rrc_ies_MonitoredCellRACH_Result = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo60 = -1;
static gint ett_umts_rrc_ies_T_fdd69 = -1;
static gint ett_umts_rrc_ies_T_measurementQuantity1 = -1;
static gint ett_umts_rrc_ies_T_tdd61 = -1;
static gint ett_umts_rrc_ies_N_CR_T_CRMaxHyst = -1;
static gint ett_umts_rrc_ies_NavigationModelSatInfo = -1;
static gint ett_umts_rrc_ies_NavigationModelSatInfoList = -1;
static gint ett_umts_rrc_ies_EphemerisParameter = -1;
static gint ett_umts_rrc_ies_Neighbour = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo61 = -1;
static gint ett_umts_rrc_ies_T_fdd70 = -1;
static gint ett_umts_rrc_ies_T_tdd62 = -1;
static gint ett_umts_rrc_ies_Neighbour_v390ext = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo62 = -1;
static gint ett_umts_rrc_ies_T_fdd71 = -1;
static gint ett_umts_rrc_ies_NeighbourList = -1;
static gint ett_umts_rrc_ies_NeighbourList_v390ext = -1;
static gint ett_umts_rrc_ies_NeighbourQuality = -1;
static gint ett_umts_rrc_ies_NewInterFreqCell = -1;
static gint ett_umts_rrc_ies_NewInterFreqCell_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellList = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellList_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_RSCP = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_ECN0 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_ECN0 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_RSCP = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewInterRATCell = -1;
static gint ett_umts_rrc_ies_T_technologySpecificInfo1 = -1;
static gint ett_umts_rrc_ies_T_gsm8 = -1;
static gint ett_umts_rrc_ies_T_is_20001 = -1;
static gint ett_umts_rrc_ies_NewInterRATCell_B = -1;
static gint ett_umts_rrc_ies_T_technologySpecificInfo2 = -1;
static gint ett_umts_rrc_ies_T_gsm9 = -1;
static gint ett_umts_rrc_ies_T_is_20002 = -1;
static gint ett_umts_rrc_ies_NewInterRATCellList = -1;
static gint ett_umts_rrc_ies_NewInterRATCellList_B = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCell = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCell_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellList = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellList_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_RSCP = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_ECN0 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4 = -1;
static gint ett_umts_rrc_ies_NonUsedFreqParameter = -1;
static gint ett_umts_rrc_ies_NonUsedFreqParameterList = -1;
static gint ett_umts_rrc_ies_PenaltyTime_RSCP = -1;
static gint ett_umts_rrc_ies_PenaltyTime_ECN0 = -1;
static gint ett_umts_rrc_ies_PeriodicalReportingCriteria = -1;
static gint ett_umts_rrc_ies_PeriodicalWithReportingCellStatus = -1;
static gint ett_umts_rrc_ies_PLMNIdentitiesOfNeighbourCells = -1;
static gint ett_umts_rrc_ies_PLMNsOfInterFreqCellsList = -1;
static gint ett_umts_rrc_ies_PLMNsOfInterFreqCellsList_item = -1;
static gint ett_umts_rrc_ies_PLMNsOfIntraFreqCellsList = -1;
static gint ett_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item = -1;
static gint ett_umts_rrc_ies_PLMNsOfInterRATCellsList = -1;
static gint ett_umts_rrc_ies_PLMNsOfInterRATCellsList_item = -1;
static gint ett_umts_rrc_ies_PositionEstimate = -1;
static gint ett_umts_rrc_ies_QualityEventResults = -1;
static gint ett_umts_rrc_ies_QualityMeasuredResults = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo63 = -1;
static gint ett_umts_rrc_ies_T_tdd63 = -1;
static gint ett_umts_rrc_ies_QualityMeasurement = -1;
static gint ett_umts_rrc_ies_QualityReportCriteria = -1;
static gint ett_umts_rrc_ies_QualityReportingCriteria = -1;
static gint ett_umts_rrc_ies_QualityReportingCriteriaSingle = -1;
static gint ett_umts_rrc_ies_QualityReportingQuantity = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo64 = -1;
static gint ett_umts_rrc_ies_T_tdd64 = -1;
static gint ett_umts_rrc_ies_ReferenceCellPosition = -1;
static gint ett_umts_rrc_ies_ReferenceLocation = -1;
static gint ett_umts_rrc_ies_ReferenceTimeDifferenceToCell = -1;
static gint ett_umts_rrc_ies_RemovedInterFreqCellList = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID = -1;
static gint ett_umts_rrc_ies_RemovedInterRATCellList = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID = -1;
static gint ett_umts_rrc_ies_RemovedIntraFreqCellList = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID = -1;
static gint ett_umts_rrc_ies_ReportingCellStatus = -1;
static gint ett_umts_rrc_ies_ReportingCellStatusOpt = -1;
static gint ett_umts_rrc_ies_ReportingInfoForCellDCH = -1;
static gint ett_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4 = -1;
static gint ett_umts_rrc_ies_RL_AdditionInfoList = -1;
static gint ett_umts_rrc_ies_RL_InformationLists = -1;
static gint ett_umts_rrc_ies_SatData = -1;
static gint ett_umts_rrc_ies_SatDataList = -1;
static gint ett_umts_rrc_ies_SFN_SFN_ObsTimeDifference = -1;
static gint ett_umts_rrc_ies_SFN_SFN_RelTimeDifference1 = -1;
static gint ett_umts_rrc_ies_SIR_MeasurementList = -1;
static gint ett_umts_rrc_ies_SIR_MeasurementResults = -1;
static gint ett_umts_rrc_ies_SIR_TFCS_List = -1;
static gint ett_umts_rrc_ies_SIR_TimeslotList = -1;
static gint ett_umts_rrc_ies_SubFrame1Reserved = -1;
static gint ett_umts_rrc_ies_T_ADVinfo = -1;
static gint ett_umts_rrc_ies_T_CRMax = -1;
static gint ett_umts_rrc_ies_TemporaryOffsetList = -1;
static gint ett_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList = -1;
static gint ett_umts_rrc_ies_TimeslotInfo = -1;
static gint ett_umts_rrc_ies_TimeslotInfo_LCR_r4 = -1;
static gint ett_umts_rrc_ies_TimeslotInfoList = -1;
static gint ett_umts_rrc_ies_TimeslotInfoList_LCR_r4 = -1;
static gint ett_umts_rrc_ies_TimeslotInfoList_r4 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4 = -1;
static gint ett_umts_rrc_ies_TimeslotISCP_List = -1;
static gint ett_umts_rrc_ies_TimeslotListWithISCP = -1;
static gint ett_umts_rrc_ies_TimeslotWithISCP = -1;
static gint ett_umts_rrc_ies_TrafficVolumeEventParam = -1;
static gint ett_umts_rrc_ies_TrafficVolumeEventResults = -1;
static gint ett_umts_rrc_ies_TrafficVolumeMeasQuantity = -1;
static gint ett_umts_rrc_ies_TrafficVolumeMeasSysInfo = -1;
static gint ett_umts_rrc_ies_TrafficVolumeMeasuredResults = -1;
static gint ett_umts_rrc_ies_TrafficVolumeMeasuredResultsList = -1;
static gint ett_umts_rrc_ies_TrafficVolumeMeasurement = -1;
static gint ett_umts_rrc_ies_TrafficVolumeMeasurementObjectList = -1;
static gint ett_umts_rrc_ies_TrafficVolumeReportCriteria = -1;
static gint ett_umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo = -1;
static gint ett_umts_rrc_ies_TrafficVolumeReportingCriteria = -1;
static gint ett_umts_rrc_ies_TrafficVolumeReportingQuantity = -1;
static gint ett_umts_rrc_ies_TransChCriteria = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam = -1;
static gint ett_umts_rrc_ies_TransChCriteriaList = -1;
static gint ett_umts_rrc_ies_UE_6AB_Event = -1;
static gint ett_umts_rrc_ies_UE_6FG_Event = -1;
static gint ett_umts_rrc_ies_UE_AutonomousUpdateMode = -1;
static gint ett_umts_rrc_ies_UE_InternalEventParam = -1;
static gint ett_umts_rrc_ies_UE_InternalEventParamList = -1;
static gint ett_umts_rrc_ies_UE_InternalEventResults = -1;
static gint ett_umts_rrc_ies_UE_InternalMeasQuantity = -1;
static gint ett_umts_rrc_ies_UE_InternalMeasuredResults = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo65 = -1;
static gint ett_umts_rrc_ies_T_fdd72 = -1;
static gint ett_umts_rrc_ies_T_tdd65 = -1;
static gint ett_umts_rrc_ies_UE_InternalMeasuredResults_LCR_r4 = -1;
static gint ett_umts_rrc_ies_UE_InternalMeasurement = -1;
static gint ett_umts_rrc_ies_UE_InternalMeasurement_r4 = -1;
static gint ett_umts_rrc_ies_UE_InternalMeasurementSysInfo = -1;
static gint ett_umts_rrc_ies_UE_InternalReportCriteria = -1;
static gint ett_umts_rrc_ies_UE_InternalReportingCriteria = -1;
static gint ett_umts_rrc_ies_UE_InternalReportingQuantity = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo66 = -1;
static gint ett_umts_rrc_ies_T_fdd73 = -1;
static gint ett_umts_rrc_ies_T_tdd66 = -1;
static gint ett_umts_rrc_ies_UE_InternalReportingQuantity_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo67 = -1;
static gint ett_umts_rrc_ies_T_fdd74 = -1;
static gint ett_umts_rrc_ies_T_tdd67 = -1;
static gint ett_umts_rrc_ies_T_tddOption14 = -1;
static gint ett_umts_rrc_ies_T_tdd38414 = -1;
static gint ett_umts_rrc_ies_T_tdd12816 = -1;
static gint ett_umts_rrc_ies_UE_RX_TX_ReportEntry = -1;
static gint ett_umts_rrc_ies_UE_RX_TX_ReportEntryList = -1;
static gint ett_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2Info = -1;
static gint ett_umts_rrc_ies_UE_TransmittedPowerTDD_List = -1;
static gint ett_umts_rrc_ies_UL_TrCH_Identity = -1;
static gint ett_umts_rrc_ies_UE_Positioning_CipherParameters = -1;
static gint ett_umts_rrc_ies_UE_Positioning_Error = -1;
static gint ett_umts_rrc_ies_UE_Positioning_EventParam = -1;
static gint ett_umts_rrc_ies_UE_Positioning_EventParamList = -1;
static gint ett_umts_rrc_ies_UE_Positioning_EventSpecificInfo = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_AcquisitionAssistance = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_AdditionalAssistanceDataRequest = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_Almanac = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_AssistanceData = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_DGPS_Corrections = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_IonosphericModel = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_MeasurementResults = -1;
static gint ett_umts_rrc_ies_T_referenceTime = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_NavigationModel = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_NavModelAddDataReq = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_ReferenceCellInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo68 = -1;
static gint ett_umts_rrc_ies_T_fdd75 = -1;
static gint ett_umts_rrc_ies_T_tdd68 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_ReferenceTime = -1;
static gint ett_umts_rrc_ies_UE_Positioning_GPS_UTC_Model = -1;
static gint ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters = -1;
static gint ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo69 = -1;
static gint ett_umts_rrc_ies_T_fdd76 = -1;
static gint ett_umts_rrc_ies_T_tdd69 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_MeasuredResults = -1;
static gint ett_umts_rrc_ies_UE_Positioning_MeasuredResults_v390ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_Measurement = -1;
static gint ett_umts_rrc_ies_UE_Positioning_Measurement_v390ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_Measurement_r4 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_MeasurementEventResults = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_UEB = -1;
static gint ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_Measurement = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo70 = -1;
static gint ett_umts_rrc_ies_T_fdd77 = -1;
static gint ett_umts_rrc_ies_T_tdd70 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_Measurement_v390ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo71 = -1;
static gint ett_umts_rrc_ies_T_fdd78 = -1;
static gint ett_umts_rrc_ies_T_tdd71 = -1;
static gint ett_umts_rrc_ies_T_positioningMode = -1;
static gint ett_umts_rrc_ies_T_ueBased = -1;
static gint ett_umts_rrc_ies_T_ueAssisted = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo72 = -1;
static gint ett_umts_rrc_ies_T_fdd79 = -1;
static gint ett_umts_rrc_ies_T_tdd72 = -1;
static gint ett_umts_rrc_ies_T_positioningMode1 = -1;
static gint ett_umts_rrc_ies_T_ueBased1 = -1;
static gint ett_umts_rrc_ies_T_ueAssisted1 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_UEB = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo73 = -1;
static gint ett_umts_rrc_ies_T_fdd80 = -1;
static gint ett_umts_rrc_ies_T_tdd73 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_Quality = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo74 = -1;
static gint ett_umts_rrc_ies_T_fdd81 = -1;
static gint ett_umts_rrc_ies_T_tdd74 = -1;
static gint ett_umts_rrc_ies_T_positioningMode2 = -1;
static gint ett_umts_rrc_ies_T_ueBased2 = -1;
static gint ett_umts_rrc_ies_T_ueAssisted2 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_r4 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo75 = -1;
static gint ett_umts_rrc_ies_T_fdd82 = -1;
static gint ett_umts_rrc_ies_T_tdd75 = -1;
static gint ett_umts_rrc_ies_T_positioningMode3 = -1;
static gint ett_umts_rrc_ies_T_ueBased3 = -1;
static gint ett_umts_rrc_ies_T_ueAssisted3 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_UEB = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo76 = -1;
static gint ett_umts_rrc_ies_T_fdd83 = -1;
static gint ett_umts_rrc_ies_T_tdd76 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_PositionEstimateInfo = -1;
static gint ett_umts_rrc_ies_T_referenceTime1 = -1;
static gint ett_umts_rrc_ies_T_cell_Timing = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo77 = -1;
static gint ett_umts_rrc_ies_T_fdd84 = -1;
static gint ett_umts_rrc_ies_T_tdd77 = -1;
static gint ett_umts_rrc_ies_UE_Positioning_ReportCriteria = -1;
static gint ett_umts_rrc_ies_UE_Positioning_ReportingQuantity = -1;
static gint ett_umts_rrc_ies_UE_Positioning_ReportingQuantity_v390ext = -1;
static gint ett_umts_rrc_ies_UE_Positioning_ReportingQuantity_r4 = -1;
static gint ett_umts_rrc_ies_UTRAN_GPSReferenceTime = -1;
static gint ett_umts_rrc_ies_T_utran_GPSTimingOfCell = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo78 = -1;
static gint ett_umts_rrc_ies_T_fdd85 = -1;
static gint ett_umts_rrc_ies_T_tdd78 = -1;
static gint ett_umts_rrc_ies_UTRAN_GPSReferenceTimeResult = -1;
static gint ett_umts_rrc_ies_T_ue_GPSTimingOfCell = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo79 = -1;
static gint ett_umts_rrc_ies_T_fdd86 = -1;
static gint ett_umts_rrc_ies_T_tdd79 = -1;
static gint ett_umts_rrc_ies_BCCH_ModificationInfo = -1;
static gint ett_umts_rrc_ies_BSIC = -1;
static gint ett_umts_rrc_ies_CBS_DRX_Level1Information = -1;
static gint ett_umts_rrc_ies_CDMA2000_Message = -1;
static gint ett_umts_rrc_ies_CDMA2000_MessageList = -1;
static gint ett_umts_rrc_ies_CDMA2000_UMTS_Frequency_List = -1;
static gint ett_umts_rrc_ies_FDD_UMTS_Frequency_List = -1;
static gint ett_umts_rrc_ies_FrequencyInfoCDMA2000 = -1;
static gint ett_umts_rrc_ies_GERAN_SystemInformation = -1;
static gint ett_umts_rrc_ies_GSM_BA_Range = -1;
static gint ett_umts_rrc_ies_GSM_BA_Range_List = -1;
static gint ett_umts_rrc_ies_GSM_MessageList = -1;
static gint ett_umts_rrc_ies_GsmSecurityCapability = -1;
static gint ett_umts_rrc_ies_GSMSecurityCapability_v6xyext = -1;
static gint ett_umts_rrc_ies_GSM_TargetCellInfoList = -1;
static gint ett_umts_rrc_ies_GSM_TargetCellInfo = -1;
static gint ett_umts_rrc_ies_IdentificationOfReceivedMessage = -1;
static gint ett_umts_rrc_ies_InterRAT_ChangeFailureCause = -1;
static gint ett_umts_rrc_ies_GERANIu_MessageList = -1;
static gint ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability = -1;
static gint ett_umts_rrc_ies_T_gsm10 = -1;
static gint ett_umts_rrc_ies_T_cdma2000 = -1;
static gint ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList = -1;
static gint ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v590ext = -1;
static gint ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v6xyext = -1;
static gint ett_umts_rrc_ies_InterRAT_UE_SecurityCapability = -1;
static gint ett_umts_rrc_ies_T_gsm11 = -1;
static gint ett_umts_rrc_ies_InterRAT_UE_SecurityCapList = -1;
static gint ett_umts_rrc_ies_InterRAT_HO_FailureCause = -1;
static gint ett_umts_rrc_ies_MasterInformationBlock = -1;
static gint ett_umts_rrc_ies_T_v6xyNonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions1 = -1;
static gint ett_umts_rrc_ies_MasterInformationBlock_v6xyext = -1;
static gint ett_umts_rrc_ies_PredefinedConfigIdentityAndValueTag = -1;
static gint ett_umts_rrc_ies_ProtocolErrorInformation = -1;
static gint ett_umts_rrc_ies_T_diagnosticsType1 = -1;
static gint ett_umts_rrc_ies_T_type13 = -1;
static gint ett_umts_rrc_ies_Rplmn_Information = -1;
static gint ett_umts_rrc_ies_Rplmn_Information_r4 = -1;
static gint ett_umts_rrc_ies_SchedulingInformation = -1;
static gint ett_umts_rrc_ies_T_scheduling = -1;
static gint ett_umts_rrc_ies_T_sib_Pos = -1;
static gint ett_umts_rrc_ies_SchedulingInformationSIB = -1;
static gint ett_umts_rrc_ies_SchedulingInformationSIBSb = -1;
static gint ett_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag = -1;
static gint ett_umts_rrc_ies_SIB_ReferenceList = -1;
static gint ett_umts_rrc_ies_SIBSb_ReferenceList = -1;
static gint ett_umts_rrc_ies_SIB_ReferenceListFACH = -1;
static gint ett_umts_rrc_ies_SIB_TypeAndTag = -1;
static gint ett_umts_rrc_ies_SIBSb_TypeAndTag = -1;
static gint ett_umts_rrc_ies_SibOFF_List = -1;
static gint ett_umts_rrc_ies_SysInfoType1 = -1;
static gint ett_umts_rrc_ies_T_v3a0NonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions2 = -1;
static gint ett_umts_rrc_ies_SysInfoType1_v3a0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType2 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions3 = -1;
static gint ett_umts_rrc_ies_SysInfoType3 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtension = -1;
static gint ett_umts_rrc_ies_T_v5c0NoncriticalExtension = -1;
static gint ett_umts_rrc_ies_T_v670NonCriticalExtension = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions4 = -1;
static gint ett_umts_rrc_ies_SysInfoType3_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType3_v590ext = -1;
static gint ett_umts_rrc_ies_SysInfoType3_v5c0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType3_v670ext = -1;
static gint ett_umts_rrc_ies_SysInfoType4 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions1 = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtension1 = -1;
static gint ett_umts_rrc_ies_T_v5b0NonCriticalExtension = -1;
static gint ett_umts_rrc_ies_T_v5c0NonCriticalExtension = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions5 = -1;
static gint ett_umts_rrc_ies_SysInfoType4_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType4_v590ext = -1;
static gint ett_umts_rrc_ies_SysInfoType4_v5b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType4_v5c0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType5 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo80 = -1;
static gint ett_umts_rrc_ies_T_fdd87 = -1;
static gint ett_umts_rrc_ies_T_tdd80 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions2 = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_v650NonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_v6xyNonCriticalExtensions1 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions6 = -1;
static gint ett_umts_rrc_ies_SysInfoType5_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_T_tdd128SpecificInfo = -1;
static gint ett_umts_rrc_ies_SysInfoType5_v590ext_IEs = -1;
static gint ett_umts_rrc_ies_T_hcr_r5_SpecificInfo = -1;
static gint ett_umts_rrc_ies_SysInfoType5_v650ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType5_v6xyext_IEs = -1;
static gint ett_umts_rrc_ies_T_sccpch_SystemInformation_MBMS = -1;
static gint ett_umts_rrc_ies_SysInfoType6 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo81 = -1;
static gint ett_umts_rrc_ies_T_fdd88 = -1;
static gint ett_umts_rrc_ies_T_tdd81 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions3 = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtensions1 = -1;
static gint ett_umts_rrc_ies_T_v650nonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_v6xynonCriticalExtensions = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions7 = -1;
static gint ett_umts_rrc_ies_SysInfoType6_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_T_tdd128SpecificInfo1 = -1;
static gint ett_umts_rrc_ies_SysInfoType6_v590ext_IEs = -1;
static gint ett_umts_rrc_ies_T_hcr_r5_SpecificInfo1 = -1;
static gint ett_umts_rrc_ies_SysInfoType6_v650ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType6_v6xyext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType7 = -1;
static gint ett_umts_rrc_ies_T_modeSpecificInfo82 = -1;
static gint ett_umts_rrc_ies_T_fdd89 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions8 = -1;
static gint ett_umts_rrc_ies_SysInfoType8 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions9 = -1;
static gint ett_umts_rrc_ies_SysInfoType9 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions10 = -1;
static gint ett_umts_rrc_ies_SysInfoType10 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions11 = -1;
static gint ett_umts_rrc_ies_SysInfoType11 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions4 = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtension2 = -1;
static gint ett_umts_rrc_ies_T_v6xyNonCriticalExtensions2 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions12 = -1;
static gint ett_umts_rrc_ies_SysInfoType11_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType11_v590ext_IEs = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext = -1;
static gint ett_umts_rrc_ies_SysInfoType11_v6xyext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType12 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions5 = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtension3 = -1;
static gint ett_umts_rrc_ies_T_v6xyNonCriticalExtensions3 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions13 = -1;
static gint ett_umts_rrc_ies_SysInfoType12_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType12_v590ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType12_v6xyext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType13 = -1;
static gint ett_umts_rrc_ies_T_v3a0NonCriticalExtensions1 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions6 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions14 = -1;
static gint ett_umts_rrc_ies_SysInfoType13_v3a0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType13_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType13_1 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions15 = -1;
static gint ett_umts_rrc_ies_SysInfoType13_2 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions16 = -1;
static gint ett_umts_rrc_ies_SysInfoType13_3 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions17 = -1;
static gint ett_umts_rrc_ies_SysInfoType13_4 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions18 = -1;
static gint ett_umts_rrc_ies_SysInfoType14 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions19 = -1;
static gint ett_umts_rrc_ies_SysInfoType15 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions7 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions20 = -1;
static gint ett_umts_rrc_ies_SysInfoType15_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_SysInfoType15_1 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions21 = -1;
static gint ett_umts_rrc_ies_SysInfoType15_2 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions22 = -1;
static gint ett_umts_rrc_ies_SysInfoType15_3 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions23 = -1;
static gint ett_umts_rrc_ies_SysInfoType15_4 = -1;
static gint ett_umts_rrc_ies_T_v3a0NonCriticalExtensions2 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions8 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions24 = -1;
static gint ett_umts_rrc_ies_SysInfoType15_4_v3a0ext = -1;
static gint ett_umts_rrc_ies_SysInfoType15_4_v4b0ext = -1;
static gint ett_umts_rrc_ies_SysInfoType15_5 = -1;
static gint ett_umts_rrc_ies_T_v3a0NonCriticalExtensions3 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions25 = -1;
static gint ett_umts_rrc_ies_SysInfoType15_5_v3a0ext = -1;
static gint ett_umts_rrc_ies_SysInfoType16 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions26 = -1;
static gint ett_umts_rrc_ies_SysInfoType17 = -1;
static gint ett_umts_rrc_ies_T_v4b0NonCriticalExtensions9 = -1;
static gint ett_umts_rrc_ies_T_v590NonCriticalExtensions2 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions27 = -1;
static gint ett_umts_rrc_ies_SysInfoType17_v4b0ext_IEs = -1;
static gint ett_umts_rrc_ies_T_tdd128SpecificInfo2 = -1;
static gint ett_umts_rrc_ies_SysInfoType17_v590ext_IEs = -1;
static gint ett_umts_rrc_ies_T_hcr_r5_SpecificInfo2 = -1;
static gint ett_umts_rrc_ies_SysInfoType18 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions28 = -1;
static gint ett_umts_rrc_ies_SysInfoTypeSB1 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions29 = -1;
static gint ett_umts_rrc_ies_SysInfoTypeSB2 = -1;
static gint ett_umts_rrc_ies_T_nonCriticalExtensions30 = -1;
static gint ett_umts_rrc_ies_TDD_UMTS_Frequency_List = -1;
static gint ett_umts_rrc_ies_MBMS_CommonRBInformation_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_CommonRBInformationList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_ConnectedModeCountingScope = -1;
static gint ett_umts_rrc_ies_MBMS_CurrentCell_SCCPCH_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_FACHCarryingMTCH_List = -1;
static gint ett_umts_rrc_ies_MBMS_JoinedInformation_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule_32 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule_64 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList1 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item1 = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule_128 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList2 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item2 = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule_256 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList3 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item3 = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule_512 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList4 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item4 = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule_1024 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList5 = -1;
static gint ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item5 = -1;
static gint ett_umts_rrc_ies_MBMS_L1CombiningSchedule = -1;
static gint ett_umts_rrc_ies_MBMS_L23Configuration = -1;
static gint ett_umts_rrc_ies_T_sameAsCurrent = -1;
static gint ett_umts_rrc_ies_T_different = -1;
static gint ett_umts_rrc_ies_MBMS_MCCH_ConfigurationInfo_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_MICHConfigurationInfo_r6 = -1;
static gint ett_umts_rrc_ies_T_mode = -1;
static gint ett_umts_rrc_ies_T_fdd90 = -1;
static gint ett_umts_rrc_ies_T_tdd38415 = -1;
static gint ett_umts_rrc_ies_T_tdd12817 = -1;
static gint ett_umts_rrc_ies_SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode = -1;
static gint ett_umts_rrc_ies_MBMS_ModifedService_r6 = -1;
static gint ett_umts_rrc_ies_T_mbms_PreferredFrequency = -1;
static gint ett_umts_rrc_ies_MBMS_ModifedServiceList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_MSCHSchedulingInfo = -1;
static gint ett_umts_rrc_ies_MBMS_NeighbouringCellSCCPCH_r6 = -1;
static gint ett_umts_rrc_ies_T_layer1Combining = -1;
static gint ett_umts_rrc_ies_T_fdd91 = -1;
static gint ett_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_PhyChInformation_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_PhyChInformationList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_PreferredFreqRequest_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_PreferredFrequencyInfo_r6 = -1;
static gint ett_umts_rrc_ies_T_layerConvergenceInformation = -1;
static gint ett_umts_rrc_ies_MBMS_PreferredFrequencyList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_PTM_RBInformation_C = -1;
static gint ett_umts_rrc_ies_MBMS_PTM_RBInformation_CList = -1;
static gint ett_umts_rrc_ies_MBMS_PTM_RBInformation_N = -1;
static gint ett_umts_rrc_ies_MBMS_PTM_RBInformation_NList = -1;
static gint ett_umts_rrc_ies_MBMS_PTM_RBInformation_S = -1;
static gint ett_umts_rrc_ies_MBMS_PTM_RBInformation_SList = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceAccessInfo_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceIdentity = -1;
static gint ett_umts_rrc_ies_T_plmn_Identity = -1;
static gint ett_umts_rrc_ies_T_other1 = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceSchedulingInfo_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceTransmInfo = -1;
static gint ett_umts_rrc_ies_MBMS_ServiceTransmInfoList = -1;
static gint ett_umts_rrc_ies_MBMS_SIBType5_SCCPCH_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_TimersAndCouneters_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_TransmissionIdentity = -1;
static gint ett_umts_rrc_ies_MBMS_TranspChInfoForCCTrCh_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_TranspChInfoForTrCh_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_TrCHInformation_Comm = -1;
static gint ett_umts_rrc_ies_MBMS_TrCHInformation_CommList = -1;
static gint ett_umts_rrc_ies_MBMS_TrCHInformation_Neighb = -1;
static gint ett_umts_rrc_ies_MBMS_TrCHInformation_NeighbList = -1;
static gint ett_umts_rrc_ies_MBMS_TrCHInformation_SIB5 = -1;
static gint ett_umts_rrc_ies_MBMS_TrCHInformation_SIB5List = -1;
static gint ett_umts_rrc_ies_MBMS_UnmodifiedService_r6 = -1;
static gint ett_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6 = -1;

/*--- End of included file: packet-umts_rrc_ies-ett.c ---*/
#line 64 "packet-umts_rrc_ies-template.c"


/*--- Included file: packet-umts_rrc_ies-fn.c ---*/
#line 1 "packet-umts_rrc_ies-fn.c"


static int
dissect_umts_rrc_ies_Ansi_41_IDNNS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     14, 14, FALSE, NULL);

  return offset;
}


const value_string umts_rrc_ies_CN_DomainIdentity_vals[] = {
  {   0, "cs-domain" },
  {   1, "ps-domain" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_CN_DomainIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       1, 8, NULL);

  return offset;
}


static const per_sequence_t CN_DomainInformation_sequence[] = {
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_cn_DomainSpecificNAS_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CN_DomainInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CN_DomainInformation, CN_DomainInformation_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_CN_DRX_CycleLengthCoefficient(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              6U, 9U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CN_DomainInformationFull_sequence[] = {
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_cn_DomainSpecificNAS_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  { &hf_umts_rrc_ies_cn_DRX_CycleLengthCoeff, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DRX_CycleLengthCoefficient },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CN_DomainInformationFull(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CN_DomainInformationFull, CN_DomainInformationFull_sequence);

  return offset;
}


static const per_sequence_t CN_DomainInformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CN_DomainInformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainInformation },
};

static int
dissect_umts_rrc_ies_CN_DomainInformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CN_DomainInformationList, CN_DomainInformationList_sequence_of,
                                                  1, maxCNdomains);

  return offset;
}


static const per_sequence_t CN_DomainInformationListFull_sequence_of[1] = {
  { &hf_umts_rrc_ies_CN_DomainInformationListFull_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainInformationFull },
};

static int
dissect_umts_rrc_ies_CN_DomainInformationListFull(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CN_DomainInformationListFull, CN_DomainInformationListFull_sequence_of,
                                                  1, maxCNdomains);

  return offset;
}



static int
dissect_umts_rrc_ies_ANSI_41_NAS_Parameter(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 2048, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NAS_SystemInformationANSI_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_ANSI_41_NAS_Parameter(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string umts_rrc_ies_T_cn_Type_vals[] = {
  {   0, "gsm-MAP" },
  {   1, "ansi-41" },
  { 0, NULL }
};

static const per_choice_t T_cn_Type_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm_MAP, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  {   1, &hf_umts_rrc_ies_ansi_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NAS_SystemInformationANSI_41 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cn_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cn_Type, T_cn_Type_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CN_DomainSysInfo_sequence[] = {
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_cn_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cn_Type },
  { &hf_umts_rrc_ies_cn_DRX_CycleLengthCoeff, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DRX_CycleLengthCoefficient },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CN_DomainSysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CN_DomainSysInfo, CN_DomainSysInfo_sequence);

  return offset;
}


static const per_sequence_t CN_DomainSysInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CN_DomainSysInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainSysInfo },
};

static int
dissect_umts_rrc_ies_CN_DomainSysInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CN_DomainSysInfoList, CN_DomainSysInfoList_sequence_of,
                                                  1, maxCNdomains);

  return offset;
}



static int
dissect_umts_rrc_ies_Digit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 9U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MCC_sequence_of[1] = {
  { &hf_umts_rrc_ies_MCC_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Digit },
};

static int
dissect_umts_rrc_ies_MCC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MCC, MCC_sequence_of,
                                                  3, 3);

  return offset;
}


static const per_sequence_t MNC_sequence_of[1] = {
  { &hf_umts_rrc_ies_MNC_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Digit },
};

static int
dissect_umts_rrc_ies_MNC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MNC, MNC_sequence_of,
                                                  2, 3);

  return offset;
}


static const per_sequence_t PLMN_Identity_sequence[] = {
  { &hf_umts_rrc_ies_mcc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MCC },
  { &hf_umts_rrc_ies_mnc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MNC },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PLMN_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PLMN_Identity, PLMN_Identity_sequence);

  return offset;
}


static const per_sequence_t CN_InformationInfo_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { &hf_umts_rrc_ies_cn_CommonGSM_MAP_NAS_SysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  { &hf_umts_rrc_ies_cn_DomainInformationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CN_DomainInformationList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CN_InformationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CN_InformationInfo, CN_InformationInfo_sequence);

  return offset;
}


static const per_sequence_t CN_InformationInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { &hf_umts_rrc_ies_cn_CommonGSM_MAP_NAS_SysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  { &hf_umts_rrc_ies_cn_DomainInformationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CN_DomainInformationList },
  { &hf_umts_rrc_ies_primary_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CN_InformationInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CN_InformationInfo_r6, CN_InformationInfo_r6_sequence);

  return offset;
}


static const per_sequence_t CN_InformationInfoFull_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { &hf_umts_rrc_ies_cn_CommonGSM_MAP_NAS_SysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  { &hf_umts_rrc_ies_cn_DomainInformationListFull, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CN_DomainInformationListFull },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CN_InformationInfoFull(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CN_InformationInfoFull, CN_InformationInfoFull_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_RoutingParameter(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     10, 10, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_localPTMSI_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_localPTMSI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_localPTMSI, T_localPTMSI_sequence);

  return offset;
}


static const per_sequence_t T_tMSIofsamePLMN_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tMSIofsamePLMN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tMSIofsamePLMN, T_tMSIofsamePLMN_sequence);

  return offset;
}


static const per_sequence_t T_tMSIofdifferentPLMN_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tMSIofdifferentPLMN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tMSIofdifferentPLMN, T_tMSIofdifferentPLMN_sequence);

  return offset;
}


static const per_sequence_t T_iMSIresponsetopaging_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_iMSIresponsetopaging(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_iMSIresponsetopaging, T_iMSIresponsetopaging_sequence);

  return offset;
}


static const per_sequence_t T_iMSIcauseUEinitiatedEvent_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_iMSIcauseUEinitiatedEvent(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_iMSIcauseUEinitiatedEvent, T_iMSIcauseUEinitiatedEvent_sequence);

  return offset;
}


static const per_sequence_t T_iMEI_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_iMEI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_iMEI, T_iMEI_sequence);

  return offset;
}


static const per_sequence_t T_spare2_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_spare2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_spare2, T_spare2_sequence);

  return offset;
}


static const per_sequence_t T_spare1_sequence[] = {
  { &hf_umts_rrc_ies_routingparameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_spare1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_spare1, T_spare1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_routingbasis_vals[] = {
  {   0, "localPTMSI" },
  {   1, "tMSIofsamePLMN" },
  {   2, "tMSIofdifferentPLMN" },
  {   3, "iMSIresponsetopaging" },
  {   4, "iMSIcauseUEinitiatedEvent" },
  {   5, "iMEI" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};

static const per_choice_t T_routingbasis_choice[] = {
  {   0, &hf_umts_rrc_ies_localPTMSI, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_localPTMSI },
  {   1, &hf_umts_rrc_ies_tMSIofsamePLMN, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tMSIofsamePLMN },
  {   2, &hf_umts_rrc_ies_tMSIofdifferentPLMN, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tMSIofdifferentPLMN },
  {   3, &hf_umts_rrc_ies_iMSIresponsetopaging, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_iMSIresponsetopaging },
  {   4, &hf_umts_rrc_ies_iMSIcauseUEinitiatedEvent, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_iMSIcauseUEinitiatedEvent },
  {   5, &hf_umts_rrc_ies_iMEI   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_iMEI },
  {   6, &hf_umts_rrc_ies_spare2 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_spare2 },
  {   7, &hf_umts_rrc_ies_spare1 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_spare1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_routingbasis(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_routingbasis, T_routingbasis_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BOOLEAN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_boolean(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t Gsm_map_IDNNS_sequence[] = {
  { &hf_umts_rrc_ies_routingbasis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_routingbasis },
  { &hf_umts_rrc_ies_dummy_BOOLEAN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Gsm_map_IDNNS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Gsm_map_IDNNS, Gsm_map_IDNNS_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_IMEI_Digit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t IMEI_sequence_of[1] = {
  { &hf_umts_rrc_ies_IMEI_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IMEI_Digit },
};

static int
dissect_umts_rrc_ies_IMEI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IMEI, IMEI_sequence_of,
                                                  15, 15);

  return offset;
}


static const per_sequence_t IMSI_GSM_MAP_sequence_of[1] = {
  { &hf_umts_rrc_ies_IMSI_GSM_MAP_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Digit },
};

static int
dissect_umts_rrc_ies_IMSI_GSM_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IMSI_GSM_MAP, IMSI_GSM_MAP_sequence_of,
                                                  6, 21);

  return offset;
}


static const value_string umts_rrc_ies_T_cn_Type1_vals[] = {
  {   0, "gsm-Map-IDNNS" },
  {   1, "ansi-41-IDNNS" },
  { 0, NULL }
};

static const per_choice_t T_cn_Type1_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm_Map_IDNNS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Gsm_map_IDNNS },
  {   1, &hf_umts_rrc_ies_ansi_41_IDNNS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Ansi_41_IDNNS },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cn_Type1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cn_Type1, T_cn_Type1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_release99_sequence[] = {
  { &hf_umts_rrc_ies_cn_Type1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cn_Type1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_release99(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_release99, T_release99_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     15, 15, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_later_sequence[] = {
  { &hf_umts_rrc_ies_futurecoding, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_15 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_later(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_later, T_later_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_version_vals[] = {
  {   0, "release99" },
  {   1, "later" },
  { 0, NULL }
};

static const per_choice_t T_version_choice[] = {
  {   0, &hf_umts_rrc_ies_release99, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_release99 },
  {   1, &hf_umts_rrc_ies_later  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_later },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_version(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_version, T_version_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraDomainNasNodeSelector_sequence[] = {
  { &hf_umts_rrc_ies_version, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_version },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_IntraDomainNasNodeSelector(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraDomainNasNodeSelector, IntraDomainNasNodeSelector_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const per_sequence_t LAI_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMN_Identity },
  { &hf_umts_rrc_ies_lac    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_LAI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_LAI, LAI_sequence);

  return offset;
}


static const per_sequence_t PLMN_IdentityWithOptionalMCC_r6_sequence[] = {
  { &hf_umts_rrc_ies_mcc    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MCC },
  { &hf_umts_rrc_ies_mnc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MNC },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PLMN_IdentityWithOptionalMCC_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PLMN_IdentityWithOptionalMCC_r6, PLMN_IdentityWithOptionalMCC_r6_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_multiplePLMNs_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMN_IdentityWithOptionalMCC_r6 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6, SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6_sequence_of,
                                                  1, 5);

  return offset;
}


static const per_sequence_t MultiplePLMN_List_r6_sequence[] = {
  { &hf_umts_rrc_ies_mibPLMN_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_multiplePLMNs, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MultiplePLMN_List_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MultiplePLMN_List_r6, MultiplePLMN_List_r6_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_NAS_Message(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       1, 4095, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NAS_Synchronisation_Indicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     4, 4, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_P_TMSI_GSM_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     32, 32, FALSE, NULL);

  return offset;
}


const value_string umts_rrc_ies_PagingRecordTypeID_vals[] = {
  {   0, "imsi-GSM-MAP" },
  {   1, "tmsi-GSM-MAP-P-TMSI" },
  {   2, "imsi-DS-41" },
  {   3, "tmsi-DS-41" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_PagingRecordTypeID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_gsm_MAP_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMN_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm_MAP, T_gsm_MAP_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_P_REV(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_Min_P_REV(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_SID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     15, 15, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_ansi_41_sequence[] = {
  { &hf_umts_rrc_ies_p_REV  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_P_REV },
  { &hf_umts_rrc_ies_min_P_REV, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Min_P_REV },
  { &hf_umts_rrc_ies_sid    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SID },
  { &hf_umts_rrc_ies_nid    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ansi_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ansi_41, T_ansi_41_sequence);

  return offset;
}


static const per_sequence_t T_gsm_MAP_and_ANSI_41_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMN_Identity },
  { &hf_umts_rrc_ies_p_REV  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_P_REV },
  { &hf_umts_rrc_ies_min_P_REV, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Min_P_REV },
  { &hf_umts_rrc_ies_sid    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SID },
  { &hf_umts_rrc_ies_nid    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm_MAP_and_ANSI_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm_MAP_and_ANSI_41, T_gsm_MAP_and_ANSI_41_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_NULL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string umts_rrc_ies_PLMN_Type_vals[] = {
  {   0, "gsm-MAP" },
  {   1, "ansi-41" },
  {   2, "gsm-MAP-and-ANSI-41" },
  {   3, "spare" },
  { 0, NULL }
};

static const per_choice_t PLMN_Type_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm_MAP1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm_MAP },
  {   1, &hf_umts_rrc_ies_ansi_411, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ansi_41 },
  {   2, &hf_umts_rrc_ies_gsm_MAP_and_ANSI_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm_MAP_and_ANSI_41 },
  {   3, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PLMN_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PLMN_Type, PLMN_Type_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_RAB_Identity_vals[] = {
  {   0, "gsm-MAP-RAB-Identity" },
  {   1, "ansi-41-RAB-Identity" },
  { 0, NULL }
};

static const per_choice_t RAB_Identity_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm_MAP_RAB_Identity, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  {   1, &hf_umts_rrc_ies_ansi_41_RAB_Identity, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RAB_Identity, RAB_Identity_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_RoutingAreaCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const per_sequence_t RAI_sequence[] = {
  { &hf_umts_rrc_ies_lai    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LAI },
  { &hf_umts_rrc_ies_rac    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RoutingAreaCode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAI, RAI_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TMSI_GSM_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     32, 32, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_AccessClassBarred_vals[] = {
  {   0, "barred" },
  {   1, "notBarred" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_AccessClassBarred(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t AccessClassBarredList_sequence_of[1] = {
  { &hf_umts_rrc_ies_AccessClassBarredList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AccessClassBarred },
};

static int
dissect_umts_rrc_ies_AccessClassBarredList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AccessClassBarredList, AccessClassBarredList_sequence_of,
                                                  maxAC, maxAC);

  return offset;
}


static const value_string umts_rrc_ies_AllowedIndicator_vals[] = {
  {   0, "allowed" },
  {   1, "notAllowed" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_AllowedIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_Barred_vals[] = {
  {   0, "s10" },
  {   1, "s20" },
  {   2, "s40" },
  {   3, "s80" },
  {   4, "s160" },
  {   5, "s320" },
  {   6, "s640" },
  {   7, "s1280" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_Barred(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_barred_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellReselectionInd, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AllowedIndicator },
  { &hf_umts_rrc_ies_t_Barred, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_Barred },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_barred(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_barred, T_barred_sequence);

  return offset;
}


static const value_string umts_rrc_ies_CellBarred_vals[] = {
  {   0, "barred" },
  {   1, "notBarred" },
  { 0, NULL }
};

static const per_choice_t CellBarred_choice[] = {
  {   0, &hf_umts_rrc_ies_barred , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_barred },
  {   1, &hf_umts_rrc_ies_notBarred, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellBarred(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_CellBarred, CellBarred_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_ReservedIndicator_vals[] = {
  {   0, "reserved" },
  {   1, "notReserved" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReservedIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t CellAccessRestriction_sequence[] = {
  { &hf_umts_rrc_ies_cellBarred, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellBarred },
  { &hf_umts_rrc_ies_cellReservedForOperatorUse, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReservedIndicator },
  { &hf_umts_rrc_ies_cellReservationExtension, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReservedIndicator },
  { &hf_umts_rrc_ies_accessClassBarredList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AccessClassBarredList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellAccessRestriction(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellAccessRestriction, CellAccessRestriction_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_CellIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     28, 28, FALSE, NULL);

  return offset;
}


static const per_sequence_t CellIdentity_PerRL_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_CellIdentity_PerRL_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellIdentity },
};

int
dissect_umts_rrc_ies_CellIdentity_PerRL_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CellIdentity_PerRL_List, CellIdentity_PerRL_List_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const value_string umts_rrc_ies_RAT_vals[] = {
  {   0, "utra-FDD" },
  {   1, "utra-TDD" },
  {   2, "gsm" },
  {   3, "cdma2000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RAT(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MappingFunctionType_vals[] = {
  {   0, "linear" },
  {   1, "functionType2" },
  {   2, "functionType3" },
  {   3, "functionType4" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MappingFunctionType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MapParameter(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 99U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_UpperLimit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 91U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MappingFunctionParameter_sequence[] = {
  { &hf_umts_rrc_ies_functionType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MappingFunctionType },
  { &hf_umts_rrc_ies_mapParameter1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MapParameter },
  { &hf_umts_rrc_ies_mapParameter2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MapParameter },
  { &hf_umts_rrc_ies_upperLimit, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UpperLimit },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MappingFunctionParameter(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MappingFunctionParameter, MappingFunctionParameter_sequence);

  return offset;
}


static const per_sequence_t MappingFunctionParameterList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MappingFunctionParameterList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MappingFunctionParameter },
};

static int
dissect_umts_rrc_ies_MappingFunctionParameterList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MappingFunctionParameterList, MappingFunctionParameterList_sequence_of,
                                                  1, maxMeasIntervals);

  return offset;
}


static const per_sequence_t Mapping_sequence[] = {
  { &hf_umts_rrc_ies_rat    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAT },
  { &hf_umts_rrc_ies_mappingFunctionParameterList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MappingFunctionParameterList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Mapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Mapping, Mapping_sequence);

  return offset;
}


static const per_sequence_t MappingInfo_sequence_of[1] = {
  { &hf_umts_rrc_ies_MappingInfo_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Mapping },
};

static int
dissect_umts_rrc_ies_MappingInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MappingInfo, MappingInfo_sequence_of,
                                                  1, maxRAT);

  return offset;
}



static int
dissect_umts_rrc_ies_Q_Hyst_S(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 20U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_cpich_Ec_N0_sequence[] = {
  { &hf_umts_rrc_ies_q_HYST_2_S, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_Hyst_S },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_Ec_N0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_Ec_N0, T_cpich_Ec_N0_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cellSelectQualityMeasure_vals[] = {
  {   0, "cpich-Ec-N0" },
  {   1, "cpich-RSCP" },
  { 0, NULL }
};

static const per_choice_t T_cellSelectQualityMeasure_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_Ec_N0, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_Ec_N0 },
  {   1, &hf_umts_rrc_ies_cpich_RSCP, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cellSelectQualityMeasure(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cellSelectQualityMeasure, T_cellSelectQualityMeasure_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_S_SearchQual(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -16, 10U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_S_SearchRXLEV(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -53, 45U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_RAT_Identifier_vals[] = {
  {   0, "gsm" },
  {   1, "cdma2000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RAT_Identifier(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RAT_FDD_Info_sequence[] = {
  { &hf_umts_rrc_ies_rat_Identifier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAT_Identifier },
  { &hf_umts_rrc_ies_s_SearchRAT, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_SearchQual },
  { &hf_umts_rrc_ies_s_HCS_RAT, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_s_Limit_SearchRAT, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_SearchQual },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAT_FDD_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAT_FDD_Info, RAT_FDD_Info_sequence);

  return offset;
}


static const per_sequence_t RAT_FDD_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAT_FDD_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAT_FDD_Info },
};

static int
dissect_umts_rrc_ies_RAT_FDD_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAT_FDD_InfoList, RAT_FDD_InfoList_sequence_of,
                                                  1, maxOtherRAT);

  return offset;
}



static int
dissect_umts_rrc_ies_Q_QualMin(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -24, 0U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_Q_RxlevMin(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -58, -13, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd_sequence[] = {
  { &hf_umts_rrc_ies_s_Intrasearch, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchQual },
  { &hf_umts_rrc_ies_s_Intersearch, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchQual },
  { &hf_umts_rrc_ies_s_SearchHCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_rat_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RAT_FDD_InfoList },
  { &hf_umts_rrc_ies_q_QualMin, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Q_QualMin },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd, T_fdd_sequence);

  return offset;
}


static const per_sequence_t RAT_TDD_Info_sequence[] = {
  { &hf_umts_rrc_ies_rat_Identifier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAT_Identifier },
  { &hf_umts_rrc_ies_s_SearchRAT1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_s_HCS_RAT, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_s_Limit_SearchRAT1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_SearchRXLEV },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAT_TDD_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAT_TDD_Info, RAT_TDD_Info_sequence);

  return offset;
}


static const per_sequence_t RAT_TDD_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAT_TDD_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAT_TDD_Info },
};

static int
dissect_umts_rrc_ies_RAT_TDD_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAT_TDD_InfoList, RAT_TDD_InfoList_sequence_of,
                                                  1, maxOtherRAT);

  return offset;
}


static const per_sequence_t T_tdd_sequence[] = {
  { &hf_umts_rrc_ies_s_Intrasearch1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_s_Intersearch1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_s_SearchHCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_S_SearchRXLEV },
  { &hf_umts_rrc_ies_rat_List1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RAT_TDD_InfoList },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd, T_tdd_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd },
  {   1, &hf_umts_rrc_ies_tdd    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo, T_modeSpecificInfo_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_T_Reselection_S(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 31U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_HCS_PRIO(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_Q_HCS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 99U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 16U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_CRMaxHyst_vals[] = {
  {   0, "notUsed" },
  {   1, "t10" },
  {   2, "t20" },
  {   3, "t30" },
  {   4, "t40" },
  {   5, "t50" },
  {   6, "t60" },
  {   7, "t70" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_CRMaxHyst(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t N_CR_T_CRMaxHyst_sequence[] = {
  { &hf_umts_rrc_ies_n_CR   , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_16 },
  { &hf_umts_rrc_ies_t_CRMaxHyst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_CRMaxHyst },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_N_CR_T_CRMaxHyst(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_N_CR_T_CRMaxHyst, N_CR_T_CRMaxHyst_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_CRMax_vals[] = {
  {   0, "notUsed" },
  {   1, "t30" },
  {   2, "t60" },
  {   3, "t120" },
  {   4, "t180" },
  {   5, "t240" },
  { 0, NULL }
};

static const per_choice_t T_CRMax_choice[] = {
  {   0, &hf_umts_rrc_ies_notUsed, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_t30    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_N_CR_T_CRMaxHyst },
  {   2, &hf_umts_rrc_ies_t60    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_N_CR_T_CRMaxHyst },
  {   3, &hf_umts_rrc_ies_t120   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_N_CR_T_CRMaxHyst },
  {   4, &hf_umts_rrc_ies_t180   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_N_CR_T_CRMaxHyst },
  {   5, &hf_umts_rrc_ies_t240   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_N_CR_T_CRMaxHyst },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_CRMax(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_CRMax, T_CRMax_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HCS_ServingCellInformation_sequence[] = {
  { &hf_umts_rrc_ies_hcs_PRIO, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_PRIO },
  { &hf_umts_rrc_ies_q_HCS  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_HCS },
  { &hf_umts_rrc_ies_t_CR_Max, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_CRMax },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HCS_ServingCellInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HCS_ServingCellInformation, HCS_ServingCellInformation_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_MaxAllowedUL_TX_Power(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -50, 33U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoSIB_3_4_sequence[] = {
  { &hf_umts_rrc_ies_mappingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MappingInfo },
  { &hf_umts_rrc_ies_cellSelectQualityMeasure, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cellSelectQualityMeasure },
  { &hf_umts_rrc_ies_modeSpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo },
  { &hf_umts_rrc_ies_q_Hyst_l_S, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Q_Hyst_S },
  { &hf_umts_rrc_ies_t_Reselection_S, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_Reselection_S },
  { &hf_umts_rrc_ies_hcs_ServingCellInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_ServingCellInformation },
  { &hf_umts_rrc_ies_maxAllowedUL_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxAllowedUL_TX_Power },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoSIB_3_4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoSIB_3_4, CellSelectReselectInfoSIB_3_4_sequence);

  return offset;
}


static const per_sequence_t T_restriction_sequence[] = {
  { &hf_umts_rrc_ies_domainSpecficAccessClassBarredList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AccessClassBarredList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_restriction(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_restriction, T_restriction_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DomainSpecificAccessRestriction_v670ext_vals[] = {
  {   0, "noRestriction" },
  {   1, "restriction" },
  { 0, NULL }
};

static const per_choice_t DomainSpecificAccessRestriction_v670ext_choice[] = {
  {   0, &hf_umts_rrc_ies_noRestriction, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_restriction, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_restriction },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DomainSpecificAccessRestriction_v670ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DomainSpecificAccessRestriction_v670ext, DomainSpecificAccessRestriction_v670ext_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DomainSpecificAccessRestrictionParam_v670ext_sequence[] = {
  { &hf_umts_rrc_ies_cSDomainSpecificAccessRestriction, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DomainSpecificAccessRestriction_v670ext },
  { &hf_umts_rrc_ies_pSDomainSpecificAccessRestriction, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DomainSpecificAccessRestriction_v670ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext, DomainSpecificAccessRestrictionParam_v670ext_sequence);

  return offset;
}


static const per_sequence_t DomainSpecificAccessRestrictionList_v670ext_sequence[] = {
  { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DomainSpecificAccessRestrictionList_v670ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DomainSpecificAccessRestrictionList_v670ext, DomainSpecificAccessRestrictionList_v670ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext_vals[] = {
  {   0, "domainSpecificAccessRestictionList" },
  {   1, "domainSpecificAccessRestictionParametersForAll" },
  { 0, NULL }
};

static const per_choice_t DomainSpecificAccessRestrictionForSharedNetwork_v670ext_choice[] = {
  {   0, &hf_umts_rrc_ies_domainSpecificAccessRestictionList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionList_v670ext },
  {   1, &hf_umts_rrc_ies_domainSpecificAccessRestictionParametersForAll, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext, DomainSpecificAccessRestrictionForSharedNetwork_v670ext_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t Mapping_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_mappingFunctionParameterList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MappingFunctionParameterList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Mapping_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Mapping_LCR_r4, Mapping_LCR_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_Q_Hyst_S_Fine(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 40U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_SpeedDependentScalingFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 10U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_T_Reselection_S_Fine(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 31U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TreselectionScalingFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              4U, 19U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_URA_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const per_sequence_t URA_IdentityList_sequence_of[1] = {
  { &hf_umts_rrc_ies_URA_IdentityList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_URA_Identity },
};

static int
dissect_umts_rrc_ies_URA_IdentityList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_URA_IdentityList, URA_IdentityList_sequence_of,
                                                  1, maxURA);

  return offset;
}


const value_string umts_rrc_ies_AccessStratumReleaseIndicator_vals[] = {
  {   0, "rel-4" },
  {   1, "rel-5" },
  {   2, "rel-6" },
  {   3, "spare13" },
  {   4, "spare12" },
  {   5, "spare11" },
  {   6, "spare10" },
  {   7, "spare9" },
  {   8, "spare8" },
  {   9, "spare7" },
  {  10, "spare6" },
  {  11, "spare5" },
  {  12, "spare4" },
  {  13, "spare3" },
  {  14, "spare2" },
  {  15, "spare1" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_AccessStratumReleaseIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_ActivationTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_AP_RetransMax(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_AccessFails(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NF_BO_NoAICH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 31U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NS_BO_Busy(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NF_BO_AllBusy(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 31U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NF_BO_Mismatch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_CPCH_vals[] = {
  {   0, "ct0" },
  {   1, "ct1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_CPCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t BackoffControlParams_sequence[] = {
  { &hf_umts_rrc_ies_n_AP_RetransMax, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_N_AP_RetransMax },
  { &hf_umts_rrc_ies_n_AccessFails, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_N_AccessFails },
  { &hf_umts_rrc_ies_nf_BO_NoAICH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NF_BO_NoAICH },
  { &hf_umts_rrc_ies_ns_BO_Busy, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NS_BO_Busy },
  { &hf_umts_rrc_ies_nf_BO_AllBusy, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NF_BO_AllBusy },
  { &hf_umts_rrc_ies_nf_BO_Mismatch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NF_BO_Mismatch },
  { &hf_umts_rrc_ies_t_CPCH , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_CPCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_BackoffControlParams(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_BackoffControlParams, BackoffControlParams_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_C_RNTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_SystemSpecificCapUpdateReq_vals[] = {
  {   0, "gsm" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SystemSpecificCapUpdateReq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SystemSpecificCapUpdateReqList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SystemSpecificCapUpdateReqList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SystemSpecificCapUpdateReq },
};

static int
dissect_umts_rrc_ies_SystemSpecificCapUpdateReqList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SystemSpecificCapUpdateReqList, SystemSpecificCapUpdateReqList_sequence_of,
                                                  1, maxSystemCapability);

  return offset;
}


static const per_sequence_t CapabilityUpdateRequirement_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_systemSpecificCapUpdateReqList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SystemSpecificCapUpdateReqList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CapabilityUpdateRequirement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CapabilityUpdateRequirement, CapabilityUpdateRequirement_sequence);

  return offset;
}


static const per_sequence_t CapabilityUpdateRequirement_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioCapabilityUpdateRequirement_TDD128, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CapabilityUpdateRequirement_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CapabilityUpdateRequirement_r4_ext, CapabilityUpdateRequirement_r4_ext_sequence);

  return offset;
}


static const per_sequence_t CapabilityUpdateRequirement_r4_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement_FDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD384, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD128, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_systemSpecificCapUpdateReqList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SystemSpecificCapUpdateReqList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CapabilityUpdateRequirement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CapabilityUpdateRequirement_r4, CapabilityUpdateRequirement_r4_sequence);

  return offset;
}


const value_string umts_rrc_ies_CellUpdateCause_vals[] = {
  {   0, "cellReselection" },
  {   1, "periodicalCellUpdate" },
  {   2, "uplinkDataTransmission" },
  {   3, "utran-pagingResponse" },
  {   4, "re-enteredServiceArea" },
  {   5, "radiolinkFailure" },
  {   6, "rlc-unrecoverableError" },
  {   7, "cellUpdateCause-ext" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_CellUpdateCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


const value_string umts_rrc_ies_CellUpdateCause_ext_vals[] = {
  {   0, "mbms-Reception" },
  {   1, "mbms-PTP-RB-Request" },
  {   2, "spare2" },
  {   3, "spare1" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_CellUpdateCause_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ChipRateCapability_vals[] = {
  {   0, "mcps3-84" },
  {   1, "mcps1-28" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ChipRateCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


const value_string umts_rrc_ies_CipheringAlgorithm_vals[] = {
  {   0, "uea0" },
  {   1, "uea1" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_CipheringAlgorithm(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_CipheringModeCommand_vals[] = {
  {   0, "startRestart" },
  {   1, "dummy-NULL" },
  { 0, NULL }
};

static const per_choice_t CipheringModeCommand_choice[] = {
  {   0, &hf_umts_rrc_ies_startRestart, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CipheringAlgorithm },
  {   1, &hf_umts_rrc_ies_dummy_NULL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_CipheringModeCommand(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_CipheringModeCommand, CipheringModeCommand_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_RB_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_RLC_SequenceNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 4095U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RB_ActivationTimeInfo_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rlc_SequenceNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_SequenceNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_ActivationTimeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_ActivationTimeInfo, RB_ActivationTimeInfo_sequence);

  return offset;
}


static const per_sequence_t RB_ActivationTimeInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_ActivationTimeInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_ActivationTimeInfo },
};

int
dissect_umts_rrc_ies_RB_ActivationTimeInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_ActivationTimeInfoList, RB_ActivationTimeInfoList_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t CipheringModeInfo_sequence[] = {
  { &hf_umts_rrc_ies_cipheringModeCommand, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CipheringModeCommand },
  { &hf_umts_rrc_ies_activationTimeForDPCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ActivationTime },
  { &hf_umts_rrc_ies_rb_DL_CiphActivationTimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_ActivationTimeInfoList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CipheringModeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CipheringModeInfo, CipheringModeInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_IMSI_DS_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       5, 7, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_TMSI_DS_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       2, 17, NULL);

  return offset;
}


static const value_string umts_rrc_ies_CN_PagedUE_Identity_vals[] = {
  {   0, "imsi-GSM-MAP" },
  {   1, "tmsi-GSM-MAP" },
  {   2, "p-TMSI-GSM-MAP" },
  {   3, "imsi-DS-41" },
  {   4, "tmsi-DS-41" },
  {   5, "spare3" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};

static const per_choice_t CN_PagedUE_Identity_choice[] = {
  {   0, &hf_umts_rrc_ies_imsi_GSM_MAP, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IMSI_GSM_MAP },
  {   1, &hf_umts_rrc_ies_tmsi_GSM_MAP, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TMSI_GSM_MAP },
  {   2, &hf_umts_rrc_ies_p_TMSI_GSM_MAP, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_P_TMSI_GSM_MAP },
  {   3, &hf_umts_rrc_ies_imsi_DS_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IMSI_DS_41 },
  {   4, &hf_umts_rrc_ies_tmsi_DS_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TMSI_DS_41 },
  {   5, &hf_umts_rrc_ies_spare3 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   6, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_CN_PagedUE_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_CN_PagedUE_Identity, CN_PagedUE_Identity_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t GSM_Measurements_sequence[] = {
  { &hf_umts_rrc_ies_gsm900 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dcs1800, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_gsm1900, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GSM_Measurements(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GSM_Measurements, GSM_Measurements_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapability_sequence[] = {
  { &hf_umts_rrc_ies_fdd_Measurements, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tdd_Measurements, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_gsm_Measurements, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_GSM_Measurements },
  { &hf_umts_rrc_ies_multiCarrierMeasurements, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapability, CompressedModeMeasCapability_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapability_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tdd128_Measurements, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapability_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapability_LCR_r4, CompressedModeMeasCapability_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RadioFrequencyBandFDD_vals[] = {
  {   0, "fdd2100" },
  {   1, "fdd1900" },
  {   2, "fdd1800" },
  {   3, "bandVI" },
  {   4, "bandIV" },
  {   5, "bandV" },
  {   6, "bandVII" },
  {   7, "extension-indicator" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RadioFrequencyBandFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabFDD_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandFDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RadioFrequencyBandFDD },
  { &hf_umts_rrc_ies_dl_MeasurementsFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_MeasurementsFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapabFDD, CompressedModeMeasCapabFDD_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabFDDList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CompressedModeMeasCapabFDDList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabFDD },
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabFDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CompressedModeMeasCapabFDDList, CompressedModeMeasCapabFDDList_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const value_string umts_rrc_ies_RadioFrequencyBandFDD2_vals[] = {
  {   0, "bandVIII" },
  {   1, "bandIX" },
  {   2, "bandX" },
  {   3, "bandXI" },
  {   4, "bandXII" },
  {   5, "bandXIII" },
  {   6, "bandXIV" },
  {   7, "bandXV" },
  {   8, "bandXVI" },
  {   9, "bandXVII" },
  {  10, "bandXVIII" },
  {  11, "bandXIX" },
  {  12, "bandXX" },
  {  13, "bandXXI" },
  {  14, "bandXXII" },
  {  15, "extension-indicator" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RadioFrequencyBandFDD2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabFDD2_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandFDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RadioFrequencyBandFDD },
  { &hf_umts_rrc_ies_radioFrequencyBandFDD2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RadioFrequencyBandFDD2 },
  { &hf_umts_rrc_ies_dl_MeasurementsFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_MeasurementsFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabFDD2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapabFDD2, CompressedModeMeasCapabFDD2_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabFDDList2_sequence_of[1] = {
  { &hf_umts_rrc_ies_CompressedModeMeasCapabFDDList2_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabFDD2 },
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabFDDList2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CompressedModeMeasCapabFDDList2, CompressedModeMeasCapabFDDList2_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabFDD_ext_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandFDD2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandFDD2 },
  { &hf_umts_rrc_ies_dl_MeasurementsFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_MeasurementsFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabFDD_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapabFDD_ext, CompressedModeMeasCapabFDD_ext_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabFDDList_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabFDD_ext },
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext, CompressedModeMeasCapabFDDList_ext_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const value_string umts_rrc_ies_RadioFrequencyBandTDD_vals[] = {
  {   0, "a" },
  {   1, "b" },
  {   2, "c" },
  {   3, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RadioFrequencyBandTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabTDD_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandTDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandTDD },
  { &hf_umts_rrc_ies_dl_MeasurementsTDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_MeasurementsTDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapabTDD, CompressedModeMeasCapabTDD_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabTDDList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CompressedModeMeasCapabTDDList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabTDD },
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabTDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CompressedModeMeasCapabTDDList, CompressedModeMeasCapabTDDList_sequence_of,
                                                  1, maxFreqBandsTDD);

  return offset;
}


static const value_string umts_rrc_ies_RadioFrequencyBandGSM_vals[] = {
  {   0, "gsm450" },
  {   1, "gsm480" },
  {   2, "gsm850" },
  {   3, "gsm900P" },
  {   4, "gsm900E" },
  {   5, "gsm1800" },
  {   6, "gsm1900" },
  {   7, "spare9" },
  {   8, "spare8" },
  {   9, "spare7" },
  {  10, "spare6" },
  {  11, "spare5" },
  {  12, "spare4" },
  {  13, "spare3" },
  {  14, "spare2" },
  {  15, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RadioFrequencyBandGSM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabGSM_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandGSM, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandGSM },
  { &hf_umts_rrc_ies_dl_MeasurementsGSM, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_MeasurementsGSM, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabGSM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapabGSM, CompressedModeMeasCapabGSM_sequence);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabGSMList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CompressedModeMeasCapabGSMList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabGSM },
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabGSMList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CompressedModeMeasCapabGSMList, CompressedModeMeasCapabGSMList_sequence_of,
                                                  1, maxFreqBandsGSM);

  return offset;
}


static const per_sequence_t CompressedModeMeasCapabMC_sequence[] = {
  { &hf_umts_rrc_ies_dl_MeasurementsMC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_MeasurementsMC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CompressedModeMeasCapabMC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CompressedModeMeasCapabMC, CompressedModeMeasCapabMC_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_NS_IP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 28U, NULL, FALSE);

  return offset;
}


static const per_sequence_t InitialPriorityDelayList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InitialPriorityDelayList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NS_IP },
};

static int
dissect_umts_rrc_ies_InitialPriorityDelayList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InitialPriorityDelayList, InitialPriorityDelayList_sequence_of,
                                                  1, maxASC);

  return offset;
}



static int
dissect_umts_rrc_ies_TPC_StepSizeFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_PowerControlAlgorithm_vals[] = {
  {   0, "algorithm1" },
  {   1, "algorithm2" },
  { 0, NULL }
};

static const per_choice_t PowerControlAlgorithm_choice[] = {
  {   0, &hf_umts_rrc_ies_algorithm1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TPC_StepSizeFDD },
  {   1, &hf_umts_rrc_ies_algorithm2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PowerControlAlgorithm(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PowerControlAlgorithm, PowerControlAlgorithm_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_DL_DPCCH_BER(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CPCH_Parameters_sequence[] = {
  { &hf_umts_rrc_ies_initialPriorityDelayList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InitialPriorityDelayList },
  { &hf_umts_rrc_ies_backoffControlParams, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BackoffControlParams },
  { &hf_umts_rrc_ies_powerControlAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerControlAlgorithm },
  { &hf_umts_rrc_ies_dl_DPCCH_BER, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_DPCCH_BER },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CPCH_Parameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CPCH_Parameters, CPCH_Parameters_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_CapabilityWithSimultaneousHS_DSCHConfig_vals[] = {
  {   0, "kbps32" },
  {   1, "kbps64" },
  {   2, "kbps128" },
  {   3, "kbps384" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_CapabilityWithSimultaneousHS_DSCHConfig(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MaxNoPhysChBitsReceived_vals[] = {
  {   0, "dummy" },
  {   1, "b1200" },
  {   2, "b2400" },
  {   3, "b3600" },
  {   4, "b4800" },
  {   5, "b7200" },
  {   6, "b9600" },
  {   7, "b14400" },
  {   8, "b19200" },
  {   9, "b28800" },
  {  10, "b38400" },
  {  11, "b48000" },
  {  12, "b57600" },
  {  13, "b67200" },
  {  14, "b76800" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNoPhysChBitsReceived(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     15, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNoSCCPCH_RL_vals[] = {
  {   0, "rl1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNoSCCPCH_RL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_supported2_sequence[] = {
  { &hf_umts_rrc_ies_maxNoSCCPCH_RL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoSCCPCH_RL },
  { &hf_umts_rrc_ies_simultaneousSCCPCH_DPCH_DPDCH_Reception, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_supported2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_supported2, T_supported2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t SimultaneousSCCPCH_DPCH_Reception_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_supported2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception, SimultaneousSCCPCH_DPCH_Reception_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_PhysChCapabilityFDD_sequence[] = {
  { &hf_umts_rrc_ies_maxNoDPCH_PDSCH_Codes, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { &hf_umts_rrc_ies_maxNoPhysChBitsReceived, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoPhysChBitsReceived },
  { &hf_umts_rrc_ies_supportForSF_512, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dummy_BOOLEAN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dummy2_SimultaneousSCCPCH_DPCH_Reception, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_PhysChCapabilityFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_PhysChCapabilityFDD, DL_PhysChCapabilityFDD_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SupportOfDedicatedPilotsForChEstimation_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SupportOfDedicatedPilotsForChEstimation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_PhysChCapabilityFDD_v380ext_sequence[] = {
  { &hf_umts_rrc_ies_dummy_SupportOfDedicatedPilotsForChEstimation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SupportOfDedicatedPilotsForChEstimation },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_PhysChCapabilityFDD_v380ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_PhysChCapabilityFDD_v380ext, DL_PhysChCapabilityFDD_v380ext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxTS_PerFrame(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 14U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxPhysChPerFrame(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 224U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MinimumSF_DL_vals[] = {
  {   0, "sf1" },
  {   1, "sf16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MinimumSF_DL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxPhysChPerTS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 16U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DL_PhysChCapabilityTDD_sequence[] = {
  { &hf_umts_rrc_ies_maxTS_PerFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTS_PerFrame },
  { &hf_umts_rrc_ies_maxPhysChPerFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPhysChPerFrame },
  { &hf_umts_rrc_ies_minimumSF, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MinimumSF_DL },
  { &hf_umts_rrc_ies_supportOfPDSCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_maxPhysChPerTS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPhysChPerTS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_PhysChCapabilityTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_PhysChCapabilityTDD, DL_PhysChCapabilityTDD_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxTS_PerSubFrame_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 6U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxPhysChPerSubFrame_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 96U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DL_PhysChCapabilityTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_maxTS_PerSubFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTS_PerSubFrame_r4 },
  { &hf_umts_rrc_ies_maxPhysChPerFrame1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPhysChPerSubFrame_r4 },
  { &hf_umts_rrc_ies_minimumSF, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MinimumSF_DL },
  { &hf_umts_rrc_ies_supportOfPDSCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_maxPhysChPerTS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPhysChPerTS },
  { &hf_umts_rrc_ies_supportOf8PSK, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_PhysChCapabilityTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_PhysChCapabilityTDD_LCR_r4, DL_PhysChCapabilityTDD_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MaxNoBits_vals[] = {
  {   0, "b640" },
  {   1, "b1280" },
  {   2, "b2560" },
  {   3, "b3840" },
  {   4, "b5120" },
  {   5, "b6400" },
  {   6, "b7680" },
  {   7, "b8960" },
  {   8, "b10240" },
  {   9, "b20480" },
  {  10, "b40960" },
  {  11, "b81920" },
  {  12, "b163840" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNoBits(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     13, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TurboSupport_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t TurboSupport_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNoBits },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TurboSupport(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TurboSupport, TurboSupport_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxSimultaneousTransChsDL_vals[] = {
  {   0, "e4" },
  {   1, "e8" },
  {   2, "e16" },
  {   3, "e32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxSimultaneousTransChsDL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxSimultaneousCCTrCH_Count(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MaxTransportBlocksDL_vals[] = {
  {   0, "tb4" },
  {   1, "tb8" },
  {   2, "tb16" },
  {   3, "tb32" },
  {   4, "tb48" },
  {   5, "tb64" },
  {   6, "tb96" },
  {   7, "tb128" },
  {   8, "tb256" },
  {   9, "tb512" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxTransportBlocksDL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     10, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNumberOfTFC_DL_vals[] = {
  {   0, "tfc16" },
  {   1, "tfc32" },
  {   2, "tfc48" },
  {   3, "tfc64" },
  {   4, "tfc96" },
  {   5, "tfc128" },
  {   6, "tfc256" },
  {   7, "tfc512" },
  {   8, "tfc1024" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNumberOfTFC_DL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     9, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNumberOfTF_vals[] = {
  {   0, "tf32" },
  {   1, "tf64" },
  {   2, "tf128" },
  {   3, "tf256" },
  {   4, "tf512" },
  {   5, "tf1024" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNumberOfTF(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     6, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_TransChCapability_sequence[] = {
  { &hf_umts_rrc_ies_maxNoBitsReceived, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoBits },
  { &hf_umts_rrc_ies_maxConvCodeBitsReceived, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoBits },
  { &hf_umts_rrc_ies_turboDecodingSupport, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TurboSupport },
  { &hf_umts_rrc_ies_maxSimultaneousTransChs, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxSimultaneousTransChsDL },
  { &hf_umts_rrc_ies_maxSimultaneousCCTrCH_Count, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxSimultaneousCCTrCH_Count },
  { &hf_umts_rrc_ies_maxReceivedTransportBlocks, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTransportBlocksDL },
  { &hf_umts_rrc_ies_maxNumberOfTFC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNumberOfTFC_DL },
  { &hf_umts_rrc_ies_maxNumberOfTF, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNumberOfTF },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TransChCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_TransChCapability, DL_TransChCapability_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TransmissionProbability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MaximumBitRate(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 32U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DRAC_SysInfo_sequence[] = {
  { &hf_umts_rrc_ies_transmissionProbability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransmissionProbability },
  { &hf_umts_rrc_ies_maximumBitRate, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaximumBitRate },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DRAC_SysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DRAC_SysInfo, DRAC_SysInfo_sequence);

  return offset;
}


static const per_sequence_t DRAC_SysInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DRAC_SysInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DRAC_SysInfo },
};

static int
dissect_umts_rrc_ies_DRAC_SysInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DRAC_SysInfoList, DRAC_SysInfoList_sequence_of,
                                                  1, maxDRACclasses);

  return offset;
}



int
dissect_umts_rrc_ies_DSCH_RNTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


const value_string umts_rrc_ies_DelayRestrictionFlag_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_DelayRestrictionFlag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_E_RNTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_ESN_DS_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     32, 32, FALSE, NULL);

  return offset;
}


const value_string umts_rrc_ies_EstablishmentCause_vals[] = {
  {   0, "originatingConversationalCall" },
  {   1, "originatingStreamingCall" },
  {   2, "originatingInteractiveCall" },
  {   3, "originatingBackgroundCall" },
  {   4, "originatingSubscribedTrafficCall" },
  {   5, "terminatingConversationalCall" },
  {   6, "terminatingStreamingCall" },
  {   7, "terminatingInteractiveCall" },
  {   8, "terminatingBackgroundCall" },
  {   9, "emergencyCall" },
  {  10, "interRAT-CellReselection" },
  {  11, "interRAT-CellChangeOrder" },
  {  12, "registration" },
  {  13, "detach" },
  {  14, "originatingHighPrioritySignalling" },
  {  15, "originatingLowPrioritySignalling" },
  {  16, "callRe-establishment" },
  {  17, "terminatingHighPrioritySignalling" },
  {  18, "terminatingLowPrioritySignalling" },
  {  19, "terminatingCauseUnknown" },
  {  20, "mbms-Reception" },
  {  21, "mbms-PTP-RB-Request" },
  {  22, "spare10" },
  {  23, "spare9" },
  {  24, "spare8" },
  {  25, "spare7" },
  {  26, "spare6" },
  {  27, "spare5" },
  {  28, "spare4" },
  {  29, "spare3" },
  {  30, "spare2" },
  {  31, "spare1" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_EstablishmentCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     32, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_TGPSI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxTGPS, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ProtocolErrorCause_vals[] = {
  {   0, "asn1-ViolationOrEncodingError" },
  {   1, "messageTypeNonexistent" },
  {   2, "messageNotCompatibleWithReceiverState" },
  {   3, "ie-ValueNotComprehended" },
  {   4, "informationElementMissing" },
  {   5, "messageExtensionNotComprehended" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ProtocolErrorCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_type13_sequence[] = {
  { &hf_umts_rrc_ies_protocolErrorCause, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ProtocolErrorCause },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_type13, T_type13_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_diagnosticsType1_vals[] = {
  {   0, "type1" },
  {   1, "spare" },
  { 0, NULL }
};

static const per_choice_t T_diagnosticsType1_choice[] = {
  {   0, &hf_umts_rrc_ies_type14 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type13 },
  {   1, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_diagnosticsType1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_diagnosticsType1, T_diagnosticsType1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ProtocolErrorInformation_sequence[] = {
  { &hf_umts_rrc_ies_diagnosticsType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_diagnosticsType1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ProtocolErrorInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ProtocolErrorInformation, ProtocolErrorInformation_sequence);

  return offset;
}


const value_string umts_rrc_ies_FailureCauseWithProtErr_vals[] = {
  {   0, "configurationUnsupported" },
  {   1, "physicalChannelFailure" },
  {   2, "incompatibleSimultaneousReconfiguration" },
  {   3, "compressedModeRuntimeError" },
  {   4, "protocolError" },
  {   5, "cellUpdateOccurred" },
  {   6, "invalidConfiguration" },
  {   7, "configurationIncomplete" },
  {   8, "unsupportedMeasurement" },
  {   9, "mbmsSessionAlreadyReceivedCorrectly" },
  {  10, "lowerPriorityMBMSService" },
  {  11, "spare5" },
  {  12, "spare4" },
  {  13, "spare3" },
  {  14, "spare2" },
  {  15, "spare1" },
  { 0, NULL }
};

static const per_choice_t FailureCauseWithProtErr_choice[] = {
  {   0, &hf_umts_rrc_ies_configurationUnsupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_physicalChannelFailure, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_incompatibleSimultaneousReconfiguration, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_compressedModeRuntimeError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TGPSI },
  {   4, &hf_umts_rrc_ies_protocolError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ProtocolErrorInformation },
  {   5, &hf_umts_rrc_ies_cellUpdateOccurred, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   6, &hf_umts_rrc_ies_invalidConfiguration, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_configurationIncomplete, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   8, &hf_umts_rrc_ies_unsupportedMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   9, &hf_umts_rrc_ies_mbmsSessionAlreadyReceivedCorrectly, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  10, &hf_umts_rrc_ies_lowerPriorityMBMSService, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  11, &hf_umts_rrc_ies_spare5 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  12, &hf_umts_rrc_ies_spare4 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  13, &hf_umts_rrc_ies_spare3 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  14, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  15, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_FailureCauseWithProtErr(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_FailureCauseWithProtErr, FailureCauseWithProtErr_choice,
                                 NULL);

  return offset;
}



int
dissect_umts_rrc_ies_RRC_TransactionIdentifier(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t FailureCauseWithProtErrTrId_sequence[] = {
  { &hf_umts_rrc_ies_rrc_TransactionIdentifier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_TransactionIdentifier },
  { &hf_umts_rrc_ies_failureCause, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FailureCauseWithProtErr },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_FailureCauseWithProtErrTrId(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FailureCauseWithProtErrTrId, FailureCauseWithProtErrTrId_sequence);

  return offset;
}


const value_string umts_rrc_ies_ReleaseCause_vals[] = {
  {   0, "normalEvent" },
  {   1, "unspecified" },
  {   2, "pre-emptiveRelease" },
  {   3, "congestion" },
  {   4, "re-establishmentReject" },
  {   5, "directedsignallingconnectionre-establishment" },
  {   6, "userInactivity" },
  {   7, "spare" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_ReleaseCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_release_sequence[] = {
  { &hf_umts_rrc_ies_releaseCause, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReleaseCause },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_release(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_release, T_release_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RRC_ConnectionReleaseInformation_vals[] = {
  {   0, "noRelease" },
  {   1, "release" },
  { 0, NULL }
};

static const per_choice_t RRC_ConnectionReleaseInformation_choice[] = {
  {   0, &hf_umts_rrc_ies_noRelease, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_release, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_release },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RRC_ConnectionReleaseInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RRC_ConnectionReleaseInformation, RRC_ConnectionReleaseInformation_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     31, 31, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_30(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     30, 30, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_29(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     29, 29, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_28(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     28, 28, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_27(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     27, 27, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_26(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     26, 26, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_25(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     25, 25, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_24(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     24, 24, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_23(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     23, 23, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_22(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     22, 22, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     21, 21, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_20(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     20, 20, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_19(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     19, 19, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_18(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     18, 18, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     17, 17, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     14, 14, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     13, 13, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     12, 12, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     11, 11, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     10, 10, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     9, 9, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     7, 7, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     6, 6, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     5, 5, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     4, 4, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     3, 3, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     2, 2, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 1, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_U_RNTI_Group_vals[] = {
  {   0, "all" },
  {   1, "u-RNTI-BitMaskIndex-b1" },
  {   2, "u-RNTI-BitMaskIndex-b2" },
  {   3, "u-RNTI-BitMaskIndex-b3" },
  {   4, "u-RNTI-BitMaskIndex-b4" },
  {   5, "u-RNTI-BitMaskIndex-b5" },
  {   6, "u-RNTI-BitMaskIndex-b6" },
  {   7, "u-RNTI-BitMaskIndex-b7" },
  {   8, "u-RNTI-BitMaskIndex-b8" },
  {   9, "u-RNTI-BitMaskIndex-b9" },
  {  10, "u-RNTI-BitMaskIndex-b10" },
  {  11, "u-RNTI-BitMaskIndex-b11" },
  {  12, "u-RNTI-BitMaskIndex-b12" },
  {  13, "u-RNTI-BitMaskIndex-b13" },
  {  14, "u-RNTI-BitMaskIndex-b14" },
  {  15, "u-RNTI-BitMaskIndex-b15" },
  {  16, "u-RNTI-BitMaskIndex-b16" },
  {  17, "u-RNTI-BitMaskIndex-b17" },
  {  18, "u-RNTI-BitMaskIndex-b18" },
  {  19, "u-RNTI-BitMaskIndex-b19" },
  {  20, "u-RNTI-BitMaskIndex-b20" },
  {  21, "u-RNTI-BitMaskIndex-b21" },
  {  22, "u-RNTI-BitMaskIndex-b22" },
  {  23, "u-RNTI-BitMaskIndex-b23" },
  {  24, "u-RNTI-BitMaskIndex-b24" },
  {  25, "u-RNTI-BitMaskIndex-b25" },
  {  26, "u-RNTI-BitMaskIndex-b26" },
  {  27, "u-RNTI-BitMaskIndex-b27" },
  {  28, "u-RNTI-BitMaskIndex-b28" },
  {  29, "u-RNTI-BitMaskIndex-b29" },
  {  30, "u-RNTI-BitMaskIndex-b30" },
  {  31, "u-RNTI-BitMaskIndex-b31" },
  { 0, NULL }
};

static const per_choice_t U_RNTI_Group_choice[] = {
  {   0, &hf_umts_rrc_ies_all    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_31 },
  {   2, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_30 },
  {   3, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_29 },
  {   4, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_28 },
  {   5, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_27 },
  {   6, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b6, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_26 },
  {   7, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b7, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_25 },
  {   8, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b8, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  {   9, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b9, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_23 },
  {  10, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b10, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_22 },
  {  11, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_21 },
  {  12, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b12, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_20 },
  {  13, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b13, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_19 },
  {  14, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b14, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_18 },
  {  15, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b15, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_17 },
  {  16, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b16, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  {  17, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b17, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_15 },
  {  18, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b18, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_14 },
  {  19, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b19, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_13 },
  {  20, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b20, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_12 },
  {  21, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_11 },
  {  22, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b22, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_10 },
  {  23, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b23, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_9 },
  {  24, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b24, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  {  25, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b25, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_7 },
  {  26, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b26, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_6 },
  {  27, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b27, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_5 },
  {  28, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b28, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_4 },
  {  29, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b29, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_3 },
  {  30, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b30, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_2 },
  {  31, &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b31, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BIT_STRING_SIZE_1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_U_RNTI_Group(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_U_RNTI_Group, U_RNTI_Group_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t GroupReleaseInformation_sequence[] = {
  { &hf_umts_rrc_ies_uRNTI_Group, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_U_RNTI_Group },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_GroupReleaseInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GroupReleaseInformation, GroupReleaseInformation_sequence);

  return offset;
}


static const per_sequence_t GroupIdentityWithReleaseInformation_sequence[] = {
  { &hf_umts_rrc_ies_rrc_ConnectionReleaseInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_ConnectionReleaseInformation },
  { &hf_umts_rrc_ies_groupReleaseInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GroupReleaseInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GroupIdentityWithReleaseInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GroupIdentityWithReleaseInformation, GroupIdentityWithReleaseInformation_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_H_RNTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_HSDSCH_physical_layer_category(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_UESpecificBehaviourInformation1idle(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     4, 4, FALSE, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_UESpecificBehaviourInformation1interRAT(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const per_sequence_t IMSI_and_ESN_DS_41_sequence[] = {
  { &hf_umts_rrc_ies_imsi_DS_41, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IMSI_DS_41 },
  { &hf_umts_rrc_ies_esn_DS_41, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ESN_DS_41 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IMSI_and_ESN_DS_41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IMSI_and_ESN_DS_41, IMSI_and_ESN_DS_41_sequence);

  return offset;
}


static const per_sequence_t TMSI_and_LAI_GSM_MAP_sequence[] = {
  { &hf_umts_rrc_ies_tmsi   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TMSI_GSM_MAP },
  { &hf_umts_rrc_ies_lai    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LAI },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TMSI_and_LAI_GSM_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TMSI_and_LAI_GSM_MAP, TMSI_and_LAI_GSM_MAP_sequence);

  return offset;
}


static const per_sequence_t P_TMSI_and_RAI_GSM_MAP_sequence[] = {
  { &hf_umts_rrc_ies_p_TMSI , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_P_TMSI_GSM_MAP },
  { &hf_umts_rrc_ies_rai    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAI },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_P_TMSI_and_RAI_GSM_MAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_P_TMSI_and_RAI_GSM_MAP, P_TMSI_and_RAI_GSM_MAP_sequence);

  return offset;
}


const value_string umts_rrc_ies_InitialUE_Identity_vals[] = {
  {   0, "imsi" },
  {   1, "tmsi-and-LAI" },
  {   2, "p-TMSI-and-RAI" },
  {   3, "imei" },
  {   4, "esn-DS-41" },
  {   5, "imsi-DS-41" },
  {   6, "imsi-and-ESN-DS-41" },
  {   7, "tmsi-DS-41" },
  { 0, NULL }
};

static const per_choice_t InitialUE_Identity_choice[] = {
  {   0, &hf_umts_rrc_ies_imsi   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IMSI_GSM_MAP },
  {   1, &hf_umts_rrc_ies_tmsi_and_LAI, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TMSI_and_LAI_GSM_MAP },
  {   2, &hf_umts_rrc_ies_p_TMSI_and_RAI, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_P_TMSI_and_RAI_GSM_MAP },
  {   3, &hf_umts_rrc_ies_imei   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IMEI },
  {   4, &hf_umts_rrc_ies_esn_DS_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ESN_DS_41 },
  {   5, &hf_umts_rrc_ies_imsi_DS_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IMSI_DS_41 },
  {   6, &hf_umts_rrc_ies_imsi_and_ESN_DS_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IMSI_and_ESN_DS_41 },
  {   7, &hf_umts_rrc_ies_tmsi_DS_41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TMSI_DS_41 },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_InitialUE_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InitialUE_Identity, InitialUE_Identity_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MessageAuthenticationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     32, 32, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_RRC_MessageSequenceNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t IntegrityCheckInfo_sequence[] = {
  { &hf_umts_rrc_ies_messageAuthenticationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MessageAuthenticationCode },
  { &hf_umts_rrc_ies_rrc_MessageSequenceNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_MessageSequenceNumber },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_IntegrityCheckInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntegrityCheckInfo, IntegrityCheckInfo_sequence);

  return offset;
}


static const per_sequence_t RRC_MessageSequenceNumberList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RRC_MessageSequenceNumberList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_MessageSequenceNumber },
};

static int
dissect_umts_rrc_ies_RRC_MessageSequenceNumberList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RRC_MessageSequenceNumberList, RRC_MessageSequenceNumberList_sequence_of,
                                                  4, 5);

  return offset;
}


static const per_sequence_t IntegrityProtActivationInfo_sequence[] = {
  { &hf_umts_rrc_ies_rrc_MessageSequenceNumberList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_MessageSequenceNumberList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_IntegrityProtActivationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntegrityProtActivationInfo, IntegrityProtActivationInfo_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntegrityProtectionAlgorithm_vals[] = {
  {   0, "uia1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IntegrityProtectionAlgorithm(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_IntegrityProtInitNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     32, 32, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_startIntegrityProtection_sequence[] = {
  { &hf_umts_rrc_ies_integrityProtInitNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntegrityProtInitNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_startIntegrityProtection(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_startIntegrityProtection, T_startIntegrityProtection_sequence);

  return offset;
}


static const per_sequence_t T_modify_sequence[] = {
  { &hf_umts_rrc_ies_dl_IntegrityProtActivationInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntegrityProtActivationInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modify(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_modify, T_modify_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntegrityProtectionModeCommand_vals[] = {
  {   0, "startIntegrityProtection" },
  {   1, "modify" },
  { 0, NULL }
};

static const per_choice_t IntegrityProtectionModeCommand_choice[] = {
  {   0, &hf_umts_rrc_ies_startIntegrityProtection, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_startIntegrityProtection },
  {   1, &hf_umts_rrc_ies_modify , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_modify },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntegrityProtectionModeCommand(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_IntegrityProtectionModeCommand, IntegrityProtectionModeCommand_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntegrityProtectionModeInfo_sequence[] = {
  { &hf_umts_rrc_ies_integrityProtectionModeCommand, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntegrityProtectionModeCommand },
  { &hf_umts_rrc_ies_integrityProtectionAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntegrityProtectionAlgorithm },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_IntegrityProtectionModeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntegrityProtectionModeInfo, IntegrityProtectionModeInfo_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MaxHcContextSpace_vals[] = {
  {   0, "dummy" },
  {   1, "by1024" },
  {   2, "by2048" },
  {   3, "by4096" },
  {   4, "by8192" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxHcContextSpace(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxHcContextSpace_r5_ext_vals[] = {
  {   0, "by16384" },
  {   1, "by32768" },
  {   2, "by65536" },
  {   3, "by131072" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxHcContextSpace_r5_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxROHC_ContextSessions_r4_vals[] = {
  {   0, "s2" },
  {   1, "s4" },
  {   2, "s8" },
  {   3, "s12" },
  {   4, "s16" },
  {   5, "s24" },
  {   6, "s32" },
  {   7, "s48" },
  {   8, "s64" },
  {   9, "s128" },
  {  10, "s256" },
  {  11, "s512" },
  {  12, "s1024" },
  {  13, "s16384" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxROHC_ContextSessions_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     14, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaximumAM_EntityNumberRLC_Cap_vals[] = {
  {   0, "dummy" },
  {   1, "am4" },
  {   2, "am5" },
  {   3, "am6" },
  {   4, "am8" },
  {   5, "am16" },
  {   6, "am30" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaximumAM_EntityNumberRLC_Cap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaximumRLC_WindowSize_vals[] = {
  {   0, "mws2047" },
  {   1, "mws4095" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaximumRLC_WindowSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNoDPDCH_BitsTransmitted_vals[] = {
  {   0, "b600" },
  {   1, "b1200" },
  {   2, "b2400" },
  {   3, "b4800" },
  {   4, "b9600" },
  {   5, "b19200" },
  {   6, "b28800" },
  {   7, "b38400" },
  {   8, "b48000" },
  {   9, "b57600" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNoDPDCH_BitsTransmitted(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     10, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNumberOfTFC_UL_vals[] = {
  {   0, "dummy1" },
  {   1, "dummy2" },
  {   2, "tfc16" },
  {   3, "tfc32" },
  {   4, "tfc48" },
  {   5, "tfc64" },
  {   6, "tfc96" },
  {   7, "tfc128" },
  {   8, "tfc256" },
  {   9, "tfc512" },
  {  10, "tfc1024" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNumberOfTFC_UL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     11, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxPhysChPerTimeslot_vals[] = {
  {   0, "ts1" },
  {   1, "ts2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxPhysChPerTimeslot(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxSimultaneousTransChsUL_vals[] = {
  {   0, "dummy" },
  {   1, "e4" },
  {   2, "e8" },
  {   3, "e16" },
  {   4, "e32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxSimultaneousTransChsUL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxTransportBlocksUL_vals[] = {
  {   0, "dummy" },
  {   1, "tb4" },
  {   2, "tb8" },
  {   3, "tb16" },
  {   4, "tb32" },
  {   5, "tb48" },
  {   6, "tb64" },
  {   7, "tb96" },
  {   8, "tb128" },
  {   9, "tb256" },
  {  10, "tb512" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxTransportBlocksUL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     11, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MeasurementCapability_sequence[] = {
  { &hf_umts_rrc_ies_downlinkCompressedMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapability },
  { &hf_umts_rrc_ies_uplinkCompressedMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementCapability, MeasurementCapability_sequence);

  return offset;
}


static const per_sequence_t MeasurementCapabilityExt_sequence[] = {
  { &hf_umts_rrc_ies_compressedModeMeasCapabFDDList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabFDDList },
  { &hf_umts_rrc_ies_compressedModeMeasCapabTDDList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CompressedModeMeasCapabTDDList },
  { &hf_umts_rrc_ies_compressedModeMeasCapabGSMList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CompressedModeMeasCapabGSMList },
  { &hf_umts_rrc_ies_compressedModeMeasCapabMC, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CompressedModeMeasCapabMC },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementCapabilityExt(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementCapabilityExt, MeasurementCapabilityExt_sequence);

  return offset;
}


static const per_sequence_t MeasurementCapabilityExt2_sequence[] = {
  { &hf_umts_rrc_ies_compressedModeMeasCapabFDDList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabFDDList2 },
  { &hf_umts_rrc_ies_compressedModeMeasCapabTDDList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CompressedModeMeasCapabTDDList },
  { &hf_umts_rrc_ies_compressedModeMeasCapabGSMList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CompressedModeMeasCapabGSMList },
  { &hf_umts_rrc_ies_compressedModeMeasCapabMC, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CompressedModeMeasCapabMC },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementCapabilityExt2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementCapabilityExt2, MeasurementCapabilityExt2_sequence);

  return offset;
}


static const per_sequence_t MeasurementCapability_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_downlinkCompressedMode_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapability_LCR_r4 },
  { &hf_umts_rrc_ies_uplinkCompressedMode_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapability_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementCapability_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementCapability_r4_ext, MeasurementCapability_r4_ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MinimumSF_UL_vals[] = {
  {   0, "sf1" },
  {   1, "sf2" },
  {   2, "sf4" },
  {   3, "sf8" },
  {   4, "dummy" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MinimumSF_UL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MultiModeCapability_vals[] = {
  {   0, "tdd" },
  {   1, "fdd" },
  {   2, "fdd-tdd" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MultiModeCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MultiRAT_Capability_sequence[] = {
  { &hf_umts_rrc_ies_supportOfGSM, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_supportOfMulticarrier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MultiRAT_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MultiRAT_Capability, MultiRAT_Capability_sequence);

  return offset;
}


static const per_sequence_t MultiModeRAT_Capability_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_supportOfUTRAN_ToGERAN_NACC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MultiModeRAT_Capability_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MultiModeRAT_Capability_v590ext, MultiModeRAT_Capability_v590ext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_N_300(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_301(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_302(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_304(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_N_308(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_310(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_N_312_vals[] = {
  {   0, "s1" },
  {   1, "s50" },
  {   2, "s100" },
  {   3, "s200" },
  {   4, "s400" },
  {   5, "s600" },
  {   6, "s800" },
  {   7, "s1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_312(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_N_312ext_vals[] = {
  {   0, "s2" },
  {   1, "s4" },
  {   2, "s10" },
  {   3, "s20" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_312ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_N_312_r5_vals[] = {
  {   0, "s1" },
  {   1, "s2" },
  {   2, "s4" },
  {   3, "s10" },
  {   4, "s20" },
  {   5, "s50" },
  {   6, "s100" },
  {   7, "s200" },
  {   8, "s400" },
  {   9, "s600" },
  {  10, "s800" },
  {  11, "s1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_312_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     12, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_N_313_vals[] = {
  {   0, "s1" },
  {   1, "s2" },
  {   2, "s4" },
  {   3, "s10" },
  {   4, "s20" },
  {   5, "s50" },
  {   6, "s100" },
  {   7, "s200" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_313(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_N_315_vals[] = {
  {   0, "s1" },
  {   1, "s50" },
  {   2, "s100" },
  {   3, "s200" },
  {   4, "s400" },
  {   5, "s600" },
  {   6, "s800" },
  {   7, "s1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_315(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_N_315ext_vals[] = {
  {   0, "s2" },
  {   1, "s4" },
  {   2, "s10" },
  {   3, "s20" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_315ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_N_315_r5_vals[] = {
  {   0, "s1" },
  {   1, "s2" },
  {   2, "s4" },
  {   3, "s10" },
  {   4, "s20" },
  {   5, "s50" },
  {   6, "s100" },
  {   7, "s200" },
  {   8, "s400" },
  {   9, "s600" },
  {  10, "s800" },
  {  11, "s1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_315_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     12, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_NetworkAssistedGPS_Supported_vals[] = {
  {   0, "networkBased" },
  {   1, "ue-Based" },
  {   2, "bothNetworkAndUE-Based" },
  {   3, "noNetworkAssistedGPS" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_NetworkAssistedGPS_Supported(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


const value_string umts_rrc_ies_PagingCause_vals[] = {
  {   0, "terminatingConversationalCall" },
  {   1, "terminatingStreamingCall" },
  {   2, "terminatingInteractiveCall" },
  {   3, "terminatingBackgroundCall" },
  {   4, "terminatingHighPrioritySignalling" },
  {   5, "terminatingLowPrioritySignalling" },
  {   6, "terminatingCauseUnknown" },
  {   7, "spare" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_PagingCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_cn_Identity_sequence[] = {
  { &hf_umts_rrc_ies_pagingCause, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingCause },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_cn_pagedUE_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_PagedUE_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cn_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cn_Identity, T_cn_Identity_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_SRNC_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     12, 12, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_S_RNTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     20, 20, FALSE, NULL);

  return offset;
}


static const per_sequence_t U_RNTI_sequence[] = {
  { &hf_umts_rrc_ies_srnc_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRNC_Identity },
  { &hf_umts_rrc_ies_s_RNTI , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_RNTI },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_U_RNTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_U_RNTI, U_RNTI_sequence);

  return offset;
}


static const per_sequence_t T_cn_OriginatedPage_connectedMode_UE_sequence[] = {
  { &hf_umts_rrc_ies_pagingCause, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingCause },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_pagingRecordTypeID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingRecordTypeID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE, T_cn_OriginatedPage_connectedMode_UE_sequence);

  return offset;
}


static const per_sequence_t T_utran_Identity_sequence[] = {
  { &hf_umts_rrc_ies_u_RNTI , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_U_RNTI },
  { &hf_umts_rrc_ies_cn_OriginatedPage_connectedMode_UE, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_utran_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_utran_Identity, T_utran_Identity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PagingRecord_vals[] = {
  {   0, "cn-Identity" },
  {   1, "utran-Identity" },
  { 0, NULL }
};

static const per_choice_t PagingRecord_choice[] = {
  {   0, &hf_umts_rrc_ies_cn_Identity, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cn_Identity },
  {   1, &hf_umts_rrc_ies_utran_Identity, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_utran_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PagingRecord(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PagingRecord, PagingRecord_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_cn_OriginatedPage_connectedMode_UE1_sequence[] = {
  { &hf_umts_rrc_ies_pagingCause, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingCause },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_pagingRecordTypeID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingRecordTypeID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE1, T_cn_OriginatedPage_connectedMode_UE1_sequence);

  return offset;
}


static const per_sequence_t T_utran_SingleUE_Identity_sequence[] = {
  { &hf_umts_rrc_ies_u_RNTI , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_U_RNTI },
  { &hf_umts_rrc_ies_cn_OriginatedPage_connectedMode_UE1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE1 },
  { &hf_umts_rrc_ies_rrc_ConnectionReleaseInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_ConnectionReleaseInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_utran_SingleUE_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_utran_SingleUE_Identity, T_utran_SingleUE_Identity_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation_sequence_of[1] = {
  { &hf_umts_rrc_ies_utran_GroupIdentity_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GroupIdentityWithReleaseInformation },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation, SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation_sequence_of,
                                                  1, maxURNTIGroup);

  return offset;
}


static const value_string umts_rrc_ies_PagingRecord2_r5_vals[] = {
  {   0, "utran-SingleUE-Identity" },
  {   1, "utran-GroupIdentity" },
  { 0, NULL }
};

static const per_choice_t PagingRecord2_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_utran_SingleUE_Identity, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_utran_SingleUE_Identity },
  {   1, &hf_umts_rrc_ies_utran_GroupIdentity, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PagingRecord2_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PagingRecord2_r5, PagingRecord2_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PagingRecordList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PagingRecordList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingRecord },
};

int
dissect_umts_rrc_ies_PagingRecordList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PagingRecordList, PagingRecordList_sequence_of,
                                                  1, maxPage1);

  return offset;
}


static const per_sequence_t PagingRecord2List_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_PagingRecord2List_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PagingRecord2_r5 },
};

int
dissect_umts_rrc_ies_PagingRecord2List_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PagingRecord2List_r5, PagingRecord2List_r5_sequence_of,
                                                  1, maxPage1);

  return offset;
}


static const value_string umts_rrc_ies_T_supportForRfc2507_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t T_supportForRfc2507_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxHcContextSpace },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_supportForRfc2507(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_supportForRfc2507, T_supportForRfc2507_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PDCP_Capability_sequence[] = {
  { &hf_umts_rrc_ies_losslessSRNS_RelocationSupport, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_supportForRfc2507, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_supportForRfc2507 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_Capability, PDCP_Capability_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_65535(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_supported_sequence[] = {
  { &hf_umts_rrc_ies_maxROHC_ContextSessions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxROHC_ContextSessions_r4 },
  { &hf_umts_rrc_ies_reverseCompressionDepth, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_supported(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_supported, T_supported_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_supportForRfc3095_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t T_supportForRfc3095_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_supported },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_supportForRfc3095(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_supportForRfc3095, T_supportForRfc3095_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PDCP_Capability_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_supportForRfc3095, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_supportForRfc3095 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_Capability_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_Capability_r4_ext, PDCP_Capability_r4_ext_sequence);

  return offset;
}


static const per_sequence_t PDCP_Capability_r5_ext_sequence[] = {
  { &hf_umts_rrc_ies_supportForRfc3095ContextRelocation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_maxHcContextSpace, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxHcContextSpace_r5_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_Capability_r5_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_Capability_r5_ext, PDCP_Capability_r5_ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_losslessDLRLC_PDUSizeChange_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_losslessDLRLC_PDUSizeChange(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PDCP_Capability_r5_ext2_sequence[] = {
  { &hf_umts_rrc_ies_losslessDLRLC_PDUSizeChange, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_losslessDLRLC_PDUSizeChange },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_Capability_r5_ext2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_Capability_r5_ext2, PDCP_Capability_r5_ext2_sequence);

  return offset;
}


static const per_sequence_t UL_PhysChCapabilityFDD_sequence[] = {
  { &hf_umts_rrc_ies_maxNoDPDCH_BitsTransmitted, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoDPDCH_BitsTransmitted },
  { &hf_umts_rrc_ies_dummy  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_PhysChCapabilityFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_PhysChCapabilityFDD, UL_PhysChCapabilityFDD_sequence);

  return offset;
}


static const per_sequence_t T_fddPhysChCapability_sequence[] = {
  { &hf_umts_rrc_ies_downlinkPhysChCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_PhysChCapabilityFDD },
  { &hf_umts_rrc_ies_uplinkPhysChCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_PhysChCapabilityFDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fddPhysChCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fddPhysChCapability, T_fddPhysChCapability_sequence);

  return offset;
}


static const per_sequence_t UL_PhysChCapabilityTDD_sequence[] = {
  { &hf_umts_rrc_ies_maxTS_PerFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTS_PerFrame },
  { &hf_umts_rrc_ies_maxPhysChPerTimeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPhysChPerTimeslot },
  { &hf_umts_rrc_ies_minimumSF1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MinimumSF_UL },
  { &hf_umts_rrc_ies_supportOfPUSCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_PhysChCapabilityTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_PhysChCapabilityTDD, UL_PhysChCapabilityTDD_sequence);

  return offset;
}


static const per_sequence_t T_tddPhysChCapability_sequence[] = {
  { &hf_umts_rrc_ies_downlinkPhysChCapability1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_PhysChCapabilityTDD },
  { &hf_umts_rrc_ies_uplinkPhysChCapability1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_PhysChCapabilityTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddPhysChCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tddPhysChCapability, T_tddPhysChCapability_sequence);

  return offset;
}


static const per_sequence_t PhysicalChannelCapability_sequence[] = {
  { &hf_umts_rrc_ies_fddPhysChCapability, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_fddPhysChCapability },
  { &hf_umts_rrc_ies_tddPhysChCapability, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tddPhysChCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PhysicalChannelCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PhysicalChannelCapability, PhysicalChannelCapability_sequence);

  return offset;
}


static const per_sequence_t UL_PhysChCapabilityTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_maxTS_PerSubFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTS_PerSubFrame_r4 },
  { &hf_umts_rrc_ies_maxPhysChPerTimeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPhysChPerTimeslot },
  { &hf_umts_rrc_ies_minimumSF1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MinimumSF_UL },
  { &hf_umts_rrc_ies_supportOfPUSCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_supportOf8PSK, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_PhysChCapabilityTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_PhysChCapabilityTDD_LCR_r4, UL_PhysChCapabilityTDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_tdd128_PhysChCapability_sequence[] = {
  { &hf_umts_rrc_ies_downlinkPhysChCapability2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_PhysChCapabilityTDD_LCR_r4 },
  { &hf_umts_rrc_ies_uplinkPhysChCapability2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_PhysChCapabilityTDD_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128_PhysChCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd128_PhysChCapability, T_tdd128_PhysChCapability_sequence);

  return offset;
}


static const per_sequence_t PhysicalChannelCapability_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tdd128_PhysChCapability, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tdd128_PhysChCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PhysicalChannelCapability_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PhysicalChannelCapability_LCR_r4, PhysicalChannelCapability_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_supported1_sequence[] = {
  { &hf_umts_rrc_ies_hsdsch_physical_layer_category, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HSDSCH_physical_layer_category },
  { &hf_umts_rrc_ies_dummy  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dummy2 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_supported1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_supported1, T_supported1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_fdd_hspdsch_vals[] = {
  {   0, "supported" },
  {   1, "unsupported" },
  { 0, NULL }
};

static const per_choice_t T_fdd_hspdsch_choice[] = {
  {   0, &hf_umts_rrc_ies_supported2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_supported1 },
  {   1, &hf_umts_rrc_ies_unsupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd_hspdsch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_fdd_hspdsch, T_fdd_hspdsch_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd384_hspdsch_vals[] = {
  {   0, "supported" },
  {   1, "unsupported" },
  { 0, NULL }
};

static const per_choice_t T_tdd384_hspdsch_choice[] = {
  {   0, &hf_umts_rrc_ies_supported3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_HSDSCH_physical_layer_category },
  {   1, &hf_umts_rrc_ies_unsupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd384_hspdsch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd384_hspdsch, T_tdd384_hspdsch_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd128_hspdsch_vals[] = {
  {   0, "supported" },
  {   1, "unsupported" },
  { 0, NULL }
};

static const per_choice_t T_tdd128_hspdsch_choice[] = {
  {   0, &hf_umts_rrc_ies_supported3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_HSDSCH_physical_layer_category },
  {   1, &hf_umts_rrc_ies_unsupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128_hspdsch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd128_hspdsch, T_tdd128_hspdsch_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PhysicalChannelCapability_hspdsch_r5_sequence[] = {
  { &hf_umts_rrc_ies_fdd_hspdsch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_fdd_hspdsch },
  { &hf_umts_rrc_ies_tdd384_hspdsch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tdd384_hspdsch },
  { &hf_umts_rrc_ies_tdd128_hspdsch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tdd128_hspdsch },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PhysicalChannelCapability_hspdsch_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PhysicalChannelCapability_hspdsch_r5, PhysicalChannelCapability_hspdsch_r5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_numberOfRepetitionsPerSFNPeriod_vals[] = {
  {   0, "c2" },
  {   1, "c3" },
  {   2, "c4" },
  {   3, "c5" },
  {   4, "c6" },
  {   5, "c7" },
  {   6, "c8" },
  {   7, "c9" },
  {   8, "c10" },
  {   9, "c12" },
  {  10, "c14" },
  {  11, "c16" },
  {  12, "c18" },
  {  13, "c20" },
  {  14, "c24" },
  {  15, "c28" },
  {  16, "c32" },
  {  17, "c36" },
  {  18, "c40" },
  {  19, "c48" },
  {  20, "c56" },
  {  21, "c64" },
  {  22, "c72" },
  {  23, "c80" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_numberOfRepetitionsPerSFNPeriod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     24, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PNBSCH_Allocation_r4_sequence[] = {
  { &hf_umts_rrc_ies_numberOfRepetitionsPerSFNPeriod, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_numberOfRepetitionsPerSFNPeriod },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PNBSCH_Allocation_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PNBSCH_Allocation_r4, PNBSCH_Allocation_r4_sequence);

  return offset;
}


const value_string umts_rrc_ies_ProtocolErrorIndicator_vals[] = {
  {   0, "noError" },
  {   1, "errorOccurred" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_ProtocolErrorIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_errorOccurred_sequence[] = {
  { &hf_umts_rrc_ies_rrc_TransactionIdentifier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_TransactionIdentifier },
  { &hf_umts_rrc_ies_protocolErrorInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ProtocolErrorInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_errorOccurred(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_errorOccurred, T_errorOccurred_sequence);

  return offset;
}


const value_string umts_rrc_ies_ProtocolErrorIndicatorWithMoreInfo_vals[] = {
  {   0, "noError" },
  {   1, "errorOccurred" },
  { 0, NULL }
};

static const per_choice_t ProtocolErrorIndicatorWithMoreInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_noError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_errorOccurred, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_errorOccurred },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_ProtocolErrorIndicatorWithMoreInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ProtocolErrorIndicatorWithMoreInfo, ProtocolErrorIndicatorWithMoreInfo_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_ReceivedMessageType_vals[] = {
  {   0, "activeSetUpdate" },
  {   1, "cellChangeOrderFromUTRAN" },
  {   2, "cellUpdateConfirm" },
  {   3, "counterCheck" },
  {   4, "downlinkDirectTransfer" },
  {   5, "interRATHandoverCommand" },
  {   6, "measurementControl" },
  {   7, "pagingType2" },
  {   8, "physicalChannelReconfiguration" },
  {   9, "physicalSharedChannelAllocation" },
  {  10, "radioBearerReconfiguration" },
  {  11, "radioBearerRelease" },
  {  12, "radioBearerSetup" },
  {  13, "rrcConnectionRelease" },
  {  14, "rrcConnectionReject" },
  {  15, "rrcConnectionSetup" },
  {  16, "securityModeCommand" },
  {  17, "signallingConnectionRelease" },
  {  18, "transportChannelReconfiguration" },
  {  19, "transportFormatCombinationControl" },
  {  20, "ueCapabilityEnquiry" },
  {  21, "ueCapabilityInformationConfirm" },
  {  22, "uplinkPhysicalChannelControl" },
  {  23, "uraUpdateConfirm" },
  {  24, "utranMobilityInformation" },
  {  25, "assistanceDataDelivery" },
  {  26, "spare6" },
  {  27, "spare5" },
  {  28, "spare4" },
  {  29, "spare3" },
  {  30, "spare2" },
  {  31, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReceivedMessageType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     32, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IdentificationOfReceivedMessage_sequence[] = {
  { &hf_umts_rrc_ies_rrc_TransactionIdentifier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC_TransactionIdentifier },
  { &hf_umts_rrc_ies_receivedMessageType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReceivedMessageType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IdentificationOfReceivedMessage(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IdentificationOfReceivedMessage, IdentificationOfReceivedMessage_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_type1_vals[] = {
  {   0, "asn1-ViolationOrEncodingError" },
  {   1, "messageTypeNonexistent" },
  {   2, "messageNotCompatibleWithReceiverState" },
  {   3, "ie-ValueNotComprehended" },
  {   4, "conditionalInformationElementError" },
  {   5, "messageExtensionNotComprehended" },
  {   6, "spare1" },
  {   7, "spare2" },
  { 0, NULL }
};

static const per_choice_t T_type1_choice[] = {
  {   0, &hf_umts_rrc_ies_asn1_ViolationOrEncodingError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_messageTypeNonexistent, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_messageNotCompatibleWithReceiverState, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IdentificationOfReceivedMessage },
  {   3, &hf_umts_rrc_ies_ie_ValueNotComprehended, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IdentificationOfReceivedMessage },
  {   4, &hf_umts_rrc_ies_conditionalInformationElementError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IdentificationOfReceivedMessage },
  {   5, &hf_umts_rrc_ies_messageExtensionNotComprehended, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IdentificationOfReceivedMessage },
  {   6, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_type1, T_type1_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_diagnosticsType_vals[] = {
  {   0, "type1" },
  {   1, "spare" },
  { 0, NULL }
};

static const per_choice_t T_diagnosticsType_choice[] = {
  {   0, &hf_umts_rrc_ies_type1  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type1 },
  {   1, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_diagnosticsType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_diagnosticsType, T_diagnosticsType_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ProtocolErrorMoreInformation_sequence[] = {
  { &hf_umts_rrc_ies_diagnosticsType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_diagnosticsType },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_ProtocolErrorMoreInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ProtocolErrorMoreInformation, ProtocolErrorMoreInformation_sequence);

  return offset;
}


const value_string umts_rrc_ies_RadioFrequencyBandTDDList_vals[] = {
  {   0, "a" },
  {   1, "b" },
  {   2, "c" },
  {   3, "ab" },
  {   4, "ac" },
  {   5, "bc" },
  {   6, "abc" },
  {   7, "spare" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_RadioFrequencyBandTDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t Rb_timer_indicator_sequence[] = {
  { &hf_umts_rrc_ies_t314_expired, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_t315_expired, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_Rb_timer_indicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Rb_timer_indicator, Rb_timer_indicator_sequence);

  return offset;
}


static const value_string umts_rrc_ies_Re_EstablishmentTimer_vals[] = {
  {   0, "useT314" },
  {   1, "useT315" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_Re_EstablishmentTimer(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_UARFCN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 16383U, NULL, FALSE);

  return offset;
}


static const per_sequence_t FrequencyInfoFDD_sequence[] = {
  { &hf_umts_rrc_ies_uarfcn_UL, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UARFCN },
  { &hf_umts_rrc_ies_uarfcn_DL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UARFCN },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_FrequencyInfoFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FrequencyInfoFDD, FrequencyInfoFDD_sequence);

  return offset;
}


static const per_sequence_t FrequencyInfoTDD_sequence[] = {
  { &hf_umts_rrc_ies_uarfcn_Nt, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UARFCN },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_FrequencyInfoTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FrequencyInfoTDD, FrequencyInfoTDD_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo25_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo25_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd28  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_FrequencyInfoFDD },
  {   1, &hf_umts_rrc_ies_tdd26  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_FrequencyInfoTDD },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo25(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo25, T_modeSpecificInfo25_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t FrequencyInfo_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo25, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo25 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_FrequencyInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FrequencyInfo, FrequencyInfo_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterRATInfo_vals[] = {
  {   0, "gsm" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_InterRATInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


const value_string umts_rrc_ies_RedirectionInfo_vals[] = {
  {   0, "frequencyInfo" },
  {   1, "interRATInfo" },
  { 0, NULL }
};

static const per_choice_t RedirectionInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_FrequencyInfo },
  {   1, &hf_umts_rrc_ies_interRATInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATInfo },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_RedirectionInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RedirectionInfo, RedirectionInfo_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BCCH_ARFCN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1023U, NULL, FALSE);

  return offset;
}


const value_string umts_rrc_ies_Frequency_Band_vals[] = {
  {   0, "dcs1800BandUsed" },
  {   1, "pcs1900BandUsed" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_Frequency_Band(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NCC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_BCC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const per_sequence_t BSIC_sequence[] = {
  { &hf_umts_rrc_ies_ncc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NCC },
  { &hf_umts_rrc_ies_bcc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BCC },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_BSIC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_BSIC, BSIC_sequence);

  return offset;
}


static const per_sequence_t GSM_TargetCellInfo_sequence[] = {
  { &hf_umts_rrc_ies_bcch_ARFCN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BCCH_ARFCN },
  { &hf_umts_rrc_ies_frequency_band, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Frequency_Band },
  { &hf_umts_rrc_ies_bsic   , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BSIC },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GSM_TargetCellInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GSM_TargetCellInfo, GSM_TargetCellInfo_sequence);

  return offset;
}


static const per_sequence_t GSM_TargetCellInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_GSM_TargetCellInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GSM_TargetCellInfo },
};

int
dissect_umts_rrc_ies_GSM_TargetCellInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GSM_TargetCellInfoList, GSM_TargetCellInfoList_sequence_of,
                                                  1, maxGSMTargetCells);

  return offset;
}


static const per_sequence_t InterRATInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_rat1   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATInfo },
  { &hf_umts_rrc_ies_gsm_TargetCellInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_GSM_TargetCellInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATInfo_r6, InterRATInfo_r6_sequence);

  return offset;
}


const value_string umts_rrc_ies_RedirectionInfo_r6_vals[] = {
  {   0, "frequencyInfo" },
  {   1, "interRATInfo" },
  { 0, NULL }
};

static const per_choice_t RedirectionInfo_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_FrequencyInfo },
  {   1, &hf_umts_rrc_ies_interRATInfo1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATInfo_r6 },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_RedirectionInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RedirectionInfo_r6, RedirectionInfo_r6_choice,
                                 NULL);

  return offset;
}


const value_string umts_rrc_ies_RejectionCause_vals[] = {
  {   0, "congestion" },
  {   1, "unspecified" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_RejectionCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_UE_PowerClass(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 4U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_TxRxFrequencySeparation_vals[] = {
  {   0, "mhz190" },
  {   1, "mhz174-8-205-2" },
  {   2, "mhz134-8-245-2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TxRxFrequencySeparation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fddRF_Capability_sequence[] = {
  { &hf_umts_rrc_ies_ue_PowerClass, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PowerClass },
  { &hf_umts_rrc_ies_txRxFrequencySeparation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TxRxFrequencySeparation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fddRF_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fddRF_Capability, T_fddRF_Capability_sequence);

  return offset;
}


static const per_sequence_t T_tddRF_Capability_sequence[] = {
  { &hf_umts_rrc_ies_ue_PowerClass, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PowerClass },
  { &hf_umts_rrc_ies_radioFrequencyTDDBandList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandTDDList },
  { &hf_umts_rrc_ies_chipRateCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChipRateCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddRF_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tddRF_Capability, T_tddRF_Capability_sequence);

  return offset;
}


static const per_sequence_t RF_Capability_sequence[] = {
  { &hf_umts_rrc_ies_fddRF_Capability, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_fddRF_Capability },
  { &hf_umts_rrc_ies_tddRF_Capability, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tddRF_Capability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RF_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RF_Capability, RF_Capability_sequence);

  return offset;
}


static const per_sequence_t T_tddRF_Capability1_sequence[] = {
  { &hf_umts_rrc_ies_ue_PowerClass, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PowerClass },
  { &hf_umts_rrc_ies_radioFrequencyBandTDDList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandTDDList },
  { &hf_umts_rrc_ies_chipRateCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChipRateCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddRF_Capability1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tddRF_Capability1, T_tddRF_Capability1_sequence);

  return offset;
}


static const per_sequence_t RF_Capability_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_tddRF_Capability1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tddRF_Capability1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RF_Capability_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RF_Capability_r4_ext, RF_Capability_r4_ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TotalRLC_AM_BufferSize_vals[] = {
  {   0, "dummy" },
  {   1, "kb10" },
  {   2, "kb50" },
  {   3, "kb100" },
  {   4, "kb150" },
  {   5, "kb500" },
  {   6, "kb1000" },
  {   7, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TotalRLC_AM_BufferSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RLC_Capability_sequence[] = {
  { &hf_umts_rrc_ies_totalRLC_AM_BufferSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TotalRLC_AM_BufferSize },
  { &hf_umts_rrc_ies_maximumRLC_WindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaximumRLC_WindowSize },
  { &hf_umts_rrc_ies_maximumAM_EntityNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaximumAM_EntityNumberRLC_Cap },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_Capability, RLC_Capability_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TotalRLC_AM_BufferSize_r5_ext_vals[] = {
  {   0, "kb200" },
  {   1, "kb300" },
  {   2, "kb400" },
  {   3, "kb750" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TotalRLC_AM_BufferSize_r5_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RLC_Capability_r5_ext_sequence[] = {
  { &hf_umts_rrc_ies_totalRLC_AM_BufferSize1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TotalRLC_AM_BufferSize_r5_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_Capability_r5_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_Capability_r5_ext, RLC_Capability_r5_ext_sequence);

  return offset;
}


const value_string umts_rrc_ies_RRC_StateIndicator_vals[] = {
  {   0, "cell-DCH" },
  {   1, "cell-FACH" },
  {   2, "cell-PCH" },
  {   3, "ura-PCH" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_RRC_StateIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_S_RNTI_2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     10, 10, FALSE, NULL);

  return offset;
}


static const asn_namedbit T_cipheringAlgorithmCap_bits[] = {
  {  0, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare15, -1, -1, "spare15", NULL },
  {  1, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare14, -1, -1, "spare14", NULL },
  {  2, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare13, -1, -1, "spare13", NULL },
  {  3, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare12, -1, -1, "spare12", NULL },
  {  4, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare11, -1, -1, "spare11", NULL },
  {  5, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare10, -1, -1, "spare10", NULL },
  {  6, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare9, -1, -1, "spare9", NULL },
  {  7, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare8, -1, -1, "spare8", NULL },
  {  8, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare7, -1, -1, "spare7", NULL },
  {  9, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare6, -1, -1, "spare6", NULL },
  { 10, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare5, -1, -1, "spare5", NULL },
  { 11, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare4, -1, -1, "spare4", NULL },
  { 12, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare3, -1, -1, "spare3", NULL },
  { 13, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare2, -1, -1, "spare2", NULL },
  { 14, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_uea1, -1, -1, "uea1", NULL },
  { 15, &hf_umts_rrc_ies_T_cipheringAlgorithmCap_uea0, -1, -1, "uea0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_cipheringAlgorithmCap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const asn_namedbit T_integrityProtectionAlgorithmCap_bits[] = {
  {  0, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare15, -1, -1, "spare15", NULL },
  {  1, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare14, -1, -1, "spare14", NULL },
  {  2, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare13, -1, -1, "spare13", NULL },
  {  3, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare12, -1, -1, "spare12", NULL },
  {  4, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare11, -1, -1, "spare11", NULL },
  {  5, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare10, -1, -1, "spare10", NULL },
  {  6, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare9, -1, -1, "spare9", NULL },
  {  7, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare8, -1, -1, "spare8", NULL },
  {  8, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare7, -1, -1, "spare7", NULL },
  {  9, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare6, -1, -1, "spare6", NULL },
  { 10, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare5, -1, -1, "spare5", NULL },
  { 11, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare4, -1, -1, "spare4", NULL },
  { 12, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare3, -1, -1, "spare3", NULL },
  { 13, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare2, -1, -1, "spare2", NULL },
  { 14, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_uia1, -1, -1, "uia1", NULL },
  { 15, &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare0, -1, -1, "spare0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_integrityProtectionAlgorithmCap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const per_sequence_t SecurityCapability_sequence[] = {
  { &hf_umts_rrc_ies_cipheringAlgorithmCap, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cipheringAlgorithmCap },
  { &hf_umts_rrc_ies_integrityProtectionAlgorithmCap, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_integrityProtectionAlgorithmCap },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_SecurityCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SecurityCapability, SecurityCapability_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaACK(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaNACK(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_HARQ_Preamble_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_PrimaryScramblingCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 511U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PrimaryCPICH_Info_sequence[] = {
  { &hf_umts_rrc_ies_primaryScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryScramblingCode },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PrimaryCPICH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PrimaryCPICH_Info, PrimaryCPICH_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_HS_SCCH_Codes(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes_sequence_of[1] = {
  { &hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SCCH_Codes },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes, SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes_sequence_of,
                                                  1, maxHSSCCHs);

  return offset;
}



static int
dissect_umts_rrc_ies_SecondaryScramblingCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd27_sequence[] = {
  { &hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes },
  { &hf_umts_rrc_ies_dl_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd27(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd27, T_fdd27_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M7_8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -7, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M22_40(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -22, 40U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_ConstantValue(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -35, -10, NULL, FALSE);

  return offset;
}


static const per_sequence_t HS_SICH_Power_Control_Info_TDD384_sequence[] = {
  { &hf_umts_rrc_ies_ul_target_SIR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M22_40 },
  { &hf_umts_rrc_ies_hs_sich_ConstantValue, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValue },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_HS_SICH_Power_Control_Info_TDD384(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SICH_Power_Control_Info_TDD384, HS_SICH_Power_Control_Info_TDD384_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeslotNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 14U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_DL_TS_ChannelisationCode_vals[] = {
  {   0, "cc16-1" },
  {   1, "cc16-2" },
  {   2, "cc16-3" },
  {   3, "cc16-4" },
  {   4, "cc16-5" },
  {   5, "cc16-6" },
  {   6, "cc16-7" },
  {   7, "cc16-8" },
  {   8, "cc16-9" },
  {   9, "cc16-10" },
  {  10, "cc16-11" },
  {  11, "cc16-12" },
  {  12, "cc16-13" },
  {  13, "cc16-14" },
  {  14, "cc16-15" },
  {  15, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_TS_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MidambleShiftLong(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble1_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble1, T_ueSpecificMidamble1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode3_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode3_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode3, T_midambleAllocationMode3_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_MidambleConfigurationBurstType1and3_vals[] = {
  {   0, "ms4" },
  {   1, "ms8" },
  {   2, "ms16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MidambleConfigurationBurstType1and3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_Bler_Target(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -63, 0U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble2_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble2, T_ueSpecificMidamble2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode4_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode4_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_ueSpecificMidamble3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode4, T_midambleAllocationMode4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HS_SICH_Configuration_TDD384_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_channelisationCode3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
  { &hf_umts_rrc_ies_midambleAllocationMode4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode4 },
  { &hf_umts_rrc_ies_midambleconfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType1and3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_SICH_Configuration_TDD384(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SICH_Configuration_TDD384, HS_SICH_Configuration_TDD384_sequence);

  return offset;
}


static const per_sequence_t HS_SCCH_TDD384_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_channelisationCode3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
  { &hf_umts_rrc_ies_midambleAllocationMode3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode3 },
  { &hf_umts_rrc_ies_midambleconfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType1and3 },
  { &hf_umts_rrc_ies_bler_target, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Bler_Target },
  { &hf_umts_rrc_ies_hs_sich_configuration1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SICH_Configuration_TDD384 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_SCCH_TDD384(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SCCH_TDD384, HS_SCCH_TDD384_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384_sequence_of[1] = {
  { &hf_umts_rrc_ies_hS_SCCH_SetConfiguration_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SCCH_TDD384 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384, SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384_sequence_of,
                                                  1, maxHSSCCHs);

  return offset;
}


static const per_sequence_t T_tdd3843_sequence[] = {
  { &hf_umts_rrc_ies_nack_ack_power_offset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M7_8 },
  { &hf_umts_rrc_ies_hs_SICH_PowerControl_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SICH_Power_Control_Info_TDD384 },
  { &hf_umts_rrc_ies_hS_SCCH_SetConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3843(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3843, T_tdd3843_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeslotNumber_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 6U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_HS_ChannelisationCode_LCR_vals[] = {
  {   0, "cc16-1" },
  {   1, "cc16-2" },
  {   2, "cc16-3" },
  {   3, "cc16-4" },
  {   4, "cc16-5" },
  {   5, "cc16-6" },
  {   6, "cc16-7" },
  {   7, "cc16-8" },
  {   8, "cc16-9" },
  {   9, "cc16-10" },
  {  10, "cc16-11" },
  {  11, "cc16-12" },
  {  12, "cc16-13" },
  {  13, "cc16-14" },
  {  14, "cc16-15" },
  {  15, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_HS_ChannelisationCode_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode1_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode1_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode1, T_midambleAllocationMode1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble, T_ueSpecificMidamble_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode2_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode2_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_ueSpecificMidamble1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode2, T_midambleAllocationMode2_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M120_M58(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -120, -58, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_tpc_step_size_vals[] = {
  {   0, "s1" },
  {   1, "s2" },
  {   2, "s3" },
  {   3, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_tpc_step_size(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t HS_SICH_Configuration_TDD128_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { &hf_umts_rrc_ies_channelisationCode2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_ChannelisationCode_LCR },
  { &hf_umts_rrc_ies_midambleAllocationMode2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode2 },
  { &hf_umts_rrc_ies_midambleConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { &hf_umts_rrc_ies_nack_ack_power_offset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M7_8 },
  { &hf_umts_rrc_ies_power_level_HSSICH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M120_M58 },
  { &hf_umts_rrc_ies_tpc_step_size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tpc_step_size },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_SICH_Configuration_TDD128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SICH_Configuration_TDD128, HS_SICH_Configuration_TDD128_sequence);

  return offset;
}


static const per_sequence_t HS_SCCH_TDD128_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { &hf_umts_rrc_ies_firstChannelisationCode1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_ChannelisationCode_LCR },
  { &hf_umts_rrc_ies_secondChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_ChannelisationCode_LCR },
  { &hf_umts_rrc_ies_midambleAllocationMode1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode1 },
  { &hf_umts_rrc_ies_midambleConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { &hf_umts_rrc_ies_bler_target, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Bler_Target },
  { &hf_umts_rrc_ies_hs_sich_configuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SICH_Configuration_TDD128 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_SCCH_TDD128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SCCH_TDD128, HS_SCCH_TDD128_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd128_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SCCH_TDD128 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128, SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128_sequence_of,
                                                  1, maxHSSCCHs);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd23_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tdd23_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3844, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3843 },
  {   1, &hf_umts_rrc_ies_tdd1286, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd23(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd23, T_tdd23_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo26_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo26_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd29  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd27 },
  {   1, &hf_umts_rrc_ies_tdd27  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd23 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo26(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo26, T_modeSpecificInfo26_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HS_SCCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo26, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo26 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_SCCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SCCH_Info, HS_SCCH_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MeasurementPowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -12, 26U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_Feedback_cycle_vals[] = {
  {   0, "fc0" },
  {   1, "fc2" },
  {   2, "fc4" },
  {   3, "fc8" },
  {   4, "fc10" },
  {   5, "fc20" },
  {   6, "fc40" },
  {   7, "fc80" },
  {   8, "fc160" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_Feedback_cycle(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     9, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_CQI_RepetitionFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 4U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaCQI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd29_sequence[] = {
  { &hf_umts_rrc_ies_measurementPowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementPowerOffset },
  { &hf_umts_rrc_ies_feedback_cycle, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Feedback_cycle },
  { &hf_umts_rrc_ies_cqi_RepetitionFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CQI_RepetitionFactor },
  { &hf_umts_rrc_ies_deltaCQI, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaCQI },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd29(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd29, T_fdd29_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo28_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo28_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd31  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd29 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo28(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo28, T_modeSpecificInfo28_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t Measurement_Feedback_Info_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo28, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo28 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Measurement_Feedback_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Measurement_Feedback_Info, Measurement_Feedback_Info_sequence);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble6_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble6, T_ueSpecificMidamble6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode8_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode8_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble7, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode8, T_midambleAllocationMode8_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_type12_sequence[] = {
  { &hf_umts_rrc_ies_midambleConfigurationBurstType1and3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType1and3 },
  { &hf_umts_rrc_ies_midambleAllocationMode8, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_type12, T_type12_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MidambleConfigurationBurstType2_vals[] = {
  {   0, "ms3" },
  {   1, "ms6" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MidambleConfigurationBurstType2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MidambleShiftShort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 5U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble7_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftShort },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble7, T_ueSpecificMidamble7_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode9_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode9_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble8, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble7 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode9, T_midambleAllocationMode9_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_type21_sequence[] = {
  { &hf_umts_rrc_ies_midambleConfigurationBurstType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType2 },
  { &hf_umts_rrc_ies_midambleAllocationMode9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode9 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_type21, T_type21_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_burstType1_vals[] = {
  {   0, "type1" },
  {   1, "type2" },
  { 0, NULL }
};

static const per_choice_t T_burstType1_choice[] = {
  {   0, &hf_umts_rrc_ies_type12 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type12 },
  {   1, &hf_umts_rrc_ies_type21 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type21 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_burstType1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_burstType1, T_burstType1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MidambleShiftAndBurstType_DL_sequence[] = {
  { &hf_umts_rrc_ies_burstType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_burstType1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MidambleShiftAndBurstType_DL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MidambleShiftAndBurstType_DL, MidambleShiftAndBurstType_DL_sequence);

  return offset;
}


static const per_sequence_t DL_HSPDSCH_TS_Configuration_item_sequence[] = {
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_DL },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item, DL_HSPDSCH_TS_Configuration_item_sequence);

  return offset;
}


static const per_sequence_t DL_HSPDSCH_TS_Configuration_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item },
};

static int
dissect_umts_rrc_ies_DL_HSPDSCH_TS_Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_HSPDSCH_TS_Configuration, DL_HSPDSCH_TS_Configuration_sequence_of,
                                                  1, maxTS1);

  return offset;
}


static const per_sequence_t T_tdd3841_sequence[] = {
  { &hf_umts_rrc_ies_dl_HSPDSCH_TS_Configuration, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_HSPDSCH_TS_Configuration },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3841(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3841, T_tdd3841_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode, T_midambleAllocationMode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HS_PDSCH_Midamble_Configuration_TDD128_sequence[] = {
  { &hf_umts_rrc_ies_midambleAllocationMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode },
  { &hf_umts_rrc_ies_midambleConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_PDSCH_Midamble_Configuration_TDD128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_PDSCH_Midamble_Configuration_TDD128, HS_PDSCH_Midamble_Configuration_TDD128_sequence);

  return offset;
}


static const per_sequence_t T_tdd1284_sequence[] = {
  { &hf_umts_rrc_ies_hs_PDSCH_Midamble_Configuration_tdd128, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HS_PDSCH_Midamble_Configuration_TDD128 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1284(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1284, T_tdd1284_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd21_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tdd21_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3842, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3841 },
  {   1, &hf_umts_rrc_ies_tdd1284, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1284 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd21, T_tdd21_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo18_vals[] = {
  {   0, "tdd" },
  {   1, "fdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo18_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd22  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd21 },
  {   1, &hf_umts_rrc_ies_fdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo18(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo18, T_modeSpecificInfo18_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_HSPDSCH_Information_sequence[] = {
  { &hf_umts_rrc_ies_hs_scch_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HS_SCCH_Info },
  { &hf_umts_rrc_ies_measurement_feedback_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Measurement_Feedback_Info },
  { &hf_umts_rrc_ies_modeSpecificInfo18, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo18 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_HSPDSCH_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_HSPDSCH_Information, DL_HSPDSCH_Information_sequence);

  return offset;
}


static const value_string umts_rrc_ies_HARQMemorySize_vals[] = {
  {   0, "hms800" },
  {   1, "hms1600" },
  {   2, "hms2400" },
  {   3, "hms3200" },
  {   4, "hms4000" },
  {   5, "hms4800" },
  {   6, "hms5600" },
  {   7, "hms6400" },
  {   8, "hms7200" },
  {   9, "hms8000" },
  {  10, "hms8800" },
  {  11, "hms9600" },
  {  12, "hms10400" },
  {  13, "hms11200" },
  {  14, "hms12000" },
  {  15, "hms12800" },
  {  16, "hms13600" },
  {  17, "hms14400" },
  {  18, "hms15200" },
  {  19, "hms16000" },
  {  20, "hms17600" },
  {  21, "hms19200" },
  {  22, "hms20800" },
  {  23, "hms22400" },
  {  24, "hms24000" },
  {  25, "hms25600" },
  {  26, "hms27200" },
  {  27, "hms28800" },
  {  28, "hms30400" },
  {  29, "hms32000" },
  {  30, "hms36000" },
  {  31, "hms40000" },
  {  32, "hms44000" },
  {  33, "hms48000" },
  {  34, "hms52000" },
  {  35, "hms56000" },
  {  36, "hms60000" },
  {  37, "hms64000" },
  {  38, "hms68000" },
  {  39, "hms72000" },
  {  40, "hms76000" },
  {  41, "hms80000" },
  {  42, "hms88000" },
  {  43, "hms96000" },
  {  44, "hms104000" },
  {  45, "hms112000" },
  {  46, "hms120000" },
  {  47, "hms128000" },
  {  48, "hms136000" },
  {  49, "hms144000" },
  {  50, "hms152000" },
  {  51, "hms160000" },
  {  52, "hms176000" },
  {  53, "hms192000" },
  {  54, "hms208000" },
  {  55, "hms224000" },
  {  56, "hms240000" },
  {  57, "hms256000" },
  {  58, "hms272000" },
  {  59, "hms288000" },
  {  60, "hms304000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_HARQMemorySize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     61, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize_sequence_of[1] = {
  { &hf_umts_rrc_ies_explicit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HARQMemorySize },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize, SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize_sequence_of,
                                                  1, maxHProcesses);

  return offset;
}


static const value_string umts_rrc_ies_T_memoryPartitioning_vals[] = {
  {   0, "implicit" },
  {   1, "explicit" },
  { 0, NULL }
};

static const per_choice_t T_memoryPartitioning_choice[] = {
  {   0, &hf_umts_rrc_ies_implicit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_explicit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_memoryPartitioning(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_memoryPartitioning, T_memoryPartitioning_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HARQ_Info_sequence[] = {
  { &hf_umts_rrc_ies_numberOfProcesses, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { &hf_umts_rrc_ies_memoryPartitioning, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_memoryPartitioning },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HARQ_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HARQ_Info, HARQ_Info_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_mac_hsResetIndicator_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_mac_hsResetIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t Serving_HSDSCH_CellInformation_sequence[] = {
  { &hf_umts_rrc_ies_deltaACK, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaACK },
  { &hf_umts_rrc_ies_deltaNACK, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaNACK },
  { &hf_umts_rrc_ies_harq_Preamble_Mode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HARQ_Preamble_Mode },
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_hspdsch_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_HSPDSCH_Information },
  { &hf_umts_rrc_ies_harqInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HARQ_Info },
  { &hf_umts_rrc_ies_mac_hsResetIndicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_mac_hsResetIndicator },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_Serving_HSDSCH_CellInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Serving_HSDSCH_CellInformation, Serving_HSDSCH_CellInformation_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_START_Value(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     20, 20, FALSE, NULL);

  return offset;
}


static const per_sequence_t STARTSingle_sequence[] = {
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_start_Value, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_START_Value },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_STARTSingle(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_STARTSingle, STARTSingle_sequence);

  return offset;
}


static const per_sequence_t STARTList_sequence_of[1] = {
  { &hf_umts_rrc_ies_STARTList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_STARTSingle },
};

int
dissect_umts_rrc_ies_STARTList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_STARTList, STARTList_sequence_of,
                                                  1, maxCNdomains);

  return offset;
}


static const value_string umts_rrc_ies_SystemSpecificCapUpdateReq_r5_vals[] = {
  {   0, "gsm" },
  {   1, "geranIu" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SystemSpecificCapUpdateReq_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SystemSpecificCapUpdateReqList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SystemSpecificCapUpdateReq_r5 },
};

static int
dissect_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5, SystemSpecificCapUpdateReqList_r5_sequence_of,
                                                  1, maxSystemCapability);

  return offset;
}


static const per_sequence_t CapabilityUpdateRequirement_r5_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement_FDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD384, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD128, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_systemSpecificCapUpdateReqList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CapabilityUpdateRequirement_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CapabilityUpdateRequirement_r5, CapabilityUpdateRequirement_r5_sequence);

  return offset;
}


const value_string umts_rrc_ies_SystemSpecificCapUpdateReq_v590ext_vals[] = {
  {   0, "geranIu" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_SystemSpecificCapUpdateReq_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_300_vals[] = {
  {   0, "ms100" },
  {   1, "ms200" },
  {   2, "ms400" },
  {   3, "ms600" },
  {   4, "ms800" },
  {   5, "ms1000" },
  {   6, "ms1200" },
  {   7, "ms1400" },
  {   8, "ms1600" },
  {   9, "ms1800" },
  {  10, "ms2000" },
  {  11, "ms3000" },
  {  12, "ms4000" },
  {  13, "ms6000" },
  {  14, "ms8000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_300(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     15, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_301_vals[] = {
  {   0, "ms100" },
  {   1, "ms200" },
  {   2, "ms400" },
  {   3, "ms600" },
  {   4, "ms800" },
  {   5, "ms1000" },
  {   6, "ms1200" },
  {   7, "ms1400" },
  {   8, "ms1600" },
  {   9, "ms1800" },
  {  10, "ms2000" },
  {  11, "ms3000" },
  {  12, "ms4000" },
  {  13, "ms6000" },
  {  14, "ms8000" },
  {  15, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_301(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_302_vals[] = {
  {   0, "ms100" },
  {   1, "ms200" },
  {   2, "ms400" },
  {   3, "ms600" },
  {   4, "ms800" },
  {   5, "ms1000" },
  {   6, "ms1200" },
  {   7, "ms1400" },
  {   8, "ms1600" },
  {   9, "ms1800" },
  {  10, "ms2000" },
  {  11, "ms3000" },
  {  12, "ms4000" },
  {  13, "ms6000" },
  {  14, "ms8000" },
  {  15, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_302(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_304_vals[] = {
  {   0, "ms100" },
  {   1, "ms200" },
  {   2, "ms400" },
  {   3, "ms1000" },
  {   4, "ms2000" },
  {   5, "spare3" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_304(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_305_vals[] = {
  {   0, "noUpdate" },
  {   1, "m5" },
  {   2, "m10" },
  {   3, "m30" },
  {   4, "m60" },
  {   5, "m120" },
  {   6, "m360" },
  {   7, "m720" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_305(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_307_vals[] = {
  {   0, "s5" },
  {   1, "s10" },
  {   2, "s15" },
  {   3, "s20" },
  {   4, "s30" },
  {   5, "s40" },
  {   6, "s50" },
  {   7, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_307(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_308_vals[] = {
  {   0, "ms40" },
  {   1, "ms80" },
  {   2, "ms160" },
  {   3, "ms320" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_308(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_T_309(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_310_vals[] = {
  {   0, "ms40" },
  {   1, "ms80" },
  {   2, "ms120" },
  {   3, "ms160" },
  {   4, "ms200" },
  {   5, "ms240" },
  {   6, "ms280" },
  {   7, "ms320" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_310(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_311_vals[] = {
  {   0, "ms250" },
  {   1, "ms500" },
  {   2, "ms750" },
  {   3, "ms1000" },
  {   4, "ms1250" },
  {   5, "ms1500" },
  {   6, "ms1750" },
  {   7, "ms2000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_311(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_T_312(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_T_313(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_314_vals[] = {
  {   0, "s0" },
  {   1, "s2" },
  {   2, "s4" },
  {   3, "s6" },
  {   4, "s8" },
  {   5, "s12" },
  {   6, "s16" },
  {   7, "s20" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_314(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_315_vals[] = {
  {   0, "s0" },
  {   1, "s10" },
  {   2, "s30" },
  {   3, "s60" },
  {   4, "s180" },
  {   5, "s600" },
  {   6, "s1200" },
  {   7, "s1800" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_315(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_316_vals[] = {
  {   0, "s0" },
  {   1, "s10" },
  {   2, "s20" },
  {   3, "s30" },
  {   4, "s40" },
  {   5, "s50" },
  {   6, "s-inf" },
  {   7, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_316(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_317_vals[] = {
  {   0, "infinity0" },
  {   1, "infinity1" },
  {   2, "infinity2" },
  {   3, "infinity3" },
  {   4, "infinity4" },
  {   5, "infinity5" },
  {   6, "infinity6" },
  {   7, "infinity7" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_317(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_318_vals[] = {
  {   0, "ms250" },
  {   1, "ms500" },
  {   2, "ms750" },
  {   3, "ms1000" },
  {   4, "ms1250" },
  {   5, "ms1500" },
  {   6, "ms1750" },
  {   7, "ms2000" },
  {   8, "ms3000" },
  {   9, "ms4000" },
  {  10, "ms6000" },
  {  11, "ms8000" },
  {  12, "ms10000" },
  {  13, "ms12000" },
  {  14, "ms16000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_318(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     15, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_tdd1_sequence[] = {
  { &hf_umts_rrc_ies_maxSimultaneousCCTrCH_Count, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxSimultaneousCCTrCH_Count },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1, T_tdd1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo1_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo1_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd1   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo1, T_modeSpecificInfo1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_TransChCapability_sequence[] = {
  { &hf_umts_rrc_ies_maxNoBitsTransmitted, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoBits },
  { &hf_umts_rrc_ies_maxConvCodeBitsTransmitted, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoBits },
  { &hf_umts_rrc_ies_turboEncodingSupport, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TurboSupport },
  { &hf_umts_rrc_ies_maxSimultaneousTransChs1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxSimultaneousTransChsUL },
  { &hf_umts_rrc_ies_modeSpecificInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo1 },
  { &hf_umts_rrc_ies_maxTransmittedBlocks, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTransportBlocksUL },
  { &hf_umts_rrc_ies_maxNumberOfTFC1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNumberOfTFC_UL },
  { &hf_umts_rrc_ies_maxNumberOfTF, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNumberOfTF },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TransChCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_TransChCapability, UL_TransChCapability_sequence);

  return offset;
}


static const per_sequence_t TransportChannelCapability_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransChCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TransChCapability },
  { &hf_umts_rrc_ies_ul_TransChCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TransChCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TransportChannelCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TransportChannelCapability, TransportChannelCapability_sequence);

  return offset;
}


static const per_sequence_t U_RNTI_Short_sequence[] = {
  { &hf_umts_rrc_ies_srnc_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRNC_Identity },
  { &hf_umts_rrc_ies_s_RNTI_2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_RNTI_2 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_U_RNTI_Short(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_U_RNTI_Short, U_RNTI_Short_sequence);

  return offset;
}


static const per_sequence_t T_supported3_sequence[] = {
  { &hf_umts_rrc_ies_edch_PhysicalLayerCategory, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_supported3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_supported3, T_supported3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_fdd_edch_vals[] = {
  {   0, "supported" },
  {   1, "unsupported" },
  { 0, NULL }
};

static const per_choice_t T_fdd_edch_choice[] = {
  {   0, &hf_umts_rrc_ies_supported8, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_supported3 },
  {   1, &hf_umts_rrc_ies_unsupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd_edch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_fdd_edch, T_fdd_edch_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PhysicalChannelCapability_edch_r6_sequence[] = {
  { &hf_umts_rrc_ies_fdd_edch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_fdd_edch },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PhysicalChannelCapability_edch_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PhysicalChannelCapability_edch_r6, PhysicalChannelCapability_edch_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_deviceType_vals[] = {
  {   0, "doesNotBenefitFromBatteryConsumptionOptimisation" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_deviceType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v6xyext_sequence[] = {
  { &hf_umts_rrc_ies_physicalchannelcapability_edch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PhysicalChannelCapability_edch_r6 },
  { &hf_umts_rrc_ies_deviceType, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_deviceType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v6xyext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v6xyext, UE_RadioAccessCapability_v6xyext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_GSM_MS_RadioAccessCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       1, 64, NULL);

  return offset;
}


static const per_sequence_t InterRAT_UE_RadioAccessCapability_v6xyext_sequence[] = {
  { &hf_umts_rrc_ies_gsm_MS_RadioAccessCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GSM_MS_RadioAccessCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v6xyext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v6xyext, InterRAT_UE_RadioAccessCapability_v6xyext_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions, T_nonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t UE_CapabilityContainer_IEs_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioAccessCapability_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapability_v6xyext },
  { &hf_umts_rrc_ies_ue_RATSpecificCapability_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v6xyext },
  { &hf_umts_rrc_ies_nonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_CapabilityContainer_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_CapabilityContainer_IEs, UE_CapabilityContainer_IEs_sequence);

  return offset;
}


static const per_sequence_t UE_ConnTimersAndConstants_sequence[] = {
  { &hf_umts_rrc_ies_t_301  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_301 },
  { &hf_umts_rrc_ies_n_301  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_301 },
  { &hf_umts_rrc_ies_t_302  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_302 },
  { &hf_umts_rrc_ies_n_302  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_302 },
  { &hf_umts_rrc_ies_t_304  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_304 },
  { &hf_umts_rrc_ies_n_304  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_304 },
  { &hf_umts_rrc_ies_t_305  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_305 },
  { &hf_umts_rrc_ies_t_307  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_307 },
  { &hf_umts_rrc_ies_t_308  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_308 },
  { &hf_umts_rrc_ies_t_309  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_309 },
  { &hf_umts_rrc_ies_t_310  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_310 },
  { &hf_umts_rrc_ies_n_310  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_310 },
  { &hf_umts_rrc_ies_t_311  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_311 },
  { &hf_umts_rrc_ies_t_312  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_312 },
  { &hf_umts_rrc_ies_n_312  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_312 },
  { &hf_umts_rrc_ies_t_313  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_313 },
  { &hf_umts_rrc_ies_n_313  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_313 },
  { &hf_umts_rrc_ies_t_314  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_314 },
  { &hf_umts_rrc_ies_t_315  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_315 },
  { &hf_umts_rrc_ies_n_315  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_315 },
  { &hf_umts_rrc_ies_t_316  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_316 },
  { &hf_umts_rrc_ies_t_317  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_317 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_ConnTimersAndConstants(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_ConnTimersAndConstants, UE_ConnTimersAndConstants_sequence);

  return offset;
}


static const per_sequence_t UE_ConnTimersAndConstants_v3a0ext_sequence[] = {
  { &hf_umts_rrc_ies_n_3121 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_312ext },
  { &hf_umts_rrc_ies_n_3151 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_315ext },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_ConnTimersAndConstants_v3a0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_ConnTimersAndConstants_v3a0ext, UE_ConnTimersAndConstants_v3a0ext_sequence);

  return offset;
}


static const per_sequence_t UE_ConnTimersAndConstants_r5_sequence[] = {
  { &hf_umts_rrc_ies_t_301  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_301 },
  { &hf_umts_rrc_ies_n_301  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_301 },
  { &hf_umts_rrc_ies_t_302  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_302 },
  { &hf_umts_rrc_ies_n_302  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_302 },
  { &hf_umts_rrc_ies_t_304  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_304 },
  { &hf_umts_rrc_ies_n_304  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_304 },
  { &hf_umts_rrc_ies_t_305  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_305 },
  { &hf_umts_rrc_ies_t_307  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_307 },
  { &hf_umts_rrc_ies_t_308  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_308 },
  { &hf_umts_rrc_ies_t_309  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_309 },
  { &hf_umts_rrc_ies_t_310  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_310 },
  { &hf_umts_rrc_ies_n_310  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_310 },
  { &hf_umts_rrc_ies_t_311  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_311 },
  { &hf_umts_rrc_ies_t_312  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_312 },
  { &hf_umts_rrc_ies_n_3122 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_312_r5 },
  { &hf_umts_rrc_ies_t_313  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_313 },
  { &hf_umts_rrc_ies_n_313  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_313 },
  { &hf_umts_rrc_ies_t_314  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_314 },
  { &hf_umts_rrc_ies_t_315  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_315 },
  { &hf_umts_rrc_ies_n_3152 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_315_r5 },
  { &hf_umts_rrc_ies_t_316  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_316 },
  { &hf_umts_rrc_ies_t_317  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_317 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_ConnTimersAndConstants_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_ConnTimersAndConstants_r5, UE_ConnTimersAndConstants_r5_sequence);

  return offset;
}


static const per_sequence_t UE_IdleTimersAndConstants_sequence[] = {
  { &hf_umts_rrc_ies_t_300  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_300 },
  { &hf_umts_rrc_ies_n_300  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_N_300 },
  { &hf_umts_rrc_ies_t_312  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_312 },
  { &hf_umts_rrc_ies_n_312  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_N_312 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_IdleTimersAndConstants(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_IdleTimersAndConstants, UE_IdleTimersAndConstants_sequence);

  return offset;
}


static const per_sequence_t UE_IdleTimersAndConstants_v3a0ext_sequence[] = {
  { &hf_umts_rrc_ies_n_3121 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_312ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_IdleTimersAndConstants_v3a0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_IdleTimersAndConstants_v3a0ext, UE_IdleTimersAndConstants_v3a0ext_sequence);

  return offset;
}


static const per_sequence_t UE_MultiModeRAT_Capability_sequence[] = {
  { &hf_umts_rrc_ies_multiRAT_CapabilityList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiRAT_Capability },
  { &hf_umts_rrc_ies_multiModeCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiModeCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_MultiModeRAT_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_MultiModeRAT_Capability, UE_MultiModeRAT_Capability_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_PowerClassExt_vals[] = {
  {   0, "class1" },
  {   1, "class2" },
  {   2, "class3" },
  {   3, "class4" },
  {   4, "spare4" },
  {   5, "spare3" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UE_PowerClassExt(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_Capability_sequence[] = {
  { &hf_umts_rrc_ies_standaloneLocMethodsSupported, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ue_BasedOTDOA_Supported, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_networkAssistedGPS_Supported, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NetworkAssistedGPS_Supported },
  { &hf_umts_rrc_ies_supportForUE_GPS_TimingOfCellFrames, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_supportForIPDL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_Capability, UE_Positioning_Capability_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_sequence[] = {
  { &hf_umts_rrc_ies_pdcp_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Capability },
  { &hf_umts_rrc_ies_rlc_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_Capability },
  { &hf_umts_rrc_ies_transportChannelCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelCapability },
  { &hf_umts_rrc_ies_rf_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RF_Capability },
  { &hf_umts_rrc_ies_physicalChannelCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PhysicalChannelCapability },
  { &hf_umts_rrc_ies_ue_MultiModeRAT_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_MultiModeRAT_Capability },
  { &hf_umts_rrc_ies_securityCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecurityCapability },
  { &hf_umts_rrc_ies_ue_positioning_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_Capability },
  { &hf_umts_rrc_ies_measurementCapability, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementCapability },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability, UE_RadioAccessCapability_sequence);

  return offset;
}


static const per_sequence_t T_fddRF_Capability2_sequence[] = {
  { &hf_umts_rrc_ies_ue_PowerClass1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PowerClassExt },
  { &hf_umts_rrc_ies_txRxFrequencySeparation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TxRxFrequencySeparation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fddRF_Capability2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fddRF_Capability2, T_fddRF_Capability2_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabBandFDD_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandFDD },
  { &hf_umts_rrc_ies_fddRF_Capability2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_fddRF_Capability2 },
  { &hf_umts_rrc_ies_measurementCapability1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementCapabilityExt },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD, UE_RadioAccessCapabBandFDD_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabBandFDDList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDD },
};

static int
dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList, UE_RadioAccessCapabBandFDDList_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v370ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDDList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v370ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v370ext, UE_RadioAccessCapability_v370ext_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabilityInfo_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioAccessCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapability },
  { &hf_umts_rrc_ies_ue_RadioAccessCapability_v370ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapability_v370ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RadioAccessCapabilityInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapabilityInfo, UE_RadioAccessCapabilityInfo_sequence);

  return offset;
}


static const per_sequence_t UE_PositioningCapabilityExt_v380_sequence[] = {
  { &hf_umts_rrc_ies_rx_tx_TimeDifferenceType2Capable, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_PositioningCapabilityExt_v380(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_PositioningCapabilityExt_v380, UE_PositioningCapabilityExt_v380_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v380ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_PositioningCapabilityExt_v380, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PositioningCapabilityExt_v380 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v380ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v380ext, UE_RadioAccessCapability_v380ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_validity_CellPCH_UraPCH_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_validity_CellPCH_UraPCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UE_PositioningCapabilityExt_v3a0_sequence[] = {
  { &hf_umts_rrc_ies_validity_CellPCH_UraPCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_validity_CellPCH_UraPCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_PositioningCapabilityExt_v3a0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_PositioningCapabilityExt_v3a0, UE_PositioningCapabilityExt_v3a0_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v3a0ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_PositioningCapabilityExt_v3a0, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PositioningCapabilityExt_v3a0 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v3a0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v3a0ext, UE_RadioAccessCapability_v3a0ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_sfn_sfnType2Capability_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_sfn_sfnType2Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UE_PositioningCapabilityExt_v3g0_sequence[] = {
  { &hf_umts_rrc_ies_sfn_sfnType2Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_sfn_sfnType2Capability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_PositioningCapabilityExt_v3g0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_PositioningCapabilityExt_v3g0, UE_PositioningCapabilityExt_v3g0_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v3g0ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_PositioningCapabilityExt_v3g0, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PositioningCapabilityExt_v3g0 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v3g0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v3g0ext, UE_RadioAccessCapability_v3g0ext_sequence);

  return offset;
}


static const per_sequence_t T_fddRF_Capability1_sequence[] = {
  { &hf_umts_rrc_ies_ue_PowerClass1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_PowerClassExt },
  { &hf_umts_rrc_ies_txRxFrequencySeparation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TxRxFrequencySeparation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fddRF_Capability1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fddRF_Capability1, T_fddRF_Capability1_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabBandFDD2_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandFDD2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandFDD2 },
  { &hf_umts_rrc_ies_fddRF_Capability1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_fddRF_Capability1 },
  { &hf_umts_rrc_ies_measurementCapability2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementCapabilityExt2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDD2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD2, UE_RadioAccessCapabBandFDD2_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabBandFDDList2_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDD2 },
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2, UE_RadioAccessCapabBandFDDList2_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabBandFDD_ext_sequence[] = {
  { &hf_umts_rrc_ies_radioFrequencyBandFDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandFDD },
  { &hf_umts_rrc_ies_compressedModeMeasCapabFDDList_ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDD_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD_ext, UE_RadioAccessCapabBandFDD_ext_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabBandFDDList_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDD_ext },
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext, UE_RadioAccessCapabBandFDDList_ext_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v650ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2 },
  { &hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList_ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v650ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v650ext, UE_RadioAccessCapability_v650ext_sequence);

  return offset;
}


static const per_sequence_t T_tdd_CapabilityExt_sequence[] = {
  { &hf_umts_rrc_ies_rf_Capability1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RF_Capability_r4_ext },
  { &hf_umts_rrc_ies_physicalChannelCapability_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PhysicalChannelCapability_LCR_r4 },
  { &hf_umts_rrc_ies_measurementCapability_r4_ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementCapability_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd_CapabilityExt(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd_CapabilityExt, T_tdd_CapabilityExt_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v4b0ext_sequence[] = {
  { &hf_umts_rrc_ies_pdcp_Capability_r4_ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Capability_r4_ext },
  { &hf_umts_rrc_ies_tdd_CapabilityExt, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tdd_CapabilityExt },
  { &hf_umts_rrc_ies_accessStratumReleaseIndicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AccessStratumReleaseIndicator },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v4b0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v4b0ext, UE_RadioAccessCapability_v4b0ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RF_CapabBandFDDComp_vals[] = {
  {   0, "notSupported" },
  {   1, "mhz190" },
  {   2, "mhz174-8-205-2" },
  {   3, "mhz134-8-245-2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RF_CapabBandFDDComp(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RF_CapabBandListFDDComp_sequence_of[1] = {
  { &hf_umts_rrc_ies_RF_CapabBandListFDDComp_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RF_CapabBandFDDComp },
};

static int
dissect_umts_rrc_ies_RF_CapabBandListFDDComp(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RF_CapabBandListFDDComp, RF_CapabBandListFDDComp_sequence_of,
                                                  1, maxFreqBandsFDD);

  return offset;
}


static const value_string umts_rrc_ies_T_fdd1_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t T_fdd1_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported6, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RF_CapabBandListFDDComp },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_fdd1, T_fdd1_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd384_RF_Capability_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t T_tdd384_RF_Capability_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported7, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RadioFrequencyBandTDDList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd384_RF_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd384_RF_Capability, T_tdd384_RF_Capability_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd128_RF_Capability_vals[] = {
  {   0, "notSupported" },
  {   1, "supported" },
  { 0, NULL }
};

static const per_choice_t T_tdd128_RF_Capability_choice[] = {
  {   0, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_supported7, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RadioFrequencyBandTDDList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128_RF_Capability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd128_RF_Capability, T_tdd128_RF_Capability_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RF_CapabilityComp_sequence[] = {
  { &hf_umts_rrc_ies_fdd1   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_fdd1 },
  { &hf_umts_rrc_ies_tdd384_RF_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tdd384_RF_Capability },
  { &hf_umts_rrc_ies_tdd128_RF_Capability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tdd128_RF_Capability },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_RF_CapabilityComp(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RF_CapabilityComp, RF_CapabilityComp_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapabilityComp_sequence[] = {
  { &hf_umts_rrc_ies_totalAM_RLCMemoryExceeds10kB, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_rf_CapabilityComp, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RF_CapabilityComp },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapabilityComp(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapabilityComp, UE_RadioAccessCapabilityComp_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_dl_CapabilityWithSimultaneousHS_DSCHConfig, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CapabilityWithSimultaneousHS_DSCHConfig },
  { &hf_umts_rrc_ies_pdcp_Capability_r5_ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Capability_r5_ext },
  { &hf_umts_rrc_ies_rlc_Capability_r5_ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_Capability_r5_ext },
  { &hf_umts_rrc_ies_physicalChannelCapability1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PhysicalChannelCapability_hspdsch_r5 },
  { &hf_umts_rrc_ies_multiModeRAT_Capability_v590ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiModeRAT_Capability_v590ext },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v590ext, UE_RadioAccessCapability_v590ext_sequence);

  return offset;
}


static const per_sequence_t UE_RadioAccessCapability_v5c0ext_sequence[] = {
  { &hf_umts_rrc_ies_pdcp_Capability_r5_ext2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Capability_r5_ext2 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_RadioAccessCapability_v5c0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RadioAccessCapability_v5c0ext, UE_RadioAccessCapability_v5c0ext_sequence);

  return offset;
}


static const per_sequence_t UL_PhysChCapabilityFDD_r6_sequence[] = {
  { &hf_umts_rrc_ies_maxNoDPDCH_BitsTransmitted, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxNoDPDCH_BitsTransmitted },
  { &hf_umts_rrc_ies_physicalchannelcapability_edch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PhysicalChannelCapability_edch_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_PhysChCapabilityFDD_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_PhysChCapabilityFDD_r6, UL_PhysChCapabilityFDD_r6_sequence);

  return offset;
}


static const per_sequence_t UE_SecurityInformation_sequence[] = {
  { &hf_umts_rrc_ies_start_CS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_START_Value },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_SecurityInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_SecurityInformation, UE_SecurityInformation_sequence);

  return offset;
}


static const per_sequence_t UE_SecurityInformation2_sequence[] = {
  { &hf_umts_rrc_ies_start_PS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_START_Value },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_SecurityInformation2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_SecurityInformation2, UE_SecurityInformation2_sequence);

  return offset;
}


const value_string umts_rrc_ies_URA_UpdateCause_vals[] = {
  {   0, "changeOfURA" },
  {   1, "periodicURAUpdate" },
  {   2, "dummy" },
  {   3, "spare1" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_URA_UpdateCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_UTRAN_DRX_CycleLengthCoefficient(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              3U, 9U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_WaitTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_65535(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_255(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_60_65535(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              60U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_3_255(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              3U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_3_65535(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              3U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ExpectReordering_vals[] = {
  {   0, "reorderingNotExpected" },
  {   1, "reorderingExpected" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ExpectReordering(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RFC2507_Info_sequence[] = {
  { &hf_umts_rrc_ies_f_MAX_PERIOD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_65535 },
  { &hf_umts_rrc_ies_f_MAX_TIME, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_255 },
  { &hf_umts_rrc_ies_max_HEADER, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_60_65535 },
  { &hf_umts_rrc_ies_tcp_SPACE, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_3_255 },
  { &hf_umts_rrc_ies_non_TCP_SPACE, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_3_65535 },
  { &hf_umts_rrc_ies_expectReordering, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ExpectReordering },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RFC2507_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RFC2507_Info, RFC2507_Info_sequence);

  return offset;
}


static const value_string umts_rrc_ies_AlgorithmSpecificInfo_vals[] = {
  {   0, "rfc2507-Info" },
  { 0, NULL }
};

static const per_choice_t AlgorithmSpecificInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_rfc2507_Info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RFC2507_Info },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_AlgorithmSpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_AlgorithmSpecificInfo, AlgorithmSpecificInfo_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_ROHC_Profile_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ROHC_ProfileList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_ROHC_ProfileList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ROHC_Profile_r4 },
};

static int
dissect_umts_rrc_ies_ROHC_ProfileList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ROHC_ProfileList_r4, ROHC_ProfileList_r4_sequence_of,
                                                  1, maxROHCProfiler4);

  return offset;
}


static const value_string umts_rrc_ies_CID_InclusionInfo_r4_vals[] = {
  {   0, "pdcp-Header" },
  {   1, "rfc3095-PacketFormat" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_CID_InclusionInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_16383(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 16383U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_ROHC_PacketSize_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              2U, 1500U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ROHC_PacketSizeList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_ROHC_PacketSizeList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ROHC_PacketSize_r4 },
};

static int
dissect_umts_rrc_ies_ROHC_PacketSizeList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ROHC_PacketSizeList_r4, ROHC_PacketSizeList_r4_sequence_of,
                                                  1, maxPRACHFPACH);

  return offset;
}


static const per_sequence_t UL_RFC3095_r4_sequence[] = {
  { &hf_umts_rrc_ies_cid_InclusionInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CID_InclusionInfo_r4 },
  { &hf_umts_rrc_ies_max_CID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_16383 },
  { &hf_umts_rrc_ies_rohcPacketSizeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ROHC_PacketSizeList_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_RFC3095_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_RFC3095_r4, UL_RFC3095_r4_sequence);

  return offset;
}


static const per_sequence_t DL_RFC3095_r4_sequence[] = {
  { &hf_umts_rrc_ies_cid_InclusionInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CID_InclusionInfo_r4 },
  { &hf_umts_rrc_ies_max_CID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_16383 },
  { &hf_umts_rrc_ies_reverseDecompressionDepth, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_RFC3095_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_RFC3095_r4, DL_RFC3095_r4_sequence);

  return offset;
}


static const per_sequence_t RFC3095_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_rohcProfileList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ROHC_ProfileList_r4 },
  { &hf_umts_rrc_ies_ul_RFC3095, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_RFC3095_r4 },
  { &hf_umts_rrc_ies_dl_RFC3095, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_RFC3095_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RFC3095_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RFC3095_Info_r4, RFC3095_Info_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_AlgorithmSpecificInfo_r4_vals[] = {
  {   0, "rfc2507-Info" },
  {   1, "rfc3095-Info" },
  { 0, NULL }
};

static const per_choice_t AlgorithmSpecificInfo_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_rfc2507_Info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RFC2507_Info },
  {   1, &hf_umts_rrc_ies_rfc3095_Info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RFC3095_Info_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_AlgorithmSpecificInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_AlgorithmSpecificInfo_r4, AlgorithmSpecificInfo_r4_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_COUNT_C(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 4294967295U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_COUNT_C_MSB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 33554431U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_DefaultConfigIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 10U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_DefaultConfigIdentity_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 12U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_DefaultConfigIdentity_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 13U, NULL, FALSE);

  return offset;
}


const value_string umts_rrc_ies_DefaultConfigMode_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_DefaultConfigMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_DDI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 62U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ReceivingWindowSize_vals[] = {
  {   0, "rw1" },
  {   1, "rw8" },
  {   2, "rw16" },
  {   3, "rw32" },
  {   4, "rw64" },
  {   5, "rw128" },
  {   6, "rw256" },
  {   7, "rw512" },
  {   8, "rw768" },
  {   9, "rw1024" },
  {  10, "rw1536" },
  {  11, "rw2047" },
  {  12, "rw2560" },
  {  13, "rw3072" },
  {  14, "rw3584" },
  {  15, "rw4095" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReceivingWindowSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerStatusProhibit_vals[] = {
  {   0, "tsp10" },
  {   1, "tsp20" },
  {   2, "tsp30" },
  {   3, "tsp40" },
  {   4, "tsp50" },
  {   5, "tsp60" },
  {   6, "tsp70" },
  {   7, "tsp80" },
  {   8, "tsp90" },
  {   9, "tsp100" },
  {  10, "tsp110" },
  {  11, "tsp120" },
  {  12, "tsp130" },
  {  13, "tsp140" },
  {  14, "tsp150" },
  {  15, "tsp160" },
  {  16, "tsp170" },
  {  17, "tsp180" },
  {  18, "tsp190" },
  {  19, "tsp200" },
  {  20, "tsp210" },
  {  21, "tsp220" },
  {  22, "tsp230" },
  {  23, "tsp240" },
  {  24, "tsp250" },
  {  25, "tsp260" },
  {  26, "tsp270" },
  {  27, "tsp280" },
  {  28, "tsp290" },
  {  29, "tsp300" },
  {  30, "tsp310" },
  {  31, "tsp320" },
  {  32, "tsp330" },
  {  33, "tsp340" },
  {  34, "tsp350" },
  {  35, "tsp360" },
  {  36, "tsp370" },
  {  37, "tsp380" },
  {  38, "tsp390" },
  {  39, "tsp400" },
  {  40, "tsp410" },
  {  41, "tsp420" },
  {  42, "tsp430" },
  {  43, "tsp440" },
  {  44, "tsp450" },
  {  45, "tsp460" },
  {  46, "tsp470" },
  {  47, "tsp480" },
  {  48, "tsp490" },
  {  49, "tsp500" },
  {  50, "tsp510" },
  {  51, "tsp520" },
  {  52, "tsp530" },
  {  53, "tsp540" },
  {  54, "tsp550" },
  {  55, "tsp600" },
  {  56, "tsp650" },
  {  57, "tsp700" },
  {  58, "tsp750" },
  {  59, "tsp800" },
  {  60, "tsp850" },
  {  61, "tsp900" },
  {  62, "tsp950" },
  {  63, "tsp1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerStatusProhibit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     64, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerEPC_vals[] = {
  {   0, "te50" },
  {   1, "te60" },
  {   2, "te70" },
  {   3, "te80" },
  {   4, "te90" },
  {   5, "te100" },
  {   6, "te120" },
  {   7, "te140" },
  {   8, "te160" },
  {   9, "te180" },
  {  10, "te200" },
  {  11, "te300" },
  {  12, "te400" },
  {  13, "te500" },
  {  14, "te700" },
  {  15, "te900" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerEPC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerStatusPeriodic_vals[] = {
  {   0, "tsp100" },
  {   1, "tsp200" },
  {   2, "tsp300" },
  {   3, "tsp400" },
  {   4, "tsp500" },
  {   5, "tsp750" },
  {   6, "tsp1000" },
  {   7, "tsp2000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerStatusPeriodic(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_RLC_StatusInfo_sequence[] = {
  { &hf_umts_rrc_ies_timerStatusProhibit, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerStatusProhibit },
  { &hf_umts_rrc_ies_dummy_TimerEPC, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerEPC },
  { &hf_umts_rrc_ies_missingPDU_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_timerStatusPeriodic, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerStatusPeriodic },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_RLC_StatusInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_RLC_StatusInfo, DL_RLC_StatusInfo_sequence);

  return offset;
}


static const per_sequence_t DL_AM_RLC_Mode_sequence[] = {
  { &hf_umts_rrc_ies_inSequenceDelivery, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_receivingWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReceivingWindowSize },
  { &hf_umts_rrc_ies_dl_RLC_StatusInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_RLC_StatusInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_AM_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_AM_RLC_Mode, DL_AM_RLC_Mode_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 31U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_23(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 23U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sizeType21_sequence[] = {
  { &hf_umts_rrc_ies_part13 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_23 },
  { &hf_umts_rrc_ies_part23 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sizeType21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sizeType21, T_sizeType21_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_61(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 61U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 7U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sizeType31_sequence[] = {
  { &hf_umts_rrc_ies_part14 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_61 },
  { &hf_umts_rrc_ies_part2  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sizeType31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sizeType31, T_sizeType31_sequence);

  return offset;
}


static const value_string umts_rrc_ies_OctetModeRLC_SizeInfoType1_vals[] = {
  {   0, "sizeType1" },
  {   1, "sizeType2" },
  {   2, "sizeType3" },
  { 0, NULL }
};

static const per_choice_t OctetModeRLC_SizeInfoType1_choice[] = {
  {   0, &hf_umts_rrc_ies_sizeType11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   1, &hf_umts_rrc_ies_sizeType21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sizeType21 },
  {   2, &hf_umts_rrc_ies_sizeType31, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sizeType31 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_OctetModeRLC_SizeInfoType1, OctetModeRLC_SizeInfoType1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_AM_RLC_Mode_r5_sequence[] = {
  { &hf_umts_rrc_ies_dl_RLC_PDU_size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1 },
  { &hf_umts_rrc_ies_inSequenceDelivery, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_receivingWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReceivingWindowSize },
  { &hf_umts_rrc_ies_dl_RLC_StatusInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_RLC_StatusInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_AM_RLC_Mode_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_AM_RLC_Mode_r5, DL_AM_RLC_Mode_r5_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_PDCP_SN_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RB_WithPDCP_Info_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_SN_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_SN_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_WithPDCP_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_WithPDCP_Info, RB_WithPDCP_Info_sequence);

  return offset;
}


static const per_sequence_t RB_WithPDCP_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_WithPDCP_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_WithPDCP_Info },
};

static int
dissect_umts_rrc_ies_RB_WithPDCP_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_WithPDCP_InfoList, RB_WithPDCP_InfoList_sequence_of,
                                                  1, maxRBallRABs);

  return offset;
}


static const per_sequence_t DL_CounterSynchronisationInfo_sequence[] = {
  { &hf_umts_rrc_ies_rB_WithPDCP_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_WithPDCP_InfoList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CounterSynchronisationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CounterSynchronisationInfo, DL_CounterSynchronisationInfo_sequence);

  return offset;
}


static const per_sequence_t RB_PDCPContextRelocation_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_dl_RFC3095_Context_Relocation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_RFC3095_Context_Relocation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_PDCPContextRelocation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_PDCPContextRelocation, RB_PDCPContextRelocation_sequence);

  return offset;
}


static const per_sequence_t RB_PDCPContextRelocationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_PDCPContextRelocationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_PDCPContextRelocation },
};

int
dissect_umts_rrc_ies_RB_PDCPContextRelocationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_PDCPContextRelocationList, RB_PDCPContextRelocationList_sequence_of,
                                                  1, maxRBallRABs);

  return offset;
}


static const per_sequence_t DL_CounterSynchronisationInfo_r5_sequence[] = {
  { &hf_umts_rrc_ies_rb_WithPDCP_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_WithPDCP_InfoList },
  { &hf_umts_rrc_ies_rb_PDCPContextRelocationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_PDCPContextRelocationList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CounterSynchronisationInfo_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CounterSynchronisationInfo_r5, DL_CounterSynchronisationInfo_r5_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TransportChannelIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TransportChannelIdentityDCHandDSCH_sequence[] = {
  { &hf_umts_rrc_ies_dch_transport_ch_id, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_dsch_transport_ch_id, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TransportChannelIdentityDCHandDSCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TransportChannelIdentityDCHandDSCH, TransportChannelIdentityDCHandDSCH_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_TransportChannelType_vals[] = {
  {   0, "dch" },
  {   1, "fach" },
  {   2, "dsch" },
  {   3, "dch-and-dsch" },
  { 0, NULL }
};

static const per_choice_t DL_TransportChannelType_choice[] = {
  {   0, &hf_umts_rrc_ies_dch    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   1, &hf_umts_rrc_ies_fach   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_dsch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   3, &hf_umts_rrc_ies_dch_and_dsch, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentityDCHandDSCH },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TransportChannelType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_TransportChannelType, DL_TransportChannelType_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_LogicalChannelIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DL_LogicalChannelMapping_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TransportChannelType },
  { &hf_umts_rrc_ies_logicalChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_LogicalChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_LogicalChannelMapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_LogicalChannelMapping, DL_LogicalChannelMapping_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MAC_d_FlowIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MAC_d_FlowIdentityDCHandHSDSCH_sequence[] = {
  { &hf_umts_rrc_ies_dch_transport_ch_id, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_hsdsch_mac_d_flow_id, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_d_FlowIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MAC_d_FlowIdentityDCHandHSDSCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MAC_d_FlowIdentityDCHandHSDSCH, MAC_d_FlowIdentityDCHandHSDSCH_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_TransportChannelType_r5_vals[] = {
  {   0, "dch" },
  {   1, "fach" },
  {   2, "dsch" },
  {   3, "dch-and-dsch" },
  {   4, "hsdsch" },
  {   5, "dch-and-hsdsch" },
  { 0, NULL }
};

static const per_choice_t DL_TransportChannelType_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_dch    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   1, &hf_umts_rrc_ies_fach   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_dsch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   3, &hf_umts_rrc_ies_dch_and_dsch, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentityDCHandDSCH },
  {   4, &hf_umts_rrc_ies_hsdsch , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MAC_d_FlowIdentity },
  {   5, &hf_umts_rrc_ies_dch_and_hsdsch, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MAC_d_FlowIdentityDCHandHSDSCH },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TransportChannelType_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_TransportChannelType_r5, DL_TransportChannelType_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_LogicalChannelMapping_r5_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TransportChannelType_r5 },
  { &hf_umts_rrc_ies_logicalChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_LogicalChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_LogicalChannelMapping_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_LogicalChannelMapping_r5, DL_LogicalChannelMapping_r5_sequence);

  return offset;
}


static const per_sequence_t DL_LogicalChannelMappingList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_LogicalChannelMappingList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_LogicalChannelMapping },
};

static int
dissect_umts_rrc_ies_DL_LogicalChannelMappingList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_LogicalChannelMappingList, DL_LogicalChannelMappingList_sequence_of,
                                                  1, maxLoCHperRLC);

  return offset;
}


static const per_sequence_t DL_LogicalChannelMappingList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_LogicalChannelMappingList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_LogicalChannelMapping_r5 },
};

static int
dissect_umts_rrc_ies_DL_LogicalChannelMappingList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_LogicalChannelMappingList_r5, DL_LogicalChannelMappingList_r5_sequence_of,
                                                  1, maxLoCHperRLC);

  return offset;
}


static const value_string umts_rrc_ies_DL_Reception_Window_Size_r6_vals[] = {
  {   0, "size32" },
  {   1, "size48" },
  {   2, "size64" },
  {   3, "size80" },
  {   4, "size96" },
  {   5, "size112" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_Reception_Window_Size_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     6, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_TM_RLC_Mode_sequence[] = {
  { &hf_umts_rrc_ies_segmentationIndication, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TM_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_TM_RLC_Mode, DL_TM_RLC_Mode_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_RLC_Mode_vals[] = {
  {   0, "dl-AM-RLC-Mode" },
  {   1, "dl-UM-RLC-Mode" },
  {   2, "dl-TM-RLC-Mode" },
  { 0, NULL }
};

static const per_choice_t DL_RLC_Mode_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_AM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_AM_RLC_Mode },
  {   1, &hf_umts_rrc_ies_dl_UM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_dl_TM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_TM_RLC_Mode },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_RLC_Mode, DL_RLC_Mode_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_DL_UM_RLC_LI_size_vals[] = {
  {   0, "size7" },
  {   1, "size15" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_UM_RLC_LI_size(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_UM_RLC_Mode_r5_sequence[] = {
  { &hf_umts_rrc_ies_dl_UM_RLC_LI_size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_UM_RLC_LI_size },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_UM_RLC_Mode_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_UM_RLC_Mode_r5, DL_UM_RLC_Mode_r5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_RLC_Mode_r5_vals[] = {
  {   0, "dl-AM-RLC-Mode-r5" },
  {   1, "dl-UM-RLC-Mode-r5" },
  {   2, "dl-TM-RLC-Mode" },
  { 0, NULL }
};

static const per_choice_t DL_RLC_Mode_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_AM_RLC_Mode_r5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_AM_RLC_Mode_r5 },
  {   1, &hf_umts_rrc_ies_dl_UM_RLC_Mode_r5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_UM_RLC_Mode_r5 },
  {   2, &hf_umts_rrc_ies_dl_TM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_TM_RLC_Mode },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_RLC_Mode_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_RLC_Mode_r5, DL_RLC_Mode_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_UM_RLC_Mode_r6_sequence[] = {
  { &hf_umts_rrc_ies_dl_UM_RLC_LI_size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_UM_RLC_LI_size },
  { &hf_umts_rrc_ies_dl_Reception_Window_Size, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_Reception_Window_Size_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_UM_RLC_Mode_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_UM_RLC_Mode_r6, DL_UM_RLC_Mode_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_RLC_Mode_r6_vals[] = {
  {   0, "dl-AM-RLC-Mode-r5" },
  {   1, "dl-UM-RLC-Mode-r5" },
  {   2, "dl-TM-RLC-Mode" },
  { 0, NULL }
};

static const per_choice_t DL_RLC_Mode_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_AM_RLC_Mode_r5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_AM_RLC_Mode_r5 },
  {   1, &hf_umts_rrc_ies_dl_UM_RLC_Mode_r51, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_UM_RLC_Mode_r6 },
  {   2, &hf_umts_rrc_ies_dl_TM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_TM_RLC_Mode },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_RLC_Mode_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_RLC_Mode_r6, DL_RLC_Mode_r6_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerMRW_vals[] = {
  {   0, "te50" },
  {   1, "te60" },
  {   2, "te70" },
  {   3, "te80" },
  {   4, "te90" },
  {   5, "te100" },
  {   6, "te120" },
  {   7, "te140" },
  {   8, "te160" },
  {   9, "te180" },
  {  10, "te200" },
  {  11, "te300" },
  {  12, "te400" },
  {  13, "te500" },
  {  14, "te700" },
  {  15, "te900" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerMRW(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerDiscard_vals[] = {
  {   0, "td0-1" },
  {   1, "td0-25" },
  {   2, "td0-5" },
  {   3, "td0-75" },
  {   4, "td1" },
  {   5, "td1-25" },
  {   6, "td1-5" },
  {   7, "td1-75" },
  {   8, "td2" },
  {   9, "td2-5" },
  {  10, "td3" },
  {  11, "td3-5" },
  {  12, "td4" },
  {  13, "td4-5" },
  {  14, "td5" },
  {  15, "td7-5" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerDiscard(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxMRW_vals[] = {
  {   0, "mm1" },
  {   1, "mm4" },
  {   2, "mm6" },
  {   3, "mm8" },
  {   4, "mm12" },
  {   5, "mm16" },
  {   6, "mm24" },
  {   7, "mm32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxMRW(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t ExplicitDiscard_sequence[] = {
  { &hf_umts_rrc_ies_timerMRW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimerMRW },
  { &hf_umts_rrc_ies_timerDiscard, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimerDiscard },
  { &hf_umts_rrc_ies_maxMRW , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxMRW },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ExplicitDiscard(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ExplicitDiscard, ExplicitDiscard_sequence);

  return offset;
}


static const per_sequence_t HeaderCompressionInfo_sequence[] = {
  { &hf_umts_rrc_ies_algorithmSpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AlgorithmSpecificInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HeaderCompressionInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HeaderCompressionInfo, HeaderCompressionInfo_sequence);

  return offset;
}


static const per_sequence_t HeaderCompressionInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_HeaderCompressionInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HeaderCompressionInfo },
};

static int
dissect_umts_rrc_ies_HeaderCompressionInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_HeaderCompressionInfoList, HeaderCompressionInfoList_sequence_of,
                                                  1, maxPDCPAlgoType);

  return offset;
}


static const per_sequence_t HeaderCompressionInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_algorithmSpecificInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AlgorithmSpecificInfo_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HeaderCompressionInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HeaderCompressionInfo_r4, HeaderCompressionInfo_r4_sequence);

  return offset;
}


static const per_sequence_t HeaderCompressionInfoList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_HeaderCompressionInfoList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HeaderCompressionInfo_r4 },
};

static int
dissect_umts_rrc_ies_HeaderCompressionInfoList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_HeaderCompressionInfoList_r4, HeaderCompressionInfoList_r4_sequence_of,
                                                  1, maxPDCPAlgoType);

  return offset;
}


static const value_string umts_rrc_ies_MaxPDCP_SN_WindowSize_vals[] = {
  {   0, "sn255" },
  {   1, "sn65535" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxPDCP_SN_WindowSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_LosslessSRNS_RelocSupport_vals[] = {
  {   0, "supported" },
  {   1, "notSupported" },
  { 0, NULL }
};

static const per_choice_t LosslessSRNS_RelocSupport_choice[] = {
  {   0, &hf_umts_rrc_ies_supported9, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxPDCP_SN_WindowSize },
  {   1, &hf_umts_rrc_ies_notSupported, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_LosslessSRNS_RelocSupport(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_LosslessSRNS_RelocSupport, LosslessSRNS_RelocSupport_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MAC_d_HFN_initial_value(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     24, 24, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MAC_LogicalChannelPriority(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MaxDAT_vals[] = {
  {   0, "dat1" },
  {   1, "dat2" },
  {   2, "dat3" },
  {   3, "dat4" },
  {   4, "dat5" },
  {   5, "dat6" },
  {   6, "dat7" },
  {   7, "dat8" },
  {   8, "dat9" },
  {   9, "dat10" },
  {  10, "dat15" },
  {  11, "dat20" },
  {  12, "dat25" },
  {  13, "dat30" },
  {  14, "dat35" },
  {  15, "dat40" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxDAT(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MaxDAT_Retransmissions_sequence[] = {
  { &hf_umts_rrc_ies_maxDAT , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxDAT },
  { &hf_umts_rrc_ies_timerMRW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimerMRW },
  { &hf_umts_rrc_ies_maxMRW , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxMRW },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MaxDAT_Retransmissions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MaxDAT_Retransmissions, MaxDAT_Retransmissions_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MaxRST_vals[] = {
  {   0, "rst1" },
  {   1, "rst4" },
  {   2, "rst6" },
  {   3, "rst8" },
  {   4, "rst12" },
  {   5, "rst16" },
  {   6, "rst24" },
  {   7, "rst32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxRST(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_NoExplicitDiscard_vals[] = {
  {   0, "dt10" },
  {   1, "dt20" },
  {   2, "dt30" },
  {   3, "dt40" },
  {   4, "dt50" },
  {   5, "dt60" },
  {   6, "dt70" },
  {   7, "dt80" },
  {   8, "dt90" },
  {   9, "dt100" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_NoExplicitDiscard(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     10, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PDCP_PDU_Header_vals[] = {
  {   0, "present" },
  {   1, "absent" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PDCP_PDU_Header(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PDCP_Info_sequence[] = {
  { &hf_umts_rrc_ies_losslessSRNS_RelocSupport, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_LosslessSRNS_RelocSupport },
  { &hf_umts_rrc_ies_pdcp_PDU_Header, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_PDU_Header },
  { &hf_umts_rrc_ies_headerCompressionInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HeaderCompressionInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_Info, PDCP_Info_sequence);

  return offset;
}


static const per_sequence_t PDCP_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_losslessSRNS_RelocSupport, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_LosslessSRNS_RelocSupport },
  { &hf_umts_rrc_ies_pdcp_PDU_Header, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_PDU_Header },
  { &hf_umts_rrc_ies_headerCompressionInfoList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HeaderCompressionInfoList_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_Info_r4, PDCP_Info_r4_sequence);

  return offset;
}


static const per_sequence_t PDCP_InfoReconfig_sequence[] = {
  { &hf_umts_rrc_ies_pdcp_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Info },
  { &hf_umts_rrc_ies_dummy_INTEGER_0_65535, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_InfoReconfig(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_InfoReconfig, PDCP_InfoReconfig_sequence);

  return offset;
}


static const per_sequence_t PDCP_InfoReconfig_r4_sequence[] = {
  { &hf_umts_rrc_ies_pdcp_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Info_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDCP_InfoReconfig_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDCP_InfoReconfig_r4, PDCP_InfoReconfig_r4_sequence);

  return offset;
}


const value_string umts_rrc_ies_PDCP_ROHC_TargetMode_vals[] = {
  {   0, "o-Mode" },
  {   1, "r-Mode" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_PDCP_ROHC_TargetMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_Poll_PDU_vals[] = {
  {   0, "pdu1" },
  {   1, "pdu2" },
  {   2, "pdu4" },
  {   3, "pdu8" },
  {   4, "pdu16" },
  {   5, "pdu32" },
  {   6, "pdu64" },
  {   7, "pdu128" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_Poll_PDU(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_Poll_SDU_vals[] = {
  {   0, "sdu1" },
  {   1, "sdu4" },
  {   2, "sdu16" },
  {   3, "sdu64" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_Poll_SDU(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerPollProhibit_vals[] = {
  {   0, "tpp10" },
  {   1, "tpp20" },
  {   2, "tpp30" },
  {   3, "tpp40" },
  {   4, "tpp50" },
  {   5, "tpp60" },
  {   6, "tpp70" },
  {   7, "tpp80" },
  {   8, "tpp90" },
  {   9, "tpp100" },
  {  10, "tpp110" },
  {  11, "tpp120" },
  {  12, "tpp130" },
  {  13, "tpp140" },
  {  14, "tpp150" },
  {  15, "tpp160" },
  {  16, "tpp170" },
  {  17, "tpp180" },
  {  18, "tpp190" },
  {  19, "tpp200" },
  {  20, "tpp210" },
  {  21, "tpp220" },
  {  22, "tpp230" },
  {  23, "tpp240" },
  {  24, "tpp250" },
  {  25, "tpp260" },
  {  26, "tpp270" },
  {  27, "tpp280" },
  {  28, "tpp290" },
  {  29, "tpp300" },
  {  30, "tpp310" },
  {  31, "tpp320" },
  {  32, "tpp330" },
  {  33, "tpp340" },
  {  34, "tpp350" },
  {  35, "tpp360" },
  {  36, "tpp370" },
  {  37, "tpp380" },
  {  38, "tpp390" },
  {  39, "tpp400" },
  {  40, "tpp410" },
  {  41, "tpp420" },
  {  42, "tpp430" },
  {  43, "tpp440" },
  {  44, "tpp450" },
  {  45, "tpp460" },
  {  46, "tpp470" },
  {  47, "tpp480" },
  {  48, "tpp490" },
  {  49, "tpp500" },
  {  50, "tpp510" },
  {  51, "tpp520" },
  {  52, "tpp530" },
  {  53, "tpp540" },
  {  54, "tpp550" },
  {  55, "tpp600" },
  {  56, "tpp650" },
  {  57, "tpp700" },
  {  58, "tpp750" },
  {  59, "tpp800" },
  {  60, "tpp850" },
  {  61, "tpp900" },
  {  62, "tpp950" },
  {  63, "tpp1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerPollProhibit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     64, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerPoll_vals[] = {
  {   0, "tp10" },
  {   1, "tp20" },
  {   2, "tp30" },
  {   3, "tp40" },
  {   4, "tp50" },
  {   5, "tp60" },
  {   6, "tp70" },
  {   7, "tp80" },
  {   8, "tp90" },
  {   9, "tp100" },
  {  10, "tp110" },
  {  11, "tp120" },
  {  12, "tp130" },
  {  13, "tp140" },
  {  14, "tp150" },
  {  15, "tp160" },
  {  16, "tp170" },
  {  17, "tp180" },
  {  18, "tp190" },
  {  19, "tp200" },
  {  20, "tp210" },
  {  21, "tp220" },
  {  22, "tp230" },
  {  23, "tp240" },
  {  24, "tp250" },
  {  25, "tp260" },
  {  26, "tp270" },
  {  27, "tp280" },
  {  28, "tp290" },
  {  29, "tp300" },
  {  30, "tp310" },
  {  31, "tp320" },
  {  32, "tp330" },
  {  33, "tp340" },
  {  34, "tp350" },
  {  35, "tp360" },
  {  36, "tp370" },
  {  37, "tp380" },
  {  38, "tp390" },
  {  39, "tp400" },
  {  40, "tp410" },
  {  41, "tp420" },
  {  42, "tp430" },
  {  43, "tp440" },
  {  44, "tp450" },
  {  45, "tp460" },
  {  46, "tp470" },
  {  47, "tp480" },
  {  48, "tp490" },
  {  49, "tp500" },
  {  50, "tp510" },
  {  51, "tp520" },
  {  52, "tp530" },
  {  53, "tp540" },
  {  54, "tp550" },
  {  55, "tp600" },
  {  56, "tp650" },
  {  57, "tp700" },
  {  58, "tp750" },
  {  59, "tp800" },
  {  60, "tp850" },
  {  61, "tp900" },
  {  62, "tp950" },
  {  63, "tp1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerPoll(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     64, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PollWindow_vals[] = {
  {   0, "pw50" },
  {   1, "pw60" },
  {   2, "pw70" },
  {   3, "pw80" },
  {   4, "pw85" },
  {   5, "pw90" },
  {   6, "pw95" },
  {   7, "pw99" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PollWindow(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerPollPeriodic_vals[] = {
  {   0, "tper100" },
  {   1, "tper200" },
  {   2, "tper300" },
  {   3, "tper400" },
  {   4, "tper500" },
  {   5, "tper750" },
  {   6, "tper1000" },
  {   7, "tper2000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerPollPeriodic(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PollingInfo_sequence[] = {
  { &hf_umts_rrc_ies_timerPollProhibit, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerPollProhibit },
  { &hf_umts_rrc_ies_timerPoll, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerPoll },
  { &hf_umts_rrc_ies_poll_PDU, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Poll_PDU },
  { &hf_umts_rrc_ies_poll_SDU, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Poll_SDU },
  { &hf_umts_rrc_ies_lastTransmissionPDU_Poll, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_lastRetransmissionPDU_Poll, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_pollWindow, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PollWindow },
  { &hf_umts_rrc_ies_timerPollPeriodic, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerPollPeriodic },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PollingInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PollingInfo, PollingInfo_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_PredefinedConfigIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_PredefinedConfigValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_TransmissionRLC_Discard_vals[] = {
  {   0, "timerBasedExplicit" },
  {   1, "timerBasedNoExplicit" },
  {   2, "maxDAT-Retransmissions" },
  {   3, "noDiscard" },
  { 0, NULL }
};

static const per_choice_t TransmissionRLC_Discard_choice[] = {
  {   0, &hf_umts_rrc_ies_timerBasedExplicit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ExplicitDiscard },
  {   1, &hf_umts_rrc_ies_timerBasedNoExplicit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NoExplicitDiscard },
  {   2, &hf_umts_rrc_ies_maxDAT_Retransmissions, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxDAT_Retransmissions },
  {   3, &hf_umts_rrc_ies_noDiscard, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxDAT },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TransmissionRLC_Discard(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TransmissionRLC_Discard, TransmissionRLC_Discard_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TransmissionWindowSize_vals[] = {
  {   0, "tw1" },
  {   1, "tw8" },
  {   2, "tw16" },
  {   3, "tw32" },
  {   4, "tw64" },
  {   5, "tw128" },
  {   6, "tw256" },
  {   7, "tw512" },
  {   8, "tw768" },
  {   9, "tw1024" },
  {  10, "tw1536" },
  {  11, "tw2047" },
  {  12, "tw2560" },
  {  13, "tw3072" },
  {  14, "tw3584" },
  {  15, "tw4095" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TransmissionWindowSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TimerRST_vals[] = {
  {   0, "tr50" },
  {   1, "tr100" },
  {   2, "tr150" },
  {   3, "tr200" },
  {   4, "tr250" },
  {   5, "tr300" },
  {   6, "tr350" },
  {   7, "tr400" },
  {   8, "tr450" },
  {   9, "tr500" },
  {  10, "tr550" },
  {  11, "tr600" },
  {  12, "tr700" },
  {  13, "tr800" },
  {  14, "tr900" },
  {  15, "tr1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerRST(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UL_AM_RLC_Mode_sequence[] = {
  { &hf_umts_rrc_ies_transmissionRLC_Discard, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransmissionRLC_Discard },
  { &hf_umts_rrc_ies_transmissionWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransmissionWindowSize },
  { &hf_umts_rrc_ies_timerRST, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimerRST },
  { &hf_umts_rrc_ies_max_RST, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxRST },
  { &hf_umts_rrc_ies_pollingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PollingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_AM_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_AM_RLC_Mode, UL_AM_RLC_Mode_sequence);

  return offset;
}


static const per_sequence_t UL_UM_RLC_Mode_sequence[] = {
  { &hf_umts_rrc_ies_transmissionRLC_Discard, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransmissionRLC_Discard },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_UM_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_UM_RLC_Mode, UL_UM_RLC_Mode_sequence);

  return offset;
}


static const per_sequence_t UL_TM_RLC_Mode_sequence[] = {
  { &hf_umts_rrc_ies_transmissionRLC_Discard, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransmissionRLC_Discard },
  { &hf_umts_rrc_ies_segmentationIndication, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TM_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_TM_RLC_Mode, UL_TM_RLC_Mode_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_RLC_Mode_vals[] = {
  {   0, "ul-AM-RLC-Mode" },
  {   1, "ul-UM-RLC-Mode" },
  {   2, "ul-TM-RLC-Mode" },
  {   3, "spare" },
  { 0, NULL }
};

static const per_choice_t UL_RLC_Mode_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_AM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_AM_RLC_Mode },
  {   1, &hf_umts_rrc_ies_ul_UM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_UM_RLC_Mode },
  {   2, &hf_umts_rrc_ies_ul_TM_RLC_Mode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_TM_RLC_Mode },
  {   3, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_RLC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_RLC_Mode, UL_RLC_Mode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RLC_Info_sequence[] = {
  { &hf_umts_rrc_ies_ul_RLC_Mode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_RLC_Mode },
  { &hf_umts_rrc_ies_dl_RLC_Mode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_RLC_Mode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_Info, RLC_Info_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RLC_InfoChoice_vals[] = {
  {   0, "rlc-Info" },
  {   1, "same-as-RB" },
  { 0, NULL }
};

static const per_choice_t RLC_InfoChoice_choice[] = {
  {   0, &hf_umts_rrc_ies_rlc_Info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RLC_Info },
  {   1, &hf_umts_rrc_ies_same_as_RB, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RB_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_InfoChoice(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RLC_InfoChoice, RLC_InfoChoice_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_UL_TransportChannelType_vals[] = {
  {   0, "dch" },
  {   1, "rach" },
  {   2, "dummy-NULL" },
  {   3, "usch" },
  { 0, NULL }
};

static const per_choice_t UL_TransportChannelType_choice[] = {
  {   0, &hf_umts_rrc_ies_dch    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   1, &hf_umts_rrc_ies_rach   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_dummy_NULL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_usch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TransportChannelType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_TransportChannelType, UL_TransportChannelType_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_maxTF(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxTF, NULL, FALSE);

  return offset;
}


static const per_sequence_t RLC_SizeInfo_sequence[] = {
  { &hf_umts_rrc_ies_rlc_SizeIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_maxTF },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_SizeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_SizeInfo, RLC_SizeInfo_sequence);

  return offset;
}


static const per_sequence_t RLC_SizeExplicitList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RLC_SizeExplicitList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_SizeInfo },
};

static int
dissect_umts_rrc_ies_RLC_SizeExplicitList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RLC_SizeExplicitList, RLC_SizeExplicitList_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const value_string umts_rrc_ies_T_rlc_SizeList_vals[] = {
  {   0, "allSizes" },
  {   1, "configured" },
  {   2, "explicitList" },
  { 0, NULL }
};

static const per_choice_t T_rlc_SizeList_choice[] = {
  {   0, &hf_umts_rrc_ies_allSizes, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_configured, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_explicitList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RLC_SizeExplicitList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_rlc_SizeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_rlc_SizeList, T_rlc_SizeList_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_LogicalChannelMapping_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TransportChannelType },
  { &hf_umts_rrc_ies_logicalChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_LogicalChannelIdentity },
  { &hf_umts_rrc_ies_rlc_SizeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_rlc_SizeList },
  { &hf_umts_rrc_ies_mac_LogicalChannelPriority, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_LogicalChannelPriority },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_LogicalChannelMapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_LogicalChannelMapping, UL_LogicalChannelMapping_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_sequence_of[1] = {
  { &hf_umts_rrc_ies_ul_LogicalChannelMapping_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_LogicalChannelMapping },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping, SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_sequence_of,
                                                  maxLoCHperRLC, maxLoCHperRLC);

  return offset;
}


static const per_sequence_t UL_LogicalChannelMappingList_sequence[] = {
  { &hf_umts_rrc_ies_rlc_LogicalChannelMappingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_LogicalChannelMapping, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_LogicalChannelMappingList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_LogicalChannelMappingList, UL_LogicalChannelMappingList_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_LogicalChannelMappings_vals[] = {
  {   0, "oneLogicalChannel" },
  {   1, "twoLogicalChannels" },
  { 0, NULL }
};

static const per_choice_t UL_LogicalChannelMappings_choice[] = {
  {   0, &hf_umts_rrc_ies_oneLogicalChannel, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_LogicalChannelMapping },
  {   1, &hf_umts_rrc_ies_twoLogicalChannels, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_LogicalChannelMappingList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_LogicalChannelMappings(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_LogicalChannelMappings, UL_LogicalChannelMappings_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RB_MappingOption_sequence[] = {
  { &hf_umts_rrc_ies_ul_LogicalChannelMappings, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_LogicalChannelMappings },
  { &hf_umts_rrc_ies_dl_LogicalChannelMappingList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_LogicalChannelMappingList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_MappingOption(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_MappingOption, RB_MappingOption_sequence);

  return offset;
}


static const per_sequence_t RB_MappingInfo_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_MappingInfo_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingOption },
};

static int
dissect_umts_rrc_ies_RB_MappingInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_MappingInfo, RB_MappingInfo_sequence_of,
                                                  1, maxRBMuxOptions);

  return offset;
}


static const per_sequence_t SRB_InformationSetup_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rlc_InfoChoice, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice },
  { &hf_umts_rrc_ies_rb_MappingInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SRB_InformationSetup(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SRB_InformationSetup, SRB_InformationSetup_sequence);

  return offset;
}


static const per_sequence_t SRB_InformationSetupList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SRB_InformationSetupList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_InformationSetup },
};

int
dissect_umts_rrc_ies_SRB_InformationSetupList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SRB_InformationSetupList, SRB_InformationSetupList_sequence_of,
                                                  1, maxSRBsetup);

  return offset;
}


static const per_sequence_t RB_InformationSetup_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_Info },
  { &hf_umts_rrc_ies_rlc_InfoChoice, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice },
  { &hf_umts_rrc_ies_rb_MappingInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationSetup(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationSetup, RB_InformationSetup_sequence);

  return offset;
}


static const per_sequence_t RB_InformationSetupList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationSetupList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetup },
};

static int
dissect_umts_rrc_ies_RB_InformationSetupList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationSetupList, RB_InformationSetupList_sequence_of,
                                                  1, maxRBperRAB);

  return offset;
}


static const per_sequence_t PredefinedRB_Configuration_sequence[] = {
  { &hf_umts_rrc_ies_re_EstablishmentTimer, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Re_EstablishmentTimer },
  { &hf_umts_rrc_ies_srb_InformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_InformationSetupList },
  { &hf_umts_rrc_ies_rb_InformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetupList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PredefinedRB_Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PredefinedRB_Configuration, PredefinedRB_Configuration_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TFC_Value(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1023U, NULL, FALSE);

  return offset;
}


static const per_sequence_t AllowedTFC_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_AllowedTFC_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFC_Value },
};

static int
dissect_umts_rrc_ies_AllowedTFC_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AllowedTFC_List, AllowedTFC_List_sequence_of,
                                                  1, maxTFC);

  return offset;
}


static const per_sequence_t Non_allowedTFC_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_Non_allowedTFC_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFC_Value },
};

static int
dissect_umts_rrc_ies_Non_allowedTFC_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_Non_allowedTFC_List, Non_allowedTFC_List_sequence_of,
                                                  1, maxTFC);

  return offset;
}


static const value_string umts_rrc_ies_UL_TrCH_Type_vals[] = {
  {   0, "dch" },
  {   1, "usch" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UL_TrCH_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t AllowedTFI_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_AllowedTFI_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_31 },
};

static int
dissect_umts_rrc_ies_AllowedTFI_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AllowedTFI_List, AllowedTFI_List_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const per_sequence_t RestrictedTrChInfo_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Type },
  { &hf_umts_rrc_ies_restrictedTrChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_allowedTFI_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AllowedTFI_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RestrictedTrChInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RestrictedTrChInfo, RestrictedTrChInfo_sequence);

  return offset;
}


static const per_sequence_t RestrictedTrChInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RestrictedTrChInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RestrictedTrChInfo },
};

static int
dissect_umts_rrc_ies_RestrictedTrChInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RestrictedTrChInfoList, RestrictedTrChInfoList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


const value_string umts_rrc_ies_TFC_Subset_vals[] = {
  {   0, "minimumAllowedTFC-Number" },
  {   1, "allowedTFC-List" },
  {   2, "non-allowedTFC-List" },
  {   3, "restrictedTrChInfoList" },
  {   4, "fullTFCS" },
  { 0, NULL }
};

static const per_choice_t TFC_Subset_choice[] = {
  {   0, &hf_umts_rrc_ies_minimumAllowedTFC_Number, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFC_Value },
  {   1, &hf_umts_rrc_ies_allowedTFC_List, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_AllowedTFC_List },
  {   2, &hf_umts_rrc_ies_non_allowedTFC_List, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Non_allowedTFC_List },
  {   3, &hf_umts_rrc_ies_restrictedTrChInfoList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RestrictedTrChInfoList },
  {   4, &hf_umts_rrc_ies_fullTFCS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_TFC_Subset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TFC_Subset, TFC_Subset_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 3U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_GainFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd6_sequence[] = {
  { &hf_umts_rrc_ies_gainFactorBetaC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GainFactor },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd6, T_fdd6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo5_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo5_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd7   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd6 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo5, T_modeSpecificInfo5_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_ReferenceTFC_ID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SignalledGainFactors_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo5 },
  { &hf_umts_rrc_ies_gainFactorBetaD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GainFactor },
  { &hf_umts_rrc_ies_referenceTFC_ID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTFC_ID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SignalledGainFactors(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SignalledGainFactors, SignalledGainFactors_sequence);

  return offset;
}


static const value_string umts_rrc_ies_GainFactorInformation_vals[] = {
  {   0, "signalledGainFactors" },
  {   1, "computedGainFactors" },
  { 0, NULL }
};

static const per_choice_t GainFactorInformation_choice[] = {
  {   0, &hf_umts_rrc_ies_signalledGainFactors, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SignalledGainFactors },
  {   1, &hf_umts_rrc_ies_computedGainFactors, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReferenceTFC_ID },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_GainFactorInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_GainFactorInformation, GainFactorInformation_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_PowerOffsetPp_m(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -5, 10U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PowerOffsetInformation_sequence[] = {
  { &hf_umts_rrc_ies_gainFactorInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GainFactorInformation },
  { &hf_umts_rrc_ies_powerOffsetPp_m, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetPp_m },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PowerOffsetInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PowerOffsetInformation, PowerOffsetInformation_sequence);

  return offset;
}


static const per_sequence_t T_ctfc2Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc2  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc2Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc2Bit_item, T_ctfc2Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc2Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc2Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc2Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc2Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc2Bit, T_ctfc2Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}


static const per_sequence_t T_ctfc4Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc4  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc4Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc4Bit_item, T_ctfc4Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc4Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc4Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc4Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc4Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc4Bit, T_ctfc4Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_63(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ctfc6Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc6  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc6Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc6Bit_item, T_ctfc6Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc6Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc6Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc6Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc6Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc6Bit, T_ctfc6Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_255(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ctfc8Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc8  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc8Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc8Bit_item, T_ctfc8Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc8Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc8Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc8Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc8Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc8Bit, T_ctfc8Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_4095(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 4095U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ctfc12Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc12 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc12Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc12Bit_item, T_ctfc12Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc12Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc12Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc12Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc12Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc12Bit, T_ctfc12Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}


static const per_sequence_t T_ctfc16Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc16 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_65535 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc16Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc16Bit_item, T_ctfc16Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc16Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc16Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc16Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc16Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc16Bit, T_ctfc16Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_16777215(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 16777215U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ctfc24Bit_item_sequence[] = {
  { &hf_umts_rrc_ies_ctfc24 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_16777215 },
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfc24Bit_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ctfc24Bit_item, T_ctfc24Bit_item_sequence);

  return offset;
}


static const per_sequence_t T_ctfc24Bit_sequence_of[1] = {
  { &hf_umts_rrc_ies_ctfc24Bit_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfc24Bit_item },
};

static int
dissect_umts_rrc_ies_T_ctfc24Bit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_ctfc24Bit, T_ctfc24Bit_sequence_of,
                                                  1, maxTFC);

  return offset;
}


static const value_string umts_rrc_ies_T_ctfcSize_vals[] = {
  {   0, "ctfc2Bit" },
  {   1, "ctfc4Bit" },
  {   2, "ctfc6Bit" },
  {   3, "ctfc8Bit" },
  {   4, "ctfc12Bit" },
  {   5, "ctfc16Bit" },
  {   6, "ctfc24Bit" },
  { 0, NULL }
};

static const per_choice_t T_ctfcSize_choice[] = {
  {   0, &hf_umts_rrc_ies_ctfc2Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc2Bit },
  {   1, &hf_umts_rrc_ies_ctfc4Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc4Bit },
  {   2, &hf_umts_rrc_ies_ctfc6Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc6Bit },
  {   3, &hf_umts_rrc_ies_ctfc8Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc8Bit },
  {   4, &hf_umts_rrc_ies_ctfc12Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc12Bit },
  {   5, &hf_umts_rrc_ies_ctfc16Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc16Bit },
  {   6, &hf_umts_rrc_ies_ctfc24Bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ctfc24Bit },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ctfcSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ctfcSize, T_ctfcSize_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TFCS_ReconfAdd_sequence[] = {
  { &hf_umts_rrc_ies_ctfcSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ctfcSize },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFCS_ReconfAdd(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TFCS_ReconfAdd, TFCS_ReconfAdd_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_1023(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1023U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TFCS_Removal_sequence[] = {
  { &hf_umts_rrc_ies_tfci   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1023 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFCS_Removal(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TFCS_Removal, TFCS_Removal_sequence);

  return offset;
}


static const per_sequence_t TFCS_RemovalList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TFCS_RemovalList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_Removal },
};

static int
dissect_umts_rrc_ies_TFCS_RemovalList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TFCS_RemovalList, TFCS_RemovalList_sequence_of,
                                                  1, maxTFC);

  return offset;
}


static const per_sequence_t T_replacement_sequence[] = {
  { &hf_umts_rrc_ies_tfcsRemoval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_RemovalList },
  { &hf_umts_rrc_ies_tfcsAdd, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_ReconfAdd },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_replacement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_replacement, T_replacement_sequence);

  return offset;
}


static const value_string umts_rrc_ies_ExplicitTFCS_Configuration_vals[] = {
  {   0, "complete" },
  {   1, "addition" },
  {   2, "removal" },
  {   3, "replacement" },
  { 0, NULL }
};

static const per_choice_t ExplicitTFCS_Configuration_choice[] = {
  {   0, &hf_umts_rrc_ies_complete, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCS_ReconfAdd },
  {   1, &hf_umts_rrc_ies_addition, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCS_ReconfAdd },
  {   2, &hf_umts_rrc_ies_removal, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCS_RemovalList },
  {   3, &hf_umts_rrc_ies_replacement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_replacement },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ExplicitTFCS_Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ExplicitTFCS_Configuration, ExplicitTFCS_Configuration_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_SplitType_vals[] = {
  {   0, "hardSplit" },
  {   1, "logicalSplit" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SplitType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 10U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_1023(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 1023U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_TFCS_InfoForDSCH_vals[] = {
  {   0, "ctfc2bit" },
  {   1, "ctfc4bit" },
  {   2, "ctfc6bit" },
  {   3, "ctfc8bit" },
  {   4, "ctfc12bit" },
  {   5, "ctfc16bit" },
  {   6, "ctfc24bit" },
  { 0, NULL }
};

static const per_choice_t TFCS_InfoForDSCH_choice[] = {
  {   0, &hf_umts_rrc_ies_ctfc2bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_3 },
  {   1, &hf_umts_rrc_ies_ctfc4bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   2, &hf_umts_rrc_ies_ctfc6bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   3, &hf_umts_rrc_ies_ctfc8bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_255 },
  {   4, &hf_umts_rrc_ies_ctfc12bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_4095 },
  {   5, &hf_umts_rrc_ies_ctfc16bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_65535 },
  {   6, &hf_umts_rrc_ies_ctfc24bit, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_16777215 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFCS_InfoForDSCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TFCS_InfoForDSCH, TFCS_InfoForDSCH_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TFCI_Range_sequence[] = {
  { &hf_umts_rrc_ies_maxTFCIField2Value, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_1023 },
  { &hf_umts_rrc_ies_tfcs_InfoForDSCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_InfoForDSCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFCI_Range(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TFCI_Range, TFCI_Range_sequence);

  return offset;
}


static const per_sequence_t TFCI_RangeList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TFCI_RangeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCI_Range },
};

static int
dissect_umts_rrc_ies_TFCI_RangeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TFCI_RangeList, TFCI_RangeList_sequence_of,
                                                  1, maxPDSCHTFCIgroups);

  return offset;
}


static const value_string umts_rrc_ies_TFCI_Field2_Information_vals[] = {
  {   0, "tfci-Range" },
  {   1, "explicit-config" },
  { 0, NULL }
};

static const per_choice_t TFCI_Field2_Information_choice[] = {
  {   0, &hf_umts_rrc_ies_tfci_Range, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCI_RangeList },
  {   1, &hf_umts_rrc_ies_explicit_config2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ExplicitTFCS_Configuration },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFCI_Field2_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TFCI_Field2_Information, TFCI_Field2_Information_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SplitTFCI_Signalling_sequence[] = {
  { &hf_umts_rrc_ies_splitType, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SplitType },
  { &hf_umts_rrc_ies_tfci_Field2_Length, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_10 },
  { &hf_umts_rrc_ies_tfci_Field1_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ExplicitTFCS_Configuration },
  { &hf_umts_rrc_ies_tfci_Field2_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCI_Field2_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SplitTFCI_Signalling(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SplitTFCI_Signalling, SplitTFCI_Signalling_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TFCS_vals[] = {
  {   0, "normalTFCI-Signalling" },
  {   1, "dummy-SplitTFCI-Signalling" },
  { 0, NULL }
};

static const per_choice_t TFCS_choice[] = {
  {   0, &hf_umts_rrc_ies_normalTFCI_Signalling, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ExplicitTFCS_Configuration },
  {   1, &hf_umts_rrc_ies_dummy_SplitTFCI_Signalling, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SplitTFCI_Signalling },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFCS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TFCS, TFCS_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd7_sequence[] = {
  { &hf_umts_rrc_ies_ul_TFCS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd7, T_fdd7_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TFCS_IdentityPlain(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TFCS_Identity_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_sharedChannelIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_TFCS_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TFCS_Identity, TFCS_Identity_sequence);

  return offset;
}


static const per_sequence_t IndividualUL_CCTrCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_ul_TFCS_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_Identity },
  { &hf_umts_rrc_ies_ul_TFCS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_tfc_Subset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFC_Subset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IndividualUL_CCTrCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IndividualUL_CCTrCH_Info, IndividualUL_CCTrCH_Info_sequence);

  return offset;
}


static const per_sequence_t IndividualUL_CCTrCH_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IndividualUL_CCTrCH_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualUL_CCTrCH_Info },
};

static int
dissect_umts_rrc_ies_IndividualUL_CCTrCH_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IndividualUL_CCTrCH_InfoList, IndividualUL_CCTrCH_InfoList_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t T_tdd6_sequence[] = {
  { &hf_umts_rrc_ies_individualUL_CCTrCH_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IndividualUL_CCTrCH_InfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd6, T_tdd6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo7_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo7_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd8   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd7 },
  {   1, &hf_umts_rrc_ies_tdd7   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo7, T_modeSpecificInfo7_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_CommonTransChInfo_sequence[] = {
  { &hf_umts_rrc_ies_tfc_Subset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFC_Subset },
  { &hf_umts_rrc_ies_prach_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_modeSpecificInfo7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_modeSpecificInfo7 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_CommonTransChInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_CommonTransChInfo, UL_CommonTransChInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_127(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sizeType2_sequence[] = {
  { &hf_umts_rrc_ies_part1  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_part2  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sizeType2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sizeType2, T_sizeType2_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_47(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 47U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sizeType3_sequence[] = {
  { &hf_umts_rrc_ies_part11 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_47 },
  { &hf_umts_rrc_ies_part21 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_15 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sizeType3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sizeType3, T_sizeType3_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_62(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 62U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_63(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sizeType4_sequence[] = {
  { &hf_umts_rrc_ies_part12 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_62 },
  { &hf_umts_rrc_ies_part22 , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_63 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sizeType4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sizeType4, T_sizeType4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_BitModeRLC_SizeInfo_vals[] = {
  {   0, "sizeType1" },
  {   1, "sizeType2" },
  {   2, "sizeType3" },
  {   3, "sizeType4" },
  { 0, NULL }
};

static const per_choice_t BitModeRLC_SizeInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_sizeType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_127 },
  {   1, &hf_umts_rrc_ies_sizeType2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sizeType2 },
  {   2, &hf_umts_rrc_ies_sizeType3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sizeType3 },
  {   3, &hf_umts_rrc_ies_sizeType4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sizeType4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_BitModeRLC_SizeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_BitModeRLC_SizeInfo, BitModeRLC_SizeInfo_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_rlc_Size1_vals[] = {
  {   0, "bitMode" },
  {   1, "octetModeType1" },
  { 0, NULL }
};

static const per_choice_t T_rlc_Size1_choice[] = {
  {   0, &hf_umts_rrc_ies_bitMode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BitModeRLC_SizeInfo },
  {   1, &hf_umts_rrc_ies_octetModeType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_rlc_Size1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_rlc_Size1, T_rlc_Size1_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_2_17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              2U, 17U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_18_512(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              18U, 512U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_NumberOfTransportBlocks_vals[] = {
  {   0, "zero" },
  {   1, "one" },
  {   2, "small" },
  {   3, "large" },
  { 0, NULL }
};

static const per_choice_t NumberOfTransportBlocks_choice[] = {
  {   0, &hf_umts_rrc_ies_zero   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_one    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_small  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_2_17 },
  {   3, &hf_umts_rrc_ies_large  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_18_512 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_NumberOfTransportBlocks(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_NumberOfTransportBlocks, NumberOfTransportBlocks_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks_sequence_of[1] = {
  { &hf_umts_rrc_ies_numberOfTbSizeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NumberOfTransportBlocks },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks, SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks_sequence_of,
                                                  1, maxTF);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1U, NULL, FALSE);

  return offset;
}


static const per_sequence_t LogicalChannelByRB_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_logChOfRb, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_LogicalChannelByRB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_LogicalChannelByRB, LogicalChannelByRB_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB_sequence_of[1] = {
  { &hf_umts_rrc_ies_explicitList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LogicalChannelByRB },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB, SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB_sequence_of,
                                                  1, 15);

  return offset;
}


static const value_string umts_rrc_ies_LogicalChannelList_vals[] = {
  {   0, "allSizes" },
  {   1, "configured" },
  {   2, "explicitList" },
  { 0, NULL }
};

static const per_choice_t LogicalChannelList_choice[] = {
  {   0, &hf_umts_rrc_ies_allSizes, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_configured, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_explicitList1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_LogicalChannelList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_LogicalChannelList, LogicalChannelList_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DedicatedDynamicTF_Info_sequence[] = {
  { &hf_umts_rrc_ies_rlc_Size1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_rlc_Size1 },
  { &hf_umts_rrc_ies_numberOfTbSizeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks },
  { &hf_umts_rrc_ies_logicalChannelList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LogicalChannelList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DedicatedDynamicTF_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DedicatedDynamicTF_Info, DedicatedDynamicTF_Info_sequence);

  return offset;
}


static const per_sequence_t DedicatedDynamicTF_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DedicatedDynamicTF_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DedicatedDynamicTF_Info },
};

static int
dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DedicatedDynamicTF_InfoList, DedicatedDynamicTF_InfoList_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const value_string umts_rrc_ies_T_rlc_Size2_vals[] = {
  {   0, "bitMode" },
  {   1, "octetModeType1" },
  { 0, NULL }
};

static const per_choice_t T_rlc_Size2_choice[] = {
  {   0, &hf_umts_rrc_ies_bitMode, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BitModeRLC_SizeInfo },
  {   1, &hf_umts_rrc_ies_octetModeType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_rlc_Size2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_rlc_Size2, T_rlc_Size2_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TransmissionTimeInterval_vals[] = {
  {   0, "tti10" },
  {   1, "tti20" },
  {   2, "tti40" },
  {   3, "tti80" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TransmissionTimeInterval(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t NumberOfTbSizeAndTTIList_item_sequence[] = {
  { &hf_umts_rrc_ies_numberOfTransportBlocks, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NumberOfTransportBlocks },
  { &hf_umts_rrc_ies_transmissionTimeInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransmissionTimeInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NumberOfTbSizeAndTTIList_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NumberOfTbSizeAndTTIList_item, NumberOfTbSizeAndTTIList_item_sequence);

  return offset;
}


static const per_sequence_t NumberOfTbSizeAndTTIList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NumberOfTbSizeAndTTIList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NumberOfTbSizeAndTTIList_item },
};

static int
dissect_umts_rrc_ies_NumberOfTbSizeAndTTIList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NumberOfTbSizeAndTTIList, NumberOfTbSizeAndTTIList_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const per_sequence_t DedicatedDynamicTF_Info_DynamicTTI_sequence[] = {
  { &hf_umts_rrc_ies_rlc_Size2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_rlc_Size2 },
  { &hf_umts_rrc_ies_numberOfTbSizeAndTTIList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NumberOfTbSizeAndTTIList },
  { &hf_umts_rrc_ies_logicalChannelList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LogicalChannelList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DedicatedDynamicTF_Info_DynamicTTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DedicatedDynamicTF_Info_DynamicTTI, DedicatedDynamicTF_Info_DynamicTTI_sequence);

  return offset;
}


static const per_sequence_t DedicatedDynamicTF_InfoList_DynamicTTI_sequence_of[1] = {
  { &hf_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DedicatedDynamicTF_Info_DynamicTTI },
};

static int
dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI, DedicatedDynamicTF_InfoList_DynamicTTI_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const value_string umts_rrc_ies_T_tti2_vals[] = {
  {   0, "tti10" },
  {   1, "tti20" },
  {   2, "tti40" },
  {   3, "tti80" },
  {   4, "dynamic" },
  { 0, NULL }
};

static const per_choice_t T_tti2_choice[] = {
  {   0, &hf_umts_rrc_ies_tti101 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList },
  {   1, &hf_umts_rrc_ies_tti201 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList },
  {   2, &hf_umts_rrc_ies_tti401 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList },
  {   3, &hf_umts_rrc_ies_tti801 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList },
  {   4, &hf_umts_rrc_ies_dynamic1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tti2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tti2, T_tti2_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_CodingRate_vals[] = {
  {   0, "half" },
  {   1, "third" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_CodingRate(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ChannelCodingType_vals[] = {
  {   0, "noCoding" },
  {   1, "convolutional" },
  {   2, "turbo" },
  { 0, NULL }
};

static const per_choice_t ChannelCodingType_choice[] = {
  {   0, &hf_umts_rrc_ies_noCoding, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_convolutional, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CodingRate },
  {   2, &hf_umts_rrc_ies_turbo  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ChannelCodingType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ChannelCodingType, ChannelCodingType_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_RateMatchingAttribute(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, hiRM, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_CRC_Size_vals[] = {
  {   0, "crc0" },
  {   1, "crc8" },
  {   2, "crc12" },
  {   3, "crc16" },
  {   4, "crc24" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_CRC_Size(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SemistaticTF_Information_sequence[] = {
  { &hf_umts_rrc_ies_channelCodingType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelCodingType },
  { &hf_umts_rrc_ies_rateMatchingAttribute, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RateMatchingAttribute },
  { &hf_umts_rrc_ies_crc_Size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CRC_Size },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SemistaticTF_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SemistaticTF_Information, SemistaticTF_Information_sequence);

  return offset;
}


static const per_sequence_t DedicatedTransChTFS_sequence[] = {
  { &hf_umts_rrc_ies_tti2   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tti2 },
  { &hf_umts_rrc_ies_semistaticTF_Information, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SemistaticTF_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DedicatedTransChTFS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DedicatedTransChTFS, DedicatedTransChTFS_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_56(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 56U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_OctetModeRLC_SizeInfoType2_vals[] = {
  {   0, "sizeType1" },
  {   1, "sizeType2" },
  {   2, "sizeType3" },
  { 0, NULL }
};

static const per_choice_t OctetModeRLC_SizeInfoType2_choice[] = {
  {   0, &hf_umts_rrc_ies_sizeType11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   1, &hf_umts_rrc_ies_sizeType22, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   2, &hf_umts_rrc_ies_sizeType32, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_56 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_OctetModeRLC_SizeInfoType2, OctetModeRLC_SizeInfoType2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd2_sequence[] = {
  { &hf_umts_rrc_ies_octetModeRLC_SizeInfoType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd2, T_fdd2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_commonTDD_Choice_vals[] = {
  {   0, "bitModeRLC-SizeInfo" },
  {   1, "octetModeRLC-SizeInfoType1" },
  { 0, NULL }
};

static const per_choice_t T_commonTDD_Choice_choice[] = {
  {   0, &hf_umts_rrc_ies_bitModeRLC_SizeInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BitModeRLC_SizeInfo },
  {   1, &hf_umts_rrc_ies_octetModeRLC_SizeInfoType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_commonTDD_Choice(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_commonTDD_Choice, T_commonTDD_Choice_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd2_sequence[] = {
  { &hf_umts_rrc_ies_commonTDD_Choice, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_commonTDD_Choice },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd2, T_tdd2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_rlc_Size_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_rlc_Size_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd3   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd2 },
  {   1, &hf_umts_rrc_ies_tdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_rlc_Size(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_rlc_Size, T_rlc_Size_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonDynamicTF_Info_sequence[] = {
  { &hf_umts_rrc_ies_rlc_Size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_rlc_Size },
  { &hf_umts_rrc_ies_numberOfTbSizeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks },
  { &hf_umts_rrc_ies_logicalChannelList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LogicalChannelList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CommonDynamicTF_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CommonDynamicTF_Info, CommonDynamicTF_Info_sequence);

  return offset;
}


static const per_sequence_t CommonDynamicTF_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CommonDynamicTF_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CommonDynamicTF_Info },
};

static int
dissect_umts_rrc_ies_CommonDynamicTF_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CommonDynamicTF_InfoList, CommonDynamicTF_InfoList_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const value_string umts_rrc_ies_T_commonTDD_Choice1_vals[] = {
  {   0, "bitModeRLC-SizeInfo" },
  {   1, "octetModeRLC-SizeInfoType1" },
  { 0, NULL }
};

static const per_choice_t T_commonTDD_Choice1_choice[] = {
  {   0, &hf_umts_rrc_ies_bitModeRLC_SizeInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BitModeRLC_SizeInfo },
  {   1, &hf_umts_rrc_ies_octetModeRLC_SizeInfoType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_commonTDD_Choice1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_commonTDD_Choice1, T_commonTDD_Choice1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonDynamicTF_Info_DynamicTTI_sequence[] = {
  { &hf_umts_rrc_ies_commonTDD_Choice1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_commonTDD_Choice1 },
  { &hf_umts_rrc_ies_numberOfTbSizeAndTTIList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NumberOfTbSizeAndTTIList },
  { &hf_umts_rrc_ies_logicalChannelList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LogicalChannelList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CommonDynamicTF_Info_DynamicTTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CommonDynamicTF_Info_DynamicTTI, CommonDynamicTF_Info_DynamicTTI_sequence);

  return offset;
}


static const per_sequence_t CommonDynamicTF_InfoList_DynamicTTI_sequence_of[1] = {
  { &hf_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CommonDynamicTF_Info_DynamicTTI },
};

static int
dissect_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI, CommonDynamicTF_InfoList_DynamicTTI_sequence_of,
                                                  1, maxTF);

  return offset;
}


static const value_string umts_rrc_ies_T_tti_vals[] = {
  {   0, "tti10" },
  {   1, "tti20" },
  {   2, "tti40" },
  {   3, "tti80" },
  {   4, "dynamic" },
  { 0, NULL }
};

static const per_choice_t T_tti_choice[] = {
  {   0, &hf_umts_rrc_ies_tti10  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   1, &hf_umts_rrc_ies_tti20  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   2, &hf_umts_rrc_ies_tti40  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   3, &hf_umts_rrc_ies_tti80  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   4, &hf_umts_rrc_ies_dynamic, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tti(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tti, T_tti_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonTransChTFS_sequence[] = {
  { &hf_umts_rrc_ies_tti    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tti },
  { &hf_umts_rrc_ies_semistaticTF_Information, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SemistaticTF_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CommonTransChTFS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CommonTransChTFS, CommonTransChTFS_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TransportFormatSet_vals[] = {
  {   0, "dedicatedTransChTFS" },
  {   1, "commonTransChTFS" },
  { 0, NULL }
};

static const per_choice_t TransportFormatSet_choice[] = {
  {   0, &hf_umts_rrc_ies_dedicatedTransChTFS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedTransChTFS },
  {   1, &hf_umts_rrc_ies_commonTransChTFS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonTransChTFS },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TransportFormatSet(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TransportFormatSet, TransportFormatSet_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_AddReconfTransChInformation_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Type },
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_transportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_AddReconfTransChInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_AddReconfTransChInformation, UL_AddReconfTransChInformation_sequence);

  return offset;
}


static const per_sequence_t UL_AddReconfTransChInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_AddReconfTransChInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_AddReconfTransChInformation },
};

int
dissect_umts_rrc_ies_UL_AddReconfTransChInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_AddReconfTransChInfoList, UL_AddReconfTransChInfoList_sequence_of,
                                                  1, maxTrCHpreconf);

  return offset;
}


static const value_string umts_rrc_ies_T_dl_Parameters_vals[] = {
  {   0, "dl-DCH-TFCS" },
  {   1, "sameAsUL" },
  { 0, NULL }
};

static const per_choice_t T_dl_Parameters_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_DCH_TFCS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCS },
  {   1, &hf_umts_rrc_ies_sameAsUL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dl_Parameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_dl_Parameters, T_dl_Parameters_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd3_sequence[] = {
  { &hf_umts_rrc_ies_dl_Parameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_dl_Parameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd3, T_fdd3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tfcs_SignallingMode_vals[] = {
  {   0, "explicit-config" },
  {   1, "sameAsUL" },
  { 0, NULL }
};

static const per_choice_t T_tfcs_SignallingMode_choice[] = {
  {   0, &hf_umts_rrc_ies_explicit_config1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCS },
  {   1, &hf_umts_rrc_ies_sameAsUL1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TFCS_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tfcs_SignallingMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tfcs_SignallingMode, T_tfcs_SignallingMode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IndividualDL_CCTrCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_dl_TFCS_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_Identity },
  { &hf_umts_rrc_ies_tfcs_SignallingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tfcs_SignallingMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IndividualDL_CCTrCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IndividualDL_CCTrCH_Info, IndividualDL_CCTrCH_Info_sequence);

  return offset;
}


static const per_sequence_t IndividualDL_CCTrCH_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IndividualDL_CCTrCH_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualDL_CCTrCH_Info },
};

static int
dissect_umts_rrc_ies_IndividualDL_CCTrCH_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IndividualDL_CCTrCH_InfoList, IndividualDL_CCTrCH_InfoList_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t T_tdd3_sequence[] = {
  { &hf_umts_rrc_ies_individualDL_CCTrCH_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IndividualDL_CCTrCH_InfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3, T_tdd3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo2_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo2_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd4   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd3 },
  {   1, &hf_umts_rrc_ies_tdd3   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo2, T_modeSpecificInfo2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_CommonTransChInfo_sequence[] = {
  { &hf_umts_rrc_ies_sccpch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_modeSpecificInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo2 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonTransChInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonTransChInfo, DL_CommonTransChInfo_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_TrCH_Type_vals[] = {
  {   0, "dch" },
  {   1, "dsch" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_TrCH_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UL_TransportChannelIdentity_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Type },
  { &hf_umts_rrc_ies_ul_TransportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TransportChannelIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_TransportChannelIdentity, UL_TransportChannelIdentity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tfs_SignallingMode_vals[] = {
  {   0, "explicit-config" },
  {   1, "sameAsULTrCH" },
  { 0, NULL }
};

static const per_choice_t T_tfs_SignallingMode_choice[] = {
  {   0, &hf_umts_rrc_ies_explicit_config, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportFormatSet },
  {   1, &hf_umts_rrc_ies_sameAsULTrCH, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_TransportChannelIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tfs_SignallingMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tfs_SignallingMode, T_tfs_SignallingMode_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BLER_QualityValue(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -63, 0U, NULL, FALSE);

  return offset;
}


static const per_sequence_t QualityTarget_sequence[] = {
  { &hf_umts_rrc_ies_bler_QualityValue, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BLER_QualityValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_QualityTarget(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_QualityTarget, QualityTarget_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MessType_vals[] = {
  {   0, "transportFormatCombinationControl" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MessType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UL_ControlledTrChList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_ControlledTrChList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
};

static int
dissect_umts_rrc_ies_UL_ControlledTrChList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_ControlledTrChList, UL_ControlledTrChList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t T_mode2_sequence[] = {
  { &hf_umts_rrc_ies_ul_controlledTrChList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_ControlledTrChList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mode2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mode2, T_mode2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tm_SignallingMode_vals[] = {
  {   0, "mode1" },
  {   1, "mode2" },
  { 0, NULL }
};

static const per_choice_t T_tm_SignallingMode_choice[] = {
  {   0, &hf_umts_rrc_ies_mode1  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_mode2  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_mode2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tm_SignallingMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tm_SignallingMode, T_tm_SignallingMode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TM_SignallingInfo_sequence[] = {
  { &hf_umts_rrc_ies_messType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MessType },
  { &hf_umts_rrc_ies_tm_SignallingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tm_SignallingMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TM_SignallingInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TM_SignallingInfo, TM_SignallingInfo_sequence);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInformation_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_Type },
  { &hf_umts_rrc_ies_dl_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_tfs_SignallingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tfs_SignallingMode },
  { &hf_umts_rrc_ies_dch_QualityTarget, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_QualityTarget },
  { &hf_umts_rrc_ies_dummy_TM_SignallingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TM_SignallingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_AddReconfTransChInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_AddReconfTransChInformation, DL_AddReconfTransChInformation_sequence);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_AddReconfTransChInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_AddReconfTransChInformation },
};

int
dissect_umts_rrc_ies_DL_AddReconfTransChInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_AddReconfTransChInfoList, DL_AddReconfTransChInfoList_sequence_of,
                                                  1, maxTrCHpreconf);

  return offset;
}


static const per_sequence_t PreDefTransChConfiguration_sequence[] = {
  { &hf_umts_rrc_ies_ul_CommonTransChInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_CommonTransChInfo },
  { &hf_umts_rrc_ies_ul_AddReconfTrChInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_AddReconfTransChInfoList },
  { &hf_umts_rrc_ies_dl_CommonTransChInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_CommonTransChInfo },
  { &hf_umts_rrc_ies_dl_TrChInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_AddReconfTransChInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PreDefTransChConfiguration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PreDefTransChConfiguration, PreDefTransChConfiguration_sequence);

  return offset;
}


static const per_sequence_t T_fdd49_sequence[] = {
  { &hf_umts_rrc_ies_powerControlAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerControlAlgorithm },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd49(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd49, T_fdd49_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_ConstantValueTdd(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -35, 10U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_tdd41_sequence[] = {
  { &hf_umts_rrc_ies_dpch_ConstantValue, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValueTdd },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd41, T_tdd41_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_DPCH_PowerControlInfoPredef_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t UL_DPCH_PowerControlInfoPredef_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd52  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd49 },
  {   1, &hf_umts_rrc_ies_tdd46  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd41 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPredef(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPredef, UL_DPCH_PowerControlInfoPredef_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_PuncturingLimit_vals[] = {
  {   0, "pl0-40" },
  {   1, "pl0-44" },
  {   2, "pl0-48" },
  {   3, "pl0-52" },
  {   4, "pl0-56" },
  {   5, "pl0-60" },
  {   6, "pl0-64" },
  {   7, "pl0-68" },
  {   8, "pl0-72" },
  {   9, "pl0-76" },
  {  10, "pl0-80" },
  {  11, "pl0-84" },
  {  12, "pl0-88" },
  {  13, "pl0-92" },
  {  14, "pl0-96" },
  {  15, "pl1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PuncturingLimit(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd44_sequence[] = {
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd44(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd44, T_fdd44_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SecondInterleavingMode_vals[] = {
  {   0, "frameRelated" },
  {   1, "timeslotRelated" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SecondInterleavingMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TFCI_Coding_vals[] = {
  {   0, "tfci-bits-4" },
  {   1, "tfci-bits-8" },
  {   2, "tfci-bits-16" },
  {   3, "tfci-bits-32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TFCI_Coding(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 1U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 31U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_RepetitionPeriodAndLength_vals[] = {
  {   0, "repetitionPeriod1" },
  {   1, "repetitionPeriod2" },
  {   2, "repetitionPeriod4" },
  {   3, "repetitionPeriod8" },
  {   4, "repetitionPeriod16" },
  {   5, "repetitionPeriod32" },
  {   6, "repetitionPeriod64" },
  { 0, NULL }
};

static const per_choice_t RepetitionPeriodAndLength_choice[] = {
  {   0, &hf_umts_rrc_ies_repetitionPeriod1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_repetitionPeriod2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_1 },
  {   2, &hf_umts_rrc_ies_repetitionPeriod4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_3 },
  {   3, &hf_umts_rrc_ies_repetitionPeriod8, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_7 },
  {   4, &hf_umts_rrc_ies_repetitionPeriod16, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_15 },
  {   5, &hf_umts_rrc_ies_repetitionPeriod32, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_31 },
  {   6, &hf_umts_rrc_ies_repetitionPeriod64, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_63 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RepetitionPeriodAndLength(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RepetitionPeriodAndLength, RepetitionPeriodAndLength_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonTimeslotInfo_sequence[] = {
  { &hf_umts_rrc_ies_secondInterleavingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondInterleavingMode },
  { &hf_umts_rrc_ies_tfci_Coding, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCI_Coding },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { &hf_umts_rrc_ies_repetitionPeriodAndLength, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RepetitionPeriodAndLength },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CommonTimeslotInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CommonTimeslotInfo, CommonTimeslotInfo_sequence);

  return offset;
}


static const per_sequence_t T_tdd36_sequence[] = {
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CommonTimeslotInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd36(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd36, T_tdd36_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo40_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo40_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd47  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd44 },
  {   1, &hf_umts_rrc_ies_tdd41  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd36 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo40(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo40, T_modeSpecificInfo40_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_InfoPredef_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPredef },
  { &hf_umts_rrc_ies_modeSpecificInfo40, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo40 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_InfoPredef(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_InfoPredef, UL_DPCH_InfoPredef_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PilotBits128_vals[] = {
  {   0, "pb4" },
  {   1, "pb8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PilotBits128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PilotBits256_vals[] = {
  {   0, "pb2" },
  {   1, "pb4" },
  {   2, "pb8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PilotBits256(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_SF512_AndPilot_vals[] = {
  {   0, "sfd4" },
  {   1, "sfd8" },
  {   2, "sfd16" },
  {   3, "sfd32" },
  {   4, "sfd64" },
  {   5, "sfd128" },
  {   6, "sfd256" },
  {   7, "sfd512" },
  { 0, NULL }
};

static const per_choice_t SF512_AndPilot_choice[] = {
  {   0, &hf_umts_rrc_ies_sfd4   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_sfd8   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_sfd16  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_sfd32  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_sfd64  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   5, &hf_umts_rrc_ies_sfd128 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PilotBits128 },
  {   6, &hf_umts_rrc_ies_sfd256 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PilotBits256 },
  {   7, &hf_umts_rrc_ies_sfd512 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SF512_AndPilot(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SF512_AndPilot, SF512_AndPilot_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_PositionFixedOrFlexible_vals[] = {
  {   0, "fixed" },
  {   1, "flexible" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PositionFixedOrFlexible(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd16_sequence[] = {
  { &hf_umts_rrc_ies_spreadingFactorAndPilot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF512_AndPilot },
  { &hf_umts_rrc_ies_positionFixedOrFlexible, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionFixedOrFlexible },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd16, T_fdd16_sequence);

  return offset;
}


static const per_sequence_t T_tdd15_sequence[] = {
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CommonTimeslotInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd15, T_tdd15_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo16_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo16_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd17  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd16 },
  {   1, &hf_umts_rrc_ies_tdd16  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd15 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo16, T_modeSpecificInfo16_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoCommonPredef_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo16, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoCommonPredef(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoCommonPredef, DL_DPCH_InfoCommonPredef_sequence);

  return offset;
}


static const per_sequence_t DL_CommonInformationPredef_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_InfoCommon4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoCommonPredef },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_CommonInformationPredef(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonInformationPredef, DL_CommonInformationPredef_sequence);

  return offset;
}


static const per_sequence_t PreDefPhyChConfiguration_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_InfoPredef, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_InfoPredef },
  { &hf_umts_rrc_ies_dl_CommonInformationPredef, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CommonInformationPredef },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PreDefPhyChConfiguration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PreDefPhyChConfiguration, PreDefPhyChConfiguration_sequence);

  return offset;
}


static const per_sequence_t PreDefRadioConfiguration_sequence[] = {
  { &hf_umts_rrc_ies_predefinedRB_Configuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedRB_Configuration },
  { &hf_umts_rrc_ies_preDefTransChConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PreDefTransChConfiguration },
  { &hf_umts_rrc_ies_preDefPhyChConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PreDefPhyChConfiguration },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PreDefRadioConfiguration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PreDefRadioConfiguration, PreDefRadioConfiguration_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_other_vals[] = {
  {   0, "notStored" },
  {   1, "storedWithDifferentValueTag" },
  { 0, NULL }
};

static const per_choice_t T_other_choice[] = {
  {   0, &hf_umts_rrc_ies_notStored, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_storedWithDifferentValueTag, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PredefinedConfigValueTag },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_other(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_other, T_other_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_PredefinedConfigStatusInfo_vals[] = {
  {   0, "storedWithValueTagSameAsPrevius" },
  {   1, "other" },
  { 0, NULL }
};

static const per_choice_t PredefinedConfigStatusInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_storedWithValueTagSameAsPrevius, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_other  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_other },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PredefinedConfigStatusInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PredefinedConfigStatusInfo, PredefinedConfigStatusInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PredefinedConfigStatusList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PredefinedConfigStatusList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigStatusInfo },
};

int
dissect_umts_rrc_ies_PredefinedConfigStatusList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PredefinedConfigStatusList, PredefinedConfigStatusList_sequence_of,
                                                  maxPredefConfig, maxPredefConfig);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 10U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PredefinedConfigValueTagList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PredefinedConfigValueTagList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigValueTag },
};

static int
dissect_umts_rrc_ies_PredefinedConfigValueTagList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PredefinedConfigValueTagList, PredefinedConfigValueTagList_sequence_of,
                                                  1, maxPredefConfig);

  return offset;
}


static const per_sequence_t PredefinedConfigSetWithDifferentValueTag_sequence[] = {
  { &hf_umts_rrc_ies_startPosition, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_10 },
  { &hf_umts_rrc_ies_valueTagList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigValueTagList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PredefinedConfigSetWithDifferentValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PredefinedConfigSetWithDifferentValueTag, PredefinedConfigSetWithDifferentValueTag_sequence);

  return offset;
}


static const per_sequence_t PredefinedConfigSetsWithDifferentValueTag_sequence_of[1] = {
  { &hf_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigSetWithDifferentValueTag },
};

static int
dissect_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag, PredefinedConfigSetsWithDifferentValueTag_sequence_of,
                                                  1, 2);

  return offset;
}


static const per_sequence_t PredefinedConfigStatusListVarSz_sequence_of[1] = {
  { &hf_umts_rrc_ies_PredefinedConfigStatusListVarSz_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigStatusInfo },
};

static int
dissect_umts_rrc_ies_PredefinedConfigStatusListVarSz(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PredefinedConfigStatusListVarSz, PredefinedConfigStatusListVarSz_sequence_of,
                                                  1, maxPredefConfig);

  return offset;
}


static const per_sequence_t PredefinedConfigStatusListComp_sequence[] = {
  { &hf_umts_rrc_ies_setsWithDifferentValueTag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag },
  { &hf_umts_rrc_ies_otherEntries, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PredefinedConfigStatusListVarSz },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PredefinedConfigStatusListComp(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PredefinedConfigStatusListComp, PredefinedConfigStatusListComp_sequence);

  return offset;
}


static const per_sequence_t RAB_Info_sequence[] = {
  { &hf_umts_rrc_ies_rab_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Identity },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_nas_Synchronisation_Indicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NAS_Synchronisation_Indicator },
  { &hf_umts_rrc_ies_re_EstablishmentTimer, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Re_EstablishmentTimer },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_RAB_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_Info, RAB_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_SessionIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       1, 1, NULL);

  return offset;
}


static const per_sequence_t RAB_Info_r6_ext_sequence[] = {
  { &hf_umts_rrc_ies_mbms_SessionIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_SessionIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_Info_r6_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_Info_r6_ext, RAB_Info_r6_ext_sequence);

  return offset;
}


static const per_sequence_t RAB_Info_r6_sequence[] = {
  { &hf_umts_rrc_ies_rab_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Identity },
  { &hf_umts_rrc_ies_mbms_SessionIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_SessionIdentity },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_nas_Synchronisation_Indicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NAS_Synchronisation_Indicator },
  { &hf_umts_rrc_ies_re_EstablishmentTimer, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Re_EstablishmentTimer },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_Info_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_Info_r6, RAB_Info_r6_sequence);

  return offset;
}


static const per_sequence_t RAB_InformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info },
};

int
dissect_umts_rrc_ies_RAB_InformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationList, RAB_InformationList_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_InformationList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info_r6 },
};

int
dissect_umts_rrc_ies_RAB_InformationList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationList_r6, RAB_InformationList_r6_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_InformationReconfig_sequence[] = {
  { &hf_umts_rrc_ies_rab_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Identity },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_nas_Synchronisation_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NAS_Synchronisation_Indicator },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_InformationReconfig(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_InformationReconfig, RAB_InformationReconfig_sequence);

  return offset;
}


static const per_sequence_t RAB_InformationReconfigList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationReconfigList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_InformationReconfig },
};

int
dissect_umts_rrc_ies_RAB_InformationReconfigList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationReconfigList, RAB_InformationReconfigList_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_Info_Post_sequence[] = {
  { &hf_umts_rrc_ies_rab_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Identity },
  { &hf_umts_rrc_ies_cn_DomainIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainIdentity },
  { &hf_umts_rrc_ies_nas_Synchronisation_Indicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NAS_Synchronisation_Indicator },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_RAB_Info_Post(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_Info_Post, RAB_Info_Post_sequence);

  return offset;
}


static const per_sequence_t RAB_InformationSetup_sequence[] = {
  { &hf_umts_rrc_ies_rab_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info },
  { &hf_umts_rrc_ies_rb_InformationSetupList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetupList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_InformationSetup(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_InformationSetup, RAB_InformationSetup_sequence);

  return offset;
}


static const per_sequence_t RB_InformationSetup_r4_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_Info_r4 },
  { &hf_umts_rrc_ies_rlc_InfoChoice, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice },
  { &hf_umts_rrc_ies_rb_MappingInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationSetup_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationSetup_r4, RB_InformationSetup_r4_sequence);

  return offset;
}


static const per_sequence_t RB_InformationSetupList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationSetupList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetup_r4 },
};

static int
dissect_umts_rrc_ies_RB_InformationSetupList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationSetupList_r4, RB_InformationSetupList_r4_sequence_of,
                                                  1, maxRBperRAB);

  return offset;
}


static const per_sequence_t RAB_InformationSetup_r4_sequence[] = {
  { &hf_umts_rrc_ies_rab_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info },
  { &hf_umts_rrc_ies_rb_InformationSetupList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetupList_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_InformationSetup_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_InformationSetup_r4, RAB_InformationSetup_r4_sequence);

  return offset;
}


static const per_sequence_t RLC_Info_r5_sequence[] = {
  { &hf_umts_rrc_ies_ul_RLC_Mode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_RLC_Mode },
  { &hf_umts_rrc_ies_dl_RLC_Mode_r5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_RLC_Mode_r5 },
  { &hf_umts_rrc_ies_rlc_OneSidedReEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_Info_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_Info_r5, RLC_Info_r5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RLC_InfoChoice_r5_vals[] = {
  {   0, "rlc-Info-r5" },
  {   1, "same-as-RB" },
  { 0, NULL }
};

static const per_choice_t RLC_InfoChoice_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_rlc_Info_r5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RLC_Info_r5 },
  {   1, &hf_umts_rrc_ies_same_as_RB, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RB_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_InfoChoice_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RLC_InfoChoice_r5, RLC_InfoChoice_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RB_MappingOption_r5_sequence[] = {
  { &hf_umts_rrc_ies_ul_LogicalChannelMappings, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_LogicalChannelMappings },
  { &hf_umts_rrc_ies_dl_LogicalChannelMappingList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_LogicalChannelMappingList_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_MappingOption_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_MappingOption_r5, RB_MappingOption_r5_sequence);

  return offset;
}


static const per_sequence_t RB_MappingInfo_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_MappingInfo_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingOption_r5 },
};

static int
dissect_umts_rrc_ies_RB_MappingInfo_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_MappingInfo_r5, RB_MappingInfo_r5_sequence_of,
                                                  1, maxRBMuxOptions);

  return offset;
}


static const per_sequence_t RB_InformationSetup_r5_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_Info_r4 },
  { &hf_umts_rrc_ies_rlc_InfoChoice1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice_r5 },
  { &hf_umts_rrc_ies_rb_MappingInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationSetup_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationSetup_r5, RB_InformationSetup_r5_sequence);

  return offset;
}


static const per_sequence_t RB_InformationSetupList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationSetupList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetup_r5 },
};

static int
dissect_umts_rrc_ies_RB_InformationSetupList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationSetupList_r5, RB_InformationSetupList_r5_sequence_of,
                                                  1, maxRBperRAB);

  return offset;
}


static const per_sequence_t RAB_InformationSetup_r5_sequence[] = {
  { &hf_umts_rrc_ies_rab_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info },
  { &hf_umts_rrc_ies_rb_InformationSetupList2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetupList_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_InformationSetup_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_InformationSetup_r5, RAB_InformationSetup_r5_sequence);

  return offset;
}


static const per_sequence_t RAB_InformationSetup_r6_ext_sequence[] = {
  { &hf_umts_rrc_ies_rab_Info_r6_ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info_r6_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_InformationSetup_r6_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_InformationSetup_r6_ext, RAB_InformationSetup_r6_ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_altE_bitInterpretation_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_altE_bitInterpretation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RLC_Info_r6_sequence[] = {
  { &hf_umts_rrc_ies_ul_RLC_Mode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_RLC_Mode },
  { &hf_umts_rrc_ies_dl_RLC_Mode_r51, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_RLC_Mode_r6 },
  { &hf_umts_rrc_ies_rlc_OneSidedReEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_altE_bitInterpretation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_altE_bitInterpretation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_Info_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_Info_r6, RLC_Info_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RLC_InfoChoice_r6_vals[] = {
  {   0, "rlc-Info-r6" },
  {   1, "same-as-RB" },
  { 0, NULL }
};

static const per_choice_t RLC_InfoChoice_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_rlc_Info_r6, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RLC_Info_r6 },
  {   1, &hf_umts_rrc_ies_same_as_RB, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RB_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_InfoChoice_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RLC_InfoChoice_r6, RLC_InfoChoice_r6_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_rlc_SizeList1_vals[] = {
  {   0, "allSizes" },
  {   1, "configured" },
  {   2, "explicitList" },
  { 0, NULL }
};

static const per_choice_t T_rlc_SizeList1_choice[] = {
  {   0, &hf_umts_rrc_ies_allSizes, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_configured, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_explicitList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RLC_SizeExplicitList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_rlc_SizeList1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_rlc_SizeList1, T_rlc_SizeList1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_dch_rach_cpch_usch_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TransportChannelType },
  { &hf_umts_rrc_ies_logicalChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_LogicalChannelIdentity },
  { &hf_umts_rrc_ies_rlc_SizeList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_rlc_SizeList1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dch_rach_cpch_usch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_dch_rach_cpch_usch, T_dch_rach_cpch_usch_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DCH_MAC_d_FlowIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, maxEDCHMACdFlow1, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_RLC_PDU_Size(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType1(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t RLC_PDU_SizeList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RLC_PDU_SizeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_PDU_Size },
};

static int
dissect_umts_rrc_ies_RLC_PDU_SizeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RLC_PDU_SizeList, RLC_PDU_SizeList_sequence_of,
                                                  1, maxRLCPDUsizePerLogChan);

  return offset;
}


static const per_sequence_t T_e_dch_sequence[] = {
  { &hf_umts_rrc_ies_logicalChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_LogicalChannelIdentity },
  { &hf_umts_rrc_ies_e_DCH_MAC_d_FlowIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DCH_MAC_d_FlowIdentity },
  { &hf_umts_rrc_ies_ddi    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DDI },
  { &hf_umts_rrc_ies_rlc_PDU_SizeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_PDU_SizeList },
  { &hf_umts_rrc_ies_includeInSchedulingInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_e_dch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_e_dch, T_e_dch_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ul_TrCH_Type_vals[] = {
  {   0, "dch-rach-cpch-usch" },
  {   1, "e-dch" },
  { 0, NULL }
};

static const per_choice_t T_ul_TrCH_Type_choice[] = {
  {   0, &hf_umts_rrc_ies_dch_rach_cpch_usch, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_dch_rach_cpch_usch },
  {   1, &hf_umts_rrc_ies_e_dch  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_e_dch },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ul_TrCH_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ul_TrCH_Type, T_ul_TrCH_Type_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_LogicalChannelMapping_r6_sequence[] = {
  { &hf_umts_rrc_ies_ul_TrCH_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ul_TrCH_Type },
  { &hf_umts_rrc_ies_mac_LogicalChannelPriority, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_LogicalChannelPriority },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_LogicalChannelMapping_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_LogicalChannelMapping_r6, UL_LogicalChannelMapping_r6_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_ul_LogicalChannelMapping_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_LogicalChannelMapping_r6 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6, SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6_sequence_of,
                                                  maxLoCHperRLC, maxLoCHperRLC);

  return offset;
}


static const per_sequence_t UL_LogicalChannelMappingList_r6_sequence[] = {
  { &hf_umts_rrc_ies_rlc_LogicalChannelMappingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ul_LogicalChannelMapping1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_LogicalChannelMappingList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_LogicalChannelMappingList_r6, UL_LogicalChannelMappingList_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_LogicalChannelMappings_r6_vals[] = {
  {   0, "oneLogicalChannel" },
  {   1, "twoLogicalChannels" },
  { 0, NULL }
};

static const per_choice_t UL_LogicalChannelMappings_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_oneLogicalChannel1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_LogicalChannelMapping_r6 },
  {   1, &hf_umts_rrc_ies_twoLogicalChannels1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_LogicalChannelMappingList_r6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_LogicalChannelMappings_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_LogicalChannelMappings_r6, UL_LogicalChannelMappings_r6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RB_MappingOption_r6_sequence[] = {
  { &hf_umts_rrc_ies_ul_LogicalChannelMappings1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_LogicalChannelMappings_r6 },
  { &hf_umts_rrc_ies_dl_LogicalChannelMappingList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_LogicalChannelMappingList_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_MappingOption_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_MappingOption_r6, RB_MappingOption_r6_sequence);

  return offset;
}


static const per_sequence_t RB_MappingInfo_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_MappingInfo_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingOption_r6 },
};

static int
dissect_umts_rrc_ies_RB_MappingInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_MappingInfo_r6, RB_MappingInfo_r6_sequence_of,
                                                  1, maxRBMuxOptions);

  return offset;
}


static const per_sequence_t RB_InformationSetup_r6_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_Info_r4 },
  { &hf_umts_rrc_ies_rlc_InfoChoice2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice_r6 },
  { &hf_umts_rrc_ies_rb_MappingInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationSetup_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationSetup_r6, RB_InformationSetup_r6_sequence);

  return offset;
}


static const per_sequence_t RB_InformationSetupList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationSetupList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetup_r6 },
};

static int
dissect_umts_rrc_ies_RB_InformationSetupList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationSetupList_r6, RB_InformationSetupList_r6_sequence_of,
                                                  1, maxRBperRAB);

  return offset;
}


static const per_sequence_t RAB_InformationSetup_r6_sequence[] = {
  { &hf_umts_rrc_ies_rab_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_Info_r6 },
  { &hf_umts_rrc_ies_rb_InformationSetupList3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationSetupList_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RAB_InformationSetup_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RAB_InformationSetup_r6, RAB_InformationSetup_r6_sequence);

  return offset;
}


static const per_sequence_t RAB_InformationSetupList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationSetupList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_InformationSetup },
};

int
dissect_umts_rrc_ies_RAB_InformationSetupList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationSetupList, RAB_InformationSetupList_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_InformationSetupList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationSetupList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_InformationSetup_r4 },
};

int
dissect_umts_rrc_ies_RAB_InformationSetupList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationSetupList_r4, RAB_InformationSetupList_r4_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_InformationSetupList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationSetupList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_InformationSetup_r5 },
};

int
dissect_umts_rrc_ies_RAB_InformationSetupList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationSetupList_r5, RAB_InformationSetupList_r5_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_InformationSetupList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationSetupList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_InformationSetup_r6 },
};

int
dissect_umts_rrc_ies_RAB_InformationSetupList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationSetupList_r6, RAB_InformationSetupList_r6_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RAB_InformationSetupList_r6_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_RAB_InformationSetupList_r6_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAB_InformationSetup_r6_ext },
};

int
dissect_umts_rrc_ies_RAB_InformationSetupList_r6_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RAB_InformationSetupList_r6_ext, RAB_InformationSetupList_r6_ext_sequence_of,
                                                  1, maxRABsetup);

  return offset;
}


static const per_sequence_t RB_COUNT_C_Information_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_count_C_UL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_COUNT_C },
  { &hf_umts_rrc_ies_count_C_DL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_COUNT_C },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_COUNT_C_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_COUNT_C_Information, RB_COUNT_C_Information_sequence);

  return offset;
}


static const per_sequence_t RB_COUNT_C_InformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_COUNT_C_InformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_COUNT_C_Information },
};

int
dissect_umts_rrc_ies_RB_COUNT_C_InformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_COUNT_C_InformationList, RB_COUNT_C_InformationList_sequence_of,
                                                  1, maxRBallRABs);

  return offset;
}


static const per_sequence_t RB_COUNT_C_MSB_Information_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_count_C_MSB_UL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_COUNT_C_MSB },
  { &hf_umts_rrc_ies_count_C_MSB_DL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_COUNT_C_MSB },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_COUNT_C_MSB_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_COUNT_C_MSB_Information, RB_COUNT_C_MSB_Information_sequence);

  return offset;
}


static const per_sequence_t RB_COUNT_C_MSB_InformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_COUNT_C_MSB_InformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_COUNT_C_MSB_Information },
};

int
dissect_umts_rrc_ies_RB_COUNT_C_MSB_InformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_COUNT_C_MSB_InformationList, RB_COUNT_C_MSB_InformationList_sequence_of,
                                                  1, maxRBallRABs);

  return offset;
}


static const per_sequence_t RB_IdentityList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_IdentityList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
};

int
dissect_umts_rrc_ies_RB_IdentityList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_IdentityList, RB_IdentityList_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationAffected_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rb_MappingInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationAffected(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationAffected, RB_InformationAffected_sequence);

  return offset;
}


static const per_sequence_t RB_InformationAffected_r5_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rb_MappingInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationAffected_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationAffected_r5, RB_InformationAffected_r5_sequence);

  return offset;
}


static const per_sequence_t RB_InformationAffected_r6_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rb_MappingInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationAffected_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationAffected_r6, RB_InformationAffected_r6_sequence);

  return offset;
}


static const per_sequence_t RB_InformationAffectedList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationAffectedList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationAffected },
};

int
dissect_umts_rrc_ies_RB_InformationAffectedList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationAffectedList, RB_InformationAffectedList_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationAffectedList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationAffectedList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationAffected_r5 },
};

int
dissect_umts_rrc_ies_RB_InformationAffectedList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationAffectedList_r5, RB_InformationAffectedList_r5_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationAffectedList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationAffectedList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationAffected_r6 },
};

int
dissect_umts_rrc_ies_RB_InformationAffectedList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationAffectedList_r6, RB_InformationAffectedList_r6_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const value_string umts_rrc_ies_T_rb_Change_vals[] = {
  {   0, "release" },
  {   1, "re-mapToDefaultRb" },
  { 0, NULL }
};

static const per_choice_t T_rb_Change_choice[] = {
  {   0, &hf_umts_rrc_ies_release1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_re_mapToDefaultRb, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RB_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_rb_Change(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_rb_Change, T_rb_Change_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RB_InformationChanged_r6_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rb_Change, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_rb_Change },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationChanged_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationChanged_r6, RB_InformationChanged_r6_sequence);

  return offset;
}


static const per_sequence_t RB_InformationChangedList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationChangedList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationChanged_r6 },
};

int
dissect_umts_rrc_ies_RB_InformationChangedList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationChangedList_r6, RB_InformationChangedList_r6_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const value_string umts_rrc_ies_RB_StopContinue_vals[] = {
  {   0, "stopRB" },
  {   1, "continueRB" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RB_StopContinue(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t RB_InformationReconfig_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_InfoReconfig },
  { &hf_umts_rrc_ies_pdcp_SN_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_SN_Info },
  { &hf_umts_rrc_ies_rlc_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RLC_Info },
  { &hf_umts_rrc_ies_rb_MappingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_MappingInfo },
  { &hf_umts_rrc_ies_rb_StopContinue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_StopContinue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationReconfig(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationReconfig, RB_InformationReconfig_sequence);

  return offset;
}


static const per_sequence_t RB_InformationReconfig_r4_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_InfoReconfig_r4 },
  { &hf_umts_rrc_ies_pdcp_SN_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_SN_Info },
  { &hf_umts_rrc_ies_rlc_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RLC_Info },
  { &hf_umts_rrc_ies_rb_MappingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_MappingInfo },
  { &hf_umts_rrc_ies_rb_StopContinue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_StopContinue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationReconfig_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationReconfig_r4, RB_InformationReconfig_r4_sequence);

  return offset;
}


static const per_sequence_t RB_InformationReconfig_r5_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_InfoReconfig_r4 },
  { &hf_umts_rrc_ies_pdcp_SN_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_SN_Info },
  { &hf_umts_rrc_ies_rlc_Info1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RLC_Info_r5 },
  { &hf_umts_rrc_ies_rb_MappingInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_MappingInfo_r5 },
  { &hf_umts_rrc_ies_rb_StopContinue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_StopContinue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationReconfig_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationReconfig_r5, RB_InformationReconfig_r5_sequence);

  return offset;
}


static const per_sequence_t RB_InformationReconfig_r6_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_pdcp_Info3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_InfoReconfig_r4 },
  { &hf_umts_rrc_ies_pdcp_SN_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDCP_SN_Info },
  { &hf_umts_rrc_ies_rlc_Info2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RLC_Info_r6 },
  { &hf_umts_rrc_ies_rb_MappingInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_MappingInfo_r6 },
  { &hf_umts_rrc_ies_rb_StopContinue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_StopContinue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RB_InformationReconfig_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RB_InformationReconfig_r6, RB_InformationReconfig_r6_sequence);

  return offset;
}


static const per_sequence_t RB_InformationReconfigList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationReconfigList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationReconfig },
};

int
dissect_umts_rrc_ies_RB_InformationReconfigList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationReconfigList, RB_InformationReconfigList_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationReconfigList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationReconfigList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationReconfig_r4 },
};

int
dissect_umts_rrc_ies_RB_InformationReconfigList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationReconfigList_r4, RB_InformationReconfigList_r4_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationReconfigList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationReconfigList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationReconfig_r5 },
};

int
dissect_umts_rrc_ies_RB_InformationReconfigList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationReconfigList_r5, RB_InformationReconfigList_r5_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationReconfigList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationReconfigList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_InformationReconfig_r6 },
};

int
dissect_umts_rrc_ies_RB_InformationReconfigList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationReconfigList_r6, RB_InformationReconfigList_r6_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const per_sequence_t RB_InformationReleaseList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RB_InformationReleaseList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
};

int
dissect_umts_rrc_ies_RB_InformationReleaseList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RB_InformationReleaseList, RB_InformationReleaseList_sequence_of,
                                                  1, maxRB);

  return offset;
}


static const value_string umts_rrc_ies_TimerDAR_r6_vals[] = {
  {   0, "ms40" },
  {   1, "ms80" },
  {   2, "ms120" },
  {   3, "ms160" },
  {   4, "ms240" },
  {   5, "ms320" },
  {   6, "ms480" },
  {   7, "ms640" },
  {   8, "ms960" },
  {   9, "ms1280" },
  {  10, "ms1920" },
  {  11, "ms2560" },
  {  12, "ms3840" },
  {  13, "ms5120" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerDAR_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     14, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_WindowSizeDAR_r6_vals[] = {
  {   0, "ws4" },
  {   1, "ws8" },
  {   2, "ws16" },
  {   3, "ws32" },
  {   4, "ws40" },
  {   5, "ws48" },
  {   6, "ws56" },
  {   7, "ws64" },
  {   8, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_WindowSizeDAR_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     9, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UM_RLC_DuplAvoid_Reord_Info_r6_sequence[] = {
  { &hf_umts_rrc_ies_timer_DAR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimerDAR_r6 },
  { &hf_umts_rrc_ies_widowSize_DAR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_WindowSizeDAR_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UM_RLC_DuplAvoid_Reord_Info_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UM_RLC_DuplAvoid_Reord_Info_r6, UM_RLC_DuplAvoid_Reord_Info_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TimerOSD_r6_vals[] = {
  {   0, "ms40" },
  {   1, "ms80" },
  {   2, "ms120" },
  {   3, "ms160" },
  {   4, "ms240" },
  {   5, "ms320" },
  {   6, "ms480" },
  {   7, "ms640" },
  {   8, "ms960" },
  {   9, "ms1280" },
  {  10, "ms1920" },
  {  11, "ms2560" },
  {  12, "ms3840" },
  {  13, "ms5120" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimerOSD_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     14, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_WindowSizeOSD_r6_vals[] = {
  {   0, "ws8" },
  {   1, "ws16" },
  {   2, "ws32" },
  {   3, "ws40" },
  {   4, "ws48" },
  {   5, "ws56" },
  {   6, "ws64" },
  {   7, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_WindowSizeOSD_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UM_RLC_OutOSeqDelivery_Info_r6_sequence[] = {
  { &hf_umts_rrc_ies_timer_OSD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimerOSD_r6 },
  { &hf_umts_rrc_ies_windowSize_OSD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_WindowSizeOSD_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UM_RLC_OutOSeqDelivery_Info_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UM_RLC_OutOSeqDelivery_Info_r6, UM_RLC_OutOSeqDelivery_Info_r6_sequence);

  return offset;
}


static const per_sequence_t RLC_Info_MBMS_r6_sequence[] = {
  { &hf_umts_rrc_ies_dl_UM_RLC_LI_size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_UM_RLC_LI_size },
  { &hf_umts_rrc_ies_dl_UM_RLC_DuplAvoid_Reord_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UM_RLC_DuplAvoid_Reord_Info_r6 },
  { &hf_umts_rrc_ies_dl_UM_RLC_OutOSeqDelivery_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UM_RLC_OutOSeqDelivery_Info_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RLC_Info_MBMS_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RLC_Info_MBMS_r6, RLC_Info_MBMS_r6_sequence);

  return offset;
}


static const per_sequence_t SRB_InformationSetup_r5_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rlc_InfoChoice1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice_r5 },
  { &hf_umts_rrc_ies_rb_MappingInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SRB_InformationSetup_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SRB_InformationSetup_r5, SRB_InformationSetup_r5_sequence);

  return offset;
}


static const per_sequence_t SRB_InformationSetup_r6_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rlc_InfoChoice2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_InfoChoice_r6 },
  { &hf_umts_rrc_ies_rb_MappingInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_MappingInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SRB_InformationSetup_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SRB_InformationSetup_r6, SRB_InformationSetup_r6_sequence);

  return offset;
}


static const per_sequence_t SRB_InformationSetupList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_SRB_InformationSetupList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_InformationSetup_r5 },
};

int
dissect_umts_rrc_ies_SRB_InformationSetupList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SRB_InformationSetupList_r5, SRB_InformationSetupList_r5_sequence_of,
                                                  1, maxSRBsetup);

  return offset;
}


static const per_sequence_t SRB_InformationSetupList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_SRB_InformationSetupList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_InformationSetup_r6 },
};

int
dissect_umts_rrc_ies_SRB_InformationSetupList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SRB_InformationSetupList_r6, SRB_InformationSetupList_r6_sequence_of,
                                                  1, maxSRBsetup);

  return offset;
}


static const per_sequence_t SRB_InformationSetupList2_sequence_of[1] = {
  { &hf_umts_rrc_ies_SRB_InformationSetupList2_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_InformationSetup },
};

int
dissect_umts_rrc_ies_SRB_InformationSetupList2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SRB_InformationSetupList2, SRB_InformationSetupList2_sequence_of,
                                                  3, 4);

  return offset;
}


static const per_sequence_t UL_CounterSynchronisationInfo_sequence[] = {
  { &hf_umts_rrc_ies_rB_WithPDCP_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RB_WithPDCP_InfoList },
  { &hf_umts_rrc_ies_startList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_STARTList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_CounterSynchronisationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_CounterSynchronisationInfo, UL_CounterSynchronisationInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T1_ReleaseTimer_vals[] = {
  {   0, "rt10" },
  {   1, "rt20" },
  {   2, "rt30" },
  {   3, "rt40" },
  {   4, "rt50" },
  {   5, "rt60" },
  {   6, "rt70" },
  {   7, "rt80" },
  {   8, "rt90" },
  {   9, "rt100" },
  {  10, "rt120" },
  {  11, "rt140" },
  {  12, "rt160" },
  {  13, "rt200" },
  {  14, "rt300" },
  {  15, "rt400" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T1_ReleaseTimer(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MAC_hs_WindowSize_vals[] = {
  {   0, "mws4" },
  {   1, "mws6" },
  {   2, "mws8" },
  {   3, "mws12" },
  {   4, "mws16" },
  {   5, "mws24" },
  {   6, "mws32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MAC_hs_WindowSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_5000(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 5000U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MAC_d_PDUsizeInfo_sequence[] = {
  { &hf_umts_rrc_ies_mac_d_PDU_Size, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_5000 },
  { &hf_umts_rrc_ies_mac_d_PDU_Index, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MAC_d_PDUsizeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MAC_d_PDUsizeInfo, MAC_d_PDUsizeInfo_sequence);

  return offset;
}


static const per_sequence_t MAC_d_PDU_SizeInfo_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_MAC_d_PDU_SizeInfo_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_d_PDUsizeInfo },
};

static int
dissect_umts_rrc_ies_MAC_d_PDU_SizeInfo_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MAC_d_PDU_SizeInfo_List, MAC_d_PDU_SizeInfo_List_sequence_of,
                                                  1, maxMACdPDUsizes);

  return offset;
}


static const per_sequence_t MAC_hs_AddReconfQueue_sequence[] = {
  { &hf_umts_rrc_ies_mac_hsQueueId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_7 },
  { &hf_umts_rrc_ies_mac_dFlowId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_d_FlowIdentity },
  { &hf_umts_rrc_ies_reorderingReleaseTimer, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T1_ReleaseTimer },
  { &hf_umts_rrc_ies_mac_hsWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_hs_WindowSize },
  { &hf_umts_rrc_ies_mac_d_PDU_SizeInfo_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MAC_d_PDU_SizeInfo_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MAC_hs_AddReconfQueue(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MAC_hs_AddReconfQueue, MAC_hs_AddReconfQueue_sequence);

  return offset;
}


static const per_sequence_t MAC_hs_AddReconfQueue_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_MAC_hs_AddReconfQueue_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_hs_AddReconfQueue },
};

static int
dissect_umts_rrc_ies_MAC_hs_AddReconfQueue_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MAC_hs_AddReconfQueue_List, MAC_hs_AddReconfQueue_List_sequence_of,
                                                  1, maxQueueIDs);

  return offset;
}


static const per_sequence_t MAC_hs_DelQueue_sequence[] = {
  { &hf_umts_rrc_ies_mac_hsQueueId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MAC_hs_DelQueue(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MAC_hs_DelQueue, MAC_hs_DelQueue_sequence);

  return offset;
}


static const per_sequence_t MAC_hs_DelQueue_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_MAC_hs_DelQueue_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MAC_hs_DelQueue },
};

static int
dissect_umts_rrc_ies_MAC_hs_DelQueue_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MAC_hs_DelQueue_List, MAC_hs_DelQueue_List_sequence_of,
                                                  1, maxQueueIDs);

  return offset;
}


static const per_sequence_t AddOrReconfMAC_dFlow_sequence[] = {
  { &hf_umts_rrc_ies_mac_hs_AddReconfQueue_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MAC_hs_AddReconfQueue_List },
  { &hf_umts_rrc_ies_mac_hs_DelQueue_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MAC_hs_DelQueue_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AddOrReconfMAC_dFlow(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AddOrReconfMAC_dFlow, AddOrReconfMAC_dFlow_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tti1_vals[] = {
  {   0, "tti5" },
  {   1, "tti10" },
  {   2, "tti20" },
  {   3, "tti40" },
  {   4, "tti80" },
  {   5, "dynamic" },
  { 0, NULL }
};

static const per_choice_t T_tti1_choice[] = {
  {   0, &hf_umts_rrc_ies_tti5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   1, &hf_umts_rrc_ies_tti10  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   2, &hf_umts_rrc_ies_tti20  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   3, &hf_umts_rrc_ies_tti40  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   4, &hf_umts_rrc_ies_tti80  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList },
  {   5, &hf_umts_rrc_ies_dynamic, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tti1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tti1, T_tti1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonTransChTFS_LCR_sequence[] = {
  { &hf_umts_rrc_ies_tti1   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tti1 },
  { &hf_umts_rrc_ies_semistaticTF_Information, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SemistaticTF_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CommonTransChTFS_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CommonTransChTFS_LCR, CommonTransChTFS_LCR_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_CPCH_SetID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxCPCHsets, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_tfs_SignallingMode3_vals[] = {
  {   0, "explicit-config" },
  {   1, "sameAsULTrCH" },
  { 0, NULL }
};

static const per_choice_t T_tfs_SignallingMode3_choice[] = {
  {   0, &hf_umts_rrc_ies_explicit_config, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportFormatSet },
  {   1, &hf_umts_rrc_ies_sameAsULTrCH, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_TransportChannelIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tfs_SignallingMode3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tfs_SignallingMode3, T_tfs_SignallingMode3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInformation2_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_Type },
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_tfs_SignallingMode3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tfs_SignallingMode3 },
  { &hf_umts_rrc_ies_qualityTarget, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_QualityTarget },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_AddReconfTransChInformation2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_AddReconfTransChInformation2, DL_AddReconfTransChInformation2_sequence);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInfo2List_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_AddReconfTransChInfo2List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_AddReconfTransChInformation2 },
};

int
dissect_umts_rrc_ies_DL_AddReconfTransChInfo2List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_AddReconfTransChInfo2List, DL_AddReconfTransChInfo2List_sequence_of,
                                                  1, maxTrCHpreconf);

  return offset;
}


static const value_string umts_rrc_ies_T_tfs_SignallingMode1_vals[] = {
  {   0, "explicit-config" },
  {   1, "sameAsULTrCH" },
  { 0, NULL }
};

static const per_choice_t T_tfs_SignallingMode1_choice[] = {
  {   0, &hf_umts_rrc_ies_explicit_config, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportFormatSet },
  {   1, &hf_umts_rrc_ies_sameAsULTrCH, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_TransportChannelIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tfs_SignallingMode1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tfs_SignallingMode1, T_tfs_SignallingMode1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInformation_r4_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_Type },
  { &hf_umts_rrc_ies_dl_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_tfs_SignallingMode1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tfs_SignallingMode1 },
  { &hf_umts_rrc_ies_dch_QualityTarget, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_QualityTarget },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_AddReconfTransChInformation_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_AddReconfTransChInformation_r4, DL_AddReconfTransChInformation_r4_sequence);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInfoList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_AddReconfTransChInfoList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_AddReconfTransChInformation_r4 },
};

int
dissect_umts_rrc_ies_DL_AddReconfTransChInfoList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_AddReconfTransChInfoList_r4, DL_AddReconfTransChInfoList_r4_sequence_of,
                                                  1, maxTrCHpreconf);

  return offset;
}


static const value_string umts_rrc_ies_DL_TrCH_TypeId1_r5_vals[] = {
  {   0, "dch" },
  {   1, "dsch" },
  {   2, "hsdsch" },
  { 0, NULL }
};

static const per_choice_t DL_TrCH_TypeId1_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_dch    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   1, &hf_umts_rrc_ies_dsch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   2, &hf_umts_rrc_ies_hsdsch2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TrCH_TypeId1_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_TrCH_TypeId1_r5, DL_TrCH_TypeId1_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HSDSCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_harqInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HARQ_Info },
  { &hf_umts_rrc_ies_addOrReconfMAC_dFlow, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AddOrReconfMAC_dFlow },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HSDSCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HSDSCH_Info, HSDSCH_Info_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tfs_SignallingMode2_vals[] = {
  {   0, "explicit-config" },
  {   1, "sameAsULTrCH" },
  {   2, "hsdsch" },
  { 0, NULL }
};

static const per_choice_t T_tfs_SignallingMode2_choice[] = {
  {   0, &hf_umts_rrc_ies_explicit_config, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportFormatSet },
  {   1, &hf_umts_rrc_ies_sameAsULTrCH, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_TransportChannelIdentity },
  {   2, &hf_umts_rrc_ies_hsdsch1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_HSDSCH_Info },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tfs_SignallingMode2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tfs_SignallingMode2, T_tfs_SignallingMode2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInformation_r5_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_TypeId1_r5 },
  { &hf_umts_rrc_ies_tfs_SignallingMode2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tfs_SignallingMode2 },
  { &hf_umts_rrc_ies_dch_QualityTarget, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_QualityTarget },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_AddReconfTransChInformation_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_AddReconfTransChInformation_r5, DL_AddReconfTransChInformation_r5_sequence);

  return offset;
}


static const per_sequence_t DL_AddReconfTransChInfoList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_AddReconfTransChInfoList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_AddReconfTransChInformation_r5 },
};

int
dissect_umts_rrc_ies_DL_AddReconfTransChInfoList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_AddReconfTransChInfoList_r5, DL_AddReconfTransChInfoList_r5_sequence_of,
                                                  1, maxTrCHpreconf);

  return offset;
}


static const per_sequence_t T_dl_DCH_TFCS_sequence[] = {
  { &hf_umts_rrc_ies_tfcs   , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dl_DCH_TFCS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_dl_DCH_TFCS, T_dl_DCH_TFCS_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_dl_Parameters1_vals[] = {
  {   0, "dl-DCH-TFCS" },
  {   1, "sameAsUL" },
  { 0, NULL }
};

static const per_choice_t T_dl_Parameters1_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_DCH_TFCS1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_dl_DCH_TFCS },
  {   1, &hf_umts_rrc_ies_sameAsUL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dl_Parameters1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_dl_Parameters1, T_dl_Parameters1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd4_sequence[] = {
  { &hf_umts_rrc_ies_dl_Parameters1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_dl_Parameters1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd4, T_fdd4_sequence);

  return offset;
}


static const per_sequence_t T_tdd4_sequence[] = {
  { &hf_umts_rrc_ies_individualDL_CCTrCH_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IndividualDL_CCTrCH_InfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd4, T_tdd4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo3_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo3_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd4 },
  {   1, &hf_umts_rrc_ies_tdd4   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo3, T_modeSpecificInfo3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_CommonTransChInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_sccpch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_modeSpecificInfo3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_modeSpecificInfo3 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonTransChInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonTransChInfo_r4, DL_CommonTransChInfo_r4_sequence);

  return offset;
}


static const per_sequence_t DL_TransportChannelIdentity_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_Type },
  { &hf_umts_rrc_ies_dl_TransportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TransportChannelIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_TransportChannelIdentity, DL_TransportChannelIdentity_sequence);

  return offset;
}


static const per_sequence_t DL_DeletedTransChInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_DeletedTransChInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TransportChannelIdentity },
};

int
dissect_umts_rrc_ies_DL_DeletedTransChInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_DeletedTransChInfoList, DL_DeletedTransChInfoList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const value_string umts_rrc_ies_DL_TrCH_TypeId2_r5_vals[] = {
  {   0, "dch" },
  {   1, "dsch" },
  {   2, "hsdsch" },
  { 0, NULL }
};

static const per_choice_t DL_TrCH_TypeId2_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_dch    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   1, &hf_umts_rrc_ies_dsch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   2, &hf_umts_rrc_ies_hsdsch , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MAC_d_FlowIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TrCH_TypeId2_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_TrCH_TypeId2_r5, DL_TrCH_TypeId2_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_TransportChannelIdentity_r5_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransportChannelType4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_TypeId2_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TransportChannelIdentity_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_TransportChannelIdentity_r5, DL_TransportChannelIdentity_r5_sequence);

  return offset;
}


static const per_sequence_t DL_DeletedTransChInfoList_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_DeletedTransChInfoList_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TransportChannelIdentity_r5 },
};

int
dissect_umts_rrc_ies_DL_DeletedTransChInfoList_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_DeletedTransChInfoList_r5, DL_DeletedTransChInfoList_r5_sequence_of,
                                                  1, maxTrCH);

  return offset;
}



static int
dissect_umts_rrc_ies_DRAC_ClassIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxDRACclasses, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TransmissionTimeValidity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 256U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeDurationBeforeRetry(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 256U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DRAC_StaticInformation_sequence[] = {
  { &hf_umts_rrc_ies_transmissionTimeValidity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransmissionTimeValidity },
  { &hf_umts_rrc_ies_timeDurationBeforeRetry, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeDurationBeforeRetry },
  { &hf_umts_rrc_ies_drac_ClassIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DRAC_ClassIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DRAC_StaticInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DRAC_StaticInformation, DRAC_StaticInformation_sequence);

  return offset;
}


static const per_sequence_t DRAC_StaticInformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DRAC_StaticInformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DRAC_StaticInformation },
};

int
dissect_umts_rrc_ies_DRAC_StaticInformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DRAC_StaticInformationList, DRAC_StaticInformationList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DCH_MAC_d_FlowPowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 6U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DCH_MAC_d_FlowMaxRetrans(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DCH_MAC_d_FlowMultiplexingList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     maxEDCHMACdFlow, maxEDCHMACdFlow, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_19982(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 19982U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_non_ScheduledTranmGrantInfo_sequence[] = {
  { &hf_umts_rrc_ies_maxMAC_e_PDUContents, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_19982 },
  { &hf_umts_rrc_ies_ms2_NonSchedTransmGrantHARQAlloc, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_non_ScheduledTranmGrantInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_non_ScheduledTranmGrantInfo, T_non_ScheduledTranmGrantInfo_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_transmissionGrantType_vals[] = {
  {   0, "non-ScheduledTranmGrantInfo" },
  {   1, "scheduledTransmissionGrantInfo" },
  { 0, NULL }
};

static const per_choice_t T_transmissionGrantType_choice[] = {
  {   0, &hf_umts_rrc_ies_non_ScheduledTranmGrantInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_non_ScheduledTranmGrantInfo },
  {   1, &hf_umts_rrc_ies_scheduledTransmissionGrantInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_transmissionGrantType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_transmissionGrantType, T_transmissionGrantType_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t E_DCH_AddReconf_MAC_d_Flow_sequence[] = {
  { &hf_umts_rrc_ies_mac_d_FlowIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DCH_MAC_d_FlowIdentity },
  { &hf_umts_rrc_ies_mac_d_FlowPowerOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_MAC_d_FlowPowerOffset },
  { &hf_umts_rrc_ies_mac_d_FlowMaxRetrans, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_MAC_d_FlowMaxRetrans },
  { &hf_umts_rrc_ies_mac_d_FlowMultiplexingList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_MAC_d_FlowMultiplexingList },
  { &hf_umts_rrc_ies_transmissionGrantType, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_transmissionGrantType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DCH_AddReconf_MAC_d_Flow(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DCH_AddReconf_MAC_d_Flow, E_DCH_AddReconf_MAC_d_Flow_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_harq_RV_Configuration_vals[] = {
  {   0, "rv0" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_harq_RV_Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t E_DCH_Harq_Info_sequence[] = {
  { &hf_umts_rrc_ies_harq_RV_Configuration, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_harq_RV_Configuration },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DCH_Harq_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DCH_Harq_Info, E_DCH_Harq_Info_sequence);

  return offset;
}


static const value_string umts_rrc_ies_E_DCH_TTI_vals[] = {
  {   0, "tti2" },
  {   1, "tti10" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_E_DCH_TTI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd5_sequence[] = {
  { &hf_umts_rrc_ies_gainFactorBetaC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GainFactor },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd5, T_fdd5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo4_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo4_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd6   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd5 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo4, T_modeSpecificInfo4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PowerOffsetInfoShort_sequence[] = {
  { &hf_umts_rrc_ies_referenceTFC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFC_Value },
  { &hf_umts_rrc_ies_modeSpecificInfo4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo4 },
  { &hf_umts_rrc_ies_gainFactorBetaD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GainFactor },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PowerOffsetInfoShort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PowerOffsetInfoShort, PowerOffsetInfoShort_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TFC_Subset_ID_With3b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TFC_Subset_ID_With5b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 31U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TFC_Subset_ID_With10b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1023U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_tdd5_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd5, T_tdd5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo6_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo6_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd6   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd5 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo6, T_modeSpecificInfo6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TFC_SubsetList_item_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo6 },
  { &hf_umts_rrc_ies_tfc_Subset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFC_Subset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TFC_SubsetList_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TFC_SubsetList_item, TFC_SubsetList_item_sequence);

  return offset;
}


static const per_sequence_t TFC_SubsetList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TFC_SubsetList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFC_SubsetList_item },
};

static int
dissect_umts_rrc_ies_TFC_SubsetList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TFC_SubsetList, TFC_SubsetList_sequence_of,
                                                  1, maxTFCsub);

  return offset;
}


static const value_string umts_rrc_ies_TransportFormatSet_LCR_vals[] = {
  {   0, "dedicatedTransChTFS" },
  {   1, "commonTransChTFS-LCR" },
  { 0, NULL }
};

static const per_choice_t TransportFormatSet_LCR_choice[] = {
  {   0, &hf_umts_rrc_ies_dedicatedTransChTFS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DedicatedTransChTFS },
  {   1, &hf_umts_rrc_ies_commonTransChTFS_LCR, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CommonTransChTFS_LCR },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TransportFormatSet_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TransportFormatSet_LCR, TransportFormatSet_LCR_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_dch_usch_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Type },
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_transportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dch_usch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_dch_usch, T_dch_usch_sequence);

  return offset;
}


static const per_sequence_t T_e_dch1_sequence[] = {
  { &hf_umts_rrc_ies_tti3   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DCH_TTI },
  { &hf_umts_rrc_ies_harq_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_Harq_Info },
  { &hf_umts_rrc_ies_addReconf_MAC_d_Flow, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_AddReconf_MAC_d_Flow },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_e_dch1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_e_dch1, T_e_dch1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_AddReconfTransChInformation_r6_vals[] = {
  {   0, "dch-usch" },
  {   1, "e-dch" },
  { 0, NULL }
};

static const per_choice_t UL_AddReconfTransChInformation_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_dch_usch, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_dch_usch },
  {   1, &hf_umts_rrc_ies_e_dch1 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_e_dch1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_AddReconfTransChInformation_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_AddReconfTransChInformation_r6, UL_AddReconfTransChInformation_r6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_AddReconfTransChInfoList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_AddReconfTransChInfoList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_AddReconfTransChInformation_r6 },
};

int
dissect_umts_rrc_ies_UL_AddReconfTransChInfoList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_AddReconfTransChInfoList_r6, UL_AddReconfTransChInfoList_r6_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t T_fdd8_sequence[] = {
  { &hf_umts_rrc_ies_ul_TFCS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd8, T_fdd8_sequence);

  return offset;
}


static const per_sequence_t T_tdd7_sequence[] = {
  { &hf_umts_rrc_ies_individualUL_CCTrCH_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IndividualUL_CCTrCH_InfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd7, T_tdd7_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo8_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo8_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd9   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd8 },
  {   1, &hf_umts_rrc_ies_tdd8   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd7 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo8, T_modeSpecificInfo8_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_CommonTransChInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfc_Subset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFC_Subset },
  { &hf_umts_rrc_ies_prach_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_modeSpecificInfo8, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_modeSpecificInfo8 },
  { &hf_umts_rrc_ies_tfc_SubsetList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFC_SubsetList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_CommonTransChInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_CommonTransChInfo_r4, UL_CommonTransChInfo_r4_sequence);

  return offset;
}


static const per_sequence_t UL_DeletedTransChInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_DeletedTransChInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TransportChannelIdentity },
};

int
dissect_umts_rrc_ies_UL_DeletedTransChInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_DeletedTransChInfoList, UL_DeletedTransChInfoList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t T_dch_usch1_sequence[] = {
  { &hf_umts_rrc_ies_ul_TransportChannelType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Type },
  { &hf_umts_rrc_ies_ul_TransportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dch_usch1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_dch_usch1, T_dch_usch1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_TransportChannelIdentity_r6_vals[] = {
  {   0, "dch-usch" },
  {   1, "e-dch" },
  { 0, NULL }
};

static const per_choice_t UL_TransportChannelIdentity_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_dch_usch1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_dch_usch1 },
  {   1, &hf_umts_rrc_ies_e_dch2 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_E_DCH_MAC_d_FlowIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TransportChannelIdentity_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_TransportChannelIdentity_r6, UL_TransportChannelIdentity_r6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DeletedTransChInfoList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_DeletedTransChInfoList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TransportChannelIdentity_r6 },
};

int
dissect_umts_rrc_ies_UL_DeletedTransChInfoList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_DeletedTransChInfoList_r6, UL_DeletedTransChInfoList_r6_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t USCH_TransportChannelsInfo_item_sequence[] = {
  { &hf_umts_rrc_ies_usch_TransportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_usch_TFS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_USCH_TransportChannelsInfo_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_USCH_TransportChannelsInfo_item, USCH_TransportChannelsInfo_item_sequence);

  return offset;
}


static const per_sequence_t USCH_TransportChannelsInfo_sequence_of[1] = {
  { &hf_umts_rrc_ies_USCH_TransportChannelsInfo_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_USCH_TransportChannelsInfo_item },
};

static int
dissect_umts_rrc_ies_USCH_TransportChannelsInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_USCH_TransportChannelsInfo, USCH_TransportChannelsInfo_sequence_of,
                                                  1, maxTrCH);

  return offset;
}



static int
dissect_umts_rrc_ies_ACK_NACK_repetitionFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 4U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_AC_To_ASC_Mapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const per_sequence_t AC_To_ASC_MappingTable_sequence_of[1] = {
  { &hf_umts_rrc_ies_AC_To_ASC_MappingTable_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AC_To_ASC_Mapping },
};

static int
dissect_umts_rrc_ies_AC_To_ASC_MappingTable(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AC_To_ASC_MappingTable, AC_To_ASC_MappingTable_sequence_of,
                                                  maxASCmap, maxASCmap);

  return offset;
}


static const asn_namedbit T_assignedSubChannelNumber_bits[] = {
  {  0, &hf_umts_rrc_ies_T_assignedSubChannelNumber_b3, -1, -1, "b3", NULL },
  {  1, &hf_umts_rrc_ies_T_assignedSubChannelNumber_b2, -1, -1, "b2", NULL },
  {  2, &hf_umts_rrc_ies_T_assignedSubChannelNumber_b1, -1, -1, "b1", NULL },
  {  3, &hf_umts_rrc_ies_T_assignedSubChannelNumber_b0, -1, -1, "b0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_assignedSubChannelNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     4, 4, FALSE, NULL);

  return offset;
}


static const per_sequence_t AccessServiceClass_FDD_sequence[] = {
  { &hf_umts_rrc_ies_availableSignatureStartIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_availableSignatureEndIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_assignedSubChannelNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_assignedSubChannelNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AccessServiceClass_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AccessServiceClass_FDD, AccessServiceClass_FDD_sequence);

  return offset;
}


static const asn_namedbit T_channelisationCodeIndices_bits[] = {
  {  0, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex7, -1, -1, "chCodeIndex7", NULL },
  {  1, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex6, -1, -1, "chCodeIndex6", NULL },
  {  2, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex5, -1, -1, "chCodeIndex5", NULL },
  {  3, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex4, -1, -1, "chCodeIndex4", NULL },
  {  4, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex3, -1, -1, "chCodeIndex3", NULL },
  {  5, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex2, -1, -1, "chCodeIndex2", NULL },
  {  6, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex1, -1, -1, "chCodeIndex1", NULL },
  {  7, &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex0, -1, -1, "chCodeIndex0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_channelisationCodeIndices(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_subchannels_vals[] = {
  {   0, "subch0" },
  {   1, "subch1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_subchannels(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_size2_sequence[] = {
  { &hf_umts_rrc_ies_subchannels, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_subchannels },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_size2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_size2, T_size2_sequence);

  return offset;
}


static const asn_namedbit T_subchannels1_bits[] = {
  {  0, &hf_umts_rrc_ies_T_subchannels1_subCh3, -1, -1, "subCh3", NULL },
  {  1, &hf_umts_rrc_ies_T_subchannels1_subCh2, -1, -1, "subCh2", NULL },
  {  2, &hf_umts_rrc_ies_T_subchannels1_subCh1, -1, -1, "subCh1", NULL },
  {  3, &hf_umts_rrc_ies_T_subchannels1_subCh0, -1, -1, "subCh0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_subchannels1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     4, 4, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_size4_sequence[] = {
  { &hf_umts_rrc_ies_subchannels1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_subchannels1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_size4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_size4, T_size4_sequence);

  return offset;
}


static const asn_namedbit T_subchannels2_bits[] = {
  {  0, &hf_umts_rrc_ies_T_subchannels2_subCh7, -1, -1, "subCh7", NULL },
  {  1, &hf_umts_rrc_ies_T_subchannels2_subCh6, -1, -1, "subCh6", NULL },
  {  2, &hf_umts_rrc_ies_T_subchannels2_subCh5, -1, -1, "subCh5", NULL },
  {  3, &hf_umts_rrc_ies_T_subchannels2_subCh4, -1, -1, "subCh4", NULL },
  {  4, &hf_umts_rrc_ies_T_subchannels2_subCh3, -1, -1, "subCh3", NULL },
  {  5, &hf_umts_rrc_ies_T_subchannels2_subCh2, -1, -1, "subCh2", NULL },
  {  6, &hf_umts_rrc_ies_T_subchannels2_subCh1, -1, -1, "subCh1", NULL },
  {  7, &hf_umts_rrc_ies_T_subchannels2_subCh0, -1, -1, "subCh0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_subchannels2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_size8_sequence[] = {
  { &hf_umts_rrc_ies_subchannels2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_subchannels2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_size8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_size8, T_size8_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_subchannelSize_vals[] = {
  {   0, "size1" },
  {   1, "size2" },
  {   2, "size4" },
  {   3, "size8" },
  { 0, NULL }
};

static const per_choice_t T_subchannelSize_choice[] = {
  {   0, &hf_umts_rrc_ies_size1  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_size2  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_size2 },
  {   2, &hf_umts_rrc_ies_size4  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_size4 },
  {   3, &hf_umts_rrc_ies_size8  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_size8 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_subchannelSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_subchannelSize, T_subchannelSize_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t AccessServiceClass_TDD_sequence[] = {
  { &hf_umts_rrc_ies_channelisationCodeIndices, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_channelisationCodeIndices },
  { &hf_umts_rrc_ies_subchannelSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_subchannelSize },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AccessServiceClass_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AccessServiceClass_TDD, AccessServiceClass_TDD_sequence);

  return offset;
}


static const asn_namedbit T_availableSYNC_UlCodesIndics_bits[] = {
  {  0, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex7, -1, -1, "sulCodeIndex7", NULL },
  {  1, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex6, -1, -1, "sulCodeIndex6", NULL },
  {  2, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex5, -1, -1, "sulCodeIndex5", NULL },
  {  3, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex4, -1, -1, "sulCodeIndex4", NULL },
  {  4, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex3, -1, -1, "sulCodeIndex3", NULL },
  {  5, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex2, -1, -1, "sulCodeIndex2", NULL },
  {  6, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex1, -1, -1, "sulCodeIndex1", NULL },
  {  7, &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex0, -1, -1, "sulCodeIndex0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_availableSYNC_UlCodesIndics(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_subchannels3_vals[] = {
  {   0, "subch0" },
  {   1, "subch1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_subchannels3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_size21_sequence[] = {
  { &hf_umts_rrc_ies_subchannels3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_subchannels3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_size21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_size21, T_size21_sequence);

  return offset;
}


static const asn_namedbit T_subchannels4_bits[] = {
  {  0, &hf_umts_rrc_ies_T_subchannels4_subCh3, -1, -1, "subCh3", NULL },
  {  1, &hf_umts_rrc_ies_T_subchannels4_subCh2, -1, -1, "subCh2", NULL },
  {  2, &hf_umts_rrc_ies_T_subchannels4_subCh1, -1, -1, "subCh1", NULL },
  {  3, &hf_umts_rrc_ies_T_subchannels4_subCh0, -1, -1, "subCh0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_subchannels4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     4, 4, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_size41_sequence[] = {
  { &hf_umts_rrc_ies_subchannels4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_subchannels4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_size41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_size41, T_size41_sequence);

  return offset;
}


static const asn_namedbit T_subchannels5_bits[] = {
  {  0, &hf_umts_rrc_ies_T_subchannels5_subCh7, -1, -1, "subCh7", NULL },
  {  1, &hf_umts_rrc_ies_T_subchannels5_subCh6, -1, -1, "subCh6", NULL },
  {  2, &hf_umts_rrc_ies_T_subchannels5_subCh5, -1, -1, "subCh5", NULL },
  {  3, &hf_umts_rrc_ies_T_subchannels5_subCh4, -1, -1, "subCh4", NULL },
  {  4, &hf_umts_rrc_ies_T_subchannels5_subCh3, -1, -1, "subCh3", NULL },
  {  5, &hf_umts_rrc_ies_T_subchannels5_subCh2, -1, -1, "subCh2", NULL },
  {  6, &hf_umts_rrc_ies_T_subchannels5_subCh1, -1, -1, "subCh1", NULL },
  {  7, &hf_umts_rrc_ies_T_subchannels5_subCh0, -1, -1, "subCh0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_subchannels5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_size81_sequence[] = {
  { &hf_umts_rrc_ies_subchannels5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_subchannels5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_size81(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_size81, T_size81_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_subchannelSize1_vals[] = {
  {   0, "size1" },
  {   1, "size2" },
  {   2, "size4" },
  {   3, "size8" },
  { 0, NULL }
};

static const per_choice_t T_subchannelSize1_choice[] = {
  {   0, &hf_umts_rrc_ies_size1  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_size21 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_size21 },
  {   2, &hf_umts_rrc_ies_size41 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_size41 },
  {   3, &hf_umts_rrc_ies_size81 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_size81 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_subchannelSize1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_subchannelSize1, T_subchannelSize1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t AccessServiceClass_TDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_availableSYNC_UlCodesIndics, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_availableSYNC_UlCodesIndics },
  { &hf_umts_rrc_ies_subchannelSize1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_subchannelSize1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AccessServiceClass_TDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AccessServiceClass_TDD_LCR_r4, AccessServiceClass_TDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t DynamicTFInformationCCCH_sequence[] = {
  { &hf_umts_rrc_ies_octetModeRLC_SizeInfoType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OctetModeRLC_SizeInfoType2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DynamicTFInformationCCCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DynamicTFInformationCCCH, DynamicTFInformationCCCH_sequence);

  return offset;
}


static const per_sequence_t AdditionalPRACH_TF_and_TFCS_CCCH_IEs_sequence[] = {
  { &hf_umts_rrc_ies_powerOffsetInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetInformation },
  { &hf_umts_rrc_ies_dynamicTFInformationCCCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DynamicTFInformationCCCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_IEs, AdditionalPRACH_TF_and_TFCS_CCCH_IEs_sequence);

  return offset;
}


static const per_sequence_t AdditionalPRACH_TF_and_TFCS_CCCH_sequence[] = {
  { &hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_IEs, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_IEs },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH, AdditionalPRACH_TF_and_TFCS_CCCH_sequence);

  return offset;
}


static const per_sequence_t AdditionalPRACH_TF_and_TFCS_CCCH_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH },
};

static int
dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List, AdditionalPRACH_TF_and_TFCS_CCCH_List_sequence_of,
                                                  1, maxPRACH);

  return offset;
}



static int
dissect_umts_rrc_ies_ChannelisationCode256(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_AICH_TransmissionTiming_vals[] = {
  {   0, "e0" },
  {   1, "e1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_AICH_TransmissionTiming(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t AICH_Info_sequence[] = {
  { &hf_umts_rrc_ies_channelisationCode256, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelisationCode256 },
  { &hf_umts_rrc_ies_sttd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_aich_TransmissionTiming, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AICH_TransmissionTiming },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AICH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AICH_Info, AICH_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_AICH_PowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -22, 5U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_256(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 256U, NULL, FALSE);

  return offset;
}


static const per_sequence_t AllocationPeriodInfo_sequence[] = {
  { &hf_umts_rrc_ies_allocationActivationTime, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_allocationDuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_256 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AllocationPeriodInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AllocationPeriodInfo, AllocationPeriodInfo_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_Alpha(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_AP_AICH_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_AP_PreambleScramblingCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 79U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_AP_Signature(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_AP_Subchannel(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 11U, NULL, FALSE);

  return offset;
}


static const per_sequence_t AvailableAP_SubchannelList_sequence_of[1] = {
  { &hf_umts_rrc_ies_AvailableAP_SubchannelList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AP_Subchannel },
};

static int
dissect_umts_rrc_ies_AvailableAP_SubchannelList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AvailableAP_SubchannelList, AvailableAP_SubchannelList_sequence_of,
                                                  1, maxPCPCHAPsubCh);

  return offset;
}


static const per_sequence_t AP_Signature_VCAM_sequence[] = {
  { &hf_umts_rrc_ies_ap_Signature, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AP_Signature },
  { &hf_umts_rrc_ies_availableAP_SubchannelList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AvailableAP_SubchannelList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AP_Signature_VCAM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AP_Signature_VCAM, AP_Signature_VCAM_sequence);

  return offset;
}


static const per_sequence_t ASCSetting_FDD_sequence[] = {
  { &hf_umts_rrc_ies_accessServiceClass_FDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AccessServiceClass_FDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ASCSetting_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ASCSetting_FDD, ASCSetting_FDD_sequence);

  return offset;
}


static const per_sequence_t ASCSetting_TDD_sequence[] = {
  { &hf_umts_rrc_ies_accessServiceClass_TDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AccessServiceClass_TDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ASCSetting_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ASCSetting_TDD, ASCSetting_TDD_sequence);

  return offset;
}


static const per_sequence_t ASCSetting_TDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_accessServiceClass_TDD_LCR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AccessServiceClass_TDD_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ASCSetting_TDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ASCSetting_TDD_LCR_r4, ASCSetting_TDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t AvailableAP_Signature_VCAMList_sequence_of[1] = {
  { &hf_umts_rrc_ies_AvailableAP_Signature_VCAMList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AP_Signature_VCAM },
};

static int
dissect_umts_rrc_ies_AvailableAP_Signature_VCAMList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AvailableAP_Signature_VCAMList, AvailableAP_Signature_VCAMList_sequence_of,
                                                  1, maxPCPCHAPsig);

  return offset;
}


static const per_sequence_t AvailableAP_SignatureList_sequence_of[1] = {
  { &hf_umts_rrc_ies_AvailableAP_SignatureList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AP_Signature },
};

static int
dissect_umts_rrc_ies_AvailableAP_SignatureList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AvailableAP_SignatureList, AvailableAP_SignatureList_sequence_of,
                                                  1, maxPCPCHAPsig);

  return offset;
}


static const value_string umts_rrc_ies_MinimumSpreadingFactor_vals[] = {
  {   0, "sf4" },
  {   1, "sf8" },
  {   2, "sf16" },
  {   3, "sf32" },
  {   4, "sf64" },
  {   5, "sf128" },
  {   6, "sf256" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MinimumSpreadingFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NF_Max(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxAvailablePCPCH_Number(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}


static const per_sequence_t AvailableMinimumSF_VCAM_sequence[] = {
  { &hf_umts_rrc_ies_minimumSpreadingFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MinimumSpreadingFactor },
  { &hf_umts_rrc_ies_nf_Max , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NF_Max },
  { &hf_umts_rrc_ies_maxAvailablePCPCH_Number, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxAvailablePCPCH_Number },
  { &hf_umts_rrc_ies_availableAP_Signature_VCAMList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AvailableAP_Signature_VCAMList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AvailableMinimumSF_VCAM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AvailableMinimumSF_VCAM, AvailableMinimumSF_VCAM_sequence);

  return offset;
}


static const per_sequence_t AvailableMinimumSF_ListVCAM_sequence_of[1] = {
  { &hf_umts_rrc_ies_AvailableMinimumSF_ListVCAM_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AvailableMinimumSF_VCAM },
};

static int
dissect_umts_rrc_ies_AvailableMinimumSF_ListVCAM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AvailableMinimumSF_ListVCAM, AvailableMinimumSF_ListVCAM_sequence_of,
                                                  1, maxPCPCHSF);

  return offset;
}


static const asn_namedbit AvailableSignatures_bits[] = {
  {  0, &hf_umts_rrc_ies_AvailableSignatures_signature15, -1, -1, "signature15", NULL },
  {  1, &hf_umts_rrc_ies_AvailableSignatures_signature14, -1, -1, "signature14", NULL },
  {  2, &hf_umts_rrc_ies_AvailableSignatures_signature13, -1, -1, "signature13", NULL },
  {  3, &hf_umts_rrc_ies_AvailableSignatures_signature12, -1, -1, "signature12", NULL },
  {  4, &hf_umts_rrc_ies_AvailableSignatures_signature11, -1, -1, "signature11", NULL },
  {  5, &hf_umts_rrc_ies_AvailableSignatures_signature10, -1, -1, "signature10", NULL },
  {  6, &hf_umts_rrc_ies_AvailableSignatures_signature9, -1, -1, "signature9", NULL },
  {  7, &hf_umts_rrc_ies_AvailableSignatures_signature8, -1, -1, "signature8", NULL },
  {  8, &hf_umts_rrc_ies_AvailableSignatures_signature7, -1, -1, "signature7", NULL },
  {  9, &hf_umts_rrc_ies_AvailableSignatures_signature6, -1, -1, "signature6", NULL },
  { 10, &hf_umts_rrc_ies_AvailableSignatures_signature5, -1, -1, "signature5", NULL },
  { 11, &hf_umts_rrc_ies_AvailableSignatures_signature4, -1, -1, "signature4", NULL },
  { 12, &hf_umts_rrc_ies_AvailableSignatures_signature3, -1, -1, "signature3", NULL },
  { 13, &hf_umts_rrc_ies_AvailableSignatures_signature2, -1, -1, "signature2", NULL },
  { 14, &hf_umts_rrc_ies_AvailableSignatures_signature1, -1, -1, "signature1", NULL },
  { 15, &hf_umts_rrc_ies_AvailableSignatures_signature0, -1, -1, "signature0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_AvailableSignatures(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const asn_namedbit AvailableSubChannelNumbers_bits[] = {
  {  0, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh11, -1, -1, "subCh11", NULL },
  {  1, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh10, -1, -1, "subCh10", NULL },
  {  2, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh9, -1, -1, "subCh9", NULL },
  {  3, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh8, -1, -1, "subCh8", NULL },
  {  4, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh7, -1, -1, "subCh7", NULL },
  {  5, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh6, -1, -1, "subCh6", NULL },
  {  6, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh5, -1, -1, "subCh5", NULL },
  {  7, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh4, -1, -1, "subCh4", NULL },
  {  8, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh3, -1, -1, "subCh3", NULL },
  {  9, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh2, -1, -1, "subCh2", NULL },
  { 10, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh1, -1, -1, "subCh1", NULL },
  { 11, &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh0, -1, -1, "subCh0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_AvailableSubChannelNumbers(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     12, 12, FALSE, NULL);

  return offset;
}


const value_string umts_rrc_ies_BEACON_PL_Est_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_BEACON_PL_Est(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_BurstType_vals[] = {
  {   0, "type1" },
  {   1, "type2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_BurstType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_DPCCH_PowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -82, -3, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_PC_Preamble(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_SRB_delay(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd45_sequence[] = {
  { &hf_umts_rrc_ies_dpcch_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCCH_PowerOffset },
  { &hf_umts_rrc_ies_pc_Preamble, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PC_Preamble },
  { &hf_umts_rrc_ies_sRB_delay, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_delay },
  { &hf_umts_rrc_ies_powerControlAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerControlAlgorithm },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd45(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd45, T_fdd45_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_UL_TargetSIR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 62U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TDD_UL_Interference(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -110, -52, NULL, FALSE);

  return offset;
}


static const per_sequence_t IndividualTS_Interference_sequence[] = {
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_ul_TimeslotInterference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_UL_Interference },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IndividualTS_Interference(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IndividualTS_Interference, IndividualTS_Interference_sequence);

  return offset;
}


static const per_sequence_t IndividualTS_InterferenceList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IndividualTS_InterferenceList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTS_Interference },
};

static int
dissect_umts_rrc_ies_IndividualTS_InterferenceList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IndividualTS_InterferenceList, IndividualTS_InterferenceList_sequence_of,
                                                  1, maxTS);

  return offset;
}



int
dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              6U, 43U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_individuallySignalled_sequence[] = {
  { &hf_umts_rrc_ies_individualTS_InterferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTS_InterferenceList },
  { &hf_umts_rrc_ies_dpch_ConstantValue, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValueTdd },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_individuallySignalled(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_individuallySignalled, T_individuallySignalled_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ul_OL_PC_Signalling_vals[] = {
  {   0, "broadcast-UL-OL-PC-info" },
  {   1, "individuallySignalled" },
  { 0, NULL }
};

static const per_choice_t T_ul_OL_PC_Signalling_choice[] = {
  {   0, &hf_umts_rrc_ies_broadcast_UL_OL_PC_info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_individuallySignalled, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_individuallySignalled },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ul_OL_PC_Signalling(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ul_OL_PC_Signalling, T_ul_OL_PC_Signalling_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd37_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_ul_OL_PC_Signalling, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_ul_OL_PC_Signalling },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd37(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd37, T_tdd37_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_DPCH_PowerControlInfo_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t UL_DPCH_PowerControlInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd48  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd45 },
  {   1, &hf_umts_rrc_ies_tdd42  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd37 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_DPCH_PowerControlInfo, UL_DPCH_PowerControlInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CCTrCH_PowerControlInfo_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_Identity },
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CCTrCH_PowerControlInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CCTrCH_PowerControlInfo, CCTrCH_PowerControlInfo_sequence);

  return offset;
}


static const per_sequence_t T_fdd46_sequence[] = {
  { &hf_umts_rrc_ies_dpcch_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCCH_PowerOffset },
  { &hf_umts_rrc_ies_pc_Preamble, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PC_Preamble },
  { &hf_umts_rrc_ies_sRB_delay, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_delay },
  { &hf_umts_rrc_ies_powerControlAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerControlAlgorithm },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd46(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd46, T_fdd46_sequence);

  return offset;
}


static const per_sequence_t T_tdd38410_sequence[] = {
  { &hf_umts_rrc_ies_individualTS_InterferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTS_InterferenceList },
  { &hf_umts_rrc_ies_dpch_ConstantValue1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38410(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38410, T_tdd38410_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TPC_StepSizeTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_tdd12812_sequence[] = {
  { &hf_umts_rrc_ies_tpc_StepSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_StepSizeTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12812(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12812, T_tdd12812_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption10_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption10_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38413, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38410 },
  {   1, &hf_umts_rrc_ies_tdd12815, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12812 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption10, T_tddOption10_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_individuallySignalled1_sequence[] = {
  { &hf_umts_rrc_ies_tddOption10, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption10 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_individuallySignalled1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_individuallySignalled1, T_individuallySignalled1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ul_OL_PC_Signalling1_vals[] = {
  {   0, "broadcast-UL-OL-PC-info" },
  {   1, "individuallySignalled" },
  { 0, NULL }
};

static const per_choice_t T_ul_OL_PC_Signalling1_choice[] = {
  {   0, &hf_umts_rrc_ies_broadcast_UL_OL_PC_info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_individuallySignalled1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_individuallySignalled1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ul_OL_PC_Signalling1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ul_OL_PC_Signalling1, T_ul_OL_PC_Signalling1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd38_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_ul_OL_PC_Signalling1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ul_OL_PC_Signalling1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38, T_tdd38_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_DPCH_PowerControlInfo_r4_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t UL_DPCH_PowerControlInfo_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd49  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd46 },
  {   1, &hf_umts_rrc_ies_tdd43  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r4, UL_DPCH_PowerControlInfo_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CCTrCH_PowerControlInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_Identity },
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r4 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CCTrCH_PowerControlInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CCTrCH_PowerControlInfo_r4, CCTrCH_PowerControlInfo_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd47_sequence[] = {
  { &hf_umts_rrc_ies_dpcch_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCCH_PowerOffset },
  { &hf_umts_rrc_ies_pc_Preamble, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PC_Preamble },
  { &hf_umts_rrc_ies_sRB_delay, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_delay },
  { &hf_umts_rrc_ies_powerControlAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerControlAlgorithm },
  { &hf_umts_rrc_ies_deltaACK, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaACK },
  { &hf_umts_rrc_ies_deltaNACK, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaNACK },
  { &hf_umts_rrc_ies_ack_NACK_repetition_factor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ACK_NACK_repetitionFactor },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd47(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd47, T_fdd47_sequence);

  return offset;
}


static const per_sequence_t T_tdd38411_sequence[] = {
  { &hf_umts_rrc_ies_individualTS_InterferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTS_InterferenceList },
  { &hf_umts_rrc_ies_dpch_ConstantValue1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38411(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38411, T_tdd38411_sequence);

  return offset;
}


static const per_sequence_t T_tdd12813_sequence[] = {
  { &hf_umts_rrc_ies_tpc_StepSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_StepSizeTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12813(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12813, T_tdd12813_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption11_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption11_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38414, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38411 },
  {   1, &hf_umts_rrc_ies_tdd12816, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12813 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption11, T_tddOption11_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_individuallySignalled2_sequence[] = {
  { &hf_umts_rrc_ies_tddOption11, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption11 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_individuallySignalled2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_individuallySignalled2, T_individuallySignalled2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ul_OL_PC_Signalling2_vals[] = {
  {   0, "broadcast-UL-OL-PC-info" },
  {   1, "individuallySignalled" },
  { 0, NULL }
};

static const per_choice_t T_ul_OL_PC_Signalling2_choice[] = {
  {   0, &hf_umts_rrc_ies_broadcast_UL_OL_PC_info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_individuallySignalled2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_individuallySignalled2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ul_OL_PC_Signalling2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ul_OL_PC_Signalling2, T_ul_OL_PC_Signalling2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd39_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_ul_OL_PC_Signalling2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ul_OL_PC_Signalling2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd39(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd39, T_tdd39_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_DPCH_PowerControlInfo_r5_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t UL_DPCH_PowerControlInfo_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd50  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd47 },
  {   1, &hf_umts_rrc_ies_tdd44  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd39 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r5, UL_DPCH_PowerControlInfo_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CCTrCH_PowerControlInfo_r5_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_Identity },
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r5 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CCTrCH_PowerControlInfo_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CCTrCH_PowerControlInfo_r5, CCTrCH_PowerControlInfo_r5_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_CD_AccessSlotSubchannel(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 11U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CD_AccessSlotSubchannelList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CD_AccessSlotSubchannelList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CD_AccessSlotSubchannel },
};

static int
dissect_umts_rrc_ies_CD_AccessSlotSubchannelList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CD_AccessSlotSubchannelList, CD_AccessSlotSubchannelList_sequence_of,
                                                  1, maxPCPCHCDsubCh);

  return offset;
}



static int
dissect_umts_rrc_ies_CD_CA_ICH_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_CD_PreambleScramblingCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 79U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_CD_SignatureCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CD_SignatureCodeList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CD_SignatureCodeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CD_SignatureCode },
};

static int
dissect_umts_rrc_ies_CD_SignatureCodeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CD_SignatureCodeList, CD_SignatureCodeList_sequence_of,
                                                  1, maxPCPCHCDsig);

  return offset;
}



static int
dissect_umts_rrc_ies_CellParametersID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CellAndChannelIdentity_sequence[] = {
  { &hf_umts_rrc_ies_burstType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BurstType },
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellAndChannelIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellAndChannelIdentity, CellAndChannelIdentity_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_Cfntargetsfnframeoffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ChannelAssignmentActive_vals[] = {
  {   0, "notActive" },
  {   1, "isActive" },
  { 0, NULL }
};

static const per_choice_t ChannelAssignmentActive_choice[] = {
  {   0, &hf_umts_rrc_ies_notActive, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_isActive, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_AvailableMinimumSF_ListVCAM },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ChannelAssignmentActive(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ChannelAssignmentActive, ChannelAssignmentActive_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ChannelReqParamsForUCSM_sequence[] = {
  { &hf_umts_rrc_ies_availableAP_SignatureList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AvailableAP_SignatureList },
  { &hf_umts_rrc_ies_availableAP_SubchannelList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AvailableAP_SubchannelList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ChannelReqParamsForUCSM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ChannelReqParamsForUCSM, ChannelReqParamsForUCSM_sequence);

  return offset;
}


static const value_string umts_rrc_ies_ClosedLoopTimingAdjMode_vals[] = {
  {   0, "slot1" },
  {   1, "slot2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ClosedLoopTimingAdjMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_CodeNumberDSCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_SF_PDSCH_vals[] = {
  {   0, "sfp4" },
  {   1, "sfp8" },
  {   2, "sfp16" },
  {   3, "sfp32" },
  {   4, "sfp64" },
  {   5, "sfp128" },
  {   6, "sfp256" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SF_PDSCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MultiCodeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 16U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PDSCH_CodeMap_sequence[] = {
  { &hf_umts_rrc_ies_spreadingFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF_PDSCH },
  { &hf_umts_rrc_ies_multiCodeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiCodeInfo },
  { &hf_umts_rrc_ies_codeNumberStart, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeNumberDSCH },
  { &hf_umts_rrc_ies_codeNumberStop, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeNumberDSCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_CodeMap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_CodeMap, PDSCH_CodeMap_sequence);

  return offset;
}


static const per_sequence_t PDSCH_CodeMapList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_CodeMapList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_CodeMap },
};

static int
dissect_umts_rrc_ies_PDSCH_CodeMapList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_CodeMapList, PDSCH_CodeMapList_sequence_of,
                                                  1, maxPDSCHTFCIgroups);

  return offset;
}


static const per_sequence_t CodeRange_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_CodeMapList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_CodeMapList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CodeRange(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CodeRange, CodeRange_sequence);

  return offset;
}


static const value_string umts_rrc_ies_CodeWordSet_vals[] = {
  {   0, "longCWS" },
  {   1, "mediumCWS" },
  {   2, "shortCWS" },
  {   3, "ssdtOff" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_CodeWordSet(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_repetitionPeriod2_sequence[] = {
  { &hf_umts_rrc_ies_length , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NULL },
  { &hf_umts_rrc_ies_offset , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_repetitionPeriod2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_repetitionPeriod2, T_repetitionPeriod2_sequence);

  return offset;
}


static const per_sequence_t T_repetitionPeriod4_sequence[] = {
  { &hf_umts_rrc_ies_length1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_3 },
  { &hf_umts_rrc_ies_offset1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_repetitionPeriod4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_repetitionPeriod4, T_repetitionPeriod4_sequence);

  return offset;
}


static const per_sequence_t T_repetitionPeriod8_sequence[] = {
  { &hf_umts_rrc_ies_length2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_7 },
  { &hf_umts_rrc_ies_offset2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_repetitionPeriod8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_repetitionPeriod8, T_repetitionPeriod8_sequence);

  return offset;
}


static const per_sequence_t T_repetitionPeriod16_sequence[] = {
  { &hf_umts_rrc_ies_length3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_15 },
  { &hf_umts_rrc_ies_offset3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_repetitionPeriod16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_repetitionPeriod16, T_repetitionPeriod16_sequence);

  return offset;
}


static const per_sequence_t T_repetitionPeriod32_sequence[] = {
  { &hf_umts_rrc_ies_length4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_31 },
  { &hf_umts_rrc_ies_offset4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_31 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_repetitionPeriod32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_repetitionPeriod32, T_repetitionPeriod32_sequence);

  return offset;
}


static const per_sequence_t T_repetitionPeriod64_sequence[] = {
  { &hf_umts_rrc_ies_length5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_63 },
  { &hf_umts_rrc_ies_offset5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_repetitionPeriod64(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_repetitionPeriod64, T_repetitionPeriod64_sequence);

  return offset;
}


static const value_string umts_rrc_ies_RepetitionPeriodLengthAndOffset_vals[] = {
  {   0, "repetitionPeriod1" },
  {   1, "repetitionPeriod2" },
  {   2, "repetitionPeriod4" },
  {   3, "repetitionPeriod8" },
  {   4, "repetitionPeriod16" },
  {   5, "repetitionPeriod32" },
  {   6, "repetitionPeriod64" },
  { 0, NULL }
};

static const per_choice_t RepetitionPeriodLengthAndOffset_choice[] = {
  {   0, &hf_umts_rrc_ies_repetitionPeriod1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_repetitionPeriod21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_repetitionPeriod2 },
  {   2, &hf_umts_rrc_ies_repetitionPeriod41, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_repetitionPeriod4 },
  {   3, &hf_umts_rrc_ies_repetitionPeriod81, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_repetitionPeriod8 },
  {   4, &hf_umts_rrc_ies_repetitionPeriod161, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_repetitionPeriod16 },
  {   5, &hf_umts_rrc_ies_repetitionPeriod321, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_repetitionPeriod32 },
  {   6, &hf_umts_rrc_ies_repetitionPeriod641, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_repetitionPeriod64 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RepetitionPeriodLengthAndOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RepetitionPeriodLengthAndOffset, RepetitionPeriodLengthAndOffset_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonTimeslotInfoSCCPCH_sequence[] = {
  { &hf_umts_rrc_ies_secondInterleavingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondInterleavingMode },
  { &hf_umts_rrc_ies_tfci_Coding, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCI_Coding },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { &hf_umts_rrc_ies_repetitionPeriodLengthAndOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RepetitionPeriodLengthAndOffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CommonTimeslotInfoSCCPCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CommonTimeslotInfoSCCPCH, CommonTimeslotInfoSCCPCH_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_DynamicPersistenceLevel(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DynamicPersistenceLevelTF_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_DynamicPersistenceLevelTF_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DynamicPersistenceLevel },
};

static int
dissect_umts_rrc_ies_DynamicPersistenceLevelTF_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DynamicPersistenceLevelTF_List, DynamicPersistenceLevelTF_List_sequence_of,
                                                  1, maxTFCPCH);

  return offset;
}


static const per_sequence_t CPCH_PersistenceLevels_sequence[] = {
  { &hf_umts_rrc_ies_cpch_SetID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_SetID },
  { &hf_umts_rrc_ies_dynamicPersistenceLevelTF_List, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DynamicPersistenceLevelTF_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CPCH_PersistenceLevels(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CPCH_PersistenceLevels, CPCH_PersistenceLevels_sequence);

  return offset;
}


static const per_sequence_t CPCH_PersistenceLevelsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CPCH_PersistenceLevelsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_PersistenceLevels },
};

static int
dissect_umts_rrc_ies_CPCH_PersistenceLevelsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CPCH_PersistenceLevelsList, CPCH_PersistenceLevelsList_sequence_of,
                                                  1, maxCPCHsets);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaPp_m(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -10, 10U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_UL_DPCCH_SlotFormat_vals[] = {
  {   0, "slf0" },
  {   1, "slf1" },
  {   2, "slf2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UL_DPCCH_SlotFormat(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_N_StartMessage(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_N_EOT(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_CPCH_StatusIndicationMode_vals[] = {
  {   0, "pa-mode" },
  {   1, "pamsf-mode" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_CPCH_StatusIndicationMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_79(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 79U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_511(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 511U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_PCP_Length_vals[] = {
  {   0, "as0" },
  {   1, "as8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PCP_Length(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UCSM_Info_sequence[] = {
  { &hf_umts_rrc_ies_minimumSpreadingFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MinimumSpreadingFactor },
  { &hf_umts_rrc_ies_nf_Max , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NF_Max },
  { &hf_umts_rrc_ies_channelReqParamsForUCSM, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelReqParamsForUCSM },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UCSM_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UCSM_Info, UCSM_Info_sequence);

  return offset;
}


static const per_sequence_t PCPCH_ChannelInfo_sequence[] = {
  { &hf_umts_rrc_ies_pcpch_UL_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_79 },
  { &hf_umts_rrc_ies_pcpch_DL_ChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_511 },
  { &hf_umts_rrc_ies_pcpch_DL_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_pcp_Length, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCP_Length },
  { &hf_umts_rrc_ies_ucsm_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UCSM_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PCPCH_ChannelInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PCPCH_ChannelInfo, PCPCH_ChannelInfo_sequence);

  return offset;
}


static const per_sequence_t PCPCH_ChannelInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PCPCH_ChannelInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPCH_ChannelInfo },
};

static int
dissect_umts_rrc_ies_PCPCH_ChannelInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PCPCH_ChannelInfoList, PCPCH_ChannelInfoList_sequence_of,
                                                  1, maxPCPCHs);

  return offset;
}


static const per_sequence_t CPCH_SetInfo_sequence[] = {
  { &hf_umts_rrc_ies_cpch_SetID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_SetID },
  { &hf_umts_rrc_ies_transportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_tfcs   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_ap_PreambleScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AP_PreambleScramblingCode },
  { &hf_umts_rrc_ies_ap_AICH_ChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AP_AICH_ChannelisationCode },
  { &hf_umts_rrc_ies_cd_PreambleScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CD_PreambleScramblingCode },
  { &hf_umts_rrc_ies_cd_CA_ICH_ChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CD_CA_ICH_ChannelisationCode },
  { &hf_umts_rrc_ies_cd_AccessSlotSubchannelList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CD_AccessSlotSubchannelList },
  { &hf_umts_rrc_ies_cd_SignatureCodeList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CD_SignatureCodeList },
  { &hf_umts_rrc_ies_deltaPp_m, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaPp_m },
  { &hf_umts_rrc_ies_ul_DPCCH_SlotFormat, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCCH_SlotFormat },
  { &hf_umts_rrc_ies_n_StartMessage, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_N_StartMessage },
  { &hf_umts_rrc_ies_n_EOT  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_N_EOT },
  { &hf_umts_rrc_ies_channelAssignmentActive, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelAssignmentActive },
  { &hf_umts_rrc_ies_cpch_StatusIndicationMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_StatusIndicationMode },
  { &hf_umts_rrc_ies_pcpch_ChannelInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPCH_ChannelInfoList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_CPCH_SetInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CPCH_SetInfo, CPCH_SetInfo_sequence);

  return offset;
}


static const per_sequence_t CPCH_SetInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CPCH_SetInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_SetInfo },
};

static int
dissect_umts_rrc_ies_CPCH_SetInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CPCH_SetInfoList, CPCH_SetInfoList_sequence_of,
                                                  1, maxCPCHsets);

  return offset;
}



static int
dissect_umts_rrc_ies_CSICH_PowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -10, 5U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_DefaultDPCH_OffsetValueFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 599U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_DefaultDPCH_OffsetValueTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaSIR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 30U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_DHS_Sync(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -20, 10U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_DurationTimeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 4096U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TimeInfo_sequence[] = {
  { &hf_umts_rrc_ies_activationTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ActivationTime },
  { &hf_umts_rrc_ies_durationTimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DurationTimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TimeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TimeInfo, TimeInfo_sequence);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble3_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble3, T_ueSpecificMidamble3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode5_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode5_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode5, T_midambleAllocationMode5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_type11_sequence[] = {
  { &hf_umts_rrc_ies_midambleConfigurationBurstType1and3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType1and3 },
  { &hf_umts_rrc_ies_midambleAllocationMode5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_type11, T_type11_sequence);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble4_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftShort },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble4, T_ueSpecificMidamble4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode6_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode6_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode6, T_midambleAllocationMode6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_type2_sequence[] = {
  { &hf_umts_rrc_ies_midambleConfigurationBurstType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType2 },
  { &hf_umts_rrc_ies_midambleAllocationMode6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_type2, T_type2_sequence);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble5_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble5, T_ueSpecificMidamble5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode7_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode7_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_ueSpecificMidamble6, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble5 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode7, T_midambleAllocationMode7_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_type3_sequence[] = {
  { &hf_umts_rrc_ies_midambleConfigurationBurstType1and3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleConfigurationBurstType1and3 },
  { &hf_umts_rrc_ies_midambleAllocationMode7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_type3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_type3, T_type3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_burstType_vals[] = {
  {   0, "type1" },
  {   1, "type2" },
  {   2, "type3" },
  { 0, NULL }
};

static const per_choice_t T_burstType_choice[] = {
  {   0, &hf_umts_rrc_ies_type11 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type11 },
  {   1, &hf_umts_rrc_ies_type2  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type2 },
  {   2, &hf_umts_rrc_ies_type3  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_type3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_burstType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_burstType, T_burstType_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MidambleShiftAndBurstType_sequence[] = {
  { &hf_umts_rrc_ies_burstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_burstType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MidambleShiftAndBurstType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MidambleShiftAndBurstType, MidambleShiftAndBurstType_sequence);

  return offset;
}


static const per_sequence_t IndividualTimeslotInfo_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IndividualTimeslotInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IndividualTimeslotInfo, IndividualTimeslotInfo_sequence);

  return offset;
}


static const per_sequence_t T_consecutive_sequence[] = {
  { &hf_umts_rrc_ies_firstChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
  { &hf_umts_rrc_ies_lastChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_consecutive(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_consecutive, T_consecutive_sequence);

  return offset;
}


static const asn_namedbit T_bitmap_bits[] = {
  {  0, &hf_umts_rrc_ies_T_bitmap_chCode16_SF16, -1, -1, "chCode16-SF16", NULL },
  {  1, &hf_umts_rrc_ies_T_bitmap_chCode15_SF16, -1, -1, "chCode15-SF16", NULL },
  {  2, &hf_umts_rrc_ies_T_bitmap_chCode14_SF16, -1, -1, "chCode14-SF16", NULL },
  {  3, &hf_umts_rrc_ies_T_bitmap_chCode13_SF16, -1, -1, "chCode13-SF16", NULL },
  {  4, &hf_umts_rrc_ies_T_bitmap_chCode12_SF16, -1, -1, "chCode12-SF16", NULL },
  {  5, &hf_umts_rrc_ies_T_bitmap_chCode11_SF16, -1, -1, "chCode11-SF16", NULL },
  {  6, &hf_umts_rrc_ies_T_bitmap_chCode10_SF16, -1, -1, "chCode10-SF16", NULL },
  {  7, &hf_umts_rrc_ies_T_bitmap_chCode9_SF16, -1, -1, "chCode9-SF16", NULL },
  {  8, &hf_umts_rrc_ies_T_bitmap_chCode8_SF16, -1, -1, "chCode8-SF16", NULL },
  {  9, &hf_umts_rrc_ies_T_bitmap_chCode7_SF16, -1, -1, "chCode7-SF16", NULL },
  { 10, &hf_umts_rrc_ies_T_bitmap_chCode6_SF16, -1, -1, "chCode6-SF16", NULL },
  { 11, &hf_umts_rrc_ies_T_bitmap_chCode5_SF16, -1, -1, "chCode5-SF16", NULL },
  { 12, &hf_umts_rrc_ies_T_bitmap_chCode4_SF16, -1, -1, "chCode4-SF16", NULL },
  { 13, &hf_umts_rrc_ies_T_bitmap_chCode3_SF16, -1, -1, "chCode3-SF16", NULL },
  { 14, &hf_umts_rrc_ies_T_bitmap_chCode2_SF16, -1, -1, "chCode2-SF16", NULL },
  { 15, &hf_umts_rrc_ies_T_bitmap_chCode1_SF16, -1, -1, "chCode1-SF16", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_bitmap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     16, 16, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_codesRepresentation_vals[] = {
  {   0, "consecutive" },
  {   1, "bitmap" },
  { 0, NULL }
};

static const per_choice_t T_codesRepresentation_choice[] = {
  {   0, &hf_umts_rrc_ies_consecutive, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_consecutive },
  {   1, &hf_umts_rrc_ies_bitmap , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_bitmap },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_codesRepresentation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_codesRepresentation, T_codesRepresentation_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_TS_ChannelisationCodesShort_sequence[] = {
  { &hf_umts_rrc_ies_codesRepresentation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_codesRepresentation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TS_ChannelisationCodesShort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_TS_ChannelisationCodesShort, DL_TS_ChannelisationCodesShort_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_maxTS1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxTS1, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sameAsLast_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sameAsLast(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sameAsLast, T_sameAsLast_sequence);

  return offset;
}


static const per_sequence_t T_newParameters_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo },
  { &hf_umts_rrc_ies_dl_TS_ChannelisationCodesShort, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCodesShort },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_newParameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_newParameters, T_newParameters_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_parameters_vals[] = {
  {   0, "sameAsLast" },
  {   1, "newParameters" },
  { 0, NULL }
};

static const per_choice_t T_parameters_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsLast, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sameAsLast },
  {   1, &hf_umts_rrc_ies_newParameters, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_newParameters },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_parameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_parameters, T_parameters_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DownlinkAdditionalTimeslots_sequence[] = {
  { &hf_umts_rrc_ies_parameters, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_parameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DownlinkAdditionalTimeslots(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DownlinkAdditionalTimeslots, DownlinkAdditionalTimeslots_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots_sequence_of[1] = {
  { &hf_umts_rrc_ies_timeslotList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DownlinkAdditionalTimeslots },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots, SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots_sequence_of,
                                                  1, maxTS1);

  return offset;
}


static const value_string umts_rrc_ies_T_additionalTimeslots_vals[] = {
  {   0, "consecutive" },
  {   1, "timeslotList" },
  { 0, NULL }
};

static const per_choice_t T_additionalTimeslots_choice[] = {
  {   0, &hf_umts_rrc_ies_consecutive1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_maxTS1 },
  {   1, &hf_umts_rrc_ies_timeslotList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_additionalTimeslots(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_additionalTimeslots, T_additionalTimeslots_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_moreTimeslots_vals[] = {
  {   0, "noMore" },
  {   1, "additionalTimeslots" },
  { 0, NULL }
};

static const per_choice_t T_moreTimeslots_choice[] = {
  {   0, &hf_umts_rrc_ies_noMore , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_additionalTimeslots, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_additionalTimeslots },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_moreTimeslots(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_moreTimeslots, T_moreTimeslots_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DownlinkTimeslotsCodes_sequence[] = {
  { &hf_umts_rrc_ies_firstIndividualTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo },
  { &hf_umts_rrc_ies_dl_TS_ChannelisationCodesShort, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCodesShort },
  { &hf_umts_rrc_ies_moreTimeslots, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_moreTimeslots },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DownlinkTimeslotsCodes(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DownlinkTimeslotsCodes, DownlinkTimeslotsCodes_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrChTPCList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_CCTrChTPCList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_Identity },
};

static int
dissect_umts_rrc_ies_UL_CCTrChTPCList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_CCTrChTPCList, UL_CCTrChTPCList_sequence_of,
                                                  0, maxCCTrCH);

  return offset;
}


static const per_sequence_t DL_CCTrCh_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_timeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeInfo },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes },
  { &hf_umts_rrc_ies_ul_CCTrChTPCList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrChTPCList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_CCTrCh(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CCTrCh, DL_CCTrCh_sequence);

  return offset;
}


static const per_sequence_t T_tdd384_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd384(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd384, T_tdd384_sequence);

  return offset;
}


static const per_sequence_t T_ueSpecificMidamble8_sequence[] = {
  { &hf_umts_rrc_ies_midambleShift2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueSpecificMidamble8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueSpecificMidamble8, T_ueSpecificMidamble8_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_midambleAllocationMode10_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode10_choice[] = {
  {   0, &hf_umts_rrc_ies_defaultMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_commonMidamble, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_ueSpecificMidamble9, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueSpecificMidamble8 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_midambleAllocationMode10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_midambleAllocationMode10, T_midambleAllocationMode10_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MidambleShiftAndBurstType_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_midambleAllocationMode10, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_midambleAllocationMode10 },
  { &hf_umts_rrc_ies_midambleConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4, MidambleShiftAndBurstType_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modulation_vals[] = {
  {   0, "mod-QPSK" },
  {   1, "mod-8PSK" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_modulation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_ss_TPC_Symbols_vals[] = {
  {   0, "zero" },
  {   1, "one" },
  {   2, "sixteenOverSF" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_ss_TPC_Symbols(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IndividualTimeslotInfo_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 },
  { &hf_umts_rrc_ies_modulation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modulation },
  { &hf_umts_rrc_ies_ss_TPC_Symbols, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ss_TPC_Symbols },
  { &hf_umts_rrc_ies_additionalSS_TPC_Symbols, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_15 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4, IndividualTimeslotInfo_LCR_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_maxTSLCR1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxTSLCR1, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sameAsLast1_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sameAsLast1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sameAsLast1, T_sameAsLast1_sequence);

  return offset;
}


static const per_sequence_t T_newParameters1_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4 },
  { &hf_umts_rrc_ies_dl_TS_ChannelisationCodesShort, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCodesShort },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_newParameters1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_newParameters1, T_newParameters1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_parameters1_vals[] = {
  {   0, "sameAsLast" },
  {   1, "newParameters" },
  { 0, NULL }
};

static const per_choice_t T_parameters1_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsLast1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sameAsLast1 },
  {   1, &hf_umts_rrc_ies_newParameters1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_newParameters1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_parameters1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_parameters1, T_parameters1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DownlinkAdditionalTimeslots_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_parameters1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_parameters1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DownlinkAdditionalTimeslots_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DownlinkAdditionalTimeslots_LCR_r4, DownlinkAdditionalTimeslots_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_timeslotList_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DownlinkAdditionalTimeslots_LCR_r4 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4, SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4_sequence_of,
                                                  1, maxTSLCR1);

  return offset;
}


static const value_string umts_rrc_ies_T_additionalTimeslots1_vals[] = {
  {   0, "consecutive" },
  {   1, "timeslotList" },
  { 0, NULL }
};

static const per_choice_t T_additionalTimeslots1_choice[] = {
  {   0, &hf_umts_rrc_ies_consecutive2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_maxTSLCR1 },
  {   1, &hf_umts_rrc_ies_timeslotList1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_additionalTimeslots1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_additionalTimeslots1, T_additionalTimeslots1_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_moreTimeslots1_vals[] = {
  {   0, "noMore" },
  {   1, "additionalTimeslots" },
  { 0, NULL }
};

static const per_choice_t T_moreTimeslots1_choice[] = {
  {   0, &hf_umts_rrc_ies_noMore , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_additionalTimeslots1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_additionalTimeslots1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_moreTimeslots1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_moreTimeslots1, T_moreTimeslots1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DownlinkTimeslotsCodes_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_firstIndividualTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4 },
  { &hf_umts_rrc_ies_dl_TS_ChannelisationCodesShort, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCodesShort },
  { &hf_umts_rrc_ies_moreTimeslots1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_moreTimeslots1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4, DownlinkTimeslotsCodes_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_tdd128_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd128, T_tdd128_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd384 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd384 },
  {   1, &hf_umts_rrc_ies_tdd128 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd128 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption, T_tddOption_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_CCTrCh_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_timeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeInfo },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_tddOption, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption },
  { &hf_umts_rrc_ies_ul_CCTrChTPCList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrChTPCList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_CCTrCh_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CCTrCh_r4, DL_CCTrCh_r4_sequence);

  return offset;
}


static const per_sequence_t DL_CCTrChList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_CCTrChList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_CCTrCh },
};

static int
dissect_umts_rrc_ies_DL_CCTrChList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_CCTrChList, DL_CCTrChList_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t DL_CCTrChList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_CCTrChList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_CCTrCh_r4 },
};

static int
dissect_umts_rrc_ies_DL_CCTrChList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_CCTrChList_r4, DL_CCTrChList_r4_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t DL_CCTrChListToRemove_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_CCTrChListToRemove_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_IdentityPlain },
};

static int
dissect_umts_rrc_ies_DL_CCTrChListToRemove(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_CCTrChListToRemove, DL_CCTrChListToRemove_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t DL_CCTrChTPCList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_CCTrChTPCList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_Identity },
};

static int
dissect_umts_rrc_ies_DL_CCTrChTPCList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_CCTrChTPCList, DL_CCTrChTPCList_sequence_of,
                                                  0, maxCCTrCH);

  return offset;
}


static const value_string umts_rrc_ies_SF512_AndCodeNumber_vals[] = {
  {   0, "sf4" },
  {   1, "sf8" },
  {   2, "sf16" },
  {   3, "sf32" },
  {   4, "sf64" },
  {   5, "sf128" },
  {   6, "sf256" },
  {   7, "sf512" },
  { 0, NULL }
};

static const per_choice_t SF512_AndCodeNumber_choice[] = {
  {   0, &hf_umts_rrc_ies_sf4    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_3 },
  {   1, &hf_umts_rrc_ies_sf8    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   2, &hf_umts_rrc_ies_sf16   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   3, &hf_umts_rrc_ies_sf32   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   4, &hf_umts_rrc_ies_sf64   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   5, &hf_umts_rrc_ies_sf128  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_127 },
  {   6, &hf_umts_rrc_ies_sf256  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_255 },
  {   7, &hf_umts_rrc_ies_sf512  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_511 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SF512_AndCodeNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SF512_AndCodeNumber, SF512_AndCodeNumber_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_ScramblingCodeChange_vals[] = {
  {   0, "codeChange" },
  {   1, "noCodeChange" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ScramblingCodeChange(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_ChannelisationCode_sequence[] = {
  { &hf_umts_rrc_ies_secondaryScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_sf_AndCodeNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF512_AndCodeNumber },
  { &hf_umts_rrc_ies_scramblingCodeChange, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ScramblingCodeChange },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_ChannelisationCode, DL_ChannelisationCode_sequence);

  return offset;
}


static const per_sequence_t DL_ChannelisationCodeList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_ChannelisationCodeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_ChannelisationCode },
};

static int
dissect_umts_rrc_ies_DL_ChannelisationCodeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_ChannelisationCodeList, DL_ChannelisationCodeList_sequence_of,
                                                  1, maxDPCHDLchan);

  return offset;
}


static const per_sequence_t T_initialise_sequence[] = {
  { &hf_umts_rrc_ies_cfntargetsfnframeoffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Cfntargetsfnframeoffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_initialise(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_initialise, T_initialise_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cfnHandling_vals[] = {
  {   0, "maintain" },
  {   1, "initialise" },
  { 0, NULL }
};

static const per_choice_t T_cfnHandling_choice[] = {
  {   0, &hf_umts_rrc_ies_maintain, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_initialise, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_initialise },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cfnHandling(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cfnHandling, T_cfnHandling_choice,
                                 NULL);

  return offset;
}


const value_string umts_rrc_ies_DPC_Mode_vals[] = {
  {   0, "singleTPC" },
  {   1, "tpcTripletInSoft" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_DPC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd21_sequence[] = {
  { &hf_umts_rrc_ies_dpc_Mode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPC_Mode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd21, T_fdd21_sequence);

  return offset;
}


static const per_sequence_t T_tdd20_sequence[] = {
  { &hf_umts_rrc_ies_tpc_StepSizeTDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TPC_StepSizeTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd20(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd20, T_tdd20_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo17_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo17_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd22  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd21 },
  {   1, &hf_umts_rrc_ies_tdd21  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd20 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo17, T_modeSpecificInfo17_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_DPCH_PowerControlInfo_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo17, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo17 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_PowerControlInfo, DL_DPCH_PowerControlInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_PowerOffsetPilot_pdpdch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 24U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RestrictedTrCH_sequence[] = {
  { &hf_umts_rrc_ies_dl_restrictedTrCh_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TrCH_Type },
  { &hf_umts_rrc_ies_restrictedDL_TrCH_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_allowedTFIList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AllowedTFI_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RestrictedTrCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RestrictedTrCH, RestrictedTrCH_sequence);

  return offset;
}


static const per_sequence_t RestrictedTrCH_InfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RestrictedTrCH_InfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RestrictedTrCH },
};

static int
dissect_umts_rrc_ies_RestrictedTrCH_InfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RestrictedTrCH_InfoList, RestrictedTrCH_InfoList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t Dl_rate_matching_restriction_sequence[] = {
  { &hf_umts_rrc_ies_restrictedTrCH_InfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RestrictedTrCH_InfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Dl_rate_matching_restriction(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Dl_rate_matching_restriction, Dl_rate_matching_restriction_sequence);

  return offset;
}


static const per_sequence_t T_fdd13_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { &hf_umts_rrc_ies_powerOffsetPilot_pdpdch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerOffsetPilot_pdpdch },
  { &hf_umts_rrc_ies_dl_rate_matching_restriction, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Dl_rate_matching_restriction },
  { &hf_umts_rrc_ies_spreadingFactorAndPilot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF512_AndPilot },
  { &hf_umts_rrc_ies_positionFixedOrFlexible, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionFixedOrFlexible },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd13, T_fdd13_sequence);

  return offset;
}


static const per_sequence_t T_tdd12_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12, T_tdd12_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo13_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo13_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd14  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd13 },
  {   1, &hf_umts_rrc_ies_tdd13  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo13, T_modeSpecificInfo13_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoCommon_sequence[] = {
  { &hf_umts_rrc_ies_cfnHandling, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cfnHandling },
  { &hf_umts_rrc_ies_modeSpecificInfo13, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo13 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoCommon(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoCommon, DL_DPCH_InfoCommon_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TGCFN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_activate_sequence[] = {
  { &hf_umts_rrc_ies_tgcfn  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGCFN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_activate(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_activate, T_activate_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tgps_Status_vals[] = {
  {   0, "activate" },
  {   1, "deactivate" },
  { 0, NULL }
};

static const per_choice_t T_tgps_Status_choice[] = {
  {   0, &hf_umts_rrc_ies_activate, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_activate },
  {   1, &hf_umts_rrc_ies_deactivate, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tgps_Status(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tgps_Status, T_tgps_Status_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TGMP_vals[] = {
  {   0, "tdd-Measurement" },
  {   1, "fdd-Measurement" },
  {   2, "gsm-CarrierRSSIMeasurement" },
  {   3, "gsm-initialBSICIdentification" },
  {   4, "gsmBSICReconfirmation" },
  {   5, "multi-carrier" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TGMP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     6, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_TGPRC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 511U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TGSN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 14U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TGL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 14U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TGD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              15U, 270U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TGPL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 144U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_RPP_vals[] = {
  {   0, "mode0" },
  {   1, "mode1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RPP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ITP_vals[] = {
  {   0, "mode0" },
  {   1, "mode1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ITP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_UL_CompressedModeMethod_vals[] = {
  {   0, "sf-2" },
  {   1, "higherLayerScheduling" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UL_CompressedModeMethod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_DL_CompressedModeMethod_vals[] = {
  {   0, "dummy" },
  {   1, "sf-2" },
  {   2, "higherLayerScheduling" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_CompressedModeMethod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_ul_and_dl_sequence[] = {
  { &hf_umts_rrc_ies_ul     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_CompressedModeMethod },
  { &hf_umts_rrc_ies_dl     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_CompressedModeMethod },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ul_and_dl(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ul_and_dl, T_ul_and_dl_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_DL_Mode_vals[] = {
  {   0, "ul" },
  {   1, "dl" },
  {   2, "ul-and-dl" },
  { 0, NULL }
};

static const per_choice_t UL_DL_Mode_choice[] = {
  {   0, &hf_umts_rrc_ies_ul     , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_CompressedModeMethod },
  {   1, &hf_umts_rrc_ies_dl     , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_CompressedModeMethod },
  {   2, &hf_umts_rrc_ies_ul_and_dl, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ul_and_dl },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DL_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_DL_Mode, UL_DL_Mode_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_DL_FrameType_vals[] = {
  {   0, "dl-FrameTypeA" },
  {   1, "dl-FrameTypeB" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DL_FrameType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_NidentifyAbort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 128U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TreconfirmAbort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 20U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TGPS_ConfigurationParams_sequence[] = {
  { &hf_umts_rrc_ies_tgmp   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGMP },
  { &hf_umts_rrc_ies_tgprc  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGPRC },
  { &hf_umts_rrc_ies_tgsn   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGSN },
  { &hf_umts_rrc_ies_tgl1   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGL },
  { &hf_umts_rrc_ies_tgl2   , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TGL },
  { &hf_umts_rrc_ies_tgd    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGD },
  { &hf_umts_rrc_ies_tgpl1  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGPL },
  { &hf_umts_rrc_ies_dummy_TGPL, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TGPL },
  { &hf_umts_rrc_ies_rpp    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RPP },
  { &hf_umts_rrc_ies_itp    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ITP },
  { &hf_umts_rrc_ies_ul_DL_Mode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DL_Mode },
  { &hf_umts_rrc_ies_dl_FrameType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_FrameType },
  { &hf_umts_rrc_ies_deltaSIR1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaSIR },
  { &hf_umts_rrc_ies_deltaSIRAfter1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaSIR },
  { &hf_umts_rrc_ies_deltaSIR2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaSIR },
  { &hf_umts_rrc_ies_deltaSIRAfter2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaSIR },
  { &hf_umts_rrc_ies_nidentifyAbort, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NidentifyAbort },
  { &hf_umts_rrc_ies_treconfirmAbort, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TreconfirmAbort },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TGPS_ConfigurationParams(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TGPS_ConfigurationParams, TGPS_ConfigurationParams_sequence);

  return offset;
}


static const per_sequence_t TGP_Sequence_sequence[] = {
  { &hf_umts_rrc_ies_tgpsi  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGPSI },
  { &hf_umts_rrc_ies_tgps_Status, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tgps_Status },
  { &hf_umts_rrc_ies_tgps_ConfigurationParams, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TGPS_ConfigurationParams },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TGP_Sequence(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TGP_Sequence, TGP_Sequence_sequence);

  return offset;
}


static const per_sequence_t TGP_SequenceList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TGP_SequenceList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGP_Sequence },
};

static int
dissect_umts_rrc_ies_TGP_SequenceList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TGP_SequenceList, TGP_SequenceList_sequence_of,
                                                  1, maxTGPS);

  return offset;
}


static const per_sequence_t DPCH_CompressedModeInfo_sequence[] = {
  { &hf_umts_rrc_ies_tgp_SequenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGP_SequenceList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DPCH_CompressedModeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DPCH_CompressedModeInfo, DPCH_CompressedModeInfo_sequence);

  return offset;
}


const value_string umts_rrc_ies_TX_DiversityMode_vals[] = {
  {   0, "noDiversity" },
  {   1, "sttd" },
  {   2, "closedLoopMode1" },
  {   3, "dummy" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_TX_DiversityMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_S_Field_vals[] = {
  {   0, "e1bit" },
  {   1, "e2bits" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_S_Field(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SSDT_Information_sequence[] = {
  { &hf_umts_rrc_ies_s_Field, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_Field },
  { &hf_umts_rrc_ies_codeWordSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeWordSet },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_SSDT_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SSDT_Information, SSDT_Information_sequence);

  return offset;
}


static const per_sequence_t T_fdd9_sequence[] = {
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueFDD },
  { &hf_umts_rrc_ies_dpch_CompressedModeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DPCH_CompressedModeInfo },
  { &hf_umts_rrc_ies_tx_DiversityMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TX_DiversityMode },
  { &hf_umts_rrc_ies_dummy_SSDT_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd9, T_fdd9_sequence);

  return offset;
}


static const per_sequence_t T_tdd8_sequence[] = {
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd8, T_tdd8_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo9_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo9_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd10  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd9 },
  {   1, &hf_umts_rrc_ies_tdd9   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd8 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo9, T_modeSpecificInfo9_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_CommonInformation_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_InfoCommon, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoCommon },
  { &hf_umts_rrc_ies_modeSpecificInfo9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo9 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonInformation, DL_CommonInformation_sequence);

  return offset;
}


static const per_sequence_t T_initialise1_sequence[] = {
  { &hf_umts_rrc_ies_cfntargetsfnframeoffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Cfntargetsfnframeoffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_initialise1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_initialise1, T_initialise1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cfnHandling1_vals[] = {
  {   0, "maintain" },
  {   1, "initialise" },
  { 0, NULL }
};

static const per_choice_t T_cfnHandling1_choice[] = {
  {   0, &hf_umts_rrc_ies_maintain, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_initialise1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_initialise1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cfnHandling1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cfnHandling1, T_cfnHandling1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd14_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { &hf_umts_rrc_ies_powerOffsetPilot_pdpdch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerOffsetPilot_pdpdch },
  { &hf_umts_rrc_ies_dl_rate_matching_restriction, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Dl_rate_matching_restriction },
  { &hf_umts_rrc_ies_spreadingFactorAndPilot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF512_AndPilot },
  { &hf_umts_rrc_ies_positionFixedOrFlexible, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionFixedOrFlexible },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd14, T_fdd14_sequence);

  return offset;
}


static const per_sequence_t T_tdd13_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd13, T_tdd13_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo14_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo14_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd15  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd14 },
  {   1, &hf_umts_rrc_ies_tdd14  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd13 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo14, T_modeSpecificInfo14_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoCommon_r4_sequence[] = {
  { &hf_umts_rrc_ies_cfnHandling1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cfnHandling1 },
  { &hf_umts_rrc_ies_modeSpecificInfo14, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo14 },
  { &hf_umts_rrc_ies_mac_d_HFN_initial_value, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MAC_d_HFN_initial_value },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoCommon_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoCommon_r4, DL_DPCH_InfoCommon_r4_sequence);

  return offset;
}


const value_string umts_rrc_ies_SSDT_UL_vals[] = {
  {   0, "ul" },
  {   1, "ul-AndDL" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_SSDT_UL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SSDT_Information_r4_sequence[] = {
  { &hf_umts_rrc_ies_s_Field, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_S_Field },
  { &hf_umts_rrc_ies_codeWordSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeWordSet },
  { &hf_umts_rrc_ies_ssdt_UL_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_UL },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_SSDT_Information_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SSDT_Information_r4, SSDT_Information_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd10_sequence[] = {
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueFDD },
  { &hf_umts_rrc_ies_dpch_CompressedModeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DPCH_CompressedModeInfo },
  { &hf_umts_rrc_ies_tx_DiversityMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TX_DiversityMode },
  { &hf_umts_rrc_ies_dummy_SSDT_Information_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_Information_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd10, T_fdd10_sequence);

  return offset;
}


static const per_sequence_t T_tdd1281_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1281(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1281, T_tdd1281_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption1_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption1_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3841, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd1281, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1281 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption1, T_tddOption1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd9_sequence[] = {
  { &hf_umts_rrc_ies_tddOption1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption1 },
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd9, T_tdd9_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo10_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo10_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd11  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd10 },
  {   1, &hf_umts_rrc_ies_tdd10  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd9 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo10, T_modeSpecificInfo10_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_CommonInformation_r4_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_InfoCommon1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoCommon_r4 },
  { &hf_umts_rrc_ies_modeSpecificInfo10, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo10 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonInformation_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonInformation_r4, DL_CommonInformation_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd11_sequence[] = {
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueFDD },
  { &hf_umts_rrc_ies_dpch_CompressedModeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DPCH_CompressedModeInfo },
  { &hf_umts_rrc_ies_tx_DiversityMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TX_DiversityMode },
  { &hf_umts_rrc_ies_dummy_SSDT_Information_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_Information_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd11, T_fdd11_sequence);

  return offset;
}


static const per_sequence_t T_tdd1282_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1282(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1282, T_tdd1282_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption2_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption2_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3841, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd1282, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1282 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption2, T_tddOption2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd10_sequence[] = {
  { &hf_umts_rrc_ies_tddOption2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption2 },
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd10, T_tdd10_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo11_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo11_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd12  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd11 },
  {   1, &hf_umts_rrc_ies_tdd11  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd10 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo11, T_modeSpecificInfo11_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_mac_hsResetIndicator1_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_mac_hsResetIndicator1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_CommonInformation_r5_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_InfoCommon1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoCommon_r4 },
  { &hf_umts_rrc_ies_modeSpecificInfo11, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo11 },
  { &hf_umts_rrc_ies_mac_hsResetIndicator1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_mac_hsResetIndicator1 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonInformation_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonInformation_r5, DL_CommonInformation_r5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TimingMaintainedSynchInd_vals[] = {
  {   0, "false" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimingMaintainedSynchInd(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_maintain_sequence[] = {
  { &hf_umts_rrc_ies_timingmaintainedsynchind, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimingMaintainedSynchInd },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_maintain(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_maintain, T_maintain_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cfnHandling2_vals[] = {
  {   0, "maintain" },
  {   1, "initialise" },
  { 0, NULL }
};

static const per_choice_t T_cfnHandling2_choice[] = {
  {   0, &hf_umts_rrc_ies_maintain1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_maintain },
  {   1, &hf_umts_rrc_ies_initialise2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cfnHandling2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cfnHandling2, T_cfnHandling2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd15_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { &hf_umts_rrc_ies_powerOffsetPilot_pdpdch, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerOffsetPilot_pdpdch },
  { &hf_umts_rrc_ies_dl_rate_matching_restriction, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Dl_rate_matching_restriction },
  { &hf_umts_rrc_ies_spreadingFactorAndPilot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF512_AndPilot },
  { &hf_umts_rrc_ies_positionFixedOrFlexible, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionFixedOrFlexible },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd15, T_fdd15_sequence);

  return offset;
}


static const per_sequence_t T_tdd14_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd14, T_tdd14_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo15_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo15_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd16  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd15 },
  {   1, &hf_umts_rrc_ies_tdd15  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd14 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo15, T_modeSpecificInfo15_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoCommon_r6_sequence[] = {
  { &hf_umts_rrc_ies_cfnHandling2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cfnHandling2 },
  { &hf_umts_rrc_ies_modeSpecificInfo15, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo15 },
  { &hf_umts_rrc_ies_mac_d_HFN_initial_value, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MAC_d_HFN_initial_value },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoCommon_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoCommon_r6, DL_DPCH_InfoCommon_r6_sequence);

  return offset;
}


static const per_sequence_t T_maintain1_sequence[] = {
  { &hf_umts_rrc_ies_timingmaintainedsynchind, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimingMaintainedSynchInd },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_maintain1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_maintain1, T_maintain1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cfnHandling3_vals[] = {
  {   0, "maintain" },
  {   1, "initialise" },
  { 0, NULL }
};

static const per_choice_t T_cfnHandling3_choice[] = {
  {   0, &hf_umts_rrc_ies_maintain2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_maintain1 },
  {   1, &hf_umts_rrc_ies_initialise2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cfnHandling3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cfnHandling3, T_cfnHandling3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_FDPCH_InfoCommon_r6_sequence[] = {
  { &hf_umts_rrc_ies_cfnHandling3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cfnHandling3 },
  { &hf_umts_rrc_ies_dl_FDPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { &hf_umts_rrc_ies_dl_FDPCH_TPCcommandErrorRate, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_FDPCH_InfoCommon_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_FDPCH_InfoCommon_r6, DL_FDPCH_InfoCommon_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_dl_dpchInfoCommon_vals[] = {
  {   0, "dl-DPCH-InfoCommon" },
  {   1, "dl-FDPCH-InfoCommon" },
  { 0, NULL }
};

static const per_choice_t T_dl_dpchInfoCommon_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_DPCH_InfoCommon2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_DPCH_InfoCommon_r6 },
  {   1, &hf_umts_rrc_ies_dl_FDPCH_InfoCommon, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_FDPCH_InfoCommon_r6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dl_dpchInfoCommon(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_dl_dpchInfoCommon, T_dl_dpchInfoCommon_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd12_sequence[] = {
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueFDD },
  { &hf_umts_rrc_ies_dpch_CompressedModeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DPCH_CompressedModeInfo },
  { &hf_umts_rrc_ies_tx_DiversityMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TX_DiversityMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd12, T_fdd12_sequence);

  return offset;
}


static const per_sequence_t T_tdd1283_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1283(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1283, T_tdd1283_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption3_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption3_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3841, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd1283, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1283 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption3, T_tddOption3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd11_sequence[] = {
  { &hf_umts_rrc_ies_tddOption3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption3 },
  { &hf_umts_rrc_ies_defaultDPCH_OffsetValue1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DefaultDPCH_OffsetValueTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd11, T_tdd11_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo12_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo12_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd13  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd12 },
  {   1, &hf_umts_rrc_ies_tdd12  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd11 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo12, T_modeSpecificInfo12_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_mac_hsResetIndicator2_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_mac_hsResetIndicator2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_postVerificationPeriod_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_postVerificationPeriod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t DL_CommonInformation_r6_sequence[] = {
  { &hf_umts_rrc_ies_dl_dpchInfoCommon, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_dl_dpchInfoCommon },
  { &hf_umts_rrc_ies_modeSpecificInfo12, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo12 },
  { &hf_umts_rrc_ies_mac_hsResetIndicator2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_mac_hsResetIndicator2 },
  { &hf_umts_rrc_ies_postVerificationPeriod, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_postVerificationPeriod },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonInformation_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonInformation_r6, DL_CommonInformation_r6_sequence);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoCommonPost_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_PowerControlInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoCommonPost(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoCommonPost, DL_DPCH_InfoCommonPost_sequence);

  return offset;
}


static const per_sequence_t DL_CommonInformationPost_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_InfoCommon3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_DPCH_InfoCommonPost },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_CommonInformationPost(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_CommonInformationPost, DL_CommonInformationPost_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PCPICH_UsageForChannelEst_vals[] = {
  {   0, "mayBeUsed" },
  {   1, "shallNotBeUsed" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PCPICH_UsageForChannelEst(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_DPCH_FrameOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 149U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SecondaryCPICH_Info_sequence[] = {
  { &hf_umts_rrc_ies_secondaryDL_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_channelisationCode6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelisationCode256 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SecondaryCPICH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SecondaryCPICH_Info, SecondaryCPICH_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TPC_CombinationIndex(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 5U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_SSDT_CellIdentity_vals[] = {
  {   0, "ssdt-id-a" },
  {   1, "ssdt-id-b" },
  {   2, "ssdt-id-c" },
  {   3, "ssdt-id-d" },
  {   4, "ssdt-id-e" },
  {   5, "ssdt-id-f" },
  {   6, "ssdt-id-g" },
  {   7, "ssdt-id-h" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SSDT_CellIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd17_sequence[] = {
  { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_dpch_FrameOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCH_FrameOffset },
  { &hf_umts_rrc_ies_secondaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_ChannelisationCodeList },
  { &hf_umts_rrc_ies_tpc_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_CombinationIndex },
  { &hf_umts_rrc_ies_dummy_SSDT_CellIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_CellIdentity },
  { &hf_umts_rrc_ies_closedLoopTimingAdjMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ClosedLoopTimingAdjMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd17, T_fdd17_sequence);

  return offset;
}


static const per_sequence_t T_tdd16_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrChListToEstablish, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChList },
  { &hf_umts_rrc_ies_dl_CCTrChListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd16, T_tdd16_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_DPCH_InfoPerRL_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t DL_DPCH_InfoPerRL_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd18  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd17 },
  {   1, &hf_umts_rrc_ies_tdd17  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd16 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_DPCH_InfoPerRL, DL_DPCH_InfoPerRL_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd18_sequence[] = {
  { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_dpch_FrameOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCH_FrameOffset },
  { &hf_umts_rrc_ies_secondaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_ChannelisationCodeList },
  { &hf_umts_rrc_ies_tpc_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_CombinationIndex },
  { &hf_umts_rrc_ies_dummy_SSDT_CellIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_CellIdentity },
  { &hf_umts_rrc_ies_closedLoopTimingAdjMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ClosedLoopTimingAdjMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd18(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd18, T_fdd18_sequence);

  return offset;
}


static const per_sequence_t T_tdd17_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrChListToEstablish1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChList_r4 },
  { &hf_umts_rrc_ies_dl_CCTrChListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd17, T_tdd17_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_DPCH_InfoPerRL_r4_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t DL_DPCH_InfoPerRL_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd19  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd18 },
  {   1, &hf_umts_rrc_ies_tdd18  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd17 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r4, DL_DPCH_InfoPerRL_r4_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_PowerOffsetTPC_pdpdch(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 24U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd19_sequence[] = {
  { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_dpch_FrameOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCH_FrameOffset },
  { &hf_umts_rrc_ies_secondaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_ChannelisationCodeList },
  { &hf_umts_rrc_ies_tpc_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_CombinationIndex },
  { &hf_umts_rrc_ies_powerOffsetTPC_pdpdch, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetTPC_pdpdch },
  { &hf_umts_rrc_ies_dummy_SSDT_CellIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SSDT_CellIdentity },
  { &hf_umts_rrc_ies_closedLoopTimingAdjMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ClosedLoopTimingAdjMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd19(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd19, T_fdd19_sequence);

  return offset;
}


static const per_sequence_t T_tdd18_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrChListToEstablish1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChList_r4 },
  { &hf_umts_rrc_ies_dl_CCTrChListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd18(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd18, T_tdd18_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_DPCH_InfoPerRL_r5_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t DL_DPCH_InfoPerRL_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd20  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd19 },
  {   1, &hf_umts_rrc_ies_tdd19  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd18 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r5, DL_DPCH_InfoPerRL_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd20_sequence[] = {
  { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_dpch_FrameOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCH_FrameOffset },
  { &hf_umts_rrc_ies_secondaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_ChannelisationCodeList },
  { &hf_umts_rrc_ies_tpc_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_CombinationIndex },
  { &hf_umts_rrc_ies_powerOffsetTPC_pdpdch, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetTPC_pdpdch },
  { &hf_umts_rrc_ies_closedLoopTimingAdjMode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ClosedLoopTimingAdjMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd20(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd20, T_fdd20_sequence);

  return offset;
}


static const per_sequence_t T_tdd19_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrChListToEstablish1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChList_r4 },
  { &hf_umts_rrc_ies_dl_CCTrChListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_CCTrChListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd19(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd19, T_tdd19_sequence);

  return offset;
}


static const value_string umts_rrc_ies_DL_DPCH_InfoPerRL_r6_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t DL_DPCH_InfoPerRL_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd21  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd20 },
  {   1, &hf_umts_rrc_ies_tdd20  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd19 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r6, DL_DPCH_InfoPerRL_r6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_FDPCH_InfoPerRL_r6_sequence[] = {
  { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_fdpch_FrameOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCH_FrameOffset },
  { &hf_umts_rrc_ies_secondaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryCPICH_Info },
  { &hf_umts_rrc_ies_secondaryScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_dl_ChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_tpc_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_CombinationIndex },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_FDPCH_InfoPerRL_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_FDPCH_InfoPerRL_r6, DL_FDPCH_InfoPerRL_r6_sequence);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoPerRL_PostFDD_sequence[] = {
  { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_dl_ChannelisationCode1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_ChannelisationCode },
  { &hf_umts_rrc_ies_tpc_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_CombinationIndex },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_PostFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostFDD, DL_DPCH_InfoPerRL_PostFDD_sequence);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoPerRL_PostTDD_sequence[] = {
  { &hf_umts_rrc_ies_dl_DPCH_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DownlinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD, DL_DPCH_InfoPerRL_PostTDD_sequence);

  return offset;
}


static const per_sequence_t DL_DPCH_InfoPerRL_PostTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD_LCR_r4, DL_DPCH_InfoPerRL_PostTDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd28_sequence[] = {
  { &hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes },
  { &hf_umts_rrc_ies_dl_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd28(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd28, T_fdd28_sequence);

  return offset;
}


static const per_sequence_t T_tdd3844_sequence[] = {
  { &hf_umts_rrc_ies_nack_ack_power_offset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M7_8 },
  { &hf_umts_rrc_ies_hs_SICH_PowerControl_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HS_SICH_Power_Control_Info_TDD384 },
  { &hf_umts_rrc_ies_dhs_sync, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DHS_Sync },
  { &hf_umts_rrc_ies_hS_SCCH_SetConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3844(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3844, T_tdd3844_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd24_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tdd24_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3845, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3844 },
  {   1, &hf_umts_rrc_ies_tdd1286, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd24(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd24, T_tdd24_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo27_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo27_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd30  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd28 },
  {   1, &hf_umts_rrc_ies_tdd28  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd24 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo27(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo27, T_modeSpecificInfo27_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HS_SCCH_Info_r6_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo27, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo27 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HS_SCCH_Info_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HS_SCCH_Info_r6, HS_SCCH_Info_r6_sequence);

  return offset;
}


static const per_sequence_t T_tdd3842_sequence[] = {
  { &hf_umts_rrc_ies_dl_HSPDSCH_TS_Configuration, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_HSPDSCH_TS_Configuration },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3842(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3842, T_tdd3842_sequence);

  return offset;
}


static const per_sequence_t T_tdd1285_sequence[] = {
  { &hf_umts_rrc_ies_hs_PDSCH_Midamble_Configuration_tdd128, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HS_PDSCH_Midamble_Configuration_TDD128 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1285(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1285, T_tdd1285_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tdd22_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tdd22_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3843, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3842 },
  {   1, &hf_umts_rrc_ies_tdd1285, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1285 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd22(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tdd22, T_tdd22_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo19_vals[] = {
  {   0, "tdd" },
  {   1, "fdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo19_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd23  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd22 },
  {   1, &hf_umts_rrc_ies_fdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo19(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo19, T_modeSpecificInfo19_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_HSPDSCH_Information_r6_sequence[] = {
  { &hf_umts_rrc_ies_hs_scch_Info1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HS_SCCH_Info_r6 },
  { &hf_umts_rrc_ies_measurement_feedback_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Measurement_Feedback_Info },
  { &hf_umts_rrc_ies_modeSpecificInfo19, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo19 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_HSPDSCH_Information_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_HSPDSCH_Information_r6, DL_HSPDSCH_Information_r6_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_DSCH_RadioLinkIdentifier(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 511U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RL_IdentifierList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RL_IdentifierList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
};

static int
dissect_umts_rrc_ies_RL_IdentifierList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RL_IdentifierList, RL_IdentifierList_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t PDSCH_SHO_DCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_dsch_RadioLinkIdentifier, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DSCH_RadioLinkIdentifier },
  { &hf_umts_rrc_ies_rl_IdentifierList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RL_IdentifierList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SHO_DCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SHO_DCH_Info, PDSCH_SHO_DCH_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxTFCI_Field2Value(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 1023U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DSCH_Mapping_sequence[] = {
  { &hf_umts_rrc_ies_maxTFCI_Field2Value, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTFCI_Field2Value },
  { &hf_umts_rrc_ies_spreadingFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF_PDSCH },
  { &hf_umts_rrc_ies_codeNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeNumberDSCH },
  { &hf_umts_rrc_ies_multiCodeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiCodeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DSCH_Mapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DSCH_Mapping, DSCH_Mapping_sequence);

  return offset;
}


static const per_sequence_t DSCH_MappingList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DSCH_MappingList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DSCH_Mapping },
};

static int
dissect_umts_rrc_ies_DSCH_MappingList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DSCH_MappingList, DSCH_MappingList_sequence_of,
                                                  1, maxPDSCHTFCIgroups);

  return offset;
}


static const per_sequence_t PDSCH_CodeInfo_sequence[] = {
  { &hf_umts_rrc_ies_spreadingFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF_PDSCH },
  { &hf_umts_rrc_ies_codeNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeNumberDSCH },
  { &hf_umts_rrc_ies_multiCodeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiCodeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_CodeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_CodeInfo, PDSCH_CodeInfo_sequence);

  return offset;
}


static const per_sequence_t PDSCH_CodeInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_CodeInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_CodeInfo },
};

static int
dissect_umts_rrc_ies_PDSCH_CodeInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_CodeInfoList, PDSCH_CodeInfoList_sequence_of,
                                                  1, maxTFCI2Combs);

  return offset;
}


static const per_sequence_t ReplacedPDSCH_CodeInfo_sequence[] = {
  { &hf_umts_rrc_ies_tfci_Field2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxTFCI_Field2Value },
  { &hf_umts_rrc_ies_spreadingFactor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF_PDSCH },
  { &hf_umts_rrc_ies_codeNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodeNumberDSCH },
  { &hf_umts_rrc_ies_multiCodeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultiCodeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReplacedPDSCH_CodeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ReplacedPDSCH_CodeInfo, ReplacedPDSCH_CodeInfo_sequence);

  return offset;
}


static const per_sequence_t ReplacedPDSCH_CodeInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_ReplacedPDSCH_CodeInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReplacedPDSCH_CodeInfo },
};

static int
dissect_umts_rrc_ies_ReplacedPDSCH_CodeInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ReplacedPDSCH_CodeInfoList, ReplacedPDSCH_CodeInfoList_sequence_of,
                                                  1, maxTFCI2Combs);

  return offset;
}


static const value_string umts_rrc_ies_T_signallingMethod_vals[] = {
  {   0, "codeRange" },
  {   1, "tfci-Range" },
  {   2, "explicit-config" },
  {   3, "replace" },
  { 0, NULL }
};

static const per_choice_t T_signallingMethod_choice[] = {
  {   0, &hf_umts_rrc_ies_codeRange, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CodeRange },
  {   1, &hf_umts_rrc_ies_tfci_Range1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DSCH_MappingList },
  {   2, &hf_umts_rrc_ies_explicit_config3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PDSCH_CodeInfoList },
  {   3, &hf_umts_rrc_ies_replace, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReplacedPDSCH_CodeInfoList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_signallingMethod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_signallingMethod, T_signallingMethod_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PDSCH_CodeMapping_sequence[] = {
  { &hf_umts_rrc_ies_dl_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_signallingMethod, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_signallingMethod },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_CodeMapping(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_CodeMapping, PDSCH_CodeMapping_sequence);

  return offset;
}


static const per_sequence_t T_fdd22_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SHO_DCH_Info },
  { &hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_CodeMapping },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd22(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd22, T_fdd22_sequence);

  return offset;
}


static const per_sequence_t T_fdd33_sequence[] = {
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd33(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd33, T_fdd33_sequence);

  return offset;
}


static const per_sequence_t T_syncCase1_sequence[] = {
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_syncCase1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_syncCase1, T_syncCase1_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeslotSync2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 6U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_syncCase2_sequence[] = {
  { &hf_umts_rrc_ies_timeslotSync2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotSync2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_syncCase2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_syncCase2, T_syncCase2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SyncCase_vals[] = {
  {   0, "syncCase1" },
  {   1, "syncCase2" },
  { 0, NULL }
};

static const per_choice_t SyncCase_choice[] = {
  {   0, &hf_umts_rrc_ies_syncCase1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_syncCase1 },
  {   1, &hf_umts_rrc_ies_syncCase2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_syncCase2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SyncCase(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SyncCase, SyncCase_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd27_sequence[] = {
  { &hf_umts_rrc_ies_syncCase, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SyncCase },
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_sctd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd27(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd27, T_tdd27_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PrimaryCCPCH_Info_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t PrimaryCCPCH_Info_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd36  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd33 },
  {   1, &hf_umts_rrc_ies_tdd32  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd27 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PrimaryCCPCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PrimaryCCPCH_Info, PrimaryCCPCH_Info_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo20_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo20_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd23  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd22 },
  {   1, &hf_umts_rrc_ies_tdd24  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo20(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo20, T_modeSpecificInfo20_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_SF256_AndCodeNumber_vals[] = {
  {   0, "sf4" },
  {   1, "sf8" },
  {   2, "sf16" },
  {   3, "sf32" },
  {   4, "sf64" },
  {   5, "sf128" },
  {   6, "sf256" },
  { 0, NULL }
};

static const per_choice_t SF256_AndCodeNumber_choice[] = {
  {   0, &hf_umts_rrc_ies_sf4    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_3 },
  {   1, &hf_umts_rrc_ies_sf8    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   2, &hf_umts_rrc_ies_sf16   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   3, &hf_umts_rrc_ies_sf32   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   4, &hf_umts_rrc_ies_sf64   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   5, &hf_umts_rrc_ies_sf128  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_127 },
  {   6, &hf_umts_rrc_ies_sf256  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_255 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SF256_AndCodeNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SF256_AndCodeNumber, SF256_AndCodeNumber_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_TimingOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 149U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd37_sequence[] = {
  { &hf_umts_rrc_ies_dummy1_PCPICH_UsageForChannelEst, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PCPICH_UsageForChannelEst },
  { &hf_umts_rrc_ies_dummy2_SecondaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryCPICH_Info },
  { &hf_umts_rrc_ies_secondaryScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_sttd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_sf_AndCodeNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF256_AndCodeNumber },
  { &hf_umts_rrc_ies_pilotSymbolExistence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_positionFixedOrFlexible, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionFixedOrFlexible },
  { &hf_umts_rrc_ies_timingOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimingOffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd37(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd37, T_fdd37_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SCCPCH_ChannelisationCode_vals[] = {
  {   0, "cc16-1" },
  {   1, "cc16-2" },
  {   2, "cc16-3" },
  {   3, "cc16-4" },
  {   4, "cc16-5" },
  {   5, "cc16-6" },
  {   6, "cc16-7" },
  {   7, "cc16-8" },
  {   8, "cc16-9" },
  {   9, "cc16-10" },
  {  10, "cc16-11" },
  {  11, "cc16-12" },
  {  12, "cc16-13" },
  {  13, "cc16-14" },
  {  14, "cc16-15" },
  {  15, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SCCPCH_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SCCPCH_ChannelisationCodeList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SCCPCH_ChannelisationCodeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_ChannelisationCode },
};

static int
dissect_umts_rrc_ies_SCCPCH_ChannelisationCodeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SCCPCH_ChannelisationCodeList, SCCPCH_ChannelisationCodeList_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t T_tdd30_sequence[] = {
  { &hf_umts_rrc_ies_commonTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CommonTimeslotInfoSCCPCH },
  { &hf_umts_rrc_ies_individualTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo },
  { &hf_umts_rrc_ies_channelisationCode5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_ChannelisationCodeList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd30(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd30, T_tdd30_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo33_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo33_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd40  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd37 },
  {   1, &hf_umts_rrc_ies_tdd35  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd30 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo33(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo33, T_modeSpecificInfo33_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SecondaryCCPCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo33, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo33 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SecondaryCCPCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SecondaryCCPCH_Info, SecondaryCCPCH_Info_sequence);

  return offset;
}


static const per_sequence_t FACH_PCH_Information_sequence[] = {
  { &hf_umts_rrc_ies_transportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_ctch_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_FACH_PCH_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FACH_PCH_Information, FACH_PCH_Information_sequence);

  return offset;
}


static const per_sequence_t FACH_PCH_InformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_FACH_PCH_InformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FACH_PCH_Information },
};

static int
dissect_umts_rrc_ies_FACH_PCH_InformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_FACH_PCH_InformationList, FACH_PCH_InformationList_sequence_of,
                                                  1, maxFACHPCH);

  return offset;
}



static int
dissect_umts_rrc_ies_PLMN_ValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 256U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_CellValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 4U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PredefinedConfigIdentityAndValueTag_sequence[] = {
  { &hf_umts_rrc_ies_predefinedConfigIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigIdentity },
  { &hf_umts_rrc_ies_predefinedConfigValueTag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PredefinedConfigValueTag },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PredefinedConfigIdentityAndValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PredefinedConfigIdentityAndValueTag, PredefinedConfigIdentityAndValueTag_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_SIBOccurIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_SIBOccurValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SIBOccurrenceIdentityAndValueTag_sequence[] = {
  { &hf_umts_rrc_ies_sibOccurIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIBOccurIdentity },
  { &hf_umts_rrc_ies_sibOccurValueTag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIBOccurValueTag },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag, SIBOccurrenceIdentityAndValueTag_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SIB_TypeAndTag_vals[] = {
  {   0, "sysInfoType1" },
  {   1, "sysInfoType2" },
  {   2, "sysInfoType3" },
  {   3, "sysInfoType4" },
  {   4, "sysInfoType5" },
  {   5, "sysInfoType6" },
  {   6, "sysInfoType7" },
  {   7, "dummy-CellValueTag" },
  {   8, "dummy2-NULL" },
  {   9, "dummy3-NULL" },
  {  10, "sysInfoType11" },
  {  11, "sysInfoType12" },
  {  12, "sysInfoType13" },
  {  13, "sysInfoType13-1" },
  {  14, "sysInfoType13-2" },
  {  15, "sysInfoType13-3" },
  {  16, "sysInfoType13-4" },
  {  17, "sysInfoType14" },
  {  18, "sysInfoType15" },
  {  19, "sysInfoType16" },
  {  20, "sysInfoType17" },
  {  21, "sysInfoType15-1" },
  {  22, "sysInfoType15-2" },
  {  23, "sysInfoType15-3" },
  {  24, "sysInfoType15-4" },
  {  25, "sysInfoType18" },
  {  26, "sysInfoType15-5" },
  {  27, "sysInfoType5bis" },
  {  28, "spare4" },
  {  29, "spare3" },
  {  30, "spare2" },
  {  31, "spare1" },
  { 0, NULL }
};

static const per_choice_t SIB_TypeAndTag_choice[] = {
  {   0, &hf_umts_rrc_ies_sysInfoType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PLMN_ValueTag },
  {   1, &hf_umts_rrc_ies_sysInfoType2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   2, &hf_umts_rrc_ies_sysInfoType3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   3, &hf_umts_rrc_ies_sysInfoType4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   4, &hf_umts_rrc_ies_sysInfoType5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   5, &hf_umts_rrc_ies_sysInfoType6, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   6, &hf_umts_rrc_ies_sysInfoType7, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_dummy_CellValueTag, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   8, &hf_umts_rrc_ies_dummy2_NULL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   9, &hf_umts_rrc_ies_dummy3_NULL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  10, &hf_umts_rrc_ies_sysInfoType11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  11, &hf_umts_rrc_ies_sysInfoType12, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  12, &hf_umts_rrc_ies_sysInfoType13, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  13, &hf_umts_rrc_ies_sysInfoType13_1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  14, &hf_umts_rrc_ies_sysInfoType13_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  15, &hf_umts_rrc_ies_sysInfoType13_3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  16, &hf_umts_rrc_ies_sysInfoType13_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  17, &hf_umts_rrc_ies_sysInfoType14, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  18, &hf_umts_rrc_ies_sysInfoType15, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  19, &hf_umts_rrc_ies_sysInfoType16, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PredefinedConfigIdentityAndValueTag },
  {  20, &hf_umts_rrc_ies_sysInfoType17, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  21, &hf_umts_rrc_ies_sysInfoType15_1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  22, &hf_umts_rrc_ies_sysInfoType15_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag },
  {  23, &hf_umts_rrc_ies_sysInfoType15_3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag },
  {  24, &hf_umts_rrc_ies_sysInfoType15_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  25, &hf_umts_rrc_ies_sysInfoType18, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  26, &hf_umts_rrc_ies_sysInfoType15_5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  27, &hf_umts_rrc_ies_sysInfoType5bis, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  28, &hf_umts_rrc_ies_spare4 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  29, &hf_umts_rrc_ies_spare3 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  30, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  31, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SIB_TypeAndTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SIB_TypeAndTag, SIB_TypeAndTag_choice,
                                 NULL);

  return offset;
}



int
dissect_umts_rrc_ies_SegCount(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 16U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_2047(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 2047U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_sib_Pos_vals[] = {
  {   0, "rep4" },
  {   1, "rep8" },
  {   2, "rep16" },
  {   3, "rep32" },
  {   4, "rep64" },
  {   5, "rep128" },
  {   6, "rep256" },
  {   7, "rep512" },
  {   8, "rep1024" },
  {   9, "rep2048" },
  {  10, "rep4096" },
  { 0, NULL }
};

static const per_choice_t T_sib_Pos_choice[] = {
  {   0, &hf_umts_rrc_ies_rep4   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_1 },
  {   1, &hf_umts_rrc_ies_rep8   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_3 },
  {   2, &hf_umts_rrc_ies_rep16  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   3, &hf_umts_rrc_ies_rep32  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   4, &hf_umts_rrc_ies_rep64  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   5, &hf_umts_rrc_ies_rep128 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   6, &hf_umts_rrc_ies_rep256 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_127 },
  {   7, &hf_umts_rrc_ies_rep512 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_255 },
  {   8, &hf_umts_rrc_ies_rep1024, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_511 },
  {   9, &hf_umts_rrc_ies_rep2048, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_1023 },
  {  10, &hf_umts_rrc_ies_rep4096, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_2047 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sib_Pos(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_sib_Pos, T_sib_Pos_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_SibOFF_vals[] = {
  {   0, "so2" },
  {   1, "so4" },
  {   2, "so6" },
  {   3, "so8" },
  {   4, "so10" },
  {   5, "so12" },
  {   6, "so14" },
  {   7, "so16" },
  {   8, "so18" },
  {   9, "so20" },
  {  10, "so22" },
  {  11, "so24" },
  {  12, "so26" },
  {  13, "so28" },
  {  14, "so30" },
  {  15, "so32" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SibOFF(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SibOFF_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_SibOFF_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SibOFF },
};

static int
dissect_umts_rrc_ies_SibOFF_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SibOFF_List, SibOFF_List_sequence_of,
                                                  1, 15);

  return offset;
}


static const per_sequence_t T_scheduling_sequence[] = {
  { &hf_umts_rrc_ies_segCount, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SegCount },
  { &hf_umts_rrc_ies_sib_Pos, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_sib_Pos },
  { &hf_umts_rrc_ies_sib_PosOffsetInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SibOFF_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_scheduling(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_scheduling, T_scheduling_sequence);

  return offset;
}


static const per_sequence_t SchedulingInformation_sequence[] = {
  { &hf_umts_rrc_ies_scheduling, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_scheduling },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SchedulingInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SchedulingInformation, SchedulingInformation_sequence);

  return offset;
}


static const per_sequence_t SchedulingInformationSIB_sequence[] = {
  { &hf_umts_rrc_ies_sib_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIB_TypeAndTag },
  { &hf_umts_rrc_ies_scheduling1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SchedulingInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SchedulingInformationSIB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SchedulingInformationSIB, SchedulingInformationSIB_sequence);

  return offset;
}


static const per_sequence_t SIB_ReferenceListFACH_sequence_of[1] = {
  { &hf_umts_rrc_ies_SIB_ReferenceListFACH_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SchedulingInformationSIB },
};

static int
dissect_umts_rrc_ies_SIB_ReferenceListFACH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SIB_ReferenceListFACH, SIB_ReferenceListFACH_sequence_of,
                                                  1, maxSIBFACH);

  return offset;
}


static const per_sequence_t T_fdd35_sequence[] = {
  { &hf_umts_rrc_ies_fach_PCH_InformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FACH_PCH_InformationList },
  { &hf_umts_rrc_ies_sib_ReferenceListFACH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIB_ReferenceListFACH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd35(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd35, T_fdd35_sequence);

  return offset;
}


static const per_sequence_t T_tdd29_sequence[] = {
  { &hf_umts_rrc_ies_fach_PCH_InformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FACH_PCH_InformationList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd29(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd29, T_tdd29_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo31_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo31_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd38  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd35 },
  {   1, &hf_umts_rrc_ies_tdd34  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd29 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo31, T_modeSpecificInfo31_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SCCPCH_InfoForFACH_sequence[] = {
  { &hf_umts_rrc_ies_secondaryCCPCH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondaryCCPCH_Info },
  { &hf_umts_rrc_ies_tfcs   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_modeSpecificInfo31, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo31 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SCCPCH_InfoForFACH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SCCPCH_InfoForFACH, SCCPCH_InfoForFACH_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo20, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo20 },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoPerRL },
  { &hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_InfoForFACH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_InformationPerRL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL, DL_InformationPerRL_sequence);

  return offset;
}


static const per_sequence_t T_fdd23_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SHO_DCH_Info },
  { &hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_CodeMapping },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd23(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd23, T_fdd23_sequence);

  return offset;
}


static const per_sequence_t T_fdd34_sequence[] = {
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd34(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd34, T_fdd34_sequence);

  return offset;
}


static const per_sequence_t T_tdd3846_sequence[] = {
  { &hf_umts_rrc_ies_syncCase, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SyncCase },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3846(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3846, T_tdd3846_sequence);

  return offset;
}


static const per_sequence_t T_tdd1287_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1287(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1287, T_tdd1287_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption5_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption5_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3847, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3846 },
  {   1, &hf_umts_rrc_ies_tdd1288, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1287 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption5, T_tddOption5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd28_sequence[] = {
  { &hf_umts_rrc_ies_tddOption5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption5 },
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_sctd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd28(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd28, T_tdd28_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PrimaryCCPCH_Info_r4_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t PrimaryCCPCH_Info_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd37  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd34 },
  {   1, &hf_umts_rrc_ies_tdd33  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd28 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PrimaryCCPCH_Info_r4, PrimaryCCPCH_Info_r4_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo21_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo21_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd24  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd23 },
  {   1, &hf_umts_rrc_ies_tdd25  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo21, T_modeSpecificInfo21_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd38_sequence[] = {
  { &hf_umts_rrc_ies_secondaryScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_sttd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_sf_AndCodeNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF256_AndCodeNumber },
  { &hf_umts_rrc_ies_pilotSymbolExistence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_positionFixedOrFlexible, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionFixedOrFlexible },
  { &hf_umts_rrc_ies_timingOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimingOffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd38(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd38, T_fdd38_sequence);

  return offset;
}


static const per_sequence_t T_tdd3848_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3848(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3848, T_tdd3848_sequence);

  return offset;
}


static const per_sequence_t T_tdd12810_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12810(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12810, T_tdd12810_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption8_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption8_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3849, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3848 },
  {   1, &hf_umts_rrc_ies_tdd12811, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12810 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption8, T_tddOption8_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd31_sequence[] = {
  { &hf_umts_rrc_ies_commonTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CommonTimeslotInfoSCCPCH },
  { &hf_umts_rrc_ies_tddOption8, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption8 },
  { &hf_umts_rrc_ies_channelisationCode5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_ChannelisationCodeList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd31, T_tdd31_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo34_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo34_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd41  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd38 },
  {   1, &hf_umts_rrc_ies_tdd36  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd31 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo34(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo34, T_modeSpecificInfo34_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SecondaryCCPCH_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo34, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo34 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SecondaryCCPCH_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SecondaryCCPCH_Info_r4, SecondaryCCPCH_Info_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd36_sequence[] = {
  { &hf_umts_rrc_ies_sib_ReferenceListFACH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIB_ReferenceListFACH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd36(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd36, T_fdd36_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo32_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo32_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd39  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd36 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo32, T_modeSpecificInfo32_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SCCPCH_InfoForFACH_r4_sequence[] = {
  { &hf_umts_rrc_ies_secondaryCCPCH_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondaryCCPCH_Info_r4 },
  { &hf_umts_rrc_ies_tfcs   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_fach_PCH_InformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FACH_PCH_InformationList },
  { &hf_umts_rrc_ies_modeSpecificInfo32, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo32 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SCCPCH_InfoForFACH_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SCCPCH_InfoForFACH_r4, SCCPCH_InfoForFACH_r4_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_r4_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo21, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo21 },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r4 },
  { &hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_InfoForFACH_r4 },
  { &hf_umts_rrc_ies_cell_id, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_InformationPerRL_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_r4, DL_InformationPerRL_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd24_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SHO_DCH_Info },
  { &hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_CodeMapping },
  { &hf_umts_rrc_ies_servingHSDSCH_RL_indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd24(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd24, T_fdd24_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo22_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo22_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd25  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd24 },
  {   1, &hf_umts_rrc_ies_tdd25  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo22(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo22, T_modeSpecificInfo22_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_r5_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo22, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo22 },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r5 },
  { &hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_InfoForFACH_r4 },
  { &hf_umts_rrc_ies_cell_id, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_InformationPerRL_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_r5, DL_InformationPerRL_r5_sequence);

  return offset;
}


static const per_sequence_t T_fdd25_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SHO_DCH_Info },
  { &hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_CodeMapping },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd25(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd25, T_fdd25_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo23_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo23_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd26  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd25 },
  {   1, &hf_umts_rrc_ies_tdd25  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo23(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo23, T_modeSpecificInfo23_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_r5bis_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo23, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo23 },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r5 },
  { &hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_InfoForFACH_r4 },
  { &hf_umts_rrc_ies_cell_id, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_InformationPerRL_r5bis(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_r5bis, DL_InformationPerRL_r5bis_sequence);

  return offset;
}


static const per_sequence_t T_fdd26_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_servingHSDSCH_RL_indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_servingEDCH_RL_indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd26(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd26, T_fdd26_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo24_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo24_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd27  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd26 },
  {   1, &hf_umts_rrc_ies_tdd25  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo24(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo24, T_modeSpecificInfo24_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_dl_dpchInfo_vals[] = {
  {   0, "dl-DPCH-InfoPerRL" },
  {   1, "dl-FDPCH-InfoPerRL" },
  { 0, NULL }
};

static const per_choice_t T_dl_dpchInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_DPCH_InfoPerRL3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r6 },
  {   1, &hf_umts_rrc_ies_dl_FDPCH_InfoPerRL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_FDPCH_InfoPerRL_r6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dl_dpchInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_dl_dpchInfo, T_dl_dpchInfo_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_E_AGCH_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t E_AGCH_Information_sequence[] = {
  { &hf_umts_rrc_ies_e_AGCH_ChannelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_AGCH_ChannelisationCode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_AGCH_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_AGCH_Information, E_AGCH_Information_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_E_HICH_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_E_HICH_RGCH_SignatureSequence(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 39U, NULL, FALSE);

  return offset;
}


static const per_sequence_t E_HICH_Information_sequence[] = {
  { &hf_umts_rrc_ies_dl_ScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_channelisationCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_HICH_ChannelisationCode },
  { &hf_umts_rrc_ies_signatureSequence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_HICH_RGCH_SignatureSequence },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_HICH_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_HICH_Information, E_HICH_Information_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_E_RGCH_CombinationIndex(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 5U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_E_RGCH_StepSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 6U, NULL, FALSE);

  return offset;
}


static const per_sequence_t E_RGCH_Information_sequence[] = {
  { &hf_umts_rrc_ies_signatureSequence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_HICH_RGCH_SignatureSequence },
  { &hf_umts_rrc_ies_rg_CombinationIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_RGCH_CombinationIndex },
  { &hf_umts_rrc_ies_e_RGCH_StepSize, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_RGCH_StepSize },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_RGCH_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_RGCH_Information, E_RGCH_Information_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_r6_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo24, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo24 },
  { &hf_umts_rrc_ies_dl_dpchInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_dl_dpchInfo },
  { &hf_umts_rrc_ies_e_AGCH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_AGCH_Information },
  { &hf_umts_rrc_ies_e_HICH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_HICH_Information },
  { &hf_umts_rrc_ies_e_RGCH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_RGCH_Information },
  { &hf_umts_rrc_ies_cell_id, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_InformationPerRL_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_r6, DL_InformationPerRL_r6_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_InformationPerRL_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_InformationPerRL },
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_InformationPerRL_List, DL_InformationPerRL_List_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_List_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_InformationPerRL_List_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_InformationPerRL_r4 },
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_List_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_InformationPerRL_List_r4, DL_InformationPerRL_List_r4_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_List_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_InformationPerRL_List_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_InformationPerRL_r5 },
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_List_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_InformationPerRL_List_r5, DL_InformationPerRL_List_r5_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_List_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_InformationPerRL_List_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_InformationPerRL_r6 },
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_List_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_InformationPerRL_List_r6, DL_InformationPerRL_List_r6_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_List_r5bis_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_InformationPerRL_List_r5bis_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_InformationPerRL_r5bis },
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_List_r5bis(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_InformationPerRL_List_r5bis, DL_InformationPerRL_List_r5bis_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_PostFDD_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_PostFDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_InformationPerRL_PostFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_PostFDD, DL_InformationPerRL_PostFDD_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_ListPostFDD_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_InformationPerRL_ListPostFDD_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_InformationPerRL_PostFDD },
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_ListPostFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_InformationPerRL_ListPostFDD, DL_InformationPerRL_ListPostFDD_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t PrimaryCCPCH_InfoPost_sequence[] = {
  { &hf_umts_rrc_ies_syncCase, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SyncCase },
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_sctd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PrimaryCCPCH_InfoPost(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PrimaryCCPCH_InfoPost, PrimaryCCPCH_InfoPost_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_PostTDD_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_InfoPost },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_PostTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_PostTDD, DL_InformationPerRL_PostTDD_sequence);

  return offset;
}


static const per_sequence_t PrimaryCCPCH_InfoPostTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_sctd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PrimaryCCPCH_InfoPostTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PrimaryCCPCH_InfoPostTDD_LCR_r4, PrimaryCCPCH_InfoPostTDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t DL_InformationPerRL_PostTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_InfoPostTDD_LCR_r4 },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD_LCR_r4 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_InformationPerRL_PostTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_InformationPerRL_PostTDD_LCR_r4, DL_InformationPerRL_PostTDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t DL_PDSCH_Information_sequence[] = {
  { &hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SHO_DCH_Info },
  { &hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_CodeMapping },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DL_PDSCH_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_PDSCH_Information, DL_PDSCH_Information_sequence);

  return offset;
}


static const per_sequence_t DL_TPC_PowerOffsetPerRL_sequence[] = {
  { &hf_umts_rrc_ies_powerOffsetTPC_pdpdch, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PowerOffsetTPC_pdpdch },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DL_TPC_PowerOffsetPerRL(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DL_TPC_PowerOffsetPerRL, DL_TPC_PowerOffsetPerRL_sequence);

  return offset;
}


static const per_sequence_t DL_TPC_PowerOffsetPerRL_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TPC_PowerOffsetPerRL },
};

int
dissect_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List, DL_TPC_PowerOffsetPerRL_List_sequence_of,
                                                  1, maxRL);

  return offset;
}



static int
dissect_umts_rrc_ies_DPCCH_PowerOffset2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -28, -13, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TGPS_Reconfiguration_CFN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_activate1_sequence[] = {
  { &hf_umts_rrc_ies_tgcfn  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGCFN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_activate1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_activate1, T_activate1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tgps_Status1_vals[] = {
  {   0, "activate" },
  {   1, "deactivate" },
  { 0, NULL }
};

static const per_choice_t T_tgps_Status1_choice[] = {
  {   0, &hf_umts_rrc_ies_activate1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_activate1 },
  {   1, &hf_umts_rrc_ies_deactivate, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tgps_Status1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tgps_Status1, T_tgps_Status1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TGP_SequenceShort_sequence[] = {
  { &hf_umts_rrc_ies_tgpsi  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGPSI },
  { &hf_umts_rrc_ies_tgps_Status1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tgps_Status1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TGP_SequenceShort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TGP_SequenceShort, TGP_SequenceShort_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort_sequence_of[1] = {
  { &hf_umts_rrc_ies_tgp_SequenceShortList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGP_SequenceShort },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort, SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort_sequence_of,
                                                  1, maxTGPS);

  return offset;
}


static const per_sequence_t DPCH_CompressedModeStatusInfo_sequence[] = {
  { &hf_umts_rrc_ies_tgps_Reconfiguration_CFN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TGPS_Reconfiguration_CFN },
  { &hf_umts_rrc_ies_tgp_SequenceShortList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_DPCH_CompressedModeStatusInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DPCH_CompressedModeStatusInfo, DPCH_CompressedModeStatusInfo_sequence);

  return offset;
}


static const per_sequence_t DSCH_TransportChannelsInfo_item_sequence[] = {
  { &hf_umts_rrc_ies_dsch_transport_channel_identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_dsch_TFS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DSCH_TransportChannelsInfo_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DSCH_TransportChannelsInfo_item, DSCH_TransportChannelsInfo_item_sequence);

  return offset;
}


static const per_sequence_t DSCH_TransportChannelsInfo_sequence_of[1] = {
  { &hf_umts_rrc_ies_DSCH_TransportChannelsInfo_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DSCH_TransportChannelsInfo_item },
};

static int
dissect_umts_rrc_ies_DSCH_TransportChannelsInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DSCH_TransportChannelsInfo, DSCH_TransportChannelsInfo_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t DynamicPersistenceLevelList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DynamicPersistenceLevelList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DynamicPersistenceLevel },
};

static int
dissect_umts_rrc_ies_DynamicPersistenceLevelList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DynamicPersistenceLevelList, DynamicPersistenceLevelList_sequence_of,
                                                  1, maxPRACH);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DCH_MinimumSet_E_TFCI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t E_DCH_RL_Info_sequence[] = {
  { &hf_umts_rrc_ies_e_HICH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_HICH_Information },
  { &hf_umts_rrc_ies_e_RGCH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_RGCH_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DCH_RL_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DCH_RL_Info, E_DCH_RL_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DPCCH_DPCCH_PowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_HappyBit_DelayCondition_vals[] = {
  {   0, "ms2" },
  {   1, "ms10" },
  {   2, "ms20" },
  {   3, "ms50" },
  {   4, "ms100" },
  {   5, "ms200" },
  {   6, "ms500" },
  {   7, "ms1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_HappyBit_DelayCondition(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t E_DPCCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_e_DPCCH_DPCCH_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPCCH_DPCCH_PowerOffset },
  { &hf_umts_rrc_ies_happyBit_DelayCondition, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HappyBit_DelayCondition },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DPCCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DPCCH_Info, E_DPCCH_Info_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_E_TFCI_TableIndex(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 0U, NULL, FALSE);

  return offset;
}


static const per_sequence_t E_DPDCH_Reference_E_TFCI_sequence[] = {
  { &hf_umts_rrc_ies_reference_E_TFCI, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_reference_E_TFCI_PO, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DPDCH_Reference_E_TFCI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DPDCH_Reference_E_TFCI, E_DPDCH_Reference_E_TFCI_sequence);

  return offset;
}


static const per_sequence_t E_DPDCH_Reference_E_TFCIList_sequence_of[1] = {
  { &hf_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPDCH_Reference_E_TFCI },
};

static int
dissect_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList, E_DPDCH_Reference_E_TFCIList_sequence_of,
                                                  1, 8);

  return offset;
}


static const value_string umts_rrc_ies_E_DPDCH_MaxChannelisationCodes_vals[] = {
  {   0, "sf64" },
  {   1, "sf32" },
  {   2, "sf16" },
  {   3, "sf8" },
  {   4, "sf4" },
  {   5, "sf4x2" },
  {   6, "sf2x2" },
  {   7, "sf4x2-and-sf2x2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_E_DPDCH_MaxChannelisationCodes(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_E_DPDCH_PL_NonMax(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              11U, 100U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_E_DPDCH_PeriodicyOfSchedInfo_vals[] = {
  {   0, "everyMACePDU" },
  {   1, "pdu4" },
  {   2, "pdu10" },
  {   3, "pdu20" },
  {   4, "pdu50" },
  {   5, "pdu100" },
  {   6, "pdu200" },
  {   7, "pdu500" },
  {   8, "pdu1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_E_DPDCH_PeriodicyOfSchedInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     9, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 6U, NULL, FALSE);

  return offset;
}


static const per_sequence_t E_DPDCH_SchedulingInfoConfiguration_sequence[] = {
  { &hf_umts_rrc_ies_periodicityOfSchedInfo_NoGrant, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DPDCH_PeriodicyOfSchedInfo },
  { &hf_umts_rrc_ies_periodicityOfSchedInfo_Grant, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DPDCH_PeriodicyOfSchedInfo },
  { &hf_umts_rrc_ies_powerOffsetForSchedInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DPDCH_SchedulingInfoConfiguration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DPDCH_SchedulingInfoConfiguration, E_DPDCH_SchedulingInfoConfiguration_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_primary_Secondary_GrantSelector_vals[] = {
  {   0, "primary" },
  {   1, "secondary" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_primary_Secondary_GrantSelector(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t E_DPDCH_SchedulingTransmConfiguration_sequence[] = {
  { &hf_umts_rrc_ies_ms2_SchedTransmGrantHARQAlloc, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_servingGrant, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_31 },
  { &hf_umts_rrc_ies_primary_Secondary_GrantSelector, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_primary_Secondary_GrantSelector },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DPDCH_SchedulingTransmConfiguration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DPDCH_SchedulingTransmConfiguration, E_DPDCH_SchedulingTransmConfiguration_sequence);

  return offset;
}


static const per_sequence_t E_DPDCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_e_TFCI_TableIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_TFCI_TableIndex },
  { &hf_umts_rrc_ies_e_DCH_MinimumSet_E_TFCI, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_MinimumSet_E_TFCI },
  { &hf_umts_rrc_ies_reference_E_TFCIs, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList },
  { &hf_umts_rrc_ies_maxChannelisationCodes, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPDCH_MaxChannelisationCodes },
  { &hf_umts_rrc_ies_pl_NonMax, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPDCH_PL_NonMax },
  { &hf_umts_rrc_ies_schedulingInfoConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPDCH_SchedulingInfoConfiguration },
  { &hf_umts_rrc_ies_schedulingTransmConfiguraration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_DPDCH_SchedulingTransmConfiguration },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_E_DPDCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_E_DPDCH_Info, E_DPDCH_Info_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TDD_FPACH_CCode16_r4_vals[] = {
  {   0, "cc16-1" },
  {   1, "cc16-2" },
  {   2, "cc16-3" },
  {   3, "cc16-4" },
  {   4, "cc16-5" },
  {   5, "cc16-6" },
  {   6, "cc16-7" },
  {   7, "cc16-8" },
  {   8, "cc16-9" },
  {   9, "cc16-10" },
  {  10, "cc16-11" },
  {  11, "cc16-12" },
  {  12, "cc16-13" },
  {  13, "cc16-14" },
  {  14, "cc16-15" },
  {  15, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TDD_FPACH_CCode16_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_Wi_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 4U, NULL, FALSE);

  return offset;
}


static const per_sequence_t FPACH_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_timeslot1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { &hf_umts_rrc_ies_channelisationCode1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_FPACH_CCode16_r4 },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 },
  { &hf_umts_rrc_ies_wi     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Wi_LCR },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_FPACH_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FPACH_Info_r4, FPACH_Info_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modulation1_vals[] = {
  {   0, "mod-QPSK" },
  {   1, "mod-8PSK" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_modulation1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_ss_TPC_Symbols1_vals[] = {
  {   0, "zero" },
  {   1, "one" },
  {   2, "sixteenOverSF" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_ss_TPC_Symbols1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IndividualTimeslotInfo_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_midambleShiftAndBurstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 },
  { &hf_umts_rrc_ies_modulation1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modulation1 },
  { &hf_umts_rrc_ies_ss_TPC_Symbols1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ss_TPC_Symbols1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4_ext, IndividualTimeslotInfo_LCR_r4_ext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxPowerIncrease_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 3U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_N_GAP_vals[] = {
  {   0, "f2" },
  {   1, "f4" },
  {   2, "f8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_N_GAP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_N_PCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NB01(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 50U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NumberOfDPDCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxDPDCHUL, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_NumberOfFBI_Bits(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 2U, NULL, FALSE);

  return offset;
}


static const per_sequence_t OpenLoopPowerControl_TDD_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_alpha  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Alpha },
  { &hf_umts_rrc_ies_prach_ConstantValue, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValueTdd },
  { &hf_umts_rrc_ies_dpch_ConstantValue, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValueTdd },
  { &hf_umts_rrc_ies_pusch_ConstantValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ConstantValueTdd },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_OpenLoopPowerControl_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_OpenLoopPowerControl_TDD, OpenLoopPowerControl_TDD_sequence);

  return offset;
}


static const per_sequence_t OpenLoopPowerControl_IPDL_TDD_r4_sequence[] = {
  { &hf_umts_rrc_ies_ipdl_alpha, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Alpha },
  { &hf_umts_rrc_ies_maxPowerIncrease, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MaxPowerIncrease_r4 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_OpenLoopPowerControl_IPDL_TDD_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_OpenLoopPowerControl_IPDL_TDD_r4, OpenLoopPowerControl_IPDL_TDD_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PagingIndicatorLength_vals[] = {
  {   0, "pi4" },
  {   1, "pi8" },
  {   2, "pi16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PagingIndicatorLength(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PDSCH_PowerControlInfo_sequence[] = {
  { &hf_umts_rrc_ies_tpc_StepSizeTDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TPC_StepSizeTDD },
  { &hf_umts_rrc_ies_ul_CCTrChTPCList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrChTPCList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_PowerControlInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_PowerControlInfo, PDSCH_PowerControlInfo_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_PDSCH_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, hiPDSCHidentities, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_old_Configuration_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_old_Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_old_Configuration, T_old_Configuration_sequence);

  return offset;
}


static const per_sequence_t PDSCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_pdsch_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_Info, PDSCH_Info_sequence);

  return offset;
}


static const per_sequence_t T_new_Configuration_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Info },
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_new_Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_new_Configuration, T_new_Configuration_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_configuration_vals[] = {
  {   0, "old-Configuration" },
  {   1, "new-Configuration" },
  { 0, NULL }
};

static const per_choice_t T_configuration_choice[] = {
  {   0, &hf_umts_rrc_ies_old_Configuration, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_old_Configuration },
  {   1, &hf_umts_rrc_ies_new_Configuration, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_new_Configuration },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_configuration, T_configuration_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PDSCH_CapacityAllocationInfo_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_PowerControlInfo },
  { &hf_umts_rrc_ies_pdsch_AllocationPeriodInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AllocationPeriodInfo },
  { &hf_umts_rrc_ies_configuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_configuration },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PDSCH_CapacityAllocationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_CapacityAllocationInfo, PDSCH_CapacityAllocationInfo_sequence);

  return offset;
}


static const per_sequence_t T_old_Configuration1_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_old_Configuration1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_old_Configuration1, T_old_Configuration1_sequence);

  return offset;
}


static const per_sequence_t T_tdd3845_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3845(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3845, T_tdd3845_sequence);

  return offset;
}


static const per_sequence_t T_tdd1286_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1286(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1286, T_tdd1286_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption4_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption4_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3846, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3845 },
  {   1, &hf_umts_rrc_ies_tdd1287, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1286 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption4, T_tddOption4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PDSCH_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_tddOption4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_Info_r4, PDSCH_Info_r4_sequence);

  return offset;
}


static const per_sequence_t T_new_Configuration1_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Info_r4 },
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_Identity },
  { &hf_umts_rrc_ies_pdsch_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_PowerControlInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_new_Configuration1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_new_Configuration1, T_new_Configuration1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_configuration1_vals[] = {
  {   0, "old-Configuration" },
  {   1, "new-Configuration" },
  { 0, NULL }
};

static const per_choice_t T_configuration1_choice[] = {
  {   0, &hf_umts_rrc_ies_old_Configuration1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_old_Configuration1 },
  {   1, &hf_umts_rrc_ies_new_Configuration1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_new_Configuration1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_configuration1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_configuration1, T_configuration1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PDSCH_CapacityAllocationInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_AllocationPeriodInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AllocationPeriodInfo },
  { &hf_umts_rrc_ies_configuration1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_configuration1 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PDSCH_CapacityAllocationInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_CapacityAllocationInfo_r4, PDSCH_CapacityAllocationInfo_r4_sequence);

  return offset;
}


static const per_sequence_t PDSCH_Info_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_pdsch_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_Info_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_Info_LCR_r4, PDSCH_Info_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfo_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Identity },
  { &hf_umts_rrc_ies_pdsch_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Info },
  { &hf_umts_rrc_ies_dsch_TFS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_dsch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SysInfo, PDSCH_SysInfo_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfo_HCR_r5_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Identity },
  { &hf_umts_rrc_ies_pdsch_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Info },
  { &hf_umts_rrc_ies_dsch_TransportChannelsInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DSCH_TransportChannelsInfo },
  { &hf_umts_rrc_ies_dsch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfo_HCR_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SysInfo_HCR_r5, PDSCH_SysInfo_HCR_r5_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfo_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Identity },
  { &hf_umts_rrc_ies_pdsch_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_dsch_TFS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_dsch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfo_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SysInfo_LCR_r4, PDSCH_SysInfo_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_SysInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfo },
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_SysInfoList, PDSCH_SysInfoList_sequence_of,
                                                  1, maxPDSCH);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_HCR_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfo_HCR_r5 },
};

int
dissect_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5, PDSCH_SysInfoList_HCR_r5_sequence_of,
                                                  1, maxPDSCH);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfo_LCR_r4 },
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4, PDSCH_SysInfoList_LCR_r4_sequence_of,
                                                  1, maxPDSCH);

  return offset;
}


static const per_sequence_t SFN_TimeInfo_sequence[] = {
  { &hf_umts_rrc_ies_activationTimeSFN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_physChDuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DurationTimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SFN_TimeInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SFN_TimeInfo, SFN_TimeInfo_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_SFN_item_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_SysInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfo },
  { &hf_umts_rrc_ies_sfn_TimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_item, PDSCH_SysInfoList_SFN_item_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_SFN_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_item },
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_SysInfoList_SFN, PDSCH_SysInfoList_SFN_sequence_of,
                                                  1, maxPDSCH);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_SFN_HCR_r5_item_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_SysInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfo_HCR_r5 },
  { &hf_umts_rrc_ies_sfn_TimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item, PDSCH_SysInfoList_SFN_HCR_r5_item_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_SFN_HCR_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item },
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5, PDSCH_SysInfoList_SFN_HCR_r5_sequence_of,
                                                  1, maxPDSCH);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_SFN_LCR_r4_item_sequence[] = {
  { &hf_umts_rrc_ies_pdsch_SysInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfo_LCR_r4 },
  { &hf_umts_rrc_ies_sfn_TimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item, PDSCH_SysInfoList_SFN_LCR_r4_item_sequence);

  return offset;
}


static const per_sequence_t PDSCH_SysInfoList_SFN_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item },
};

static int
dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4, PDSCH_SysInfoList_SFN_LCR_r4_sequence_of,
                                                  1, maxPDSCH);

  return offset;
}


static const value_string umts_rrc_ies_PersistenceScalingFactor_vals[] = {
  {   0, "psf0-9" },
  {   1, "psf0-8" },
  {   2, "psf0-7" },
  {   3, "psf0-6" },
  {   4, "psf0-5" },
  {   5, "psf0-4" },
  {   6, "psf0-3" },
  {   7, "psf0-2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PersistenceScalingFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PersistenceScalingFactorList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PersistenceScalingFactorList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PersistenceScalingFactor },
};

static int
dissect_umts_rrc_ies_PersistenceScalingFactorList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PersistenceScalingFactorList, PersistenceScalingFactorList_sequence_of,
                                                  1, maxASCpersist);

  return offset;
}


static const value_string umts_rrc_ies_PI_CountPerFrame_vals[] = {
  {   0, "e18" },
  {   1, "e36" },
  {   2, "e72" },
  {   3, "e144" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PI_CountPerFrame(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PichChannelisationCodeList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PichChannelisationCodeList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
};

static int
dissect_umts_rrc_ies_PichChannelisationCodeList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PichChannelisationCodeList_LCR_r4, PichChannelisationCodeList_LCR_r4_sequence_of,
                                                  1, 2);

  return offset;
}


static const per_sequence_t T_fdd30_sequence[] = {
  { &hf_umts_rrc_ies_channelisationCode256, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelisationCode256 },
  { &hf_umts_rrc_ies_pi_CountPerFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PI_CountPerFrame },
  { &hf_umts_rrc_ies_sttd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd30(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd30, T_fdd30_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TDD_PICH_CCode_vals[] = {
  {   0, "cc16-1" },
  {   1, "cc16-2" },
  {   2, "cc16-3" },
  {   3, "cc16-4" },
  {   4, "cc16-5" },
  {   5, "cc16-6" },
  {   6, "cc16-7" },
  {   7, "cc16-8" },
  {   8, "cc16-9" },
  {   9, "cc16-10" },
  {  10, "cc16-11" },
  {  11, "cc16-12" },
  {  12, "cc16-13" },
  {  13, "cc16-14" },
  {  14, "cc16-15" },
  {  15, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TDD_PICH_CCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_RepPerLengthOffset_PICH_vals[] = {
  {   0, "rpp4-2" },
  {   1, "rpp8-2" },
  {   2, "rpp8-4" },
  {   3, "rpp16-2" },
  {   4, "rpp16-4" },
  {   5, "rpp32-2" },
  {   6, "rpp32-4" },
  {   7, "rpp64-2" },
  {   8, "rpp64-4" },
  { 0, NULL }
};

static const per_choice_t RepPerLengthOffset_PICH_choice[] = {
  {   0, &hf_umts_rrc_ies_rpp4_2 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_3 },
  {   1, &hf_umts_rrc_ies_rpp8_2 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   2, &hf_umts_rrc_ies_rpp8_4 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   3, &hf_umts_rrc_ies_rpp16_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   4, &hf_umts_rrc_ies_rpp16_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   5, &hf_umts_rrc_ies_rpp32_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   6, &hf_umts_rrc_ies_rpp32_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   7, &hf_umts_rrc_ies_rpp64_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   8, &hf_umts_rrc_ies_rpp64_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RepPerLengthOffset_PICH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RepPerLengthOffset_PICH, RepPerLengthOffset_PICH_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd25_sequence[] = {
  { &hf_umts_rrc_ies_channelisationCode4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TDD_PICH_CCode },
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType },
  { &hf_umts_rrc_ies_repetitionPeriodLengthOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RepPerLengthOffset_PICH },
  { &hf_umts_rrc_ies_pagingIndicatorLength, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PagingIndicatorLength },
  { &hf_umts_rrc_ies_n_GAP  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_GAP },
  { &hf_umts_rrc_ies_n_PCH  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_PCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd25(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd25, T_tdd25_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PICH_Info_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t PICH_Info_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd32  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd30 },
  {   1, &hf_umts_rrc_ies_tdd29  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd25 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PICH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PICH_Info, PICH_Info_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PICH_Info_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_timeslot1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { &hf_umts_rrc_ies_pichChannelisationCodeList_LCR_r4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PichChannelisationCodeList_LCR_r4 },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 },
  { &hf_umts_rrc_ies_repetitionPeriodLengthOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RepPerLengthOffset_PICH },
  { &hf_umts_rrc_ies_pagingIndicatorLength, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PagingIndicatorLength },
  { &hf_umts_rrc_ies_n_GAP  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_GAP },
  { &hf_umts_rrc_ies_n_PCH  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_N_PCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PICH_Info_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PICH_Info_LCR_r4, PICH_Info_LCR_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_PICH_PowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -10, 5U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_PowerRampStep(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_TDD_PRACH_CCode_LCR_r4_vals[] = {
  {   0, "cc4-1" },
  {   1, "cc4-2" },
  {   2, "cc4-3" },
  {   3, "cc4-4" },
  {   4, "cc8-1" },
  {   5, "cc8-2" },
  {   6, "cc8-3" },
  {   7, "cc8-4" },
  {   8, "cc8-5" },
  {   9, "cc8-6" },
  {  10, "cc8-7" },
  {  11, "cc8-8" },
  {  12, "cc16-1" },
  {  13, "cc16-2" },
  {  14, "cc16-3" },
  {  15, "cc16-4" },
  {  16, "cc16-5" },
  {  17, "cc16-6" },
  {  18, "cc16-7" },
  {  19, "cc16-8" },
  {  20, "cc16-9" },
  {  21, "cc16-10" },
  {  22, "cc16-11" },
  {  23, "cc16-12" },
  {  24, "cc16-13" },
  {  25, "cc16-14" },
  {  26, "cc16-15" },
  {  27, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TDD_PRACH_CCode_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     28, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PRACH_ChanCodes_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PRACH_ChanCodes_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_PRACH_CCode_LCR_r4 },
};

static int
dissect_umts_rrc_ies_PRACH_ChanCodes_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PRACH_ChanCodes_LCR_r4, PRACH_ChanCodes_LCR_r4_sequence_of,
                                                  1, 4);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeslotNumber_PRACH_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 6U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PRACH_Definition_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_timeslot2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_PRACH_LCR_r4 },
  { &hf_umts_rrc_ies_prach_ChanCodes_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_ChanCodes_LCR_r4 },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 },
  { &hf_umts_rrc_ies_fpach_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FPACH_Info_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_Definition_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PRACH_Definition_LCR_r4, PRACH_Definition_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PRACH_Midamble_vals[] = {
  {   0, "direct" },
  {   1, "direct-Inverted" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PRACH_Midamble(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD_sequence_of[1] = {
  { &hf_umts_rrc_ies_fdd_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ASCSetting_FDD },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD, SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD_sequence_of,
                                                  1, maxASC);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ASCSetting_TDD },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD, SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD_sequence_of,
                                                  1, maxASC);

  return offset;
}


static const value_string umts_rrc_ies_PRACH_Partitioning_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t PRACH_Partitioning_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd33  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD },
  {   1, &hf_umts_rrc_ies_tdd30  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_Partitioning(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PRACH_Partitioning, PRACH_Partitioning_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PRACH_Partitioning_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PRACH_Partitioning_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ASCSetting_TDD_LCR_r4 },
};

static int
dissect_umts_rrc_ies_PRACH_Partitioning_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PRACH_Partitioning_LCR_r4, PRACH_Partitioning_LCR_r4_sequence_of,
                                                  1, maxASC);

  return offset;
}



static int
dissect_umts_rrc_ies_PreambleRetransMax(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}


static const per_sequence_t PRACH_PowerOffset_sequence[] = {
  { &hf_umts_rrc_ies_powerRampStep, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerRampStep },
  { &hf_umts_rrc_ies_preambleRetransMax, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PreambleRetransMax },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_PowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PRACH_PowerOffset, PRACH_PowerOffset_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SF_PRACH_vals[] = {
  {   0, "sfpr32" },
  {   1, "sfpr64" },
  {   2, "sfpr128" },
  {   3, "sfpr256" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SF_PRACH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_PreambleScramblingCodeWordNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd31_sequence[] = {
  { &hf_umts_rrc_ies_availableSignatures, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AvailableSignatures },
  { &hf_umts_rrc_ies_availableSF, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF_PRACH },
  { &hf_umts_rrc_ies_preambleScramblingCodeWordNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PreambleScramblingCodeWordNumber },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { &hf_umts_rrc_ies_availableSubChannelNumbers, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AvailableSubChannelNumbers },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd31(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd31, T_fdd31_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TDD_PRACH_CCode8_vals[] = {
  {   0, "cc8-1" },
  {   1, "cc8-2" },
  {   2, "cc8-3" },
  {   3, "cc8-4" },
  {   4, "cc8-5" },
  {   5, "cc8-6" },
  {   6, "cc8-7" },
  {   7, "cc8-8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TDD_PRACH_CCode8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8_sequence_of[1] = {
  { &hf_umts_rrc_ies_sf8_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_PRACH_CCode8 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8, SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8_sequence_of,
                                                  1, 8);

  return offset;
}


static const value_string umts_rrc_ies_TDD_PRACH_CCode16_vals[] = {
  {   0, "cc16-1" },
  {   1, "cc16-2" },
  {   2, "cc16-3" },
  {   3, "cc16-4" },
  {   4, "cc16-5" },
  {   5, "cc16-6" },
  {   6, "cc16-7" },
  {   7, "cc16-8" },
  {   8, "cc16-9" },
  {   9, "cc16-10" },
  {  10, "cc16-11" },
  {  11, "cc16-12" },
  {  12, "cc16-13" },
  {  13, "cc16-14" },
  {  14, "cc16-15" },
  {  15, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TDD_PRACH_CCode16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16_sequence_of[1] = {
  { &hf_umts_rrc_ies_sf16_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_PRACH_CCode16 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16, SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16_sequence_of,
                                                  1, 8);

  return offset;
}


static const value_string umts_rrc_ies_TDD_PRACH_CCodeList_vals[] = {
  {   0, "sf8" },
  {   1, "sf16" },
  { 0, NULL }
};

static const per_choice_t TDD_PRACH_CCodeList_choice[] = {
  {   0, &hf_umts_rrc_ies_sf81   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8 },
  {   1, &hf_umts_rrc_ies_sf161  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TDD_PRACH_CCodeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TDD_PRACH_CCodeList, TDD_PRACH_CCodeList_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd26_sequence[] = {
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_channelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_PRACH_CCodeList },
  { &hf_umts_rrc_ies_prach_Midamble, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_Midamble },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd26(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd26, T_tdd26_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo29_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo29_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd34  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd31 },
  {   1, &hf_umts_rrc_ies_tdd31  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd26 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo29(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo29, T_modeSpecificInfo29_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PRACH_RACH_Info_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo29, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo29 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_RACH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PRACH_RACH_Info, PRACH_RACH_Info_sequence);

  return offset;
}


static const asn_namedbit T_sync_UL_Codes_Bitmap_bits[] = {
  {  0, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code7, -1, -1, "code7", NULL },
  {  1, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code6, -1, -1, "code6", NULL },
  {  2, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code5, -1, -1, "code5", NULL },
  {  3, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code4, -1, -1, "code4", NULL },
  {  4, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code3, -1, -1, "code3", NULL },
  {  5, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code2, -1, -1, "code2", NULL },
  {  6, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code1, -1, -1, "code1", NULL },
  {  7, &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code0, -1, -1, "code0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_sync_UL_Codes_Bitmap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_max_SYNC_UL_Transmissions1_vals[] = {
  {   0, "tr1" },
  {   1, "tr2" },
  {   2, "tr4" },
  {   3, "tr8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_max_SYNC_UL_Transmissions1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SYNC_UL_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_sync_UL_Codes_Bitmap, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_sync_UL_Codes_Bitmap },
  { &hf_umts_rrc_ies_prxUpPCHdes, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_62 },
  { &hf_umts_rrc_ies_powerRampStep1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { &hf_umts_rrc_ies_max_SYNC_UL_Transmissions1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_max_SYNC_UL_Transmissions1 },
  { &hf_umts_rrc_ies_mmax   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_32 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SYNC_UL_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SYNC_UL_Info_r4, SYNC_UL_Info_r4_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_prach_DefinitionList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_Definition_LCR_r4 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4, SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4_sequence_of,
                                                  1, maxPRACHFPACH);

  return offset;
}


static const per_sequence_t PRACH_RACH_Info_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_sync_UL_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SYNC_UL_Info_r4 },
  { &hf_umts_rrc_ies_prach_DefinitionList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_RACH_Info_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PRACH_RACH_Info_LCR_r4, PRACH_RACH_Info_LCR_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_PrimaryCPICH_TX_Power(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -10, 50U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RACH_TransmissionParameters_sequence[] = {
  { &hf_umts_rrc_ies_mmax   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_32 },
  { &hf_umts_rrc_ies_nb01Min, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NB01 },
  { &hf_umts_rrc_ies_nb01Max, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NB01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RACH_TransmissionParameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RACH_TransmissionParameters, RACH_TransmissionParameters_sequence);

  return offset;
}


static const per_sequence_t T_fdd32_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_constantValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ConstantValue },
  { &hf_umts_rrc_ies_prach_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PRACH_PowerOffset },
  { &hf_umts_rrc_ies_rach_TransmissionParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RACH_TransmissionParameters },
  { &hf_umts_rrc_ies_aich_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd32, T_fdd32_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo30_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo30_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd35  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd32 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo30(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo30, T_modeSpecificInfo30_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PRACH_SystemInformation_sequence[] = {
  { &hf_umts_rrc_ies_prach_RACH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_RACH_Info },
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_rach_TransportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_rach_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_prach_Partitioning, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PRACH_Partitioning },
  { &hf_umts_rrc_ies_persistenceScalingFactorList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PersistenceScalingFactorList },
  { &hf_umts_rrc_ies_ac_To_ASC_MappingTable, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AC_To_ASC_MappingTable },
  { &hf_umts_rrc_ies_modeSpecificInfo30, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo30 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_SystemInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PRACH_SystemInformation, PRACH_SystemInformation_sequence);

  return offset;
}


static const per_sequence_t PRACH_SystemInformation_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_prach_RACH_Info_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_RACH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_rach_TransportFormatSet_LCR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransportFormatSet_LCR },
  { &hf_umts_rrc_ies_prach_Partitioning_LCR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PRACH_Partitioning_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PRACH_SystemInformation_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PRACH_SystemInformation_LCR_r4, PRACH_SystemInformation_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t PRACH_SystemInformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PRACH_SystemInformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_SystemInformation },
};

static int
dissect_umts_rrc_ies_PRACH_SystemInformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PRACH_SystemInformationList, PRACH_SystemInformationList_sequence_of,
                                                  1, maxPRACH);

  return offset;
}


static const per_sequence_t PRACH_SystemInformationList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_SystemInformation_LCR_r4 },
};

static int
dissect_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4, PRACH_SystemInformationList_LCR_r4_sequence_of,
                                                  1, maxPRACH);

  return offset;
}


static const per_sequence_t PrimaryCCPCH_Info_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_sctd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4, PrimaryCCPCH_Info_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t PrimaryCCPCH_Info_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_tstd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4_ext, PrimaryCCPCH_Info_LCR_r4_ext_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_PUSCH_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, hiPUSCHidentities, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_old_Configuration2_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_old_Configuration2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_old_Configuration2, T_old_Configuration2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_TS_ChannelisationCode_vals[] = {
  {   0, "cc1-1" },
  {   1, "cc2-1" },
  {   2, "cc2-2" },
  {   3, "cc4-1" },
  {   4, "cc4-2" },
  {   5, "cc4-3" },
  {   6, "cc4-4" },
  {   7, "cc8-1" },
  {   8, "cc8-2" },
  {   9, "cc8-3" },
  {  10, "cc8-4" },
  {  11, "cc8-5" },
  {  12, "cc8-6" },
  {  13, "cc8-7" },
  {  14, "cc8-8" },
  {  15, "cc16-1" },
  {  16, "cc16-2" },
  {  17, "cc16-3" },
  {  18, "cc16-4" },
  {  19, "cc16-5" },
  {  20, "cc16-6" },
  {  21, "cc16-7" },
  {  22, "cc16-8" },
  {  23, "cc16-9" },
  {  24, "cc16-10" },
  {  25, "cc16-11" },
  {  26, "cc16-12" },
  {  27, "cc16-13" },
  {  28, "cc16-14" },
  {  29, "cc16-15" },
  {  30, "cc16-16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UL_TS_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     31, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UL_TS_ChannelisationCodeList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_TS_ChannelisationCodeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TS_ChannelisationCode },
};

static int
dissect_umts_rrc_ies_UL_TS_ChannelisationCodeList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_TS_ChannelisationCodeList, UL_TS_ChannelisationCodeList_sequence_of,
                                                  1, 2);

  return offset;
}


static const per_sequence_t T_consecutive1_sequence[] = {
  { &hf_umts_rrc_ies_numAdditionalTimeslots, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_maxTS1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_consecutive1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_consecutive1, T_consecutive1_sequence);

  return offset;
}


static const per_sequence_t T_sameAsLast2_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sameAsLast2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sameAsLast2, T_sameAsLast2_sequence);

  return offset;
}


static const per_sequence_t T_newParameters2_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo },
  { &hf_umts_rrc_ies_ul_TS_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TS_ChannelisationCodeList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_newParameters2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_newParameters2, T_newParameters2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_parameters2_vals[] = {
  {   0, "sameAsLast" },
  {   1, "newParameters" },
  { 0, NULL }
};

static const per_choice_t T_parameters2_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsLast2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sameAsLast2 },
  {   1, &hf_umts_rrc_ies_newParameters2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_newParameters2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_parameters2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_parameters2, T_parameters2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UplinkAdditionalTimeslots_sequence[] = {
  { &hf_umts_rrc_ies_parameters2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_parameters2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UplinkAdditionalTimeslots(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UplinkAdditionalTimeslots, UplinkAdditionalTimeslots_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots_sequence_of[1] = {
  { &hf_umts_rrc_ies_timeslotList_item2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UplinkAdditionalTimeslots },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots, SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots_sequence_of,
                                                  1, maxTS1);

  return offset;
}


static const value_string umts_rrc_ies_T_additionalTimeslots2_vals[] = {
  {   0, "consecutive" },
  {   1, "timeslotList" },
  { 0, NULL }
};

static const per_choice_t T_additionalTimeslots2_choice[] = {
  {   0, &hf_umts_rrc_ies_consecutive3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_consecutive1 },
  {   1, &hf_umts_rrc_ies_timeslotList2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_additionalTimeslots2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_additionalTimeslots2, T_additionalTimeslots2_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_moreTimeslots2_vals[] = {
  {   0, "noMore" },
  {   1, "additionalTimeslots" },
  { 0, NULL }
};

static const per_choice_t T_moreTimeslots2_choice[] = {
  {   0, &hf_umts_rrc_ies_noMore , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_additionalTimeslots2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_additionalTimeslots2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_moreTimeslots2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_moreTimeslots2, T_moreTimeslots2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UplinkTimeslotsCodes_sequence[] = {
  { &hf_umts_rrc_ies_dynamicSFusage, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_firstIndividualTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo },
  { &hf_umts_rrc_ies_ul_TS_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TS_ChannelisationCodeList },
  { &hf_umts_rrc_ies_moreTimeslots2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_moreTimeslots2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UplinkTimeslotsCodes(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UplinkTimeslotsCodes, UplinkTimeslotsCodes_sequence);

  return offset;
}


static const per_sequence_t PUSCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_pusch_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_Info, PUSCH_Info_sequence);

  return offset;
}


static const per_sequence_t T_new_Configuration2_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Info },
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_new_Configuration2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_new_Configuration2, T_new_Configuration2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_configuration2_vals[] = {
  {   0, "old-Configuration" },
  {   1, "new-Configuration" },
  { 0, NULL }
};

static const per_choice_t T_configuration2_choice[] = {
  {   0, &hf_umts_rrc_ies_old_Configuration2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_old_Configuration2 },
  {   1, &hf_umts_rrc_ies_new_Configuration2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_new_Configuration2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_configuration2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_configuration2, T_configuration2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_pusch_AllocationAssignment_sequence[] = {
  { &hf_umts_rrc_ies_pusch_AllocationPeriodInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AllocationPeriodInfo },
  { &hf_umts_rrc_ies_pusch_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_configuration2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_configuration2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_pusch_AllocationAssignment(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_pusch_AllocationAssignment, T_pusch_AllocationAssignment_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_pusch_Allocation_vals[] = {
  {   0, "pusch-AllocationPending" },
  {   1, "pusch-AllocationAssignment" },
  { 0, NULL }
};

static const per_choice_t T_pusch_Allocation_choice[] = {
  {   0, &hf_umts_rrc_ies_pusch_AllocationPending, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_pusch_AllocationAssignment, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_pusch_AllocationAssignment },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_pusch_Allocation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_pusch_Allocation, T_pusch_Allocation_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PUSCH_CapacityAllocationInfo_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Allocation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_pusch_Allocation },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PUSCH_CapacityAllocationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_CapacityAllocationInfo, PUSCH_CapacityAllocationInfo_sequence);

  return offset;
}


static const per_sequence_t T_tdd1289_sequence[] = {
  { &hf_umts_rrc_ies_tpc_StepSize, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TPC_StepSizeTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1289(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1289, T_tdd1289_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption7_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption7_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3841, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd12810, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1289 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption7, T_tddOption7_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PUSCH_PowerControlInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_tddOption7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_PowerControlInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_PowerControlInfo_r4, PUSCH_PowerControlInfo_r4_sequence);

  return offset;
}


static const per_sequence_t T_old_Configuration3_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_old_Configuration3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_old_Configuration3, T_old_Configuration3_sequence);

  return offset;
}


static const per_sequence_t T_tdd3847_sequence[] = {
  { &hf_umts_rrc_ies_pusch_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3847(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3847, T_tdd3847_sequence);

  return offset;
}


static const per_sequence_t T_consecutive2_sequence[] = {
  { &hf_umts_rrc_ies_numAdditionalTimeslots1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_maxTSLCR1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_consecutive2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_consecutive2, T_consecutive2_sequence);

  return offset;
}


static const per_sequence_t T_sameAsLast3_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sameAsLast3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sameAsLast3, T_sameAsLast3_sequence);

  return offset;
}


static const per_sequence_t T_newParameters3_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4 },
  { &hf_umts_rrc_ies_ul_TS_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TS_ChannelisationCodeList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_newParameters3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_newParameters3, T_newParameters3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_parameters3_vals[] = {
  {   0, "sameAsLast" },
  {   1, "newParameters" },
  { 0, NULL }
};

static const per_choice_t T_parameters3_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsLast3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sameAsLast3 },
  {   1, &hf_umts_rrc_ies_newParameters3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_newParameters3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_parameters3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_parameters3, T_parameters3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UplinkAdditionalTimeslots_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_parameters3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_parameters3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UplinkAdditionalTimeslots_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UplinkAdditionalTimeslots_LCR_r4, UplinkAdditionalTimeslots_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_timeslotList_item3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UplinkAdditionalTimeslots_LCR_r4 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4, SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4_sequence_of,
                                                  1, maxTSLCR1);

  return offset;
}


static const value_string umts_rrc_ies_T_additionalTimeslots3_vals[] = {
  {   0, "consecutive" },
  {   1, "timeslotList" },
  { 0, NULL }
};

static const per_choice_t T_additionalTimeslots3_choice[] = {
  {   0, &hf_umts_rrc_ies_consecutive4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_consecutive2 },
  {   1, &hf_umts_rrc_ies_timeslotList3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_additionalTimeslots3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_additionalTimeslots3, T_additionalTimeslots3_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_moreTimeslots3_vals[] = {
  {   0, "noMore" },
  {   1, "additionalTimeslots" },
  { 0, NULL }
};

static const per_choice_t T_moreTimeslots3_choice[] = {
  {   0, &hf_umts_rrc_ies_noMore , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_additionalTimeslots3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_additionalTimeslots3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_moreTimeslots3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_moreTimeslots3, T_moreTimeslots3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UplinkTimeslotsCodes_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_dynamicSFusage, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_firstIndividualTimeslotInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4 },
  { &hf_umts_rrc_ies_ul_TS_ChannelisationCodeList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TS_ChannelisationCodeList },
  { &hf_umts_rrc_ies_moreTimeslots3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_moreTimeslots3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4, UplinkTimeslotsCodes_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_tdd1288_sequence[] = {
  { &hf_umts_rrc_ies_pusch_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd1288(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd1288, T_tdd1288_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption6_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption6_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd3848, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3847 },
  {   1, &hf_umts_rrc_ies_tdd1289, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd1288 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption6, T_tddOption6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PUSCH_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_tddOption6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_Info_r4, PUSCH_Info_r4_sequence);

  return offset;
}


static const per_sequence_t T_new_Configuration3_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Info_r4 },
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_new_Configuration3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_new_Configuration3, T_new_Configuration3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_configuration3_vals[] = {
  {   0, "old-Configuration" },
  {   1, "new-Configuration" },
  { 0, NULL }
};

static const per_choice_t T_configuration3_choice[] = {
  {   0, &hf_umts_rrc_ies_old_Configuration3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_old_Configuration3 },
  {   1, &hf_umts_rrc_ies_new_Configuration3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_new_Configuration3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_configuration3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_configuration3, T_configuration3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_pusch_AllocationAssignment1_sequence[] = {
  { &hf_umts_rrc_ies_pusch_AllocationPeriodInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AllocationPeriodInfo },
  { &hf_umts_rrc_ies_pusch_PowerControlInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_PowerControlInfo_r4 },
  { &hf_umts_rrc_ies_configuration3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_configuration3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_pusch_AllocationAssignment1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_pusch_AllocationAssignment1, T_pusch_AllocationAssignment1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_pusch_Allocation1_vals[] = {
  {   0, "pusch-AllocationPending" },
  {   1, "pusch-AllocationAssignment" },
  { 0, NULL }
};

static const per_choice_t T_pusch_Allocation1_choice[] = {
  {   0, &hf_umts_rrc_ies_pusch_AllocationPending, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_pusch_AllocationAssignment1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_pusch_AllocationAssignment1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_pusch_Allocation1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_pusch_Allocation1, T_pusch_Allocation1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PUSCH_CapacityAllocationInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Allocation1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_pusch_Allocation1 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_PUSCH_CapacityAllocationInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_CapacityAllocationInfo_r4, PUSCH_CapacityAllocationInfo_r4_sequence);

  return offset;
}


static const per_sequence_t PUSCH_Info_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_pusch_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_Info_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_Info_LCR_r4, PUSCH_Info_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfo_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Identity },
  { &hf_umts_rrc_ies_pusch_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Info },
  { &hf_umts_rrc_ies_usch_TFS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_usch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_SysInfo, PUSCH_SysInfo_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfo_HCR_r5_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Identity },
  { &hf_umts_rrc_ies_pusch_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Info },
  { &hf_umts_rrc_ies_usch_TransportChannelsInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_USCH_TransportChannelsInfo },
  { &hf_umts_rrc_ies_usch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfo_HCR_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_SysInfo_HCR_r5, PUSCH_SysInfo_HCR_r5_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfo_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_pusch_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Identity },
  { &hf_umts_rrc_ies_pusch_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_usch_TFS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_usch_TFCS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfo_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_SysInfo_LCR_r4, PUSCH_SysInfo_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PUSCH_SysInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfo },
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PUSCH_SysInfoList, PUSCH_SysInfoList_sequence_of,
                                                  1, maxPUSCH);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_HCR_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfo_HCR_r5 },
};

int
dissect_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5, PUSCH_SysInfoList_HCR_r5_sequence_of,
                                                  1, maxPUSCH);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfo_LCR_r4 },
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4, PUSCH_SysInfoList_LCR_r4_sequence_of,
                                                  1, maxPUSCH);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_SFN_item_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfo },
  { &hf_umts_rrc_ies_sfn_TimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_item, PUSCH_SysInfoList_SFN_item_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_SFN_sequence_of[1] = {
  { &hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_item },
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PUSCH_SysInfoList_SFN, PUSCH_SysInfoList_SFN_sequence_of,
                                                  1, maxPUSCH);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_SFN_HCR_r5_item_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfo_HCR_r5 },
  { &hf_umts_rrc_ies_sfn_TimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item, PUSCH_SysInfoList_SFN_HCR_r5_item_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_SFN_HCR_r5_sequence_of[1] = {
  { &hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item },
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5, PUSCH_SysInfoList_SFN_HCR_r5_sequence_of,
                                                  1, maxPUSCH);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_SFN_LCR_r4_item_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfo_LCR_r4 },
  { &hf_umts_rrc_ies_sfn_TimeInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TimeInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item, PUSCH_SysInfoList_SFN_LCR_r4_item_sequence);

  return offset;
}


static const per_sequence_t PUSCH_SysInfoList_SFN_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item },
};

static int
dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4, PUSCH_SysInfoList_SFN_LCR_r4_sequence_of,
                                                  1, maxPUSCH);

  return offset;
}



static int
dissect_umts_rrc_ies_ReducedScramblingCodeNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8191U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_RepPerLengthOffset_MICH_vals[] = {
  {   0, "rpp4-2" },
  {   1, "rpp8-2" },
  {   2, "rpp8-4" },
  {   3, "rpp16-2" },
  {   4, "rpp16-4" },
  {   5, "rpp32-2" },
  {   6, "rpp32-4" },
  {   7, "rpp64-2" },
  {   8, "rpp64-4" },
  { 0, NULL }
};

static const per_choice_t RepPerLengthOffset_MICH_choice[] = {
  {   0, &hf_umts_rrc_ies_rpp4_2 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_3 },
  {   1, &hf_umts_rrc_ies_rpp8_2 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   2, &hf_umts_rrc_ies_rpp8_4 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   3, &hf_umts_rrc_ies_rpp16_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   4, &hf_umts_rrc_ies_rpp16_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  {   5, &hf_umts_rrc_ies_rpp32_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   6, &hf_umts_rrc_ies_rpp32_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   7, &hf_umts_rrc_ies_rpp64_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   8, &hf_umts_rrc_ies_rpp64_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RepPerLengthOffset_MICH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RepPerLengthOffset_MICH, RepPerLengthOffset_MICH_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RL_AdditionInformation_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_DPCH_InfoPerRL },
  { &hf_umts_rrc_ies_dummy_BOOLEAN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_sccpch_InfoforFACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_InfoForFACH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RL_AdditionInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RL_AdditionInformation, RL_AdditionInformation_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_dl_dpchInfo1_vals[] = {
  {   0, "dl-DPCH-InfoPerRL" },
  {   1, "dl-FDPCH-InfoPerRL" },
  { 0, NULL }
};

static const per_choice_t T_dl_dpchInfo1_choice[] = {
  {   0, &hf_umts_rrc_ies_dl_DPCH_InfoPerRL2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_DPCH_InfoPerRL_r5 },
  {   1, &hf_umts_rrc_ies_dl_FDPCH_InfoPerRL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DL_FDPCH_InfoPerRL_r6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_dl_dpchInfo1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_dl_dpchInfo1, T_dl_dpchInfo1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RL_AdditionInformation_r6_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_cell_Id, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIdentity },
  { &hf_umts_rrc_ies_dl_dpchInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_dl_dpchInfo1 },
  { &hf_umts_rrc_ies_e_HICH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_HICH_Information },
  { &hf_umts_rrc_ies_e_RGCH_Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_RGCH_Information },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RL_AdditionInformation_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RL_AdditionInformation_r6, RL_AdditionInformation_r6_sequence);

  return offset;
}


static const per_sequence_t RL_AdditionInformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RL_AdditionInformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RL_AdditionInformation },
};

int
dissect_umts_rrc_ies_RL_AdditionInformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RL_AdditionInformationList, RL_AdditionInformationList_sequence_of,
                                                  1, maxRL-1);

  return offset;
}


static const per_sequence_t RL_AdditionInformationList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_RL_AdditionInformationList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RL_AdditionInformation_r6 },
};

int
dissect_umts_rrc_ies_RL_AdditionInformationList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RL_AdditionInformationList_r6, RL_AdditionInformationList_r6_sequence_of,
                                                  1, maxRL-1);

  return offset;
}


static const per_sequence_t RL_RemovalInformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RL_RemovalInformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
};

int
dissect_umts_rrc_ies_RL_RemovalInformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RL_RemovalInformationList, RL_RemovalInformationList_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformation_sequence[] = {
  { &hf_umts_rrc_ies_secondaryCCPCH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondaryCCPCH_Info },
  { &hf_umts_rrc_ies_tfcs   , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_fach_PCH_InformationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FACH_PCH_InformationList },
  { &hf_umts_rrc_ies_pich_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SCCPCH_SystemInformation, SCCPCH_SystemInformation_sequence);

  return offset;
}


static const per_sequence_t SecondaryCCPCH_Info_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_individualTimeslotLCR_Ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SecondaryCCPCH_Info_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SecondaryCCPCH_Info_LCR_r4_ext, SecondaryCCPCH_Info_LCR_r4_ext_sequence);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformation_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_secondaryCCPCH_LCR_Extensions, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondaryCCPCH_Info_LCR_r4_ext },
  { &hf_umts_rrc_ies_pich_Info1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PICH_Info_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformation_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SCCPCH_SystemInformation_LCR_r4_ext, SCCPCH_SystemInformation_LCR_r4_ext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_7_10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              7U, 10U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_TCTF_Presence_vals[] = {
  {   0, "false" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_TCTF_Presence(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MBMS_MCCH_ConfigurationInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_accessInfoPeriodCoefficient, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { &hf_umts_rrc_ies_repetitionPeriodCoefficient, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { &hf_umts_rrc_ies_modificationPeriodCoefficient, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_7_10 },
  { &hf_umts_rrc_ies_rlc_Info3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_Info_MBMS_r6 },
  { &hf_umts_rrc_ies_tctf_Presence, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_TCTF_Presence },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_MCCH_ConfigurationInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_MCCH_ConfigurationInfo_r6, MBMS_MCCH_ConfigurationInfo_r6_sequence);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformation_MBMS_r6_ext_sequence[] = {
  { &hf_umts_rrc_ies_mcch_ConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MCCH_ConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6_ext, SCCPCH_SystemInformation_MBMS_r6_ext_sequence);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformationList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SCCPCH_SystemInformationList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_SystemInformation },
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformationList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SCCPCH_SystemInformationList, SCCPCH_SystemInformationList_sequence_of,
                                                  1, maxSCCPCH);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformationList_LCR_r4_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_SystemInformation_LCR_r4_ext },
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext, SCCPCH_SystemInformationList_LCR_r4_ext_sequence_of,
                                                  1, maxSCCPCH);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformationList_MBMS_r6_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6_ext },
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext, SCCPCH_SystemInformationList_MBMS_r6_ext_sequence_of,
                                                  1, maxSCCPCH);

  return offset;
}


static const per_sequence_t T_fdd39_sequence[] = {
  { &hf_umts_rrc_ies_secondaryScramblingCode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SecondaryScramblingCode },
  { &hf_umts_rrc_ies_sttd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_sf_AndCodeNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SF256_AndCodeNumber },
  { &hf_umts_rrc_ies_timingOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimingOffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd39(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd39, T_fdd39_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo35_vals[] = {
  {   0, "fdd" },
  {   1, "tdd384" },
  {   2, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo35_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd42  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd39 },
  {   1, &hf_umts_rrc_ies_tdd38410, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DownlinkTimeslotsCodes },
  {   2, &hf_umts_rrc_ies_tdd12812, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo35(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo35, T_modeSpecificInfo35_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SecondaryCCPCHInfo_MBMS_r6_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo35, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo35 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SecondaryCCPCHInfo_MBMS_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SecondaryCCPCHInfo_MBMS_r6, SecondaryCCPCHInfo_MBMS_r6_sequence);

  return offset;
}


static const per_sequence_t T_fachCarryingMCCH_sequence[] = {
  { &hf_umts_rrc_ies_transportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_mcch_ConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_MCCH_ConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fachCarryingMCCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fachCarryingMCCH, T_fachCarryingMCCH_sequence);

  return offset;
}


static const per_sequence_t MBMS_FACHCarryingMTCH_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_FACHCarryingMTCH_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
};

static int
dissect_umts_rrc_ies_MBMS_FACHCarryingMTCH_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_FACHCarryingMTCH_List, MBMS_FACHCarryingMTCH_List_sequence_of,
                                                  1, maxFACHPCH);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_MSCHSchedulingInfo_vals[] = {
  {   0, "schedulingPeriod-32-Offset" },
  {   1, "schedulingPeriod-64-Offset" },
  {   2, "schedulingPeriod-128-Offset" },
  {   3, "schedulingPeriod-256-Offset" },
  {   4, "schedulingPeriod-512-Offset" },
  {   5, "schedulingPeriod-1024-Offset" },
  { 0, NULL }
};

static const per_choice_t MBMS_MSCHSchedulingInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_schedulingPeriod_32_Offset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_31 },
  {   1, &hf_umts_rrc_ies_schedulingPeriod_64_Offset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_63 },
  {   2, &hf_umts_rrc_ies_schedulingPeriod_128_Offset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_127 },
  {   3, &hf_umts_rrc_ies_schedulingPeriod_256_Offset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_255 },
  {   4, &hf_umts_rrc_ies_schedulingPeriod_512_Offset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_511 },
  {   5, &hf_umts_rrc_ies_schedulingPeriod_1024_Offset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_1023 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_MSCHSchedulingInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MBMS_MSCHSchedulingInfo, MBMS_MSCHSchedulingInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MBMS_MSCHConfigurationInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_mschShedulingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MSCHSchedulingInfo },
  { &hf_umts_rrc_ies_rlc_Info3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RLC_Info_MBMS_r6 },
  { &hf_umts_rrc_ies_tctf_Presence, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_TCTF_Presence },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6, MBMS_MSCHConfigurationInfo_r6_sequence);

  return offset;
}


static const per_sequence_t T_schedulingInformation_sequence[] = {
  { &hf_umts_rrc_ies_fachCarryingMSCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { &hf_umts_rrc_ies_mschConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_schedulingInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_schedulingInformation, T_schedulingInformation_sequence);

  return offset;
}


static const per_sequence_t SCCPCH_SystemInformation_MBMS_r6_sequence[] = {
  { &hf_umts_rrc_ies_secondaryCCPCHInfo_MBMS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondaryCCPCHInfo_MBMS_r6 },
  { &hf_umts_rrc_ies_transportFormatCombinationSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS },
  { &hf_umts_rrc_ies_fachCarryingMCCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_fachCarryingMCCH },
  { &hf_umts_rrc_ies_fachCarryingMTCH_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_FACHCarryingMTCH_List },
  { &hf_umts_rrc_ies_schedulingInformation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_schedulingInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6, SCCPCH_SystemInformation_MBMS_r6_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_primary_Secondary_GrantSelector1_vals[] = {
  {   0, "primary" },
  {   1, "secondary" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_primary_Secondary_GrantSelector1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t Scheduling_E_DCH_CellInformation_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_e_AGCH_Information, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_E_AGCH_Information },
  { &hf_umts_rrc_ies_servingGrant, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_31 },
  { &hf_umts_rrc_ies_primary_Secondary_GrantSelector1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_primary_Secondary_GrantSelector1 },
  { &hf_umts_rrc_ies_e_DCH_RL_Info_NewServingCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_RL_Info },
  { &hf_umts_rrc_ies_e_DCH_RL_Info_OldServingCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DCH_RL_Info },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_Scheduling_E_DCH_CellInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Scheduling_E_DCH_CellInformation, Scheduling_E_DCH_CellInformation_sequence);

  return offset;
}


static const value_string umts_rrc_ies_ScramblingCodeType_vals[] = {
  {   0, "shortSC" },
  {   1, "longSC" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ScramblingCodeType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_SpecialBurstScheduling(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 7U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_SpreadingFactor_vals[] = {
  {   0, "sf4" },
  {   1, "sf8" },
  {   2, "sf16" },
  {   3, "sf32" },
  {   4, "sf64" },
  {   5, "sf128" },
  {   6, "sf256" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SpreadingFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}


static const asn_namedbit T_sync_UL_CodesBitmap_bits[] = {
  {  0, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code7, -1, -1, "code7", NULL },
  {  1, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code6, -1, -1, "code6", NULL },
  {  2, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code5, -1, -1, "code5", NULL },
  {  3, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code4, -1, -1, "code4", NULL },
  {  4, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code3, -1, -1, "code3", NULL },
  {  5, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code2, -1, -1, "code2", NULL },
  {  6, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code1, -1, -1, "code1", NULL },
  {  7, &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code0, -1, -1, "code0", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_T_sync_UL_CodesBitmap(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     8, 8, FALSE, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_max_SYNC_UL_Transmissions_vals[] = {
  {   0, "tr1" },
  {   1, "tr2" },
  {   2, "tr4" },
  {   3, "tr8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_max_SYNC_UL_Transmissions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SYNC_UL_Procedure_r4_sequence[] = {
  { &hf_umts_rrc_ies_max_SYNC_UL_Transmissions, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_max_SYNC_UL_Transmissions },
  { &hf_umts_rrc_ies_powerRampStep1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SYNC_UL_Procedure_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SYNC_UL_Procedure_r4, SYNC_UL_Procedure_r4_sequence);

  return offset;
}


static const per_sequence_t SynchronisationParameters_r4_sequence[] = {
  { &hf_umts_rrc_ies_sync_UL_CodesBitmap, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_sync_UL_CodesBitmap },
  { &hf_umts_rrc_ies_fpach_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FPACH_Info_r4 },
  { &hf_umts_rrc_ies_prxUpPCHdes, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_62 },
  { &hf_umts_rrc_ies_sync_UL_Procedure, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SYNC_UL_Procedure_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SynchronisationParameters_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SynchronisationParameters_r4, SynchronisationParameters_r4_sequence);

  return offset;
}


const value_string umts_rrc_ies_TFC_ControlDuration_vals[] = {
  {   0, "tfc-cd1" },
  {   1, "tfc-cd2" },
  {   2, "tfc-cd4" },
  {   3, "tfc-cd8" },
  {   4, "tfc-cd16" },
  {   5, "tfc-cd24" },
  {   6, "tfc-cd32" },
  {   7, "tfc-cd48" },
  {   8, "tfc-cd64" },
  {   9, "tfc-cd128" },
  {  10, "tfc-cd192" },
  {  11, "tfc-cd256" },
  {  12, "tfc-cd512" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_TFC_ControlDuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     13, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t TimeslotList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TimeslotList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
};

int
dissect_umts_rrc_ies_TimeslotList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TimeslotList, TimeslotList_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd384_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber, SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd128_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4, SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4_sequence_of,
                                                  1, maxTSLCR);

  return offset;
}


const value_string umts_rrc_ies_TimeslotList_r4_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t TimeslotList_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38411, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber },
  {   1, &hf_umts_rrc_ies_tdd12813, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4 },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_TimeslotList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TimeslotList_r4, TimeslotList_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_CCTrCH_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_timeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeInfo },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_CCTrCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_CCTrCH, UL_CCTrCH_sequence);

  return offset;
}


static const per_sequence_t T_tdd3849_sequence[] = {
  { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd3849(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd3849, T_tdd3849_sequence);

  return offset;
}


static const per_sequence_t T_tdd12811_sequence[] = {
  { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12811(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12811, T_tdd12811_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption9_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption9_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38412, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd3849 },
  {   1, &hf_umts_rrc_ies_tdd12814, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12811 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption9, T_tddOption9_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_CCTrCH_r4_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_timeInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeInfo },
  { &hf_umts_rrc_ies_commonTimeslotInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CommonTimeslotInfo },
  { &hf_umts_rrc_ies_tddOption9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption9 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_CCTrCH_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_CCTrCH_r4, UL_CCTrCH_r4_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCHList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_CCTrCHList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_CCTrCH },
};

static int
dissect_umts_rrc_ies_UL_CCTrCHList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_CCTrCHList, UL_CCTrCHList_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t UL_CCTrCHList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_CCTrCHList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_CCTrCH_r4 },
};

static int
dissect_umts_rrc_ies_UL_CCTrCHList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_CCTrCHList_r4, UL_CCTrCHList_r4_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t UL_CCTrCHListToRemove_sequence_of[1] = {
  { &hf_umts_rrc_ies_UL_CCTrCHListToRemove_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_IdentityPlain },
};

static int
dissect_umts_rrc_ies_UL_CCTrCHListToRemove(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UL_CCTrCHListToRemove, UL_CCTrCHListToRemove_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}



static int
dissect_umts_rrc_ies_UL_ScramblingCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 16777215U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd40_sequence[] = {
  { &hf_umts_rrc_ies_scramblingCodeType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ScramblingCodeType },
  { &hf_umts_rrc_ies_scramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_ScramblingCode },
  { &hf_umts_rrc_ies_numberOfDPDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfDPDCH },
  { &hf_umts_rrc_ies_spreadingFactor1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SpreadingFactor },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_numberOfFBI_Bits, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfFBI_Bits },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd40(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd40, T_fdd40_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_UL_TimingAdvance(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_enabled_sequence[] = {
  { &hf_umts_rrc_ies_ul_TimingAdvance3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvance },
  { &hf_umts_rrc_ies_activationTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ActivationTime },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_enabled(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_enabled, T_enabled_sequence);

  return offset;
}


const value_string umts_rrc_ies_UL_TimingAdvanceControl_vals[] = {
  {   0, "disabled" },
  {   1, "enabled" },
  { 0, NULL }
};

static const per_choice_t UL_TimingAdvanceControl_choice[] = {
  {   0, &hf_umts_rrc_ies_disabled, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_enabled, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_enabled },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_TimingAdvanceControl(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_TimingAdvanceControl, UL_TimingAdvanceControl_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd32_sequence[] = {
  { &hf_umts_rrc_ies_ul_TimingAdvance, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvanceControl },
  { &hf_umts_rrc_ies_ul_CCTrCHList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHList },
  { &hf_umts_rrc_ies_ul_CCTrCHListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd32, T_tdd32_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo36_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo36_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd43  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd40 },
  {   1, &hf_umts_rrc_ies_tdd37  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd32 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo36(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo36, T_modeSpecificInfo36_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_Info_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo },
  { &hf_umts_rrc_ies_modeSpecificInfo36, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo36 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_Info, UL_DPCH_Info_sequence);

  return offset;
}


const value_string umts_rrc_ies_UL_ChannelRequirement_vals[] = {
  {   0, "ul-DPCH-Info" },
  {   1, "dummy-CPCH-SetInfo" },
  { 0, NULL }
};

static const per_choice_t UL_ChannelRequirement_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_DPCH_Info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_DPCH_Info },
  {   1, &hf_umts_rrc_ies_dummy_CPCH_SetInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetInfo },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_ChannelRequirement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_ChannelRequirement, UL_ChannelRequirement_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd41_sequence[] = {
  { &hf_umts_rrc_ies_scramblingCodeType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ScramblingCodeType },
  { &hf_umts_rrc_ies_scramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_ScramblingCode },
  { &hf_umts_rrc_ies_numberOfDPDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfDPDCH },
  { &hf_umts_rrc_ies_spreadingFactor1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SpreadingFactor },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_numberOfFBI_Bits, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfFBI_Bits },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd41, T_fdd41_sequence);

  return offset;
}


static const per_sequence_t T_tdd38413_sequence[] = {
  { &hf_umts_rrc_ies_ul_TimingAdvance3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvance },
  { &hf_umts_rrc_ies_activationTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ActivationTime },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38413(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38413, T_tdd38413_sequence);

  return offset;
}


static const per_sequence_t UL_SynchronisationParameters_r4_sequence[] = {
  { &hf_umts_rrc_ies_stepSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { &hf_umts_rrc_ies_frequency, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_SynchronisationParameters_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_SynchronisationParameters_r4, UL_SynchronisationParameters_r4_sequence);

  return offset;
}


static const per_sequence_t T_tdd12815_sequence[] = {
  { &hf_umts_rrc_ies_ul_SynchronisationParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_SynchronisationParameters_r4 },
  { &hf_umts_rrc_ies_synchronisationParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SynchronisationParameters_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12815(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12815, T_tdd12815_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption13_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption13_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38416, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38413 },
  {   1, &hf_umts_rrc_ies_tdd12818, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12815 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption13, T_tddOption13_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_enabled1_sequence[] = {
  { &hf_umts_rrc_ies_tddOption13, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption13 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_enabled1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_enabled1, T_enabled1_sequence);

  return offset;
}


const value_string umts_rrc_ies_UL_TimingAdvanceControl_r4_vals[] = {
  {   0, "disabled" },
  {   1, "enabled" },
  { 0, NULL }
};

static const per_choice_t UL_TimingAdvanceControl_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_disabled, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_enabled1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_enabled1 },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_TimingAdvanceControl_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_TimingAdvanceControl_r4, UL_TimingAdvanceControl_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd33_sequence[] = {
  { &hf_umts_rrc_ies_ul_TimingAdvance1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvanceControl_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCHList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHList_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCHListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd33(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd33, T_tdd33_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo37_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo37_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd44  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd41 },
  {   1, &hf_umts_rrc_ies_tdd38  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd33 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo37(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo37, T_modeSpecificInfo37_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_Info_r4_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r4 },
  { &hf_umts_rrc_ies_modeSpecificInfo37, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo37 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_Info_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_Info_r4, UL_DPCH_Info_r4_sequence);

  return offset;
}


const value_string umts_rrc_ies_UL_ChannelRequirement_r4_vals[] = {
  {   0, "ul-DPCH-Info" },
  {   1, "dummy-CPCH-SetInfo" },
  { 0, NULL }
};

static const per_choice_t UL_ChannelRequirement_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_DPCH_Info1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_DPCH_Info_r4 },
  {   1, &hf_umts_rrc_ies_dummy_CPCH_SetInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetInfo },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_ChannelRequirement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_ChannelRequirement_r4, UL_ChannelRequirement_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd42_sequence[] = {
  { &hf_umts_rrc_ies_scramblingCodeType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ScramblingCodeType },
  { &hf_umts_rrc_ies_scramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_ScramblingCode },
  { &hf_umts_rrc_ies_numberOfDPDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfDPDCH },
  { &hf_umts_rrc_ies_spreadingFactor1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SpreadingFactor },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_numberOfFBI_Bits, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfFBI_Bits },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd42(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd42, T_fdd42_sequence);

  return offset;
}


static const per_sequence_t T_tdd34_sequence[] = {
  { &hf_umts_rrc_ies_ul_TimingAdvance1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvanceControl_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCHList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHList_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCHListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd34(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd34, T_tdd34_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo38_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo38_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd45  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd42 },
  {   1, &hf_umts_rrc_ies_tdd39  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd34 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo38(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo38, T_modeSpecificInfo38_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_Info_r5_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r5 },
  { &hf_umts_rrc_ies_modeSpecificInfo38, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo38 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_Info_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_Info_r5, UL_DPCH_Info_r5_sequence);

  return offset;
}


const value_string umts_rrc_ies_UL_ChannelRequirement_r5_vals[] = {
  {   0, "ul-DPCH-Info" },
  {   1, "dummy-CPCH-SetInfo" },
  { 0, NULL }
};

static const per_choice_t UL_ChannelRequirement_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_DPCH_Info2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_DPCH_Info_r5 },
  {   1, &hf_umts_rrc_ies_dummy_CPCH_SetInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetInfo },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_ChannelRequirement_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_ChannelRequirement_r5, UL_ChannelRequirement_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd48_sequence[] = {
  { &hf_umts_rrc_ies_dpcch_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCCH_PowerOffset },
  { &hf_umts_rrc_ies_pc_Preamble, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PC_Preamble },
  { &hf_umts_rrc_ies_sRB_delay, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_delay },
  { &hf_umts_rrc_ies_powerControlAlgorithm, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PowerControlAlgorithm },
  { &hf_umts_rrc_ies_deltaACK, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaACK },
  { &hf_umts_rrc_ies_deltaNACK, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaNACK },
  { &hf_umts_rrc_ies_ack_NACK_repetition_factor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ACK_NACK_repetitionFactor },
  { &hf_umts_rrc_ies_harq_Preamble_Mode, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HARQ_Preamble_Mode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd48(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd48, T_fdd48_sequence);

  return offset;
}


static const per_sequence_t T_tdd38412_sequence[] = {
  { &hf_umts_rrc_ies_individualTS_InterferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTS_InterferenceList },
  { &hf_umts_rrc_ies_dpch_ConstantValue1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ConstantValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38412(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38412, T_tdd38412_sequence);

  return offset;
}


static const per_sequence_t T_tdd12814_sequence[] = {
  { &hf_umts_rrc_ies_beaconPLEst, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BEACON_PL_Est },
  { &hf_umts_rrc_ies_tpc_StepSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TPC_StepSizeTDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12814(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12814, T_tdd12814_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption12_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption12_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38415, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38412 },
  {   1, &hf_umts_rrc_ies_tdd12817, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12814 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption12, T_tddOption12_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_individuallySignalled3_sequence[] = {
  { &hf_umts_rrc_ies_tddOption12, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption12 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_individuallySignalled3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_individuallySignalled3, T_individuallySignalled3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ul_OL_PC_Signalling3_vals[] = {
  {   0, "broadcast-UL-OL-PC-info" },
  {   1, "individuallySignalled" },
  { 0, NULL }
};

static const per_choice_t T_ul_OL_PC_Signalling3_choice[] = {
  {   0, &hf_umts_rrc_ies_broadcast_UL_OL_PC_info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_individuallySignalled3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_individuallySignalled3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ul_OL_PC_Signalling3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ul_OL_PC_Signalling3, T_ul_OL_PC_Signalling3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd40_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_ul_OL_PC_Signalling3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ul_OL_PC_Signalling3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd40(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd40, T_tdd40_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_DPCH_PowerControlInfo_r6_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t UL_DPCH_PowerControlInfo_r6_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd51  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd48 },
  {   1, &hf_umts_rrc_ies_tdd45  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd40 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r6, UL_DPCH_PowerControlInfo_r6_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd43_sequence[] = {
  { &hf_umts_rrc_ies_scramblingCodeType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ScramblingCodeType },
  { &hf_umts_rrc_ies_scramblingCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_ScramblingCode },
  { &hf_umts_rrc_ies_numberOfDPDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfDPDCH },
  { &hf_umts_rrc_ies_spreadingFactor1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SpreadingFactor },
  { &hf_umts_rrc_ies_tfci_Existence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_numberOfFBI_Bits, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NumberOfFBI_Bits },
  { &hf_umts_rrc_ies_puncturingLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PuncturingLimit },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd43(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd43, T_fdd43_sequence);

  return offset;
}


static const per_sequence_t T_tdd35_sequence[] = {
  { &hf_umts_rrc_ies_ul_TimingAdvance1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvanceControl_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCHList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHList_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCHListToRemove, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_CCTrCHListToRemove },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd35(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd35, T_tdd35_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo39_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo39_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd46  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd43 },
  {   1, &hf_umts_rrc_ies_tdd40  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd35 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo39(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo39, T_modeSpecificInfo39_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_Info_r6_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_DPCH_PowerControlInfo_r6 },
  { &hf_umts_rrc_ies_modeSpecificInfo39, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo39 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_Info_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_Info_r6, UL_DPCH_Info_r6_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_UL_ChannelRequirement_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_UL_DPCH_Info_r6(tvb, offset, actx, tree, hf_index);

  return offset;
}


const value_string umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_vals[] = {
  {   0, "ul-DPCH-Info" },
  {   1, "dummy1-CPCH-SetInfo" },
  {   2, "dummy2-CPCH-SetID" },
  { 0, NULL }
};

static const per_choice_t UL_ChannelRequirementWithCPCH_SetID_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_DPCH_Info, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_DPCH_Info },
  {   1, &hf_umts_rrc_ies_dummy1_CPCH_SetInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetInfo },
  {   2, &hf_umts_rrc_ies_dummy2_CPCH_SetID, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetID },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID, UL_ChannelRequirementWithCPCH_SetID_choice,
                                 NULL);

  return offset;
}


const value_string umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r4_vals[] = {
  {   0, "ul-DPCH-Info" },
  {   1, "dummy1-CPCH-SetInfo" },
  {   2, "dummy2-CPCH-SetID" },
  { 0, NULL }
};

static const per_choice_t UL_ChannelRequirementWithCPCH_SetID_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_DPCH_Info1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_DPCH_Info_r4 },
  {   1, &hf_umts_rrc_ies_dummy1_CPCH_SetInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetInfo },
  {   2, &hf_umts_rrc_ies_dummy2_CPCH_SetID, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetID },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r4, UL_ChannelRequirementWithCPCH_SetID_r4_choice,
                                 NULL);

  return offset;
}


const value_string umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r5_vals[] = {
  {   0, "ul-DPCH-Info" },
  {   1, "dummy1-CPCH-SetInfo" },
  {   2, "dummy2-CPCH-SetID" },
  { 0, NULL }
};

static const per_choice_t UL_ChannelRequirementWithCPCH_SetID_r5_choice[] = {
  {   0, &hf_umts_rrc_ies_ul_DPCH_Info2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UL_DPCH_Info_r5 },
  {   1, &hf_umts_rrc_ies_dummy1_CPCH_SetInfo, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetInfo },
  {   2, &hf_umts_rrc_ies_dummy2_CPCH_SetID, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPCH_SetID },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r5, UL_ChannelRequirementWithCPCH_SetID_r5_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_PowerControlInfoPostFDD_sequence[] = {
  { &hf_umts_rrc_ies_dpcch_PowerOffset1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DPCCH_PowerOffset2 },
  { &hf_umts_rrc_ies_pc_Preamble, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PC_Preamble },
  { &hf_umts_rrc_ies_sRB_delay, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SRB_delay },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPostFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostFDD, UL_DPCH_PowerControlInfoPostFDD_sequence);

  return offset;
}


static const per_sequence_t UL_DPCH_InfoPostFDD_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPostFDD },
  { &hf_umts_rrc_ies_scramblingCodeType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ScramblingCodeType },
  { &hf_umts_rrc_ies_reducedScramblingCodeNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReducedScramblingCodeNumber },
  { &hf_umts_rrc_ies_spreadingFactor1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SpreadingFactor },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_InfoPostFDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_InfoPostFDD, UL_DPCH_InfoPostFDD_sequence);

  return offset;
}


static const per_sequence_t UL_DPCH_PowerControlInfoPostTDD_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TargetSIR },
  { &hf_umts_rrc_ies_ul_TimeslotInterference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TDD_UL_Interference },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD, UL_DPCH_PowerControlInfoPostTDD_sequence);

  return offset;
}


static const per_sequence_t UL_DPCH_InfoPostTDD_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD },
  { &hf_umts_rrc_ies_ul_TimingAdvance, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvanceControl },
  { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UplinkTimeslotsCodes },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_InfoPostTDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_InfoPostTDD, UL_DPCH_InfoPostTDD_sequence);

  return offset;
}


static const per_sequence_t UL_DPCH_PowerControlInfoPostTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_ul_TargetSIR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TargetSIR },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD_LCR_r4, UL_DPCH_PowerControlInfoPostTDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_enabled2_sequence[] = {
  { &hf_umts_rrc_ies_ul_SynchronisationParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_SynchronisationParameters_r4 },
  { &hf_umts_rrc_ies_synchronisationParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SynchronisationParameters_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_enabled2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_enabled2, T_enabled2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4_vals[] = {
  {   0, "disabled" },
  {   1, "enabled" },
  { 0, NULL }
};

static const per_choice_t UL_TimingAdvanceControl_LCR_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_disabled, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_enabled2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_enabled2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4, UL_TimingAdvanceControl_LCR_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UL_DPCH_InfoPostTDD_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD_LCR_r4 },
  { &hf_umts_rrc_ies_ul_TimingAdvance2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4 },
  { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_DPCH_InfoPostTDD_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_DPCH_InfoPostTDD_LCR_r4, UL_DPCH_InfoPostTDD_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t UL_EDCH_Information_r6_sequence[] = {
  { &hf_umts_rrc_ies_e_DPCCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DPCCH_Info },
  { &hf_umts_rrc_ies_e_DPDCH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_E_DPDCH_Info },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UL_EDCH_Information_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UL_EDCH_Information_r6, UL_EDCH_Information_r6_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_UL_Interference(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -110, -70, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_SatID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M2048_2047(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -2048, 2047U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M42_21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -42, 21U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_DopplerUncertainty_vals[] = {
  {   0, "hz12-5" },
  {   1, "hz25" },
  {   2, "hz50" },
  {   3, "hz100" },
  {   4, "hz200" },
  {   5, "spare3" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DopplerUncertainty(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t ExtraDopplerInfo_sequence[] = {
  { &hf_umts_rrc_ies_doppler1stOrder, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M42_21 },
  { &hf_umts_rrc_ies_dopplerUncertainty, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DopplerUncertainty },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ExtraDopplerInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ExtraDopplerInfo, ExtraDopplerInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_1022(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 1022U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_19(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 19U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_CodePhaseSearchWindow_vals[] = {
  {   0, "w1023" },
  {   1, "w1" },
  {   2, "w2" },
  {   3, "w3" },
  {   4, "w4" },
  {   5, "w6" },
  {   6, "w8" },
  {   7, "w12" },
  {   8, "w16" },
  {   9, "w24" },
  {  10, "w32" },
  {  11, "w48" },
  {  12, "w64" },
  {  13, "w96" },
  {  14, "w128" },
  {  15, "w192" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_CodePhaseSearchWindow(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t AzimuthAndElevation_sequence[] = {
  { &hf_umts_rrc_ies_azimuth, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_31 },
  { &hf_umts_rrc_ies_elevation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AzimuthAndElevation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AzimuthAndElevation, AzimuthAndElevation_sequence);

  return offset;
}


static const per_sequence_t AcquisitionSatInfo_sequence[] = {
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_doppler0thOrder, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M2048_2047 },
  { &hf_umts_rrc_ies_extraDopplerInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ExtraDopplerInfo },
  { &hf_umts_rrc_ies_codePhase, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1022 },
  { &hf_umts_rrc_ies_integerCodePhase, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_19 },
  { &hf_umts_rrc_ies_gps_BitNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { &hf_umts_rrc_ies_codePhaseSearchWindow, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CodePhaseSearchWindow },
  { &hf_umts_rrc_ies_azimuthAndElevation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AzimuthAndElevation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AcquisitionSatInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AcquisitionSatInfo, AcquisitionSatInfo_sequence);

  return offset;
}


static const per_sequence_t AcquisitionSatInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_AcquisitionSatInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AcquisitionSatInfo },
};

static int
dissect_umts_rrc_ies_AcquisitionSatInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AcquisitionSatInfoList, AcquisitionSatInfoList_sequence_of,
                                                  1, maxSat);

  return offset;
}



int
dissect_umts_rrc_ies_MeasurementIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 16U, NULL, FALSE);

  return offset;
}


static const per_sequence_t AdditionalMeasurementID_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_AdditionalMeasurementID_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementIdentity },
};

int
dissect_umts_rrc_ies_AdditionalMeasurementID_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AdditionalMeasurementID_List, AdditionalMeasurementID_List_sequence_of,
                                                  1, maxAdditionalMeas);

  return offset;
}


static const per_sequence_t AlmanacSatInfo_sequence[] = {
  { &hf_umts_rrc_ies_dataID , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_3 },
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_e      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_t_oa   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_deltaI , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_omegaDot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_satHealth, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_a_Sqrt , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_omega0 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_m0     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_omega  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_af0    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_11 },
  { &hf_umts_rrc_ies_af1    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_11 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_AlmanacSatInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_AlmanacSatInfo, AlmanacSatInfo_sequence);

  return offset;
}


static const per_sequence_t AlmanacSatInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_AlmanacSatInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AlmanacSatInfo },
};

static int
dissect_umts_rrc_ies_AlmanacSatInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_AlmanacSatInfoList, AlmanacSatInfoList_sequence_of,
                                                  1, maxSat);

  return offset;
}


static const value_string umts_rrc_ies_AverageRLC_BufferPayload_vals[] = {
  {   0, "pla0" },
  {   1, "pla4" },
  {   2, "pla8" },
  {   3, "pla16" },
  {   4, "pla32" },
  {   5, "pla64" },
  {   6, "pla128" },
  {   7, "pla256" },
  {   8, "pla512" },
  {   9, "pla1024" },
  {  10, "pla2k" },
  {  11, "pla4k" },
  {  12, "pla8k" },
  {  13, "pla16k" },
  {  14, "pla32k" },
  {  15, "pla64k" },
  {  16, "pla128k" },
  {  17, "pla256k" },
  {  18, "pla512k" },
  {  19, "pla1024k" },
  {  20, "spare12" },
  {  21, "spare11" },
  {  22, "spare10" },
  {  23, "spare9" },
  {  24, "spare8" },
  {  25, "spare7" },
  {  26, "spare6" },
  {  27, "spare5" },
  {  28, "spare4" },
  {  29, "spare3" },
  {  30, "spare2" },
  {  31, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_AverageRLC_BufferPayload(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     32, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t BadSatList_sequence_of[1] = {
  { &hf_umts_rrc_ies_BadSatList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
};

static int
dissect_umts_rrc_ies_BadSatList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_BadSatList, BadSatList_sequence_of,
                                                  1, maxSat);

  return offset;
}



static int
dissect_umts_rrc_ies_DL_TransportChannelBLER(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t BLER_MeasurementResults_sequence[] = {
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_dl_TransportChannelBLER, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DL_TransportChannelBLER },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_BLER_MeasurementResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_BLER_MeasurementResults, BLER_MeasurementResults_sequence);

  return offset;
}


static const per_sequence_t BLER_MeasurementResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_BLER_MeasurementResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BLER_MeasurementResults },
};

static int
dissect_umts_rrc_ies_BLER_MeasurementResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_BLER_MeasurementResultsList, BLER_MeasurementResultsList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t BLER_TransChIdList_sequence_of[1] = {
  { &hf_umts_rrc_ies_BLER_TransChIdList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
};

static int
dissect_umts_rrc_ies_BLER_TransChIdList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_BLER_TransChIdList, BLER_TransChIdList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const value_string umts_rrc_ies_BSIC_VerificationRequired_vals[] = {
  {   0, "required" },
  {   1, "notRequired" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_BSIC_VerificationRequired(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_maxCellMeas(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, maxCellMeas, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_BSICReported_vals[] = {
  {   0, "verifiedBSIC" },
  {   1, "nonVerifiedBSIC" },
  { 0, NULL }
};

static const per_choice_t BSICReported_choice[] = {
  {   0, &hf_umts_rrc_ies_verifiedBSIC, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_maxCellMeas },
  {   1, &hf_umts_rrc_ies_nonVerifiedBSIC, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_BCCH_ARFCN },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_BSICReported(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_BSICReported, BSICReported_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_10_25(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              10U, 25U, NULL, FALSE);

  return offset;
}


static const per_sequence_t BurstModeParameters_sequence[] = {
  { &hf_umts_rrc_ies_burstStart, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_burstLength, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_10_25 },
  { &hf_umts_rrc_ies_burstFreq, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_BurstModeParameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_BurstModeParameters, BurstModeParameters_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TriggeringCondition2_vals[] = {
  {   0, "activeSetCellsOnly" },
  {   1, "monitoredSetCellsOnly" },
  {   2, "activeSetAndMonitoredSetCells" },
  {   3, "detectedSetCellsOnly" },
  {   4, "detectedSetAndMonitoredSetCells" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TriggeringCondition2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_ReportingRange(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 29U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ForbiddenAffectCell_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t ForbiddenAffectCell_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd68  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  {   1, &hf_umts_rrc_ies_tdd24  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ForbiddenAffectCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ForbiddenAffectCell, ForbiddenAffectCell_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ForbiddenAffectCellList_sequence_of[1] = {
  { &hf_umts_rrc_ies_ForbiddenAffectCellList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ForbiddenAffectCell },
};

static int
dissect_umts_rrc_ies_ForbiddenAffectCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ForbiddenAffectCellList, ForbiddenAffectCellList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}



static int
dissect_umts_rrc_ies_W(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 20U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ReportDeactivationThreshold_vals[] = {
  {   0, "notApplicable" },
  {   1, "t1" },
  {   2, "t2" },
  {   3, "t3" },
  {   4, "t4" },
  {   5, "t5" },
  {   6, "t6" },
  {   7, "t7" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReportDeactivationThreshold(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ReportingAmount_vals[] = {
  {   0, "ra1" },
  {   1, "ra2" },
  {   2, "ra4" },
  {   3, "ra8" },
  {   4, "ra16" },
  {   5, "ra32" },
  {   6, "ra64" },
  {   7, "ra-Infinity" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReportingAmount(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ReportingInterval_vals[] = {
  {   0, "noPeriodicalreporting" },
  {   1, "ri0-25" },
  {   2, "ri0-5" },
  {   3, "ri1" },
  {   4, "ri2" },
  {   5, "ri4" },
  {   6, "ri8" },
  {   7, "ri16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReportingInterval(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t Event1a_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition2 },
  { &hf_umts_rrc_ies_reportingRange, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingRange },
  { &hf_umts_rrc_ies_forbiddenAffectCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ForbiddenAffectCellList },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_reportDeactivationThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportDeactivationThreshold },
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportingInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1a(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1a, Event1a_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TriggeringCondition1_vals[] = {
  {   0, "activeSetCellsOnly" },
  {   1, "monitoredSetCellsOnly" },
  {   2, "activeSetAndMonitoredSetCells" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TriggeringCondition1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t Event1b_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition1 },
  { &hf_umts_rrc_ies_reportingRange, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingRange },
  { &hf_umts_rrc_ies_forbiddenAffectCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ForbiddenAffectCellList },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1b, Event1b_sequence);

  return offset;
}


static const value_string umts_rrc_ies_ReplacementActivationThreshold_vals[] = {
  {   0, "notApplicable" },
  {   1, "t1" },
  {   2, "t2" },
  {   3, "t3" },
  {   4, "t4" },
  {   5, "t5" },
  {   6, "t6" },
  {   7, "t7" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReplacementActivationThreshold(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t Event1c_sequence[] = {
  { &hf_umts_rrc_ies_replacementActivationThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReplacementActivationThreshold },
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportingInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1c(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1c, Event1c_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_ThresholdUsedFrequency(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -115, 165U, NULL, FALSE);

  return offset;
}


static const per_sequence_t Event1e_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition2 },
  { &hf_umts_rrc_ies_thresholdUsedFrequency, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ThresholdUsedFrequency },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1e(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1e, Event1e_sequence);

  return offset;
}


static const per_sequence_t Event1f_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition1 },
  { &hf_umts_rrc_ies_thresholdUsedFrequency, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ThresholdUsedFrequency },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1f(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1f, Event1f_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqEvent_vals[] = {
  {   0, "e1a" },
  {   1, "e1b" },
  {   2, "e1c" },
  {   3, "e1d" },
  {   4, "e1e" },
  {   5, "e1f" },
  {   6, "e1g" },
  {   7, "e1h" },
  {   8, "e1i" },
  { 0, NULL }
};

static const per_choice_t IntraFreqEvent_choice[] = {
  {   0, &hf_umts_rrc_ies_e1a    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1a },
  {   1, &hf_umts_rrc_ies_e1b    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1b },
  {   2, &hf_umts_rrc_ies_e1c    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1c },
  {   3, &hf_umts_rrc_ies_e1d    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_e1e    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1e },
  {   5, &hf_umts_rrc_ies_e1f    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1f },
  {   6, &hf_umts_rrc_ies_e1g    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_e1h    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdUsedFrequency },
  {   8, &hf_umts_rrc_ies_e1i    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdUsedFrequency },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEvent(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_IntraFreqEvent, IntraFreqEvent_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_Hysteresis(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_TimeToTrigger_vals[] = {
  {   0, "ttt0" },
  {   1, "ttt10" },
  {   2, "ttt20" },
  {   3, "ttt40" },
  {   4, "ttt60" },
  {   5, "ttt80" },
  {   6, "ttt100" },
  {   7, "ttt120" },
  {   8, "ttt160" },
  {   9, "ttt200" },
  {  10, "ttt240" },
  {  11, "tt320" },
  {  12, "ttt640" },
  {  13, "ttt1280" },
  {  14, "ttt2560" },
  {  15, "ttt5000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TimeToTrigger(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNumberOfReportingCellsType1_vals[] = {
  {   0, "e1" },
  {   1, "e2" },
  {   2, "e3" },
  {   3, "e4" },
  {   4, "e5" },
  {   5, "e6" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     6, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNumberOfReportingCellsType3_vals[] = {
  {   0, "viactCellsPlus1" },
  {   1, "viactCellsPlus2" },
  {   2, "viactCellsPlus3" },
  {   3, "viactCellsPlus4" },
  {   4, "viactCellsPlus5" },
  {   5, "viactCellsPlus6" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNumberOfReportingCellsType3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     6, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_MaxNumberOfReportingCellsType2_vals[] = {
  {   0, "e1" },
  {   1, "e2" },
  {   2, "e3" },
  {   3, "e4" },
  {   4, "e5" },
  {   5, "e6" },
  {   6, "e7" },
  {   7, "e8" },
  {   8, "e9" },
  {   9, "e10" },
  {  10, "e11" },
  {  11, "e12" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxNumberOfReportingCellsType2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     12, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ReportingCellStatus_vals[] = {
  {   0, "withinActiveSet" },
  {   1, "withinMonitoredSetUsedFreq" },
  {   2, "withinActiveAndOrMonitoredUsedFreq" },
  {   3, "withinDetectedSetUsedFreq" },
  {   4, "withinMonitoredAndOrDetectedUsedFreq" },
  {   5, "allActiveplusMonitoredSet" },
  {   6, "allActivePlusDetectedSet" },
  {   7, "allActivePlusMonitoredAndOrDetectedSet" },
  {   8, "withinVirtualActSet" },
  {   9, "withinMonitoredSetNonUsedFreq" },
  {  10, "withinMonitoredAndOrVirtualActiveSetNonUsedFreq" },
  {  11, "allVirtualActSetplusMonitoredSetNonUsedFreq" },
  {  12, "withinActSetOrVirtualActSet-InterRATcells" },
  {  13, "withinActSetAndOrMonitoredUsedFreqOrVirtualActSetAndOrMonitoredNonUsedFreq" },
  { 0, NULL }
};

static const per_choice_t ReportingCellStatus_choice[] = {
  {   0, &hf_umts_rrc_ies_withinActiveSet, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {   1, &hf_umts_rrc_ies_withinMonitoredSetUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {   2, &hf_umts_rrc_ies_withinActiveAndOrMonitoredUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {   3, &hf_umts_rrc_ies_withinDetectedSetUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {   4, &hf_umts_rrc_ies_withinMonitoredAndOrDetectedUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {   5, &hf_umts_rrc_ies_allActiveplusMonitoredSet, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType3 },
  {   6, &hf_umts_rrc_ies_allActivePlusDetectedSet, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType3 },
  {   7, &hf_umts_rrc_ies_allActivePlusMonitoredAndOrDetectedSet, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType3 },
  {   8, &hf_umts_rrc_ies_withinVirtualActSet, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {   9, &hf_umts_rrc_ies_withinMonitoredSetNonUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {  10, &hf_umts_rrc_ies_withinMonitoredAndOrVirtualActiveSetNonUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType1 },
  {  11, &hf_umts_rrc_ies_allVirtualActSetplusMonitoredSetNonUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType3 },
  {  12, &hf_umts_rrc_ies_withinActSetOrVirtualActSet_InterRATcells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType2 },
  {  13, &hf_umts_rrc_ies_withinActSetAndOrMonitoredUsedFreqOrVirtualActSetAndOrMonitoredNonUsedFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxNumberOfReportingCellsType2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReportingCellStatus(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ReportingCellStatus, ReportingCellStatus_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraFreqEventCriteria_sequence[] = {
  { &hf_umts_rrc_ies_event  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqEvent },
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEventCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqEventCriteria, IntraFreqEventCriteria_sequence);

  return offset;
}


static const per_sequence_t IntraFreqEventCriteriaList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFreqEventCriteriaList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqEventCriteria },
};

static int
dissect_umts_rrc_ies_IntraFreqEventCriteriaList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFreqEventCriteriaList, IntraFreqEventCriteriaList_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t IntraFreqReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_eventCriteriaList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqEventCriteriaList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqReportingCriteria, IntraFreqReportingCriteria_sequence);

  return offset;
}


static const value_string umts_rrc_ies_ReportingIntervalLong_vals[] = {
  {   0, "ril0" },
  {   1, "ril0-25" },
  {   2, "ril0-5" },
  {   3, "ril1" },
  {   4, "ril2" },
  {   5, "ril3" },
  {   6, "ril4" },
  {   7, "ril6" },
  {   8, "ril8" },
  {   9, "ril12" },
  {  10, "ril16" },
  {  11, "ril20" },
  {  12, "ril24" },
  {  13, "ril28" },
  {  14, "ril32" },
  {  15, "ril64" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ReportingIntervalLong(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t PeriodicalReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportingInterval1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingIntervalLong },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PeriodicalReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PeriodicalReportingCriteria, PeriodicalReportingCriteria_sequence);

  return offset;
}


static const value_string umts_rrc_ies_CellDCH_ReportCriteria_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  { 0, NULL }
};

static const per_choice_t CellDCH_ReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellDCH_ReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_CellDCH_ReportCriteria, CellDCH_ReportCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ForbiddenAffectCell_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_tdd62  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ForbiddenAffectCell_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ForbiddenAffectCell_LCR_r4, ForbiddenAffectCell_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t ForbiddenAffectCellList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ForbiddenAffectCell_LCR_r4 },
};

static int
dissect_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4, ForbiddenAffectCellList_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t Event1a_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition2 },
  { &hf_umts_rrc_ies_reportingRange, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingRange },
  { &hf_umts_rrc_ies_forbiddenAffectCellList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4 },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_reportDeactivationThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportDeactivationThreshold },
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportingInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1a_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1a_LCR_r4, Event1a_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t Event1b_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition1 },
  { &hf_umts_rrc_ies_reportingRange, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingRange },
  { &hf_umts_rrc_ies_forbiddenAffectCellList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4 },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1b_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1b_LCR_r4, Event1b_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqEvent_LCR_r4_vals[] = {
  {   0, "e1a" },
  {   1, "e1b" },
  {   2, "e1c" },
  {   3, "e1d" },
  {   4, "e1e" },
  {   5, "e1f" },
  {   6, "e1g" },
  {   7, "e1h" },
  {   8, "e1i" },
  { 0, NULL }
};

static const per_choice_t IntraFreqEvent_LCR_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_e1a2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1a_LCR_r4 },
  {   1, &hf_umts_rrc_ies_e1b2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1b_LCR_r4 },
  {   2, &hf_umts_rrc_ies_e1c    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1c },
  {   3, &hf_umts_rrc_ies_e1d    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_e1e    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1e },
  {   5, &hf_umts_rrc_ies_e1f    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1f },
  {   6, &hf_umts_rrc_ies_e1g    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_e1h    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdUsedFrequency },
  {   8, &hf_umts_rrc_ies_e1i    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdUsedFrequency },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEvent_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_IntraFreqEvent_LCR_r4, IntraFreqEvent_LCR_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraFreqEventCriteria_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_event2 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqEvent_LCR_r4 },
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEventCriteria_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqEventCriteria_LCR_r4, IntraFreqEventCriteria_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqEventCriteriaList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqEventCriteria_LCR_r4 },
};

static int
dissect_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4, IntraFreqEventCriteriaList_LCR_r4_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t IntraFreqReportingCriteria_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_eventCriteriaList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportingCriteria_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqReportingCriteria_LCR_r4, IntraFreqReportingCriteria_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  { 0, NULL }
};

static const per_choice_t CellDCH_ReportCriteria_LCR_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqReportingCriteria_LCR_r4 },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4, CellDCH_ReportCriteria_LCR_r4_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_CellIndividualOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -20, 20U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_960(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 960U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_150(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 150U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_ReferenceTimeDifferenceToCell_vals[] = {
  {   0, "accuracy40" },
  {   1, "accuracy256" },
  {   2, "accuracy2560" },
  { 0, NULL }
};

static const per_choice_t ReferenceTimeDifferenceToCell_choice[] = {
  {   0, &hf_umts_rrc_ies_accuracy40, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_960 },
  {   1, &hf_umts_rrc_ies_accuracy256, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_150 },
  {   2, &hf_umts_rrc_ies_accuracy2560, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_15 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ReferenceTimeDifferenceToCell, ReferenceTimeDifferenceToCell_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd50_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd50(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd50, T_fdd50_sequence);

  return offset;
}


static const per_sequence_t TimeslotInfo_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_burstType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BurstType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TimeslotInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TimeslotInfo, TimeslotInfo_sequence);

  return offset;
}


static const per_sequence_t TimeslotInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TimeslotInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotInfo },
};

static int
dissect_umts_rrc_ies_TimeslotInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TimeslotInfoList, TimeslotInfoList_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t T_tdd42_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd42(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd42, T_tdd42_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo41_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo41_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd53  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd50 },
  {   1, &hf_umts_rrc_ies_tdd47  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd42 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo41(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo41, T_modeSpecificInfo41_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellInfo_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_modeSpecificInfo41, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo41 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfo, CellInfo_sequence);

  return offset;
}


static const per_sequence_t T_fdd51_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd51(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd51, T_fdd51_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd384_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotInfo },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo, SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t TimeslotInfo_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_timeslotNumber1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TimeslotInfo_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TimeslotInfo_LCR_r4, TimeslotInfo_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd128_item2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotInfo_LCR_r4 },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4, SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4_sequence_of,
                                                  1, maxTSLCR);

  return offset;
}


static const value_string umts_rrc_ies_TimeslotInfoList_r4_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t TimeslotInfoList_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38417, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo },
  {   1, &hf_umts_rrc_ies_tdd12819, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TimeslotInfoList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TimeslotInfoList_r4, TimeslotInfoList_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd43_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList_r4 },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd43(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd43, T_tdd43_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo42_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo42_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd54  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd51 },
  {   1, &hf_umts_rrc_ies_tdd48  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd43 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo42(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo42, T_modeSpecificInfo42_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_modeSpecificInfo42, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo42 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfo_r4, CellInfo_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd52_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd52(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd52, T_fdd52_sequence);

  return offset;
}


static const per_sequence_t T_tdd44_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd44(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd44, T_tdd44_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo43_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo43_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd55  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd52 },
  {   1, &hf_umts_rrc_ies_tdd49  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd44 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo43(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo43, T_modeSpecificInfo43_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_Q_OffsetS_N(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -50, 50U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd59_sequence[] = {
  { &hf_umts_rrc_ies_q_QualMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_QualMin },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd59(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd59, T_fdd59_sequence);

  return offset;
}


static const per_sequence_t T_tdd51_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd51(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd51, T_tdd51_sequence);

  return offset;
}


static const per_sequence_t T_gsm1_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm1, T_gsm1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo50_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  {   2, "gsm" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo50_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd63  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd59 },
  {   1, &hf_umts_rrc_ies_tdd57  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd51 },
  {   2, &hf_umts_rrc_ies_gsm1   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo50(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo50, T_modeSpecificInfo50_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoSIB_11_12_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_q_OffsetS_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_maxAllowedUL_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxAllowedUL_TX_Power },
  { &hf_umts_rrc_ies_modeSpecificInfo50, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo50 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_RSCP, CellSelectReselectInfoSIB_11_12_RSCP_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_modeSpecificInfo43, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo43 },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_RSCP, CellInfoSI_RSCP_sequence);

  return offset;
}


static const per_sequence_t TimeslotInfoList_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_TimeslotInfoList_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotInfo_LCR_r4 },
};

static int
dissect_umts_rrc_ies_TimeslotInfoList_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TimeslotInfoList_LCR_r4, TimeslotInfoList_LCR_r4_sequence_of,
                                                  1, maxTSLCR);

  return offset;
}


static const per_sequence_t CellInfoSI_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_primaryCCPCH_Info4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList_LCR_r4 },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_RSCP_LCR_r4, CellInfoSI_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd53_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd53(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd53, T_fdd53_sequence);

  return offset;
}


static const per_sequence_t T_tdd45_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd45(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd45, T_tdd45_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo44_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo44_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd56  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd53 },
  {   1, &hf_umts_rrc_ies_tdd50  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd45 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo44(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo44, T_modeSpecificInfo44_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd60_sequence[] = {
  { &hf_umts_rrc_ies_q_QualMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_QualMin },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd60(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd60, T_fdd60_sequence);

  return offset;
}


static const per_sequence_t T_tdd52_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd52(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd52, T_tdd52_sequence);

  return offset;
}


static const per_sequence_t T_gsm2_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm2, T_gsm2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo51_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  {   2, "gsm" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo51_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd64  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd60 },
  {   1, &hf_umts_rrc_ies_tdd58  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd52 },
  {   2, &hf_umts_rrc_ies_gsm2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo51(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo51, T_modeSpecificInfo51_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoSIB_11_12_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_q_Offset1S_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_q_Offset2S_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_maxAllowedUL_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxAllowedUL_TX_Power },
  { &hf_umts_rrc_ies_modeSpecificInfo51, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo51 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_ECN0, CellSelectReselectInfoSIB_11_12_ECN0_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_modeSpecificInfo44, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo44 },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_ECN0, CellInfoSI_ECN0_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_primaryCCPCH_Info4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList_LCR_r4 },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_ECN0_LCR_r4, CellInfoSI_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd54_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd54(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd54, T_fdd54_sequence);

  return offset;
}


static const per_sequence_t T_tdd46_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd46(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd46, T_tdd46_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo45_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo45_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd57  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd54 },
  {   1, &hf_umts_rrc_ies_tdd51  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd46 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo45(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo45, T_modeSpecificInfo45_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TemporaryOffset1_vals[] = {
  {   0, "to3" },
  {   1, "to6" },
  {   2, "to9" },
  {   3, "to12" },
  {   4, "to15" },
  {   5, "to18" },
  {   6, "to21" },
  {   7, "infinite" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TemporaryOffset1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PenaltyTime_RSCP_vals[] = {
  {   0, "notUsed" },
  {   1, "pt10" },
  {   2, "pt20" },
  {   3, "pt30" },
  {   4, "pt40" },
  {   5, "pt50" },
  {   6, "pt60" },
  { 0, NULL }
};

static const per_choice_t PenaltyTime_RSCP_choice[] = {
  {   0, &hf_umts_rrc_ies_notUsed, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_pt10   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffset1 },
  {   2, &hf_umts_rrc_ies_pt20   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffset1 },
  {   3, &hf_umts_rrc_ies_pt30   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffset1 },
  {   4, &hf_umts_rrc_ies_pt40   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffset1 },
  {   5, &hf_umts_rrc_ies_pt50   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffset1 },
  {   6, &hf_umts_rrc_ies_pt60   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffset1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PenaltyTime_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PenaltyTime_RSCP, PenaltyTime_RSCP_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HCS_CellReselectInformation_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_penaltyTime, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PenaltyTime_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HCS_CellReselectInformation_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HCS_CellReselectInformation_RSCP, HCS_CellReselectInformation_RSCP_sequence);

  return offset;
}


static const per_sequence_t HCS_NeighbouringCellInformation_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_hcs_PRIO, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_PRIO },
  { &hf_umts_rrc_ies_q_HCS  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_HCS },
  { &hf_umts_rrc_ies_hcs_CellReselectInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HCS_CellReselectInformation_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HCS_NeighbouringCellInformation_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HCS_NeighbouringCellInformation_RSCP, HCS_NeighbouringCellInformation_RSCP_sequence);

  return offset;
}


static const per_sequence_t T_fdd61_sequence[] = {
  { &hf_umts_rrc_ies_q_QualMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_QualMin },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd61(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd61, T_fdd61_sequence);

  return offset;
}


static const per_sequence_t T_tdd53_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd53(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd53, T_tdd53_sequence);

  return offset;
}


static const per_sequence_t T_gsm3_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm3, T_gsm3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo52_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  {   2, "gsm" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo52_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd65  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd61 },
  {   1, &hf_umts_rrc_ies_tdd59  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd53 },
  {   2, &hf_umts_rrc_ies_gsm3   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo52(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo52, T_modeSpecificInfo52_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoSIB_11_12_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_q_OffsetS_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_maxAllowedUL_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxAllowedUL_TX_Power },
  { &hf_umts_rrc_ies_hcs_NeighbouringCellInformation_RSCP, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_NeighbouringCellInformation_RSCP },
  { &hf_umts_rrc_ies_modeSpecificInfo52, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo52 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_RSCP, CellSelectReselectInfoSIB_11_12_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_modeSpecificInfo45, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo45 },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_HCS_RSCP, CellInfoSI_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_HCS_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_primaryCCPCH_Info4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList_LCR_r4 },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_HCS_RSCP_LCR_r4, CellInfoSI_HCS_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd55_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_primaryCPICH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_TX_Power },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_tx_DiversityIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd55(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd55, T_fdd55_sequence);

  return offset;
}


static const per_sequence_t T_tdd47_sequence[] = {
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd47(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd47, T_tdd47_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo46_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo46_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd58  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd55 },
  {   1, &hf_umts_rrc_ies_tdd52  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd47 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo46(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo46, T_modeSpecificInfo46_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TemporaryOffset2_vals[] = {
  {   0, "to2" },
  {   1, "to3" },
  {   2, "to4" },
  {   3, "to6" },
  {   4, "to8" },
  {   5, "to10" },
  {   6, "to12" },
  {   7, "infinite" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TemporaryOffset2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t TemporaryOffsetList_sequence[] = {
  { &hf_umts_rrc_ies_temporaryOffset1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TemporaryOffset1 },
  { &hf_umts_rrc_ies_temporaryOffset2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TemporaryOffset2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TemporaryOffsetList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TemporaryOffsetList, TemporaryOffsetList_sequence);

  return offset;
}


static const value_string umts_rrc_ies_PenaltyTime_ECN0_vals[] = {
  {   0, "notUsed" },
  {   1, "pt10" },
  {   2, "pt20" },
  {   3, "pt30" },
  {   4, "pt40" },
  {   5, "pt50" },
  {   6, "pt60" },
  { 0, NULL }
};

static const per_choice_t PenaltyTime_ECN0_choice[] = {
  {   0, &hf_umts_rrc_ies_notUsed, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_pt101  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffsetList },
  {   2, &hf_umts_rrc_ies_pt201  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffsetList },
  {   3, &hf_umts_rrc_ies_pt301  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffsetList },
  {   4, &hf_umts_rrc_ies_pt401  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffsetList },
  {   5, &hf_umts_rrc_ies_pt501  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffsetList },
  {   6, &hf_umts_rrc_ies_pt601  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TemporaryOffsetList },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PenaltyTime_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PenaltyTime_ECN0, PenaltyTime_ECN0_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t HCS_CellReselectInformation_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_penaltyTime1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PenaltyTime_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HCS_CellReselectInformation_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HCS_CellReselectInformation_ECN0, HCS_CellReselectInformation_ECN0_sequence);

  return offset;
}


static const per_sequence_t HCS_NeighbouringCellInformation_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_hcs_PRIO, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_PRIO },
  { &hf_umts_rrc_ies_q_HCS  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_HCS },
  { &hf_umts_rrc_ies_hcs_CellReselectInformation1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HCS_CellReselectInformation_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_HCS_NeighbouringCellInformation_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_HCS_NeighbouringCellInformation_ECN0, HCS_NeighbouringCellInformation_ECN0_sequence);

  return offset;
}


static const per_sequence_t T_fdd62_sequence[] = {
  { &hf_umts_rrc_ies_q_QualMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_QualMin },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd62(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd62, T_fdd62_sequence);

  return offset;
}


static const per_sequence_t T_tdd54_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd54(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd54, T_tdd54_sequence);

  return offset;
}


static const per_sequence_t T_gsm4_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm4, T_gsm4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo53_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  {   2, "gsm" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo53_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd66  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd62 },
  {   1, &hf_umts_rrc_ies_tdd60  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd54 },
  {   2, &hf_umts_rrc_ies_gsm4   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo53(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo53, T_modeSpecificInfo53_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoSIB_11_12_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_q_Offset1S_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_q_Offset2S_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_maxAllowedUL_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxAllowedUL_TX_Power },
  { &hf_umts_rrc_ies_hcs_NeighbouringCellInformation_ECN0, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_NeighbouringCellInformation_ECN0 },
  { &hf_umts_rrc_ies_modeSpecificInfo53, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo53 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_ECN0, CellSelectReselectInfoSIB_11_12_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_modeSpecificInfo46, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo46 },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_HCS_ECN0, CellInfoSI_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t CellInfoSI_HCS_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_cellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIndividualOffset },
  { &hf_umts_rrc_ies_referenceTimeDifferenceToCell, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceTimeDifferenceToCell },
  { &hf_umts_rrc_ies_primaryCCPCH_Info4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 },
  { &hf_umts_rrc_ies_primaryCCPCH_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_TX_Power },
  { &hf_umts_rrc_ies_timeslotInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotInfoList_LCR_r4 },
  { &hf_umts_rrc_ies_readSFN_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellInfoSI_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellInfoSI_HCS_ECN0_LCR_r4, CellInfoSI_HCS_ECN0_LCR_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 16777215U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_SFN_SFN_ObsTimeDifference_vals[] = {
  {   0, "type1" },
  {   1, "type2" },
  { 0, NULL }
};

static const per_choice_t SFN_SFN_ObsTimeDifference_choice[] = {
  {   0, &hf_umts_rrc_ies_type13 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference1 },
  {   1, &hf_umts_rrc_ies_type22 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SFN_SFN_ObsTimeDifference, SFN_SFN_ObsTimeDifference_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CountC_SFN_Frame_difference_sequence[] = {
  { &hf_umts_rrc_ies_countC_SFN_High, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_off    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CountC_SFN_Frame_difference(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CountC_SFN_Frame_difference, CountC_SFN_Frame_difference_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_38399(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 38399U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd63_sequence[] = {
  { &hf_umts_rrc_ies_countC_SFN_Frame_difference, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CountC_SFN_Frame_difference },
  { &hf_umts_rrc_ies_tm     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_38399 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd63(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd63, T_fdd63_sequence);

  return offset;
}


static const per_sequence_t T_tdd55_sequence[] = {
  { &hf_umts_rrc_ies_countC_SFN_Frame_difference, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CountC_SFN_Frame_difference },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd55(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd55, T_tdd55_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo54_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo54_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd67  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd63 },
  {   1, &hf_umts_rrc_ies_tdd61  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd55 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo54(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo54, T_modeSpecificInfo54_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellSynchronisationInfo_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo54, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo54 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSynchronisationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSynchronisationInfo, CellSynchronisationInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_CPICH_Ec_N0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_CPICH_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_Pathloss(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              46U, 173U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd56_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_cpich_Ec_N01, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CPICH_Ec_N0 },
  { &hf_umts_rrc_ies_cpich_RSCP1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CPICH_RSCP },
  { &hf_umts_rrc_ies_pathloss, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Pathloss },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd56(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd56, T_fdd56_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_PrimaryCCPCH_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeslotISCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TimeslotISCP_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_TimeslotISCP_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotISCP },
};

static int
dissect_umts_rrc_ies_TimeslotISCP_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TimeslotISCP_List, TimeslotISCP_List_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t T_tdd48_sequence[] = {
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_proposedTGSN, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TGSN },
  { &hf_umts_rrc_ies_primaryCCPCH_RSCP, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_RSCP },
  { &hf_umts_rrc_ies_pathloss, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Pathloss },
  { &hf_umts_rrc_ies_timeslotISCP_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotISCP_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd48(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd48, T_tdd48_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo47_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo47_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd59  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd56 },
  {   1, &hf_umts_rrc_ies_tdd53  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd48 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo47(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo47, T_modeSpecificInfo47_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellMeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_cellIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellIdentity },
  { &hf_umts_rrc_ies_dummy_SFN_SFN_ObsTimeDifference, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference },
  { &hf_umts_rrc_ies_cellSynchronisationInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSynchronisationInfo },
  { &hf_umts_rrc_ies_modeSpecificInfo47, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo47 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellMeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellMeasuredResults, CellMeasuredResults_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info_sequence_of[1] = {
  { &hf_umts_rrc_ies_fdd_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info, SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info_sequence_of[1] = {
  { &hf_umts_rrc_ies_tdd_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info, SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_CellMeasurementEventResults_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t CellMeasurementEventResults_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd60  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info },
  {   1, &hf_umts_rrc_ies_tdd54  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellMeasurementEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_CellMeasurementEventResults, CellMeasurementEventResults_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellMeasurementEventResults_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_CellMeasurementEventResults_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4 },
};

static int
dissect_umts_rrc_ies_CellMeasurementEventResults_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CellMeasurementEventResults_LCR_r4, CellMeasurementEventResults_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_SFN_SFN_OTD_Type_vals[] = {
  {   0, "noReport" },
  {   1, "type1" },
  {   2, "type2" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SFN_SFN_OTD_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd57_sequence[] = {
  { &hf_umts_rrc_ies_cpich_Ec_N0_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cpich_RSCP_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_pathloss_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd57(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd57, T_fdd57_sequence);

  return offset;
}


static const per_sequence_t T_tdd49_sequence[] = {
  { &hf_umts_rrc_ies_timeslotISCP_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_proposedTGSN_ReportingRequired, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_primaryCCPCH_RSCP_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_pathloss_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd49(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd49, T_tdd49_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo48_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo48_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd61  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd57 },
  {   1, &hf_umts_rrc_ies_tdd55  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd49 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo48(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo48, T_modeSpecificInfo48_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellReportingQuantities_sequence[] = {
  { &hf_umts_rrc_ies_dummy_SFN_SFN_OTD_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SFN_SFN_OTD_Type },
  { &hf_umts_rrc_ies_cellIdentity_reportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellSynchronisationInfoReportingIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_modeSpecificInfo48, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo48 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellReportingQuantities(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellReportingQuantities, CellReportingQuantities_sequence);

  return offset;
}


static const per_sequence_t T_fdd58_sequence[] = {
  { &hf_umts_rrc_ies_q_QualMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_QualMin },
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd58(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd58, T_fdd58_sequence);

  return offset;
}


static const per_sequence_t T_tdd50_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd50(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd50, T_tdd50_sequence);

  return offset;
}


static const per_sequence_t T_gsm_sequence[] = {
  { &hf_umts_rrc_ies_q_RxlevMin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_RxlevMin },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm, T_gsm_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo49_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  {   2, "gsm" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo49_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd62  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd58 },
  {   1, &hf_umts_rrc_ies_tdd56  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd50 },
  {   2, &hf_umts_rrc_ies_gsm    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo49(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo49, T_modeSpecificInfo49_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoSIB_11_12_sequence[] = {
  { &hf_umts_rrc_ies_q_Offset1S_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_q_Offset2S_N, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_OffsetS_N },
  { &hf_umts_rrc_ies_maxAllowedUL_TX_Power, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxAllowedUL_TX_Power },
  { &hf_umts_rrc_ies_hcs_NeighbouringCellInformation_RSCP, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_HCS_NeighbouringCellInformation_RSCP },
  { &hf_umts_rrc_ies_modeSpecificInfo49, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo49 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12, CellSelectReselectInfoSIB_11_12_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaQrxlevmin(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -2, -1, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_DeltaRSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -5, -1, NULL, FALSE);

  return offset;
}


static const per_sequence_t CellSelectReselectInfo_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_deltaQrxlevmin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaQrxlevmin },
  { &hf_umts_rrc_ies_deltaQhcs, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaRSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfo_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfo_v590ext, CellSelectReselectInfo_v590ext_sequence);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoPCHFACH_v5b0ext_sequence[] = {
  { &hf_umts_rrc_ies_q_Hyst_l_S_PCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_Hyst_S_Fine },
  { &hf_umts_rrc_ies_q_Hyst_l_S_FACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_Hyst_S_Fine },
  { &hf_umts_rrc_ies_q_Hyst_2_S_PCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_Hyst_S_Fine },
  { &hf_umts_rrc_ies_q_Hyst_2_S_FACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Q_Hyst_S_Fine },
  { &hf_umts_rrc_ies_t_Reselection_S_PCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_Reselection_S },
  { &hf_umts_rrc_ies_t_Reselection_S_FACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_Reselection_S_Fine },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoPCHFACH_v5b0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoPCHFACH_v5b0ext, CellSelectReselectInfoPCHFACH_v5b0ext_sequence);

  return offset;
}


static const per_sequence_t CellSelectReselectInfoTreselectionScaling_v5c0ext_sequence[] = {
  { &hf_umts_rrc_ies_non_HCS_t_CR_Max, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_CRMax },
  { &hf_umts_rrc_ies_speedDependentScalingFactor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SpeedDependentScalingFactor },
  { &hf_umts_rrc_ies_interFrequencyTreselectionScalingFactor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TreselectionScalingFactor },
  { &hf_umts_rrc_ies_interRATTreselectionScalingFactor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TreselectionScalingFactor },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellSelectReselectInfoTreselectionScaling_v5c0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellSelectReselectInfoTreselectionScaling_v5c0ext, CellSelectReselectInfoTreselectionScaling_v5c0ext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_InterFreqCellID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, maxCellMeas1, NULL, FALSE);

  return offset;
}


static const per_sequence_t CellsForInterFreqMeasList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CellsForInterFreqMeasList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCellID },
};

static int
dissect_umts_rrc_ies_CellsForInterFreqMeasList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CellsForInterFreqMeasList, CellsForInterFreqMeasList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}



static int
dissect_umts_rrc_ies_InterRATCellID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, maxCellMeas1, NULL, FALSE);

  return offset;
}


static const per_sequence_t CellsForInterRATMeasList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CellsForInterRATMeasList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATCellID },
};

static int
dissect_umts_rrc_ies_CellsForInterRATMeasList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CellsForInterRATMeasList, CellsForInterRATMeasList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}



int
dissect_umts_rrc_ies_IntraFreqCellID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, maxCellMeas1, NULL, FALSE);

  return offset;
}


static const per_sequence_t CellsForIntraFreqMeasList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CellsForIntraFreqMeasList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqCellID },
};

static int
dissect_umts_rrc_ies_CellsForIntraFreqMeasList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CellsForIntraFreqMeasList, CellsForIntraFreqMeasList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t CellToReport_sequence[] = {
  { &hf_umts_rrc_ies_bsicReported, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BSICReported },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CellToReport(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CellToReport, CellToReport_sequence);

  return offset;
}


static const per_sequence_t CellToReportList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CellToReportList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellToReport },
};

static int
dissect_umts_rrc_ies_CellToReportList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CellToReportList, CellToReportList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaPRC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -127, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DeltaRSCPPerCell_sequence[] = {
  { &hf_umts_rrc_ies_deltaRSCP, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaRSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DeltaRSCPPerCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DeltaRSCPPerCell, DeltaRSCPPerCell_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_DeltaRRC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -7, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_IODE(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_UDRE_vals[] = {
  {   0, "lessThan1" },
  {   1, "between1-and-4" },
  {   2, "between4-and-8" },
  {   3, "over8" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UDRE(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_PRC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -2047, 2047U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_RRC(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -127, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DGPS_CorrectionSatInfo_sequence[] = {
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_iode   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IODE },
  { &hf_umts_rrc_ies_udre   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UDRE },
  { &hf_umts_rrc_ies_prc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRC },
  { &hf_umts_rrc_ies_rrc    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RRC },
  { &hf_umts_rrc_ies_dummy1_DeltaPRC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaPRC },
  { &hf_umts_rrc_ies_dummy2_DeltaPRC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaRRC },
  { &hf_umts_rrc_ies_dummy3_DeltaPRC, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaPRC },
  { &hf_umts_rrc_ies_dummy4_DeltaPRC, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DeltaRRC },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_DGPS_CorrectionSatInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_DGPS_CorrectionSatInfo, DGPS_CorrectionSatInfo_sequence);

  return offset;
}


static const per_sequence_t DGPS_CorrectionSatInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_DGPS_CorrectionSatInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DGPS_CorrectionSatInfo },
};

static int
dissect_umts_rrc_ies_DGPS_CorrectionSatInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_DGPS_CorrectionSatInfoList, DGPS_CorrectionSatInfoList_sequence_of,
                                                  1, maxSat);

  return offset;
}


static const value_string umts_rrc_ies_DiffCorrectionStatus_vals[] = {
  {   0, "udre-1-0" },
  {   1, "udre-0-75" },
  {   2, "udre-0-5" },
  {   3, "udre-0-3" },
  {   4, "udre-0-2" },
  {   5, "udre-0-1" },
  {   6, "noData" },
  {   7, "invalidData" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_DiffCorrectionStatus(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_latitudeSign_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_latitudeSign(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_8388607(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8388607U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M8388608_8388607(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -8388608, 8388607U, NULL, FALSE);

  return offset;
}


static const per_sequence_t EllipsoidPoint_sequence[] = {
  { &hf_umts_rrc_ies_latitudeSign, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_latitudeSign },
  { &hf_umts_rrc_ies_latitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_8388607 },
  { &hf_umts_rrc_ies_longitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M8388608_8388607 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_EllipsoidPoint(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_EllipsoidPoint, EllipsoidPoint_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_latitudeSign1_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_latitudeSign1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_altitudeDirection_vals[] = {
  {   0, "height" },
  {   1, "depth" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_altitudeDirection(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_32767(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 32767U, NULL, FALSE);

  return offset;
}


static const per_sequence_t EllipsoidPointAltitude_sequence[] = {
  { &hf_umts_rrc_ies_latitudeSign1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_latitudeSign1 },
  { &hf_umts_rrc_ies_latitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_8388607 },
  { &hf_umts_rrc_ies_longitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M8388608_8388607 },
  { &hf_umts_rrc_ies_altitudeDirection, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_altitudeDirection },
  { &hf_umts_rrc_ies_altitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_32767 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_EllipsoidPointAltitude(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_EllipsoidPointAltitude, EllipsoidPointAltitude_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_latitudeSign2_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_latitudeSign2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_altitudeDirection1_vals[] = {
  {   0, "height" },
  {   1, "depth" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_altitudeDirection1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_89(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 89U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_100(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 100U, NULL, FALSE);

  return offset;
}


static const per_sequence_t EllipsoidPointAltitudeEllipsoide_sequence[] = {
  { &hf_umts_rrc_ies_latitudeSign2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_latitudeSign2 },
  { &hf_umts_rrc_ies_latitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_8388607 },
  { &hf_umts_rrc_ies_longitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M8388608_8388607 },
  { &hf_umts_rrc_ies_altitudeDirection1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_altitudeDirection1 },
  { &hf_umts_rrc_ies_altitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_32767 },
  { &hf_umts_rrc_ies_uncertaintySemiMajor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_uncertaintySemiMinor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_orientationMajorAxis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_89 },
  { &hf_umts_rrc_ies_uncertaintyAltitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_confidence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_100 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_EllipsoidPointAltitudeEllipsoide(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_EllipsoidPointAltitudeEllipsoide, EllipsoidPointAltitudeEllipsoide_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_latitudeSign3_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_latitudeSign3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t EllipsoidPointUncertCircle_sequence[] = {
  { &hf_umts_rrc_ies_latitudeSign3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_latitudeSign3 },
  { &hf_umts_rrc_ies_latitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_8388607 },
  { &hf_umts_rrc_ies_longitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M8388608_8388607 },
  { &hf_umts_rrc_ies_uncertaintyCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_EllipsoidPointUncertCircle(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_EllipsoidPointUncertCircle, EllipsoidPointUncertCircle_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_latitudeSign4_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_latitudeSign4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t EllipsoidPointUncertEllipse_sequence[] = {
  { &hf_umts_rrc_ies_latitudeSign4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_latitudeSign4 },
  { &hf_umts_rrc_ies_latitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_8388607 },
  { &hf_umts_rrc_ies_longitude, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M8388608_8388607 },
  { &hf_umts_rrc_ies_uncertaintySemiMajor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_uncertaintySemiMinor, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_orientationMajorAxis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_89 },
  { &hf_umts_rrc_ies_confidence, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_100 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_EllipsoidPointUncertEllipse(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_EllipsoidPointUncertEllipse, EllipsoidPointUncertEllipse_sequence);

  return offset;
}


static const value_string umts_rrc_ies_EnvironmentCharacterisation_vals[] = {
  {   0, "possibleHeavyMultipathNLOS" },
  {   1, "lightMultipathLOS" },
  {   2, "notDefined" },
  {   3, "spare" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_EnvironmentCharacterisation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ForbiddenAffectCell_r4_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t ForbiddenAffectCell_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd68  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  {   1, &hf_umts_rrc_ies_tdd25  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCCPCH_Info_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ForbiddenAffectCell_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ForbiddenAffectCell_r4, ForbiddenAffectCell_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ForbiddenAffectCellList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_ForbiddenAffectCellList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ForbiddenAffectCell_r4 },
};

static int
dissect_umts_rrc_ies_ForbiddenAffectCellList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ForbiddenAffectCellList_r4, ForbiddenAffectCellList_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t Event1a_r4_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition2 },
  { &hf_umts_rrc_ies_reportingRange, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingRange },
  { &hf_umts_rrc_ies_forbiddenAffectCellList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ForbiddenAffectCellList_r4 },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_reportDeactivationThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportDeactivationThreshold },
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportingInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1a_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1a_r4, Event1a_r4_sequence);

  return offset;
}


static const per_sequence_t Event1b_r4_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TriggeringCondition1 },
  { &hf_umts_rrc_ies_reportingRange, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingRange },
  { &hf_umts_rrc_ies_forbiddenAffectCellList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ForbiddenAffectCellList_r4 },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event1b_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event1b_r4, Event1b_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_Threshold(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -115, 0U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_HysteresisInterFreq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 29U, NULL, FALSE);

  return offset;
}


static const per_sequence_t NonUsedFreqParameter_sequence[] = {
  { &hf_umts_rrc_ies_nonUsedFreqThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_nonUsedFreqW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NonUsedFreqParameter(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NonUsedFreqParameter, NonUsedFreqParameter_sequence);

  return offset;
}


static const per_sequence_t NonUsedFreqParameterList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NonUsedFreqParameterList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NonUsedFreqParameter },
};

static int
dissect_umts_rrc_ies_NonUsedFreqParameterList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NonUsedFreqParameterList, NonUsedFreqParameterList_sequence_of,
                                                  1, maxFreq);

  return offset;
}


static const per_sequence_t Event2a_sequence[] = {
  { &hf_umts_rrc_ies_dummy_Threshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_usedFreqW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_hysteresis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HysteresisInterFreq },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { &hf_umts_rrc_ies_nonUsedFreqParameterList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NonUsedFreqParameterList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event2a(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event2a, Event2a_sequence);

  return offset;
}


static const per_sequence_t Event2b_sequence[] = {
  { &hf_umts_rrc_ies_usedFreqThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_usedFreqW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_hysteresis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HysteresisInterFreq },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { &hf_umts_rrc_ies_nonUsedFreqParameterList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NonUsedFreqParameterList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event2b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event2b, Event2b_sequence);

  return offset;
}


static const per_sequence_t Event2c_sequence[] = {
  { &hf_umts_rrc_ies_hysteresis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HysteresisInterFreq },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { &hf_umts_rrc_ies_nonUsedFreqParameterList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NonUsedFreqParameterList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event2c(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event2c, Event2c_sequence);

  return offset;
}


static const per_sequence_t Event2d_sequence[] = {
  { &hf_umts_rrc_ies_usedFreqThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_usedFreqW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_hysteresis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HysteresisInterFreq },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event2d(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event2d, Event2d_sequence);

  return offset;
}


static const per_sequence_t Event2e_sequence[] = {
  { &hf_umts_rrc_ies_hysteresis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HysteresisInterFreq },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { &hf_umts_rrc_ies_nonUsedFreqParameterList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NonUsedFreqParameterList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event2e(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event2e, Event2e_sequence);

  return offset;
}


static const per_sequence_t Event2f_sequence[] = {
  { &hf_umts_rrc_ies_usedFreqThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_usedFreqW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_hysteresis, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_HysteresisInterFreq },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event2f(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event2f, Event2f_sequence);

  return offset;
}


static const per_sequence_t Event3a_sequence[] = {
  { &hf_umts_rrc_ies_thresholdOwnSystem, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_w      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_W },
  { &hf_umts_rrc_ies_thresholdOtherSystem, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event3a(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event3a, Event3a_sequence);

  return offset;
}


static const per_sequence_t Event3b_sequence[] = {
  { &hf_umts_rrc_ies_thresholdOtherSystem, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event3b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event3b, Event3b_sequence);

  return offset;
}


static const per_sequence_t Event3c_sequence[] = {
  { &hf_umts_rrc_ies_thresholdOtherSystem, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Threshold },
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event3c(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event3c, Event3c_sequence);

  return offset;
}


static const per_sequence_t Event3d_sequence[] = {
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Event3d(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Event3d, Event3d_sequence);

  return offset;
}


static const value_string umts_rrc_ies_EventIDInterFreq_vals[] = {
  {   0, "e2a" },
  {   1, "e2b" },
  {   2, "e2c" },
  {   3, "e2d" },
  {   4, "e2e" },
  {   5, "e2f" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_EventIDInterFreq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_EventIDInterRAT_vals[] = {
  {   0, "e3a" },
  {   1, "e3b" },
  {   2, "e3c" },
  {   3, "e3d" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_EventIDInterRAT(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_EventIDIntraFreq_vals[] = {
  {   0, "e1a" },
  {   1, "e1b" },
  {   2, "e1c" },
  {   3, "e1d" },
  {   4, "e1e" },
  {   5, "e1f" },
  {   6, "e1g" },
  {   7, "e1h" },
  {   8, "e1i" },
  {   9, "spare7" },
  {  10, "spare6" },
  {  11, "spare5" },
  {  12, "spare4" },
  {  13, "spare3" },
  {  14, "spare2" },
  {  15, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_EventIDIntraFreq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IntraFreqEventResults_sequence[] = {
  { &hf_umts_rrc_ies_eventID2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_EventIDIntraFreq },
  { &hf_umts_rrc_ies_cellMeasurementEventResults, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellMeasurementEventResults },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqEventResults, IntraFreqEventResults_sequence);

  return offset;
}


static const per_sequence_t InterFreqCell_sequence[] = {
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_nonFreqRelatedEventResults, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellMeasurementEventResults },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCell, InterFreqCell_sequence);

  return offset;
}


static const per_sequence_t InterFreqCellList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqCellList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCell },
};

static int
dissect_umts_rrc_ies_InterFreqCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqCellList, InterFreqCellList_sequence_of,
                                                  1, maxFreq);

  return offset;
}


static const per_sequence_t InterFreqEventResults_sequence[] = {
  { &hf_umts_rrc_ies_eventID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_EventIDInterFreq },
  { &hf_umts_rrc_ies_interFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqEventResults, InterFreqEventResults_sequence);

  return offset;
}


static const per_sequence_t InterRATEventResults_sequence[] = {
  { &hf_umts_rrc_ies_eventID1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_EventIDInterRAT },
  { &hf_umts_rrc_ies_cellToReportList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellToReportList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATEventResults, InterRATEventResults_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UL_TrCH_Identity_vals[] = {
  {   0, "dch" },
  {   1, "rachorcpch" },
  {   2, "usch" },
  { 0, NULL }
};

static const per_choice_t UL_TrCH_Identity_choice[] = {
  {   0, &hf_umts_rrc_ies_dch    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  {   1, &hf_umts_rrc_ies_rachorcpch, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_usch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TransportChannelIdentity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UL_TrCH_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UL_TrCH_Identity, UL_TrCH_Identity_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TrafficVolumeEventType_vals[] = {
  {   0, "e4a" },
  {   1, "e4b" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TrafficVolumeEventType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t TrafficVolumeEventResults_sequence[] = {
  { &hf_umts_rrc_ies_ul_transportChannelCausingEvent, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Identity },
  { &hf_umts_rrc_ies_trafficVolumeEventIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeEventType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeEventResults, TrafficVolumeEventResults_sequence);

  return offset;
}


static const per_sequence_t QualityEventResults_sequence_of[1] = {
  { &hf_umts_rrc_ies_QualityEventResults_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
};

static int
dissect_umts_rrc_ies_QualityEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_QualityEventResults, QualityEventResults_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const value_string umts_rrc_ies_UE_InternalEventResults_vals[] = {
  {   0, "event6a" },
  {   1, "event6b" },
  {   2, "event6c" },
  {   3, "event6d" },
  {   4, "event6e" },
  {   5, "event6f" },
  {   6, "event6g" },
  {   7, "spare" },
  { 0, NULL }
};

static const per_choice_t UE_InternalEventResults_choice[] = {
  {   0, &hf_umts_rrc_ies_event6a1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_event6b1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_event6c1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_event6d1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_event6e1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   5, &hf_umts_rrc_ies_event6f1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  {   6, &hf_umts_rrc_ies_event6g1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  {   7, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_InternalEventResults, UE_InternalEventResults_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_16383(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 16383U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_4294967295(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 4294967295U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ue_GPSTimingOfCell_sequence[] = {
  { &hf_umts_rrc_ies_ms_part1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_16383 },
  { &hf_umts_rrc_ies_ls_part, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4294967295 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ue_GPSTimingOfCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ue_GPSTimingOfCell, T_ue_GPSTimingOfCell_sequence);

  return offset;
}


static const per_sequence_t T_fdd86_sequence[] = {
  { &hf_umts_rrc_ies_referenceIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd86(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd86, T_fdd86_sequence);

  return offset;
}


static const per_sequence_t T_tdd79_sequence[] = {
  { &hf_umts_rrc_ies_referenceIdentity1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd79(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd79, T_tdd79_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo79_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo79_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd91  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd86 },
  {   1, &hf_umts_rrc_ies_tdd86  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd79 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo79(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo79, T_modeSpecificInfo79_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UTRAN_GPSReferenceTimeResult_sequence[] = {
  { &hf_umts_rrc_ies_ue_GPSTimingOfCell, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ue_GPSTimingOfCell },
  { &hf_umts_rrc_ies_modeSpecificInfo79, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo79 },
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UTRAN_GPSReferenceTimeResult(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UTRAN_GPSReferenceTimeResult, UTRAN_GPSReferenceTimeResult_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_604799999(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 604799999U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_fdd84_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd84(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd84, T_fdd84_sequence);

  return offset;
}


static const per_sequence_t T_tdd77_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd77(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd77, T_tdd77_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo77_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo77_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd89  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd84 },
  {   1, &hf_umts_rrc_ies_tdd84  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd77 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo77(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo77, T_modeSpecificInfo77_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_cell_Timing_sequence[] = {
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_modeSpecificInfo77, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo77 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cell_Timing(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cell_Timing, T_cell_Timing_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_referenceTime1_vals[] = {
  {   0, "utran-GPSReferenceTimeResult" },
  {   1, "gps-ReferenceTimeOnly" },
  {   2, "cell-Timing" },
  { 0, NULL }
};

static const per_choice_t T_referenceTime1_choice[] = {
  {   0, &hf_umts_rrc_ies_utran_GPSReferenceTimeResult, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UTRAN_GPSReferenceTimeResult },
  {   1, &hf_umts_rrc_ies_gps_ReferenceTimeOnly, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_604799999 },
  {   2, &hf_umts_rrc_ies_cell_Timing, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cell_Timing },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_referenceTime1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_referenceTime1, T_referenceTime1_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_PositionEstimate_vals[] = {
  {   0, "ellipsoidPoint" },
  {   1, "ellipsoidPointUncertCircle" },
  {   2, "ellipsoidPointUncertEllipse" },
  {   3, "ellipsoidPointAltitude" },
  {   4, "ellipsoidPointAltitudeEllipse" },
  { 0, NULL }
};

static const per_choice_t PositionEstimate_choice[] = {
  {   0, &hf_umts_rrc_ies_ellipsoidPoint, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPoint },
  {   1, &hf_umts_rrc_ies_ellipsoidPointUncertCircle, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPointUncertCircle },
  {   2, &hf_umts_rrc_ies_ellipsoidPointUncertEllipse, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPointUncertEllipse },
  {   3, &hf_umts_rrc_ies_ellipsoidPointAltitude, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPointAltitude },
  {   4, &hf_umts_rrc_ies_ellipsoidPointAltitudeEllipse, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPointAltitudeEllipsoide },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_PositionEstimate(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_PositionEstimate, PositionEstimate_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_PositionEstimateInfo_sequence[] = {
  { &hf_umts_rrc_ies_referenceTime1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_referenceTime1 },
  { &hf_umts_rrc_ies_positionEstimate, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositionEstimate },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_PositionEstimateInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_PositionEstimateInfo, UE_Positioning_PositionEstimateInfo_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 8191U, NULL, FALSE);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_Quality_sequence[] = {
  { &hf_umts_rrc_ies_stdResolution, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_2 },
  { &hf_umts_rrc_ies_numberOfOTDOA_Measurements, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_3 },
  { &hf_umts_rrc_ies_stdOfOTDOA_Measurements, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_Quality(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_Quality, UE_Positioning_OTDOA_Quality_sequence);

  return offset;
}


static const per_sequence_t NeighbourQuality_sequence[] = {
  { &hf_umts_rrc_ies_ue_Positioning_OTDOA_Quality, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_Quality },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NeighbourQuality(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NeighbourQuality, NeighbourQuality_sequence);

  return offset;
}


static const per_sequence_t UE_RX_TX_TimeDifferenceType2Info_sequence[] = {
  { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2 },
  { &hf_umts_rrc_ies_neighbourQuality, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NeighbourQuality },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2Info(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2Info, UE_RX_TX_TimeDifferenceType2Info_sequence);

  return offset;
}


static const per_sequence_t T_fdd77_sequence[] = {
  { &hf_umts_rrc_ies_referenceCellIDentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType2Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd77(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd77, T_fdd77_sequence);

  return offset;
}


static const per_sequence_t T_tdd70_sequence[] = {
  { &hf_umts_rrc_ies_referenceCellIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd70(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd70, T_tdd70_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo70_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo70_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd82  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd77 },
  {   1, &hf_umts_rrc_ies_tdd77  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd70 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo70(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo70, T_modeSpecificInfo70_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd70_sequence[] = {
  { &hf_umts_rrc_ies_neighbourIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_uE_RX_TX_TimeDifferenceType2Info, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd70(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd70, T_fdd70_sequence);

  return offset;
}


static const per_sequence_t T_tdd62_sequence[] = {
  { &hf_umts_rrc_ies_neighbourAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd62(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd62, T_tdd62_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo61_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo61_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd75  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd70 },
  {   1, &hf_umts_rrc_ies_tdd69  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd62 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo61(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo61, T_modeSpecificInfo61_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t Neighbour_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo61, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo61 },
  { &hf_umts_rrc_ies_neighbourQuality, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NeighbourQuality },
  { &hf_umts_rrc_ies_sfn_SFN_ObsTimeDifference2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Neighbour(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Neighbour, Neighbour_sequence);

  return offset;
}


static const per_sequence_t NeighbourList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NeighbourList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Neighbour },
};

static int
dissect_umts_rrc_ies_NeighbourList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NeighbourList, NeighbourList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_Measurement_sequence[] = {
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_modeSpecificInfo70, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo70 },
  { &hf_umts_rrc_ies_neighbourList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NeighbourList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_Measurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_Measurement, UE_Positioning_OTDOA_Measurement_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_referenceTime_vals[] = {
  {   0, "utran-GPSReferenceTimeResult" },
  {   1, "gps-ReferenceTimeOnly" },
  { 0, NULL }
};

static const per_choice_t T_referenceTime_choice[] = {
  {   0, &hf_umts_rrc_ies_utran_GPSReferenceTimeResult, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UTRAN_GPSReferenceTimeResult },
  {   1, &hf_umts_rrc_ies_gps_ReferenceTimeOnly, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_604799999 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_referenceTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_referenceTime, T_referenceTime_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M32768_32768(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -32768, 32768U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MultipathIndicator_vals[] = {
  {   0, "nm" },
  {   1, "low" },
  {   2, "medium" },
  {   3, "high" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MultipathIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t GPS_MeasurementParam_sequence[] = {
  { &hf_umts_rrc_ies_satelliteID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_c_N0   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_doppler, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_M32768_32768 },
  { &hf_umts_rrc_ies_wholeGPS_Chips, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1022 },
  { &hf_umts_rrc_ies_fractionalGPS_Chips, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1023 },
  { &hf_umts_rrc_ies_multipathIndicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MultipathIndicator },
  { &hf_umts_rrc_ies_pseudorangeRMS_Error, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GPS_MeasurementParam(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GPS_MeasurementParam, GPS_MeasurementParam_sequence);

  return offset;
}


static const per_sequence_t GPS_MeasurementParamList_sequence_of[1] = {
  { &hf_umts_rrc_ies_GPS_MeasurementParamList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GPS_MeasurementParam },
};

static int
dissect_umts_rrc_ies_GPS_MeasurementParamList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GPS_MeasurementParamList, GPS_MeasurementParamList_sequence_of,
                                                  1, maxSat);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_MeasurementResults_sequence[] = {
  { &hf_umts_rrc_ies_referenceTime, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_referenceTime },
  { &hf_umts_rrc_ies_gps_MeasurementParamList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GPS_MeasurementParamList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_MeasurementResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_MeasurementResults, UE_Positioning_GPS_MeasurementResults_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_MeasurementEventResults_vals[] = {
  {   0, "event7a" },
  {   1, "event7b" },
  {   2, "event7c" },
  {   3, "spare" },
  { 0, NULL }
};

static const per_choice_t UE_Positioning_MeasurementEventResults_choice[] = {
  {   0, &hf_umts_rrc_ies_event7a, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_PositionEstimateInfo },
  {   1, &hf_umts_rrc_ies_event7b, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_OTDOA_Measurement },
  {   2, &hf_umts_rrc_ies_event7c, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_GPS_MeasurementResults },
  {   3, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_MeasurementEventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_Positioning_MeasurementEventResults, UE_Positioning_MeasurementEventResults_choice,
                                 NULL);

  return offset;
}


const value_string umts_rrc_ies_EventResults_vals[] = {
  {   0, "intraFreqEventResults" },
  {   1, "interFreqEventResults" },
  {   2, "interRATEventResults" },
  {   3, "trafficVolumeEventResults" },
  {   4, "qualityEventResults" },
  {   5, "ue-InternalEventResults" },
  {   6, "ue-positioning-MeasurementEventResults" },
  {   7, "spare" },
  { 0, NULL }
};

static const per_choice_t EventResults_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqEventResults },
  {   1, &hf_umts_rrc_ies_interFreqEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFreqEventResults },
  {   2, &hf_umts_rrc_ies_interRATEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATEventResults },
  {   3, &hf_umts_rrc_ies_trafficVolumeEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeEventResults },
  {   4, &hf_umts_rrc_ies_qualityEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_QualityEventResults },
  {   5, &hf_umts_rrc_ies_ue_InternalEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_InternalEventResults },
  {   6, &hf_umts_rrc_ies_ue_positioning_MeasurementEventResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_MeasurementEventResults },
  {   7, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_EventResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_EventResults, EventResults_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 12U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_RAT_Type_vals[] = {
  {   0, "gsm" },
  {   1, "is2000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RAT_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type_sequence_of[1] = {
  { &hf_umts_rrc_ies_inter_RAT_meas_ind_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RAT_Type },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type, SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type_sequence_of,
                                                  1, maxOtherRAT);

  return offset;
}


static const per_sequence_t FACH_MeasurementOccasionInfo_sequence[] = {
  { &hf_umts_rrc_ies_fACH_meas_occasion_coeff, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_1_12 },
  { &hf_umts_rrc_ies_inter_freq_FDD_meas_ind, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_inter_freq_TDD_meas_ind, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_inter_RAT_meas_ind, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_FACH_MeasurementOccasionInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FACH_MeasurementOccasionInfo, FACH_MeasurementOccasionInfo_sequence);

  return offset;
}


static const per_sequence_t FACH_MeasurementOccasionInfo_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_inter_freq_TDD128_meas_ind, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_FACH_MeasurementOccasionInfo_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FACH_MeasurementOccasionInfo_LCR_r4_ext, FACH_MeasurementOccasionInfo_LCR_r4_ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_FilterCoefficient_vals[] = {
  {   0, "fc0" },
  {   1, "fc1" },
  {   2, "fc2" },
  {   3, "fc3" },
  {   4, "fc4" },
  {   5, "fc5" },
  {   6, "fc6" },
  {   7, "fc7" },
  {   8, "fc8" },
  {   9, "fc9" },
  {  10, "fc11" },
  {  11, "fc13" },
  {  12, "fc15" },
  {  13, "fc17" },
  {  14, "fc19" },
  {  15, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_FilterCoefficient(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_FineSFN_SFN(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 15U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_FreqQualityEstimateQuantity_FDD_vals[] = {
  {   0, "cpich-Ec-N0" },
  {   1, "cpich-RSCP" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_FreqQualityEstimateQuantity_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_FreqQualityEstimateQuantity_TDD_vals[] = {
  {   0, "primaryCCPCH-RSCP" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_FreqQualityEstimateQuantity_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_GSM_CarrierRSSI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     6, 6, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_46_173(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              46U, 173U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_ObservedTimeDifferenceToGSM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 4095U, NULL, FALSE);

  return offset;
}


static const per_sequence_t GSM_MeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_gsm_CarrierRSSI, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_GSM_CarrierRSSI },
  { &hf_umts_rrc_ies_dummy_INTEGER_46_173, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_46_173 },
  { &hf_umts_rrc_ies_bsicReported, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BSICReported },
  { &hf_umts_rrc_ies_dummy2_ObservedTimeDifferenceToGSM, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ObservedTimeDifferenceToGSM },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GSM_MeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GSM_MeasuredResults, GSM_MeasuredResults_sequence);

  return offset;
}


static const per_sequence_t GSM_MeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_GSM_MeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GSM_MeasuredResults },
};

static int
dissect_umts_rrc_ies_GSM_MeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GSM_MeasuredResultsList, GSM_MeasuredResultsList_sequence_of,
                                                  1, maxReportedGSMCells);

  return offset;
}



static int
dissect_umts_rrc_ies_GPS_TOW_1msec(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 604799999U, NULL, FALSE);

  return offset;
}


static const per_sequence_t GPS_TOW_Assist_sequence[] = {
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_tlm_Message, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_14 },
  { &hf_umts_rrc_ies_tlm_Reserved, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_2 },
  { &hf_umts_rrc_ies_alert  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_antiSpoof, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GPS_TOW_Assist(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GPS_TOW_Assist, GPS_TOW_Assist_sequence);

  return offset;
}


static const per_sequence_t GPS_TOW_AssistList_sequence_of[1] = {
  { &hf_umts_rrc_ies_GPS_TOW_AssistList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GPS_TOW_Assist },
};

static int
dissect_umts_rrc_ies_GPS_TOW_AssistList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GPS_TOW_AssistList, GPS_TOW_AssistList_sequence_of,
                                                  1, maxSat);

  return offset;
}


static const per_sequence_t InterFreqCell_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_nonFreqRelatedEventResults1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellMeasurementEventResults_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCell_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCell_LCR_r4, InterFreqCell_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID_sequence_of[1] = {
  { &hf_umts_rrc_ies_removeSomeInterFreqCells_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCellID },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID, SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_RemovedInterFreqCellList_vals[] = {
  {   0, "removeAllInterFreqCells" },
  {   1, "removeSomeInterFreqCells" },
  {   2, "removeNoInterFreqCells" },
  { 0, NULL }
};

static const per_choice_t RemovedInterFreqCellList_choice[] = {
  {   0, &hf_umts_rrc_ies_removeAllInterFreqCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_removeSomeInterFreqCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID },
  {   2, &hf_umts_rrc_ies_removeNoInterFreqCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RemovedInterFreqCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RemovedInterFreqCellList, RemovedInterFreqCellList_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t NewInterFreqCell_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCell, NewInterFreqCell_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCell },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellList, NewInterFreqCellList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoList_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellList },
  { &hf_umts_rrc_ies_cellsForInterFreqMeasList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellsForInterFreqMeasList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoList, InterFreqCellInfoList_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCell_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfo_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCell_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCell_r4, NewInterFreqCell_r4_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCell_r4 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellList_r4, NewInterFreqCellList_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoList_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellList_r4 },
  { &hf_umts_rrc_ies_cellsForInterFreqMeasList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellsForInterFreqMeasList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoList_r4, InterFreqCellInfoList_r4_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_RSCP, NewInterFreqCellSI_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_RSCP_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_RSCP },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_RSCP, NewInterFreqCellSI_List_RSCP_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP, InterFreqCellInfoSI_List_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_ECN0, NewInterFreqCellSI_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_ECN0_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_ECN0 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_ECN0, NewInterFreqCellSI_List_ECN0_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0, InterFreqCellInfoSI_List_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP, NewInterFreqCellSI_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_HCS_RSCP_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP, NewInterFreqCellSI_List_HCS_RSCP_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP, InterFreqCellInfoSI_List_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0, NewInterFreqCellSI_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_HCS_ECN0_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0, NewInterFreqCellSI_List_HCS_ECN0_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0, InterFreqCellInfoSI_List_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_RSCP_LCR_r4, NewInterFreqCellSI_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_RSCP_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_RSCP_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4, NewInterFreqCellSI_List_RSCP_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_RSCP_LCR_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP_LCR, InterFreqCellInfoSI_List_RSCP_LCR_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_ECN0_LCR_r4, NewInterFreqCellSI_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_ECN0_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_ECN0_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4, NewInterFreqCellSI_List_ECN0_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_ECN0_LCR_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0_LCR, InterFreqCellInfoSI_List_ECN0_LCR_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_HCS_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo8, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP_LCR_r4, NewInterFreqCellSI_HCS_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_HCS_RSCP_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4, NewInterFreqCellSI_List_HCS_RSCP_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_HCS_RSCP_LCR_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList8, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP_LCR, InterFreqCellInfoSI_List_HCS_RSCP_LCR_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_HCS_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellID },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellInfo9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0_LCR_r4, NewInterFreqCellSI_HCS_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewInterFreqCellSI_List_HCS_ECN0_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4, NewInterFreqCellSI_List_HCS_ECN0_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterFreqCellInfoSI_List_HCS_ECN0_LCR_sequence[] = {
  { &hf_umts_rrc_ies_removedInterFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedInterFreqCellList },
  { &hf_umts_rrc_ies_newInterFreqCellList9, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0_LCR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0_LCR, InterFreqCellInfoSI_List_HCS_ECN0_LCR_sequence);

  return offset;
}


static const per_sequence_t InterFreqCellList_LCR_r4_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqCellList_LCR_r4_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCell_LCR_r4 },
};

static int
dissect_umts_rrc_ies_InterFreqCellList_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqCellList_LCR_r4_ext, InterFreqCellList_LCR_r4_ext_sequence_of,
                                                  1, maxFreq);

  return offset;
}


static const per_sequence_t InterFreqCellMeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqCellMeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellMeasuredResults },
};

static int
dissect_umts_rrc_ies_InterFreqCellMeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqCellMeasuredResultsList, InterFreqCellMeasuredResultsList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_InterFreqEvent_vals[] = {
  {   0, "event2a" },
  {   1, "event2b" },
  {   2, "event2c" },
  {   3, "event2d" },
  {   4, "event2e" },
  {   5, "event2f" },
  { 0, NULL }
};

static const per_choice_t InterFreqEvent_choice[] = {
  {   0, &hf_umts_rrc_ies_event2a, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event2a },
  {   1, &hf_umts_rrc_ies_event2b, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event2b },
  {   2, &hf_umts_rrc_ies_event2c, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event2c },
  {   3, &hf_umts_rrc_ies_event2d, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event2d },
  {   4, &hf_umts_rrc_ies_event2e, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event2e },
  {   5, &hf_umts_rrc_ies_event2f, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event2f },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqEvent(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterFreqEvent, InterFreqEvent_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterFreqEventList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqEventList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqEvent },
};

static int
dissect_umts_rrc_ies_InterFreqEventList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqEventList, InterFreqEventList_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t InterFrequencyMeasuredResultsList_v590ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaRSCPPerCell },
};

static int
dissect_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext, InterFrequencyMeasuredResultsList_v590ext_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t ThreholdNonUsedFrequency_deltaList_sequence_of[1] = {
  { &hf_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaRSCPPerCell },
};

static int
dissect_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList, ThreholdNonUsedFrequency_deltaList_sequence_of,
                                                  1, maxFreq);

  return offset;
}


static const per_sequence_t Inter_FreqEventCriteria_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_threholdUsedFrequency_delta, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaRSCP },
  { &hf_umts_rrc_ies_threholdNonUsedFrequency_deltaList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Inter_FreqEventCriteria_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Inter_FreqEventCriteria_v590ext, Inter_FreqEventCriteria_v590ext_sequence);

  return offset;
}


static const per_sequence_t Inter_FreqEventCriteriaList_v590ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Inter_FreqEventCriteria_v590ext },
};

int
dissect_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext, Inter_FreqEventCriteriaList_v590ext_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t Intra_FreqEventCriteriaList_v590ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaRSCP },
};

int
dissect_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext, Intra_FreqEventCriteriaList_v590ext_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t IntraFrequencyMeasuredResultsList_v590ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DeltaRSCPPerCell },
};

static int
dissect_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext, IntraFrequencyMeasuredResultsList_v590ext_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t PeriodicReportingInfo_1b_sequence[] = {
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportingInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PeriodicReportingInfo_1b(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PeriodicReportingInfo_1b, PeriodicReportingInfo_1b_sequence);

  return offset;
}


static const per_sequence_t IntraFreqReportingCriteria_1b_r5_sequence[] = {
  { &hf_umts_rrc_ies_periodicReportingInfo_1b, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PeriodicReportingInfo_1b },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_IntraFreqReportingCriteria_1b_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqReportingCriteria_1b_r5, IntraFreqReportingCriteria_1b_r5_sequence);

  return offset;
}


static const per_sequence_t InterFreqEventResults_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_eventID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_EventIDInterFreq },
  { &hf_umts_rrc_ies_interFreqCellList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellList_LCR_r4_ext },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_InterFreqEventResults_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqEventResults_LCR_r4_ext, InterFreqEventResults_LCR_r4_ext_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqMeasQuantity_FDD_vals[] = {
  {   0, "cpich-Ec-N0" },
  {   1, "cpich-RSCP" },
  {   2, "pathloss" },
  {   3, "dummy" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IntraFreqMeasQuantity_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd66_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasQuantity_FDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqMeasQuantity_FDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd66(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd66, T_fdd66_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqMeasQuantity_TDD_vals[] = {
  {   0, "primaryCCPCH-RSCP" },
  {   1, "pathloss" },
  {   2, "timeslotISCP" },
  {   3, "dummy" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IntraFreqMeasQuantity_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IntraFreqMeasQuantity_TDDList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFreqMeasQuantity_TDDList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqMeasQuantity_TDD },
};

static int
dissect_umts_rrc_ies_IntraFreqMeasQuantity_TDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFreqMeasQuantity_TDDList, IntraFreqMeasQuantity_TDDList_sequence_of,
                                                  1, 4);

  return offset;
}


static const per_sequence_t T_tdd58_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasQuantity_TDDList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqMeasQuantity_TDDList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd58(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd58, T_tdd58_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo57_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo57_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd71  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd66 },
  {   1, &hf_umts_rrc_ies_tdd65  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd58 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo57(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo57, T_modeSpecificInfo57_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraFreqMeasQuantity_sequence[] = {
  { &hf_umts_rrc_ies_filterCoefficient, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FilterCoefficient },
  { &hf_umts_rrc_ies_modeSpecificInfo57, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo57 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasQuantity, IntraFreqMeasQuantity_sequence);

  return offset;
}


static const per_sequence_t T_intraFreqReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_intraFreqReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_intraFreqReportingCriteria, T_intraFreqReportingCriteria_sequence);

  return offset;
}


static const per_sequence_t T_fdd64_sequence[] = {
  { &hf_umts_rrc_ies_freqQualityEstimateQuantity_FDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FreqQualityEstimateQuantity_FDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd64(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd64, T_fdd64_sequence);

  return offset;
}


static const per_sequence_t T_tdd56_sequence[] = {
  { &hf_umts_rrc_ies_freqQualityEstimateQuantity_TDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FreqQualityEstimateQuantity_TDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd56(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd56, T_tdd56_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo55_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo55_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd69  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd64 },
  {   1, &hf_umts_rrc_ies_tdd63  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd56 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo55(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo55, T_modeSpecificInfo55_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_interFreqReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_filterCoefficient, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FilterCoefficient },
  { &hf_umts_rrc_ies_modeSpecificInfo55, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo55 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_interFreqReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_interFreqReportingCriteria, T_interFreqReportingCriteria_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_reportingCriteria_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "interFreqReportingCriteria" },
  { 0, NULL }
};

static const per_choice_t T_reportingCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_intraFreqReportingCriteria },
  {   1, &hf_umts_rrc_ies_interFreqReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_interFreqReportingCriteria },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_reportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_reportingCriteria, T_reportingCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterFreqMeasQuantity_sequence[] = {
  { &hf_umts_rrc_ies_reportingCriteria, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_reportingCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasQuantity, InterFreqMeasQuantity_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_UTRA_CarrierRSSI(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t InterFreqMeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_utra_CarrierRSSI, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UTRA_CarrierRSSI },
  { &hf_umts_rrc_ies_interFreqCellMeasuredResultsList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellMeasuredResultsList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasuredResults, InterFreqMeasuredResults_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqMeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqMeasuredResults },
};

static int
dissect_umts_rrc_ies_InterFreqMeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqMeasuredResultsList, InterFreqMeasuredResultsList_sequence_of,
                                                  1, maxFreq);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP, InterFreqMeasurementSysInfo_RSCP_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0, InterFreqMeasurementSysInfo_ECN0_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP, InterFreqMeasurementSysInfo_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0, InterFreqMeasurementSysInfo_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP_LCR },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP_LCR_r4, InterFreqMeasurementSysInfo_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0_LCR },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0_LCR_r4, InterFreqMeasurementSysInfo_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP_LCR },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4, InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoSI_List7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0_LCR },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4, InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t InterFreqRACHRepCellsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqRACHRepCellsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCellID },
};

static int
dissect_umts_rrc_ies_InterFreqRACHRepCellsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqRACHRepCellsList, InterFreqRACHRepCellsList_sequence_of,
                                                  1, maxFreq);

  return offset;
}


static const value_string umts_rrc_ies_InterFreqRepQuantityRACH_FDD_vals[] = {
  {   0, "cpich-EcN0" },
  {   1, "cpich-RSCP" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_InterFreqRepQuantityRACH_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd65_sequence[] = {
  { &hf_umts_rrc_ies_interFreqRepQuantityRACH_FDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqRepQuantityRACH_FDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd65(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd65, T_fdd65_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterFreqRepQuantityRACH_TDD_vals[] = {
  {   0, "timeslotISCP" },
  {   1, "primaryCCPCH-RSCP" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_InterFreqRepQuantityRACH_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t InterFreqRepQuantityRACH_TDDList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqRepQuantityRACH_TDD },
};

static int
dissect_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList, InterFreqRepQuantityRACH_TDDList_sequence_of,
                                                  1, 2);

  return offset;
}


static const per_sequence_t T_tdd57_sequence[] = {
  { &hf_umts_rrc_ies_interFreqRepQuantityRACH_TDDList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd57(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd57, T_tdd57_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MaxReportedCellsOnRACHinterFreq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo56_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  {   2, "interFreqRACHReportingThreshold" },
  {   3, "maxReportedCellsOnRACHinterFreq" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo56_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd70  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd65 },
  {   1, &hf_umts_rrc_ies_tdd64  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd57 },
  {   2, &hf_umts_rrc_ies_interFreqRACHReportingThreshold, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Threshold },
  {   3, &hf_umts_rrc_ies_maxReportedCellsOnRACHinterFreq, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MaxReportedCellsOnRACHinterFreq },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo56(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo56, T_modeSpecificInfo56_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterFreqRACHReportingInfo_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo56, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo56 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqRACHReportingInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqRACHReportingInfo, InterFreqRACHReportingInfo_sequence);

  return offset;
}


static const per_sequence_t InterFreqReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_interFreqEventList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqEventList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqReportingCriteria, InterFreqReportingCriteria_sequence);

  return offset;
}


static const per_sequence_t PeriodicalWithReportingCellStatus_sequence[] = {
  { &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PeriodicalWithReportingCellStatus(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PeriodicalWithReportingCellStatus, PeriodicalWithReportingCellStatus_sequence);

  return offset;
}


static const per_sequence_t ReportingCellStatusOpt_sequence[] = {
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReportingCellStatusOpt(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ReportingCellStatusOpt, ReportingCellStatusOpt_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterFreqReportCriteria_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "interFreqReportingCriteria" },
  {   2, "periodicalReportingCriteria" },
  {   3, "noReporting" },
  { 0, NULL }
};

static const per_choice_t InterFreqReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqReportingCriteria },
  {   1, &hf_umts_rrc_ies_interFreqReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFreqReportingCriteria },
  {   2, &hf_umts_rrc_ies_periodicalReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalWithReportingCellStatus },
  {   3, &hf_umts_rrc_ies_noReporting, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReportingCellStatusOpt },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterFreqReportCriteria, InterFreqReportCriteria_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqEvent_r4_vals[] = {
  {   0, "e1a" },
  {   1, "e1b" },
  {   2, "e1c" },
  {   3, "e1d" },
  {   4, "e1e" },
  {   5, "e1f" },
  {   6, "e1g" },
  {   7, "e1h" },
  {   8, "e1i" },
  { 0, NULL }
};

static const per_choice_t IntraFreqEvent_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_e1a1   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1a_r4 },
  {   1, &hf_umts_rrc_ies_e1b1   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1b_r4 },
  {   2, &hf_umts_rrc_ies_e1c    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1c },
  {   3, &hf_umts_rrc_ies_e1d    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_e1e    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1e },
  {   5, &hf_umts_rrc_ies_e1f    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event1f },
  {   6, &hf_umts_rrc_ies_e1g    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_e1h    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdUsedFrequency },
  {   8, &hf_umts_rrc_ies_e1i    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdUsedFrequency },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEvent_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_IntraFreqEvent_r4, IntraFreqEvent_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraFreqEventCriteria_r4_sequence[] = {
  { &hf_umts_rrc_ies_event1 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqEvent_r4 },
  { &hf_umts_rrc_ies_hysteresis1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Hysteresis },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_reportingCellStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingCellStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqEventCriteria_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqEventCriteria_r4, IntraFreqEventCriteria_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqEventCriteriaList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFreqEventCriteriaList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqEventCriteria_r4 },
};

static int
dissect_umts_rrc_ies_IntraFreqEventCriteriaList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFreqEventCriteriaList_r4, IntraFreqEventCriteriaList_r4_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t IntraFreqReportingCriteria_r4_sequence[] = {
  { &hf_umts_rrc_ies_eventCriteriaList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqEventCriteriaList_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportingCriteria_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqReportingCriteria_r4, IntraFreqReportingCriteria_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterFreqReportCriteria_r4_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "interFreqReportingCriteria" },
  {   2, "periodicalReportingCriteria" },
  {   3, "noReporting" },
  { 0, NULL }
};

static const per_choice_t InterFreqReportCriteria_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqReportingCriteria_r4 },
  {   1, &hf_umts_rrc_ies_interFreqReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFreqReportingCriteria },
  {   2, &hf_umts_rrc_ies_periodicalReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalWithReportingCellStatus },
  {   3, &hf_umts_rrc_ies_noReporting, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReportingCellStatusOpt },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqReportCriteria_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterFreqReportCriteria_r4, InterFreqReportCriteria_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterFreqReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_utra_Carrier_RSSI, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_frequencyQualityEstimate, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_nonFreqRelatedQuantities, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellReportingQuantities },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFreqReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFreqReportingQuantity, InterFreqReportingQuantity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ue_State_vals[] = {
  {   0, "cell-DCH" },
  {   1, "all-But-Cell-DCH" },
  {   2, "all-States" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_ue_State(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MeasurementValidity_sequence[] = {
  { &hf_umts_rrc_ies_ue_State, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ue_State },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementValidity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementValidity, MeasurementValidity_sequence);

  return offset;
}


static const per_sequence_t RL_AdditionInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_RL_AdditionInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
};

static int
dissect_umts_rrc_ies_RL_AdditionInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_RL_AdditionInfoList, RL_AdditionInfoList_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t RL_InformationLists_sequence[] = {
  { &hf_umts_rrc_ies_rl_AdditionInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RL_AdditionInfoList },
  { &hf_umts_rrc_ies_rL_RemovalInformationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RL_RemovalInformationList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_RL_InformationLists(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_RL_InformationLists, RL_InformationLists_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_AutonomousUpdateMode_vals[] = {
  {   0, "dummy" },
  {   1, "onWithNoReporting" },
  {   2, "dummy2-RL-InformationLists" },
  { 0, NULL }
};

static const per_choice_t UE_AutonomousUpdateMode_choice[] = {
  {   0, &hf_umts_rrc_ies_dummy1 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_onWithNoReporting, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_dummy2_RL_InformationLists, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_RL_InformationLists },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_AutonomousUpdateMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_AutonomousUpdateMode, UE_AutonomousUpdateMode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterFrequencyMeasurement_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCellInfoList },
  { &hf_umts_rrc_ies_interFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasQuantity },
  { &hf_umts_rrc_ies_interFreqReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqReportingQuantity },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_interFreqSetUpdate, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_AutonomousUpdateMode },
  { &hf_umts_rrc_ies_reportCriteria, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFrequencyMeasurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFrequencyMeasurement, InterFrequencyMeasurement_sequence);

  return offset;
}


static const per_sequence_t InterFrequencyMeasurement_r4_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellInfoList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqCellInfoList_r4 },
  { &hf_umts_rrc_ies_interFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasQuantity },
  { &hf_umts_rrc_ies_interFreqReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqReportingQuantity },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_interFreqSetUpdate, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_AutonomousUpdateMode },
  { &hf_umts_rrc_ies_reportCriteria1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqReportCriteria_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterFrequencyMeasurement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterFrequencyMeasurement_r4, InterFrequencyMeasurement_r4_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_NC_Mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     3, 3, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_gsm5_sequence[] = {
  { &hf_umts_rrc_ies_bsic   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BSIC },
  { &hf_umts_rrc_ies_frequency_band, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Frequency_Band },
  { &hf_umts_rrc_ies_bcch_ARFCN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BCCH_ARFCN },
  { &hf_umts_rrc_ies_ncMode , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NC_Mode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm5, T_gsm5_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_technologySpecificInfo_vals[] = {
  {   0, "gsm" },
  {   1, "is-2000" },
  {   2, "spare2" },
  {   3, "spare1" },
  { 0, NULL }
};

static const per_choice_t T_technologySpecificInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm5 },
  {   1, &hf_umts_rrc_ies_is_2000, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_technologySpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_technologySpecificInfo, T_technologySpecificInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRAT_TargetCellDescription_sequence[] = {
  { &hf_umts_rrc_ies_technologySpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_technologySpecificInfo },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_InterRAT_TargetCellDescription(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRAT_TargetCellDescription, InterRAT_TargetCellDescription_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_InterRATCellInfoIndication(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID_sequence_of[1] = {
  { &hf_umts_rrc_ies_removeSomeInterRATCells_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATCellID },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID, SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_RemovedInterRATCellList_vals[] = {
  {   0, "removeAllInterRATCells" },
  {   1, "removeSomeInterRATCells" },
  {   2, "removeNoInterRATCells" },
  { 0, NULL }
};

static const per_choice_t RemovedInterRATCellList_choice[] = {
  {   0, &hf_umts_rrc_ies_removeAllInterRATCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_removeSomeInterRATCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID },
  {   2, &hf_umts_rrc_ies_removeNoInterRATCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RemovedInterRATCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RemovedInterRATCellList, RemovedInterRATCellList_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_InterRATCellIndividualOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -50, 50U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_gsm8_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12 },
  { &hf_umts_rrc_ies_interRATCellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATCellIndividualOffset },
  { &hf_umts_rrc_ies_bsic   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BSIC },
  { &hf_umts_rrc_ies_frequency_band, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Frequency_Band },
  { &hf_umts_rrc_ies_bcch_ARFCN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BCCH_ARFCN },
  { &hf_umts_rrc_ies_dummy_NULL, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NULL },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm8, T_gsm8_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IS_2000SpecificMeasInfo_vals[] = {
  {   0, "frequency" },
  {   1, "timeslot" },
  {   2, "colourcode" },
  {   3, "outputpower" },
  {   4, "pn-Offset" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IS_2000SpecificMeasInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_is_20001_sequence[] = {
  { &hf_umts_rrc_ies_is_2000SpecificMeasInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IS_2000SpecificMeasInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_is_20001(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_is_20001, T_is_20001_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_technologySpecificInfo1_vals[] = {
  {   0, "gsm" },
  {   1, "is-2000" },
  {   2, "absent" },
  {   3, "spare1" },
  { 0, NULL }
};

static const per_choice_t T_technologySpecificInfo1_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm9   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm8 },
  {   1, &hf_umts_rrc_ies_is_20002, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_is_20001 },
  {   2, &hf_umts_rrc_ies_absent , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_technologySpecificInfo1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_technologySpecificInfo1, T_technologySpecificInfo1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t NewInterRATCell_sequence[] = {
  { &hf_umts_rrc_ies_interRATCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATCellID },
  { &hf_umts_rrc_ies_technologySpecificInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_technologySpecificInfo1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterRATCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterRATCell, NewInterRATCell_sequence);

  return offset;
}


static const per_sequence_t NewInterRATCellList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterRATCellList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterRATCell },
};

static int
dissect_umts_rrc_ies_NewInterRATCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterRATCellList, NewInterRATCellList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterRATCellInfoList_sequence[] = {
  { &hf_umts_rrc_ies_removedInterRATCellList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RemovedInterRATCellList },
  { &hf_umts_rrc_ies_newInterRATCellList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterRATCellList },
  { &hf_umts_rrc_ies_cellsForInterRATMeasList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellsForInterRATMeasList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATCellInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATCellInfoList, InterRATCellInfoList_sequence);

  return offset;
}


static const per_sequence_t T_gsm9_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectionReselectionInfo4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoSIB_11_12 },
  { &hf_umts_rrc_ies_interRATCellIndividualOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATCellIndividualOffset },
  { &hf_umts_rrc_ies_bsic   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BSIC },
  { &hf_umts_rrc_ies_frequency_band, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Frequency_Band },
  { &hf_umts_rrc_ies_bcch_ARFCN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BCCH_ARFCN },
  { &hf_umts_rrc_ies_dummy_NULL, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NULL },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm9, T_gsm9_sequence);

  return offset;
}


static const per_sequence_t T_is_20002_sequence[] = {
  { &hf_umts_rrc_ies_is_2000SpecificMeasInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IS_2000SpecificMeasInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_is_20002(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_is_20002, T_is_20002_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_technologySpecificInfo2_vals[] = {
  {   0, "gsm" },
  {   1, "is-2000" },
  {   2, "absent" },
  {   3, "spare1" },
  { 0, NULL }
};

static const per_choice_t T_technologySpecificInfo2_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm10  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm9 },
  {   1, &hf_umts_rrc_ies_is_20003, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_is_20002 },
  {   2, &hf_umts_rrc_ies_absent , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   3, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_technologySpecificInfo2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_technologySpecificInfo2, T_technologySpecificInfo2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t NewInterRATCell_B_sequence[] = {
  { &hf_umts_rrc_ies_interRATCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATCellID },
  { &hf_umts_rrc_ies_technologySpecificInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_technologySpecificInfo2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewInterRATCell_B(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewInterRATCell_B, NewInterRATCell_B_sequence);

  return offset;
}


static const per_sequence_t NewInterRATCellList_B_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewInterRATCellList_B_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterRATCell_B },
};

static int
dissect_umts_rrc_ies_NewInterRATCellList_B(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewInterRATCellList_B, NewInterRATCellList_B_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t InterRATCellInfoList_B_sequence[] = {
  { &hf_umts_rrc_ies_removedInterRATCellList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RemovedInterRATCellList },
  { &hf_umts_rrc_ies_newInterRATCellList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewInterRATCellList_B },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATCellInfoList_B(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATCellInfoList_B, InterRATCellInfoList_B_sequence);

  return offset;
}


static const per_sequence_t InterRATCellInfoList_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedInterRATCellList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RemovedInterRATCellList },
  { &hf_umts_rrc_ies_newInterRATCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewInterRATCellList },
  { &hf_umts_rrc_ies_cellsForInterRATMeasList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellsForInterRATMeasList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATCellInfoList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATCellInfoList_r4, InterRATCellInfoList_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterRATEvent_vals[] = {
  {   0, "event3a" },
  {   1, "event3b" },
  {   2, "event3c" },
  {   3, "event3d" },
  { 0, NULL }
};

static const per_choice_t InterRATEvent_choice[] = {
  {   0, &hf_umts_rrc_ies_event3a, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event3a },
  {   1, &hf_umts_rrc_ies_event3b, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event3b },
  {   2, &hf_umts_rrc_ies_event3c, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event3c },
  {   3, &hf_umts_rrc_ies_event3d, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Event3d },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATEvent(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRATEvent, InterRATEvent_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRATEventList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterRATEventList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATEvent },
};

static int
dissect_umts_rrc_ies_InterRATEventList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterRATEventList, InterRATEventList_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const value_string umts_rrc_ies_MeasurementQuantityGSM_vals[] = {
  {   0, "gsm-CarrierRSSI" },
  {   1, "dummy" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MeasurementQuantityGSM(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_gsm6_sequence[] = {
  { &hf_umts_rrc_ies_measurementQuantity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementQuantityGSM },
  { &hf_umts_rrc_ies_filterCoefficient, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FilterCoefficient },
  { &hf_umts_rrc_ies_bsic_VerificationRequired, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BSIC_VerificationRequired },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm6, T_gsm6_sequence);

  return offset;
}


static const per_sequence_t T_is_2000_sequence[] = {
  { &hf_umts_rrc_ies_tadd_EcIo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_tcomp_EcIo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_softSlope, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_addIntercept, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_63 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_is_2000(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_is_2000, T_is_2000_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ratSpecificInfo_vals[] = {
  {   0, "gsm" },
  {   1, "is-2000" },
  { 0, NULL }
};

static const per_choice_t T_ratSpecificInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm6   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm6 },
  {   1, &hf_umts_rrc_ies_is_20001, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_is_2000 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ratSpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ratSpecificInfo, T_ratSpecificInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRATMeasQuantity_sequence[] = {
  { &hf_umts_rrc_ies_measQuantityUTRAN_QualityEstimate, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_ratSpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ratSpecificInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATMeasQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATMeasQuantity, InterRATMeasQuantity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterRATMeasuredResults_vals[] = {
  {   0, "gsm" },
  {   1, "spare" },
  { 0, NULL }
};

static const per_choice_t InterRATMeasuredResults_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm7   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_GSM_MeasuredResultsList },
  {   1, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATMeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRATMeasuredResults, InterRATMeasuredResults_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRATMeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterRATMeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATMeasuredResults },
};

static int
dissect_umts_rrc_ies_InterRATMeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterRATMeasuredResultsList, InterRATMeasuredResultsList_sequence_of,
                                                  1, maxOtherRAT16);

  return offset;
}


static const per_sequence_t T_gsm7_sequence[] = {
  { &hf_umts_rrc_ies_dummy_BOOLEAN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dummy2_BOOLEAN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_gsm_Carrier_RSSI, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm7, T_gsm7_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_ratSpecificInfo1_vals[] = {
  {   0, "gsm" },
  { 0, NULL }
};

static const per_choice_t T_ratSpecificInfo1_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm8   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm7 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ratSpecificInfo1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_ratSpecificInfo1, T_ratSpecificInfo1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRATReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_utran_EstimatedQuality, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ratSpecificInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_ratSpecificInfo1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATReportingQuantity, InterRATReportingQuantity_sequence);

  return offset;
}


static const per_sequence_t InterRATReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_interRATEventList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATEventList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATReportingCriteria, InterRATReportingCriteria_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterRATReportCriteria_vals[] = {
  {   0, "interRATReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t InterRATReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_interRATReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalWithReportingCellStatus },
  {   2, &hf_umts_rrc_ies_noReporting, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReportingCellStatusOpt },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRATReportCriteria, InterRATReportCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRATMeasurement_sequence[] = {
  { &hf_umts_rrc_ies_interRATCellInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATCellInfoList },
  { &hf_umts_rrc_ies_interRATMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATMeasQuantity },
  { &hf_umts_rrc_ies_interRATReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATReportingQuantity },
  { &hf_umts_rrc_ies_reportCriteria2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATMeasurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATMeasurement, InterRATMeasurement_sequence);

  return offset;
}


static const per_sequence_t InterRATMeasurement_r4_sequence[] = {
  { &hf_umts_rrc_ies_interRATCellInfoList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATCellInfoList_r4 },
  { &hf_umts_rrc_ies_interRATMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATMeasQuantity },
  { &hf_umts_rrc_ies_interRATReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATReportingQuantity },
  { &hf_umts_rrc_ies_reportCriteria2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRATReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATMeasurement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATMeasurement_r4, InterRATMeasurement_r4_sequence);

  return offset;
}


static const per_sequence_t InterRATMeasurementSysInfo_sequence[] = {
  { &hf_umts_rrc_ies_interRATCellInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATCellInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATMeasurementSysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATMeasurementSysInfo, InterRATMeasurementSysInfo_sequence);

  return offset;
}


static const per_sequence_t InterRATMeasurementSysInfo_B_sequence[] = {
  { &hf_umts_rrc_ies_interRATCellInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATCellInfoList_B },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRATMeasurementSysInfo_B(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRATMeasurementSysInfo_B, InterRATMeasurementSysInfo_B_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID_sequence_of[1] = {
  { &hf_umts_rrc_ies_removeSomeIntraFreqCells_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqCellID },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID, SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_RemovedIntraFreqCellList_vals[] = {
  {   0, "removeAllIntraFreqCells" },
  {   1, "removeSomeIntraFreqCells" },
  {   2, "removeNoIntraFreqCells" },
  { 0, NULL }
};

static const per_choice_t RemovedIntraFreqCellList_choice[] = {
  {   0, &hf_umts_rrc_ies_removeAllIntraFreqCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_removeSomeIntraFreqCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID },
  {   2, &hf_umts_rrc_ies_removeNoIntraFreqCells, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_RemovedIntraFreqCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_RemovedIntraFreqCellList, RemovedIntraFreqCellList_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t NewIntraFreqCell_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCell, NewIntraFreqCell_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCell },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellList, NewIntraFreqCellList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoList_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewIntraFreqCellList },
  { &hf_umts_rrc_ies_cellsForIntraFreqMeasList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellsForIntraFreqMeasList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoList, IntraFreqCellInfoList_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCell_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfo_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCell_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCell_r4, NewIntraFreqCell_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCell_r4 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellList_r4, NewIntraFreqCellList_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoList_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_NewIntraFreqCellList_r4 },
  { &hf_umts_rrc_ies_cellsForIntraFreqMeasList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellsForIntraFreqMeasList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoList_r4, IntraFreqCellInfoList_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_RSCP, NewIntraFreqCellSI_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_RSCP_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_RSCP },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP, NewIntraFreqCellSI_List_RSCP_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP, IntraFreqCellInfoSI_List_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_ECN0, NewIntraFreqCellSI_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_ECN0_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_ECN0 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0, NewIntraFreqCellSI_List_ECN0_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0, IntraFreqCellInfoSI_List_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP, NewIntraFreqCellSI_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_HCS_RSCP_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP, NewIntraFreqCellSI_List_HCS_RSCP_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP, IntraFreqCellInfoSI_List_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0, NewIntraFreqCellSI_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_HCS_ECN0_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0, NewIntraFreqCellSI_List_HCS_ECN0_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0, IntraFreqCellInfoSI_List_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_RSCP_LCR_r4, NewIntraFreqCellSI_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_RSCP_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_RSCP_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4, NewIntraFreqCellSI_List_RSCP_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP_LCR_r4, IntraFreqCellInfoSI_List_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_ECN0_LCR_r4, NewIntraFreqCellSI_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_ECN0_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_ECN0_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4, NewIntraFreqCellSI_List_ECN0_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0_LCR_r4, IntraFreqCellInfoSI_List_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_HCS_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo8, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP_LCR_r4, NewIntraFreqCellSI_HCS_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4, NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList8, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4, IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_HCS_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellID },
  { &hf_umts_rrc_ies_cellInfo9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellInfoSI_HCS_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0_LCR_r4, NewIntraFreqCellSI_HCS_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0_LCR_r4 },
};

static int
dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4, NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_removedIntraFreqCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RemovedIntraFreqCellList },
  { &hf_umts_rrc_ies_newIntraFreqCellList9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4, IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqEvent_1d_r5_sequence[] = {
  { &hf_umts_rrc_ies_triggeringCondition, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TriggeringCondition2 },
  { &hf_umts_rrc_ies_useCIO , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_IntraFreqEvent_1d_r5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqEvent_1d_r5, IntraFreqEvent_1d_r5_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFreqMeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellMeasuredResults },
};

static int
dissect_umts_rrc_ies_IntraFreqMeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFreqMeasuredResultsList, IntraFreqMeasuredResultsList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqRepQuantityRACH_FDD_vals[] = {
  {   0, "cpich-EcN0" },
  {   1, "cpich-RSCP" },
  {   2, "pathloss" },
  {   3, "noReport" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IntraFreqRepQuantityRACH_FDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd67_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqRepQuantityRACH_FDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqRepQuantityRACH_FDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd67(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd67, T_fdd67_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqRepQuantityRACH_TDD_vals[] = {
  {   0, "timeslotISCP" },
  {   1, "primaryCCPCH-RSCP" },
  {   2, "noReport" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IntraFreqRepQuantityRACH_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IntraFreqRepQuantityRACH_TDDList_sequence_of[1] = {
  { &hf_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqRepQuantityRACH_TDD },
};

static int
dissect_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList, IntraFreqRepQuantityRACH_TDDList_sequence_of,
                                                  1, 2);

  return offset;
}


static const per_sequence_t T_tdd59_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqRepQuantityRACH_TDDList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd59(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd59, T_tdd59_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo58_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo58_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd72  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd67 },
  {   1, &hf_umts_rrc_ies_tdd66  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd59 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo58(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo58, T_modeSpecificInfo58_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraFreqReportingQuantityForRACH_sequence[] = {
  { &hf_umts_rrc_ies_sfn_SFN_OTD_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SFN_SFN_OTD_Type },
  { &hf_umts_rrc_ies_modeSpecificInfo58, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo58 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqReportingQuantityForRACH, IntraFreqReportingQuantityForRACH_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MaxReportedCellsOnRACH_vals[] = {
  {   0, "noReport" },
  {   1, "currentCell" },
  {   2, "currentAnd-1-BestNeighbour" },
  {   3, "currentAnd-2-BestNeighbour" },
  {   4, "currentAnd-3-BestNeighbour" },
  {   5, "currentAnd-4-BestNeighbour" },
  {   6, "currentAnd-5-BestNeighbour" },
  {   7, "currentAnd-6-BestNeighbour" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MaxReportedCellsOnRACH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t IntraFreqReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_activeSetReportingQuantities, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellReportingQuantities },
  { &hf_umts_rrc_ies_monitoredSetReportingQuantities, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellReportingQuantities },
  { &hf_umts_rrc_ies_detectedSetReportingQuantities, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellReportingQuantities },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqReportingQuantity, IntraFreqReportingQuantity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TransferMode_vals[] = {
  {   0, "acknowledgedModeRLC" },
  {   1, "unacknowledgedModeRLC" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TransferMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PeriodicalOrEventTrigger_vals[] = {
  {   0, "periodical" },
  {   1, "eventTrigger" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PeriodicalOrEventTrigger(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MeasurementReportingMode_sequence[] = {
  { &hf_umts_rrc_ies_measurementReportTransferMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransferMode },
  { &hf_umts_rrc_ies_periodicalOrEventTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PeriodicalOrEventTrigger },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasurementReportingMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementReportingMode, MeasurementReportingMode_sequence);

  return offset;
}


static const per_sequence_t ReportingInfoForCellDCH_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqReportingQuantity },
  { &hf_umts_rrc_ies_measurementReportingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementReportingMode },
  { &hf_umts_rrc_ies_reportCriteria6, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellDCH_ReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReportingInfoForCellDCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ReportingInfoForCellDCH, ReportingInfoForCellDCH_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP, IntraFreqMeasurementSysInfo_RSCP_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0, IntraFreqMeasurementSysInfo_ECN0_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_HCS_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP, IntraFreqMeasurementSysInfo_HCS_RSCP_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_HCS_ECN0_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0, IntraFreqMeasurementSysInfo_HCS_ECN0_sequence);

  return offset;
}


static const per_sequence_t ReportingInfoForCellDCH_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IntraFreqReportingQuantity },
  { &hf_umts_rrc_ies_measurementReportingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementReportingMode },
  { &hf_umts_rrc_ies_reportCriteria7, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4, ReportingInfoForCellDCH_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP_LCR_r4 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP_LCR_r4, IntraFreqMeasurementSysInfo_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0_LCR_r4 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0_LCR_r4, IntraFreqMeasurementSysInfo_ECN0_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4, IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4_sequence);

  return offset;
}


static const per_sequence_t IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_intraFreqCellInfoSI_List7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantityForRACH },
  { &hf_umts_rrc_ies_maxReportedCellsOnRACH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MaxReportedCellsOnRACH },
  { &hf_umts_rrc_ies_reportingInfoForCellDCH1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4, IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqReportCriteria_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t IntraFreqReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalWithReportingCellStatus },
  {   2, &hf_umts_rrc_ies_noReporting, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReportingCellStatusOpt },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_IntraFreqReportCriteria, IntraFreqReportCriteria_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_IntraFreqReportCriteria_r4_vals[] = {
  {   0, "intraFreqReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t IntraFreqReportCriteria_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqReportingCriteria3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqReportingCriteria_r4 },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalWithReportingCellStatus },
  {   2, &hf_umts_rrc_ies_noReporting, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ReportingCellStatusOpt },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFreqReportCriteria_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_IntraFreqReportCriteria_r4, IntraFreqReportCriteria_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t IntraFrequencyMeasurement_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoList },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantity },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_reportCriteria3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFrequencyMeasurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFrequencyMeasurement, IntraFrequencyMeasurement_sequence);

  return offset;
}


static const per_sequence_t IntraFrequencyMeasurement_r4_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqCellInfoList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqCellInfoList_r4 },
  { &hf_umts_rrc_ies_intraFreqMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasQuantity },
  { &hf_umts_rrc_ies_intraFreqReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingQuantity },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_reportCriteria4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportCriteria_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_IntraFrequencyMeasurement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_IntraFrequencyMeasurement_r4, IntraFrequencyMeasurement_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_IP_Length_vals[] = {
  {   0, "ipl5" },
  {   1, "ipl10" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IP_Length(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_IP_PCCPCH_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_boolean(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const value_string umts_rrc_ies_IP_Spacing_vals[] = {
  {   0, "e5" },
  {   1, "e7" },
  {   2, "e10" },
  {   3, "e15" },
  {   4, "e20" },
  {   5, "e30" },
  {   6, "e40" },
  {   7, "e50" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IP_Spacing(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_IP_Spacing_TDD_vals[] = {
  {   0, "e30" },
  {   1, "e40" },
  {   2, "e50" },
  {   3, "e70" },
  {   4, "e100" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_IP_Spacing_TDD(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_RLC_BuffersPayload_vals[] = {
  {   0, "pl0" },
  {   1, "pl4" },
  {   2, "pl8" },
  {   3, "pl16" },
  {   4, "pl32" },
  {   5, "pl64" },
  {   6, "pl128" },
  {   7, "pl256" },
  {   8, "pl512" },
  {   9, "pl1024" },
  {  10, "pl2k" },
  {  11, "pl4k" },
  {  12, "pl8k" },
  {  13, "pl16k" },
  {  14, "pl32k" },
  {  15, "pl64k" },
  {  16, "pl128k" },
  {  17, "pl256k" },
  {  18, "pl512k" },
  {  19, "pl1024k" },
  {  20, "spare12" },
  {  21, "spare11" },
  {  22, "spare10" },
  {  23, "spare9" },
  {  24, "spare8" },
  {  25, "spare7" },
  {  26, "spare6" },
  {  27, "spare5" },
  {  28, "spare4" },
  {  29, "spare3" },
  {  30, "spare2" },
  {  31, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_RLC_BuffersPayload(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     32, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_VarianceOfRLC_BufferPayload_vals[] = {
  {   0, "plv0" },
  {   1, "plv4" },
  {   2, "plv8" },
  {   3, "plv16" },
  {   4, "plv32" },
  {   5, "plv64" },
  {   6, "plv128" },
  {   7, "plv256" },
  {   8, "plv512" },
  {   9, "plv1024" },
  {  10, "plv2k" },
  {  11, "plv4k" },
  {  12, "plv8k" },
  {  13, "plv16k" },
  {  14, "spare2" },
  {  15, "spare1" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_VarianceOfRLC_BufferPayload(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t TrafficVolumeMeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_rb_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RB_Identity },
  { &hf_umts_rrc_ies_rlc_BuffersPayload, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RLC_BuffersPayload },
  { &hf_umts_rrc_ies_averageRLC_BufferPayload1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AverageRLC_BufferPayload },
  { &hf_umts_rrc_ies_varianceOfRLC_BufferPayload1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_VarianceOfRLC_BufferPayload },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeMeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeMeasuredResults, TrafficVolumeMeasuredResults_sequence);

  return offset;
}


static const per_sequence_t TrafficVolumeMeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TrafficVolumeMeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeMeasuredResults },
};

int
dissect_umts_rrc_ies_TrafficVolumeMeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TrafficVolumeMeasuredResultsList, TrafficVolumeMeasuredResultsList_sequence_of,
                                                  1, maxRB);

  return offset;
}



static int
dissect_umts_rrc_ies_SIR(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SIR_TimeslotList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SIR_TimeslotList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIR },
};

static int
dissect_umts_rrc_ies_SIR_TimeslotList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SIR_TimeslotList, SIR_TimeslotList_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t SIR_MeasurementResults_sequence[] = {
  { &hf_umts_rrc_ies_tfcs_ID1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TFCS_IdentityPlain },
  { &hf_umts_rrc_ies_sir_TimeslotList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIR_TimeslotList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SIR_MeasurementResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SIR_MeasurementResults, SIR_MeasurementResults_sequence);

  return offset;
}


static const per_sequence_t SIR_MeasurementList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SIR_MeasurementList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIR_MeasurementResults },
};

static int
dissect_umts_rrc_ies_SIR_MeasurementList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SIR_MeasurementList, SIR_MeasurementList_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t T_tdd63_sequence[] = {
  { &hf_umts_rrc_ies_sir_MeasurementResults, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SIR_MeasurementList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd63(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd63, T_tdd63_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo63_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo63_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd70  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd63 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo63(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo63, T_modeSpecificInfo63_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t QualityMeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_blerMeasurementResultsList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BLER_MeasurementResultsList },
  { &hf_umts_rrc_ies_modeSpecificInfo63, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo63 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_QualityMeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_QualityMeasuredResults, QualityMeasuredResults_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_UE_TransmittedPower(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 104U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              768U, 1791U, NULL, FALSE);

  return offset;
}


static const per_sequence_t UE_RX_TX_ReportEntry_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceType1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_RX_TX_ReportEntry(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_RX_TX_ReportEntry, UE_RX_TX_ReportEntry_sequence);

  return offset;
}


static const per_sequence_t UE_RX_TX_ReportEntryList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_RX_TX_ReportEntryList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RX_TX_ReportEntry },
};

static int
dissect_umts_rrc_ies_UE_RX_TX_ReportEntryList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_RX_TX_ReportEntryList, UE_RX_TX_ReportEntryList_sequence_of,
                                                  1, maxRL);

  return offset;
}


static const per_sequence_t T_fdd72_sequence[] = {
  { &hf_umts_rrc_ies_ue_TransmittedPowerFDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_TransmittedPower },
  { &hf_umts_rrc_ies_ue_RX_TX_ReportEntryList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_RX_TX_ReportEntryList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd72(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd72, T_fdd72_sequence);

  return offset;
}


static const per_sequence_t UE_TransmittedPowerTDD_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_TransmittedPowerTDD_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_TransmittedPower },
};

static int
dissect_umts_rrc_ies_UE_TransmittedPowerTDD_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_TransmittedPowerTDD_List, UE_TransmittedPowerTDD_List_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t T_tdd65_sequence[] = {
  { &hf_umts_rrc_ies_ue_TransmittedPowerTDD_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_TransmittedPowerTDD_List },
  { &hf_umts_rrc_ies_appliedTA, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TimingAdvance },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd65(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd65, T_tdd65_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo65_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo65_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd77  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd72 },
  {   1, &hf_umts_rrc_ies_tdd72  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd65 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo65(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo65, T_modeSpecificInfo65_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_InternalMeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo65, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo65 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalMeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalMeasuredResults, UE_InternalMeasuredResults_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_ErrorCause_vals[] = {
  {   0, "notEnoughOTDOA-Cells" },
  {   1, "notEnoughGPS-Satellites" },
  {   2, "assistanceDataMissing" },
  {   3, "notAccomplishedGPS-TimingOfCellFrames" },
  {   4, "undefinedError" },
  {   5, "requestDeniedByUser" },
  {   6, "notProcessedAndTimeout" },
  {   7, "referenceCellNotServingCell" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UE_Positioning_ErrorCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SatData_sequence[] = {
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_iode   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IODE },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SatData(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SatData, SatData_sequence);

  return offset;
}


static const per_sequence_t SatDataList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SatDataList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatData },
};

static int
dissect_umts_rrc_ies_SatDataList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SatDataList, SatDataList_sequence_of,
                                                  0, maxSat);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_NavModelAddDataReq_sequence[] = {
  { &hf_umts_rrc_ies_gps_Week, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1023 },
  { &hf_umts_rrc_ies_gps_Toe, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_tToeLimit, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_satDataList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatDataList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_NavModelAddDataReq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_NavModelAddDataReq, UE_Positioning_GPS_NavModelAddDataReq_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_AdditionalAssistanceDataRequest_sequence[] = {
  { &hf_umts_rrc_ies_almanacRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_utcModelRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_ionosphericModelRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_navigationModelRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dgpsCorrectionsRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_referenceLocationRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_referenceTimeRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_aquisitionAssistanceRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_realTimeIntegrityRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_navModelAddDataRequest, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_NavModelAddDataReq },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_AdditionalAssistanceDataRequest(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_AdditionalAssistanceDataRequest, UE_Positioning_GPS_AdditionalAssistanceDataRequest_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_Error_sequence[] = {
  { &hf_umts_rrc_ies_errorReason, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_ErrorCause },
  { &hf_umts_rrc_ies_ue_positioning_GPS_additionalAssistanceDataRequest, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_AdditionalAssistanceDataRequest },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_Error(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_Error, UE_Positioning_Error_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_MeasuredResults_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_Measurement, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_Measurement },
  { &hf_umts_rrc_ies_ue_positioning_PositionEstimateInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_PositionEstimateInfo },
  { &hf_umts_rrc_ies_ue_positioning_GPS_Measurement, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_MeasurementResults },
  { &hf_umts_rrc_ies_ue_positioning_Error, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_Error },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_MeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_MeasuredResults, UE_Positioning_MeasuredResults_sequence);

  return offset;
}


const value_string umts_rrc_ies_MeasuredResults_vals[] = {
  {   0, "intraFreqMeasuredResultsList" },
  {   1, "interFreqMeasuredResultsList" },
  {   2, "interRATMeasuredResultsList" },
  {   3, "trafficVolumeMeasuredResultsList" },
  {   4, "qualityMeasuredResults" },
  {   5, "ue-InternalMeasuredResults" },
  {   6, "ue-positioning-MeasuredResults" },
  {   7, "spare" },
  { 0, NULL }
};

static const per_choice_t MeasuredResults_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqMeasuredResultsList },
  {   1, &hf_umts_rrc_ies_interFreqMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFreqMeasuredResultsList },
  {   2, &hf_umts_rrc_ies_interRATMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATMeasuredResultsList },
  {   3, &hf_umts_rrc_ies_trafficVolumeMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeMeasuredResultsList },
  {   4, &hf_umts_rrc_ies_qualityMeasuredResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_QualityMeasuredResults },
  {   5, &hf_umts_rrc_ies_ue_InternalMeasuredResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_InternalMeasuredResults },
  {   6, &hf_umts_rrc_ies_ue_positioning_MeasuredResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_MeasuredResults },
  {   7, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasuredResults(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasuredResults, MeasuredResults_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd71_sequence[] = {
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd71(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd71, T_fdd71_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo62_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo62_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd76  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd71 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo62(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo62, T_modeSpecificInfo62_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t Neighbour_v390ext_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo62, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo62 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_Neighbour_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Neighbour_v390ext, Neighbour_v390ext_sequence);

  return offset;
}


static const per_sequence_t NeighbourList_v390ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_NeighbourList_v390ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_Neighbour_v390ext },
};

static int
dissect_umts_rrc_ies_NeighbourList_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NeighbourList_v390ext, NeighbourList_v390ext_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_Measurement_v390ext_sequence[] = {
  { &hf_umts_rrc_ies_neighbourList_v390ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NeighbourList_v390ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_Measurement_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_Measurement_v390ext, UE_Positioning_OTDOA_Measurement_v390ext_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_MeasuredResults_v390ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_Positioning_OTDOA_Measurement_v390ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_Measurement_v390ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_MeasuredResults_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_MeasuredResults_v390ext, UE_Positioning_MeasuredResults_v390ext_sequence);

  return offset;
}


static const per_sequence_t MeasuredResults_v390ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_MeasuredResults_v390ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_MeasuredResults_v390ext },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasuredResults_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasuredResults_v390ext, MeasuredResults_v390ext_sequence);

  return offset;
}


const value_string umts_rrc_ies_MeasuredResults_v590ext_vals[] = {
  {   0, "intraFrequencyMeasuredResultsList" },
  {   1, "interFrequencyMeasuredResultsList" },
  { 0, NULL }
};

static const per_choice_t MeasuredResults_v590ext_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFrequencyMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext },
  {   1, &hf_umts_rrc_ies_interFrequencyMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasuredResults_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasuredResults_v590ext, MeasuredResults_v590ext_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_ADVinfo_sequence[] = {
  { &hf_umts_rrc_ies_t_ADV  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_2047 },
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ADVinfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ADVinfo, T_ADVinfo_sequence);

  return offset;
}


static const per_sequence_t UE_InternalMeasuredResults_LCR_r4_sequence[] = {
  { &hf_umts_rrc_ies_ue_TransmittedPowerTDD_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_TransmittedPowerTDD_List },
  { &hf_umts_rrc_ies_t_ADVinfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_ADVinfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalMeasuredResults_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalMeasuredResults_LCR_r4, UE_InternalMeasuredResults_LCR_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MeasuredResults_LCR_r4_vals[] = {
  {   0, "intraFreqMeasuredResultsList" },
  {   1, "interFreqMeasuredResultsList" },
  {   2, "interRATMeasuredResultsList" },
  {   3, "trafficVolumeMeasuredResultsList" },
  {   4, "qualityMeasuredResults" },
  {   5, "ue-InternalMeasuredResults" },
  {   6, "ue-positioniing-MeasuredResults" },
  {   7, "spare" },
  { 0, NULL }
};

static const per_choice_t MeasuredResults_LCR_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFreqMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFreqMeasuredResultsList },
  {   1, &hf_umts_rrc_ies_interFreqMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFreqMeasuredResultsList },
  {   2, &hf_umts_rrc_ies_interRATMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATMeasuredResultsList },
  {   3, &hf_umts_rrc_ies_trafficVolumeMeasuredResultsList, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeMeasuredResultsList },
  {   4, &hf_umts_rrc_ies_qualityMeasuredResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_QualityMeasuredResults },
  {   5, &hf_umts_rrc_ies_ue_InternalMeasuredResults1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_InternalMeasuredResults_LCR_r4 },
  {   6, &hf_umts_rrc_ies_ue_positioniing_MeasuredResults, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_MeasuredResults },
  {   7, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasuredResults_LCR_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasuredResults_LCR_r4, MeasuredResults_LCR_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MeasuredResultsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MeasuredResultsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasuredResults },
};

int
dissect_umts_rrc_ies_MeasuredResultsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MeasuredResultsList, MeasuredResultsList_sequence_of,
                                                  1, maxAdditionalMeas);

  return offset;
}


static const per_sequence_t MeasuredResultsList_LCR_r4_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasuredResults_LCR_r4 },
};

int
dissect_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext, MeasuredResultsList_LCR_r4_ext_sequence_of,
                                                  1, maxAdditionalMeas);

  return offset;
}


static const value_string umts_rrc_ies_T_measurementQuantity_vals[] = {
  {   0, "cpich-Ec-N0" },
  {   1, "cpich-RSCP" },
  {   2, "pathloss" },
  {   3, "spare" },
  { 0, NULL }
};

static const per_choice_t T_measurementQuantity_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_Ec_N01, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPICH_Ec_N0 },
  {   1, &hf_umts_rrc_ies_cpich_RSCP1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPICH_RSCP },
  {   2, &hf_umts_rrc_ies_pathloss, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Pathloss },
  {   3, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_measurementQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_measurementQuantity, T_measurementQuantity_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd68_sequence[] = {
  { &hf_umts_rrc_ies_measurementQuantity1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_measurementQuantity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd68(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd68, T_fdd68_sequence);

  return offset;
}


static const per_sequence_t T_tdd60_sequence[] = {
  { &hf_umts_rrc_ies_timeslotISCP, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeslotISCP_List },
  { &hf_umts_rrc_ies_primaryCCPCH_RSCP, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd60(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd60, T_tdd60_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo59_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo59_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd73  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd68 },
  {   1, &hf_umts_rrc_ies_tdd67  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd60 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo59(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo59, T_modeSpecificInfo59_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_currentCell_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo59, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo59 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_currentCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_currentCell, T_currentCell_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_measurementQuantity1_vals[] = {
  {   0, "cpich-Ec-N0" },
  {   1, "cpich-RSCP" },
  {   2, "pathloss" },
  {   3, "spare" },
  { 0, NULL }
};

static const per_choice_t T_measurementQuantity1_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_Ec_N01, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPICH_Ec_N0 },
  {   1, &hf_umts_rrc_ies_cpich_RSCP1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CPICH_RSCP },
  {   2, &hf_umts_rrc_ies_pathloss, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_Pathloss },
  {   3, &hf_umts_rrc_ies_spare  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_measurementQuantity1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_measurementQuantity1, T_measurementQuantity1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd69_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { &hf_umts_rrc_ies_measurementQuantity2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_measurementQuantity1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd69(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd69, T_fdd69_sequence);

  return offset;
}


static const per_sequence_t T_tdd61_sequence[] = {
  { &hf_umts_rrc_ies_cellParametersID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { &hf_umts_rrc_ies_primaryCCPCH_RSCP, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCCPCH_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd61(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd61, T_tdd61_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo60_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo60_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd74  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd69 },
  {   1, &hf_umts_rrc_ies_tdd68  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd61 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo60(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo60, T_modeSpecificInfo60_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MonitoredCellRACH_Result_sequence[] = {
  { &hf_umts_rrc_ies_sfn_SFN_ObsTimeDifference, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_SFN_ObsTimeDifference },
  { &hf_umts_rrc_ies_modeSpecificInfo60, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo60 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MonitoredCellRACH_Result(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MonitoredCellRACH_Result, MonitoredCellRACH_Result_sequence);

  return offset;
}


static const per_sequence_t MonitoredCellRACH_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_MonitoredCellRACH_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MonitoredCellRACH_Result },
};

static int
dissect_umts_rrc_ies_MonitoredCellRACH_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MonitoredCellRACH_List, MonitoredCellRACH_List_sequence_of,
                                                  1, 8);

  return offset;
}


static const per_sequence_t MeasuredResultsOnRACH_sequence[] = {
  { &hf_umts_rrc_ies_currentCell, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_currentCell },
  { &hf_umts_rrc_ies_monitoredCells, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MonitoredCellRACH_List },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasuredResultsOnRACH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasuredResultsOnRACH, MeasuredResultsOnRACH_sequence);

  return offset;
}


static const per_sequence_t MeasuredResultsOnRACHinterFreq_sequence[] = {
  { &hf_umts_rrc_ies_interFreqCellIndication_SIB11, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1 },
  { &hf_umts_rrc_ies_interFreqCellIndication_SIB12, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1 },
  { &hf_umts_rrc_ies_interFreqRACHRepCellsList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterFreqRACHRepCellsList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasuredResultsOnRACHinterFreq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasuredResultsOnRACHinterFreq, MeasuredResultsOnRACHinterFreq_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_MethodType_vals[] = {
  {   0, "ue-Assisted" },
  {   1, "ue-Based" },
  {   2, "ue-BasedPreferred" },
  {   3, "ue-AssistedPreferred" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UE_Positioning_MethodType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PositioningMethod_vals[] = {
  {   0, "otdoa" },
  {   1, "gps" },
  {   2, "otdoaOrGPS" },
  {   3, "cellID" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PositioningMethod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_ResponseTime_vals[] = {
  {   0, "s1" },
  {   1, "s2" },
  {   2, "s4" },
  {   3, "s8" },
  {   4, "s16" },
  {   5, "s32" },
  {   6, "s64" },
  {   7, "s128" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UE_Positioning_ResponseTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_UE_Positioning_Accuracy(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     7, 7, FALSE, NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_ReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_methodType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_MethodType },
  { &hf_umts_rrc_ies_positioningMethod, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositioningMethod },
  { &hf_umts_rrc_ies_dummy1_UE_Positioning_ResponseTime, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_ResponseTime },
  { &hf_umts_rrc_ies_horizontal_Accuracy, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_Accuracy },
  { &hf_umts_rrc_ies_gps_TimingOfCellWanted, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_dummy2_BOOLEAN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_additionalAssistanceDataRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_environmentCharacterisation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_EnvironmentCharacterisation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_ReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_ReportingQuantity, UE_Positioning_ReportingQuantity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_MeasurementInterval_vals[] = {
  {   0, "e5" },
  {   1, "e15" },
  {   2, "e60" },
  {   3, "e300" },
  {   4, "e900" },
  {   5, "e1800" },
  {   6, "e3600" },
  {   7, "e7200" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UE_Positioning_MeasurementInterval(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ThresholdPositionChange_vals[] = {
  {   0, "pc10" },
  {   1, "pc20" },
  {   2, "pc30" },
  {   3, "pc40" },
  {   4, "pc50" },
  {   5, "pc100" },
  {   6, "pc200" },
  {   7, "pc300" },
  {   8, "pc500" },
  {   9, "pc1000" },
  {  10, "pc2000" },
  {  11, "pc5000" },
  {  12, "pc10000" },
  {  13, "pc20000" },
  {  14, "pc50000" },
  {  15, "pc100000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ThresholdPositionChange(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ThresholdSFN_SFN_Change_vals[] = {
  {   0, "c0-25" },
  {   1, "c0-5" },
  {   2, "c1" },
  {   3, "c2" },
  {   4, "c3" },
  {   5, "c4" },
  {   6, "c5" },
  {   7, "c10" },
  {   8, "c20" },
  {   9, "c50" },
  {  10, "c100" },
  {  11, "c200" },
  {  12, "c500" },
  {  13, "c1000" },
  {  14, "c2000" },
  {  15, "c5000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ThresholdSFN_SFN_Change(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     16, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_ThresholdSFN_GPS_TOW_vals[] = {
  {   0, "ms1" },
  {   1, "ms2" },
  {   2, "ms3" },
  {   3, "ms5" },
  {   4, "ms10" },
  {   5, "ms20" },
  {   6, "ms50" },
  {   7, "ms100" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_ThresholdSFN_GPS_TOW(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_EventSpecificInfo_vals[] = {
  {   0, "e7a" },
  {   1, "e7b" },
  {   2, "e7c" },
  { 0, NULL }
};

static const per_choice_t UE_Positioning_EventSpecificInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_e7a    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdPositionChange },
  {   1, &hf_umts_rrc_ies_e7b    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdSFN_SFN_Change },
  {   2, &hf_umts_rrc_ies_e7c    , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ThresholdSFN_GPS_TOW },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_EventSpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_Positioning_EventSpecificInfo, UE_Positioning_EventSpecificInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_EventParam_sequence[] = {
  { &hf_umts_rrc_ies_reportingAmount, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReportingAmount },
  { &hf_umts_rrc_ies_reportFirstFix, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_measurementInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_MeasurementInterval },
  { &hf_umts_rrc_ies_eventSpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_EventSpecificInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_EventParam(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_EventParam, UE_Positioning_EventParam_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_EventParamList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_Positioning_EventParamList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_EventParam },
};

static int
dissect_umts_rrc_ies_UE_Positioning_EventParamList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_Positioning_EventParamList, UE_Positioning_EventParamList_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const value_string umts_rrc_ies_UE_Positioning_ReportCriteria_vals[] = {
  {   0, "ue-positioning-ReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t UE_Positioning_ReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_ue_positioning_ReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_EventParamList },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  {   2, &hf_umts_rrc_ies_noReporting1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_ReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_Positioning_ReportCriteria, UE_Positioning_ReportCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd81_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd81(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd81, T_fdd81_sequence);

  return offset;
}


static const per_sequence_t T_tdd74_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd74(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd74, T_tdd74_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo74_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo74_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd86  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd81 },
  {   1, &hf_umts_rrc_ies_tdd81  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd74 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo74(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo74, T_modeSpecificInfo74_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_ueBased2_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueBased2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueBased2, T_ueBased2_sequence);

  return offset;
}


static const per_sequence_t T_ueAssisted2_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueAssisted2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueAssisted2, T_ueAssisted2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_positioningMode2_vals[] = {
  {   0, "ueBased" },
  {   1, "ueAssisted" },
  { 0, NULL }
};

static const per_choice_t T_positioningMode2_choice[] = {
  {   0, &hf_umts_rrc_ies_ueBased2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueBased2 },
  {   1, &hf_umts_rrc_ies_ueAssisted2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueAssisted2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_positioningMode2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_positioningMode2, T_positioningMode2_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 9U, NULL, FALSE);

  return offset;
}


static const per_sequence_t UE_Positioning_IPDL_Parameters_sequence[] = {
  { &hf_umts_rrc_ies_ip_Spacing, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IP_Spacing },
  { &hf_umts_rrc_ies_ip_Length, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IP_Length },
  { &hf_umts_rrc_ies_ip_Offset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_9 },
  { &hf_umts_rrc_ies_seed   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_burstModeParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BurstModeParameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters, UE_Positioning_IPDL_Parameters_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_ReferenceCellInfo_sequence[] = {
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_modeSpecificInfo74, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo74 },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_positioningMode2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_positioningMode2 },
  { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo, UE_Positioning_OTDOA_ReferenceCellInfo_sequence);

  return offset;
}


static const per_sequence_t T_fdd78_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd78(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd78, T_fdd78_sequence);

  return offset;
}


static const per_sequence_t T_tdd71_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd71(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd71, T_tdd71_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo71_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo71_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd83  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd78 },
  {   1, &hf_umts_rrc_ies_tdd78  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd71 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo71(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo71, T_modeSpecificInfo71_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SFN_SFN_RelTimeDifference1_sequence[] = {
  { &hf_umts_rrc_ies_sfn_Offset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_sfn_sfn_Reltimedifference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_38399 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SFN_SFN_RelTimeDifference1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SFN_SFN_RelTimeDifference1, SFN_SFN_RelTimeDifference1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SFN_SFN_Drift_vals[] = {
  {   0, "sfnsfndrift0" },
  {   1, "sfnsfndrift1" },
  {   2, "sfnsfndrift2" },
  {   3, "sfnsfndrift3" },
  {   4, "sfnsfndrift4" },
  {   5, "sfnsfndrift5" },
  {   6, "sfnsfndrift8" },
  {   7, "sfnsfndrift10" },
  {   8, "sfnsfndrift15" },
  {   9, "sfnsfndrift25" },
  {  10, "sfnsfndrift35" },
  {  11, "sfnsfndrift50" },
  {  12, "sfnsfndrift65" },
  {  13, "sfnsfndrift80" },
  {  14, "sfnsfndrift100" },
  {  15, "sfnsfndrift-1" },
  {  16, "sfnsfndrift-2" },
  {  17, "sfnsfndrift-3" },
  {  18, "sfnsfndrift-4" },
  {  19, "sfnsfndrift-5" },
  {  20, "sfnsfndrift-8" },
  {  21, "sfnsfndrift-10" },
  {  22, "sfnsfndrift-15" },
  {  23, "sfnsfndrift-25" },
  {  24, "sfnsfndrift-35" },
  {  25, "sfnsfndrift-50" },
  {  26, "sfnsfndrift-65" },
  {  27, "sfnsfndrift-80" },
  {  28, "sfnsfndrift-100" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SFN_SFN_Drift(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     29, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_OTDOA_SearchWindowSize_vals[] = {
  {   0, "c20" },
  {   1, "c40" },
  {   2, "c80" },
  {   3, "c160" },
  {   4, "c320" },
  {   5, "c640" },
  {   6, "c1280" },
  {   7, "moreThan1280" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_OTDOA_SearchWindowSize(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     8, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_ueBased_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueBased(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueBased, T_ueBased_sequence);

  return offset;
}


static const per_sequence_t T_ueAssisted_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueAssisted(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueAssisted, T_ueAssisted_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_positioningMode_vals[] = {
  {   0, "ueBased" },
  {   1, "ueAssisted" },
  { 0, NULL }
};

static const per_choice_t T_positioningMode_choice[] = {
  {   0, &hf_umts_rrc_ies_ueBased, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueBased },
  {   1, &hf_umts_rrc_ies_ueAssisted, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueAssisted },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_positioningMode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_positioningMode, T_positioningMode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_NeighbourCellInfo_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo71, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo71 },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters },
  { &hf_umts_rrc_ies_sfn_SFN_RelTimeDifference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SFN_SFN_RelTimeDifference1 },
  { &hf_umts_rrc_ies_sfn_SFN_Drift, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_SFN_Drift },
  { &hf_umts_rrc_ies_searchWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OTDOA_SearchWindowSize },
  { &hf_umts_rrc_ies_positioningMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_positioningMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo, UE_Positioning_OTDOA_NeighbourCellInfo_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_NeighbourCellList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo },
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList, UE_Positioning_OTDOA_NeighbourCellList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_AssistanceData_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData, UE_Positioning_OTDOA_AssistanceData_sequence);

  return offset;
}


static const per_sequence_t T_utran_GPSTimingOfCell_sequence[] = {
  { &hf_umts_rrc_ies_ms_part, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1023 },
  { &hf_umts_rrc_ies_ls_part, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4294967295 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_utran_GPSTimingOfCell(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_utran_GPSTimingOfCell, T_utran_GPSTimingOfCell_sequence);

  return offset;
}


static const per_sequence_t T_fdd85_sequence[] = {
  { &hf_umts_rrc_ies_referenceIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd85(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd85, T_fdd85_sequence);

  return offset;
}


static const per_sequence_t T_tdd78_sequence[] = {
  { &hf_umts_rrc_ies_referenceIdentity1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd78(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd78, T_tdd78_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo78_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo78_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd90  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd85 },
  {   1, &hf_umts_rrc_ies_tdd85  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd78 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo78(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo78, T_modeSpecificInfo78_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UTRAN_GPSReferenceTime_sequence[] = {
  { &hf_umts_rrc_ies_utran_GPSTimingOfCell, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_utran_GPSTimingOfCell },
  { &hf_umts_rrc_ies_modeSpecificInfo78, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_modeSpecificInfo78 },
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UTRAN_GPSReferenceTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UTRAN_GPSReferenceTime, UTRAN_GPSReferenceTime_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SFN_TOW_Uncertainty_vals[] = {
  {   0, "lessThan10" },
  {   1, "moreThan10" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SFN_TOW_Uncertainty(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     2, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_UTRAN_GPS_DriftRate_vals[] = {
  {   0, "utran-GPSDrift0" },
  {   1, "utran-GPSDrift1" },
  {   2, "utran-GPSDrift2" },
  {   3, "utran-GPSDrift5" },
  {   4, "utran-GPSDrift10" },
  {   5, "utran-GPSDrift15" },
  {   6, "utran-GPSDrift25" },
  {   7, "utran-GPSDrift50" },
  {   8, "utran-GPSDrift-1" },
  {   9, "utran-GPSDrift-2" },
  {  10, "utran-GPSDrift-5" },
  {  11, "utran-GPSDrift-10" },
  {  12, "utran-GPSDrift-15" },
  {  13, "utran-GPSDrift-25" },
  {  14, "utran-GPSDrift-50" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UTRAN_GPS_DriftRate(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     15, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_ReferenceTime_sequence[] = {
  { &hf_umts_rrc_ies_gps_Week, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_1023 },
  { &hf_umts_rrc_ies_gps_tow_1msec, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GPS_TOW_1msec },
  { &hf_umts_rrc_ies_utran_GPSReferenceTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UTRAN_GPSReferenceTime },
  { &hf_umts_rrc_ies_sfn_tow_Uncertainty, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_TOW_Uncertainty },
  { &hf_umts_rrc_ies_utran_GPS_DriftRate, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UTRAN_GPS_DriftRate },
  { &hf_umts_rrc_ies_gps_TOW_AssistList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_GPS_TOW_AssistList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_ReferenceTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_ReferenceTime, UE_Positioning_GPS_ReferenceTime_sequence);

  return offset;
}


static const per_sequence_t ReferenceLocation_sequence[] = {
  { &hf_umts_rrc_ies_ellipsoidPointAltitudeEllipsoide, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_EllipsoidPointAltitudeEllipsoide },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReferenceLocation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_ReferenceLocation, ReferenceLocation_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_604799(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 604799U, NULL, FALSE);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_DGPS_Corrections_sequence[] = {
  { &hf_umts_rrc_ies_gps_TOW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_604799 },
  { &hf_umts_rrc_ies_statusHealth, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DiffCorrectionStatus },
  { &hf_umts_rrc_ies_dgps_CorrectionSatInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DGPS_CorrectionSatInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_DGPS_Corrections(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_DGPS_Corrections, UE_Positioning_GPS_DGPS_Corrections_sequence);

  return offset;
}


static const value_string umts_rrc_ies_SatelliteStatus_vals[] = {
  {   0, "ns-NN-U" },
  {   1, "es-SN" },
  {   2, "es-NN-U" },
  {   3, "rev2" },
  {   4, "rev" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_SatelliteStatus(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     5, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SubFrame1Reserved_sequence[] = {
  { &hf_umts_rrc_ies_reserved1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_23 },
  { &hf_umts_rrc_ies_reserved2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_reserved3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_reserved4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SubFrame1Reserved(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SubFrame1Reserved, SubFrame1Reserved_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     32, 32, FALSE, NULL);

  return offset;
}


static const per_sequence_t EphemerisParameter_sequence[] = {
  { &hf_umts_rrc_ies_codeOnL2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_2 },
  { &hf_umts_rrc_ies_uraIndex, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_4 },
  { &hf_umts_rrc_ies_satHealth1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_6 },
  { &hf_umts_rrc_ies_iodc   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_10 },
  { &hf_umts_rrc_ies_l2Pflag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_1 },
  { &hf_umts_rrc_ies_sf1Revd, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SubFrame1Reserved },
  { &hf_umts_rrc_ies_t_GD   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_t_oc   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_af2    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_af11   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_af01   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_22 },
  { &hf_umts_rrc_ies_c_rs   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_delta_n, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_m01    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_c_uc   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_e1     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_c_us   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_a_Sqrt1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_t_oe   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_fitInterval, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_1 },
  { &hf_umts_rrc_ies_aodo   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_5 },
  { &hf_umts_rrc_ies_c_ic   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_omega01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_c_is   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_i0     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_c_rc   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_16 },
  { &hf_umts_rrc_ies_omega1 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_omegaDot1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_iDot   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_14 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_EphemerisParameter(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_EphemerisParameter, EphemerisParameter_sequence);

  return offset;
}


static const per_sequence_t NavigationModelSatInfo_sequence[] = {
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_satelliteStatus, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatelliteStatus },
  { &hf_umts_rrc_ies_ephemerisParameter, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_EphemerisParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_NavigationModelSatInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_NavigationModelSatInfo, NavigationModelSatInfo_sequence);

  return offset;
}


static const per_sequence_t NavigationModelSatInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_NavigationModelSatInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NavigationModelSatInfo },
};

static int
dissect_umts_rrc_ies_NavigationModelSatInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_NavigationModelSatInfoList, NavigationModelSatInfoList_sequence_of,
                                                  1, maxSat);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_NavigationModel_sequence[] = {
  { &hf_umts_rrc_ies_navigationModelSatInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NavigationModelSatInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_NavigationModel(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_NavigationModel, UE_Positioning_GPS_NavigationModel_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_IonosphericModel_sequence[] = {
  { &hf_umts_rrc_ies_alfa0  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_alfa1  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_alfa2  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_alfa3  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_beta0  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_beta1  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_beta2  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_beta3  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_IonosphericModel(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_IonosphericModel, UE_Positioning_GPS_IonosphericModel_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_UTC_Model_sequence[] = {
  { &hf_umts_rrc_ies_a1     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_24 },
  { &hf_umts_rrc_ies_a0     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_32 },
  { &hf_umts_rrc_ies_t_ot   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_wn_t   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_delta_t_LS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_wn_lsf , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_dn     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_delta_t_LSF, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_UTC_Model(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_UTC_Model, UE_Positioning_GPS_UTC_Model_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_364(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     364, 364, FALSE, NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_Almanac_sequence[] = {
  { &hf_umts_rrc_ies_wn_a   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_almanacSatInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AlmanacSatInfoList },
  { &hf_umts_rrc_ies_sv_GlobalHealth, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BIT_STRING_SIZE_364 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_Almanac(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_Almanac, UE_Positioning_GPS_Almanac_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_AcquisitionAssistance_sequence[] = {
  { &hf_umts_rrc_ies_gps_ReferenceTime, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_604799999 },
  { &hf_umts_rrc_ies_utran_GPSReferenceTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UTRAN_GPSReferenceTime },
  { &hf_umts_rrc_ies_satelliteInformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AcquisitionSatInfoList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_AcquisitionAssistance(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_AcquisitionAssistance, UE_Positioning_GPS_AcquisitionAssistance_sequence);

  return offset;
}


static const per_sequence_t T_fdd75_sequence[] = {
  { &hf_umts_rrc_ies_referenceIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd75(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd75, T_fdd75_sequence);

  return offset;
}


static const per_sequence_t T_tdd68_sequence[] = {
  { &hf_umts_rrc_ies_referenceIdentity1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellParametersID },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd68(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd68, T_tdd68_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo68_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo68_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd80  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd75 },
  {   1, &hf_umts_rrc_ies_tdd75  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd68 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo68(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo68, T_modeSpecificInfo68_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_ReferenceCellInfo_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo68, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo68 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_GPS_ReferenceCellInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_ReferenceCellInfo, UE_Positioning_GPS_ReferenceCellInfo_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_GPS_AssistanceData_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_GPS_ReferenceTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_ReferenceTime },
  { &hf_umts_rrc_ies_ue_positioning_GPS_ReferenceLocation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceLocation },
  { &hf_umts_rrc_ies_ue_positioning_GPS_DGPS_Corrections, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_DGPS_Corrections },
  { &hf_umts_rrc_ies_ue_positioning_GPS_NavigationModel, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_NavigationModel },
  { &hf_umts_rrc_ies_ue_positioning_GPS_IonosphericModel, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_IonosphericModel },
  { &hf_umts_rrc_ies_ue_positioning_GPS_UTC_Model, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_UTC_Model },
  { &hf_umts_rrc_ies_ue_positioning_GPS_Almanac, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_Almanac },
  { &hf_umts_rrc_ies_ue_positioning_GPS_AcquisitionAssistance, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_AcquisitionAssistance },
  { &hf_umts_rrc_ies_ue_positioning_GPS_Real_timeIntegrity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BadSatList },
  { &hf_umts_rrc_ies_dummy_UE_Positioning_GPS_ReferenceCellInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_ReferenceCellInfo },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_Positioning_GPS_AssistanceData(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_GPS_AssistanceData, UE_Positioning_GPS_AssistanceData_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_Measurement_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_ReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_ReportingQuantity },
  { &hf_umts_rrc_ies_reportCriteria10, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_ReportCriteria },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData },
  { &hf_umts_rrc_ies_ue_positioning_GPS_AssistanceData, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_AssistanceData },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_Measurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_Measurement, UE_Positioning_Measurement_sequence);

  return offset;
}


static const per_sequence_t TrafficVolumeMeasurementObjectList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TrafficVolumeMeasurementObjectList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_TrCH_Identity },
};

static int
dissect_umts_rrc_ies_TrafficVolumeMeasurementObjectList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TrafficVolumeMeasurementObjectList, TrafficVolumeMeasurementObjectList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}



static int
dissect_umts_rrc_ies_TimeInterval(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 13U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_TrafficVolumeMeasQuantity_vals[] = {
  {   0, "rlc-BufferPayload" },
  {   1, "averageRLC-BufferPayload" },
  {   2, "varianceOfRLC-BufferPayload" },
  { 0, NULL }
};

static const per_choice_t TrafficVolumeMeasQuantity_choice[] = {
  {   0, &hf_umts_rrc_ies_rlc_BufferPayload, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_averageRLC_BufferPayload, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TimeInterval },
  {   2, &hf_umts_rrc_ies_varianceOfRLC_BufferPayload, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TimeInterval },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeMeasQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TrafficVolumeMeasQuantity, TrafficVolumeMeasQuantity_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TrafficVolumeReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_rlc_RB_BufferPayload, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_rlc_RB_BufferPayloadAverage, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_rlc_RB_BufferPayloadVariance, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeReportingQuantity, TrafficVolumeReportingQuantity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TrafficVolumeThreshold_vals[] = {
  {   0, "th8" },
  {   1, "th16" },
  {   2, "th32" },
  {   3, "th64" },
  {   4, "th128" },
  {   5, "th256" },
  {   6, "th512" },
  {   7, "th1024" },
  {   8, "th2k" },
  {   9, "th3k" },
  {  10, "th4k" },
  {  11, "th6k" },
  {  12, "th8k" },
  {  13, "th12k" },
  {  14, "th16k" },
  {  15, "th24k" },
  {  16, "th32k" },
  {  17, "th48k" },
  {  18, "th64k" },
  {  19, "th96k" },
  {  20, "th128k" },
  {  21, "th192k" },
  {  22, "th256k" },
  {  23, "th384k" },
  {  24, "th512k" },
  {  25, "th768k" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TrafficVolumeThreshold(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     26, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_PendingTimeAfterTrigger_vals[] = {
  {   0, "ptat0-25" },
  {   1, "ptat0-5" },
  {   2, "ptat1" },
  {   3, "ptat2" },
  {   4, "ptat4" },
  {   5, "ptat8" },
  {   6, "ptat16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_PendingTimeAfterTrigger(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}


static const value_string umts_rrc_ies_TX_InterruptionAfterTrigger_vals[] = {
  {   0, "txiat0-25" },
  {   1, "txiat0-5" },
  {   2, "txiat1" },
  {   3, "txiat2" },
  {   4, "txiat4" },
  {   5, "txiat8" },
  {   6, "txiat16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_TX_InterruptionAfterTrigger(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     7, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t TrafficVolumeEventParam_sequence[] = {
  { &hf_umts_rrc_ies_eventID3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeEventType },
  { &hf_umts_rrc_ies_reportingThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeThreshold },
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_pendingTimeAfterTrigger, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PendingTimeAfterTrigger },
  { &hf_umts_rrc_ies_tx_InterruptionAfterTrigger, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TX_InterruptionAfterTrigger },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeEventParam(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeEventParam, TrafficVolumeEventParam_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam_sequence_of[1] = {
  { &hf_umts_rrc_ies_eventSpecificParameters_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeEventParam },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam, SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam_sequence_of,
                                                  1, maxMeasParEvent);

  return offset;
}


static const per_sequence_t TransChCriteria_sequence[] = {
  { &hf_umts_rrc_ies_ul_transportChannelID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UL_TrCH_Identity },
  { &hf_umts_rrc_ies_eventSpecificParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TransChCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TransChCriteria, TransChCriteria_sequence);

  return offset;
}


static const per_sequence_t TransChCriteriaList_sequence_of[1] = {
  { &hf_umts_rrc_ies_TransChCriteriaList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransChCriteria },
};

static int
dissect_umts_rrc_ies_TransChCriteriaList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TransChCriteriaList, TransChCriteriaList_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const per_sequence_t TrafficVolumeReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_transChCriteriaList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TransChCriteriaList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeReportingCriteria, TrafficVolumeReportingCriteria_sequence);

  return offset;
}


static const value_string umts_rrc_ies_TrafficVolumeReportCriteria_vals[] = {
  {   0, "trafficVolumeReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t TrafficVolumeReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_trafficVolumeReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  {   2, &hf_umts_rrc_ies_noReporting1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TrafficVolumeReportCriteria, TrafficVolumeReportCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TrafficVolumeMeasurement_sequence[] = {
  { &hf_umts_rrc_ies_trafficVolumeMeasurementObjectList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeMeasurementObjectList },
  { &hf_umts_rrc_ies_trafficVolumeMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeMeasQuantity },
  { &hf_umts_rrc_ies_trafficVolumeReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeReportingQuantity },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_reportCriteria8, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeMeasurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeMeasurement, TrafficVolumeMeasurement_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_SIR_TFCS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_TFCS_IdentityPlain(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t SIR_TFCS_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_SIR_TFCS_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIR_TFCS },
};

static int
dissect_umts_rrc_ies_SIR_TFCS_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SIR_TFCS_List, SIR_TFCS_List_sequence_of,
                                                  1, maxCCTrCH);

  return offset;
}


static const per_sequence_t T_tdd64_sequence[] = {
  { &hf_umts_rrc_ies_sir_TFCS_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SIR_TFCS_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd64(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd64, T_tdd64_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo64_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo64_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd2   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_tdd71  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd64 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo64(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo64, T_modeSpecificInfo64_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t QualityReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_dl_TransChBLER, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_bler_dl_TransChIdList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BLER_TransChIdList },
  { &hf_umts_rrc_ies_modeSpecificInfo64, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo64 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_QualityReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_QualityReportingQuantity, QualityReportingQuantity_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_512(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 512U, NULL, FALSE);

  return offset;
}


static const per_sequence_t QualityReportingCriteriaSingle_sequence[] = {
  { &hf_umts_rrc_ies_transportChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportChannelIdentity },
  { &hf_umts_rrc_ies_totalCRC, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_512 },
  { &hf_umts_rrc_ies_badCRC , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_512 },
  { &hf_umts_rrc_ies_pendingAfterTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_512 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_QualityReportingCriteriaSingle(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_QualityReportingCriteriaSingle, QualityReportingCriteriaSingle_sequence);

  return offset;
}


static const per_sequence_t QualityReportingCriteria_sequence_of[1] = {
  { &hf_umts_rrc_ies_QualityReportingCriteria_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_QualityReportingCriteriaSingle },
};

static int
dissect_umts_rrc_ies_QualityReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_QualityReportingCriteria, QualityReportingCriteria_sequence_of,
                                                  1, maxTrCH);

  return offset;
}


static const value_string umts_rrc_ies_QualityReportCriteria_vals[] = {
  {   0, "qualityReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t QualityReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_qualityReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_QualityReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  {   2, &hf_umts_rrc_ies_noReporting1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_QualityReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_QualityReportCriteria, QualityReportCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t QualityMeasurement_sequence[] = {
  { &hf_umts_rrc_ies_qualityReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_QualityReportingQuantity },
  { &hf_umts_rrc_ies_reportCriteria5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_QualityReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_QualityMeasurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_QualityMeasurement, QualityMeasurement_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_MeasurementQuantity_vals[] = {
  {   0, "ue-TransmittedPower" },
  {   1, "utra-Carrier-RSSI" },
  {   2, "ue-RX-TX-TimeDifference" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_UE_MeasurementQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t UE_InternalMeasQuantity_sequence[] = {
  { &hf_umts_rrc_ies_measurementQuantity3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_MeasurementQuantity },
  { &hf_umts_rrc_ies_filterCoefficient, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FilterCoefficient },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalMeasQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalMeasQuantity, UE_InternalMeasQuantity_sequence);

  return offset;
}


static const per_sequence_t T_fdd73_sequence[] = {
  { &hf_umts_rrc_ies_ue_RX_TX_TimeDifference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd73(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd73, T_fdd73_sequence);

  return offset;
}


static const per_sequence_t T_tdd66_sequence[] = {
  { &hf_umts_rrc_ies_appliedTA1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd66(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd66, T_tdd66_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo66_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo66_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd78  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd73 },
  {   1, &hf_umts_rrc_ies_tdd73  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd66 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo66(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo66, T_modeSpecificInfo66_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_InternalReportingQuantity_sequence[] = {
  { &hf_umts_rrc_ies_ue_TransmittedPower, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_modeSpecificInfo66, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo66 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalReportingQuantity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalReportingQuantity, UE_InternalReportingQuantity_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_TransmittedPowerThreshold(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -50, 33U, NULL, FALSE);

  return offset;
}


static const per_sequence_t UE_6AB_Event_sequence[] = {
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_transmittedPowerThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransmittedPowerThreshold },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_6AB_Event(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_6AB_Event, UE_6AB_Event_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceThreshold(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              768U, 1280U, NULL, FALSE);

  return offset;
}


static const per_sequence_t UE_6FG_Event_sequence[] = {
  { &hf_umts_rrc_ies_timeToTrigger, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeToTrigger },
  { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceThreshold, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_RX_TX_TimeDifferenceThreshold },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_6FG_Event(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_6FG_Event, UE_6FG_Event_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_InternalEventParam_vals[] = {
  {   0, "event6a" },
  {   1, "event6b" },
  {   2, "event6c" },
  {   3, "event6d" },
  {   4, "event6e" },
  {   5, "event6f" },
  {   6, "event6g" },
  { 0, NULL }
};

static const per_choice_t UE_InternalEventParam_choice[] = {
  {   0, &hf_umts_rrc_ies_event6a, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_6AB_Event },
  {   1, &hf_umts_rrc_ies_event6b, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_6AB_Event },
  {   2, &hf_umts_rrc_ies_event6c, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TimeToTrigger },
  {   3, &hf_umts_rrc_ies_event6d, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TimeToTrigger },
  {   4, &hf_umts_rrc_ies_event6e, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TimeToTrigger },
  {   5, &hf_umts_rrc_ies_event6f, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_6FG_Event },
  {   6, &hf_umts_rrc_ies_event6g, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_6FG_Event },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalEventParam(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_InternalEventParam, UE_InternalEventParam_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_InternalEventParamList_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_InternalEventParamList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_InternalEventParam },
};

static int
dissect_umts_rrc_ies_UE_InternalEventParamList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_InternalEventParamList, UE_InternalEventParamList_sequence_of,
                                                  1, maxMeasEvent);

  return offset;
}


static const per_sequence_t UE_InternalReportingCriteria_sequence[] = {
  { &hf_umts_rrc_ies_ue_InternalEventParamList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_InternalEventParamList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalReportingCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalReportingCriteria, UE_InternalReportingCriteria_sequence);

  return offset;
}


static const value_string umts_rrc_ies_UE_InternalReportCriteria_vals[] = {
  {   0, "ue-InternalReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  {   2, "noReporting" },
  { 0, NULL }
};

static const per_choice_t UE_InternalReportCriteria_choice[] = {
  {   0, &hf_umts_rrc_ies_ue_InternalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_InternalReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  {   2, &hf_umts_rrc_ies_noReporting1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalReportCriteria(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_UE_InternalReportCriteria, UE_InternalReportCriteria_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_InternalMeasurement_sequence[] = {
  { &hf_umts_rrc_ies_ue_InternalMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_InternalMeasQuantity },
  { &hf_umts_rrc_ies_ue_InternalReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_InternalReportingQuantity },
  { &hf_umts_rrc_ies_reportCriteria9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_InternalReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalMeasurement(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalMeasurement, UE_InternalMeasurement_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MeasurementType_vals[] = {
  {   0, "intraFrequencyMeasurement" },
  {   1, "interFrequencyMeasurement" },
  {   2, "interRATMeasurement" },
  {   3, "ue-positioning-Measurement" },
  {   4, "trafficVolumeMeasurement" },
  {   5, "qualityMeasurement" },
  {   6, "ue-InternalMeasurement" },
  { 0, NULL }
};

static const per_choice_t MeasurementType_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFrequencyMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFrequencyMeasurement },
  {   1, &hf_umts_rrc_ies_interFrequencyMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFrequencyMeasurement },
  {   2, &hf_umts_rrc_ies_interRATMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATMeasurement },
  {   3, &hf_umts_rrc_ies_ue_positioning_Measurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_Measurement },
  {   4, &hf_umts_rrc_ies_trafficVolumeMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeMeasurement },
  {   5, &hf_umts_rrc_ies_qualityMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_QualityMeasurement },
  {   6, &hf_umts_rrc_ies_ue_InternalMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_InternalMeasurement },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementType(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasurementType, MeasurementType_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_modify1_sequence[] = {
  { &hf_umts_rrc_ies_measurementType, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementType },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modify1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_modify1, T_modify1_sequence);

  return offset;
}


const value_string umts_rrc_ies_MeasurementCommand_vals[] = {
  {   0, "setup" },
  {   1, "modify" },
  {   2, "release" },
  { 0, NULL }
};

static const per_choice_t MeasurementCommand_choice[] = {
  {   0, &hf_umts_rrc_ies_setup  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MeasurementType },
  {   1, &hf_umts_rrc_ies_modify1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_modify1 },
  {   2, &hf_umts_rrc_ies_release1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasurementCommand(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasurementCommand, MeasurementCommand_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_ReportingQuantity_r4_sequence[] = {
  { &hf_umts_rrc_ies_methodType, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_MethodType },
  { &hf_umts_rrc_ies_positioningMethod, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PositioningMethod },
  { &hf_umts_rrc_ies_horizontalAccuracy, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_Accuracy },
  { &hf_umts_rrc_ies_verticalAccuracy, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_Accuracy },
  { &hf_umts_rrc_ies_gps_TimingOfCellWanted, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_additionalAssistanceDataReq, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_environmentCharacterisation, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_EnvironmentCharacterisation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_ReportingQuantity_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_ReportingQuantity_r4, UE_Positioning_ReportingQuantity_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd82_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd82(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd82, T_fdd82_sequence);

  return offset;
}


static const per_sequence_t T_tdd75_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd75(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd75, T_tdd75_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo75_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo75_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd87  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd82 },
  {   1, &hf_umts_rrc_ies_tdd82  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd75 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo75(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo75, T_modeSpecificInfo75_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_ReferenceCellPosition_vals[] = {
  {   0, "ellipsoidPoint" },
  {   1, "ellipsoidPointWithAltitude" },
  { 0, NULL }
};

static const per_choice_t ReferenceCellPosition_choice[] = {
  {   0, &hf_umts_rrc_ies_ellipsoidPoint, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPoint },
  {   1, &hf_umts_rrc_ies_ellipsoidPointWithAltitude, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_EllipsoidPointAltitude },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_ReferenceCellPosition(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_ReferenceCellPosition, ReferenceCellPosition_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_32766(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 32766U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ueBased3_sequence[] = {
  { &hf_umts_rrc_ies_cellPosition, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceCellPosition },
  { &hf_umts_rrc_ies_roundTripTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_32766 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueBased3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueBased3, T_ueBased3_sequence);

  return offset;
}


static const per_sequence_t T_ueAssisted3_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueAssisted3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueAssisted3, T_ueAssisted3_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_positioningMode3_vals[] = {
  {   0, "ueBased" },
  {   1, "ueAssisted" },
  { 0, NULL }
};

static const per_choice_t T_positioningMode3_choice[] = {
  {   0, &hf_umts_rrc_ies_ueBased3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueBased3 },
  {   1, &hf_umts_rrc_ies_ueAssisted3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueAssisted3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_positioningMode3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_positioningMode3, T_positioningMode3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_fdd76_sequence[] = {
  { &hf_umts_rrc_ies_ip_Spacing, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IP_Spacing },
  { &hf_umts_rrc_ies_ip_Length, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IP_Length },
  { &hf_umts_rrc_ies_ip_Offset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_9 },
  { &hf_umts_rrc_ies_seed   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd76(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd76, T_fdd76_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_0_14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 14U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_tdd69_sequence[] = {
  { &hf_umts_rrc_ies_ip_Spacing_TDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IP_Spacing_TDD },
  { &hf_umts_rrc_ies_ip_slot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_14 },
  { &hf_umts_rrc_ies_ip_Start, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_ip_PCCPCG, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IP_PCCPCH_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd69(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd69, T_tdd69_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo69_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo69_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd81  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd76 },
  {   1, &hf_umts_rrc_ies_tdd76  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd69 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo69(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo69, T_modeSpecificInfo69_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_IPDL_Parameters_r4_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo69, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo69 },
  { &hf_umts_rrc_ies_burstModeParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BurstModeParameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_r4, UE_Positioning_IPDL_Parameters_r4_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_ReferenceCellInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_modeSpecificInfo75, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo75 },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_positioningMode3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_positioningMode3 },
  { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_r4, UE_Positioning_OTDOA_ReferenceCellInfo_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd79_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd79(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd79, T_fdd79_sequence);

  return offset;
}


static const per_sequence_t T_tdd72_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd72(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd72, T_tdd72_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo72_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo72_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd84  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd79 },
  {   1, &hf_umts_rrc_ies_tdd79  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd72 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo72(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo72, T_modeSpecificInfo72_choice,
                                 NULL);

  return offset;
}


const value_string umts_rrc_ies_SFN_Offset_Validity_vals[] = {
  {   0, "false" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_SFN_Offset_Validity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M20000_20000(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -20000, 20000U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_M4000_4000(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -4000, 4000U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_ueBased1_sequence[] = {
  { &hf_umts_rrc_ies_relativeNorth, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_M20000_20000 },
  { &hf_umts_rrc_ies_relativeEast, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_M20000_20000 },
  { &hf_umts_rrc_ies_relativeAltitude, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_M4000_4000 },
  { &hf_umts_rrc_ies_fineSFN_SFN, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FineSFN_SFN },
  { &hf_umts_rrc_ies_roundTripTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_32766 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueBased1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueBased1, T_ueBased1_sequence);

  return offset;
}


static const per_sequence_t T_ueAssisted1_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_ueAssisted1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_ueAssisted1, T_ueAssisted1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_positioningMode1_vals[] = {
  {   0, "ueBased" },
  {   1, "ueAssisted" },
  { 0, NULL }
};

static const per_choice_t T_positioningMode1_choice[] = {
  {   0, &hf_umts_rrc_ies_ueBased1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueBased1 },
  {   1, &hf_umts_rrc_ies_ueAssisted1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_ueAssisted1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_positioningMode1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_positioningMode1, T_positioningMode1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_NeighbourCellInfo_r4_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo72, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo72 },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_r4 },
  { &hf_umts_rrc_ies_sfn_SFN_RelTimeDifference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SFN_SFN_RelTimeDifference1 },
  { &hf_umts_rrc_ies_sfn_Offset_Validity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_Offset_Validity },
  { &hf_umts_rrc_ies_sfn_SFN_Drift, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_SFN_Drift },
  { &hf_umts_rrc_ies_searchWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OTDOA_SearchWindowSize },
  { &hf_umts_rrc_ies_positioningMode1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_positioningMode1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_r4, UE_Positioning_OTDOA_NeighbourCellInfo_r4_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_NeighbourCellList_r4_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_r4 },
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4, UE_Positioning_OTDOA_NeighbourCellList_r4_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_AssistanceData_r4_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_r4 },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4, UE_Positioning_OTDOA_AssistanceData_r4_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_Measurement_r4_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_ReportingQuantity1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_ReportingQuantity_r4 },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_reportCriteria10, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_ReportCriteria },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4 },
  { &hf_umts_rrc_ies_ue_positioning_GPS_AssistanceData, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_AssistanceData },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_Measurement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_Measurement_r4, UE_Positioning_Measurement_r4_sequence);

  return offset;
}


static const per_sequence_t T_fdd74_sequence[] = {
  { &hf_umts_rrc_ies_ue_RX_TX_TimeDifference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd74(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd74, T_fdd74_sequence);

  return offset;
}


static const per_sequence_t T_tdd38414_sequence[] = {
  { &hf_umts_rrc_ies_appliedTA1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38414(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38414, T_tdd38414_sequence);

  return offset;
}


static const per_sequence_t T_tdd12816_sequence[] = {
  { &hf_umts_rrc_ies_t_ADVinfo1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12816(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12816, T_tdd12816_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_tddOption14_vals[] = {
  {   0, "tdd384" },
  {   1, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_tddOption14_choice[] = {
  {   0, &hf_umts_rrc_ies_tdd38418, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38414 },
  {   1, &hf_umts_rrc_ies_tdd12820, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12816 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tddOption14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_tddOption14, T_tddOption14_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd67_sequence[] = {
  { &hf_umts_rrc_ies_tddOption14, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_tddOption14 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd67(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd67, T_tdd67_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo67_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo67_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd79  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd74 },
  {   1, &hf_umts_rrc_ies_tdd74  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd67 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo67(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo67, T_modeSpecificInfo67_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_InternalReportingQuantity_r4_sequence[] = {
  { &hf_umts_rrc_ies_ue_TransmittedPower, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_modeSpecificInfo67, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo67 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalReportingQuantity_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalReportingQuantity_r4, UE_InternalReportingQuantity_r4_sequence);

  return offset;
}


static const per_sequence_t UE_InternalMeasurement_r4_sequence[] = {
  { &hf_umts_rrc_ies_ue_InternalMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_InternalMeasQuantity },
  { &hf_umts_rrc_ies_ue_InternalReportingQuantity1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_InternalReportingQuantity_r4 },
  { &hf_umts_rrc_ies_reportCriteria9, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_InternalReportCriteria },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalMeasurement_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalMeasurement_r4, UE_InternalMeasurement_r4_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MeasurementType_r4_vals[] = {
  {   0, "intraFrequencyMeasurement" },
  {   1, "interFrequencyMeasurement" },
  {   2, "interRATMeasurement" },
  {   3, "up-Measurement" },
  {   4, "trafficVolumeMeasurement" },
  {   5, "qualityMeasurement" },
  {   6, "ue-InternalMeasurement" },
  { 0, NULL }
};

static const per_choice_t MeasurementType_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_intraFrequencyMeasurement1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_IntraFrequencyMeasurement_r4 },
  {   1, &hf_umts_rrc_ies_interFrequencyMeasurement1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterFrequencyMeasurement_r4 },
  {   2, &hf_umts_rrc_ies_interRATMeasurement1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_InterRATMeasurement_r4 },
  {   3, &hf_umts_rrc_ies_up_Measurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_Positioning_Measurement_r4 },
  {   4, &hf_umts_rrc_ies_trafficVolumeMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeMeasurement },
  {   5, &hf_umts_rrc_ies_qualityMeasurement, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_QualityMeasurement },
  {   6, &hf_umts_rrc_ies_ue_InternalMeasurement1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_UE_InternalMeasurement_r4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementType_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasurementType_r4, MeasurementType_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_modify2_sequence[] = {
  { &hf_umts_rrc_ies_measurementType1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementType_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modify2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_modify2, T_modify2_sequence);

  return offset;
}


const value_string umts_rrc_ies_MeasurementCommand_r4_vals[] = {
  {   0, "setup" },
  {   1, "modify" },
  {   2, "release" },
  { 0, NULL }
};

static const per_choice_t MeasurementCommand_r4_choice[] = {
  {   0, &hf_umts_rrc_ies_setup1 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MeasurementType_r4 },
  {   1, &hf_umts_rrc_ies_modify2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_modify2 },
  {   2, &hf_umts_rrc_ies_release1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_MeasurementCommand_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MeasurementCommand_r4, MeasurementCommand_r4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_cpich_RSCP_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_RSCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_RSCP, T_cpich_RSCP_sequence);

  return offset;
}


static const per_sequence_t T_cpich_Ec_N01_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0 },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_Ec_N01(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_Ec_N01, T_cpich_Ec_N01_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cellSelectQualityMeasure1_vals[] = {
  {   0, "cpich-RSCP" },
  {   1, "cpich-Ec-N0" },
  { 0, NULL }
};

static const per_choice_t T_cellSelectQualityMeasure1_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_RSCP2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_RSCP },
  {   1, &hf_umts_rrc_ies_cpich_Ec_N02, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_Ec_N01 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cellSelectQualityMeasure1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cellSelectQualityMeasure1, T_cellSelectQualityMeasure1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_hcs_not_used_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectQualityMeasure1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cellSelectQualityMeasure1 },
  { &hf_umts_rrc_ies_interRATMeasurementSysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATMeasurementSysInfo_B },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcs_not_used(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcs_not_used, T_hcs_not_used_sequence);

  return offset;
}


static const per_sequence_t T_cpich_RSCP1_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_RSCP1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_RSCP1, T_cpich_RSCP1_sequence);

  return offset;
}


static const per_sequence_t T_cpich_Ec_N02_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0 },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_Ec_N02(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_Ec_N02, T_cpich_Ec_N02_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cellSelectQualityMeasure2_vals[] = {
  {   0, "cpich-RSCP" },
  {   1, "cpich-Ec-N0" },
  { 0, NULL }
};

static const per_choice_t T_cellSelectQualityMeasure2_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_RSCP3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_RSCP1 },
  {   1, &hf_umts_rrc_ies_cpich_Ec_N03, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_Ec_N02 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cellSelectQualityMeasure2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cellSelectQualityMeasure2, T_cellSelectQualityMeasure2_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_hcs_used_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectQualityMeasure2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cellSelectQualityMeasure2 },
  { &hf_umts_rrc_ies_interRATMeasurementSysInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterRATMeasurementSysInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcs_used(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcs_used, T_hcs_used_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_use_of_HCS_vals[] = {
  {   0, "hcs-not-used" },
  {   1, "hcs-used" },
  { 0, NULL }
};

static const per_choice_t T_use_of_HCS_choice[] = {
  {   0, &hf_umts_rrc_ies_hcs_not_used, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_hcs_not_used },
  {   1, &hf_umts_rrc_ies_hcs_used, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_hcs_used },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_use_of_HCS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_use_of_HCS, T_use_of_HCS_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo_vals[] = {
  {   0, "trafficVolumeReportingCriteria" },
  {   1, "periodicalReportingCriteria" },
  { 0, NULL }
};

static const per_choice_t TrafficVolumeReportCriteriaSysInfo_choice[] = {
  {   0, &hf_umts_rrc_ies_trafficVolumeReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_TrafficVolumeReportingCriteria },
  {   1, &hf_umts_rrc_ies_periodicalReportingCriteria, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PeriodicalReportingCriteria },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo, TrafficVolumeReportCriteriaSysInfo_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TrafficVolumeMeasSysInfo_sequence[] = {
  { &hf_umts_rrc_ies_trafficVolumeMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_trafficVolumeMeasurementObjectList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeMeasurementObjectList },
  { &hf_umts_rrc_ies_trafficVolumeMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeMeasQuantity },
  { &hf_umts_rrc_ies_trafficVolumeReportingQuantity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeReportingQuantity },
  { &hf_umts_rrc_ies_dummy_TrafficVolumeReportingCriteria, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeReportingCriteria },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_measurementReportingMode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementReportingMode },
  { &hf_umts_rrc_ies_reportCriteriaSysInf, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TrafficVolumeMeasSysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TrafficVolumeMeasSysInfo, TrafficVolumeMeasSysInfo_sequence);

  return offset;
}


static const per_sequence_t UE_InternalMeasurementSysInfo_sequence[] = {
  { &hf_umts_rrc_ies_ue_InternalMeasurementID, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementIdentity },
  { &hf_umts_rrc_ies_ue_InternalMeasQuantity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_InternalMeasQuantity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_InternalMeasurementSysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_InternalMeasurementSysInfo, UE_InternalMeasurementSysInfo_sequence);

  return offset;
}


static const per_sequence_t MeasurementControlSysInfo_sequence[] = {
  { &hf_umts_rrc_ies_use_of_HCS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_use_of_HCS },
  { &hf_umts_rrc_ies_trafficVolumeMeasSysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TrafficVolumeMeasSysInfo },
  { &hf_umts_rrc_ies_dummy_UE_InternalMeasurementSysInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_InternalMeasurementSysInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementControlSysInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementControlSysInfo, MeasurementControlSysInfo_sequence);

  return offset;
}


static const per_sequence_t T_cpich_RSCP2_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP_LCR_r4 },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_RSCP2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_RSCP2, T_cpich_RSCP2_sequence);

  return offset;
}


static const per_sequence_t T_cpich_Ec_N03_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0_LCR_r4 },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_Ec_N03(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_Ec_N03, T_cpich_Ec_N03_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cellSelectQualityMeasure3_vals[] = {
  {   0, "cpich-RSCP" },
  {   1, "cpich-Ec-N0" },
  { 0, NULL }
};

static const per_choice_t T_cellSelectQualityMeasure3_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_RSCP4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_RSCP2 },
  {   1, &hf_umts_rrc_ies_cpich_Ec_N04, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_Ec_N03 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cellSelectQualityMeasure3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cellSelectQualityMeasure3, T_cellSelectQualityMeasure3_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_hcs_not_used1_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectQualityMeasure3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cellSelectQualityMeasure3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcs_not_used1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcs_not_used1, T_hcs_not_used1_sequence);

  return offset;
}


static const per_sequence_t T_cpich_RSCP3_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4 },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_RSCP3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_RSCP3, T_cpich_RSCP3_sequence);

  return offset;
}


static const per_sequence_t T_cpich_Ec_N04_sequence[] = {
  { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4 },
  { &hf_umts_rrc_ies_interFreqMeasurementSysInfo7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cpich_Ec_N04(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cpich_Ec_N04, T_cpich_Ec_N04_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_cellSelectQualityMeasure4_vals[] = {
  {   0, "cpich-RSCP" },
  {   1, "cpich-Ec-N0" },
  { 0, NULL }
};

static const per_choice_t T_cellSelectQualityMeasure4_choice[] = {
  {   0, &hf_umts_rrc_ies_cpich_RSCP5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_RSCP3 },
  {   1, &hf_umts_rrc_ies_cpich_Ec_N05, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cpich_Ec_N04 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cellSelectQualityMeasure4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_cellSelectQualityMeasure4, T_cellSelectQualityMeasure4_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_hcs_used1_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectQualityMeasure4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_cellSelectQualityMeasure4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcs_used1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcs_used1, T_hcs_used1_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_use_of_HCS1_vals[] = {
  {   0, "hcs-not-used" },
  {   1, "hcs-used" },
  { 0, NULL }
};

static const per_choice_t T_use_of_HCS1_choice[] = {
  {   0, &hf_umts_rrc_ies_hcs_not_used1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_hcs_not_used1 },
  {   1, &hf_umts_rrc_ies_hcs_used1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_hcs_used1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_use_of_HCS1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_use_of_HCS1, T_use_of_HCS1_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MeasurementControlSysInfo_LCR_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_use_of_HCS1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_use_of_HCS1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MeasurementControlSysInfo_LCR_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MeasurementControlSysInfo_LCR_r4_ext, MeasurementControlSysInfo_LCR_r4_ext_sequence);

  return offset;
}


static const per_sequence_t PLMNsOfIntraFreqCellsList_item_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item, PLMNsOfIntraFreqCellsList_item_sequence);

  return offset;
}


static const per_sequence_t PLMNsOfIntraFreqCellsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item },
};

static int
dissect_umts_rrc_ies_PLMNsOfIntraFreqCellsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PLMNsOfIntraFreqCellsList, PLMNsOfIntraFreqCellsList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t PLMNsOfInterFreqCellsList_item_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PLMNsOfInterFreqCellsList_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PLMNsOfInterFreqCellsList_item, PLMNsOfInterFreqCellsList_item_sequence);

  return offset;
}


static const per_sequence_t PLMNsOfInterFreqCellsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PLMNsOfInterFreqCellsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMNsOfInterFreqCellsList_item },
};

static int
dissect_umts_rrc_ies_PLMNsOfInterFreqCellsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PLMNsOfInterFreqCellsList, PLMNsOfInterFreqCellsList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t PLMNsOfInterRATCellsList_item_sequence[] = {
  { &hf_umts_rrc_ies_plmn_Identity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMN_Identity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PLMNsOfInterRATCellsList_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PLMNsOfInterRATCellsList_item, PLMNsOfInterRATCellsList_item_sequence);

  return offset;
}


static const per_sequence_t PLMNsOfInterRATCellsList_sequence_of[1] = {
  { &hf_umts_rrc_ies_PLMNsOfInterRATCellsList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMNsOfInterRATCellsList_item },
};

static int
dissect_umts_rrc_ies_PLMNsOfInterRATCellsList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_PLMNsOfInterRATCellsList, PLMNsOfInterRATCellsList_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t PLMNIdentitiesOfNeighbourCells_sequence[] = {
  { &hf_umts_rrc_ies_plmnsOfIntraFreqCellsList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMNsOfIntraFreqCellsList },
  { &hf_umts_rrc_ies_plmnsOfInterFreqCellsList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMNsOfInterFreqCellsList },
  { &hf_umts_rrc_ies_plmnsOfInterRATCellsList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMNsOfInterRATCellsList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_PLMNIdentitiesOfNeighbourCells(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_PLMNIdentitiesOfNeighbourCells, PLMNIdentitiesOfNeighbourCells_sequence);

  return offset;
}


static const per_sequence_t TimeslotWithISCP_sequence[] = {
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_timeslotISCP1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotISCP },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_TimeslotWithISCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_TimeslotWithISCP, TimeslotWithISCP_sequence);

  return offset;
}


static const per_sequence_t TimeslotListWithISCP_sequence_of[1] = {
  { &hf_umts_rrc_ies_TimeslotListWithISCP_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotWithISCP },
};

int
dissect_umts_rrc_ies_TimeslotListWithISCP(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TimeslotListWithISCP, TimeslotListWithISCP_sequence_of,
                                                  1, maxTS);

  return offset;
}


static const per_sequence_t UE_Positioning_CipherParameters_sequence[] = {
  { &hf_umts_rrc_ies_cipheringKeyFlag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_1 },
  { &hf_umts_rrc_ies_cipheringSerialNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_CipherParameters(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_CipherParameters, UE_Positioning_CipherParameters_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_IPDL_Parameters_TDD_r4_ext_sequence[] = {
  { &hf_umts_rrc_ies_ip_Spacing1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IP_Spacing_TDD },
  { &hf_umts_rrc_ies_ip_slot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_14 },
  { &hf_umts_rrc_ies_ip_Start, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_ip_PCCPCG, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IP_PCCPCH_r4 },
  { &hf_umts_rrc_ies_burstModeParameters, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BurstModeParameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext, UE_Positioning_IPDL_Parameters_TDD_r4_ext_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_ReportingQuantity_v390ext_sequence[] = {
  { &hf_umts_rrc_ies_vertical_Accuracy, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_Accuracy },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_ReportingQuantity_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_ReportingQuantity_v390ext, UE_Positioning_ReportingQuantity_v390ext_sequence);

  return offset;
}


static const per_sequence_t T_fdd83_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd83(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd83, T_fdd83_sequence);

  return offset;
}


static const per_sequence_t T_tdd76_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd76(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd76, T_tdd76_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo76_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo76_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd88  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd83 },
  {   1, &hf_umts_rrc_ies_tdd83  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd76 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo76(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo76, T_modeSpecificInfo76_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_ReferenceCellInfo_UEB_sequence[] = {
  { &hf_umts_rrc_ies_sfn    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_4095 },
  { &hf_umts_rrc_ies_modeSpecificInfo76, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo76 },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_cellPosition, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ReferenceCellPosition },
  { &hf_umts_rrc_ies_roundTripTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_32766 },
  { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_UEB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_UEB, UE_Positioning_OTDOA_ReferenceCellInfo_UEB_sequence);

  return offset;
}


static const per_sequence_t T_fdd80_sequence[] = {
  { &hf_umts_rrc_ies_primaryCPICH_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PrimaryCPICH_Info },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd80(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd80, T_fdd80_sequence);

  return offset;
}


static const per_sequence_t T_tdd73_sequence[] = {
  { &hf_umts_rrc_ies_cellAndChannelIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAndChannelIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd73(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd73, T_tdd73_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo73_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo73_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd85  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd80 },
  {   1, &hf_umts_rrc_ies_tdd80  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd73 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo73(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo73, T_modeSpecificInfo73_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_NeighbourCellInfo_UEB_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo73, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo73 },
  { &hf_umts_rrc_ies_frequencyInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FrequencyInfo },
  { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters },
  { &hf_umts_rrc_ies_sfn_SFN_RelTimeDifference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SFN_SFN_RelTimeDifference1 },
  { &hf_umts_rrc_ies_sfn_SFN_Drift, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_SFN_Drift },
  { &hf_umts_rrc_ies_searchWindowSize, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OTDOA_SearchWindowSize },
  { &hf_umts_rrc_ies_relativeNorth, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_M20000_20000 },
  { &hf_umts_rrc_ies_relativeEast, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_M20000_20000 },
  { &hf_umts_rrc_ies_relativeAltitude, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_M4000_4000 },
  { &hf_umts_rrc_ies_fineSFN_SFN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FineSFN_SFN },
  { &hf_umts_rrc_ies_roundTripTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_32766 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_UEB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_UEB, UE_Positioning_OTDOA_NeighbourCellInfo_UEB_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_NeighbourCellList_UEB_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_UEB },
};

static int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB, UE_Positioning_OTDOA_NeighbourCellList_UEB_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_AssistanceData_UEB_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo_UEB, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_UEB },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList_UEB, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_UEB(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_UEB, UE_Positioning_OTDOA_AssistanceData_UEB_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_Measurement_v390ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_ReportingQuantity_v390ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_ReportingQuantity_v390ext },
  { &hf_umts_rrc_ies_measurementValidity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MeasurementValidity },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData_UEB, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_UEB },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_Positioning_Measurement_v390ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_Measurement_v390ext, UE_Positioning_Measurement_v390ext_sequence);

  return offset;
}


static const per_sequence_t UE_Positioning_IPDL_Parameters_TDDList_r4_ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext },
};

static int
dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext, UE_Positioning_IPDL_Parameters_TDDList_r4_ext_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t UE_Positioning_OTDOA_AssistanceData_r4ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_Positioning_IPDL_Parameters_TDD_r4_ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext },
  { &hf_umts_rrc_ies_ue_Positioning_IPDL_Parameters_TDDList_r4_ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4ext, UE_Positioning_OTDOA_AssistanceData_r4ext_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MIB_ValueTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_BCCH_ModificationTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 511U, NULL, FALSE);

  return offset;
}


static const per_sequence_t BCCH_ModificationInfo_sequence[] = {
  { &hf_umts_rrc_ies_mib_ValueTag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MIB_ValueTag },
  { &hf_umts_rrc_ies_bcch_ModificationTime, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BCCH_ModificationTime },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_BCCH_ModificationInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_BCCH_ModificationInfo, BCCH_ModificationInfo_sequence);

  return offset;
}


static const per_sequence_t CBS_DRX_Level1Information_sequence[] = {
  { &hf_umts_rrc_ies_ctch_AllocationPeriod, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_256 },
  { &hf_umts_rrc_ies_cbs_FrameOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CBS_DRX_Level1Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CBS_DRX_Level1Information, CBS_DRX_Level1Information_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_1_512(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 512, FALSE, NULL);

  return offset;
}


static const per_sequence_t CDMA2000_Message_sequence[] = {
  { &hf_umts_rrc_ies_msg_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_payload, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_1_512 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_CDMA2000_Message(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_CDMA2000_Message, CDMA2000_Message_sequence);

  return offset;
}


static const per_sequence_t CDMA2000_MessageList_sequence_of[1] = {
  { &hf_umts_rrc_ies_CDMA2000_MessageList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CDMA2000_Message },
};

int
dissect_umts_rrc_ies_CDMA2000_MessageList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CDMA2000_MessageList, CDMA2000_MessageList_sequence_of,
                                                  1, maxInterSysMessages);

  return offset;
}


static const per_sequence_t FrequencyInfoCDMA2000_sequence[] = {
  { &hf_umts_rrc_ies_band_Class, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_5 },
  { &hf_umts_rrc_ies_cdma_Freq, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_11 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_FrequencyInfoCDMA2000(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_FrequencyInfoCDMA2000, FrequencyInfoCDMA2000_sequence);

  return offset;
}


static const per_sequence_t CDMA2000_UMTS_Frequency_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_CDMA2000_UMTS_Frequency_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfoCDMA2000 },
};

static int
dissect_umts_rrc_ies_CDMA2000_UMTS_Frequency_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_CDMA2000_UMTS_Frequency_List, CDMA2000_UMTS_Frequency_List_sequence_of,
                                                  1, maxNumCDMA2000Freqs);

  return offset;
}



static int
dissect_umts_rrc_ies_ExpirationTimeFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 8U, NULL, FALSE);

  return offset;
}


static const per_sequence_t FDD_UMTS_Frequency_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_FDD_UMTS_Frequency_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfoFDD },
};

static int
dissect_umts_rrc_ies_FDD_UMTS_Frequency_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_FDD_UMTS_Frequency_List, FDD_UMTS_Frequency_List_sequence_of,
                                                  1, maxNumFDDFreqs);

  return offset;
}



static int
dissect_umts_rrc_ies_GERAN_SystemInfoBlock(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       1, 23, NULL);

  return offset;
}


static const per_sequence_t GERAN_SystemInformation_sequence_of[1] = {
  { &hf_umts_rrc_ies_GERAN_SystemInformation_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GERAN_SystemInfoBlock },
};

int
dissect_umts_rrc_ies_GERAN_SystemInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GERAN_SystemInformation, GERAN_SystemInformation_sequence_of,
                                                  1, maxGERANSI);

  return offset;
}


static const per_sequence_t GSM_BA_Range_sequence[] = {
  { &hf_umts_rrc_ies_gsmLowRangeUARFCN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UARFCN },
  { &hf_umts_rrc_ies_gsmUpRangeUARFCN, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UARFCN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_GSM_BA_Range(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_GSM_BA_Range, GSM_BA_Range_sequence);

  return offset;
}


static const per_sequence_t GSM_BA_Range_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_GSM_BA_Range_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GSM_BA_Range },
};

static int
dissect_umts_rrc_ies_GSM_BA_Range_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GSM_BA_Range_List, GSM_BA_Range_List_sequence_of,
                                                  1, maxNumGSMFreqRanges);

  return offset;
}



static int
dissect_umts_rrc_ies_GSM_Classmark2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       5, 5, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_GSM_Classmark3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       1, 32, NULL);

  return offset;
}


static const per_sequence_t GSM_MessageList_sequence_of[1] = {
  { &hf_umts_rrc_ies_GSM_MessageList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_1_512 },
};

int
dissect_umts_rrc_ies_GSM_MessageList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GSM_MessageList, GSM_MessageList_sequence_of,
                                                  1, maxInterSysMessages);

  return offset;
}


static const asn_namedbit GsmSecurityCapability_bits[] = {
  {  0, &hf_umts_rrc_ies_GsmSecurityCapability_a5_7, -1, -1, "a5-7", NULL },
  {  1, &hf_umts_rrc_ies_GsmSecurityCapability_a5_6, -1, -1, "a5-6", NULL },
  {  2, &hf_umts_rrc_ies_GsmSecurityCapability_a5_5, -1, -1, "a5-5", NULL },
  {  3, &hf_umts_rrc_ies_GsmSecurityCapability_a5_4, -1, -1, "a5-4", NULL },
  {  4, &hf_umts_rrc_ies_GsmSecurityCapability_a5_3, -1, -1, "a5-3", NULL },
  {  5, &hf_umts_rrc_ies_GsmSecurityCapability_a5_2, -1, -1, "a5-2", NULL },
  {  6, &hf_umts_rrc_ies_GsmSecurityCapability_a5_1, -1, -1, "a5-1", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

static int
dissect_umts_rrc_ies_GsmSecurityCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     7, 7, FALSE, NULL);

  return offset;
}


static const asn_namedbit GSMSecurityCapability_v6xyext_bits[] = {
  {  0, &hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea0, -1, -1, "gea0", NULL },
  {  1, &hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea1, -1, -1, "gea1", NULL },
  {  2, &hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea2, -1, -1, "gea2", NULL },
  { 0, NULL, 0, 0, NULL, NULL }
};

int
dissect_umts_rrc_ies_GSMSecurityCapability_v6xyext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     3, 3, FALSE, NULL);

  return offset;
}


const value_string umts_rrc_ies_InterRAT_ChangeFailureCause_vals[] = {
  {   0, "configurationUnacceptable" },
  {   1, "physicalChannelFailure" },
  {   2, "protocolError" },
  {   3, "unspecified" },
  {   4, "spare4" },
  {   5, "spare3" },
  {   6, "spare2" },
  {   7, "spare1" },
  { 0, NULL }
};

static const per_choice_t InterRAT_ChangeFailureCause_choice[] = {
  {   0, &hf_umts_rrc_ies_configurationUnacceptable, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_physicalChannelFailure, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_protocolError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ProtocolErrorInformation },
  {   3, &hf_umts_rrc_ies_unspecified, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_spare4 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   5, &hf_umts_rrc_ies_spare3 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   6, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_InterRAT_ChangeFailureCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRAT_ChangeFailureCause, InterRAT_ChangeFailureCause_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_1_32768(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 32768, FALSE, NULL);

  return offset;
}


static const per_sequence_t GERANIu_MessageList_sequence_of[1] = {
  { &hf_umts_rrc_ies_GERANIu_MessageList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BIT_STRING_SIZE_1_32768 },
};

int
dissect_umts_rrc_ies_GERANIu_MessageList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_GERANIu_MessageList, GERANIu_MessageList_sequence_of,
                                                  1, maxInterSysMessages);

  return offset;
}



static int
dissect_umts_rrc_ies_GERANIu_RadioAccessCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 170, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_gsm10_sequence[] = {
  { &hf_umts_rrc_ies_gsm_Classmark2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GSM_Classmark2 },
  { &hf_umts_rrc_ies_gsm_Classmark3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GSM_Classmark3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm10, T_gsm10_sequence);

  return offset;
}


static const per_sequence_t T_cdma2000_sequence[] = {
  { &hf_umts_rrc_ies_cdma2000_MessageList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CDMA2000_MessageList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_cdma2000(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_cdma2000, T_cdma2000_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterRAT_UE_RadioAccessCapability_vals[] = {
  {   0, "gsm" },
  {   1, "cdma2000" },
  { 0, NULL }
};

static const per_choice_t InterRAT_UE_RadioAccessCapability_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm11  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm10 },
  {   1, &hf_umts_rrc_ies_cdma2000, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_cdma2000 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRAT_UE_RadioAccessCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability, InterRAT_UE_RadioAccessCapability_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRAT_UE_RadioAccessCapabilityList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRAT_UE_RadioAccessCapability },
};

int
dissect_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList, InterRAT_UE_RadioAccessCapabilityList_sequence_of,
                                                  1, maxInterSysMessages);

  return offset;
}


static const per_sequence_t InterRAT_UE_RadioAccessCapability_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_geranIu_RadioAccessCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GERANIu_RadioAccessCapability },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v590ext, InterRAT_UE_RadioAccessCapability_v590ext_sequence);

  return offset;
}


static const per_sequence_t T_gsm11_sequence[] = {
  { &hf_umts_rrc_ies_gsmSecurityCapability, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_GsmSecurityCapability },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_gsm11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_gsm11, T_gsm11_sequence);

  return offset;
}


static const value_string umts_rrc_ies_InterRAT_UE_SecurityCapability_vals[] = {
  {   0, "gsm" },
  { 0, NULL }
};

static const per_choice_t InterRAT_UE_SecurityCapability_choice[] = {
  {   0, &hf_umts_rrc_ies_gsm12  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_gsm11 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_InterRAT_UE_SecurityCapability(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRAT_UE_SecurityCapability, InterRAT_UE_SecurityCapability_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InterRAT_UE_SecurityCapList_sequence_of[1] = {
  { &hf_umts_rrc_ies_InterRAT_UE_SecurityCapList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_InterRAT_UE_SecurityCapability },
};

int
dissect_umts_rrc_ies_InterRAT_UE_SecurityCapList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_InterRAT_UE_SecurityCapList, InterRAT_UE_SecurityCapList_sequence_of,
                                                  1, maxInterSysMessages);

  return offset;
}


const value_string umts_rrc_ies_InterRAT_HO_FailureCause_vals[] = {
  {   0, "configurationUnacceptable" },
  {   1, "physicalChannelFailure" },
  {   2, "protocolError" },
  {   3, "interRAT-ProtocolError" },
  {   4, "unspecified" },
  {   5, "spare11" },
  {   6, "spare10" },
  {   7, "spare9" },
  {   8, "spare8" },
  {   9, "spare7" },
  {  10, "spare6" },
  {  11, "spare5" },
  {  12, "spare4" },
  {  13, "spare3" },
  {  14, "spare2" },
  {  15, "spare1" },
  { 0, NULL }
};

static const per_choice_t InterRAT_HO_FailureCause_choice[] = {
  {   0, &hf_umts_rrc_ies_configurationUnacceptable, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_physicalChannelFailure, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   2, &hf_umts_rrc_ies_protocolError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_ProtocolErrorInformation },
  {   3, &hf_umts_rrc_ies_interRAT_ProtocolError, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   4, &hf_umts_rrc_ies_unspecified, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   5, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   6, &hf_umts_rrc_ies_spare10, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_spare9 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   8, &hf_umts_rrc_ies_spare8 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   9, &hf_umts_rrc_ies_spare7 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  10, &hf_umts_rrc_ies_spare6 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  11, &hf_umts_rrc_ies_spare5 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  12, &hf_umts_rrc_ies_spare4 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  13, &hf_umts_rrc_ies_spare3 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  14, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  15, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

int
dissect_umts_rrc_ies_InterRAT_HO_FailureCause(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_InterRAT_HO_FailureCause, InterRAT_HO_FailureCause_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_SIBSb_TypeAndTag_vals[] = {
  {   0, "sysInfoType1" },
  {   1, "sysInfoType2" },
  {   2, "sysInfoType3" },
  {   3, "sysInfoType4" },
  {   4, "sysInfoType5" },
  {   5, "sysInfoType6" },
  {   6, "sysInfoType7" },
  {   7, "dummy-CellValueTag" },
  {   8, "dummy2-NULL" },
  {   9, "dummy3-NULL" },
  {  10, "sysInfoType11" },
  {  11, "sysInfoType12" },
  {  12, "sysInfoType13" },
  {  13, "sysInfoType13-1" },
  {  14, "sysInfoType13-2" },
  {  15, "sysInfoType13-3" },
  {  16, "sysInfoType13-4" },
  {  17, "sysInfoType14" },
  {  18, "sysInfoType15" },
  {  19, "sysInfoType16" },
  {  20, "sysInfoType17" },
  {  21, "sysInfoTypeSB1" },
  {  22, "sysInfoTypeSB2" },
  {  23, "sysInfoType15-1" },
  {  24, "sysInfoType15-2" },
  {  25, "sysInfoType15-3" },
  {  26, "sysInfoType15-4" },
  {  27, "sysInfoType18" },
  {  28, "sysInfoType15-5" },
  {  29, "sysInfoType5bis" },
  {  30, "spare2" },
  {  31, "spare1" },
  { 0, NULL }
};

static const per_choice_t SIBSb_TypeAndTag_choice[] = {
  {   0, &hf_umts_rrc_ies_sysInfoType1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PLMN_ValueTag },
  {   1, &hf_umts_rrc_ies_sysInfoType2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   2, &hf_umts_rrc_ies_sysInfoType3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   3, &hf_umts_rrc_ies_sysInfoType4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   4, &hf_umts_rrc_ies_sysInfoType5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   5, &hf_umts_rrc_ies_sysInfoType6, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   6, &hf_umts_rrc_ies_sysInfoType7, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   7, &hf_umts_rrc_ies_dummy_CellValueTag, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {   8, &hf_umts_rrc_ies_dummy2_NULL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   9, &hf_umts_rrc_ies_dummy3_NULL, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  10, &hf_umts_rrc_ies_sysInfoType11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  11, &hf_umts_rrc_ies_sysInfoType12, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  12, &hf_umts_rrc_ies_sysInfoType13, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  13, &hf_umts_rrc_ies_sysInfoType13_1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  14, &hf_umts_rrc_ies_sysInfoType13_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  15, &hf_umts_rrc_ies_sysInfoType13_3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  16, &hf_umts_rrc_ies_sysInfoType13_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  17, &hf_umts_rrc_ies_sysInfoType14, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  18, &hf_umts_rrc_ies_sysInfoType15, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  19, &hf_umts_rrc_ies_sysInfoType16, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PredefinedConfigIdentityAndValueTag },
  {  20, &hf_umts_rrc_ies_sysInfoType17, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  21, &hf_umts_rrc_ies_sysInfoTypeSB1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  22, &hf_umts_rrc_ies_sysInfoTypeSB2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  23, &hf_umts_rrc_ies_sysInfoType15_1, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  24, &hf_umts_rrc_ies_sysInfoType15_2, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag },
  {  25, &hf_umts_rrc_ies_sysInfoType15_3, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag },
  {  26, &hf_umts_rrc_ies_sysInfoType15_4, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  27, &hf_umts_rrc_ies_sysInfoType18, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  28, &hf_umts_rrc_ies_sysInfoType15_5, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  29, &hf_umts_rrc_ies_sysInfoType5bis, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_CellValueTag },
  {  30, &hf_umts_rrc_ies_spare21, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {  31, &hf_umts_rrc_ies_spare11, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_SIBSb_TypeAndTag(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_SIBSb_TypeAndTag, SIBSb_TypeAndTag_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SchedulingInformationSIBSb_sequence[] = {
  { &hf_umts_rrc_ies_sibSb_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIBSb_TypeAndTag },
  { &hf_umts_rrc_ies_scheduling1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SchedulingInformation },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SchedulingInformationSIBSb(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SchedulingInformationSIBSb, SchedulingInformationSIBSb_sequence);

  return offset;
}


static const per_sequence_t SIBSb_ReferenceList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SIBSb_ReferenceList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SchedulingInformationSIBSb },
};

static int
dissect_umts_rrc_ies_SIBSb_ReferenceList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SIBSb_ReferenceList, SIBSb_ReferenceList_sequence_of,
                                                  1, maxSIB);

  return offset;
}


static const per_sequence_t MasterInformationBlock_v6xyext_sequence[] = {
  { &hf_umts_rrc_ies_multiplePLMN_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MultiplePLMN_List_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MasterInformationBlock_v6xyext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MasterInformationBlock_v6xyext, MasterInformationBlock_v6xyext_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions1_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions1, T_nonCriticalExtensions1_sequence);

  return offset;
}


static const per_sequence_t T_v6xyNonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_masterInformationBlock_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MasterInformationBlock_v6xyext },
  { &hf_umts_rrc_ies_nonCriticalExtensions1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v6xyNonCriticalExtensions, T_v6xyNonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t MasterInformationBlock_sequence[] = {
  { &hf_umts_rrc_ies_mib_ValueTag, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MIB_ValueTag },
  { &hf_umts_rrc_ies_plmn_Type, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PLMN_Type },
  { &hf_umts_rrc_ies_sibSb_ReferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIBSb_ReferenceList },
  { &hf_umts_rrc_ies_v6xyNonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MasterInformationBlock(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MasterInformationBlock, MasterInformationBlock_sequence);

  return offset;
}


static const per_sequence_t TDD_UMTS_Frequency_List_sequence_of[1] = {
  { &hf_umts_rrc_ies_TDD_UMTS_Frequency_List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfoTDD },
};

static int
dissect_umts_rrc_ies_TDD_UMTS_Frequency_List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_TDD_UMTS_Frequency_List, TDD_UMTS_Frequency_List_sequence_of,
                                                  1, maxNumTDDFreqs);

  return offset;
}


static const per_sequence_t Rplmn_Information_sequence[] = {
  { &hf_umts_rrc_ies_gsm_BA_Range_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_GSM_BA_Range_List },
  { &hf_umts_rrc_ies_fdd_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FDD_UMTS_Frequency_List },
  { &hf_umts_rrc_ies_tdd_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TDD_UMTS_Frequency_List },
  { &hf_umts_rrc_ies_cdma2000_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CDMA2000_UMTS_Frequency_List },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_Rplmn_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Rplmn_Information, Rplmn_Information_sequence);

  return offset;
}


static const per_sequence_t Rplmn_Information_r4_sequence[] = {
  { &hf_umts_rrc_ies_gsm_BA_Range_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_GSM_BA_Range_List },
  { &hf_umts_rrc_ies_fdd_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FDD_UMTS_Frequency_List },
  { &hf_umts_rrc_ies_tdd384_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TDD_UMTS_Frequency_List },
  { &hf_umts_rrc_ies_tdd128_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TDD_UMTS_Frequency_List },
  { &hf_umts_rrc_ies_cdma2000_UMTS_Frequency_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CDMA2000_UMTS_Frequency_List },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_Rplmn_Information_r4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_Rplmn_Information_r4, Rplmn_Information_r4_sequence);

  return offset;
}



int
dissect_umts_rrc_ies_SegmentIndex(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 15U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_SFN_Prime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 2047U, NULL, FALSE);

  return offset;
}



int
dissect_umts_rrc_ies_SIB_Data_fixed(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     222, 222, FALSE, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_SIB_Data_variable(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 214, FALSE, NULL);

  return offset;
}


static const per_sequence_t SIB_ReferenceList_sequence_of[1] = {
  { &hf_umts_rrc_ies_SIB_ReferenceList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SchedulingInformationSIB },
};

static int
dissect_umts_rrc_ies_SIB_ReferenceList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SIB_ReferenceList, SIB_ReferenceList_sequence_of,
                                                  1, maxSIB);

  return offset;
}


const value_string umts_rrc_ies_SIB_Type_vals[] = {
  {   0, "masterInformationBlock" },
  {   1, "systemInformationBlockType1" },
  {   2, "systemInformationBlockType2" },
  {   3, "systemInformationBlockType3" },
  {   4, "systemInformationBlockType4" },
  {   5, "systemInformationBlockType5" },
  {   6, "systemInformationBlockType6" },
  {   7, "systemInformationBlockType7" },
  {   8, "dummy" },
  {   9, "dummy2" },
  {  10, "dummy3" },
  {  11, "systemInformationBlockType11" },
  {  12, "systemInformationBlockType12" },
  {  13, "systemInformationBlockType13" },
  {  14, "systemInformationBlockType13-1" },
  {  15, "systemInformationBlockType13-2" },
  {  16, "systemInformationBlockType13-3" },
  {  17, "systemInformationBlockType13-4" },
  {  18, "systemInformationBlockType14" },
  {  19, "systemInformationBlockType15" },
  {  20, "systemInformationBlockType15-1" },
  {  21, "systemInformationBlockType15-2" },
  {  22, "systemInformationBlockType15-3" },
  {  23, "systemInformationBlockType16" },
  {  24, "systemInformationBlockType17" },
  {  25, "systemInformationBlockType15-4" },
  {  26, "systemInformationBlockType18" },
  {  27, "schedulingBlock1" },
  {  28, "schedulingBlock2" },
  {  29, "systemInformationBlockType15-5" },
  {  30, "systemInformationBlockType5bis" },
  {  31, "spare1" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_SIB_Type(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     32, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t SysInfoType1_v3a0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_ue_ConnTimersAndConstants_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_ConnTimersAndConstants_v3a0ext },
  { &hf_umts_rrc_ies_ue_IdleTimersAndConstants_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_IdleTimersAndConstants_v3a0ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType1_v3a0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType1_v3a0ext_IEs, SysInfoType1_v3a0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions2_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions2, T_nonCriticalExtensions2_sequence);

  return offset;
}


static const per_sequence_t T_v3a0NonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType1_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType1_v3a0ext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v3a0NonCriticalExtensions, T_v3a0NonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t SysInfoType1_sequence[] = {
  { &hf_umts_rrc_ies_cn_CommonGSM_MAP_NAS_SysInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_NAS_SystemInformationGSM_MAP },
  { &hf_umts_rrc_ies_cn_DomainSysInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainSysInfoList },
  { &hf_umts_rrc_ies_ue_ConnTimersAndConstants, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_ConnTimersAndConstants },
  { &hf_umts_rrc_ies_ue_IdleTimersAndConstants, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_IdleTimersAndConstants },
  { &hf_umts_rrc_ies_v3a0NonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType1, SysInfoType1_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions3_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions3, T_nonCriticalExtensions3_sequence);

  return offset;
}


static const per_sequence_t SysInfoType2_sequence[] = {
  { &hf_umts_rrc_ies_ura_IdentityList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_URA_IdentityList },
  { &hf_umts_rrc_ies_nonCriticalExtensions3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType2, SysInfoType2_sequence);

  return offset;
}


static const per_sequence_t SysInfoType3_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_mapping_LCR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Mapping_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType3_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType3_v4b0ext_IEs, SysInfoType3_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType3_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectReselectInfo_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfo_v590ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType3_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType3_v590ext, SysInfoType3_v590ext_sequence);

  return offset;
}


static const per_sequence_t SysInfoType3_v5c0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectReselectInfoTreselectionScaling_v5c0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoTreselectionScaling_v5c0ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType3_v5c0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType3_v5c0ext_IEs, SysInfoType3_v5c0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType3_v670ext_sequence[] = {
  { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForPLMNOfMIB, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext },
  { &hf_umts_rrc_ies_domainSpecificAccessRestictionForSharedNetwork, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType3_v670ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType3_v670ext, SysInfoType3_v670ext_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions4_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions4, T_nonCriticalExtensions4_sequence);

  return offset;
}


static const per_sequence_t T_v670NonCriticalExtension_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType3_v670ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType3_v670ext },
  { &hf_umts_rrc_ies_nonCriticalExtensions4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v670NonCriticalExtension(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v670NonCriticalExtension, T_v670NonCriticalExtension_sequence);

  return offset;
}


static const per_sequence_t T_v5c0NoncriticalExtension_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType3_v5c0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType3_v5c0ext_IEs },
  { &hf_umts_rrc_ies_v670NonCriticalExtension, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v670NonCriticalExtension },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v5c0NoncriticalExtension(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v5c0NoncriticalExtension, T_v5c0NoncriticalExtension_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtension_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType3_v590ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType3_v590ext },
  { &hf_umts_rrc_ies_v5c0NoncriticalExtension, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v5c0NoncriticalExtension },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtension(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtension, T_v590NonCriticalExtension_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType3_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType3_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtension, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtension },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions, T_v4b0NonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t SysInfoType3_sequence[] = {
  { &hf_umts_rrc_ies_sib4indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_cellIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellIdentity },
  { &hf_umts_rrc_ies_cellSelectReselectInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellSelectReselectInfoSIB_3_4 },
  { &hf_umts_rrc_ies_cellAccessRestriction, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAccessRestriction },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType3, SysInfoType3_sequence);

  return offset;
}


static const per_sequence_t SysInfoType4_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_mapping_LCR, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Mapping_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType4_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType4_v4b0ext_IEs, SysInfoType4_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType4_v590ext_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectReselectInfo_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfo_v590ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType4_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType4_v590ext, SysInfoType4_v590ext_sequence);

  return offset;
}


static const per_sequence_t SysInfoType4_v5b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectReselectInfoPCHFACH_v5b0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoPCHFACH_v5b0ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType4_v5b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType4_v5b0ext_IEs, SysInfoType4_v5b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType4_v5c0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_cellSelectReselectInfoTreselectionScaling_v5c0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CellSelectReselectInfoTreselectionScaling_v5c0ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType4_v5c0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType4_v5c0ext_IEs, SysInfoType4_v5c0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions5_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions5, T_nonCriticalExtensions5_sequence);

  return offset;
}


static const per_sequence_t T_v5c0NonCriticalExtension_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType4_v5c0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType4_v5c0ext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v5c0NonCriticalExtension(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v5c0NonCriticalExtension, T_v5c0NonCriticalExtension_sequence);

  return offset;
}


static const per_sequence_t T_v5b0NonCriticalExtension_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType4_v5b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType4_v5b0ext_IEs },
  { &hf_umts_rrc_ies_v5c0NonCriticalExtension, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v5c0NonCriticalExtension },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v5b0NonCriticalExtension(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v5b0NonCriticalExtension, T_v5b0NonCriticalExtension_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtension1_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType4_v590ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType4_v590ext },
  { &hf_umts_rrc_ies_v5b0NonCriticalExtension, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v5b0NonCriticalExtension },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtension1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtension1, T_v590NonCriticalExtension1_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions1_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType4_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType4_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtension1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtension1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions1, T_v4b0NonCriticalExtensions1_sequence);

  return offset;
}


static const per_sequence_t SysInfoType4_sequence[] = {
  { &hf_umts_rrc_ies_cellIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellIdentity },
  { &hf_umts_rrc_ies_cellSelectReselectInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellSelectReselectInfoSIB_3_4 },
  { &hf_umts_rrc_ies_cellAccessRestriction, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellAccessRestriction },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType4, SysInfoType4_sequence);

  return offset;
}


static const per_sequence_t T_fdd87_sequence[] = {
  { &hf_umts_rrc_ies_aich_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AICH_PowerOffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd87(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd87, T_fdd87_sequence);

  return offset;
}


static const per_sequence_t T_tdd80_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList_SFN, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN },
  { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN },
  { &hf_umts_rrc_ies_openLoopPowerControl_TDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OpenLoopPowerControl_TDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd80(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd80, T_tdd80_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo80_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo80_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd92  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd87 },
  {   1, &hf_umts_rrc_ies_tdd87  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd80 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo80(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo80, T_modeSpecificInfo80_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd128SpecificInfo_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList_SFN1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4 },
  { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4 },
  { &hf_umts_rrc_ies_pCCPCH_LCR_Extensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4_ext },
  { &hf_umts_rrc_ies_sCCPCH_LCR_ExtensionsList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128SpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd128SpecificInfo, T_tdd128SpecificInfo_sequence);

  return offset;
}


static const per_sequence_t SysInfoType5_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_pNBSCH_Allocation_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PNBSCH_Allocation_r4 },
  { &hf_umts_rrc_ies_openLoopPowerControl_IPDL_TDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_OpenLoopPowerControl_IPDL_TDD_r4 },
  { &hf_umts_rrc_ies_prach_SystemInformationList_LCR_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4 },
  { &hf_umts_rrc_ies_tdd128SpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tdd128SpecificInfo },
  { &hf_umts_rrc_ies_frequencyBandIndicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RadioFrequencyBandFDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType5_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType5_v4b0ext_IEs, SysInfoType5_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_hcr_r5_SpecificInfo_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList_SFN2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5 },
  { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcr_r5_SpecificInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcr_r5_SpecificInfo, T_hcr_r5_SpecificInfo_sequence);

  return offset;
}


static const per_sequence_t SysInfoType5_v590ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_hcr_r5_SpecificInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_hcr_r5_SpecificInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType5_v590ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType5_v590ext_IEs, SysInfoType5_v590ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType5_v650ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_frequencyBandIndicator2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandFDD2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType5_v650ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType5_v650ext_IEs, SysInfoType5_v650ext_IEs_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_sccpch_SystemInformation_MBMS_vals[] = {
  {   0, "sccpch-CommonForMBMSAndNonMBMS" },
  {   1, "sccpch-DedicatedForMBMS" },
  { 0, NULL }
};

static const per_choice_t T_sccpch_SystemInformation_MBMS_choice[] = {
  {   0, &hf_umts_rrc_ies_sccpch_CommonForMBMSAndNonMBMS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext },
  {   1, &hf_umts_rrc_ies_sccpch_DedicatedForMBMS, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sccpch_SystemInformation_MBMS(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_sccpch_SystemInformation_MBMS, T_sccpch_SystemInformation_MBMS_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SysInfoType5_v6xyext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_sccpch_SystemInformation_MBMS, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_sccpch_SystemInformation_MBMS },
  { &hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType5_v6xyext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType5_v6xyext_IEs, SysInfoType5_v6xyext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions6_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions6, T_nonCriticalExtensions6_sequence);

  return offset;
}


static const per_sequence_t T_v6xyNonCriticalExtensions1_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType5_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType5_v6xyext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v6xyNonCriticalExtensions1, T_v6xyNonCriticalExtensions1_sequence);

  return offset;
}


static const per_sequence_t T_v650NonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType5_v650ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType5_v650ext_IEs },
  { &hf_umts_rrc_ies_v6xyNonCriticalExtensions1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v650NonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v650NonCriticalExtensions, T_v650NonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType5_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType5_v590ext_IEs },
  { &hf_umts_rrc_ies_v650NonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v650NonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtensions, T_v590NonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions2_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType5_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType5_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions2, T_v4b0NonCriticalExtensions2_sequence);

  return offset;
}


static const per_sequence_t SysInfoType5_sequence[] = {
  { &hf_umts_rrc_ies_sib6indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_pich_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PICH_PowerOffset },
  { &hf_umts_rrc_ies_modeSpecificInfo80, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo80 },
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_prach_SystemInformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PRACH_SystemInformationList },
  { &hf_umts_rrc_ies_sCCPCH_SystemInformationList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SCCPCH_SystemInformationList },
  { &hf_umts_rrc_ies_cbs_DRX_Level1Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CBS_DRX_Level1Information },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType5, SysInfoType5_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_SysInfoType5bis(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_SysInfoType5(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t T_fdd88_sequence[] = {
  { &hf_umts_rrc_ies_aich_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_AICH_PowerOffset },
  { &hf_umts_rrc_ies_dummy_CSICH_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CSICH_PowerOffset },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd88(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd88, T_fdd88_sequence);

  return offset;
}


static const per_sequence_t T_tdd81_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList_SFN, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN },
  { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN },
  { &hf_umts_rrc_ies_openLoopPowerControl_TDD, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OpenLoopPowerControl_TDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd81(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd81, T_tdd81_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo81_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo81_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd93  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd88 },
  {   1, &hf_umts_rrc_ies_tdd88  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd81 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo81(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo81, T_modeSpecificInfo81_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_tdd128SpecificInfo1_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList_SFN1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4 },
  { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4 },
  { &hf_umts_rrc_ies_pCCPCH_LCR_Extensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4_ext },
  { &hf_umts_rrc_ies_sCCPCH_LCR_ExtensionsList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128SpecificInfo1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd128SpecificInfo1, T_tdd128SpecificInfo1_sequence);

  return offset;
}


static const per_sequence_t SysInfoType6_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_openLoopPowerControl_IPDL_TDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_OpenLoopPowerControl_IPDL_TDD_r4 },
  { &hf_umts_rrc_ies_prach_SystemInformationList_LCR_r4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4 },
  { &hf_umts_rrc_ies_tdd128SpecificInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tdd128SpecificInfo1 },
  { &hf_umts_rrc_ies_frequencyBandIndicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RadioFrequencyBandFDD },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType6_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType6_v4b0ext_IEs, SysInfoType6_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_hcr_r5_SpecificInfo1_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList_SFN2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5 },
  { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcr_r5_SpecificInfo1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcr_r5_SpecificInfo1, T_hcr_r5_SpecificInfo1_sequence);

  return offset;
}


static const per_sequence_t SysInfoType6_v590ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_hcr_r5_SpecificInfo1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_hcr_r5_SpecificInfo1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType6_v590ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType6_v590ext_IEs, SysInfoType6_v590ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType6_v650ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_frequencyBandIndicator2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RadioFrequencyBandFDD2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType6_v650ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType6_v650ext_IEs, SysInfoType6_v650ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType6_v6xyext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType6_v6xyext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType6_v6xyext_IEs, SysInfoType6_v6xyext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions7_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions7, T_nonCriticalExtensions7_sequence);

  return offset;
}


static const per_sequence_t T_v6xynonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType6_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType6_v6xyext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v6xynonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v6xynonCriticalExtensions, T_v6xynonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t T_v650nonCriticalExtensions_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType6_v650ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType6_v650ext_IEs },
  { &hf_umts_rrc_ies_v6xynonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v6xynonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v650nonCriticalExtensions(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v650nonCriticalExtensions, T_v650nonCriticalExtensions_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtensions1_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType6_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType6_v590ext_IEs },
  { &hf_umts_rrc_ies_v650nonCriticalExtensions, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v650nonCriticalExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtensions1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtensions1, T_v590NonCriticalExtensions1_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions3_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType6_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType6_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtensions1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtensions1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions3, T_v4b0NonCriticalExtensions3_sequence);

  return offset;
}


static const per_sequence_t SysInfoType6_sequence[] = {
  { &hf_umts_rrc_ies_pich_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PICH_PowerOffset },
  { &hf_umts_rrc_ies_modeSpecificInfo81, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo81 },
  { &hf_umts_rrc_ies_primaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PrimaryCCPCH_Info },
  { &hf_umts_rrc_ies_prach_SystemInformationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PRACH_SystemInformationList },
  { &hf_umts_rrc_ies_sCCPCH_SystemInformationList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SCCPCH_SystemInformationList },
  { &hf_umts_rrc_ies_cbs_DRX_Level1Information, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CBS_DRX_Level1Information },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType6, SysInfoType6_sequence);

  return offset;
}


static const per_sequence_t T_fdd89_sequence[] = {
  { &hf_umts_rrc_ies_ul_Interference, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UL_Interference },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd89(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd89, T_fdd89_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_modeSpecificInfo82_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_modeSpecificInfo82_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd94  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd89 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_modeSpecificInfo82(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_modeSpecificInfo82, T_modeSpecificInfo82_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions8_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions8, T_nonCriticalExtensions8_sequence);

  return offset;
}


static const per_sequence_t SysInfoType7_sequence[] = {
  { &hf_umts_rrc_ies_modeSpecificInfo82, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_modeSpecificInfo82 },
  { &hf_umts_rrc_ies_prach_Information_SIB5_List, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DynamicPersistenceLevelList },
  { &hf_umts_rrc_ies_prach_Information_SIB6_List, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_DynamicPersistenceLevelList },
  { &hf_umts_rrc_ies_expirationTimeFactor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ExpirationTimeFactor },
  { &hf_umts_rrc_ies_nonCriticalExtensions8, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType7, SysInfoType7_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions9_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions9, T_nonCriticalExtensions9_sequence);

  return offset;
}


static const per_sequence_t SysInfoType8_sequence[] = {
  { &hf_umts_rrc_ies_dummy1_CPCH_Parameters, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_Parameters },
  { &hf_umts_rrc_ies_dummy2_CPCH_SetInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_SetInfoList },
  { &hf_umts_rrc_ies_dummy3_CSICH_PowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CSICH_PowerOffset },
  { &hf_umts_rrc_ies_nonCriticalExtensions9, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions9 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType8, SysInfoType8_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions10_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions10, T_nonCriticalExtensions10_sequence);

  return offset;
}


static const per_sequence_t SysInfoType9_sequence[] = {
  { &hf_umts_rrc_ies_dummy_CPCH_PersistenceLevelsList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CPCH_PersistenceLevelsList },
  { &hf_umts_rrc_ies_nonCriticalExtensions10, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions10 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType9, SysInfoType9_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions11_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions11, T_nonCriticalExtensions11_sequence);

  return offset;
}


static const per_sequence_t SysInfoType10_sequence[] = {
  { &hf_umts_rrc_ies_dummy_DRAC_SysInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DRAC_SysInfoList },
  { &hf_umts_rrc_ies_nonCriticalExtensions11, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions11 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType10(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType10, SysInfoType10_sequence);

  return offset;
}


static const per_sequence_t SysInfoType11_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_fach_MeasurementOccasionInfo_LCR_Ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FACH_MeasurementOccasionInfo_LCR_r4_ext },
  { &hf_umts_rrc_ies_measurementControlSysInfo_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementControlSysInfo_LCR_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType11_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType11_v4b0ext_IEs, SysInfoType11_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext_sequence_of[1] = {
  { &hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CellSelectReselectInfo_v590ext },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext, SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext_sequence_of,
                                                  1, maxCellMeas);

  return offset;
}


static const per_sequence_t SysInfoType11_v590ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext },
  { &hf_umts_rrc_ies_newInterFrequencyCellInfoList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext },
  { &hf_umts_rrc_ies_newInterRATCellInfoList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext },
  { &hf_umts_rrc_ies_intraFreqEventCriteriaList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext },
  { &hf_umts_rrc_ies_intraFreqReportingCriteria_1b_r5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingCriteria_1b_r5 },
  { &hf_umts_rrc_ies_intraFreqEvent_1d_r5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqEvent_1d_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType11_v590ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType11_v590ext_IEs, SysInfoType11_v590ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType11_v6xyext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_interFreqRACHReportingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqRACHReportingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType11_v6xyext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType11_v6xyext_IEs, SysInfoType11_v6xyext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions12_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions12, T_nonCriticalExtensions12_sequence);

  return offset;
}


static const per_sequence_t T_v6xyNonCriticalExtensions2_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType11_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType11_v6xyext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions12, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions12 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v6xyNonCriticalExtensions2, T_v6xyNonCriticalExtensions2_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtension2_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType11_v590ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType11_v590ext_IEs },
  { &hf_umts_rrc_ies_v6xyNonCriticalExtensions2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtension2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtension2, T_v590NonCriticalExtension2_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions4_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType11_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType11_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtension2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtension2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions4, T_v4b0NonCriticalExtensions4_sequence);

  return offset;
}


static const per_sequence_t SysInfoType11_sequence[] = {
  { &hf_umts_rrc_ies_sib12indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_fach_MeasurementOccasionInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FACH_MeasurementOccasionInfo },
  { &hf_umts_rrc_ies_measurementControlSysInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementControlSysInfo },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType11(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType11, SysInfoType11_sequence);

  return offset;
}


static const per_sequence_t SysInfoType12_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_fach_MeasurementOccasionInfo_LCR_Ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FACH_MeasurementOccasionInfo_LCR_r4_ext },
  { &hf_umts_rrc_ies_measurementControlSysInfo_LCR, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementControlSysInfo_LCR_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType12_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType12_v4b0ext_IEs, SysInfoType12_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType12_v590ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext },
  { &hf_umts_rrc_ies_newInterFrequencyCellInfoList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext },
  { &hf_umts_rrc_ies_newInterRATCellInfoList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext },
  { &hf_umts_rrc_ies_intraFreqEventCriteriaList_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext },
  { &hf_umts_rrc_ies_intraFreqReportingCriteria_1b_r5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqReportingCriteria_1b_r5 },
  { &hf_umts_rrc_ies_intraFreqEvent_1d_r5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_IntraFreqEvent_1d_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType12_v590ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType12_v590ext_IEs, SysInfoType12_v590ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType12_v6xyext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_interFreqRACHReportingInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_InterFreqRACHReportingInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType12_v6xyext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType12_v6xyext_IEs, SysInfoType12_v6xyext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions13_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions13, T_nonCriticalExtensions13_sequence);

  return offset;
}


static const per_sequence_t T_v6xyNonCriticalExtensions3_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType12_v6xyext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType12_v6xyext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions13, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions13 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v6xyNonCriticalExtensions3, T_v6xyNonCriticalExtensions3_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtension3_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType12_v590ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType12_v590ext_IEs },
  { &hf_umts_rrc_ies_v6xyNonCriticalExtensions3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v6xyNonCriticalExtensions3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtension3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtension3, T_v590NonCriticalExtension3_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions5_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType12_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType12_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtension3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtension3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions5, T_v4b0NonCriticalExtensions5_sequence);

  return offset;
}


static const per_sequence_t SysInfoType12_sequence[] = {
  { &hf_umts_rrc_ies_fach_MeasurementOccasionInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_FACH_MeasurementOccasionInfo },
  { &hf_umts_rrc_ies_measurementControlSysInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MeasurementControlSysInfo },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType12(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType12, SysInfoType12_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_v3a0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_ue_IdleTimersAndConstants_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_IdleTimersAndConstants_v3a0ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13_v3a0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13_v3a0ext_IEs, SysInfoType13_v3a0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_capabilityUpdateRequirement_r4Ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CapabilityUpdateRequirement_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13_v4b0ext_IEs, SysInfoType13_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions14_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions14, T_nonCriticalExtensions14_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions6_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType13_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType13_v4b0ext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions14, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions14 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions6, T_v4b0NonCriticalExtensions6_sequence);

  return offset;
}


static const per_sequence_t T_v3a0NonCriticalExtensions1_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType13_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType13_v3a0ext_IEs },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions6, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v3a0NonCriticalExtensions1, T_v3a0NonCriticalExtensions1_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_sequence[] = {
  { &hf_umts_rrc_ies_cn_DomainSysInfoList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_CN_DomainSysInfoList },
  { &hf_umts_rrc_ies_ue_IdleTimersAndConstants, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_IdleTimersAndConstants },
  { &hf_umts_rrc_ies_capabilityUpdateRequirement, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_CapabilityUpdateRequirement },
  { &hf_umts_rrc_ies_v3a0NonCriticalExtensions1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13, SysInfoType13_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_ANSI_41_RAND_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_ANSI_41_NAS_Parameter(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions15_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions15, T_nonCriticalExtensions15_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_1_sequence[] = {
  { &hf_umts_rrc_ies_ansi_41_RAND_Information, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ANSI_41_RAND_Information },
  { &hf_umts_rrc_ies_nonCriticalExtensions15, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions15 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13_1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13_1, SysInfoType13_1_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_ANSI_41_UserZoneID_Information(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_ANSI_41_NAS_Parameter(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions16_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions16, T_nonCriticalExtensions16_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_2_sequence[] = {
  { &hf_umts_rrc_ies_ansi_41_UserZoneID_Information, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ANSI_41_UserZoneID_Information },
  { &hf_umts_rrc_ies_nonCriticalExtensions16, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13_2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13_2, SysInfoType13_2_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_ANSI_41_PrivateNeighbourListInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_ANSI_41_NAS_Parameter(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions17_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions17, T_nonCriticalExtensions17_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_3_sequence[] = {
  { &hf_umts_rrc_ies_ansi_41_PrivateNeighbourListInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ANSI_41_PrivateNeighbourListInfo },
  { &hf_umts_rrc_ies_nonCriticalExtensions17, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions17 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13_3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13_3, SysInfoType13_3_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_ANSI_41_GlobalServiceRedirectInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_ANSI_41_NAS_Parameter(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions18_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions18(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions18, T_nonCriticalExtensions18_sequence);

  return offset;
}


static const per_sequence_t SysInfoType13_4_sequence[] = {
  { &hf_umts_rrc_ies_ansi_41_GlobalServiceRedirectInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ANSI_41_GlobalServiceRedirectInfo },
  { &hf_umts_rrc_ies_nonCriticalExtensions18, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions18 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType13_4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType13_4, SysInfoType13_4_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions19_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions19(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions19, T_nonCriticalExtensions19_sequence);

  return offset;
}


static const per_sequence_t SysInfoType14_sequence[] = {
  { &hf_umts_rrc_ies_individualTS_InterferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_IndividualTS_InterferenceList },
  { &hf_umts_rrc_ies_expirationTimeFactor, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_ExpirationTimeFactor },
  { &hf_umts_rrc_ies_nonCriticalExtensions19, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions19 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType14(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType14, SysInfoType14_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_up_Ipdl_Parameters_TDD, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_v4b0ext_IEs, SysInfoType15_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions20_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions20(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions20, T_nonCriticalExtensions20_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions7_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType15_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType15_v4b0ext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions20, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions20 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions7(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions7, T_v4b0NonCriticalExtensions7_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_GPS_CipherParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_CipherParameters },
  { &hf_umts_rrc_ies_ue_positioning_GPS_ReferenceLocation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ReferenceLocation },
  { &hf_umts_rrc_ies_ue_positioning_GPS_ReferenceTime, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_GPS_ReferenceTime },
  { &hf_umts_rrc_ies_ue_positioning_GPS_Real_timeIntegrity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BadSatList },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions7, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions7 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15, SysInfoType15_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions21_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions21(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions21, T_nonCriticalExtensions21_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_1_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_GPS_DGPS_Corrections, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_GPS_DGPS_Corrections },
  { &hf_umts_rrc_ies_nonCriticalExtensions21, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions21 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_1, SysInfoType15_1_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions22_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions22(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions22, T_nonCriticalExtensions22_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_2_sequence[] = {
  { &hf_umts_rrc_ies_transmissionTOW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_604799 },
  { &hf_umts_rrc_ies_satID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SatID },
  { &hf_umts_rrc_ies_ephemerisParameter, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_EphemerisParameter },
  { &hf_umts_rrc_ies_nonCriticalExtensions22, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions22 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_2, SysInfoType15_2_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_BIT_STRING_SIZE_1_32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 32, FALSE, NULL);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions23_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions23(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions23, T_nonCriticalExtensions23_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_3_sequence[] = {
  { &hf_umts_rrc_ies_transmissionTOW, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_604799 },
  { &hf_umts_rrc_ies_ue_positioning_GPS_Almanac, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_Almanac },
  { &hf_umts_rrc_ies_ue_positioning_GPS_IonosphericModel, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_IonosphericModel },
  { &hf_umts_rrc_ies_ue_positioning_GPS_UTC_Model, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_GPS_UTC_Model },
  { &hf_umts_rrc_ies_satMask, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BIT_STRING_SIZE_1_32 },
  { &hf_umts_rrc_ies_lsbTOW , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_BIT_STRING_SIZE_8 },
  { &hf_umts_rrc_ies_nonCriticalExtensions23, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions23 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_3, SysInfoType15_3_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_4_v3a0ext_sequence[] = {
  { &hf_umts_rrc_ies_sfn_Offset_Validity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_Offset_Validity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_4_v3a0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_4_v3a0ext, SysInfoType15_4_v3a0ext_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_4_v4b0ext_sequence[] = {
  { &hf_umts_rrc_ies_ue_Positioning_OTDOA_AssistanceData_r4ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4ext },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_4_v4b0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_4_v4b0ext, SysInfoType15_4_v4b0ext_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions24_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions24(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions24, T_nonCriticalExtensions24_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions8_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType15_4_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType15_4_v4b0ext },
  { &hf_umts_rrc_ies_nonCriticalExtensions24, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions24 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions8(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions8, T_v4b0NonCriticalExtensions8_sequence);

  return offset;
}


static const per_sequence_t T_v3a0NonCriticalExtensions2_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType15_4_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType15_4_v3a0ext },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions8, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v3a0NonCriticalExtensions2, T_v3a0NonCriticalExtensions2_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_4_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_CipherParameters, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_UE_Positioning_CipherParameters },
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData },
  { &hf_umts_rrc_ies_v3a0NonCriticalExtensions2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_4, SysInfoType15_4_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_5_v3a0ext_sequence[] = {
  { &hf_umts_rrc_ies_sfn_Offset_Validity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SFN_Offset_Validity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_5_v3a0ext(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_5_v3a0ext, SysInfoType15_5_v3a0ext_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions25_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions25(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions25, T_nonCriticalExtensions25_sequence);

  return offset;
}


static const per_sequence_t T_v3a0NonCriticalExtensions3_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType15_5_v3a0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType15_5_v3a0ext },
  { &hf_umts_rrc_ies_nonCriticalExtensions25, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions25 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v3a0NonCriticalExtensions3, T_v3a0NonCriticalExtensions3_sequence);

  return offset;
}


static const per_sequence_t SysInfoType15_5_sequence[] = {
  { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData_UEB, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_UEB },
  { &hf_umts_rrc_ies_v3a0NonCriticalExtensions3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v3a0NonCriticalExtensions3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType15_5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType15_5, SysInfoType15_5_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions26_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions26(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions26, T_nonCriticalExtensions26_sequence);

  return offset;
}


static const per_sequence_t SysInfoType16_sequence[] = {
  { &hf_umts_rrc_ies_preDefinedRadioConfiguration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PreDefRadioConfiguration },
  { &hf_umts_rrc_ies_nonCriticalExtensions26, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions26 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType16(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType16, SysInfoType16_sequence);

  return offset;
}


static const per_sequence_t T_tdd128SpecificInfo2_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4 },
  { &hf_umts_rrc_ies_pdsch_SysInfoList1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd128SpecificInfo2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd128SpecificInfo2, T_tdd128SpecificInfo2_sequence);

  return offset;
}


static const per_sequence_t SysInfoType17_v4b0ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_tdd128SpecificInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_tdd128SpecificInfo2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType17_v4b0ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType17_v4b0ext_IEs, SysInfoType17_v4b0ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_hcr_r5_SpecificInfo2_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5 },
  { &hf_umts_rrc_ies_pdsch_SysInfoList2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_hcr_r5_SpecificInfo2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_hcr_r5_SpecificInfo2, T_hcr_r5_SpecificInfo2_sequence);

  return offset;
}


static const per_sequence_t SysInfoType17_v590ext_IEs_sequence[] = {
  { &hf_umts_rrc_ies_hcr_r5_SpecificInfo2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_hcr_r5_SpecificInfo2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType17_v590ext_IEs(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType17_v590ext_IEs, SysInfoType17_v590ext_IEs_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions27_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions27(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions27, T_nonCriticalExtensions27_sequence);

  return offset;
}


static const per_sequence_t T_v590NonCriticalExtensions2_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType17_v590ext, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_SysInfoType17_v590ext_IEs },
  { &hf_umts_rrc_ies_nonCriticalExtensions27, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions27 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v590NonCriticalExtensions2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v590NonCriticalExtensions2, T_v590NonCriticalExtensions2_sequence);

  return offset;
}


static const per_sequence_t T_v4b0NonCriticalExtensions9_sequence[] = {
  { &hf_umts_rrc_ies_sysInfoType17_v4b0ext, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SysInfoType17_v4b0ext_IEs },
  { &hf_umts_rrc_ies_v590NonCriticalExtensions2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v590NonCriticalExtensions2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions9(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_v4b0NonCriticalExtensions9, T_v4b0NonCriticalExtensions9_sequence);

  return offset;
}


static const per_sequence_t SysInfoType17_sequence[] = {
  { &hf_umts_rrc_ies_pusch_SysInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PUSCH_SysInfoList },
  { &hf_umts_rrc_ies_pdsch_SysInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PDSCH_SysInfoList },
  { &hf_umts_rrc_ies_v4b0NonCriticalExtensions9, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_v4b0NonCriticalExtensions9 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType17(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType17, SysInfoType17_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions28_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions28(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions28, T_nonCriticalExtensions28_sequence);

  return offset;
}


static const per_sequence_t SysInfoType18_sequence[] = {
  { &hf_umts_rrc_ies_idleModePLMNIdentities, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMNIdentitiesOfNeighbourCells },
  { &hf_umts_rrc_ies_connectedModePLMNIdentities, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_PLMNIdentitiesOfNeighbourCells },
  { &hf_umts_rrc_ies_nonCriticalExtensions28, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions28 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoType18(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoType18, SysInfoType18_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions29_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions29(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions29, T_nonCriticalExtensions29_sequence);

  return offset;
}


static const per_sequence_t SysInfoTypeSB1_sequence[] = {
  { &hf_umts_rrc_ies_sib_ReferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIB_ReferenceList },
  { &hf_umts_rrc_ies_nonCriticalExtensions29, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions29 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoTypeSB1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoTypeSB1, SysInfoTypeSB1_sequence);

  return offset;
}


static const per_sequence_t T_nonCriticalExtensions30_sequence[] = {
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_nonCriticalExtensions30(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_nonCriticalExtensions30, T_nonCriticalExtensions30_sequence);

  return offset;
}


static const per_sequence_t SysInfoTypeSB2_sequence[] = {
  { &hf_umts_rrc_ies_sib_ReferenceList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SIB_ReferenceList },
  { &hf_umts_rrc_ies_nonCriticalExtensions30, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_nonCriticalExtensions30 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_SysInfoTypeSB2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_SysInfoTypeSB2, SysInfoTypeSB2_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_AccessProbabilityFactor_vals[] = {
  {   0, "apf0" },
  {   1, "apf32" },
  {   2, "apf64" },
  {   3, "apf96" },
  {   4, "apf128" },
  {   5, "apf160" },
  {   6, "apf192" },
  {   7, "apf224" },
  {   8, "apf256" },
  {   9, "apf288" },
  {  10, "apf320" },
  {  11, "apf352" },
  {  12, "apf384" },
  {  13, "apf416" },
  {  14, "apf448" },
  {  15, "apf480" },
  {  16, "apf512" },
  {  17, "apf544" },
  {  18, "apf576" },
  {  19, "apf608" },
  {  20, "apf640" },
  {  21, "apf672" },
  {  22, "apf704" },
  {  23, "apf736" },
  {  24, "apf768" },
  {  25, "apf800" },
  {  26, "apf832" },
  {  27, "apf864" },
  {  28, "apf896" },
  {  29, "apf928" },
  {  30, "apf960" },
  {  31, "apf1000" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_AccessProbabilityFactor(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     32, NULL, FALSE, 0, NULL);

  return offset;
}



int
dissect_umts_rrc_ies_MBMS_CellGroupIdentity_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     12, 12, FALSE, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_CommonCCTrChIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_CommonPhyChIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_CommonRBIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MBMS_CommonRBInformation_r6_sequence[] = {
  { &hf_umts_rrc_ies_commonRBIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonRBIdentity },
  { &hf_umts_rrc_ies_pdcp_Info1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_PDCP_Info_r4 },
  { &hf_umts_rrc_ies_rlc_Info3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_RLC_Info_MBMS_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_CommonRBInformation_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_CommonRBInformation_r6, MBMS_CommonRBInformation_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_CommonRBInformationList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_CommonRBInformationList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonRBInformation_r6 },
};

int
dissect_umts_rrc_ies_MBMS_CommonRBInformationList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_CommonRBInformationList_r6, MBMS_CommonRBInformationList_r6_sequence_of,
                                                  1, maxMBMSCommonRB);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_CommonTrChIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 32U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MBMS_ConnectedModeCountingScope_sequence[] = {
  { &hf_umts_rrc_ies_countingForUraPCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_countingForCellPCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_countingForCellFACH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_ConnectedModeCountingScope(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_ConnectedModeCountingScope, MBMS_ConnectedModeCountingScope_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_SCCPCHIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxSCCPCH, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_SoftComb_TimingOffset_vals[] = {
  {   0, "ms0" },
  {   1, "ms10" },
  {   2, "ms20" },
  {   3, "ms40" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_SoftComb_TimingOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_ShortTransmissionID(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxMBMSservUnmodif, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_LogicalChIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 15U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MBMS_PTM_RBInformation_C_sequence[] = {
  { &hf_umts_rrc_ies_rbInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonRBIdentity },
  { &hf_umts_rrc_ies_shortTransmissionID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ShortTransmissionID },
  { &hf_umts_rrc_ies_logicalChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_LogicalChIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_PTM_RBInformation_C(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_PTM_RBInformation_C, MBMS_PTM_RBInformation_C_sequence);

  return offset;
}


static const per_sequence_t MBMS_PTM_RBInformation_CList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_PTM_RBInformation_CList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_PTM_RBInformation_C },
};

static int
dissect_umts_rrc_ies_MBMS_PTM_RBInformation_CList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_PTM_RBInformation_CList, MBMS_PTM_RBInformation_CList_sequence_of,
                                                  1, maxRBperTrCh);

  return offset;
}


static const per_sequence_t MBMS_TrCHInformation_Comm_sequence[] = {
  { &hf_umts_rrc_ies_transpCh_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonTrChIdentity },
  { &hf_umts_rrc_ies_rbInformation1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_PTM_RBInformation_CList },
  { &hf_umts_rrc_ies_mschConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_TrCHInformation_Comm(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TrCHInformation_Comm, MBMS_TrCHInformation_Comm_sequence);

  return offset;
}


static const per_sequence_t MBMS_TrCHInformation_CommList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_TrCHInformation_CommList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TrCHInformation_Comm },
};

static int
dissect_umts_rrc_ies_MBMS_TrCHInformation_CommList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_TrCHInformation_CommList, MBMS_TrCHInformation_CommList_sequence_of,
                                                  1, maxTrChperSCCPCH);

  return offset;
}


static const per_sequence_t MBMS_CurrentCell_SCCPCH_r6_sequence[] = {
  { &hf_umts_rrc_ies_sccpchIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_SCCPCHIdentity },
  { &hf_umts_rrc_ies_secondaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonPhyChIdentity },
  { &hf_umts_rrc_ies_softComb_TimingOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_SoftComb_TimingOffset },
  { &hf_umts_rrc_ies_transpCh_InfoCommonForAllTrCh, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonCCTrChIdentity },
  { &hf_umts_rrc_ies_transpCHInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TrCHInformation_CommList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_CurrentCell_SCCPCH_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_CurrentCell_SCCPCH_r6, MBMS_CurrentCell_SCCPCH_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_CurrentCell_SCCPCHList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CurrentCell_SCCPCH_r6 },
};

int
dissect_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6, MBMS_CurrentCell_SCCPCHList_r6_sequence_of,
                                                  1, maxSCCPCH);

  return offset;
}


static const per_sequence_t MBMS_JoinedInformation_r6_sequence[] = {
  { &hf_umts_rrc_ies_p_TMSI , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_P_TMSI_GSM_MAP },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MBMS_JoinedInformation_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_JoinedInformation_r6, MBMS_JoinedInformation_r6_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_item_sequence[] = {
  { &hf_umts_rrc_ies_periodStart, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_7 },
  { &hf_umts_rrc_ies_periodDuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_8 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item, T_mtch_L1CombiningPeriodList_item_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_sequence_of[1] = {
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item },
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList, T_mtch_L1CombiningPeriodList_sequence_of,
                                                  1, maxMBMSL1CP);

  return offset;
}


static const per_sequence_t MBMS_L1CombiningSchedule_32_sequence[] = {
  { &hf_umts_rrc_ies_cycleOffset, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_7 },
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_32(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_L1CombiningSchedule_32, MBMS_L1CombiningSchedule_32_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_item1_sequence[] = {
  { &hf_umts_rrc_ies_periodStart1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_periodDuration1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_16 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item1, T_mtch_L1CombiningPeriodList_item1_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList1_sequence_of[1] = {
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item1 },
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList1, T_mtch_L1CombiningPeriodList1_sequence_of,
                                                  1, maxMBMSL1CP);

  return offset;
}


static const per_sequence_t MBMS_L1CombiningSchedule_64_sequence[] = {
  { &hf_umts_rrc_ies_cycleOffset1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_15 },
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_64(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_L1CombiningSchedule_64, MBMS_L1CombiningSchedule_64_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_item2_sequence[] = {
  { &hf_umts_rrc_ies_periodStart2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_31 },
  { &hf_umts_rrc_ies_periodDuration2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_32 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item2, T_mtch_L1CombiningPeriodList_item2_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList2_sequence_of[1] = {
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item2 },
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList2(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList2, T_mtch_L1CombiningPeriodList2_sequence_of,
                                                  1, maxMBMSL1CP);

  return offset;
}


static const per_sequence_t MBMS_L1CombiningSchedule_128_sequence[] = {
  { &hf_umts_rrc_ies_cycleOffset2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_31 },
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_L1CombiningSchedule_128, MBMS_L1CombiningSchedule_128_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_64(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 64U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_item3_sequence[] = {
  { &hf_umts_rrc_ies_periodStart3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_periodDuration3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_64 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item3, T_mtch_L1CombiningPeriodList_item3_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList3_sequence_of[1] = {
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item3 },
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList3, T_mtch_L1CombiningPeriodList3_sequence_of,
                                                  1, maxMBMSL1CP);

  return offset;
}


static const per_sequence_t MBMS_L1CombiningSchedule_256_sequence[] = {
  { &hf_umts_rrc_ies_cycleOffset3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_63 },
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList3 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_256(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_L1CombiningSchedule_256, MBMS_L1CombiningSchedule_256_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_128(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 128U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_item4_sequence[] = {
  { &hf_umts_rrc_ies_periodStart4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_periodDuration4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_128 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item4, T_mtch_L1CombiningPeriodList_item4_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList4_sequence_of[1] = {
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item4 },
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList4(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList4, T_mtch_L1CombiningPeriodList4_sequence_of,
                                                  1, maxMBMSL1CP);

  return offset;
}


static const per_sequence_t MBMS_L1CombiningSchedule_512_sequence[] = {
  { &hf_umts_rrc_ies_cycleOffset4, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_127 },
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList4, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList4 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_512(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_L1CombiningSchedule_512, MBMS_L1CombiningSchedule_512_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList_item5_sequence[] = {
  { &hf_umts_rrc_ies_periodStart5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_periodDuration5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_256 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item5, T_mtch_L1CombiningPeriodList_item5_sequence);

  return offset;
}


static const per_sequence_t T_mtch_L1CombiningPeriodList5_sequence_of[1] = {
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item5 },
};

static int
dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList5, T_mtch_L1CombiningPeriodList5_sequence_of,
                                                  1, maxMBMSL1CP);

  return offset;
}


static const per_sequence_t MBMS_L1CombiningSchedule_1024_sequence[] = {
  { &hf_umts_rrc_ies_cycleOffset5, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList5, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mtch_L1CombiningPeriodList5 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_1024(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_L1CombiningSchedule_1024, MBMS_L1CombiningSchedule_1024_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_L1CombiningSchedule_vals[] = {
  {   0, "cycleLength-32" },
  {   1, "cycleLength-64" },
  {   2, "cycleLength-128" },
  {   3, "cycleLength-256" },
  {   4, "cycleLength-512" },
  {   5, "cycleLength-1024" },
  { 0, NULL }
};

static const per_choice_t MBMS_L1CombiningSchedule_choice[] = {
  {   0, &hf_umts_rrc_ies_cycleLength_32, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_32 },
  {   1, &hf_umts_rrc_ies_cycleLength_64, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_64 },
  {   2, &hf_umts_rrc_ies_cycleLength_128, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_128 },
  {   3, &hf_umts_rrc_ies_cycleLength_256, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_256 },
  {   4, &hf_umts_rrc_ies_cycleLength_512, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_512 },
  {   5, &hf_umts_rrc_ies_cycleLength_1024, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule_1024 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L1CombiningSchedule(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MBMS_L1CombiningSchedule, MBMS_L1CombiningSchedule_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_L1CombiningTransmTimeDiff(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t T_sameAsCurrent_sequence[] = {
  { &hf_umts_rrc_ies_currentCell_SCCPCH, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_SCCPCHIdentity },
  { &hf_umts_rrc_ies_mschConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_sameAsCurrent(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_sameAsCurrent, T_sameAsCurrent_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_layer1_CombiningStatus_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_layer1_CombiningStatus(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MBMS_PTM_RBInformation_N_sequence[] = {
  { &hf_umts_rrc_ies_shortTransmissionID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ShortTransmissionID },
  { &hf_umts_rrc_ies_logicalChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_LogicalChIdentity },
  { &hf_umts_rrc_ies_layer1_CombiningStatus, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_layer1_CombiningStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_PTM_RBInformation_N(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_PTM_RBInformation_N, MBMS_PTM_RBInformation_N_sequence);

  return offset;
}


static const per_sequence_t MBMS_PTM_RBInformation_NList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_PTM_RBInformation_NList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_PTM_RBInformation_N },
};

static int
dissect_umts_rrc_ies_MBMS_PTM_RBInformation_NList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_PTM_RBInformation_NList, MBMS_PTM_RBInformation_NList_sequence_of,
                                                  1, maxRBperTrCh);

  return offset;
}


static const per_sequence_t MBMS_TrCHInformation_Neighb_sequence[] = {
  { &hf_umts_rrc_ies_transpCh_Info, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonTrChIdentity },
  { &hf_umts_rrc_ies_transpCh_CombiningStatus, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { &hf_umts_rrc_ies_rbInformation2, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_PTM_RBInformation_NList },
  { &hf_umts_rrc_ies_mschConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_TrCHInformation_Neighb(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TrCHInformation_Neighb, MBMS_TrCHInformation_Neighb_sequence);

  return offset;
}


static const per_sequence_t MBMS_TrCHInformation_NeighbList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_TrCHInformation_NeighbList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TrCHInformation_Neighb },
};

static int
dissect_umts_rrc_ies_MBMS_TrCHInformation_NeighbList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_TrCHInformation_NeighbList, MBMS_TrCHInformation_NeighbList_sequence_of,
                                                  1, maxFACHPCH);

  return offset;
}


static const per_sequence_t T_different_sequence[] = {
  { &hf_umts_rrc_ies_transpCh_InfoCommonForAllTrCh, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonCCTrChIdentity },
  { &hf_umts_rrc_ies_transpCHInformation1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TrCHInformation_NeighbList },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_different(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_different, T_different_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_L23Configuration_vals[] = {
  {   0, "sameAsCurrent" },
  {   1, "different" },
  { 0, NULL }
};

static const per_choice_t MBMS_L23Configuration_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsCurrent, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_sameAsCurrent },
  {   1, &hf_umts_rrc_ies_different, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_different },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_L23Configuration(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_MBMS_L23Configuration, MBMS_L23Configuration_choice,
                                 NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_MICHPowerOffset(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              -10, 5U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_NI_CountPerFrame_vals[] = {
  {   0, "ni18" },
  {   1, "ni36" },
  {   2, "ni72" },
  {   3, "ni144" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_NI_CountPerFrame(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd90_sequence[] = {
  { &hf_umts_rrc_ies_channelisationCode256, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_ChannelisationCode256 },
  { &hf_umts_rrc_ies_ni_CountPerFrame, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_NI_CountPerFrame },
  { &hf_umts_rrc_ies_sttd_Indicator, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd90(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd90, T_fdd90_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_MICHNotificationIndLength_vals[] = {
  {   0, "mn4" },
  {   1, "mn8" },
  {   2, "mn16" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_MICHNotificationIndLength(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_tdd38415_sequence[] = {
  { &hf_umts_rrc_ies_timeslot, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType },
  { &hf_umts_rrc_ies_channelisationCode3, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
  { &hf_umts_rrc_ies_repetitionPeriodLengthOffset1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RepPerLengthOffset_MICH },
  { &hf_umts_rrc_ies_mbmsNotificationIndLength, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MICHNotificationIndLength },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd38415(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd38415, T_tdd38415_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode_sequence_of[1] = {
  { &hf_umts_rrc_ies_channelisationCodeList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_DL_TS_ChannelisationCode },
};

static int
dissect_umts_rrc_ies_SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode, SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode_sequence_of,
                                                  1, 2);

  return offset;
}


static const per_sequence_t T_tdd12817_sequence[] = {
  { &hf_umts_rrc_ies_timeslot1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TimeslotNumber_LCR_r4 },
  { &hf_umts_rrc_ies_midambleShiftAndBurstType1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4 },
  { &hf_umts_rrc_ies_channelisationCodeList1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode },
  { &hf_umts_rrc_ies_repetitionPeriodLengthOffset1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_RepPerLengthOffset_MICH },
  { &hf_umts_rrc_ies_mbmsNotificationIndLength, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MICHNotificationIndLength },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_tdd12817(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_tdd12817, T_tdd12817_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_mode_vals[] = {
  {   0, "fdd" },
  {   1, "tdd384" },
  {   2, "tdd128" },
  { 0, NULL }
};

static const per_choice_t T_mode_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd95  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd90 },
  {   1, &hf_umts_rrc_ies_tdd38419, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd38415 },
  {   2, &hf_umts_rrc_ies_tdd12821, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_tdd12817 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mode(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_mode, T_mode_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MBMS_MICHConfigurationInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_michPowerOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_MICHPowerOffset },
  { &hf_umts_rrc_ies_mode   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_mode },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MBMS_MICHConfigurationInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_MICHConfigurationInfo_r6, MBMS_MICHConfigurationInfo_r6_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_OCTET_STRING_SIZE_3(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       3, 3, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, 5U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_other1_vals[] = {
  {   0, "sameAsMIB-MultiPLMN-Id" },
  {   1, "explicitPLMN-Id" },
  { 0, NULL }
};

static const per_choice_t T_other1_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsMIB_MultiPLMN_Id, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_1_5 },
  {   1, &hf_umts_rrc_ies_explicitPLMN_Id, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_PLMN_Identity },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_other1(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_other1, T_other1_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_plmn_Identity_vals[] = {
  {   0, "sameAsMIB-PLMN-Id" },
  {   1, "other" },
  { 0, NULL }
};

static const per_choice_t T_plmn_Identity_choice[] = {
  {   0, &hf_umts_rrc_ies_sameAsMIB_PLMN_Id, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  {   1, &hf_umts_rrc_ies_other1 , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_other1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_plmn_Identity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_plmn_Identity, T_plmn_Identity_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MBMS_ServiceIdentity_sequence[] = {
  { &hf_umts_rrc_ies_serviceIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_OCTET_STRING_SIZE_3 },
  { &hf_umts_rrc_ies_plmn_Identity1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_plmn_Identity },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MBMS_ServiceIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_ServiceIdentity, MBMS_ServiceIdentity_sequence);

  return offset;
}


static const per_sequence_t MBMS_TransmissionIdentity_sequence[] = {
  { &hf_umts_rrc_ies_mbms_ServiceIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ServiceIdentity },
  { &hf_umts_rrc_ies_mbms_SessionIdentity, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_SessionIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_TransmissionIdentity(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TransmissionIdentity, MBMS_TransmissionIdentity_sequence);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_RequiredUEAction_Mod_vals[] = {
  {   0, "none" },
  {   1, "acquireCountingInfo" },
  {   2, "acquireCountingInfoPTM-RBsUnmodified" },
  {   3, "acquirePTM-RBInfo" },
  {   4, "requestPTPRB" },
  {   5, "releasePTM-RB" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_RequiredUEAction_Mod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     6, NULL, FALSE, 0, NULL);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_PFLIndex(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxMBMSFreq, NULL, FALSE);

  return offset;
}



static int
dissect_umts_rrc_ies_MBMS_PFLInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_umts_rrc_ies_FrequencyInfo(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string umts_rrc_ies_T_mbms_PreferredFrequency_vals[] = {
  {   0, "mcch" },
  {   1, "dcch" },
  { 0, NULL }
};

static const per_choice_t T_mbms_PreferredFrequency_choice[] = {
  {   0, &hf_umts_rrc_ies_mcch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_PFLIndex },
  {   1, &hf_umts_rrc_ies_dcch   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_MBMS_PFLInfo },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_mbms_PreferredFrequency(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_mbms_PreferredFrequency, T_mbms_PreferredFrequency_choice,
                                 NULL);

  return offset;
}


static const value_string umts_rrc_ies_T_mbms_DispersionIndicator_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_T_mbms_DispersionIndicator(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MBMS_ModifedService_r6_sequence[] = {
  { &hf_umts_rrc_ies_mbms_TransmissionIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TransmissionIdentity },
  { &hf_umts_rrc_ies_mbms_RequiredUEAction, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_RequiredUEAction_Mod },
  { &hf_umts_rrc_ies_mbms_PreferredFrequency, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_mbms_PreferredFrequency },
  { &hf_umts_rrc_ies_mbms_DispersionIndicator, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_mbms_DispersionIndicator },
  { &hf_umts_rrc_ies_continueMCCHReading, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_ModifedService_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_ModifedService_r6, MBMS_ModifedService_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_ModifedServiceList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_ModifedServiceList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ModifedService_r6 },
};

int
dissect_umts_rrc_ies_MBMS_ModifedServiceList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_ModifedServiceList_r6, MBMS_ModifedServiceList_r6_sequence_of,
                                                  1, maxMBMSservModif);

  return offset;
}



int
dissect_umts_rrc_ies_MBMS_PtMActivationTime(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 2047U, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_SCCPCHPwrOffsetDiff_vals[] = {
  {   0, "mcpo-minus6" },
  {   1, "mcpo-minus3" },
  {   2, "mcpo-plus3" },
  {   3, "mcpo-plus6" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_SCCPCHPwrOffsetDiff(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     4, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t T_fdd91_sequence[] = {
  { &hf_umts_rrc_ies_softComb_TimingOffset, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_SoftComb_TimingOffset },
  { &hf_umts_rrc_ies_mbms_L1CombiningTransmTimeDiff, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_L1CombiningTransmTimeDiff },
  { &hf_umts_rrc_ies_mbms_L1CombiningSchedule, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_L1CombiningSchedule },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_fdd91(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_T_fdd91, T_fdd91_sequence);

  return offset;
}


static const value_string umts_rrc_ies_T_layer1Combining_vals[] = {
  {   0, "fdd" },
  {   1, "tdd" },
  { 0, NULL }
};

static const per_choice_t T_layer1Combining_choice[] = {
  {   0, &hf_umts_rrc_ies_fdd96  , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_T_fdd91 },
  {   1, &hf_umts_rrc_ies_tdd5   , ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_layer1Combining(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_layer1Combining, T_layer1Combining_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MBMS_NeighbouringCellSCCPCH_r6_sequence[] = {
  { &hf_umts_rrc_ies_secondaryCCPCH_Info2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonPhyChIdentity },
  { &hf_umts_rrc_ies_secondaryCCPCHPwrOffsetDiff, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_SCCPCHPwrOffsetDiff },
  { &hf_umts_rrc_ies_layer1Combining, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_layer1Combining },
  { &hf_umts_rrc_ies_mbms_L23Configuration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_L23Configuration },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_NeighbouringCellSCCPCH_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_NeighbouringCellSCCPCH_r6, MBMS_NeighbouringCellSCCPCH_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_NeighbouringCellSCCPCHList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_NeighbouringCellSCCPCH_r6 },
};

int
dissect_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6, MBMS_NeighbouringCellSCCPCHList_r6_sequence_of,
                                                  1, maxSCCPCH);

  return offset;
}



int
dissect_umts_rrc_ies_MBMS_NumberOfNeighbourCells_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              0U, 32U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MBMS_PhyChInformation_r6_sequence[] = {
  { &hf_umts_rrc_ies_mbms_CommonPhyChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonPhyChIdentity },
  { &hf_umts_rrc_ies_secondaryCCPCHInfo_MBMS, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_SecondaryCCPCHInfo_MBMS_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_PhyChInformation_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_PhyChInformation_r6, MBMS_PhyChInformation_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_PhyChInformationList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_PhyChInformationList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_PhyChInformation_r6 },
};

int
dissect_umts_rrc_ies_MBMS_PhyChInformationList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_PhyChInformationList_r6, MBMS_PhyChInformationList_r6_sequence_of,
                                                  1, maxMBMSCommonPhyCh);

  return offset;
}


const value_string umts_rrc_ies_MBMS_PL_ServiceRestrictInfo_r6_vals[] = {
  {   0, "true" },
  { 0, NULL }
};


int
dissect_umts_rrc_ies_MBMS_PL_ServiceRestrictInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     1, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MBMS_PreferredFreqRequest_r6_sequence[] = {
  { &hf_umts_rrc_ies_preferredFreqRequest, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_FrequencyInfo },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MBMS_PreferredFreqRequest_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_PreferredFreqRequest_r6, MBMS_PreferredFreqRequest_r6_sequence);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_maxMBMSFreq(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxMBMSFreq, NULL, FALSE);

  return offset;
}


static const value_string umts_rrc_ies_T_layerConvergenceInformation_vals[] = {
  {   0, "mbms-Qoffset" },
  {   1, "mbms-HCSoffset" },
  { 0, NULL }
};

static const per_choice_t T_layerConvergenceInformation_choice[] = {
  {   0, &hf_umts_rrc_ies_mbms_Qoffset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  {   1, &hf_umts_rrc_ies_mbms_HCSoffset, ASN1_NO_EXTENSIONS     , dissect_umts_rrc_ies_INTEGER_0_7 },
  { 0, NULL, 0, NULL }
};

static int
dissect_umts_rrc_ies_T_layerConvergenceInformation(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_umts_rrc_ies_T_layerConvergenceInformation, T_layerConvergenceInformation_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MBMS_PreferredFrequencyInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_mbmsPreferredFrequency, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_maxMBMSFreq },
  { &hf_umts_rrc_ies_layerConvergenceInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_T_layerConvergenceInformation },
  { &hf_umts_rrc_ies_mbms_PL_ServiceRestrictInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_PL_ServiceRestrictInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_PreferredFrequencyInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_PreferredFrequencyInfo_r6, MBMS_PreferredFrequencyInfo_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_PreferredFrequencyList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_PreferredFrequencyList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_PreferredFrequencyInfo_r6 },
};

int
dissect_umts_rrc_ies_MBMS_PreferredFrequencyList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_PreferredFrequencyList_r6, MBMS_PreferredFrequencyList_r6_sequence_of,
                                                  1, maxMBMSFreq);

  return offset;
}


static const per_sequence_t MBMS_PTM_RBInformation_S_sequence[] = {
  { &hf_umts_rrc_ies_rbInformation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonRBIdentity },
  { &hf_umts_rrc_ies_shortTransmissionID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ShortTransmissionID },
  { &hf_umts_rrc_ies_logicalChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_LogicalChIdentity },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_PTM_RBInformation_S(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_PTM_RBInformation_S, MBMS_PTM_RBInformation_S_sequence);

  return offset;
}


static const per_sequence_t MBMS_PTM_RBInformation_SList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_PTM_RBInformation_SList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_PTM_RBInformation_S },
};

static int
dissect_umts_rrc_ies_MBMS_PTM_RBInformation_SList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_PTM_RBInformation_SList, MBMS_PTM_RBInformation_SList_sequence_of,
                                                  1, maxRBperTrCh);

  return offset;
}


static const value_string umts_rrc_ies_MBMS_RequiredUEAction_UMod_vals[] = {
  {   0, "none" },
  {   1, "acquirePTM-RBInfo" },
  {   2, "requestPTPRB" },
  { 0, NULL }
};


static int
dissect_umts_rrc_ies_MBMS_RequiredUEAction_UMod(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_enumerated(tvb, offset, actx, tree, hf_index,
                                     3, NULL, FALSE, 0, NULL);

  return offset;
}


static const per_sequence_t MBMS_ServiceAccessInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_shortTransmissionID, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ShortTransmissionID },
  { &hf_umts_rrc_ies_accessprobabilityFactor_Idle, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_AccessProbabilityFactor },
  { &hf_umts_rrc_ies_accessprobabilityFactor_UraPCH, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_AccessProbabilityFactor },
  { &hf_umts_rrc_ies_mbms_ConnectedModeCountingScope, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ConnectedModeCountingScope },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_ServiceAccessInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_ServiceAccessInfo_r6, MBMS_ServiceAccessInfo_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_ServiceAccessInfoList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ServiceAccessInfo_r6 },
};

int
dissect_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6, MBMS_ServiceAccessInfoList_r6_sequence_of,
                                                  1, maxMBMSservCount);

  return offset;
}


static const per_sequence_t MBMS_ServiceTransmInfo_sequence[] = {
  { &hf_umts_rrc_ies_start  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_255 },
  { &hf_umts_rrc_ies_duration, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_256 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_ServiceTransmInfo(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_ServiceTransmInfo, MBMS_ServiceTransmInfo_sequence);

  return offset;
}


static const per_sequence_t MBMS_ServiceTransmInfoList_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_ServiceTransmInfoList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ServiceTransmInfo },
};

static int
dissect_umts_rrc_ies_MBMS_ServiceTransmInfoList(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_ServiceTransmInfoList, MBMS_ServiceTransmInfoList_sequence_of,
                                                  1, maxMBMSTransmis);

  return offset;
}


static const per_sequence_t MBMS_ServiceSchedulingInfo_r6_sequence[] = {
  { &hf_umts_rrc_ies_mbms_TransmissionIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TransmissionIdentity },
  { &hf_umts_rrc_ies_mbms_ServiceTransmInfoList, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_ServiceTransmInfoList },
  { &hf_umts_rrc_ies_nextSchedulingperiod, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_0_31 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_ServiceSchedulingInfo_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_ServiceSchedulingInfo_r6, MBMS_ServiceSchedulingInfo_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_ServiceSchedulingInfoList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_ServiceSchedulingInfo_r6 },
};

int
dissect_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6, MBMS_ServiceSchedulingInfoList_r6_sequence_of,
                                                  1, maxMBMSservSched);

  return offset;
}



static int
dissect_umts_rrc_ies_INTEGER_1_maxFACHPCH(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                              1U, maxFACHPCH, NULL, FALSE);

  return offset;
}


static const per_sequence_t MBMS_TrCHInformation_SIB5_sequence[] = {
  { &hf_umts_rrc_ies_transpCh_Identity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_INTEGER_1_maxFACHPCH },
  { &hf_umts_rrc_ies_rbInformation3, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_PTM_RBInformation_SList },
  { &hf_umts_rrc_ies_mschConfigurationInfo, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6 },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_TrCHInformation_SIB5(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TrCHInformation_SIB5, MBMS_TrCHInformation_SIB5_sequence);

  return offset;
}


static const per_sequence_t MBMS_TrCHInformation_SIB5List_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_TrCHInformation_SIB5List_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TrCHInformation_SIB5 },
};

static int
dissect_umts_rrc_ies_MBMS_TrCHInformation_SIB5List(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_TrCHInformation_SIB5List, MBMS_TrCHInformation_SIB5List_sequence_of,
                                                  1, maxTrChperSCCPCH);

  return offset;
}


static const per_sequence_t MBMS_SIBType5_SCCPCH_r6_sequence[] = {
  { &hf_umts_rrc_ies_sccpchIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_SCCPCHIdentity },
  { &hf_umts_rrc_ies_transpCHInformation2, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TrCHInformation_SIB5List },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_SIBType5_SCCPCH_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_SIBType5_SCCPCH_r6, MBMS_SIBType5_SCCPCH_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_SIBType5_SCCPCHList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_SIBType5_SCCPCH_r6 },
};

int
dissect_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6, MBMS_SIBType5_SCCPCHList_r6_sequence_of,
                                                  1, maxSCCPCH);

  return offset;
}


static const per_sequence_t MBMS_TimersAndCouneters_r6_sequence[] = {
  { &hf_umts_rrc_ies_t_318  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_T_318 },
  { NULL, 0, 0, NULL }
};

int
dissect_umts_rrc_ies_MBMS_TimersAndCouneters_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TimersAndCouneters_r6, MBMS_TimersAndCouneters_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_TranspChInfoForCCTrCh_r6_sequence[] = {
  { &hf_umts_rrc_ies_commonCCTrChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonCCTrChIdentity },
  { &hf_umts_rrc_ies_transportFormatCombinationSet, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_TFCS },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_TranspChInfoForCCTrCh_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TranspChInfoForCCTrCh_r6, MBMS_TranspChInfoForCCTrCh_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_TranspChInfoForEachCCTrCh_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TranspChInfoForCCTrCh_r6 },
};

int
dissect_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6, MBMS_TranspChInfoForEachCCTrCh_r6_sequence_of,
                                                  1, maxMBMSCommonCCTrCh);

  return offset;
}


static const per_sequence_t MBMS_TranspChInfoForTrCh_r6_sequence[] = {
  { &hf_umts_rrc_ies_commonTrChIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_CommonTrChIdentity },
  { &hf_umts_rrc_ies_transportFormatSet, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_TransportFormatSet },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_TranspChInfoForTrCh_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_TranspChInfoForTrCh_r6, MBMS_TranspChInfoForTrCh_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_TranspChInfoForEachTrCh_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TranspChInfoForTrCh_r6 },
};

int
dissect_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6, MBMS_TranspChInfoForEachTrCh_r6_sequence_of,
                                                  1, maxMBMSCommonTrCh);

  return offset;
}


static const per_sequence_t MBMS_UnmodifiedService_r6_sequence[] = {
  { &hf_umts_rrc_ies_mbms_TransmissionIdentity, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_TransmissionIdentity },
  { &hf_umts_rrc_ies_mbms_RequiredUEAction1, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_RequiredUEAction_UMod },
  { &hf_umts_rrc_ies_mbms_PreferredFrequency1, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_umts_rrc_ies_MBMS_PFLIndex },
  { NULL, 0, 0, NULL }
};

static int
dissect_umts_rrc_ies_MBMS_UnmodifiedService_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_umts_rrc_ies_MBMS_UnmodifiedService_r6, MBMS_UnmodifiedService_r6_sequence);

  return offset;
}


static const per_sequence_t MBMS_UnmodifiedServiceList_r6_sequence_of[1] = {
  { &hf_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_umts_rrc_ies_MBMS_UnmodifiedService_r6 },
};

int
dissect_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6(tvbuff_t *tvb, int offset, asn1_ctx_t *actx _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6, MBMS_UnmodifiedServiceList_r6_sequence_of,
                                                  1, maxMBMSservUnmodif);

  return offset;
}


/*--- End of included file: packet-umts_rrc_ies-fn.c ---*/
#line 66 "packet-umts_rrc_ies-template.c"


static void
dissect_umts_rrc_ies(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree)
{
	/* 
	 * Dummy function, currently not used
	 */

}
/*--- proto_register_umts_rrc_ies -------------------------------------------*/
void proto_register_umts_rrc_ies(void) {

  /* List of fields */
  static hf_register_info hf[] = {


/*--- Included file: packet-umts_rrc_ies-hfarr.c ---*/
#line 1 "packet-umts_rrc_ies-hfarr.c"
    { &hf_umts_rrc_ies_cn_DomainIdentity,
      { "cn-DomainIdentity", "umts_rrc_ies.cn_DomainIdentity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CN_DomainIdentity_vals), 0,
        "umts_rrc_ies.CN_DomainIdentity", HFILL }},
    { &hf_umts_rrc_ies_cn_DomainSpecificNAS_Info,
      { "cn-DomainSpecificNAS-Info", "umts_rrc_ies.cn_DomainSpecificNAS_Info",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NAS_SystemInformationGSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_cn_DRX_CycleLengthCoeff,
      { "cn-DRX-CycleLengthCoeff", "umts_rrc_ies.cn_DRX_CycleLengthCoeff",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CN_DRX_CycleLengthCoefficient", HFILL }},
    { &hf_umts_rrc_ies_CN_DomainInformationList_item,
      { "Item", "umts_rrc_ies.CN_DomainInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CN_DomainInformation", HFILL }},
    { &hf_umts_rrc_ies_CN_DomainInformationListFull_item,
      { "Item", "umts_rrc_ies.CN_DomainInformationListFull_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CN_DomainInformationFull", HFILL }},
    { &hf_umts_rrc_ies_cn_Type,
      { "cn-Type", "umts_rrc_ies.cn_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cn_Type_vals), 0,
        "umts_rrc_ies.T_cn_Type", HFILL }},
    { &hf_umts_rrc_ies_gsm_MAP,
      { "gsm-MAP", "umts_rrc_ies.gsm_MAP",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NAS_SystemInformationGSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_ansi_41,
      { "ansi-41", "umts_rrc_ies.ansi_41",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NAS_SystemInformationANSI_41", HFILL }},
    { &hf_umts_rrc_ies_CN_DomainSysInfoList_item,
      { "Item", "umts_rrc_ies.CN_DomainSysInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CN_DomainSysInfo", HFILL }},
    { &hf_umts_rrc_ies_plmn_Identity,
      { "plmn-Identity", "umts_rrc_ies.plmn_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMN_Identity", HFILL }},
    { &hf_umts_rrc_ies_cn_CommonGSM_MAP_NAS_SysInfo,
      { "cn-CommonGSM-MAP-NAS-SysInfo", "umts_rrc_ies.cn_CommonGSM_MAP_NAS_SysInfo",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NAS_SystemInformationGSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_cn_DomainInformationList,
      { "cn-DomainInformationList", "umts_rrc_ies.cn_DomainInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CN_DomainInformationList", HFILL }},
    { &hf_umts_rrc_ies_primary_plmn_Identity,
      { "primary-plmn-Identity", "umts_rrc_ies.primary_plmn_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMN_Identity", HFILL }},
    { &hf_umts_rrc_ies_cn_DomainInformationListFull,
      { "cn-DomainInformationListFull", "umts_rrc_ies.cn_DomainInformationListFull",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CN_DomainInformationListFull", HFILL }},
    { &hf_umts_rrc_ies_routingbasis,
      { "routingbasis", "umts_rrc_ies.routingbasis",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_routingbasis_vals), 0,
        "umts_rrc_ies.T_routingbasis", HFILL }},
    { &hf_umts_rrc_ies_localPTMSI,
      { "localPTMSI", "umts_rrc_ies.localPTMSI",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_localPTMSI", HFILL }},
    { &hf_umts_rrc_ies_routingparameter,
      { "routingparameter", "umts_rrc_ies.routingparameter",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.RoutingParameter", HFILL }},
    { &hf_umts_rrc_ies_tMSIofsamePLMN,
      { "tMSIofsamePLMN", "umts_rrc_ies.tMSIofsamePLMN",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tMSIofsamePLMN", HFILL }},
    { &hf_umts_rrc_ies_tMSIofdifferentPLMN,
      { "tMSIofdifferentPLMN", "umts_rrc_ies.tMSIofdifferentPLMN",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tMSIofdifferentPLMN", HFILL }},
    { &hf_umts_rrc_ies_iMSIresponsetopaging,
      { "iMSIresponsetopaging", "umts_rrc_ies.iMSIresponsetopaging",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_iMSIresponsetopaging", HFILL }},
    { &hf_umts_rrc_ies_iMSIcauseUEinitiatedEvent,
      { "iMSIcauseUEinitiatedEvent", "umts_rrc_ies.iMSIcauseUEinitiatedEvent",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_iMSIcauseUEinitiatedEvent", HFILL }},
    { &hf_umts_rrc_ies_iMEI,
      { "iMEI", "umts_rrc_ies.iMEI",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_iMEI", HFILL }},
    { &hf_umts_rrc_ies_spare2,
      { "spare2", "umts_rrc_ies.spare2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_spare2", HFILL }},
    { &hf_umts_rrc_ies_spare1,
      { "spare1", "umts_rrc_ies.spare1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_spare1", HFILL }},
    { &hf_umts_rrc_ies_dummy_BOOLEAN,
      { "dummy-BOOLEAN", "umts_rrc_ies.dummy_BOOLEAN",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_IMEI_item,
      { "Item", "umts_rrc_ies.IMEI_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IMEI_Digit", HFILL }},
    { &hf_umts_rrc_ies_IMSI_GSM_MAP_item,
      { "Item", "umts_rrc_ies.IMSI_GSM_MAP_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Digit", HFILL }},
    { &hf_umts_rrc_ies_version,
      { "version", "umts_rrc_ies.version",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_version_vals), 0,
        "umts_rrc_ies.T_version", HFILL }},
    { &hf_umts_rrc_ies_release99,
      { "release99", "umts_rrc_ies.release99",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_release99", HFILL }},
    { &hf_umts_rrc_ies_cn_Type1,
      { "cn-Type", "umts_rrc_ies.cn_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cn_Type1_vals), 0,
        "umts_rrc_ies.T_cn_Type1", HFILL }},
    { &hf_umts_rrc_ies_gsm_Map_IDNNS,
      { "gsm-Map-IDNNS", "umts_rrc_ies.gsm_Map_IDNNS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Gsm_map_IDNNS", HFILL }},
    { &hf_umts_rrc_ies_ansi_41_IDNNS,
      { "ansi-41-IDNNS", "umts_rrc_ies.ansi_41_IDNNS",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.Ansi_41_IDNNS", HFILL }},
    { &hf_umts_rrc_ies_later,
      { "later", "umts_rrc_ies.later",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_later", HFILL }},
    { &hf_umts_rrc_ies_futurecoding,
      { "futurecoding", "umts_rrc_ies.futurecoding",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_15", HFILL }},
    { &hf_umts_rrc_ies_lac,
      { "lac", "umts_rrc_ies.lac",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_MCC_item,
      { "Item", "umts_rrc_ies.MCC_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Digit", HFILL }},
    { &hf_umts_rrc_ies_MNC_item,
      { "Item", "umts_rrc_ies.MNC_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Digit", HFILL }},
    { &hf_umts_rrc_ies_mibPLMN_Identity,
      { "mibPLMN-Identity", "umts_rrc_ies.mibPLMN_Identity",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_multiplePLMNs,
      { "multiplePLMNs", "umts_rrc_ies.multiplePLMNs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6", HFILL }},
    { &hf_umts_rrc_ies_multiplePLMNs_item,
      { "Item", "umts_rrc_ies.multiplePLMNs_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMN_IdentityWithOptionalMCC_r6", HFILL }},
    { &hf_umts_rrc_ies_mcc,
      { "mcc", "umts_rrc_ies.mcc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MCC", HFILL }},
    { &hf_umts_rrc_ies_mnc,
      { "mnc", "umts_rrc_ies.mnc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MNC", HFILL }},
    { &hf_umts_rrc_ies_gsm_MAP1,
      { "gsm-MAP", "umts_rrc_ies.gsm_MAP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm_MAP", HFILL }},
    { &hf_umts_rrc_ies_ansi_411,
      { "ansi-41", "umts_rrc_ies.ansi_41",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ansi_41", HFILL }},
    { &hf_umts_rrc_ies_p_REV,
      { "p-REV", "umts_rrc_ies.p_REV",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.P_REV", HFILL }},
    { &hf_umts_rrc_ies_min_P_REV,
      { "min-P-REV", "umts_rrc_ies.min_P_REV",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.Min_P_REV", HFILL }},
    { &hf_umts_rrc_ies_sid,
      { "sid", "umts_rrc_ies.sid",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.SID", HFILL }},
    { &hf_umts_rrc_ies_nid,
      { "nid", "umts_rrc_ies.nid",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NID", HFILL }},
    { &hf_umts_rrc_ies_gsm_MAP_and_ANSI_41,
      { "gsm-MAP-and-ANSI-41", "umts_rrc_ies.gsm_MAP_and_ANSI_41",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm_MAP_and_ANSI_41", HFILL }},
    { &hf_umts_rrc_ies_spare,
      { "spare", "umts_rrc_ies.spare",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_gsm_MAP_RAB_Identity,
      { "gsm-MAP-RAB-Identity", "umts_rrc_ies.gsm_MAP_RAB_Identity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_ansi_41_RAB_Identity,
      { "ansi-41-RAB-Identity", "umts_rrc_ies.ansi_41_RAB_Identity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_lai,
      { "lai", "umts_rrc_ies.lai",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.LAI", HFILL }},
    { &hf_umts_rrc_ies_rac,
      { "rac", "umts_rrc_ies.rac",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.RoutingAreaCode", HFILL }},
    { &hf_umts_rrc_ies_AccessClassBarredList_item,
      { "Item", "umts_rrc_ies.AccessClassBarredList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AccessClassBarred_vals), 0,
        "umts_rrc_ies.AccessClassBarred", HFILL }},
    { &hf_umts_rrc_ies_cellBarred,
      { "cellBarred", "umts_rrc_ies.cellBarred",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CellBarred_vals), 0,
        "umts_rrc_ies.CellBarred", HFILL }},
    { &hf_umts_rrc_ies_cellReservedForOperatorUse,
      { "cellReservedForOperatorUse", "umts_rrc_ies.cellReservedForOperatorUse",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReservedIndicator_vals), 0,
        "umts_rrc_ies.ReservedIndicator", HFILL }},
    { &hf_umts_rrc_ies_cellReservationExtension,
      { "cellReservationExtension", "umts_rrc_ies.cellReservationExtension",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReservedIndicator_vals), 0,
        "umts_rrc_ies.ReservedIndicator", HFILL }},
    { &hf_umts_rrc_ies_accessClassBarredList,
      { "accessClassBarredList", "umts_rrc_ies.accessClassBarredList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AccessClassBarredList", HFILL }},
    { &hf_umts_rrc_ies_barred,
      { "barred", "umts_rrc_ies.barred",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_barred", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellReselectionInd,
      { "intraFreqCellReselectionInd", "umts_rrc_ies.intraFreqCellReselectionInd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AllowedIndicator_vals), 0,
        "umts_rrc_ies.AllowedIndicator", HFILL }},
    { &hf_umts_rrc_ies_t_Barred,
      { "t-Barred", "umts_rrc_ies.t_Barred",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_Barred_vals), 0,
        "umts_rrc_ies.T_Barred", HFILL }},
    { &hf_umts_rrc_ies_notBarred,
      { "notBarred", "umts_rrc_ies.notBarred",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_CellIdentity_PerRL_List_item,
      { "Item", "umts_rrc_ies.CellIdentity_PerRL_List_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.CellIdentity", HFILL }},
    { &hf_umts_rrc_ies_mappingInfo,
      { "mappingInfo", "umts_rrc_ies.mappingInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MappingInfo", HFILL }},
    { &hf_umts_rrc_ies_cellSelectQualityMeasure,
      { "cellSelectQualityMeasure", "umts_rrc_ies.cellSelectQualityMeasure",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cellSelectQualityMeasure_vals), 0,
        "umts_rrc_ies.T_cellSelectQualityMeasure", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N0,
      { "cpich-Ec-N0", "umts_rrc_ies.cpich_Ec_N0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_Ec_N0", HFILL }},
    { &hf_umts_rrc_ies_q_HYST_2_S,
      { "q-HYST-2-S", "umts_rrc_ies.q_HYST_2_S",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_Hyst_S", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP,
      { "cpich-RSCP", "umts_rrc_ies.cpich_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_fdd,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd", HFILL }},
    { &hf_umts_rrc_ies_s_Intrasearch,
      { "s-Intrasearch", "umts_rrc_ies.s_Intrasearch",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchQual", HFILL }},
    { &hf_umts_rrc_ies_s_Intersearch,
      { "s-Intersearch", "umts_rrc_ies.s_Intersearch",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchQual", HFILL }},
    { &hf_umts_rrc_ies_s_SearchHCS,
      { "s-SearchHCS", "umts_rrc_ies.s_SearchHCS",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchRXLEV", HFILL }},
    { &hf_umts_rrc_ies_rat_List,
      { "rat-List", "umts_rrc_ies.rat_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RAT_FDD_InfoList", HFILL }},
    { &hf_umts_rrc_ies_q_QualMin,
      { "q-QualMin", "umts_rrc_ies.q_QualMin",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_QualMin", HFILL }},
    { &hf_umts_rrc_ies_q_RxlevMin,
      { "q-RxlevMin", "umts_rrc_ies.q_RxlevMin",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_RxlevMin", HFILL }},
    { &hf_umts_rrc_ies_tdd,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd", HFILL }},
    { &hf_umts_rrc_ies_s_Intrasearch1,
      { "s-Intrasearch", "umts_rrc_ies.s_Intrasearch",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchRXLEV", HFILL }},
    { &hf_umts_rrc_ies_s_Intersearch1,
      { "s-Intersearch", "umts_rrc_ies.s_Intersearch",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchRXLEV", HFILL }},
    { &hf_umts_rrc_ies_rat_List1,
      { "rat-List", "umts_rrc_ies.rat_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RAT_TDD_InfoList", HFILL }},
    { &hf_umts_rrc_ies_q_Hyst_l_S,
      { "q-Hyst-l-S", "umts_rrc_ies.q_Hyst_l_S",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_Hyst_S", HFILL }},
    { &hf_umts_rrc_ies_t_Reselection_S,
      { "t-Reselection-S", "umts_rrc_ies.t_Reselection_S",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_Reselection_S", HFILL }},
    { &hf_umts_rrc_ies_hcs_ServingCellInformation,
      { "hcs-ServingCellInformation", "umts_rrc_ies.hcs_ServingCellInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HCS_ServingCellInformation", HFILL }},
    { &hf_umts_rrc_ies_maxAllowedUL_TX_Power,
      { "maxAllowedUL-TX-Power", "umts_rrc_ies.maxAllowedUL_TX_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxAllowedUL_TX_Power", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestictionList,
      { "domainSpecificAccessRestictionList", "umts_rrc_ies.domainSpecificAccessRestictionList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionList_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestictionParametersForAll,
      { "domainSpecificAccessRestictionParametersForAll", "umts_rrc_ies.domainSpecificAccessRestictionParametersForAll",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator1,
      { "domainSpecificAccessRestrictionParametersForOperator1", "umts_rrc_ies.domainSpecificAccessRestrictionParametersForOperator1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator2,
      { "domainSpecificAccessRestrictionParametersForOperator2", "umts_rrc_ies.domainSpecificAccessRestrictionParametersForOperator2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator3,
      { "domainSpecificAccessRestrictionParametersForOperator3", "umts_rrc_ies.domainSpecificAccessRestrictionParametersForOperator3",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator4,
      { "domainSpecificAccessRestrictionParametersForOperator4", "umts_rrc_ies.domainSpecificAccessRestrictionParametersForOperator4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForOperator5,
      { "domainSpecificAccessRestrictionParametersForOperator5", "umts_rrc_ies.domainSpecificAccessRestrictionParametersForOperator5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_cSDomainSpecificAccessRestriction,
      { "cSDomainSpecificAccessRestriction", "umts_rrc_ies.cSDomainSpecificAccessRestriction",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DomainSpecificAccessRestriction_v670ext_vals), 0,
        "umts_rrc_ies.DomainSpecificAccessRestriction_v670ext", HFILL }},
    { &hf_umts_rrc_ies_pSDomainSpecificAccessRestriction,
      { "pSDomainSpecificAccessRestriction", "umts_rrc_ies.pSDomainSpecificAccessRestriction",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DomainSpecificAccessRestriction_v670ext_vals), 0,
        "umts_rrc_ies.DomainSpecificAccessRestriction_v670ext", HFILL }},
    { &hf_umts_rrc_ies_noRestriction,
      { "noRestriction", "umts_rrc_ies.noRestriction",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_restriction,
      { "restriction", "umts_rrc_ies.restriction",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_restriction", HFILL }},
    { &hf_umts_rrc_ies_domainSpecficAccessClassBarredList,
      { "domainSpecficAccessClassBarredList", "umts_rrc_ies.domainSpecficAccessClassBarredList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AccessClassBarredList", HFILL }},
    { &hf_umts_rrc_ies_rat,
      { "rat", "umts_rrc_ies.rat",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RAT_vals), 0,
        "umts_rrc_ies.RAT", HFILL }},
    { &hf_umts_rrc_ies_mappingFunctionParameterList,
      { "mappingFunctionParameterList", "umts_rrc_ies.mappingFunctionParameterList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MappingFunctionParameterList", HFILL }},
    { &hf_umts_rrc_ies_functionType,
      { "functionType", "umts_rrc_ies.functionType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MappingFunctionType_vals), 0,
        "umts_rrc_ies.MappingFunctionType", HFILL }},
    { &hf_umts_rrc_ies_mapParameter1,
      { "mapParameter1", "umts_rrc_ies.mapParameter1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MapParameter", HFILL }},
    { &hf_umts_rrc_ies_mapParameter2,
      { "mapParameter2", "umts_rrc_ies.mapParameter2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MapParameter", HFILL }},
    { &hf_umts_rrc_ies_upperLimit,
      { "upperLimit", "umts_rrc_ies.upperLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UpperLimit", HFILL }},
    { &hf_umts_rrc_ies_MappingFunctionParameterList_item,
      { "Item", "umts_rrc_ies.MappingFunctionParameterList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MappingFunctionParameter", HFILL }},
    { &hf_umts_rrc_ies_MappingInfo_item,
      { "Item", "umts_rrc_ies.MappingInfo_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Mapping", HFILL }},
    { &hf_umts_rrc_ies_rat_Identifier,
      { "rat-Identifier", "umts_rrc_ies.rat_Identifier",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RAT_Identifier_vals), 0,
        "umts_rrc_ies.RAT_Identifier", HFILL }},
    { &hf_umts_rrc_ies_s_SearchRAT,
      { "s-SearchRAT", "umts_rrc_ies.s_SearchRAT",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchQual", HFILL }},
    { &hf_umts_rrc_ies_s_HCS_RAT,
      { "s-HCS-RAT", "umts_rrc_ies.s_HCS_RAT",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchRXLEV", HFILL }},
    { &hf_umts_rrc_ies_s_Limit_SearchRAT,
      { "s-Limit-SearchRAT", "umts_rrc_ies.s_Limit_SearchRAT",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchQual", HFILL }},
    { &hf_umts_rrc_ies_RAT_FDD_InfoList_item,
      { "Item", "umts_rrc_ies.RAT_FDD_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAT_FDD_Info", HFILL }},
    { &hf_umts_rrc_ies_s_SearchRAT1,
      { "s-SearchRAT", "umts_rrc_ies.s_SearchRAT",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchRXLEV", HFILL }},
    { &hf_umts_rrc_ies_s_Limit_SearchRAT1,
      { "s-Limit-SearchRAT", "umts_rrc_ies.s_Limit_SearchRAT",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.S_SearchRXLEV", HFILL }},
    { &hf_umts_rrc_ies_RAT_TDD_InfoList_item,
      { "Item", "umts_rrc_ies.RAT_TDD_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAT_TDD_Info", HFILL }},
    { &hf_umts_rrc_ies_URA_IdentityList_item,
      { "Item", "umts_rrc_ies.URA_IdentityList_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.URA_Identity", HFILL }},
    { &hf_umts_rrc_ies_n_AP_RetransMax,
      { "n-AP-RetransMax", "umts_rrc_ies.n_AP_RetransMax",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_AP_RetransMax", HFILL }},
    { &hf_umts_rrc_ies_n_AccessFails,
      { "n-AccessFails", "umts_rrc_ies.n_AccessFails",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_AccessFails", HFILL }},
    { &hf_umts_rrc_ies_nf_BO_NoAICH,
      { "nf-BO-NoAICH", "umts_rrc_ies.nf_BO_NoAICH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NF_BO_NoAICH", HFILL }},
    { &hf_umts_rrc_ies_ns_BO_Busy,
      { "ns-BO-Busy", "umts_rrc_ies.ns_BO_Busy",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NS_BO_Busy", HFILL }},
    { &hf_umts_rrc_ies_nf_BO_AllBusy,
      { "nf-BO-AllBusy", "umts_rrc_ies.nf_BO_AllBusy",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NF_BO_AllBusy", HFILL }},
    { &hf_umts_rrc_ies_nf_BO_Mismatch,
      { "nf-BO-Mismatch", "umts_rrc_ies.nf_BO_Mismatch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NF_BO_Mismatch", HFILL }},
    { &hf_umts_rrc_ies_t_CPCH,
      { "t-CPCH", "umts_rrc_ies.t_CPCH",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_CPCH_vals), 0,
        "umts_rrc_ies.T_CPCH", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement,
      { "ue-RadioCapabilityFDDUpdateRequirement", "umts_rrc_ies.ue_RadioCapabilityFDDUpdateRequirement",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement,
      { "ue-RadioCapabilityTDDUpdateRequirement", "umts_rrc_ies.ue_RadioCapabilityTDDUpdateRequirement",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_systemSpecificCapUpdateReqList,
      { "systemSpecificCapUpdateReqList", "umts_rrc_ies.systemSpecificCapUpdateReqList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SystemSpecificCapUpdateReqList", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioCapabilityUpdateRequirement_TDD128,
      { "ue-RadioCapabilityUpdateRequirement-TDD128", "umts_rrc_ies.ue_RadioCapabilityUpdateRequirement_TDD128",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioCapabilityFDDUpdateRequirement_FDD,
      { "ue-RadioCapabilityFDDUpdateRequirement-FDD", "umts_rrc_ies.ue_RadioCapabilityFDDUpdateRequirement_FDD",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD384,
      { "ue-RadioCapabilityTDDUpdateRequirement-TDD384", "umts_rrc_ies.ue_RadioCapabilityTDDUpdateRequirement_TDD384",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioCapabilityTDDUpdateRequirement_TDD128,
      { "ue-RadioCapabilityTDDUpdateRequirement-TDD128", "umts_rrc_ies.ue_RadioCapabilityTDDUpdateRequirement_TDD128",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_startRestart,
      { "startRestart", "umts_rrc_ies.startRestart",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CipheringAlgorithm_vals), 0,
        "umts_rrc_ies.CipheringAlgorithm", HFILL }},
    { &hf_umts_rrc_ies_dummy_NULL,
      { "dummy-NULL", "umts_rrc_ies.dummy_NULL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_cipheringModeCommand,
      { "cipheringModeCommand", "umts_rrc_ies.cipheringModeCommand",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CipheringModeCommand_vals), 0,
        "umts_rrc_ies.CipheringModeCommand", HFILL }},
    { &hf_umts_rrc_ies_activationTimeForDPCH,
      { "activationTimeForDPCH", "umts_rrc_ies.activationTimeForDPCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ActivationTime", HFILL }},
    { &hf_umts_rrc_ies_rb_DL_CiphActivationTimeInfo,
      { "rb-DL-CiphActivationTimeInfo", "umts_rrc_ies.rb_DL_CiphActivationTimeInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_ActivationTimeInfoList", HFILL }},
    { &hf_umts_rrc_ies_imsi_GSM_MAP,
      { "imsi-GSM-MAP", "umts_rrc_ies.imsi_GSM_MAP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IMSI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_tmsi_GSM_MAP,
      { "tmsi-GSM-MAP", "umts_rrc_ies.tmsi_GSM_MAP",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.TMSI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_p_TMSI_GSM_MAP,
      { "p-TMSI-GSM-MAP", "umts_rrc_ies.p_TMSI_GSM_MAP",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.P_TMSI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_imsi_DS_41,
      { "imsi-DS-41", "umts_rrc_ies.imsi_DS_41",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.IMSI_DS_41", HFILL }},
    { &hf_umts_rrc_ies_tmsi_DS_41,
      { "tmsi-DS-41", "umts_rrc_ies.tmsi_DS_41",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.TMSI_DS_41", HFILL }},
    { &hf_umts_rrc_ies_spare3,
      { "spare3", "umts_rrc_ies.spare3",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare21,
      { "spare2", "umts_rrc_ies.spare2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare11,
      { "spare1", "umts_rrc_ies.spare1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_fdd_Measurements,
      { "fdd-Measurements", "umts_rrc_ies.fdd_Measurements",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd_Measurements,
      { "tdd-Measurements", "umts_rrc_ies.tdd_Measurements",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_gsm_Measurements,
      { "gsm-Measurements", "umts_rrc_ies.gsm_Measurements",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GSM_Measurements", HFILL }},
    { &hf_umts_rrc_ies_multiCarrierMeasurements,
      { "multiCarrierMeasurements", "umts_rrc_ies.multiCarrierMeasurements",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd128_Measurements,
      { "tdd128-Measurements", "umts_rrc_ies.tdd128_Measurements",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_CompressedModeMeasCapabFDDList_item,
      { "Item", "umts_rrc_ies.CompressedModeMeasCapabFDDList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabFDD", HFILL }},
    { &hf_umts_rrc_ies_CompressedModeMeasCapabFDDList2_item,
      { "Item", "umts_rrc_ies.CompressedModeMeasCapabFDDList2_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabFDD2", HFILL }},
    { &hf_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext_item,
      { "Item", "umts_rrc_ies.CompressedModeMeasCapabFDDList_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabFDD_ext", HFILL }},
    { &hf_umts_rrc_ies_radioFrequencyBandFDD,
      { "radioFrequencyBandFDD", "umts_rrc_ies.radioFrequencyBandFDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandFDD_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandFDD", HFILL }},
    { &hf_umts_rrc_ies_dl_MeasurementsFDD,
      { "dl-MeasurementsFDD", "umts_rrc_ies.dl_MeasurementsFDD",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_MeasurementsFDD,
      { "ul-MeasurementsFDD", "umts_rrc_ies.ul_MeasurementsFDD",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_radioFrequencyBandFDD2,
      { "radioFrequencyBandFDD2", "umts_rrc_ies.radioFrequencyBandFDD2",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandFDD2_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandFDD2", HFILL }},
    { &hf_umts_rrc_ies_CompressedModeMeasCapabTDDList_item,
      { "Item", "umts_rrc_ies.CompressedModeMeasCapabTDDList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabTDD", HFILL }},
    { &hf_umts_rrc_ies_radioFrequencyBandTDD,
      { "radioFrequencyBandTDD", "umts_rrc_ies.radioFrequencyBandTDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandTDD_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandTDD", HFILL }},
    { &hf_umts_rrc_ies_dl_MeasurementsTDD,
      { "dl-MeasurementsTDD", "umts_rrc_ies.dl_MeasurementsTDD",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_MeasurementsTDD,
      { "ul-MeasurementsTDD", "umts_rrc_ies.ul_MeasurementsTDD",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_CompressedModeMeasCapabGSMList_item,
      { "Item", "umts_rrc_ies.CompressedModeMeasCapabGSMList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabGSM", HFILL }},
    { &hf_umts_rrc_ies_radioFrequencyBandGSM,
      { "radioFrequencyBandGSM", "umts_rrc_ies.radioFrequencyBandGSM",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandGSM_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandGSM", HFILL }},
    { &hf_umts_rrc_ies_dl_MeasurementsGSM,
      { "dl-MeasurementsGSM", "umts_rrc_ies.dl_MeasurementsGSM",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_MeasurementsGSM,
      { "ul-MeasurementsGSM", "umts_rrc_ies.ul_MeasurementsGSM",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dl_MeasurementsMC,
      { "dl-MeasurementsMC", "umts_rrc_ies.dl_MeasurementsMC",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_MeasurementsMC,
      { "ul-MeasurementsMC", "umts_rrc_ies.ul_MeasurementsMC",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_initialPriorityDelayList,
      { "initialPriorityDelayList", "umts_rrc_ies.initialPriorityDelayList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InitialPriorityDelayList", HFILL }},
    { &hf_umts_rrc_ies_backoffControlParams,
      { "backoffControlParams", "umts_rrc_ies.backoffControlParams",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.BackoffControlParams", HFILL }},
    { &hf_umts_rrc_ies_powerControlAlgorithm,
      { "powerControlAlgorithm", "umts_rrc_ies.powerControlAlgorithm",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PowerControlAlgorithm_vals), 0,
        "umts_rrc_ies.PowerControlAlgorithm", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCCH_BER,
      { "dl-DPCCH-BER", "umts_rrc_ies.dl_DPCCH_BER",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_DPCCH_BER", HFILL }},
    { &hf_umts_rrc_ies_maxNoDPCH_PDSCH_Codes,
      { "maxNoDPCH-PDSCH-Codes", "umts_rrc_ies.maxNoDPCH_PDSCH_Codes",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_8", HFILL }},
    { &hf_umts_rrc_ies_maxNoPhysChBitsReceived,
      { "maxNoPhysChBitsReceived", "umts_rrc_ies.maxNoPhysChBitsReceived",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoPhysChBitsReceived_vals), 0,
        "umts_rrc_ies.MaxNoPhysChBitsReceived", HFILL }},
    { &hf_umts_rrc_ies_supportForSF_512,
      { "supportForSF-512", "umts_rrc_ies.supportForSF_512",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dummy2_SimultaneousSCCPCH_DPCH_Reception,
      { "dummy2-SimultaneousSCCPCH-DPCH-Reception", "umts_rrc_ies.dummy2_SimultaneousSCCPCH_DPCH_Reception",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception_vals), 0,
        "umts_rrc_ies.SimultaneousSCCPCH_DPCH_Reception", HFILL }},
    { &hf_umts_rrc_ies_dummy_SupportOfDedicatedPilotsForChEstimation,
      { "dummy-SupportOfDedicatedPilotsForChEstimation", "umts_rrc_ies.dummy_SupportOfDedicatedPilotsForChEstimation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SupportOfDedicatedPilotsForChEstimation_vals), 0,
        "umts_rrc_ies.SupportOfDedicatedPilotsForChEstimation", HFILL }},
    { &hf_umts_rrc_ies_maxTS_PerFrame,
      { "maxTS-PerFrame", "umts_rrc_ies.maxTS_PerFrame",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxTS_PerFrame", HFILL }},
    { &hf_umts_rrc_ies_maxPhysChPerFrame,
      { "maxPhysChPerFrame", "umts_rrc_ies.maxPhysChPerFrame",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxPhysChPerFrame", HFILL }},
    { &hf_umts_rrc_ies_minimumSF,
      { "minimumSF", "umts_rrc_ies.minimumSF",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MinimumSF_DL_vals), 0,
        "umts_rrc_ies.MinimumSF_DL", HFILL }},
    { &hf_umts_rrc_ies_supportOfPDSCH,
      { "supportOfPDSCH", "umts_rrc_ies.supportOfPDSCH",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_maxPhysChPerTS,
      { "maxPhysChPerTS", "umts_rrc_ies.maxPhysChPerTS",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxPhysChPerTS", HFILL }},
    { &hf_umts_rrc_ies_maxTS_PerSubFrame,
      { "maxTS-PerSubFrame", "umts_rrc_ies.maxTS_PerSubFrame",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxTS_PerSubFrame_r4", HFILL }},
    { &hf_umts_rrc_ies_maxPhysChPerFrame1,
      { "maxPhysChPerFrame", "umts_rrc_ies.maxPhysChPerFrame",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxPhysChPerSubFrame_r4", HFILL }},
    { &hf_umts_rrc_ies_supportOf8PSK,
      { "supportOf8PSK", "umts_rrc_ies.supportOf8PSK",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_maxNoBitsReceived,
      { "maxNoBitsReceived", "umts_rrc_ies.maxNoBitsReceived",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoBits_vals), 0,
        "umts_rrc_ies.MaxNoBits", HFILL }},
    { &hf_umts_rrc_ies_maxConvCodeBitsReceived,
      { "maxConvCodeBitsReceived", "umts_rrc_ies.maxConvCodeBitsReceived",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoBits_vals), 0,
        "umts_rrc_ies.MaxNoBits", HFILL }},
    { &hf_umts_rrc_ies_turboDecodingSupport,
      { "turboDecodingSupport", "umts_rrc_ies.turboDecodingSupport",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TurboSupport_vals), 0,
        "umts_rrc_ies.TurboSupport", HFILL }},
    { &hf_umts_rrc_ies_maxSimultaneousTransChs,
      { "maxSimultaneousTransChs", "umts_rrc_ies.maxSimultaneousTransChs",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxSimultaneousTransChsDL_vals), 0,
        "umts_rrc_ies.MaxSimultaneousTransChsDL", HFILL }},
    { &hf_umts_rrc_ies_maxSimultaneousCCTrCH_Count,
      { "maxSimultaneousCCTrCH-Count", "umts_rrc_ies.maxSimultaneousCCTrCH_Count",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxSimultaneousCCTrCH_Count", HFILL }},
    { &hf_umts_rrc_ies_maxReceivedTransportBlocks,
      { "maxReceivedTransportBlocks", "umts_rrc_ies.maxReceivedTransportBlocks",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxTransportBlocksDL_vals), 0,
        "umts_rrc_ies.MaxTransportBlocksDL", HFILL }},
    { &hf_umts_rrc_ies_maxNumberOfTFC,
      { "maxNumberOfTFC", "umts_rrc_ies.maxNumberOfTFC",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfTFC_DL_vals), 0,
        "umts_rrc_ies.MaxNumberOfTFC_DL", HFILL }},
    { &hf_umts_rrc_ies_maxNumberOfTF,
      { "maxNumberOfTF", "umts_rrc_ies.maxNumberOfTF",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfTF_vals), 0,
        "umts_rrc_ies.MaxNumberOfTF", HFILL }},
    { &hf_umts_rrc_ies_transmissionProbability,
      { "transmissionProbability", "umts_rrc_ies.transmissionProbability",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransmissionProbability", HFILL }},
    { &hf_umts_rrc_ies_maximumBitRate,
      { "maximumBitRate", "umts_rrc_ies.maximumBitRate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaximumBitRate", HFILL }},
    { &hf_umts_rrc_ies_DRAC_SysInfoList_item,
      { "Item", "umts_rrc_ies.DRAC_SysInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DRAC_SysInfo", HFILL }},
    { &hf_umts_rrc_ies_configurationUnsupported,
      { "configurationUnsupported", "umts_rrc_ies.configurationUnsupported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_physicalChannelFailure,
      { "physicalChannelFailure", "umts_rrc_ies.physicalChannelFailure",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_incompatibleSimultaneousReconfiguration,
      { "incompatibleSimultaneousReconfiguration", "umts_rrc_ies.incompatibleSimultaneousReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_compressedModeRuntimeError,
      { "compressedModeRuntimeError", "umts_rrc_ies.compressedModeRuntimeError",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGPSI", HFILL }},
    { &hf_umts_rrc_ies_protocolError,
      { "protocolError", "umts_rrc_ies.protocolError",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ProtocolErrorInformation", HFILL }},
    { &hf_umts_rrc_ies_cellUpdateOccurred,
      { "cellUpdateOccurred", "umts_rrc_ies.cellUpdateOccurred",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_invalidConfiguration,
      { "invalidConfiguration", "umts_rrc_ies.invalidConfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_configurationIncomplete,
      { "configurationIncomplete", "umts_rrc_ies.configurationIncomplete",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_unsupportedMeasurement,
      { "unsupportedMeasurement", "umts_rrc_ies.unsupportedMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_mbmsSessionAlreadyReceivedCorrectly,
      { "mbmsSessionAlreadyReceivedCorrectly", "umts_rrc_ies.mbmsSessionAlreadyReceivedCorrectly",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_lowerPriorityMBMSService,
      { "lowerPriorityMBMSService", "umts_rrc_ies.lowerPriorityMBMSService",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare5,
      { "spare5", "umts_rrc_ies.spare5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare4,
      { "spare4", "umts_rrc_ies.spare4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_rrc_TransactionIdentifier,
      { "rrc-TransactionIdentifier", "umts_rrc_ies.rrc_TransactionIdentifier",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RRC_TransactionIdentifier", HFILL }},
    { &hf_umts_rrc_ies_failureCause,
      { "failureCause", "umts_rrc_ies.failureCause",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_FailureCauseWithProtErr_vals), 0,
        "umts_rrc_ies.FailureCauseWithProtErr", HFILL }},
    { &hf_umts_rrc_ies_rrc_ConnectionReleaseInformation,
      { "rrc-ConnectionReleaseInformation", "umts_rrc_ies.rrc_ConnectionReleaseInformation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RRC_ConnectionReleaseInformation_vals), 0,
        "umts_rrc_ies.RRC_ConnectionReleaseInformation", HFILL }},
    { &hf_umts_rrc_ies_groupReleaseInformation,
      { "groupReleaseInformation", "umts_rrc_ies.groupReleaseInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GroupReleaseInformation", HFILL }},
    { &hf_umts_rrc_ies_uRNTI_Group,
      { "uRNTI-Group", "umts_rrc_ies.uRNTI_Group",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_U_RNTI_Group_vals), 0,
        "umts_rrc_ies.U_RNTI_Group", HFILL }},
    { &hf_umts_rrc_ies_gsm900,
      { "gsm900", "umts_rrc_ies.gsm900",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dcs1800,
      { "dcs1800", "umts_rrc_ies.dcs1800",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_gsm1900,
      { "gsm1900", "umts_rrc_ies.gsm1900",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_esn_DS_41,
      { "esn-DS-41", "umts_rrc_ies.esn_DS_41",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.ESN_DS_41", HFILL }},
    { &hf_umts_rrc_ies_InitialPriorityDelayList_item,
      { "Item", "umts_rrc_ies.InitialPriorityDelayList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NS_IP", HFILL }},
    { &hf_umts_rrc_ies_imsi,
      { "imsi", "umts_rrc_ies.imsi",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IMSI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_tmsi_and_LAI,
      { "tmsi-and-LAI", "umts_rrc_ies.tmsi_and_LAI",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TMSI_and_LAI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_p_TMSI_and_RAI,
      { "p-TMSI-and-RAI", "umts_rrc_ies.p_TMSI_and_RAI",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.P_TMSI_and_RAI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_imei,
      { "imei", "umts_rrc_ies.imei",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IMEI", HFILL }},
    { &hf_umts_rrc_ies_imsi_and_ESN_DS_41,
      { "imsi-and-ESN-DS-41", "umts_rrc_ies.imsi_and_ESN_DS_41",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IMSI_and_ESN_DS_41", HFILL }},
    { &hf_umts_rrc_ies_messageAuthenticationCode,
      { "messageAuthenticationCode", "umts_rrc_ies.messageAuthenticationCode",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.MessageAuthenticationCode", HFILL }},
    { &hf_umts_rrc_ies_rrc_MessageSequenceNumber,
      { "rrc-MessageSequenceNumber", "umts_rrc_ies.rrc_MessageSequenceNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RRC_MessageSequenceNumber", HFILL }},
    { &hf_umts_rrc_ies_rrc_MessageSequenceNumberList,
      { "rrc-MessageSequenceNumberList", "umts_rrc_ies.rrc_MessageSequenceNumberList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RRC_MessageSequenceNumberList", HFILL }},
    { &hf_umts_rrc_ies_startIntegrityProtection,
      { "startIntegrityProtection", "umts_rrc_ies.startIntegrityProtection",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_startIntegrityProtection", HFILL }},
    { &hf_umts_rrc_ies_integrityProtInitNumber,
      { "integrityProtInitNumber", "umts_rrc_ies.integrityProtInitNumber",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.IntegrityProtInitNumber", HFILL }},
    { &hf_umts_rrc_ies_modify,
      { "modify", "umts_rrc_ies.modify",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_modify", HFILL }},
    { &hf_umts_rrc_ies_dl_IntegrityProtActivationInfo,
      { "dl-IntegrityProtActivationInfo", "umts_rrc_ies.dl_IntegrityProtActivationInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntegrityProtActivationInfo", HFILL }},
    { &hf_umts_rrc_ies_integrityProtectionModeCommand,
      { "integrityProtectionModeCommand", "umts_rrc_ies.integrityProtectionModeCommand",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntegrityProtectionModeCommand_vals), 0,
        "umts_rrc_ies.IntegrityProtectionModeCommand", HFILL }},
    { &hf_umts_rrc_ies_integrityProtectionAlgorithm,
      { "integrityProtectionAlgorithm", "umts_rrc_ies.integrityProtectionAlgorithm",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntegrityProtectionAlgorithm_vals), 0,
        "umts_rrc_ies.IntegrityProtectionAlgorithm", HFILL }},
    { &hf_umts_rrc_ies_downlinkCompressedMode,
      { "downlinkCompressedMode", "umts_rrc_ies.downlinkCompressedMode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapability", HFILL }},
    { &hf_umts_rrc_ies_uplinkCompressedMode,
      { "uplinkCompressedMode", "umts_rrc_ies.uplinkCompressedMode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapability", HFILL }},
    { &hf_umts_rrc_ies_compressedModeMeasCapabFDDList,
      { "compressedModeMeasCapabFDDList", "umts_rrc_ies.compressedModeMeasCapabFDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabFDDList", HFILL }},
    { &hf_umts_rrc_ies_compressedModeMeasCapabTDDList,
      { "compressedModeMeasCapabTDDList", "umts_rrc_ies.compressedModeMeasCapabTDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabTDDList", HFILL }},
    { &hf_umts_rrc_ies_compressedModeMeasCapabGSMList,
      { "compressedModeMeasCapabGSMList", "umts_rrc_ies.compressedModeMeasCapabGSMList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabGSMList", HFILL }},
    { &hf_umts_rrc_ies_compressedModeMeasCapabMC,
      { "compressedModeMeasCapabMC", "umts_rrc_ies.compressedModeMeasCapabMC",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabMC", HFILL }},
    { &hf_umts_rrc_ies_compressedModeMeasCapabFDDList1,
      { "compressedModeMeasCapabFDDList", "umts_rrc_ies.compressedModeMeasCapabFDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabFDDList2", HFILL }},
    { &hf_umts_rrc_ies_downlinkCompressedMode_LCR,
      { "downlinkCompressedMode-LCR", "umts_rrc_ies.downlinkCompressedMode_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapability_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_uplinkCompressedMode_LCR,
      { "uplinkCompressedMode-LCR", "umts_rrc_ies.uplinkCompressedMode_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapability_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_supportOfGSM,
      { "supportOfGSM", "umts_rrc_ies.supportOfGSM",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_supportOfMulticarrier,
      { "supportOfMulticarrier", "umts_rrc_ies.supportOfMulticarrier",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_supportOfUTRAN_ToGERAN_NACC,
      { "supportOfUTRAN-ToGERAN-NACC", "umts_rrc_ies.supportOfUTRAN_ToGERAN_NACC",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_p_TMSI,
      { "p-TMSI", "umts_rrc_ies.p_TMSI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.P_TMSI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_rai,
      { "rai", "umts_rrc_ies.rai",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAI", HFILL }},
    { &hf_umts_rrc_ies_cn_Identity,
      { "cn-Identity", "umts_rrc_ies.cn_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cn_Identity", HFILL }},
    { &hf_umts_rrc_ies_pagingCause,
      { "pagingCause", "umts_rrc_ies.pagingCause",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PagingCause_vals), 0,
        "umts_rrc_ies.PagingCause", HFILL }},
    { &hf_umts_rrc_ies_cn_pagedUE_Identity,
      { "cn-pagedUE-Identity", "umts_rrc_ies.cn_pagedUE_Identity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CN_PagedUE_Identity_vals), 0,
        "umts_rrc_ies.CN_PagedUE_Identity", HFILL }},
    { &hf_umts_rrc_ies_utran_Identity,
      { "utran-Identity", "umts_rrc_ies.utran_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_utran_Identity", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI,
      { "u-RNTI", "umts_rrc_ies.u_RNTI",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.U_RNTI", HFILL }},
    { &hf_umts_rrc_ies_cn_OriginatedPage_connectedMode_UE,
      { "cn-OriginatedPage-connectedMode-UE", "umts_rrc_ies.cn_OriginatedPage_connectedMode_UE",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cn_OriginatedPage_connectedMode_UE", HFILL }},
    { &hf_umts_rrc_ies_pagingRecordTypeID,
      { "pagingRecordTypeID", "umts_rrc_ies.pagingRecordTypeID",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PagingRecordTypeID_vals), 0,
        "umts_rrc_ies.PagingRecordTypeID", HFILL }},
    { &hf_umts_rrc_ies_utran_SingleUE_Identity,
      { "utran-SingleUE-Identity", "umts_rrc_ies.utran_SingleUE_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_utran_SingleUE_Identity", HFILL }},
    { &hf_umts_rrc_ies_cn_OriginatedPage_connectedMode_UE1,
      { "cn-OriginatedPage-connectedMode-UE", "umts_rrc_ies.cn_OriginatedPage_connectedMode_UE",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cn_OriginatedPage_connectedMode_UE1", HFILL }},
    { &hf_umts_rrc_ies_utran_GroupIdentity,
      { "utran-GroupIdentity", "umts_rrc_ies.utran_GroupIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation", HFILL }},
    { &hf_umts_rrc_ies_utran_GroupIdentity_item,
      { "Item", "umts_rrc_ies.utran_GroupIdentity_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GroupIdentityWithReleaseInformation", HFILL }},
    { &hf_umts_rrc_ies_PagingRecordList_item,
      { "Item", "umts_rrc_ies.PagingRecordList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PagingRecord_vals), 0,
        "umts_rrc_ies.PagingRecord", HFILL }},
    { &hf_umts_rrc_ies_PagingRecord2List_r5_item,
      { "Item", "umts_rrc_ies.PagingRecord2List_r5_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PagingRecord2_r5_vals), 0,
        "umts_rrc_ies.PagingRecord2_r5", HFILL }},
    { &hf_umts_rrc_ies_losslessSRNS_RelocationSupport,
      { "losslessSRNS-RelocationSupport", "umts_rrc_ies.losslessSRNS_RelocationSupport",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_supportForRfc2507,
      { "supportForRfc2507", "umts_rrc_ies.supportForRfc2507",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_supportForRfc2507_vals), 0,
        "umts_rrc_ies.T_supportForRfc2507", HFILL }},
    { &hf_umts_rrc_ies_notSupported,
      { "notSupported", "umts_rrc_ies.notSupported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_supported,
      { "supported", "umts_rrc_ies.supported",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxHcContextSpace_vals), 0,
        "umts_rrc_ies.MaxHcContextSpace", HFILL }},
    { &hf_umts_rrc_ies_supportForRfc3095,
      { "supportForRfc3095", "umts_rrc_ies.supportForRfc3095",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_supportForRfc3095_vals), 0,
        "umts_rrc_ies.T_supportForRfc3095", HFILL }},
    { &hf_umts_rrc_ies_supported1,
      { "supported", "umts_rrc_ies.supported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_supported", HFILL }},
    { &hf_umts_rrc_ies_maxROHC_ContextSessions,
      { "maxROHC-ContextSessions", "umts_rrc_ies.maxROHC_ContextSessions",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxROHC_ContextSessions_r4_vals), 0,
        "umts_rrc_ies.MaxROHC_ContextSessions_r4", HFILL }},
    { &hf_umts_rrc_ies_reverseCompressionDepth,
      { "reverseCompressionDepth", "umts_rrc_ies.reverseCompressionDepth",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_65535", HFILL }},
    { &hf_umts_rrc_ies_supportForRfc3095ContextRelocation,
      { "supportForRfc3095ContextRelocation", "umts_rrc_ies.supportForRfc3095ContextRelocation",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_maxHcContextSpace,
      { "maxHcContextSpace", "umts_rrc_ies.maxHcContextSpace",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxHcContextSpace_r5_ext_vals), 0,
        "umts_rrc_ies.MaxHcContextSpace_r5_ext", HFILL }},
    { &hf_umts_rrc_ies_losslessDLRLC_PDUSizeChange,
      { "losslessDLRLC-PDUSizeChange", "umts_rrc_ies.losslessDLRLC_PDUSizeChange",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_losslessDLRLC_PDUSizeChange_vals), 0,
        "umts_rrc_ies.T_losslessDLRLC_PDUSizeChange", HFILL }},
    { &hf_umts_rrc_ies_fddPhysChCapability,
      { "fddPhysChCapability", "umts_rrc_ies.fddPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fddPhysChCapability", HFILL }},
    { &hf_umts_rrc_ies_downlinkPhysChCapability,
      { "downlinkPhysChCapability", "umts_rrc_ies.downlinkPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_PhysChCapabilityFDD", HFILL }},
    { &hf_umts_rrc_ies_uplinkPhysChCapability,
      { "uplinkPhysChCapability", "umts_rrc_ies.uplinkPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_PhysChCapabilityFDD", HFILL }},
    { &hf_umts_rrc_ies_tddPhysChCapability,
      { "tddPhysChCapability", "umts_rrc_ies.tddPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tddPhysChCapability", HFILL }},
    { &hf_umts_rrc_ies_downlinkPhysChCapability1,
      { "downlinkPhysChCapability", "umts_rrc_ies.downlinkPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_PhysChCapabilityTDD", HFILL }},
    { &hf_umts_rrc_ies_uplinkPhysChCapability1,
      { "uplinkPhysChCapability", "umts_rrc_ies.uplinkPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_PhysChCapabilityTDD", HFILL }},
    { &hf_umts_rrc_ies_tdd128_PhysChCapability,
      { "tdd128-PhysChCapability", "umts_rrc_ies.tdd128_PhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd128_PhysChCapability", HFILL }},
    { &hf_umts_rrc_ies_downlinkPhysChCapability2,
      { "downlinkPhysChCapability", "umts_rrc_ies.downlinkPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_PhysChCapabilityTDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_uplinkPhysChCapability2,
      { "uplinkPhysChCapability", "umts_rrc_ies.uplinkPhysChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_PhysChCapabilityTDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_fdd_hspdsch,
      { "fdd-hspdsch", "umts_rrc_ies.fdd_hspdsch",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_fdd_hspdsch_vals), 0,
        "umts_rrc_ies.T_fdd_hspdsch", HFILL }},
    { &hf_umts_rrc_ies_supported2,
      { "supported", "umts_rrc_ies.supported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_supported1", HFILL }},
    { &hf_umts_rrc_ies_hsdsch_physical_layer_category,
      { "hsdsch-physical-layer-category", "umts_rrc_ies.hsdsch_physical_layer_category",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HSDSCH_physical_layer_category", HFILL }},
    { &hf_umts_rrc_ies_dummy,
      { "dummy", "umts_rrc_ies.dummy",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dummy2,
      { "dummy2", "umts_rrc_ies.dummy2",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_unsupported,
      { "unsupported", "umts_rrc_ies.unsupported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_tdd384_hspdsch,
      { "tdd384-hspdsch", "umts_rrc_ies.tdd384_hspdsch",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd384_hspdsch_vals), 0,
        "umts_rrc_ies.T_tdd384_hspdsch", HFILL }},
    { &hf_umts_rrc_ies_supported3,
      { "supported", "umts_rrc_ies.supported",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HSDSCH_physical_layer_category", HFILL }},
    { &hf_umts_rrc_ies_tdd128_hspdsch,
      { "tdd128-hspdsch", "umts_rrc_ies.tdd128_hspdsch",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd128_hspdsch_vals), 0,
        "umts_rrc_ies.T_tdd128_hspdsch", HFILL }},
    { &hf_umts_rrc_ies_numberOfRepetitionsPerSFNPeriod,
      { "numberOfRepetitionsPerSFNPeriod", "umts_rrc_ies.numberOfRepetitionsPerSFNPeriod",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_numberOfRepetitionsPerSFNPeriod_vals), 0,
        "umts_rrc_ies.T_numberOfRepetitionsPerSFNPeriod", HFILL }},
    { &hf_umts_rrc_ies_noError,
      { "noError", "umts_rrc_ies.noError",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_errorOccurred,
      { "errorOccurred", "umts_rrc_ies.errorOccurred",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_errorOccurred", HFILL }},
    { &hf_umts_rrc_ies_protocolErrorInformation,
      { "protocolErrorInformation", "umts_rrc_ies.protocolErrorInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ProtocolErrorInformation", HFILL }},
    { &hf_umts_rrc_ies_diagnosticsType,
      { "diagnosticsType", "umts_rrc_ies.diagnosticsType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_diagnosticsType_vals), 0,
        "umts_rrc_ies.T_diagnosticsType", HFILL }},
    { &hf_umts_rrc_ies_type1,
      { "type1", "umts_rrc_ies.type1",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_type1_vals), 0,
        "umts_rrc_ies.T_type1", HFILL }},
    { &hf_umts_rrc_ies_asn1_ViolationOrEncodingError,
      { "asn1-ViolationOrEncodingError", "umts_rrc_ies.asn1_ViolationOrEncodingError",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_messageTypeNonexistent,
      { "messageTypeNonexistent", "umts_rrc_ies.messageTypeNonexistent",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_messageNotCompatibleWithReceiverState,
      { "messageNotCompatibleWithReceiverState", "umts_rrc_ies.messageNotCompatibleWithReceiverState",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IdentificationOfReceivedMessage", HFILL }},
    { &hf_umts_rrc_ies_ie_ValueNotComprehended,
      { "ie-ValueNotComprehended", "umts_rrc_ies.ie_ValueNotComprehended",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IdentificationOfReceivedMessage", HFILL }},
    { &hf_umts_rrc_ies_conditionalInformationElementError,
      { "conditionalInformationElementError", "umts_rrc_ies.conditionalInformationElementError",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IdentificationOfReceivedMessage", HFILL }},
    { &hf_umts_rrc_ies_messageExtensionNotComprehended,
      { "messageExtensionNotComprehended", "umts_rrc_ies.messageExtensionNotComprehended",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IdentificationOfReceivedMessage", HFILL }},
    { &hf_umts_rrc_ies_t314_expired,
      { "t314-expired", "umts_rrc_ies.t314_expired",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_t315_expired,
      { "t315-expired", "umts_rrc_ies.t315_expired",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_frequencyInfo,
      { "frequencyInfo", "umts_rrc_ies.frequencyInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfo", HFILL }},
    { &hf_umts_rrc_ies_interRATInfo,
      { "interRATInfo", "umts_rrc_ies.interRATInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRATInfo_vals), 0,
        "umts_rrc_ies.InterRATInfo", HFILL }},
    { &hf_umts_rrc_ies_interRATInfo1,
      { "interRATInfo", "umts_rrc_ies.interRATInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_fddRF_Capability,
      { "fddRF-Capability", "umts_rrc_ies.fddRF_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fddRF_Capability", HFILL }},
    { &hf_umts_rrc_ies_ue_PowerClass,
      { "ue-PowerClass", "umts_rrc_ies.ue_PowerClass",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_PowerClass", HFILL }},
    { &hf_umts_rrc_ies_txRxFrequencySeparation,
      { "txRxFrequencySeparation", "umts_rrc_ies.txRxFrequencySeparation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TxRxFrequencySeparation_vals), 0,
        "umts_rrc_ies.TxRxFrequencySeparation", HFILL }},
    { &hf_umts_rrc_ies_tddRF_Capability,
      { "tddRF-Capability", "umts_rrc_ies.tddRF_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tddRF_Capability", HFILL }},
    { &hf_umts_rrc_ies_radioFrequencyTDDBandList,
      { "radioFrequencyTDDBandList", "umts_rrc_ies.radioFrequencyTDDBandList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandTDDList_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandTDDList", HFILL }},
    { &hf_umts_rrc_ies_chipRateCapability,
      { "chipRateCapability", "umts_rrc_ies.chipRateCapability",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ChipRateCapability_vals), 0,
        "umts_rrc_ies.ChipRateCapability", HFILL }},
    { &hf_umts_rrc_ies_tddRF_Capability1,
      { "tddRF-Capability", "umts_rrc_ies.tddRF_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tddRF_Capability1", HFILL }},
    { &hf_umts_rrc_ies_radioFrequencyBandTDDList,
      { "radioFrequencyBandTDDList", "umts_rrc_ies.radioFrequencyBandTDDList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandTDDList_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandTDDList", HFILL }},
    { &hf_umts_rrc_ies_totalRLC_AM_BufferSize,
      { "totalRLC-AM-BufferSize", "umts_rrc_ies.totalRLC_AM_BufferSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TotalRLC_AM_BufferSize_vals), 0,
        "umts_rrc_ies.TotalRLC_AM_BufferSize", HFILL }},
    { &hf_umts_rrc_ies_maximumRLC_WindowSize,
      { "maximumRLC-WindowSize", "umts_rrc_ies.maximumRLC_WindowSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaximumRLC_WindowSize_vals), 0,
        "umts_rrc_ies.MaximumRLC_WindowSize", HFILL }},
    { &hf_umts_rrc_ies_maximumAM_EntityNumber,
      { "maximumAM-EntityNumber", "umts_rrc_ies.maximumAM_EntityNumber",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaximumAM_EntityNumberRLC_Cap_vals), 0,
        "umts_rrc_ies.MaximumAM_EntityNumberRLC_Cap", HFILL }},
    { &hf_umts_rrc_ies_totalRLC_AM_BufferSize1,
      { "totalRLC-AM-BufferSize", "umts_rrc_ies.totalRLC_AM_BufferSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TotalRLC_AM_BufferSize_r5_ext_vals), 0,
        "umts_rrc_ies.TotalRLC_AM_BufferSize_r5_ext", HFILL }},
    { &hf_umts_rrc_ies_noRelease,
      { "noRelease", "umts_rrc_ies.noRelease",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_release,
      { "release", "umts_rrc_ies.release",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_release", HFILL }},
    { &hf_umts_rrc_ies_releaseCause,
      { "releaseCause", "umts_rrc_ies.releaseCause",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReleaseCause_vals), 0,
        "umts_rrc_ies.ReleaseCause", HFILL }},
    { &hf_umts_rrc_ies_RRC_MessageSequenceNumberList_item,
      { "Item", "umts_rrc_ies.RRC_MessageSequenceNumberList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RRC_MessageSequenceNumber", HFILL }},
    { &hf_umts_rrc_ies_cipheringAlgorithmCap,
      { "cipheringAlgorithmCap", "umts_rrc_ies.cipheringAlgorithmCap",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_cipheringAlgorithmCap", HFILL }},
    { &hf_umts_rrc_ies_integrityProtectionAlgorithmCap,
      { "integrityProtectionAlgorithmCap", "umts_rrc_ies.integrityProtectionAlgorithmCap",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_integrityProtectionAlgorithmCap", HFILL }},
    { &hf_umts_rrc_ies_deltaACK,
      { "deltaACK", "umts_rrc_ies.deltaACK",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaACK", HFILL }},
    { &hf_umts_rrc_ies_deltaNACK,
      { "deltaNACK", "umts_rrc_ies.deltaNACK",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaNACK", HFILL }},
    { &hf_umts_rrc_ies_harq_Preamble_Mode,
      { "harq-Preamble-Mode", "umts_rrc_ies.harq_Preamble_Mode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HARQ_Preamble_Mode", HFILL }},
    { &hf_umts_rrc_ies_primaryCPICH_Info,
      { "primaryCPICH-Info", "umts_rrc_ies.primaryCPICH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_dl_hspdsch_Information,
      { "dl-hspdsch-Information", "umts_rrc_ies.dl_hspdsch_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_HSPDSCH_Information", HFILL }},
    { &hf_umts_rrc_ies_harqInfo,
      { "harqInfo", "umts_rrc_ies.harqInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HARQ_Info", HFILL }},
    { &hf_umts_rrc_ies_mac_hsResetIndicator,
      { "mac-hsResetIndicator", "umts_rrc_ies.mac_hsResetIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_mac_hsResetIndicator_vals), 0,
        "umts_rrc_ies.T_mac_hsResetIndicator", HFILL }},
    { &hf_umts_rrc_ies_supported4,
      { "supported", "umts_rrc_ies.supported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_supported2", HFILL }},
    { &hf_umts_rrc_ies_maxNoSCCPCH_RL,
      { "maxNoSCCPCH-RL", "umts_rrc_ies.maxNoSCCPCH_RL",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoSCCPCH_RL_vals), 0,
        "umts_rrc_ies.MaxNoSCCPCH_RL", HFILL }},
    { &hf_umts_rrc_ies_simultaneousSCCPCH_DPCH_DPDCH_Reception,
      { "simultaneousSCCPCH-DPCH-DPDCH-Reception", "umts_rrc_ies.simultaneousSCCPCH_DPCH_DPDCH_Reception",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_STARTList_item,
      { "Item", "umts_rrc_ies.STARTList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.STARTSingle", HFILL }},
    { &hf_umts_rrc_ies_start_Value,
      { "start-Value", "umts_rrc_ies.start_Value",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.START_Value", HFILL }},
    { &hf_umts_rrc_ies_systemSpecificCapUpdateReqList1,
      { "systemSpecificCapUpdateReqList", "umts_rrc_ies.systemSpecificCapUpdateReqList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SystemSpecificCapUpdateReqList_r5", HFILL }},
    { &hf_umts_rrc_ies_SystemSpecificCapUpdateReqList_item,
      { "Item", "umts_rrc_ies.SystemSpecificCapUpdateReqList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SystemSpecificCapUpdateReq_vals), 0,
        "umts_rrc_ies.SystemSpecificCapUpdateReq", HFILL }},
    { &hf_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5_item,
      { "Item", "umts_rrc_ies.SystemSpecificCapUpdateReqList_r5_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SystemSpecificCapUpdateReq_r5_vals), 0,
        "umts_rrc_ies.SystemSpecificCapUpdateReq_r5", HFILL }},
    { &hf_umts_rrc_ies_tmsi,
      { "tmsi", "umts_rrc_ies.tmsi",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.TMSI_GSM_MAP", HFILL }},
    { &hf_umts_rrc_ies_dl_TransChCapability,
      { "dl-TransChCapability", "umts_rrc_ies.dl_TransChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_TransChCapability", HFILL }},
    { &hf_umts_rrc_ies_ul_TransChCapability,
      { "ul-TransChCapability", "umts_rrc_ies.ul_TransChCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_TransChCapability", HFILL }},
    { &hf_umts_rrc_ies_supported5,
      { "supported", "umts_rrc_ies.supported",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoBits_vals), 0,
        "umts_rrc_ies.MaxNoBits", HFILL }},
    { &hf_umts_rrc_ies_srnc_Identity,
      { "srnc-Identity", "umts_rrc_ies.srnc_Identity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.SRNC_Identity", HFILL }},
    { &hf_umts_rrc_ies_s_RNTI,
      { "s-RNTI", "umts_rrc_ies.s_RNTI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.S_RNTI", HFILL }},
    { &hf_umts_rrc_ies_all,
      { "all", "umts_rrc_ies.all",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b1,
      { "u-RNTI-BitMaskIndex-b1", "umts_rrc_ies.u_RNTI_BitMaskIndex_b1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_31", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b2,
      { "u-RNTI-BitMaskIndex-b2", "umts_rrc_ies.u_RNTI_BitMaskIndex_b2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_30", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b3,
      { "u-RNTI-BitMaskIndex-b3", "umts_rrc_ies.u_RNTI_BitMaskIndex_b3",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_29", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b4,
      { "u-RNTI-BitMaskIndex-b4", "umts_rrc_ies.u_RNTI_BitMaskIndex_b4",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_28", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b5,
      { "u-RNTI-BitMaskIndex-b5", "umts_rrc_ies.u_RNTI_BitMaskIndex_b5",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_27", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b6,
      { "u-RNTI-BitMaskIndex-b6", "umts_rrc_ies.u_RNTI_BitMaskIndex_b6",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_26", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b7,
      { "u-RNTI-BitMaskIndex-b7", "umts_rrc_ies.u_RNTI_BitMaskIndex_b7",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_25", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b8,
      { "u-RNTI-BitMaskIndex-b8", "umts_rrc_ies.u_RNTI_BitMaskIndex_b8",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b9,
      { "u-RNTI-BitMaskIndex-b9", "umts_rrc_ies.u_RNTI_BitMaskIndex_b9",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_23", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b10,
      { "u-RNTI-BitMaskIndex-b10", "umts_rrc_ies.u_RNTI_BitMaskIndex_b10",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_22", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b11,
      { "u-RNTI-BitMaskIndex-b11", "umts_rrc_ies.u_RNTI_BitMaskIndex_b11",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_21", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b12,
      { "u-RNTI-BitMaskIndex-b12", "umts_rrc_ies.u_RNTI_BitMaskIndex_b12",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_20", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b13,
      { "u-RNTI-BitMaskIndex-b13", "umts_rrc_ies.u_RNTI_BitMaskIndex_b13",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_19", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b14,
      { "u-RNTI-BitMaskIndex-b14", "umts_rrc_ies.u_RNTI_BitMaskIndex_b14",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_18", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b15,
      { "u-RNTI-BitMaskIndex-b15", "umts_rrc_ies.u_RNTI_BitMaskIndex_b15",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_17", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b16,
      { "u-RNTI-BitMaskIndex-b16", "umts_rrc_ies.u_RNTI_BitMaskIndex_b16",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b17,
      { "u-RNTI-BitMaskIndex-b17", "umts_rrc_ies.u_RNTI_BitMaskIndex_b17",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_15", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b18,
      { "u-RNTI-BitMaskIndex-b18", "umts_rrc_ies.u_RNTI_BitMaskIndex_b18",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_14", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b19,
      { "u-RNTI-BitMaskIndex-b19", "umts_rrc_ies.u_RNTI_BitMaskIndex_b19",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_13", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b20,
      { "u-RNTI-BitMaskIndex-b20", "umts_rrc_ies.u_RNTI_BitMaskIndex_b20",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_12", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b21,
      { "u-RNTI-BitMaskIndex-b21", "umts_rrc_ies.u_RNTI_BitMaskIndex_b21",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_11", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b22,
      { "u-RNTI-BitMaskIndex-b22", "umts_rrc_ies.u_RNTI_BitMaskIndex_b22",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_10", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b23,
      { "u-RNTI-BitMaskIndex-b23", "umts_rrc_ies.u_RNTI_BitMaskIndex_b23",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_9", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b24,
      { "u-RNTI-BitMaskIndex-b24", "umts_rrc_ies.u_RNTI_BitMaskIndex_b24",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b25,
      { "u-RNTI-BitMaskIndex-b25", "umts_rrc_ies.u_RNTI_BitMaskIndex_b25",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_7", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b26,
      { "u-RNTI-BitMaskIndex-b26", "umts_rrc_ies.u_RNTI_BitMaskIndex_b26",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_6", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b27,
      { "u-RNTI-BitMaskIndex-b27", "umts_rrc_ies.u_RNTI_BitMaskIndex_b27",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_5", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b28,
      { "u-RNTI-BitMaskIndex-b28", "umts_rrc_ies.u_RNTI_BitMaskIndex_b28",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_4", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b29,
      { "u-RNTI-BitMaskIndex-b29", "umts_rrc_ies.u_RNTI_BitMaskIndex_b29",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_3", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b30,
      { "u-RNTI-BitMaskIndex-b30", "umts_rrc_ies.u_RNTI_BitMaskIndex_b30",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_2", HFILL }},
    { &hf_umts_rrc_ies_u_RNTI_BitMaskIndex_b31,
      { "u-RNTI-BitMaskIndex-b31", "umts_rrc_ies.u_RNTI_BitMaskIndex_b31",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1", HFILL }},
    { &hf_umts_rrc_ies_s_RNTI_2,
      { "s-RNTI-2", "umts_rrc_ies.s_RNTI_2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.S_RNTI_2", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioAccessCapability_v6xyext,
      { "ue-RadioAccessCapability-v6xyext", "umts_rrc_ies.ue_RadioAccessCapability_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapability_v6xyext", HFILL }},
    { &hf_umts_rrc_ies_ue_RATSpecificCapability_v6xyext,
      { "ue-RATSpecificCapability-v6xyext", "umts_rrc_ies.ue_RATSpecificCapability_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRAT_UE_RadioAccessCapability_v6xyext", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_t_301,
      { "t-301", "umts_rrc_ies.t_301",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_301_vals), 0,
        "umts_rrc_ies.T_301", HFILL }},
    { &hf_umts_rrc_ies_n_301,
      { "n-301", "umts_rrc_ies.n_301",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_301", HFILL }},
    { &hf_umts_rrc_ies_t_302,
      { "t-302", "umts_rrc_ies.t_302",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_302_vals), 0,
        "umts_rrc_ies.T_302", HFILL }},
    { &hf_umts_rrc_ies_n_302,
      { "n-302", "umts_rrc_ies.n_302",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_302", HFILL }},
    { &hf_umts_rrc_ies_t_304,
      { "t-304", "umts_rrc_ies.t_304",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_304_vals), 0,
        "umts_rrc_ies.T_304", HFILL }},
    { &hf_umts_rrc_ies_n_304,
      { "n-304", "umts_rrc_ies.n_304",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_304", HFILL }},
    { &hf_umts_rrc_ies_t_305,
      { "t-305", "umts_rrc_ies.t_305",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_305_vals), 0,
        "umts_rrc_ies.T_305", HFILL }},
    { &hf_umts_rrc_ies_t_307,
      { "t-307", "umts_rrc_ies.t_307",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_307_vals), 0,
        "umts_rrc_ies.T_307", HFILL }},
    { &hf_umts_rrc_ies_t_308,
      { "t-308", "umts_rrc_ies.t_308",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_308_vals), 0,
        "umts_rrc_ies.T_308", HFILL }},
    { &hf_umts_rrc_ies_t_309,
      { "t-309", "umts_rrc_ies.t_309",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_309", HFILL }},
    { &hf_umts_rrc_ies_t_310,
      { "t-310", "umts_rrc_ies.t_310",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_310_vals), 0,
        "umts_rrc_ies.T_310", HFILL }},
    { &hf_umts_rrc_ies_n_310,
      { "n-310", "umts_rrc_ies.n_310",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_310", HFILL }},
    { &hf_umts_rrc_ies_t_311,
      { "t-311", "umts_rrc_ies.t_311",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_311_vals), 0,
        "umts_rrc_ies.T_311", HFILL }},
    { &hf_umts_rrc_ies_t_312,
      { "t-312", "umts_rrc_ies.t_312",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_312", HFILL }},
    { &hf_umts_rrc_ies_n_312,
      { "n-312", "umts_rrc_ies.n_312",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_312_vals), 0,
        "umts_rrc_ies.N_312", HFILL }},
    { &hf_umts_rrc_ies_t_313,
      { "t-313", "umts_rrc_ies.t_313",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_313", HFILL }},
    { &hf_umts_rrc_ies_n_313,
      { "n-313", "umts_rrc_ies.n_313",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_313_vals), 0,
        "umts_rrc_ies.N_313", HFILL }},
    { &hf_umts_rrc_ies_t_314,
      { "t-314", "umts_rrc_ies.t_314",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_314_vals), 0,
        "umts_rrc_ies.T_314", HFILL }},
    { &hf_umts_rrc_ies_t_315,
      { "t-315", "umts_rrc_ies.t_315",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_315_vals), 0,
        "umts_rrc_ies.T_315", HFILL }},
    { &hf_umts_rrc_ies_n_315,
      { "n-315", "umts_rrc_ies.n_315",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_315_vals), 0,
        "umts_rrc_ies.N_315", HFILL }},
    { &hf_umts_rrc_ies_t_316,
      { "t-316", "umts_rrc_ies.t_316",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_316_vals), 0,
        "umts_rrc_ies.T_316", HFILL }},
    { &hf_umts_rrc_ies_t_317,
      { "t-317", "umts_rrc_ies.t_317",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_317_vals), 0,
        "umts_rrc_ies.T_317", HFILL }},
    { &hf_umts_rrc_ies_n_3121,
      { "n-312", "umts_rrc_ies.n_312",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_312ext_vals), 0,
        "umts_rrc_ies.N_312ext", HFILL }},
    { &hf_umts_rrc_ies_n_3151,
      { "n-315", "umts_rrc_ies.n_315",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_315ext_vals), 0,
        "umts_rrc_ies.N_315ext", HFILL }},
    { &hf_umts_rrc_ies_n_3122,
      { "n-312", "umts_rrc_ies.n_312",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_312_r5_vals), 0,
        "umts_rrc_ies.N_312_r5", HFILL }},
    { &hf_umts_rrc_ies_n_3152,
      { "n-315", "umts_rrc_ies.n_315",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_315_r5_vals), 0,
        "umts_rrc_ies.N_315_r5", HFILL }},
    { &hf_umts_rrc_ies_t_300,
      { "t-300", "umts_rrc_ies.t_300",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_300_vals), 0,
        "umts_rrc_ies.T_300", HFILL }},
    { &hf_umts_rrc_ies_n_300,
      { "n-300", "umts_rrc_ies.n_300",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_300", HFILL }},
    { &hf_umts_rrc_ies_multiRAT_CapabilityList,
      { "multiRAT-CapabilityList", "umts_rrc_ies.multiRAT_CapabilityList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MultiRAT_Capability", HFILL }},
    { &hf_umts_rrc_ies_multiModeCapability,
      { "multiModeCapability", "umts_rrc_ies.multiModeCapability",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MultiModeCapability_vals), 0,
        "umts_rrc_ies.MultiModeCapability", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Capability,
      { "pdcp-Capability", "umts_rrc_ies.pdcp_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_Capability", HFILL }},
    { &hf_umts_rrc_ies_rlc_Capability,
      { "rlc-Capability", "umts_rrc_ies.rlc_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Capability", HFILL }},
    { &hf_umts_rrc_ies_transportChannelCapability,
      { "transportChannelCapability", "umts_rrc_ies.transportChannelCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TransportChannelCapability", HFILL }},
    { &hf_umts_rrc_ies_rf_Capability,
      { "rf-Capability", "umts_rrc_ies.rf_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RF_Capability", HFILL }},
    { &hf_umts_rrc_ies_physicalChannelCapability,
      { "physicalChannelCapability", "umts_rrc_ies.physicalChannelCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PhysicalChannelCapability", HFILL }},
    { &hf_umts_rrc_ies_ue_MultiModeRAT_Capability,
      { "ue-MultiModeRAT-Capability", "umts_rrc_ies.ue_MultiModeRAT_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_MultiModeRAT_Capability", HFILL }},
    { &hf_umts_rrc_ies_securityCapability,
      { "securityCapability", "umts_rrc_ies.securityCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecurityCapability", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_Capability,
      { "ue-positioning-Capability", "umts_rrc_ies.ue_positioning_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Capability", HFILL }},
    { &hf_umts_rrc_ies_measurementCapability,
      { "measurementCapability", "umts_rrc_ies.measurementCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementCapability", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioAccessCapability,
      { "ue-RadioAccessCapability", "umts_rrc_ies.ue_RadioAccessCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapability", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioAccessCapability_v370ext,
      { "ue-RadioAccessCapability-v370ext", "umts_rrc_ies.ue_RadioAccessCapability_v370ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapability_v370ext", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList,
      { "ue-RadioAccessCapabBandFDDList", "umts_rrc_ies.ue_RadioAccessCapabBandFDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapabBandFDDList", HFILL }},
    { &hf_umts_rrc_ies_ue_PositioningCapabilityExt_v380,
      { "ue-PositioningCapabilityExt-v380", "umts_rrc_ies.ue_PositioningCapabilityExt_v380",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_PositioningCapabilityExt_v380", HFILL }},
    { &hf_umts_rrc_ies_ue_PositioningCapabilityExt_v3a0,
      { "ue-PositioningCapabilityExt-v3a0", "umts_rrc_ies.ue_PositioningCapabilityExt_v3a0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_PositioningCapabilityExt_v3a0", HFILL }},
    { &hf_umts_rrc_ies_ue_PositioningCapabilityExt_v3g0,
      { "ue-PositioningCapabilityExt-v3g0", "umts_rrc_ies.ue_PositioningCapabilityExt_v3g0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_PositioningCapabilityExt_v3g0", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList2,
      { "ue-RadioAccessCapabBandFDDList2", "umts_rrc_ies.ue_RadioAccessCapabBandFDDList2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapabBandFDDList2", HFILL }},
    { &hf_umts_rrc_ies_ue_RadioAccessCapabBandFDDList_ext,
      { "ue-RadioAccessCapabBandFDDList-ext", "umts_rrc_ies.ue_RadioAccessCapabBandFDDList_ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapabBandFDDList_ext", HFILL }},
    { &hf_umts_rrc_ies_physicalchannelcapability_edch,
      { "physicalchannelcapability-edch", "umts_rrc_ies.physicalchannelcapability_edch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PhysicalChannelCapability_edch_r6", HFILL }},
    { &hf_umts_rrc_ies_deviceType,
      { "deviceType", "umts_rrc_ies.deviceType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_deviceType_vals), 0,
        "umts_rrc_ies.T_deviceType", HFILL }},
    { &hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2_item,
      { "Item", "umts_rrc_ies.UE_RadioAccessCapabBandFDDList2_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapabBandFDD2", HFILL }},
    { &hf_umts_rrc_ies_fddRF_Capability1,
      { "fddRF-Capability", "umts_rrc_ies.fddRF_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fddRF_Capability1", HFILL }},
    { &hf_umts_rrc_ies_ue_PowerClass1,
      { "ue-PowerClass", "umts_rrc_ies.ue_PowerClass",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_PowerClassExt_vals), 0,
        "umts_rrc_ies.UE_PowerClassExt", HFILL }},
    { &hf_umts_rrc_ies_measurementCapability2,
      { "measurementCapability2", "umts_rrc_ies.measurementCapability2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementCapabilityExt2", HFILL }},
    { &hf_umts_rrc_ies_rx_tx_TimeDifferenceType2Capable,
      { "rx-tx-TimeDifferenceType2Capable", "umts_rrc_ies.rx_tx_TimeDifferenceType2Capable",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_validity_CellPCH_UraPCH,
      { "validity-CellPCH-UraPCH", "umts_rrc_ies.validity_CellPCH_UraPCH",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_validity_CellPCH_UraPCH_vals), 0,
        "umts_rrc_ies.T_validity_CellPCH_UraPCH", HFILL }},
    { &hf_umts_rrc_ies_sfn_sfnType2Capability,
      { "sfn-sfnType2Capability", "umts_rrc_ies.sfn_sfnType2Capability",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_sfn_sfnType2Capability_vals), 0,
        "umts_rrc_ies.T_sfn_sfnType2Capability", HFILL }},
    { &hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_item,
      { "Item", "umts_rrc_ies.UE_RadioAccessCapabBandFDDList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapabBandFDD", HFILL }},
    { &hf_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext_item,
      { "Item", "umts_rrc_ies.UE_RadioAccessCapabBandFDDList_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RadioAccessCapabBandFDD_ext", HFILL }},
    { &hf_umts_rrc_ies_fddRF_Capability2,
      { "fddRF-Capability", "umts_rrc_ies.fddRF_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fddRF_Capability2", HFILL }},
    { &hf_umts_rrc_ies_measurementCapability1,
      { "measurementCapability", "umts_rrc_ies.measurementCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementCapabilityExt", HFILL }},
    { &hf_umts_rrc_ies_compressedModeMeasCapabFDDList_ext,
      { "compressedModeMeasCapabFDDList-ext", "umts_rrc_ies.compressedModeMeasCapabFDDList_ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CompressedModeMeasCapabFDDList_ext", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Capability_r4_ext,
      { "pdcp-Capability-r4-ext", "umts_rrc_ies.pdcp_Capability_r4_ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_Capability_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_tdd_CapabilityExt,
      { "tdd-CapabilityExt", "umts_rrc_ies.tdd_CapabilityExt",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd_CapabilityExt", HFILL }},
    { &hf_umts_rrc_ies_rf_Capability1,
      { "rf-Capability", "umts_rrc_ies.rf_Capability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RF_Capability_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_physicalChannelCapability_LCR,
      { "physicalChannelCapability-LCR", "umts_rrc_ies.physicalChannelCapability_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PhysicalChannelCapability_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_measurementCapability_r4_ext,
      { "measurementCapability-r4-ext", "umts_rrc_ies.measurementCapability_r4_ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementCapability_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_accessStratumReleaseIndicator,
      { "accessStratumReleaseIndicator", "umts_rrc_ies.accessStratumReleaseIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AccessStratumReleaseIndicator_vals), 0,
        "umts_rrc_ies.AccessStratumReleaseIndicator", HFILL }},
    { &hf_umts_rrc_ies_totalAM_RLCMemoryExceeds10kB,
      { "totalAM-RLCMemoryExceeds10kB", "umts_rrc_ies.totalAM_RLCMemoryExceeds10kB",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_rf_CapabilityComp,
      { "rf-CapabilityComp", "umts_rrc_ies.rf_CapabilityComp",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RF_CapabilityComp", HFILL }},
    { &hf_umts_rrc_ies_fdd1,
      { "fdd", "umts_rrc_ies.fdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_fdd1_vals), 0,
        "umts_rrc_ies.T_fdd1", HFILL }},
    { &hf_umts_rrc_ies_supported6,
      { "supported", "umts_rrc_ies.supported",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RF_CapabBandListFDDComp", HFILL }},
    { &hf_umts_rrc_ies_tdd384_RF_Capability,
      { "tdd384-RF-Capability", "umts_rrc_ies.tdd384_RF_Capability",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd384_RF_Capability_vals), 0,
        "umts_rrc_ies.T_tdd384_RF_Capability", HFILL }},
    { &hf_umts_rrc_ies_supported7,
      { "supported", "umts_rrc_ies.supported",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandTDDList_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandTDDList", HFILL }},
    { &hf_umts_rrc_ies_tdd128_RF_Capability,
      { "tdd128-RF-Capability", "umts_rrc_ies.tdd128_RF_Capability",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd128_RF_Capability_vals), 0,
        "umts_rrc_ies.T_tdd128_RF_Capability", HFILL }},
    { &hf_umts_rrc_ies_RF_CapabBandListFDDComp_item,
      { "Item", "umts_rrc_ies.RF_CapabBandListFDDComp_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RF_CapabBandFDDComp_vals), 0,
        "umts_rrc_ies.RF_CapabBandFDDComp", HFILL }},
    { &hf_umts_rrc_ies_dl_CapabilityWithSimultaneousHS_DSCHConfig,
      { "dl-CapabilityWithSimultaneousHS-DSCHConfig", "umts_rrc_ies.dl_CapabilityWithSimultaneousHS_DSCHConfig",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_CapabilityWithSimultaneousHS_DSCHConfig_vals), 0,
        "umts_rrc_ies.DL_CapabilityWithSimultaneousHS_DSCHConfig", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Capability_r5_ext,
      { "pdcp-Capability-r5-ext", "umts_rrc_ies.pdcp_Capability_r5_ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_Capability_r5_ext", HFILL }},
    { &hf_umts_rrc_ies_rlc_Capability_r5_ext,
      { "rlc-Capability-r5-ext", "umts_rrc_ies.rlc_Capability_r5_ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Capability_r5_ext", HFILL }},
    { &hf_umts_rrc_ies_physicalChannelCapability1,
      { "physicalChannelCapability", "umts_rrc_ies.physicalChannelCapability",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PhysicalChannelCapability_hspdsch_r5", HFILL }},
    { &hf_umts_rrc_ies_multiModeRAT_Capability_v590ext,
      { "multiModeRAT-Capability-v590ext", "umts_rrc_ies.multiModeRAT_Capability_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MultiModeRAT_Capability_v590ext", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Capability_r5_ext2,
      { "pdcp-Capability-r5-ext2", "umts_rrc_ies.pdcp_Capability_r5_ext2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_Capability_r5_ext2", HFILL }},
    { &hf_umts_rrc_ies_maxNoDPDCH_BitsTransmitted,
      { "maxNoDPDCH-BitsTransmitted", "umts_rrc_ies.maxNoDPDCH_BitsTransmitted",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoDPDCH_BitsTransmitted_vals), 0,
        "umts_rrc_ies.MaxNoDPDCH_BitsTransmitted", HFILL }},
    { &hf_umts_rrc_ies_maxPhysChPerTimeslot,
      { "maxPhysChPerTimeslot", "umts_rrc_ies.maxPhysChPerTimeslot",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxPhysChPerTimeslot_vals), 0,
        "umts_rrc_ies.MaxPhysChPerTimeslot", HFILL }},
    { &hf_umts_rrc_ies_minimumSF1,
      { "minimumSF", "umts_rrc_ies.minimumSF",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MinimumSF_UL_vals), 0,
        "umts_rrc_ies.MinimumSF_UL", HFILL }},
    { &hf_umts_rrc_ies_supportOfPUSCH,
      { "supportOfPUSCH", "umts_rrc_ies.supportOfPUSCH",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_fdd_edch,
      { "fdd-edch", "umts_rrc_ies.fdd_edch",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_fdd_edch_vals), 0,
        "umts_rrc_ies.T_fdd_edch", HFILL }},
    { &hf_umts_rrc_ies_supported8,
      { "supported", "umts_rrc_ies.supported",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_supported3", HFILL }},
    { &hf_umts_rrc_ies_edch_PhysicalLayerCategory,
      { "edch-PhysicalLayerCategory", "umts_rrc_ies.edch_PhysicalLayerCategory",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_16", HFILL }},
    { &hf_umts_rrc_ies_maxNoBitsTransmitted,
      { "maxNoBitsTransmitted", "umts_rrc_ies.maxNoBitsTransmitted",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoBits_vals), 0,
        "umts_rrc_ies.MaxNoBits", HFILL }},
    { &hf_umts_rrc_ies_maxConvCodeBitsTransmitted,
      { "maxConvCodeBitsTransmitted", "umts_rrc_ies.maxConvCodeBitsTransmitted",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNoBits_vals), 0,
        "umts_rrc_ies.MaxNoBits", HFILL }},
    { &hf_umts_rrc_ies_turboEncodingSupport,
      { "turboEncodingSupport", "umts_rrc_ies.turboEncodingSupport",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TurboSupport_vals), 0,
        "umts_rrc_ies.TurboSupport", HFILL }},
    { &hf_umts_rrc_ies_maxSimultaneousTransChs1,
      { "maxSimultaneousTransChs", "umts_rrc_ies.maxSimultaneousTransChs",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxSimultaneousTransChsUL_vals), 0,
        "umts_rrc_ies.MaxSimultaneousTransChsUL", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo1,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo1_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo1", HFILL }},
    { &hf_umts_rrc_ies_fdd2,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_tdd1,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1", HFILL }},
    { &hf_umts_rrc_ies_maxTransmittedBlocks,
      { "maxTransmittedBlocks", "umts_rrc_ies.maxTransmittedBlocks",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxTransportBlocksUL_vals), 0,
        "umts_rrc_ies.MaxTransportBlocksUL", HFILL }},
    { &hf_umts_rrc_ies_maxNumberOfTFC1,
      { "maxNumberOfTFC", "umts_rrc_ies.maxNumberOfTFC",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfTFC_UL_vals), 0,
        "umts_rrc_ies.MaxNumberOfTFC_UL", HFILL }},
    { &hf_umts_rrc_ies_standaloneLocMethodsSupported,
      { "standaloneLocMethodsSupported", "umts_rrc_ies.standaloneLocMethodsSupported",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ue_BasedOTDOA_Supported,
      { "ue-BasedOTDOA-Supported", "umts_rrc_ies.ue_BasedOTDOA_Supported",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_networkAssistedGPS_Supported,
      { "networkAssistedGPS-Supported", "umts_rrc_ies.networkAssistedGPS_Supported",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_NetworkAssistedGPS_Supported_vals), 0,
        "umts_rrc_ies.NetworkAssistedGPS_Supported", HFILL }},
    { &hf_umts_rrc_ies_supportForUE_GPS_TimingOfCellFrames,
      { "supportForUE-GPS-TimingOfCellFrames", "umts_rrc_ies.supportForUE_GPS_TimingOfCellFrames",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_supportForIPDL,
      { "supportForIPDL", "umts_rrc_ies.supportForIPDL",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_start_CS,
      { "start-CS", "umts_rrc_ies.start_CS",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.START_Value", HFILL }},
    { &hf_umts_rrc_ies_start_PS,
      { "start-PS", "umts_rrc_ies.start_PS",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.START_Value", HFILL }},
    { &hf_umts_rrc_ies_rfc2507_Info,
      { "rfc2507-Info", "umts_rrc_ies.rfc2507_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RFC2507_Info", HFILL }},
    { &hf_umts_rrc_ies_rfc3095_Info,
      { "rfc3095-Info", "umts_rrc_ies.rfc3095_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RFC3095_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_inSequenceDelivery,
      { "inSequenceDelivery", "umts_rrc_ies.inSequenceDelivery",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_receivingWindowSize,
      { "receivingWindowSize", "umts_rrc_ies.receivingWindowSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReceivingWindowSize_vals), 0,
        "umts_rrc_ies.ReceivingWindowSize", HFILL }},
    { &hf_umts_rrc_ies_dl_RLC_StatusInfo,
      { "dl-RLC-StatusInfo", "umts_rrc_ies.dl_RLC_StatusInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_RLC_StatusInfo", HFILL }},
    { &hf_umts_rrc_ies_dl_RLC_PDU_size,
      { "dl-RLC-PDU-size", "umts_rrc_ies.dl_RLC_PDU_size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_OctetModeRLC_SizeInfoType1_vals), 0,
        "umts_rrc_ies.OctetModeRLC_SizeInfoType1", HFILL }},
    { &hf_umts_rrc_ies_rB_WithPDCP_InfoList,
      { "rB-WithPDCP-InfoList", "umts_rrc_ies.rB_WithPDCP_InfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_WithPDCP_InfoList", HFILL }},
    { &hf_umts_rrc_ies_rb_WithPDCP_InfoList,
      { "rb-WithPDCP-InfoList", "umts_rrc_ies.rb_WithPDCP_InfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_WithPDCP_InfoList", HFILL }},
    { &hf_umts_rrc_ies_rb_PDCPContextRelocationList,
      { "rb-PDCPContextRelocationList", "umts_rrc_ies.rb_PDCPContextRelocationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_PDCPContextRelocationList", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelType,
      { "dl-TransportChannelType", "umts_rrc_ies.dl_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TransportChannelType_vals), 0,
        "umts_rrc_ies.DL_TransportChannelType", HFILL }},
    { &hf_umts_rrc_ies_logicalChannelIdentity,
      { "logicalChannelIdentity", "umts_rrc_ies.logicalChannelIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.LogicalChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelType1,
      { "dl-TransportChannelType", "umts_rrc_ies.dl_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TransportChannelType_r5_vals), 0,
        "umts_rrc_ies.DL_TransportChannelType_r5", HFILL }},
    { &hf_umts_rrc_ies_DL_LogicalChannelMappingList_item,
      { "Item", "umts_rrc_ies.DL_LogicalChannelMappingList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_LogicalChannelMapping", HFILL }},
    { &hf_umts_rrc_ies_DL_LogicalChannelMappingList_r5_item,
      { "Item", "umts_rrc_ies.DL_LogicalChannelMappingList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_LogicalChannelMapping_r5", HFILL }},
    { &hf_umts_rrc_ies_cid_InclusionInfo,
      { "cid-InclusionInfo", "umts_rrc_ies.cid_InclusionInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CID_InclusionInfo_r4_vals), 0,
        "umts_rrc_ies.CID_InclusionInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_max_CID,
      { "max-CID", "umts_rrc_ies.max_CID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_16383", HFILL }},
    { &hf_umts_rrc_ies_reverseDecompressionDepth,
      { "reverseDecompressionDepth", "umts_rrc_ies.reverseDecompressionDepth",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_65535", HFILL }},
    { &hf_umts_rrc_ies_dl_AM_RLC_Mode,
      { "dl-AM-RLC-Mode", "umts_rrc_ies.dl_AM_RLC_Mode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_AM_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_dl_UM_RLC_Mode,
      { "dl-UM-RLC-Mode", "umts_rrc_ies.dl_UM_RLC_Mode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_dl_TM_RLC_Mode,
      { "dl-TM-RLC-Mode", "umts_rrc_ies.dl_TM_RLC_Mode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_TM_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_dl_AM_RLC_Mode_r5,
      { "dl-AM-RLC-Mode-r5", "umts_rrc_ies.dl_AM_RLC_Mode_r5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_AM_RLC_Mode_r5", HFILL }},
    { &hf_umts_rrc_ies_dl_UM_RLC_Mode_r5,
      { "dl-UM-RLC-Mode-r5", "umts_rrc_ies.dl_UM_RLC_Mode_r5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_UM_RLC_Mode_r5", HFILL }},
    { &hf_umts_rrc_ies_dl_UM_RLC_Mode_r51,
      { "dl-UM-RLC-Mode-r5", "umts_rrc_ies.dl_UM_RLC_Mode_r5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_UM_RLC_Mode_r6", HFILL }},
    { &hf_umts_rrc_ies_timerStatusProhibit,
      { "timerStatusProhibit", "umts_rrc_ies.timerStatusProhibit",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerStatusProhibit_vals), 0,
        "umts_rrc_ies.TimerStatusProhibit", HFILL }},
    { &hf_umts_rrc_ies_dummy_TimerEPC,
      { "dummy-TimerEPC", "umts_rrc_ies.dummy_TimerEPC",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerEPC_vals), 0,
        "umts_rrc_ies.TimerEPC", HFILL }},
    { &hf_umts_rrc_ies_missingPDU_Indicator,
      { "missingPDU-Indicator", "umts_rrc_ies.missingPDU_Indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_timerStatusPeriodic,
      { "timerStatusPeriodic", "umts_rrc_ies.timerStatusPeriodic",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerStatusPeriodic_vals), 0,
        "umts_rrc_ies.TimerStatusPeriodic", HFILL }},
    { &hf_umts_rrc_ies_segmentationIndication,
      { "segmentationIndication", "umts_rrc_ies.segmentationIndication",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dch,
      { "dch", "umts_rrc_ies.dch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_fach,
      { "fach", "umts_rrc_ies.fach",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_dsch,
      { "dsch", "umts_rrc_ies.dsch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dch_and_dsch,
      { "dch-and-dsch", "umts_rrc_ies.dch_and_dsch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentityDCHandDSCH", HFILL }},
    { &hf_umts_rrc_ies_hsdsch,
      { "hsdsch", "umts_rrc_ies.hsdsch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_d_FlowIdentity", HFILL }},
    { &hf_umts_rrc_ies_dch_and_hsdsch,
      { "dch-and-hsdsch", "umts_rrc_ies.dch_and_hsdsch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MAC_d_FlowIdentityDCHandHSDSCH", HFILL }},
    { &hf_umts_rrc_ies_dl_UM_RLC_LI_size,
      { "dl-UM-RLC-LI-size", "umts_rrc_ies.dl_UM_RLC_LI_size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_UM_RLC_LI_size_vals), 0,
        "umts_rrc_ies.DL_UM_RLC_LI_size", HFILL }},
    { &hf_umts_rrc_ies_dl_Reception_Window_Size,
      { "dl-Reception-Window-Size", "umts_rrc_ies.dl_Reception_Window_Size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_Reception_Window_Size_r6_vals), 0,
        "umts_rrc_ies.DL_Reception_Window_Size_r6", HFILL }},
    { &hf_umts_rrc_ies_timerMRW,
      { "timerMRW", "umts_rrc_ies.timerMRW",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerMRW_vals), 0,
        "umts_rrc_ies.TimerMRW", HFILL }},
    { &hf_umts_rrc_ies_timerDiscard,
      { "timerDiscard", "umts_rrc_ies.timerDiscard",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerDiscard_vals), 0,
        "umts_rrc_ies.TimerDiscard", HFILL }},
    { &hf_umts_rrc_ies_maxMRW,
      { "maxMRW", "umts_rrc_ies.maxMRW",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxMRW_vals), 0,
        "umts_rrc_ies.MaxMRW", HFILL }},
    { &hf_umts_rrc_ies_algorithmSpecificInfo,
      { "algorithmSpecificInfo", "umts_rrc_ies.algorithmSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AlgorithmSpecificInfo_vals), 0,
        "umts_rrc_ies.AlgorithmSpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_HeaderCompressionInfoList_item,
      { "Item", "umts_rrc_ies.HeaderCompressionInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HeaderCompressionInfo", HFILL }},
    { &hf_umts_rrc_ies_algorithmSpecificInfo1,
      { "algorithmSpecificInfo", "umts_rrc_ies.algorithmSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AlgorithmSpecificInfo_r4_vals), 0,
        "umts_rrc_ies.AlgorithmSpecificInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_HeaderCompressionInfoList_r4_item,
      { "Item", "umts_rrc_ies.HeaderCompressionInfoList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HeaderCompressionInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_supported9,
      { "supported", "umts_rrc_ies.supported",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxPDCP_SN_WindowSize_vals), 0,
        "umts_rrc_ies.MaxPDCP_SN_WindowSize", HFILL }},
    { &hf_umts_rrc_ies_maxDAT,
      { "maxDAT", "umts_rrc_ies.maxDAT",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxDAT_vals), 0,
        "umts_rrc_ies.MaxDAT", HFILL }},
    { &hf_umts_rrc_ies_losslessSRNS_RelocSupport,
      { "losslessSRNS-RelocSupport", "umts_rrc_ies.losslessSRNS_RelocSupport",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_LosslessSRNS_RelocSupport_vals), 0,
        "umts_rrc_ies.LosslessSRNS_RelocSupport", HFILL }},
    { &hf_umts_rrc_ies_pdcp_PDU_Header,
      { "pdcp-PDU-Header", "umts_rrc_ies.pdcp_PDU_Header",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PDCP_PDU_Header_vals), 0,
        "umts_rrc_ies.PDCP_PDU_Header", HFILL }},
    { &hf_umts_rrc_ies_headerCompressionInfoList,
      { "headerCompressionInfoList", "umts_rrc_ies.headerCompressionInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HeaderCompressionInfoList", HFILL }},
    { &hf_umts_rrc_ies_headerCompressionInfoList1,
      { "headerCompressionInfoList", "umts_rrc_ies.headerCompressionInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HeaderCompressionInfoList_r4", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Info,
      { "pdcp-Info", "umts_rrc_ies.pdcp_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_Info", HFILL }},
    { &hf_umts_rrc_ies_dummy_INTEGER_0_65535,
      { "dummy-INTEGER-0-65535", "umts_rrc_ies.dummy_INTEGER_0_65535",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_65535", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Info1,
      { "pdcp-Info", "umts_rrc_ies.pdcp_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_timerPollProhibit,
      { "timerPollProhibit", "umts_rrc_ies.timerPollProhibit",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerPollProhibit_vals), 0,
        "umts_rrc_ies.TimerPollProhibit", HFILL }},
    { &hf_umts_rrc_ies_timerPoll,
      { "timerPoll", "umts_rrc_ies.timerPoll",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerPoll_vals), 0,
        "umts_rrc_ies.TimerPoll", HFILL }},
    { &hf_umts_rrc_ies_poll_PDU,
      { "poll-PDU", "umts_rrc_ies.poll_PDU",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_Poll_PDU_vals), 0,
        "umts_rrc_ies.Poll_PDU", HFILL }},
    { &hf_umts_rrc_ies_poll_SDU,
      { "poll-SDU", "umts_rrc_ies.poll_SDU",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_Poll_SDU_vals), 0,
        "umts_rrc_ies.Poll_SDU", HFILL }},
    { &hf_umts_rrc_ies_lastTransmissionPDU_Poll,
      { "lastTransmissionPDU-Poll", "umts_rrc_ies.lastTransmissionPDU_Poll",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_lastRetransmissionPDU_Poll,
      { "lastRetransmissionPDU-Poll", "umts_rrc_ies.lastRetransmissionPDU_Poll",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_pollWindow,
      { "pollWindow", "umts_rrc_ies.pollWindow",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PollWindow_vals), 0,
        "umts_rrc_ies.PollWindow", HFILL }},
    { &hf_umts_rrc_ies_timerPollPeriodic,
      { "timerPollPeriodic", "umts_rrc_ies.timerPollPeriodic",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerPollPeriodic_vals), 0,
        "umts_rrc_ies.TimerPollPeriodic", HFILL }},
    { &hf_umts_rrc_ies_re_EstablishmentTimer,
      { "re-EstablishmentTimer", "umts_rrc_ies.re_EstablishmentTimer",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_Re_EstablishmentTimer_vals), 0,
        "umts_rrc_ies.Re_EstablishmentTimer", HFILL }},
    { &hf_umts_rrc_ies_srb_InformationList,
      { "srb-InformationList", "umts_rrc_ies.srb_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SRB_InformationSetupList", HFILL }},
    { &hf_umts_rrc_ies_rb_InformationList,
      { "rb-InformationList", "umts_rrc_ies.rb_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_InformationSetupList", HFILL }},
    { &hf_umts_rrc_ies_predefinedRB_Configuration,
      { "predefinedRB-Configuration", "umts_rrc_ies.predefinedRB_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PredefinedRB_Configuration", HFILL }},
    { &hf_umts_rrc_ies_preDefTransChConfiguration,
      { "preDefTransChConfiguration", "umts_rrc_ies.preDefTransChConfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PreDefTransChConfiguration", HFILL }},
    { &hf_umts_rrc_ies_preDefPhyChConfiguration,
      { "preDefPhyChConfiguration", "umts_rrc_ies.preDefPhyChConfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PreDefPhyChConfiguration", HFILL }},
    { &hf_umts_rrc_ies_PredefinedConfigStatusList_item,
      { "Item", "umts_rrc_ies.PredefinedConfigStatusList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PredefinedConfigStatusInfo_vals), 0,
        "umts_rrc_ies.PredefinedConfigStatusInfo", HFILL }},
    { &hf_umts_rrc_ies_storedWithValueTagSameAsPrevius,
      { "storedWithValueTagSameAsPrevius", "umts_rrc_ies.storedWithValueTagSameAsPrevius",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_other,
      { "other", "umts_rrc_ies.other",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_other_vals), 0,
        "umts_rrc_ies.T_other", HFILL }},
    { &hf_umts_rrc_ies_notStored,
      { "notStored", "umts_rrc_ies.notStored",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_storedWithDifferentValueTag,
      { "storedWithDifferentValueTag", "umts_rrc_ies.storedWithDifferentValueTag",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigValueTag", HFILL }},
    { &hf_umts_rrc_ies_setsWithDifferentValueTag,
      { "setsWithDifferentValueTag", "umts_rrc_ies.setsWithDifferentValueTag",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigSetsWithDifferentValueTag", HFILL }},
    { &hf_umts_rrc_ies_otherEntries,
      { "otherEntries", "umts_rrc_ies.otherEntries",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigStatusListVarSz", HFILL }},
    { &hf_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag_item,
      { "Item", "umts_rrc_ies.PredefinedConfigSetsWithDifferentValueTag_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PredefinedConfigSetWithDifferentValueTag", HFILL }},
    { &hf_umts_rrc_ies_startPosition,
      { "startPosition", "umts_rrc_ies.startPosition",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_10", HFILL }},
    { &hf_umts_rrc_ies_valueTagList,
      { "valueTagList", "umts_rrc_ies.valueTagList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigValueTagList", HFILL }},
    { &hf_umts_rrc_ies_PredefinedConfigValueTagList_item,
      { "Item", "umts_rrc_ies.PredefinedConfigValueTagList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigValueTag", HFILL }},
    { &hf_umts_rrc_ies_PredefinedConfigStatusListVarSz_item,
      { "Item", "umts_rrc_ies.PredefinedConfigStatusListVarSz_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PredefinedConfigStatusInfo_vals), 0,
        "umts_rrc_ies.PredefinedConfigStatusInfo", HFILL }},
    { &hf_umts_rrc_ies_rab_Identity,
      { "rab-Identity", "umts_rrc_ies.rab_Identity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RAB_Identity_vals), 0,
        "umts_rrc_ies.RAB_Identity", HFILL }},
    { &hf_umts_rrc_ies_nas_Synchronisation_Indicator,
      { "nas-Synchronisation-Indicator", "umts_rrc_ies.nas_Synchronisation_Indicator",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NAS_Synchronisation_Indicator", HFILL }},
    { &hf_umts_rrc_ies_mbms_SessionIdentity,
      { "mbms-SessionIdentity", "umts_rrc_ies.mbms_SessionIdentity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.MBMS_SessionIdentity", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationList_item,
      { "Item", "umts_rrc_ies.RAB_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_Info", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationList_r6_item,
      { "Item", "umts_rrc_ies.RAB_InformationList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationReconfigList_item,
      { "Item", "umts_rrc_ies.RAB_InformationReconfigList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_InformationReconfig", HFILL }},
    { &hf_umts_rrc_ies_rab_Info,
      { "rab-Info", "umts_rrc_ies.rab_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_Info", HFILL }},
    { &hf_umts_rrc_ies_rb_InformationSetupList,
      { "rb-InformationSetupList", "umts_rrc_ies.rb_InformationSetupList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_InformationSetupList", HFILL }},
    { &hf_umts_rrc_ies_rb_InformationSetupList1,
      { "rb-InformationSetupList", "umts_rrc_ies.rb_InformationSetupList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_InformationSetupList_r4", HFILL }},
    { &hf_umts_rrc_ies_rb_InformationSetupList2,
      { "rb-InformationSetupList", "umts_rrc_ies.rb_InformationSetupList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_InformationSetupList_r5", HFILL }},
    { &hf_umts_rrc_ies_rab_Info_r6_ext,
      { "rab-Info-r6-ext", "umts_rrc_ies.rab_Info_r6_ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_Info_r6_ext", HFILL }},
    { &hf_umts_rrc_ies_rab_Info1,
      { "rab-Info", "umts_rrc_ies.rab_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_rb_InformationSetupList3,
      { "rb-InformationSetupList", "umts_rrc_ies.rb_InformationSetupList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_InformationSetupList_r6", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationSetupList_item,
      { "Item", "umts_rrc_ies.RAB_InformationSetupList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_InformationSetup", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationSetupList_r4_item,
      { "Item", "umts_rrc_ies.RAB_InformationSetupList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_InformationSetup_r4", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationSetupList_r5_item,
      { "Item", "umts_rrc_ies.RAB_InformationSetupList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_InformationSetup_r5", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationSetupList_r6_item,
      { "Item", "umts_rrc_ies.RAB_InformationSetupList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_InformationSetup_r6", HFILL }},
    { &hf_umts_rrc_ies_RAB_InformationSetupList_r6_ext_item,
      { "Item", "umts_rrc_ies.RAB_InformationSetupList_r6_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RAB_InformationSetup_r6_ext", HFILL }},
    { &hf_umts_rrc_ies_rb_Identity,
      { "rb-Identity", "umts_rrc_ies.rb_Identity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_Identity", HFILL }},
    { &hf_umts_rrc_ies_rlc_SequenceNumber,
      { "rlc-SequenceNumber", "umts_rrc_ies.rlc_SequenceNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RLC_SequenceNumber", HFILL }},
    { &hf_umts_rrc_ies_RB_ActivationTimeInfoList_item,
      { "Item", "umts_rrc_ies.RB_ActivationTimeInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_ActivationTimeInfo", HFILL }},
    { &hf_umts_rrc_ies_count_C_UL,
      { "count-C-UL", "umts_rrc_ies.count_C_UL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.COUNT_C", HFILL }},
    { &hf_umts_rrc_ies_count_C_DL,
      { "count-C-DL", "umts_rrc_ies.count_C_DL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.COUNT_C", HFILL }},
    { &hf_umts_rrc_ies_RB_COUNT_C_InformationList_item,
      { "Item", "umts_rrc_ies.RB_COUNT_C_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_COUNT_C_Information", HFILL }},
    { &hf_umts_rrc_ies_count_C_MSB_UL,
      { "count-C-MSB-UL", "umts_rrc_ies.count_C_MSB_UL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.COUNT_C_MSB", HFILL }},
    { &hf_umts_rrc_ies_count_C_MSB_DL,
      { "count-C-MSB-DL", "umts_rrc_ies.count_C_MSB_DL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.COUNT_C_MSB", HFILL }},
    { &hf_umts_rrc_ies_RB_COUNT_C_MSB_InformationList_item,
      { "Item", "umts_rrc_ies.RB_COUNT_C_MSB_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_COUNT_C_MSB_Information", HFILL }},
    { &hf_umts_rrc_ies_RB_IdentityList_item,
      { "Item", "umts_rrc_ies.RB_IdentityList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_Identity", HFILL }},
    { &hf_umts_rrc_ies_rb_MappingInfo,
      { "rb-MappingInfo", "umts_rrc_ies.rb_MappingInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_MappingInfo", HFILL }},
    { &hf_umts_rrc_ies_rb_MappingInfo1,
      { "rb-MappingInfo", "umts_rrc_ies.rb_MappingInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_MappingInfo_r5", HFILL }},
    { &hf_umts_rrc_ies_rb_MappingInfo2,
      { "rb-MappingInfo", "umts_rrc_ies.rb_MappingInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_MappingInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationAffectedList_item,
      { "Item", "umts_rrc_ies.RB_InformationAffectedList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationAffected", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationAffectedList_r5_item,
      { "Item", "umts_rrc_ies.RB_InformationAffectedList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationAffected_r5", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationAffectedList_r6_item,
      { "Item", "umts_rrc_ies.RB_InformationAffectedList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationAffected_r6", HFILL }},
    { &hf_umts_rrc_ies_rb_Change,
      { "rb-Change", "umts_rrc_ies.rb_Change",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_rb_Change_vals), 0,
        "umts_rrc_ies.T_rb_Change", HFILL }},
    { &hf_umts_rrc_ies_release1,
      { "release", "umts_rrc_ies.release",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_re_mapToDefaultRb,
      { "re-mapToDefaultRb", "umts_rrc_ies.re_mapToDefaultRb",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_Identity", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationChangedList_r6_item,
      { "Item", "umts_rrc_ies.RB_InformationChangedList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationChanged_r6", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Info2,
      { "pdcp-Info", "umts_rrc_ies.pdcp_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_InfoReconfig", HFILL }},
    { &hf_umts_rrc_ies_pdcp_SN_Info,
      { "pdcp-SN-Info", "umts_rrc_ies.pdcp_SN_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDCP_SN_Info", HFILL }},
    { &hf_umts_rrc_ies_rlc_Info,
      { "rlc-Info", "umts_rrc_ies.rlc_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Info", HFILL }},
    { &hf_umts_rrc_ies_rb_StopContinue,
      { "rb-StopContinue", "umts_rrc_ies.rb_StopContinue",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RB_StopContinue_vals), 0,
        "umts_rrc_ies.RB_StopContinue", HFILL }},
    { &hf_umts_rrc_ies_pdcp_Info3,
      { "pdcp-Info", "umts_rrc_ies.pdcp_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDCP_InfoReconfig_r4", HFILL }},
    { &hf_umts_rrc_ies_rlc_Info1,
      { "rlc-Info", "umts_rrc_ies.rlc_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Info_r5", HFILL }},
    { &hf_umts_rrc_ies_rlc_Info2,
      { "rlc-Info", "umts_rrc_ies.rlc_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationReconfigList_item,
      { "Item", "umts_rrc_ies.RB_InformationReconfigList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationReconfig", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationReconfigList_r4_item,
      { "Item", "umts_rrc_ies.RB_InformationReconfigList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationReconfig_r4", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationReconfigList_r5_item,
      { "Item", "umts_rrc_ies.RB_InformationReconfigList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationReconfig_r5", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationReconfigList_r6_item,
      { "Item", "umts_rrc_ies.RB_InformationReconfigList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationReconfig_r6", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationReleaseList_item,
      { "Item", "umts_rrc_ies.RB_InformationReleaseList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_Identity", HFILL }},
    { &hf_umts_rrc_ies_rlc_InfoChoice,
      { "rlc-InfoChoice", "umts_rrc_ies.rlc_InfoChoice",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RLC_InfoChoice_vals), 0,
        "umts_rrc_ies.RLC_InfoChoice", HFILL }},
    { &hf_umts_rrc_ies_rlc_InfoChoice1,
      { "rlc-InfoChoice", "umts_rrc_ies.rlc_InfoChoice",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RLC_InfoChoice_r5_vals), 0,
        "umts_rrc_ies.RLC_InfoChoice_r5", HFILL }},
    { &hf_umts_rrc_ies_rlc_InfoChoice2,
      { "rlc-InfoChoice", "umts_rrc_ies.rlc_InfoChoice",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RLC_InfoChoice_r6_vals), 0,
        "umts_rrc_ies.RLC_InfoChoice_r6", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationSetupList_item,
      { "Item", "umts_rrc_ies.RB_InformationSetupList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationSetup", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationSetupList_r4_item,
      { "Item", "umts_rrc_ies.RB_InformationSetupList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationSetup_r4", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationSetupList_r5_item,
      { "Item", "umts_rrc_ies.RB_InformationSetupList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationSetup_r5", HFILL }},
    { &hf_umts_rrc_ies_RB_InformationSetupList_r6_item,
      { "Item", "umts_rrc_ies.RB_InformationSetupList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_InformationSetup_r6", HFILL }},
    { &hf_umts_rrc_ies_RB_MappingInfo_item,
      { "Item", "umts_rrc_ies.RB_MappingInfo_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_MappingOption", HFILL }},
    { &hf_umts_rrc_ies_RB_MappingInfo_r5_item,
      { "Item", "umts_rrc_ies.RB_MappingInfo_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_MappingOption_r5", HFILL }},
    { &hf_umts_rrc_ies_RB_MappingInfo_r6_item,
      { "Item", "umts_rrc_ies.RB_MappingInfo_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_MappingOption_r6", HFILL }},
    { &hf_umts_rrc_ies_ul_LogicalChannelMappings,
      { "ul-LogicalChannelMappings", "umts_rrc_ies.ul_LogicalChannelMappings",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_LogicalChannelMappings_vals), 0,
        "umts_rrc_ies.UL_LogicalChannelMappings", HFILL }},
    { &hf_umts_rrc_ies_dl_LogicalChannelMappingList,
      { "dl-LogicalChannelMappingList", "umts_rrc_ies.dl_LogicalChannelMappingList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_LogicalChannelMappingList", HFILL }},
    { &hf_umts_rrc_ies_dl_LogicalChannelMappingList1,
      { "dl-LogicalChannelMappingList", "umts_rrc_ies.dl_LogicalChannelMappingList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_LogicalChannelMappingList_r5", HFILL }},
    { &hf_umts_rrc_ies_ul_LogicalChannelMappings1,
      { "ul-LogicalChannelMappings", "umts_rrc_ies.ul_LogicalChannelMappings",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_LogicalChannelMappings_r6_vals), 0,
        "umts_rrc_ies.UL_LogicalChannelMappings_r6", HFILL }},
    { &hf_umts_rrc_ies_dl_RFC3095_Context_Relocation,
      { "dl-RFC3095-Context-Relocation", "umts_rrc_ies.dl_RFC3095_Context_Relocation",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_RFC3095_Context_Relocation,
      { "ul-RFC3095-Context-Relocation", "umts_rrc_ies.ul_RFC3095_Context_Relocation",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_RB_PDCPContextRelocationList_item,
      { "Item", "umts_rrc_ies.RB_PDCPContextRelocationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_PDCPContextRelocation", HFILL }},
    { &hf_umts_rrc_ies_RB_WithPDCP_InfoList_item,
      { "Item", "umts_rrc_ies.RB_WithPDCP_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RB_WithPDCP_Info", HFILL }},
    { &hf_umts_rrc_ies_f_MAX_PERIOD,
      { "f-MAX-PERIOD", "umts_rrc_ies.f_MAX_PERIOD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_65535", HFILL }},
    { &hf_umts_rrc_ies_f_MAX_TIME,
      { "f-MAX-TIME", "umts_rrc_ies.f_MAX_TIME",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_255", HFILL }},
    { &hf_umts_rrc_ies_max_HEADER,
      { "max-HEADER", "umts_rrc_ies.max_HEADER",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_60_65535", HFILL }},
    { &hf_umts_rrc_ies_tcp_SPACE,
      { "tcp-SPACE", "umts_rrc_ies.tcp_SPACE",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_3_255", HFILL }},
    { &hf_umts_rrc_ies_non_TCP_SPACE,
      { "non-TCP-SPACE", "umts_rrc_ies.non_TCP_SPACE",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_3_65535", HFILL }},
    { &hf_umts_rrc_ies_expectReordering,
      { "expectReordering", "umts_rrc_ies.expectReordering",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ExpectReordering_vals), 0,
        "umts_rrc_ies.ExpectReordering", HFILL }},
    { &hf_umts_rrc_ies_rohcProfileList,
      { "rohcProfileList", "umts_rrc_ies.rohcProfileList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ROHC_ProfileList_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_RFC3095,
      { "ul-RFC3095", "umts_rrc_ies.ul_RFC3095",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_RFC3095_r4", HFILL }},
    { &hf_umts_rrc_ies_dl_RFC3095,
      { "dl-RFC3095", "umts_rrc_ies.dl_RFC3095",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_RFC3095_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_RLC_Mode,
      { "ul-RLC-Mode", "umts_rrc_ies.ul_RLC_Mode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_RLC_Mode_vals), 0,
        "umts_rrc_ies.UL_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_dl_RLC_Mode,
      { "dl-RLC-Mode", "umts_rrc_ies.dl_RLC_Mode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_RLC_Mode_vals), 0,
        "umts_rrc_ies.DL_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_dl_RLC_Mode_r5,
      { "dl-RLC-Mode-r5", "umts_rrc_ies.dl_RLC_Mode_r5",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_RLC_Mode_r5_vals), 0,
        "umts_rrc_ies.DL_RLC_Mode_r5", HFILL }},
    { &hf_umts_rrc_ies_rlc_OneSidedReEst,
      { "rlc-OneSidedReEst", "umts_rrc_ies.rlc_OneSidedReEst",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dl_RLC_Mode_r51,
      { "dl-RLC-Mode-r5", "umts_rrc_ies.dl_RLC_Mode_r5",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_RLC_Mode_r6_vals), 0,
        "umts_rrc_ies.DL_RLC_Mode_r6", HFILL }},
    { &hf_umts_rrc_ies_altE_bitInterpretation,
      { "altE-bitInterpretation", "umts_rrc_ies.altE_bitInterpretation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_altE_bitInterpretation_vals), 0,
        "umts_rrc_ies.T_altE_bitInterpretation", HFILL }},
    { &hf_umts_rrc_ies_dl_UM_RLC_DuplAvoid_Reord_Info,
      { "dl-UM-RLC-DuplAvoid-Reord-Info", "umts_rrc_ies.dl_UM_RLC_DuplAvoid_Reord_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UM_RLC_DuplAvoid_Reord_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_dl_UM_RLC_OutOSeqDelivery_Info,
      { "dl-UM-RLC-OutOSeqDelivery-Info", "umts_rrc_ies.dl_UM_RLC_OutOSeqDelivery_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UM_RLC_OutOSeqDelivery_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_same_as_RB,
      { "same-as-RB", "umts_rrc_ies.same_as_RB",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RB_Identity", HFILL }},
    { &hf_umts_rrc_ies_rlc_Info_r5,
      { "rlc-Info-r5", "umts_rrc_ies.rlc_Info_r5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Info_r5", HFILL }},
    { &hf_umts_rrc_ies_rlc_Info_r6,
      { "rlc-Info-r6", "umts_rrc_ies.rlc_Info_r6",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_RLC_PDU_SizeList_item,
      { "Item", "umts_rrc_ies.RLC_PDU_SizeList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_OctetModeRLC_SizeInfoType1_vals), 0,
        "umts_rrc_ies.RLC_PDU_Size", HFILL }},
    { &hf_umts_rrc_ies_rlc_SizeIndex,
      { "rlc-SizeIndex", "umts_rrc_ies.rlc_SizeIndex",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxTF", HFILL }},
    { &hf_umts_rrc_ies_RLC_SizeExplicitList_item,
      { "Item", "umts_rrc_ies.RLC_SizeExplicitList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_SizeInfo", HFILL }},
    { &hf_umts_rrc_ies_ROHC_ProfileList_r4_item,
      { "Item", "umts_rrc_ies.ROHC_ProfileList_r4_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ROHC_Profile_r4", HFILL }},
    { &hf_umts_rrc_ies_ROHC_PacketSizeList_r4_item,
      { "Item", "umts_rrc_ies.ROHC_PacketSizeList_r4_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ROHC_PacketSize_r4", HFILL }},
    { &hf_umts_rrc_ies_SRB_InformationSetupList_item,
      { "Item", "umts_rrc_ies.SRB_InformationSetupList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SRB_InformationSetup", HFILL }},
    { &hf_umts_rrc_ies_SRB_InformationSetupList_r5_item,
      { "Item", "umts_rrc_ies.SRB_InformationSetupList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SRB_InformationSetup_r5", HFILL }},
    { &hf_umts_rrc_ies_SRB_InformationSetupList_r6_item,
      { "Item", "umts_rrc_ies.SRB_InformationSetupList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SRB_InformationSetup_r6", HFILL }},
    { &hf_umts_rrc_ies_SRB_InformationSetupList2_item,
      { "Item", "umts_rrc_ies.SRB_InformationSetupList2_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SRB_InformationSetup", HFILL }},
    { &hf_umts_rrc_ies_timerBasedExplicit,
      { "timerBasedExplicit", "umts_rrc_ies.timerBasedExplicit",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ExplicitDiscard", HFILL }},
    { &hf_umts_rrc_ies_timerBasedNoExplicit,
      { "timerBasedNoExplicit", "umts_rrc_ies.timerBasedNoExplicit",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_NoExplicitDiscard_vals), 0,
        "umts_rrc_ies.NoExplicitDiscard", HFILL }},
    { &hf_umts_rrc_ies_maxDAT_Retransmissions,
      { "maxDAT-Retransmissions", "umts_rrc_ies.maxDAT_Retransmissions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MaxDAT_Retransmissions", HFILL }},
    { &hf_umts_rrc_ies_noDiscard,
      { "noDiscard", "umts_rrc_ies.noDiscard",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxDAT_vals), 0,
        "umts_rrc_ies.MaxDAT", HFILL }},
    { &hf_umts_rrc_ies_transmissionRLC_Discard,
      { "transmissionRLC-Discard", "umts_rrc_ies.transmissionRLC_Discard",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransmissionRLC_Discard_vals), 0,
        "umts_rrc_ies.TransmissionRLC_Discard", HFILL }},
    { &hf_umts_rrc_ies_transmissionWindowSize,
      { "transmissionWindowSize", "umts_rrc_ies.transmissionWindowSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransmissionWindowSize_vals), 0,
        "umts_rrc_ies.TransmissionWindowSize", HFILL }},
    { &hf_umts_rrc_ies_timerRST,
      { "timerRST", "umts_rrc_ies.timerRST",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerRST_vals), 0,
        "umts_rrc_ies.TimerRST", HFILL }},
    { &hf_umts_rrc_ies_max_RST,
      { "max-RST", "umts_rrc_ies.max_RST",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxRST_vals), 0,
        "umts_rrc_ies.MaxRST", HFILL }},
    { &hf_umts_rrc_ies_pollingInfo,
      { "pollingInfo", "umts_rrc_ies.pollingInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PollingInfo", HFILL }},
    { &hf_umts_rrc_ies_startList,
      { "startList", "umts_rrc_ies.startList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.STARTList", HFILL }},
    { &hf_umts_rrc_ies_ul_TransportChannelType,
      { "ul-TransportChannelType", "umts_rrc_ies.ul_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TransportChannelType_vals), 0,
        "umts_rrc_ies.UL_TransportChannelType", HFILL }},
    { &hf_umts_rrc_ies_rlc_SizeList,
      { "rlc-SizeList", "umts_rrc_ies.rlc_SizeList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_rlc_SizeList_vals), 0,
        "umts_rrc_ies.T_rlc_SizeList", HFILL }},
    { &hf_umts_rrc_ies_allSizes,
      { "allSizes", "umts_rrc_ies.allSizes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_configured,
      { "configured", "umts_rrc_ies.configured",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_explicitList,
      { "explicitList", "umts_rrc_ies.explicitList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RLC_SizeExplicitList", HFILL }},
    { &hf_umts_rrc_ies_mac_LogicalChannelPriority,
      { "mac-LogicalChannelPriority", "umts_rrc_ies.mac_LogicalChannelPriority",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_LogicalChannelPriority", HFILL }},
    { &hf_umts_rrc_ies_ul_TrCH_Type,
      { "ul-TrCH-Type", "umts_rrc_ies.ul_TrCH_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ul_TrCH_Type_vals), 0,
        "umts_rrc_ies.T_ul_TrCH_Type", HFILL }},
    { &hf_umts_rrc_ies_dch_rach_cpch_usch,
      { "dch-rach-cpch-usch", "umts_rrc_ies.dch_rach_cpch_usch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_dch_rach_cpch_usch", HFILL }},
    { &hf_umts_rrc_ies_rlc_SizeList1,
      { "rlc-SizeList", "umts_rrc_ies.rlc_SizeList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_rlc_SizeList1_vals), 0,
        "umts_rrc_ies.T_rlc_SizeList1", HFILL }},
    { &hf_umts_rrc_ies_e_dch,
      { "e-dch", "umts_rrc_ies.e_dch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_e_dch", HFILL }},
    { &hf_umts_rrc_ies_e_DCH_MAC_d_FlowIdentity,
      { "e-DCH-MAC-d-FlowIdentity", "umts_rrc_ies.e_DCH_MAC_d_FlowIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DCH_MAC_d_FlowIdentity", HFILL }},
    { &hf_umts_rrc_ies_ddi,
      { "ddi", "umts_rrc_ies.ddi",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DDI", HFILL }},
    { &hf_umts_rrc_ies_rlc_PDU_SizeList,
      { "rlc-PDU-SizeList", "umts_rrc_ies.rlc_PDU_SizeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RLC_PDU_SizeList", HFILL }},
    { &hf_umts_rrc_ies_includeInSchedulingInfo,
      { "includeInSchedulingInfo", "umts_rrc_ies.includeInSchedulingInfo",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_rlc_LogicalChannelMappingIndicator,
      { "rlc-LogicalChannelMappingIndicator", "umts_rrc_ies.rlc_LogicalChannelMappingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_LogicalChannelMapping,
      { "ul-LogicalChannelMapping", "umts_rrc_ies.ul_LogicalChannelMapping",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping", HFILL }},
    { &hf_umts_rrc_ies_ul_LogicalChannelMapping_item,
      { "Item", "umts_rrc_ies.ul_LogicalChannelMapping_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_LogicalChannelMapping", HFILL }},
    { &hf_umts_rrc_ies_ul_LogicalChannelMapping1,
      { "ul-LogicalChannelMapping", "umts_rrc_ies.ul_LogicalChannelMapping",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6", HFILL }},
    { &hf_umts_rrc_ies_ul_LogicalChannelMapping_item1,
      { "Item", "umts_rrc_ies.ul_LogicalChannelMapping_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_LogicalChannelMapping_r6", HFILL }},
    { &hf_umts_rrc_ies_oneLogicalChannel,
      { "oneLogicalChannel", "umts_rrc_ies.oneLogicalChannel",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_LogicalChannelMapping", HFILL }},
    { &hf_umts_rrc_ies_twoLogicalChannels,
      { "twoLogicalChannels", "umts_rrc_ies.twoLogicalChannels",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_LogicalChannelMappingList", HFILL }},
    { &hf_umts_rrc_ies_oneLogicalChannel1,
      { "oneLogicalChannel", "umts_rrc_ies.oneLogicalChannel",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_LogicalChannelMapping_r6", HFILL }},
    { &hf_umts_rrc_ies_twoLogicalChannels1,
      { "twoLogicalChannels", "umts_rrc_ies.twoLogicalChannels",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_LogicalChannelMappingList_r6", HFILL }},
    { &hf_umts_rrc_ies_rohcPacketSizeList,
      { "rohcPacketSizeList", "umts_rrc_ies.rohcPacketSizeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ROHC_PacketSizeList_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_AM_RLC_Mode,
      { "ul-AM-RLC-Mode", "umts_rrc_ies.ul_AM_RLC_Mode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_AM_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_ul_UM_RLC_Mode,
      { "ul-UM-RLC-Mode", "umts_rrc_ies.ul_UM_RLC_Mode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_UM_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_ul_TM_RLC_Mode,
      { "ul-TM-RLC-Mode", "umts_rrc_ies.ul_TM_RLC_Mode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_TM_RLC_Mode", HFILL }},
    { &hf_umts_rrc_ies_rach,
      { "rach", "umts_rrc_ies.rach",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_usch,
      { "usch", "umts_rrc_ies.usch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_timer_DAR,
      { "timer-DAR", "umts_rrc_ies.timer_DAR",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerDAR_r6_vals), 0,
        "umts_rrc_ies.TimerDAR_r6", HFILL }},
    { &hf_umts_rrc_ies_widowSize_DAR,
      { "widowSize-DAR", "umts_rrc_ies.widowSize_DAR",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_WindowSizeDAR_r6_vals), 0,
        "umts_rrc_ies.WindowSizeDAR_r6", HFILL }},
    { &hf_umts_rrc_ies_timer_OSD,
      { "timer-OSD", "umts_rrc_ies.timer_OSD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimerOSD_r6_vals), 0,
        "umts_rrc_ies.TimerOSD_r6", HFILL }},
    { &hf_umts_rrc_ies_windowSize_OSD,
      { "windowSize-OSD", "umts_rrc_ies.windowSize_OSD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_WindowSizeOSD_r6_vals), 0,
        "umts_rrc_ies.WindowSizeOSD_r6", HFILL }},
    { &hf_umts_rrc_ies_mac_hs_AddReconfQueue_List,
      { "mac-hs-AddReconfQueue-List", "umts_rrc_ies.mac_hs_AddReconfQueue_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_hs_AddReconfQueue_List", HFILL }},
    { &hf_umts_rrc_ies_mac_hs_DelQueue_List,
      { "mac-hs-DelQueue-List", "umts_rrc_ies.mac_hs_DelQueue_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_hs_DelQueue_List", HFILL }},
    { &hf_umts_rrc_ies_AllowedTFC_List_item,
      { "Item", "umts_rrc_ies.AllowedTFC_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFC_Value", HFILL }},
    { &hf_umts_rrc_ies_AllowedTFI_List_item,
      { "Item", "umts_rrc_ies.AllowedTFI_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_sizeType1,
      { "sizeType1", "umts_rrc_ies.sizeType1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_sizeType2,
      { "sizeType2", "umts_rrc_ies.sizeType2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sizeType2", HFILL }},
    { &hf_umts_rrc_ies_part1,
      { "part1", "umts_rrc_ies.part1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_part2,
      { "part2", "umts_rrc_ies.part2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_7", HFILL }},
    { &hf_umts_rrc_ies_sizeType3,
      { "sizeType3", "umts_rrc_ies.sizeType3",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sizeType3", HFILL }},
    { &hf_umts_rrc_ies_part11,
      { "part1", "umts_rrc_ies.part1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_47", HFILL }},
    { &hf_umts_rrc_ies_part21,
      { "part2", "umts_rrc_ies.part2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_15", HFILL }},
    { &hf_umts_rrc_ies_sizeType4,
      { "sizeType4", "umts_rrc_ies.sizeType4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sizeType4", HFILL }},
    { &hf_umts_rrc_ies_part12,
      { "part1", "umts_rrc_ies.part1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_62", HFILL }},
    { &hf_umts_rrc_ies_part22,
      { "part2", "umts_rrc_ies.part2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_63", HFILL }},
    { &hf_umts_rrc_ies_noCoding,
      { "noCoding", "umts_rrc_ies.noCoding",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_convolutional,
      { "convolutional", "umts_rrc_ies.convolutional",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CodingRate_vals), 0,
        "umts_rrc_ies.CodingRate", HFILL }},
    { &hf_umts_rrc_ies_turbo,
      { "turbo", "umts_rrc_ies.turbo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_rlc_Size,
      { "rlc-Size", "umts_rrc_ies.rlc_Size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_rlc_Size_vals), 0,
        "umts_rrc_ies.T_rlc_Size", HFILL }},
    { &hf_umts_rrc_ies_fdd3,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd2", HFILL }},
    { &hf_umts_rrc_ies_octetModeRLC_SizeInfoType2,
      { "octetModeRLC-SizeInfoType2", "umts_rrc_ies.octetModeRLC_SizeInfoType2",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_OctetModeRLC_SizeInfoType2_vals), 0,
        "umts_rrc_ies.OctetModeRLC_SizeInfoType2", HFILL }},
    { &hf_umts_rrc_ies_tdd2,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd2", HFILL }},
    { &hf_umts_rrc_ies_commonTDD_Choice,
      { "commonTDD-Choice", "umts_rrc_ies.commonTDD_Choice",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_commonTDD_Choice_vals), 0,
        "umts_rrc_ies.T_commonTDD_Choice", HFILL }},
    { &hf_umts_rrc_ies_bitModeRLC_SizeInfo,
      { "bitModeRLC-SizeInfo", "umts_rrc_ies.bitModeRLC_SizeInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_BitModeRLC_SizeInfo_vals), 0,
        "umts_rrc_ies.BitModeRLC_SizeInfo", HFILL }},
    { &hf_umts_rrc_ies_octetModeRLC_SizeInfoType1,
      { "octetModeRLC-SizeInfoType1", "umts_rrc_ies.octetModeRLC_SizeInfoType1",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_OctetModeRLC_SizeInfoType1_vals), 0,
        "umts_rrc_ies.OctetModeRLC_SizeInfoType1", HFILL }},
    { &hf_umts_rrc_ies_numberOfTbSizeList,
      { "numberOfTbSizeList", "umts_rrc_ies.numberOfTbSizeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks", HFILL }},
    { &hf_umts_rrc_ies_numberOfTbSizeList_item,
      { "Item", "umts_rrc_ies.numberOfTbSizeList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_NumberOfTransportBlocks_vals), 0,
        "umts_rrc_ies.NumberOfTransportBlocks", HFILL }},
    { &hf_umts_rrc_ies_logicalChannelList,
      { "logicalChannelList", "umts_rrc_ies.logicalChannelList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_LogicalChannelList_vals), 0,
        "umts_rrc_ies.LogicalChannelList", HFILL }},
    { &hf_umts_rrc_ies_commonTDD_Choice1,
      { "commonTDD-Choice", "umts_rrc_ies.commonTDD_Choice",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_commonTDD_Choice1_vals), 0,
        "umts_rrc_ies.T_commonTDD_Choice1", HFILL }},
    { &hf_umts_rrc_ies_numberOfTbSizeAndTTIList,
      { "numberOfTbSizeAndTTIList", "umts_rrc_ies.numberOfTbSizeAndTTIList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NumberOfTbSizeAndTTIList", HFILL }},
    { &hf_umts_rrc_ies_CommonDynamicTF_InfoList_item,
      { "Item", "umts_rrc_ies.CommonDynamicTF_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_Info", HFILL }},
    { &hf_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI_item,
      { "Item", "umts_rrc_ies.CommonDynamicTF_InfoList_DynamicTTI_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_Info_DynamicTTI", HFILL }},
    { &hf_umts_rrc_ies_tti,
      { "tti", "umts_rrc_ies.tti",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tti_vals), 0,
        "umts_rrc_ies.T_tti", HFILL }},
    { &hf_umts_rrc_ies_tti10,
      { "tti10", "umts_rrc_ies.tti10",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_tti20,
      { "tti20", "umts_rrc_ies.tti20",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_tti40,
      { "tti40", "umts_rrc_ies.tti40",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_tti80,
      { "tti80", "umts_rrc_ies.tti80",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_dynamic,
      { "dynamic", "umts_rrc_ies.dynamic",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_InfoList_DynamicTTI", HFILL }},
    { &hf_umts_rrc_ies_semistaticTF_Information,
      { "semistaticTF-Information", "umts_rrc_ies.semistaticTF_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SemistaticTF_Information", HFILL }},
    { &hf_umts_rrc_ies_tti1,
      { "tti", "umts_rrc_ies.tti",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tti1_vals), 0,
        "umts_rrc_ies.T_tti1", HFILL }},
    { &hf_umts_rrc_ies_tti5,
      { "tti5", "umts_rrc_ies.tti5",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CommonDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_rlc_Size1,
      { "rlc-Size", "umts_rrc_ies.rlc_Size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_rlc_Size1_vals), 0,
        "umts_rrc_ies.T_rlc_Size1", HFILL }},
    { &hf_umts_rrc_ies_bitMode,
      { "bitMode", "umts_rrc_ies.bitMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_BitModeRLC_SizeInfo_vals), 0,
        "umts_rrc_ies.BitModeRLC_SizeInfo", HFILL }},
    { &hf_umts_rrc_ies_octetModeType1,
      { "octetModeType1", "umts_rrc_ies.octetModeType1",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_OctetModeRLC_SizeInfoType1_vals), 0,
        "umts_rrc_ies.OctetModeRLC_SizeInfoType1", HFILL }},
    { &hf_umts_rrc_ies_rlc_Size2,
      { "rlc-Size", "umts_rrc_ies.rlc_Size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_rlc_Size2_vals), 0,
        "umts_rrc_ies.T_rlc_Size2", HFILL }},
    { &hf_umts_rrc_ies_DedicatedDynamicTF_InfoList_item,
      { "Item", "umts_rrc_ies.DedicatedDynamicTF_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_Info", HFILL }},
    { &hf_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI_item,
      { "Item", "umts_rrc_ies.DedicatedDynamicTF_InfoList_DynamicTTI_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_Info_DynamicTTI", HFILL }},
    { &hf_umts_rrc_ies_tti2,
      { "tti", "umts_rrc_ies.tti",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tti2_vals), 0,
        "umts_rrc_ies.T_tti2", HFILL }},
    { &hf_umts_rrc_ies_tti101,
      { "tti10", "umts_rrc_ies.tti10",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_tti201,
      { "tti20", "umts_rrc_ies.tti20",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_tti401,
      { "tti40", "umts_rrc_ies.tti40",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_tti801,
      { "tti80", "umts_rrc_ies.tti80",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_InfoList", HFILL }},
    { &hf_umts_rrc_ies_dynamic1,
      { "dynamic", "umts_rrc_ies.dynamic",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DedicatedDynamicTF_InfoList_DynamicTTI", HFILL }},
    { &hf_umts_rrc_ies_DL_AddReconfTransChInfo2List_item,
      { "Item", "umts_rrc_ies.DL_AddReconfTransChInfo2List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_AddReconfTransChInformation2", HFILL }},
    { &hf_umts_rrc_ies_DL_AddReconfTransChInfoList_item,
      { "Item", "umts_rrc_ies.DL_AddReconfTransChInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_AddReconfTransChInformation", HFILL }},
    { &hf_umts_rrc_ies_DL_AddReconfTransChInfoList_r4_item,
      { "Item", "umts_rrc_ies.DL_AddReconfTransChInfoList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_AddReconfTransChInformation_r4", HFILL }},
    { &hf_umts_rrc_ies_DL_AddReconfTransChInfoList_r5_item,
      { "Item", "umts_rrc_ies.DL_AddReconfTransChInfoList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_AddReconfTransChInformation_r5", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelType2,
      { "dl-TransportChannelType", "umts_rrc_ies.dl_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TrCH_Type_vals), 0,
        "umts_rrc_ies.DL_TrCH_Type", HFILL }},
    { &hf_umts_rrc_ies_dl_transportChannelIdentity,
      { "dl-transportChannelIdentity", "umts_rrc_ies.dl_transportChannelIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_tfs_SignallingMode,
      { "tfs-SignallingMode", "umts_rrc_ies.tfs_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tfs_SignallingMode_vals), 0,
        "umts_rrc_ies.T_tfs_SignallingMode", HFILL }},
    { &hf_umts_rrc_ies_explicit_config,
      { "explicit-config", "umts_rrc_ies.explicit_config",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_sameAsULTrCH,
      { "sameAsULTrCH", "umts_rrc_ies.sameAsULTrCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dch_QualityTarget,
      { "dch-QualityTarget", "umts_rrc_ies.dch_QualityTarget",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.QualityTarget", HFILL }},
    { &hf_umts_rrc_ies_dummy_TM_SignallingInfo,
      { "dummy-TM-SignallingInfo", "umts_rrc_ies.dummy_TM_SignallingInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TM_SignallingInfo", HFILL }},
    { &hf_umts_rrc_ies_tfs_SignallingMode1,
      { "tfs-SignallingMode", "umts_rrc_ies.tfs_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tfs_SignallingMode1_vals), 0,
        "umts_rrc_ies.T_tfs_SignallingMode1", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelType3,
      { "dl-TransportChannelType", "umts_rrc_ies.dl_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TrCH_TypeId1_r5_vals), 0,
        "umts_rrc_ies.DL_TrCH_TypeId1_r5", HFILL }},
    { &hf_umts_rrc_ies_tfs_SignallingMode2,
      { "tfs-SignallingMode", "umts_rrc_ies.tfs_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tfs_SignallingMode2_vals), 0,
        "umts_rrc_ies.T_tfs_SignallingMode2", HFILL }},
    { &hf_umts_rrc_ies_hsdsch1,
      { "hsdsch", "umts_rrc_ies.hsdsch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HSDSCH_Info", HFILL }},
    { &hf_umts_rrc_ies_transportChannelIdentity,
      { "transportChannelIdentity", "umts_rrc_ies.transportChannelIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_tfs_SignallingMode3,
      { "tfs-SignallingMode", "umts_rrc_ies.tfs_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tfs_SignallingMode3_vals), 0,
        "umts_rrc_ies.T_tfs_SignallingMode3", HFILL }},
    { &hf_umts_rrc_ies_qualityTarget,
      { "qualityTarget", "umts_rrc_ies.qualityTarget",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.QualityTarget", HFILL }},
    { &hf_umts_rrc_ies_sccpch_TFCS,
      { "sccpch-TFCS", "umts_rrc_ies.sccpch_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo2,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo2_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo2", HFILL }},
    { &hf_umts_rrc_ies_fdd4,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd3", HFILL }},
    { &hf_umts_rrc_ies_dl_Parameters,
      { "dl-Parameters", "umts_rrc_ies.dl_Parameters",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_dl_Parameters_vals), 0,
        "umts_rrc_ies.T_dl_Parameters", HFILL }},
    { &hf_umts_rrc_ies_dl_DCH_TFCS,
      { "dl-DCH-TFCS", "umts_rrc_ies.dl_DCH_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_sameAsUL,
      { "sameAsUL", "umts_rrc_ies.sameAsUL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_tdd3,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3", HFILL }},
    { &hf_umts_rrc_ies_individualDL_CCTrCH_InfoList,
      { "individualDL-CCTrCH-InfoList", "umts_rrc_ies.individualDL_CCTrCH_InfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IndividualDL_CCTrCH_InfoList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo3,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo3_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo3", HFILL }},
    { &hf_umts_rrc_ies_fdd5,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd4", HFILL }},
    { &hf_umts_rrc_ies_dl_Parameters1,
      { "dl-Parameters", "umts_rrc_ies.dl_Parameters",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_dl_Parameters1_vals), 0,
        "umts_rrc_ies.T_dl_Parameters1", HFILL }},
    { &hf_umts_rrc_ies_dl_DCH_TFCS1,
      { "dl-DCH-TFCS", "umts_rrc_ies.dl_DCH_TFCS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_dl_DCH_TFCS", HFILL }},
    { &hf_umts_rrc_ies_tfcs,
      { "tfcs", "umts_rrc_ies.tfcs",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_tdd4,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd4", HFILL }},
    { &hf_umts_rrc_ies_DL_DeletedTransChInfoList_item,
      { "Item", "umts_rrc_ies.DL_DeletedTransChInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_DL_DeletedTransChInfoList_r5_item,
      { "Item", "umts_rrc_ies.DL_DeletedTransChInfoList_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_TransportChannelIdentity_r5", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelIdentity,
      { "dl-TransportChannelIdentity", "umts_rrc_ies.dl_TransportChannelIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelType4,
      { "dl-TransportChannelType", "umts_rrc_ies.dl_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TrCH_TypeId2_r5_vals), 0,
        "umts_rrc_ies.DL_TrCH_TypeId2_r5", HFILL }},
    { &hf_umts_rrc_ies_hsdsch2,
      { "hsdsch", "umts_rrc_ies.hsdsch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_transmissionTimeValidity,
      { "transmissionTimeValidity", "umts_rrc_ies.transmissionTimeValidity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransmissionTimeValidity", HFILL }},
    { &hf_umts_rrc_ies_timeDurationBeforeRetry,
      { "timeDurationBeforeRetry", "umts_rrc_ies.timeDurationBeforeRetry",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeDurationBeforeRetry", HFILL }},
    { &hf_umts_rrc_ies_drac_ClassIdentity,
      { "drac-ClassIdentity", "umts_rrc_ies.drac_ClassIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DRAC_ClassIdentity", HFILL }},
    { &hf_umts_rrc_ies_DRAC_StaticInformationList_item,
      { "Item", "umts_rrc_ies.DRAC_StaticInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DRAC_StaticInformation", HFILL }},
    { &hf_umts_rrc_ies_mac_d_FlowIdentity,
      { "mac-d-FlowIdentity", "umts_rrc_ies.mac_d_FlowIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DCH_MAC_d_FlowIdentity", HFILL }},
    { &hf_umts_rrc_ies_mac_d_FlowPowerOffset,
      { "mac-d-FlowPowerOffset", "umts_rrc_ies.mac_d_FlowPowerOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DCH_MAC_d_FlowPowerOffset", HFILL }},
    { &hf_umts_rrc_ies_mac_d_FlowMaxRetrans,
      { "mac-d-FlowMaxRetrans", "umts_rrc_ies.mac_d_FlowMaxRetrans",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DCH_MAC_d_FlowMaxRetrans", HFILL }},
    { &hf_umts_rrc_ies_mac_d_FlowMultiplexingList,
      { "mac-d-FlowMultiplexingList", "umts_rrc_ies.mac_d_FlowMultiplexingList",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.E_DCH_MAC_d_FlowMultiplexingList", HFILL }},
    { &hf_umts_rrc_ies_transmissionGrantType,
      { "transmissionGrantType", "umts_rrc_ies.transmissionGrantType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_transmissionGrantType_vals), 0,
        "umts_rrc_ies.T_transmissionGrantType", HFILL }},
    { &hf_umts_rrc_ies_non_ScheduledTranmGrantInfo,
      { "non-ScheduledTranmGrantInfo", "umts_rrc_ies.non_ScheduledTranmGrantInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_non_ScheduledTranmGrantInfo", HFILL }},
    { &hf_umts_rrc_ies_maxMAC_e_PDUContents,
      { "maxMAC-e-PDUContents", "umts_rrc_ies.maxMAC_e_PDUContents",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_19982", HFILL }},
    { &hf_umts_rrc_ies_ms2_NonSchedTransmGrantHARQAlloc,
      { "ms2-NonSchedTransmGrantHARQAlloc", "umts_rrc_ies.ms2_NonSchedTransmGrantHARQAlloc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_scheduledTransmissionGrantInfo,
      { "scheduledTransmissionGrantInfo", "umts_rrc_ies.scheduledTransmissionGrantInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_harq_RV_Configuration,
      { "harq-RV-Configuration", "umts_rrc_ies.harq_RV_Configuration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_harq_RV_Configuration_vals), 0,
        "umts_rrc_ies.T_harq_RV_Configuration", HFILL }},
    { &hf_umts_rrc_ies_complete,
      { "complete", "umts_rrc_ies.complete",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_ReconfAdd", HFILL }},
    { &hf_umts_rrc_ies_addition,
      { "addition", "umts_rrc_ies.addition",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_ReconfAdd", HFILL }},
    { &hf_umts_rrc_ies_removal,
      { "removal", "umts_rrc_ies.removal",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFCS_RemovalList", HFILL }},
    { &hf_umts_rrc_ies_replacement,
      { "replacement", "umts_rrc_ies.replacement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_replacement", HFILL }},
    { &hf_umts_rrc_ies_tfcsRemoval,
      { "tfcsRemoval", "umts_rrc_ies.tfcsRemoval",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFCS_RemovalList", HFILL }},
    { &hf_umts_rrc_ies_tfcsAdd,
      { "tfcsAdd", "umts_rrc_ies.tfcsAdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_ReconfAdd", HFILL }},
    { &hf_umts_rrc_ies_signalledGainFactors,
      { "signalledGainFactors", "umts_rrc_ies.signalledGainFactors",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SignalledGainFactors", HFILL }},
    { &hf_umts_rrc_ies_computedGainFactors,
      { "computedGainFactors", "umts_rrc_ies.computedGainFactors",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ReferenceTFC_ID", HFILL }},
    { &hf_umts_rrc_ies_addOrReconfMAC_dFlow,
      { "addOrReconfMAC-dFlow", "umts_rrc_ies.addOrReconfMAC_dFlow",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AddOrReconfMAC_dFlow", HFILL }},
    { &hf_umts_rrc_ies_numberOfProcesses,
      { "numberOfProcesses", "umts_rrc_ies.numberOfProcesses",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_8", HFILL }},
    { &hf_umts_rrc_ies_memoryPartitioning,
      { "memoryPartitioning", "umts_rrc_ies.memoryPartitioning",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_memoryPartitioning_vals), 0,
        "umts_rrc_ies.T_memoryPartitioning", HFILL }},
    { &hf_umts_rrc_ies_implicit,
      { "implicit", "umts_rrc_ies.implicit",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_explicit,
      { "explicit", "umts_rrc_ies.explicit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize", HFILL }},
    { &hf_umts_rrc_ies_explicit_item,
      { "Item", "umts_rrc_ies.explicit_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_HARQMemorySize_vals), 0,
        "umts_rrc_ies.HARQMemorySize", HFILL }},
    { &hf_umts_rrc_ies_dl_TFCS_Identity,
      { "dl-TFCS-Identity", "umts_rrc_ies.dl_TFCS_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_tfcs_SignallingMode,
      { "tfcs-SignallingMode", "umts_rrc_ies.tfcs_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tfcs_SignallingMode_vals), 0,
        "umts_rrc_ies.T_tfcs_SignallingMode", HFILL }},
    { &hf_umts_rrc_ies_explicit_config1,
      { "explicit-config", "umts_rrc_ies.explicit_config",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_sameAsUL1,
      { "sameAsUL", "umts_rrc_ies.sameAsUL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_IndividualDL_CCTrCH_InfoList_item,
      { "Item", "umts_rrc_ies.IndividualDL_CCTrCH_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualDL_CCTrCH_Info", HFILL }},
    { &hf_umts_rrc_ies_ul_TFCS_Identity,
      { "ul-TFCS-Identity", "umts_rrc_ies.ul_TFCS_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_ul_TFCS,
      { "ul-TFCS", "umts_rrc_ies.ul_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_tfc_Subset,
      { "tfc-Subset", "umts_rrc_ies.tfc_Subset",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFC_Subset_vals), 0,
        "umts_rrc_ies.TFC_Subset", HFILL }},
    { &hf_umts_rrc_ies_IndividualUL_CCTrCH_InfoList_item,
      { "Item", "umts_rrc_ies.IndividualUL_CCTrCH_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualUL_CCTrCH_Info", HFILL }},
    { &hf_umts_rrc_ies_logChOfRb,
      { "logChOfRb", "umts_rrc_ies.logChOfRb",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1", HFILL }},
    { &hf_umts_rrc_ies_explicitList1,
      { "explicitList", "umts_rrc_ies.explicitList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB", HFILL }},
    { &hf_umts_rrc_ies_explicitList_item,
      { "Item", "umts_rrc_ies.explicitList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.LogicalChannelByRB", HFILL }},
    { &hf_umts_rrc_ies_dch_transport_ch_id,
      { "dch-transport-ch-id", "umts_rrc_ies.dch_transport_ch_id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_hsdsch_mac_d_flow_id,
      { "hsdsch-mac-d-flow-id", "umts_rrc_ies.hsdsch_mac_d_flow_id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_d_FlowIdentity", HFILL }},
    { &hf_umts_rrc_ies_MAC_d_PDU_SizeInfo_List_item,
      { "Item", "umts_rrc_ies.MAC_d_PDU_SizeInfo_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MAC_d_PDUsizeInfo", HFILL }},
    { &hf_umts_rrc_ies_mac_d_PDU_Size,
      { "mac-d-PDU-Size", "umts_rrc_ies.mac_d_PDU_Size",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_5000", HFILL }},
    { &hf_umts_rrc_ies_mac_d_PDU_Index,
      { "mac-d-PDU-Index", "umts_rrc_ies.mac_d_PDU_Index",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_MAC_hs_AddReconfQueue_List_item,
      { "Item", "umts_rrc_ies.MAC_hs_AddReconfQueue_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MAC_hs_AddReconfQueue", HFILL }},
    { &hf_umts_rrc_ies_mac_hsQueueId,
      { "mac-hsQueueId", "umts_rrc_ies.mac_hsQueueId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_mac_dFlowId,
      { "mac-dFlowId", "umts_rrc_ies.mac_dFlowId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_d_FlowIdentity", HFILL }},
    { &hf_umts_rrc_ies_reorderingReleaseTimer,
      { "reorderingReleaseTimer", "umts_rrc_ies.reorderingReleaseTimer",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T1_ReleaseTimer_vals), 0,
        "umts_rrc_ies.T1_ReleaseTimer", HFILL }},
    { &hf_umts_rrc_ies_mac_hsWindowSize,
      { "mac-hsWindowSize", "umts_rrc_ies.mac_hsWindowSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MAC_hs_WindowSize_vals), 0,
        "umts_rrc_ies.MAC_hs_WindowSize", HFILL }},
    { &hf_umts_rrc_ies_mac_d_PDU_SizeInfo_List,
      { "mac-d-PDU-SizeInfo-List", "umts_rrc_ies.mac_d_PDU_SizeInfo_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MAC_d_PDU_SizeInfo_List", HFILL }},
    { &hf_umts_rrc_ies_MAC_hs_DelQueue_List_item,
      { "Item", "umts_rrc_ies.MAC_hs_DelQueue_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MAC_hs_DelQueue", HFILL }},
    { &hf_umts_rrc_ies_NumberOfTbSizeAndTTIList_item,
      { "Item", "umts_rrc_ies.NumberOfTbSizeAndTTIList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NumberOfTbSizeAndTTIList_item", HFILL }},
    { &hf_umts_rrc_ies_numberOfTransportBlocks,
      { "numberOfTransportBlocks", "umts_rrc_ies.numberOfTransportBlocks",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_NumberOfTransportBlocks_vals), 0,
        "umts_rrc_ies.NumberOfTransportBlocks", HFILL }},
    { &hf_umts_rrc_ies_transmissionTimeInterval,
      { "transmissionTimeInterval", "umts_rrc_ies.transmissionTimeInterval",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransmissionTimeInterval_vals), 0,
        "umts_rrc_ies.TransmissionTimeInterval", HFILL }},
    { &hf_umts_rrc_ies_Non_allowedTFC_List_item,
      { "Item", "umts_rrc_ies.Non_allowedTFC_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFC_Value", HFILL }},
    { &hf_umts_rrc_ies_zero,
      { "zero", "umts_rrc_ies.zero",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_one,
      { "one", "umts_rrc_ies.one",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_small,
      { "small", "umts_rrc_ies.small",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_2_17", HFILL }},
    { &hf_umts_rrc_ies_large,
      { "large", "umts_rrc_ies.large",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_18_512", HFILL }},
    { &hf_umts_rrc_ies_sizeType11,
      { "sizeType1", "umts_rrc_ies.sizeType1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_sizeType21,
      { "sizeType2", "umts_rrc_ies.sizeType2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sizeType21", HFILL }},
    { &hf_umts_rrc_ies_part13,
      { "part1", "umts_rrc_ies.part1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_23", HFILL }},
    { &hf_umts_rrc_ies_part23,
      { "part2", "umts_rrc_ies.part2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_3", HFILL }},
    { &hf_umts_rrc_ies_sizeType31,
      { "sizeType3", "umts_rrc_ies.sizeType3",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sizeType31", HFILL }},
    { &hf_umts_rrc_ies_part14,
      { "part1", "umts_rrc_ies.part1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_61", HFILL }},
    { &hf_umts_rrc_ies_sizeType22,
      { "sizeType2", "umts_rrc_ies.sizeType2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_sizeType32,
      { "sizeType3", "umts_rrc_ies.sizeType3",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_56", HFILL }},
    { &hf_umts_rrc_ies_referenceTFC,
      { "referenceTFC", "umts_rrc_ies.referenceTFC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFC_Value", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo4,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo4_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo4", HFILL }},
    { &hf_umts_rrc_ies_fdd6,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd5", HFILL }},
    { &hf_umts_rrc_ies_gainFactorBetaC,
      { "gainFactorBetaC", "umts_rrc_ies.gainFactorBetaC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GainFactor", HFILL }},
    { &hf_umts_rrc_ies_tdd5,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_gainFactorBetaD,
      { "gainFactorBetaD", "umts_rrc_ies.gainFactorBetaD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GainFactor", HFILL }},
    { &hf_umts_rrc_ies_gainFactorInformation,
      { "gainFactorInformation", "umts_rrc_ies.gainFactorInformation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_GainFactorInformation_vals), 0,
        "umts_rrc_ies.GainFactorInformation", HFILL }},
    { &hf_umts_rrc_ies_powerOffsetPp_m,
      { "powerOffsetPp-m", "umts_rrc_ies.powerOffsetPp_m",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PowerOffsetPp_m", HFILL }},
    { &hf_umts_rrc_ies_ul_CommonTransChInfo,
      { "ul-CommonTransChInfo", "umts_rrc_ies.ul_CommonTransChInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_CommonTransChInfo", HFILL }},
    { &hf_umts_rrc_ies_ul_AddReconfTrChInfoList,
      { "ul-AddReconfTrChInfoList", "umts_rrc_ies.ul_AddReconfTrChInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_AddReconfTransChInfoList", HFILL }},
    { &hf_umts_rrc_ies_dl_CommonTransChInfo,
      { "dl-CommonTransChInfo", "umts_rrc_ies.dl_CommonTransChInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_CommonTransChInfo", HFILL }},
    { &hf_umts_rrc_ies_dl_TrChInfoList,
      { "dl-TrChInfoList", "umts_rrc_ies.dl_TrChInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_AddReconfTransChInfoList", HFILL }},
    { &hf_umts_rrc_ies_bler_QualityValue,
      { "bler-QualityValue", "umts_rrc_ies.bler_QualityValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BLER_QualityValue", HFILL }},
    { &hf_umts_rrc_ies_ul_TransportChannelType1,
      { "ul-TransportChannelType", "umts_rrc_ies.ul_TransportChannelType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TrCH_Type_vals), 0,
        "umts_rrc_ies.UL_TrCH_Type", HFILL }},
    { &hf_umts_rrc_ies_restrictedTrChIdentity,
      { "restrictedTrChIdentity", "umts_rrc_ies.restrictedTrChIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_allowedTFI_List,
      { "allowedTFI-List", "umts_rrc_ies.allowedTFI_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AllowedTFI_List", HFILL }},
    { &hf_umts_rrc_ies_RestrictedTrChInfoList_item,
      { "Item", "umts_rrc_ies.RestrictedTrChInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RestrictedTrChInfo", HFILL }},
    { &hf_umts_rrc_ies_channelCodingType,
      { "channelCodingType", "umts_rrc_ies.channelCodingType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ChannelCodingType_vals), 0,
        "umts_rrc_ies.ChannelCodingType", HFILL }},
    { &hf_umts_rrc_ies_rateMatchingAttribute,
      { "rateMatchingAttribute", "umts_rrc_ies.rateMatchingAttribute",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RateMatchingAttribute", HFILL }},
    { &hf_umts_rrc_ies_crc_Size,
      { "crc-Size", "umts_rrc_ies.crc_Size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CRC_Size_vals), 0,
        "umts_rrc_ies.CRC_Size", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo5,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo5_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo5", HFILL }},
    { &hf_umts_rrc_ies_fdd7,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd6", HFILL }},
    { &hf_umts_rrc_ies_referenceTFC_ID,
      { "referenceTFC-ID", "umts_rrc_ies.referenceTFC_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ReferenceTFC_ID", HFILL }},
    { &hf_umts_rrc_ies_splitType,
      { "splitType", "umts_rrc_ies.splitType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SplitType_vals), 0,
        "umts_rrc_ies.SplitType", HFILL }},
    { &hf_umts_rrc_ies_tfci_Field2_Length,
      { "tfci-Field2-Length", "umts_rrc_ies.tfci_Field2_Length",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_10", HFILL }},
    { &hf_umts_rrc_ies_tfci_Field1_Information,
      { "tfci-Field1-Information", "umts_rrc_ies.tfci_Field1_Information",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ExplicitTFCS_Configuration_vals), 0,
        "umts_rrc_ies.ExplicitTFCS_Configuration", HFILL }},
    { &hf_umts_rrc_ies_tfci_Field2_Information,
      { "tfci-Field2-Information", "umts_rrc_ies.tfci_Field2_Information",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCI_Field2_Information_vals), 0,
        "umts_rrc_ies.TFCI_Field2_Information", HFILL }},
    { &hf_umts_rrc_ies_minimumAllowedTFC_Number,
      { "minimumAllowedTFC-Number", "umts_rrc_ies.minimumAllowedTFC_Number",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFC_Value", HFILL }},
    { &hf_umts_rrc_ies_allowedTFC_List,
      { "allowedTFC-List", "umts_rrc_ies.allowedTFC_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AllowedTFC_List", HFILL }},
    { &hf_umts_rrc_ies_non_allowedTFC_List,
      { "non-allowedTFC-List", "umts_rrc_ies.non_allowedTFC_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Non_allowedTFC_List", HFILL }},
    { &hf_umts_rrc_ies_restrictedTrChInfoList,
      { "restrictedTrChInfoList", "umts_rrc_ies.restrictedTrChInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RestrictedTrChInfoList", HFILL }},
    { &hf_umts_rrc_ies_fullTFCS,
      { "fullTFCS", "umts_rrc_ies.fullTFCS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_TFC_SubsetList_item,
      { "Item", "umts_rrc_ies.TFC_SubsetList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFC_SubsetList_item", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo6,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo6_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo6", HFILL }},
    { &hf_umts_rrc_ies_tdd6,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd5", HFILL }},
    { &hf_umts_rrc_ies_tfcs_ID,
      { "tfcs-ID", "umts_rrc_ies.tfcs_ID",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_tfci_Range,
      { "tfci-Range", "umts_rrc_ies.tfci_Range",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFCI_RangeList", HFILL }},
    { &hf_umts_rrc_ies_explicit_config2,
      { "explicit-config", "umts_rrc_ies.explicit_config",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ExplicitTFCS_Configuration_vals), 0,
        "umts_rrc_ies.ExplicitTFCS_Configuration", HFILL }},
    { &hf_umts_rrc_ies_maxTFCIField2Value,
      { "maxTFCIField2Value", "umts_rrc_ies.maxTFCIField2Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_1023", HFILL }},
    { &hf_umts_rrc_ies_tfcs_InfoForDSCH,
      { "tfcs-InfoForDSCH", "umts_rrc_ies.tfcs_InfoForDSCH",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_InfoForDSCH_vals), 0,
        "umts_rrc_ies.TFCS_InfoForDSCH", HFILL }},
    { &hf_umts_rrc_ies_TFCI_RangeList_item,
      { "Item", "umts_rrc_ies.TFCI_RangeList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCI_Range", HFILL }},
    { &hf_umts_rrc_ies_normalTFCI_Signalling,
      { "normalTFCI-Signalling", "umts_rrc_ies.normalTFCI_Signalling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ExplicitTFCS_Configuration_vals), 0,
        "umts_rrc_ies.ExplicitTFCS_Configuration", HFILL }},
    { &hf_umts_rrc_ies_dummy_SplitTFCI_Signalling,
      { "dummy-SplitTFCI-Signalling", "umts_rrc_ies.dummy_SplitTFCI_Signalling",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SplitTFCI_Signalling", HFILL }},
    { &hf_umts_rrc_ies_tfcs_ID1,
      { "tfcs-ID", "umts_rrc_ies.tfcs_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFCS_IdentityPlain", HFILL }},
    { &hf_umts_rrc_ies_sharedChannelIndicator,
      { "sharedChannelIndicator", "umts_rrc_ies.sharedChannelIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ctfc2bit,
      { "ctfc2bit", "umts_rrc_ies.ctfc2bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_ctfc4bit,
      { "ctfc4bit", "umts_rrc_ies.ctfc4bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_ctfc6bit,
      { "ctfc6bit", "umts_rrc_ies.ctfc6bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_ctfc8bit,
      { "ctfc8bit", "umts_rrc_ies.ctfc8bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_ctfc12bit,
      { "ctfc12bit", "umts_rrc_ies.ctfc12bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4095", HFILL }},
    { &hf_umts_rrc_ies_ctfc16bit,
      { "ctfc16bit", "umts_rrc_ies.ctfc16bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_65535", HFILL }},
    { &hf_umts_rrc_ies_ctfc24bit,
      { "ctfc24bit", "umts_rrc_ies.ctfc24bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_16777215", HFILL }},
    { &hf_umts_rrc_ies_ctfcSize,
      { "ctfcSize", "umts_rrc_ies.ctfcSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ctfcSize_vals), 0,
        "umts_rrc_ies.T_ctfcSize", HFILL }},
    { &hf_umts_rrc_ies_ctfc2Bit,
      { "ctfc2Bit", "umts_rrc_ies.ctfc2Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc2Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc2Bit_item,
      { "Item", "umts_rrc_ies.ctfc2Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc2Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc2,
      { "ctfc2", "umts_rrc_ies.ctfc2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_powerOffsetInformation,
      { "powerOffsetInformation", "umts_rrc_ies.powerOffsetInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PowerOffsetInformation", HFILL }},
    { &hf_umts_rrc_ies_ctfc4Bit,
      { "ctfc4Bit", "umts_rrc_ies.ctfc4Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc4Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc4Bit_item,
      { "Item", "umts_rrc_ies.ctfc4Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc4Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc4,
      { "ctfc4", "umts_rrc_ies.ctfc4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_ctfc6Bit,
      { "ctfc6Bit", "umts_rrc_ies.ctfc6Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc6Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc6Bit_item,
      { "Item", "umts_rrc_ies.ctfc6Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc6Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc6,
      { "ctfc6", "umts_rrc_ies.ctfc6",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_ctfc8Bit,
      { "ctfc8Bit", "umts_rrc_ies.ctfc8Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc8Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc8Bit_item,
      { "Item", "umts_rrc_ies.ctfc8Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc8Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc8,
      { "ctfc8", "umts_rrc_ies.ctfc8",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_ctfc12Bit,
      { "ctfc12Bit", "umts_rrc_ies.ctfc12Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc12Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc12Bit_item,
      { "Item", "umts_rrc_ies.ctfc12Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc12Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc12,
      { "ctfc12", "umts_rrc_ies.ctfc12",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4095", HFILL }},
    { &hf_umts_rrc_ies_ctfc16Bit,
      { "ctfc16Bit", "umts_rrc_ies.ctfc16Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc16Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc16Bit_item,
      { "Item", "umts_rrc_ies.ctfc16Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc16Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc16,
      { "ctfc16", "umts_rrc_ies.ctfc16",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_65535", HFILL }},
    { &hf_umts_rrc_ies_ctfc24Bit,
      { "ctfc24Bit", "umts_rrc_ies.ctfc24Bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_ctfc24Bit", HFILL }},
    { &hf_umts_rrc_ies_ctfc24Bit_item,
      { "Item", "umts_rrc_ies.ctfc24Bit_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ctfc24Bit_item", HFILL }},
    { &hf_umts_rrc_ies_ctfc24,
      { "ctfc24", "umts_rrc_ies.ctfc24",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_16777215", HFILL }},
    { &hf_umts_rrc_ies_tfci,
      { "tfci", "umts_rrc_ies.tfci",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1023", HFILL }},
    { &hf_umts_rrc_ies_TFCS_RemovalList_item,
      { "Item", "umts_rrc_ies.TFCS_RemovalList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Removal", HFILL }},
    { &hf_umts_rrc_ies_messType,
      { "messType", "umts_rrc_ies.messType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MessType_vals), 0,
        "umts_rrc_ies.MessType", HFILL }},
    { &hf_umts_rrc_ies_tm_SignallingMode,
      { "tm-SignallingMode", "umts_rrc_ies.tm_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tm_SignallingMode_vals), 0,
        "umts_rrc_ies.T_tm_SignallingMode", HFILL }},
    { &hf_umts_rrc_ies_mode1,
      { "mode1", "umts_rrc_ies.mode1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_mode2,
      { "mode2", "umts_rrc_ies.mode2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mode2", HFILL }},
    { &hf_umts_rrc_ies_ul_controlledTrChList,
      { "ul-controlledTrChList", "umts_rrc_ies.ul_controlledTrChList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_ControlledTrChList", HFILL }},
    { &hf_umts_rrc_ies_dsch_transport_ch_id,
      { "dsch-transport-ch-id", "umts_rrc_ies.dsch_transport_ch_id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dedicatedTransChTFS,
      { "dedicatedTransChTFS", "umts_rrc_ies.dedicatedTransChTFS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DedicatedTransChTFS", HFILL }},
    { &hf_umts_rrc_ies_commonTransChTFS,
      { "commonTransChTFS", "umts_rrc_ies.commonTransChTFS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CommonTransChTFS", HFILL }},
    { &hf_umts_rrc_ies_commonTransChTFS_LCR,
      { "commonTransChTFS-LCR", "umts_rrc_ies.commonTransChTFS_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CommonTransChTFS_LCR", HFILL }},
    { &hf_umts_rrc_ies_UL_AddReconfTransChInfoList_item,
      { "Item", "umts_rrc_ies.UL_AddReconfTransChInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_AddReconfTransChInformation", HFILL }},
    { &hf_umts_rrc_ies_UL_AddReconfTransChInfoList_r6_item,
      { "Item", "umts_rrc_ies.UL_AddReconfTransChInfoList_r6_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_AddReconfTransChInformation_r6_vals), 0,
        "umts_rrc_ies.UL_AddReconfTransChInformation_r6", HFILL }},
    { &hf_umts_rrc_ies_transportFormatSet,
      { "transportFormatSet", "umts_rrc_ies.transportFormatSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_dch_usch,
      { "dch-usch", "umts_rrc_ies.dch_usch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_dch_usch", HFILL }},
    { &hf_umts_rrc_ies_e_dch1,
      { "e-dch", "umts_rrc_ies.e_dch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_e_dch1", HFILL }},
    { &hf_umts_rrc_ies_tti3,
      { "tti", "umts_rrc_ies.tti",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_E_DCH_TTI_vals), 0,
        "umts_rrc_ies.E_DCH_TTI", HFILL }},
    { &hf_umts_rrc_ies_harq_Info,
      { "harq-Info", "umts_rrc_ies.harq_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DCH_Harq_Info", HFILL }},
    { &hf_umts_rrc_ies_addReconf_MAC_d_Flow,
      { "addReconf-MAC-d-Flow", "umts_rrc_ies.addReconf_MAC_d_Flow",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DCH_AddReconf_MAC_d_Flow", HFILL }},
    { &hf_umts_rrc_ies_prach_TFCS,
      { "prach-TFCS", "umts_rrc_ies.prach_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo7,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo7_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo7", HFILL }},
    { &hf_umts_rrc_ies_fdd8,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd7", HFILL }},
    { &hf_umts_rrc_ies_tdd7,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd6", HFILL }},
    { &hf_umts_rrc_ies_individualUL_CCTrCH_InfoList,
      { "individualUL-CCTrCH-InfoList", "umts_rrc_ies.individualUL_CCTrCH_InfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IndividualUL_CCTrCH_InfoList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo8,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo8_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo8", HFILL }},
    { &hf_umts_rrc_ies_fdd9,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd8", HFILL }},
    { &hf_umts_rrc_ies_tdd8,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd7", HFILL }},
    { &hf_umts_rrc_ies_tfc_SubsetList,
      { "tfc-SubsetList", "umts_rrc_ies.tfc_SubsetList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFC_SubsetList", HFILL }},
    { &hf_umts_rrc_ies_UL_ControlledTrChList_item,
      { "Item", "umts_rrc_ies.UL_ControlledTrChList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_UL_DeletedTransChInfoList_item,
      { "Item", "umts_rrc_ies.UL_DeletedTransChInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_UL_DeletedTransChInfoList_r6_item,
      { "Item", "umts_rrc_ies.UL_DeletedTransChInfoList_r6_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TransportChannelIdentity_r6_vals), 0,
        "umts_rrc_ies.UL_TransportChannelIdentity_r6", HFILL }},
    { &hf_umts_rrc_ies_ul_TransportChannelIdentity,
      { "ul-TransportChannelIdentity", "umts_rrc_ies.ul_TransportChannelIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dch_usch1,
      { "dch-usch", "umts_rrc_ies.dch_usch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_dch_usch1", HFILL }},
    { &hf_umts_rrc_ies_e_dch2,
      { "e-dch", "umts_rrc_ies.e_dch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DCH_MAC_d_FlowIdentity", HFILL }},
    { &hf_umts_rrc_ies_USCH_TransportChannelsInfo_item,
      { "Item", "umts_rrc_ies.USCH_TransportChannelsInfo_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.USCH_TransportChannelsInfo_item", HFILL }},
    { &hf_umts_rrc_ies_usch_TransportChannelIdentity,
      { "usch-TransportChannelIdentity", "umts_rrc_ies.usch_TransportChannelIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_usch_TFS,
      { "usch-TFS", "umts_rrc_ies.usch_TFS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_AC_To_ASC_MappingTable_item,
      { "Item", "umts_rrc_ies.AC_To_ASC_MappingTable_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AC_To_ASC_Mapping", HFILL }},
    { &hf_umts_rrc_ies_availableSignatureStartIndex,
      { "availableSignatureStartIndex", "umts_rrc_ies.availableSignatureStartIndex",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_availableSignatureEndIndex,
      { "availableSignatureEndIndex", "umts_rrc_ies.availableSignatureEndIndex",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_assignedSubChannelNumber,
      { "assignedSubChannelNumber", "umts_rrc_ies.assignedSubChannelNumber",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_assignedSubChannelNumber", HFILL }},
    { &hf_umts_rrc_ies_channelisationCodeIndices,
      { "channelisationCodeIndices", "umts_rrc_ies.channelisationCodeIndices",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_channelisationCodeIndices", HFILL }},
    { &hf_umts_rrc_ies_subchannelSize,
      { "subchannelSize", "umts_rrc_ies.subchannelSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_subchannelSize_vals), 0,
        "umts_rrc_ies.T_subchannelSize", HFILL }},
    { &hf_umts_rrc_ies_size1,
      { "size1", "umts_rrc_ies.size1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_size2,
      { "size2", "umts_rrc_ies.size2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_size2", HFILL }},
    { &hf_umts_rrc_ies_subchannels,
      { "subchannels", "umts_rrc_ies.subchannels",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_subchannels_vals), 0,
        "umts_rrc_ies.T_subchannels", HFILL }},
    { &hf_umts_rrc_ies_size4,
      { "size4", "umts_rrc_ies.size4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_size4", HFILL }},
    { &hf_umts_rrc_ies_subchannels1,
      { "subchannels", "umts_rrc_ies.subchannels",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_subchannels1", HFILL }},
    { &hf_umts_rrc_ies_size8,
      { "size8", "umts_rrc_ies.size8",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_size8", HFILL }},
    { &hf_umts_rrc_ies_subchannels2,
      { "subchannels", "umts_rrc_ies.subchannels",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_subchannels2", HFILL }},
    { &hf_umts_rrc_ies_availableSYNC_UlCodesIndics,
      { "availableSYNC-UlCodesIndics", "umts_rrc_ies.availableSYNC_UlCodesIndics",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_availableSYNC_UlCodesIndics", HFILL }},
    { &hf_umts_rrc_ies_subchannelSize1,
      { "subchannelSize", "umts_rrc_ies.subchannelSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_subchannelSize1_vals), 0,
        "umts_rrc_ies.T_subchannelSize1", HFILL }},
    { &hf_umts_rrc_ies_size21,
      { "size2", "umts_rrc_ies.size2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_size21", HFILL }},
    { &hf_umts_rrc_ies_subchannels3,
      { "subchannels", "umts_rrc_ies.subchannels",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_subchannels3_vals), 0,
        "umts_rrc_ies.T_subchannels3", HFILL }},
    { &hf_umts_rrc_ies_size41,
      { "size4", "umts_rrc_ies.size4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_size41", HFILL }},
    { &hf_umts_rrc_ies_subchannels4,
      { "subchannels", "umts_rrc_ies.subchannels",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_subchannels4", HFILL }},
    { &hf_umts_rrc_ies_size81,
      { "size8", "umts_rrc_ies.size8",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_size81", HFILL }},
    { &hf_umts_rrc_ies_subchannels5,
      { "subchannels", "umts_rrc_ies.subchannels",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_subchannels5", HFILL }},
    { &hf_umts_rrc_ies_dynamicTFInformationCCCH,
      { "dynamicTFInformationCCCH", "umts_rrc_ies.dynamicTFInformationCCCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DynamicTFInformationCCCH", HFILL }},
    { &hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_IEs,
      { "additionalPRACH-TF-and-TFCS-CCCH-IEs", "umts_rrc_ies.additionalPRACH_TF_and_TFCS_CCCH_IEs",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AdditionalPRACH_TF_and_TFCS_CCCH_IEs", HFILL }},
    { &hf_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List_item,
      { "Item", "umts_rrc_ies.AdditionalPRACH_TF_and_TFCS_CCCH_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AdditionalPRACH_TF_and_TFCS_CCCH", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode256,
      { "channelisationCode256", "umts_rrc_ies.channelisationCode256",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ChannelisationCode256", HFILL }},
    { &hf_umts_rrc_ies_sttd_Indicator,
      { "sttd-Indicator", "umts_rrc_ies.sttd_Indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_aich_TransmissionTiming,
      { "aich-TransmissionTiming", "umts_rrc_ies.aich_TransmissionTiming",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AICH_TransmissionTiming_vals), 0,
        "umts_rrc_ies.AICH_TransmissionTiming", HFILL }},
    { &hf_umts_rrc_ies_allocationActivationTime,
      { "allocationActivationTime", "umts_rrc_ies.allocationActivationTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_allocationDuration,
      { "allocationDuration", "umts_rrc_ies.allocationDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_256", HFILL }},
    { &hf_umts_rrc_ies_ap_Signature,
      { "ap-Signature", "umts_rrc_ies.ap_Signature",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AP_Signature", HFILL }},
    { &hf_umts_rrc_ies_availableAP_SubchannelList,
      { "availableAP-SubchannelList", "umts_rrc_ies.availableAP_SubchannelList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AvailableAP_SubchannelList", HFILL }},
    { &hf_umts_rrc_ies_accessServiceClass_FDD,
      { "accessServiceClass-FDD", "umts_rrc_ies.accessServiceClass_FDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AccessServiceClass_FDD", HFILL }},
    { &hf_umts_rrc_ies_accessServiceClass_TDD,
      { "accessServiceClass-TDD", "umts_rrc_ies.accessServiceClass_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AccessServiceClass_TDD", HFILL }},
    { &hf_umts_rrc_ies_accessServiceClass_TDD_LCR,
      { "accessServiceClass-TDD-LCR", "umts_rrc_ies.accessServiceClass_TDD_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AccessServiceClass_TDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_AvailableAP_Signature_VCAMList_item,
      { "Item", "umts_rrc_ies.AvailableAP_Signature_VCAMList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AP_Signature_VCAM", HFILL }},
    { &hf_umts_rrc_ies_AvailableAP_SignatureList_item,
      { "Item", "umts_rrc_ies.AvailableAP_SignatureList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AP_Signature", HFILL }},
    { &hf_umts_rrc_ies_AvailableAP_SubchannelList_item,
      { "Item", "umts_rrc_ies.AvailableAP_SubchannelList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AP_Subchannel", HFILL }},
    { &hf_umts_rrc_ies_AvailableMinimumSF_ListVCAM_item,
      { "Item", "umts_rrc_ies.AvailableMinimumSF_ListVCAM_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AvailableMinimumSF_VCAM", HFILL }},
    { &hf_umts_rrc_ies_minimumSpreadingFactor,
      { "minimumSpreadingFactor", "umts_rrc_ies.minimumSpreadingFactor",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MinimumSpreadingFactor_vals), 0,
        "umts_rrc_ies.MinimumSpreadingFactor", HFILL }},
    { &hf_umts_rrc_ies_nf_Max,
      { "nf-Max", "umts_rrc_ies.nf_Max",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NF_Max", HFILL }},
    { &hf_umts_rrc_ies_maxAvailablePCPCH_Number,
      { "maxAvailablePCPCH-Number", "umts_rrc_ies.maxAvailablePCPCH_Number",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxAvailablePCPCH_Number", HFILL }},
    { &hf_umts_rrc_ies_availableAP_Signature_VCAMList,
      { "availableAP-Signature-VCAMList", "umts_rrc_ies.availableAP_Signature_VCAMList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AvailableAP_Signature_VCAMList", HFILL }},
    { &hf_umts_rrc_ies_tfcs_Identity,
      { "tfcs-Identity", "umts_rrc_ies.tfcs_Identity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DPCH_PowerControlInfo_vals), 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfo", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo1,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DPCH_PowerControlInfo_r4_vals), 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo2,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DPCH_PowerControlInfo_r5_vals), 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfo_r5", HFILL }},
    { &hf_umts_rrc_ies_CD_AccessSlotSubchannelList_item,
      { "Item", "umts_rrc_ies.CD_AccessSlotSubchannelList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CD_AccessSlotSubchannel", HFILL }},
    { &hf_umts_rrc_ies_CD_SignatureCodeList_item,
      { "Item", "umts_rrc_ies.CD_SignatureCodeList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CD_SignatureCode", HFILL }},
    { &hf_umts_rrc_ies_burstType,
      { "burstType", "umts_rrc_ies.burstType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_BurstType_vals), 0,
        "umts_rrc_ies.BurstType", HFILL }},
    { &hf_umts_rrc_ies_midambleShift,
      { "midambleShift", "umts_rrc_ies.midambleShift",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MidambleShiftLong", HFILL }},
    { &hf_umts_rrc_ies_timeslot,
      { "timeslot", "umts_rrc_ies.timeslot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber", HFILL }},
    { &hf_umts_rrc_ies_cellParametersID,
      { "cellParametersID", "umts_rrc_ies.cellParametersID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellParametersID", HFILL }},
    { &hf_umts_rrc_ies_notActive,
      { "notActive", "umts_rrc_ies.notActive",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_isActive,
      { "isActive", "umts_rrc_ies.isActive",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AvailableMinimumSF_ListVCAM", HFILL }},
    { &hf_umts_rrc_ies_availableAP_SignatureList,
      { "availableAP-SignatureList", "umts_rrc_ies.availableAP_SignatureList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AvailableAP_SignatureList", HFILL }},
    { &hf_umts_rrc_ies_pdsch_CodeMapList,
      { "pdsch-CodeMapList", "umts_rrc_ies.pdsch_CodeMapList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_CodeMapList", HFILL }},
    { &hf_umts_rrc_ies_secondInterleavingMode,
      { "secondInterleavingMode", "umts_rrc_ies.secondInterleavingMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SecondInterleavingMode_vals), 0,
        "umts_rrc_ies.SecondInterleavingMode", HFILL }},
    { &hf_umts_rrc_ies_tfci_Coding,
      { "tfci-Coding", "umts_rrc_ies.tfci_Coding",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCI_Coding_vals), 0,
        "umts_rrc_ies.TFCI_Coding", HFILL }},
    { &hf_umts_rrc_ies_puncturingLimit,
      { "puncturingLimit", "umts_rrc_ies.puncturingLimit",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PuncturingLimit_vals), 0,
        "umts_rrc_ies.PuncturingLimit", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriodAndLength,
      { "repetitionPeriodAndLength", "umts_rrc_ies.repetitionPeriodAndLength",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RepetitionPeriodAndLength_vals), 0,
        "umts_rrc_ies.RepetitionPeriodAndLength", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriodLengthAndOffset,
      { "repetitionPeriodLengthAndOffset", "umts_rrc_ies.repetitionPeriodLengthAndOffset",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RepetitionPeriodLengthAndOffset_vals), 0,
        "umts_rrc_ies.RepetitionPeriodLengthAndOffset", HFILL }},
    { &hf_umts_rrc_ies_cpch_SetID,
      { "cpch-SetID", "umts_rrc_ies.cpch_SetID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CPCH_SetID", HFILL }},
    { &hf_umts_rrc_ies_dynamicPersistenceLevelTF_List,
      { "dynamicPersistenceLevelTF-List", "umts_rrc_ies.dynamicPersistenceLevelTF_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DynamicPersistenceLevelTF_List", HFILL }},
    { &hf_umts_rrc_ies_CPCH_PersistenceLevelsList_item,
      { "Item", "umts_rrc_ies.CPCH_PersistenceLevelsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CPCH_PersistenceLevels", HFILL }},
    { &hf_umts_rrc_ies_ap_PreambleScramblingCode,
      { "ap-PreambleScramblingCode", "umts_rrc_ies.ap_PreambleScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AP_PreambleScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_ap_AICH_ChannelisationCode,
      { "ap-AICH-ChannelisationCode", "umts_rrc_ies.ap_AICH_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AP_AICH_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_cd_PreambleScramblingCode,
      { "cd-PreambleScramblingCode", "umts_rrc_ies.cd_PreambleScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CD_PreambleScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_cd_CA_ICH_ChannelisationCode,
      { "cd-CA-ICH-ChannelisationCode", "umts_rrc_ies.cd_CA_ICH_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CD_CA_ICH_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_cd_AccessSlotSubchannelList,
      { "cd-AccessSlotSubchannelList", "umts_rrc_ies.cd_AccessSlotSubchannelList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CD_AccessSlotSubchannelList", HFILL }},
    { &hf_umts_rrc_ies_cd_SignatureCodeList,
      { "cd-SignatureCodeList", "umts_rrc_ies.cd_SignatureCodeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CD_SignatureCodeList", HFILL }},
    { &hf_umts_rrc_ies_deltaPp_m,
      { "deltaPp-m", "umts_rrc_ies.deltaPp_m",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaPp_m", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCCH_SlotFormat,
      { "ul-DPCCH-SlotFormat", "umts_rrc_ies.ul_DPCCH_SlotFormat",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DPCCH_SlotFormat_vals), 0,
        "umts_rrc_ies.UL_DPCCH_SlotFormat", HFILL }},
    { &hf_umts_rrc_ies_n_StartMessage,
      { "n-StartMessage", "umts_rrc_ies.n_StartMessage",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_StartMessage", HFILL }},
    { &hf_umts_rrc_ies_n_EOT,
      { "n-EOT", "umts_rrc_ies.n_EOT",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_EOT", HFILL }},
    { &hf_umts_rrc_ies_channelAssignmentActive,
      { "channelAssignmentActive", "umts_rrc_ies.channelAssignmentActive",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ChannelAssignmentActive_vals), 0,
        "umts_rrc_ies.ChannelAssignmentActive", HFILL }},
    { &hf_umts_rrc_ies_cpch_StatusIndicationMode,
      { "cpch-StatusIndicationMode", "umts_rrc_ies.cpch_StatusIndicationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CPCH_StatusIndicationMode_vals), 0,
        "umts_rrc_ies.CPCH_StatusIndicationMode", HFILL }},
    { &hf_umts_rrc_ies_pcpch_ChannelInfoList,
      { "pcpch-ChannelInfoList", "umts_rrc_ies.pcpch_ChannelInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PCPCH_ChannelInfoList", HFILL }},
    { &hf_umts_rrc_ies_CPCH_SetInfoList_item,
      { "Item", "umts_rrc_ies.CPCH_SetInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CPCH_SetInfo", HFILL }},
    { &hf_umts_rrc_ies_timeInfo,
      { "timeInfo", "umts_rrc_ies.timeInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TimeInfo", HFILL }},
    { &hf_umts_rrc_ies_commonTimeslotInfo,
      { "commonTimeslotInfo", "umts_rrc_ies.commonTimeslotInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CommonTimeslotInfo", HFILL }},
    { &hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes,
      { "dl-CCTrCH-TimeslotsCodes", "umts_rrc_ies.dl_CCTrCH_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes", HFILL }},
    { &hf_umts_rrc_ies_ul_CCTrChTPCList,
      { "ul-CCTrChTPCList", "umts_rrc_ies.ul_CCTrChTPCList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_CCTrChTPCList", HFILL }},
    { &hf_umts_rrc_ies_tddOption,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption_vals), 0,
        "umts_rrc_ies.T_tddOption", HFILL }},
    { &hf_umts_rrc_ies_tdd384,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd384", HFILL }},
    { &hf_umts_rrc_ies_tdd128,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd128", HFILL }},
    { &hf_umts_rrc_ies_dl_CCTrCH_TimeslotsCodes1,
      { "dl-CCTrCH-TimeslotsCodes", "umts_rrc_ies.dl_CCTrCH_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_DL_CCTrChList_item,
      { "Item", "umts_rrc_ies.DL_CCTrChList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_CCTrCh", HFILL }},
    { &hf_umts_rrc_ies_DL_CCTrChList_r4_item,
      { "Item", "umts_rrc_ies.DL_CCTrChList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_CCTrCh_r4", HFILL }},
    { &hf_umts_rrc_ies_DL_CCTrChListToRemove_item,
      { "Item", "umts_rrc_ies.DL_CCTrChListToRemove_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFCS_IdentityPlain", HFILL }},
    { &hf_umts_rrc_ies_DL_CCTrChTPCList_item,
      { "Item", "umts_rrc_ies.DL_CCTrChTPCList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_secondaryScramblingCode,
      { "secondaryScramblingCode", "umts_rrc_ies.secondaryScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SecondaryScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_sf_AndCodeNumber,
      { "sf-AndCodeNumber", "umts_rrc_ies.sf_AndCodeNumber",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SF512_AndCodeNumber_vals), 0,
        "umts_rrc_ies.SF512_AndCodeNumber", HFILL }},
    { &hf_umts_rrc_ies_scramblingCodeChange,
      { "scramblingCodeChange", "umts_rrc_ies.scramblingCodeChange",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ScramblingCodeChange_vals), 0,
        "umts_rrc_ies.ScramblingCodeChange", HFILL }},
    { &hf_umts_rrc_ies_DL_ChannelisationCodeList_item,
      { "Item", "umts_rrc_ies.DL_ChannelisationCodeList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoCommon,
      { "dl-DPCH-InfoCommon", "umts_rrc_ies.dl_DPCH_InfoCommon",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoCommon", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo9,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo9_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo9", HFILL }},
    { &hf_umts_rrc_ies_fdd10,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd9", HFILL }},
    { &hf_umts_rrc_ies_defaultDPCH_OffsetValue,
      { "defaultDPCH-OffsetValue", "umts_rrc_ies.defaultDPCH_OffsetValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DefaultDPCH_OffsetValueFDD", HFILL }},
    { &hf_umts_rrc_ies_dpch_CompressedModeInfo,
      { "dpch-CompressedModeInfo", "umts_rrc_ies.dpch_CompressedModeInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DPCH_CompressedModeInfo", HFILL }},
    { &hf_umts_rrc_ies_tx_DiversityMode,
      { "tx-DiversityMode", "umts_rrc_ies.tx_DiversityMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TX_DiversityMode_vals), 0,
        "umts_rrc_ies.TX_DiversityMode", HFILL }},
    { &hf_umts_rrc_ies_dummy_SSDT_Information,
      { "dummy-SSDT-Information", "umts_rrc_ies.dummy_SSDT_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SSDT_Information", HFILL }},
    { &hf_umts_rrc_ies_tdd9,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd8", HFILL }},
    { &hf_umts_rrc_ies_defaultDPCH_OffsetValue1,
      { "defaultDPCH-OffsetValue", "umts_rrc_ies.defaultDPCH_OffsetValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DefaultDPCH_OffsetValueTDD", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoCommon1,
      { "dl-DPCH-InfoCommon", "umts_rrc_ies.dl_DPCH_InfoCommon",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoCommon_r4", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo10,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo10_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo10", HFILL }},
    { &hf_umts_rrc_ies_fdd11,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd10", HFILL }},
    { &hf_umts_rrc_ies_dummy_SSDT_Information_r4,
      { "dummy-SSDT-Information-r4", "umts_rrc_ies.dummy_SSDT_Information_r4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SSDT_Information_r4", HFILL }},
    { &hf_umts_rrc_ies_tdd10,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd9", HFILL }},
    { &hf_umts_rrc_ies_tddOption1,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption1_vals), 0,
        "umts_rrc_ies.T_tddOption1", HFILL }},
    { &hf_umts_rrc_ies_tdd3841,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_tdd1281,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1281", HFILL }},
    { &hf_umts_rrc_ies_tstd_Indicator,
      { "tstd-Indicator", "umts_rrc_ies.tstd_Indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo11,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo11_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo11", HFILL }},
    { &hf_umts_rrc_ies_fdd12,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd11", HFILL }},
    { &hf_umts_rrc_ies_tdd11,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd10", HFILL }},
    { &hf_umts_rrc_ies_tddOption2,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption2_vals), 0,
        "umts_rrc_ies.T_tddOption2", HFILL }},
    { &hf_umts_rrc_ies_tdd1282,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1282", HFILL }},
    { &hf_umts_rrc_ies_mac_hsResetIndicator1,
      { "mac-hsResetIndicator", "umts_rrc_ies.mac_hsResetIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_mac_hsResetIndicator1_vals), 0,
        "umts_rrc_ies.T_mac_hsResetIndicator1", HFILL }},
    { &hf_umts_rrc_ies_dl_dpchInfoCommon,
      { "dl-dpchInfoCommon", "umts_rrc_ies.dl_dpchInfoCommon",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_dl_dpchInfoCommon_vals), 0,
        "umts_rrc_ies.T_dl_dpchInfoCommon", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoCommon2,
      { "dl-DPCH-InfoCommon", "umts_rrc_ies.dl_DPCH_InfoCommon",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoCommon_r6", HFILL }},
    { &hf_umts_rrc_ies_dl_FDPCH_InfoCommon,
      { "dl-FDPCH-InfoCommon", "umts_rrc_ies.dl_FDPCH_InfoCommon",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_FDPCH_InfoCommon_r6", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo12,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo12_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo12", HFILL }},
    { &hf_umts_rrc_ies_fdd13,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd12", HFILL }},
    { &hf_umts_rrc_ies_tdd12,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd11", HFILL }},
    { &hf_umts_rrc_ies_tddOption3,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption3_vals), 0,
        "umts_rrc_ies.T_tddOption3", HFILL }},
    { &hf_umts_rrc_ies_tdd1283,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1283", HFILL }},
    { &hf_umts_rrc_ies_mac_hsResetIndicator2,
      { "mac-hsResetIndicator", "umts_rrc_ies.mac_hsResetIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_mac_hsResetIndicator2_vals), 0,
        "umts_rrc_ies.T_mac_hsResetIndicator2", HFILL }},
    { &hf_umts_rrc_ies_postVerificationPeriod,
      { "postVerificationPeriod", "umts_rrc_ies.postVerificationPeriod",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_postVerificationPeriod_vals), 0,
        "umts_rrc_ies.T_postVerificationPeriod", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoCommon3,
      { "dl-DPCH-InfoCommon", "umts_rrc_ies.dl_DPCH_InfoCommon",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoCommonPost", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoCommon4,
      { "dl-DPCH-InfoCommon", "umts_rrc_ies.dl_DPCH_InfoCommon",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoCommonPredef", HFILL }},
    { &hf_umts_rrc_ies_cfnHandling,
      { "cfnHandling", "umts_rrc_ies.cfnHandling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cfnHandling_vals), 0,
        "umts_rrc_ies.T_cfnHandling", HFILL }},
    { &hf_umts_rrc_ies_maintain,
      { "maintain", "umts_rrc_ies.maintain",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_initialise,
      { "initialise", "umts_rrc_ies.initialise",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_initialise", HFILL }},
    { &hf_umts_rrc_ies_cfntargetsfnframeoffset,
      { "cfntargetsfnframeoffset", "umts_rrc_ies.cfntargetsfnframeoffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Cfntargetsfnframeoffset", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo13,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo13_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo13", HFILL }},
    { &hf_umts_rrc_ies_fdd14,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd13", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_PowerControlInfo,
      { "dl-DPCH-PowerControlInfo", "umts_rrc_ies.dl_DPCH_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_PowerControlInfo", HFILL }},
    { &hf_umts_rrc_ies_powerOffsetPilot_pdpdch,
      { "powerOffsetPilot-pdpdch", "umts_rrc_ies.powerOffsetPilot_pdpdch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PowerOffsetPilot_pdpdch", HFILL }},
    { &hf_umts_rrc_ies_dl_rate_matching_restriction,
      { "dl-rate-matching-restriction", "umts_rrc_ies.dl_rate_matching_restriction",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Dl_rate_matching_restriction", HFILL }},
    { &hf_umts_rrc_ies_spreadingFactorAndPilot,
      { "spreadingFactorAndPilot", "umts_rrc_ies.spreadingFactorAndPilot",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SF512_AndPilot_vals), 0,
        "umts_rrc_ies.SF512_AndPilot", HFILL }},
    { &hf_umts_rrc_ies_positionFixedOrFlexible,
      { "positionFixedOrFlexible", "umts_rrc_ies.positionFixedOrFlexible",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PositionFixedOrFlexible_vals), 0,
        "umts_rrc_ies.PositionFixedOrFlexible", HFILL }},
    { &hf_umts_rrc_ies_tfci_Existence,
      { "tfci-Existence", "umts_rrc_ies.tfci_Existence",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd13,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12", HFILL }},
    { &hf_umts_rrc_ies_cfnHandling1,
      { "cfnHandling", "umts_rrc_ies.cfnHandling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cfnHandling1_vals), 0,
        "umts_rrc_ies.T_cfnHandling1", HFILL }},
    { &hf_umts_rrc_ies_initialise1,
      { "initialise", "umts_rrc_ies.initialise",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_initialise1", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo14,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo14_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo14", HFILL }},
    { &hf_umts_rrc_ies_fdd15,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd14", HFILL }},
    { &hf_umts_rrc_ies_tdd14,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd13", HFILL }},
    { &hf_umts_rrc_ies_mac_d_HFN_initial_value,
      { "mac-d-HFN-initial-value", "umts_rrc_ies.mac_d_HFN_initial_value",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.MAC_d_HFN_initial_value", HFILL }},
    { &hf_umts_rrc_ies_cfnHandling2,
      { "cfnHandling", "umts_rrc_ies.cfnHandling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cfnHandling2_vals), 0,
        "umts_rrc_ies.T_cfnHandling2", HFILL }},
    { &hf_umts_rrc_ies_maintain1,
      { "maintain", "umts_rrc_ies.maintain",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_maintain", HFILL }},
    { &hf_umts_rrc_ies_timingmaintainedsynchind,
      { "timingmaintainedsynchind", "umts_rrc_ies.timingmaintainedsynchind",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimingMaintainedSynchInd_vals), 0,
        "umts_rrc_ies.TimingMaintainedSynchInd", HFILL }},
    { &hf_umts_rrc_ies_initialise2,
      { "initialise", "umts_rrc_ies.initialise",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo15,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo15_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo15", HFILL }},
    { &hf_umts_rrc_ies_fdd16,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd15", HFILL }},
    { &hf_umts_rrc_ies_tdd15,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd14", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo16,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo16_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo16", HFILL }},
    { &hf_umts_rrc_ies_fdd17,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd16", HFILL }},
    { &hf_umts_rrc_ies_tdd16,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd15", HFILL }},
    { &hf_umts_rrc_ies_fdd18,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd17", HFILL }},
    { &hf_umts_rrc_ies_pCPICH_UsageForChannelEst,
      { "pCPICH-UsageForChannelEst", "umts_rrc_ies.pCPICH_UsageForChannelEst",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PCPICH_UsageForChannelEst_vals), 0,
        "umts_rrc_ies.PCPICH_UsageForChannelEst", HFILL }},
    { &hf_umts_rrc_ies_dpch_FrameOffset,
      { "dpch-FrameOffset", "umts_rrc_ies.dpch_FrameOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DPCH_FrameOffset", HFILL }},
    { &hf_umts_rrc_ies_secondaryCPICH_Info,
      { "secondaryCPICH-Info", "umts_rrc_ies.secondaryCPICH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecondaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_dl_ChannelisationCodeList,
      { "dl-ChannelisationCodeList", "umts_rrc_ies.dl_ChannelisationCodeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_ChannelisationCodeList", HFILL }},
    { &hf_umts_rrc_ies_tpc_CombinationIndex,
      { "tpc-CombinationIndex", "umts_rrc_ies.tpc_CombinationIndex",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TPC_CombinationIndex", HFILL }},
    { &hf_umts_rrc_ies_dummy_SSDT_CellIdentity,
      { "dummy-SSDT-CellIdentity", "umts_rrc_ies.dummy_SSDT_CellIdentity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SSDT_CellIdentity_vals), 0,
        "umts_rrc_ies.SSDT_CellIdentity", HFILL }},
    { &hf_umts_rrc_ies_closedLoopTimingAdjMode,
      { "closedLoopTimingAdjMode", "umts_rrc_ies.closedLoopTimingAdjMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ClosedLoopTimingAdjMode_vals), 0,
        "umts_rrc_ies.ClosedLoopTimingAdjMode", HFILL }},
    { &hf_umts_rrc_ies_tdd17,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd16", HFILL }},
    { &hf_umts_rrc_ies_dl_CCTrChListToEstablish,
      { "dl-CCTrChListToEstablish", "umts_rrc_ies.dl_CCTrChListToEstablish",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_CCTrChList", HFILL }},
    { &hf_umts_rrc_ies_dl_CCTrChListToRemove,
      { "dl-CCTrChListToRemove", "umts_rrc_ies.dl_CCTrChListToRemove",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_CCTrChListToRemove", HFILL }},
    { &hf_umts_rrc_ies_fdd19,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd18", HFILL }},
    { &hf_umts_rrc_ies_tdd18,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd17", HFILL }},
    { &hf_umts_rrc_ies_dl_CCTrChListToEstablish1,
      { "dl-CCTrChListToEstablish", "umts_rrc_ies.dl_CCTrChListToEstablish",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_CCTrChList_r4", HFILL }},
    { &hf_umts_rrc_ies_fdd20,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd19", HFILL }},
    { &hf_umts_rrc_ies_powerOffsetTPC_pdpdch,
      { "powerOffsetTPC-pdpdch", "umts_rrc_ies.powerOffsetTPC_pdpdch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PowerOffsetTPC_pdpdch", HFILL }},
    { &hf_umts_rrc_ies_tdd19,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd18", HFILL }},
    { &hf_umts_rrc_ies_fdd21,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd20", HFILL }},
    { &hf_umts_rrc_ies_tdd20,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd19", HFILL }},
    { &hf_umts_rrc_ies_fdpch_FrameOffset,
      { "fdpch-FrameOffset", "umts_rrc_ies.fdpch_FrameOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DPCH_FrameOffset", HFILL }},
    { &hf_umts_rrc_ies_dl_ChannelisationCode,
      { "dl-ChannelisationCode", "umts_rrc_ies.dl_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_dl_ChannelisationCode1,
      { "dl-ChannelisationCode", "umts_rrc_ies.dl_ChannelisationCode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_TimeslotsCodes,
      { "dl-DPCH-TimeslotsCodes", "umts_rrc_ies.dl_DPCH_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo17,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo17_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo17", HFILL }},
    { &hf_umts_rrc_ies_fdd22,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd21", HFILL }},
    { &hf_umts_rrc_ies_dpc_Mode,
      { "dpc-Mode", "umts_rrc_ies.dpc_Mode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DPC_Mode_vals), 0,
        "umts_rrc_ies.DPC_Mode", HFILL }},
    { &hf_umts_rrc_ies_tdd21,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd20", HFILL }},
    { &hf_umts_rrc_ies_tpc_StepSizeTDD,
      { "tpc-StepSizeTDD", "umts_rrc_ies.tpc_StepSizeTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TPC_StepSizeTDD", HFILL }},
    { &hf_umts_rrc_ies_cfnHandling3,
      { "cfnHandling", "umts_rrc_ies.cfnHandling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cfnHandling3_vals), 0,
        "umts_rrc_ies.T_cfnHandling3", HFILL }},
    { &hf_umts_rrc_ies_maintain2,
      { "maintain", "umts_rrc_ies.maintain",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_maintain1", HFILL }},
    { &hf_umts_rrc_ies_dl_FDPCH_PowerControlInfo,
      { "dl-FDPCH-PowerControlInfo", "umts_rrc_ies.dl_FDPCH_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_PowerControlInfo", HFILL }},
    { &hf_umts_rrc_ies_dl_FDPCH_TPCcommandErrorRate,
      { "dl-FDPCH-TPCcommandErrorRate", "umts_rrc_ies.dl_FDPCH_TPCcommandErrorRate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_16", HFILL }},
    { &hf_umts_rrc_ies_hs_scch_Info,
      { "hs-scch-Info", "umts_rrc_ies.hs_scch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SCCH_Info", HFILL }},
    { &hf_umts_rrc_ies_measurement_feedback_Info,
      { "measurement-feedback-Info", "umts_rrc_ies.measurement_feedback_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Measurement_Feedback_Info", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo18,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo18_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo18", HFILL }},
    { &hf_umts_rrc_ies_tdd22,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd21_vals), 0,
        "umts_rrc_ies.T_tdd21", HFILL }},
    { &hf_umts_rrc_ies_tdd3842,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3841", HFILL }},
    { &hf_umts_rrc_ies_dl_HSPDSCH_TS_Configuration,
      { "dl-HSPDSCH-TS-Configuration", "umts_rrc_ies.dl_HSPDSCH_TS_Configuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_HSPDSCH_TS_Configuration", HFILL }},
    { &hf_umts_rrc_ies_tdd1284,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1284", HFILL }},
    { &hf_umts_rrc_ies_hs_PDSCH_Midamble_Configuration_tdd128,
      { "hs-PDSCH-Midamble-Configuration-tdd128", "umts_rrc_ies.hs_PDSCH_Midamble_Configuration_tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_PDSCH_Midamble_Configuration_TDD128", HFILL }},
    { &hf_umts_rrc_ies_hs_scch_Info1,
      { "hs-scch-Info", "umts_rrc_ies.hs_scch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SCCH_Info_r6", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo19,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo19_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo19", HFILL }},
    { &hf_umts_rrc_ies_tdd23,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd22_vals), 0,
        "umts_rrc_ies.T_tdd22", HFILL }},
    { &hf_umts_rrc_ies_tdd3843,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3842", HFILL }},
    { &hf_umts_rrc_ies_tdd1285,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1285", HFILL }},
    { &hf_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item,
      { "Item", "umts_rrc_ies.DL_HSPDSCH_TS_Configuration_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_HSPDSCH_TS_Configuration_item", HFILL }},
    { &hf_umts_rrc_ies_midambleShiftAndBurstType,
      { "midambleShiftAndBurstType", "umts_rrc_ies.midambleShiftAndBurstType",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MidambleShiftAndBurstType_DL", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo20,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo20_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo20", HFILL }},
    { &hf_umts_rrc_ies_fdd23,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd22", HFILL }},
    { &hf_umts_rrc_ies_dummy1_PDSCH_SHO_DCH_Info,
      { "dummy1-PDSCH-SHO-DCH-Info", "umts_rrc_ies.dummy1_PDSCH_SHO_DCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SHO_DCH_Info", HFILL }},
    { &hf_umts_rrc_ies_dummy2_PDSCH_CodeMapping,
      { "dummy2-PDSCH-CodeMapping", "umts_rrc_ies.dummy2_PDSCH_CodeMapping",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_CodeMapping", HFILL }},
    { &hf_umts_rrc_ies_tdd24,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PrimaryCCPCH_Info_vals), 0,
        "umts_rrc_ies.PrimaryCCPCH_Info", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_DPCH_InfoPerRL_vals), 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL", HFILL }},
    { &hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH,
      { "dummy-SCCPCH-InfoForFACH", "umts_rrc_ies.dummy_SCCPCH_InfoForFACH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_InfoForFACH", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo21,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo21_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo21", HFILL }},
    { &hf_umts_rrc_ies_fdd24,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd23", HFILL }},
    { &hf_umts_rrc_ies_tdd25,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PrimaryCCPCH_Info_r4_vals), 0,
        "umts_rrc_ies.PrimaryCCPCH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL1,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_DPCH_InfoPerRL_r4_vals), 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL_r4", HFILL }},
    { &hf_umts_rrc_ies_dummy_SCCPCH_InfoForFACH_r4,
      { "dummy-SCCPCH-InfoForFACH-r4", "umts_rrc_ies.dummy_SCCPCH_InfoForFACH_r4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_InfoForFACH_r4", HFILL }},
    { &hf_umts_rrc_ies_cell_id,
      { "cell-id", "umts_rrc_ies.cell_id",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.CellIdentity", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo22,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo22_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo22", HFILL }},
    { &hf_umts_rrc_ies_fdd25,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd24", HFILL }},
    { &hf_umts_rrc_ies_servingHSDSCH_RL_indicator,
      { "servingHSDSCH-RL-indicator", "umts_rrc_ies.servingHSDSCH_RL_indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL2,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_DPCH_InfoPerRL_r5_vals), 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL_r5", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo23,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo23_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo23", HFILL }},
    { &hf_umts_rrc_ies_fdd26,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd25", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo24,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo24_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo24", HFILL }},
    { &hf_umts_rrc_ies_fdd27,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd26", HFILL }},
    { &hf_umts_rrc_ies_servingEDCH_RL_indicator,
      { "servingEDCH-RL-indicator", "umts_rrc_ies.servingEDCH_RL_indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dl_dpchInfo,
      { "dl-dpchInfo", "umts_rrc_ies.dl_dpchInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_dl_dpchInfo_vals), 0,
        "umts_rrc_ies.T_dl_dpchInfo", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL3,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_DPCH_InfoPerRL_r6_vals), 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL_r6", HFILL }},
    { &hf_umts_rrc_ies_dl_FDPCH_InfoPerRL,
      { "dl-FDPCH-InfoPerRL", "umts_rrc_ies.dl_FDPCH_InfoPerRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_FDPCH_InfoPerRL_r6", HFILL }},
    { &hf_umts_rrc_ies_e_AGCH_Information,
      { "e-AGCH-Information", "umts_rrc_ies.e_AGCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_AGCH_Information", HFILL }},
    { &hf_umts_rrc_ies_e_HICH_Information,
      { "e-HICH-Information", "umts_rrc_ies.e_HICH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_HICH_Information", HFILL }},
    { &hf_umts_rrc_ies_e_RGCH_Information,
      { "e-RGCH-Information", "umts_rrc_ies.e_RGCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_RGCH_Information", HFILL }},
    { &hf_umts_rrc_ies_DL_InformationPerRL_List_item,
      { "Item", "umts_rrc_ies.DL_InformationPerRL_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_InformationPerRL", HFILL }},
    { &hf_umts_rrc_ies_DL_InformationPerRL_List_r4_item,
      { "Item", "umts_rrc_ies.DL_InformationPerRL_List_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_InformationPerRL_r4", HFILL }},
    { &hf_umts_rrc_ies_DL_InformationPerRL_List_r5_item,
      { "Item", "umts_rrc_ies.DL_InformationPerRL_List_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_InformationPerRL_r5", HFILL }},
    { &hf_umts_rrc_ies_DL_InformationPerRL_List_r6_item,
      { "Item", "umts_rrc_ies.DL_InformationPerRL_List_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_InformationPerRL_r6", HFILL }},
    { &hf_umts_rrc_ies_DL_InformationPerRL_List_r5bis_item,
      { "Item", "umts_rrc_ies.DL_InformationPerRL_List_r5bis_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_InformationPerRL_r5bis", HFILL }},
    { &hf_umts_rrc_ies_DL_InformationPerRL_ListPostFDD_item,
      { "Item", "umts_rrc_ies.DL_InformationPerRL_ListPostFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_InformationPerRL_PostFDD", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL4,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL_PostFDD", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_Info,
      { "primaryCCPCH-Info", "umts_rrc_ies.primaryCCPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_InfoPost", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL5,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL_PostTDD", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_Info1,
      { "primaryCCPCH-Info", "umts_rrc_ies.primaryCCPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_InfoPostTDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_dl_DPCH_InfoPerRL6,
      { "dl-DPCH-InfoPerRL", "umts_rrc_ies.dl_DPCH_InfoPerRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_DPCH_InfoPerRL_PostTDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_restrictedTrCH_InfoList,
      { "restrictedTrCH-InfoList", "umts_rrc_ies.restrictedTrCH_InfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RestrictedTrCH_InfoList", HFILL }},
    { &hf_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List_item,
      { "Item", "umts_rrc_ies.DL_TPC_PowerOffsetPerRL_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_TPC_PowerOffsetPerRL", HFILL }},
    { &hf_umts_rrc_ies_codesRepresentation,
      { "codesRepresentation", "umts_rrc_ies.codesRepresentation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_codesRepresentation_vals), 0,
        "umts_rrc_ies.T_codesRepresentation", HFILL }},
    { &hf_umts_rrc_ies_consecutive,
      { "consecutive", "umts_rrc_ies.consecutive",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_consecutive", HFILL }},
    { &hf_umts_rrc_ies_firstChannelisationCode,
      { "firstChannelisationCode", "umts_rrc_ies.firstChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TS_ChannelisationCode_vals), 0,
        "umts_rrc_ies.DL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_lastChannelisationCode,
      { "lastChannelisationCode", "umts_rrc_ies.lastChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TS_ChannelisationCode_vals), 0,
        "umts_rrc_ies.DL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_bitmap,
      { "bitmap", "umts_rrc_ies.bitmap",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_bitmap", HFILL }},
    { &hf_umts_rrc_ies_parameters,
      { "parameters", "umts_rrc_ies.parameters",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_parameters_vals), 0,
        "umts_rrc_ies.T_parameters", HFILL }},
    { &hf_umts_rrc_ies_sameAsLast,
      { "sameAsLast", "umts_rrc_ies.sameAsLast",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sameAsLast", HFILL }},
    { &hf_umts_rrc_ies_timeslotNumber,
      { "timeslotNumber", "umts_rrc_ies.timeslotNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber", HFILL }},
    { &hf_umts_rrc_ies_newParameters,
      { "newParameters", "umts_rrc_ies.newParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_newParameters", HFILL }},
    { &hf_umts_rrc_ies_individualTimeslotInfo,
      { "individualTimeslotInfo", "umts_rrc_ies.individualTimeslotInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualTimeslotInfo", HFILL }},
    { &hf_umts_rrc_ies_dl_TS_ChannelisationCodesShort,
      { "dl-TS-ChannelisationCodesShort", "umts_rrc_ies.dl_TS_ChannelisationCodesShort",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_TS_ChannelisationCodesShort", HFILL }},
    { &hf_umts_rrc_ies_parameters1,
      { "parameters", "umts_rrc_ies.parameters",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_parameters1_vals), 0,
        "umts_rrc_ies.T_parameters1", HFILL }},
    { &hf_umts_rrc_ies_sameAsLast1,
      { "sameAsLast", "umts_rrc_ies.sameAsLast",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sameAsLast1", HFILL }},
    { &hf_umts_rrc_ies_timeslotNumber1,
      { "timeslotNumber", "umts_rrc_ies.timeslotNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newParameters1,
      { "newParameters", "umts_rrc_ies.newParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_newParameters1", HFILL }},
    { &hf_umts_rrc_ies_individualTimeslotInfo1,
      { "individualTimeslotInfo", "umts_rrc_ies.individualTimeslotInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualTimeslotInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_firstIndividualTimeslotInfo,
      { "firstIndividualTimeslotInfo", "umts_rrc_ies.firstIndividualTimeslotInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualTimeslotInfo", HFILL }},
    { &hf_umts_rrc_ies_moreTimeslots,
      { "moreTimeslots", "umts_rrc_ies.moreTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_moreTimeslots_vals), 0,
        "umts_rrc_ies.T_moreTimeslots", HFILL }},
    { &hf_umts_rrc_ies_noMore,
      { "noMore", "umts_rrc_ies.noMore",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_additionalTimeslots,
      { "additionalTimeslots", "umts_rrc_ies.additionalTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_additionalTimeslots_vals), 0,
        "umts_rrc_ies.T_additionalTimeslots", HFILL }},
    { &hf_umts_rrc_ies_consecutive1,
      { "consecutive", "umts_rrc_ies.consecutive",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxTS1", HFILL }},
    { &hf_umts_rrc_ies_timeslotList,
      { "timeslotList", "umts_rrc_ies.timeslotList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots", HFILL }},
    { &hf_umts_rrc_ies_timeslotList_item,
      { "Item", "umts_rrc_ies.timeslotList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkAdditionalTimeslots", HFILL }},
    { &hf_umts_rrc_ies_firstIndividualTimeslotInfo1,
      { "firstIndividualTimeslotInfo", "umts_rrc_ies.firstIndividualTimeslotInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualTimeslotInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_moreTimeslots1,
      { "moreTimeslots", "umts_rrc_ies.moreTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_moreTimeslots1_vals), 0,
        "umts_rrc_ies.T_moreTimeslots1", HFILL }},
    { &hf_umts_rrc_ies_additionalTimeslots1,
      { "additionalTimeslots", "umts_rrc_ies.additionalTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_additionalTimeslots1_vals), 0,
        "umts_rrc_ies.T_additionalTimeslots1", HFILL }},
    { &hf_umts_rrc_ies_consecutive2,
      { "consecutive", "umts_rrc_ies.consecutive",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxTSLCR1", HFILL }},
    { &hf_umts_rrc_ies_timeslotList1,
      { "timeslotList", "umts_rrc_ies.timeslotList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_timeslotList_item1,
      { "Item", "umts_rrc_ies.timeslotList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkAdditionalTimeslots_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_tgp_SequenceList,
      { "tgp-SequenceList", "umts_rrc_ies.tgp_SequenceList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGP_SequenceList", HFILL }},
    { &hf_umts_rrc_ies_tgps_Reconfiguration_CFN,
      { "tgps-Reconfiguration-CFN", "umts_rrc_ies.tgps_Reconfiguration_CFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGPS_Reconfiguration_CFN", HFILL }},
    { &hf_umts_rrc_ies_tgp_SequenceShortList,
      { "tgp-SequenceShortList", "umts_rrc_ies.tgp_SequenceShortList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort", HFILL }},
    { &hf_umts_rrc_ies_tgp_SequenceShortList_item,
      { "Item", "umts_rrc_ies.tgp_SequenceShortList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TGP_SequenceShort", HFILL }},
    { &hf_umts_rrc_ies_maxTFCI_Field2Value,
      { "maxTFCI-Field2Value", "umts_rrc_ies.maxTFCI_Field2Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxTFCI_Field2Value", HFILL }},
    { &hf_umts_rrc_ies_spreadingFactor,
      { "spreadingFactor", "umts_rrc_ies.spreadingFactor",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SF_PDSCH_vals), 0,
        "umts_rrc_ies.SF_PDSCH", HFILL }},
    { &hf_umts_rrc_ies_codeNumber,
      { "codeNumber", "umts_rrc_ies.codeNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CodeNumberDSCH", HFILL }},
    { &hf_umts_rrc_ies_multiCodeInfo,
      { "multiCodeInfo", "umts_rrc_ies.multiCodeInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MultiCodeInfo", HFILL }},
    { &hf_umts_rrc_ies_DSCH_MappingList_item,
      { "Item", "umts_rrc_ies.DSCH_MappingList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DSCH_Mapping", HFILL }},
    { &hf_umts_rrc_ies_DSCH_TransportChannelsInfo_item,
      { "Item", "umts_rrc_ies.DSCH_TransportChannelsInfo_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DSCH_TransportChannelsInfo_item", HFILL }},
    { &hf_umts_rrc_ies_dsch_transport_channel_identity,
      { "dsch-transport-channel-identity", "umts_rrc_ies.dsch_transport_channel_identity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_dsch_TFS,
      { "dsch-TFS", "umts_rrc_ies.dsch_TFS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_DynamicPersistenceLevelList_item,
      { "Item", "umts_rrc_ies.DynamicPersistenceLevelList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DynamicPersistenceLevel", HFILL }},
    { &hf_umts_rrc_ies_DynamicPersistenceLevelTF_List_item,
      { "Item", "umts_rrc_ies.DynamicPersistenceLevelTF_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DynamicPersistenceLevel", HFILL }},
    { &hf_umts_rrc_ies_e_AGCH_ChannelisationCode,
      { "e-AGCH-ChannelisationCode", "umts_rrc_ies.e_AGCH_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_AGCH_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_e_DPCCH_DPCCH_PowerOffset,
      { "e-DPCCH-DPCCH-PowerOffset", "umts_rrc_ies.e_DPCCH_DPCCH_PowerOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DPCCH_DPCCH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_happyBit_DelayCondition,
      { "happyBit-DelayCondition", "umts_rrc_ies.happyBit_DelayCondition",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_HappyBit_DelayCondition_vals), 0,
        "umts_rrc_ies.HappyBit_DelayCondition", HFILL }},
    { &hf_umts_rrc_ies_e_TFCI_TableIndex,
      { "e-TFCI-TableIndex", "umts_rrc_ies.e_TFCI_TableIndex",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_TFCI_TableIndex", HFILL }},
    { &hf_umts_rrc_ies_e_DCH_MinimumSet_E_TFCI,
      { "e-DCH-MinimumSet-E-TFCI", "umts_rrc_ies.e_DCH_MinimumSet_E_TFCI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DCH_MinimumSet_E_TFCI", HFILL }},
    { &hf_umts_rrc_ies_reference_E_TFCIs,
      { "reference-E-TFCIs", "umts_rrc_ies.reference_E_TFCIs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DPDCH_Reference_E_TFCIList", HFILL }},
    { &hf_umts_rrc_ies_maxChannelisationCodes,
      { "maxChannelisationCodes", "umts_rrc_ies.maxChannelisationCodes",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_E_DPDCH_MaxChannelisationCodes_vals), 0,
        "umts_rrc_ies.E_DPDCH_MaxChannelisationCodes", HFILL }},
    { &hf_umts_rrc_ies_pl_NonMax,
      { "pl-NonMax", "umts_rrc_ies.pl_NonMax",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_DPDCH_PL_NonMax", HFILL }},
    { &hf_umts_rrc_ies_schedulingInfoConfiguration,
      { "schedulingInfoConfiguration", "umts_rrc_ies.schedulingInfoConfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DPDCH_SchedulingInfoConfiguration", HFILL }},
    { &hf_umts_rrc_ies_schedulingTransmConfiguraration,
      { "schedulingTransmConfiguraration", "umts_rrc_ies.schedulingTransmConfiguraration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DPDCH_SchedulingTransmConfiguration", HFILL }},
    { &hf_umts_rrc_ies_reference_E_TFCI,
      { "reference-E-TFCI", "umts_rrc_ies.reference_E_TFCI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_reference_E_TFCI_PO,
      { "reference-E-TFCI-PO", "umts_rrc_ies.reference_E_TFCI_PO",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0", HFILL }},
    { &hf_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList_item,
      { "Item", "umts_rrc_ies.E_DPDCH_Reference_E_TFCIList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DPDCH_Reference_E_TFCI", HFILL }},
    { &hf_umts_rrc_ies_periodicityOfSchedInfo_NoGrant,
      { "periodicityOfSchedInfo-NoGrant", "umts_rrc_ies.periodicityOfSchedInfo_NoGrant",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_E_DPDCH_PeriodicyOfSchedInfo_vals), 0,
        "umts_rrc_ies.E_DPDCH_PeriodicyOfSchedInfo", HFILL }},
    { &hf_umts_rrc_ies_periodicityOfSchedInfo_Grant,
      { "periodicityOfSchedInfo-Grant", "umts_rrc_ies.periodicityOfSchedInfo_Grant",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_E_DPDCH_PeriodicyOfSchedInfo_vals), 0,
        "umts_rrc_ies.E_DPDCH_PeriodicyOfSchedInfo", HFILL }},
    { &hf_umts_rrc_ies_powerOffsetForSchedInfo,
      { "powerOffsetForSchedInfo", "umts_rrc_ies.powerOffsetForSchedInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_6", HFILL }},
    { &hf_umts_rrc_ies_ms2_SchedTransmGrantHARQAlloc,
      { "ms2-SchedTransmGrantHARQAlloc", "umts_rrc_ies.ms2_SchedTransmGrantHARQAlloc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_servingGrant,
      { "servingGrant", "umts_rrc_ies.servingGrant",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_primary_Secondary_GrantSelector,
      { "primary-Secondary-GrantSelector", "umts_rrc_ies.primary_Secondary_GrantSelector",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_primary_Secondary_GrantSelector_vals), 0,
        "umts_rrc_ies.T_primary_Secondary_GrantSelector", HFILL }},
    { &hf_umts_rrc_ies_dl_ScramblingCode,
      { "dl-ScramblingCode", "umts_rrc_ies.dl_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SecondaryScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_HICH_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_signatureSequence,
      { "signatureSequence", "umts_rrc_ies.signatureSequence",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_HICH_RGCH_SignatureSequence", HFILL }},
    { &hf_umts_rrc_ies_rg_CombinationIndex,
      { "rg-CombinationIndex", "umts_rrc_ies.rg_CombinationIndex",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_RGCH_CombinationIndex", HFILL }},
    { &hf_umts_rrc_ies_e_RGCH_StepSize,
      { "e-RGCH-StepSize", "umts_rrc_ies.e_RGCH_StepSize",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.E_RGCH_StepSize", HFILL }},
    { &hf_umts_rrc_ies_ctch_Indicator,
      { "ctch-Indicator", "umts_rrc_ies.ctch_Indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_FACH_PCH_InformationList_item,
      { "Item", "umts_rrc_ies.FACH_PCH_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FACH_PCH_Information", HFILL }},
    { &hf_umts_rrc_ies_timeslot1,
      { "timeslot", "umts_rrc_ies.timeslot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode1,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TDD_FPACH_CCode16_r4_vals), 0,
        "umts_rrc_ies.TDD_FPACH_CCode16_r4", HFILL }},
    { &hf_umts_rrc_ies_midambleShiftAndBurstType1,
      { "midambleShiftAndBurstType", "umts_rrc_ies.midambleShiftAndBurstType",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MidambleShiftAndBurstType_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_wi,
      { "wi", "umts_rrc_ies.wi",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Wi_LCR", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo25,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo25_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo25", HFILL }},
    { &hf_umts_rrc_ies_fdd28,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfoFDD", HFILL }},
    { &hf_umts_rrc_ies_tdd26,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfoTDD", HFILL }},
    { &hf_umts_rrc_ies_uarfcn_UL,
      { "uarfcn-UL", "umts_rrc_ies.uarfcn_UL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UARFCN", HFILL }},
    { &hf_umts_rrc_ies_uarfcn_DL,
      { "uarfcn-DL", "umts_rrc_ies.uarfcn_DL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UARFCN", HFILL }},
    { &hf_umts_rrc_ies_uarfcn_Nt,
      { "uarfcn-Nt", "umts_rrc_ies.uarfcn_Nt",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UARFCN", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode", HFILL }},
    { &hf_umts_rrc_ies_defaultMidamble,
      { "defaultMidamble", "umts_rrc_ies.defaultMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_commonMidamble,
      { "commonMidamble", "umts_rrc_ies.commonMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_midambleConfiguration,
      { "midambleConfiguration", "umts_rrc_ies.midambleConfiguration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_8", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo26,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo26_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo26", HFILL }},
    { &hf_umts_rrc_ies_fdd29,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd27", HFILL }},
    { &hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo,
      { "hS-SCCHChannelisationCodeInfo", "umts_rrc_ies.hS_SCCHChannelisationCodeInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes", HFILL }},
    { &hf_umts_rrc_ies_hS_SCCHChannelisationCodeInfo_item,
      { "Item", "umts_rrc_ies.hS_SCCHChannelisationCodeInfo_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HS_SCCH_Codes", HFILL }},
    { &hf_umts_rrc_ies_tdd27,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd23_vals), 0,
        "umts_rrc_ies.T_tdd23", HFILL }},
    { &hf_umts_rrc_ies_tdd3844,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3843", HFILL }},
    { &hf_umts_rrc_ies_nack_ack_power_offset,
      { "nack-ack-power-offset", "umts_rrc_ies.nack_ack_power_offset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M7_8", HFILL }},
    { &hf_umts_rrc_ies_hs_SICH_PowerControl_Info,
      { "hs-SICH-PowerControl-Info", "umts_rrc_ies.hs_SICH_PowerControl_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SICH_Power_Control_Info_TDD384", HFILL }},
    { &hf_umts_rrc_ies_hS_SCCH_SetConfiguration,
      { "hS-SCCH-SetConfiguration", "umts_rrc_ies.hS_SCCH_SetConfiguration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384", HFILL }},
    { &hf_umts_rrc_ies_hS_SCCH_SetConfiguration_item,
      { "Item", "umts_rrc_ies.hS_SCCH_SetConfiguration_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SCCH_TDD384", HFILL }},
    { &hf_umts_rrc_ies_tdd1286,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128", HFILL }},
    { &hf_umts_rrc_ies_tdd128_item,
      { "Item", "umts_rrc_ies.tdd128_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SCCH_TDD128", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo27,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo27_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo27", HFILL }},
    { &hf_umts_rrc_ies_fdd30,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd28", HFILL }},
    { &hf_umts_rrc_ies_tdd28,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tdd24_vals), 0,
        "umts_rrc_ies.T_tdd24", HFILL }},
    { &hf_umts_rrc_ies_tdd3845,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3844", HFILL }},
    { &hf_umts_rrc_ies_dhs_sync,
      { "dhs-sync", "umts_rrc_ies.dhs_sync",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DHS_Sync", HFILL }},
    { &hf_umts_rrc_ies_firstChannelisationCode1,
      { "firstChannelisationCode", "umts_rrc_ies.firstChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_HS_ChannelisationCode_LCR_vals), 0,
        "umts_rrc_ies.HS_ChannelisationCode_LCR", HFILL }},
    { &hf_umts_rrc_ies_secondChannelisationCode,
      { "secondChannelisationCode", "umts_rrc_ies.secondChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_HS_ChannelisationCode_LCR_vals), 0,
        "umts_rrc_ies.HS_ChannelisationCode_LCR", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode1,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode1_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode1", HFILL }},
    { &hf_umts_rrc_ies_bler_target,
      { "bler-target", "umts_rrc_ies.bler_target",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Bler_Target", HFILL }},
    { &hf_umts_rrc_ies_hs_sich_configuration,
      { "hs-sich-configuration", "umts_rrc_ies.hs_sich_configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SICH_Configuration_TDD128", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode2,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_HS_ChannelisationCode_LCR_vals), 0,
        "umts_rrc_ies.HS_ChannelisationCode_LCR", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode2,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode2_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode2", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble1,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble", HFILL }},
    { &hf_umts_rrc_ies_power_level_HSSICH,
      { "power-level-HSSICH", "umts_rrc_ies.power_level_HSSICH",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M120_M58", HFILL }},
    { &hf_umts_rrc_ies_tpc_step_size,
      { "tpc-step-size", "umts_rrc_ies.tpc_step_size",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tpc_step_size_vals), 0,
        "umts_rrc_ies.T_tpc_step_size", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode3,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TS_ChannelisationCode_vals), 0,
        "umts_rrc_ies.DL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode3,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode3_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode3", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble2,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble1", HFILL }},
    { &hf_umts_rrc_ies_midambleconfiguration,
      { "midambleconfiguration", "umts_rrc_ies.midambleconfiguration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MidambleConfigurationBurstType1and3_vals), 0,
        "umts_rrc_ies.MidambleConfigurationBurstType1and3", HFILL }},
    { &hf_umts_rrc_ies_hs_sich_configuration1,
      { "hs-sich-configuration", "umts_rrc_ies.hs_sich_configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HS_SICH_Configuration_TDD384", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode4,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode4_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode4", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble3,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble2", HFILL }},
    { &hf_umts_rrc_ies_ul_target_SIR,
      { "ul-target-SIR", "umts_rrc_ies.ul_target_SIR",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M22_40", HFILL }},
    { &hf_umts_rrc_ies_hs_sich_ConstantValue,
      { "hs-sich-ConstantValue", "umts_rrc_ies.hs_sich_ConstantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ConstantValue", HFILL }},
    { &hf_umts_rrc_ies_midambleShiftAndBurstType2,
      { "midambleShiftAndBurstType", "umts_rrc_ies.midambleShiftAndBurstType",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MidambleShiftAndBurstType", HFILL }},
    { &hf_umts_rrc_ies_modulation,
      { "modulation", "umts_rrc_ies.modulation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modulation_vals), 0,
        "umts_rrc_ies.T_modulation", HFILL }},
    { &hf_umts_rrc_ies_ss_TPC_Symbols,
      { "ss-TPC-Symbols", "umts_rrc_ies.ss_TPC_Symbols",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ss_TPC_Symbols_vals), 0,
        "umts_rrc_ies.T_ss_TPC_Symbols", HFILL }},
    { &hf_umts_rrc_ies_additionalSS_TPC_Symbols,
      { "additionalSS-TPC-Symbols", "umts_rrc_ies.additionalSS_TPC_Symbols",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_15", HFILL }},
    { &hf_umts_rrc_ies_modulation1,
      { "modulation", "umts_rrc_ies.modulation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modulation1_vals), 0,
        "umts_rrc_ies.T_modulation1", HFILL }},
    { &hf_umts_rrc_ies_ss_TPC_Symbols1,
      { "ss-TPC-Symbols", "umts_rrc_ies.ss_TPC_Symbols",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ss_TPC_Symbols1_vals), 0,
        "umts_rrc_ies.T_ss_TPC_Symbols1", HFILL }},
    { &hf_umts_rrc_ies_ul_TimeslotInterference,
      { "ul-TimeslotInterference", "umts_rrc_ies.ul_TimeslotInterference",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TDD_UL_Interference", HFILL }},
    { &hf_umts_rrc_ies_IndividualTS_InterferenceList_item,
      { "Item", "umts_rrc_ies.IndividualTS_InterferenceList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualTS_Interference", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo28,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo28_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo28", HFILL }},
    { &hf_umts_rrc_ies_fdd31,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd29", HFILL }},
    { &hf_umts_rrc_ies_measurementPowerOffset,
      { "measurementPowerOffset", "umts_rrc_ies.measurementPowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MeasurementPowerOffset", HFILL }},
    { &hf_umts_rrc_ies_feedback_cycle,
      { "feedback-cycle", "umts_rrc_ies.feedback_cycle",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_Feedback_cycle_vals), 0,
        "umts_rrc_ies.Feedback_cycle", HFILL }},
    { &hf_umts_rrc_ies_cqi_RepetitionFactor,
      { "cqi-RepetitionFactor", "umts_rrc_ies.cqi_RepetitionFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CQI_RepetitionFactor", HFILL }},
    { &hf_umts_rrc_ies_deltaCQI,
      { "deltaCQI", "umts_rrc_ies.deltaCQI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaCQI", HFILL }},
    { &hf_umts_rrc_ies_burstType1,
      { "burstType", "umts_rrc_ies.burstType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_burstType_vals), 0,
        "umts_rrc_ies.T_burstType", HFILL }},
    { &hf_umts_rrc_ies_type11,
      { "type1", "umts_rrc_ies.type1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_type11", HFILL }},
    { &hf_umts_rrc_ies_midambleConfigurationBurstType1and3,
      { "midambleConfigurationBurstType1and3", "umts_rrc_ies.midambleConfigurationBurstType1and3",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MidambleConfigurationBurstType1and3_vals), 0,
        "umts_rrc_ies.MidambleConfigurationBurstType1and3", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode5,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode5_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode5", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble4,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble3", HFILL }},
    { &hf_umts_rrc_ies_type2,
      { "type2", "umts_rrc_ies.type2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_type2", HFILL }},
    { &hf_umts_rrc_ies_midambleConfigurationBurstType2,
      { "midambleConfigurationBurstType2", "umts_rrc_ies.midambleConfigurationBurstType2",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MidambleConfigurationBurstType2_vals), 0,
        "umts_rrc_ies.MidambleConfigurationBurstType2", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode6,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode6_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode6", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble5,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble4", HFILL }},
    { &hf_umts_rrc_ies_midambleShift1,
      { "midambleShift", "umts_rrc_ies.midambleShift",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MidambleShiftShort", HFILL }},
    { &hf_umts_rrc_ies_type3,
      { "type3", "umts_rrc_ies.type3",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_type3", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode7,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode7_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode7", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble6,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble5", HFILL }},
    { &hf_umts_rrc_ies_burstType2,
      { "burstType", "umts_rrc_ies.burstType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_burstType1_vals), 0,
        "umts_rrc_ies.T_burstType1", HFILL }},
    { &hf_umts_rrc_ies_type12,
      { "type1", "umts_rrc_ies.type1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_type12", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode8,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode8_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode8", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble7,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble6", HFILL }},
    { &hf_umts_rrc_ies_type21,
      { "type2", "umts_rrc_ies.type2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_type21", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode9,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode9_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode9", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble8,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble7", HFILL }},
    { &hf_umts_rrc_ies_midambleAllocationMode10,
      { "midambleAllocationMode", "umts_rrc_ies.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_midambleAllocationMode10_vals), 0,
        "umts_rrc_ies.T_midambleAllocationMode10", HFILL }},
    { &hf_umts_rrc_ies_ueSpecificMidamble9,
      { "ueSpecificMidamble", "umts_rrc_ies.ueSpecificMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueSpecificMidamble8", HFILL }},
    { &hf_umts_rrc_ies_midambleShift2,
      { "midambleShift", "umts_rrc_ies.midambleShift",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_TX_Power,
      { "primaryCCPCH-TX-Power", "umts_rrc_ies.primaryCCPCH_TX_Power",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_TX_Power", HFILL }},
    { &hf_umts_rrc_ies_alpha,
      { "alpha", "umts_rrc_ies.alpha",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Alpha", HFILL }},
    { &hf_umts_rrc_ies_prach_ConstantValue,
      { "prach-ConstantValue", "umts_rrc_ies.prach_ConstantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ConstantValueTdd", HFILL }},
    { &hf_umts_rrc_ies_dpch_ConstantValue,
      { "dpch-ConstantValue", "umts_rrc_ies.dpch_ConstantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ConstantValueTdd", HFILL }},
    { &hf_umts_rrc_ies_pusch_ConstantValue,
      { "pusch-ConstantValue", "umts_rrc_ies.pusch_ConstantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ConstantValueTdd", HFILL }},
    { &hf_umts_rrc_ies_ipdl_alpha,
      { "ipdl-alpha", "umts_rrc_ies.ipdl_alpha",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Alpha", HFILL }},
    { &hf_umts_rrc_ies_maxPowerIncrease,
      { "maxPowerIncrease", "umts_rrc_ies.maxPowerIncrease",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxPowerIncrease_r4", HFILL }},
    { &hf_umts_rrc_ies_pcpch_UL_ScramblingCode,
      { "pcpch-UL-ScramblingCode", "umts_rrc_ies.pcpch_UL_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_79", HFILL }},
    { &hf_umts_rrc_ies_pcpch_DL_ChannelisationCode,
      { "pcpch-DL-ChannelisationCode", "umts_rrc_ies.pcpch_DL_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_511", HFILL }},
    { &hf_umts_rrc_ies_pcpch_DL_ScramblingCode,
      { "pcpch-DL-ScramblingCode", "umts_rrc_ies.pcpch_DL_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SecondaryScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_pcp_Length,
      { "pcp-Length", "umts_rrc_ies.pcp_Length",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PCP_Length_vals), 0,
        "umts_rrc_ies.PCP_Length", HFILL }},
    { &hf_umts_rrc_ies_ucsm_Info,
      { "ucsm-Info", "umts_rrc_ies.ucsm_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UCSM_Info", HFILL }},
    { &hf_umts_rrc_ies_PCPCH_ChannelInfoList_item,
      { "Item", "umts_rrc_ies.PCPCH_ChannelInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PCPCH_ChannelInfo", HFILL }},
    { &hf_umts_rrc_ies_pdsch_PowerControlInfo,
      { "pdsch-PowerControlInfo", "umts_rrc_ies.pdsch_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_PowerControlInfo", HFILL }},
    { &hf_umts_rrc_ies_pdsch_AllocationPeriodInfo,
      { "pdsch-AllocationPeriodInfo", "umts_rrc_ies.pdsch_AllocationPeriodInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AllocationPeriodInfo", HFILL }},
    { &hf_umts_rrc_ies_configuration,
      { "configuration", "umts_rrc_ies.configuration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_configuration_vals), 0,
        "umts_rrc_ies.T_configuration", HFILL }},
    { &hf_umts_rrc_ies_old_Configuration,
      { "old-Configuration", "umts_rrc_ies.old_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_old_Configuration", HFILL }},
    { &hf_umts_rrc_ies_pdsch_Identity,
      { "pdsch-Identity", "umts_rrc_ies.pdsch_Identity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_Identity", HFILL }},
    { &hf_umts_rrc_ies_new_Configuration,
      { "new-Configuration", "umts_rrc_ies.new_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_new_Configuration", HFILL }},
    { &hf_umts_rrc_ies_pdsch_Info,
      { "pdsch-Info", "umts_rrc_ies.pdsch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_Info", HFILL }},
    { &hf_umts_rrc_ies_configuration1,
      { "configuration", "umts_rrc_ies.configuration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_configuration1_vals), 0,
        "umts_rrc_ies.T_configuration1", HFILL }},
    { &hf_umts_rrc_ies_old_Configuration1,
      { "old-Configuration", "umts_rrc_ies.old_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_old_Configuration1", HFILL }},
    { &hf_umts_rrc_ies_new_Configuration1,
      { "new-Configuration", "umts_rrc_ies.new_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_new_Configuration1", HFILL }},
    { &hf_umts_rrc_ies_pdsch_Info1,
      { "pdsch-Info", "umts_rrc_ies.pdsch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_CodeInfoList_item,
      { "Item", "umts_rrc_ies.PDSCH_CodeInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_CodeInfo", HFILL }},
    { &hf_umts_rrc_ies_codeNumberStart,
      { "codeNumberStart", "umts_rrc_ies.codeNumberStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CodeNumberDSCH", HFILL }},
    { &hf_umts_rrc_ies_codeNumberStop,
      { "codeNumberStop", "umts_rrc_ies.codeNumberStop",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CodeNumberDSCH", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_CodeMapList_item,
      { "Item", "umts_rrc_ies.PDSCH_CodeMapList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_CodeMap", HFILL }},
    { &hf_umts_rrc_ies_signallingMethod,
      { "signallingMethod", "umts_rrc_ies.signallingMethod",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_signallingMethod_vals), 0,
        "umts_rrc_ies.T_signallingMethod", HFILL }},
    { &hf_umts_rrc_ies_codeRange,
      { "codeRange", "umts_rrc_ies.codeRange",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CodeRange", HFILL }},
    { &hf_umts_rrc_ies_tfci_Range1,
      { "tfci-Range", "umts_rrc_ies.tfci_Range",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DSCH_MappingList", HFILL }},
    { &hf_umts_rrc_ies_explicit_config3,
      { "explicit-config", "umts_rrc_ies.explicit_config",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_CodeInfoList", HFILL }},
    { &hf_umts_rrc_ies_replace,
      { "replace", "umts_rrc_ies.replace",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ReplacedPDSCH_CodeInfoList", HFILL }},
    { &hf_umts_rrc_ies_pdsch_TimeslotsCodes,
      { "pdsch-TimeslotsCodes", "umts_rrc_ies.pdsch_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes", HFILL }},
    { &hf_umts_rrc_ies_tddOption4,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption4_vals), 0,
        "umts_rrc_ies.T_tddOption4", HFILL }},
    { &hf_umts_rrc_ies_tdd3846,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3845", HFILL }},
    { &hf_umts_rrc_ies_tdd1287,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1286", HFILL }},
    { &hf_umts_rrc_ies_pdsch_TimeslotsCodes1,
      { "pdsch-TimeslotsCodes", "umts_rrc_ies.pdsch_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_dsch_RadioLinkIdentifier,
      { "dsch-RadioLinkIdentifier", "umts_rrc_ies.dsch_RadioLinkIdentifier",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DSCH_RadioLinkIdentifier", HFILL }},
    { &hf_umts_rrc_ies_rl_IdentifierList,
      { "rl-IdentifierList", "umts_rrc_ies.rl_IdentifierList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RL_IdentifierList", HFILL }},
    { &hf_umts_rrc_ies_dsch_TFCS,
      { "dsch-TFCS", "umts_rrc_ies.dsch_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_dsch_TransportChannelsInfo,
      { "dsch-TransportChannelsInfo", "umts_rrc_ies.dsch_TransportChannelsInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DSCH_TransportChannelsInfo", HFILL }},
    { &hf_umts_rrc_ies_pdsch_Info2,
      { "pdsch-Info", "umts_rrc_ies.pdsch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_SysInfoList_item,
      { "Item", "umts_rrc_ies.PDSCH_SysInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfo", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5_item,
      { "Item", "umts_rrc_ies.PDSCH_SysInfoList_HCR_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfo_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4_item,
      { "Item", "umts_rrc_ies.PDSCH_SysInfoList_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_item,
      { "Item", "umts_rrc_ies.PDSCH_SysInfoList_SFN_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_SFN_item", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfo,
      { "pdsch-SysInfo", "umts_rrc_ies.pdsch_SysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfo", HFILL }},
    { &hf_umts_rrc_ies_sfn_TimeInfo,
      { "sfn-TimeInfo", "umts_rrc_ies.sfn_TimeInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SFN_TimeInfo", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item,
      { "Item", "umts_rrc_ies.PDSCH_SysInfoList_SFN_HCR_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_SFN_HCR_r5_item", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfo1,
      { "pdsch-SysInfo", "umts_rrc_ies.pdsch_SysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfo_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item,
      { "Item", "umts_rrc_ies.PDSCH_SysInfoList_SFN_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_SFN_LCR_r4_item", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfo2,
      { "pdsch-SysInfo", "umts_rrc_ies.pdsch_SysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_PersistenceScalingFactorList_item,
      { "Item", "umts_rrc_ies.PersistenceScalingFactorList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PersistenceScalingFactor_vals), 0,
        "umts_rrc_ies.PersistenceScalingFactor", HFILL }},
    { &hf_umts_rrc_ies_PichChannelisationCodeList_LCR_r4_item,
      { "Item", "umts_rrc_ies.PichChannelisationCodeList_LCR_r4_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TS_ChannelisationCode_vals), 0,
        "umts_rrc_ies.DL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_fdd32,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd30", HFILL }},
    { &hf_umts_rrc_ies_pi_CountPerFrame,
      { "pi-CountPerFrame", "umts_rrc_ies.pi_CountPerFrame",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PI_CountPerFrame_vals), 0,
        "umts_rrc_ies.PI_CountPerFrame", HFILL }},
    { &hf_umts_rrc_ies_tdd29,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd25", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode4,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TDD_PICH_CCode_vals), 0,
        "umts_rrc_ies.TDD_PICH_CCode", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriodLengthOffset,
      { "repetitionPeriodLengthOffset", "umts_rrc_ies.repetitionPeriodLengthOffset",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RepPerLengthOffset_PICH_vals), 0,
        "umts_rrc_ies.RepPerLengthOffset_PICH", HFILL }},
    { &hf_umts_rrc_ies_pagingIndicatorLength,
      { "pagingIndicatorLength", "umts_rrc_ies.pagingIndicatorLength",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PagingIndicatorLength_vals), 0,
        "umts_rrc_ies.PagingIndicatorLength", HFILL }},
    { &hf_umts_rrc_ies_n_GAP,
      { "n-GAP", "umts_rrc_ies.n_GAP",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_N_GAP_vals), 0,
        "umts_rrc_ies.N_GAP", HFILL }},
    { &hf_umts_rrc_ies_n_PCH,
      { "n-PCH", "umts_rrc_ies.n_PCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.N_PCH", HFILL }},
    { &hf_umts_rrc_ies_pichChannelisationCodeList_LCR_r4,
      { "pichChannelisationCodeList-LCR-r4", "umts_rrc_ies.pichChannelisationCodeList_LCR_r4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PichChannelisationCodeList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_algorithm1,
      { "algorithm1", "umts_rrc_ies.algorithm1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TPC_StepSizeFDD", HFILL }},
    { &hf_umts_rrc_ies_algorithm2,
      { "algorithm2", "umts_rrc_ies.algorithm2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_PRACH_ChanCodes_LCR_r4_item,
      { "Item", "umts_rrc_ies.PRACH_ChanCodes_LCR_r4_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TDD_PRACH_CCode_LCR_r4_vals), 0,
        "umts_rrc_ies.TDD_PRACH_CCode_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_timeslot2,
      { "timeslot", "umts_rrc_ies.timeslot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber_PRACH_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_prach_ChanCodes_LCR,
      { "prach-ChanCodes-LCR", "umts_rrc_ies.prach_ChanCodes_LCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PRACH_ChanCodes_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_fpach_Info,
      { "fpach-Info", "umts_rrc_ies.fpach_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FPACH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_fdd33,
      { "fdd", "umts_rrc_ies.fdd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD", HFILL }},
    { &hf_umts_rrc_ies_fdd_item,
      { "Item", "umts_rrc_ies.fdd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ASCSetting_FDD", HFILL }},
    { &hf_umts_rrc_ies_tdd30,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD", HFILL }},
    { &hf_umts_rrc_ies_tdd_item,
      { "Item", "umts_rrc_ies.tdd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ASCSetting_TDD", HFILL }},
    { &hf_umts_rrc_ies_PRACH_Partitioning_LCR_r4_item,
      { "Item", "umts_rrc_ies.PRACH_Partitioning_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ASCSetting_TDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_powerRampStep,
      { "powerRampStep", "umts_rrc_ies.powerRampStep",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PowerRampStep", HFILL }},
    { &hf_umts_rrc_ies_preambleRetransMax,
      { "preambleRetransMax", "umts_rrc_ies.preambleRetransMax",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PreambleRetransMax", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo29,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo29_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo29", HFILL }},
    { &hf_umts_rrc_ies_fdd34,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd31", HFILL }},
    { &hf_umts_rrc_ies_availableSignatures,
      { "availableSignatures", "umts_rrc_ies.availableSignatures",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.AvailableSignatures", HFILL }},
    { &hf_umts_rrc_ies_availableSF,
      { "availableSF", "umts_rrc_ies.availableSF",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SF_PRACH_vals), 0,
        "umts_rrc_ies.SF_PRACH", HFILL }},
    { &hf_umts_rrc_ies_preambleScramblingCodeWordNumber,
      { "preambleScramblingCodeWordNumber", "umts_rrc_ies.preambleScramblingCodeWordNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PreambleScramblingCodeWordNumber", HFILL }},
    { &hf_umts_rrc_ies_availableSubChannelNumbers,
      { "availableSubChannelNumbers", "umts_rrc_ies.availableSubChannelNumbers",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.AvailableSubChannelNumbers", HFILL }},
    { &hf_umts_rrc_ies_tdd31,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd26", HFILL }},
    { &hf_umts_rrc_ies_channelisationCodeList,
      { "channelisationCodeList", "umts_rrc_ies.channelisationCodeList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TDD_PRACH_CCodeList_vals), 0,
        "umts_rrc_ies.TDD_PRACH_CCodeList", HFILL }},
    { &hf_umts_rrc_ies_prach_Midamble,
      { "prach-Midamble", "umts_rrc_ies.prach_Midamble",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PRACH_Midamble_vals), 0,
        "umts_rrc_ies.PRACH_Midamble", HFILL }},
    { &hf_umts_rrc_ies_sync_UL_Info,
      { "sync-UL-Info", "umts_rrc_ies.sync_UL_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SYNC_UL_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_prach_DefinitionList,
      { "prach-DefinitionList", "umts_rrc_ies.prach_DefinitionList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_prach_DefinitionList_item,
      { "Item", "umts_rrc_ies.prach_DefinitionList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PRACH_Definition_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_prach_RACH_Info,
      { "prach-RACH-Info", "umts_rrc_ies.prach_RACH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PRACH_RACH_Info", HFILL }},
    { &hf_umts_rrc_ies_rach_TransportFormatSet,
      { "rach-TransportFormatSet", "umts_rrc_ies.rach_TransportFormatSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_rach_TFCS,
      { "rach-TFCS", "umts_rrc_ies.rach_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_prach_Partitioning,
      { "prach-Partitioning", "umts_rrc_ies.prach_Partitioning",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PRACH_Partitioning_vals), 0,
        "umts_rrc_ies.PRACH_Partitioning", HFILL }},
    { &hf_umts_rrc_ies_persistenceScalingFactorList,
      { "persistenceScalingFactorList", "umts_rrc_ies.persistenceScalingFactorList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PersistenceScalingFactorList", HFILL }},
    { &hf_umts_rrc_ies_ac_To_ASC_MappingTable,
      { "ac-To-ASC-MappingTable", "umts_rrc_ies.ac_To_ASC_MappingTable",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AC_To_ASC_MappingTable", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo30,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo30_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo30", HFILL }},
    { &hf_umts_rrc_ies_fdd35,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd32", HFILL }},
    { &hf_umts_rrc_ies_primaryCPICH_TX_Power,
      { "primaryCPICH-TX-Power", "umts_rrc_ies.primaryCPICH_TX_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_TX_Power", HFILL }},
    { &hf_umts_rrc_ies_constantValue,
      { "constantValue", "umts_rrc_ies.constantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ConstantValue", HFILL }},
    { &hf_umts_rrc_ies_prach_PowerOffset,
      { "prach-PowerOffset", "umts_rrc_ies.prach_PowerOffset",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PRACH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_rach_TransmissionParameters,
      { "rach-TransmissionParameters", "umts_rrc_ies.rach_TransmissionParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RACH_TransmissionParameters", HFILL }},
    { &hf_umts_rrc_ies_aich_Info,
      { "aich-Info", "umts_rrc_ies.aich_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AICH_Info", HFILL }},
    { &hf_umts_rrc_ies_prach_RACH_Info_LCR,
      { "prach-RACH-Info-LCR", "umts_rrc_ies.prach_RACH_Info_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PRACH_RACH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_rach_TransportFormatSet_LCR,
      { "rach-TransportFormatSet-LCR", "umts_rrc_ies.rach_TransportFormatSet_LCR",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_LCR_vals), 0,
        "umts_rrc_ies.TransportFormatSet_LCR", HFILL }},
    { &hf_umts_rrc_ies_prach_Partitioning_LCR,
      { "prach-Partitioning-LCR", "umts_rrc_ies.prach_Partitioning_LCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PRACH_Partitioning_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_PRACH_SystemInformationList_item,
      { "Item", "umts_rrc_ies.PRACH_SystemInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PRACH_SystemInformation", HFILL }},
    { &hf_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4_item,
      { "Item", "umts_rrc_ies.PRACH_SystemInformationList_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PRACH_SystemInformation_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_InfoPredef,
      { "ul-DPCH-InfoPredef", "umts_rrc_ies.ul_DPCH_InfoPredef",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_InfoPredef", HFILL }},
    { &hf_umts_rrc_ies_dl_CommonInformationPredef,
      { "dl-CommonInformationPredef", "umts_rrc_ies.dl_CommonInformationPredef",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DL_CommonInformationPredef", HFILL }},
    { &hf_umts_rrc_ies_fdd36,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd33", HFILL }},
    { &hf_umts_rrc_ies_tx_DiversityIndicator,
      { "tx-DiversityIndicator", "umts_rrc_ies.tx_DiversityIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd32,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd27", HFILL }},
    { &hf_umts_rrc_ies_syncCase,
      { "syncCase", "umts_rrc_ies.syncCase",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SyncCase_vals), 0,
        "umts_rrc_ies.SyncCase", HFILL }},
    { &hf_umts_rrc_ies_sctd_Indicator,
      { "sctd-Indicator", "umts_rrc_ies.sctd_Indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_syncCase1,
      { "syncCase1", "umts_rrc_ies.syncCase1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_syncCase1", HFILL }},
    { &hf_umts_rrc_ies_syncCase2,
      { "syncCase2", "umts_rrc_ies.syncCase2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_syncCase2", HFILL }},
    { &hf_umts_rrc_ies_timeslotSync2,
      { "timeslotSync2", "umts_rrc_ies.timeslotSync2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotSync2", HFILL }},
    { &hf_umts_rrc_ies_fdd37,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd34", HFILL }},
    { &hf_umts_rrc_ies_tdd33,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd28", HFILL }},
    { &hf_umts_rrc_ies_tddOption5,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption5_vals), 0,
        "umts_rrc_ies.T_tddOption5", HFILL }},
    { &hf_umts_rrc_ies_tdd3847,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3846", HFILL }},
    { &hf_umts_rrc_ies_tdd1288,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1287", HFILL }},
    { &hf_umts_rrc_ies_primaryScramblingCode,
      { "primaryScramblingCode", "umts_rrc_ies.primaryScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PrimaryScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_pusch_Allocation,
      { "pusch-Allocation", "umts_rrc_ies.pusch_Allocation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_pusch_Allocation_vals), 0,
        "umts_rrc_ies.T_pusch_Allocation", HFILL }},
    { &hf_umts_rrc_ies_pusch_AllocationPending,
      { "pusch-AllocationPending", "umts_rrc_ies.pusch_AllocationPending",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_pusch_AllocationAssignment,
      { "pusch-AllocationAssignment", "umts_rrc_ies.pusch_AllocationAssignment",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_pusch_AllocationAssignment", HFILL }},
    { &hf_umts_rrc_ies_pusch_AllocationPeriodInfo,
      { "pusch-AllocationPeriodInfo", "umts_rrc_ies.pusch_AllocationPeriodInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AllocationPeriodInfo", HFILL }},
    { &hf_umts_rrc_ies_pusch_PowerControlInfo,
      { "pusch-PowerControlInfo", "umts_rrc_ies.pusch_PowerControlInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_TargetSIR", HFILL }},
    { &hf_umts_rrc_ies_configuration2,
      { "configuration", "umts_rrc_ies.configuration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_configuration2_vals), 0,
        "umts_rrc_ies.T_configuration2", HFILL }},
    { &hf_umts_rrc_ies_old_Configuration2,
      { "old-Configuration", "umts_rrc_ies.old_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_old_Configuration2", HFILL }},
    { &hf_umts_rrc_ies_pusch_Identity,
      { "pusch-Identity", "umts_rrc_ies.pusch_Identity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_Identity", HFILL }},
    { &hf_umts_rrc_ies_new_Configuration2,
      { "new-Configuration", "umts_rrc_ies.new_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_new_Configuration2", HFILL }},
    { &hf_umts_rrc_ies_pusch_Info,
      { "pusch-Info", "umts_rrc_ies.pusch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_Info", HFILL }},
    { &hf_umts_rrc_ies_pusch_Allocation1,
      { "pusch-Allocation", "umts_rrc_ies.pusch_Allocation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_pusch_Allocation1_vals), 0,
        "umts_rrc_ies.T_pusch_Allocation1", HFILL }},
    { &hf_umts_rrc_ies_pusch_AllocationAssignment1,
      { "pusch-AllocationAssignment", "umts_rrc_ies.pusch_AllocationAssignment",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_pusch_AllocationAssignment1", HFILL }},
    { &hf_umts_rrc_ies_pusch_PowerControlInfo1,
      { "pusch-PowerControlInfo", "umts_rrc_ies.pusch_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_PowerControlInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_configuration3,
      { "configuration", "umts_rrc_ies.configuration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_configuration3_vals), 0,
        "umts_rrc_ies.T_configuration3", HFILL }},
    { &hf_umts_rrc_ies_old_Configuration3,
      { "old-Configuration", "umts_rrc_ies.old_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_old_Configuration3", HFILL }},
    { &hf_umts_rrc_ies_new_Configuration3,
      { "new-Configuration", "umts_rrc_ies.new_Configuration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_new_Configuration3", HFILL }},
    { &hf_umts_rrc_ies_pusch_Info1,
      { "pusch-Info", "umts_rrc_ies.pusch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_pusch_TimeslotsCodes,
      { "pusch-TimeslotsCodes", "umts_rrc_ies.pusch_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UplinkTimeslotsCodes", HFILL }},
    { &hf_umts_rrc_ies_tddOption6,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption6_vals), 0,
        "umts_rrc_ies.T_tddOption6", HFILL }},
    { &hf_umts_rrc_ies_tdd3848,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3847", HFILL }},
    { &hf_umts_rrc_ies_tdd1289,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1288", HFILL }},
    { &hf_umts_rrc_ies_pusch_TimeslotsCodes1,
      { "pusch-TimeslotsCodes", "umts_rrc_ies.pusch_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UplinkTimeslotsCodes_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_TargetSIR,
      { "ul-TargetSIR", "umts_rrc_ies.ul_TargetSIR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_TargetSIR", HFILL }},
    { &hf_umts_rrc_ies_tddOption7,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption7_vals), 0,
        "umts_rrc_ies.T_tddOption7", HFILL }},
    { &hf_umts_rrc_ies_tdd12810,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd1289", HFILL }},
    { &hf_umts_rrc_ies_tpc_StepSize,
      { "tpc-StepSize", "umts_rrc_ies.tpc_StepSize",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TPC_StepSizeTDD", HFILL }},
    { &hf_umts_rrc_ies_usch_TFCS,
      { "usch-TFCS", "umts_rrc_ies.usch_TFCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_usch_TransportChannelsInfo,
      { "usch-TransportChannelsInfo", "umts_rrc_ies.usch_TransportChannelsInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.USCH_TransportChannelsInfo", HFILL }},
    { &hf_umts_rrc_ies_pusch_Info2,
      { "pusch-Info", "umts_rrc_ies.pusch_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_PUSCH_SysInfoList_item,
      { "Item", "umts_rrc_ies.PUSCH_SysInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfo", HFILL }},
    { &hf_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5_item,
      { "Item", "umts_rrc_ies.PUSCH_SysInfoList_HCR_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfo_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4_item,
      { "Item", "umts_rrc_ies.PUSCH_SysInfoList_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_item,
      { "Item", "umts_rrc_ies.PUSCH_SysInfoList_SFN_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_SFN_item", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfo,
      { "pusch-SysInfo", "umts_rrc_ies.pusch_SysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfo", HFILL }},
    { &hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item,
      { "Item", "umts_rrc_ies.PUSCH_SysInfoList_SFN_HCR_r5_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_SFN_HCR_r5_item", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfo1,
      { "pusch-SysInfo", "umts_rrc_ies.pusch_SysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfo_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item,
      { "Item", "umts_rrc_ies.PUSCH_SysInfoList_SFN_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_SFN_LCR_r4_item", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfo2,
      { "pusch-SysInfo", "umts_rrc_ies.pusch_SysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_mmax,
      { "mmax", "umts_rrc_ies.mmax",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_32", HFILL }},
    { &hf_umts_rrc_ies_nb01Min,
      { "nb01Min", "umts_rrc_ies.nb01Min",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NB01", HFILL }},
    { &hf_umts_rrc_ies_nb01Max,
      { "nb01Max", "umts_rrc_ies.nb01Max",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NB01", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod1,
      { "repetitionPeriod1", "umts_rrc_ies.repetitionPeriod1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod2,
      { "repetitionPeriod2", "umts_rrc_ies.repetitionPeriod2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_1", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod4,
      { "repetitionPeriod4", "umts_rrc_ies.repetitionPeriod4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_3", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod8,
      { "repetitionPeriod8", "umts_rrc_ies.repetitionPeriod8",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_7", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod16,
      { "repetitionPeriod16", "umts_rrc_ies.repetitionPeriod16",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_15", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod32,
      { "repetitionPeriod32", "umts_rrc_ies.repetitionPeriod32",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_31", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod64,
      { "repetitionPeriod64", "umts_rrc_ies.repetitionPeriod64",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_63", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod21,
      { "repetitionPeriod2", "umts_rrc_ies.repetitionPeriod2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_repetitionPeriod2", HFILL }},
    { &hf_umts_rrc_ies_length,
      { "length", "umts_rrc_ies.length",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_offset,
      { "offset", "umts_rrc_ies.offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod41,
      { "repetitionPeriod4", "umts_rrc_ies.repetitionPeriod4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_repetitionPeriod4", HFILL }},
    { &hf_umts_rrc_ies_length1,
      { "length", "umts_rrc_ies.length",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_3", HFILL }},
    { &hf_umts_rrc_ies_offset1,
      { "offset", "umts_rrc_ies.offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod81,
      { "repetitionPeriod8", "umts_rrc_ies.repetitionPeriod8",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_repetitionPeriod8", HFILL }},
    { &hf_umts_rrc_ies_length2,
      { "length", "umts_rrc_ies.length",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_7", HFILL }},
    { &hf_umts_rrc_ies_offset2,
      { "offset", "umts_rrc_ies.offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod161,
      { "repetitionPeriod16", "umts_rrc_ies.repetitionPeriod16",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_repetitionPeriod16", HFILL }},
    { &hf_umts_rrc_ies_length3,
      { "length", "umts_rrc_ies.length",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_15", HFILL }},
    { &hf_umts_rrc_ies_offset3,
      { "offset", "umts_rrc_ies.offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod321,
      { "repetitionPeriod32", "umts_rrc_ies.repetitionPeriod32",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_repetitionPeriod32", HFILL }},
    { &hf_umts_rrc_ies_length4,
      { "length", "umts_rrc_ies.length",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_31", HFILL }},
    { &hf_umts_rrc_ies_offset4,
      { "offset", "umts_rrc_ies.offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriod641,
      { "repetitionPeriod64", "umts_rrc_ies.repetitionPeriod64",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_repetitionPeriod64", HFILL }},
    { &hf_umts_rrc_ies_length5,
      { "length", "umts_rrc_ies.length",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_63", HFILL }},
    { &hf_umts_rrc_ies_offset5,
      { "offset", "umts_rrc_ies.offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_tfci_Field2,
      { "tfci-Field2", "umts_rrc_ies.tfci_Field2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxTFCI_Field2Value", HFILL }},
    { &hf_umts_rrc_ies_ReplacedPDSCH_CodeInfoList_item,
      { "Item", "umts_rrc_ies.ReplacedPDSCH_CodeInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ReplacedPDSCH_CodeInfo", HFILL }},
    { &hf_umts_rrc_ies_rpp4_2,
      { "rpp4-2", "umts_rrc_ies.rpp4_2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_rpp8_2,
      { "rpp8-2", "umts_rrc_ies.rpp8_2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_rpp8_4,
      { "rpp8-4", "umts_rrc_ies.rpp8_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_rpp16_2,
      { "rpp16-2", "umts_rrc_ies.rpp16_2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_rpp16_4,
      { "rpp16-4", "umts_rrc_ies.rpp16_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_rpp32_2,
      { "rpp32-2", "umts_rrc_ies.rpp32_2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_rpp32_4,
      { "rpp32-4", "umts_rrc_ies.rpp32_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_rpp64_2,
      { "rpp64-2", "umts_rrc_ies.rpp64_2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_rpp64_4,
      { "rpp64-4", "umts_rrc_ies.rpp64_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_dl_restrictedTrCh_Type,
      { "dl-restrictedTrCh-Type", "umts_rrc_ies.dl_restrictedTrCh_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TrCH_Type_vals), 0,
        "umts_rrc_ies.DL_TrCH_Type", HFILL }},
    { &hf_umts_rrc_ies_restrictedDL_TrCH_Identity,
      { "restrictedDL-TrCH-Identity", "umts_rrc_ies.restrictedDL_TrCH_Identity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_allowedTFIList,
      { "allowedTFIList", "umts_rrc_ies.allowedTFIList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AllowedTFI_List", HFILL }},
    { &hf_umts_rrc_ies_RestrictedTrCH_InfoList_item,
      { "Item", "umts_rrc_ies.RestrictedTrCH_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RestrictedTrCH", HFILL }},
    { &hf_umts_rrc_ies_sccpch_InfoforFACH,
      { "sccpch-InfoforFACH", "umts_rrc_ies.sccpch_InfoforFACH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_InfoForFACH", HFILL }},
    { &hf_umts_rrc_ies_cell_Id,
      { "cell-Id", "umts_rrc_ies.cell_Id",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.CellIdentity", HFILL }},
    { &hf_umts_rrc_ies_dl_dpchInfo1,
      { "dl-dpchInfo", "umts_rrc_ies.dl_dpchInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_dl_dpchInfo1_vals), 0,
        "umts_rrc_ies.T_dl_dpchInfo1", HFILL }},
    { &hf_umts_rrc_ies_RL_AdditionInformationList_item,
      { "Item", "umts_rrc_ies.RL_AdditionInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RL_AdditionInformation", HFILL }},
    { &hf_umts_rrc_ies_RL_AdditionInformationList_r6_item,
      { "Item", "umts_rrc_ies.RL_AdditionInformationList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RL_AdditionInformation_r6", HFILL }},
    { &hf_umts_rrc_ies_RL_IdentifierList_item,
      { "Item", "umts_rrc_ies.RL_IdentifierList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_RL_RemovalInformationList_item,
      { "Item", "umts_rrc_ies.RL_RemovalInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_SCCPCH_ChannelisationCodeList_item,
      { "Item", "umts_rrc_ies.SCCPCH_ChannelisationCodeList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SCCPCH_ChannelisationCode_vals), 0,
        "umts_rrc_ies.SCCPCH_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_secondaryCCPCH_Info,
      { "secondaryCCPCH-Info", "umts_rrc_ies.secondaryCCPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecondaryCCPCH_Info", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo31,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo31_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo31", HFILL }},
    { &hf_umts_rrc_ies_fdd38,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd35", HFILL }},
    { &hf_umts_rrc_ies_fach_PCH_InformationList,
      { "fach-PCH-InformationList", "umts_rrc_ies.fach_PCH_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.FACH_PCH_InformationList", HFILL }},
    { &hf_umts_rrc_ies_sib_ReferenceListFACH,
      { "sib-ReferenceListFACH", "umts_rrc_ies.sib_ReferenceListFACH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIB_ReferenceListFACH", HFILL }},
    { &hf_umts_rrc_ies_tdd34,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd29", HFILL }},
    { &hf_umts_rrc_ies_secondaryCCPCH_Info1,
      { "secondaryCCPCH-Info", "umts_rrc_ies.secondaryCCPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecondaryCCPCH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo32,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo32_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo32", HFILL }},
    { &hf_umts_rrc_ies_fdd39,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd36", HFILL }},
    { &hf_umts_rrc_ies_pich_Info,
      { "pich-Info", "umts_rrc_ies.pich_Info",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PICH_Info_vals), 0,
        "umts_rrc_ies.PICH_Info", HFILL }},
    { &hf_umts_rrc_ies_secondaryCCPCH_LCR_Extensions,
      { "secondaryCCPCH-LCR-Extensions", "umts_rrc_ies.secondaryCCPCH_LCR_Extensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecondaryCCPCH_Info_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_pich_Info1,
      { "pich-Info", "umts_rrc_ies.pich_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PICH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_mcch_ConfigurationInfo,
      { "mcch-ConfigurationInfo", "umts_rrc_ies.mcch_ConfigurationInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_MCCH_ConfigurationInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_SCCPCH_SystemInformationList_item,
      { "Item", "umts_rrc_ies.SCCPCH_SystemInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformation", HFILL }},
    { &hf_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext_item,
      { "Item", "umts_rrc_ies.SCCPCH_SystemInformationList_LCR_r4_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformation_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext_item,
      { "Item", "umts_rrc_ies.SCCPCH_SystemInformationList_MBMS_r6_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformation_MBMS_r6_ext", HFILL }},
    { &hf_umts_rrc_ies_secondaryCCPCHInfo_MBMS,
      { "secondaryCCPCHInfo-MBMS", "umts_rrc_ies.secondaryCCPCHInfo_MBMS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecondaryCCPCHInfo_MBMS_r6", HFILL }},
    { &hf_umts_rrc_ies_transportFormatCombinationSet,
      { "transportFormatCombinationSet", "umts_rrc_ies.transportFormatCombinationSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TFCS_vals), 0,
        "umts_rrc_ies.TFCS", HFILL }},
    { &hf_umts_rrc_ies_fachCarryingMCCH,
      { "fachCarryingMCCH", "umts_rrc_ies.fachCarryingMCCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fachCarryingMCCH", HFILL }},
    { &hf_umts_rrc_ies_fachCarryingMTCH_List,
      { "fachCarryingMTCH-List", "umts_rrc_ies.fachCarryingMTCH_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_FACHCarryingMTCH_List", HFILL }},
    { &hf_umts_rrc_ies_schedulingInformation,
      { "schedulingInformation", "umts_rrc_ies.schedulingInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_schedulingInformation", HFILL }},
    { &hf_umts_rrc_ies_fachCarryingMSCH,
      { "fachCarryingMSCH", "umts_rrc_ies.fachCarryingMSCH",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_mschConfigurationInfo,
      { "mschConfigurationInfo", "umts_rrc_ies.mschConfigurationInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_MSCHConfigurationInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_primary_Secondary_GrantSelector1,
      { "primary-Secondary-GrantSelector", "umts_rrc_ies.primary_Secondary_GrantSelector",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_primary_Secondary_GrantSelector1_vals), 0,
        "umts_rrc_ies.T_primary_Secondary_GrantSelector1", HFILL }},
    { &hf_umts_rrc_ies_e_DCH_RL_Info_NewServingCell,
      { "e-DCH-RL-Info-NewServingCell", "umts_rrc_ies.e_DCH_RL_Info_NewServingCell",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DCH_RL_Info", HFILL }},
    { &hf_umts_rrc_ies_e_DCH_RL_Info_OldServingCell,
      { "e-DCH-RL-Info-OldServingCell", "umts_rrc_ies.e_DCH_RL_Info_OldServingCell",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DCH_RL_Info", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo33,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo33_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo33", HFILL }},
    { &hf_umts_rrc_ies_fdd40,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd37", HFILL }},
    { &hf_umts_rrc_ies_dummy1_PCPICH_UsageForChannelEst,
      { "dummy1-PCPICH-UsageForChannelEst", "umts_rrc_ies.dummy1_PCPICH_UsageForChannelEst",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PCPICH_UsageForChannelEst_vals), 0,
        "umts_rrc_ies.PCPICH_UsageForChannelEst", HFILL }},
    { &hf_umts_rrc_ies_dummy2_SecondaryCPICH_Info,
      { "dummy2-SecondaryCPICH-Info", "umts_rrc_ies.dummy2_SecondaryCPICH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SecondaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_sf_AndCodeNumber1,
      { "sf-AndCodeNumber", "umts_rrc_ies.sf_AndCodeNumber",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SF256_AndCodeNumber_vals), 0,
        "umts_rrc_ies.SF256_AndCodeNumber", HFILL }},
    { &hf_umts_rrc_ies_pilotSymbolExistence,
      { "pilotSymbolExistence", "umts_rrc_ies.pilotSymbolExistence",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_timingOffset,
      { "timingOffset", "umts_rrc_ies.timingOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimingOffset", HFILL }},
    { &hf_umts_rrc_ies_tdd35,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd30", HFILL }},
    { &hf_umts_rrc_ies_commonTimeslotInfo1,
      { "commonTimeslotInfo", "umts_rrc_ies.commonTimeslotInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CommonTimeslotInfoSCCPCH", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode5,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SCCPCH_ChannelisationCodeList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo34,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo34_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo34", HFILL }},
    { &hf_umts_rrc_ies_fdd41,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd38", HFILL }},
    { &hf_umts_rrc_ies_tdd36,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd31", HFILL }},
    { &hf_umts_rrc_ies_tddOption8,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption8_vals), 0,
        "umts_rrc_ies.T_tddOption8", HFILL }},
    { &hf_umts_rrc_ies_tdd3849,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3848", HFILL }},
    { &hf_umts_rrc_ies_tdd12811,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12810", HFILL }},
    { &hf_umts_rrc_ies_individualTimeslotLCR_Ext,
      { "individualTimeslotLCR-Ext", "umts_rrc_ies.individualTimeslotLCR_Ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IndividualTimeslotInfo_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo35,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo35_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo35", HFILL }},
    { &hf_umts_rrc_ies_fdd42,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd39", HFILL }},
    { &hf_umts_rrc_ies_tdd38410,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes", HFILL }},
    { &hf_umts_rrc_ies_tdd12812,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DownlinkTimeslotsCodes_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_secondaryDL_ScramblingCode,
      { "secondaryDL-ScramblingCode", "umts_rrc_ies.secondaryDL_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SecondaryScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_channelisationCode6,
      { "channelisationCode", "umts_rrc_ies.channelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ChannelisationCode256", HFILL }},
    { &hf_umts_rrc_ies_sf4,
      { "sf4", "umts_rrc_ies.sf4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_sf8,
      { "sf8", "umts_rrc_ies.sf8",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_sf16,
      { "sf16", "umts_rrc_ies.sf16",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_sf32,
      { "sf32", "umts_rrc_ies.sf32",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_sf64,
      { "sf64", "umts_rrc_ies.sf64",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_sf128,
      { "sf128", "umts_rrc_ies.sf128",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_sf256,
      { "sf256", "umts_rrc_ies.sf256",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_sf512,
      { "sf512", "umts_rrc_ies.sf512",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_511", HFILL }},
    { &hf_umts_rrc_ies_sfd4,
      { "sfd4", "umts_rrc_ies.sfd4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sfd8,
      { "sfd8", "umts_rrc_ies.sfd8",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sfd16,
      { "sfd16", "umts_rrc_ies.sfd16",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sfd32,
      { "sfd32", "umts_rrc_ies.sfd32",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sfd64,
      { "sfd64", "umts_rrc_ies.sfd64",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sfd128,
      { "sfd128", "umts_rrc_ies.sfd128",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PilotBits128_vals), 0,
        "umts_rrc_ies.PilotBits128", HFILL }},
    { &hf_umts_rrc_ies_sfd256,
      { "sfd256", "umts_rrc_ies.sfd256",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PilotBits256_vals), 0,
        "umts_rrc_ies.PilotBits256", HFILL }},
    { &hf_umts_rrc_ies_sfd512,
      { "sfd512", "umts_rrc_ies.sfd512",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_activationTimeSFN,
      { "activationTimeSFN", "umts_rrc_ies.activationTimeSFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4095", HFILL }},
    { &hf_umts_rrc_ies_physChDuration,
      { "physChDuration", "umts_rrc_ies.physChDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DurationTimeInfo", HFILL }},
    { &hf_umts_rrc_ies_s_Field,
      { "s-Field", "umts_rrc_ies.s_Field",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_S_Field_vals), 0,
        "umts_rrc_ies.S_Field", HFILL }},
    { &hf_umts_rrc_ies_codeWordSet,
      { "codeWordSet", "umts_rrc_ies.codeWordSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CodeWordSet_vals), 0,
        "umts_rrc_ies.CodeWordSet", HFILL }},
    { &hf_umts_rrc_ies_ssdt_UL_r4,
      { "ssdt-UL-r4", "umts_rrc_ies.ssdt_UL_r4",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SSDT_UL_vals), 0,
        "umts_rrc_ies.SSDT_UL", HFILL }},
    { &hf_umts_rrc_ies_sync_UL_CodesBitmap,
      { "sync-UL-CodesBitmap", "umts_rrc_ies.sync_UL_CodesBitmap",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_sync_UL_CodesBitmap", HFILL }},
    { &hf_umts_rrc_ies_prxUpPCHdes,
      { "prxUpPCHdes", "umts_rrc_ies.prxUpPCHdes",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_62", HFILL }},
    { &hf_umts_rrc_ies_sync_UL_Procedure,
      { "sync-UL-Procedure", "umts_rrc_ies.sync_UL_Procedure",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SYNC_UL_Procedure_r4", HFILL }},
    { &hf_umts_rrc_ies_max_SYNC_UL_Transmissions,
      { "max-SYNC-UL-Transmissions", "umts_rrc_ies.max_SYNC_UL_Transmissions",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_max_SYNC_UL_Transmissions_vals), 0,
        "umts_rrc_ies.T_max_SYNC_UL_Transmissions", HFILL }},
    { &hf_umts_rrc_ies_powerRampStep1,
      { "powerRampStep", "umts_rrc_ies.powerRampStep",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_sync_UL_Codes_Bitmap,
      { "sync-UL-Codes-Bitmap", "umts_rrc_ies.sync_UL_Codes_Bitmap",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.T_sync_UL_Codes_Bitmap", HFILL }},
    { &hf_umts_rrc_ies_max_SYNC_UL_Transmissions1,
      { "max-SYNC-UL-Transmissions", "umts_rrc_ies.max_SYNC_UL_Transmissions",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_max_SYNC_UL_Transmissions1_vals), 0,
        "umts_rrc_ies.T_max_SYNC_UL_Transmissions1", HFILL }},
    { &hf_umts_rrc_ies_sf81,
      { "sf8", "umts_rrc_ies.sf8",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8", HFILL }},
    { &hf_umts_rrc_ies_sf8_item,
      { "Item", "umts_rrc_ies.sf8_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TDD_PRACH_CCode8_vals), 0,
        "umts_rrc_ies.TDD_PRACH_CCode8", HFILL }},
    { &hf_umts_rrc_ies_sf161,
      { "sf16", "umts_rrc_ies.sf16",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16", HFILL }},
    { &hf_umts_rrc_ies_sf16_item,
      { "Item", "umts_rrc_ies.sf16_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TDD_PRACH_CCode16_vals), 0,
        "umts_rrc_ies.TDD_PRACH_CCode16", HFILL }},
    { &hf_umts_rrc_ies_tgpsi,
      { "tgpsi", "umts_rrc_ies.tgpsi",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGPSI", HFILL }},
    { &hf_umts_rrc_ies_tgps_Status,
      { "tgps-Status", "umts_rrc_ies.tgps_Status",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tgps_Status_vals), 0,
        "umts_rrc_ies.T_tgps_Status", HFILL }},
    { &hf_umts_rrc_ies_activate,
      { "activate", "umts_rrc_ies.activate",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_activate", HFILL }},
    { &hf_umts_rrc_ies_tgcfn,
      { "tgcfn", "umts_rrc_ies.tgcfn",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGCFN", HFILL }},
    { &hf_umts_rrc_ies_deactivate,
      { "deactivate", "umts_rrc_ies.deactivate",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_tgps_ConfigurationParams,
      { "tgps-ConfigurationParams", "umts_rrc_ies.tgps_ConfigurationParams",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TGPS_ConfigurationParams", HFILL }},
    { &hf_umts_rrc_ies_TGP_SequenceList_item,
      { "Item", "umts_rrc_ies.TGP_SequenceList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TGP_Sequence", HFILL }},
    { &hf_umts_rrc_ies_tgps_Status1,
      { "tgps-Status", "umts_rrc_ies.tgps_Status",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tgps_Status1_vals), 0,
        "umts_rrc_ies.T_tgps_Status1", HFILL }},
    { &hf_umts_rrc_ies_activate1,
      { "activate", "umts_rrc_ies.activate",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_activate1", HFILL }},
    { &hf_umts_rrc_ies_tgmp,
      { "tgmp", "umts_rrc_ies.tgmp",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TGMP_vals), 0,
        "umts_rrc_ies.TGMP", HFILL }},
    { &hf_umts_rrc_ies_tgprc,
      { "tgprc", "umts_rrc_ies.tgprc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGPRC", HFILL }},
    { &hf_umts_rrc_ies_tgsn,
      { "tgsn", "umts_rrc_ies.tgsn",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGSN", HFILL }},
    { &hf_umts_rrc_ies_tgl1,
      { "tgl1", "umts_rrc_ies.tgl1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGL", HFILL }},
    { &hf_umts_rrc_ies_tgl2,
      { "tgl2", "umts_rrc_ies.tgl2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGL", HFILL }},
    { &hf_umts_rrc_ies_tgd,
      { "tgd", "umts_rrc_ies.tgd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGD", HFILL }},
    { &hf_umts_rrc_ies_tgpl1,
      { "tgpl1", "umts_rrc_ies.tgpl1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGPL", HFILL }},
    { &hf_umts_rrc_ies_dummy_TGPL,
      { "dummy-TGPL", "umts_rrc_ies.dummy_TGPL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGPL", HFILL }},
    { &hf_umts_rrc_ies_rpp,
      { "rpp", "umts_rrc_ies.rpp",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RPP_vals), 0,
        "umts_rrc_ies.RPP", HFILL }},
    { &hf_umts_rrc_ies_itp,
      { "itp", "umts_rrc_ies.itp",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ITP_vals), 0,
        "umts_rrc_ies.ITP", HFILL }},
    { &hf_umts_rrc_ies_ul_DL_Mode,
      { "ul-DL-Mode", "umts_rrc_ies.ul_DL_Mode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DL_Mode_vals), 0,
        "umts_rrc_ies.UL_DL_Mode", HFILL }},
    { &hf_umts_rrc_ies_dl_FrameType,
      { "dl-FrameType", "umts_rrc_ies.dl_FrameType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_FrameType_vals), 0,
        "umts_rrc_ies.DL_FrameType", HFILL }},
    { &hf_umts_rrc_ies_deltaSIR1,
      { "deltaSIR1", "umts_rrc_ies.deltaSIR1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaSIR", HFILL }},
    { &hf_umts_rrc_ies_deltaSIRAfter1,
      { "deltaSIRAfter1", "umts_rrc_ies.deltaSIRAfter1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaSIR", HFILL }},
    { &hf_umts_rrc_ies_deltaSIR2,
      { "deltaSIR2", "umts_rrc_ies.deltaSIR2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaSIR", HFILL }},
    { &hf_umts_rrc_ies_deltaSIRAfter2,
      { "deltaSIRAfter2", "umts_rrc_ies.deltaSIRAfter2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaSIR", HFILL }},
    { &hf_umts_rrc_ies_nidentifyAbort,
      { "nidentifyAbort", "umts_rrc_ies.nidentifyAbort",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NidentifyAbort", HFILL }},
    { &hf_umts_rrc_ies_treconfirmAbort,
      { "treconfirmAbort", "umts_rrc_ies.treconfirmAbort",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TreconfirmAbort", HFILL }},
    { &hf_umts_rrc_ies_activationTime,
      { "activationTime", "umts_rrc_ies.activationTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ActivationTime", HFILL }},
    { &hf_umts_rrc_ies_durationTimeInfo,
      { "durationTimeInfo", "umts_rrc_ies.durationTimeInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DurationTimeInfo", HFILL }},
    { &hf_umts_rrc_ies_TimeslotList_item,
      { "Item", "umts_rrc_ies.TimeslotList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber", HFILL }},
    { &hf_umts_rrc_ies_tdd38411,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber", HFILL }},
    { &hf_umts_rrc_ies_tdd384_item,
      { "Item", "umts_rrc_ies.tdd384_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber", HFILL }},
    { &hf_umts_rrc_ies_tdd12813,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_tdd128_item1,
      { "Item", "umts_rrc_ies.tdd128_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotNumber_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_channelReqParamsForUCSM,
      { "channelReqParamsForUCSM", "umts_rrc_ies.channelReqParamsForUCSM",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ChannelReqParamsForUCSM", HFILL }},
    { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes,
      { "ul-CCTrCH-TimeslotsCodes", "umts_rrc_ies.ul_CCTrCH_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UplinkTimeslotsCodes", HFILL }},
    { &hf_umts_rrc_ies_tddOption9,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption9_vals), 0,
        "umts_rrc_ies.T_tddOption9", HFILL }},
    { &hf_umts_rrc_ies_tdd38412,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd3849", HFILL }},
    { &hf_umts_rrc_ies_tdd12814,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12811", HFILL }},
    { &hf_umts_rrc_ies_ul_CCTrCH_TimeslotsCodes1,
      { "ul-CCTrCH-TimeslotsCodes", "umts_rrc_ies.ul_CCTrCH_TimeslotsCodes",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UplinkTimeslotsCodes_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_UL_CCTrCHList_item,
      { "Item", "umts_rrc_ies.UL_CCTrCHList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_CCTrCH", HFILL }},
    { &hf_umts_rrc_ies_UL_CCTrCHList_r4_item,
      { "Item", "umts_rrc_ies.UL_CCTrCHList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_CCTrCH_r4", HFILL }},
    { &hf_umts_rrc_ies_UL_CCTrCHListToRemove_item,
      { "Item", "umts_rrc_ies.UL_CCTrCHListToRemove_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TFCS_IdentityPlain", HFILL }},
    { &hf_umts_rrc_ies_UL_CCTrChTPCList_item,
      { "Item", "umts_rrc_ies.UL_CCTrChTPCList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TFCS_Identity", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_Info,
      { "ul-DPCH-Info", "umts_rrc_ies.ul_DPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_Info", HFILL }},
    { &hf_umts_rrc_ies_dummy_CPCH_SetInfo,
      { "dummy-CPCH-SetInfo", "umts_rrc_ies.dummy_CPCH_SetInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CPCH_SetInfo", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_Info1,
      { "ul-DPCH-Info", "umts_rrc_ies.ul_DPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_Info2,
      { "ul-DPCH-Info", "umts_rrc_ies.ul_DPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_Info_r5", HFILL }},
    { &hf_umts_rrc_ies_dummy1_CPCH_SetInfo,
      { "dummy1-CPCH-SetInfo", "umts_rrc_ies.dummy1_CPCH_SetInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CPCH_SetInfo", HFILL }},
    { &hf_umts_rrc_ies_dummy2_CPCH_SetID,
      { "dummy2-CPCH-SetID", "umts_rrc_ies.dummy2_CPCH_SetID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CPCH_SetID", HFILL }},
    { &hf_umts_rrc_ies_ul,
      { "ul", "umts_rrc_ies.ul",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_CompressedModeMethod_vals), 0,
        "umts_rrc_ies.UL_CompressedModeMethod", HFILL }},
    { &hf_umts_rrc_ies_dl,
      { "dl", "umts_rrc_ies.dl",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_CompressedModeMethod_vals), 0,
        "umts_rrc_ies.DL_CompressedModeMethod", HFILL }},
    { &hf_umts_rrc_ies_ul_and_dl,
      { "ul-and-dl", "umts_rrc_ies.ul_and_dl",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ul_and_dl", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo36,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo36_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo36", HFILL }},
    { &hf_umts_rrc_ies_fdd43,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd40", HFILL }},
    { &hf_umts_rrc_ies_scramblingCodeType,
      { "scramblingCodeType", "umts_rrc_ies.scramblingCodeType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ScramblingCodeType_vals), 0,
        "umts_rrc_ies.ScramblingCodeType", HFILL }},
    { &hf_umts_rrc_ies_scramblingCode,
      { "scramblingCode", "umts_rrc_ies.scramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_ScramblingCode", HFILL }},
    { &hf_umts_rrc_ies_numberOfDPDCH,
      { "numberOfDPDCH", "umts_rrc_ies.numberOfDPDCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NumberOfDPDCH", HFILL }},
    { &hf_umts_rrc_ies_spreadingFactor1,
      { "spreadingFactor", "umts_rrc_ies.spreadingFactor",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SpreadingFactor_vals), 0,
        "umts_rrc_ies.SpreadingFactor", HFILL }},
    { &hf_umts_rrc_ies_numberOfFBI_Bits,
      { "numberOfFBI-Bits", "umts_rrc_ies.numberOfFBI_Bits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NumberOfFBI_Bits", HFILL }},
    { &hf_umts_rrc_ies_tdd37,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd32", HFILL }},
    { &hf_umts_rrc_ies_ul_TimingAdvance,
      { "ul-TimingAdvance", "umts_rrc_ies.ul_TimingAdvance",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TimingAdvanceControl_vals), 0,
        "umts_rrc_ies.UL_TimingAdvanceControl", HFILL }},
    { &hf_umts_rrc_ies_ul_CCTrCHList,
      { "ul-CCTrCHList", "umts_rrc_ies.ul_CCTrCHList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_CCTrCHList", HFILL }},
    { &hf_umts_rrc_ies_ul_CCTrCHListToRemove,
      { "ul-CCTrCHListToRemove", "umts_rrc_ies.ul_CCTrCHListToRemove",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_CCTrCHListToRemove", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo37,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo37_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo37", HFILL }},
    { &hf_umts_rrc_ies_fdd44,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd41", HFILL }},
    { &hf_umts_rrc_ies_tdd38,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd33", HFILL }},
    { &hf_umts_rrc_ies_ul_TimingAdvance1,
      { "ul-TimingAdvance", "umts_rrc_ies.ul_TimingAdvance",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TimingAdvanceControl_r4_vals), 0,
        "umts_rrc_ies.UL_TimingAdvanceControl_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_CCTrCHList1,
      { "ul-CCTrCHList", "umts_rrc_ies.ul_CCTrCHList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_CCTrCHList_r4", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo38,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo38_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo38", HFILL }},
    { &hf_umts_rrc_ies_fdd45,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd42", HFILL }},
    { &hf_umts_rrc_ies_tdd39,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd34", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo3,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DPCH_PowerControlInfo_r6_vals), 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo39,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo39_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo39", HFILL }},
    { &hf_umts_rrc_ies_fdd46,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd43", HFILL }},
    { &hf_umts_rrc_ies_tdd40,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd35", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo4,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfoPostFDD", HFILL }},
    { &hf_umts_rrc_ies_reducedScramblingCodeNumber,
      { "reducedScramblingCodeNumber", "umts_rrc_ies.reducedScramblingCodeNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ReducedScramblingCodeNumber", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo5,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfoPostTDD", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo6,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfoPostTDD_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_TimingAdvance2,
      { "ul-TimingAdvance", "umts_rrc_ies.ul_TimingAdvance",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4_vals), 0,
        "umts_rrc_ies.UL_TimingAdvanceControl_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_ul_DPCH_PowerControlInfo7,
      { "ul-DPCH-PowerControlInfo", "umts_rrc_ies.ul_DPCH_PowerControlInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_DPCH_PowerControlInfoPredef_vals), 0,
        "umts_rrc_ies.UL_DPCH_PowerControlInfoPredef", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo40,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo40_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo40", HFILL }},
    { &hf_umts_rrc_ies_fdd47,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd44", HFILL }},
    { &hf_umts_rrc_ies_tdd41,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd36", HFILL }},
    { &hf_umts_rrc_ies_fdd48,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd45", HFILL }},
    { &hf_umts_rrc_ies_dpcch_PowerOffset,
      { "dpcch-PowerOffset", "umts_rrc_ies.dpcch_PowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DPCCH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_pc_Preamble,
      { "pc-Preamble", "umts_rrc_ies.pc_Preamble",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PC_Preamble", HFILL }},
    { &hf_umts_rrc_ies_sRB_delay,
      { "sRB-delay", "umts_rrc_ies.sRB_delay",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SRB_delay", HFILL }},
    { &hf_umts_rrc_ies_tdd42,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd37", HFILL }},
    { &hf_umts_rrc_ies_ul_OL_PC_Signalling,
      { "ul-OL-PC-Signalling", "umts_rrc_ies.ul_OL_PC_Signalling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ul_OL_PC_Signalling_vals), 0,
        "umts_rrc_ies.T_ul_OL_PC_Signalling", HFILL }},
    { &hf_umts_rrc_ies_broadcast_UL_OL_PC_info,
      { "broadcast-UL-OL-PC-info", "umts_rrc_ies.broadcast_UL_OL_PC_info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_individuallySignalled,
      { "individuallySignalled", "umts_rrc_ies.individuallySignalled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_individuallySignalled", HFILL }},
    { &hf_umts_rrc_ies_individualTS_InterferenceList,
      { "individualTS-InterferenceList", "umts_rrc_ies.individualTS_InterferenceList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IndividualTS_InterferenceList", HFILL }},
    { &hf_umts_rrc_ies_fdd49,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd46", HFILL }},
    { &hf_umts_rrc_ies_tdd43,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38", HFILL }},
    { &hf_umts_rrc_ies_ul_OL_PC_Signalling1,
      { "ul-OL-PC-Signalling", "umts_rrc_ies.ul_OL_PC_Signalling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ul_OL_PC_Signalling1_vals), 0,
        "umts_rrc_ies.T_ul_OL_PC_Signalling1", HFILL }},
    { &hf_umts_rrc_ies_individuallySignalled1,
      { "individuallySignalled", "umts_rrc_ies.individuallySignalled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_individuallySignalled1", HFILL }},
    { &hf_umts_rrc_ies_tddOption10,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption10_vals), 0,
        "umts_rrc_ies.T_tddOption10", HFILL }},
    { &hf_umts_rrc_ies_tdd38413,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38410", HFILL }},
    { &hf_umts_rrc_ies_dpch_ConstantValue1,
      { "dpch-ConstantValue", "umts_rrc_ies.dpch_ConstantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ConstantValue", HFILL }},
    { &hf_umts_rrc_ies_tdd12815,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12812", HFILL }},
    { &hf_umts_rrc_ies_fdd50,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd47", HFILL }},
    { &hf_umts_rrc_ies_ack_NACK_repetition_factor,
      { "ack-NACK-repetition-factor", "umts_rrc_ies.ack_NACK_repetition_factor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ACK_NACK_repetitionFactor", HFILL }},
    { &hf_umts_rrc_ies_tdd44,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd39", HFILL }},
    { &hf_umts_rrc_ies_ul_OL_PC_Signalling2,
      { "ul-OL-PC-Signalling", "umts_rrc_ies.ul_OL_PC_Signalling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ul_OL_PC_Signalling2_vals), 0,
        "umts_rrc_ies.T_ul_OL_PC_Signalling2", HFILL }},
    { &hf_umts_rrc_ies_individuallySignalled2,
      { "individuallySignalled", "umts_rrc_ies.individuallySignalled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_individuallySignalled2", HFILL }},
    { &hf_umts_rrc_ies_tddOption11,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption11_vals), 0,
        "umts_rrc_ies.T_tddOption11", HFILL }},
    { &hf_umts_rrc_ies_tdd38414,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38411", HFILL }},
    { &hf_umts_rrc_ies_tdd12816,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12813", HFILL }},
    { &hf_umts_rrc_ies_fdd51,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd48", HFILL }},
    { &hf_umts_rrc_ies_tdd45,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd40", HFILL }},
    { &hf_umts_rrc_ies_ul_OL_PC_Signalling3,
      { "ul-OL-PC-Signalling", "umts_rrc_ies.ul_OL_PC_Signalling",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ul_OL_PC_Signalling3_vals), 0,
        "umts_rrc_ies.T_ul_OL_PC_Signalling3", HFILL }},
    { &hf_umts_rrc_ies_individuallySignalled3,
      { "individuallySignalled", "umts_rrc_ies.individuallySignalled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_individuallySignalled3", HFILL }},
    { &hf_umts_rrc_ies_tddOption12,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption12_vals), 0,
        "umts_rrc_ies.T_tddOption12", HFILL }},
    { &hf_umts_rrc_ies_tdd38415,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38412", HFILL }},
    { &hf_umts_rrc_ies_tdd12817,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12814", HFILL }},
    { &hf_umts_rrc_ies_beaconPLEst,
      { "beaconPLEst", "umts_rrc_ies.beaconPLEst",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_BEACON_PL_Est_vals), 0,
        "umts_rrc_ies.BEACON_PL_Est", HFILL }},
    { &hf_umts_rrc_ies_dpcch_PowerOffset1,
      { "dpcch-PowerOffset", "umts_rrc_ies.dpcch_PowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DPCCH_PowerOffset2", HFILL }},
    { &hf_umts_rrc_ies_fdd52,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd49", HFILL }},
    { &hf_umts_rrc_ies_tdd46,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd41", HFILL }},
    { &hf_umts_rrc_ies_e_DPCCH_Info,
      { "e-DPCCH-Info", "umts_rrc_ies.e_DPCCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DPCCH_Info", HFILL }},
    { &hf_umts_rrc_ies_e_DPDCH_Info,
      { "e-DPDCH-Info", "umts_rrc_ies.e_DPDCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.E_DPDCH_Info", HFILL }},
    { &hf_umts_rrc_ies_stepSize,
      { "stepSize", "umts_rrc_ies.stepSize",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_8", HFILL }},
    { &hf_umts_rrc_ies_frequency,
      { "frequency", "umts_rrc_ies.frequency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_8", HFILL }},
    { &hf_umts_rrc_ies_disabled,
      { "disabled", "umts_rrc_ies.disabled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_enabled,
      { "enabled", "umts_rrc_ies.enabled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_enabled", HFILL }},
    { &hf_umts_rrc_ies_ul_TimingAdvance3,
      { "ul-TimingAdvance", "umts_rrc_ies.ul_TimingAdvance",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_TimingAdvance", HFILL }},
    { &hf_umts_rrc_ies_enabled1,
      { "enabled", "umts_rrc_ies.enabled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_enabled1", HFILL }},
    { &hf_umts_rrc_ies_tddOption13,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption13_vals), 0,
        "umts_rrc_ies.T_tddOption13", HFILL }},
    { &hf_umts_rrc_ies_tdd38416,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38413", HFILL }},
    { &hf_umts_rrc_ies_tdd12818,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12815", HFILL }},
    { &hf_umts_rrc_ies_ul_SynchronisationParameters,
      { "ul-SynchronisationParameters", "umts_rrc_ies.ul_SynchronisationParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UL_SynchronisationParameters_r4", HFILL }},
    { &hf_umts_rrc_ies_synchronisationParameters,
      { "synchronisationParameters", "umts_rrc_ies.synchronisationParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SynchronisationParameters_r4", HFILL }},
    { &hf_umts_rrc_ies_enabled2,
      { "enabled", "umts_rrc_ies.enabled",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_enabled2", HFILL }},
    { &hf_umts_rrc_ies_UL_TS_ChannelisationCodeList_item,
      { "Item", "umts_rrc_ies.UL_TS_ChannelisationCodeList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TS_ChannelisationCode_vals), 0,
        "umts_rrc_ies.UL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_parameters2,
      { "parameters", "umts_rrc_ies.parameters",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_parameters2_vals), 0,
        "umts_rrc_ies.T_parameters2", HFILL }},
    { &hf_umts_rrc_ies_sameAsLast2,
      { "sameAsLast", "umts_rrc_ies.sameAsLast",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sameAsLast2", HFILL }},
    { &hf_umts_rrc_ies_newParameters2,
      { "newParameters", "umts_rrc_ies.newParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_newParameters2", HFILL }},
    { &hf_umts_rrc_ies_ul_TS_ChannelisationCodeList,
      { "ul-TS-ChannelisationCodeList", "umts_rrc_ies.ul_TS_ChannelisationCodeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_TS_ChannelisationCodeList", HFILL }},
    { &hf_umts_rrc_ies_parameters3,
      { "parameters", "umts_rrc_ies.parameters",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_parameters3_vals), 0,
        "umts_rrc_ies.T_parameters3", HFILL }},
    { &hf_umts_rrc_ies_sameAsLast3,
      { "sameAsLast", "umts_rrc_ies.sameAsLast",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sameAsLast3", HFILL }},
    { &hf_umts_rrc_ies_newParameters3,
      { "newParameters", "umts_rrc_ies.newParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_newParameters3", HFILL }},
    { &hf_umts_rrc_ies_dynamicSFusage,
      { "dynamicSFusage", "umts_rrc_ies.dynamicSFusage",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_moreTimeslots2,
      { "moreTimeslots", "umts_rrc_ies.moreTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_moreTimeslots2_vals), 0,
        "umts_rrc_ies.T_moreTimeslots2", HFILL }},
    { &hf_umts_rrc_ies_additionalTimeslots2,
      { "additionalTimeslots", "umts_rrc_ies.additionalTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_additionalTimeslots2_vals), 0,
        "umts_rrc_ies.T_additionalTimeslots2", HFILL }},
    { &hf_umts_rrc_ies_consecutive3,
      { "consecutive", "umts_rrc_ies.consecutive",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_consecutive1", HFILL }},
    { &hf_umts_rrc_ies_numAdditionalTimeslots,
      { "numAdditionalTimeslots", "umts_rrc_ies.numAdditionalTimeslots",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxTS1", HFILL }},
    { &hf_umts_rrc_ies_timeslotList2,
      { "timeslotList", "umts_rrc_ies.timeslotList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots", HFILL }},
    { &hf_umts_rrc_ies_timeslotList_item2,
      { "Item", "umts_rrc_ies.timeslotList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UplinkAdditionalTimeslots", HFILL }},
    { &hf_umts_rrc_ies_moreTimeslots3,
      { "moreTimeslots", "umts_rrc_ies.moreTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_moreTimeslots3_vals), 0,
        "umts_rrc_ies.T_moreTimeslots3", HFILL }},
    { &hf_umts_rrc_ies_additionalTimeslots3,
      { "additionalTimeslots", "umts_rrc_ies.additionalTimeslots",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_additionalTimeslots3_vals), 0,
        "umts_rrc_ies.T_additionalTimeslots3", HFILL }},
    { &hf_umts_rrc_ies_consecutive4,
      { "consecutive", "umts_rrc_ies.consecutive",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_consecutive2", HFILL }},
    { &hf_umts_rrc_ies_numAdditionalTimeslots1,
      { "numAdditionalTimeslots", "umts_rrc_ies.numAdditionalTimeslots",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxTSLCR1", HFILL }},
    { &hf_umts_rrc_ies_timeslotList3,
      { "timeslotList", "umts_rrc_ies.timeslotList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_timeslotList_item3,
      { "Item", "umts_rrc_ies.timeslotList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UplinkAdditionalTimeslots_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_satID,
      { "satID", "umts_rrc_ies.satID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SatID", HFILL }},
    { &hf_umts_rrc_ies_doppler0thOrder,
      { "doppler0thOrder", "umts_rrc_ies.doppler0thOrder",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M2048_2047", HFILL }},
    { &hf_umts_rrc_ies_extraDopplerInfo,
      { "extraDopplerInfo", "umts_rrc_ies.extraDopplerInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ExtraDopplerInfo", HFILL }},
    { &hf_umts_rrc_ies_codePhase,
      { "codePhase", "umts_rrc_ies.codePhase",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1022", HFILL }},
    { &hf_umts_rrc_ies_integerCodePhase,
      { "integerCodePhase", "umts_rrc_ies.integerCodePhase",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_19", HFILL }},
    { &hf_umts_rrc_ies_gps_BitNumber,
      { "gps-BitNumber", "umts_rrc_ies.gps_BitNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_codePhaseSearchWindow,
      { "codePhaseSearchWindow", "umts_rrc_ies.codePhaseSearchWindow",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CodePhaseSearchWindow_vals), 0,
        "umts_rrc_ies.CodePhaseSearchWindow", HFILL }},
    { &hf_umts_rrc_ies_azimuthAndElevation,
      { "azimuthAndElevation", "umts_rrc_ies.azimuthAndElevation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AzimuthAndElevation", HFILL }},
    { &hf_umts_rrc_ies_AcquisitionSatInfoList_item,
      { "Item", "umts_rrc_ies.AcquisitionSatInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AcquisitionSatInfo", HFILL }},
    { &hf_umts_rrc_ies_AdditionalMeasurementID_List_item,
      { "Item", "umts_rrc_ies.AdditionalMeasurementID_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MeasurementIdentity", HFILL }},
    { &hf_umts_rrc_ies_dataID,
      { "dataID", "umts_rrc_ies.dataID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_e,
      { "e", "umts_rrc_ies.e",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_t_oa,
      { "t-oa", "umts_rrc_ies.t_oa",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_deltaI,
      { "deltaI", "umts_rrc_ies.deltaI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_omegaDot,
      { "omegaDot", "umts_rrc_ies.omegaDot",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_satHealth,
      { "satHealth", "umts_rrc_ies.satHealth",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_a_Sqrt,
      { "a-Sqrt", "umts_rrc_ies.a_Sqrt",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_omega0,
      { "omega0", "umts_rrc_ies.omega0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_m0,
      { "m0", "umts_rrc_ies.m0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_omega,
      { "omega", "umts_rrc_ies.omega",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_af0,
      { "af0", "umts_rrc_ies.af0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_11", HFILL }},
    { &hf_umts_rrc_ies_af1,
      { "af1", "umts_rrc_ies.af1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_11", HFILL }},
    { &hf_umts_rrc_ies_AlmanacSatInfoList_item,
      { "Item", "umts_rrc_ies.AlmanacSatInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.AlmanacSatInfo", HFILL }},
    { &hf_umts_rrc_ies_azimuth,
      { "azimuth", "umts_rrc_ies.azimuth",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_elevation,
      { "elevation", "umts_rrc_ies.elevation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_BadSatList_item,
      { "Item", "umts_rrc_ies.BadSatList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_dl_TransportChannelBLER,
      { "dl-TransportChannelBLER", "umts_rrc_ies.dl_TransportChannelBLER",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DL_TransportChannelBLER", HFILL }},
    { &hf_umts_rrc_ies_BLER_MeasurementResultsList_item,
      { "Item", "umts_rrc_ies.BLER_MeasurementResultsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.BLER_MeasurementResults", HFILL }},
    { &hf_umts_rrc_ies_BLER_TransChIdList_item,
      { "Item", "umts_rrc_ies.BLER_TransChIdList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_verifiedBSIC,
      { "verifiedBSIC", "umts_rrc_ies.verifiedBSIC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_maxCellMeas", HFILL }},
    { &hf_umts_rrc_ies_nonVerifiedBSIC,
      { "nonVerifiedBSIC", "umts_rrc_ies.nonVerifiedBSIC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BCCH_ARFCN", HFILL }},
    { &hf_umts_rrc_ies_burstStart,
      { "burstStart", "umts_rrc_ies.burstStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_burstLength,
      { "burstLength", "umts_rrc_ies.burstLength",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_10_25", HFILL }},
    { &hf_umts_rrc_ies_burstFreq,
      { "burstFreq", "umts_rrc_ies.burstFreq",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_16", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingCriteria,
      { "intraFreqReportingCriteria", "umts_rrc_ies.intraFreqReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_periodicalReportingCriteria,
      { "periodicalReportingCriteria", "umts_rrc_ies.periodicalReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PeriodicalReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingCriteria1,
      { "intraFreqReportingCriteria", "umts_rrc_ies.intraFreqReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqReportingCriteria_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cellIndividualOffset,
      { "cellIndividualOffset", "umts_rrc_ies.cellIndividualOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellIndividualOffset", HFILL }},
    { &hf_umts_rrc_ies_referenceTimeDifferenceToCell,
      { "referenceTimeDifferenceToCell", "umts_rrc_ies.referenceTimeDifferenceToCell",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReferenceTimeDifferenceToCell_vals), 0,
        "umts_rrc_ies.ReferenceTimeDifferenceToCell", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo41,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo41_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo41", HFILL }},
    { &hf_umts_rrc_ies_fdd53,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd50", HFILL }},
    { &hf_umts_rrc_ies_readSFN_Indicator,
      { "readSFN-Indicator", "umts_rrc_ies.readSFN_Indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd47,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd42", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_Info2,
      { "primaryCCPCH-Info", "umts_rrc_ies.primaryCCPCH_Info",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PrimaryCCPCH_Info_vals), 0,
        "umts_rrc_ies.PrimaryCCPCH_Info", HFILL }},
    { &hf_umts_rrc_ies_timeslotInfoList,
      { "timeslotInfoList", "umts_rrc_ies.timeslotInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotInfoList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo42,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo42_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo42", HFILL }},
    { &hf_umts_rrc_ies_fdd54,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd51", HFILL }},
    { &hf_umts_rrc_ies_tdd48,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd43", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_Info3,
      { "primaryCCPCH-Info", "umts_rrc_ies.primaryCCPCH_Info",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PrimaryCCPCH_Info_r4_vals), 0,
        "umts_rrc_ies.PrimaryCCPCH_Info_r4", HFILL }},
    { &hf_umts_rrc_ies_timeslotInfoList1,
      { "timeslotInfoList", "umts_rrc_ies.timeslotInfoList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimeslotInfoList_r4_vals), 0,
        "umts_rrc_ies.TimeslotInfoList_r4", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo43,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo43_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo43", HFILL }},
    { &hf_umts_rrc_ies_fdd55,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd52", HFILL }},
    { &hf_umts_rrc_ies_tdd49,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd44", HFILL }},
    { &hf_umts_rrc_ies_cellSelectionReselectionInfo,
      { "cellSelectionReselectionInfo", "umts_rrc_ies.cellSelectionReselectionInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoSIB_11_12_RSCP", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_Info4,
      { "primaryCCPCH-Info", "umts_rrc_ies.primaryCCPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_timeslotInfoList2,
      { "timeslotInfoList", "umts_rrc_ies.timeslotInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotInfoList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo44,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo44_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo44", HFILL }},
    { &hf_umts_rrc_ies_fdd56,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd53", HFILL }},
    { &hf_umts_rrc_ies_tdd50,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd45", HFILL }},
    { &hf_umts_rrc_ies_cellSelectionReselectionInfo1,
      { "cellSelectionReselectionInfo", "umts_rrc_ies.cellSelectionReselectionInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoSIB_11_12_ECN0", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo45,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo45_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo45", HFILL }},
    { &hf_umts_rrc_ies_fdd57,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd54", HFILL }},
    { &hf_umts_rrc_ies_tdd51,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd46", HFILL }},
    { &hf_umts_rrc_ies_cellSelectionReselectionInfo2,
      { "cellSelectionReselectionInfo", "umts_rrc_ies.cellSelectionReselectionInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoSIB_11_12_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo46,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo46_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo46", HFILL }},
    { &hf_umts_rrc_ies_fdd58,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd55", HFILL }},
    { &hf_umts_rrc_ies_tdd52,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd47", HFILL }},
    { &hf_umts_rrc_ies_cellSelectionReselectionInfo3,
      { "cellSelectionReselectionInfo", "umts_rrc_ies.cellSelectionReselectionInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoSIB_11_12_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_cellIdentity,
      { "cellIdentity", "umts_rrc_ies.cellIdentity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.CellIdentity", HFILL }},
    { &hf_umts_rrc_ies_dummy_SFN_SFN_ObsTimeDifference,
      { "dummy-SFN-SFN-ObsTimeDifference", "umts_rrc_ies.dummy_SFN_SFN_ObsTimeDifference",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_SFN_ObsTimeDifference_vals), 0,
        "umts_rrc_ies.SFN_SFN_ObsTimeDifference", HFILL }},
    { &hf_umts_rrc_ies_cellSynchronisationInfo,
      { "cellSynchronisationInfo", "umts_rrc_ies.cellSynchronisationInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSynchronisationInfo", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo47,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo47_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo47", HFILL }},
    { &hf_umts_rrc_ies_fdd59,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd56", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N01,
      { "cpich-Ec-N0", "umts_rrc_ies.cpich_Ec_N0",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CPICH_Ec_N0", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP1,
      { "cpich-RSCP", "umts_rrc_ies.cpich_RSCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CPICH_RSCP", HFILL }},
    { &hf_umts_rrc_ies_pathloss,
      { "pathloss", "umts_rrc_ies.pathloss",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Pathloss", HFILL }},
    { &hf_umts_rrc_ies_tdd53,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd48", HFILL }},
    { &hf_umts_rrc_ies_proposedTGSN,
      { "proposedTGSN", "umts_rrc_ies.proposedTGSN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TGSN", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_RSCP,
      { "primaryCCPCH-RSCP", "umts_rrc_ies.primaryCCPCH_RSCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_RSCP", HFILL }},
    { &hf_umts_rrc_ies_timeslotISCP_List,
      { "timeslotISCP-List", "umts_rrc_ies.timeslotISCP_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotISCP_List", HFILL }},
    { &hf_umts_rrc_ies_fdd60,
      { "fdd", "umts_rrc_ies.fdd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_fdd_item1,
      { "Item", "umts_rrc_ies.fdd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_tdd54,
      { "tdd", "umts_rrc_ies.tdd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info", HFILL }},
    { &hf_umts_rrc_ies_tdd_item1,
      { "Item", "umts_rrc_ies.tdd_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PrimaryCCPCH_Info_vals), 0,
        "umts_rrc_ies.PrimaryCCPCH_Info", HFILL }},
    { &hf_umts_rrc_ies_CellMeasurementEventResults_LCR_r4_item,
      { "Item", "umts_rrc_ies.CellMeasurementEventResults_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_dummy_SFN_SFN_OTD_Type,
      { "dummy-SFN-SFN-OTD-Type", "umts_rrc_ies.dummy_SFN_SFN_OTD_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_SFN_OTD_Type_vals), 0,
        "umts_rrc_ies.SFN_SFN_OTD_Type", HFILL }},
    { &hf_umts_rrc_ies_cellIdentity_reportingIndicator,
      { "cellIdentity-reportingIndicator", "umts_rrc_ies.cellIdentity_reportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_cellSynchronisationInfoReportingIndicator,
      { "cellSynchronisationInfoReportingIndicator", "umts_rrc_ies.cellSynchronisationInfoReportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo48,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo48_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo48", HFILL }},
    { &hf_umts_rrc_ies_fdd61,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd57", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N0_reportingIndicator,
      { "cpich-Ec-N0-reportingIndicator", "umts_rrc_ies.cpich_Ec_N0_reportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP_reportingIndicator,
      { "cpich-RSCP-reportingIndicator", "umts_rrc_ies.cpich_RSCP_reportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_pathloss_reportingIndicator,
      { "pathloss-reportingIndicator", "umts_rrc_ies.pathloss_reportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd55,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd49", HFILL }},
    { &hf_umts_rrc_ies_timeslotISCP_reportingIndicator,
      { "timeslotISCP-reportingIndicator", "umts_rrc_ies.timeslotISCP_reportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_proposedTGSN_ReportingRequired,
      { "proposedTGSN-ReportingRequired", "umts_rrc_ies.proposedTGSN_ReportingRequired",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_primaryCCPCH_RSCP_reportingIndicator,
      { "primaryCCPCH-RSCP-reportingIndicator", "umts_rrc_ies.primaryCCPCH_RSCP_reportingIndicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_q_Offset1S_N,
      { "q-Offset1S-N", "umts_rrc_ies.q_Offset1S_N",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_OffsetS_N", HFILL }},
    { &hf_umts_rrc_ies_q_Offset2S_N,
      { "q-Offset2S-N", "umts_rrc_ies.q_Offset2S_N",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_OffsetS_N", HFILL }},
    { &hf_umts_rrc_ies_hcs_NeighbouringCellInformation_RSCP,
      { "hcs-NeighbouringCellInformation-RSCP", "umts_rrc_ies.hcs_NeighbouringCellInformation_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HCS_NeighbouringCellInformation_RSCP", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo49,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo49_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo49", HFILL }},
    { &hf_umts_rrc_ies_fdd62,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd58", HFILL }},
    { &hf_umts_rrc_ies_tdd56,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd50", HFILL }},
    { &hf_umts_rrc_ies_gsm,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm", HFILL }},
    { &hf_umts_rrc_ies_q_OffsetS_N,
      { "q-OffsetS-N", "umts_rrc_ies.q_OffsetS_N",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_OffsetS_N", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo50,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo50_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo50", HFILL }},
    { &hf_umts_rrc_ies_fdd63,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd59", HFILL }},
    { &hf_umts_rrc_ies_tdd57,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd51", HFILL }},
    { &hf_umts_rrc_ies_gsm1,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm1", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo51,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo51_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo51", HFILL }},
    { &hf_umts_rrc_ies_fdd64,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd60", HFILL }},
    { &hf_umts_rrc_ies_tdd58,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd52", HFILL }},
    { &hf_umts_rrc_ies_gsm2,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm2", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo52,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo52_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo52", HFILL }},
    { &hf_umts_rrc_ies_fdd65,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd61", HFILL }},
    { &hf_umts_rrc_ies_tdd59,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd53", HFILL }},
    { &hf_umts_rrc_ies_gsm3,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm3", HFILL }},
    { &hf_umts_rrc_ies_hcs_NeighbouringCellInformation_ECN0,
      { "hcs-NeighbouringCellInformation-ECN0", "umts_rrc_ies.hcs_NeighbouringCellInformation_ECN0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HCS_NeighbouringCellInformation_ECN0", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo53,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo53_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo53", HFILL }},
    { &hf_umts_rrc_ies_fdd66,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd62", HFILL }},
    { &hf_umts_rrc_ies_tdd60,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd54", HFILL }},
    { &hf_umts_rrc_ies_gsm4,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm4", HFILL }},
    { &hf_umts_rrc_ies_deltaQrxlevmin,
      { "deltaQrxlevmin", "umts_rrc_ies.deltaQrxlevmin",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaQrxlevmin", HFILL }},
    { &hf_umts_rrc_ies_deltaQhcs,
      { "deltaQhcs", "umts_rrc_ies.deltaQhcs",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaRSCP", HFILL }},
    { &hf_umts_rrc_ies_q_Hyst_l_S_PCH,
      { "q-Hyst-l-S-PCH", "umts_rrc_ies.q_Hyst_l_S_PCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_Hyst_S_Fine", HFILL }},
    { &hf_umts_rrc_ies_q_Hyst_l_S_FACH,
      { "q-Hyst-l-S-FACH", "umts_rrc_ies.q_Hyst_l_S_FACH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_Hyst_S_Fine", HFILL }},
    { &hf_umts_rrc_ies_q_Hyst_2_S_PCH,
      { "q-Hyst-2-S-PCH", "umts_rrc_ies.q_Hyst_2_S_PCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_Hyst_S_Fine", HFILL }},
    { &hf_umts_rrc_ies_q_Hyst_2_S_FACH,
      { "q-Hyst-2-S-FACH", "umts_rrc_ies.q_Hyst_2_S_FACH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_Hyst_S_Fine", HFILL }},
    { &hf_umts_rrc_ies_t_Reselection_S_PCH,
      { "t-Reselection-S-PCH", "umts_rrc_ies.t_Reselection_S_PCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_Reselection_S", HFILL }},
    { &hf_umts_rrc_ies_t_Reselection_S_FACH,
      { "t-Reselection-S-FACH", "umts_rrc_ies.t_Reselection_S_FACH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_Reselection_S_Fine", HFILL }},
    { &hf_umts_rrc_ies_non_HCS_t_CR_Max,
      { "non-HCS-t-CR-Max", "umts_rrc_ies.non_HCS_t_CR_Max",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_CRMax_vals), 0,
        "umts_rrc_ies.T_CRMax", HFILL }},
    { &hf_umts_rrc_ies_speedDependentScalingFactor,
      { "speedDependentScalingFactor", "umts_rrc_ies.speedDependentScalingFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SpeedDependentScalingFactor", HFILL }},
    { &hf_umts_rrc_ies_interFrequencyTreselectionScalingFactor,
      { "interFrequencyTreselectionScalingFactor", "umts_rrc_ies.interFrequencyTreselectionScalingFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TreselectionScalingFactor", HFILL }},
    { &hf_umts_rrc_ies_interRATTreselectionScalingFactor,
      { "interRATTreselectionScalingFactor", "umts_rrc_ies.interRATTreselectionScalingFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TreselectionScalingFactor", HFILL }},
    { &hf_umts_rrc_ies_CellsForInterFreqMeasList_item,
      { "Item", "umts_rrc_ies.CellsForInterFreqMeasList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_CellsForInterRATMeasList_item,
      { "Item", "umts_rrc_ies.CellsForInterRATMeasList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterRATCellID", HFILL }},
    { &hf_umts_rrc_ies_CellsForIntraFreqMeasList_item,
      { "Item", "umts_rrc_ies.CellsForIntraFreqMeasList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo54,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo54_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo54", HFILL }},
    { &hf_umts_rrc_ies_fdd67,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd63", HFILL }},
    { &hf_umts_rrc_ies_countC_SFN_Frame_difference,
      { "countC-SFN-Frame-difference", "umts_rrc_ies.countC_SFN_Frame_difference",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CountC_SFN_Frame_difference", HFILL }},
    { &hf_umts_rrc_ies_tm,
      { "tm", "umts_rrc_ies.tm",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_38399", HFILL }},
    { &hf_umts_rrc_ies_tdd61,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd55", HFILL }},
    { &hf_umts_rrc_ies_bsicReported,
      { "bsicReported", "umts_rrc_ies.bsicReported",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_BSICReported_vals), 0,
        "umts_rrc_ies.BSICReported", HFILL }},
    { &hf_umts_rrc_ies_CellToReportList_item,
      { "Item", "umts_rrc_ies.CellToReportList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellToReport", HFILL }},
    { &hf_umts_rrc_ies_countC_SFN_High,
      { "countC-SFN-High", "umts_rrc_ies.countC_SFN_High",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_off,
      { "off", "umts_rrc_ies.off",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_deltaRSCP,
      { "deltaRSCP", "umts_rrc_ies.deltaRSCP",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaRSCP", HFILL }},
    { &hf_umts_rrc_ies_iode,
      { "iode", "umts_rrc_ies.iode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IODE", HFILL }},
    { &hf_umts_rrc_ies_udre,
      { "udre", "umts_rrc_ies.udre",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UDRE_vals), 0,
        "umts_rrc_ies.UDRE", HFILL }},
    { &hf_umts_rrc_ies_prc,
      { "prc", "umts_rrc_ies.prc",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PRC", HFILL }},
    { &hf_umts_rrc_ies_rrc,
      { "rrc", "umts_rrc_ies.rrc",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RRC", HFILL }},
    { &hf_umts_rrc_ies_dummy1_DeltaPRC,
      { "dummy1-DeltaPRC", "umts_rrc_ies.dummy1_DeltaPRC",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaPRC", HFILL }},
    { &hf_umts_rrc_ies_dummy2_DeltaPRC,
      { "dummy2-DeltaPRC", "umts_rrc_ies.dummy2_DeltaPRC",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaRRC", HFILL }},
    { &hf_umts_rrc_ies_dummy3_DeltaPRC,
      { "dummy3-DeltaPRC", "umts_rrc_ies.dummy3_DeltaPRC",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaPRC", HFILL }},
    { &hf_umts_rrc_ies_dummy4_DeltaPRC,
      { "dummy4-DeltaPRC", "umts_rrc_ies.dummy4_DeltaPRC",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaRRC", HFILL }},
    { &hf_umts_rrc_ies_DGPS_CorrectionSatInfoList_item,
      { "Item", "umts_rrc_ies.DGPS_CorrectionSatInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DGPS_CorrectionSatInfo", HFILL }},
    { &hf_umts_rrc_ies_latitudeSign,
      { "latitudeSign", "umts_rrc_ies.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_latitudeSign_vals), 0,
        "umts_rrc_ies.T_latitudeSign", HFILL }},
    { &hf_umts_rrc_ies_latitude,
      { "latitude", "umts_rrc_ies.latitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_8388607", HFILL }},
    { &hf_umts_rrc_ies_longitude,
      { "longitude", "umts_rrc_ies.longitude",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M8388608_8388607", HFILL }},
    { &hf_umts_rrc_ies_latitudeSign1,
      { "latitudeSign", "umts_rrc_ies.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_latitudeSign1_vals), 0,
        "umts_rrc_ies.T_latitudeSign1", HFILL }},
    { &hf_umts_rrc_ies_altitudeDirection,
      { "altitudeDirection", "umts_rrc_ies.altitudeDirection",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_altitudeDirection_vals), 0,
        "umts_rrc_ies.T_altitudeDirection", HFILL }},
    { &hf_umts_rrc_ies_altitude,
      { "altitude", "umts_rrc_ies.altitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_32767", HFILL }},
    { &hf_umts_rrc_ies_latitudeSign2,
      { "latitudeSign", "umts_rrc_ies.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_latitudeSign2_vals), 0,
        "umts_rrc_ies.T_latitudeSign2", HFILL }},
    { &hf_umts_rrc_ies_altitudeDirection1,
      { "altitudeDirection", "umts_rrc_ies.altitudeDirection",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_altitudeDirection1_vals), 0,
        "umts_rrc_ies.T_altitudeDirection1", HFILL }},
    { &hf_umts_rrc_ies_uncertaintySemiMajor,
      { "uncertaintySemiMajor", "umts_rrc_ies.uncertaintySemiMajor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_uncertaintySemiMinor,
      { "uncertaintySemiMinor", "umts_rrc_ies.uncertaintySemiMinor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_orientationMajorAxis,
      { "orientationMajorAxis", "umts_rrc_ies.orientationMajorAxis",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_89", HFILL }},
    { &hf_umts_rrc_ies_uncertaintyAltitude,
      { "uncertaintyAltitude", "umts_rrc_ies.uncertaintyAltitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_confidence,
      { "confidence", "umts_rrc_ies.confidence",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_100", HFILL }},
    { &hf_umts_rrc_ies_latitudeSign3,
      { "latitudeSign", "umts_rrc_ies.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_latitudeSign3_vals), 0,
        "umts_rrc_ies.T_latitudeSign3", HFILL }},
    { &hf_umts_rrc_ies_uncertaintyCode,
      { "uncertaintyCode", "umts_rrc_ies.uncertaintyCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_latitudeSign4,
      { "latitudeSign", "umts_rrc_ies.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_latitudeSign4_vals), 0,
        "umts_rrc_ies.T_latitudeSign4", HFILL }},
    { &hf_umts_rrc_ies_triggeringCondition,
      { "triggeringCondition", "umts_rrc_ies.triggeringCondition",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TriggeringCondition2_vals), 0,
        "umts_rrc_ies.TriggeringCondition2", HFILL }},
    { &hf_umts_rrc_ies_reportingRange,
      { "reportingRange", "umts_rrc_ies.reportingRange",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ReportingRange", HFILL }},
    { &hf_umts_rrc_ies_forbiddenAffectCellList,
      { "forbiddenAffectCellList", "umts_rrc_ies.forbiddenAffectCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ForbiddenAffectCellList", HFILL }},
    { &hf_umts_rrc_ies_w,
      { "w", "umts_rrc_ies.w",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.W", HFILL }},
    { &hf_umts_rrc_ies_reportDeactivationThreshold,
      { "reportDeactivationThreshold", "umts_rrc_ies.reportDeactivationThreshold",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReportDeactivationThreshold_vals), 0,
        "umts_rrc_ies.ReportDeactivationThreshold", HFILL }},
    { &hf_umts_rrc_ies_reportingAmount,
      { "reportingAmount", "umts_rrc_ies.reportingAmount",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReportingAmount_vals), 0,
        "umts_rrc_ies.ReportingAmount", HFILL }},
    { &hf_umts_rrc_ies_reportingInterval,
      { "reportingInterval", "umts_rrc_ies.reportingInterval",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReportingInterval_vals), 0,
        "umts_rrc_ies.ReportingInterval", HFILL }},
    { &hf_umts_rrc_ies_forbiddenAffectCellList1,
      { "forbiddenAffectCellList", "umts_rrc_ies.forbiddenAffectCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ForbiddenAffectCellList_r4", HFILL }},
    { &hf_umts_rrc_ies_forbiddenAffectCellList2,
      { "forbiddenAffectCellList", "umts_rrc_ies.forbiddenAffectCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ForbiddenAffectCellList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_triggeringCondition1,
      { "triggeringCondition", "umts_rrc_ies.triggeringCondition",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TriggeringCondition1_vals), 0,
        "umts_rrc_ies.TriggeringCondition1", HFILL }},
    { &hf_umts_rrc_ies_replacementActivationThreshold,
      { "replacementActivationThreshold", "umts_rrc_ies.replacementActivationThreshold",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReplacementActivationThreshold_vals), 0,
        "umts_rrc_ies.ReplacementActivationThreshold", HFILL }},
    { &hf_umts_rrc_ies_thresholdUsedFrequency,
      { "thresholdUsedFrequency", "umts_rrc_ies.thresholdUsedFrequency",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ThresholdUsedFrequency", HFILL }},
    { &hf_umts_rrc_ies_dummy_Threshold,
      { "dummy-Threshold", "umts_rrc_ies.dummy_Threshold",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Threshold", HFILL }},
    { &hf_umts_rrc_ies_usedFreqW,
      { "usedFreqW", "umts_rrc_ies.usedFreqW",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.W", HFILL }},
    { &hf_umts_rrc_ies_hysteresis,
      { "hysteresis", "umts_rrc_ies.hysteresis",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HysteresisInterFreq", HFILL }},
    { &hf_umts_rrc_ies_timeToTrigger,
      { "timeToTrigger", "umts_rrc_ies.timeToTrigger",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimeToTrigger_vals), 0,
        "umts_rrc_ies.TimeToTrigger", HFILL }},
    { &hf_umts_rrc_ies_reportingCellStatus,
      { "reportingCellStatus", "umts_rrc_ies.reportingCellStatus",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReportingCellStatus_vals), 0,
        "umts_rrc_ies.ReportingCellStatus", HFILL }},
    { &hf_umts_rrc_ies_nonUsedFreqParameterList,
      { "nonUsedFreqParameterList", "umts_rrc_ies.nonUsedFreqParameterList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NonUsedFreqParameterList", HFILL }},
    { &hf_umts_rrc_ies_usedFreqThreshold,
      { "usedFreqThreshold", "umts_rrc_ies.usedFreqThreshold",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Threshold", HFILL }},
    { &hf_umts_rrc_ies_thresholdOwnSystem,
      { "thresholdOwnSystem", "umts_rrc_ies.thresholdOwnSystem",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Threshold", HFILL }},
    { &hf_umts_rrc_ies_thresholdOtherSystem,
      { "thresholdOtherSystem", "umts_rrc_ies.thresholdOtherSystem",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Threshold", HFILL }},
    { &hf_umts_rrc_ies_hysteresis1,
      { "hysteresis", "umts_rrc_ies.hysteresis",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Hysteresis", HFILL }},
    { &hf_umts_rrc_ies_intraFreqEventResults,
      { "intraFreqEventResults", "umts_rrc_ies.intraFreqEventResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqEventResults", HFILL }},
    { &hf_umts_rrc_ies_interFreqEventResults,
      { "interFreqEventResults", "umts_rrc_ies.interFreqEventResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqEventResults", HFILL }},
    { &hf_umts_rrc_ies_interRATEventResults,
      { "interRATEventResults", "umts_rrc_ies.interRATEventResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATEventResults", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeEventResults,
      { "trafficVolumeEventResults", "umts_rrc_ies.trafficVolumeEventResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeEventResults", HFILL }},
    { &hf_umts_rrc_ies_qualityEventResults,
      { "qualityEventResults", "umts_rrc_ies.qualityEventResults",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.QualityEventResults", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalEventResults,
      { "ue-InternalEventResults", "umts_rrc_ies.ue_InternalEventResults",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_InternalEventResults_vals), 0,
        "umts_rrc_ies.UE_InternalEventResults", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_MeasurementEventResults,
      { "ue-positioning-MeasurementEventResults", "umts_rrc_ies.ue_positioning_MeasurementEventResults",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_MeasurementEventResults_vals), 0,
        "umts_rrc_ies.UE_Positioning_MeasurementEventResults", HFILL }},
    { &hf_umts_rrc_ies_doppler1stOrder,
      { "doppler1stOrder", "umts_rrc_ies.doppler1stOrder",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M42_21", HFILL }},
    { &hf_umts_rrc_ies_dopplerUncertainty,
      { "dopplerUncertainty", "umts_rrc_ies.dopplerUncertainty",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DopplerUncertainty_vals), 0,
        "umts_rrc_ies.DopplerUncertainty", HFILL }},
    { &hf_umts_rrc_ies_fACH_meas_occasion_coeff,
      { "fACH-meas-occasion-coeff", "umts_rrc_ies.fACH_meas_occasion_coeff",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_12", HFILL }},
    { &hf_umts_rrc_ies_inter_freq_FDD_meas_ind,
      { "inter-freq-FDD-meas-ind", "umts_rrc_ies.inter_freq_FDD_meas_ind",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_inter_freq_TDD_meas_ind,
      { "inter-freq-TDD-meas-ind", "umts_rrc_ies.inter_freq_TDD_meas_ind",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_inter_RAT_meas_ind,
      { "inter-RAT-meas-ind", "umts_rrc_ies.inter_RAT_meas_ind",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type", HFILL }},
    { &hf_umts_rrc_ies_inter_RAT_meas_ind_item,
      { "Item", "umts_rrc_ies.inter_RAT_meas_ind_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RAT_Type_vals), 0,
        "umts_rrc_ies.RAT_Type", HFILL }},
    { &hf_umts_rrc_ies_inter_freq_TDD128_meas_ind,
      { "inter-freq-TDD128-meas-ind", "umts_rrc_ies.inter_freq_TDD128_meas_ind",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_fdd68,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_tdd62,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_Info_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_ForbiddenAffectCellList_item,
      { "Item", "umts_rrc_ies.ForbiddenAffectCellList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ForbiddenAffectCell_vals), 0,
        "umts_rrc_ies.ForbiddenAffectCell", HFILL }},
    { &hf_umts_rrc_ies_ForbiddenAffectCellList_r4_item,
      { "Item", "umts_rrc_ies.ForbiddenAffectCellList_r4_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ForbiddenAffectCell_r4_vals), 0,
        "umts_rrc_ies.ForbiddenAffectCell_r4", HFILL }},
    { &hf_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4_item,
      { "Item", "umts_rrc_ies.ForbiddenAffectCellList_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ForbiddenAffectCell_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_satelliteID,
      { "satelliteID", "umts_rrc_ies.satelliteID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_c_N0,
      { "c-N0", "umts_rrc_ies.c_N0",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_doppler,
      { "doppler", "umts_rrc_ies.doppler",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M32768_32768", HFILL }},
    { &hf_umts_rrc_ies_wholeGPS_Chips,
      { "wholeGPS-Chips", "umts_rrc_ies.wholeGPS_Chips",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1022", HFILL }},
    { &hf_umts_rrc_ies_fractionalGPS_Chips,
      { "fractionalGPS-Chips", "umts_rrc_ies.fractionalGPS_Chips",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1023", HFILL }},
    { &hf_umts_rrc_ies_multipathIndicator,
      { "multipathIndicator", "umts_rrc_ies.multipathIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MultipathIndicator_vals), 0,
        "umts_rrc_ies.MultipathIndicator", HFILL }},
    { &hf_umts_rrc_ies_pseudorangeRMS_Error,
      { "pseudorangeRMS-Error", "umts_rrc_ies.pseudorangeRMS_Error",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_GPS_MeasurementParamList_item,
      { "Item", "umts_rrc_ies.GPS_MeasurementParamList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GPS_MeasurementParam", HFILL }},
    { &hf_umts_rrc_ies_gsm_CarrierRSSI,
      { "gsm-CarrierRSSI", "umts_rrc_ies.gsm_CarrierRSSI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GSM_CarrierRSSI", HFILL }},
    { &hf_umts_rrc_ies_dummy_INTEGER_46_173,
      { "dummy-INTEGER-46-173", "umts_rrc_ies.dummy_INTEGER_46_173",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_46_173", HFILL }},
    { &hf_umts_rrc_ies_dummy2_ObservedTimeDifferenceToGSM,
      { "dummy2-ObservedTimeDifferenceToGSM", "umts_rrc_ies.dummy2_ObservedTimeDifferenceToGSM",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ObservedTimeDifferenceToGSM", HFILL }},
    { &hf_umts_rrc_ies_GSM_MeasuredResultsList_item,
      { "Item", "umts_rrc_ies.GSM_MeasuredResultsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GSM_MeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_tlm_Message,
      { "tlm-Message", "umts_rrc_ies.tlm_Message",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_14", HFILL }},
    { &hf_umts_rrc_ies_tlm_Reserved,
      { "tlm-Reserved", "umts_rrc_ies.tlm_Reserved",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_2", HFILL }},
    { &hf_umts_rrc_ies_alert,
      { "alert", "umts_rrc_ies.alert",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_antiSpoof,
      { "antiSpoof", "umts_rrc_ies.antiSpoof",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_GPS_TOW_AssistList_item,
      { "Item", "umts_rrc_ies.GPS_TOW_AssistList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GPS_TOW_Assist", HFILL }},
    { &hf_umts_rrc_ies_penaltyTime,
      { "penaltyTime", "umts_rrc_ies.penaltyTime",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PenaltyTime_RSCP_vals), 0,
        "umts_rrc_ies.PenaltyTime_RSCP", HFILL }},
    { &hf_umts_rrc_ies_penaltyTime1,
      { "penaltyTime", "umts_rrc_ies.penaltyTime",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PenaltyTime_ECN0_vals), 0,
        "umts_rrc_ies.PenaltyTime_ECN0", HFILL }},
    { &hf_umts_rrc_ies_hcs_PRIO,
      { "hcs-PRIO", "umts_rrc_ies.hcs_PRIO",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.HCS_PRIO", HFILL }},
    { &hf_umts_rrc_ies_q_HCS,
      { "q-HCS", "umts_rrc_ies.q_HCS",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Q_HCS", HFILL }},
    { &hf_umts_rrc_ies_hcs_CellReselectInformation,
      { "hcs-CellReselectInformation", "umts_rrc_ies.hcs_CellReselectInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HCS_CellReselectInformation_RSCP", HFILL }},
    { &hf_umts_rrc_ies_hcs_CellReselectInformation1,
      { "hcs-CellReselectInformation", "umts_rrc_ies.hcs_CellReselectInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.HCS_CellReselectInformation_ECN0", HFILL }},
    { &hf_umts_rrc_ies_t_CR_Max,
      { "t-CR-Max", "umts_rrc_ies.t_CR_Max",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_CRMax_vals), 0,
        "umts_rrc_ies.T_CRMax", HFILL }},
    { &hf_umts_rrc_ies_nonFreqRelatedEventResults,
      { "nonFreqRelatedEventResults", "umts_rrc_ies.nonFreqRelatedEventResults",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CellMeasurementEventResults_vals), 0,
        "umts_rrc_ies.CellMeasurementEventResults", HFILL }},
    { &hf_umts_rrc_ies_nonFreqRelatedEventResults1,
      { "nonFreqRelatedEventResults", "umts_rrc_ies.nonFreqRelatedEventResults",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellMeasurementEventResults_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_removedInterFreqCellList,
      { "removedInterFreqCellList", "umts_rrc_ies.removedInterFreqCellList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RemovedInterFreqCellList_vals), 0,
        "umts_rrc_ies.RemovedInterFreqCellList", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellList", HFILL }},
    { &hf_umts_rrc_ies_cellsForInterFreqMeasList,
      { "cellsForInterFreqMeasList", "umts_rrc_ies.cellsForInterFreqMeasList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellsForInterFreqMeasList", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList1,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellList_r4", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList2,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_RSCP", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList3,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_ECN0", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList4,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList5,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList6,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList7,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList8,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newInterFreqCellList9,
      { "newInterFreqCellList", "umts_rrc_ies.newInterFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_List_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_InterFreqCellList_item,
      { "Item", "umts_rrc_ies.InterFreqCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCell", HFILL }},
    { &hf_umts_rrc_ies_InterFreqCellList_LCR_r4_ext_item,
      { "Item", "umts_rrc_ies.InterFreqCellList_LCR_r4_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCell_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_InterFreqCellMeasuredResultsList_item,
      { "Item", "umts_rrc_ies.InterFreqCellMeasuredResultsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_event2a,
      { "event2a", "umts_rrc_ies.event2a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event2a", HFILL }},
    { &hf_umts_rrc_ies_event2b,
      { "event2b", "umts_rrc_ies.event2b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event2b", HFILL }},
    { &hf_umts_rrc_ies_event2c,
      { "event2c", "umts_rrc_ies.event2c",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event2c", HFILL }},
    { &hf_umts_rrc_ies_event2d,
      { "event2d", "umts_rrc_ies.event2d",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event2d", HFILL }},
    { &hf_umts_rrc_ies_event2e,
      { "event2e", "umts_rrc_ies.event2e",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event2e", HFILL }},
    { &hf_umts_rrc_ies_event2f,
      { "event2f", "umts_rrc_ies.event2f",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event2f", HFILL }},
    { &hf_umts_rrc_ies_InterFreqEventList_item,
      { "Item", "umts_rrc_ies.InterFreqEventList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterFreqEvent_vals), 0,
        "umts_rrc_ies.InterFreqEvent", HFILL }},
    { &hf_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext_item,
      { "Item", "umts_rrc_ies.InterFrequencyMeasuredResultsList_v590ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DeltaRSCPPerCell", HFILL }},
    { &hf_umts_rrc_ies_threholdUsedFrequency_delta,
      { "threholdUsedFrequency-delta", "umts_rrc_ies.threholdUsedFrequency_delta",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaRSCP", HFILL }},
    { &hf_umts_rrc_ies_threholdNonUsedFrequency_deltaList,
      { "threholdNonUsedFrequency-deltaList", "umts_rrc_ies.threholdNonUsedFrequency_deltaList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ThreholdNonUsedFrequency_deltaList", HFILL }},
    { &hf_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext_item,
      { "Item", "umts_rrc_ies.Inter_FreqEventCriteriaList_v590ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Inter_FreqEventCriteria_v590ext", HFILL }},
    { &hf_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext_item,
      { "Item", "umts_rrc_ies.Intra_FreqEventCriteriaList_v590ext_item",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DeltaRSCP", HFILL }},
    { &hf_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext_item,
      { "Item", "umts_rrc_ies.IntraFrequencyMeasuredResultsList_v590ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DeltaRSCPPerCell", HFILL }},
    { &hf_umts_rrc_ies_periodicReportingInfo_1b,
      { "periodicReportingInfo-1b", "umts_rrc_ies.periodicReportingInfo_1b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PeriodicReportingInfo_1b", HFILL }},
    { &hf_umts_rrc_ies_eventID,
      { "eventID", "umts_rrc_ies.eventID",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_EventIDInterFreq_vals), 0,
        "umts_rrc_ies.EventIDInterFreq", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellList,
      { "interFreqCellList", "umts_rrc_ies.interFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellList", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellList1,
      { "interFreqCellList", "umts_rrc_ies.interFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellList_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_reportingCriteria,
      { "reportingCriteria", "umts_rrc_ies.reportingCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_reportingCriteria_vals), 0,
        "umts_rrc_ies.T_reportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingCriteria2,
      { "intraFreqReportingCriteria", "umts_rrc_ies.intraFreqReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_intraFreqReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasQuantity,
      { "intraFreqMeasQuantity", "umts_rrc_ies.intraFreqMeasQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasQuantity", HFILL }},
    { &hf_umts_rrc_ies_interFreqReportingCriteria,
      { "interFreqReportingCriteria", "umts_rrc_ies.interFreqReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_interFreqReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_filterCoefficient,
      { "filterCoefficient", "umts_rrc_ies.filterCoefficient",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_FilterCoefficient_vals), 0,
        "umts_rrc_ies.FilterCoefficient", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo55,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo55_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo55", HFILL }},
    { &hf_umts_rrc_ies_fdd69,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd64", HFILL }},
    { &hf_umts_rrc_ies_freqQualityEstimateQuantity_FDD,
      { "freqQualityEstimateQuantity-FDD", "umts_rrc_ies.freqQualityEstimateQuantity_FDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_FreqQualityEstimateQuantity_FDD_vals), 0,
        "umts_rrc_ies.FreqQualityEstimateQuantity_FDD", HFILL }},
    { &hf_umts_rrc_ies_tdd63,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd56", HFILL }},
    { &hf_umts_rrc_ies_freqQualityEstimateQuantity_TDD,
      { "freqQualityEstimateQuantity-TDD", "umts_rrc_ies.freqQualityEstimateQuantity_TDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_FreqQualityEstimateQuantity_TDD_vals), 0,
        "umts_rrc_ies.FreqQualityEstimateQuantity_TDD", HFILL }},
    { &hf_umts_rrc_ies_utra_CarrierRSSI,
      { "utra-CarrierRSSI", "umts_rrc_ies.utra_CarrierRSSI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UTRA_CarrierRSSI", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellMeasuredResultsList,
      { "interFreqCellMeasuredResultsList", "umts_rrc_ies.interFreqCellMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellMeasuredResultsList", HFILL }},
    { &hf_umts_rrc_ies_InterFreqMeasuredResultsList_item,
      { "Item", "umts_rrc_ies.InterFreqMeasuredResultsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_RSCP", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List1,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_ECN0", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List2,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List3,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List4,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_RSCP_LCR", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List5,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_ECN0_LCR", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List6,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_HCS_RSCP_LCR", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoSI_List7,
      { "interFreqCellInfoSI-List", "umts_rrc_ies.interFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoSI_List_HCS_ECN0_LCR", HFILL }},
    { &hf_umts_rrc_ies_InterFreqRACHRepCellsList_item,
      { "Item", "umts_rrc_ies.InterFreqRACHRepCellsList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo56,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo56_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo56", HFILL }},
    { &hf_umts_rrc_ies_fdd70,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd65", HFILL }},
    { &hf_umts_rrc_ies_interFreqRepQuantityRACH_FDD,
      { "interFreqRepQuantityRACH-FDD", "umts_rrc_ies.interFreqRepQuantityRACH_FDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterFreqRepQuantityRACH_FDD_vals), 0,
        "umts_rrc_ies.InterFreqRepQuantityRACH_FDD", HFILL }},
    { &hf_umts_rrc_ies_tdd64,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd57", HFILL }},
    { &hf_umts_rrc_ies_interFreqRepQuantityRACH_TDDList,
      { "interFreqRepQuantityRACH-TDDList", "umts_rrc_ies.interFreqRepQuantityRACH_TDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqRepQuantityRACH_TDDList", HFILL }},
    { &hf_umts_rrc_ies_interFreqRACHReportingThreshold,
      { "interFreqRACHReportingThreshold", "umts_rrc_ies.interFreqRACHReportingThreshold",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Threshold", HFILL }},
    { &hf_umts_rrc_ies_maxReportedCellsOnRACHinterFreq,
      { "maxReportedCellsOnRACHinterFreq", "umts_rrc_ies.maxReportedCellsOnRACHinterFreq",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MaxReportedCellsOnRACHinterFreq", HFILL }},
    { &hf_umts_rrc_ies_interFreqReportingCriteria1,
      { "interFreqReportingCriteria", "umts_rrc_ies.interFreqReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_periodicalReportingCriteria1,
      { "periodicalReportingCriteria", "umts_rrc_ies.periodicalReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PeriodicalWithReportingCellStatus", HFILL }},
    { &hf_umts_rrc_ies_noReporting,
      { "noReporting", "umts_rrc_ies.noReporting",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ReportingCellStatusOpt", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingCriteria3,
      { "intraFreqReportingCriteria", "umts_rrc_ies.intraFreqReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqReportingCriteria_r4", HFILL }},
    { &hf_umts_rrc_ies_interFreqEventList,
      { "interFreqEventList", "umts_rrc_ies.interFreqEventList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqEventList", HFILL }},
    { &hf_umts_rrc_ies_utra_Carrier_RSSI,
      { "utra-Carrier-RSSI", "umts_rrc_ies.utra_Carrier_RSSI",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_frequencyQualityEstimate,
      { "frequencyQualityEstimate", "umts_rrc_ies.frequencyQualityEstimate",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_nonFreqRelatedQuantities,
      { "nonFreqRelatedQuantities", "umts_rrc_ies.nonFreqRelatedQuantities",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellReportingQuantities", HFILL }},
    { &hf_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList_item,
      { "Item", "umts_rrc_ies.InterFreqRepQuantityRACH_TDDList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterFreqRepQuantityRACH_TDD_vals), 0,
        "umts_rrc_ies.InterFreqRepQuantityRACH_TDD", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoList,
      { "interFreqCellInfoList", "umts_rrc_ies.interFreqCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoList", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasQuantity,
      { "interFreqMeasQuantity", "umts_rrc_ies.interFreqMeasQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasQuantity", HFILL }},
    { &hf_umts_rrc_ies_interFreqReportingQuantity,
      { "interFreqReportingQuantity", "umts_rrc_ies.interFreqReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_measurementValidity,
      { "measurementValidity", "umts_rrc_ies.measurementValidity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementValidity", HFILL }},
    { &hf_umts_rrc_ies_interFreqSetUpdate,
      { "interFreqSetUpdate", "umts_rrc_ies.interFreqSetUpdate",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_AutonomousUpdateMode_vals), 0,
        "umts_rrc_ies.UE_AutonomousUpdateMode", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterFreqReportCriteria_vals), 0,
        "umts_rrc_ies.InterFreqReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellInfoList1,
      { "interFreqCellInfoList", "umts_rrc_ies.interFreqCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqCellInfoList_r4", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria1,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterFreqReportCriteria_r4_vals), 0,
        "umts_rrc_ies.InterFreqReportCriteria_r4", HFILL }},
    { &hf_umts_rrc_ies_technologySpecificInfo,
      { "technologySpecificInfo", "umts_rrc_ies.technologySpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_technologySpecificInfo_vals), 0,
        "umts_rrc_ies.T_technologySpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_gsm5,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm5", HFILL }},
    { &hf_umts_rrc_ies_bsic,
      { "bsic", "umts_rrc_ies.bsic",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.BSIC", HFILL }},
    { &hf_umts_rrc_ies_frequency_band,
      { "frequency-band", "umts_rrc_ies.frequency_band",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_Frequency_Band_vals), 0,
        "umts_rrc_ies.Frequency_Band", HFILL }},
    { &hf_umts_rrc_ies_bcch_ARFCN,
      { "bcch-ARFCN", "umts_rrc_ies.bcch_ARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BCCH_ARFCN", HFILL }},
    { &hf_umts_rrc_ies_ncMode,
      { "ncMode", "umts_rrc_ies.ncMode",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.NC_Mode", HFILL }},
    { &hf_umts_rrc_ies_is_2000,
      { "is-2000", "umts_rrc_ies.is_2000",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_removedInterRATCellList,
      { "removedInterRATCellList", "umts_rrc_ies.removedInterRATCellList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RemovedInterRATCellList_vals), 0,
        "umts_rrc_ies.RemovedInterRATCellList", HFILL }},
    { &hf_umts_rrc_ies_newInterRATCellList,
      { "newInterRATCellList", "umts_rrc_ies.newInterRATCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterRATCellList", HFILL }},
    { &hf_umts_rrc_ies_cellsForInterRATMeasList,
      { "cellsForInterRATMeasList", "umts_rrc_ies.cellsForInterRATMeasList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellsForInterRATMeasList", HFILL }},
    { &hf_umts_rrc_ies_newInterRATCellList1,
      { "newInterRATCellList", "umts_rrc_ies.newInterRATCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewInterRATCellList_B", HFILL }},
    { &hf_umts_rrc_ies_event3a,
      { "event3a", "umts_rrc_ies.event3a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event3a", HFILL }},
    { &hf_umts_rrc_ies_event3b,
      { "event3b", "umts_rrc_ies.event3b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event3b", HFILL }},
    { &hf_umts_rrc_ies_event3c,
      { "event3c", "umts_rrc_ies.event3c",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event3c", HFILL }},
    { &hf_umts_rrc_ies_event3d,
      { "event3d", "umts_rrc_ies.event3d",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event3d", HFILL }},
    { &hf_umts_rrc_ies_InterRATEventList_item,
      { "Item", "umts_rrc_ies.InterRATEventList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRATEvent_vals), 0,
        "umts_rrc_ies.InterRATEvent", HFILL }},
    { &hf_umts_rrc_ies_eventID1,
      { "eventID", "umts_rrc_ies.eventID",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_EventIDInterRAT_vals), 0,
        "umts_rrc_ies.EventIDInterRAT", HFILL }},
    { &hf_umts_rrc_ies_cellToReportList,
      { "cellToReportList", "umts_rrc_ies.cellToReportList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellToReportList", HFILL }},
    { &hf_umts_rrc_ies_rat1,
      { "rat", "umts_rrc_ies.rat",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRATInfo_vals), 0,
        "umts_rrc_ies.InterRATInfo", HFILL }},
    { &hf_umts_rrc_ies_gsm_TargetCellInfoList,
      { "gsm-TargetCellInfoList", "umts_rrc_ies.gsm_TargetCellInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GSM_TargetCellInfoList", HFILL }},
    { &hf_umts_rrc_ies_measQuantityUTRAN_QualityEstimate,
      { "measQuantityUTRAN-QualityEstimate", "umts_rrc_ies.measQuantityUTRAN_QualityEstimate",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasQuantity", HFILL }},
    { &hf_umts_rrc_ies_ratSpecificInfo,
      { "ratSpecificInfo", "umts_rrc_ies.ratSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ratSpecificInfo_vals), 0,
        "umts_rrc_ies.T_ratSpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_gsm6,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm6", HFILL }},
    { &hf_umts_rrc_ies_measurementQuantity,
      { "measurementQuantity", "umts_rrc_ies.measurementQuantity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasurementQuantityGSM_vals), 0,
        "umts_rrc_ies.MeasurementQuantityGSM", HFILL }},
    { &hf_umts_rrc_ies_bsic_VerificationRequired,
      { "bsic-VerificationRequired", "umts_rrc_ies.bsic_VerificationRequired",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_BSIC_VerificationRequired_vals), 0,
        "umts_rrc_ies.BSIC_VerificationRequired", HFILL }},
    { &hf_umts_rrc_ies_is_20001,
      { "is-2000", "umts_rrc_ies.is_2000",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_is_2000", HFILL }},
    { &hf_umts_rrc_ies_tadd_EcIo,
      { "tadd-EcIo", "umts_rrc_ies.tadd_EcIo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_tcomp_EcIo,
      { "tcomp-EcIo", "umts_rrc_ies.tcomp_EcIo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_softSlope,
      { "softSlope", "umts_rrc_ies.softSlope",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_addIntercept,
      { "addIntercept", "umts_rrc_ies.addIntercept",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_gsm7,
      { "gsm", "umts_rrc_ies.gsm",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GSM_MeasuredResultsList", HFILL }},
    { &hf_umts_rrc_ies_InterRATMeasuredResultsList_item,
      { "Item", "umts_rrc_ies.InterRATMeasuredResultsList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRATMeasuredResults_vals), 0,
        "umts_rrc_ies.InterRATMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_interRATCellInfoList,
      { "interRATCellInfoList", "umts_rrc_ies.interRATCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATCellInfoList", HFILL }},
    { &hf_umts_rrc_ies_interRATMeasQuantity,
      { "interRATMeasQuantity", "umts_rrc_ies.interRATMeasQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATMeasQuantity", HFILL }},
    { &hf_umts_rrc_ies_interRATReportingQuantity,
      { "interRATReportingQuantity", "umts_rrc_ies.interRATReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria2,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRATReportCriteria_vals), 0,
        "umts_rrc_ies.InterRATReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_interRATCellInfoList1,
      { "interRATCellInfoList", "umts_rrc_ies.interRATCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATCellInfoList_r4", HFILL }},
    { &hf_umts_rrc_ies_interRATCellInfoList2,
      { "interRATCellInfoList", "umts_rrc_ies.interRATCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATCellInfoList_B", HFILL }},
    { &hf_umts_rrc_ies_interRATReportingCriteria,
      { "interRATReportingCriteria", "umts_rrc_ies.interRATReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_interRATEventList,
      { "interRATEventList", "umts_rrc_ies.interRATEventList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterRATEventList", HFILL }},
    { &hf_umts_rrc_ies_utran_EstimatedQuality,
      { "utran-EstimatedQuality", "umts_rrc_ies.utran_EstimatedQuality",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ratSpecificInfo1,
      { "ratSpecificInfo", "umts_rrc_ies.ratSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ratSpecificInfo1_vals), 0,
        "umts_rrc_ies.T_ratSpecificInfo1", HFILL }},
    { &hf_umts_rrc_ies_gsm8,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm7", HFILL }},
    { &hf_umts_rrc_ies_dummy2_BOOLEAN,
      { "dummy2-BOOLEAN", "umts_rrc_ies.dummy2_BOOLEAN",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_gsm_Carrier_RSSI,
      { "gsm-Carrier-RSSI", "umts_rrc_ies.gsm_Carrier_RSSI",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_removedIntraFreqCellList,
      { "removedIntraFreqCellList", "umts_rrc_ies.removedIntraFreqCellList",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RemovedIntraFreqCellList_vals), 0,
        "umts_rrc_ies.RemovedIntraFreqCellList", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellList", HFILL }},
    { &hf_umts_rrc_ies_cellsForIntraFreqMeasList,
      { "cellsForIntraFreqMeasList", "umts_rrc_ies.cellsForIntraFreqMeasList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellsForIntraFreqMeasList", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList1,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellList_r4", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList2,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_RSCP", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList3,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_ECN0", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList4,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList5,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList6,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList7,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList8,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_newIntraFreqCellList9,
      { "newIntraFreqCellList", "umts_rrc_ies.newIntraFreqCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_e1a,
      { "e1a", "umts_rrc_ies.e1a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1a", HFILL }},
    { &hf_umts_rrc_ies_e1b,
      { "e1b", "umts_rrc_ies.e1b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1b", HFILL }},
    { &hf_umts_rrc_ies_e1c,
      { "e1c", "umts_rrc_ies.e1c",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1c", HFILL }},
    { &hf_umts_rrc_ies_e1d,
      { "e1d", "umts_rrc_ies.e1d",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_e1e,
      { "e1e", "umts_rrc_ies.e1e",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1e", HFILL }},
    { &hf_umts_rrc_ies_e1f,
      { "e1f", "umts_rrc_ies.e1f",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1f", HFILL }},
    { &hf_umts_rrc_ies_e1g,
      { "e1g", "umts_rrc_ies.e1g",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_e1h,
      { "e1h", "umts_rrc_ies.e1h",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ThresholdUsedFrequency", HFILL }},
    { &hf_umts_rrc_ies_e1i,
      { "e1i", "umts_rrc_ies.e1i",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ThresholdUsedFrequency", HFILL }},
    { &hf_umts_rrc_ies_e1a1,
      { "e1a", "umts_rrc_ies.e1a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1a_r4", HFILL }},
    { &hf_umts_rrc_ies_e1b1,
      { "e1b", "umts_rrc_ies.e1b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1b_r4", HFILL }},
    { &hf_umts_rrc_ies_e1a2,
      { "e1a", "umts_rrc_ies.e1a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1a_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_e1b2,
      { "e1b", "umts_rrc_ies.e1b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Event1b_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_useCIO,
      { "useCIO", "umts_rrc_ies.useCIO",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_event,
      { "event", "umts_rrc_ies.event",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqEvent_vals), 0,
        "umts_rrc_ies.IntraFreqEvent", HFILL }},
    { &hf_umts_rrc_ies_event1,
      { "event", "umts_rrc_ies.event",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqEvent_r4_vals), 0,
        "umts_rrc_ies.IntraFreqEvent_r4", HFILL }},
    { &hf_umts_rrc_ies_event2,
      { "event", "umts_rrc_ies.event",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqEvent_LCR_r4_vals), 0,
        "umts_rrc_ies.IntraFreqEvent_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_IntraFreqEventCriteriaList_item,
      { "Item", "umts_rrc_ies.IntraFreqEventCriteriaList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqEventCriteria", HFILL }},
    { &hf_umts_rrc_ies_IntraFreqEventCriteriaList_r4_item,
      { "Item", "umts_rrc_ies.IntraFreqEventCriteriaList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqEventCriteria_r4", HFILL }},
    { &hf_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4_item,
      { "Item", "umts_rrc_ies.IntraFreqEventCriteriaList_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqEventCriteria_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_eventID2,
      { "eventID", "umts_rrc_ies.eventID",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_EventIDIntraFreq_vals), 0,
        "umts_rrc_ies.EventIDIntraFreq", HFILL }},
    { &hf_umts_rrc_ies_cellMeasurementEventResults,
      { "cellMeasurementEventResults", "umts_rrc_ies.cellMeasurementEventResults",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CellMeasurementEventResults_vals), 0,
        "umts_rrc_ies.CellMeasurementEventResults", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo57,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo57_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo57", HFILL }},
    { &hf_umts_rrc_ies_fdd71,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd66", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasQuantity_FDD,
      { "intraFreqMeasQuantity-FDD", "umts_rrc_ies.intraFreqMeasQuantity_FDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqMeasQuantity_FDD_vals), 0,
        "umts_rrc_ies.IntraFreqMeasQuantity_FDD", HFILL }},
    { &hf_umts_rrc_ies_tdd65,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd58", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasQuantity_TDDList,
      { "intraFreqMeasQuantity-TDDList", "umts_rrc_ies.intraFreqMeasQuantity_TDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasQuantity_TDDList", HFILL }},
    { &hf_umts_rrc_ies_IntraFreqMeasQuantity_TDDList_item,
      { "Item", "umts_rrc_ies.IntraFreqMeasQuantity_TDDList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqMeasQuantity_TDD_vals), 0,
        "umts_rrc_ies.IntraFreqMeasQuantity_TDD", HFILL }},
    { &hf_umts_rrc_ies_IntraFreqMeasuredResultsList_item,
      { "Item", "umts_rrc_ies.IntraFreqMeasuredResultsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementID,
      { "intraFreqMeasurementID", "umts_rrc_ies.intraFreqMeasurementID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MeasurementIdentity", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_RSCP", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingQuantityForRACH,
      { "intraFreqReportingQuantityForRACH", "umts_rrc_ies.intraFreqReportingQuantityForRACH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqReportingQuantityForRACH", HFILL }},
    { &hf_umts_rrc_ies_maxReportedCellsOnRACH,
      { "maxReportedCellsOnRACH", "umts_rrc_ies.maxReportedCellsOnRACH",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxReportedCellsOnRACH_vals), 0,
        "umts_rrc_ies.MaxReportedCellsOnRACH", HFILL }},
    { &hf_umts_rrc_ies_reportingInfoForCellDCH,
      { "reportingInfoForCellDCH", "umts_rrc_ies.reportingInfoForCellDCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ReportingInfoForCellDCH", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List1,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_ECN0", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List2,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List3,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List4,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_reportingInfoForCellDCH1,
      { "reportingInfoForCellDCH", "umts_rrc_ies.reportingInfoForCellDCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ReportingInfoForCellDCH_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List5,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List6,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoSI_List7,
      { "intraFreqCellInfoSI-List", "umts_rrc_ies.intraFreqCellInfoSI_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_eventCriteriaList,
      { "eventCriteriaList", "umts_rrc_ies.eventCriteriaList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqEventCriteriaList", HFILL }},
    { &hf_umts_rrc_ies_eventCriteriaList1,
      { "eventCriteriaList", "umts_rrc_ies.eventCriteriaList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqEventCriteriaList_r4", HFILL }},
    { &hf_umts_rrc_ies_eventCriteriaList2,
      { "eventCriteriaList", "umts_rrc_ies.eventCriteriaList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqEventCriteriaList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_activeSetReportingQuantities,
      { "activeSetReportingQuantities", "umts_rrc_ies.activeSetReportingQuantities",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellReportingQuantities", HFILL }},
    { &hf_umts_rrc_ies_monitoredSetReportingQuantities,
      { "monitoredSetReportingQuantities", "umts_rrc_ies.monitoredSetReportingQuantities",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellReportingQuantities", HFILL }},
    { &hf_umts_rrc_ies_detectedSetReportingQuantities,
      { "detectedSetReportingQuantities", "umts_rrc_ies.detectedSetReportingQuantities",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellReportingQuantities", HFILL }},
    { &hf_umts_rrc_ies_sfn_SFN_OTD_Type,
      { "sfn-SFN-OTD-Type", "umts_rrc_ies.sfn_SFN_OTD_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_SFN_OTD_Type_vals), 0,
        "umts_rrc_ies.SFN_SFN_OTD_Type", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo58,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo58_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo58", HFILL }},
    { &hf_umts_rrc_ies_fdd72,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd67", HFILL }},
    { &hf_umts_rrc_ies_intraFreqRepQuantityRACH_FDD,
      { "intraFreqRepQuantityRACH-FDD", "umts_rrc_ies.intraFreqRepQuantityRACH_FDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqRepQuantityRACH_FDD_vals), 0,
        "umts_rrc_ies.IntraFreqRepQuantityRACH_FDD", HFILL }},
    { &hf_umts_rrc_ies_tdd66,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd59", HFILL }},
    { &hf_umts_rrc_ies_intraFreqRepQuantityRACH_TDDList,
      { "intraFreqRepQuantityRACH-TDDList", "umts_rrc_ies.intraFreqRepQuantityRACH_TDDList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqRepQuantityRACH_TDDList", HFILL }},
    { &hf_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList_item,
      { "Item", "umts_rrc_ies.IntraFreqRepQuantityRACH_TDDList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqRepQuantityRACH_TDD_vals), 0,
        "umts_rrc_ies.IntraFreqRepQuantityRACH_TDD", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoList,
      { "intraFreqCellInfoList", "umts_rrc_ies.intraFreqCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoList", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingQuantity,
      { "intraFreqReportingQuantity", "umts_rrc_ies.intraFreqReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria3,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqReportCriteria_vals), 0,
        "umts_rrc_ies.IntraFreqReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellInfoList1,
      { "intraFreqCellInfoList", "umts_rrc_ies.intraFreqCellInfoList",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqCellInfoList_r4", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria4,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IntraFreqReportCriteria_r4_vals), 0,
        "umts_rrc_ies.IntraFreqReportCriteria_r4", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasuredResultsList,
      { "intraFreqMeasuredResultsList", "umts_rrc_ies.intraFreqMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasuredResultsList", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasuredResultsList,
      { "interFreqMeasuredResultsList", "umts_rrc_ies.interFreqMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqMeasuredResultsList", HFILL }},
    { &hf_umts_rrc_ies_interRATMeasuredResultsList,
      { "interRATMeasuredResultsList", "umts_rrc_ies.interRATMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterRATMeasuredResultsList", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeMeasuredResultsList,
      { "trafficVolumeMeasuredResultsList", "umts_rrc_ies.trafficVolumeMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TrafficVolumeMeasuredResultsList", HFILL }},
    { &hf_umts_rrc_ies_qualityMeasuredResults,
      { "qualityMeasuredResults", "umts_rrc_ies.qualityMeasuredResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.QualityMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalMeasuredResults,
      { "ue-InternalMeasuredResults", "umts_rrc_ies.ue_InternalMeasuredResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_MeasuredResults,
      { "ue-positioning-MeasuredResults", "umts_rrc_ies.ue_positioning_MeasuredResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_MeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_MeasuredResults_v390ext,
      { "ue-positioning-MeasuredResults-v390ext", "umts_rrc_ies.ue_positioning_MeasuredResults_v390ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_MeasuredResults_v390ext", HFILL }},
    { &hf_umts_rrc_ies_intraFrequencyMeasuredResultsList,
      { "intraFrequencyMeasuredResultsList", "umts_rrc_ies.intraFrequencyMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFrequencyMeasuredResultsList_v590ext", HFILL }},
    { &hf_umts_rrc_ies_interFrequencyMeasuredResultsList,
      { "interFrequencyMeasuredResultsList", "umts_rrc_ies.interFrequencyMeasuredResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFrequencyMeasuredResultsList_v590ext", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalMeasuredResults1,
      { "ue-InternalMeasuredResults", "umts_rrc_ies.ue_InternalMeasuredResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalMeasuredResults_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_positioniing_MeasuredResults,
      { "ue-positioniing-MeasuredResults", "umts_rrc_ies.ue_positioniing_MeasuredResults",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_MeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_MeasuredResultsList_item,
      { "Item", "umts_rrc_ies.MeasuredResultsList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasuredResults_vals), 0,
        "umts_rrc_ies.MeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext_item,
      { "Item", "umts_rrc_ies.MeasuredResultsList_LCR_r4_ext_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasuredResults_LCR_r4_vals), 0,
        "umts_rrc_ies.MeasuredResults_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_currentCell,
      { "currentCell", "umts_rrc_ies.currentCell",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_currentCell", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo59,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo59_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo59", HFILL }},
    { &hf_umts_rrc_ies_fdd73,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd68", HFILL }},
    { &hf_umts_rrc_ies_measurementQuantity1,
      { "measurementQuantity", "umts_rrc_ies.measurementQuantity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_measurementQuantity_vals), 0,
        "umts_rrc_ies.T_measurementQuantity", HFILL }},
    { &hf_umts_rrc_ies_tdd67,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd60", HFILL }},
    { &hf_umts_rrc_ies_timeslotISCP,
      { "timeslotISCP", "umts_rrc_ies.timeslotISCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotISCP_List", HFILL }},
    { &hf_umts_rrc_ies_monitoredCells,
      { "monitoredCells", "umts_rrc_ies.monitoredCells",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MonitoredCellRACH_List", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellIndication_SIB11,
      { "interFreqCellIndication-SIB11", "umts_rrc_ies.interFreqCellIndication_SIB11",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellIndication_SIB12,
      { "interFreqCellIndication-SIB12", "umts_rrc_ies.interFreqCellIndication_SIB12",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1", HFILL }},
    { &hf_umts_rrc_ies_interFreqRACHRepCellsList,
      { "interFreqRACHRepCellsList", "umts_rrc_ies.interFreqRACHRepCellsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqRACHRepCellsList", HFILL }},
    { &hf_umts_rrc_ies_setup,
      { "setup", "umts_rrc_ies.setup",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasurementType_vals), 0,
        "umts_rrc_ies.MeasurementType", HFILL }},
    { &hf_umts_rrc_ies_modify1,
      { "modify", "umts_rrc_ies.modify",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_modify1", HFILL }},
    { &hf_umts_rrc_ies_measurementType,
      { "measurementType", "umts_rrc_ies.measurementType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasurementType_vals), 0,
        "umts_rrc_ies.MeasurementType", HFILL }},
    { &hf_umts_rrc_ies_setup1,
      { "setup", "umts_rrc_ies.setup",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasurementType_r4_vals), 0,
        "umts_rrc_ies.MeasurementType_r4", HFILL }},
    { &hf_umts_rrc_ies_modify2,
      { "modify", "umts_rrc_ies.modify",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_modify2", HFILL }},
    { &hf_umts_rrc_ies_measurementType1,
      { "measurementType", "umts_rrc_ies.measurementType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MeasurementType_r4_vals), 0,
        "umts_rrc_ies.MeasurementType_r4", HFILL }},
    { &hf_umts_rrc_ies_use_of_HCS,
      { "use-of-HCS", "umts_rrc_ies.use_of_HCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_use_of_HCS_vals), 0,
        "umts_rrc_ies.T_use_of_HCS", HFILL }},
    { &hf_umts_rrc_ies_hcs_not_used,
      { "hcs-not-used", "umts_rrc_ies.hcs_not_used",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcs_not_used", HFILL }},
    { &hf_umts_rrc_ies_cellSelectQualityMeasure1,
      { "cellSelectQualityMeasure", "umts_rrc_ies.cellSelectQualityMeasure",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cellSelectQualityMeasure1_vals), 0,
        "umts_rrc_ies.T_cellSelectQualityMeasure1", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP2,
      { "cpich-RSCP", "umts_rrc_ies.cpich_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_RSCP", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_RSCP", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_RSCP", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N02,
      { "cpich-Ec-N0", "umts_rrc_ies.cpich_Ec_N0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_Ec_N01", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo1,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_ECN0", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo1,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_ECN0", HFILL }},
    { &hf_umts_rrc_ies_interRATMeasurementSysInfo,
      { "interRATMeasurementSysInfo", "umts_rrc_ies.interRATMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATMeasurementSysInfo_B", HFILL }},
    { &hf_umts_rrc_ies_hcs_used,
      { "hcs-used", "umts_rrc_ies.hcs_used",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcs_used", HFILL }},
    { &hf_umts_rrc_ies_cellSelectQualityMeasure2,
      { "cellSelectQualityMeasure", "umts_rrc_ies.cellSelectQualityMeasure",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cellSelectQualityMeasure2_vals), 0,
        "umts_rrc_ies.T_cellSelectQualityMeasure2", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP3,
      { "cpich-RSCP", "umts_rrc_ies.cpich_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_RSCP1", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo2,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo2,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N03,
      { "cpich-Ec-N0", "umts_rrc_ies.cpich_Ec_N0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_Ec_N02", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo3,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo3,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_interRATMeasurementSysInfo1,
      { "interRATMeasurementSysInfo", "umts_rrc_ies.interRATMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATMeasurementSysInfo", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeMeasSysInfo,
      { "trafficVolumeMeasSysInfo", "umts_rrc_ies.trafficVolumeMeasSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeMeasSysInfo", HFILL }},
    { &hf_umts_rrc_ies_dummy_UE_InternalMeasurementSysInfo,
      { "dummy-UE-InternalMeasurementSysInfo", "umts_rrc_ies.dummy_UE_InternalMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalMeasurementSysInfo", HFILL }},
    { &hf_umts_rrc_ies_use_of_HCS1,
      { "use-of-HCS", "umts_rrc_ies.use_of_HCS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_use_of_HCS1_vals), 0,
        "umts_rrc_ies.T_use_of_HCS1", HFILL }},
    { &hf_umts_rrc_ies_hcs_not_used1,
      { "hcs-not-used", "umts_rrc_ies.hcs_not_used",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcs_not_used1", HFILL }},
    { &hf_umts_rrc_ies_cellSelectQualityMeasure3,
      { "cellSelectQualityMeasure", "umts_rrc_ies.cellSelectQualityMeasure",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cellSelectQualityMeasure3_vals), 0,
        "umts_rrc_ies.T_cellSelectQualityMeasure3", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP4,
      { "cpich-RSCP", "umts_rrc_ies.cpich_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_RSCP2", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo4,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo4,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N04,
      { "cpich-Ec-N0", "umts_rrc_ies.cpich_Ec_N0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_Ec_N03", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo5,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo5,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_hcs_used1,
      { "hcs-used", "umts_rrc_ies.hcs_used",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcs_used1", HFILL }},
    { &hf_umts_rrc_ies_cellSelectQualityMeasure4,
      { "cellSelectQualityMeasure", "umts_rrc_ies.cellSelectQualityMeasure",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_cellSelectQualityMeasure4_vals), 0,
        "umts_rrc_ies.T_cellSelectQualityMeasure4", HFILL }},
    { &hf_umts_rrc_ies_cpich_RSCP5,
      { "cpich-RSCP", "umts_rrc_ies.cpich_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_RSCP3", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo6,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo6,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cpich_Ec_N05,
      { "cpich-Ec-N0", "umts_rrc_ies.cpich_Ec_N0",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cpich_Ec_N04", HFILL }},
    { &hf_umts_rrc_ies_intraFreqMeasurementSysInfo7,
      { "intraFreqMeasurementSysInfo", "umts_rrc_ies.intraFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_interFreqMeasurementSysInfo7,
      { "interFreqMeasurementSysInfo", "umts_rrc_ies.interFreqMeasurementSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_measurementReportTransferMode,
      { "measurementReportTransferMode", "umts_rrc_ies.measurementReportTransferMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransferMode_vals), 0,
        "umts_rrc_ies.TransferMode", HFILL }},
    { &hf_umts_rrc_ies_periodicalOrEventTrigger,
      { "periodicalOrEventTrigger", "umts_rrc_ies.periodicalOrEventTrigger",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PeriodicalOrEventTrigger_vals), 0,
        "umts_rrc_ies.PeriodicalOrEventTrigger", HFILL }},
    { &hf_umts_rrc_ies_intraFrequencyMeasurement,
      { "intraFrequencyMeasurement", "umts_rrc_ies.intraFrequencyMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFrequencyMeasurement", HFILL }},
    { &hf_umts_rrc_ies_interFrequencyMeasurement,
      { "interFrequencyMeasurement", "umts_rrc_ies.interFrequencyMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFrequencyMeasurement", HFILL }},
    { &hf_umts_rrc_ies_interRATMeasurement,
      { "interRATMeasurement", "umts_rrc_ies.interRATMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATMeasurement", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_Measurement,
      { "ue-positioning-Measurement", "umts_rrc_ies.ue_positioning_Measurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Measurement", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeMeasurement,
      { "trafficVolumeMeasurement", "umts_rrc_ies.trafficVolumeMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeMeasurement", HFILL }},
    { &hf_umts_rrc_ies_qualityMeasurement,
      { "qualityMeasurement", "umts_rrc_ies.qualityMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.QualityMeasurement", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalMeasurement,
      { "ue-InternalMeasurement", "umts_rrc_ies.ue_InternalMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalMeasurement", HFILL }},
    { &hf_umts_rrc_ies_intraFrequencyMeasurement1,
      { "intraFrequencyMeasurement", "umts_rrc_ies.intraFrequencyMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFrequencyMeasurement_r4", HFILL }},
    { &hf_umts_rrc_ies_interFrequencyMeasurement1,
      { "interFrequencyMeasurement", "umts_rrc_ies.interFrequencyMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFrequencyMeasurement_r4", HFILL }},
    { &hf_umts_rrc_ies_interRATMeasurement1,
      { "interRATMeasurement", "umts_rrc_ies.interRATMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterRATMeasurement_r4", HFILL }},
    { &hf_umts_rrc_ies_up_Measurement,
      { "up-Measurement", "umts_rrc_ies.up_Measurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Measurement_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalMeasurement1,
      { "ue-InternalMeasurement", "umts_rrc_ies.ue_InternalMeasurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalMeasurement_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_State,
      { "ue-State", "umts_rrc_ies.ue_State",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_ue_State_vals), 0,
        "umts_rrc_ies.T_ue_State", HFILL }},
    { &hf_umts_rrc_ies_MonitoredCellRACH_List_item,
      { "Item", "umts_rrc_ies.MonitoredCellRACH_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MonitoredCellRACH_Result", HFILL }},
    { &hf_umts_rrc_ies_sfn_SFN_ObsTimeDifference,
      { "sfn-SFN-ObsTimeDifference", "umts_rrc_ies.sfn_SFN_ObsTimeDifference",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_SFN_ObsTimeDifference_vals), 0,
        "umts_rrc_ies.SFN_SFN_ObsTimeDifference", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo60,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo60_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo60", HFILL }},
    { &hf_umts_rrc_ies_fdd74,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd69", HFILL }},
    { &hf_umts_rrc_ies_measurementQuantity2,
      { "measurementQuantity", "umts_rrc_ies.measurementQuantity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_measurementQuantity1_vals), 0,
        "umts_rrc_ies.T_measurementQuantity1", HFILL }},
    { &hf_umts_rrc_ies_tdd68,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd61", HFILL }},
    { &hf_umts_rrc_ies_n_CR,
      { "n-CR", "umts_rrc_ies.n_CR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_16", HFILL }},
    { &hf_umts_rrc_ies_t_CRMaxHyst,
      { "t-CRMaxHyst", "umts_rrc_ies.t_CRMaxHyst",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_CRMaxHyst_vals), 0,
        "umts_rrc_ies.T_CRMaxHyst", HFILL }},
    { &hf_umts_rrc_ies_satelliteStatus,
      { "satelliteStatus", "umts_rrc_ies.satelliteStatus",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SatelliteStatus_vals), 0,
        "umts_rrc_ies.SatelliteStatus", HFILL }},
    { &hf_umts_rrc_ies_ephemerisParameter,
      { "ephemerisParameter", "umts_rrc_ies.ephemerisParameter",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EphemerisParameter", HFILL }},
    { &hf_umts_rrc_ies_NavigationModelSatInfoList_item,
      { "Item", "umts_rrc_ies.NavigationModelSatInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NavigationModelSatInfo", HFILL }},
    { &hf_umts_rrc_ies_codeOnL2,
      { "codeOnL2", "umts_rrc_ies.codeOnL2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_2", HFILL }},
    { &hf_umts_rrc_ies_uraIndex,
      { "uraIndex", "umts_rrc_ies.uraIndex",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_4", HFILL }},
    { &hf_umts_rrc_ies_satHealth1,
      { "satHealth", "umts_rrc_ies.satHealth",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_6", HFILL }},
    { &hf_umts_rrc_ies_iodc,
      { "iodc", "umts_rrc_ies.iodc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_10", HFILL }},
    { &hf_umts_rrc_ies_l2Pflag,
      { "l2Pflag", "umts_rrc_ies.l2Pflag",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1", HFILL }},
    { &hf_umts_rrc_ies_sf1Revd,
      { "sf1Revd", "umts_rrc_ies.sf1Revd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SubFrame1Reserved", HFILL }},
    { &hf_umts_rrc_ies_t_GD,
      { "t-GD", "umts_rrc_ies.t_GD",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_t_oc,
      { "t-oc", "umts_rrc_ies.t_oc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_af2,
      { "af2", "umts_rrc_ies.af2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_af11,
      { "af1", "umts_rrc_ies.af1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_af01,
      { "af0", "umts_rrc_ies.af0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_22", HFILL }},
    { &hf_umts_rrc_ies_c_rs,
      { "c-rs", "umts_rrc_ies.c_rs",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_delta_n,
      { "delta-n", "umts_rrc_ies.delta_n",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_m01,
      { "m0", "umts_rrc_ies.m0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_c_uc,
      { "c-uc", "umts_rrc_ies.c_uc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_e1,
      { "e", "umts_rrc_ies.e",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_c_us,
      { "c-us", "umts_rrc_ies.c_us",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_a_Sqrt1,
      { "a-Sqrt", "umts_rrc_ies.a_Sqrt",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_t_oe,
      { "t-oe", "umts_rrc_ies.t_oe",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_fitInterval,
      { "fitInterval", "umts_rrc_ies.fitInterval",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1", HFILL }},
    { &hf_umts_rrc_ies_aodo,
      { "aodo", "umts_rrc_ies.aodo",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_5", HFILL }},
    { &hf_umts_rrc_ies_c_ic,
      { "c-ic", "umts_rrc_ies.c_ic",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_omega01,
      { "omega0", "umts_rrc_ies.omega0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_c_is,
      { "c-is", "umts_rrc_ies.c_is",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_i0,
      { "i0", "umts_rrc_ies.i0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_c_rc,
      { "c-rc", "umts_rrc_ies.c_rc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_omega1,
      { "omega", "umts_rrc_ies.omega",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_omegaDot1,
      { "omegaDot", "umts_rrc_ies.omegaDot",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_iDot,
      { "iDot", "umts_rrc_ies.iDot",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_14", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo61,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo61_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo61", HFILL }},
    { &hf_umts_rrc_ies_fdd75,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd70", HFILL }},
    { &hf_umts_rrc_ies_neighbourIdentity,
      { "neighbourIdentity", "umts_rrc_ies.neighbourIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_uE_RX_TX_TimeDifferenceType2Info,
      { "uE-RX-TX-TimeDifferenceType2Info", "umts_rrc_ies.uE_RX_TX_TimeDifferenceType2Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_TimeDifferenceType2Info", HFILL }},
    { &hf_umts_rrc_ies_tdd69,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd62", HFILL }},
    { &hf_umts_rrc_ies_neighbourAndChannelIdentity,
      { "neighbourAndChannelIdentity", "umts_rrc_ies.neighbourAndChannelIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellAndChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_neighbourQuality,
      { "neighbourQuality", "umts_rrc_ies.neighbourQuality",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NeighbourQuality", HFILL }},
    { &hf_umts_rrc_ies_sfn_SFN_ObsTimeDifference2,
      { "sfn-SFN-ObsTimeDifference2", "umts_rrc_ies.sfn_SFN_ObsTimeDifference2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SFN_SFN_ObsTimeDifference2", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo62,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo62_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo62", HFILL }},
    { &hf_umts_rrc_ies_fdd76,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd71", HFILL }},
    { &hf_umts_rrc_ies_NeighbourList_item,
      { "Item", "umts_rrc_ies.NeighbourList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Neighbour", HFILL }},
    { &hf_umts_rrc_ies_NeighbourList_v390ext_item,
      { "Item", "umts_rrc_ies.NeighbourList_v390ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Neighbour_v390ext", HFILL }},
    { &hf_umts_rrc_ies_ue_Positioning_OTDOA_Quality,
      { "ue-Positioning-OTDOA-Quality", "umts_rrc_ies.ue_Positioning_OTDOA_Quality",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_Quality", HFILL }},
    { &hf_umts_rrc_ies_interFreqCellID,
      { "interFreqCellID", "umts_rrc_ies.interFreqCellID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_cellInfo,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfo", HFILL }},
    { &hf_umts_rrc_ies_cellInfo1,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellList_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCell", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellList_r4_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCell_r4", HFILL }},
    { &hf_umts_rrc_ies_cellInfo2,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_RSCP", HFILL }},
    { &hf_umts_rrc_ies_cellInfo3,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_ECN0", HFILL }},
    { &hf_umts_rrc_ies_cellInfo4,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_cellInfo5,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_cellInfo6,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cellInfo7,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cellInfo8,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cellInfo9,
      { "cellInfo", "umts_rrc_ies.cellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellInfoSI_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_ECN0_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_ECN0", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_HCS_RSCP_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_HCS_ECN0_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_RSCP_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_RSCP", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_ECN0_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_HCS_RSCP_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_HCS_ECN0_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewInterFreqCellSI_List_RSCP_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterFreqCellSI_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_interRATCellID,
      { "interRATCellID", "umts_rrc_ies.interRATCellID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterRATCellID", HFILL }},
    { &hf_umts_rrc_ies_technologySpecificInfo1,
      { "technologySpecificInfo", "umts_rrc_ies.technologySpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_technologySpecificInfo1_vals), 0,
        "umts_rrc_ies.T_technologySpecificInfo1", HFILL }},
    { &hf_umts_rrc_ies_gsm9,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm8", HFILL }},
    { &hf_umts_rrc_ies_cellSelectionReselectionInfo4,
      { "cellSelectionReselectionInfo", "umts_rrc_ies.cellSelectionReselectionInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoSIB_11_12", HFILL }},
    { &hf_umts_rrc_ies_interRATCellIndividualOffset,
      { "interRATCellIndividualOffset", "umts_rrc_ies.interRATCellIndividualOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterRATCellIndividualOffset", HFILL }},
    { &hf_umts_rrc_ies_is_20002,
      { "is-2000", "umts_rrc_ies.is_2000",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_is_20001", HFILL }},
    { &hf_umts_rrc_ies_is_2000SpecificMeasInfo,
      { "is-2000SpecificMeasInfo", "umts_rrc_ies.is_2000SpecificMeasInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IS_2000SpecificMeasInfo_vals), 0,
        "umts_rrc_ies.IS_2000SpecificMeasInfo", HFILL }},
    { &hf_umts_rrc_ies_absent,
      { "absent", "umts_rrc_ies.absent",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_technologySpecificInfo2,
      { "technologySpecificInfo", "umts_rrc_ies.technologySpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_technologySpecificInfo2_vals), 0,
        "umts_rrc_ies.T_technologySpecificInfo2", HFILL }},
    { &hf_umts_rrc_ies_gsm10,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm9", HFILL }},
    { &hf_umts_rrc_ies_is_20003,
      { "is-2000", "umts_rrc_ies.is_2000",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_is_20002", HFILL }},
    { &hf_umts_rrc_ies_NewInterRATCellList_item,
      { "Item", "umts_rrc_ies.NewInterRATCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterRATCell", HFILL }},
    { &hf_umts_rrc_ies_NewInterRATCellList_B_item,
      { "Item", "umts_rrc_ies.NewInterRATCellList_B_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewInterRATCell_B", HFILL }},
    { &hf_umts_rrc_ies_intraFreqCellID,
      { "intraFreqCellID", "umts_rrc_ies.intraFreqCellID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellList_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCell", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellList_r4_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCell_r4", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_RSCP_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_RSCP", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_ECN0_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_ECN0", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_RSCP_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_HCS_RSCP", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_ECN0_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_HCS_ECN0", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_RSCP_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_ECN0_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_HCS_RSCP_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4_item,
      { "Item", "umts_rrc_ies.NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NewIntraFreqCellSI_HCS_ECN0_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_nonUsedFreqThreshold,
      { "nonUsedFreqThreshold", "umts_rrc_ies.nonUsedFreqThreshold",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Threshold", HFILL }},
    { &hf_umts_rrc_ies_nonUsedFreqW,
      { "nonUsedFreqW", "umts_rrc_ies.nonUsedFreqW",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.W", HFILL }},
    { &hf_umts_rrc_ies_NonUsedFreqParameterList_item,
      { "Item", "umts_rrc_ies.NonUsedFreqParameterList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NonUsedFreqParameter", HFILL }},
    { &hf_umts_rrc_ies_notUsed,
      { "notUsed", "umts_rrc_ies.notUsed",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_pt10,
      { "pt10", "umts_rrc_ies.pt10",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_pt20,
      { "pt20", "umts_rrc_ies.pt20",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_pt30,
      { "pt30", "umts_rrc_ies.pt30",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_pt40,
      { "pt40", "umts_rrc_ies.pt40",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_pt50,
      { "pt50", "umts_rrc_ies.pt50",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_pt60,
      { "pt60", "umts_rrc_ies.pt60",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_pt101,
      { "pt10", "umts_rrc_ies.pt10",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TemporaryOffsetList", HFILL }},
    { &hf_umts_rrc_ies_pt201,
      { "pt20", "umts_rrc_ies.pt20",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TemporaryOffsetList", HFILL }},
    { &hf_umts_rrc_ies_pt301,
      { "pt30", "umts_rrc_ies.pt30",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TemporaryOffsetList", HFILL }},
    { &hf_umts_rrc_ies_pt401,
      { "pt40", "umts_rrc_ies.pt40",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TemporaryOffsetList", HFILL }},
    { &hf_umts_rrc_ies_pt501,
      { "pt50", "umts_rrc_ies.pt50",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TemporaryOffsetList", HFILL }},
    { &hf_umts_rrc_ies_pt601,
      { "pt60", "umts_rrc_ies.pt60",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TemporaryOffsetList", HFILL }},
    { &hf_umts_rrc_ies_reportingInterval1,
      { "reportingInterval", "umts_rrc_ies.reportingInterval",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReportingIntervalLong_vals), 0,
        "umts_rrc_ies.ReportingIntervalLong", HFILL }},
    { &hf_umts_rrc_ies_plmnsOfIntraFreqCellsList,
      { "plmnsOfIntraFreqCellsList", "umts_rrc_ies.plmnsOfIntraFreqCellsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PLMNsOfIntraFreqCellsList", HFILL }},
    { &hf_umts_rrc_ies_plmnsOfInterFreqCellsList,
      { "plmnsOfInterFreqCellsList", "umts_rrc_ies.plmnsOfInterFreqCellsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PLMNsOfInterFreqCellsList", HFILL }},
    { &hf_umts_rrc_ies_plmnsOfInterRATCellsList,
      { "plmnsOfInterRATCellsList", "umts_rrc_ies.plmnsOfInterRATCellsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PLMNsOfInterRATCellsList", HFILL }},
    { &hf_umts_rrc_ies_PLMNsOfInterFreqCellsList_item,
      { "Item", "umts_rrc_ies.PLMNsOfInterFreqCellsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMNsOfInterFreqCellsList_item", HFILL }},
    { &hf_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item,
      { "Item", "umts_rrc_ies.PLMNsOfIntraFreqCellsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMNsOfIntraFreqCellsList_item", HFILL }},
    { &hf_umts_rrc_ies_PLMNsOfInterRATCellsList_item,
      { "Item", "umts_rrc_ies.PLMNsOfInterRATCellsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMNsOfInterRATCellsList_item", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPoint,
      { "ellipsoidPoint", "umts_rrc_ies.ellipsoidPoint",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPoint", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPointUncertCircle,
      { "ellipsoidPointUncertCircle", "umts_rrc_ies.ellipsoidPointUncertCircle",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPointUncertCircle", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPointUncertEllipse,
      { "ellipsoidPointUncertEllipse", "umts_rrc_ies.ellipsoidPointUncertEllipse",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPointUncertEllipse", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPointAltitude,
      { "ellipsoidPointAltitude", "umts_rrc_ies.ellipsoidPointAltitude",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPointAltitude", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPointAltitudeEllipse,
      { "ellipsoidPointAltitudeEllipse", "umts_rrc_ies.ellipsoidPointAltitudeEllipse",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPointAltitudeEllipsoide", HFILL }},
    { &hf_umts_rrc_ies_QualityEventResults_item,
      { "Item", "umts_rrc_ies.QualityEventResults_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransportChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_blerMeasurementResultsList,
      { "blerMeasurementResultsList", "umts_rrc_ies.blerMeasurementResultsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BLER_MeasurementResultsList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo63,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo63_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo63", HFILL }},
    { &hf_umts_rrc_ies_tdd70,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd63", HFILL }},
    { &hf_umts_rrc_ies_sir_MeasurementResults,
      { "sir-MeasurementResults", "umts_rrc_ies.sir_MeasurementResults",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIR_MeasurementList", HFILL }},
    { &hf_umts_rrc_ies_qualityReportingQuantity,
      { "qualityReportingQuantity", "umts_rrc_ies.qualityReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.QualityReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria5,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_QualityReportCriteria_vals), 0,
        "umts_rrc_ies.QualityReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_qualityReportingCriteria,
      { "qualityReportingCriteria", "umts_rrc_ies.qualityReportingCriteria",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.QualityReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_noReporting1,
      { "noReporting", "umts_rrc_ies.noReporting",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_QualityReportingCriteria_item,
      { "Item", "umts_rrc_ies.QualityReportingCriteria_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.QualityReportingCriteriaSingle", HFILL }},
    { &hf_umts_rrc_ies_totalCRC,
      { "totalCRC", "umts_rrc_ies.totalCRC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_512", HFILL }},
    { &hf_umts_rrc_ies_badCRC,
      { "badCRC", "umts_rrc_ies.badCRC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_512", HFILL }},
    { &hf_umts_rrc_ies_pendingAfterTrigger,
      { "pendingAfterTrigger", "umts_rrc_ies.pendingAfterTrigger",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_512", HFILL }},
    { &hf_umts_rrc_ies_dl_TransChBLER,
      { "dl-TransChBLER", "umts_rrc_ies.dl_TransChBLER",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_bler_dl_TransChIdList,
      { "bler-dl-TransChIdList", "umts_rrc_ies.bler_dl_TransChIdList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BLER_TransChIdList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo64,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo64_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo64", HFILL }},
    { &hf_umts_rrc_ies_tdd71,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd64", HFILL }},
    { &hf_umts_rrc_ies_sir_TFCS_List,
      { "sir-TFCS-List", "umts_rrc_ies.sir_TFCS_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIR_TFCS_List", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPointWithAltitude,
      { "ellipsoidPointWithAltitude", "umts_rrc_ies.ellipsoidPointWithAltitude",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPointAltitude", HFILL }},
    { &hf_umts_rrc_ies_ellipsoidPointAltitudeEllipsoide,
      { "ellipsoidPointAltitudeEllipsoide", "umts_rrc_ies.ellipsoidPointAltitudeEllipsoide",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.EllipsoidPointAltitudeEllipsoide", HFILL }},
    { &hf_umts_rrc_ies_accuracy40,
      { "accuracy40", "umts_rrc_ies.accuracy40",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_960", HFILL }},
    { &hf_umts_rrc_ies_accuracy256,
      { "accuracy256", "umts_rrc_ies.accuracy256",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_150", HFILL }},
    { &hf_umts_rrc_ies_accuracy2560,
      { "accuracy2560", "umts_rrc_ies.accuracy2560",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_removeAllInterFreqCells,
      { "removeAllInterFreqCells", "umts_rrc_ies.removeAllInterFreqCells",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_removeSomeInterFreqCells,
      { "removeSomeInterFreqCells", "umts_rrc_ies.removeSomeInterFreqCells",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_removeSomeInterFreqCells_item,
      { "Item", "umts_rrc_ies.removeSomeInterFreqCells_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_removeNoInterFreqCells,
      { "removeNoInterFreqCells", "umts_rrc_ies.removeNoInterFreqCells",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_removeAllInterRATCells,
      { "removeAllInterRATCells", "umts_rrc_ies.removeAllInterRATCells",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_removeSomeInterRATCells,
      { "removeSomeInterRATCells", "umts_rrc_ies.removeSomeInterRATCells",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID", HFILL }},
    { &hf_umts_rrc_ies_removeSomeInterRATCells_item,
      { "Item", "umts_rrc_ies.removeSomeInterRATCells_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.InterRATCellID", HFILL }},
    { &hf_umts_rrc_ies_removeNoInterRATCells,
      { "removeNoInterRATCells", "umts_rrc_ies.removeNoInterRATCells",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_removeAllIntraFreqCells,
      { "removeAllIntraFreqCells", "umts_rrc_ies.removeAllIntraFreqCells",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_removeSomeIntraFreqCells,
      { "removeSomeIntraFreqCells", "umts_rrc_ies.removeSomeIntraFreqCells",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_removeSomeIntraFreqCells_item,
      { "Item", "umts_rrc_ies.removeSomeIntraFreqCells_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.IntraFreqCellID", HFILL }},
    { &hf_umts_rrc_ies_removeNoIntraFreqCells,
      { "removeNoIntraFreqCells", "umts_rrc_ies.removeNoIntraFreqCells",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_withinActiveSet,
      { "withinActiveSet", "umts_rrc_ies.withinActiveSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_withinMonitoredSetUsedFreq,
      { "withinMonitoredSetUsedFreq", "umts_rrc_ies.withinMonitoredSetUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_withinActiveAndOrMonitoredUsedFreq,
      { "withinActiveAndOrMonitoredUsedFreq", "umts_rrc_ies.withinActiveAndOrMonitoredUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_withinDetectedSetUsedFreq,
      { "withinDetectedSetUsedFreq", "umts_rrc_ies.withinDetectedSetUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_withinMonitoredAndOrDetectedUsedFreq,
      { "withinMonitoredAndOrDetectedUsedFreq", "umts_rrc_ies.withinMonitoredAndOrDetectedUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_allActiveplusMonitoredSet,
      { "allActiveplusMonitoredSet", "umts_rrc_ies.allActiveplusMonitoredSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType3_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType3", HFILL }},
    { &hf_umts_rrc_ies_allActivePlusDetectedSet,
      { "allActivePlusDetectedSet", "umts_rrc_ies.allActivePlusDetectedSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType3_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType3", HFILL }},
    { &hf_umts_rrc_ies_allActivePlusMonitoredAndOrDetectedSet,
      { "allActivePlusMonitoredAndOrDetectedSet", "umts_rrc_ies.allActivePlusMonitoredAndOrDetectedSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType3_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType3", HFILL }},
    { &hf_umts_rrc_ies_withinVirtualActSet,
      { "withinVirtualActSet", "umts_rrc_ies.withinVirtualActSet",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_withinMonitoredSetNonUsedFreq,
      { "withinMonitoredSetNonUsedFreq", "umts_rrc_ies.withinMonitoredSetNonUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_withinMonitoredAndOrVirtualActiveSetNonUsedFreq,
      { "withinMonitoredAndOrVirtualActiveSetNonUsedFreq", "umts_rrc_ies.withinMonitoredAndOrVirtualActiveSetNonUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType1_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType1", HFILL }},
    { &hf_umts_rrc_ies_allVirtualActSetplusMonitoredSetNonUsedFreq,
      { "allVirtualActSetplusMonitoredSetNonUsedFreq", "umts_rrc_ies.allVirtualActSetplusMonitoredSetNonUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType3_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType3", HFILL }},
    { &hf_umts_rrc_ies_withinActSetOrVirtualActSet_InterRATcells,
      { "withinActSetOrVirtualActSet-InterRATcells", "umts_rrc_ies.withinActSetOrVirtualActSet_InterRATcells",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType2_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType2", HFILL }},
    { &hf_umts_rrc_ies_withinActSetAndOrMonitoredUsedFreqOrVirtualActSetAndOrMonitoredNonUsedFreq,
      { "withinActSetAndOrMonitoredUsedFreqOrVirtualActSetAndOrMonitoredNonUsedFreq", "umts_rrc_ies.withinActSetAndOrMonitoredUsedFreqOrVirtualActSetAndOrMonitoredNonUsedFreq",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MaxNumberOfReportingCellsType2_vals), 0,
        "umts_rrc_ies.MaxNumberOfReportingCellsType2", HFILL }},
    { &hf_umts_rrc_ies_measurementReportingMode,
      { "measurementReportingMode", "umts_rrc_ies.measurementReportingMode",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementReportingMode", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria6,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CellDCH_ReportCriteria_vals), 0,
        "umts_rrc_ies.CellDCH_ReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria7,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4_vals), 0,
        "umts_rrc_ies.CellDCH_ReportCriteria_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_RL_AdditionInfoList_item,
      { "Item", "umts_rrc_ies.RL_AdditionInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_rl_AdditionInfoList,
      { "rl-AdditionInfoList", "umts_rrc_ies.rl_AdditionInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RL_AdditionInfoList", HFILL }},
    { &hf_umts_rrc_ies_rL_RemovalInformationList,
      { "rL-RemovalInformationList", "umts_rrc_ies.rL_RemovalInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.RL_RemovalInformationList", HFILL }},
    { &hf_umts_rrc_ies_SatDataList_item,
      { "Item", "umts_rrc_ies.SatDataList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SatData", HFILL }},
    { &hf_umts_rrc_ies_type13,
      { "type1", "umts_rrc_ies.type1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SFN_SFN_ObsTimeDifference1", HFILL }},
    { &hf_umts_rrc_ies_type22,
      { "type2", "umts_rrc_ies.type2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SFN_SFN_ObsTimeDifference2", HFILL }},
    { &hf_umts_rrc_ies_sfn_Offset,
      { "sfn-Offset", "umts_rrc_ies.sfn_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4095", HFILL }},
    { &hf_umts_rrc_ies_sfn_sfn_Reltimedifference,
      { "sfn-sfn-Reltimedifference", "umts_rrc_ies.sfn_sfn_Reltimedifference",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_38399", HFILL }},
    { &hf_umts_rrc_ies_SIR_MeasurementList_item,
      { "Item", "umts_rrc_ies.SIR_MeasurementList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SIR_MeasurementResults", HFILL }},
    { &hf_umts_rrc_ies_sir_TimeslotList,
      { "sir-TimeslotList", "umts_rrc_ies.sir_TimeslotList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIR_TimeslotList", HFILL }},
    { &hf_umts_rrc_ies_SIR_TFCS_List_item,
      { "Item", "umts_rrc_ies.SIR_TFCS_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIR_TFCS", HFILL }},
    { &hf_umts_rrc_ies_SIR_TimeslotList_item,
      { "Item", "umts_rrc_ies.SIR_TimeslotList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIR", HFILL }},
    { &hf_umts_rrc_ies_reserved1,
      { "reserved1", "umts_rrc_ies.reserved1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_23", HFILL }},
    { &hf_umts_rrc_ies_reserved2,
      { "reserved2", "umts_rrc_ies.reserved2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_reserved3,
      { "reserved3", "umts_rrc_ies.reserved3",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_reserved4,
      { "reserved4", "umts_rrc_ies.reserved4",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_16", HFILL }},
    { &hf_umts_rrc_ies_t_ADV,
      { "t-ADV", "umts_rrc_ies.t_ADV",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_2047", HFILL }},
    { &hf_umts_rrc_ies_sfn,
      { "sfn", "umts_rrc_ies.sfn",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4095", HFILL }},
    { &hf_umts_rrc_ies_t30,
      { "t30", "umts_rrc_ies.t30",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.N_CR_T_CRMaxHyst", HFILL }},
    { &hf_umts_rrc_ies_t60,
      { "t60", "umts_rrc_ies.t60",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.N_CR_T_CRMaxHyst", HFILL }},
    { &hf_umts_rrc_ies_t120,
      { "t120", "umts_rrc_ies.t120",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.N_CR_T_CRMaxHyst", HFILL }},
    { &hf_umts_rrc_ies_t180,
      { "t180", "umts_rrc_ies.t180",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.N_CR_T_CRMaxHyst", HFILL }},
    { &hf_umts_rrc_ies_t240,
      { "t240", "umts_rrc_ies.t240",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.N_CR_T_CRMaxHyst", HFILL }},
    { &hf_umts_rrc_ies_temporaryOffset1,
      { "temporaryOffset1", "umts_rrc_ies.temporaryOffset1",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset1_vals), 0,
        "umts_rrc_ies.TemporaryOffset1", HFILL }},
    { &hf_umts_rrc_ies_temporaryOffset2,
      { "temporaryOffset2", "umts_rrc_ies.temporaryOffset2",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TemporaryOffset2_vals), 0,
        "umts_rrc_ies.TemporaryOffset2", HFILL }},
    { &hf_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList_item,
      { "Item", "umts_rrc_ies.ThreholdNonUsedFrequency_deltaList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DeltaRSCPPerCell", HFILL }},
    { &hf_umts_rrc_ies_TimeslotInfoList_item,
      { "Item", "umts_rrc_ies.TimeslotInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TimeslotInfo", HFILL }},
    { &hf_umts_rrc_ies_TimeslotInfoList_LCR_r4_item,
      { "Item", "umts_rrc_ies.TimeslotInfoList_LCR_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TimeslotInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_tdd38417,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo", HFILL }},
    { &hf_umts_rrc_ies_tdd384_item1,
      { "Item", "umts_rrc_ies.tdd384_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TimeslotInfo", HFILL }},
    { &hf_umts_rrc_ies_tdd12819,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_tdd128_item2,
      { "Item", "umts_rrc_ies.tdd128_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TimeslotInfo_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_TimeslotISCP_List_item,
      { "Item", "umts_rrc_ies.TimeslotISCP_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotISCP", HFILL }},
    { &hf_umts_rrc_ies_TimeslotListWithISCP_item,
      { "Item", "umts_rrc_ies.TimeslotListWithISCP_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TimeslotWithISCP", HFILL }},
    { &hf_umts_rrc_ies_timeslotISCP1,
      { "timeslotISCP", "umts_rrc_ies.timeslotISCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeslotISCP", HFILL }},
    { &hf_umts_rrc_ies_eventID3,
      { "eventID", "umts_rrc_ies.eventID",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TrafficVolumeEventType_vals), 0,
        "umts_rrc_ies.TrafficVolumeEventType", HFILL }},
    { &hf_umts_rrc_ies_reportingThreshold,
      { "reportingThreshold", "umts_rrc_ies.reportingThreshold",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TrafficVolumeThreshold_vals), 0,
        "umts_rrc_ies.TrafficVolumeThreshold", HFILL }},
    { &hf_umts_rrc_ies_pendingTimeAfterTrigger,
      { "pendingTimeAfterTrigger", "umts_rrc_ies.pendingTimeAfterTrigger",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PendingTimeAfterTrigger_vals), 0,
        "umts_rrc_ies.PendingTimeAfterTrigger", HFILL }},
    { &hf_umts_rrc_ies_tx_InterruptionAfterTrigger,
      { "tx-InterruptionAfterTrigger", "umts_rrc_ies.tx_InterruptionAfterTrigger",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TX_InterruptionAfterTrigger_vals), 0,
        "umts_rrc_ies.TX_InterruptionAfterTrigger", HFILL }},
    { &hf_umts_rrc_ies_ul_transportChannelCausingEvent,
      { "ul-transportChannelCausingEvent", "umts_rrc_ies.ul_transportChannelCausingEvent",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TrCH_Identity_vals), 0,
        "umts_rrc_ies.UL_TrCH_Identity", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeEventIdentity,
      { "trafficVolumeEventIdentity", "umts_rrc_ies.trafficVolumeEventIdentity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TrafficVolumeEventType_vals), 0,
        "umts_rrc_ies.TrafficVolumeEventType", HFILL }},
    { &hf_umts_rrc_ies_rlc_BufferPayload,
      { "rlc-BufferPayload", "umts_rrc_ies.rlc_BufferPayload",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_averageRLC_BufferPayload,
      { "averageRLC-BufferPayload", "umts_rrc_ies.averageRLC_BufferPayload",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeInterval", HFILL }},
    { &hf_umts_rrc_ies_varianceOfRLC_BufferPayload,
      { "varianceOfRLC-BufferPayload", "umts_rrc_ies.varianceOfRLC_BufferPayload",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TimeInterval", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeMeasurementID,
      { "trafficVolumeMeasurementID", "umts_rrc_ies.trafficVolumeMeasurementID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MeasurementIdentity", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeMeasurementObjectList,
      { "trafficVolumeMeasurementObjectList", "umts_rrc_ies.trafficVolumeMeasurementObjectList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TrafficVolumeMeasurementObjectList", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeMeasQuantity,
      { "trafficVolumeMeasQuantity", "umts_rrc_ies.trafficVolumeMeasQuantity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TrafficVolumeMeasQuantity_vals), 0,
        "umts_rrc_ies.TrafficVolumeMeasQuantity", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeReportingQuantity,
      { "trafficVolumeReportingQuantity", "umts_rrc_ies.trafficVolumeReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_dummy_TrafficVolumeReportingCriteria,
      { "dummy-TrafficVolumeReportingCriteria", "umts_rrc_ies.dummy_TrafficVolumeReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_reportCriteriaSysInf,
      { "reportCriteriaSysInf", "umts_rrc_ies.reportCriteriaSysInf",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo_vals), 0,
        "umts_rrc_ies.TrafficVolumeReportCriteriaSysInfo", HFILL }},
    { &hf_umts_rrc_ies_rlc_BuffersPayload,
      { "rlc-BuffersPayload", "umts_rrc_ies.rlc_BuffersPayload",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RLC_BuffersPayload_vals), 0,
        "umts_rrc_ies.RLC_BuffersPayload", HFILL }},
    { &hf_umts_rrc_ies_averageRLC_BufferPayload1,
      { "averageRLC-BufferPayload", "umts_rrc_ies.averageRLC_BufferPayload",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_AverageRLC_BufferPayload_vals), 0,
        "umts_rrc_ies.AverageRLC_BufferPayload", HFILL }},
    { &hf_umts_rrc_ies_varianceOfRLC_BufferPayload1,
      { "varianceOfRLC-BufferPayload", "umts_rrc_ies.varianceOfRLC_BufferPayload",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_VarianceOfRLC_BufferPayload_vals), 0,
        "umts_rrc_ies.VarianceOfRLC_BufferPayload", HFILL }},
    { &hf_umts_rrc_ies_TrafficVolumeMeasuredResultsList_item,
      { "Item", "umts_rrc_ies.TrafficVolumeMeasuredResultsList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeMeasuredResults", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria8,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TrafficVolumeReportCriteria_vals), 0,
        "umts_rrc_ies.TrafficVolumeReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_TrafficVolumeMeasurementObjectList_item,
      { "Item", "umts_rrc_ies.TrafficVolumeMeasurementObjectList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TrCH_Identity_vals), 0,
        "umts_rrc_ies.UL_TrCH_Identity", HFILL }},
    { &hf_umts_rrc_ies_trafficVolumeReportingCriteria,
      { "trafficVolumeReportingCriteria", "umts_rrc_ies.trafficVolumeReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_transChCriteriaList,
      { "transChCriteriaList", "umts_rrc_ies.transChCriteriaList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransChCriteriaList", HFILL }},
    { &hf_umts_rrc_ies_rlc_RB_BufferPayload,
      { "rlc-RB-BufferPayload", "umts_rrc_ies.rlc_RB_BufferPayload",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_rlc_RB_BufferPayloadAverage,
      { "rlc-RB-BufferPayloadAverage", "umts_rrc_ies.rlc_RB_BufferPayloadAverage",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_rlc_RB_BufferPayloadVariance,
      { "rlc-RB-BufferPayloadVariance", "umts_rrc_ies.rlc_RB_BufferPayloadVariance",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ul_transportChannelID,
      { "ul-transportChannelID", "umts_rrc_ies.ul_transportChannelID",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UL_TrCH_Identity_vals), 0,
        "umts_rrc_ies.UL_TrCH_Identity", HFILL }},
    { &hf_umts_rrc_ies_eventSpecificParameters,
      { "eventSpecificParameters", "umts_rrc_ies.eventSpecificParameters",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam", HFILL }},
    { &hf_umts_rrc_ies_eventSpecificParameters_item,
      { "Item", "umts_rrc_ies.eventSpecificParameters_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TrafficVolumeEventParam", HFILL }},
    { &hf_umts_rrc_ies_TransChCriteriaList_item,
      { "Item", "umts_rrc_ies.TransChCriteriaList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.TransChCriteria", HFILL }},
    { &hf_umts_rrc_ies_transmittedPowerThreshold,
      { "transmittedPowerThreshold", "umts_rrc_ies.transmittedPowerThreshold",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TransmittedPowerThreshold", HFILL }},
    { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceThreshold,
      { "ue-RX-TX-TimeDifferenceThreshold", "umts_rrc_ies.ue_RX_TX_TimeDifferenceThreshold",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_TimeDifferenceThreshold", HFILL }},
    { &hf_umts_rrc_ies_dummy1,
      { "dummy", "umts_rrc_ies.dummy",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_onWithNoReporting,
      { "onWithNoReporting", "umts_rrc_ies.onWithNoReporting",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_dummy2_RL_InformationLists,
      { "dummy2-RL-InformationLists", "umts_rrc_ies.dummy2_RL_InformationLists",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RL_InformationLists", HFILL }},
    { &hf_umts_rrc_ies_event6a,
      { "event6a", "umts_rrc_ies.event6a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_6AB_Event", HFILL }},
    { &hf_umts_rrc_ies_event6b,
      { "event6b", "umts_rrc_ies.event6b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_6AB_Event", HFILL }},
    { &hf_umts_rrc_ies_event6c,
      { "event6c", "umts_rrc_ies.event6c",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimeToTrigger_vals), 0,
        "umts_rrc_ies.TimeToTrigger", HFILL }},
    { &hf_umts_rrc_ies_event6d,
      { "event6d", "umts_rrc_ies.event6d",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimeToTrigger_vals), 0,
        "umts_rrc_ies.TimeToTrigger", HFILL }},
    { &hf_umts_rrc_ies_event6e,
      { "event6e", "umts_rrc_ies.event6e",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TimeToTrigger_vals), 0,
        "umts_rrc_ies.TimeToTrigger", HFILL }},
    { &hf_umts_rrc_ies_event6f,
      { "event6f", "umts_rrc_ies.event6f",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_6FG_Event", HFILL }},
    { &hf_umts_rrc_ies_event6g,
      { "event6g", "umts_rrc_ies.event6g",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_6FG_Event", HFILL }},
    { &hf_umts_rrc_ies_UE_InternalEventParamList_item,
      { "Item", "umts_rrc_ies.UE_InternalEventParamList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_InternalEventParam_vals), 0,
        "umts_rrc_ies.UE_InternalEventParam", HFILL }},
    { &hf_umts_rrc_ies_event6a1,
      { "event6a", "umts_rrc_ies.event6a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_event6b1,
      { "event6b", "umts_rrc_ies.event6b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_event6c1,
      { "event6c", "umts_rrc_ies.event6c",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_event6d1,
      { "event6d", "umts_rrc_ies.event6d",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_event6e1,
      { "event6e", "umts_rrc_ies.event6e",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_event6f1,
      { "event6f", "umts_rrc_ies.event6f",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_event6g1,
      { "event6g", "umts_rrc_ies.event6g",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_measurementQuantity3,
      { "measurementQuantity", "umts_rrc_ies.measurementQuantity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_MeasurementQuantity_vals), 0,
        "umts_rrc_ies.UE_MeasurementQuantity", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo65,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo65_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo65", HFILL }},
    { &hf_umts_rrc_ies_fdd77,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd72", HFILL }},
    { &hf_umts_rrc_ies_ue_TransmittedPowerFDD,
      { "ue-TransmittedPowerFDD", "umts_rrc_ies.ue_TransmittedPowerFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_TransmittedPower", HFILL }},
    { &hf_umts_rrc_ies_ue_RX_TX_ReportEntryList,
      { "ue-RX-TX-ReportEntryList", "umts_rrc_ies.ue_RX_TX_ReportEntryList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_ReportEntryList", HFILL }},
    { &hf_umts_rrc_ies_tdd72,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd65", HFILL }},
    { &hf_umts_rrc_ies_ue_TransmittedPowerTDD_List,
      { "ue-TransmittedPowerTDD-List", "umts_rrc_ies.ue_TransmittedPowerTDD_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_TransmittedPowerTDD_List", HFILL }},
    { &hf_umts_rrc_ies_appliedTA,
      { "appliedTA", "umts_rrc_ies.appliedTA",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_TimingAdvance", HFILL }},
    { &hf_umts_rrc_ies_t_ADVinfo,
      { "t-ADVinfo", "umts_rrc_ies.t_ADVinfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ADVinfo", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalMeasQuantity,
      { "ue-InternalMeasQuantity", "umts_rrc_ies.ue_InternalMeasQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalMeasQuantity", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalReportingQuantity,
      { "ue-InternalReportingQuantity", "umts_rrc_ies.ue_InternalReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria9,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_InternalReportCriteria_vals), 0,
        "umts_rrc_ies.UE_InternalReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalReportingQuantity1,
      { "ue-InternalReportingQuantity", "umts_rrc_ies.ue_InternalReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalReportingQuantity_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalMeasurementID,
      { "ue-InternalMeasurementID", "umts_rrc_ies.ue_InternalMeasurementID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MeasurementIdentity", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalReportingCriteria,
      { "ue-InternalReportingCriteria", "umts_rrc_ies.ue_InternalReportingCriteria",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_InternalReportingCriteria", HFILL }},
    { &hf_umts_rrc_ies_ue_InternalEventParamList,
      { "ue-InternalEventParamList", "umts_rrc_ies.ue_InternalEventParamList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_InternalEventParamList", HFILL }},
    { &hf_umts_rrc_ies_ue_TransmittedPower,
      { "ue-TransmittedPower", "umts_rrc_ies.ue_TransmittedPower",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo66,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo66_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo66", HFILL }},
    { &hf_umts_rrc_ies_fdd78,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd73", HFILL }},
    { &hf_umts_rrc_ies_ue_RX_TX_TimeDifference,
      { "ue-RX-TX-TimeDifference", "umts_rrc_ies.ue_RX_TX_TimeDifference",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_tdd73,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd66", HFILL }},
    { &hf_umts_rrc_ies_appliedTA1,
      { "appliedTA", "umts_rrc_ies.appliedTA",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo67,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo67_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo67", HFILL }},
    { &hf_umts_rrc_ies_fdd79,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd74", HFILL }},
    { &hf_umts_rrc_ies_tdd74,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd67", HFILL }},
    { &hf_umts_rrc_ies_tddOption14,
      { "tddOption", "umts_rrc_ies.tddOption",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_tddOption14_vals), 0,
        "umts_rrc_ies.T_tddOption14", HFILL }},
    { &hf_umts_rrc_ies_tdd38418,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38414", HFILL }},
    { &hf_umts_rrc_ies_tdd12820,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12816", HFILL }},
    { &hf_umts_rrc_ies_t_ADVinfo1,
      { "t-ADVinfo", "umts_rrc_ies.t_ADVinfo",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType1,
      { "ue-RX-TX-TimeDifferenceType1", "umts_rrc_ies.ue_RX_TX_TimeDifferenceType1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_TimeDifferenceType1", HFILL }},
    { &hf_umts_rrc_ies_UE_RX_TX_ReportEntryList_item,
      { "Item", "umts_rrc_ies.UE_RX_TX_ReportEntryList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_ReportEntry", HFILL }},
    { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType2,
      { "ue-RX-TX-TimeDifferenceType2", "umts_rrc_ies.ue_RX_TX_TimeDifferenceType2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_TimeDifferenceType2", HFILL }},
    { &hf_umts_rrc_ies_UE_TransmittedPowerTDD_List_item,
      { "Item", "umts_rrc_ies.UE_TransmittedPowerTDD_List_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_TransmittedPower", HFILL }},
    { &hf_umts_rrc_ies_rachorcpch,
      { "rachorcpch", "umts_rrc_ies.rachorcpch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_cipheringKeyFlag,
      { "cipheringKeyFlag", "umts_rrc_ies.cipheringKeyFlag",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1", HFILL }},
    { &hf_umts_rrc_ies_cipheringSerialNumber,
      { "cipheringSerialNumber", "umts_rrc_ies.cipheringSerialNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_65535", HFILL }},
    { &hf_umts_rrc_ies_errorReason,
      { "errorReason", "umts_rrc_ies.errorReason",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_ErrorCause_vals), 0,
        "umts_rrc_ies.UE_Positioning_ErrorCause", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_additionalAssistanceDataRequest,
      { "ue-positioning-GPS-additionalAssistanceDataRequest", "umts_rrc_ies.ue_positioning_GPS_additionalAssistanceDataRequest",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_AdditionalAssistanceDataRequest", HFILL }},
    { &hf_umts_rrc_ies_reportFirstFix,
      { "reportFirstFix", "umts_rrc_ies.reportFirstFix",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_measurementInterval,
      { "measurementInterval", "umts_rrc_ies.measurementInterval",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_MeasurementInterval_vals), 0,
        "umts_rrc_ies.UE_Positioning_MeasurementInterval", HFILL }},
    { &hf_umts_rrc_ies_eventSpecificInfo,
      { "eventSpecificInfo", "umts_rrc_ies.eventSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_EventSpecificInfo_vals), 0,
        "umts_rrc_ies.UE_Positioning_EventSpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_UE_Positioning_EventParamList_item,
      { "Item", "umts_rrc_ies.UE_Positioning_EventParamList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_EventParam", HFILL }},
    { &hf_umts_rrc_ies_e7a,
      { "e7a", "umts_rrc_ies.e7a",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ThresholdPositionChange_vals), 0,
        "umts_rrc_ies.ThresholdPositionChange", HFILL }},
    { &hf_umts_rrc_ies_e7b,
      { "e7b", "umts_rrc_ies.e7b",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ThresholdSFN_SFN_Change_vals), 0,
        "umts_rrc_ies.ThresholdSFN_SFN_Change", HFILL }},
    { &hf_umts_rrc_ies_e7c,
      { "e7c", "umts_rrc_ies.e7c",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ThresholdSFN_GPS_TOW_vals), 0,
        "umts_rrc_ies.ThresholdSFN_GPS_TOW", HFILL }},
    { &hf_umts_rrc_ies_gps_ReferenceTime,
      { "gps-ReferenceTime", "umts_rrc_ies.gps_ReferenceTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_604799999", HFILL }},
    { &hf_umts_rrc_ies_utran_GPSReferenceTime,
      { "utran-GPSReferenceTime", "umts_rrc_ies.utran_GPSReferenceTime",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UTRAN_GPSReferenceTime", HFILL }},
    { &hf_umts_rrc_ies_satelliteInformationList,
      { "satelliteInformationList", "umts_rrc_ies.satelliteInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AcquisitionSatInfoList", HFILL }},
    { &hf_umts_rrc_ies_almanacRequest,
      { "almanacRequest", "umts_rrc_ies.almanacRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_utcModelRequest,
      { "utcModelRequest", "umts_rrc_ies.utcModelRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_ionosphericModelRequest,
      { "ionosphericModelRequest", "umts_rrc_ies.ionosphericModelRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_navigationModelRequest,
      { "navigationModelRequest", "umts_rrc_ies.navigationModelRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_dgpsCorrectionsRequest,
      { "dgpsCorrectionsRequest", "umts_rrc_ies.dgpsCorrectionsRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_referenceLocationRequest,
      { "referenceLocationRequest", "umts_rrc_ies.referenceLocationRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_referenceTimeRequest,
      { "referenceTimeRequest", "umts_rrc_ies.referenceTimeRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_aquisitionAssistanceRequest,
      { "aquisitionAssistanceRequest", "umts_rrc_ies.aquisitionAssistanceRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_realTimeIntegrityRequest,
      { "realTimeIntegrityRequest", "umts_rrc_ies.realTimeIntegrityRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_navModelAddDataRequest,
      { "navModelAddDataRequest", "umts_rrc_ies.navModelAddDataRequest",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_NavModelAddDataReq", HFILL }},
    { &hf_umts_rrc_ies_wn_a,
      { "wn-a", "umts_rrc_ies.wn_a",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_almanacSatInfoList,
      { "almanacSatInfoList", "umts_rrc_ies.almanacSatInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AlmanacSatInfoList", HFILL }},
    { &hf_umts_rrc_ies_sv_GlobalHealth,
      { "sv-GlobalHealth", "umts_rrc_ies.sv_GlobalHealth",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_364", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_ReferenceTime,
      { "ue-positioning-GPS-ReferenceTime", "umts_rrc_ies.ue_positioning_GPS_ReferenceTime",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_ReferenceTime", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_ReferenceLocation,
      { "ue-positioning-GPS-ReferenceLocation", "umts_rrc_ies.ue_positioning_GPS_ReferenceLocation",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.ReferenceLocation", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_DGPS_Corrections,
      { "ue-positioning-GPS-DGPS-Corrections", "umts_rrc_ies.ue_positioning_GPS_DGPS_Corrections",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_DGPS_Corrections", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_NavigationModel,
      { "ue-positioning-GPS-NavigationModel", "umts_rrc_ies.ue_positioning_GPS_NavigationModel",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_NavigationModel", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_IonosphericModel,
      { "ue-positioning-GPS-IonosphericModel", "umts_rrc_ies.ue_positioning_GPS_IonosphericModel",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_IonosphericModel", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_UTC_Model,
      { "ue-positioning-GPS-UTC-Model", "umts_rrc_ies.ue_positioning_GPS_UTC_Model",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_UTC_Model", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_Almanac,
      { "ue-positioning-GPS-Almanac", "umts_rrc_ies.ue_positioning_GPS_Almanac",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_Almanac", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_AcquisitionAssistance,
      { "ue-positioning-GPS-AcquisitionAssistance", "umts_rrc_ies.ue_positioning_GPS_AcquisitionAssistance",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_AcquisitionAssistance", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_Real_timeIntegrity,
      { "ue-positioning-GPS-Real-timeIntegrity", "umts_rrc_ies.ue_positioning_GPS_Real_timeIntegrity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BadSatList", HFILL }},
    { &hf_umts_rrc_ies_dummy_UE_Positioning_GPS_ReferenceCellInfo,
      { "dummy-UE-Positioning-GPS-ReferenceCellInfo", "umts_rrc_ies.dummy_UE_Positioning_GPS_ReferenceCellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_ReferenceCellInfo", HFILL }},
    { &hf_umts_rrc_ies_gps_TOW,
      { "gps-TOW", "umts_rrc_ies.gps_TOW",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_604799", HFILL }},
    { &hf_umts_rrc_ies_statusHealth,
      { "statusHealth", "umts_rrc_ies.statusHealth",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DiffCorrectionStatus_vals), 0,
        "umts_rrc_ies.DiffCorrectionStatus", HFILL }},
    { &hf_umts_rrc_ies_dgps_CorrectionSatInfoList,
      { "dgps-CorrectionSatInfoList", "umts_rrc_ies.dgps_CorrectionSatInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DGPS_CorrectionSatInfoList", HFILL }},
    { &hf_umts_rrc_ies_alfa0,
      { "alfa0", "umts_rrc_ies.alfa0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_alfa1,
      { "alfa1", "umts_rrc_ies.alfa1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_alfa2,
      { "alfa2", "umts_rrc_ies.alfa2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_alfa3,
      { "alfa3", "umts_rrc_ies.alfa3",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_beta0,
      { "beta0", "umts_rrc_ies.beta0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_beta1,
      { "beta1", "umts_rrc_ies.beta1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_beta2,
      { "beta2", "umts_rrc_ies.beta2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_beta3,
      { "beta3", "umts_rrc_ies.beta3",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_referenceTime,
      { "referenceTime", "umts_rrc_ies.referenceTime",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_referenceTime_vals), 0,
        "umts_rrc_ies.T_referenceTime", HFILL }},
    { &hf_umts_rrc_ies_utran_GPSReferenceTimeResult,
      { "utran-GPSReferenceTimeResult", "umts_rrc_ies.utran_GPSReferenceTimeResult",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UTRAN_GPSReferenceTimeResult", HFILL }},
    { &hf_umts_rrc_ies_gps_ReferenceTimeOnly,
      { "gps-ReferenceTimeOnly", "umts_rrc_ies.gps_ReferenceTimeOnly",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_604799999", HFILL }},
    { &hf_umts_rrc_ies_gps_MeasurementParamList,
      { "gps-MeasurementParamList", "umts_rrc_ies.gps_MeasurementParamList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GPS_MeasurementParamList", HFILL }},
    { &hf_umts_rrc_ies_navigationModelSatInfoList,
      { "navigationModelSatInfoList", "umts_rrc_ies.navigationModelSatInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NavigationModelSatInfoList", HFILL }},
    { &hf_umts_rrc_ies_gps_Week,
      { "gps-Week", "umts_rrc_ies.gps_Week",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1023", HFILL }},
    { &hf_umts_rrc_ies_gps_Toe,
      { "gps-Toe", "umts_rrc_ies.gps_Toe",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_tToeLimit,
      { "tToeLimit", "umts_rrc_ies.tToeLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_satDataList,
      { "satDataList", "umts_rrc_ies.satDataList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SatDataList", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo68,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo68_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo68", HFILL }},
    { &hf_umts_rrc_ies_fdd80,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd75", HFILL }},
    { &hf_umts_rrc_ies_referenceIdentity,
      { "referenceIdentity", "umts_rrc_ies.referenceIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_tdd75,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd68", HFILL }},
    { &hf_umts_rrc_ies_referenceIdentity1,
      { "referenceIdentity", "umts_rrc_ies.referenceIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellParametersID", HFILL }},
    { &hf_umts_rrc_ies_gps_tow_1msec,
      { "gps-tow-1msec", "umts_rrc_ies.gps_tow_1msec",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GPS_TOW_1msec", HFILL }},
    { &hf_umts_rrc_ies_sfn_tow_Uncertainty,
      { "sfn-tow-Uncertainty", "umts_rrc_ies.sfn_tow_Uncertainty",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_TOW_Uncertainty_vals), 0,
        "umts_rrc_ies.SFN_TOW_Uncertainty", HFILL }},
    { &hf_umts_rrc_ies_utran_GPS_DriftRate,
      { "utran-GPS-DriftRate", "umts_rrc_ies.utran_GPS_DriftRate",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UTRAN_GPS_DriftRate_vals), 0,
        "umts_rrc_ies.UTRAN_GPS_DriftRate", HFILL }},
    { &hf_umts_rrc_ies_gps_TOW_AssistList,
      { "gps-TOW-AssistList", "umts_rrc_ies.gps_TOW_AssistList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GPS_TOW_AssistList", HFILL }},
    { &hf_umts_rrc_ies_a1,
      { "a1", "umts_rrc_ies.a1",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_24", HFILL }},
    { &hf_umts_rrc_ies_a0,
      { "a0", "umts_rrc_ies.a0",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_32", HFILL }},
    { &hf_umts_rrc_ies_t_ot,
      { "t-ot", "umts_rrc_ies.t_ot",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_wn_t,
      { "wn-t", "umts_rrc_ies.wn_t",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_delta_t_LS,
      { "delta-t-LS", "umts_rrc_ies.delta_t_LS",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_wn_lsf,
      { "wn-lsf", "umts_rrc_ies.wn_lsf",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_dn,
      { "dn", "umts_rrc_ies.dn",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_delta_t_LSF,
      { "delta-t-LSF", "umts_rrc_ies.delta_t_LSF",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_ip_Spacing,
      { "ip-Spacing", "umts_rrc_ies.ip_Spacing",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IP_Spacing_vals), 0,
        "umts_rrc_ies.IP_Spacing", HFILL }},
    { &hf_umts_rrc_ies_ip_Length,
      { "ip-Length", "umts_rrc_ies.ip_Length",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IP_Length_vals), 0,
        "umts_rrc_ies.IP_Length", HFILL }},
    { &hf_umts_rrc_ies_ip_Offset,
      { "ip-Offset", "umts_rrc_ies.ip_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_9", HFILL }},
    { &hf_umts_rrc_ies_seed,
      { "seed", "umts_rrc_ies.seed",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_burstModeParameters,
      { "burstModeParameters", "umts_rrc_ies.burstModeParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.BurstModeParameters", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo69,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo69_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo69", HFILL }},
    { &hf_umts_rrc_ies_fdd81,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd76", HFILL }},
    { &hf_umts_rrc_ies_tdd76,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd69", HFILL }},
    { &hf_umts_rrc_ies_ip_Spacing_TDD,
      { "ip-Spacing-TDD", "umts_rrc_ies.ip_Spacing_TDD",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IP_Spacing_TDD_vals), 0,
        "umts_rrc_ies.IP_Spacing_TDD", HFILL }},
    { &hf_umts_rrc_ies_ip_slot,
      { "ip-slot", "umts_rrc_ies.ip_slot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_14", HFILL }},
    { &hf_umts_rrc_ies_ip_Start,
      { "ip-Start", "umts_rrc_ies.ip_Start",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4095", HFILL }},
    { &hf_umts_rrc_ies_ip_PCCPCG,
      { "ip-PCCPCG", "umts_rrc_ies.ip_PCCPCG",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.IP_PCCPCH_r4", HFILL }},
    { &hf_umts_rrc_ies_ip_Spacing1,
      { "ip-Spacing", "umts_rrc_ies.ip_Spacing",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_IP_Spacing_TDD_vals), 0,
        "umts_rrc_ies.IP_Spacing_TDD", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_Measurement,
      { "ue-positioning-OTDOA-Measurement", "umts_rrc_ies.ue_positioning_OTDOA_Measurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_Measurement", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_PositionEstimateInfo,
      { "ue-positioning-PositionEstimateInfo", "umts_rrc_ies.ue_positioning_PositionEstimateInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_PositionEstimateInfo", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_Measurement,
      { "ue-positioning-GPS-Measurement", "umts_rrc_ies.ue_positioning_GPS_Measurement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_MeasurementResults", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_Error,
      { "ue-positioning-Error", "umts_rrc_ies.ue_positioning_Error",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Error", HFILL }},
    { &hf_umts_rrc_ies_ue_Positioning_OTDOA_Measurement_v390ext,
      { "ue-Positioning-OTDOA-Measurement-v390ext", "umts_rrc_ies.ue_Positioning_OTDOA_Measurement_v390ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_Measurement_v390ext", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_ReportingQuantity,
      { "ue-positioning-ReportingQuantity", "umts_rrc_ies.ue_positioning_ReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_ReportingQuantity", HFILL }},
    { &hf_umts_rrc_ies_reportCriteria10,
      { "reportCriteria", "umts_rrc_ies.reportCriteria",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_ReportCriteria_vals), 0,
        "umts_rrc_ies.UE_Positioning_ReportCriteria", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData,
      { "ue-positioning-OTDOA-AssistanceData", "umts_rrc_ies.ue_positioning_OTDOA_AssistanceData",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_AssistanceData", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_AssistanceData,
      { "ue-positioning-GPS-AssistanceData", "umts_rrc_ies.ue_positioning_GPS_AssistanceData",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_AssistanceData", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_ReportingQuantity_v390ext,
      { "ue-positioning-ReportingQuantity-v390ext", "umts_rrc_ies.ue_positioning_ReportingQuantity_v390ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_ReportingQuantity_v390ext", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData_UEB,
      { "ue-positioning-OTDOA-AssistanceData-UEB", "umts_rrc_ies.ue_positioning_OTDOA_AssistanceData_UEB",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_AssistanceData_UEB", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_ReportingQuantity1,
      { "ue-positioning-ReportingQuantity", "umts_rrc_ies.ue_positioning_ReportingQuantity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_ReportingQuantity_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_AssistanceData1,
      { "ue-positioning-OTDOA-AssistanceData", "umts_rrc_ies.ue_positioning_OTDOA_AssistanceData",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_AssistanceData_r4", HFILL }},
    { &hf_umts_rrc_ies_event7a,
      { "event7a", "umts_rrc_ies.event7a",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_PositionEstimateInfo", HFILL }},
    { &hf_umts_rrc_ies_event7b,
      { "event7b", "umts_rrc_ies.event7b",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_Measurement", HFILL }},
    { &hf_umts_rrc_ies_event7c,
      { "event7c", "umts_rrc_ies.event7c",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_GPS_MeasurementResults", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo,
      { "ue-positioning-OTDOA-ReferenceCellInfo", "umts_rrc_ies.ue_positioning_OTDOA_ReferenceCellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_ReferenceCellInfo", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList,
      { "ue-positioning-OTDOA-NeighbourCellList", "umts_rrc_ies.ue_positioning_OTDOA_NeighbourCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellList", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo1,
      { "ue-positioning-OTDOA-ReferenceCellInfo", "umts_rrc_ies.ue_positioning_OTDOA_ReferenceCellInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_ReferenceCellInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList1,
      { "ue-positioning-OTDOA-NeighbourCellList", "umts_rrc_ies.ue_positioning_OTDOA_NeighbourCellList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellList_r4", HFILL }},
    { &hf_umts_rrc_ies_ue_Positioning_IPDL_Parameters_TDD_r4_ext,
      { "ue-Positioning-IPDL-Parameters-TDD-r4-ext", "umts_rrc_ies.ue_Positioning_IPDL_Parameters_TDD_r4_ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_IPDL_Parameters_TDD_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_ue_Positioning_IPDL_Parameters_TDDList_r4_ext,
      { "ue-Positioning-IPDL-Parameters-TDDList-r4-ext", "umts_rrc_ies.ue_Positioning_IPDL_Parameters_TDDList_r4_ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_Positioning_IPDL_Parameters_TDDList_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_ReferenceCellInfo_UEB,
      { "ue-positioning-OTDOA-ReferenceCellInfo-UEB", "umts_rrc_ies.ue_positioning_OTDOA_ReferenceCellInfo_UEB",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_ReferenceCellInfo_UEB", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_NeighbourCellList_UEB,
      { "ue-positioning-OTDOA-NeighbourCellList-UEB", "umts_rrc_ies.ue_positioning_OTDOA_NeighbourCellList_UEB",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellList_UEB", HFILL }},
    { &hf_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext_item,
      { "Item", "umts_rrc_ies.UE_Positioning_IPDL_Parameters_TDDList_r4_ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_IPDL_Parameters_TDD_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo70,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo70_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo70", HFILL }},
    { &hf_umts_rrc_ies_fdd82,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd77", HFILL }},
    { &hf_umts_rrc_ies_referenceCellIDentity,
      { "referenceCellIDentity", "umts_rrc_ies.referenceCellIDentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCPICH_Info", HFILL }},
    { &hf_umts_rrc_ies_ue_RX_TX_TimeDifferenceType2Info,
      { "ue-RX-TX-TimeDifferenceType2Info", "umts_rrc_ies.ue_RX_TX_TimeDifferenceType2Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_RX_TX_TimeDifferenceType2Info", HFILL }},
    { &hf_umts_rrc_ies_tdd77,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd70", HFILL }},
    { &hf_umts_rrc_ies_referenceCellIdentity,
      { "referenceCellIdentity", "umts_rrc_ies.referenceCellIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellParametersID", HFILL }},
    { &hf_umts_rrc_ies_neighbourList,
      { "neighbourList", "umts_rrc_ies.neighbourList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NeighbourList", HFILL }},
    { &hf_umts_rrc_ies_neighbourList_v390ext,
      { "neighbourList-v390ext", "umts_rrc_ies.neighbourList_v390ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NeighbourList_v390ext", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo71,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo71_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo71", HFILL }},
    { &hf_umts_rrc_ies_fdd83,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd78", HFILL }},
    { &hf_umts_rrc_ies_tdd78,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd71", HFILL }},
    { &hf_umts_rrc_ies_cellAndChannelIdentity,
      { "cellAndChannelIdentity", "umts_rrc_ies.cellAndChannelIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellAndChannelIdentity", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters,
      { "ue-positioning-IPDL-Paremeters", "umts_rrc_ies.ue_positioning_IPDL_Paremeters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_IPDL_Parameters", HFILL }},
    { &hf_umts_rrc_ies_sfn_SFN_RelTimeDifference,
      { "sfn-SFN-RelTimeDifference", "umts_rrc_ies.sfn_SFN_RelTimeDifference",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SFN_SFN_RelTimeDifference1", HFILL }},
    { &hf_umts_rrc_ies_sfn_SFN_Drift,
      { "sfn-SFN-Drift", "umts_rrc_ies.sfn_SFN_Drift",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_SFN_Drift_vals), 0,
        "umts_rrc_ies.SFN_SFN_Drift", HFILL }},
    { &hf_umts_rrc_ies_searchWindowSize,
      { "searchWindowSize", "umts_rrc_ies.searchWindowSize",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_OTDOA_SearchWindowSize_vals), 0,
        "umts_rrc_ies.OTDOA_SearchWindowSize", HFILL }},
    { &hf_umts_rrc_ies_positioningMode,
      { "positioningMode", "umts_rrc_ies.positioningMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_positioningMode_vals), 0,
        "umts_rrc_ies.T_positioningMode", HFILL }},
    { &hf_umts_rrc_ies_ueBased,
      { "ueBased", "umts_rrc_ies.ueBased",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueBased", HFILL }},
    { &hf_umts_rrc_ies_ueAssisted,
      { "ueAssisted", "umts_rrc_ies.ueAssisted",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueAssisted", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo72,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo72_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo72", HFILL }},
    { &hf_umts_rrc_ies_fdd84,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd79", HFILL }},
    { &hf_umts_rrc_ies_tdd79,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd72", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_IPDL_Paremeters1,
      { "ue-positioning-IPDL-Paremeters", "umts_rrc_ies.ue_positioning_IPDL_Paremeters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_IPDL_Parameters_r4", HFILL }},
    { &hf_umts_rrc_ies_sfn_Offset_Validity,
      { "sfn-Offset-Validity", "umts_rrc_ies.sfn_Offset_Validity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SFN_Offset_Validity_vals), 0,
        "umts_rrc_ies.SFN_Offset_Validity", HFILL }},
    { &hf_umts_rrc_ies_positioningMode1,
      { "positioningMode", "umts_rrc_ies.positioningMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_positioningMode1_vals), 0,
        "umts_rrc_ies.T_positioningMode1", HFILL }},
    { &hf_umts_rrc_ies_ueBased1,
      { "ueBased", "umts_rrc_ies.ueBased",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueBased1", HFILL }},
    { &hf_umts_rrc_ies_relativeNorth,
      { "relativeNorth", "umts_rrc_ies.relativeNorth",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M20000_20000", HFILL }},
    { &hf_umts_rrc_ies_relativeEast,
      { "relativeEast", "umts_rrc_ies.relativeEast",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M20000_20000", HFILL }},
    { &hf_umts_rrc_ies_relativeAltitude,
      { "relativeAltitude", "umts_rrc_ies.relativeAltitude",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_M4000_4000", HFILL }},
    { &hf_umts_rrc_ies_fineSFN_SFN,
      { "fineSFN-SFN", "umts_rrc_ies.fineSFN_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.FineSFN_SFN", HFILL }},
    { &hf_umts_rrc_ies_roundTripTime,
      { "roundTripTime", "umts_rrc_ies.roundTripTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_32766", HFILL }},
    { &hf_umts_rrc_ies_ueAssisted1,
      { "ueAssisted", "umts_rrc_ies.ueAssisted",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueAssisted1", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo73,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo73_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo73", HFILL }},
    { &hf_umts_rrc_ies_fdd85,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd80", HFILL }},
    { &hf_umts_rrc_ies_tdd80,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd73", HFILL }},
    { &hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_item,
      { "Item", "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellInfo", HFILL }},
    { &hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4_item,
      { "Item", "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellList_r4_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellInfo_r4", HFILL }},
    { &hf_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB_item,
      { "Item", "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellList_UEB_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_NeighbourCellInfo_UEB", HFILL }},
    { &hf_umts_rrc_ies_stdResolution,
      { "stdResolution", "umts_rrc_ies.stdResolution",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_2", HFILL }},
    { &hf_umts_rrc_ies_numberOfOTDOA_Measurements,
      { "numberOfOTDOA-Measurements", "umts_rrc_ies.numberOfOTDOA_Measurements",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_3", HFILL }},
    { &hf_umts_rrc_ies_stdOfOTDOA_Measurements,
      { "stdOfOTDOA-Measurements", "umts_rrc_ies.stdOfOTDOA_Measurements",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_5", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo74,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo74_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo74", HFILL }},
    { &hf_umts_rrc_ies_fdd86,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd81", HFILL }},
    { &hf_umts_rrc_ies_tdd81,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd74", HFILL }},
    { &hf_umts_rrc_ies_positioningMode2,
      { "positioningMode", "umts_rrc_ies.positioningMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_positioningMode2_vals), 0,
        "umts_rrc_ies.T_positioningMode2", HFILL }},
    { &hf_umts_rrc_ies_ueBased2,
      { "ueBased", "umts_rrc_ies.ueBased",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueBased2", HFILL }},
    { &hf_umts_rrc_ies_ueAssisted2,
      { "ueAssisted", "umts_rrc_ies.ueAssisted",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueAssisted2", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo75,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo75_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo75", HFILL }},
    { &hf_umts_rrc_ies_fdd87,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd82", HFILL }},
    { &hf_umts_rrc_ies_tdd82,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd75", HFILL }},
    { &hf_umts_rrc_ies_positioningMode3,
      { "positioningMode", "umts_rrc_ies.positioningMode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_positioningMode3_vals), 0,
        "umts_rrc_ies.T_positioningMode3", HFILL }},
    { &hf_umts_rrc_ies_ueBased3,
      { "ueBased", "umts_rrc_ies.ueBased",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueBased3", HFILL }},
    { &hf_umts_rrc_ies_cellPosition,
      { "cellPosition", "umts_rrc_ies.cellPosition",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReferenceCellPosition_vals), 0,
        "umts_rrc_ies.ReferenceCellPosition", HFILL }},
    { &hf_umts_rrc_ies_ueAssisted3,
      { "ueAssisted", "umts_rrc_ies.ueAssisted",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ueAssisted3", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo76,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo76_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo76", HFILL }},
    { &hf_umts_rrc_ies_fdd88,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd83", HFILL }},
    { &hf_umts_rrc_ies_tdd83,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd76", HFILL }},
    { &hf_umts_rrc_ies_referenceTime1,
      { "referenceTime", "umts_rrc_ies.referenceTime",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_referenceTime1_vals), 0,
        "umts_rrc_ies.T_referenceTime1", HFILL }},
    { &hf_umts_rrc_ies_cell_Timing,
      { "cell-Timing", "umts_rrc_ies.cell_Timing",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cell_Timing", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo77,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo77_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo77", HFILL }},
    { &hf_umts_rrc_ies_fdd89,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd84", HFILL }},
    { &hf_umts_rrc_ies_tdd84,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd77", HFILL }},
    { &hf_umts_rrc_ies_positionEstimate,
      { "positionEstimate", "umts_rrc_ies.positionEstimate",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PositionEstimate_vals), 0,
        "umts_rrc_ies.PositionEstimate", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_ReportingCriteria,
      { "ue-positioning-ReportingCriteria", "umts_rrc_ies.ue_positioning_ReportingCriteria",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UE_Positioning_EventParamList", HFILL }},
    { &hf_umts_rrc_ies_methodType,
      { "methodType", "umts_rrc_ies.methodType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_MethodType_vals), 0,
        "umts_rrc_ies.UE_Positioning_MethodType", HFILL }},
    { &hf_umts_rrc_ies_positioningMethod,
      { "positioningMethod", "umts_rrc_ies.positioningMethod",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PositioningMethod_vals), 0,
        "umts_rrc_ies.PositioningMethod", HFILL }},
    { &hf_umts_rrc_ies_dummy1_UE_Positioning_ResponseTime,
      { "dummy1-UE-Positioning-ResponseTime", "umts_rrc_ies.dummy1_UE_Positioning_ResponseTime",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_UE_Positioning_ResponseTime_vals), 0,
        "umts_rrc_ies.UE_Positioning_ResponseTime", HFILL }},
    { &hf_umts_rrc_ies_horizontal_Accuracy,
      { "horizontal-Accuracy", "umts_rrc_ies.horizontal_Accuracy",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Accuracy", HFILL }},
    { &hf_umts_rrc_ies_gps_TimingOfCellWanted,
      { "gps-TimingOfCellWanted", "umts_rrc_ies.gps_TimingOfCellWanted",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_additionalAssistanceDataRequest,
      { "additionalAssistanceDataRequest", "umts_rrc_ies.additionalAssistanceDataRequest",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_environmentCharacterisation,
      { "environmentCharacterisation", "umts_rrc_ies.environmentCharacterisation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_EnvironmentCharacterisation_vals), 0,
        "umts_rrc_ies.EnvironmentCharacterisation", HFILL }},
    { &hf_umts_rrc_ies_vertical_Accuracy,
      { "vertical-Accuracy", "umts_rrc_ies.vertical_Accuracy",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Accuracy", HFILL }},
    { &hf_umts_rrc_ies_horizontalAccuracy,
      { "horizontalAccuracy", "umts_rrc_ies.horizontalAccuracy",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Accuracy", HFILL }},
    { &hf_umts_rrc_ies_verticalAccuracy,
      { "verticalAccuracy", "umts_rrc_ies.verticalAccuracy",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.UE_Positioning_Accuracy", HFILL }},
    { &hf_umts_rrc_ies_additionalAssistanceDataReq,
      { "additionalAssistanceDataReq", "umts_rrc_ies.additionalAssistanceDataReq",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_utran_GPSTimingOfCell,
      { "utran-GPSTimingOfCell", "umts_rrc_ies.utran_GPSTimingOfCell",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_utran_GPSTimingOfCell", HFILL }},
    { &hf_umts_rrc_ies_ms_part,
      { "ms-part", "umts_rrc_ies.ms_part",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1023", HFILL }},
    { &hf_umts_rrc_ies_ls_part,
      { "ls-part", "umts_rrc_ies.ls_part",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_4294967295", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo78,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo78_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo78", HFILL }},
    { &hf_umts_rrc_ies_fdd90,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd85", HFILL }},
    { &hf_umts_rrc_ies_tdd85,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd78", HFILL }},
    { &hf_umts_rrc_ies_ue_GPSTimingOfCell,
      { "ue-GPSTimingOfCell", "umts_rrc_ies.ue_GPSTimingOfCell",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_ue_GPSTimingOfCell", HFILL }},
    { &hf_umts_rrc_ies_ms_part1,
      { "ms-part", "umts_rrc_ies.ms_part",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_16383", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo79,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo79_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo79", HFILL }},
    { &hf_umts_rrc_ies_fdd91,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd86", HFILL }},
    { &hf_umts_rrc_ies_tdd86,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd79", HFILL }},
    { &hf_umts_rrc_ies_mib_ValueTag,
      { "mib-ValueTag", "umts_rrc_ies.mib_ValueTag",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MIB_ValueTag", HFILL }},
    { &hf_umts_rrc_ies_bcch_ModificationTime,
      { "bcch-ModificationTime", "umts_rrc_ies.bcch_ModificationTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BCCH_ModificationTime", HFILL }},
    { &hf_umts_rrc_ies_ncc,
      { "ncc", "umts_rrc_ies.ncc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.NCC", HFILL }},
    { &hf_umts_rrc_ies_bcc,
      { "bcc", "umts_rrc_ies.bcc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.BCC", HFILL }},
    { &hf_umts_rrc_ies_ctch_AllocationPeriod,
      { "ctch-AllocationPeriod", "umts_rrc_ies.ctch_AllocationPeriod",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_256", HFILL }},
    { &hf_umts_rrc_ies_cbs_FrameOffset,
      { "cbs-FrameOffset", "umts_rrc_ies.cbs_FrameOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_msg_Type,
      { "msg-Type", "umts_rrc_ies.msg_Type",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_payload,
      { "payload", "umts_rrc_ies.payload",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1_512", HFILL }},
    { &hf_umts_rrc_ies_CDMA2000_MessageList_item,
      { "Item", "umts_rrc_ies.CDMA2000_MessageList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CDMA2000_Message", HFILL }},
    { &hf_umts_rrc_ies_CDMA2000_UMTS_Frequency_List_item,
      { "Item", "umts_rrc_ies.CDMA2000_UMTS_Frequency_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfoCDMA2000", HFILL }},
    { &hf_umts_rrc_ies_FDD_UMTS_Frequency_List_item,
      { "Item", "umts_rrc_ies.FDD_UMTS_Frequency_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfoFDD", HFILL }},
    { &hf_umts_rrc_ies_band_Class,
      { "band-Class", "umts_rrc_ies.band_Class",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_5", HFILL }},
    { &hf_umts_rrc_ies_cdma_Freq,
      { "cdma-Freq", "umts_rrc_ies.cdma_Freq",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_11", HFILL }},
    { &hf_umts_rrc_ies_GERAN_SystemInformation_item,
      { "Item", "umts_rrc_ies.GERAN_SystemInformation_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GERAN_SystemInfoBlock", HFILL }},
    { &hf_umts_rrc_ies_gsmLowRangeUARFCN,
      { "gsmLowRangeUARFCN", "umts_rrc_ies.gsmLowRangeUARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UARFCN", HFILL }},
    { &hf_umts_rrc_ies_gsmUpRangeUARFCN,
      { "gsmUpRangeUARFCN", "umts_rrc_ies.gsmUpRangeUARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UARFCN", HFILL }},
    { &hf_umts_rrc_ies_GSM_BA_Range_List_item,
      { "Item", "umts_rrc_ies.GSM_BA_Range_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GSM_BA_Range", HFILL }},
    { &hf_umts_rrc_ies_GSM_MessageList_item,
      { "Item", "umts_rrc_ies.GSM_MessageList_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1_512", HFILL }},
    { &hf_umts_rrc_ies_GSM_TargetCellInfoList_item,
      { "Item", "umts_rrc_ies.GSM_TargetCellInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.GSM_TargetCellInfo", HFILL }},
    { &hf_umts_rrc_ies_receivedMessageType,
      { "receivedMessageType", "umts_rrc_ies.receivedMessageType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ReceivedMessageType_vals), 0,
        "umts_rrc_ies.ReceivedMessageType", HFILL }},
    { &hf_umts_rrc_ies_configurationUnacceptable,
      { "configurationUnacceptable", "umts_rrc_ies.configurationUnacceptable",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_unspecified,
      { "unspecified", "umts_rrc_ies.unspecified",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_GERANIu_MessageList_item,
      { "Item", "umts_rrc_ies.GERANIu_MessageList_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1_32768", HFILL }},
    { &hf_umts_rrc_ies_gsm11,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm10", HFILL }},
    { &hf_umts_rrc_ies_gsm_Classmark2,
      { "gsm-Classmark2", "umts_rrc_ies.gsm_Classmark2",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GSM_Classmark2", HFILL }},
    { &hf_umts_rrc_ies_gsm_Classmark3,
      { "gsm-Classmark3", "umts_rrc_ies.gsm_Classmark3",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GSM_Classmark3", HFILL }},
    { &hf_umts_rrc_ies_cdma2000,
      { "cdma2000", "umts_rrc_ies.cdma2000",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_cdma2000", HFILL }},
    { &hf_umts_rrc_ies_cdma2000_MessageList,
      { "cdma2000-MessageList", "umts_rrc_ies.cdma2000_MessageList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CDMA2000_MessageList", HFILL }},
    { &hf_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList_item,
      { "Item", "umts_rrc_ies.InterRAT_UE_RadioAccessCapabilityList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRAT_UE_RadioAccessCapability_vals), 0,
        "umts_rrc_ies.InterRAT_UE_RadioAccessCapability", HFILL }},
    { &hf_umts_rrc_ies_geranIu_RadioAccessCapability,
      { "geranIu-RadioAccessCapability", "umts_rrc_ies.geranIu_RadioAccessCapability",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GERANIu_RadioAccessCapability", HFILL }},
    { &hf_umts_rrc_ies_gsm_MS_RadioAccessCapability,
      { "gsm-MS-RadioAccessCapability", "umts_rrc_ies.gsm_MS_RadioAccessCapability",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GSM_MS_RadioAccessCapability", HFILL }},
    { &hf_umts_rrc_ies_gsm12,
      { "gsm", "umts_rrc_ies.gsm",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_gsm11", HFILL }},
    { &hf_umts_rrc_ies_gsmSecurityCapability,
      { "gsmSecurityCapability", "umts_rrc_ies.gsmSecurityCapability",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.GsmSecurityCapability", HFILL }},
    { &hf_umts_rrc_ies_InterRAT_UE_SecurityCapList_item,
      { "Item", "umts_rrc_ies.InterRAT_UE_SecurityCapList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_InterRAT_UE_SecurityCapability_vals), 0,
        "umts_rrc_ies.InterRAT_UE_SecurityCapability", HFILL }},
    { &hf_umts_rrc_ies_interRAT_ProtocolError,
      { "interRAT-ProtocolError", "umts_rrc_ies.interRAT_ProtocolError",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare10,
      { "spare10", "umts_rrc_ies.spare10",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare9,
      { "spare9", "umts_rrc_ies.spare9",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare8,
      { "spare8", "umts_rrc_ies.spare8",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare7,
      { "spare7", "umts_rrc_ies.spare7",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_spare6,
      { "spare6", "umts_rrc_ies.spare6",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_plmn_Type,
      { "plmn-Type", "umts_rrc_ies.plmn_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_PLMN_Type_vals), 0,
        "umts_rrc_ies.PLMN_Type", HFILL }},
    { &hf_umts_rrc_ies_sibSb_ReferenceList,
      { "sibSb-ReferenceList", "umts_rrc_ies.sibSb_ReferenceList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIBSb_ReferenceList", HFILL }},
    { &hf_umts_rrc_ies_v6xyNonCriticalExtensions,
      { "v6xyNonCriticalExtensions", "umts_rrc_ies.v6xyNonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v6xyNonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_masterInformationBlock_v6xyext,
      { "masterInformationBlock-v6xyext", "umts_rrc_ies.masterInformationBlock_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MasterInformationBlock_v6xyext", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions1,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions1", HFILL }},
    { &hf_umts_rrc_ies_multiplePLMN_List,
      { "multiplePLMN-List", "umts_rrc_ies.multiplePLMN_List",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MultiplePLMN_List_r6", HFILL }},
    { &hf_umts_rrc_ies_predefinedConfigIdentity,
      { "predefinedConfigIdentity", "umts_rrc_ies.predefinedConfigIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigIdentity", HFILL }},
    { &hf_umts_rrc_ies_predefinedConfigValueTag,
      { "predefinedConfigValueTag", "umts_rrc_ies.predefinedConfigValueTag",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PredefinedConfigValueTag", HFILL }},
    { &hf_umts_rrc_ies_diagnosticsType1,
      { "diagnosticsType", "umts_rrc_ies.diagnosticsType",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_diagnosticsType1_vals), 0,
        "umts_rrc_ies.T_diagnosticsType1", HFILL }},
    { &hf_umts_rrc_ies_type14,
      { "type1", "umts_rrc_ies.type1",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_type13", HFILL }},
    { &hf_umts_rrc_ies_protocolErrorCause,
      { "protocolErrorCause", "umts_rrc_ies.protocolErrorCause",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_ProtocolErrorCause_vals), 0,
        "umts_rrc_ies.ProtocolErrorCause", HFILL }},
    { &hf_umts_rrc_ies_gsm_BA_Range_List,
      { "gsm-BA-Range-List", "umts_rrc_ies.gsm_BA_Range_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.GSM_BA_Range_List", HFILL }},
    { &hf_umts_rrc_ies_fdd_UMTS_Frequency_List,
      { "fdd-UMTS-Frequency-List", "umts_rrc_ies.fdd_UMTS_Frequency_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.FDD_UMTS_Frequency_List", HFILL }},
    { &hf_umts_rrc_ies_tdd_UMTS_Frequency_List,
      { "tdd-UMTS-Frequency-List", "umts_rrc_ies.tdd_UMTS_Frequency_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TDD_UMTS_Frequency_List", HFILL }},
    { &hf_umts_rrc_ies_cdma2000_UMTS_Frequency_List,
      { "cdma2000-UMTS-Frequency-List", "umts_rrc_ies.cdma2000_UMTS_Frequency_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CDMA2000_UMTS_Frequency_List", HFILL }},
    { &hf_umts_rrc_ies_tdd384_UMTS_Frequency_List,
      { "tdd384-UMTS-Frequency-List", "umts_rrc_ies.tdd384_UMTS_Frequency_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TDD_UMTS_Frequency_List", HFILL }},
    { &hf_umts_rrc_ies_tdd128_UMTS_Frequency_List,
      { "tdd128-UMTS-Frequency-List", "umts_rrc_ies.tdd128_UMTS_Frequency_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.TDD_UMTS_Frequency_List", HFILL }},
    { &hf_umts_rrc_ies_scheduling,
      { "scheduling", "umts_rrc_ies.scheduling",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_scheduling", HFILL }},
    { &hf_umts_rrc_ies_segCount,
      { "segCount", "umts_rrc_ies.segCount",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SegCount", HFILL }},
    { &hf_umts_rrc_ies_sib_Pos,
      { "sib-Pos", "umts_rrc_ies.sib_Pos",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_sib_Pos_vals), 0,
        "umts_rrc_ies.T_sib_Pos", HFILL }},
    { &hf_umts_rrc_ies_rep4,
      { "rep4", "umts_rrc_ies.rep4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1", HFILL }},
    { &hf_umts_rrc_ies_rep8,
      { "rep8", "umts_rrc_ies.rep8",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_rep16,
      { "rep16", "umts_rrc_ies.rep16",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_rep32,
      { "rep32", "umts_rrc_ies.rep32",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_rep64,
      { "rep64", "umts_rrc_ies.rep64",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_rep128,
      { "rep128", "umts_rrc_ies.rep128",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_rep256,
      { "rep256", "umts_rrc_ies.rep256",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_rep512,
      { "rep512", "umts_rrc_ies.rep512",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_rep1024,
      { "rep1024", "umts_rrc_ies.rep1024",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_511", HFILL }},
    { &hf_umts_rrc_ies_rep2048,
      { "rep2048", "umts_rrc_ies.rep2048",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1023", HFILL }},
    { &hf_umts_rrc_ies_rep4096,
      { "rep4096", "umts_rrc_ies.rep4096",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_2047", HFILL }},
    { &hf_umts_rrc_ies_sib_PosOffsetInfo,
      { "sib-PosOffsetInfo", "umts_rrc_ies.sib_PosOffsetInfo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SibOFF_List", HFILL }},
    { &hf_umts_rrc_ies_sib_Type,
      { "sib-Type", "umts_rrc_ies.sib_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SIB_TypeAndTag_vals), 0,
        "umts_rrc_ies.SIB_TypeAndTag", HFILL }},
    { &hf_umts_rrc_ies_scheduling1,
      { "scheduling", "umts_rrc_ies.scheduling",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SchedulingInformation", HFILL }},
    { &hf_umts_rrc_ies_sibSb_Type,
      { "sibSb-Type", "umts_rrc_ies.sibSb_Type",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SIBSb_TypeAndTag_vals), 0,
        "umts_rrc_ies.SIBSb_TypeAndTag", HFILL }},
    { &hf_umts_rrc_ies_sibOccurIdentity,
      { "sibOccurIdentity", "umts_rrc_ies.sibOccurIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIBOccurIdentity", HFILL }},
    { &hf_umts_rrc_ies_sibOccurValueTag,
      { "sibOccurValueTag", "umts_rrc_ies.sibOccurValueTag",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIBOccurValueTag", HFILL }},
    { &hf_umts_rrc_ies_SIB_ReferenceList_item,
      { "Item", "umts_rrc_ies.SIB_ReferenceList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SchedulingInformationSIB", HFILL }},
    { &hf_umts_rrc_ies_SIBSb_ReferenceList_item,
      { "Item", "umts_rrc_ies.SIBSb_ReferenceList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SchedulingInformationSIBSb", HFILL }},
    { &hf_umts_rrc_ies_SIB_ReferenceListFACH_item,
      { "Item", "umts_rrc_ies.SIB_ReferenceListFACH_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SchedulingInformationSIB", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType1,
      { "sysInfoType1", "umts_rrc_ies.sysInfoType1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PLMN_ValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType2,
      { "sysInfoType2", "umts_rrc_ies.sysInfoType2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType3,
      { "sysInfoType3", "umts_rrc_ies.sysInfoType3",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType4,
      { "sysInfoType4", "umts_rrc_ies.sysInfoType4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType5,
      { "sysInfoType5", "umts_rrc_ies.sysInfoType5",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType6,
      { "sysInfoType6", "umts_rrc_ies.sysInfoType6",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType7,
      { "sysInfoType7", "umts_rrc_ies.sysInfoType7",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_dummy_CellValueTag,
      { "dummy-CellValueTag", "umts_rrc_ies.dummy_CellValueTag",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_dummy2_NULL,
      { "dummy2-NULL", "umts_rrc_ies.dummy2_NULL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_dummy3_NULL,
      { "dummy3-NULL", "umts_rrc_ies.dummy3_NULL",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType11,
      { "sysInfoType11", "umts_rrc_ies.sysInfoType11",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType12,
      { "sysInfoType12", "umts_rrc_ies.sysInfoType12",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13,
      { "sysInfoType13", "umts_rrc_ies.sysInfoType13",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13_1,
      { "sysInfoType13-1", "umts_rrc_ies.sysInfoType13_1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13_2,
      { "sysInfoType13-2", "umts_rrc_ies.sysInfoType13_2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13_3,
      { "sysInfoType13-3", "umts_rrc_ies.sysInfoType13_3",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13_4,
      { "sysInfoType13-4", "umts_rrc_ies.sysInfoType13_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType14,
      { "sysInfoType14", "umts_rrc_ies.sysInfoType14",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15,
      { "sysInfoType15", "umts_rrc_ies.sysInfoType15",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType16,
      { "sysInfoType16", "umts_rrc_ies.sysInfoType16",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PredefinedConfigIdentityAndValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType17,
      { "sysInfoType17", "umts_rrc_ies.sysInfoType17",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_1,
      { "sysInfoType15-1", "umts_rrc_ies.sysInfoType15_1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_2,
      { "sysInfoType15-2", "umts_rrc_ies.sysInfoType15_2",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SIBOccurrenceIdentityAndValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_3,
      { "sysInfoType15-3", "umts_rrc_ies.sysInfoType15_3",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SIBOccurrenceIdentityAndValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_4,
      { "sysInfoType15-4", "umts_rrc_ies.sysInfoType15_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType18,
      { "sysInfoType18", "umts_rrc_ies.sysInfoType18",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_5,
      { "sysInfoType15-5", "umts_rrc_ies.sysInfoType15_5",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType5bis,
      { "sysInfoType5bis", "umts_rrc_ies.sysInfoType5bis",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoTypeSB1,
      { "sysInfoTypeSB1", "umts_rrc_ies.sysInfoTypeSB1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_sysInfoTypeSB2,
      { "sysInfoTypeSB2", "umts_rrc_ies.sysInfoTypeSB2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CellValueTag", HFILL }},
    { &hf_umts_rrc_ies_SibOFF_List_item,
      { "Item", "umts_rrc_ies.SibOFF_List_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_SibOFF_vals), 0,
        "umts_rrc_ies.SibOFF", HFILL }},
    { &hf_umts_rrc_ies_cn_DomainSysInfoList,
      { "cn-DomainSysInfoList", "umts_rrc_ies.cn_DomainSysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CN_DomainSysInfoList", HFILL }},
    { &hf_umts_rrc_ies_ue_ConnTimersAndConstants,
      { "ue-ConnTimersAndConstants", "umts_rrc_ies.ue_ConnTimersAndConstants",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_ConnTimersAndConstants", HFILL }},
    { &hf_umts_rrc_ies_ue_IdleTimersAndConstants,
      { "ue-IdleTimersAndConstants", "umts_rrc_ies.ue_IdleTimersAndConstants",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_IdleTimersAndConstants", HFILL }},
    { &hf_umts_rrc_ies_v3a0NonCriticalExtensions,
      { "v3a0NonCriticalExtensions", "umts_rrc_ies.v3a0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v3a0NonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType1_v3a0ext,
      { "sysInfoType1-v3a0ext", "umts_rrc_ies.sysInfoType1_v3a0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType1_v3a0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions2,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions2", HFILL }},
    { &hf_umts_rrc_ies_ue_ConnTimersAndConstants_v3a0ext,
      { "ue-ConnTimersAndConstants-v3a0ext", "umts_rrc_ies.ue_ConnTimersAndConstants_v3a0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_ConnTimersAndConstants_v3a0ext", HFILL }},
    { &hf_umts_rrc_ies_ue_IdleTimersAndConstants_v3a0ext,
      { "ue-IdleTimersAndConstants-v3a0ext", "umts_rrc_ies.ue_IdleTimersAndConstants_v3a0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_IdleTimersAndConstants_v3a0ext", HFILL }},
    { &hf_umts_rrc_ies_ura_IdentityList,
      { "ura-IdentityList", "umts_rrc_ies.ura_IdentityList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.URA_IdentityList", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions3,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions3", HFILL }},
    { &hf_umts_rrc_ies_sib4indicator,
      { "sib4indicator", "umts_rrc_ies.sib4indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_cellSelectReselectInfo,
      { "cellSelectReselectInfo", "umts_rrc_ies.cellSelectReselectInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoSIB_3_4", HFILL }},
    { &hf_umts_rrc_ies_cellAccessRestriction,
      { "cellAccessRestriction", "umts_rrc_ies.cellAccessRestriction",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellAccessRestriction", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType3_v4b0ext,
      { "sysInfoType3-v4b0ext", "umts_rrc_ies.sysInfoType3_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType3_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtension,
      { "v590NonCriticalExtension", "umts_rrc_ies.v590NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtension", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType3_v590ext,
      { "sysInfoType3-v590ext", "umts_rrc_ies.sysInfoType3_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType3_v590ext", HFILL }},
    { &hf_umts_rrc_ies_v5c0NoncriticalExtension,
      { "v5c0NoncriticalExtension", "umts_rrc_ies.v5c0NoncriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v5c0NoncriticalExtension", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType3_v5c0ext,
      { "sysInfoType3-v5c0ext", "umts_rrc_ies.sysInfoType3_v5c0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType3_v5c0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v670NonCriticalExtension,
      { "v670NonCriticalExtension", "umts_rrc_ies.v670NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v670NonCriticalExtension", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType3_v670ext,
      { "sysInfoType3-v670ext", "umts_rrc_ies.sysInfoType3_v670ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType3_v670ext", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions4,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions4", HFILL }},
    { &hf_umts_rrc_ies_mapping_LCR,
      { "mapping-LCR", "umts_rrc_ies.mapping_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.Mapping_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_cellSelectReselectInfo_v590ext,
      { "cellSelectReselectInfo-v590ext", "umts_rrc_ies.cellSelectReselectInfo_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_cellSelectReselectInfoTreselectionScaling_v5c0ext,
      { "cellSelectReselectInfoTreselectionScaling-v5c0ext", "umts_rrc_ies.cellSelectReselectInfoTreselectionScaling_v5c0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoTreselectionScaling_v5c0ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestrictionParametersForPLMNOfMIB,
      { "domainSpecificAccessRestrictionParametersForPLMNOfMIB", "umts_rrc_ies.domainSpecificAccessRestrictionParametersForPLMNOfMIB",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionParam_v670ext", HFILL }},
    { &hf_umts_rrc_ies_domainSpecificAccessRestictionForSharedNetwork,
      { "domainSpecificAccessRestictionForSharedNetwork", "umts_rrc_ies.domainSpecificAccessRestictionForSharedNetwork",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext_vals), 0,
        "umts_rrc_ies.DomainSpecificAccessRestrictionForSharedNetwork_v670ext", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions1,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions1", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType4_v4b0ext,
      { "sysInfoType4-v4b0ext", "umts_rrc_ies.sysInfoType4_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType4_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtension1,
      { "v590NonCriticalExtension", "umts_rrc_ies.v590NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtension1", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType4_v590ext,
      { "sysInfoType4-v590ext", "umts_rrc_ies.sysInfoType4_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType4_v590ext", HFILL }},
    { &hf_umts_rrc_ies_v5b0NonCriticalExtension,
      { "v5b0NonCriticalExtension", "umts_rrc_ies.v5b0NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v5b0NonCriticalExtension", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType4_v5b0ext,
      { "sysInfoType4-v5b0ext", "umts_rrc_ies.sysInfoType4_v5b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType4_v5b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v5c0NonCriticalExtension,
      { "v5c0NonCriticalExtension", "umts_rrc_ies.v5c0NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v5c0NonCriticalExtension", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType4_v5c0ext,
      { "sysInfoType4-v5c0ext", "umts_rrc_ies.sysInfoType4_v5c0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType4_v5c0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions5,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions5", HFILL }},
    { &hf_umts_rrc_ies_cellSelectReselectInfoPCHFACH_v5b0ext,
      { "cellSelectReselectInfoPCHFACH-v5b0ext", "umts_rrc_ies.cellSelectReselectInfoPCHFACH_v5b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfoPCHFACH_v5b0ext", HFILL }},
    { &hf_umts_rrc_ies_sib6indicator,
      { "sib6indicator", "umts_rrc_ies.sib6indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_pich_PowerOffset,
      { "pich-PowerOffset", "umts_rrc_ies.pich_PowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PICH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo80,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo80_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo80", HFILL }},
    { &hf_umts_rrc_ies_fdd92,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd87", HFILL }},
    { &hf_umts_rrc_ies_aich_PowerOffset,
      { "aich-PowerOffset", "umts_rrc_ies.aich_PowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AICH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_tdd87,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd80", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfoList_SFN,
      { "pusch-SysInfoList-SFN", "umts_rrc_ies.pusch_SysInfoList_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_SFN", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN,
      { "pdsch-SysInfoList-SFN", "umts_rrc_ies.pdsch_SysInfoList_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_SFN", HFILL }},
    { &hf_umts_rrc_ies_openLoopPowerControl_TDD,
      { "openLoopPowerControl-TDD", "umts_rrc_ies.openLoopPowerControl_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.OpenLoopPowerControl_TDD", HFILL }},
    { &hf_umts_rrc_ies_prach_SystemInformationList,
      { "prach-SystemInformationList", "umts_rrc_ies.prach_SystemInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PRACH_SystemInformationList", HFILL }},
    { &hf_umts_rrc_ies_sCCPCH_SystemInformationList,
      { "sCCPCH-SystemInformationList", "umts_rrc_ies.sCCPCH_SystemInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformationList", HFILL }},
    { &hf_umts_rrc_ies_cbs_DRX_Level1Information,
      { "cbs-DRX-Level1Information", "umts_rrc_ies.cbs_DRX_Level1Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CBS_DRX_Level1Information", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions2,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions2", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType5_v4b0ext,
      { "sysInfoType5-v4b0ext", "umts_rrc_ies.sysInfoType5_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType5_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtensions,
      { "v590NonCriticalExtensions", "umts_rrc_ies.v590NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType5_v590ext,
      { "sysInfoType5-v590ext", "umts_rrc_ies.sysInfoType5_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType5_v590ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v650NonCriticalExtensions,
      { "v650NonCriticalExtensions", "umts_rrc_ies.v650NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v650NonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType5_v650ext,
      { "sysInfoType5-v650ext", "umts_rrc_ies.sysInfoType5_v650ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType5_v650ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v6xyNonCriticalExtensions1,
      { "v6xyNonCriticalExtensions", "umts_rrc_ies.v6xyNonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v6xyNonCriticalExtensions1", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType5_v6xyext,
      { "sysInfoType5-v6xyext", "umts_rrc_ies.sysInfoType5_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType5_v6xyext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions6,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions6", HFILL }},
    { &hf_umts_rrc_ies_pNBSCH_Allocation_r4,
      { "pNBSCH-Allocation-r4", "umts_rrc_ies.pNBSCH_Allocation_r4",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PNBSCH_Allocation_r4", HFILL }},
    { &hf_umts_rrc_ies_openLoopPowerControl_IPDL_TDD,
      { "openLoopPowerControl-IPDL-TDD", "umts_rrc_ies.openLoopPowerControl_IPDL_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.OpenLoopPowerControl_IPDL_TDD_r4", HFILL }},
    { &hf_umts_rrc_ies_prach_SystemInformationList_LCR_r4,
      { "prach-SystemInformationList-LCR-r4", "umts_rrc_ies.prach_SystemInformationList_LCR_r4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PRACH_SystemInformationList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_tdd128SpecificInfo,
      { "tdd128SpecificInfo", "umts_rrc_ies.tdd128SpecificInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd128SpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfoList_SFN1,
      { "pusch-SysInfoList-SFN", "umts_rrc_ies.pusch_SysInfoList_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_SFN_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN1,
      { "pdsch-SysInfoList-SFN", "umts_rrc_ies.pdsch_SysInfoList_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_SFN_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_pCCPCH_LCR_Extensions,
      { "pCCPCH-LCR-Extensions", "umts_rrc_ies.pCCPCH_LCR_Extensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PrimaryCCPCH_Info_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_sCCPCH_LCR_ExtensionsList,
      { "sCCPCH-LCR-ExtensionsList", "umts_rrc_ies.sCCPCH_LCR_ExtensionsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformationList_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_frequencyBandIndicator,
      { "frequencyBandIndicator", "umts_rrc_ies.frequencyBandIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandFDD_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandFDD", HFILL }},
    { &hf_umts_rrc_ies_hcr_r5_SpecificInfo,
      { "hcr-r5-SpecificInfo", "umts_rrc_ies.hcr_r5_SpecificInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcr_r5_SpecificInfo", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfoList_SFN2,
      { "pusch-SysInfoList-SFN", "umts_rrc_ies.pusch_SysInfoList_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_SFN_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfoList_SFN2,
      { "pdsch-SysInfoList-SFN", "umts_rrc_ies.pdsch_SysInfoList_SFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_SFN_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_frequencyBandIndicator2,
      { "frequencyBandIndicator2", "umts_rrc_ies.frequencyBandIndicator2",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RadioFrequencyBandFDD2_vals), 0,
        "umts_rrc_ies.RadioFrequencyBandFDD2", HFILL }},
    { &hf_umts_rrc_ies_sccpch_SystemInformation_MBMS,
      { "sccpch-SystemInformation-MBMS", "umts_rrc_ies.sccpch_SystemInformation_MBMS",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_sccpch_SystemInformation_MBMS_vals), 0,
        "umts_rrc_ies.T_sccpch_SystemInformation_MBMS", HFILL }},
    { &hf_umts_rrc_ies_sccpch_CommonForMBMSAndNonMBMS,
      { "sccpch-CommonForMBMSAndNonMBMS", "umts_rrc_ies.sccpch_CommonForMBMSAndNonMBMS",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformationList_MBMS_r6_ext", HFILL }},
    { &hf_umts_rrc_ies_sccpch_DedicatedForMBMS,
      { "sccpch-DedicatedForMBMS", "umts_rrc_ies.sccpch_DedicatedForMBMS",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SCCPCH_SystemInformation_MBMS_r6", HFILL }},
    { &hf_umts_rrc_ies_additionalPRACH_TF_and_TFCS_CCCH_List,
      { "additionalPRACH-TF-and-TFCS-CCCH-List", "umts_rrc_ies.additionalPRACH_TF_and_TFCS_CCCH_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.AdditionalPRACH_TF_and_TFCS_CCCH_List", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo81,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo81_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo81", HFILL }},
    { &hf_umts_rrc_ies_fdd93,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd88", HFILL }},
    { &hf_umts_rrc_ies_dummy_CSICH_PowerOffset,
      { "dummy-CSICH-PowerOffset", "umts_rrc_ies.dummy_CSICH_PowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CSICH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_tdd88,
      { "tdd", "umts_rrc_ies.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd81", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions3,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions3", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType6_v4b0ext,
      { "sysInfoType6-v4b0ext", "umts_rrc_ies.sysInfoType6_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType6_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtensions1,
      { "v590NonCriticalExtensions", "umts_rrc_ies.v590NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtensions1", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType6_v590ext,
      { "sysInfoType6-v590ext", "umts_rrc_ies.sysInfoType6_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType6_v590ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v650nonCriticalExtensions,
      { "v650nonCriticalExtensions", "umts_rrc_ies.v650nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v650nonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType6_v650ext,
      { "sysInfoType6-v650ext", "umts_rrc_ies.sysInfoType6_v650ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType6_v650ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v6xynonCriticalExtensions,
      { "v6xynonCriticalExtensions", "umts_rrc_ies.v6xynonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v6xynonCriticalExtensions", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType6_v6xyext,
      { "sysInfoType6-v6xyext", "umts_rrc_ies.sysInfoType6_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType6_v6xyext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions7,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions7", HFILL }},
    { &hf_umts_rrc_ies_tdd128SpecificInfo1,
      { "tdd128SpecificInfo", "umts_rrc_ies.tdd128SpecificInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd128SpecificInfo1", HFILL }},
    { &hf_umts_rrc_ies_hcr_r5_SpecificInfo1,
      { "hcr-r5-SpecificInfo", "umts_rrc_ies.hcr_r5_SpecificInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcr_r5_SpecificInfo1", HFILL }},
    { &hf_umts_rrc_ies_modeSpecificInfo82,
      { "modeSpecificInfo", "umts_rrc_ies.modeSpecificInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_modeSpecificInfo82_vals), 0,
        "umts_rrc_ies.T_modeSpecificInfo82", HFILL }},
    { &hf_umts_rrc_ies_fdd94,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd89", HFILL }},
    { &hf_umts_rrc_ies_ul_Interference,
      { "ul-Interference", "umts_rrc_ies.ul_Interference",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.UL_Interference", HFILL }},
    { &hf_umts_rrc_ies_prach_Information_SIB5_List,
      { "prach-Information-SIB5-List", "umts_rrc_ies.prach_Information_SIB5_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DynamicPersistenceLevelList", HFILL }},
    { &hf_umts_rrc_ies_prach_Information_SIB6_List,
      { "prach-Information-SIB6-List", "umts_rrc_ies.prach_Information_SIB6_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DynamicPersistenceLevelList", HFILL }},
    { &hf_umts_rrc_ies_expirationTimeFactor,
      { "expirationTimeFactor", "umts_rrc_ies.expirationTimeFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.ExpirationTimeFactor", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions8,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions8", HFILL }},
    { &hf_umts_rrc_ies_dummy1_CPCH_Parameters,
      { "dummy1-CPCH-Parameters", "umts_rrc_ies.dummy1_CPCH_Parameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CPCH_Parameters", HFILL }},
    { &hf_umts_rrc_ies_dummy2_CPCH_SetInfoList,
      { "dummy2-CPCH-SetInfoList", "umts_rrc_ies.dummy2_CPCH_SetInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CPCH_SetInfoList", HFILL }},
    { &hf_umts_rrc_ies_dummy3_CSICH_PowerOffset,
      { "dummy3-CSICH-PowerOffset", "umts_rrc_ies.dummy3_CSICH_PowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CSICH_PowerOffset", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions9,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions9", HFILL }},
    { &hf_umts_rrc_ies_dummy_CPCH_PersistenceLevelsList,
      { "dummy-CPCH-PersistenceLevelsList", "umts_rrc_ies.dummy_CPCH_PersistenceLevelsList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.CPCH_PersistenceLevelsList", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions10,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions10", HFILL }},
    { &hf_umts_rrc_ies_dummy_DRAC_SysInfoList,
      { "dummy-DRAC-SysInfoList", "umts_rrc_ies.dummy_DRAC_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.DRAC_SysInfoList", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions11,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions11", HFILL }},
    { &hf_umts_rrc_ies_sib12indicator,
      { "sib12indicator", "umts_rrc_ies.sib12indicator",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_fach_MeasurementOccasionInfo,
      { "fach-MeasurementOccasionInfo", "umts_rrc_ies.fach_MeasurementOccasionInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FACH_MeasurementOccasionInfo", HFILL }},
    { &hf_umts_rrc_ies_measurementControlSysInfo,
      { "measurementControlSysInfo", "umts_rrc_ies.measurementControlSysInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementControlSysInfo", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions4,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions4", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType11_v4b0ext,
      { "sysInfoType11-v4b0ext", "umts_rrc_ies.sysInfoType11_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType11_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtension2,
      { "v590NonCriticalExtension", "umts_rrc_ies.v590NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtension2", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType11_v590ext,
      { "sysInfoType11-v590ext", "umts_rrc_ies.sysInfoType11_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType11_v590ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v6xyNonCriticalExtensions2,
      { "v6xyNonCriticalExtensions", "umts_rrc_ies.v6xyNonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v6xyNonCriticalExtensions2", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType11_v6xyext,
      { "sysInfoType11-v6xyext", "umts_rrc_ies.sysInfoType11_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType11_v6xyext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions12,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions12", HFILL }},
    { &hf_umts_rrc_ies_fach_MeasurementOccasionInfo_LCR_Ext,
      { "fach-MeasurementOccasionInfo-LCR-Ext", "umts_rrc_ies.fach_MeasurementOccasionInfo_LCR_Ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FACH_MeasurementOccasionInfo_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_measurementControlSysInfo_LCR,
      { "measurementControlSysInfo-LCR", "umts_rrc_ies.measurementControlSysInfo_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MeasurementControlSysInfo_LCR_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext,
      { "newIntraFrequencyCellInfoList-v590ext", "umts_rrc_ies.newIntraFrequencyCellInfoList_v590ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_newIntraFrequencyCellInfoList_v590ext_item,
      { "Item", "umts_rrc_ies.newIntraFrequencyCellInfoList_v590ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_newInterFrequencyCellInfoList_v590ext,
      { "newInterFrequencyCellInfoList-v590ext", "umts_rrc_ies.newInterFrequencyCellInfoList_v590ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_newInterFrequencyCellInfoList_v590ext_item,
      { "Item", "umts_rrc_ies.newInterFrequencyCellInfoList_v590ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_newInterRATCellInfoList_v590ext,
      { "newInterRATCellInfoList-v590ext", "umts_rrc_ies.newInterRATCellInfoList_v590ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_newInterRATCellInfoList_v590ext_item,
      { "Item", "umts_rrc_ies.newInterRATCellInfoList_v590ext_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CellSelectReselectInfo_v590ext", HFILL }},
    { &hf_umts_rrc_ies_intraFreqEventCriteriaList_v590ext,
      { "intraFreqEventCriteriaList-v590ext", "umts_rrc_ies.intraFreqEventCriteriaList_v590ext",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.Intra_FreqEventCriteriaList_v590ext", HFILL }},
    { &hf_umts_rrc_ies_intraFreqReportingCriteria_1b_r5,
      { "intraFreqReportingCriteria-1b-r5", "umts_rrc_ies.intraFreqReportingCriteria_1b_r5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqReportingCriteria_1b_r5", HFILL }},
    { &hf_umts_rrc_ies_intraFreqEvent_1d_r5,
      { "intraFreqEvent-1d-r5", "umts_rrc_ies.intraFreqEvent_1d_r5",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.IntraFreqEvent_1d_r5", HFILL }},
    { &hf_umts_rrc_ies_interFreqRACHReportingInfo,
      { "interFreqRACHReportingInfo", "umts_rrc_ies.interFreqRACHReportingInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.InterFreqRACHReportingInfo", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions5,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions5", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType12_v4b0ext,
      { "sysInfoType12-v4b0ext", "umts_rrc_ies.sysInfoType12_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType12_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtension3,
      { "v590NonCriticalExtension", "umts_rrc_ies.v590NonCriticalExtension",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtension3", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType12_v590ext,
      { "sysInfoType12-v590ext", "umts_rrc_ies.sysInfoType12_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType12_v590ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v6xyNonCriticalExtensions3,
      { "v6xyNonCriticalExtensions", "umts_rrc_ies.v6xyNonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v6xyNonCriticalExtensions3", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType12_v6xyext,
      { "sysInfoType12-v6xyext", "umts_rrc_ies.sysInfoType12_v6xyext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType12_v6xyext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions13,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions13", HFILL }},
    { &hf_umts_rrc_ies_capabilityUpdateRequirement,
      { "capabilityUpdateRequirement", "umts_rrc_ies.capabilityUpdateRequirement",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CapabilityUpdateRequirement", HFILL }},
    { &hf_umts_rrc_ies_v3a0NonCriticalExtensions1,
      { "v3a0NonCriticalExtensions", "umts_rrc_ies.v3a0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v3a0NonCriticalExtensions1", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13_v3a0ext,
      { "sysInfoType13-v3a0ext", "umts_rrc_ies.sysInfoType13_v3a0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType13_v3a0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions6,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions6", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType13_v4b0ext,
      { "sysInfoType13-v4b0ext", "umts_rrc_ies.sysInfoType13_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType13_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions14,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions14", HFILL }},
    { &hf_umts_rrc_ies_capabilityUpdateRequirement_r4Ext,
      { "capabilityUpdateRequirement-r4Ext", "umts_rrc_ies.capabilityUpdateRequirement_r4Ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.CapabilityUpdateRequirement_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_ansi_41_RAND_Information,
      { "ansi-41-RAND-Information", "umts_rrc_ies.ansi_41_RAND_Information",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.ANSI_41_RAND_Information", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions15,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions15", HFILL }},
    { &hf_umts_rrc_ies_ansi_41_UserZoneID_Information,
      { "ansi-41-UserZoneID-Information", "umts_rrc_ies.ansi_41_UserZoneID_Information",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.ANSI_41_UserZoneID_Information", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions16,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions16", HFILL }},
    { &hf_umts_rrc_ies_ansi_41_PrivateNeighbourListInfo,
      { "ansi-41-PrivateNeighbourListInfo", "umts_rrc_ies.ansi_41_PrivateNeighbourListInfo",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.ANSI_41_PrivateNeighbourListInfo", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions17,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions17", HFILL }},
    { &hf_umts_rrc_ies_ansi_41_GlobalServiceRedirectInfo,
      { "ansi-41-GlobalServiceRedirectInfo", "umts_rrc_ies.ansi_41_GlobalServiceRedirectInfo",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.ANSI_41_GlobalServiceRedirectInfo", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions18,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions18", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions19,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions19", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_GPS_CipherParameters,
      { "ue-positioning-GPS-CipherParameters", "umts_rrc_ies.ue_positioning_GPS_CipherParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_CipherParameters", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions7,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions7", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_v4b0ext,
      { "sysInfoType15-v4b0ext", "umts_rrc_ies.sysInfoType15_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType15_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions20,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions20", HFILL }},
    { &hf_umts_rrc_ies_up_Ipdl_Parameters_TDD,
      { "up-Ipdl-Parameters-TDD", "umts_rrc_ies.up_Ipdl_Parameters_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_IPDL_Parameters_TDD_r4_ext", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions21,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions21", HFILL }},
    { &hf_umts_rrc_ies_transmissionTOW,
      { "transmissionTOW", "umts_rrc_ies.transmissionTOW",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_604799", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions22,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions22", HFILL }},
    { &hf_umts_rrc_ies_satMask,
      { "satMask", "umts_rrc_ies.satMask",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_1_32", HFILL }},
    { &hf_umts_rrc_ies_lsbTOW,
      { "lsbTOW", "umts_rrc_ies.lsbTOW",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.BIT_STRING_SIZE_8", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions23,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions23", HFILL }},
    { &hf_umts_rrc_ies_ue_positioning_OTDOA_CipherParameters,
      { "ue-positioning-OTDOA-CipherParameters", "umts_rrc_ies.ue_positioning_OTDOA_CipherParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_CipherParameters", HFILL }},
    { &hf_umts_rrc_ies_v3a0NonCriticalExtensions2,
      { "v3a0NonCriticalExtensions", "umts_rrc_ies.v3a0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v3a0NonCriticalExtensions2", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_4_v3a0ext,
      { "sysInfoType15-4-v3a0ext", "umts_rrc_ies.sysInfoType15_4_v3a0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType15_4_v3a0ext", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions8,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions8", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_4_v4b0ext,
      { "sysInfoType15-4-v4b0ext", "umts_rrc_ies.sysInfoType15_4_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType15_4_v4b0ext", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions24,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions24", HFILL }},
    { &hf_umts_rrc_ies_ue_Positioning_OTDOA_AssistanceData_r4ext,
      { "ue-Positioning-OTDOA-AssistanceData-r4ext", "umts_rrc_ies.ue_Positioning_OTDOA_AssistanceData_r4ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.UE_Positioning_OTDOA_AssistanceData_r4ext", HFILL }},
    { &hf_umts_rrc_ies_v3a0NonCriticalExtensions3,
      { "v3a0NonCriticalExtensions", "umts_rrc_ies.v3a0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v3a0NonCriticalExtensions3", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType15_5_v3a0ext,
      { "sysInfoType15-5-v3a0ext", "umts_rrc_ies.sysInfoType15_5_v3a0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType15_5_v3a0ext", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions25,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions25", HFILL }},
    { &hf_umts_rrc_ies_preDefinedRadioConfiguration,
      { "preDefinedRadioConfiguration", "umts_rrc_ies.preDefinedRadioConfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PreDefRadioConfiguration", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions26,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions26", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfoList,
      { "pusch-SysInfoList", "umts_rrc_ies.pusch_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfoList,
      { "pdsch-SysInfoList", "umts_rrc_ies.pdsch_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList", HFILL }},
    { &hf_umts_rrc_ies_v4b0NonCriticalExtensions9,
      { "v4b0NonCriticalExtensions", "umts_rrc_ies.v4b0NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v4b0NonCriticalExtensions9", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType17_v4b0ext,
      { "sysInfoType17-v4b0ext", "umts_rrc_ies.sysInfoType17_v4b0ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType17_v4b0ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_v590NonCriticalExtensions2,
      { "v590NonCriticalExtensions", "umts_rrc_ies.v590NonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_v590NonCriticalExtensions2", HFILL }},
    { &hf_umts_rrc_ies_sysInfoType17_v590ext,
      { "sysInfoType17-v590ext", "umts_rrc_ies.sysInfoType17_v590ext",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.SysInfoType17_v590ext_IEs", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions27,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions27", HFILL }},
    { &hf_umts_rrc_ies_tdd128SpecificInfo2,
      { "tdd128SpecificInfo", "umts_rrc_ies.tdd128SpecificInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd128SpecificInfo2", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfoList1,
      { "pusch-SysInfoList", "umts_rrc_ies.pusch_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfoList1,
      { "pdsch-SysInfoList", "umts_rrc_ies.pdsch_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_LCR_r4", HFILL }},
    { &hf_umts_rrc_ies_hcr_r5_SpecificInfo2,
      { "hcr-r5-SpecificInfo", "umts_rrc_ies.hcr_r5_SpecificInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_hcr_r5_SpecificInfo2", HFILL }},
    { &hf_umts_rrc_ies_pusch_SysInfoList2,
      { "pusch-SysInfoList", "umts_rrc_ies.pusch_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PUSCH_SysInfoList_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_pdsch_SysInfoList2,
      { "pdsch-SysInfoList", "umts_rrc_ies.pdsch_SysInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.PDSCH_SysInfoList_HCR_r5", HFILL }},
    { &hf_umts_rrc_ies_idleModePLMNIdentities,
      { "idleModePLMNIdentities", "umts_rrc_ies.idleModePLMNIdentities",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMNIdentitiesOfNeighbourCells", HFILL }},
    { &hf_umts_rrc_ies_connectedModePLMNIdentities,
      { "connectedModePLMNIdentities", "umts_rrc_ies.connectedModePLMNIdentities",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMNIdentitiesOfNeighbourCells", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions28,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions28", HFILL }},
    { &hf_umts_rrc_ies_sib_ReferenceList,
      { "sib-ReferenceList", "umts_rrc_ies.sib_ReferenceList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SIB_ReferenceList", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions29,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions29", HFILL }},
    { &hf_umts_rrc_ies_nonCriticalExtensions30,
      { "nonCriticalExtensions", "umts_rrc_ies.nonCriticalExtensions",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_nonCriticalExtensions30", HFILL }},
    { &hf_umts_rrc_ies_TDD_UMTS_Frequency_List_item,
      { "Item", "umts_rrc_ies.TDD_UMTS_Frequency_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfoTDD", HFILL }},
    { &hf_umts_rrc_ies_commonRBIdentity,
      { "commonRBIdentity", "umts_rrc_ies.commonRBIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonRBIdentity", HFILL }},
    { &hf_umts_rrc_ies_rlc_Info3,
      { "rlc-Info", "umts_rrc_ies.rlc_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.RLC_Info_MBMS_r6", HFILL }},
    { &hf_umts_rrc_ies_MBMS_CommonRBInformationList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_CommonRBInformationList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_CommonRBInformation_r6", HFILL }},
    { &hf_umts_rrc_ies_countingForUraPCH,
      { "countingForUraPCH", "umts_rrc_ies.countingForUraPCH",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_countingForCellPCH,
      { "countingForCellPCH", "umts_rrc_ies.countingForCellPCH",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_countingForCellFACH,
      { "countingForCellFACH", "umts_rrc_ies.countingForCellFACH",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_sccpchIdentity,
      { "sccpchIdentity", "umts_rrc_ies.sccpchIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_SCCPCHIdentity", HFILL }},
    { &hf_umts_rrc_ies_secondaryCCPCH_Info2,
      { "secondaryCCPCH-Info", "umts_rrc_ies.secondaryCCPCH_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonPhyChIdentity", HFILL }},
    { &hf_umts_rrc_ies_softComb_TimingOffset,
      { "softComb-TimingOffset", "umts_rrc_ies.softComb_TimingOffset",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_SoftComb_TimingOffset_vals), 0,
        "umts_rrc_ies.MBMS_SoftComb_TimingOffset", HFILL }},
    { &hf_umts_rrc_ies_transpCh_InfoCommonForAllTrCh,
      { "transpCh-InfoCommonForAllTrCh", "umts_rrc_ies.transpCh_InfoCommonForAllTrCh",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonCCTrChIdentity", HFILL }},
    { &hf_umts_rrc_ies_transpCHInformation,
      { "transpCHInformation", "umts_rrc_ies.transpCHInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_TrCHInformation_CommList", HFILL }},
    { &hf_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_CurrentCell_SCCPCHList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_CurrentCell_SCCPCH_r6", HFILL }},
    { &hf_umts_rrc_ies_MBMS_FACHCarryingMTCH_List_item,
      { "Item", "umts_rrc_ies.MBMS_FACHCarryingMTCH_List_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_TransportFormatSet_vals), 0,
        "umts_rrc_ies.TransportFormatSet", HFILL }},
    { &hf_umts_rrc_ies_cycleOffset,
      { "cycleOffset", "umts_rrc_ies.cycleOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList,
      { "mtch-L1CombiningPeriodList", "umts_rrc_ies.mtch_L1CombiningPeriodList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item,
      { "Item", "umts_rrc_ies.mtch_L1CombiningPeriodList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList_item", HFILL }},
    { &hf_umts_rrc_ies_periodStart,
      { "periodStart", "umts_rrc_ies.periodStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_periodDuration,
      { "periodDuration", "umts_rrc_ies.periodDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_8", HFILL }},
    { &hf_umts_rrc_ies_cycleOffset1,
      { "cycleOffset", "umts_rrc_ies.cycleOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList1,
      { "mtch-L1CombiningPeriodList", "umts_rrc_ies.mtch_L1CombiningPeriodList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList1", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item1,
      { "Item", "umts_rrc_ies.mtch_L1CombiningPeriodList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList_item1", HFILL }},
    { &hf_umts_rrc_ies_periodStart1,
      { "periodStart", "umts_rrc_ies.periodStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_15", HFILL }},
    { &hf_umts_rrc_ies_periodDuration1,
      { "periodDuration", "umts_rrc_ies.periodDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_16", HFILL }},
    { &hf_umts_rrc_ies_cycleOffset2,
      { "cycleOffset", "umts_rrc_ies.cycleOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList2,
      { "mtch-L1CombiningPeriodList", "umts_rrc_ies.mtch_L1CombiningPeriodList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList2", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item2,
      { "Item", "umts_rrc_ies.mtch_L1CombiningPeriodList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList_item2", HFILL }},
    { &hf_umts_rrc_ies_periodStart2,
      { "periodStart", "umts_rrc_ies.periodStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_periodDuration2,
      { "periodDuration", "umts_rrc_ies.periodDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_32", HFILL }},
    { &hf_umts_rrc_ies_cycleOffset3,
      { "cycleOffset", "umts_rrc_ies.cycleOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList3,
      { "mtch-L1CombiningPeriodList", "umts_rrc_ies.mtch_L1CombiningPeriodList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList3", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item3,
      { "Item", "umts_rrc_ies.mtch_L1CombiningPeriodList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList_item3", HFILL }},
    { &hf_umts_rrc_ies_periodStart3,
      { "periodStart", "umts_rrc_ies.periodStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_periodDuration3,
      { "periodDuration", "umts_rrc_ies.periodDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_64", HFILL }},
    { &hf_umts_rrc_ies_cycleOffset4,
      { "cycleOffset", "umts_rrc_ies.cycleOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList4,
      { "mtch-L1CombiningPeriodList", "umts_rrc_ies.mtch_L1CombiningPeriodList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList4", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item4,
      { "Item", "umts_rrc_ies.mtch_L1CombiningPeriodList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList_item4", HFILL }},
    { &hf_umts_rrc_ies_periodStart4,
      { "periodStart", "umts_rrc_ies.periodStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_periodDuration4,
      { "periodDuration", "umts_rrc_ies.periodDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_128", HFILL }},
    { &hf_umts_rrc_ies_cycleOffset5,
      { "cycleOffset", "umts_rrc_ies.cycleOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList5,
      { "mtch-L1CombiningPeriodList", "umts_rrc_ies.mtch_L1CombiningPeriodList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList5", HFILL }},
    { &hf_umts_rrc_ies_mtch_L1CombiningPeriodList_item5,
      { "Item", "umts_rrc_ies.mtch_L1CombiningPeriodList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_mtch_L1CombiningPeriodList_item5", HFILL }},
    { &hf_umts_rrc_ies_periodStart5,
      { "periodStart", "umts_rrc_ies.periodStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_periodDuration5,
      { "periodDuration", "umts_rrc_ies.periodDuration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_256", HFILL }},
    { &hf_umts_rrc_ies_cycleLength_32,
      { "cycleLength-32", "umts_rrc_ies.cycleLength_32",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule_32", HFILL }},
    { &hf_umts_rrc_ies_cycleLength_64,
      { "cycleLength-64", "umts_rrc_ies.cycleLength_64",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule_64", HFILL }},
    { &hf_umts_rrc_ies_cycleLength_128,
      { "cycleLength-128", "umts_rrc_ies.cycleLength_128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule_128", HFILL }},
    { &hf_umts_rrc_ies_cycleLength_256,
      { "cycleLength-256", "umts_rrc_ies.cycleLength_256",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule_256", HFILL }},
    { &hf_umts_rrc_ies_cycleLength_512,
      { "cycleLength-512", "umts_rrc_ies.cycleLength_512",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule_512", HFILL }},
    { &hf_umts_rrc_ies_cycleLength_1024,
      { "cycleLength-1024", "umts_rrc_ies.cycleLength_1024",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule_1024", HFILL }},
    { &hf_umts_rrc_ies_sameAsCurrent,
      { "sameAsCurrent", "umts_rrc_ies.sameAsCurrent",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_sameAsCurrent", HFILL }},
    { &hf_umts_rrc_ies_currentCell_SCCPCH,
      { "currentCell-SCCPCH", "umts_rrc_ies.currentCell_SCCPCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_SCCPCHIdentity", HFILL }},
    { &hf_umts_rrc_ies_different,
      { "different", "umts_rrc_ies.different",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_different", HFILL }},
    { &hf_umts_rrc_ies_transpCHInformation1,
      { "transpCHInformation", "umts_rrc_ies.transpCHInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_TrCHInformation_NeighbList", HFILL }},
    { &hf_umts_rrc_ies_accessInfoPeriodCoefficient,
      { "accessInfoPeriodCoefficient", "umts_rrc_ies.accessInfoPeriodCoefficient",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriodCoefficient,
      { "repetitionPeriodCoefficient", "umts_rrc_ies.repetitionPeriodCoefficient",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_3", HFILL }},
    { &hf_umts_rrc_ies_modificationPeriodCoefficient,
      { "modificationPeriodCoefficient", "umts_rrc_ies.modificationPeriodCoefficient",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_7_10", HFILL }},
    { &hf_umts_rrc_ies_tctf_Presence,
      { "tctf-Presence", "umts_rrc_ies.tctf_Presence",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_TCTF_Presence_vals), 0,
        "umts_rrc_ies.MBMS_TCTF_Presence", HFILL }},
    { &hf_umts_rrc_ies_michPowerOffset,
      { "michPowerOffset", "umts_rrc_ies.michPowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_MICHPowerOffset", HFILL }},
    { &hf_umts_rrc_ies_mode,
      { "mode", "umts_rrc_ies.mode",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_mode_vals), 0,
        "umts_rrc_ies.T_mode", HFILL }},
    { &hf_umts_rrc_ies_fdd95,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd90", HFILL }},
    { &hf_umts_rrc_ies_ni_CountPerFrame,
      { "ni-CountPerFrame", "umts_rrc_ies.ni_CountPerFrame",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_NI_CountPerFrame_vals), 0,
        "umts_rrc_ies.MBMS_NI_CountPerFrame", HFILL }},
    { &hf_umts_rrc_ies_tdd38419,
      { "tdd384", "umts_rrc_ies.tdd384",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd38415", HFILL }},
    { &hf_umts_rrc_ies_repetitionPeriodLengthOffset1,
      { "repetitionPeriodLengthOffset", "umts_rrc_ies.repetitionPeriodLengthOffset",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_RepPerLengthOffset_MICH_vals), 0,
        "umts_rrc_ies.RepPerLengthOffset_MICH", HFILL }},
    { &hf_umts_rrc_ies_mbmsNotificationIndLength,
      { "mbmsNotificationIndLength", "umts_rrc_ies.mbmsNotificationIndLength",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_MICHNotificationIndLength_vals), 0,
        "umts_rrc_ies.MBMS_MICHNotificationIndLength", HFILL }},
    { &hf_umts_rrc_ies_tdd12821,
      { "tdd128", "umts_rrc_ies.tdd128",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_tdd12817", HFILL }},
    { &hf_umts_rrc_ies_channelisationCodeList1,
      { "channelisationCodeList", "umts_rrc_ies.channelisationCodeList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_channelisationCodeList_item,
      { "Item", "umts_rrc_ies.channelisationCodeList_item",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_DL_TS_ChannelisationCode_vals), 0,
        "umts_rrc_ies.DL_TS_ChannelisationCode", HFILL }},
    { &hf_umts_rrc_ies_mbms_TransmissionIdentity,
      { "mbms-TransmissionIdentity", "umts_rrc_ies.mbms_TransmissionIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_TransmissionIdentity", HFILL }},
    { &hf_umts_rrc_ies_mbms_RequiredUEAction,
      { "mbms-RequiredUEAction", "umts_rrc_ies.mbms_RequiredUEAction",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_RequiredUEAction_Mod_vals), 0,
        "umts_rrc_ies.MBMS_RequiredUEAction_Mod", HFILL }},
    { &hf_umts_rrc_ies_mbms_PreferredFrequency,
      { "mbms-PreferredFrequency", "umts_rrc_ies.mbms_PreferredFrequency",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_mbms_PreferredFrequency_vals), 0,
        "umts_rrc_ies.T_mbms_PreferredFrequency", HFILL }},
    { &hf_umts_rrc_ies_mcch,
      { "mcch", "umts_rrc_ies.mcch",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_PFLIndex", HFILL }},
    { &hf_umts_rrc_ies_dcch,
      { "dcch", "umts_rrc_ies.dcch",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_PFLInfo", HFILL }},
    { &hf_umts_rrc_ies_mbms_DispersionIndicator,
      { "mbms-DispersionIndicator", "umts_rrc_ies.mbms_DispersionIndicator",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_mbms_DispersionIndicator_vals), 0,
        "umts_rrc_ies.T_mbms_DispersionIndicator", HFILL }},
    { &hf_umts_rrc_ies_continueMCCHReading,
      { "continueMCCHReading", "umts_rrc_ies.continueMCCHReading",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_MBMS_ModifedServiceList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_ModifedServiceList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_ModifedService_r6", HFILL }},
    { &hf_umts_rrc_ies_mschShedulingInfo,
      { "mschShedulingInfo", "umts_rrc_ies.mschShedulingInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_MSCHSchedulingInfo_vals), 0,
        "umts_rrc_ies.MBMS_MSCHSchedulingInfo", HFILL }},
    { &hf_umts_rrc_ies_schedulingPeriod_32_Offset,
      { "schedulingPeriod-32-Offset", "umts_rrc_ies.schedulingPeriod_32_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_schedulingPeriod_64_Offset,
      { "schedulingPeriod-64-Offset", "umts_rrc_ies.schedulingPeriod_64_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_63", HFILL }},
    { &hf_umts_rrc_ies_schedulingPeriod_128_Offset,
      { "schedulingPeriod-128-Offset", "umts_rrc_ies.schedulingPeriod_128_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_127", HFILL }},
    { &hf_umts_rrc_ies_schedulingPeriod_256_Offset,
      { "schedulingPeriod-256-Offset", "umts_rrc_ies.schedulingPeriod_256_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_schedulingPeriod_512_Offset,
      { "schedulingPeriod-512-Offset", "umts_rrc_ies.schedulingPeriod_512_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_511", HFILL }},
    { &hf_umts_rrc_ies_schedulingPeriod_1024_Offset,
      { "schedulingPeriod-1024-Offset", "umts_rrc_ies.schedulingPeriod_1024_Offset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_1023", HFILL }},
    { &hf_umts_rrc_ies_secondaryCCPCHPwrOffsetDiff,
      { "secondaryCCPCHPwrOffsetDiff", "umts_rrc_ies.secondaryCCPCHPwrOffsetDiff",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_SCCPCHPwrOffsetDiff_vals), 0,
        "umts_rrc_ies.MBMS_SCCPCHPwrOffsetDiff", HFILL }},
    { &hf_umts_rrc_ies_layer1Combining,
      { "layer1Combining", "umts_rrc_ies.layer1Combining",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_layer1Combining_vals), 0,
        "umts_rrc_ies.T_layer1Combining", HFILL }},
    { &hf_umts_rrc_ies_fdd96,
      { "fdd", "umts_rrc_ies.fdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.T_fdd91", HFILL }},
    { &hf_umts_rrc_ies_mbms_L1CombiningTransmTimeDiff,
      { "mbms-L1CombiningTransmTimeDiff", "umts_rrc_ies.mbms_L1CombiningTransmTimeDiff",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_L1CombiningTransmTimeDiff", HFILL }},
    { &hf_umts_rrc_ies_mbms_L1CombiningSchedule,
      { "mbms-L1CombiningSchedule", "umts_rrc_ies.mbms_L1CombiningSchedule",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_L1CombiningSchedule_vals), 0,
        "umts_rrc_ies.MBMS_L1CombiningSchedule", HFILL }},
    { &hf_umts_rrc_ies_mbms_L23Configuration,
      { "mbms-L23Configuration", "umts_rrc_ies.mbms_L23Configuration",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_L23Configuration_vals), 0,
        "umts_rrc_ies.MBMS_L23Configuration", HFILL }},
    { &hf_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_NeighbouringCellSCCPCHList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_NeighbouringCellSCCPCH_r6", HFILL }},
    { &hf_umts_rrc_ies_mbms_CommonPhyChIdentity,
      { "mbms-CommonPhyChIdentity", "umts_rrc_ies.mbms_CommonPhyChIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonPhyChIdentity", HFILL }},
    { &hf_umts_rrc_ies_MBMS_PhyChInformationList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_PhyChInformationList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_PhyChInformation_r6", HFILL }},
    { &hf_umts_rrc_ies_preferredFreqRequest,
      { "preferredFreqRequest", "umts_rrc_ies.preferredFreqRequest",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.FrequencyInfo", HFILL }},
    { &hf_umts_rrc_ies_mbmsPreferredFrequency,
      { "mbmsPreferredFrequency", "umts_rrc_ies.mbmsPreferredFrequency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxMBMSFreq", HFILL }},
    { &hf_umts_rrc_ies_layerConvergenceInformation,
      { "layerConvergenceInformation", "umts_rrc_ies.layerConvergenceInformation",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_layerConvergenceInformation_vals), 0,
        "umts_rrc_ies.T_layerConvergenceInformation", HFILL }},
    { &hf_umts_rrc_ies_mbms_Qoffset,
      { "mbms-Qoffset", "umts_rrc_ies.mbms_Qoffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_mbms_HCSoffset,
      { "mbms-HCSoffset", "umts_rrc_ies.mbms_HCSoffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_7", HFILL }},
    { &hf_umts_rrc_ies_mbms_PL_ServiceRestrictInfo,
      { "mbms-PL-ServiceRestrictInfo", "umts_rrc_ies.mbms_PL_ServiceRestrictInfo",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_PL_ServiceRestrictInfo_r6_vals), 0,
        "umts_rrc_ies.MBMS_PL_ServiceRestrictInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_MBMS_PreferredFrequencyList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_PreferredFrequencyList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_PreferredFrequencyInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_rbInformation,
      { "rbInformation", "umts_rrc_ies.rbInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonRBIdentity", HFILL }},
    { &hf_umts_rrc_ies_shortTransmissionID,
      { "shortTransmissionID", "umts_rrc_ies.shortTransmissionID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_ShortTransmissionID", HFILL }},
    { &hf_umts_rrc_ies_logicalChIdentity,
      { "logicalChIdentity", "umts_rrc_ies.logicalChIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_LogicalChIdentity", HFILL }},
    { &hf_umts_rrc_ies_MBMS_PTM_RBInformation_CList_item,
      { "Item", "umts_rrc_ies.MBMS_PTM_RBInformation_CList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_PTM_RBInformation_C", HFILL }},
    { &hf_umts_rrc_ies_layer1_CombiningStatus,
      { "layer1-CombiningStatus", "umts_rrc_ies.layer1_CombiningStatus",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_layer1_CombiningStatus_vals), 0,
        "umts_rrc_ies.T_layer1_CombiningStatus", HFILL }},
    { &hf_umts_rrc_ies_MBMS_PTM_RBInformation_NList_item,
      { "Item", "umts_rrc_ies.MBMS_PTM_RBInformation_NList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_PTM_RBInformation_N", HFILL }},
    { &hf_umts_rrc_ies_MBMS_PTM_RBInformation_SList_item,
      { "Item", "umts_rrc_ies.MBMS_PTM_RBInformation_SList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_PTM_RBInformation_S", HFILL }},
    { &hf_umts_rrc_ies_accessprobabilityFactor_Idle,
      { "accessprobabilityFactor-Idle", "umts_rrc_ies.accessprobabilityFactor_Idle",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_AccessProbabilityFactor_vals), 0,
        "umts_rrc_ies.MBMS_AccessProbabilityFactor", HFILL }},
    { &hf_umts_rrc_ies_accessprobabilityFactor_UraPCH,
      { "accessprobabilityFactor-UraPCH", "umts_rrc_ies.accessprobabilityFactor_UraPCH",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_AccessProbabilityFactor_vals), 0,
        "umts_rrc_ies.MBMS_AccessProbabilityFactor", HFILL }},
    { &hf_umts_rrc_ies_mbms_ConnectedModeCountingScope,
      { "mbms-ConnectedModeCountingScope", "umts_rrc_ies.mbms_ConnectedModeCountingScope",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_ConnectedModeCountingScope", HFILL }},
    { &hf_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_ServiceAccessInfoList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_ServiceAccessInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_serviceIdentity,
      { "serviceIdentity", "umts_rrc_ies.serviceIdentity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "umts_rrc_ies.OCTET_STRING_SIZE_3", HFILL }},
    { &hf_umts_rrc_ies_plmn_Identity1,
      { "plmn-Identity", "umts_rrc_ies.plmn_Identity",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_plmn_Identity_vals), 0,
        "umts_rrc_ies.T_plmn_Identity", HFILL }},
    { &hf_umts_rrc_ies_sameAsMIB_PLMN_Id,
      { "sameAsMIB-PLMN-Id", "umts_rrc_ies.sameAsMIB_PLMN_Id",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.NULL", HFILL }},
    { &hf_umts_rrc_ies_other1,
      { "other", "umts_rrc_ies.other",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_other1_vals), 0,
        "umts_rrc_ies.T_other1", HFILL }},
    { &hf_umts_rrc_ies_sameAsMIB_MultiPLMN_Id,
      { "sameAsMIB-MultiPLMN-Id", "umts_rrc_ies.sameAsMIB_MultiPLMN_Id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_5", HFILL }},
    { &hf_umts_rrc_ies_explicitPLMN_Id,
      { "explicitPLMN-Id", "umts_rrc_ies.explicitPLMN_Id",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.PLMN_Identity", HFILL }},
    { &hf_umts_rrc_ies_mbms_ServiceTransmInfoList,
      { "mbms-ServiceTransmInfoList", "umts_rrc_ies.mbms_ServiceTransmInfoList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_ServiceTransmInfoList", HFILL }},
    { &hf_umts_rrc_ies_nextSchedulingperiod,
      { "nextSchedulingperiod", "umts_rrc_ies.nextSchedulingperiod",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_31", HFILL }},
    { &hf_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_ServiceSchedulingInfoList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_ServiceSchedulingInfo_r6", HFILL }},
    { &hf_umts_rrc_ies_start,
      { "start", "umts_rrc_ies.start",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_0_255", HFILL }},
    { &hf_umts_rrc_ies_duration,
      { "duration", "umts_rrc_ies.duration",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_256", HFILL }},
    { &hf_umts_rrc_ies_MBMS_ServiceTransmInfoList_item,
      { "Item", "umts_rrc_ies.MBMS_ServiceTransmInfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_ServiceTransmInfo", HFILL }},
    { &hf_umts_rrc_ies_transpCHInformation2,
      { "transpCHInformation", "umts_rrc_ies.transpCHInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_TrCHInformation_SIB5List", HFILL }},
    { &hf_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_SIBType5_SCCPCHList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_SIBType5_SCCPCH_r6", HFILL }},
    { &hf_umts_rrc_ies_t_318,
      { "t-318", "umts_rrc_ies.t_318",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_T_318_vals), 0,
        "umts_rrc_ies.T_318", HFILL }},
    { &hf_umts_rrc_ies_mbms_ServiceIdentity,
      { "mbms-ServiceIdentity", "umts_rrc_ies.mbms_ServiceIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_ServiceIdentity", HFILL }},
    { &hf_umts_rrc_ies_commonCCTrChIdentity,
      { "commonCCTrChIdentity", "umts_rrc_ies.commonCCTrChIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonCCTrChIdentity", HFILL }},
    { &hf_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6_item,
      { "Item", "umts_rrc_ies.MBMS_TranspChInfoForEachCCTrCh_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_TranspChInfoForCCTrCh_r6", HFILL }},
    { &hf_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6_item,
      { "Item", "umts_rrc_ies.MBMS_TranspChInfoForEachTrCh_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_TranspChInfoForTrCh_r6", HFILL }},
    { &hf_umts_rrc_ies_commonTrChIdentity,
      { "commonTrChIdentity", "umts_rrc_ies.commonTrChIdentity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonTrChIdentity", HFILL }},
    { &hf_umts_rrc_ies_transpCh_Info,
      { "transpCh-Info", "umts_rrc_ies.transpCh_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_CommonTrChIdentity", HFILL }},
    { &hf_umts_rrc_ies_rbInformation1,
      { "rbInformation", "umts_rrc_ies.rbInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_PTM_RBInformation_CList", HFILL }},
    { &hf_umts_rrc_ies_MBMS_TrCHInformation_CommList_item,
      { "Item", "umts_rrc_ies.MBMS_TrCHInformation_CommList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_TrCHInformation_Comm", HFILL }},
    { &hf_umts_rrc_ies_transpCh_CombiningStatus,
      { "transpCh-CombiningStatus", "umts_rrc_ies.transpCh_CombiningStatus",
        FT_BOOLEAN, 8, NULL, 0,
        "umts_rrc_ies.BOOLEAN", HFILL }},
    { &hf_umts_rrc_ies_rbInformation2,
      { "rbInformation", "umts_rrc_ies.rbInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_PTM_RBInformation_NList", HFILL }},
    { &hf_umts_rrc_ies_MBMS_TrCHInformation_NeighbList_item,
      { "Item", "umts_rrc_ies.MBMS_TrCHInformation_NeighbList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_TrCHInformation_Neighb", HFILL }},
    { &hf_umts_rrc_ies_transpCh_Identity,
      { "transpCh-Identity", "umts_rrc_ies.transpCh_Identity",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.INTEGER_1_maxFACHPCH", HFILL }},
    { &hf_umts_rrc_ies_rbInformation3,
      { "rbInformation", "umts_rrc_ies.rbInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_PTM_RBInformation_SList", HFILL }},
    { &hf_umts_rrc_ies_MBMS_TrCHInformation_SIB5List_item,
      { "Item", "umts_rrc_ies.MBMS_TrCHInformation_SIB5List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_TrCHInformation_SIB5", HFILL }},
    { &hf_umts_rrc_ies_mbms_RequiredUEAction1,
      { "mbms-RequiredUEAction", "umts_rrc_ies.mbms_RequiredUEAction",
        FT_UINT32, BASE_DEC, VALS(umts_rrc_ies_MBMS_RequiredUEAction_UMod_vals), 0,
        "umts_rrc_ies.MBMS_RequiredUEAction_UMod", HFILL }},
    { &hf_umts_rrc_ies_mbms_PreferredFrequency1,
      { "mbms-PreferredFrequency", "umts_rrc_ies.mbms_PreferredFrequency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "umts_rrc_ies.MBMS_PFLIndex", HFILL }},
    { &hf_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6_item,
      { "Item", "umts_rrc_ies.MBMS_UnmodifiedServiceList_r6_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "umts_rrc_ies.MBMS_UnmodifiedService_r6", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare15,
      { "spare15", "umts_rrc_ies.spare15",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare14,
      { "spare14", "umts_rrc_ies.spare14",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare13,
      { "spare13", "umts_rrc_ies.spare13",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare12,
      { "spare12", "umts_rrc_ies.spare12",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare11,
      { "spare11", "umts_rrc_ies.spare11",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare10,
      { "spare10", "umts_rrc_ies.spare10",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare9,
      { "spare9", "umts_rrc_ies.spare9",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare8,
      { "spare8", "umts_rrc_ies.spare8",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare7,
      { "spare7", "umts_rrc_ies.spare7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare6,
      { "spare6", "umts_rrc_ies.spare6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare5,
      { "spare5", "umts_rrc_ies.spare5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare4,
      { "spare4", "umts_rrc_ies.spare4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare3,
      { "spare3", "umts_rrc_ies.spare3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_spare2,
      { "spare2", "umts_rrc_ies.spare2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_uea1,
      { "uea1", "umts_rrc_ies.uea1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_cipheringAlgorithmCap_uea0,
      { "uea0", "umts_rrc_ies.uea0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare15,
      { "spare15", "umts_rrc_ies.spare15",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare14,
      { "spare14", "umts_rrc_ies.spare14",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare13,
      { "spare13", "umts_rrc_ies.spare13",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare12,
      { "spare12", "umts_rrc_ies.spare12",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare11,
      { "spare11", "umts_rrc_ies.spare11",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare10,
      { "spare10", "umts_rrc_ies.spare10",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare9,
      { "spare9", "umts_rrc_ies.spare9",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare8,
      { "spare8", "umts_rrc_ies.spare8",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare7,
      { "spare7", "umts_rrc_ies.spare7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare6,
      { "spare6", "umts_rrc_ies.spare6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare5,
      { "spare5", "umts_rrc_ies.spare5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare4,
      { "spare4", "umts_rrc_ies.spare4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare3,
      { "spare3", "umts_rrc_ies.spare3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare2,
      { "spare2", "umts_rrc_ies.spare2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_uia1,
      { "uia1", "umts_rrc_ies.uia1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_integrityProtectionAlgorithmCap_spare0,
      { "spare0", "umts_rrc_ies.spare0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_assignedSubChannelNumber_b3,
      { "b3", "umts_rrc_ies.b3",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_assignedSubChannelNumber_b2,
      { "b2", "umts_rrc_ies.b2",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_assignedSubChannelNumber_b1,
      { "b1", "umts_rrc_ies.b1",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_assignedSubChannelNumber_b0,
      { "b0", "umts_rrc_ies.b0",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex7,
      { "chCodeIndex7", "umts_rrc_ies.chCodeIndex7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex6,
      { "chCodeIndex6", "umts_rrc_ies.chCodeIndex6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex5,
      { "chCodeIndex5", "umts_rrc_ies.chCodeIndex5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex4,
      { "chCodeIndex4", "umts_rrc_ies.chCodeIndex4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex3,
      { "chCodeIndex3", "umts_rrc_ies.chCodeIndex3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex2,
      { "chCodeIndex2", "umts_rrc_ies.chCodeIndex2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex1,
      { "chCodeIndex1", "umts_rrc_ies.chCodeIndex1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_channelisationCodeIndices_chCodeIndex0,
      { "chCodeIndex0", "umts_rrc_ies.chCodeIndex0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels1_subCh3,
      { "subCh3", "umts_rrc_ies.subCh3",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels1_subCh2,
      { "subCh2", "umts_rrc_ies.subCh2",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels1_subCh1,
      { "subCh1", "umts_rrc_ies.subCh1",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels1_subCh0,
      { "subCh0", "umts_rrc_ies.subCh0",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh7,
      { "subCh7", "umts_rrc_ies.subCh7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh6,
      { "subCh6", "umts_rrc_ies.subCh6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh5,
      { "subCh5", "umts_rrc_ies.subCh5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh4,
      { "subCh4", "umts_rrc_ies.subCh4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh3,
      { "subCh3", "umts_rrc_ies.subCh3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh2,
      { "subCh2", "umts_rrc_ies.subCh2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh1,
      { "subCh1", "umts_rrc_ies.subCh1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels2_subCh0,
      { "subCh0", "umts_rrc_ies.subCh0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex7,
      { "sulCodeIndex7", "umts_rrc_ies.sulCodeIndex7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex6,
      { "sulCodeIndex6", "umts_rrc_ies.sulCodeIndex6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex5,
      { "sulCodeIndex5", "umts_rrc_ies.sulCodeIndex5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex4,
      { "sulCodeIndex4", "umts_rrc_ies.sulCodeIndex4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex3,
      { "sulCodeIndex3", "umts_rrc_ies.sulCodeIndex3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex2,
      { "sulCodeIndex2", "umts_rrc_ies.sulCodeIndex2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex1,
      { "sulCodeIndex1", "umts_rrc_ies.sulCodeIndex1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_availableSYNC_UlCodesIndics_sulCodeIndex0,
      { "sulCodeIndex0", "umts_rrc_ies.sulCodeIndex0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels4_subCh3,
      { "subCh3", "umts_rrc_ies.subCh3",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels4_subCh2,
      { "subCh2", "umts_rrc_ies.subCh2",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels4_subCh1,
      { "subCh1", "umts_rrc_ies.subCh1",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels4_subCh0,
      { "subCh0", "umts_rrc_ies.subCh0",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh7,
      { "subCh7", "umts_rrc_ies.subCh7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh6,
      { "subCh6", "umts_rrc_ies.subCh6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh5,
      { "subCh5", "umts_rrc_ies.subCh5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh4,
      { "subCh4", "umts_rrc_ies.subCh4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh3,
      { "subCh3", "umts_rrc_ies.subCh3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh2,
      { "subCh2", "umts_rrc_ies.subCh2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh1,
      { "subCh1", "umts_rrc_ies.subCh1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_subchannels5_subCh0,
      { "subCh0", "umts_rrc_ies.subCh0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature15,
      { "signature15", "umts_rrc_ies.signature15",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature14,
      { "signature14", "umts_rrc_ies.signature14",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature13,
      { "signature13", "umts_rrc_ies.signature13",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature12,
      { "signature12", "umts_rrc_ies.signature12",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature11,
      { "signature11", "umts_rrc_ies.signature11",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature10,
      { "signature10", "umts_rrc_ies.signature10",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature9,
      { "signature9", "umts_rrc_ies.signature9",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature8,
      { "signature8", "umts_rrc_ies.signature8",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature7,
      { "signature7", "umts_rrc_ies.signature7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature6,
      { "signature6", "umts_rrc_ies.signature6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature5,
      { "signature5", "umts_rrc_ies.signature5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature4,
      { "signature4", "umts_rrc_ies.signature4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature3,
      { "signature3", "umts_rrc_ies.signature3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature2,
      { "signature2", "umts_rrc_ies.signature2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature1,
      { "signature1", "umts_rrc_ies.signature1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSignatures_signature0,
      { "signature0", "umts_rrc_ies.signature0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh11,
      { "subCh11", "umts_rrc_ies.subCh11",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh10,
      { "subCh10", "umts_rrc_ies.subCh10",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh9,
      { "subCh9", "umts_rrc_ies.subCh9",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh8,
      { "subCh8", "umts_rrc_ies.subCh8",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh7,
      { "subCh7", "umts_rrc_ies.subCh7",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh6,
      { "subCh6", "umts_rrc_ies.subCh6",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh5,
      { "subCh5", "umts_rrc_ies.subCh5",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh4,
      { "subCh4", "umts_rrc_ies.subCh4",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh3,
      { "subCh3", "umts_rrc_ies.subCh3",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh2,
      { "subCh2", "umts_rrc_ies.subCh2",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh1,
      { "subCh1", "umts_rrc_ies.subCh1",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_AvailableSubChannelNumbers_subCh0,
      { "subCh0", "umts_rrc_ies.subCh0",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode16_SF16,
      { "chCode16-SF16", "umts_rrc_ies.chCode16-SF16",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode15_SF16,
      { "chCode15-SF16", "umts_rrc_ies.chCode15-SF16",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode14_SF16,
      { "chCode14-SF16", "umts_rrc_ies.chCode14-SF16",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode13_SF16,
      { "chCode13-SF16", "umts_rrc_ies.chCode13-SF16",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode12_SF16,
      { "chCode12-SF16", "umts_rrc_ies.chCode12-SF16",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode11_SF16,
      { "chCode11-SF16", "umts_rrc_ies.chCode11-SF16",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode10_SF16,
      { "chCode10-SF16", "umts_rrc_ies.chCode10-SF16",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode9_SF16,
      { "chCode9-SF16", "umts_rrc_ies.chCode9-SF16",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode8_SF16,
      { "chCode8-SF16", "umts_rrc_ies.chCode8-SF16",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode7_SF16,
      { "chCode7-SF16", "umts_rrc_ies.chCode7-SF16",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode6_SF16,
      { "chCode6-SF16", "umts_rrc_ies.chCode6-SF16",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode5_SF16,
      { "chCode5-SF16", "umts_rrc_ies.chCode5-SF16",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode4_SF16,
      { "chCode4-SF16", "umts_rrc_ies.chCode4-SF16",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode3_SF16,
      { "chCode3-SF16", "umts_rrc_ies.chCode3-SF16",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode2_SF16,
      { "chCode2-SF16", "umts_rrc_ies.chCode2-SF16",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_bitmap_chCode1_SF16,
      { "chCode1-SF16", "umts_rrc_ies.chCode1-SF16",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code7,
      { "code7", "umts_rrc_ies.code7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code6,
      { "code6", "umts_rrc_ies.code6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code5,
      { "code5", "umts_rrc_ies.code5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code4,
      { "code4", "umts_rrc_ies.code4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code3,
      { "code3", "umts_rrc_ies.code3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code2,
      { "code2", "umts_rrc_ies.code2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code1,
      { "code1", "umts_rrc_ies.code1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_CodesBitmap_code0,
      { "code0", "umts_rrc_ies.code0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code7,
      { "code7", "umts_rrc_ies.code7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code6,
      { "code6", "umts_rrc_ies.code6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code5,
      { "code5", "umts_rrc_ies.code5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code4,
      { "code4", "umts_rrc_ies.code4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code3,
      { "code3", "umts_rrc_ies.code3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code2,
      { "code2", "umts_rrc_ies.code2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code1,
      { "code1", "umts_rrc_ies.code1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_T_sync_UL_Codes_Bitmap_code0,
      { "code0", "umts_rrc_ies.code0",
        FT_BOOLEAN, 8, NULL, 0x01,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_7,
      { "a5-7", "umts_rrc_ies.a5-7",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_6,
      { "a5-6", "umts_rrc_ies.a5-6",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_5,
      { "a5-5", "umts_rrc_ies.a5-5",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_4,
      { "a5-4", "umts_rrc_ies.a5-4",
        FT_BOOLEAN, 8, NULL, 0x10,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_3,
      { "a5-3", "umts_rrc_ies.a5-3",
        FT_BOOLEAN, 8, NULL, 0x08,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_2,
      { "a5-2", "umts_rrc_ies.a5-2",
        FT_BOOLEAN, 8, NULL, 0x04,
        "", HFILL }},
    { &hf_umts_rrc_ies_GsmSecurityCapability_a5_1,
      { "a5-1", "umts_rrc_ies.a5-1",
        FT_BOOLEAN, 8, NULL, 0x02,
        "", HFILL }},
    { &hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea0,
      { "gea0", "umts_rrc_ies.gea0",
        FT_BOOLEAN, 8, NULL, 0x80,
        "", HFILL }},
    { &hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea1,
      { "gea1", "umts_rrc_ies.gea1",
        FT_BOOLEAN, 8, NULL, 0x40,
        "", HFILL }},
    { &hf_umts_rrc_ies_GSMSecurityCapability_v6xyext_gea2,
      { "gea2", "umts_rrc_ies.gea2",
        FT_BOOLEAN, 8, NULL, 0x20,
        "", HFILL }},

/*--- End of included file: packet-umts_rrc_ies-hfarr.c ---*/
#line 83 "packet-umts_rrc_ies-template.c"
  };

  /* List of subtrees */
  static gint *ett[] = {
		  &ett_umts_rrc_ies,

/*--- Included file: packet-umts_rrc_ies-ettarr.c ---*/
#line 1 "packet-umts_rrc_ies-ettarr.c"
    &ett_umts_rrc_ies_CN_DomainInformation,
    &ett_umts_rrc_ies_CN_DomainInformationFull,
    &ett_umts_rrc_ies_CN_DomainInformationList,
    &ett_umts_rrc_ies_CN_DomainInformationListFull,
    &ett_umts_rrc_ies_CN_DomainSysInfo,
    &ett_umts_rrc_ies_T_cn_Type,
    &ett_umts_rrc_ies_CN_DomainSysInfoList,
    &ett_umts_rrc_ies_CN_InformationInfo,
    &ett_umts_rrc_ies_CN_InformationInfo_r6,
    &ett_umts_rrc_ies_CN_InformationInfoFull,
    &ett_umts_rrc_ies_Gsm_map_IDNNS,
    &ett_umts_rrc_ies_T_routingbasis,
    &ett_umts_rrc_ies_T_localPTMSI,
    &ett_umts_rrc_ies_T_tMSIofsamePLMN,
    &ett_umts_rrc_ies_T_tMSIofdifferentPLMN,
    &ett_umts_rrc_ies_T_iMSIresponsetopaging,
    &ett_umts_rrc_ies_T_iMSIcauseUEinitiatedEvent,
    &ett_umts_rrc_ies_T_iMEI,
    &ett_umts_rrc_ies_T_spare2,
    &ett_umts_rrc_ies_T_spare1,
    &ett_umts_rrc_ies_IMEI,
    &ett_umts_rrc_ies_IMSI_GSM_MAP,
    &ett_umts_rrc_ies_IntraDomainNasNodeSelector,
    &ett_umts_rrc_ies_T_version,
    &ett_umts_rrc_ies_T_release99,
    &ett_umts_rrc_ies_T_cn_Type1,
    &ett_umts_rrc_ies_T_later,
    &ett_umts_rrc_ies_LAI,
    &ett_umts_rrc_ies_MCC,
    &ett_umts_rrc_ies_MNC,
    &ett_umts_rrc_ies_MultiplePLMN_List_r6,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_5_OF_PLMN_IdentityWithOptionalMCC_r6,
    &ett_umts_rrc_ies_PLMN_Identity,
    &ett_umts_rrc_ies_PLMN_IdentityWithOptionalMCC_r6,
    &ett_umts_rrc_ies_PLMN_Type,
    &ett_umts_rrc_ies_T_gsm_MAP,
    &ett_umts_rrc_ies_T_ansi_41,
    &ett_umts_rrc_ies_T_gsm_MAP_and_ANSI_41,
    &ett_umts_rrc_ies_RAB_Identity,
    &ett_umts_rrc_ies_RAI,
    &ett_umts_rrc_ies_AccessClassBarredList,
    &ett_umts_rrc_ies_CellAccessRestriction,
    &ett_umts_rrc_ies_CellBarred,
    &ett_umts_rrc_ies_T_barred,
    &ett_umts_rrc_ies_CellIdentity_PerRL_List,
    &ett_umts_rrc_ies_CellSelectReselectInfoSIB_3_4,
    &ett_umts_rrc_ies_T_cellSelectQualityMeasure,
    &ett_umts_rrc_ies_T_cpich_Ec_N0,
    &ett_umts_rrc_ies_T_modeSpecificInfo,
    &ett_umts_rrc_ies_T_fdd,
    &ett_umts_rrc_ies_T_tdd,
    &ett_umts_rrc_ies_DomainSpecificAccessRestrictionForSharedNetwork_v670ext,
    &ett_umts_rrc_ies_DomainSpecificAccessRestrictionList_v670ext,
    &ett_umts_rrc_ies_DomainSpecificAccessRestrictionParam_v670ext,
    &ett_umts_rrc_ies_DomainSpecificAccessRestriction_v670ext,
    &ett_umts_rrc_ies_T_restriction,
    &ett_umts_rrc_ies_Mapping,
    &ett_umts_rrc_ies_Mapping_LCR_r4,
    &ett_umts_rrc_ies_MappingFunctionParameter,
    &ett_umts_rrc_ies_MappingFunctionParameterList,
    &ett_umts_rrc_ies_MappingInfo,
    &ett_umts_rrc_ies_RAT_FDD_Info,
    &ett_umts_rrc_ies_RAT_FDD_InfoList,
    &ett_umts_rrc_ies_RAT_TDD_Info,
    &ett_umts_rrc_ies_RAT_TDD_InfoList,
    &ett_umts_rrc_ies_URA_IdentityList,
    &ett_umts_rrc_ies_BackoffControlParams,
    &ett_umts_rrc_ies_CapabilityUpdateRequirement,
    &ett_umts_rrc_ies_CapabilityUpdateRequirement_r4_ext,
    &ett_umts_rrc_ies_CapabilityUpdateRequirement_r4,
    &ett_umts_rrc_ies_CipheringModeCommand,
    &ett_umts_rrc_ies_CipheringModeInfo,
    &ett_umts_rrc_ies_CN_PagedUE_Identity,
    &ett_umts_rrc_ies_CompressedModeMeasCapability,
    &ett_umts_rrc_ies_CompressedModeMeasCapability_LCR_r4,
    &ett_umts_rrc_ies_CompressedModeMeasCapabFDDList,
    &ett_umts_rrc_ies_CompressedModeMeasCapabFDDList2,
    &ett_umts_rrc_ies_CompressedModeMeasCapabFDDList_ext,
    &ett_umts_rrc_ies_CompressedModeMeasCapabFDD,
    &ett_umts_rrc_ies_CompressedModeMeasCapabFDD2,
    &ett_umts_rrc_ies_CompressedModeMeasCapabFDD_ext,
    &ett_umts_rrc_ies_CompressedModeMeasCapabTDDList,
    &ett_umts_rrc_ies_CompressedModeMeasCapabTDD,
    &ett_umts_rrc_ies_CompressedModeMeasCapabGSMList,
    &ett_umts_rrc_ies_CompressedModeMeasCapabGSM,
    &ett_umts_rrc_ies_CompressedModeMeasCapabMC,
    &ett_umts_rrc_ies_CPCH_Parameters,
    &ett_umts_rrc_ies_DL_PhysChCapabilityFDD,
    &ett_umts_rrc_ies_DL_PhysChCapabilityFDD_v380ext,
    &ett_umts_rrc_ies_DL_PhysChCapabilityTDD,
    &ett_umts_rrc_ies_DL_PhysChCapabilityTDD_LCR_r4,
    &ett_umts_rrc_ies_DL_TransChCapability,
    &ett_umts_rrc_ies_DRAC_SysInfo,
    &ett_umts_rrc_ies_DRAC_SysInfoList,
    &ett_umts_rrc_ies_FailureCauseWithProtErr,
    &ett_umts_rrc_ies_FailureCauseWithProtErrTrId,
    &ett_umts_rrc_ies_GroupIdentityWithReleaseInformation,
    &ett_umts_rrc_ies_GroupReleaseInformation,
    &ett_umts_rrc_ies_GSM_Measurements,
    &ett_umts_rrc_ies_IMSI_and_ESN_DS_41,
    &ett_umts_rrc_ies_InitialPriorityDelayList,
    &ett_umts_rrc_ies_InitialUE_Identity,
    &ett_umts_rrc_ies_IntegrityCheckInfo,
    &ett_umts_rrc_ies_IntegrityProtActivationInfo,
    &ett_umts_rrc_ies_IntegrityProtectionModeCommand,
    &ett_umts_rrc_ies_T_startIntegrityProtection,
    &ett_umts_rrc_ies_T_modify,
    &ett_umts_rrc_ies_IntegrityProtectionModeInfo,
    &ett_umts_rrc_ies_MeasurementCapability,
    &ett_umts_rrc_ies_MeasurementCapabilityExt,
    &ett_umts_rrc_ies_MeasurementCapabilityExt2,
    &ett_umts_rrc_ies_MeasurementCapability_r4_ext,
    &ett_umts_rrc_ies_MultiRAT_Capability,
    &ett_umts_rrc_ies_MultiModeRAT_Capability_v590ext,
    &ett_umts_rrc_ies_P_TMSI_and_RAI_GSM_MAP,
    &ett_umts_rrc_ies_PagingRecord,
    &ett_umts_rrc_ies_T_cn_Identity,
    &ett_umts_rrc_ies_T_utran_Identity,
    &ett_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE,
    &ett_umts_rrc_ies_PagingRecord2_r5,
    &ett_umts_rrc_ies_T_utran_SingleUE_Identity,
    &ett_umts_rrc_ies_T_cn_OriginatedPage_connectedMode_UE1,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxURNTIGroup_OF_GroupIdentityWithReleaseInformation,
    &ett_umts_rrc_ies_PagingRecordList,
    &ett_umts_rrc_ies_PagingRecord2List_r5,
    &ett_umts_rrc_ies_PDCP_Capability,
    &ett_umts_rrc_ies_T_supportForRfc2507,
    &ett_umts_rrc_ies_PDCP_Capability_r4_ext,
    &ett_umts_rrc_ies_T_supportForRfc3095,
    &ett_umts_rrc_ies_T_supported,
    &ett_umts_rrc_ies_PDCP_Capability_r5_ext,
    &ett_umts_rrc_ies_PDCP_Capability_r5_ext2,
    &ett_umts_rrc_ies_PhysicalChannelCapability,
    &ett_umts_rrc_ies_T_fddPhysChCapability,
    &ett_umts_rrc_ies_T_tddPhysChCapability,
    &ett_umts_rrc_ies_PhysicalChannelCapability_LCR_r4,
    &ett_umts_rrc_ies_T_tdd128_PhysChCapability,
    &ett_umts_rrc_ies_PhysicalChannelCapability_hspdsch_r5,
    &ett_umts_rrc_ies_T_fdd_hspdsch,
    &ett_umts_rrc_ies_T_supported1,
    &ett_umts_rrc_ies_T_tdd384_hspdsch,
    &ett_umts_rrc_ies_T_tdd128_hspdsch,
    &ett_umts_rrc_ies_PNBSCH_Allocation_r4,
    &ett_umts_rrc_ies_ProtocolErrorIndicatorWithMoreInfo,
    &ett_umts_rrc_ies_T_errorOccurred,
    &ett_umts_rrc_ies_ProtocolErrorMoreInformation,
    &ett_umts_rrc_ies_T_diagnosticsType,
    &ett_umts_rrc_ies_T_type1,
    &ett_umts_rrc_ies_Rb_timer_indicator,
    &ett_umts_rrc_ies_RedirectionInfo,
    &ett_umts_rrc_ies_RedirectionInfo_r6,
    &ett_umts_rrc_ies_RF_Capability,
    &ett_umts_rrc_ies_T_fddRF_Capability,
    &ett_umts_rrc_ies_T_tddRF_Capability,
    &ett_umts_rrc_ies_RF_Capability_r4_ext,
    &ett_umts_rrc_ies_T_tddRF_Capability1,
    &ett_umts_rrc_ies_RLC_Capability,
    &ett_umts_rrc_ies_RLC_Capability_r5_ext,
    &ett_umts_rrc_ies_RRC_ConnectionReleaseInformation,
    &ett_umts_rrc_ies_T_release,
    &ett_umts_rrc_ies_RRC_MessageSequenceNumberList,
    &ett_umts_rrc_ies_SecurityCapability,
    &ett_umts_rrc_ies_T_cipheringAlgorithmCap,
    &ett_umts_rrc_ies_T_integrityProtectionAlgorithmCap,
    &ett_umts_rrc_ies_Serving_HSDSCH_CellInformation,
    &ett_umts_rrc_ies_SimultaneousSCCPCH_DPCH_Reception,
    &ett_umts_rrc_ies_T_supported2,
    &ett_umts_rrc_ies_STARTList,
    &ett_umts_rrc_ies_STARTSingle,
    &ett_umts_rrc_ies_CapabilityUpdateRequirement_r5,
    &ett_umts_rrc_ies_SystemSpecificCapUpdateReqList,
    &ett_umts_rrc_ies_SystemSpecificCapUpdateReqList_r5,
    &ett_umts_rrc_ies_TMSI_and_LAI_GSM_MAP,
    &ett_umts_rrc_ies_TransportChannelCapability,
    &ett_umts_rrc_ies_TurboSupport,
    &ett_umts_rrc_ies_U_RNTI,
    &ett_umts_rrc_ies_U_RNTI_Group,
    &ett_umts_rrc_ies_U_RNTI_Short,
    &ett_umts_rrc_ies_UE_CapabilityContainer_IEs,
    &ett_umts_rrc_ies_T_nonCriticalExtensions,
    &ett_umts_rrc_ies_UE_ConnTimersAndConstants,
    &ett_umts_rrc_ies_UE_ConnTimersAndConstants_v3a0ext,
    &ett_umts_rrc_ies_UE_ConnTimersAndConstants_r5,
    &ett_umts_rrc_ies_UE_IdleTimersAndConstants,
    &ett_umts_rrc_ies_UE_IdleTimersAndConstants_v3a0ext,
    &ett_umts_rrc_ies_UE_MultiModeRAT_Capability,
    &ett_umts_rrc_ies_UE_RadioAccessCapability,
    &ett_umts_rrc_ies_UE_RadioAccessCapabilityInfo,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v370ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v380ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v3a0ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v3g0ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v650ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v6xyext,
    &ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList2,
    &ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD2,
    &ett_umts_rrc_ies_T_fddRF_Capability1,
    &ett_umts_rrc_ies_UE_PositioningCapabilityExt_v380,
    &ett_umts_rrc_ies_UE_PositioningCapabilityExt_v3a0,
    &ett_umts_rrc_ies_UE_PositioningCapabilityExt_v3g0,
    &ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList,
    &ett_umts_rrc_ies_UE_RadioAccessCapabBandFDDList_ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD,
    &ett_umts_rrc_ies_T_fddRF_Capability2,
    &ett_umts_rrc_ies_UE_RadioAccessCapabBandFDD_ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v4b0ext,
    &ett_umts_rrc_ies_T_tdd_CapabilityExt,
    &ett_umts_rrc_ies_UE_RadioAccessCapabilityComp,
    &ett_umts_rrc_ies_RF_CapabilityComp,
    &ett_umts_rrc_ies_T_fdd1,
    &ett_umts_rrc_ies_T_tdd384_RF_Capability,
    &ett_umts_rrc_ies_T_tdd128_RF_Capability,
    &ett_umts_rrc_ies_RF_CapabBandListFDDComp,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v590ext,
    &ett_umts_rrc_ies_UE_RadioAccessCapability_v5c0ext,
    &ett_umts_rrc_ies_UL_PhysChCapabilityFDD,
    &ett_umts_rrc_ies_UL_PhysChCapabilityFDD_r6,
    &ett_umts_rrc_ies_UL_PhysChCapabilityTDD,
    &ett_umts_rrc_ies_UL_PhysChCapabilityTDD_LCR_r4,
    &ett_umts_rrc_ies_PhysicalChannelCapability_edch_r6,
    &ett_umts_rrc_ies_T_fdd_edch,
    &ett_umts_rrc_ies_T_supported3,
    &ett_umts_rrc_ies_UL_TransChCapability,
    &ett_umts_rrc_ies_T_modeSpecificInfo1,
    &ett_umts_rrc_ies_T_tdd1,
    &ett_umts_rrc_ies_UE_Positioning_Capability,
    &ett_umts_rrc_ies_UE_SecurityInformation,
    &ett_umts_rrc_ies_UE_SecurityInformation2,
    &ett_umts_rrc_ies_AlgorithmSpecificInfo,
    &ett_umts_rrc_ies_AlgorithmSpecificInfo_r4,
    &ett_umts_rrc_ies_DL_AM_RLC_Mode,
    &ett_umts_rrc_ies_DL_AM_RLC_Mode_r5,
    &ett_umts_rrc_ies_DL_CounterSynchronisationInfo,
    &ett_umts_rrc_ies_DL_CounterSynchronisationInfo_r5,
    &ett_umts_rrc_ies_DL_LogicalChannelMapping,
    &ett_umts_rrc_ies_DL_LogicalChannelMapping_r5,
    &ett_umts_rrc_ies_DL_LogicalChannelMappingList,
    &ett_umts_rrc_ies_DL_LogicalChannelMappingList_r5,
    &ett_umts_rrc_ies_DL_RFC3095_r4,
    &ett_umts_rrc_ies_DL_RLC_Mode,
    &ett_umts_rrc_ies_DL_RLC_Mode_r5,
    &ett_umts_rrc_ies_DL_RLC_Mode_r6,
    &ett_umts_rrc_ies_DL_RLC_StatusInfo,
    &ett_umts_rrc_ies_DL_TM_RLC_Mode,
    &ett_umts_rrc_ies_DL_TransportChannelType,
    &ett_umts_rrc_ies_DL_TransportChannelType_r5,
    &ett_umts_rrc_ies_DL_UM_RLC_Mode_r5,
    &ett_umts_rrc_ies_DL_UM_RLC_Mode_r6,
    &ett_umts_rrc_ies_ExplicitDiscard,
    &ett_umts_rrc_ies_HeaderCompressionInfo,
    &ett_umts_rrc_ies_HeaderCompressionInfoList,
    &ett_umts_rrc_ies_HeaderCompressionInfo_r4,
    &ett_umts_rrc_ies_HeaderCompressionInfoList_r4,
    &ett_umts_rrc_ies_LosslessSRNS_RelocSupport,
    &ett_umts_rrc_ies_MaxDAT_Retransmissions,
    &ett_umts_rrc_ies_PDCP_Info,
    &ett_umts_rrc_ies_PDCP_Info_r4,
    &ett_umts_rrc_ies_PDCP_InfoReconfig,
    &ett_umts_rrc_ies_PDCP_InfoReconfig_r4,
    &ett_umts_rrc_ies_PollingInfo,
    &ett_umts_rrc_ies_PredefinedRB_Configuration,
    &ett_umts_rrc_ies_PreDefRadioConfiguration,
    &ett_umts_rrc_ies_PredefinedConfigStatusList,
    &ett_umts_rrc_ies_PredefinedConfigStatusInfo,
    &ett_umts_rrc_ies_T_other,
    &ett_umts_rrc_ies_PredefinedConfigStatusListComp,
    &ett_umts_rrc_ies_PredefinedConfigSetsWithDifferentValueTag,
    &ett_umts_rrc_ies_PredefinedConfigSetWithDifferentValueTag,
    &ett_umts_rrc_ies_PredefinedConfigValueTagList,
    &ett_umts_rrc_ies_PredefinedConfigStatusListVarSz,
    &ett_umts_rrc_ies_RAB_Info,
    &ett_umts_rrc_ies_RAB_Info_r6_ext,
    &ett_umts_rrc_ies_RAB_Info_r6,
    &ett_umts_rrc_ies_RAB_InformationList,
    &ett_umts_rrc_ies_RAB_InformationList_r6,
    &ett_umts_rrc_ies_RAB_InformationReconfigList,
    &ett_umts_rrc_ies_RAB_InformationReconfig,
    &ett_umts_rrc_ies_RAB_Info_Post,
    &ett_umts_rrc_ies_RAB_InformationSetup,
    &ett_umts_rrc_ies_RAB_InformationSetup_r4,
    &ett_umts_rrc_ies_RAB_InformationSetup_r5,
    &ett_umts_rrc_ies_RAB_InformationSetup_r6_ext,
    &ett_umts_rrc_ies_RAB_InformationSetup_r6,
    &ett_umts_rrc_ies_RAB_InformationSetupList,
    &ett_umts_rrc_ies_RAB_InformationSetupList_r4,
    &ett_umts_rrc_ies_RAB_InformationSetupList_r5,
    &ett_umts_rrc_ies_RAB_InformationSetupList_r6,
    &ett_umts_rrc_ies_RAB_InformationSetupList_r6_ext,
    &ett_umts_rrc_ies_RB_ActivationTimeInfo,
    &ett_umts_rrc_ies_RB_ActivationTimeInfoList,
    &ett_umts_rrc_ies_RB_COUNT_C_Information,
    &ett_umts_rrc_ies_RB_COUNT_C_InformationList,
    &ett_umts_rrc_ies_RB_COUNT_C_MSB_Information,
    &ett_umts_rrc_ies_RB_COUNT_C_MSB_InformationList,
    &ett_umts_rrc_ies_RB_IdentityList,
    &ett_umts_rrc_ies_RB_InformationAffected,
    &ett_umts_rrc_ies_RB_InformationAffected_r5,
    &ett_umts_rrc_ies_RB_InformationAffected_r6,
    &ett_umts_rrc_ies_RB_InformationAffectedList,
    &ett_umts_rrc_ies_RB_InformationAffectedList_r5,
    &ett_umts_rrc_ies_RB_InformationAffectedList_r6,
    &ett_umts_rrc_ies_RB_InformationChanged_r6,
    &ett_umts_rrc_ies_T_rb_Change,
    &ett_umts_rrc_ies_RB_InformationChangedList_r6,
    &ett_umts_rrc_ies_RB_InformationReconfig,
    &ett_umts_rrc_ies_RB_InformationReconfig_r4,
    &ett_umts_rrc_ies_RB_InformationReconfig_r5,
    &ett_umts_rrc_ies_RB_InformationReconfig_r6,
    &ett_umts_rrc_ies_RB_InformationReconfigList,
    &ett_umts_rrc_ies_RB_InformationReconfigList_r4,
    &ett_umts_rrc_ies_RB_InformationReconfigList_r5,
    &ett_umts_rrc_ies_RB_InformationReconfigList_r6,
    &ett_umts_rrc_ies_RB_InformationReleaseList,
    &ett_umts_rrc_ies_RB_InformationSetup,
    &ett_umts_rrc_ies_RB_InformationSetup_r4,
    &ett_umts_rrc_ies_RB_InformationSetup_r5,
    &ett_umts_rrc_ies_RB_InformationSetup_r6,
    &ett_umts_rrc_ies_RB_InformationSetupList,
    &ett_umts_rrc_ies_RB_InformationSetupList_r4,
    &ett_umts_rrc_ies_RB_InformationSetupList_r5,
    &ett_umts_rrc_ies_RB_InformationSetupList_r6,
    &ett_umts_rrc_ies_RB_MappingInfo,
    &ett_umts_rrc_ies_RB_MappingInfo_r5,
    &ett_umts_rrc_ies_RB_MappingInfo_r6,
    &ett_umts_rrc_ies_RB_MappingOption,
    &ett_umts_rrc_ies_RB_MappingOption_r5,
    &ett_umts_rrc_ies_RB_MappingOption_r6,
    &ett_umts_rrc_ies_RB_PDCPContextRelocation,
    &ett_umts_rrc_ies_RB_PDCPContextRelocationList,
    &ett_umts_rrc_ies_RB_WithPDCP_Info,
    &ett_umts_rrc_ies_RB_WithPDCP_InfoList,
    &ett_umts_rrc_ies_RFC2507_Info,
    &ett_umts_rrc_ies_RFC3095_Info_r4,
    &ett_umts_rrc_ies_RLC_Info,
    &ett_umts_rrc_ies_RLC_Info_r5,
    &ett_umts_rrc_ies_RLC_Info_r6,
    &ett_umts_rrc_ies_RLC_Info_MBMS_r6,
    &ett_umts_rrc_ies_RLC_InfoChoice,
    &ett_umts_rrc_ies_RLC_InfoChoice_r5,
    &ett_umts_rrc_ies_RLC_InfoChoice_r6,
    &ett_umts_rrc_ies_RLC_PDU_SizeList,
    &ett_umts_rrc_ies_RLC_SizeInfo,
    &ett_umts_rrc_ies_RLC_SizeExplicitList,
    &ett_umts_rrc_ies_ROHC_ProfileList_r4,
    &ett_umts_rrc_ies_ROHC_PacketSizeList_r4,
    &ett_umts_rrc_ies_SRB_InformationSetup,
    &ett_umts_rrc_ies_SRB_InformationSetup_r5,
    &ett_umts_rrc_ies_SRB_InformationSetup_r6,
    &ett_umts_rrc_ies_SRB_InformationSetupList,
    &ett_umts_rrc_ies_SRB_InformationSetupList_r5,
    &ett_umts_rrc_ies_SRB_InformationSetupList_r6,
    &ett_umts_rrc_ies_SRB_InformationSetupList2,
    &ett_umts_rrc_ies_TransmissionRLC_Discard,
    &ett_umts_rrc_ies_UL_AM_RLC_Mode,
    &ett_umts_rrc_ies_UL_CounterSynchronisationInfo,
    &ett_umts_rrc_ies_UL_LogicalChannelMapping,
    &ett_umts_rrc_ies_T_rlc_SizeList,
    &ett_umts_rrc_ies_UL_LogicalChannelMapping_r6,
    &ett_umts_rrc_ies_T_ul_TrCH_Type,
    &ett_umts_rrc_ies_T_dch_rach_cpch_usch,
    &ett_umts_rrc_ies_T_rlc_SizeList1,
    &ett_umts_rrc_ies_T_e_dch,
    &ett_umts_rrc_ies_UL_LogicalChannelMappingList,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping,
    &ett_umts_rrc_ies_UL_LogicalChannelMappingList_r6,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_maxLoCHperRLC_OF_UL_LogicalChannelMapping_r6,
    &ett_umts_rrc_ies_UL_LogicalChannelMappings,
    &ett_umts_rrc_ies_UL_LogicalChannelMappings_r6,
    &ett_umts_rrc_ies_UL_RFC3095_r4,
    &ett_umts_rrc_ies_UL_RLC_Mode,
    &ett_umts_rrc_ies_UL_TM_RLC_Mode,
    &ett_umts_rrc_ies_UL_UM_RLC_Mode,
    &ett_umts_rrc_ies_UL_TransportChannelType,
    &ett_umts_rrc_ies_UM_RLC_DuplAvoid_Reord_Info_r6,
    &ett_umts_rrc_ies_UM_RLC_OutOSeqDelivery_Info_r6,
    &ett_umts_rrc_ies_AddOrReconfMAC_dFlow,
    &ett_umts_rrc_ies_AllowedTFC_List,
    &ett_umts_rrc_ies_AllowedTFI_List,
    &ett_umts_rrc_ies_BitModeRLC_SizeInfo,
    &ett_umts_rrc_ies_T_sizeType2,
    &ett_umts_rrc_ies_T_sizeType3,
    &ett_umts_rrc_ies_T_sizeType4,
    &ett_umts_rrc_ies_ChannelCodingType,
    &ett_umts_rrc_ies_CommonDynamicTF_Info,
    &ett_umts_rrc_ies_T_rlc_Size,
    &ett_umts_rrc_ies_T_fdd2,
    &ett_umts_rrc_ies_T_tdd2,
    &ett_umts_rrc_ies_T_commonTDD_Choice,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTF_OF_NumberOfTransportBlocks,
    &ett_umts_rrc_ies_CommonDynamicTF_Info_DynamicTTI,
    &ett_umts_rrc_ies_T_commonTDD_Choice1,
    &ett_umts_rrc_ies_CommonDynamicTF_InfoList,
    &ett_umts_rrc_ies_CommonDynamicTF_InfoList_DynamicTTI,
    &ett_umts_rrc_ies_CommonTransChTFS,
    &ett_umts_rrc_ies_T_tti,
    &ett_umts_rrc_ies_CommonTransChTFS_LCR,
    &ett_umts_rrc_ies_T_tti1,
    &ett_umts_rrc_ies_DedicatedDynamicTF_Info,
    &ett_umts_rrc_ies_T_rlc_Size1,
    &ett_umts_rrc_ies_DedicatedDynamicTF_Info_DynamicTTI,
    &ett_umts_rrc_ies_T_rlc_Size2,
    &ett_umts_rrc_ies_DedicatedDynamicTF_InfoList,
    &ett_umts_rrc_ies_DedicatedDynamicTF_InfoList_DynamicTTI,
    &ett_umts_rrc_ies_DedicatedTransChTFS,
    &ett_umts_rrc_ies_T_tti2,
    &ett_umts_rrc_ies_DL_AddReconfTransChInfo2List,
    &ett_umts_rrc_ies_DL_AddReconfTransChInfoList,
    &ett_umts_rrc_ies_DL_AddReconfTransChInfoList_r4,
    &ett_umts_rrc_ies_DL_AddReconfTransChInfoList_r5,
    &ett_umts_rrc_ies_DL_AddReconfTransChInformation,
    &ett_umts_rrc_ies_T_tfs_SignallingMode,
    &ett_umts_rrc_ies_DL_AddReconfTransChInformation_r4,
    &ett_umts_rrc_ies_T_tfs_SignallingMode1,
    &ett_umts_rrc_ies_DL_AddReconfTransChInformation_r5,
    &ett_umts_rrc_ies_T_tfs_SignallingMode2,
    &ett_umts_rrc_ies_DL_AddReconfTransChInformation2,
    &ett_umts_rrc_ies_T_tfs_SignallingMode3,
    &ett_umts_rrc_ies_DL_CommonTransChInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo2,
    &ett_umts_rrc_ies_T_fdd3,
    &ett_umts_rrc_ies_T_dl_Parameters,
    &ett_umts_rrc_ies_T_tdd3,
    &ett_umts_rrc_ies_DL_CommonTransChInfo_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo3,
    &ett_umts_rrc_ies_T_fdd4,
    &ett_umts_rrc_ies_T_dl_Parameters1,
    &ett_umts_rrc_ies_T_dl_DCH_TFCS,
    &ett_umts_rrc_ies_T_tdd4,
    &ett_umts_rrc_ies_DL_DeletedTransChInfoList,
    &ett_umts_rrc_ies_DL_DeletedTransChInfoList_r5,
    &ett_umts_rrc_ies_DL_TransportChannelIdentity,
    &ett_umts_rrc_ies_DL_TransportChannelIdentity_r5,
    &ett_umts_rrc_ies_DL_TrCH_TypeId1_r5,
    &ett_umts_rrc_ies_DL_TrCH_TypeId2_r5,
    &ett_umts_rrc_ies_DRAC_StaticInformation,
    &ett_umts_rrc_ies_DRAC_StaticInformationList,
    &ett_umts_rrc_ies_E_DCH_AddReconf_MAC_d_Flow,
    &ett_umts_rrc_ies_T_transmissionGrantType,
    &ett_umts_rrc_ies_T_non_ScheduledTranmGrantInfo,
    &ett_umts_rrc_ies_E_DCH_Harq_Info,
    &ett_umts_rrc_ies_ExplicitTFCS_Configuration,
    &ett_umts_rrc_ies_T_replacement,
    &ett_umts_rrc_ies_GainFactorInformation,
    &ett_umts_rrc_ies_HSDSCH_Info,
    &ett_umts_rrc_ies_HARQ_Info,
    &ett_umts_rrc_ies_T_memoryPartitioning,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHProcesses_OF_HARQMemorySize,
    &ett_umts_rrc_ies_IndividualDL_CCTrCH_Info,
    &ett_umts_rrc_ies_T_tfcs_SignallingMode,
    &ett_umts_rrc_ies_IndividualDL_CCTrCH_InfoList,
    &ett_umts_rrc_ies_IndividualUL_CCTrCH_Info,
    &ett_umts_rrc_ies_IndividualUL_CCTrCH_InfoList,
    &ett_umts_rrc_ies_LogicalChannelByRB,
    &ett_umts_rrc_ies_LogicalChannelList,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_15_OF_LogicalChannelByRB,
    &ett_umts_rrc_ies_MAC_d_FlowIdentityDCHandHSDSCH,
    &ett_umts_rrc_ies_MAC_d_PDU_SizeInfo_List,
    &ett_umts_rrc_ies_MAC_d_PDUsizeInfo,
    &ett_umts_rrc_ies_MAC_hs_AddReconfQueue_List,
    &ett_umts_rrc_ies_MAC_hs_AddReconfQueue,
    &ett_umts_rrc_ies_MAC_hs_DelQueue_List,
    &ett_umts_rrc_ies_MAC_hs_DelQueue,
    &ett_umts_rrc_ies_NumberOfTbSizeAndTTIList,
    &ett_umts_rrc_ies_NumberOfTbSizeAndTTIList_item,
    &ett_umts_rrc_ies_Non_allowedTFC_List,
    &ett_umts_rrc_ies_NumberOfTransportBlocks,
    &ett_umts_rrc_ies_OctetModeRLC_SizeInfoType1,
    &ett_umts_rrc_ies_T_sizeType21,
    &ett_umts_rrc_ies_T_sizeType31,
    &ett_umts_rrc_ies_OctetModeRLC_SizeInfoType2,
    &ett_umts_rrc_ies_PowerOffsetInfoShort,
    &ett_umts_rrc_ies_T_modeSpecificInfo4,
    &ett_umts_rrc_ies_T_fdd5,
    &ett_umts_rrc_ies_PowerOffsetInformation,
    &ett_umts_rrc_ies_PreDefTransChConfiguration,
    &ett_umts_rrc_ies_QualityTarget,
    &ett_umts_rrc_ies_RestrictedTrChInfo,
    &ett_umts_rrc_ies_RestrictedTrChInfoList,
    &ett_umts_rrc_ies_SemistaticTF_Information,
    &ett_umts_rrc_ies_SignalledGainFactors,
    &ett_umts_rrc_ies_T_modeSpecificInfo5,
    &ett_umts_rrc_ies_T_fdd6,
    &ett_umts_rrc_ies_SplitTFCI_Signalling,
    &ett_umts_rrc_ies_TFC_Subset,
    &ett_umts_rrc_ies_TFC_SubsetList,
    &ett_umts_rrc_ies_TFC_SubsetList_item,
    &ett_umts_rrc_ies_T_modeSpecificInfo6,
    &ett_umts_rrc_ies_T_tdd5,
    &ett_umts_rrc_ies_TFCI_Field2_Information,
    &ett_umts_rrc_ies_TFCI_Range,
    &ett_umts_rrc_ies_TFCI_RangeList,
    &ett_umts_rrc_ies_TFCS,
    &ett_umts_rrc_ies_TFCS_Identity,
    &ett_umts_rrc_ies_TFCS_InfoForDSCH,
    &ett_umts_rrc_ies_TFCS_ReconfAdd,
    &ett_umts_rrc_ies_T_ctfcSize,
    &ett_umts_rrc_ies_T_ctfc2Bit,
    &ett_umts_rrc_ies_T_ctfc2Bit_item,
    &ett_umts_rrc_ies_T_ctfc4Bit,
    &ett_umts_rrc_ies_T_ctfc4Bit_item,
    &ett_umts_rrc_ies_T_ctfc6Bit,
    &ett_umts_rrc_ies_T_ctfc6Bit_item,
    &ett_umts_rrc_ies_T_ctfc8Bit,
    &ett_umts_rrc_ies_T_ctfc8Bit_item,
    &ett_umts_rrc_ies_T_ctfc12Bit,
    &ett_umts_rrc_ies_T_ctfc12Bit_item,
    &ett_umts_rrc_ies_T_ctfc16Bit,
    &ett_umts_rrc_ies_T_ctfc16Bit_item,
    &ett_umts_rrc_ies_T_ctfc24Bit,
    &ett_umts_rrc_ies_T_ctfc24Bit_item,
    &ett_umts_rrc_ies_TFCS_Removal,
    &ett_umts_rrc_ies_TFCS_RemovalList,
    &ett_umts_rrc_ies_TM_SignallingInfo,
    &ett_umts_rrc_ies_T_tm_SignallingMode,
    &ett_umts_rrc_ies_T_mode2,
    &ett_umts_rrc_ies_TransportChannelIdentityDCHandDSCH,
    &ett_umts_rrc_ies_TransportFormatSet,
    &ett_umts_rrc_ies_TransportFormatSet_LCR,
    &ett_umts_rrc_ies_UL_AddReconfTransChInfoList,
    &ett_umts_rrc_ies_UL_AddReconfTransChInfoList_r6,
    &ett_umts_rrc_ies_UL_AddReconfTransChInformation,
    &ett_umts_rrc_ies_UL_AddReconfTransChInformation_r6,
    &ett_umts_rrc_ies_T_dch_usch,
    &ett_umts_rrc_ies_T_e_dch1,
    &ett_umts_rrc_ies_UL_CommonTransChInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo7,
    &ett_umts_rrc_ies_T_fdd7,
    &ett_umts_rrc_ies_T_tdd6,
    &ett_umts_rrc_ies_UL_CommonTransChInfo_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo8,
    &ett_umts_rrc_ies_T_fdd8,
    &ett_umts_rrc_ies_T_tdd7,
    &ett_umts_rrc_ies_UL_ControlledTrChList,
    &ett_umts_rrc_ies_UL_DeletedTransChInfoList,
    &ett_umts_rrc_ies_UL_DeletedTransChInfoList_r6,
    &ett_umts_rrc_ies_UL_TransportChannelIdentity,
    &ett_umts_rrc_ies_UL_TransportChannelIdentity_r6,
    &ett_umts_rrc_ies_T_dch_usch1,
    &ett_umts_rrc_ies_USCH_TransportChannelsInfo,
    &ett_umts_rrc_ies_USCH_TransportChannelsInfo_item,
    &ett_umts_rrc_ies_AC_To_ASC_MappingTable,
    &ett_umts_rrc_ies_AccessServiceClass_FDD,
    &ett_umts_rrc_ies_T_assignedSubChannelNumber,
    &ett_umts_rrc_ies_AccessServiceClass_TDD,
    &ett_umts_rrc_ies_T_channelisationCodeIndices,
    &ett_umts_rrc_ies_T_subchannelSize,
    &ett_umts_rrc_ies_T_size2,
    &ett_umts_rrc_ies_T_size4,
    &ett_umts_rrc_ies_T_subchannels1,
    &ett_umts_rrc_ies_T_size8,
    &ett_umts_rrc_ies_T_subchannels2,
    &ett_umts_rrc_ies_AccessServiceClass_TDD_LCR_r4,
    &ett_umts_rrc_ies_T_availableSYNC_UlCodesIndics,
    &ett_umts_rrc_ies_T_subchannelSize1,
    &ett_umts_rrc_ies_T_size21,
    &ett_umts_rrc_ies_T_size41,
    &ett_umts_rrc_ies_T_subchannels4,
    &ett_umts_rrc_ies_T_size81,
    &ett_umts_rrc_ies_T_subchannels5,
    &ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_IEs,
    &ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH,
    &ett_umts_rrc_ies_AdditionalPRACH_TF_and_TFCS_CCCH_List,
    &ett_umts_rrc_ies_AICH_Info,
    &ett_umts_rrc_ies_AllocationPeriodInfo,
    &ett_umts_rrc_ies_AP_Signature_VCAM,
    &ett_umts_rrc_ies_ASCSetting_FDD,
    &ett_umts_rrc_ies_ASCSetting_TDD,
    &ett_umts_rrc_ies_ASCSetting_TDD_LCR_r4,
    &ett_umts_rrc_ies_AvailableAP_Signature_VCAMList,
    &ett_umts_rrc_ies_AvailableAP_SignatureList,
    &ett_umts_rrc_ies_AvailableAP_SubchannelList,
    &ett_umts_rrc_ies_AvailableMinimumSF_ListVCAM,
    &ett_umts_rrc_ies_AvailableMinimumSF_VCAM,
    &ett_umts_rrc_ies_AvailableSignatures,
    &ett_umts_rrc_ies_AvailableSubChannelNumbers,
    &ett_umts_rrc_ies_CCTrCH_PowerControlInfo,
    &ett_umts_rrc_ies_CCTrCH_PowerControlInfo_r4,
    &ett_umts_rrc_ies_CCTrCH_PowerControlInfo_r5,
    &ett_umts_rrc_ies_CD_AccessSlotSubchannelList,
    &ett_umts_rrc_ies_CD_SignatureCodeList,
    &ett_umts_rrc_ies_CellAndChannelIdentity,
    &ett_umts_rrc_ies_ChannelAssignmentActive,
    &ett_umts_rrc_ies_ChannelReqParamsForUCSM,
    &ett_umts_rrc_ies_CodeRange,
    &ett_umts_rrc_ies_CommonTimeslotInfo,
    &ett_umts_rrc_ies_CommonTimeslotInfoSCCPCH,
    &ett_umts_rrc_ies_CPCH_PersistenceLevels,
    &ett_umts_rrc_ies_CPCH_PersistenceLevelsList,
    &ett_umts_rrc_ies_CPCH_SetInfo,
    &ett_umts_rrc_ies_CPCH_SetInfoList,
    &ett_umts_rrc_ies_DL_CCTrCh,
    &ett_umts_rrc_ies_DL_CCTrCh_r4,
    &ett_umts_rrc_ies_T_tddOption,
    &ett_umts_rrc_ies_T_tdd384,
    &ett_umts_rrc_ies_T_tdd128,
    &ett_umts_rrc_ies_DL_CCTrChList,
    &ett_umts_rrc_ies_DL_CCTrChList_r4,
    &ett_umts_rrc_ies_DL_CCTrChListToRemove,
    &ett_umts_rrc_ies_DL_CCTrChTPCList,
    &ett_umts_rrc_ies_DL_ChannelisationCode,
    &ett_umts_rrc_ies_DL_ChannelisationCodeList,
    &ett_umts_rrc_ies_DL_CommonInformation,
    &ett_umts_rrc_ies_T_modeSpecificInfo9,
    &ett_umts_rrc_ies_T_fdd9,
    &ett_umts_rrc_ies_T_tdd8,
    &ett_umts_rrc_ies_DL_CommonInformation_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo10,
    &ett_umts_rrc_ies_T_fdd10,
    &ett_umts_rrc_ies_T_tdd9,
    &ett_umts_rrc_ies_T_tddOption1,
    &ett_umts_rrc_ies_T_tdd1281,
    &ett_umts_rrc_ies_DL_CommonInformation_r5,
    &ett_umts_rrc_ies_T_modeSpecificInfo11,
    &ett_umts_rrc_ies_T_fdd11,
    &ett_umts_rrc_ies_T_tdd10,
    &ett_umts_rrc_ies_T_tddOption2,
    &ett_umts_rrc_ies_T_tdd1282,
    &ett_umts_rrc_ies_DL_CommonInformation_r6,
    &ett_umts_rrc_ies_T_dl_dpchInfoCommon,
    &ett_umts_rrc_ies_T_modeSpecificInfo12,
    &ett_umts_rrc_ies_T_fdd12,
    &ett_umts_rrc_ies_T_tdd11,
    &ett_umts_rrc_ies_T_tddOption3,
    &ett_umts_rrc_ies_T_tdd1283,
    &ett_umts_rrc_ies_DL_CommonInformationPost,
    &ett_umts_rrc_ies_DL_CommonInformationPredef,
    &ett_umts_rrc_ies_DL_DPCH_InfoCommon,
    &ett_umts_rrc_ies_T_cfnHandling,
    &ett_umts_rrc_ies_T_initialise,
    &ett_umts_rrc_ies_T_modeSpecificInfo13,
    &ett_umts_rrc_ies_T_fdd13,
    &ett_umts_rrc_ies_T_tdd12,
    &ett_umts_rrc_ies_DL_DPCH_InfoCommon_r4,
    &ett_umts_rrc_ies_T_cfnHandling1,
    &ett_umts_rrc_ies_T_initialise1,
    &ett_umts_rrc_ies_T_modeSpecificInfo14,
    &ett_umts_rrc_ies_T_fdd14,
    &ett_umts_rrc_ies_T_tdd13,
    &ett_umts_rrc_ies_DL_DPCH_InfoCommon_r6,
    &ett_umts_rrc_ies_T_cfnHandling2,
    &ett_umts_rrc_ies_T_maintain,
    &ett_umts_rrc_ies_T_modeSpecificInfo15,
    &ett_umts_rrc_ies_T_fdd15,
    &ett_umts_rrc_ies_T_tdd14,
    &ett_umts_rrc_ies_DL_DPCH_InfoCommonPost,
    &ett_umts_rrc_ies_DL_DPCH_InfoCommonPredef,
    &ett_umts_rrc_ies_T_modeSpecificInfo16,
    &ett_umts_rrc_ies_T_fdd16,
    &ett_umts_rrc_ies_T_tdd15,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL,
    &ett_umts_rrc_ies_T_fdd17,
    &ett_umts_rrc_ies_T_tdd16,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r4,
    &ett_umts_rrc_ies_T_fdd18,
    &ett_umts_rrc_ies_T_tdd17,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r5,
    &ett_umts_rrc_ies_T_fdd19,
    &ett_umts_rrc_ies_T_tdd18,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL_r6,
    &ett_umts_rrc_ies_T_fdd20,
    &ett_umts_rrc_ies_T_tdd19,
    &ett_umts_rrc_ies_DL_FDPCH_InfoPerRL_r6,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostFDD,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD,
    &ett_umts_rrc_ies_DL_DPCH_InfoPerRL_PostTDD_LCR_r4,
    &ett_umts_rrc_ies_DL_DPCH_PowerControlInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo17,
    &ett_umts_rrc_ies_T_fdd21,
    &ett_umts_rrc_ies_T_tdd20,
    &ett_umts_rrc_ies_DL_FDPCH_InfoCommon_r6,
    &ett_umts_rrc_ies_T_cfnHandling3,
    &ett_umts_rrc_ies_T_maintain1,
    &ett_umts_rrc_ies_DL_HSPDSCH_Information,
    &ett_umts_rrc_ies_T_modeSpecificInfo18,
    &ett_umts_rrc_ies_T_tdd21,
    &ett_umts_rrc_ies_T_tdd3841,
    &ett_umts_rrc_ies_T_tdd1284,
    &ett_umts_rrc_ies_DL_HSPDSCH_Information_r6,
    &ett_umts_rrc_ies_T_modeSpecificInfo19,
    &ett_umts_rrc_ies_T_tdd22,
    &ett_umts_rrc_ies_T_tdd3842,
    &ett_umts_rrc_ies_T_tdd1285,
    &ett_umts_rrc_ies_DL_HSPDSCH_TS_Configuration,
    &ett_umts_rrc_ies_DL_HSPDSCH_TS_Configuration_item,
    &ett_umts_rrc_ies_DL_InformationPerRL,
    &ett_umts_rrc_ies_T_modeSpecificInfo20,
    &ett_umts_rrc_ies_T_fdd22,
    &ett_umts_rrc_ies_DL_InformationPerRL_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo21,
    &ett_umts_rrc_ies_T_fdd23,
    &ett_umts_rrc_ies_DL_InformationPerRL_r5,
    &ett_umts_rrc_ies_T_modeSpecificInfo22,
    &ett_umts_rrc_ies_T_fdd24,
    &ett_umts_rrc_ies_DL_InformationPerRL_r5bis,
    &ett_umts_rrc_ies_T_modeSpecificInfo23,
    &ett_umts_rrc_ies_T_fdd25,
    &ett_umts_rrc_ies_DL_InformationPerRL_r6,
    &ett_umts_rrc_ies_T_modeSpecificInfo24,
    &ett_umts_rrc_ies_T_fdd26,
    &ett_umts_rrc_ies_T_dl_dpchInfo,
    &ett_umts_rrc_ies_DL_InformationPerRL_List,
    &ett_umts_rrc_ies_DL_InformationPerRL_List_r4,
    &ett_umts_rrc_ies_DL_InformationPerRL_List_r5,
    &ett_umts_rrc_ies_DL_InformationPerRL_List_r6,
    &ett_umts_rrc_ies_DL_InformationPerRL_List_r5bis,
    &ett_umts_rrc_ies_DL_InformationPerRL_ListPostFDD,
    &ett_umts_rrc_ies_DL_InformationPerRL_PostFDD,
    &ett_umts_rrc_ies_DL_InformationPerRL_PostTDD,
    &ett_umts_rrc_ies_DL_InformationPerRL_PostTDD_LCR_r4,
    &ett_umts_rrc_ies_DL_PDSCH_Information,
    &ett_umts_rrc_ies_Dl_rate_matching_restriction,
    &ett_umts_rrc_ies_DL_TPC_PowerOffsetPerRL,
    &ett_umts_rrc_ies_DL_TPC_PowerOffsetPerRL_List,
    &ett_umts_rrc_ies_DL_TS_ChannelisationCodesShort,
    &ett_umts_rrc_ies_T_codesRepresentation,
    &ett_umts_rrc_ies_T_consecutive,
    &ett_umts_rrc_ies_T_bitmap,
    &ett_umts_rrc_ies_DownlinkAdditionalTimeslots,
    &ett_umts_rrc_ies_T_parameters,
    &ett_umts_rrc_ies_T_sameAsLast,
    &ett_umts_rrc_ies_T_newParameters,
    &ett_umts_rrc_ies_DownlinkAdditionalTimeslots_LCR_r4,
    &ett_umts_rrc_ies_T_parameters1,
    &ett_umts_rrc_ies_T_sameAsLast1,
    &ett_umts_rrc_ies_T_newParameters1,
    &ett_umts_rrc_ies_DownlinkTimeslotsCodes,
    &ett_umts_rrc_ies_T_moreTimeslots,
    &ett_umts_rrc_ies_T_additionalTimeslots,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_DownlinkAdditionalTimeslots,
    &ett_umts_rrc_ies_DownlinkTimeslotsCodes_LCR_r4,
    &ett_umts_rrc_ies_T_moreTimeslots1,
    &ett_umts_rrc_ies_T_additionalTimeslots1,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_DownlinkAdditionalTimeslots_LCR_r4,
    &ett_umts_rrc_ies_DPCH_CompressedModeInfo,
    &ett_umts_rrc_ies_DPCH_CompressedModeStatusInfo,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTGPS_OF_TGP_SequenceShort,
    &ett_umts_rrc_ies_DSCH_Mapping,
    &ett_umts_rrc_ies_DSCH_MappingList,
    &ett_umts_rrc_ies_DSCH_TransportChannelsInfo,
    &ett_umts_rrc_ies_DSCH_TransportChannelsInfo_item,
    &ett_umts_rrc_ies_DynamicPersistenceLevelList,
    &ett_umts_rrc_ies_DynamicPersistenceLevelTF_List,
    &ett_umts_rrc_ies_DynamicTFInformationCCCH,
    &ett_umts_rrc_ies_E_AGCH_Information,
    &ett_umts_rrc_ies_E_DCH_RL_Info,
    &ett_umts_rrc_ies_E_DPCCH_Info,
    &ett_umts_rrc_ies_E_DPDCH_Info,
    &ett_umts_rrc_ies_E_DPDCH_Reference_E_TFCI,
    &ett_umts_rrc_ies_E_DPDCH_Reference_E_TFCIList,
    &ett_umts_rrc_ies_E_DPDCH_SchedulingInfoConfiguration,
    &ett_umts_rrc_ies_E_DPDCH_SchedulingTransmConfiguration,
    &ett_umts_rrc_ies_E_HICH_Information,
    &ett_umts_rrc_ies_E_RGCH_Information,
    &ett_umts_rrc_ies_FACH_PCH_Information,
    &ett_umts_rrc_ies_FACH_PCH_InformationList,
    &ett_umts_rrc_ies_FPACH_Info_r4,
    &ett_umts_rrc_ies_FrequencyInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo25,
    &ett_umts_rrc_ies_FrequencyInfoFDD,
    &ett_umts_rrc_ies_FrequencyInfoTDD,
    &ett_umts_rrc_ies_HS_PDSCH_Midamble_Configuration_TDD128,
    &ett_umts_rrc_ies_T_midambleAllocationMode,
    &ett_umts_rrc_ies_HS_SCCH_Info,
    &ett_umts_rrc_ies_T_modeSpecificInfo26,
    &ett_umts_rrc_ies_T_fdd27,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_Codes,
    &ett_umts_rrc_ies_T_tdd23,
    &ett_umts_rrc_ies_T_tdd3843,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD384,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxHSSCCHs_OF_HS_SCCH_TDD128,
    &ett_umts_rrc_ies_HS_SCCH_Info_r6,
    &ett_umts_rrc_ies_T_modeSpecificInfo27,
    &ett_umts_rrc_ies_T_fdd28,
    &ett_umts_rrc_ies_T_tdd24,
    &ett_umts_rrc_ies_T_tdd3844,
    &ett_umts_rrc_ies_HS_SCCH_TDD128,
    &ett_umts_rrc_ies_T_midambleAllocationMode1,
    &ett_umts_rrc_ies_HS_SICH_Configuration_TDD128,
    &ett_umts_rrc_ies_T_midambleAllocationMode2,
    &ett_umts_rrc_ies_T_ueSpecificMidamble,
    &ett_umts_rrc_ies_HS_SCCH_TDD384,
    &ett_umts_rrc_ies_T_midambleAllocationMode3,
    &ett_umts_rrc_ies_T_ueSpecificMidamble1,
    &ett_umts_rrc_ies_HS_SICH_Configuration_TDD384,
    &ett_umts_rrc_ies_T_midambleAllocationMode4,
    &ett_umts_rrc_ies_T_ueSpecificMidamble2,
    &ett_umts_rrc_ies_HS_SICH_Power_Control_Info_TDD384,
    &ett_umts_rrc_ies_IndividualTimeslotInfo,
    &ett_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4,
    &ett_umts_rrc_ies_IndividualTimeslotInfo_LCR_r4_ext,
    &ett_umts_rrc_ies_IndividualTS_Interference,
    &ett_umts_rrc_ies_IndividualTS_InterferenceList,
    &ett_umts_rrc_ies_Measurement_Feedback_Info,
    &ett_umts_rrc_ies_T_modeSpecificInfo28,
    &ett_umts_rrc_ies_T_fdd29,
    &ett_umts_rrc_ies_MidambleShiftAndBurstType,
    &ett_umts_rrc_ies_T_burstType,
    &ett_umts_rrc_ies_T_type11,
    &ett_umts_rrc_ies_T_midambleAllocationMode5,
    &ett_umts_rrc_ies_T_ueSpecificMidamble3,
    &ett_umts_rrc_ies_T_type2,
    &ett_umts_rrc_ies_T_midambleAllocationMode6,
    &ett_umts_rrc_ies_T_ueSpecificMidamble4,
    &ett_umts_rrc_ies_T_type3,
    &ett_umts_rrc_ies_T_midambleAllocationMode7,
    &ett_umts_rrc_ies_T_ueSpecificMidamble5,
    &ett_umts_rrc_ies_MidambleShiftAndBurstType_DL,
    &ett_umts_rrc_ies_T_burstType1,
    &ett_umts_rrc_ies_T_type12,
    &ett_umts_rrc_ies_T_midambleAllocationMode8,
    &ett_umts_rrc_ies_T_ueSpecificMidamble6,
    &ett_umts_rrc_ies_T_type21,
    &ett_umts_rrc_ies_T_midambleAllocationMode9,
    &ett_umts_rrc_ies_T_ueSpecificMidamble7,
    &ett_umts_rrc_ies_MidambleShiftAndBurstType_LCR_r4,
    &ett_umts_rrc_ies_T_midambleAllocationMode10,
    &ett_umts_rrc_ies_T_ueSpecificMidamble8,
    &ett_umts_rrc_ies_OpenLoopPowerControl_TDD,
    &ett_umts_rrc_ies_OpenLoopPowerControl_IPDL_TDD_r4,
    &ett_umts_rrc_ies_PCPCH_ChannelInfo,
    &ett_umts_rrc_ies_PCPCH_ChannelInfoList,
    &ett_umts_rrc_ies_PDSCH_CapacityAllocationInfo,
    &ett_umts_rrc_ies_T_configuration,
    &ett_umts_rrc_ies_T_old_Configuration,
    &ett_umts_rrc_ies_T_new_Configuration,
    &ett_umts_rrc_ies_PDSCH_CapacityAllocationInfo_r4,
    &ett_umts_rrc_ies_T_configuration1,
    &ett_umts_rrc_ies_T_old_Configuration1,
    &ett_umts_rrc_ies_T_new_Configuration1,
    &ett_umts_rrc_ies_PDSCH_CodeInfo,
    &ett_umts_rrc_ies_PDSCH_CodeInfoList,
    &ett_umts_rrc_ies_PDSCH_CodeMap,
    &ett_umts_rrc_ies_PDSCH_CodeMapList,
    &ett_umts_rrc_ies_PDSCH_CodeMapping,
    &ett_umts_rrc_ies_T_signallingMethod,
    &ett_umts_rrc_ies_PDSCH_Info,
    &ett_umts_rrc_ies_PDSCH_Info_r4,
    &ett_umts_rrc_ies_T_tddOption4,
    &ett_umts_rrc_ies_T_tdd3845,
    &ett_umts_rrc_ies_T_tdd1286,
    &ett_umts_rrc_ies_PDSCH_Info_LCR_r4,
    &ett_umts_rrc_ies_PDSCH_PowerControlInfo,
    &ett_umts_rrc_ies_PDSCH_SHO_DCH_Info,
    &ett_umts_rrc_ies_PDSCH_SysInfo,
    &ett_umts_rrc_ies_PDSCH_SysInfo_HCR_r5,
    &ett_umts_rrc_ies_PDSCH_SysInfo_LCR_r4,
    &ett_umts_rrc_ies_PDSCH_SysInfoList,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_HCR_r5,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_LCR_r4,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_SFN,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_item,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_HCR_r5_item,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4,
    &ett_umts_rrc_ies_PDSCH_SysInfoList_SFN_LCR_r4_item,
    &ett_umts_rrc_ies_PersistenceScalingFactorList,
    &ett_umts_rrc_ies_PichChannelisationCodeList_LCR_r4,
    &ett_umts_rrc_ies_PICH_Info,
    &ett_umts_rrc_ies_T_fdd30,
    &ett_umts_rrc_ies_T_tdd25,
    &ett_umts_rrc_ies_PICH_Info_LCR_r4,
    &ett_umts_rrc_ies_PowerControlAlgorithm,
    &ett_umts_rrc_ies_PRACH_ChanCodes_LCR_r4,
    &ett_umts_rrc_ies_PRACH_Definition_LCR_r4,
    &ett_umts_rrc_ies_PRACH_Partitioning,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_FDD,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxASC_OF_ASCSetting_TDD,
    &ett_umts_rrc_ies_PRACH_Partitioning_LCR_r4,
    &ett_umts_rrc_ies_PRACH_PowerOffset,
    &ett_umts_rrc_ies_PRACH_RACH_Info,
    &ett_umts_rrc_ies_T_modeSpecificInfo29,
    &ett_umts_rrc_ies_T_fdd31,
    &ett_umts_rrc_ies_T_tdd26,
    &ett_umts_rrc_ies_PRACH_RACH_Info_LCR_r4,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxPRACHFPACH_OF_PRACH_Definition_LCR_r4,
    &ett_umts_rrc_ies_PRACH_SystemInformation,
    &ett_umts_rrc_ies_T_modeSpecificInfo30,
    &ett_umts_rrc_ies_T_fdd32,
    &ett_umts_rrc_ies_PRACH_SystemInformation_LCR_r4,
    &ett_umts_rrc_ies_PRACH_SystemInformationList,
    &ett_umts_rrc_ies_PRACH_SystemInformationList_LCR_r4,
    &ett_umts_rrc_ies_PreDefPhyChConfiguration,
    &ett_umts_rrc_ies_PrimaryCCPCH_Info,
    &ett_umts_rrc_ies_T_fdd33,
    &ett_umts_rrc_ies_T_tdd27,
    &ett_umts_rrc_ies_SyncCase,
    &ett_umts_rrc_ies_T_syncCase1,
    &ett_umts_rrc_ies_T_syncCase2,
    &ett_umts_rrc_ies_PrimaryCCPCH_Info_r4,
    &ett_umts_rrc_ies_T_fdd34,
    &ett_umts_rrc_ies_T_tdd28,
    &ett_umts_rrc_ies_T_tddOption5,
    &ett_umts_rrc_ies_T_tdd3846,
    &ett_umts_rrc_ies_T_tdd1287,
    &ett_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4,
    &ett_umts_rrc_ies_PrimaryCCPCH_Info_LCR_r4_ext,
    &ett_umts_rrc_ies_PrimaryCCPCH_InfoPost,
    &ett_umts_rrc_ies_PrimaryCCPCH_InfoPostTDD_LCR_r4,
    &ett_umts_rrc_ies_PrimaryCPICH_Info,
    &ett_umts_rrc_ies_PUSCH_CapacityAllocationInfo,
    &ett_umts_rrc_ies_T_pusch_Allocation,
    &ett_umts_rrc_ies_T_pusch_AllocationAssignment,
    &ett_umts_rrc_ies_T_configuration2,
    &ett_umts_rrc_ies_T_old_Configuration2,
    &ett_umts_rrc_ies_T_new_Configuration2,
    &ett_umts_rrc_ies_PUSCH_CapacityAllocationInfo_r4,
    &ett_umts_rrc_ies_T_pusch_Allocation1,
    &ett_umts_rrc_ies_T_pusch_AllocationAssignment1,
    &ett_umts_rrc_ies_T_configuration3,
    &ett_umts_rrc_ies_T_old_Configuration3,
    &ett_umts_rrc_ies_T_new_Configuration3,
    &ett_umts_rrc_ies_PUSCH_Info,
    &ett_umts_rrc_ies_PUSCH_Info_r4,
    &ett_umts_rrc_ies_T_tddOption6,
    &ett_umts_rrc_ies_T_tdd3847,
    &ett_umts_rrc_ies_T_tdd1288,
    &ett_umts_rrc_ies_PUSCH_Info_LCR_r4,
    &ett_umts_rrc_ies_PUSCH_PowerControlInfo_r4,
    &ett_umts_rrc_ies_T_tddOption7,
    &ett_umts_rrc_ies_T_tdd1289,
    &ett_umts_rrc_ies_PUSCH_SysInfo,
    &ett_umts_rrc_ies_PUSCH_SysInfo_HCR_r5,
    &ett_umts_rrc_ies_PUSCH_SysInfo_LCR_r4,
    &ett_umts_rrc_ies_PUSCH_SysInfoList,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_HCR_r5,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_LCR_r4,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_SFN,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_item,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_HCR_r5_item,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4,
    &ett_umts_rrc_ies_PUSCH_SysInfoList_SFN_LCR_r4_item,
    &ett_umts_rrc_ies_RACH_TransmissionParameters,
    &ett_umts_rrc_ies_RepetitionPeriodAndLength,
    &ett_umts_rrc_ies_RepetitionPeriodLengthAndOffset,
    &ett_umts_rrc_ies_T_repetitionPeriod2,
    &ett_umts_rrc_ies_T_repetitionPeriod4,
    &ett_umts_rrc_ies_T_repetitionPeriod8,
    &ett_umts_rrc_ies_T_repetitionPeriod16,
    &ett_umts_rrc_ies_T_repetitionPeriod32,
    &ett_umts_rrc_ies_T_repetitionPeriod64,
    &ett_umts_rrc_ies_ReplacedPDSCH_CodeInfo,
    &ett_umts_rrc_ies_ReplacedPDSCH_CodeInfoList,
    &ett_umts_rrc_ies_RepPerLengthOffset_PICH,
    &ett_umts_rrc_ies_RepPerLengthOffset_MICH,
    &ett_umts_rrc_ies_RestrictedTrCH,
    &ett_umts_rrc_ies_RestrictedTrCH_InfoList,
    &ett_umts_rrc_ies_RL_AdditionInformation,
    &ett_umts_rrc_ies_RL_AdditionInformation_r6,
    &ett_umts_rrc_ies_T_dl_dpchInfo1,
    &ett_umts_rrc_ies_RL_AdditionInformationList,
    &ett_umts_rrc_ies_RL_AdditionInformationList_r6,
    &ett_umts_rrc_ies_RL_IdentifierList,
    &ett_umts_rrc_ies_RL_RemovalInformationList,
    &ett_umts_rrc_ies_SCCPCH_ChannelisationCodeList,
    &ett_umts_rrc_ies_SCCPCH_InfoForFACH,
    &ett_umts_rrc_ies_T_modeSpecificInfo31,
    &ett_umts_rrc_ies_T_fdd35,
    &ett_umts_rrc_ies_T_tdd29,
    &ett_umts_rrc_ies_SCCPCH_InfoForFACH_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo32,
    &ett_umts_rrc_ies_T_fdd36,
    &ett_umts_rrc_ies_SCCPCH_SystemInformation,
    &ett_umts_rrc_ies_SCCPCH_SystemInformation_LCR_r4_ext,
    &ett_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6_ext,
    &ett_umts_rrc_ies_SCCPCH_SystemInformationList,
    &ett_umts_rrc_ies_SCCPCH_SystemInformationList_LCR_r4_ext,
    &ett_umts_rrc_ies_SCCPCH_SystemInformationList_MBMS_r6_ext,
    &ett_umts_rrc_ies_SCCPCH_SystemInformation_MBMS_r6,
    &ett_umts_rrc_ies_T_fachCarryingMCCH,
    &ett_umts_rrc_ies_T_schedulingInformation,
    &ett_umts_rrc_ies_Scheduling_E_DCH_CellInformation,
    &ett_umts_rrc_ies_SecondaryCCPCH_Info,
    &ett_umts_rrc_ies_T_modeSpecificInfo33,
    &ett_umts_rrc_ies_T_fdd37,
    &ett_umts_rrc_ies_T_tdd30,
    &ett_umts_rrc_ies_SecondaryCCPCH_Info_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo34,
    &ett_umts_rrc_ies_T_fdd38,
    &ett_umts_rrc_ies_T_tdd31,
    &ett_umts_rrc_ies_T_tddOption8,
    &ett_umts_rrc_ies_T_tdd3848,
    &ett_umts_rrc_ies_T_tdd12810,
    &ett_umts_rrc_ies_SecondaryCCPCH_Info_LCR_r4_ext,
    &ett_umts_rrc_ies_SecondaryCCPCHInfo_MBMS_r6,
    &ett_umts_rrc_ies_T_modeSpecificInfo35,
    &ett_umts_rrc_ies_T_fdd39,
    &ett_umts_rrc_ies_SecondaryCPICH_Info,
    &ett_umts_rrc_ies_SF256_AndCodeNumber,
    &ett_umts_rrc_ies_SF512_AndCodeNumber,
    &ett_umts_rrc_ies_SF512_AndPilot,
    &ett_umts_rrc_ies_SFN_TimeInfo,
    &ett_umts_rrc_ies_SSDT_Information,
    &ett_umts_rrc_ies_SSDT_Information_r4,
    &ett_umts_rrc_ies_SynchronisationParameters_r4,
    &ett_umts_rrc_ies_T_sync_UL_CodesBitmap,
    &ett_umts_rrc_ies_SYNC_UL_Procedure_r4,
    &ett_umts_rrc_ies_SYNC_UL_Info_r4,
    &ett_umts_rrc_ies_T_sync_UL_Codes_Bitmap,
    &ett_umts_rrc_ies_TDD_PRACH_CCodeList,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode8,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_8_OF_TDD_PRACH_CCode16,
    &ett_umts_rrc_ies_TGP_Sequence,
    &ett_umts_rrc_ies_T_tgps_Status,
    &ett_umts_rrc_ies_T_activate,
    &ett_umts_rrc_ies_TGP_SequenceList,
    &ett_umts_rrc_ies_TGP_SequenceShort,
    &ett_umts_rrc_ies_T_tgps_Status1,
    &ett_umts_rrc_ies_T_activate1,
    &ett_umts_rrc_ies_TGPS_ConfigurationParams,
    &ett_umts_rrc_ies_TimeInfo,
    &ett_umts_rrc_ies_TimeslotList,
    &ett_umts_rrc_ies_TimeslotList_r4,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotNumber,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotNumber_LCR_r4,
    &ett_umts_rrc_ies_UCSM_Info,
    &ett_umts_rrc_ies_UL_CCTrCH,
    &ett_umts_rrc_ies_UL_CCTrCH_r4,
    &ett_umts_rrc_ies_T_tddOption9,
    &ett_umts_rrc_ies_T_tdd3849,
    &ett_umts_rrc_ies_T_tdd12811,
    &ett_umts_rrc_ies_UL_CCTrCHList,
    &ett_umts_rrc_ies_UL_CCTrCHList_r4,
    &ett_umts_rrc_ies_UL_CCTrCHListToRemove,
    &ett_umts_rrc_ies_UL_CCTrChTPCList,
    &ett_umts_rrc_ies_UL_ChannelRequirement,
    &ett_umts_rrc_ies_UL_ChannelRequirement_r4,
    &ett_umts_rrc_ies_UL_ChannelRequirement_r5,
    &ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID,
    &ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r4,
    &ett_umts_rrc_ies_UL_ChannelRequirementWithCPCH_SetID_r5,
    &ett_umts_rrc_ies_UL_DL_Mode,
    &ett_umts_rrc_ies_T_ul_and_dl,
    &ett_umts_rrc_ies_UL_DPCH_Info,
    &ett_umts_rrc_ies_T_modeSpecificInfo36,
    &ett_umts_rrc_ies_T_fdd40,
    &ett_umts_rrc_ies_T_tdd32,
    &ett_umts_rrc_ies_UL_DPCH_Info_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo37,
    &ett_umts_rrc_ies_T_fdd41,
    &ett_umts_rrc_ies_T_tdd33,
    &ett_umts_rrc_ies_UL_DPCH_Info_r5,
    &ett_umts_rrc_ies_T_modeSpecificInfo38,
    &ett_umts_rrc_ies_T_fdd42,
    &ett_umts_rrc_ies_T_tdd34,
    &ett_umts_rrc_ies_UL_DPCH_Info_r6,
    &ett_umts_rrc_ies_T_modeSpecificInfo39,
    &ett_umts_rrc_ies_T_fdd43,
    &ett_umts_rrc_ies_T_tdd35,
    &ett_umts_rrc_ies_UL_DPCH_InfoPostFDD,
    &ett_umts_rrc_ies_UL_DPCH_InfoPostTDD,
    &ett_umts_rrc_ies_UL_DPCH_InfoPostTDD_LCR_r4,
    &ett_umts_rrc_ies_UL_DPCH_InfoPredef,
    &ett_umts_rrc_ies_T_modeSpecificInfo40,
    &ett_umts_rrc_ies_T_fdd44,
    &ett_umts_rrc_ies_T_tdd36,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfo,
    &ett_umts_rrc_ies_T_fdd45,
    &ett_umts_rrc_ies_T_tdd37,
    &ett_umts_rrc_ies_T_ul_OL_PC_Signalling,
    &ett_umts_rrc_ies_T_individuallySignalled,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r4,
    &ett_umts_rrc_ies_T_fdd46,
    &ett_umts_rrc_ies_T_tdd38,
    &ett_umts_rrc_ies_T_ul_OL_PC_Signalling1,
    &ett_umts_rrc_ies_T_individuallySignalled1,
    &ett_umts_rrc_ies_T_tddOption10,
    &ett_umts_rrc_ies_T_tdd38410,
    &ett_umts_rrc_ies_T_tdd12812,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r5,
    &ett_umts_rrc_ies_T_fdd47,
    &ett_umts_rrc_ies_T_tdd39,
    &ett_umts_rrc_ies_T_ul_OL_PC_Signalling2,
    &ett_umts_rrc_ies_T_individuallySignalled2,
    &ett_umts_rrc_ies_T_tddOption11,
    &ett_umts_rrc_ies_T_tdd38411,
    &ett_umts_rrc_ies_T_tdd12813,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfo_r6,
    &ett_umts_rrc_ies_T_fdd48,
    &ett_umts_rrc_ies_T_tdd40,
    &ett_umts_rrc_ies_T_ul_OL_PC_Signalling3,
    &ett_umts_rrc_ies_T_individuallySignalled3,
    &ett_umts_rrc_ies_T_tddOption12,
    &ett_umts_rrc_ies_T_tdd38412,
    &ett_umts_rrc_ies_T_tdd12814,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostFDD,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPostTDD_LCR_r4,
    &ett_umts_rrc_ies_UL_DPCH_PowerControlInfoPredef,
    &ett_umts_rrc_ies_T_fdd49,
    &ett_umts_rrc_ies_T_tdd41,
    &ett_umts_rrc_ies_UL_EDCH_Information_r6,
    &ett_umts_rrc_ies_UL_SynchronisationParameters_r4,
    &ett_umts_rrc_ies_UL_TimingAdvanceControl,
    &ett_umts_rrc_ies_T_enabled,
    &ett_umts_rrc_ies_UL_TimingAdvanceControl_r4,
    &ett_umts_rrc_ies_T_enabled1,
    &ett_umts_rrc_ies_T_tddOption13,
    &ett_umts_rrc_ies_T_tdd38413,
    &ett_umts_rrc_ies_T_tdd12815,
    &ett_umts_rrc_ies_UL_TimingAdvanceControl_LCR_r4,
    &ett_umts_rrc_ies_T_enabled2,
    &ett_umts_rrc_ies_UL_TS_ChannelisationCodeList,
    &ett_umts_rrc_ies_UplinkAdditionalTimeslots,
    &ett_umts_rrc_ies_T_parameters2,
    &ett_umts_rrc_ies_T_sameAsLast2,
    &ett_umts_rrc_ies_T_newParameters2,
    &ett_umts_rrc_ies_UplinkAdditionalTimeslots_LCR_r4,
    &ett_umts_rrc_ies_T_parameters3,
    &ett_umts_rrc_ies_T_sameAsLast3,
    &ett_umts_rrc_ies_T_newParameters3,
    &ett_umts_rrc_ies_UplinkTimeslotsCodes,
    &ett_umts_rrc_ies_T_moreTimeslots2,
    &ett_umts_rrc_ies_T_additionalTimeslots2,
    &ett_umts_rrc_ies_T_consecutive1,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS1_OF_UplinkAdditionalTimeslots,
    &ett_umts_rrc_ies_UplinkTimeslotsCodes_LCR_r4,
    &ett_umts_rrc_ies_T_moreTimeslots3,
    &ett_umts_rrc_ies_T_additionalTimeslots3,
    &ett_umts_rrc_ies_T_consecutive2,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR1_OF_UplinkAdditionalTimeslots_LCR_r4,
    &ett_umts_rrc_ies_AcquisitionSatInfo,
    &ett_umts_rrc_ies_AcquisitionSatInfoList,
    &ett_umts_rrc_ies_AdditionalMeasurementID_List,
    &ett_umts_rrc_ies_AlmanacSatInfo,
    &ett_umts_rrc_ies_AlmanacSatInfoList,
    &ett_umts_rrc_ies_AzimuthAndElevation,
    &ett_umts_rrc_ies_BadSatList,
    &ett_umts_rrc_ies_BLER_MeasurementResults,
    &ett_umts_rrc_ies_BLER_MeasurementResultsList,
    &ett_umts_rrc_ies_BLER_TransChIdList,
    &ett_umts_rrc_ies_BSICReported,
    &ett_umts_rrc_ies_BurstModeParameters,
    &ett_umts_rrc_ies_CellDCH_ReportCriteria,
    &ett_umts_rrc_ies_CellDCH_ReportCriteria_LCR_r4,
    &ett_umts_rrc_ies_CellInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo41,
    &ett_umts_rrc_ies_T_fdd50,
    &ett_umts_rrc_ies_T_tdd42,
    &ett_umts_rrc_ies_CellInfo_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo42,
    &ett_umts_rrc_ies_T_fdd51,
    &ett_umts_rrc_ies_T_tdd43,
    &ett_umts_rrc_ies_CellInfoSI_RSCP,
    &ett_umts_rrc_ies_T_modeSpecificInfo43,
    &ett_umts_rrc_ies_T_fdd52,
    &ett_umts_rrc_ies_T_tdd44,
    &ett_umts_rrc_ies_CellInfoSI_RSCP_LCR_r4,
    &ett_umts_rrc_ies_CellInfoSI_ECN0,
    &ett_umts_rrc_ies_T_modeSpecificInfo44,
    &ett_umts_rrc_ies_T_fdd53,
    &ett_umts_rrc_ies_T_tdd45,
    &ett_umts_rrc_ies_CellInfoSI_ECN0_LCR_r4,
    &ett_umts_rrc_ies_CellInfoSI_HCS_RSCP,
    &ett_umts_rrc_ies_T_modeSpecificInfo45,
    &ett_umts_rrc_ies_T_fdd54,
    &ett_umts_rrc_ies_T_tdd46,
    &ett_umts_rrc_ies_CellInfoSI_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_CellInfoSI_HCS_ECN0,
    &ett_umts_rrc_ies_T_modeSpecificInfo46,
    &ett_umts_rrc_ies_T_fdd55,
    &ett_umts_rrc_ies_T_tdd47,
    &ett_umts_rrc_ies_CellInfoSI_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_CellMeasuredResults,
    &ett_umts_rrc_ies_T_modeSpecificInfo47,
    &ett_umts_rrc_ies_T_fdd56,
    &ett_umts_rrc_ies_T_tdd48,
    &ett_umts_rrc_ies_CellMeasurementEventResults,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCPICH_Info,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_PrimaryCCPCH_Info,
    &ett_umts_rrc_ies_CellMeasurementEventResults_LCR_r4,
    &ett_umts_rrc_ies_CellReportingQuantities,
    &ett_umts_rrc_ies_T_modeSpecificInfo48,
    &ett_umts_rrc_ies_T_fdd57,
    &ett_umts_rrc_ies_T_tdd49,
    &ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12,
    &ett_umts_rrc_ies_T_modeSpecificInfo49,
    &ett_umts_rrc_ies_T_fdd58,
    &ett_umts_rrc_ies_T_tdd50,
    &ett_umts_rrc_ies_T_gsm,
    &ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_RSCP,
    &ett_umts_rrc_ies_T_modeSpecificInfo50,
    &ett_umts_rrc_ies_T_fdd59,
    &ett_umts_rrc_ies_T_tdd51,
    &ett_umts_rrc_ies_T_gsm1,
    &ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_ECN0,
    &ett_umts_rrc_ies_T_modeSpecificInfo51,
    &ett_umts_rrc_ies_T_fdd60,
    &ett_umts_rrc_ies_T_tdd52,
    &ett_umts_rrc_ies_T_gsm2,
    &ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_RSCP,
    &ett_umts_rrc_ies_T_modeSpecificInfo52,
    &ett_umts_rrc_ies_T_fdd61,
    &ett_umts_rrc_ies_T_tdd53,
    &ett_umts_rrc_ies_T_gsm3,
    &ett_umts_rrc_ies_CellSelectReselectInfoSIB_11_12_HCS_ECN0,
    &ett_umts_rrc_ies_T_modeSpecificInfo53,
    &ett_umts_rrc_ies_T_fdd62,
    &ett_umts_rrc_ies_T_tdd54,
    &ett_umts_rrc_ies_T_gsm4,
    &ett_umts_rrc_ies_CellSelectReselectInfo_v590ext,
    &ett_umts_rrc_ies_CellSelectReselectInfoPCHFACH_v5b0ext,
    &ett_umts_rrc_ies_CellSelectReselectInfoTreselectionScaling_v5c0ext,
    &ett_umts_rrc_ies_CellsForInterFreqMeasList,
    &ett_umts_rrc_ies_CellsForInterRATMeasList,
    &ett_umts_rrc_ies_CellsForIntraFreqMeasList,
    &ett_umts_rrc_ies_CellSynchronisationInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo54,
    &ett_umts_rrc_ies_T_fdd63,
    &ett_umts_rrc_ies_T_tdd55,
    &ett_umts_rrc_ies_CellToReport,
    &ett_umts_rrc_ies_CellToReportList,
    &ett_umts_rrc_ies_CountC_SFN_Frame_difference,
    &ett_umts_rrc_ies_DeltaRSCPPerCell,
    &ett_umts_rrc_ies_DGPS_CorrectionSatInfo,
    &ett_umts_rrc_ies_DGPS_CorrectionSatInfoList,
    &ett_umts_rrc_ies_EllipsoidPoint,
    &ett_umts_rrc_ies_EllipsoidPointAltitude,
    &ett_umts_rrc_ies_EllipsoidPointAltitudeEllipsoide,
    &ett_umts_rrc_ies_EllipsoidPointUncertCircle,
    &ett_umts_rrc_ies_EllipsoidPointUncertEllipse,
    &ett_umts_rrc_ies_Event1a,
    &ett_umts_rrc_ies_Event1a_r4,
    &ett_umts_rrc_ies_Event1a_LCR_r4,
    &ett_umts_rrc_ies_Event1b,
    &ett_umts_rrc_ies_Event1b_r4,
    &ett_umts_rrc_ies_Event1b_LCR_r4,
    &ett_umts_rrc_ies_Event1c,
    &ett_umts_rrc_ies_Event1e,
    &ett_umts_rrc_ies_Event1f,
    &ett_umts_rrc_ies_Event2a,
    &ett_umts_rrc_ies_Event2b,
    &ett_umts_rrc_ies_Event2c,
    &ett_umts_rrc_ies_Event2d,
    &ett_umts_rrc_ies_Event2e,
    &ett_umts_rrc_ies_Event2f,
    &ett_umts_rrc_ies_Event3a,
    &ett_umts_rrc_ies_Event3b,
    &ett_umts_rrc_ies_Event3c,
    &ett_umts_rrc_ies_Event3d,
    &ett_umts_rrc_ies_EventResults,
    &ett_umts_rrc_ies_ExtraDopplerInfo,
    &ett_umts_rrc_ies_FACH_MeasurementOccasionInfo,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxOtherRAT_OF_RAT_Type,
    &ett_umts_rrc_ies_FACH_MeasurementOccasionInfo_LCR_r4_ext,
    &ett_umts_rrc_ies_ForbiddenAffectCell,
    &ett_umts_rrc_ies_ForbiddenAffectCell_r4,
    &ett_umts_rrc_ies_ForbiddenAffectCell_LCR_r4,
    &ett_umts_rrc_ies_ForbiddenAffectCellList,
    &ett_umts_rrc_ies_ForbiddenAffectCellList_r4,
    &ett_umts_rrc_ies_ForbiddenAffectCellList_LCR_r4,
    &ett_umts_rrc_ies_GPS_MeasurementParam,
    &ett_umts_rrc_ies_GPS_MeasurementParamList,
    &ett_umts_rrc_ies_GSM_MeasuredResults,
    &ett_umts_rrc_ies_GSM_MeasuredResultsList,
    &ett_umts_rrc_ies_GPS_TOW_Assist,
    &ett_umts_rrc_ies_GPS_TOW_AssistList,
    &ett_umts_rrc_ies_HCS_CellReselectInformation_RSCP,
    &ett_umts_rrc_ies_HCS_CellReselectInformation_ECN0,
    &ett_umts_rrc_ies_HCS_NeighbouringCellInformation_RSCP,
    &ett_umts_rrc_ies_HCS_NeighbouringCellInformation_ECN0,
    &ett_umts_rrc_ies_HCS_ServingCellInformation,
    &ett_umts_rrc_ies_InterFreqCell,
    &ett_umts_rrc_ies_InterFreqCell_LCR_r4,
    &ett_umts_rrc_ies_InterFreqCellInfoList,
    &ett_umts_rrc_ies_InterFreqCellInfoList_r4,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_RSCP_LCR,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_ECN0_LCR,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_RSCP_LCR,
    &ett_umts_rrc_ies_InterFreqCellInfoSI_List_HCS_ECN0_LCR,
    &ett_umts_rrc_ies_InterFreqCellList,
    &ett_umts_rrc_ies_InterFreqCellList_LCR_r4_ext,
    &ett_umts_rrc_ies_InterFreqCellMeasuredResultsList,
    &ett_umts_rrc_ies_InterFreqEvent,
    &ett_umts_rrc_ies_InterFreqEventList,
    &ett_umts_rrc_ies_InterFrequencyMeasuredResultsList_v590ext,
    &ett_umts_rrc_ies_Inter_FreqEventCriteria_v590ext,
    &ett_umts_rrc_ies_Inter_FreqEventCriteriaList_v590ext,
    &ett_umts_rrc_ies_Intra_FreqEventCriteriaList_v590ext,
    &ett_umts_rrc_ies_IntraFrequencyMeasuredResultsList_v590ext,
    &ett_umts_rrc_ies_IntraFreqReportingCriteria_1b_r5,
    &ett_umts_rrc_ies_PeriodicReportingInfo_1b,
    &ett_umts_rrc_ies_InterFreqEventResults,
    &ett_umts_rrc_ies_InterFreqEventResults_LCR_r4_ext,
    &ett_umts_rrc_ies_InterFreqMeasQuantity,
    &ett_umts_rrc_ies_T_reportingCriteria,
    &ett_umts_rrc_ies_T_intraFreqReportingCriteria,
    &ett_umts_rrc_ies_T_interFreqReportingCriteria,
    &ett_umts_rrc_ies_T_modeSpecificInfo55,
    &ett_umts_rrc_ies_T_fdd64,
    &ett_umts_rrc_ies_T_tdd56,
    &ett_umts_rrc_ies_InterFreqMeasuredResults,
    &ett_umts_rrc_ies_InterFreqMeasuredResultsList,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_RSCP_LCR_r4,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_ECN0_LCR_r4,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_InterFreqMeasurementSysInfo_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_InterFreqRACHRepCellsList,
    &ett_umts_rrc_ies_InterFreqRACHReportingInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo56,
    &ett_umts_rrc_ies_T_fdd65,
    &ett_umts_rrc_ies_T_tdd57,
    &ett_umts_rrc_ies_InterFreqReportCriteria,
    &ett_umts_rrc_ies_InterFreqReportCriteria_r4,
    &ett_umts_rrc_ies_InterFreqReportingCriteria,
    &ett_umts_rrc_ies_InterFreqReportingQuantity,
    &ett_umts_rrc_ies_InterFreqRepQuantityRACH_TDDList,
    &ett_umts_rrc_ies_InterFrequencyMeasurement,
    &ett_umts_rrc_ies_InterFrequencyMeasurement_r4,
    &ett_umts_rrc_ies_InterRAT_TargetCellDescription,
    &ett_umts_rrc_ies_T_technologySpecificInfo,
    &ett_umts_rrc_ies_T_gsm5,
    &ett_umts_rrc_ies_InterRATCellInfoList,
    &ett_umts_rrc_ies_InterRATCellInfoList_B,
    &ett_umts_rrc_ies_InterRATCellInfoList_r4,
    &ett_umts_rrc_ies_InterRATEvent,
    &ett_umts_rrc_ies_InterRATEventList,
    &ett_umts_rrc_ies_InterRATEventResults,
    &ett_umts_rrc_ies_InterRATInfo_r6,
    &ett_umts_rrc_ies_InterRATMeasQuantity,
    &ett_umts_rrc_ies_T_ratSpecificInfo,
    &ett_umts_rrc_ies_T_gsm6,
    &ett_umts_rrc_ies_T_is_2000,
    &ett_umts_rrc_ies_InterRATMeasuredResults,
    &ett_umts_rrc_ies_InterRATMeasuredResultsList,
    &ett_umts_rrc_ies_InterRATMeasurement,
    &ett_umts_rrc_ies_InterRATMeasurement_r4,
    &ett_umts_rrc_ies_InterRATMeasurementSysInfo,
    &ett_umts_rrc_ies_InterRATMeasurementSysInfo_B,
    &ett_umts_rrc_ies_InterRATReportCriteria,
    &ett_umts_rrc_ies_InterRATReportingCriteria,
    &ett_umts_rrc_ies_InterRATReportingQuantity,
    &ett_umts_rrc_ies_T_ratSpecificInfo1,
    &ett_umts_rrc_ies_T_gsm7,
    &ett_umts_rrc_ies_IntraFreqCellInfoList,
    &ett_umts_rrc_ies_IntraFreqCellInfoList_r4,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_RSCP_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_ECN0_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqCellInfoSI_List_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqEvent,
    &ett_umts_rrc_ies_IntraFreqEvent_r4,
    &ett_umts_rrc_ies_IntraFreqEvent_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqEvent_1d_r5,
    &ett_umts_rrc_ies_IntraFreqEventCriteria,
    &ett_umts_rrc_ies_IntraFreqEventCriteria_r4,
    &ett_umts_rrc_ies_IntraFreqEventCriteria_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqEventCriteriaList,
    &ett_umts_rrc_ies_IntraFreqEventCriteriaList_r4,
    &ett_umts_rrc_ies_IntraFreqEventCriteriaList_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqEventResults,
    &ett_umts_rrc_ies_IntraFreqMeasQuantity,
    &ett_umts_rrc_ies_T_modeSpecificInfo57,
    &ett_umts_rrc_ies_T_fdd66,
    &ett_umts_rrc_ies_T_tdd58,
    &ett_umts_rrc_ies_IntraFreqMeasQuantity_TDDList,
    &ett_umts_rrc_ies_IntraFreqMeasuredResultsList,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_RSCP_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_ECN0_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqMeasurementSysInfo_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqReportCriteria,
    &ett_umts_rrc_ies_IntraFreqReportCriteria_r4,
    &ett_umts_rrc_ies_IntraFreqReportingCriteria,
    &ett_umts_rrc_ies_IntraFreqReportingCriteria_r4,
    &ett_umts_rrc_ies_IntraFreqReportingCriteria_LCR_r4,
    &ett_umts_rrc_ies_IntraFreqReportingQuantity,
    &ett_umts_rrc_ies_IntraFreqReportingQuantityForRACH,
    &ett_umts_rrc_ies_T_modeSpecificInfo58,
    &ett_umts_rrc_ies_T_fdd67,
    &ett_umts_rrc_ies_T_tdd59,
    &ett_umts_rrc_ies_IntraFreqRepQuantityRACH_TDDList,
    &ett_umts_rrc_ies_IntraFrequencyMeasurement,
    &ett_umts_rrc_ies_IntraFrequencyMeasurement_r4,
    &ett_umts_rrc_ies_MeasuredResults,
    &ett_umts_rrc_ies_MeasuredResults_v390ext,
    &ett_umts_rrc_ies_MeasuredResults_v590ext,
    &ett_umts_rrc_ies_MeasuredResults_LCR_r4,
    &ett_umts_rrc_ies_MeasuredResultsList,
    &ett_umts_rrc_ies_MeasuredResultsList_LCR_r4_ext,
    &ett_umts_rrc_ies_MeasuredResultsOnRACH,
    &ett_umts_rrc_ies_T_currentCell,
    &ett_umts_rrc_ies_T_modeSpecificInfo59,
    &ett_umts_rrc_ies_T_fdd68,
    &ett_umts_rrc_ies_T_measurementQuantity,
    &ett_umts_rrc_ies_T_tdd60,
    &ett_umts_rrc_ies_MeasuredResultsOnRACHinterFreq,
    &ett_umts_rrc_ies_MeasurementCommand,
    &ett_umts_rrc_ies_T_modify1,
    &ett_umts_rrc_ies_MeasurementCommand_r4,
    &ett_umts_rrc_ies_T_modify2,
    &ett_umts_rrc_ies_MeasurementControlSysInfo,
    &ett_umts_rrc_ies_T_use_of_HCS,
    &ett_umts_rrc_ies_T_hcs_not_used,
    &ett_umts_rrc_ies_T_cellSelectQualityMeasure1,
    &ett_umts_rrc_ies_T_cpich_RSCP,
    &ett_umts_rrc_ies_T_cpich_Ec_N01,
    &ett_umts_rrc_ies_T_hcs_used,
    &ett_umts_rrc_ies_T_cellSelectQualityMeasure2,
    &ett_umts_rrc_ies_T_cpich_RSCP1,
    &ett_umts_rrc_ies_T_cpich_Ec_N02,
    &ett_umts_rrc_ies_MeasurementControlSysInfo_LCR_r4_ext,
    &ett_umts_rrc_ies_T_use_of_HCS1,
    &ett_umts_rrc_ies_T_hcs_not_used1,
    &ett_umts_rrc_ies_T_cellSelectQualityMeasure3,
    &ett_umts_rrc_ies_T_cpich_RSCP2,
    &ett_umts_rrc_ies_T_cpich_Ec_N03,
    &ett_umts_rrc_ies_T_hcs_used1,
    &ett_umts_rrc_ies_T_cellSelectQualityMeasure4,
    &ett_umts_rrc_ies_T_cpich_RSCP3,
    &ett_umts_rrc_ies_T_cpich_Ec_N04,
    &ett_umts_rrc_ies_MeasurementReportingMode,
    &ett_umts_rrc_ies_MeasurementType,
    &ett_umts_rrc_ies_MeasurementType_r4,
    &ett_umts_rrc_ies_MeasurementValidity,
    &ett_umts_rrc_ies_MonitoredCellRACH_List,
    &ett_umts_rrc_ies_MonitoredCellRACH_Result,
    &ett_umts_rrc_ies_T_modeSpecificInfo60,
    &ett_umts_rrc_ies_T_fdd69,
    &ett_umts_rrc_ies_T_measurementQuantity1,
    &ett_umts_rrc_ies_T_tdd61,
    &ett_umts_rrc_ies_N_CR_T_CRMaxHyst,
    &ett_umts_rrc_ies_NavigationModelSatInfo,
    &ett_umts_rrc_ies_NavigationModelSatInfoList,
    &ett_umts_rrc_ies_EphemerisParameter,
    &ett_umts_rrc_ies_Neighbour,
    &ett_umts_rrc_ies_T_modeSpecificInfo61,
    &ett_umts_rrc_ies_T_fdd70,
    &ett_umts_rrc_ies_T_tdd62,
    &ett_umts_rrc_ies_Neighbour_v390ext,
    &ett_umts_rrc_ies_T_modeSpecificInfo62,
    &ett_umts_rrc_ies_T_fdd71,
    &ett_umts_rrc_ies_NeighbourList,
    &ett_umts_rrc_ies_NeighbourList_v390ext,
    &ett_umts_rrc_ies_NeighbourQuality,
    &ett_umts_rrc_ies_NewInterFreqCell,
    &ett_umts_rrc_ies_NewInterFreqCell_r4,
    &ett_umts_rrc_ies_NewInterFreqCellList,
    &ett_umts_rrc_ies_NewInterFreqCellList_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_RSCP,
    &ett_umts_rrc_ies_NewInterFreqCellSI_ECN0,
    &ett_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP,
    &ett_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0,
    &ett_umts_rrc_ies_NewInterFreqCellSI_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_ECN0,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_RSCP,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewInterFreqCellSI_List_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewInterRATCell,
    &ett_umts_rrc_ies_T_technologySpecificInfo1,
    &ett_umts_rrc_ies_T_gsm8,
    &ett_umts_rrc_ies_T_is_20001,
    &ett_umts_rrc_ies_NewInterRATCell_B,
    &ett_umts_rrc_ies_T_technologySpecificInfo2,
    &ett_umts_rrc_ies_T_gsm9,
    &ett_umts_rrc_ies_T_is_20002,
    &ett_umts_rrc_ies_NewInterRATCellList,
    &ett_umts_rrc_ies_NewInterRATCellList_B,
    &ett_umts_rrc_ies_NewIntraFreqCell,
    &ett_umts_rrc_ies_NewIntraFreqCell_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellList,
    &ett_umts_rrc_ies_NewIntraFreqCellList_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_RSCP,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_ECN0,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_RSCP_LCR_r4,
    &ett_umts_rrc_ies_NewIntraFreqCellSI_List_HCS_ECN0_LCR_r4,
    &ett_umts_rrc_ies_NonUsedFreqParameter,
    &ett_umts_rrc_ies_NonUsedFreqParameterList,
    &ett_umts_rrc_ies_PenaltyTime_RSCP,
    &ett_umts_rrc_ies_PenaltyTime_ECN0,
    &ett_umts_rrc_ies_PeriodicalReportingCriteria,
    &ett_umts_rrc_ies_PeriodicalWithReportingCellStatus,
    &ett_umts_rrc_ies_PLMNIdentitiesOfNeighbourCells,
    &ett_umts_rrc_ies_PLMNsOfInterFreqCellsList,
    &ett_umts_rrc_ies_PLMNsOfInterFreqCellsList_item,
    &ett_umts_rrc_ies_PLMNsOfIntraFreqCellsList,
    &ett_umts_rrc_ies_PLMNsOfIntraFreqCellsList_item,
    &ett_umts_rrc_ies_PLMNsOfInterRATCellsList,
    &ett_umts_rrc_ies_PLMNsOfInterRATCellsList_item,
    &ett_umts_rrc_ies_PositionEstimate,
    &ett_umts_rrc_ies_QualityEventResults,
    &ett_umts_rrc_ies_QualityMeasuredResults,
    &ett_umts_rrc_ies_T_modeSpecificInfo63,
    &ett_umts_rrc_ies_T_tdd63,
    &ett_umts_rrc_ies_QualityMeasurement,
    &ett_umts_rrc_ies_QualityReportCriteria,
    &ett_umts_rrc_ies_QualityReportingCriteria,
    &ett_umts_rrc_ies_QualityReportingCriteriaSingle,
    &ett_umts_rrc_ies_QualityReportingQuantity,
    &ett_umts_rrc_ies_T_modeSpecificInfo64,
    &ett_umts_rrc_ies_T_tdd64,
    &ett_umts_rrc_ies_ReferenceCellPosition,
    &ett_umts_rrc_ies_ReferenceLocation,
    &ett_umts_rrc_ies_ReferenceTimeDifferenceToCell,
    &ett_umts_rrc_ies_RemovedInterFreqCellList,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterFreqCellID,
    &ett_umts_rrc_ies_RemovedInterRATCellList,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_InterRATCellID,
    &ett_umts_rrc_ies_RemovedIntraFreqCellList,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_IntraFreqCellID,
    &ett_umts_rrc_ies_ReportingCellStatus,
    &ett_umts_rrc_ies_ReportingCellStatusOpt,
    &ett_umts_rrc_ies_ReportingInfoForCellDCH,
    &ett_umts_rrc_ies_ReportingInfoForCellDCH_LCR_r4,
    &ett_umts_rrc_ies_RL_AdditionInfoList,
    &ett_umts_rrc_ies_RL_InformationLists,
    &ett_umts_rrc_ies_SatData,
    &ett_umts_rrc_ies_SatDataList,
    &ett_umts_rrc_ies_SFN_SFN_ObsTimeDifference,
    &ett_umts_rrc_ies_SFN_SFN_RelTimeDifference1,
    &ett_umts_rrc_ies_SIR_MeasurementList,
    &ett_umts_rrc_ies_SIR_MeasurementResults,
    &ett_umts_rrc_ies_SIR_TFCS_List,
    &ett_umts_rrc_ies_SIR_TimeslotList,
    &ett_umts_rrc_ies_SubFrame1Reserved,
    &ett_umts_rrc_ies_T_ADVinfo,
    &ett_umts_rrc_ies_T_CRMax,
    &ett_umts_rrc_ies_TemporaryOffsetList,
    &ett_umts_rrc_ies_ThreholdNonUsedFrequency_deltaList,
    &ett_umts_rrc_ies_TimeslotInfo,
    &ett_umts_rrc_ies_TimeslotInfo_LCR_r4,
    &ett_umts_rrc_ies_TimeslotInfoList,
    &ett_umts_rrc_ies_TimeslotInfoList_LCR_r4,
    &ett_umts_rrc_ies_TimeslotInfoList_r4,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTS_OF_TimeslotInfo,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxTSLCR_OF_TimeslotInfo_LCR_r4,
    &ett_umts_rrc_ies_TimeslotISCP_List,
    &ett_umts_rrc_ies_TimeslotListWithISCP,
    &ett_umts_rrc_ies_TimeslotWithISCP,
    &ett_umts_rrc_ies_TrafficVolumeEventParam,
    &ett_umts_rrc_ies_TrafficVolumeEventResults,
    &ett_umts_rrc_ies_TrafficVolumeMeasQuantity,
    &ett_umts_rrc_ies_TrafficVolumeMeasSysInfo,
    &ett_umts_rrc_ies_TrafficVolumeMeasuredResults,
    &ett_umts_rrc_ies_TrafficVolumeMeasuredResultsList,
    &ett_umts_rrc_ies_TrafficVolumeMeasurement,
    &ett_umts_rrc_ies_TrafficVolumeMeasurementObjectList,
    &ett_umts_rrc_ies_TrafficVolumeReportCriteria,
    &ett_umts_rrc_ies_TrafficVolumeReportCriteriaSysInfo,
    &ett_umts_rrc_ies_TrafficVolumeReportingCriteria,
    &ett_umts_rrc_ies_TrafficVolumeReportingQuantity,
    &ett_umts_rrc_ies_TransChCriteria,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxMeasParEvent_OF_TrafficVolumeEventParam,
    &ett_umts_rrc_ies_TransChCriteriaList,
    &ett_umts_rrc_ies_UE_6AB_Event,
    &ett_umts_rrc_ies_UE_6FG_Event,
    &ett_umts_rrc_ies_UE_AutonomousUpdateMode,
    &ett_umts_rrc_ies_UE_InternalEventParam,
    &ett_umts_rrc_ies_UE_InternalEventParamList,
    &ett_umts_rrc_ies_UE_InternalEventResults,
    &ett_umts_rrc_ies_UE_InternalMeasQuantity,
    &ett_umts_rrc_ies_UE_InternalMeasuredResults,
    &ett_umts_rrc_ies_T_modeSpecificInfo65,
    &ett_umts_rrc_ies_T_fdd72,
    &ett_umts_rrc_ies_T_tdd65,
    &ett_umts_rrc_ies_UE_InternalMeasuredResults_LCR_r4,
    &ett_umts_rrc_ies_UE_InternalMeasurement,
    &ett_umts_rrc_ies_UE_InternalMeasurement_r4,
    &ett_umts_rrc_ies_UE_InternalMeasurementSysInfo,
    &ett_umts_rrc_ies_UE_InternalReportCriteria,
    &ett_umts_rrc_ies_UE_InternalReportingCriteria,
    &ett_umts_rrc_ies_UE_InternalReportingQuantity,
    &ett_umts_rrc_ies_T_modeSpecificInfo66,
    &ett_umts_rrc_ies_T_fdd73,
    &ett_umts_rrc_ies_T_tdd66,
    &ett_umts_rrc_ies_UE_InternalReportingQuantity_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo67,
    &ett_umts_rrc_ies_T_fdd74,
    &ett_umts_rrc_ies_T_tdd67,
    &ett_umts_rrc_ies_T_tddOption14,
    &ett_umts_rrc_ies_T_tdd38414,
    &ett_umts_rrc_ies_T_tdd12816,
    &ett_umts_rrc_ies_UE_RX_TX_ReportEntry,
    &ett_umts_rrc_ies_UE_RX_TX_ReportEntryList,
    &ett_umts_rrc_ies_UE_RX_TX_TimeDifferenceType2Info,
    &ett_umts_rrc_ies_UE_TransmittedPowerTDD_List,
    &ett_umts_rrc_ies_UL_TrCH_Identity,
    &ett_umts_rrc_ies_UE_Positioning_CipherParameters,
    &ett_umts_rrc_ies_UE_Positioning_Error,
    &ett_umts_rrc_ies_UE_Positioning_EventParam,
    &ett_umts_rrc_ies_UE_Positioning_EventParamList,
    &ett_umts_rrc_ies_UE_Positioning_EventSpecificInfo,
    &ett_umts_rrc_ies_UE_Positioning_GPS_AcquisitionAssistance,
    &ett_umts_rrc_ies_UE_Positioning_GPS_AdditionalAssistanceDataRequest,
    &ett_umts_rrc_ies_UE_Positioning_GPS_Almanac,
    &ett_umts_rrc_ies_UE_Positioning_GPS_AssistanceData,
    &ett_umts_rrc_ies_UE_Positioning_GPS_DGPS_Corrections,
    &ett_umts_rrc_ies_UE_Positioning_GPS_IonosphericModel,
    &ett_umts_rrc_ies_UE_Positioning_GPS_MeasurementResults,
    &ett_umts_rrc_ies_T_referenceTime,
    &ett_umts_rrc_ies_UE_Positioning_GPS_NavigationModel,
    &ett_umts_rrc_ies_UE_Positioning_GPS_NavModelAddDataReq,
    &ett_umts_rrc_ies_UE_Positioning_GPS_ReferenceCellInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo68,
    &ett_umts_rrc_ies_T_fdd75,
    &ett_umts_rrc_ies_T_tdd68,
    &ett_umts_rrc_ies_UE_Positioning_GPS_ReferenceTime,
    &ett_umts_rrc_ies_UE_Positioning_GPS_UTC_Model,
    &ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters,
    &ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo69,
    &ett_umts_rrc_ies_T_fdd76,
    &ett_umts_rrc_ies_T_tdd69,
    &ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDD_r4_ext,
    &ett_umts_rrc_ies_UE_Positioning_MeasuredResults,
    &ett_umts_rrc_ies_UE_Positioning_MeasuredResults_v390ext,
    &ett_umts_rrc_ies_UE_Positioning_Measurement,
    &ett_umts_rrc_ies_UE_Positioning_Measurement_v390ext,
    &ett_umts_rrc_ies_UE_Positioning_Measurement_r4,
    &ett_umts_rrc_ies_UE_Positioning_MeasurementEventResults,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_r4ext,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_AssistanceData_UEB,
    &ett_umts_rrc_ies_UE_Positioning_IPDL_Parameters_TDDList_r4_ext,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_Measurement,
    &ett_umts_rrc_ies_T_modeSpecificInfo70,
    &ett_umts_rrc_ies_T_fdd77,
    &ett_umts_rrc_ies_T_tdd70,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_Measurement_v390ext,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo71,
    &ett_umts_rrc_ies_T_fdd78,
    &ett_umts_rrc_ies_T_tdd71,
    &ett_umts_rrc_ies_T_positioningMode,
    &ett_umts_rrc_ies_T_ueBased,
    &ett_umts_rrc_ies_T_ueAssisted,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo72,
    &ett_umts_rrc_ies_T_fdd79,
    &ett_umts_rrc_ies_T_tdd72,
    &ett_umts_rrc_ies_T_positioningMode1,
    &ett_umts_rrc_ies_T_ueBased1,
    &ett_umts_rrc_ies_T_ueAssisted1,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellInfo_UEB,
    &ett_umts_rrc_ies_T_modeSpecificInfo73,
    &ett_umts_rrc_ies_T_fdd80,
    &ett_umts_rrc_ies_T_tdd73,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_r4,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_NeighbourCellList_UEB,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_Quality,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo,
    &ett_umts_rrc_ies_T_modeSpecificInfo74,
    &ett_umts_rrc_ies_T_fdd81,
    &ett_umts_rrc_ies_T_tdd74,
    &ett_umts_rrc_ies_T_positioningMode2,
    &ett_umts_rrc_ies_T_ueBased2,
    &ett_umts_rrc_ies_T_ueAssisted2,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_r4,
    &ett_umts_rrc_ies_T_modeSpecificInfo75,
    &ett_umts_rrc_ies_T_fdd82,
    &ett_umts_rrc_ies_T_tdd75,
    &ett_umts_rrc_ies_T_positioningMode3,
    &ett_umts_rrc_ies_T_ueBased3,
    &ett_umts_rrc_ies_T_ueAssisted3,
    &ett_umts_rrc_ies_UE_Positioning_OTDOA_ReferenceCellInfo_UEB,
    &ett_umts_rrc_ies_T_modeSpecificInfo76,
    &ett_umts_rrc_ies_T_fdd83,
    &ett_umts_rrc_ies_T_tdd76,
    &ett_umts_rrc_ies_UE_Positioning_PositionEstimateInfo,
    &ett_umts_rrc_ies_T_referenceTime1,
    &ett_umts_rrc_ies_T_cell_Timing,
    &ett_umts_rrc_ies_T_modeSpecificInfo77,
    &ett_umts_rrc_ies_T_fdd84,
    &ett_umts_rrc_ies_T_tdd77,
    &ett_umts_rrc_ies_UE_Positioning_ReportCriteria,
    &ett_umts_rrc_ies_UE_Positioning_ReportingQuantity,
    &ett_umts_rrc_ies_UE_Positioning_ReportingQuantity_v390ext,
    &ett_umts_rrc_ies_UE_Positioning_ReportingQuantity_r4,
    &ett_umts_rrc_ies_UTRAN_GPSReferenceTime,
    &ett_umts_rrc_ies_T_utran_GPSTimingOfCell,
    &ett_umts_rrc_ies_T_modeSpecificInfo78,
    &ett_umts_rrc_ies_T_fdd85,
    &ett_umts_rrc_ies_T_tdd78,
    &ett_umts_rrc_ies_UTRAN_GPSReferenceTimeResult,
    &ett_umts_rrc_ies_T_ue_GPSTimingOfCell,
    &ett_umts_rrc_ies_T_modeSpecificInfo79,
    &ett_umts_rrc_ies_T_fdd86,
    &ett_umts_rrc_ies_T_tdd79,
    &ett_umts_rrc_ies_BCCH_ModificationInfo,
    &ett_umts_rrc_ies_BSIC,
    &ett_umts_rrc_ies_CBS_DRX_Level1Information,
    &ett_umts_rrc_ies_CDMA2000_Message,
    &ett_umts_rrc_ies_CDMA2000_MessageList,
    &ett_umts_rrc_ies_CDMA2000_UMTS_Frequency_List,
    &ett_umts_rrc_ies_FDD_UMTS_Frequency_List,
    &ett_umts_rrc_ies_FrequencyInfoCDMA2000,
    &ett_umts_rrc_ies_GERAN_SystemInformation,
    &ett_umts_rrc_ies_GSM_BA_Range,
    &ett_umts_rrc_ies_GSM_BA_Range_List,
    &ett_umts_rrc_ies_GSM_MessageList,
    &ett_umts_rrc_ies_GsmSecurityCapability,
    &ett_umts_rrc_ies_GSMSecurityCapability_v6xyext,
    &ett_umts_rrc_ies_GSM_TargetCellInfoList,
    &ett_umts_rrc_ies_GSM_TargetCellInfo,
    &ett_umts_rrc_ies_IdentificationOfReceivedMessage,
    &ett_umts_rrc_ies_InterRAT_ChangeFailureCause,
    &ett_umts_rrc_ies_GERANIu_MessageList,
    &ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability,
    &ett_umts_rrc_ies_T_gsm10,
    &ett_umts_rrc_ies_T_cdma2000,
    &ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapabilityList,
    &ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v590ext,
    &ett_umts_rrc_ies_InterRAT_UE_RadioAccessCapability_v6xyext,
    &ett_umts_rrc_ies_InterRAT_UE_SecurityCapability,
    &ett_umts_rrc_ies_T_gsm11,
    &ett_umts_rrc_ies_InterRAT_UE_SecurityCapList,
    &ett_umts_rrc_ies_InterRAT_HO_FailureCause,
    &ett_umts_rrc_ies_MasterInformationBlock,
    &ett_umts_rrc_ies_T_v6xyNonCriticalExtensions,
    &ett_umts_rrc_ies_T_nonCriticalExtensions1,
    &ett_umts_rrc_ies_MasterInformationBlock_v6xyext,
    &ett_umts_rrc_ies_PredefinedConfigIdentityAndValueTag,
    &ett_umts_rrc_ies_ProtocolErrorInformation,
    &ett_umts_rrc_ies_T_diagnosticsType1,
    &ett_umts_rrc_ies_T_type13,
    &ett_umts_rrc_ies_Rplmn_Information,
    &ett_umts_rrc_ies_Rplmn_Information_r4,
    &ett_umts_rrc_ies_SchedulingInformation,
    &ett_umts_rrc_ies_T_scheduling,
    &ett_umts_rrc_ies_T_sib_Pos,
    &ett_umts_rrc_ies_SchedulingInformationSIB,
    &ett_umts_rrc_ies_SchedulingInformationSIBSb,
    &ett_umts_rrc_ies_SIBOccurrenceIdentityAndValueTag,
    &ett_umts_rrc_ies_SIB_ReferenceList,
    &ett_umts_rrc_ies_SIBSb_ReferenceList,
    &ett_umts_rrc_ies_SIB_ReferenceListFACH,
    &ett_umts_rrc_ies_SIB_TypeAndTag,
    &ett_umts_rrc_ies_SIBSb_TypeAndTag,
    &ett_umts_rrc_ies_SibOFF_List,
    &ett_umts_rrc_ies_SysInfoType1,
    &ett_umts_rrc_ies_T_v3a0NonCriticalExtensions,
    &ett_umts_rrc_ies_T_nonCriticalExtensions2,
    &ett_umts_rrc_ies_SysInfoType1_v3a0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType2,
    &ett_umts_rrc_ies_T_nonCriticalExtensions3,
    &ett_umts_rrc_ies_SysInfoType3,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions,
    &ett_umts_rrc_ies_T_v590NonCriticalExtension,
    &ett_umts_rrc_ies_T_v5c0NoncriticalExtension,
    &ett_umts_rrc_ies_T_v670NonCriticalExtension,
    &ett_umts_rrc_ies_T_nonCriticalExtensions4,
    &ett_umts_rrc_ies_SysInfoType3_v4b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType3_v590ext,
    &ett_umts_rrc_ies_SysInfoType3_v5c0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType3_v670ext,
    &ett_umts_rrc_ies_SysInfoType4,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions1,
    &ett_umts_rrc_ies_T_v590NonCriticalExtension1,
    &ett_umts_rrc_ies_T_v5b0NonCriticalExtension,
    &ett_umts_rrc_ies_T_v5c0NonCriticalExtension,
    &ett_umts_rrc_ies_T_nonCriticalExtensions5,
    &ett_umts_rrc_ies_SysInfoType4_v4b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType4_v590ext,
    &ett_umts_rrc_ies_SysInfoType4_v5b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType4_v5c0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType5,
    &ett_umts_rrc_ies_T_modeSpecificInfo80,
    &ett_umts_rrc_ies_T_fdd87,
    &ett_umts_rrc_ies_T_tdd80,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions2,
    &ett_umts_rrc_ies_T_v590NonCriticalExtensions,
    &ett_umts_rrc_ies_T_v650NonCriticalExtensions,
    &ett_umts_rrc_ies_T_v6xyNonCriticalExtensions1,
    &ett_umts_rrc_ies_T_nonCriticalExtensions6,
    &ett_umts_rrc_ies_SysInfoType5_v4b0ext_IEs,
    &ett_umts_rrc_ies_T_tdd128SpecificInfo,
    &ett_umts_rrc_ies_SysInfoType5_v590ext_IEs,
    &ett_umts_rrc_ies_T_hcr_r5_SpecificInfo,
    &ett_umts_rrc_ies_SysInfoType5_v650ext_IEs,
    &ett_umts_rrc_ies_SysInfoType5_v6xyext_IEs,
    &ett_umts_rrc_ies_T_sccpch_SystemInformation_MBMS,
    &ett_umts_rrc_ies_SysInfoType6,
    &ett_umts_rrc_ies_T_modeSpecificInfo81,
    &ett_umts_rrc_ies_T_fdd88,
    &ett_umts_rrc_ies_T_tdd81,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions3,
    &ett_umts_rrc_ies_T_v590NonCriticalExtensions1,
    &ett_umts_rrc_ies_T_v650nonCriticalExtensions,
    &ett_umts_rrc_ies_T_v6xynonCriticalExtensions,
    &ett_umts_rrc_ies_T_nonCriticalExtensions7,
    &ett_umts_rrc_ies_SysInfoType6_v4b0ext_IEs,
    &ett_umts_rrc_ies_T_tdd128SpecificInfo1,
    &ett_umts_rrc_ies_SysInfoType6_v590ext_IEs,
    &ett_umts_rrc_ies_T_hcr_r5_SpecificInfo1,
    &ett_umts_rrc_ies_SysInfoType6_v650ext_IEs,
    &ett_umts_rrc_ies_SysInfoType6_v6xyext_IEs,
    &ett_umts_rrc_ies_SysInfoType7,
    &ett_umts_rrc_ies_T_modeSpecificInfo82,
    &ett_umts_rrc_ies_T_fdd89,
    &ett_umts_rrc_ies_T_nonCriticalExtensions8,
    &ett_umts_rrc_ies_SysInfoType8,
    &ett_umts_rrc_ies_T_nonCriticalExtensions9,
    &ett_umts_rrc_ies_SysInfoType9,
    &ett_umts_rrc_ies_T_nonCriticalExtensions10,
    &ett_umts_rrc_ies_SysInfoType10,
    &ett_umts_rrc_ies_T_nonCriticalExtensions11,
    &ett_umts_rrc_ies_SysInfoType11,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions4,
    &ett_umts_rrc_ies_T_v590NonCriticalExtension2,
    &ett_umts_rrc_ies_T_v6xyNonCriticalExtensions2,
    &ett_umts_rrc_ies_T_nonCriticalExtensions12,
    &ett_umts_rrc_ies_SysInfoType11_v4b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType11_v590ext_IEs,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_maxCellMeas_OF_CellSelectReselectInfo_v590ext,
    &ett_umts_rrc_ies_SysInfoType11_v6xyext_IEs,
    &ett_umts_rrc_ies_SysInfoType12,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions5,
    &ett_umts_rrc_ies_T_v590NonCriticalExtension3,
    &ett_umts_rrc_ies_T_v6xyNonCriticalExtensions3,
    &ett_umts_rrc_ies_T_nonCriticalExtensions13,
    &ett_umts_rrc_ies_SysInfoType12_v4b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType12_v590ext_IEs,
    &ett_umts_rrc_ies_SysInfoType12_v6xyext_IEs,
    &ett_umts_rrc_ies_SysInfoType13,
    &ett_umts_rrc_ies_T_v3a0NonCriticalExtensions1,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions6,
    &ett_umts_rrc_ies_T_nonCriticalExtensions14,
    &ett_umts_rrc_ies_SysInfoType13_v3a0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType13_v4b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType13_1,
    &ett_umts_rrc_ies_T_nonCriticalExtensions15,
    &ett_umts_rrc_ies_SysInfoType13_2,
    &ett_umts_rrc_ies_T_nonCriticalExtensions16,
    &ett_umts_rrc_ies_SysInfoType13_3,
    &ett_umts_rrc_ies_T_nonCriticalExtensions17,
    &ett_umts_rrc_ies_SysInfoType13_4,
    &ett_umts_rrc_ies_T_nonCriticalExtensions18,
    &ett_umts_rrc_ies_SysInfoType14,
    &ett_umts_rrc_ies_T_nonCriticalExtensions19,
    &ett_umts_rrc_ies_SysInfoType15,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions7,
    &ett_umts_rrc_ies_T_nonCriticalExtensions20,
    &ett_umts_rrc_ies_SysInfoType15_v4b0ext_IEs,
    &ett_umts_rrc_ies_SysInfoType15_1,
    &ett_umts_rrc_ies_T_nonCriticalExtensions21,
    &ett_umts_rrc_ies_SysInfoType15_2,
    &ett_umts_rrc_ies_T_nonCriticalExtensions22,
    &ett_umts_rrc_ies_SysInfoType15_3,
    &ett_umts_rrc_ies_T_nonCriticalExtensions23,
    &ett_umts_rrc_ies_SysInfoType15_4,
    &ett_umts_rrc_ies_T_v3a0NonCriticalExtensions2,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions8,
    &ett_umts_rrc_ies_T_nonCriticalExtensions24,
    &ett_umts_rrc_ies_SysInfoType15_4_v3a0ext,
    &ett_umts_rrc_ies_SysInfoType15_4_v4b0ext,
    &ett_umts_rrc_ies_SysInfoType15_5,
    &ett_umts_rrc_ies_T_v3a0NonCriticalExtensions3,
    &ett_umts_rrc_ies_T_nonCriticalExtensions25,
    &ett_umts_rrc_ies_SysInfoType15_5_v3a0ext,
    &ett_umts_rrc_ies_SysInfoType16,
    &ett_umts_rrc_ies_T_nonCriticalExtensions26,
    &ett_umts_rrc_ies_SysInfoType17,
    &ett_umts_rrc_ies_T_v4b0NonCriticalExtensions9,
    &ett_umts_rrc_ies_T_v590NonCriticalExtensions2,
    &ett_umts_rrc_ies_T_nonCriticalExtensions27,
    &ett_umts_rrc_ies_SysInfoType17_v4b0ext_IEs,
    &ett_umts_rrc_ies_T_tdd128SpecificInfo2,
    &ett_umts_rrc_ies_SysInfoType17_v590ext_IEs,
    &ett_umts_rrc_ies_T_hcr_r5_SpecificInfo2,
    &ett_umts_rrc_ies_SysInfoType18,
    &ett_umts_rrc_ies_T_nonCriticalExtensions28,
    &ett_umts_rrc_ies_SysInfoTypeSB1,
    &ett_umts_rrc_ies_T_nonCriticalExtensions29,
    &ett_umts_rrc_ies_SysInfoTypeSB2,
    &ett_umts_rrc_ies_T_nonCriticalExtensions30,
    &ett_umts_rrc_ies_TDD_UMTS_Frequency_List,
    &ett_umts_rrc_ies_MBMS_CommonRBInformation_r6,
    &ett_umts_rrc_ies_MBMS_CommonRBInformationList_r6,
    &ett_umts_rrc_ies_MBMS_ConnectedModeCountingScope,
    &ett_umts_rrc_ies_MBMS_CurrentCell_SCCPCH_r6,
    &ett_umts_rrc_ies_MBMS_CurrentCell_SCCPCHList_r6,
    &ett_umts_rrc_ies_MBMS_FACHCarryingMTCH_List,
    &ett_umts_rrc_ies_MBMS_JoinedInformation_r6,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule_32,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule_64,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList1,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item1,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule_128,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList2,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item2,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule_256,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList3,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item3,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule_512,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList4,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item4,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule_1024,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList5,
    &ett_umts_rrc_ies_T_mtch_L1CombiningPeriodList_item5,
    &ett_umts_rrc_ies_MBMS_L1CombiningSchedule,
    &ett_umts_rrc_ies_MBMS_L23Configuration,
    &ett_umts_rrc_ies_T_sameAsCurrent,
    &ett_umts_rrc_ies_T_different,
    &ett_umts_rrc_ies_MBMS_MCCH_ConfigurationInfo_r6,
    &ett_umts_rrc_ies_MBMS_MICHConfigurationInfo_r6,
    &ett_umts_rrc_ies_T_mode,
    &ett_umts_rrc_ies_T_fdd90,
    &ett_umts_rrc_ies_T_tdd38415,
    &ett_umts_rrc_ies_T_tdd12817,
    &ett_umts_rrc_ies_SEQUENCE_SIZE_1_2_OF_DL_TS_ChannelisationCode,
    &ett_umts_rrc_ies_MBMS_ModifedService_r6,
    &ett_umts_rrc_ies_T_mbms_PreferredFrequency,
    &ett_umts_rrc_ies_MBMS_ModifedServiceList_r6,
    &ett_umts_rrc_ies_MBMS_MSCHConfigurationInfo_r6,
    &ett_umts_rrc_ies_MBMS_MSCHSchedulingInfo,
    &ett_umts_rrc_ies_MBMS_NeighbouringCellSCCPCH_r6,
    &ett_umts_rrc_ies_T_layer1Combining,
    &ett_umts_rrc_ies_T_fdd91,
    &ett_umts_rrc_ies_MBMS_NeighbouringCellSCCPCHList_r6,
    &ett_umts_rrc_ies_MBMS_PhyChInformation_r6,
    &ett_umts_rrc_ies_MBMS_PhyChInformationList_r6,
    &ett_umts_rrc_ies_MBMS_PreferredFreqRequest_r6,
    &ett_umts_rrc_ies_MBMS_PreferredFrequencyInfo_r6,
    &ett_umts_rrc_ies_T_layerConvergenceInformation,
    &ett_umts_rrc_ies_MBMS_PreferredFrequencyList_r6,
    &ett_umts_rrc_ies_MBMS_PTM_RBInformation_C,
    &ett_umts_rrc_ies_MBMS_PTM_RBInformation_CList,
    &ett_umts_rrc_ies_MBMS_PTM_RBInformation_N,
    &ett_umts_rrc_ies_MBMS_PTM_RBInformation_NList,
    &ett_umts_rrc_ies_MBMS_PTM_RBInformation_S,
    &ett_umts_rrc_ies_MBMS_PTM_RBInformation_SList,
    &ett_umts_rrc_ies_MBMS_ServiceAccessInfo_r6,
    &ett_umts_rrc_ies_MBMS_ServiceAccessInfoList_r6,
    &ett_umts_rrc_ies_MBMS_ServiceIdentity,
    &ett_umts_rrc_ies_T_plmn_Identity,
    &ett_umts_rrc_ies_T_other1,
    &ett_umts_rrc_ies_MBMS_ServiceSchedulingInfo_r6,
    &ett_umts_rrc_ies_MBMS_ServiceSchedulingInfoList_r6,
    &ett_umts_rrc_ies_MBMS_ServiceTransmInfo,
    &ett_umts_rrc_ies_MBMS_ServiceTransmInfoList,
    &ett_umts_rrc_ies_MBMS_SIBType5_SCCPCH_r6,
    &ett_umts_rrc_ies_MBMS_SIBType5_SCCPCHList_r6,
    &ett_umts_rrc_ies_MBMS_TimersAndCouneters_r6,
    &ett_umts_rrc_ies_MBMS_TransmissionIdentity,
    &ett_umts_rrc_ies_MBMS_TranspChInfoForCCTrCh_r6,
    &ett_umts_rrc_ies_MBMS_TranspChInfoForEachCCTrCh_r6,
    &ett_umts_rrc_ies_MBMS_TranspChInfoForEachTrCh_r6,
    &ett_umts_rrc_ies_MBMS_TranspChInfoForTrCh_r6,
    &ett_umts_rrc_ies_MBMS_TrCHInformation_Comm,
    &ett_umts_rrc_ies_MBMS_TrCHInformation_CommList,
    &ett_umts_rrc_ies_MBMS_TrCHInformation_Neighb,
    &ett_umts_rrc_ies_MBMS_TrCHInformation_NeighbList,
    &ett_umts_rrc_ies_MBMS_TrCHInformation_SIB5,
    &ett_umts_rrc_ies_MBMS_TrCHInformation_SIB5List,
    &ett_umts_rrc_ies_MBMS_UnmodifiedService_r6,
    &ett_umts_rrc_ies_MBMS_UnmodifiedServiceList_r6,

/*--- End of included file: packet-umts_rrc_ies-ettarr.c ---*/
#line 89 "packet-umts_rrc_ies-template.c"
  };


  /* Register protocol */
  proto_umts_rrc_ies = proto_register_protocol(PNAME, PSNAME, PFNAME);
  /* Register fields and subtrees */
  proto_register_field_array(proto_umts_rrc_ies, hf, array_length(hf));
  proto_register_subtree_array(ett, array_length(ett));

 
  register_dissector("umts_rrc_ies", dissect_umts_rrc_ies, proto_umts_rrc_ies);


}


/*--- proto_reg_handoff_umts_rrc_ies ---------------------------------------*/
void
proto_reg_handoff_umts_rrc_ies(void)
{

	umts_rrc_ies_handle = find_dissector("umts_rrc_ies");

}


